// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `RTypes.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero;

/**
 * The collection ""protected"" classes permit the passing of sequences of all
 * other RTypes (including other collections) and it is itself nullable. The
 * allows for similar arguments to collections in languages with a unified
 * inheritance hierarchy (e.g., Java in which all ""protected"" classes extend
 * from java.lang.Object).
 * 
 * Unlike the other rtypes which are used internally within the
 * {@link omero.model} classes, these types are mutable since they solely
 * pass through the
 * 
 * This flexible mechanism is not used in all API calls because
 * the flexibility brings a performance penalty.
 **/
public abstract class RCollection extends RType
                                  implements _RCollectionOperations,
                                             _RCollectionOperationsNC
{
    public RCollection()
    {
        super();
    }

    public RCollection(java.util.List<omero.RType> val)
    {
        this.val = val;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::RCollection",
        "::omero::RType"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    public final void add(RType value)
    {
        add(value, null);
    }

    public final void addAll(java.util.List<omero.RType> value)
    {
        addAll(value, null);
    }

    public final RType get(int index)
    {
        return get(index, null);
    }

    public final java.util.List<omero.RType> getValue()
    {
        return getValue(null);
    }

    public final int size()
    {
        return size(null);
    }

    public static Ice.DispatchStatus ___getValue(RCollection __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        java.util.List<omero.RType> __ret = __obj.getValue(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        RTypeSeqHelper.write(__os, __ret);
        __os.writePendingObjects();
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___size(RCollection __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        int __ret = __obj.size(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeInt(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___get(RCollection __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int index;
        index = __is.readInt();
        __inS.endReadParams();
        RType __ret = __obj.get(index, __current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeObject(__ret);
        __os.writePendingObjects();
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___add(RCollection __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        RTypeHolder value = new RTypeHolder();
        __is.readObject(value);
        __is.readPendingObjects();
        __inS.endReadParams();
        __obj.add(value.value, __current);
        __inS.__writeEmptyParams();
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___addAll(RCollection __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<omero.RType> value;
        value = RTypeSeqHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        __obj.addAll(value, __current);
        __inS.__writeEmptyParams();
        return Ice.DispatchStatus.DispatchOK;
    }

    private final static String[] __all =
    {
        "add",
        "addAll",
        "compare",
        "get",
        "getValue",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "size"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___add(this, in, __current);
            }
            case 1:
            {
                return ___addAll(this, in, __current);
            }
            case 2:
            {
                return RType.___compare(this, in, __current);
            }
            case 3:
            {
                return ___get(this, in, __current);
            }
            case 4:
            {
                return ___getValue(this, in, __current);
            }
            case 5:
            {
                return ___ice_id(this, in, __current);
            }
            case 6:
            {
                return ___ice_ids(this, in, __current);
            }
            case 7:
            {
                return ___ice_isA(this, in, __current);
            }
            case 8:
            {
                return ___ice_ping(this, in, __current);
            }
            case 9:
            {
                return ___size(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, false);
        RTypeSeqHelper.write(__os, val);
        __os.endWriteSlice();
        super.__writeImpl(__os);
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        val = RTypeSeqHelper.read(__is);
        __is.endReadSlice();
        super.__readImpl(__is);
    }

    protected java.util.List<omero.RType> val;

    public static final long serialVersionUID = -6148320526079450813L;
}
