// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IContainer.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Retrieves hierarchy trees in various hierarchies that
 * contain the specified Images.
 * <p>
 * This method will look for all the containers containing the
 * specified Images and then for all containers containing
 * those containers and on up the container hierarchy.
 * </p>
 * <p>
 * This method returns a <code>Set</code> with all root nodes
 * that were
 * found. Every root node is linked to the found objects and
 * so on until the leaf nodes, which are
 * {@link omero.model.Image} objects. Note that the type of any
 * root node in the returned set can be the given
 * rootNodeType, any of its containees or an
 * {@link omero.model.Image}.
 * </p>
 * <p>
 * For example, say that you pass in the ids of six Images:
 * <code>i1, i2, i3, i4, i5, i6</code>.
 * If the P/D/I hierarchy in the DB looks like this:
 * </p>
 * 
 * <pre>
 * |                  __p1__                     
 * |                 /      \                    
 * |               _d1_    _d2_      d3          
 * |              /    \  /    \     |           
 * |             i1     i2     i3    i4    i5  i6
 * </pre>
 * 
 * <p>
 * Then the returned set will contain
 * <code>p1, d3, i5, i6</code>. All objects will be properly
 * linked up.
 * </p>
 * <p>
 * Finally, this method will <i>only</i> retrieve the nodes
 * that are connected in a tree to the specified leaf image
 * nodes. Back to the previous example, if <code>d1</code>
 * contained image <code>img500</code>, then the returned
 * object would <i>not</i> contain <code>img500</code>. In a
 * similar way, if <code>p1</code> contained
 * <code>ds300</code> and this dataset weren't linked to any of
 * the <code>i1, i2, i3, i4, i5, i6 </code> images, then
 * <code>ds300</code> would <i>not</i> be part of the returned
 * tree rooted by <code>p1</code>.
 * </p>
 * 
 **/

public interface AMD_IContainer_findContainerHierarchies extends Ice.AMDCallback
{
    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) A <code>Set</code> with all root nodes that were
     * found.
     **/
    void ice_response(java.util.List<omero.model.IObject> __ret);
}
