// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IContainer.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Retrieves hierarchy trees rooted by a given node (unless
 * orphan is specified -- See below)
 * <p>
 * This method also retrieves the Experimenters linked to the
 * objects in the tree. Similarly, all Images will be linked
 * to their Pixel objects if included.
 * </p>
 * <p>
 * Note that objects are never duplicated. For example, if an
 * Experimenter owns all the objects in the retrieved tree,
 * then those objects will be linked to the <i>same</i>
 * instance of {@link omero.model.Experimenter}. Or if an
 * Image is contained in more than one Dataset in the
 * retrieved tree, then all enclosing
 * {@link omero.model.Dataset} objects will point
 * to the <i>same</i> {@link omero.model.Image} object. And
 * so on.
 * </p>
 * 
 **/

public interface AMD_IContainer_loadContainerHierarchy extends Ice.AMDCallback
{
    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a set of hierarchy trees. The requested node as
     * root and all of its descendants. The type of the
     * returned value will be <code>rootNodeType</code>,
     * unless <code>orphan</code> is specified in which
     * case objects of type <code>rootNodeType</code> and
     * below may be returned.
     **/
    void ice_response(java.util.List<omero.model.IObject> __ret);
}
