// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IAdmin.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Uploads a photo for the user which will be displayed on
 * his/her profile.
 * This photo will be saved as an
 * {@link omero.model.OriginalFile} object with the given
 * format, and attached to the user's
 * {@link omero.model.Experimenter} object via an
 * {@link omero.model.FileAnnotation} with
 * the namespace:
 * <i>openmicroscopy.org/omero/experimenter/photo</i>
 * (NSEXPERIMENTERPHOTO).
 * If such an {@link omero.model.OriginalFile} instance
 * already exists, it will be overwritten. If more than one
 * photo is present, the oldest version will be modified (i.e.
 * the highest updateEvent id).
 * 
 * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
 * this photo will be placed in the <i>user</i> group and
 * therefore will be visible to everyone on the system.
 * 
 **/

public abstract class AMI_IAdmin_uploadMyUserPhoto extends Callback_IAdmin_uploadMyUserPhoto
{
    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) the id of the overwritten or newly created user
     * photo OriginalFile object.
     **/
    public abstract void ice_response(long __ret);

    /**
     * ice_exception indicates to the caller that
     * the operation completed with an exception.
     * @param ex The Ice run-time exception to be raised.
     **/
    public abstract void ice_exception(Ice.LocalException ex);

    /**
     * ice_exception indicates to the caller that
     * the operation completed with an exception.
     * @param ex The user exception to be raised.
     **/
    public abstract void ice_exception(Ice.UserException ex);

    public final void response(long __ret)
    {
        ice_response(__ret);
    }

    public final void exception(Ice.UserException __ex)
    {
        ice_exception(__ex);
    }

    public final void exception(Ice.LocalException __ex)
    {
        ice_exception(__ex);
    }

    @Override public final void sent(boolean sentSynchronously)
    {
        if(!sentSynchronously && this instanceof Ice.AMISentCallback)
        {
            ((Ice.AMISentCallback)this).ice_sent();
        }
    }
}
