// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IQuery.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Executes the stored query with the given name. If a query
 * with the name cannot be found, an exception will be thrown.
 * 
 * The queryName parameter can be an actual query String if the
 * StringQuerySource is configured on the server and the user
 * running the query has proper permissions.
 * 
 * Queries can only return lists of
 * {@link omero.model.IObject} instances. This means
 * all must be of the form:
 * 
 * <pre>
 * select this from SomeModelClass this ...
 * </pre>
 * 
 * though the alias <i>this</i> is unimportant. Do not try to
 * return multiple classes in one call like:
 * 
 * <pre>
 * select this, that from SomeClass this, SomeOtherClass that ...
 * </pre>
 * 
 * nor to project values out of an object:
 * 
 * <pre>
 * select this.name from SomeClass this ...
 * </pre>
 * 
 * If a page is desired, add it to the query parameters.
 * 
 **/

public abstract class AMI_IQuery_findAllByQuery extends Callback_IQuery_findAllByQuery
{
    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Possibly empty List of IObject results.
     **/
    public abstract void ice_response(java.util.List<omero.model.IObject> __ret);

    /**
     * ice_exception indicates to the caller that
     * the operation completed with an exception.
     * @param ex The Ice run-time exception to be raised.
     **/
    public abstract void ice_exception(Ice.LocalException ex);

    /**
     * ice_exception indicates to the caller that
     * the operation completed with an exception.
     * @param ex The user exception to be raised.
     **/
    public abstract void ice_exception(Ice.UserException ex);

    public final void response(java.util.List<omero.model.IObject> __ret)
    {
        ice_response(__ret);
    }

    public final void exception(Ice.UserException __ex)
    {
        ice_exception(__ex);
    }

    public final void exception(Ice.LocalException __ex)
    {
        ice_exception(__ex);
    }

    @Override public final void sent(boolean sentSynchronously)
    {
        if(!sentSynchronously && this instanceof Ice.AMISentCallback)
        {
            ((Ice.AMISentCallback)this).ice_sent();
        }
    }
}
