// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IScript.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * This method returns official server scripts identified
 * with the specified extension as a list of
 * {@link omero.model.OriginalFile} objects.
 * These scripts will be executed by the server if submitted
 * via {@link #runScript}. The input parameters
 * necessary for proper functioning can be retrieved via
 * {@link #getParams}.
 * 
 * The {@link omero.model.OriginalFile#path} value can be used
 * in other official scripts via the
 * language specific import command, since the script
 * directory will be placed on the appropriate
 * environment path variable.
 * <pre>
 * scripts = scriptService.getScripts("py")
 * for script in scripts:
 * text = scriptService.getScriptText(script.id.val)
 * path = script.path.val\[1:\] # First symbol is a "/"
 * path = path.replace("/",".")
 * print "Possible import: %s" % path
 * </pre>
 * 
 **/

public abstract class AMI_IScript_getScriptsByMimetype extends Callback_IScript_getScriptsByMimetype
{
    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) see above.
     **/
    public abstract void ice_response(java.util.List<omero.model.OriginalFile> __ret);

    /**
     * ice_exception indicates to the caller that
     * the operation completed with an exception.
     * @param ex The Ice run-time exception to be raised.
     **/
    public abstract void ice_exception(Ice.LocalException ex);

    /**
     * ice_exception indicates to the caller that
     * the operation completed with an exception.
     * @param ex The user exception to be raised.
     **/
    public abstract void ice_exception(Ice.UserException ex);

    public final void response(java.util.List<omero.model.OriginalFile> __ret)
    {
        ice_response(__ret);
    }

    public final void exception(Ice.UserException __ex)
    {
        ice_exception(__ex);
    }

    public final void exception(Ice.LocalException __ex)
    {
        ice_exception(__ex);
    }

    @Override public final void sent(boolean sentSynchronously)
    {
        if(!sentSynchronously && this instanceof Ice.AMISentCallback)
        {
            ((Ice.AMISentCallback)this).ice_sent();
        }
    }
}
