// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IScript.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * If {@link ResourceError} is thrown, then no
 * {@link Processor} is available. Use {@link #scheduleJob}
 * to create a {@link omero.model.ScriptJob} in the
 * <i>Waiting</i> state. A {@link Processor} may become
 * available.
 * 
 * <pre>
 * try:
 * proc = scriptService.runScript(1, {}, None)
 * except ResourceError:
 * job = scriptService.scheduleScript(1, {}, None)
 * </pre>
 * 
 * The {@link ScriptProcess} proxy MUST be closed before
 * exiting. If you would like the script execution to continue
 * in the background, pass <code>True</code> as the argument.
 * 
 * <pre>
 * try:
 * proc.poll()         # See if process is finished
 * finally:
 * proc.close(True)    # Detach and execution can continue
 * # proc.close(False) # OR script is immediately stopped.
 * </pre>
 **/

public abstract class AMI_IScript_runScript extends Callback_IScript_runScript
{
    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public abstract void ice_response(omero.grid.ScriptProcessPrx __ret);

    /**
     * ice_exception indicates to the caller that
     * the operation completed with an exception.
     * @param ex The Ice run-time exception to be raised.
     **/
    public abstract void ice_exception(Ice.LocalException ex);

    /**
     * ice_exception indicates to the caller that
     * the operation completed with an exception.
     * @param ex The user exception to be raised.
     **/
    public abstract void ice_exception(Ice.UserException ex);

    public final void response(omero.grid.ScriptProcessPrx __ret)
    {
        ice_response(__ret);
    }

    public final void exception(Ice.UserException __ex)
    {
        ice_exception(__ex);
    }

    public final void exception(Ice.LocalException __ex)
    {
        ice_exception(__ex);
    }

    @Override public final void sent(boolean sentSynchronously)
    {
        if(!sentSynchronously && this instanceof Ice.AMISentCallback)
        {
            ((Ice.AMISentCallback)this).ice_sent();
        }
    }
}
