// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Search.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Applies the next by* method to the previous by* method, so
 * that a call {@link #hasNext}, {@link #next} or
 * {@link #results} sees only the union of the two calls.
 * 
 * For example,
 * 
 * <pre>
 * service.onlyType(Image.class);
 * service.byFullText(&quot;foo&quot;);
 * service.or();
 * service.onlyType(Dataset.class);
 * service.byFullText(&quot;foo&quot;);
 * </pre>
 * 
 * will return both Images and Datasets together.
 * 
 * Calling this method overrides a previous setting of
 * {@link #and} or {@link #not}. If there is no active queries
 * (i.e. {@link #activeQueries} > 0), then an
 * {@link omero.ApiUsageException} will be thrown.
 **/

public abstract class AMI_Search_or extends Callback_Search_or
{
    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public abstract void ice_response();

    /**
     * ice_exception indicates to the caller that
     * the operation completed with an exception.
     * @param ex The Ice run-time exception to be raised.
     **/
    public abstract void ice_exception(Ice.LocalException ex);

    /**
     * ice_exception indicates to the caller that
     * the operation completed with an exception.
     * @param ex The user exception to be raised.
     **/
    public abstract void ice_exception(Ice.UserException ex);

    public final void response()
    {
        ice_response();
    }

    public final void exception(Ice.UserException __ex)
    {
        ice_exception(__ex);
    }

    public final void exception(Ice.LocalException __ex)
    {
        ice_exception(__ex);
    }

    @Override public final void sent(boolean sentSynchronously)
    {
        if(!sentSynchronously && this instanceof Ice.AMISentCallback)
        {
            ((Ice.AMISentCallback)this).ice_sent();
        }
    }
}
