// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IQuery.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Return a sequence of {@link omero.RType} sequences.
 * 
 * <p>
 * Each element of the outer sequence is one row in the return
 * value.
 * Each element of the inner sequence is one column specified
 * in the HQL.
 * </p>
 * 
 * <p>
 * {@link omero.model.IObject} instances are returned wrapped
 * in an {@link omero.RObject} instance. Primitives are
 * mapped to the expected {@link omero.RType} subclass. Types
 * without an {@link omero.RType} mapper if returned will
 * throw an exception if present in the select except where a
 * manual conversion is present on the server. This includes:
 * </p>
 * 
 * <ul>
 * <li>
 * {@link omero.model.Permissions} instances are
 * serialized to an {@link omero.RMap} containing the
 * keys: perms, canAnnotate, canEdit, canLink, canDelete
 * </li>
 * <li>
 * The quantity types like {@link omero.model.Length} are
 * serialized to an {@link omero.RMap} containing the
 * keys: value, unit, symbol
 * </li>
 * </ul>
 * 
 * <p>
 * As with SQL, if an aggregation statement is used, a group
 * by clause must be added.
 * </p>
 * 
 * <p>
 * Examples:
 * <pre>
 * select i.name, i.description from Image i where i.name like '%.dv'
 * 
 * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
 * 
 * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
 * </pre>
 * </p>
 * 
 **/

public abstract class Callback_IQuery_projection extends Ice.TwowayCallback
{
    public abstract void response(java.util.List<java.util.List<omero.RType>> __ret);
    public abstract void exception(Ice.UserException __ex);

    public final void __completed(Ice.AsyncResult __result)
    {
        IQueryPrx __proxy = (IQueryPrx)__result.getProxy();
        java.util.List<java.util.List<omero.RType>> __ret = null;
        try
        {
            __ret = __proxy.end_projection(__result);
        }
        catch(Ice.UserException __ex)
        {
            exception(__ex);
            return;
        }
        catch(Ice.LocalException __ex)
        {
            exception(__ex);
            return;
        }
        response(__ret);
    }
}
