// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IScript.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * If {@link ResourceError} is thrown, then no
 * {@link Processor} is available. Use {@link #scheduleJob}
 * to create a {@link omero.model.ScriptJob} in the
 * <i>Waiting</i> state. A {@link Processor} may become
 * available.
 * 
 * <pre>
 * try:
 * proc = scriptService.runScript(1, {}, None)
 * except ResourceError:
 * job = scriptService.scheduleScript(1, {}, None)
 * </pre>
 * 
 * The {@link ScriptProcess} proxy MUST be closed before
 * exiting. If you would like the script execution to continue
 * in the background, pass <code>True</code> as the argument.
 * 
 * <pre>
 * try:
 * proc.poll()         # See if process is finished
 * finally:
 * proc.close(True)    # Detach and execution can continue
 * # proc.close(False) # OR script is immediately stopped.
 * </pre>
 **/

public abstract class Callback_IScript_runScript extends Ice.TwowayCallback
{
    public abstract void response(omero.grid.ScriptProcessPrx __ret);
    public abstract void exception(Ice.UserException __ex);

    public final void __completed(Ice.AsyncResult __result)
    {
        IScriptPrx __proxy = (IScriptPrx)__result.getProxy();
        omero.grid.ScriptProcessPrx __ret = null;
        try
        {
            __ret = __proxy.end_runScript(__result);
        }
        catch(Ice.UserException __ex)
        {
            exception(__ex);
            return;
        }
        catch(Ice.LocalException __ex)
        {
            exception(__ex);
            return;
        }
        response(__ret);
    }
}
