// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `API.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Changes the security context for the current session.
 * 
 * <p> A security context limits the set of objects which will
 * be returned by all queries and restricts what updates
 * can be made. </p>
 * 
 * <p> Current valid values for security context:
 * <ul>
 * <li>{@link omero.model.ExperimenterGroup} - logs into a
 * specific group</li>
 * <li>{@link omero.model.Share} - uses IShare to activate a
 * share</li>
 * </ul> </p>
 * 
 * <p> Passing an unloaded version of either object type will change
 * the way the current session operates. Note: only objects which
 * are returned by the {@link #getSecurityContexts} method are
 * considered valid. Any other instance will cause an exception to
 * be thrown. </p>
 * 
 * <h4>Example usage in Python:<h4>
 * <pre>
 * sf = client.createSession()
 * objs = sf.getSecurityContexts()
 * old = sf.setSecurityContext(objs\[-1])
 * </pre>
 * 
 **/

public abstract class Callback_ServiceFactory_setSecurityContext extends Ice.TwowayCallback
{
    public abstract void response(omero.model.IObject __ret);
    public abstract void exception(Ice.UserException __ex);

    public final void __completed(Ice.AsyncResult __result)
    {
        ServiceFactoryPrx __proxy = (ServiceFactoryPrx)__result.getProxy();
        omero.model.IObject __ret = null;
        try
        {
            __ret = __proxy.end_setSecurityContext(__result);
        }
        catch(Ice.UserException __ex)
        {
            exception(__ex);
            return;
        }
        catch(Ice.LocalException __ex)
        {
            exception(__ex);
            return;
        }
        response(__ret);
    }
}
