// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `API.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Primary callback interface for interaction between client and
 * server session (""ServiceFactory""). Where possible these methods
 * will be called one-way to prevent clients from hanging the server.
 **/
public final class ClientCallbackPrxHelper extends Ice.ObjectPrxHelperBase implements ClientCallbackPrx
{
    private static final String __requestHeartbeat_name = "requestHeartbeat";

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     **/
    public void requestHeartbeat()
    {
        requestHeartbeat(null, false);
    }

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void requestHeartbeat(java.util.Map<String, String> __ctx)
    {
        requestHeartbeat(__ctx, true);
    }

    private void requestHeartbeat(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "requestHeartbeat", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _ClientCallbackDel __del = (_ClientCallbackDel)__delBase;
                    __del.requestHeartbeat(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_requestHeartbeat()
    {
        return begin_requestHeartbeat(null, false, null);
    }

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_requestHeartbeat(java.util.Map<String, String> __ctx)
    {
        return begin_requestHeartbeat(__ctx, true, null);
    }

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_requestHeartbeat(Ice.Callback __cb)
    {
        return begin_requestHeartbeat(null, false, __cb);
    }

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_requestHeartbeat(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_requestHeartbeat(__ctx, true, __cb);
    }

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_requestHeartbeat(Callback_ClientCallback_requestHeartbeat __cb)
    {
        return begin_requestHeartbeat(null, false, __cb);
    }

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_requestHeartbeat(java.util.Map<String, String> __ctx, Callback_ClientCallback_requestHeartbeat __cb)
    {
        return begin_requestHeartbeat(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_requestHeartbeat(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __requestHeartbeat_name, __cb);
        try
        {
            __result.__prepare(__requestHeartbeat_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_requestHeartbeat(Ice.AsyncResult __result)
    {
        __end(__result, __requestHeartbeat_name);
    }

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __cb The callback object for the operation.
     **/
    public boolean requestHeartbeat_async(AMI_ClientCallback_requestHeartbeat __cb)
    {
        Ice.AsyncResult __r = begin_requestHeartbeat(null, false, __cb);
        return __r.sentSynchronously();
    }

    /**
     * Heartbeat-request made by the server to guarantee that the client
     * is alive. If the client is still active, then some method should
     * be made on the server to update the last idle time.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean requestHeartbeat_async(AMI_ClientCallback_requestHeartbeat __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r = begin_requestHeartbeat(__ctx, true, __cb);
        return __r.sentSynchronously();
    }

    private static final String __sessionClosed_name = "sessionClosed";

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     **/
    public void sessionClosed()
    {
        sessionClosed(null, false);
    }

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __ctx The Context map to send with the invocation.
     **/
    public void sessionClosed(java.util.Map<String, String> __ctx)
    {
        sessionClosed(__ctx, true);
    }

    private void sessionClosed(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "sessionClosed", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _ClientCallbackDel __del = (_ClientCallbackDel)__delBase;
                    __del.sessionClosed(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_sessionClosed()
    {
        return begin_sessionClosed(null, false, null);
    }

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_sessionClosed(java.util.Map<String, String> __ctx)
    {
        return begin_sessionClosed(__ctx, true, null);
    }

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_sessionClosed(Ice.Callback __cb)
    {
        return begin_sessionClosed(null, false, __cb);
    }

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_sessionClosed(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_sessionClosed(__ctx, true, __cb);
    }

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_sessionClosed(Callback_ClientCallback_sessionClosed __cb)
    {
        return begin_sessionClosed(null, false, __cb);
    }

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_sessionClosed(java.util.Map<String, String> __ctx, Callback_ClientCallback_sessionClosed __cb)
    {
        return begin_sessionClosed(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_sessionClosed(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __sessionClosed_name, __cb);
        try
        {
            __result.__prepare(__sessionClosed_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_sessionClosed(Ice.AsyncResult __result)
    {
        __end(__result, __sessionClosed_name);
    }

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __cb The callback object for the operation.
     **/
    public boolean sessionClosed_async(AMI_ClientCallback_sessionClosed __cb)
    {
        Ice.AsyncResult __r = begin_sessionClosed(null, false, __cb);
        return __r.sentSynchronously();
    }

    /**
     * The session to which this ServiceFactory is connected has been
     * closed. Almost no further method calls (if any) are possible.
     * Create a new session via omero.client.createSession()
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean sessionClosed_async(AMI_ClientCallback_sessionClosed __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r = begin_sessionClosed(__ctx, true, __cb);
        return __r.sentSynchronously();
    }

    private static final String __shutdownIn_name = "shutdownIn";

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     **/
    public void shutdownIn(long milliseconds)
    {
        shutdownIn(milliseconds, null, false);
    }

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void shutdownIn(long milliseconds, java.util.Map<String, String> __ctx)
    {
        shutdownIn(milliseconds, __ctx, true);
    }

    private void shutdownIn(long milliseconds, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "shutdownIn", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _ClientCallbackDel __del = (_ClientCallbackDel)__delBase;
                    __del.shutdownIn(milliseconds, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_shutdownIn(long milliseconds)
    {
        return begin_shutdownIn(milliseconds, null, false, null);
    }

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_shutdownIn(long milliseconds, java.util.Map<String, String> __ctx)
    {
        return begin_shutdownIn(milliseconds, __ctx, true, null);
    }

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_shutdownIn(long milliseconds, Ice.Callback __cb)
    {
        return begin_shutdownIn(milliseconds, null, false, __cb);
    }

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_shutdownIn(long milliseconds, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_shutdownIn(milliseconds, __ctx, true, __cb);
    }

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_shutdownIn(long milliseconds, Callback_ClientCallback_shutdownIn __cb)
    {
        return begin_shutdownIn(milliseconds, null, false, __cb);
    }

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_shutdownIn(long milliseconds, java.util.Map<String, String> __ctx, Callback_ClientCallback_shutdownIn __cb)
    {
        return begin_shutdownIn(milliseconds, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_shutdownIn(long milliseconds, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __shutdownIn_name, __cb);
        try
        {
            __result.__prepare(__shutdownIn_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(milliseconds);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_shutdownIn(Ice.AsyncResult __result)
    {
        __end(__result, __shutdownIn_name);
    }

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __cb The callback object for the operation.
     **/
    public boolean shutdownIn_async(AMI_ClientCallback_shutdownIn __cb, long milliseconds)
    {
        Ice.AsyncResult __r = begin_shutdownIn(milliseconds, null, false, __cb);
        return __r.sentSynchronously();
    }

    /**
     * Message that the server will be shutting down in the
     * given number of milliseconds, after which all new and
     * running method invocations will receive a CancelledException.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean shutdownIn_async(AMI_ClientCallback_shutdownIn __cb, long milliseconds, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r = begin_shutdownIn(milliseconds, __ctx, true, __cb);
        return __r.sentSynchronously();
    }

    public static ClientCallbackPrx checkedCast(Ice.ObjectPrx __obj)
    {
        ClientCallbackPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ClientCallbackPrx)
            {
                __d = (ClientCallbackPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    ClientCallbackPrxHelper __h = new ClientCallbackPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ClientCallbackPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        ClientCallbackPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ClientCallbackPrx)
            {
                __d = (ClientCallbackPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    ClientCallbackPrxHelper __h = new ClientCallbackPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ClientCallbackPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ClientCallbackPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    ClientCallbackPrxHelper __h = new ClientCallbackPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ClientCallbackPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        ClientCallbackPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    ClientCallbackPrxHelper __h = new ClientCallbackPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ClientCallbackPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        ClientCallbackPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ClientCallbackPrx)
            {
                __d = (ClientCallbackPrx)__obj;
            }
            else
            {
                ClientCallbackPrxHelper __h = new ClientCallbackPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static ClientCallbackPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ClientCallbackPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            ClientCallbackPrxHelper __h = new ClientCallbackPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::ClientCallback"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _ClientCallbackDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _ClientCallbackDelD();
    }

    public static void __write(IceInternal.BasicStream __os, ClientCallbackPrx v)
    {
        __os.writeProxy(v);
    }

    public static ClientCallbackPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            ClientCallbackPrxHelper result = new ClientCallbackPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
