// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Exporter.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Stateful service for generating OME-XML or OME-TIFF from data stored
 * in OMERO. Intended usage:
 * <pre>
 * 
 * ExporterPrx e = sf.createExporter();
 * 
 * // Exporter is currently in the <i>configuration</i> state
 * // Objects can be added by id which should be present
 * // in the output.
 * 
 * e.addImage(1);
 * 
 * 
 * // As soon as a generate method is called, the objects
 * // added to the Exporter are converted to the specified
 * // format. The length of the file produced is returned.
 * // No more objects can be added to the Exporter, nor can
 * // another generate method be called.
 * 
 * long length = e.generateTiff();
 * 
 * // As soon as the server-side file is generated, read()
 * // can be called to get file segments. To create another
 * // file, create a second Exporter. Be sure to close all
 * // Exporter instances.
 * 
 * long read = 0
 * byte\[] buf;
 * while (true) {
 * buf = e.read(read, 1000000);
 * // Store to file locally here
 * if (buf.length < 1000000) {
 * break;
 * }
 * read += buf.length;
 * }
 * e.close();
 * 
 * </pre>
 **/
public interface Exporter extends Ice.Object,
                                  _ExporterOperations, _ExporterOperationsNC,
                                  StatefulServiceInterface
{
    public static final long serialVersionUID = -250434248291131362L;
}
