// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Exporter.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Stateful service for generating OME-XML or OME-TIFF from data stored
 * in OMERO. Intended usage:
 * <pre>
 * 
 * ExporterPrx e = sf.createExporter();
 * 
 * // Exporter is currently in the <i>configuration</i> state
 * // Objects can be added by id which should be present
 * // in the output.
 * 
 * e.addImage(1);
 * 
 * 
 * // As soon as a generate method is called, the objects
 * // added to the Exporter are converted to the specified
 * // format. The length of the file produced is returned.
 * // No more objects can be added to the Exporter, nor can
 * // another generate method be called.
 * 
 * long length = e.generateTiff();
 * 
 * // As soon as the server-side file is generated, read()
 * // can be called to get file segments. To create another
 * // file, create a second Exporter. Be sure to close all
 * // Exporter instances.
 * 
 * long read = 0
 * byte\[] buf;
 * while (true) {
 * buf = e.read(read, 1000000);
 * // Store to file locally here
 * if (buf.length < 1000000) {
 * break;
 * }
 * read += buf.length;
 * }
 * e.close();
 * 
 * </pre>
 **/
public interface ExporterPrx extends StatefulServiceInterfacePrx
{
    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     **/
    public void addImage(long id)
        throws omero.ServerError;

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addImage(long id, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addImage(long id);

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addImage(long id, java.util.Map<String, String> __ctx);

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addImage(long id, Ice.Callback __cb);

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addImage(long id, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addImage(long id, Callback_Exporter_addImage __cb);

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addImage(long id, java.util.Map<String, String> __ctx, Callback_Exporter_addImage __cb);

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __result The asynchronous result object.
     **/
    public void end_addImage(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __cb The callback object for the operation.
     **/
    public boolean addImage_async(AMI_Exporter_addImage __cb, long id);

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addImage_async(AMI_Exporter_addImage __cb, long id, java.util.Map<String, String> __ctx);

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     **/
    public long generateXml()
        throws omero.ServerError;

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __ctx The Context map to send with the invocation.
     **/
    public long generateXml(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_generateXml();

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_generateXml(java.util.Map<String, String> __ctx);

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_generateXml(Ice.Callback __cb);

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_generateXml(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_generateXml(Callback_Exporter_generateXml __cb);

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_generateXml(java.util.Map<String, String> __ctx, Callback_Exporter_generateXml __cb);

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __result The asynchronous result object.
     **/
    public long end_generateXml(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __cb The callback object for the operation.
     **/
    public boolean generateXml_async(AMI_Exporter_generateXml __cb);

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean generateXml_async(AMI_Exporter_generateXml __cb, java.util.Map<String, String> __ctx);

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     **/
    public long generateTiff()
        throws omero.ServerError;

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __ctx The Context map to send with the invocation.
     **/
    public long generateTiff(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_generateTiff();

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_generateTiff(java.util.Map<String, String> __ctx);

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_generateTiff(Ice.Callback __cb);

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_generateTiff(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_generateTiff(Callback_Exporter_generateTiff __cb);

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_generateTiff(java.util.Map<String, String> __ctx, Callback_Exporter_generateTiff __cb);

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __result The asynchronous result object.
     **/
    public long end_generateTiff(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __cb The callback object for the operation.
     **/
    public boolean generateTiff_async(AMI_Exporter_generateTiff __cb);

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean generateTiff_async(AMI_Exporter_generateTiff __cb, java.util.Map<String, String> __ctx);

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     **/
    public byte[] read(long position, int length)
        throws omero.ServerError;

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __ctx The Context map to send with the invocation.
     **/
    public byte[] read(long position, int length, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_read(long position, int length);

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_read(long position, int length, java.util.Map<String, String> __ctx);

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_read(long position, int length, Ice.Callback __cb);

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_read(long position, int length, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_read(long position, int length, Callback_Exporter_read __cb);

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_read(long position, int length, java.util.Map<String, String> __ctx, Callback_Exporter_read __cb);

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __result The asynchronous result object.
     **/
    public byte[] end_read(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __cb The callback object for the operation.
     **/
    public boolean read_async(AMI_Exporter_read __cb, long position, int length);

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean read_async(AMI_Exporter_read __cb, long position, int length, java.util.Map<String, String> __ctx);
}
