// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Exporter.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Stateful service for generating OME-XML or OME-TIFF from data stored
 * in OMERO. Intended usage:
 * <pre>
 * 
 * ExporterPrx e = sf.createExporter();
 * 
 * // Exporter is currently in the <i>configuration</i> state
 * // Objects can be added by id which should be present
 * // in the output.
 * 
 * e.addImage(1);
 * 
 * 
 * // As soon as a generate method is called, the objects
 * // added to the Exporter are converted to the specified
 * // format. The length of the file produced is returned.
 * // No more objects can be added to the Exporter, nor can
 * // another generate method be called.
 * 
 * long length = e.generateTiff();
 * 
 * // As soon as the server-side file is generated, read()
 * // can be called to get file segments. To create another
 * // file, create a second Exporter. Be sure to close all
 * // Exporter instances.
 * 
 * long read = 0
 * byte\[] buf;
 * while (true) {
 * buf = e.read(read, 1000000);
 * // Store to file locally here
 * if (buf.length < 1000000) {
 * break;
 * }
 * read += buf.length;
 * }
 * e.close();
 * 
 * </pre>
 **/
public final class ExporterPrxHelper extends Ice.ObjectPrxHelperBase implements ExporterPrx
{
    private static final String __addImage_name = "addImage";

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     **/
    public void addImage(long id)
        throws omero.ServerError
    {
        addImage(id, null, false);
    }

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addImage(long id, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        addImage(id, __ctx, true);
    }

    private void addImage(long id, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "addImage", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("addImage");
                    __delBase = __getDelegate(false);
                    _ExporterDel __del = (_ExporterDel)__delBase;
                    __del.addImage(id, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addImage(long id)
    {
        return begin_addImage(id, null, false, null);
    }

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addImage(long id, java.util.Map<String, String> __ctx)
    {
        return begin_addImage(id, __ctx, true, null);
    }

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addImage(long id, Ice.Callback __cb)
    {
        return begin_addImage(id, null, false, __cb);
    }

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addImage(long id, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_addImage(id, __ctx, true, __cb);
    }

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addImage(long id, Callback_Exporter_addImage __cb)
    {
        return begin_addImage(id, null, false, __cb);
    }

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addImage(long id, java.util.Map<String, String> __ctx, Callback_Exporter_addImage __cb)
    {
        return begin_addImage(id, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_addImage(long id, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__addImage_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __addImage_name, __cb);
        try
        {
            __result.__prepare(__addImage_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(id);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_addImage(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __addImage_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __cb The callback object for the operation.
     **/
    public boolean addImage_async(AMI_Exporter_addImage __cb, long id)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addImage_name);
            __r = begin_addImage(id, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addImage_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addImage_async(AMI_Exporter_addImage __cb, long id, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addImage_name);
            __r = begin_addImage(id, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addImage_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __generateTiff_name = "generateTiff";

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     **/
    public long generateTiff()
        throws omero.ServerError
    {
        return generateTiff(null, false);
    }

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __ctx The Context map to send with the invocation.
     **/
    public long generateTiff(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return generateTiff(__ctx, true);
    }

    private long generateTiff(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "generateTiff", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("generateTiff");
                    __delBase = __getDelegate(false);
                    _ExporterDel __del = (_ExporterDel)__delBase;
                    return __del.generateTiff(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_generateTiff()
    {
        return begin_generateTiff(null, false, null);
    }

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_generateTiff(java.util.Map<String, String> __ctx)
    {
        return begin_generateTiff(__ctx, true, null);
    }

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_generateTiff(Ice.Callback __cb)
    {
        return begin_generateTiff(null, false, __cb);
    }

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_generateTiff(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_generateTiff(__ctx, true, __cb);
    }

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_generateTiff(Callback_Exporter_generateTiff __cb)
    {
        return begin_generateTiff(null, false, __cb);
    }

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_generateTiff(java.util.Map<String, String> __ctx, Callback_Exporter_generateTiff __cb)
    {
        return begin_generateTiff(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_generateTiff(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__generateTiff_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __generateTiff_name, __cb);
        try
        {
            __result.__prepare(__generateTiff_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public long end_generateTiff(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __generateTiff_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __cb The callback object for the operation.
     **/
    public boolean generateTiff_async(AMI_Exporter_generateTiff __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__generateTiff_name);
            __r = begin_generateTiff(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __generateTiff_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean generateTiff_async(AMI_Exporter_generateTiff __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__generateTiff_name);
            __r = begin_generateTiff(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __generateTiff_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __generateXml_name = "generateXml";

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     **/
    public long generateXml()
        throws omero.ServerError
    {
        return generateXml(null, false);
    }

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __ctx The Context map to send with the invocation.
     **/
    public long generateXml(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return generateXml(__ctx, true);
    }

    private long generateXml(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "generateXml", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("generateXml");
                    __delBase = __getDelegate(false);
                    _ExporterDel __del = (_ExporterDel)__delBase;
                    return __del.generateXml(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_generateXml()
    {
        return begin_generateXml(null, false, null);
    }

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_generateXml(java.util.Map<String, String> __ctx)
    {
        return begin_generateXml(__ctx, true, null);
    }

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_generateXml(Ice.Callback __cb)
    {
        return begin_generateXml(null, false, __cb);
    }

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_generateXml(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_generateXml(__ctx, true, __cb);
    }

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_generateXml(Callback_Exporter_generateXml __cb)
    {
        return begin_generateXml(null, false, __cb);
    }

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_generateXml(java.util.Map<String, String> __ctx, Callback_Exporter_generateXml __cb)
    {
        return begin_generateXml(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_generateXml(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__generateXml_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __generateXml_name, __cb);
        try
        {
            __result.__prepare(__generateXml_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public long end_generateXml(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __generateXml_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __cb The callback object for the operation.
     **/
    public boolean generateXml_async(AMI_Exporter_generateXml __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__generateXml_name);
            __r = begin_generateXml(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __generateXml_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean generateXml_async(AMI_Exporter_generateXml __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__generateXml_name);
            __r = begin_generateXml(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __generateXml_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __read_name = "read";

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     **/
    public byte[] read(long position, int length)
        throws omero.ServerError
    {
        return read(position, length, null, false);
    }

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __ctx The Context map to send with the invocation.
     **/
    public byte[] read(long position, int length, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return read(position, length, __ctx, true);
    }

    private byte[] read(long position, int length, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "read", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("read");
                    __delBase = __getDelegate(false);
                    _ExporterDel __del = (_ExporterDel)__delBase;
                    return __del.read(position, length, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_read(long position, int length)
    {
        return begin_read(position, length, null, false, null);
    }

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_read(long position, int length, java.util.Map<String, String> __ctx)
    {
        return begin_read(position, length, __ctx, true, null);
    }

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_read(long position, int length, Ice.Callback __cb)
    {
        return begin_read(position, length, null, false, __cb);
    }

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_read(long position, int length, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_read(position, length, __ctx, true, __cb);
    }

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_read(long position, int length, Callback_Exporter_read __cb)
    {
        return begin_read(position, length, null, false, __cb);
    }

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_read(long position, int length, java.util.Map<String, String> __ctx, Callback_Exporter_read __cb)
    {
        return begin_read(position, length, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_read(long position, int length, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__read_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __read_name, __cb);
        try
        {
            __result.__prepare(__read_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(position);
            __os.writeInt(length);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public byte[] end_read(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __read_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __cb The callback object for the operation.
     **/
    public boolean read_async(AMI_Exporter_read __cb, long position, int length)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__read_name);
            __r = begin_read(position, length, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __read_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean read_async(AMI_Exporter_read __cb, long position, int length, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__read_name);
            __r = begin_read(position, length, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __read_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __activate_name = "activate";

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     **/
    public void activate()
        throws omero.ServerError
    {
        activate(null, false);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void activate(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        activate(__ctx, true);
    }

    private void activate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "activate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("activate");
                    __delBase = __getDelegate(false);
                    _ExporterDel __del = (_ExporterDel)__delBase;
                    __del.activate(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate()
    {
        return begin_activate(null, false, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx)
    {
        return begin_activate(__ctx, true, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate(Ice.Callback __cb)
    {
        return begin_activate(null, false, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_activate(__ctx, true, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate(Callback_StatefulServiceInterface_activate __cb)
    {
        return begin_activate(null, false, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_activate __cb)
    {
        return begin_activate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__activate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
        try
        {
            __result.__prepare(__activate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_activate(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __activate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public boolean activate_async(AMI_StatefulServiceInterface_activate __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__activate_name);
            __r = begin_activate(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean activate_async(AMI_StatefulServiceInterface_activate __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__activate_name);
            __r = begin_activate(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __close_name = "close";

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     **/
    public void close()
        throws omero.ServerError
    {
        close(null, false);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void close(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        close(__ctx, true);
    }

    private void close(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "close", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("close");
                    __delBase = __getDelegate(false);
                    _ExporterDel __del = (_ExporterDel)__delBase;
                    __del.close(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close()
    {
        return begin_close(null, false, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx)
    {
        return begin_close(__ctx, true, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close(Ice.Callback __cb)
    {
        return begin_close(null, false, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_close(__ctx, true, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close(Callback_StatefulServiceInterface_close __cb)
    {
        return begin_close(null, false, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_close __cb)
    {
        return begin_close(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__close_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __close_name, __cb);
        try
        {
            __result.__prepare(__close_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_close(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __close_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public boolean close_async(AMI_StatefulServiceInterface_close __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__close_name);
            __r = begin_close(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __close_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean close_async(AMI_StatefulServiceInterface_close __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__close_name);
            __r = begin_close(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __close_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getCurrentEventContext_name = "getCurrentEventContext";

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     **/
    public omero.sys.EventContext getCurrentEventContext()
        throws omero.ServerError
    {
        return getCurrentEventContext(null, false);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.sys.EventContext getCurrentEventContext(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getCurrentEventContext(__ctx, true);
    }

    private omero.sys.EventContext getCurrentEventContext(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getCurrentEventContext", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getCurrentEventContext");
                    __delBase = __getDelegate(false);
                    _ExporterDel __del = (_ExporterDel)__delBase;
                    return __del.getCurrentEventContext(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext()
    {
        return begin_getCurrentEventContext(null, false, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx)
    {
        return begin_getCurrentEventContext(__ctx, true, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(Ice.Callback __cb)
    {
        return begin_getCurrentEventContext(null, false, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getCurrentEventContext(__ctx, true, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(Callback_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        return begin_getCurrentEventContext(null, false, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        return begin_getCurrentEventContext(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getCurrentEventContext_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
        try
        {
            __result.__prepare(__getCurrentEventContext_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.sys.EventContext end_getCurrentEventContext(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getCurrentEventContext_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.sys.EventContextHolder __ret = new omero.sys.EventContextHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public boolean getCurrentEventContext_async(AMI_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCurrentEventContext_name);
            __r = begin_getCurrentEventContext(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getCurrentEventContext_async(AMI_StatefulServiceInterface_getCurrentEventContext __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCurrentEventContext_name);
            __r = begin_getCurrentEventContext(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __passivate_name = "passivate";

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     **/
    public void passivate()
        throws omero.ServerError
    {
        passivate(null, false);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void passivate(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        passivate(__ctx, true);
    }

    private void passivate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "passivate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("passivate");
                    __delBase = __getDelegate(false);
                    _ExporterDel __del = (_ExporterDel)__delBase;
                    __del.passivate(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate()
    {
        return begin_passivate(null, false, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx)
    {
        return begin_passivate(__ctx, true, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate(Ice.Callback __cb)
    {
        return begin_passivate(null, false, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_passivate(__ctx, true, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate(Callback_StatefulServiceInterface_passivate __cb)
    {
        return begin_passivate(null, false, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_passivate __cb)
    {
        return begin_passivate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__passivate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
        try
        {
            __result.__prepare(__passivate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_passivate(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __passivate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public boolean passivate_async(AMI_StatefulServiceInterface_passivate __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__passivate_name);
            __r = begin_passivate(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean passivate_async(AMI_StatefulServiceInterface_passivate __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__passivate_name);
            __r = begin_passivate(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static ExporterPrx checkedCast(Ice.ObjectPrx __obj)
    {
        ExporterPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ExporterPrx)
            {
                __d = (ExporterPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    ExporterPrxHelper __h = new ExporterPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ExporterPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        ExporterPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ExporterPrx)
            {
                __d = (ExporterPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    ExporterPrxHelper __h = new ExporterPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ExporterPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ExporterPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    ExporterPrxHelper __h = new ExporterPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ExporterPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        ExporterPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    ExporterPrxHelper __h = new ExporterPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ExporterPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        ExporterPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ExporterPrx)
            {
                __d = (ExporterPrx)__obj;
            }
            else
            {
                ExporterPrxHelper __h = new ExporterPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static ExporterPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ExporterPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            ExporterPrxHelper __h = new ExporterPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::Exporter",
        "::omero::api::ServiceInterface",
        "::omero::api::StatefulServiceInterface"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _ExporterDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _ExporterDelD();
    }

    public static void __write(IceInternal.BasicStream __os, ExporterPrx v)
    {
        __os.writeProxy(v);
    }

    public static ExporterPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            ExporterPrxHelper result = new ExporterPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
