// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IConfig.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Access to server configuration. These methods provide access to the
 * state and configuration of the server and its components (e.g. the
 * database). However, it should not be assumed that two subsequent
 * calls to a proxy for this service will go to the same server due to
 * clustering.
 * 
 * Not all possible server configuration is available through this
 * API. Some values (such as DB connection info, ports, etc.) must
 * naturally be set before this service is accessible.
 * 
 * Manages synchronization of the various configuration sources
 * internally. It is therefore important that as far as possible all
 * configuration changes take place via this interface and not, for
 * example, directly via java.util.prefs.Preferences.
 * 
 * Also used as the main developer example for developing (stateless)
 * ome.api interfaces. See source code documentation for more.
 **/
public interface IConfigPrx extends ServiceInterfacePrx
{
    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     **/
    public String getVersion()
        throws omero.ServerError;

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @param __ctx The Context map to send with the invocation.
     **/
    public String getVersion(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getVersion();

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getVersion(java.util.Map<String, String> __ctx);

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getVersion(Ice.Callback __cb);

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getVersion(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getVersion(Callback_IConfig_getVersion __cb);

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getVersion(java.util.Map<String, String> __ctx, Callback_IConfig_getVersion __cb);

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @param __result The asynchronous result object.
     **/
    public String end_getVersion(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @param __cb The callback object for the operation.
     **/
    public boolean getVersion_async(AMI_IConfig_getVersion __cb);

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getVersion_async(AMI_IConfig_getVersion __cb, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @return The string value linked to this key, possibly null
     * if not set.
     * @throws ApiUsageException if the key is null or invalid.
     * @throws SecurityViolation if the value for the key is not
     * readable.
     **/
    public String getConfigValue(String key)
        throws omero.ServerError;

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @param __ctx The Context map to send with the invocation.
     * @return The string value linked to this key, possibly null
     * if not set.
     * @throws ApiUsageException if the key is null or invalid.
     * @throws SecurityViolation if the value for the key is not
     * readable.
     **/
    public String getConfigValue(String key, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getConfigValue(String key);

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getConfigValue(String key, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getConfigValue(String key, Ice.Callback __cb);

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getConfigValue(String key, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getConfigValue(String key, Callback_IConfig_getConfigValue __cb);

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getConfigValue(String key, java.util.Map<String, String> __ctx, Callback_IConfig_getConfigValue __cb);

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param __result The asynchronous result object.
     * @return The string value linked to this key, possibly null
     * if not set.
     * @throws ApiUsageException if the key is null or invalid.
     * @throws SecurityViolation if the value for the key is not
     * readable.
     **/
    public String end_getConfigValue(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     **/
    public boolean getConfigValue_async(AMI_IConfig_getConfigValue __cb, String key);

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getConfigValue_async(AMI_IConfig_getConfigValue __cb, String key, java.util.Map<String, String> __ctx);

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param keyRegex The non-null regex of the desired
     * configuration values
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> getConfigValues(String keyRegex)
        throws omero.ServerError;

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param keyRegex The non-null regex of the desired
     * configuration values
     * @param __ctx The Context map to send with the invocation.
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> getConfigValues(String keyRegex, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param keyRegex The non-null regex of the desired
     * configuration values
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getConfigValues(String keyRegex);

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param keyRegex The non-null regex of the desired
     * configuration values
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getConfigValues(String keyRegex, java.util.Map<String, String> __ctx);

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param keyRegex The non-null regex of the desired
     * configuration values
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getConfigValues(String keyRegex, Ice.Callback __cb);

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param keyRegex The non-null regex of the desired
     * configuration values
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getConfigValues(String keyRegex, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param keyRegex The non-null regex of the desired
     * configuration values
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getConfigValues(String keyRegex, Callback_IConfig_getConfigValues __cb);

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param keyRegex The non-null regex of the desired
     * configuration values
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getConfigValues(String keyRegex, java.util.Map<String, String> __ctx, Callback_IConfig_getConfigValues __cb);

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param __result The asynchronous result object.
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> end_getConfigValues(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param __cb The callback object for the operation.
     * @param keyRegex The non-null regex of the desired
     * configuration values
     **/
    public boolean getConfigValues_async(AMI_IConfig_getConfigValues __cb, String keyRegex);

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param __cb The callback object for the operation.
     * @param keyRegex The non-null regex of the desired
     * configuration values
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getConfigValues_async(AMI_IConfig_getConfigValues __cb, String keyRegex, java.util.Map<String, String> __ctx);

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> getConfigDefaults()
        throws omero.ServerError;

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> getConfigDefaults(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getConfigDefaults();

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getConfigDefaults(java.util.Map<String, String> __ctx);

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getConfigDefaults(Ice.Callback __cb);

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getConfigDefaults(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getConfigDefaults(Callback_IConfig_getConfigDefaults __cb);

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getConfigDefaults(java.util.Map<String, String> __ctx, Callback_IConfig_getConfigDefaults __cb);

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @param __result The asynchronous result object.
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> end_getConfigDefaults(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getConfigDefaults_async(AMI_IConfig_getConfigDefaults __cb);

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getConfigDefaults_async(AMI_IConfig_getConfigDefaults __cb, java.util.Map<String, String> __ctx);

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> getClientConfigValues()
        throws omero.ServerError;

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> getClientConfigValues(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getClientConfigValues();

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getClientConfigValues(java.util.Map<String, String> __ctx);

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getClientConfigValues(Ice.Callback __cb);

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getClientConfigValues(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getClientConfigValues(Callback_IConfig_getClientConfigValues __cb);

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getClientConfigValues(java.util.Map<String, String> __ctx, Callback_IConfig_getClientConfigValues __cb);

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @param __result The asynchronous result object.
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> end_getClientConfigValues(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getClientConfigValues_async(AMI_IConfig_getClientConfigValues __cb);

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getClientConfigValues_async(AMI_IConfig_getClientConfigValues __cb, java.util.Map<String, String> __ctx);

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> getClientConfigDefaults()
        throws omero.ServerError;

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> getClientConfigDefaults(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getClientConfigDefaults();

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getClientConfigDefaults(java.util.Map<String, String> __ctx);

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getClientConfigDefaults(Ice.Callback __cb);

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getClientConfigDefaults(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getClientConfigDefaults(Callback_IConfig_getClientConfigDefaults __cb);

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getClientConfigDefaults(java.util.Map<String, String> __ctx, Callback_IConfig_getClientConfigDefaults __cb);

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @param __result The asynchronous result object.
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> end_getClientConfigDefaults(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getClientConfigDefaults_async(AMI_IConfig_getClientConfigDefaults __cb);

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getClientConfigDefaults_async(AMI_IConfig_getClientConfigDefaults __cb, java.util.Map<String, String> __ctx);

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     * @throws ApiUsageException if the key is null or invalid.
     * @throws SecurityViolation if the value is not writable.
     **/
    public void setConfigValue(String key, String value)
        throws omero.ServerError;

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     * @throws ApiUsageException if the key is null or invalid.
     * @throws SecurityViolation if the value is not writable.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setConfigValue(String key, String value, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setConfigValue(String key, String value);

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setConfigValue(String key, String value, java.util.Map<String, String> __ctx);

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setConfigValue(String key, String value, Ice.Callback __cb);

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setConfigValue(String key, String value, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setConfigValue(String key, String value, Callback_IConfig_setConfigValue __cb);

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setConfigValue(String key, String value, java.util.Map<String, String> __ctx, Callback_IConfig_setConfigValue __cb);

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param __result The asynchronous result object.
     * @throws ApiUsageException if the key is null or invalid.
     * @throws SecurityViolation if the value is not writable.
     **/
    public void end_setConfigValue(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     **/
    public boolean setConfigValue_async(AMI_IConfig_setConfigValue __cb, String key, String value);

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setConfigValue_async(AMI_IConfig_setConfigValue __cb, String key, String value, java.util.Map<String, String> __ctx);

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param key
     * @param value
     * @throws ApiUsageException
     * @throws SecurityViolation
     * @see #setConfigValue
     **/
    public boolean setConfigValueIfEquals(String key, String value, String test)
        throws omero.ServerError;

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param key
     * @param value
     * @throws ApiUsageException
     * @throws SecurityViolation
     * @see #setConfigValue
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setConfigValueIfEquals(String key, String value, String test, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param key
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setConfigValueIfEquals(String key, String value, String test);

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param key
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setConfigValueIfEquals(String key, String value, String test, java.util.Map<String, String> __ctx);

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param key
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setConfigValueIfEquals(String key, String value, String test, Ice.Callback __cb);

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param key
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setConfigValueIfEquals(String key, String value, String test, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param key
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setConfigValueIfEquals(String key, String value, String test, Callback_IConfig_setConfigValueIfEquals __cb);

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param key
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setConfigValueIfEquals(String key, String value, String test, java.util.Map<String, String> __ctx, Callback_IConfig_setConfigValueIfEquals __cb);

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param __result The asynchronous result object.
     * @throws ApiUsageException
     * @throws SecurityViolation
     * @see #setConfigValue
     **/
    public boolean end_setConfigValueIfEquals(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param __cb The callback object for the operation.
     * @param key
     **/
    public boolean setConfigValueIfEquals_async(AMI_IConfig_setConfigValueIfEquals __cb, String key, String value, String test);

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param __cb The callback object for the operation.
     * @param key
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setConfigValueIfEquals_async(AMI_IConfig_setConfigValueIfEquals __cb, String key, String value, String test, java.util.Map<String, String> __ctx);

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @return String not null.
     **/
    public String getDatabaseUuid()
        throws omero.ServerError;

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return String not null.
     **/
    public String getDatabaseUuid(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDatabaseUuid();

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDatabaseUuid(java.util.Map<String, String> __ctx);

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDatabaseUuid(Ice.Callback __cb);

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDatabaseUuid(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDatabaseUuid(Callback_IConfig_getDatabaseUuid __cb);

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDatabaseUuid(java.util.Map<String, String> __ctx, Callback_IConfig_getDatabaseUuid __cb);

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @param __result The asynchronous result object.
     * @return String not null.
     **/
    public String end_getDatabaseUuid(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getDatabaseUuid_async(AMI_IConfig_getDatabaseUuid __cb);

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getDatabaseUuid_async(AMI_IConfig_getDatabaseUuid __cb, java.util.Map<String, String> __ctx);

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @return Non-null {@link RTime} representation of the
     * database time.
     * @throws InternalException though any call can throw an
     * InternalException it is more likely that this can
     * occur while contacting the DB. An exception here
     * most likely means (A) a temporary issue with the DB
     * or (B) a SQL dialect issue which must be corrected
     * by the Omero team.
     **/
    public omero.RTime getDatabaseTime()
        throws omero.ServerError;

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return Non-null {@link RTime} representation of the
     * database time.
     * @throws InternalException though any call can throw an
     * InternalException it is more likely that this can
     * occur while contacting the DB. An exception here
     * most likely means (A) a temporary issue with the DB
     * or (B) a SQL dialect issue which must be corrected
     * by the Omero team.
     **/
    public omero.RTime getDatabaseTime(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDatabaseTime();

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDatabaseTime(java.util.Map<String, String> __ctx);

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDatabaseTime(Ice.Callback __cb);

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDatabaseTime(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDatabaseTime(Callback_IConfig_getDatabaseTime __cb);

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDatabaseTime(java.util.Map<String, String> __ctx, Callback_IConfig_getDatabaseTime __cb);

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @param __result The asynchronous result object.
     * @return Non-null {@link RTime} representation of the
     * database time.
     * @throws InternalException though any call can throw an
     * InternalException it is more likely that this can
     * occur while contacting the DB. An exception here
     * most likely means (A) a temporary issue with the DB
     * or (B) a SQL dialect issue which must be corrected
     * by the Omero team.
     **/
    public omero.RTime end_getDatabaseTime(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getDatabaseTime_async(AMI_IConfig_getDatabaseTime __cb);

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getDatabaseTime_async(AMI_IConfig_getDatabaseTime __cb, java.util.Map<String, String> __ctx);

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @return Non-null {@link RTime} representation of the
     * server's own time.
     **/
    public omero.RTime getServerTime()
        throws omero.ServerError;

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return Non-null {@link RTime} representation of the
     * server's own time.
     **/
    public omero.RTime getServerTime(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getServerTime();

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getServerTime(java.util.Map<String, String> __ctx);

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getServerTime(Ice.Callback __cb);

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getServerTime(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getServerTime(Callback_IConfig_getServerTime __cb);

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getServerTime(java.util.Map<String, String> __ctx, Callback_IConfig_getServerTime __cb);

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @param __result The asynchronous result object.
     * @return Non-null {@link RTime} representation of the
     * server's own time.
     **/
    public omero.RTime end_getServerTime(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getServerTime_async(AMI_IConfig_getServerTime __cb);

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getServerTime_async(AMI_IConfig_getServerTime __cb, java.util.Map<String, String> __ctx);
}
