// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IConfig.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Access to server configuration. These methods provide access to the
 * state and configuration of the server and its components (e.g. the
 * database). However, it should not be assumed that two subsequent
 * calls to a proxy for this service will go to the same server due to
 * clustering.
 * 
 * Not all possible server configuration is available through this
 * API. Some values (such as DB connection info, ports, etc.) must
 * naturally be set before this service is accessible.
 * 
 * Manages synchronization of the various configuration sources
 * internally. It is therefore important that as far as possible all
 * configuration changes take place via this interface and not, for
 * example, directly via java.util.prefs.Preferences.
 * 
 * Also used as the main developer example for developing (stateless)
 * ome.api interfaces. See source code documentation for more.
 **/
public final class IConfigPrxHelper extends Ice.ObjectPrxHelperBase implements IConfigPrx
{
    private static final String __getClientConfigDefaults_name = "getClientConfigDefaults";

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> getClientConfigDefaults()
        throws omero.ServerError
    {
        return getClientConfigDefaults(null, false);
    }

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> getClientConfigDefaults(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getClientConfigDefaults(__ctx, true);
    }

    private java.util.Map<java.lang.String, java.lang.String> getClientConfigDefaults(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getClientConfigDefaults", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getClientConfigDefaults");
                    __delBase = __getDelegate(false);
                    _IConfigDel __del = (_IConfigDel)__delBase;
                    return __del.getClientConfigDefaults(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getClientConfigDefaults()
    {
        return begin_getClientConfigDefaults(null, false, null);
    }

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getClientConfigDefaults(java.util.Map<String, String> __ctx)
    {
        return begin_getClientConfigDefaults(__ctx, true, null);
    }

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getClientConfigDefaults(Ice.Callback __cb)
    {
        return begin_getClientConfigDefaults(null, false, __cb);
    }

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getClientConfigDefaults(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getClientConfigDefaults(__ctx, true, __cb);
    }

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getClientConfigDefaults(Callback_IConfig_getClientConfigDefaults __cb)
    {
        return begin_getClientConfigDefaults(null, false, __cb);
    }

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getClientConfigDefaults(java.util.Map<String, String> __ctx, Callback_IConfig_getClientConfigDefaults __cb)
    {
        return begin_getClientConfigDefaults(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getClientConfigDefaults(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getClientConfigDefaults_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getClientConfigDefaults_name, __cb);
        try
        {
            __result.__prepare(__getClientConfigDefaults_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> end_getClientConfigDefaults(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getClientConfigDefaults_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.String, java.lang.String> __ret;
            __ret = StringStringMapHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getClientConfigDefaults_async(AMI_IConfig_getClientConfigDefaults __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getClientConfigDefaults_name);
            __r = begin_getClientConfigDefaults(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getClientConfigDefaults_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there which match the prefix
     * <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getClientConfigDefaults_async(AMI_IConfig_getClientConfigDefaults __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getClientConfigDefaults_name);
            __r = begin_getClientConfigDefaults(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getClientConfigDefaults_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getClientConfigValues_name = "getClientConfigValues";

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> getClientConfigValues()
        throws omero.ServerError
    {
        return getClientConfigValues(null, false);
    }

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> getClientConfigValues(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getClientConfigValues(__ctx, true);
    }

    private java.util.Map<java.lang.String, java.lang.String> getClientConfigValues(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getClientConfigValues", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getClientConfigValues");
                    __delBase = __getDelegate(false);
                    _IConfigDel __del = (_IConfigDel)__delBase;
                    return __del.getClientConfigValues(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getClientConfigValues()
    {
        return begin_getClientConfigValues(null, false, null);
    }

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getClientConfigValues(java.util.Map<String, String> __ctx)
    {
        return begin_getClientConfigValues(__ctx, true, null);
    }

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getClientConfigValues(Ice.Callback __cb)
    {
        return begin_getClientConfigValues(null, false, __cb);
    }

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getClientConfigValues(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getClientConfigValues(__ctx, true, __cb);
    }

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getClientConfigValues(Callback_IConfig_getClientConfigValues __cb)
    {
        return begin_getClientConfigValues(null, false, __cb);
    }

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getClientConfigValues(java.util.Map<String, String> __ctx, Callback_IConfig_getClientConfigValues __cb)
    {
        return begin_getClientConfigValues(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getClientConfigValues(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getClientConfigValues_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getClientConfigValues_name, __cb);
        try
        {
            __result.__prepare(__getClientConfigValues_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> end_getClientConfigValues(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getClientConfigValues_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.String, java.lang.String> __ret;
            __ret = StringStringMapHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getClientConfigValues_async(AMI_IConfig_getClientConfigValues __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getClientConfigValues_name);
            __r = begin_getClientConfigValues(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getClientConfigValues_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves configuration values like {@link #getConfigValues}
     * but only those with the prefix <i>omero.client</i>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getClientConfigValues_async(AMI_IConfig_getClientConfigValues __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getClientConfigValues_name);
            __r = begin_getClientConfigValues(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getClientConfigValues_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getConfigDefaults_name = "getConfigDefaults";

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> getConfigDefaults()
        throws omero.ServerError
    {
        return getConfigDefaults(null, false);
    }

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> getConfigDefaults(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getConfigDefaults(__ctx, true);
    }

    private java.util.Map<java.lang.String, java.lang.String> getConfigDefaults(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getConfigDefaults", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getConfigDefaults");
                    __delBase = __getDelegate(false);
                    _IConfigDel __del = (_IConfigDel)__delBase;
                    return __del.getConfigDefaults(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getConfigDefaults()
    {
        return begin_getConfigDefaults(null, false, null);
    }

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getConfigDefaults(java.util.Map<String, String> __ctx)
    {
        return begin_getConfigDefaults(__ctx, true, null);
    }

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getConfigDefaults(Ice.Callback __cb)
    {
        return begin_getConfigDefaults(null, false, __cb);
    }

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getConfigDefaults(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getConfigDefaults(__ctx, true, __cb);
    }

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getConfigDefaults(Callback_IConfig_getConfigDefaults __cb)
    {
        return begin_getConfigDefaults(null, false, __cb);
    }

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getConfigDefaults(java.util.Map<String, String> __ctx, Callback_IConfig_getConfigDefaults __cb)
    {
        return begin_getConfigDefaults(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getConfigDefaults(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getConfigDefaults_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getConfigDefaults_name, __cb);
        try
        {
            __result.__prepare(__getConfigDefaults_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> end_getConfigDefaults(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getConfigDefaults_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.String, java.lang.String> __ret;
            __ret = StringStringMapHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getConfigDefaults_async(AMI_IConfig_getConfigDefaults __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getConfigDefaults_name);
            __r = begin_getConfigDefaults(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getConfigDefaults_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Reads the etc/omero.properties file and returns all the
     * key/value pairs that are found there. Since this file is
     * not to be edited its assumed that these values are in the
     * public domain and so there's no need to protect them.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getConfigDefaults_async(AMI_IConfig_getConfigDefaults __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getConfigDefaults_name);
            __r = begin_getConfigDefaults(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getConfigDefaults_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getConfigValue_name = "getConfigValue";

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @return The string value linked to this key, possibly null
     * if not set.
     * @throws ApiUsageException if the key is null or invalid.
     * @throws SecurityViolation if the value for the key is not
     * readable.
     **/
    public String getConfigValue(String key)
        throws omero.ServerError
    {
        return getConfigValue(key, null, false);
    }

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @param __ctx The Context map to send with the invocation.
     * @return The string value linked to this key, possibly null
     * if not set.
     * @throws ApiUsageException if the key is null or invalid.
     * @throws SecurityViolation if the value for the key is not
     * readable.
     **/
    public String getConfigValue(String key, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getConfigValue(key, __ctx, true);
    }

    private String getConfigValue(String key, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getConfigValue", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getConfigValue");
                    __delBase = __getDelegate(false);
                    _IConfigDel __del = (_IConfigDel)__delBase;
                    return __del.getConfigValue(key, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     **/
    public Ice.AsyncResult begin_getConfigValue(String key)
    {
        return begin_getConfigValue(key, null, false, null);
    }

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getConfigValue(String key, java.util.Map<String, String> __ctx)
    {
        return begin_getConfigValue(key, __ctx, true, null);
    }

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     **/
    public Ice.AsyncResult begin_getConfigValue(String key, Ice.Callback __cb)
    {
        return begin_getConfigValue(key, null, false, __cb);
    }

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getConfigValue(String key, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getConfigValue(key, __ctx, true, __cb);
    }

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     **/
    public Ice.AsyncResult begin_getConfigValue(String key, Callback_IConfig_getConfigValue __cb)
    {
        return begin_getConfigValue(key, null, false, __cb);
    }

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getConfigValue(String key, java.util.Map<String, String> __ctx, Callback_IConfig_getConfigValue __cb)
    {
        return begin_getConfigValue(key, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getConfigValue(String key, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getConfigValue_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getConfigValue_name, __cb);
        try
        {
            __result.__prepare(__getConfigValue_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(key);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) The string value linked to this key, possibly null
     * if not set.
     **/
    public String end_getConfigValue(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getConfigValue_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            String __ret;
            __ret = __is.readString();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     **/
    public boolean getConfigValue_async(AMI_IConfig_getConfigValue __cb, String key)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getConfigValue_name);
            __r = begin_getConfigValue(key, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getConfigValue_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a configuration value from the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getConfigValue_async(AMI_IConfig_getConfigValue __cb, String key, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getConfigValue_name);
            __r = begin_getConfigValue(key, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getConfigValue_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getConfigValues_name = "getConfigValues";

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param keyRegex The non-null regex of the desired
     * configuration values
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> getConfigValues(String keyRegex)
        throws omero.ServerError
    {
        return getConfigValues(keyRegex, null, false);
    }

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param keyRegex The non-null regex of the desired
     * configuration values
     * @param __ctx The Context map to send with the invocation.
     * @return a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> getConfigValues(String keyRegex, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getConfigValues(keyRegex, __ctx, true);
    }

    private java.util.Map<java.lang.String, java.lang.String> getConfigValues(String keyRegex, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getConfigValues", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getConfigValues");
                    __delBase = __getDelegate(false);
                    _IConfigDel __del = (_IConfigDel)__delBase;
                    return __del.getConfigValues(keyRegex, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param __cb The callback object for the operation.
     * @param keyRegex The non-null regex of the desired
     * configuration values
     **/
    public Ice.AsyncResult begin_getConfigValues(String keyRegex)
    {
        return begin_getConfigValues(keyRegex, null, false, null);
    }

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param __cb The callback object for the operation.
     * @param keyRegex The non-null regex of the desired
     * configuration values
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getConfigValues(String keyRegex, java.util.Map<String, String> __ctx)
    {
        return begin_getConfigValues(keyRegex, __ctx, true, null);
    }

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param __cb The callback object for the operation.
     * @param keyRegex The non-null regex of the desired
     * configuration values
     **/
    public Ice.AsyncResult begin_getConfigValues(String keyRegex, Ice.Callback __cb)
    {
        return begin_getConfigValues(keyRegex, null, false, __cb);
    }

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param __cb The callback object for the operation.
     * @param keyRegex The non-null regex of the desired
     * configuration values
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getConfigValues(String keyRegex, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getConfigValues(keyRegex, __ctx, true, __cb);
    }

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param __cb The callback object for the operation.
     * @param keyRegex The non-null regex of the desired
     * configuration values
     **/
    public Ice.AsyncResult begin_getConfigValues(String keyRegex, Callback_IConfig_getConfigValues __cb)
    {
        return begin_getConfigValues(keyRegex, null, false, __cb);
    }

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param __cb The callback object for the operation.
     * @param keyRegex The non-null regex of the desired
     * configuration values
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getConfigValues(String keyRegex, java.util.Map<String, String> __ctx, Callback_IConfig_getConfigValues __cb)
    {
        return begin_getConfigValues(keyRegex, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getConfigValues(String keyRegex, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getConfigValues_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getConfigValues_name, __cb);
        try
        {
            __result.__prepare(__getConfigValues_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(keyRegex);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a map from the found keys to the linked values.
     **/
    public java.util.Map<java.lang.String, java.lang.String> end_getConfigValues(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getConfigValues_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.String, java.lang.String> __ret;
            __ret = StringStringMapHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param __cb The callback object for the operation.
     * @param keyRegex The non-null regex of the desired
     * configuration values
     **/
    public boolean getConfigValues_async(AMI_IConfig_getConfigValues __cb, String keyRegex)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getConfigValues_name);
            __r = begin_getConfigValues(keyRegex, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getConfigValues_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves configuration values from the backend store which
     * match the given regex. Any configuration value which would
     * throw an exception on being loaded is omitted.
     * 
     * @param __cb The callback object for the operation.
     * @param keyRegex The non-null regex of the desired
     * configuration values
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getConfigValues_async(AMI_IConfig_getConfigValues __cb, String keyRegex, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getConfigValues_name);
            __r = begin_getConfigValues(keyRegex, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getConfigValues_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getDatabaseTime_name = "getDatabaseTime";

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @return Non-null {@link RTime} representation of the
     * database time.
     * @throws InternalException though any call can throw an
     * InternalException it is more likely that this can
     * occur while contacting the DB. An exception here
     * most likely means (A) a temporary issue with the DB
     * or (B) a SQL dialect issue which must be corrected
     * by the Omero team.
     **/
    public omero.RTime getDatabaseTime()
        throws omero.ServerError
    {
        return getDatabaseTime(null, false);
    }

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return Non-null {@link RTime} representation of the
     * database time.
     * @throws InternalException though any call can throw an
     * InternalException it is more likely that this can
     * occur while contacting the DB. An exception here
     * most likely means (A) a temporary issue with the DB
     * or (B) a SQL dialect issue which must be corrected
     * by the Omero team.
     **/
    public omero.RTime getDatabaseTime(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getDatabaseTime(__ctx, true);
    }

    private omero.RTime getDatabaseTime(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getDatabaseTime", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getDatabaseTime");
                    __delBase = __getDelegate(false);
                    _IConfigDel __del = (_IConfigDel)__delBase;
                    return __del.getDatabaseTime(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getDatabaseTime()
    {
        return begin_getDatabaseTime(null, false, null);
    }

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getDatabaseTime(java.util.Map<String, String> __ctx)
    {
        return begin_getDatabaseTime(__ctx, true, null);
    }

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getDatabaseTime(Ice.Callback __cb)
    {
        return begin_getDatabaseTime(null, false, __cb);
    }

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getDatabaseTime(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getDatabaseTime(__ctx, true, __cb);
    }

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getDatabaseTime(Callback_IConfig_getDatabaseTime __cb)
    {
        return begin_getDatabaseTime(null, false, __cb);
    }

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getDatabaseTime(java.util.Map<String, String> __ctx, Callback_IConfig_getDatabaseTime __cb)
    {
        return begin_getDatabaseTime(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getDatabaseTime(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getDatabaseTime_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getDatabaseTime_name, __cb);
        try
        {
            __result.__prepare(__getDatabaseTime_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Non-null {@link RTime} representation of the
     * database time.
     **/
    public omero.RTime end_getDatabaseTime(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getDatabaseTime_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.RTimeHolder __ret = new omero.RTimeHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getDatabaseTime_async(AMI_IConfig_getDatabaseTime __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getDatabaseTime_name);
            __r = begin_getDatabaseTime(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getDatabaseTime_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Checks the database for its time using a SELECT statement.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getDatabaseTime_async(AMI_IConfig_getDatabaseTime __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getDatabaseTime_name);
            __r = begin_getDatabaseTime(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getDatabaseTime_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getDatabaseUuid_name = "getDatabaseUuid";

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @return String not null.
     **/
    public String getDatabaseUuid()
        throws omero.ServerError
    {
        return getDatabaseUuid(null, false);
    }

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return String not null.
     **/
    public String getDatabaseUuid(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getDatabaseUuid(__ctx, true);
    }

    private String getDatabaseUuid(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getDatabaseUuid", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getDatabaseUuid");
                    __delBase = __getDelegate(false);
                    _IConfigDel __del = (_IConfigDel)__delBase;
                    return __del.getDatabaseUuid(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getDatabaseUuid()
    {
        return begin_getDatabaseUuid(null, false, null);
    }

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getDatabaseUuid(java.util.Map<String, String> __ctx)
    {
        return begin_getDatabaseUuid(__ctx, true, null);
    }

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getDatabaseUuid(Ice.Callback __cb)
    {
        return begin_getDatabaseUuid(null, false, __cb);
    }

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getDatabaseUuid(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getDatabaseUuid(__ctx, true, __cb);
    }

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getDatabaseUuid(Callback_IConfig_getDatabaseUuid __cb)
    {
        return begin_getDatabaseUuid(null, false, __cb);
    }

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getDatabaseUuid(java.util.Map<String, String> __ctx, Callback_IConfig_getDatabaseUuid __cb)
    {
        return begin_getDatabaseUuid(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getDatabaseUuid(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getDatabaseUuid_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getDatabaseUuid_name, __cb);
        try
        {
            __result.__prepare(__getDatabaseUuid_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) String not null.
     **/
    public String end_getDatabaseUuid(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getDatabaseUuid_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            String __ret;
            __ret = __is.readString();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getDatabaseUuid_async(AMI_IConfig_getDatabaseUuid __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getDatabaseUuid_name);
            __r = begin_getDatabaseUuid(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getDatabaseUuid_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Provides the UUID for this OMERO (database) instance. To
     * make imports and exports function properly, only one
     * physical database should be active with a given instance
     * UUID. All other copies of the database with that UUID are
     * invalid as soon as one modification is made.
     * 
     * This value is stored in the configuration table under the
     * key <i>omero.db.uuid</i>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getDatabaseUuid_async(AMI_IConfig_getDatabaseUuid __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getDatabaseUuid_name);
            __r = begin_getDatabaseUuid(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getDatabaseUuid_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getServerTime_name = "getServerTime";

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @return Non-null {@link RTime} representation of the
     * server's own time.
     **/
    public omero.RTime getServerTime()
        throws omero.ServerError
    {
        return getServerTime(null, false);
    }

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return Non-null {@link RTime} representation of the
     * server's own time.
     **/
    public omero.RTime getServerTime(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getServerTime(__ctx, true);
    }

    private omero.RTime getServerTime(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getServerTime", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getServerTime");
                    __delBase = __getDelegate(false);
                    _IConfigDel __del = (_IConfigDel)__delBase;
                    return __del.getServerTime(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getServerTime()
    {
        return begin_getServerTime(null, false, null);
    }

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getServerTime(java.util.Map<String, String> __ctx)
    {
        return begin_getServerTime(__ctx, true, null);
    }

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getServerTime(Ice.Callback __cb)
    {
        return begin_getServerTime(null, false, __cb);
    }

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getServerTime(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getServerTime(__ctx, true, __cb);
    }

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getServerTime(Callback_IConfig_getServerTime __cb)
    {
        return begin_getServerTime(null, false, __cb);
    }

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getServerTime(java.util.Map<String, String> __ctx, Callback_IConfig_getServerTime __cb)
    {
        return begin_getServerTime(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getServerTime(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getServerTime_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getServerTime_name, __cb);
        try
        {
            __result.__prepare(__getServerTime_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Non-null {@link RTime} representation of the
     * server's own time.
     **/
    public omero.RTime end_getServerTime(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getServerTime_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.RTimeHolder __ret = new omero.RTimeHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getServerTime_async(AMI_IConfig_getServerTime __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getServerTime_name);
            __r = begin_getServerTime(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getServerTime_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Checks the current server for its time. This value may be
     * variant depending on whether the service is clustered or
     * not.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getServerTime_async(AMI_IConfig_getServerTime __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getServerTime_name);
            __r = begin_getServerTime(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getServerTime_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getVersion_name = "getVersion";

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     **/
    public String getVersion()
        throws omero.ServerError
    {
        return getVersion(null, false);
    }

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @param __ctx The Context map to send with the invocation.
     **/
    public String getVersion(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getVersion(__ctx, true);
    }

    private String getVersion(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getVersion", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getVersion");
                    __delBase = __getDelegate(false);
                    _IConfigDel __del = (_IConfigDel)__delBase;
                    return __del.getVersion(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getVersion()
    {
        return begin_getVersion(null, false, null);
    }

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getVersion(java.util.Map<String, String> __ctx)
    {
        return begin_getVersion(__ctx, true, null);
    }

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getVersion(Ice.Callback __cb)
    {
        return begin_getVersion(null, false, __cb);
    }

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getVersion(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getVersion(__ctx, true, __cb);
    }

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getVersion(Callback_IConfig_getVersion __cb)
    {
        return begin_getVersion(null, false, __cb);
    }

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getVersion(java.util.Map<String, String> __ctx, Callback_IConfig_getVersion __cb)
    {
        return begin_getVersion(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getVersion(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getVersion_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getVersion_name, __cb);
        try
        {
            __result.__prepare(__getVersion_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public String end_getVersion(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getVersion_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            String __ret;
            __ret = __is.readString();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @param __cb The callback object for the operation.
     **/
    public boolean getVersion_async(AMI_IConfig_getVersion __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getVersion_name);
            __r = begin_getVersion(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getVersion_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Provides the release version. OMERO-internal values will be
     * in the form Major.minor.patch, starting with the value
     * 4.0.0 for the 4.0 release, Spring 2009.
     * 
     * Customized values should begin with a alphabetic sequence
     * followed by a hyphen: ACME-0.0.1 and any build information
     * should follow the patch number also with a hyphen:
     * 4.0.0-RC1. These values will be removed by
     * {@link #getVersion}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getVersion_async(AMI_IConfig_getVersion __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getVersion_name);
            __r = begin_getVersion(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getVersion_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setConfigValue_name = "setConfigValue";

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     * @throws ApiUsageException if the key is null or invalid.
     * @throws SecurityViolation if the value is not writable.
     **/
    public void setConfigValue(String key, String value)
        throws omero.ServerError
    {
        setConfigValue(key, value, null, false);
    }

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     * @throws ApiUsageException if the key is null or invalid.
     * @throws SecurityViolation if the value is not writable.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setConfigValue(String key, String value, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setConfigValue(key, value, __ctx, true);
    }

    private void setConfigValue(String key, String value, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setConfigValue", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setConfigValue");
                    __delBase = __getDelegate(false);
                    _IConfigDel __del = (_IConfigDel)__delBase;
                    __del.setConfigValue(key, value, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     **/
    public Ice.AsyncResult begin_setConfigValue(String key, String value)
    {
        return begin_setConfigValue(key, value, null, false, null);
    }

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setConfigValue(String key, String value, java.util.Map<String, String> __ctx)
    {
        return begin_setConfigValue(key, value, __ctx, true, null);
    }

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     **/
    public Ice.AsyncResult begin_setConfigValue(String key, String value, Ice.Callback __cb)
    {
        return begin_setConfigValue(key, value, null, false, __cb);
    }

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setConfigValue(String key, String value, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setConfigValue(key, value, __ctx, true, __cb);
    }

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     **/
    public Ice.AsyncResult begin_setConfigValue(String key, String value, Callback_IConfig_setConfigValue __cb)
    {
        return begin_setConfigValue(key, value, null, false, __cb);
    }

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setConfigValue(String key, String value, java.util.Map<String, String> __ctx, Callback_IConfig_setConfigValue __cb)
    {
        return begin_setConfigValue(key, value, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setConfigValue(String key, String value, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setConfigValue_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setConfigValue_name, __cb);
        try
        {
            __result.__prepare(__setConfigValue_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(key);
            __os.writeString(value);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setConfigValue(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setConfigValue_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     **/
    public boolean setConfigValue_async(AMI_IConfig_setConfigValue __cb, String key, String value)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setConfigValue_name);
            __r = begin_setConfigValue(key, value, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setConfigValue_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets a configuration value in the backend store.
     * Permissions applied to the configuration value may cause a
     * {@link SecurityViolation} to be thrown. If the value is
     * null or empty, then the configuration will be removed in
     * all writable configuration sources. If the configuration is
     * set in a non-modifiable source (e.g. in a property file on
     * the classpath), then a subsequent call to
     * {@link #getConfigValue} will return that value.
     * 
     * @param __cb The callback object for the operation.
     * @param key The non-null name of the desired configuration
     * value
     * @param value The string value to assign to the given key.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setConfigValue_async(AMI_IConfig_setConfigValue __cb, String key, String value, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setConfigValue_name);
            __r = begin_setConfigValue(key, value, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setConfigValue_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setConfigValueIfEquals_name = "setConfigValueIfEquals";

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param key
     * @param value
     * @throws ApiUsageException
     * @throws SecurityViolation
     * @see #setConfigValue
     **/
    public boolean setConfigValueIfEquals(String key, String value, String test)
        throws omero.ServerError
    {
        return setConfigValueIfEquals(key, value, test, null, false);
    }

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param key
     * @param value
     * @throws ApiUsageException
     * @throws SecurityViolation
     * @see #setConfigValue
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setConfigValueIfEquals(String key, String value, String test, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return setConfigValueIfEquals(key, value, test, __ctx, true);
    }

    private boolean setConfigValueIfEquals(String key, String value, String test, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setConfigValueIfEquals", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setConfigValueIfEquals");
                    __delBase = __getDelegate(false);
                    _IConfigDel __del = (_IConfigDel)__delBase;
                    return __del.setConfigValueIfEquals(key, value, test, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param __cb The callback object for the operation.
     * @param key
     **/
    public Ice.AsyncResult begin_setConfigValueIfEquals(String key, String value, String test)
    {
        return begin_setConfigValueIfEquals(key, value, test, null, false, null);
    }

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param __cb The callback object for the operation.
     * @param key
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setConfigValueIfEquals(String key, String value, String test, java.util.Map<String, String> __ctx)
    {
        return begin_setConfigValueIfEquals(key, value, test, __ctx, true, null);
    }

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param __cb The callback object for the operation.
     * @param key
     **/
    public Ice.AsyncResult begin_setConfigValueIfEquals(String key, String value, String test, Ice.Callback __cb)
    {
        return begin_setConfigValueIfEquals(key, value, test, null, false, __cb);
    }

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param __cb The callback object for the operation.
     * @param key
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setConfigValueIfEquals(String key, String value, String test, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setConfigValueIfEquals(key, value, test, __ctx, true, __cb);
    }

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param __cb The callback object for the operation.
     * @param key
     **/
    public Ice.AsyncResult begin_setConfigValueIfEquals(String key, String value, String test, Callback_IConfig_setConfigValueIfEquals __cb)
    {
        return begin_setConfigValueIfEquals(key, value, test, null, false, __cb);
    }

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param __cb The callback object for the operation.
     * @param key
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setConfigValueIfEquals(String key, String value, String test, java.util.Map<String, String> __ctx, Callback_IConfig_setConfigValueIfEquals __cb)
    {
        return begin_setConfigValueIfEquals(key, value, test, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setConfigValueIfEquals(String key, String value, String test, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setConfigValueIfEquals_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setConfigValueIfEquals_name, __cb);
        try
        {
            __result.__prepare(__setConfigValueIfEquals_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(key);
            __os.writeString(value);
            __os.writeString(test);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_setConfigValueIfEquals(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setConfigValueIfEquals_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param __cb The callback object for the operation.
     * @param key
     **/
    public boolean setConfigValueIfEquals_async(AMI_IConfig_setConfigValueIfEquals __cb, String key, String value, String test)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setConfigValueIfEquals_name);
            __r = begin_setConfigValueIfEquals(key, value, test, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setConfigValueIfEquals_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Calls {@link #setConfigValue} if and only if the
     * configuration property is currently equal to the test
     * argument. If the test is null or empty, then the
     * configuration property will be set only if missing.
     * 
     * @param __cb The callback object for the operation.
     * @param key
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setConfigValueIfEquals_async(AMI_IConfig_setConfigValueIfEquals __cb, String key, String value, String test, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setConfigValueIfEquals_name);
            __r = begin_setConfigValueIfEquals(key, value, test, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setConfigValueIfEquals_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static IConfigPrx checkedCast(Ice.ObjectPrx __obj)
    {
        IConfigPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IConfigPrx)
            {
                __d = (IConfigPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    IConfigPrxHelper __h = new IConfigPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static IConfigPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        IConfigPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IConfigPrx)
            {
                __d = (IConfigPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    IConfigPrxHelper __h = new IConfigPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static IConfigPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        IConfigPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    IConfigPrxHelper __h = new IConfigPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static IConfigPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        IConfigPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    IConfigPrxHelper __h = new IConfigPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static IConfigPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        IConfigPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IConfigPrx)
            {
                __d = (IConfigPrx)__obj;
            }
            else
            {
                IConfigPrxHelper __h = new IConfigPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static IConfigPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        IConfigPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            IConfigPrxHelper __h = new IConfigPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IConfig",
        "::omero::api::ServiceInterface"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _IConfigDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _IConfigDelD();
    }

    public static void __write(IceInternal.BasicStream __os, IConfigPrx v)
    {
        __os.writeProxy(v);
    }

    public static IConfigPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            IConfigPrxHelper result = new IConfigPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
