// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IContainer.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides methods for dealing with the core <i>Pojos</i> of OME.
 * Included are:
 * Projects, Datasets, Images.
 * 
 * <h3>Read API</h3>
 * <p>
 * The names of the methods correlate to how the function operates:
 * <ul>
 * <li><b>load</b>: start at container objects and work down toward the
 * leaves, returning hierarchy (Project-&gt;Dataset-&gt;Image</li>
 * <li><b>find</b>: start at leaf objects and work up to containers,
 * returning hierarchy</li>
 * <li><b>get</b>: retrieves only leaves in the hierarchy (currently
 * only Images)</li>
 * </ul>
 * </p>
 * <h4>Options Mechanism</h4>
 * <p>
 * The options are used to add some constraints to the generic method
 * e.g. load hierarchy trees images <i>for a given user</i>. This
 * mechanism should give us enough flexibility to extend the API if
 * necessary, e.g. in some cases we might want to retrieve the images
 * with or without annotations
 * </p>
 * <p>
 * Most methods take such an <code>options</code> map which is built
 * on the client-side using the {@link Parameters} class. The
 * currently supported options are:
 * <ul>
 * <li><b>annotator</b>(Integer): If key exists but value null,
 * annotations are retrieved for all objects in the hierarchy where
 * they exist; if a valid experimenterID, annotations are only
 * retrieved for that user. May not be used
 * be all methods. <b>Default: all annotations</b></li>
 * <li><b>leaves</b>(Boolean): if FALSE omits images from the returned
 * hierarchy. May not be used by all methods. <b>Default: true</b></li>
 * <li><b>experimenter</b>(Integer): enables filtering on a
 * per-experimenter basis. This option has a method-specific (and
 * possibly context-specific) meaning. Please see the individual
 * methods.</li>
 * <li><b>group</b>(Integer): enables filtering on a per-group basis.
 * The <b>experimenter</b> value is ignored if present and instead a
 * similar filtering is done using all <b>experimenter</b>s in the
 * given group.
 * </ul>
 * </p>
 * <h3>Write API</h3>
 * <p>
 * As outlined in TODO, the semantics of the Omero write API are based
 * on three rules:
 * <ol>
 * <li>IObject-valued fields for which <code>isLoaded()</code> returns
 * false are assumed filtered</li>
 * <li>Collection-valued fields that are null are assumed filtered</li>
 * <li>Collection-valued fields for which
 * <code>getDetails().isFiltered(String collectionName)</code> returns
 * true are assumed filtered. TODO: should we accept isFiltered for
 * all fields?
 * </ol>
 * In each of these cases, the server will reload that given field
 * <b>before</b> attempting to save the graph.
 * </p>
 * <p>
 * For all write calls, the options map (see below) must contain the
 * userId and the userGroupId for the newly created objects. TODO
 * umask.
 * </p>
 * 
 **/
public interface IContainer extends Ice.Object,
                                    _IContainerOperations, _IContainerOperationsNC,
                                    ServiceInterface
{
    public static final long serialVersionUID = 6561821805695337739L;
}
