// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `ILdap.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Administration interface providing access to admin-only
 * functionality as well as JMX-based server access and selected user
 * functions. Most methods require membership in privileged
 * {@link omero.model.ExperimenterGroup} groups.
 * 
 * Methods which return {@link omero.model.Experimenter} or
 * {@link omero.model.ExperimenterGroup} instances fetch and load all
 * related instances of {@link omero.model.ExperimenterGroup} or
 * {@link omero.model.Experimenter}, respectively.
 **/
public interface ILdapPrx extends ServiceInterfacePrx
{
    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @return all Experimenter list.
     **/
    public java.util.List<omero.model.Experimenter> searchAll()
        throws omero.ServerError;

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return all Experimenter list.
     **/
    public java.util.List<omero.model.Experimenter> searchAll(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchAll();

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchAll(java.util.Map<String, String> __ctx);

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchAll(Ice.Callback __cb);

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchAll(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchAll(Callback_ILdap_searchAll __cb);

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchAll(java.util.Map<String, String> __ctx, Callback_ILdap_searchAll __cb);

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __result The asynchronous result object.
     * @return all Experimenter list.
     **/
    public java.util.List<omero.model.Experimenter> end_searchAll(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean searchAll_async(AMI_ILdap_searchAll __cb);

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean searchAll_async(AMI_ILdap_searchAll __cb, java.util.Map<String, String> __ctx);

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param attr   Name of member attribute. Never null or empty.
     * @param value  User's DN which should be set on value for
     * attribute. Never null or empty.
     * @return       List of groups which contains DN.
     **/
    public java.util.List<String> searchDnInGroups(String attr, String value)
        throws omero.ServerError;

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param attr   Name of member attribute. Never null or empty.
     * @param value  User's DN which should be set on value for
     * attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     * @return       List of groups which contains DN.
     **/
    public java.util.List<String> searchDnInGroups(String attr, String value, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param attr   Name of member attribute. Never null or empty.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchDnInGroups(String attr, String value);

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param attr   Name of member attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchDnInGroups(String attr, String value, java.util.Map<String, String> __ctx);

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param attr   Name of member attribute. Never null or empty.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchDnInGroups(String attr, String value, Ice.Callback __cb);

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param attr   Name of member attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchDnInGroups(String attr, String value, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param attr   Name of member attribute. Never null or empty.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchDnInGroups(String attr, String value, Callback_ILdap_searchDnInGroups __cb);

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param attr   Name of member attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchDnInGroups(String attr, String value, java.util.Map<String, String> __ctx, Callback_ILdap_searchDnInGroups __cb);

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param __result The asynchronous result object.
     * @return       List of groups which contains DN.
     **/
    public java.util.List<String> end_searchDnInGroups(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param __cb The callback object for the operation.
     * @param attr   Name of member attribute. Never null or empty.
     **/
    public boolean searchDnInGroups_async(AMI_ILdap_searchDnInGroups __cb, String attr, String value);

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param __cb The callback object for the operation.
     * @param attr   Name of member attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean searchDnInGroups_async(AMI_ILdap_searchDnInGroups __cb, String attr, String value, java.util.Map<String, String> __ctx);

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     * @param value     Expected value of attribute. Never null or
     * empty.
     * @return          List of Experimenters.
     **/
    public java.util.List<omero.model.Experimenter> searchByAttribute(String dn, String attribute, String value)
        throws omero.ServerError;

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     * @param value     Expected value of attribute. Never null or
     * empty.
     * @param __ctx The Context map to send with the invocation.
     * @return          List of Experimenters.
     **/
    public java.util.List<omero.model.Experimenter> searchByAttribute(String dn, String attribute, String value, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchByAttribute(String dn, String attribute, String value);

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchByAttribute(String dn, String attribute, String value, java.util.Map<String, String> __ctx);

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchByAttribute(String dn, String attribute, String value, Ice.Callback __cb);

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchByAttribute(String dn, String attribute, String value, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchByAttribute(String dn, String attribute, String value, Callback_ILdap_searchByAttribute __cb);

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchByAttribute(String dn, String attribute, String value, java.util.Map<String, String> __ctx, Callback_ILdap_searchByAttribute __cb);

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param __result The asynchronous result object.
     * @return          List of Experimenters.
     **/
    public java.util.List<omero.model.Experimenter> end_searchByAttribute(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param __cb The callback object for the operation.
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     **/
    public boolean searchByAttribute_async(AMI_ILdap_searchByAttribute __cb, String dn, String attribute, String value);

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param __cb The callback object for the operation.
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean searchByAttribute_async(AMI_ILdap_searchByAttribute __cb, String dn, String attribute, String value, java.util.Map<String, String> __ctx);

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     * @param values     Expected value of attribute. Never null
     * or empty.
     * @return           List of Experimenters.
     **/
    public java.util.List<omero.model.Experimenter> searchByAttributes(String dn, java.util.List<String> attributes, java.util.List<String> values)
        throws omero.ServerError;

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     * @param values     Expected value of attribute. Never null
     * or empty.
     * @param __ctx The Context map to send with the invocation.
     * @return           List of Experimenters.
     **/
    public java.util.List<omero.model.Experimenter> searchByAttributes(String dn, java.util.List<String> attributes, java.util.List<String> values, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchByAttributes(String dn, java.util.List<String> attributes, java.util.List<String> values);

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchByAttributes(String dn, java.util.List<String> attributes, java.util.List<String> values, java.util.Map<String, String> __ctx);

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchByAttributes(String dn, java.util.List<String> attributes, java.util.List<String> values, Ice.Callback __cb);

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchByAttributes(String dn, java.util.List<String> attributes, java.util.List<String> values, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchByAttributes(String dn, java.util.List<String> attributes, java.util.List<String> values, Callback_ILdap_searchByAttributes __cb);

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchByAttributes(String dn, java.util.List<String> attributes, java.util.List<String> values, java.util.Map<String, String> __ctx, Callback_ILdap_searchByAttributes __cb);

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param __result The asynchronous result object.
     * @return           List of Experimenters.
     **/
    public java.util.List<omero.model.Experimenter> end_searchByAttributes(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param __cb The callback object for the operation.
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     **/
    public boolean searchByAttributes_async(AMI_ILdap_searchByAttributes __cb, String dn, java.util.List<String> attributes, java.util.List<String> values);

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param __cb The callback object for the operation.
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean searchByAttributes_async(AMI_ILdap_searchByAttributes __cb, String dn, java.util.List<String> attributes, java.util.List<String> values, java.util.Map<String, String> __ctx);

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     * @return an Experimenter.
     **/
    public omero.model.Experimenter searchByDN(String userdn)
        throws omero.ServerError;

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     * @return an Experimenter.
     **/
    public omero.model.Experimenter searchByDN(String userdn, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchByDN(String userdn);

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchByDN(String userdn, java.util.Map<String, String> __ctx);

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchByDN(String userdn, Ice.Callback __cb);

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchByDN(String userdn, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchByDN(String userdn, Callback_ILdap_searchByDN __cb);

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_searchByDN(String userdn, java.util.Map<String, String> __ctx, Callback_ILdap_searchByDN __cb);

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param __result The asynchronous result object.
     * @return an Experimenter.
     **/
    public omero.model.Experimenter end_searchByDN(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param __cb The callback object for the operation.
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     **/
    public boolean searchByDN_async(AMI_ILdap_searchByDN __cb, String userdn);

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param __cb The callback object for the operation.
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean searchByDN_async(AMI_ILdap_searchByDN __cb, String userdn, java.util.Map<String, String> __ctx);

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @return a Distinguished Name. Never null.
     * @throws ApiUsageException
     * if more then one 'cn' under the specified base.
     **/
    public String findDN(String username)
        throws omero.ServerError;

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     * @return a Distinguished Name. Never null.
     * @throws ApiUsageException
     * if more then one 'cn' under the specified base.
     **/
    public String findDN(String username, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findDN(String username);

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findDN(String username, java.util.Map<String, String> __ctx);

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findDN(String username, Ice.Callback __cb);

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findDN(String username, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findDN(String username, Callback_ILdap_findDN __cb);

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findDN(String username, java.util.Map<String, String> __ctx, Callback_ILdap_findDN __cb);

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param __result The asynchronous result object.
     * @return a Distinguished Name. Never null.
     * @throws ApiUsageException
     * if more then one 'cn' under the specified base.
     **/
    public String end_findDN(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     **/
    public boolean findDN_async(AMI_ILdap_findDN __cb, String username);

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findDN_async(AMI_ILdap_findDN __cb, String username, java.util.Map<String, String> __ctx);

    /**
     * Looks up the DN for a group.
     * 
     * @return a Distinguished Name. Never null.
     * @throws ApiUsageException
     * if more then one 'cn' under the specified base.
     **/
    public String findGroupDN(String groupname)
        throws omero.ServerError;

    /**
     * Looks up the DN for a group.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return a Distinguished Name. Never null.
     * @throws ApiUsageException
     * if more then one 'cn' under the specified base.
     **/
    public String findGroupDN(String groupname, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Looks up the DN for a group.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findGroupDN(String groupname);

    /**
     * Looks up the DN for a group.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findGroupDN(String groupname, java.util.Map<String, String> __ctx);

    /**
     * Looks up the DN for a group.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findGroupDN(String groupname, Ice.Callback __cb);

    /**
     * Looks up the DN for a group.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findGroupDN(String groupname, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Looks up the DN for a group.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findGroupDN(String groupname, Callback_ILdap_findGroupDN __cb);

    /**
     * Looks up the DN for a group.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findGroupDN(String groupname, java.util.Map<String, String> __ctx, Callback_ILdap_findGroupDN __cb);

    /**
     * Looks up the DN for a group.
     * 
     * @param __result The asynchronous result object.
     * @return a Distinguished Name. Never null.
     * @throws ApiUsageException
     * if more then one 'cn' under the specified base.
     **/
    public String end_findGroupDN(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Looks up the DN for a group.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean findGroupDN_async(AMI_ILdap_findGroupDN __cb, String groupname);

    /**
     * Looks up the DN for a group.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findGroupDN_async(AMI_ILdap_findGroupDN __cb, String groupname, java.util.Map<String, String> __ctx);

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @return an Experimenter. Never null.
     * @throws ApiUsageException
     * if more then one 'cn' under the specified base.
     **/
    public omero.model.Experimenter findExperimenter(String username)
        throws omero.ServerError;

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     * @return an Experimenter. Never null.
     * @throws ApiUsageException
     * if more then one 'cn' under the specified base.
     **/
    public omero.model.Experimenter findExperimenter(String username, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findExperimenter(String username);

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findExperimenter(String username, java.util.Map<String, String> __ctx);

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findExperimenter(String username, Ice.Callback __cb);

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findExperimenter(String username, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findExperimenter(String username, Callback_ILdap_findExperimenter __cb);

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findExperimenter(String username, java.util.Map<String, String> __ctx, Callback_ILdap_findExperimenter __cb);

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param __result The asynchronous result object.
     * @return an Experimenter. Never null.
     * @throws ApiUsageException
     * if more then one 'cn' under the specified base.
     **/
    public omero.model.Experimenter end_findExperimenter(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     **/
    public boolean findExperimenter_async(AMI_ILdap_findExperimenter __cb, String username);

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findExperimenter_async(AMI_ILdap_findExperimenter __cb, String username, java.util.Map<String, String> __ctx);

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param groupname
     * @return an ExperimenterGroup. Never <code>null</null>.
     * @throws ApiUsageException
     * if more then one group name matches under the
     * specified base.
     **/
    public omero.model.ExperimenterGroup findGroup(String groupname)
        throws omero.ServerError;

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param groupname
     * @param __ctx The Context map to send with the invocation.
     * @return an ExperimenterGroup. Never <code>null</null>.
     * @throws ApiUsageException
     * if more then one group name matches under the
     * specified base.
     **/
    public omero.model.ExperimenterGroup findGroup(String groupname, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param groupname
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findGroup(String groupname);

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param groupname
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findGroup(String groupname, java.util.Map<String, String> __ctx);

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param groupname
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findGroup(String groupname, Ice.Callback __cb);

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param groupname
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findGroup(String groupname, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param groupname
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findGroup(String groupname, Callback_ILdap_findGroup __cb);

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param groupname
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findGroup(String groupname, java.util.Map<String, String> __ctx, Callback_ILdap_findGroup __cb);

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param __result The asynchronous result object.
     * @return an ExperimenterGroup. Never <code>null</null>.
     * @throws ApiUsageException
     * if more then one group name matches under the
     * specified base.
     **/
    public omero.model.ExperimenterGroup end_findGroup(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param groupname
     **/
    public boolean findGroup_async(AMI_ILdap_findGroup __cb, String groupname);

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param groupname
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findGroup_async(AMI_ILdap_findGroup __cb, String groupname, java.util.Map<String, String> __ctx);

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void setDN(omero.RLong experimenterID, String dn)
        throws omero.ServerError;

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void setDN(omero.RLong experimenterID, String dn, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_setDN(omero.RLong experimenterID, String dn);

    /**
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_setDN(omero.RLong experimenterID, String dn, java.util.Map<String, String> __ctx);

    /**
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_setDN(omero.RLong experimenterID, String dn, Ice.Callback __cb);

    /**
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_setDN(omero.RLong experimenterID, String dn, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_setDN(omero.RLong experimenterID, String dn, Callback_ILdap_setDN __cb);

    /**
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_setDN(omero.RLong experimenterID, String dn, java.util.Map<String, String> __ctx, Callback_ILdap_setDN __cb);

    /**
     * @param __result The asynchronous result object.
     **/
    public void end_setDN(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean setDN_async(AMI_ILdap_setDN __cb, omero.RLong experimenterID, String dn);

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean setDN_async(AMI_ILdap_setDN __cb, omero.RLong experimenterID, String dn, java.util.Map<String, String> __ctx);

    /**
     * Gets config value from properties.
     * 
     * @return boolean
     **/
    public boolean getSetting()
        throws omero.ServerError;

    /**
     * Gets config value from properties.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return boolean
     **/
    public boolean getSetting(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Gets config value from properties.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSetting();

    /**
     * Gets config value from properties.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSetting(java.util.Map<String, String> __ctx);

    /**
     * Gets config value from properties.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSetting(Ice.Callback __cb);

    /**
     * Gets config value from properties.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSetting(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Gets config value from properties.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSetting(Callback_ILdap_getSetting __cb);

    /**
     * Gets config value from properties.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSetting(java.util.Map<String, String> __ctx, Callback_ILdap_getSetting __cb);

    /**
     * Gets config value from properties.
     * 
     * @param __result The asynchronous result object.
     * @return boolean
     **/
    public boolean end_getSetting(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Gets config value from properties.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getSetting_async(AMI_ILdap_getSetting __cb);

    /**
     * Gets config value from properties.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getSetting_async(AMI_ILdap_getSetting __cb, java.util.Map<String, String> __ctx);

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @return list of Experimenters.
     **/
    public java.util.List<omero.model.Experimenter> discover()
        throws omero.ServerError;

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return list of Experimenters.
     **/
    public java.util.List<omero.model.Experimenter> discover(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_discover();

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_discover(java.util.Map<String, String> __ctx);

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_discover(Ice.Callback __cb);

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_discover(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_discover(Callback_ILdap_discover __cb);

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_discover(java.util.Map<String, String> __ctx, Callback_ILdap_discover __cb);

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __result The asynchronous result object.
     * @return list of Experimenters.
     **/
    public java.util.List<omero.model.Experimenter> end_discover(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean discover_async(AMI_ILdap_discover __cb);

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean discover_async(AMI_ILdap_discover __cb, java.util.Map<String, String> __ctx);

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @return list of ExperimenterGroups.
     **/
    public java.util.List<omero.model.ExperimenterGroup> discoverGroups()
        throws omero.ServerError;

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return list of ExperimenterGroups.
     **/
    public java.util.List<omero.model.ExperimenterGroup> discoverGroups(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_discoverGroups();

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_discoverGroups(java.util.Map<String, String> __ctx);

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_discoverGroups(Ice.Callback __cb);

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_discoverGroups(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_discoverGroups(Callback_ILdap_discoverGroups __cb);

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_discoverGroups(java.util.Map<String, String> __ctx, Callback_ILdap_discoverGroups __cb);

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __result The asynchronous result object.
     * @return list of ExperimenterGroups.
     **/
    public java.util.List<omero.model.ExperimenterGroup> end_discoverGroups(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean discoverGroups_async(AMI_ILdap_discoverGroups __cb);

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean discoverGroups_async(AMI_ILdap_discoverGroups __cb, java.util.Map<String, String> __ctx);

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param username
     * @return created Experimenter or null
     **/
    public omero.model.Experimenter createUser(String username)
        throws omero.ServerError;

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param username
     * @param __ctx The Context map to send with the invocation.
     * @return created Experimenter or null
     **/
    public omero.model.Experimenter createUser(String username, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param username
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createUser(String username);

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param username
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createUser(String username, java.util.Map<String, String> __ctx);

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param username
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createUser(String username, Ice.Callback __cb);

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param username
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createUser(String username, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param username
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createUser(String username, Callback_ILdap_createUser __cb);

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param username
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createUser(String username, java.util.Map<String, String> __ctx, Callback_ILdap_createUser __cb);

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param __result The asynchronous result object.
     * @return created Experimenter or null
     **/
    public omero.model.Experimenter end_createUser(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param __cb The callback object for the operation.
     * @param username
     **/
    public boolean createUser_async(AMI_ILdap_createUser __cb, String username);

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param __cb The callback object for the operation.
     * @param username
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createUser_async(AMI_ILdap_createUser __cb, String username, java.util.Map<String, String> __ctx);
}
