// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `ILdap.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Administration interface providing access to admin-only
 * functionality as well as JMX-based server access and selected user
 * functions. Most methods require membership in privileged
 * {@link omero.model.ExperimenterGroup} groups.
 * 
 * Methods which return {@link omero.model.Experimenter} or
 * {@link omero.model.ExperimenterGroup} instances fetch and load all
 * related instances of {@link omero.model.ExperimenterGroup} or
 * {@link omero.model.Experimenter}, respectively.
 **/
public final class ILdapPrxHelper extends Ice.ObjectPrxHelperBase implements ILdapPrx
{
    private static final String __createUser_name = "createUser";

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param username
     * @return created Experimenter or null
     **/
    public omero.model.Experimenter createUser(String username)
        throws omero.ServerError
    {
        return createUser(username, null, false);
    }

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param username
     * @param __ctx The Context map to send with the invocation.
     * @return created Experimenter or null
     **/
    public omero.model.Experimenter createUser(String username, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return createUser(username, __ctx, true);
    }

    private omero.model.Experimenter createUser(String username, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "createUser", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("createUser");
                    __delBase = __getDelegate(false);
                    _ILdapDel __del = (_ILdapDel)__delBase;
                    return __del.createUser(username, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param __cb The callback object for the operation.
     * @param username
     **/
    public Ice.AsyncResult begin_createUser(String username)
    {
        return begin_createUser(username, null, false, null);
    }

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param __cb The callback object for the operation.
     * @param username
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createUser(String username, java.util.Map<String, String> __ctx)
    {
        return begin_createUser(username, __ctx, true, null);
    }

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param __cb The callback object for the operation.
     * @param username
     **/
    public Ice.AsyncResult begin_createUser(String username, Ice.Callback __cb)
    {
        return begin_createUser(username, null, false, __cb);
    }

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param __cb The callback object for the operation.
     * @param username
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createUser(String username, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_createUser(username, __ctx, true, __cb);
    }

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param __cb The callback object for the operation.
     * @param username
     **/
    public Ice.AsyncResult begin_createUser(String username, Callback_ILdap_createUser __cb)
    {
        return begin_createUser(username, null, false, __cb);
    }

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param __cb The callback object for the operation.
     * @param username
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createUser(String username, java.util.Map<String, String> __ctx, Callback_ILdap_createUser __cb)
    {
        return begin_createUser(username, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_createUser(String username, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__createUser_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __createUser_name, __cb);
        try
        {
            __result.__prepare(__createUser_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(username);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) created Experimenter or null
     **/
    public omero.model.Experimenter end_createUser(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __createUser_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.ExperimenterHolder __ret = new omero.model.ExperimenterHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param __cb The callback object for the operation.
     * @param username
     **/
    public boolean createUser_async(AMI_ILdap_createUser __cb, String username)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createUser_name);
            __r = begin_createUser(username, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createUser_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param __cb The callback object for the operation.
     * @param username
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createUser_async(AMI_ILdap_createUser __cb, String username, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createUser_name);
            __r = begin_createUser(username, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createUser_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __discover_name = "discover";

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @return list of Experimenters.
     **/
    public java.util.List<omero.model.Experimenter> discover()
        throws omero.ServerError
    {
        return discover(null, false);
    }

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return list of Experimenters.
     **/
    public java.util.List<omero.model.Experimenter> discover(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return discover(__ctx, true);
    }

    private java.util.List<omero.model.Experimenter> discover(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "discover", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("discover");
                    __delBase = __getDelegate(false);
                    _ILdapDel __del = (_ILdapDel)__delBase;
                    return __del.discover(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_discover()
    {
        return begin_discover(null, false, null);
    }

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_discover(java.util.Map<String, String> __ctx)
    {
        return begin_discover(__ctx, true, null);
    }

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_discover(Ice.Callback __cb)
    {
        return begin_discover(null, false, __cb);
    }

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_discover(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_discover(__ctx, true, __cb);
    }

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_discover(Callback_ILdap_discover __cb)
    {
        return begin_discover(null, false, __cb);
    }

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_discover(java.util.Map<String, String> __ctx, Callback_ILdap_discover __cb)
    {
        return begin_discover(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_discover(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__discover_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __discover_name, __cb);
        try
        {
            __result.__prepare(__discover_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) list of Experimenters.
     **/
    public java.util.List<omero.model.Experimenter> end_discover(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __discover_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.Experimenter> __ret;
            __ret = ExperimenterListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean discover_async(AMI_ILdap_discover __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__discover_name);
            __r = begin_discover(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __discover_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean discover_async(AMI_ILdap_discover __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__discover_name);
            __r = begin_discover(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __discover_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __discoverGroups_name = "discoverGroups";

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @return list of ExperimenterGroups.
     **/
    public java.util.List<omero.model.ExperimenterGroup> discoverGroups()
        throws omero.ServerError
    {
        return discoverGroups(null, false);
    }

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return list of ExperimenterGroups.
     **/
    public java.util.List<omero.model.ExperimenterGroup> discoverGroups(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return discoverGroups(__ctx, true);
    }

    private java.util.List<omero.model.ExperimenterGroup> discoverGroups(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "discoverGroups", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("discoverGroups");
                    __delBase = __getDelegate(false);
                    _ILdapDel __del = (_ILdapDel)__delBase;
                    return __del.discoverGroups(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_discoverGroups()
    {
        return begin_discoverGroups(null, false, null);
    }

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_discoverGroups(java.util.Map<String, String> __ctx)
    {
        return begin_discoverGroups(__ctx, true, null);
    }

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_discoverGroups(Ice.Callback __cb)
    {
        return begin_discoverGroups(null, false, __cb);
    }

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_discoverGroups(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_discoverGroups(__ctx, true, __cb);
    }

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_discoverGroups(Callback_ILdap_discoverGroups __cb)
    {
        return begin_discoverGroups(null, false, __cb);
    }

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_discoverGroups(java.util.Map<String, String> __ctx, Callback_ILdap_discoverGroups __cb)
    {
        return begin_discoverGroups(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_discoverGroups(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__discoverGroups_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __discoverGroups_name, __cb);
        try
        {
            __result.__prepare(__discoverGroups_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) list of ExperimenterGroups.
     **/
    public java.util.List<omero.model.ExperimenterGroup> end_discoverGroups(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __discoverGroups_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.ExperimenterGroup> __ret;
            __ret = ExperimenterGroupListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean discoverGroups_async(AMI_ILdap_discoverGroups __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__discoverGroups_name);
            __r = begin_discoverGroups(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __discoverGroups_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean discoverGroups_async(AMI_ILdap_discoverGroups __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__discoverGroups_name);
            __r = begin_discoverGroups(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __discoverGroups_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __findDN_name = "findDN";

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @return a Distinguished Name. Never null.
     * @throws ApiUsageException
     * if more then one 'cn' under the specified base.
     **/
    public String findDN(String username)
        throws omero.ServerError
    {
        return findDN(username, null, false);
    }

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     * @return a Distinguished Name. Never null.
     * @throws ApiUsageException
     * if more then one 'cn' under the specified base.
     **/
    public String findDN(String username, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return findDN(username, __ctx, true);
    }

    private String findDN(String username, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "findDN", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("findDN");
                    __delBase = __getDelegate(false);
                    _ILdapDel __del = (_ILdapDel)__delBase;
                    return __del.findDN(username, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     **/
    public Ice.AsyncResult begin_findDN(String username)
    {
        return begin_findDN(username, null, false, null);
    }

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findDN(String username, java.util.Map<String, String> __ctx)
    {
        return begin_findDN(username, __ctx, true, null);
    }

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     **/
    public Ice.AsyncResult begin_findDN(String username, Ice.Callback __cb)
    {
        return begin_findDN(username, null, false, __cb);
    }

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findDN(String username, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findDN(username, __ctx, true, __cb);
    }

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     **/
    public Ice.AsyncResult begin_findDN(String username, Callback_ILdap_findDN __cb)
    {
        return begin_findDN(username, null, false, __cb);
    }

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findDN(String username, java.util.Map<String, String> __ctx, Callback_ILdap_findDN __cb)
    {
        return begin_findDN(username, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findDN(String username, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findDN_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findDN_name, __cb);
        try
        {
            __result.__prepare(__findDN_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(username);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a Distinguished Name. Never null.
     **/
    public String end_findDN(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __findDN_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            String __ret;
            __ret = __is.readString();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     **/
    public boolean findDN_async(AMI_ILdap_findDN __cb, String username)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findDN_name);
            __r = begin_findDN(username, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findDN_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findDN_async(AMI_ILdap_findDN __cb, String username, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findDN_name);
            __r = begin_findDN(username, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findDN_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __findExperimenter_name = "findExperimenter";

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @return an Experimenter. Never null.
     * @throws ApiUsageException
     * if more then one 'cn' under the specified base.
     **/
    public omero.model.Experimenter findExperimenter(String username)
        throws omero.ServerError
    {
        return findExperimenter(username, null, false);
    }

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     * @return an Experimenter. Never null.
     * @throws ApiUsageException
     * if more then one 'cn' under the specified base.
     **/
    public omero.model.Experimenter findExperimenter(String username, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return findExperimenter(username, __ctx, true);
    }

    private omero.model.Experimenter findExperimenter(String username, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "findExperimenter", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("findExperimenter");
                    __delBase = __getDelegate(false);
                    _ILdapDel __del = (_ILdapDel)__delBase;
                    return __del.findExperimenter(username, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     **/
    public Ice.AsyncResult begin_findExperimenter(String username)
    {
        return begin_findExperimenter(username, null, false, null);
    }

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findExperimenter(String username, java.util.Map<String, String> __ctx)
    {
        return begin_findExperimenter(username, __ctx, true, null);
    }

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     **/
    public Ice.AsyncResult begin_findExperimenter(String username, Ice.Callback __cb)
    {
        return begin_findExperimenter(username, null, false, __cb);
    }

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findExperimenter(String username, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findExperimenter(username, __ctx, true, __cb);
    }

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     **/
    public Ice.AsyncResult begin_findExperimenter(String username, Callback_ILdap_findExperimenter __cb)
    {
        return begin_findExperimenter(username, null, false, __cb);
    }

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findExperimenter(String username, java.util.Map<String, String> __ctx, Callback_ILdap_findExperimenter __cb)
    {
        return begin_findExperimenter(username, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findExperimenter(String username, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findExperimenter_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findExperimenter_name, __cb);
        try
        {
            __result.__prepare(__findExperimenter_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(username);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) an Experimenter. Never null.
     **/
    public omero.model.Experimenter end_findExperimenter(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __findExperimenter_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.ExperimenterHolder __ret = new omero.model.ExperimenterHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     **/
    public boolean findExperimenter_async(AMI_ILdap_findExperimenter __cb, String username)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findExperimenter_name);
            __r = begin_findExperimenter(username, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findExperimenter_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findExperimenter_async(AMI_ILdap_findExperimenter __cb, String username, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findExperimenter_name);
            __r = begin_findExperimenter(username, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findExperimenter_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __findGroup_name = "findGroup";

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param groupname
     * @return an ExperimenterGroup. Never <code>null</null>.
     * @throws ApiUsageException
     * if more then one group name matches under the
     * specified base.
     **/
    public omero.model.ExperimenterGroup findGroup(String groupname)
        throws omero.ServerError
    {
        return findGroup(groupname, null, false);
    }

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param groupname
     * @param __ctx The Context map to send with the invocation.
     * @return an ExperimenterGroup. Never <code>null</null>.
     * @throws ApiUsageException
     * if more then one group name matches under the
     * specified base.
     **/
    public omero.model.ExperimenterGroup findGroup(String groupname, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return findGroup(groupname, __ctx, true);
    }

    private omero.model.ExperimenterGroup findGroup(String groupname, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "findGroup", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("findGroup");
                    __delBase = __getDelegate(false);
                    _ILdapDel __del = (_ILdapDel)__delBase;
                    return __del.findGroup(groupname, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param groupname
     **/
    public Ice.AsyncResult begin_findGroup(String groupname)
    {
        return begin_findGroup(groupname, null, false, null);
    }

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param groupname
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findGroup(String groupname, java.util.Map<String, String> __ctx)
    {
        return begin_findGroup(groupname, __ctx, true, null);
    }

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param groupname
     **/
    public Ice.AsyncResult begin_findGroup(String groupname, Ice.Callback __cb)
    {
        return begin_findGroup(groupname, null, false, __cb);
    }

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param groupname
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findGroup(String groupname, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findGroup(groupname, __ctx, true, __cb);
    }

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param groupname
     **/
    public Ice.AsyncResult begin_findGroup(String groupname, Callback_ILdap_findGroup __cb)
    {
        return begin_findGroup(groupname, null, false, __cb);
    }

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param groupname
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findGroup(String groupname, java.util.Map<String, String> __ctx, Callback_ILdap_findGroup __cb)
    {
        return begin_findGroup(groupname, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findGroup(String groupname, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findGroup_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findGroup_name, __cb);
        try
        {
            __result.__prepare(__findGroup_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(groupname);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) an ExperimenterGroup. Never <code>null</null>.
     **/
    public omero.model.ExperimenterGroup end_findGroup(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __findGroup_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.ExperimenterGroupHolder __ret = new omero.model.ExperimenterGroupHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param groupname
     **/
    public boolean findGroup_async(AMI_ILdap_findGroup __cb, String groupname)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findGroup_name);
            __r = begin_findGroup(groupname, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findGroup_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param groupname
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findGroup_async(AMI_ILdap_findGroup __cb, String groupname, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findGroup_name);
            __r = begin_findGroup(groupname, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findGroup_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __findGroupDN_name = "findGroupDN";

    /**
     * Looks up the DN for a group.
     * 
     * @return a Distinguished Name. Never null.
     * @throws ApiUsageException
     * if more then one 'cn' under the specified base.
     **/
    public String findGroupDN(String groupname)
        throws omero.ServerError
    {
        return findGroupDN(groupname, null, false);
    }

    /**
     * Looks up the DN for a group.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return a Distinguished Name. Never null.
     * @throws ApiUsageException
     * if more then one 'cn' under the specified base.
     **/
    public String findGroupDN(String groupname, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return findGroupDN(groupname, __ctx, true);
    }

    private String findGroupDN(String groupname, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "findGroupDN", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("findGroupDN");
                    __delBase = __getDelegate(false);
                    _ILdapDel __del = (_ILdapDel)__delBase;
                    return __del.findGroupDN(groupname, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Looks up the DN for a group.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_findGroupDN(String groupname)
    {
        return begin_findGroupDN(groupname, null, false, null);
    }

    /**
     * Looks up the DN for a group.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findGroupDN(String groupname, java.util.Map<String, String> __ctx)
    {
        return begin_findGroupDN(groupname, __ctx, true, null);
    }

    /**
     * Looks up the DN for a group.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_findGroupDN(String groupname, Ice.Callback __cb)
    {
        return begin_findGroupDN(groupname, null, false, __cb);
    }

    /**
     * Looks up the DN for a group.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findGroupDN(String groupname, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findGroupDN(groupname, __ctx, true, __cb);
    }

    /**
     * Looks up the DN for a group.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_findGroupDN(String groupname, Callback_ILdap_findGroupDN __cb)
    {
        return begin_findGroupDN(groupname, null, false, __cb);
    }

    /**
     * Looks up the DN for a group.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findGroupDN(String groupname, java.util.Map<String, String> __ctx, Callback_ILdap_findGroupDN __cb)
    {
        return begin_findGroupDN(groupname, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findGroupDN(String groupname, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findGroupDN_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findGroupDN_name, __cb);
        try
        {
            __result.__prepare(__findGroupDN_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(groupname);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a Distinguished Name. Never null.
     **/
    public String end_findGroupDN(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __findGroupDN_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            String __ret;
            __ret = __is.readString();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Looks up the DN for a group.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean findGroupDN_async(AMI_ILdap_findGroupDN __cb, String groupname)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findGroupDN_name);
            __r = begin_findGroupDN(groupname, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findGroupDN_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Looks up the DN for a group.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findGroupDN_async(AMI_ILdap_findGroupDN __cb, String groupname, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findGroupDN_name);
            __r = begin_findGroupDN(groupname, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findGroupDN_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getSetting_name = "getSetting";

    /**
     * Gets config value from properties.
     * 
     * @return boolean
     **/
    public boolean getSetting()
        throws omero.ServerError
    {
        return getSetting(null, false);
    }

    /**
     * Gets config value from properties.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return boolean
     **/
    public boolean getSetting(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getSetting(__ctx, true);
    }

    private boolean getSetting(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getSetting", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getSetting");
                    __delBase = __getDelegate(false);
                    _ILdapDel __del = (_ILdapDel)__delBase;
                    return __del.getSetting(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Gets config value from properties.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getSetting()
    {
        return begin_getSetting(null, false, null);
    }

    /**
     * Gets config value from properties.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getSetting(java.util.Map<String, String> __ctx)
    {
        return begin_getSetting(__ctx, true, null);
    }

    /**
     * Gets config value from properties.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getSetting(Ice.Callback __cb)
    {
        return begin_getSetting(null, false, __cb);
    }

    /**
     * Gets config value from properties.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getSetting(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getSetting(__ctx, true, __cb);
    }

    /**
     * Gets config value from properties.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getSetting(Callback_ILdap_getSetting __cb)
    {
        return begin_getSetting(null, false, __cb);
    }

    /**
     * Gets config value from properties.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getSetting(java.util.Map<String, String> __ctx, Callback_ILdap_getSetting __cb)
    {
        return begin_getSetting(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getSetting(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getSetting_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getSetting_name, __cb);
        try
        {
            __result.__prepare(__getSetting_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) boolean
     **/
    public boolean end_getSetting(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getSetting_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Gets config value from properties.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getSetting_async(AMI_ILdap_getSetting __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getSetting_name);
            __r = begin_getSetting(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getSetting_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Gets config value from properties.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getSetting_async(AMI_ILdap_getSetting __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getSetting_name);
            __r = begin_getSetting(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getSetting_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __searchAll_name = "searchAll";

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @return all Experimenter list.
     **/
    public java.util.List<omero.model.Experimenter> searchAll()
        throws omero.ServerError
    {
        return searchAll(null, false);
    }

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return all Experimenter list.
     **/
    public java.util.List<omero.model.Experimenter> searchAll(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return searchAll(__ctx, true);
    }

    private java.util.List<omero.model.Experimenter> searchAll(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "searchAll", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("searchAll");
                    __delBase = __getDelegate(false);
                    _ILdapDel __del = (_ILdapDel)__delBase;
                    return __del.searchAll(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_searchAll()
    {
        return begin_searchAll(null, false, null);
    }

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_searchAll(java.util.Map<String, String> __ctx)
    {
        return begin_searchAll(__ctx, true, null);
    }

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_searchAll(Ice.Callback __cb)
    {
        return begin_searchAll(null, false, __cb);
    }

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_searchAll(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_searchAll(__ctx, true, __cb);
    }

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_searchAll(Callback_ILdap_searchAll __cb)
    {
        return begin_searchAll(null, false, __cb);
    }

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_searchAll(java.util.Map<String, String> __ctx, Callback_ILdap_searchAll __cb)
    {
        return begin_searchAll(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_searchAll(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__searchAll_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __searchAll_name, __cb);
        try
        {
            __result.__prepare(__searchAll_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) all Experimenter list.
     **/
    public java.util.List<omero.model.Experimenter> end_searchAll(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __searchAll_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.Experimenter> __ret;
            __ret = ExperimenterListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean searchAll_async(AMI_ILdap_searchAll __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__searchAll_name);
            __r = begin_searchAll(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __searchAll_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean searchAll_async(AMI_ILdap_searchAll __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__searchAll_name);
            __r = begin_searchAll(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __searchAll_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __searchByAttribute_name = "searchByAttribute";

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     * @param value     Expected value of attribute. Never null or
     * empty.
     * @return          List of Experimenters.
     **/
    public java.util.List<omero.model.Experimenter> searchByAttribute(String dn, String attribute, String value)
        throws omero.ServerError
    {
        return searchByAttribute(dn, attribute, value, null, false);
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     * @param value     Expected value of attribute. Never null or
     * empty.
     * @param __ctx The Context map to send with the invocation.
     * @return          List of Experimenters.
     **/
    public java.util.List<omero.model.Experimenter> searchByAttribute(String dn, String attribute, String value, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return searchByAttribute(dn, attribute, value, __ctx, true);
    }

    private java.util.List<omero.model.Experimenter> searchByAttribute(String dn, String attribute, String value, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "searchByAttribute", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("searchByAttribute");
                    __delBase = __getDelegate(false);
                    _ILdapDel __del = (_ILdapDel)__delBase;
                    return __del.searchByAttribute(dn, attribute, value, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param __cb The callback object for the operation.
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     **/
    public Ice.AsyncResult begin_searchByAttribute(String dn, String attribute, String value)
    {
        return begin_searchByAttribute(dn, attribute, value, null, false, null);
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param __cb The callback object for the operation.
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_searchByAttribute(String dn, String attribute, String value, java.util.Map<String, String> __ctx)
    {
        return begin_searchByAttribute(dn, attribute, value, __ctx, true, null);
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param __cb The callback object for the operation.
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     **/
    public Ice.AsyncResult begin_searchByAttribute(String dn, String attribute, String value, Ice.Callback __cb)
    {
        return begin_searchByAttribute(dn, attribute, value, null, false, __cb);
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param __cb The callback object for the operation.
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_searchByAttribute(String dn, String attribute, String value, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_searchByAttribute(dn, attribute, value, __ctx, true, __cb);
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param __cb The callback object for the operation.
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     **/
    public Ice.AsyncResult begin_searchByAttribute(String dn, String attribute, String value, Callback_ILdap_searchByAttribute __cb)
    {
        return begin_searchByAttribute(dn, attribute, value, null, false, __cb);
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param __cb The callback object for the operation.
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_searchByAttribute(String dn, String attribute, String value, java.util.Map<String, String> __ctx, Callback_ILdap_searchByAttribute __cb)
    {
        return begin_searchByAttribute(dn, attribute, value, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_searchByAttribute(String dn, String attribute, String value, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__searchByAttribute_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __searchByAttribute_name, __cb);
        try
        {
            __result.__prepare(__searchByAttribute_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(dn);
            __os.writeString(attribute);
            __os.writeString(value);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value)          List of Experimenters.
     **/
    public java.util.List<omero.model.Experimenter> end_searchByAttribute(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __searchByAttribute_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.Experimenter> __ret;
            __ret = ExperimenterListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param __cb The callback object for the operation.
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     **/
    public boolean searchByAttribute_async(AMI_ILdap_searchByAttribute __cb, String dn, String attribute, String value)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__searchByAttribute_name);
            __r = begin_searchByAttribute(dn, attribute, value, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __searchByAttribute_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param __cb The callback object for the operation.
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean searchByAttribute_async(AMI_ILdap_searchByAttribute __cb, String dn, String attribute, String value, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__searchByAttribute_name);
            __r = begin_searchByAttribute(dn, attribute, value, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __searchByAttribute_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __searchByAttributes_name = "searchByAttributes";

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     * @param values     Expected value of attribute. Never null
     * or empty.
     * @return           List of Experimenters.
     **/
    public java.util.List<omero.model.Experimenter> searchByAttributes(String dn, java.util.List<String> attributes, java.util.List<String> values)
        throws omero.ServerError
    {
        return searchByAttributes(dn, attributes, values, null, false);
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     * @param values     Expected value of attribute. Never null
     * or empty.
     * @param __ctx The Context map to send with the invocation.
     * @return           List of Experimenters.
     **/
    public java.util.List<omero.model.Experimenter> searchByAttributes(String dn, java.util.List<String> attributes, java.util.List<String> values, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return searchByAttributes(dn, attributes, values, __ctx, true);
    }

    private java.util.List<omero.model.Experimenter> searchByAttributes(String dn, java.util.List<String> attributes, java.util.List<String> values, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "searchByAttributes", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("searchByAttributes");
                    __delBase = __getDelegate(false);
                    _ILdapDel __del = (_ILdapDel)__delBase;
                    return __del.searchByAttributes(dn, attributes, values, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param __cb The callback object for the operation.
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     **/
    public Ice.AsyncResult begin_searchByAttributes(String dn, java.util.List<String> attributes, java.util.List<String> values)
    {
        return begin_searchByAttributes(dn, attributes, values, null, false, null);
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param __cb The callback object for the operation.
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_searchByAttributes(String dn, java.util.List<String> attributes, java.util.List<String> values, java.util.Map<String, String> __ctx)
    {
        return begin_searchByAttributes(dn, attributes, values, __ctx, true, null);
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param __cb The callback object for the operation.
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     **/
    public Ice.AsyncResult begin_searchByAttributes(String dn, java.util.List<String> attributes, java.util.List<String> values, Ice.Callback __cb)
    {
        return begin_searchByAttributes(dn, attributes, values, null, false, __cb);
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param __cb The callback object for the operation.
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_searchByAttributes(String dn, java.util.List<String> attributes, java.util.List<String> values, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_searchByAttributes(dn, attributes, values, __ctx, true, __cb);
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param __cb The callback object for the operation.
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     **/
    public Ice.AsyncResult begin_searchByAttributes(String dn, java.util.List<String> attributes, java.util.List<String> values, Callback_ILdap_searchByAttributes __cb)
    {
        return begin_searchByAttributes(dn, attributes, values, null, false, __cb);
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param __cb The callback object for the operation.
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_searchByAttributes(String dn, java.util.List<String> attributes, java.util.List<String> values, java.util.Map<String, String> __ctx, Callback_ILdap_searchByAttributes __cb)
    {
        return begin_searchByAttributes(dn, attributes, values, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_searchByAttributes(String dn, java.util.List<String> attributes, java.util.List<String> values, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__searchByAttributes_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __searchByAttributes_name, __cb);
        try
        {
            __result.__prepare(__searchByAttributes_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(dn);
            StringSetHelper.write(__os, attributes);
            StringSetHelper.write(__os, values);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value)           List of Experimenters.
     **/
    public java.util.List<omero.model.Experimenter> end_searchByAttributes(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __searchByAttributes_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.Experimenter> __ret;
            __ret = ExperimenterListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param __cb The callback object for the operation.
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     **/
    public boolean searchByAttributes_async(AMI_ILdap_searchByAttributes __cb, String dn, java.util.List<String> attributes, java.util.List<String> values)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__searchByAttributes_name);
            __r = begin_searchByAttributes(dn, attributes, values, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __searchByAttributes_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param __cb The callback object for the operation.
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean searchByAttributes_async(AMI_ILdap_searchByAttributes __cb, String dn, java.util.List<String> attributes, java.util.List<String> values, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__searchByAttributes_name);
            __r = begin_searchByAttributes(dn, attributes, values, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __searchByAttributes_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __searchByDN_name = "searchByDN";

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     * @return an Experimenter.
     **/
    public omero.model.Experimenter searchByDN(String userdn)
        throws omero.ServerError
    {
        return searchByDN(userdn, null, false);
    }

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     * @return an Experimenter.
     **/
    public omero.model.Experimenter searchByDN(String userdn, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return searchByDN(userdn, __ctx, true);
    }

    private omero.model.Experimenter searchByDN(String userdn, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "searchByDN", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("searchByDN");
                    __delBase = __getDelegate(false);
                    _ILdapDel __del = (_ILdapDel)__delBase;
                    return __del.searchByDN(userdn, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param __cb The callback object for the operation.
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     **/
    public Ice.AsyncResult begin_searchByDN(String userdn)
    {
        return begin_searchByDN(userdn, null, false, null);
    }

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param __cb The callback object for the operation.
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_searchByDN(String userdn, java.util.Map<String, String> __ctx)
    {
        return begin_searchByDN(userdn, __ctx, true, null);
    }

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param __cb The callback object for the operation.
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     **/
    public Ice.AsyncResult begin_searchByDN(String userdn, Ice.Callback __cb)
    {
        return begin_searchByDN(userdn, null, false, __cb);
    }

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param __cb The callback object for the operation.
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_searchByDN(String userdn, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_searchByDN(userdn, __ctx, true, __cb);
    }

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param __cb The callback object for the operation.
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     **/
    public Ice.AsyncResult begin_searchByDN(String userdn, Callback_ILdap_searchByDN __cb)
    {
        return begin_searchByDN(userdn, null, false, __cb);
    }

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param __cb The callback object for the operation.
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_searchByDN(String userdn, java.util.Map<String, String> __ctx, Callback_ILdap_searchByDN __cb)
    {
        return begin_searchByDN(userdn, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_searchByDN(String userdn, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__searchByDN_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __searchByDN_name, __cb);
        try
        {
            __result.__prepare(__searchByDN_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(userdn);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) an Experimenter.
     **/
    public omero.model.Experimenter end_searchByDN(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __searchByDN_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.ExperimenterHolder __ret = new omero.model.ExperimenterHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param __cb The callback object for the operation.
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     **/
    public boolean searchByDN_async(AMI_ILdap_searchByDN __cb, String userdn)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__searchByDN_name);
            __r = begin_searchByDN(userdn, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __searchByDN_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param __cb The callback object for the operation.
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean searchByDN_async(AMI_ILdap_searchByDN __cb, String userdn, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__searchByDN_name);
            __r = begin_searchByDN(userdn, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __searchByDN_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __searchDnInGroups_name = "searchDnInGroups";

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param attr   Name of member attribute. Never null or empty.
     * @param value  User's DN which should be set on value for
     * attribute. Never null or empty.
     * @return       List of groups which contains DN.
     **/
    public java.util.List<String> searchDnInGroups(String attr, String value)
        throws omero.ServerError
    {
        return searchDnInGroups(attr, value, null, false);
    }

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param attr   Name of member attribute. Never null or empty.
     * @param value  User's DN which should be set on value for
     * attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     * @return       List of groups which contains DN.
     **/
    public java.util.List<String> searchDnInGroups(String attr, String value, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return searchDnInGroups(attr, value, __ctx, true);
    }

    private java.util.List<String> searchDnInGroups(String attr, String value, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "searchDnInGroups", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("searchDnInGroups");
                    __delBase = __getDelegate(false);
                    _ILdapDel __del = (_ILdapDel)__delBase;
                    return __del.searchDnInGroups(attr, value, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param __cb The callback object for the operation.
     * @param attr   Name of member attribute. Never null or empty.
     **/
    public Ice.AsyncResult begin_searchDnInGroups(String attr, String value)
    {
        return begin_searchDnInGroups(attr, value, null, false, null);
    }

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param __cb The callback object for the operation.
     * @param attr   Name of member attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_searchDnInGroups(String attr, String value, java.util.Map<String, String> __ctx)
    {
        return begin_searchDnInGroups(attr, value, __ctx, true, null);
    }

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param __cb The callback object for the operation.
     * @param attr   Name of member attribute. Never null or empty.
     **/
    public Ice.AsyncResult begin_searchDnInGroups(String attr, String value, Ice.Callback __cb)
    {
        return begin_searchDnInGroups(attr, value, null, false, __cb);
    }

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param __cb The callback object for the operation.
     * @param attr   Name of member attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_searchDnInGroups(String attr, String value, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_searchDnInGroups(attr, value, __ctx, true, __cb);
    }

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param __cb The callback object for the operation.
     * @param attr   Name of member attribute. Never null or empty.
     **/
    public Ice.AsyncResult begin_searchDnInGroups(String attr, String value, Callback_ILdap_searchDnInGroups __cb)
    {
        return begin_searchDnInGroups(attr, value, null, false, __cb);
    }

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param __cb The callback object for the operation.
     * @param attr   Name of member attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_searchDnInGroups(String attr, String value, java.util.Map<String, String> __ctx, Callback_ILdap_searchDnInGroups __cb)
    {
        return begin_searchDnInGroups(attr, value, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_searchDnInGroups(String attr, String value, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__searchDnInGroups_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __searchDnInGroups_name, __cb);
        try
        {
            __result.__prepare(__searchDnInGroups_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(attr);
            __os.writeString(value);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value)       List of groups which contains DN.
     **/
    public java.util.List<String> end_searchDnInGroups(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __searchDnInGroups_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<String> __ret;
            __ret = StringSetHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param __cb The callback object for the operation.
     * @param attr   Name of member attribute. Never null or empty.
     **/
    public boolean searchDnInGroups_async(AMI_ILdap_searchDnInGroups __cb, String attr, String value)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__searchDnInGroups_name);
            __r = begin_searchDnInGroups(attr, value, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __searchDnInGroups_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param __cb The callback object for the operation.
     * @param attr   Name of member attribute. Never null or empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean searchDnInGroups_async(AMI_ILdap_searchDnInGroups __cb, String attr, String value, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__searchDnInGroups_name);
            __r = begin_searchDnInGroups(attr, value, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __searchDnInGroups_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setDN_name = "setDN";

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void setDN(omero.RLong experimenterID, String dn)
        throws omero.ServerError
    {
        setDN(experimenterID, dn, null, false);
    }

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void setDN(omero.RLong experimenterID, String dn, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setDN(experimenterID, dn, __ctx, true);
    }

    private void setDN(omero.RLong experimenterID, String dn, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setDN", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setDN");
                    __delBase = __getDelegate(false);
                    _ILdapDel __del = (_ILdapDel)__delBase;
                    __del.setDN(experimenterID, dn, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_setDN(omero.RLong experimenterID, String dn)
    {
        return begin_setDN(experimenterID, dn, null, false, null);
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_setDN(omero.RLong experimenterID, String dn, java.util.Map<String, String> __ctx)
    {
        return begin_setDN(experimenterID, dn, __ctx, true, null);
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_setDN(omero.RLong experimenterID, String dn, Ice.Callback __cb)
    {
        return begin_setDN(experimenterID, dn, null, false, __cb);
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_setDN(omero.RLong experimenterID, String dn, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setDN(experimenterID, dn, __ctx, true, __cb);
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_setDN(omero.RLong experimenterID, String dn, Callback_ILdap_setDN __cb)
    {
        return begin_setDN(experimenterID, dn, null, false, __cb);
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_setDN(omero.RLong experimenterID, String dn, java.util.Map<String, String> __ctx, Callback_ILdap_setDN __cb)
    {
        return begin_setDN(experimenterID, dn, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setDN(omero.RLong experimenterID, String dn, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setDN_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setDN_name, __cb);
        try
        {
            __result.__prepare(__setDN_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(experimenterID);
            __os.writeString(dn);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setDN(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setDN_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean setDN_async(AMI_ILdap_setDN __cb, omero.RLong experimenterID, String dn)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setDN_name);
            __r = begin_setDN(experimenterID, dn, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setDN_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean setDN_async(AMI_ILdap_setDN __cb, omero.RLong experimenterID, String dn, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setDN_name);
            __r = begin_setDN(experimenterID, dn, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setDN_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static ILdapPrx checkedCast(Ice.ObjectPrx __obj)
    {
        ILdapPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ILdapPrx)
            {
                __d = (ILdapPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    ILdapPrxHelper __h = new ILdapPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ILdapPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        ILdapPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ILdapPrx)
            {
                __d = (ILdapPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    ILdapPrxHelper __h = new ILdapPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ILdapPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ILdapPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    ILdapPrxHelper __h = new ILdapPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ILdapPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        ILdapPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    ILdapPrxHelper __h = new ILdapPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ILdapPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        ILdapPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ILdapPrx)
            {
                __d = (ILdapPrx)__obj;
            }
            else
            {
                ILdapPrxHelper __h = new ILdapPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static ILdapPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ILdapPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            ILdapPrxHelper __h = new ILdapPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::ILdap",
        "::omero::api::ServiceInterface"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _ILdapDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _ILdapDelD();
    }

    public static void __write(IceInternal.BasicStream __os, ILdapPrx v)
    {
        __os.writeProxy(v);
    }

    public static ILdapPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            ILdapPrxHelper result = new ILdapPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
