// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IMetadata.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides method to interact with acquisition metadata and
 * annotations.
 **/
public interface IMetadataPrx extends ServiceInterfacePrx
{
    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     * @return The collection of loaded logical channels.
     **/
    public java.util.List<omero.model.LogicalChannel> loadChannelAcquisitionData(java.util.List<Long> ids)
        throws omero.ServerError;

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     * @param __ctx The Context map to send with the invocation.
     * @return The collection of loaded logical channels.
     **/
    public java.util.List<omero.model.LogicalChannel> loadChannelAcquisitionData(java.util.List<Long> ids, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadChannelAcquisitionData(java.util.List<Long> ids);

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadChannelAcquisitionData(java.util.List<Long> ids, java.util.Map<String, String> __ctx);

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadChannelAcquisitionData(java.util.List<Long> ids, Ice.Callback __cb);

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadChannelAcquisitionData(java.util.List<Long> ids, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadChannelAcquisitionData(java.util.List<Long> ids, Callback_IMetadata_loadChannelAcquisitionData __cb);

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadChannelAcquisitionData(java.util.List<Long> ids, java.util.Map<String, String> __ctx, Callback_IMetadata_loadChannelAcquisitionData __cb);

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param __result The asynchronous result object.
     * @return The collection of loaded logical channels.
     **/
    public java.util.List<omero.model.LogicalChannel> end_loadChannelAcquisitionData(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     **/
    public boolean loadChannelAcquisitionData_async(AMI_IMetadata_loadChannelAcquisitionData __cb, java.util.List<Long> ids);

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadChannelAcquisitionData_async(AMI_IMetadata_loadChannelAcquisitionData __cb, java.util.List<Long> ids, java.util.Map<String, String> __ctx);

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotationType
     * The types of annotation to retrieve. If
     * <code>null</code> all annotations will be loaded.
     * String of the type
     * <code>omero.model.annotations.*</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     * @return A map whose key is rootId and value the
     * <code>Map</code> of all annotations for that node
     * or <code>null</code>.
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> loadAnnotations(String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options)
        throws omero.ServerError;

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotationType
     * The types of annotation to retrieve. If
     * <code>null</code> all annotations will be loaded.
     * String of the type
     * <code>omero.model.annotations.*</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     * @param __ctx The Context map to send with the invocation.
     * @return A map whose key is rootId and value the
     * <code>Map</code> of all annotations for that node
     * or <code>null</code>.
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> loadAnnotations(String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadAnnotations(String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options);

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadAnnotations(String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx);

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadAnnotations(String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options, Ice.Callback __cb);

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadAnnotations(String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadAnnotations(String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options, Callback_IMetadata_loadAnnotations __cb);

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadAnnotations(String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Callback_IMetadata_loadAnnotations __cb);

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param __result The asynchronous result object.
     * @return A map whose key is rootId and value the
     * <code>Map</code> of all annotations for that node
     * or <code>null</code>.
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> end_loadAnnotations(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param __cb The callback object for the operation.
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     **/
    public boolean loadAnnotations_async(AMI_IMetadata_loadAnnotations __cb, String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options);

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param __cb The callback object for the operation.
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadAnnotations_async(AMI_IMetadata_loadAnnotations __cb, String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx);

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param annotationType The type of annotations to load.
     * @param include
     * Include the annotations with the specified name spaces.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     * @return          A collection of found annotations.
     **/
    public java.util.List<omero.model.Annotation> loadSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options)
        throws omero.ServerError;

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param annotationType The type of annotations to load.
     * @param include
     * Include the annotations with the specified name spaces.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @return          A collection of found annotations.
     **/
    public java.util.List<omero.model.Annotation> loadSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param annotationType The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options);

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param annotationType The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx);

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param annotationType The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, Ice.Callback __cb);

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param annotationType The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param annotationType The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, Callback_IMetadata_loadSpecifiedAnnotations __cb);

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param annotationType The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Callback_IMetadata_loadSpecifiedAnnotations __cb);

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param __result The asynchronous result object.
     * @return          A collection of found annotations.
     **/
    public java.util.List<omero.model.Annotation> end_loadSpecifiedAnnotations(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     **/
    public boolean loadSpecifiedAnnotations_async(AMI_IMetadata_loadSpecifiedAnnotations __cb, String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options);

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadSpecifiedAnnotations_async(AMI_IMetadata_loadSpecifiedAnnotations __cb, String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx);

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param ids The id of the tag to load or <code>-1</code>.
     * @return Map whose key is a <code>Tag/TagSet</code> and the
     * value either a Map or a list of related
     * <code>DataObject</code>.
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> loadTagContent(java.util.List<Long> ids, omero.sys.Parameters options)
        throws omero.ServerError;

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param ids The id of the tag to load or <code>-1</code>.
     * @param __ctx The Context map to send with the invocation.
     * @return Map whose key is a <code>Tag/TagSet</code> and the
     * value either a Map or a list of related
     * <code>DataObject</code>.
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> loadTagContent(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param ids The id of the tag to load or <code>-1</code>.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadTagContent(java.util.List<Long> ids, omero.sys.Parameters options);

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param ids The id of the tag to load or <code>-1</code>.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadTagContent(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx);

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param ids The id of the tag to load or <code>-1</code>.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadTagContent(java.util.List<Long> ids, omero.sys.Parameters options, Ice.Callback __cb);

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param ids The id of the tag to load or <code>-1</code>.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadTagContent(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param ids The id of the tag to load or <code>-1</code>.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadTagContent(java.util.List<Long> ids, omero.sys.Parameters options, Callback_IMetadata_loadTagContent __cb);

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param ids The id of the tag to load or <code>-1</code>.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadTagContent(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Callback_IMetadata_loadTagContent __cb);

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param __result The asynchronous result object.
     * @return Map whose key is a <code>Tag/TagSet</code> and the
     * value either a Map or a list of related
     * <code>DataObject</code>.
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> end_loadTagContent(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The id of the tag to load or <code>-1</code>.
     **/
    public boolean loadTagContent_async(AMI_IMetadata_loadTagContent __cb, java.util.List<Long> ids, omero.sys.Parameters options);

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The id of the tag to load or <code>-1</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadTagContent_async(AMI_IMetadata_loadTagContent __cb, java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx);

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param options The POJO options.
     * @return See above.
     **/
    public java.util.List<omero.model.IObject> loadTagSets(omero.sys.Parameters options)
        throws omero.ServerError;

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param options The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public java.util.List<omero.model.IObject> loadTagSets(omero.sys.Parameters options, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param options The POJO options.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadTagSets(omero.sys.Parameters options);

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param options The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadTagSets(omero.sys.Parameters options, java.util.Map<String, String> __ctx);

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param options The POJO options.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadTagSets(omero.sys.Parameters options, Ice.Callback __cb);

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param options The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadTagSets(omero.sys.Parameters options, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param options The POJO options.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadTagSets(omero.sys.Parameters options, Callback_IMetadata_loadTagSets __cb);

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param options The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadTagSets(omero.sys.Parameters options, java.util.Map<String, String> __ctx, Callback_IMetadata_loadTagSets __cb);

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param __result The asynchronous result object.
     * @return See above.
     **/
    public java.util.List<omero.model.IObject> end_loadTagSets(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param __cb The callback object for the operation.
     * @param options The POJO options.
     **/
    public boolean loadTagSets_async(AMI_IMetadata_loadTagSets __cb, omero.sys.Parameters options);

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param __cb The callback object for the operation.
     * @param options The POJO options.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadTagSets_async(AMI_IMetadata_loadTagSets __cb, omero.sys.Parameters options, java.util.Map<String, String> __ctx);

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param ids The collection of ids.
     * @param options The POJO options.
     * @return See above.
     **/
    public java.util.Map<Long,Long> getTaggedObjectsCount(java.util.List<Long> ids, omero.sys.Parameters options)
        throws omero.ServerError;

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param ids The collection of ids.
     * @param options The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public java.util.Map<Long,Long> getTaggedObjectsCount(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param ids The collection of ids.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTaggedObjectsCount(java.util.List<Long> ids, omero.sys.Parameters options);

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param ids The collection of ids.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTaggedObjectsCount(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx);

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param ids The collection of ids.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTaggedObjectsCount(java.util.List<Long> ids, omero.sys.Parameters options, Ice.Callback __cb);

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param ids The collection of ids.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTaggedObjectsCount(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param ids The collection of ids.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTaggedObjectsCount(java.util.List<Long> ids, omero.sys.Parameters options, Callback_IMetadata_getTaggedObjectsCount __cb);

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param ids The collection of ids.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTaggedObjectsCount(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Callback_IMetadata_getTaggedObjectsCount __cb);

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param __result The asynchronous result object.
     * @return See above.
     **/
    public java.util.Map<Long,Long> end_getTaggedObjectsCount(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of ids.
     **/
    public boolean getTaggedObjectsCount_async(AMI_IMetadata_getTaggedObjectsCount __cb, java.util.List<Long> ids, omero.sys.Parameters options);

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of ids.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getTaggedObjectsCount_async(AMI_IMetadata_getTaggedObjectsCount __cb, java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx);

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param annotationType The type of annotations to load.
     * @param include   The collection of name space, one of the
     * constants defined by this class.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     * @return See above.
     **/
    public omero.RLong countSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options)
        throws omero.ServerError;

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param annotationType The type of annotations to load.
     * @param include   The collection of name space, one of the
     * constants defined by this class.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public omero.RLong countSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param annotationType The type of annotations to load.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_countSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options);

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param annotationType The type of annotations to load.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_countSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx);

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param annotationType The type of annotations to load.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_countSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, Ice.Callback __cb);

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param annotationType The type of annotations to load.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_countSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param annotationType The type of annotations to load.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_countSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, Callback_IMetadata_countSpecifiedAnnotations __cb);

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param annotationType The type of annotations to load.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_countSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Callback_IMetadata_countSpecifiedAnnotations __cb);

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param __result The asynchronous result object.
     * @return See above.
     **/
    public omero.RLong end_countSpecifiedAnnotations(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     **/
    public boolean countSpecifiedAnnotations_async(AMI_IMetadata_countSpecifiedAnnotations __cb, String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options);

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean countSpecifiedAnnotations_async(AMI_IMetadata_countSpecifiedAnnotations __cb, String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx);

    /**
     * Loads the specified annotations.
     * 
     * @param annotationIds The collection of annotation ids.
     * @return              See above.
     **/
    public java.util.List<omero.model.Annotation> loadAnnotation(java.util.List<Long> annotationIds)
        throws omero.ServerError;

    /**
     * Loads the specified annotations.
     * 
     * @param annotationIds The collection of annotation ids.
     * @param __ctx The Context map to send with the invocation.
     * @return              See above.
     **/
    public java.util.List<omero.model.Annotation> loadAnnotation(java.util.List<Long> annotationIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Loads the specified annotations.
     * 
     * @param annotationIds The collection of annotation ids.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadAnnotation(java.util.List<Long> annotationIds);

    /**
     * Loads the specified annotations.
     * 
     * @param annotationIds The collection of annotation ids.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadAnnotation(java.util.List<Long> annotationIds, java.util.Map<String, String> __ctx);

    /**
     * Loads the specified annotations.
     * 
     * @param annotationIds The collection of annotation ids.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadAnnotation(java.util.List<Long> annotationIds, Ice.Callback __cb);

    /**
     * Loads the specified annotations.
     * 
     * @param annotationIds The collection of annotation ids.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadAnnotation(java.util.List<Long> annotationIds, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Loads the specified annotations.
     * 
     * @param annotationIds The collection of annotation ids.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadAnnotation(java.util.List<Long> annotationIds, Callback_IMetadata_loadAnnotation __cb);

    /**
     * Loads the specified annotations.
     * 
     * @param annotationIds The collection of annotation ids.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadAnnotation(java.util.List<Long> annotationIds, java.util.Map<String, String> __ctx, Callback_IMetadata_loadAnnotation __cb);

    /**
     * Loads the specified annotations.
     * 
     * @param __result The asynchronous result object.
     * @return              See above.
     **/
    public java.util.List<omero.model.Annotation> end_loadAnnotation(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Loads the specified annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationIds The collection of annotation ids.
     **/
    public boolean loadAnnotation_async(AMI_IMetadata_loadAnnotation __cb, java.util.List<Long> annotationIds);

    /**
     * Loads the specified annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationIds The collection of annotation ids.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadAnnotation_async(AMI_IMetadata_loadAnnotation __cb, java.util.List<Long> annotationIds, java.util.Map<String, String> __ctx);

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param id    The id of the instrument to load.
     * @return      See above
     **/
    public omero.model.Instrument loadInstrument(long id)
        throws omero.ServerError;

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param id    The id of the instrument to load.
     * @param __ctx The Context map to send with the invocation.
     * @return      See above
     **/
    public omero.model.Instrument loadInstrument(long id, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param id    The id of the instrument to load.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadInstrument(long id);

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param id    The id of the instrument to load.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadInstrument(long id, java.util.Map<String, String> __ctx);

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param id    The id of the instrument to load.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadInstrument(long id, Ice.Callback __cb);

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param id    The id of the instrument to load.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadInstrument(long id, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param id    The id of the instrument to load.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadInstrument(long id, Callback_IMetadata_loadInstrument __cb);

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param id    The id of the instrument to load.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadInstrument(long id, java.util.Map<String, String> __ctx, Callback_IMetadata_loadInstrument __cb);

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param __result The asynchronous result object.
     * @return      See above
     **/
    public omero.model.Instrument end_loadInstrument(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param __cb The callback object for the operation.
     * @param id    The id of the instrument to load.
     **/
    public boolean loadInstrument_async(AMI_IMetadata_loadInstrument __cb, long id);

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param __cb The callback object for the operation.
     * @param id    The id of the instrument to load.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadInstrument_async(AMI_IMetadata_loadInstrument __cb, long id, java.util.Map<String, String> __ctx);

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @param userID            The identifier of the user.
     * @return                  See above.
     **/
    public java.util.List<omero.model.IObject> loadAnnotationsUsedNotOwned(String annotationType, long userID)
        throws omero.ServerError;

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @param userID            The identifier of the user.
     * @param __ctx The Context map to send with the invocation.
     * @return                  See above.
     **/
    public java.util.List<omero.model.IObject> loadAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadAnnotationsUsedNotOwned(String annotationType, long userID);

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx);

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadAnnotationsUsedNotOwned(String annotationType, long userID, Ice.Callback __cb);

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadAnnotationsUsedNotOwned(String annotationType, long userID, Callback_IMetadata_loadAnnotationsUsedNotOwned __cb);

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx, Callback_IMetadata_loadAnnotationsUsedNotOwned __cb);

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param __result The asynchronous result object.
     * @return                  See above.
     **/
    public java.util.List<omero.model.IObject> end_loadAnnotationsUsedNotOwned(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     **/
    public boolean loadAnnotationsUsedNotOwned_async(AMI_IMetadata_loadAnnotationsUsedNotOwned __cb, String annotationType, long userID);

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadAnnotationsUsedNotOwned_async(AMI_IMetadata_loadAnnotationsUsedNotOwned __cb, String annotationType, long userID, java.util.Map<String, String> __ctx);

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @param userID            The identifier of the user.
     * @return                  See above.
     **/
    public omero.RLong countAnnotationsUsedNotOwned(String annotationType, long userID)
        throws omero.ServerError;

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @param userID            The identifier of the user.
     * @param __ctx The Context map to send with the invocation.
     * @return                  See above.
     **/
    public omero.RLong countAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_countAnnotationsUsedNotOwned(String annotationType, long userID);

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_countAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx);

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_countAnnotationsUsedNotOwned(String annotationType, long userID, Ice.Callback __cb);

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_countAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_countAnnotationsUsedNotOwned(String annotationType, long userID, Callback_IMetadata_countAnnotationsUsedNotOwned __cb);

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_countAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx, Callback_IMetadata_countAnnotationsUsedNotOwned __cb);

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param __result The asynchronous result object.
     * @return                  See above.
     **/
    public omero.RLong end_countAnnotationsUsedNotOwned(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     **/
    public boolean countAnnotationsUsedNotOwned_async(AMI_IMetadata_countAnnotationsUsedNotOwned __cb, String annotationType, long userID);

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean countAnnotationsUsedNotOwned_async(AMI_IMetadata_countAnnotationsUsedNotOwned __cb, String annotationType, long userID, java.util.Map<String, String> __ctx);

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param annotationType  The type of annotations to load.
     * @param include
     * Include the annotations with the specified name spaces.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     * @param options       The POJO options.
     * @return              A collection of found annotations.
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.Annotation>> loadSpecifiedAnnotationsLinkedTo(String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options)
        throws omero.ServerError;

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param annotationType  The type of annotations to load.
     * @param include
     * Include the annotations with the specified name spaces.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     * @param options       The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @return              A collection of found annotations.
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.Annotation>> loadSpecifiedAnnotationsLinkedTo(String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param annotationType  The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotationsLinkedTo(String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options);

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param annotationType  The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotationsLinkedTo(String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx);

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param annotationType  The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotationsLinkedTo(String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options, Ice.Callback __cb);

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param annotationType  The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotationsLinkedTo(String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param annotationType  The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotationsLinkedTo(String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options, Callback_IMetadata_loadSpecifiedAnnotationsLinkedTo __cb);

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param annotationType  The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotationsLinkedTo(String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Callback_IMetadata_loadSpecifiedAnnotationsLinkedTo __cb);

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param __result The asynchronous result object.
     * @return              A collection of found annotations.
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.Annotation>> end_loadSpecifiedAnnotationsLinkedTo(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType  The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     **/
    public boolean loadSpecifiedAnnotationsLinkedTo_async(AMI_IMetadata_loadSpecifiedAnnotationsLinkedTo __cb, String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options);

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType  The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadSpecifiedAnnotationsLinkedTo_async(AMI_IMetadata_loadSpecifiedAnnotationsLinkedTo __cb, String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx);

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param rootNodeType
     * the root node type, may be {@link omero.model.Image}
     * or {@link omero.model.Fileset}
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     * @return the original file IDs of the import logs
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> loadLogFiles(String rootType, java.util.List<Long> ids)
        throws omero.ServerError;

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param rootNodeType
     * the root node type, may be {@link omero.model.Image}
     * or {@link omero.model.Fileset}
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     * @param __ctx The Context map to send with the invocation.
     * @return the original file IDs of the import logs
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> loadLogFiles(String rootType, java.util.List<Long> ids, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadLogFiles(String rootType, java.util.List<Long> ids);

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadLogFiles(String rootType, java.util.List<Long> ids, java.util.Map<String, String> __ctx);

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadLogFiles(String rootType, java.util.List<Long> ids, Ice.Callback __cb);

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadLogFiles(String rootType, java.util.List<Long> ids, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadLogFiles(String rootType, java.util.List<Long> ids, Callback_IMetadata_loadLogFiles __cb);

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadLogFiles(String rootType, java.util.List<Long> ids, java.util.Map<String, String> __ctx, Callback_IMetadata_loadLogFiles __cb);

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param __result The asynchronous result object.
     * @return the original file IDs of the import logs
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> end_loadLogFiles(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param __cb The callback object for the operation.
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     **/
    public boolean loadLogFiles_async(AMI_IMetadata_loadLogFiles __cb, String rootType, java.util.List<Long> ids);

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param __cb The callback object for the operation.
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadLogFiles_async(AMI_IMetadata_loadLogFiles __cb, String rootType, java.util.List<Long> ids, java.util.Map<String, String> __ctx);
}
