// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IMetadata.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides method to interact with acquisition metadata and
 * annotations.
 **/
public final class IMetadataPrxHelper extends Ice.ObjectPrxHelperBase implements IMetadataPrx
{
    private static final String __countAnnotationsUsedNotOwned_name = "countAnnotationsUsedNotOwned";

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @param userID            The identifier of the user.
     * @return                  See above.
     **/
    public omero.RLong countAnnotationsUsedNotOwned(String annotationType, long userID)
        throws omero.ServerError
    {
        return countAnnotationsUsedNotOwned(annotationType, userID, null, false);
    }

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @param userID            The identifier of the user.
     * @param __ctx The Context map to send with the invocation.
     * @return                  See above.
     **/
    public omero.RLong countAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return countAnnotationsUsedNotOwned(annotationType, userID, __ctx, true);
    }

    private omero.RLong countAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "countAnnotationsUsedNotOwned", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("countAnnotationsUsedNotOwned");
                    __delBase = __getDelegate(false);
                    _IMetadataDel __del = (_IMetadataDel)__delBase;
                    return __del.countAnnotationsUsedNotOwned(annotationType, userID, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     **/
    public Ice.AsyncResult begin_countAnnotationsUsedNotOwned(String annotationType, long userID)
    {
        return begin_countAnnotationsUsedNotOwned(annotationType, userID, null, false, null);
    }

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_countAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx)
    {
        return begin_countAnnotationsUsedNotOwned(annotationType, userID, __ctx, true, null);
    }

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     **/
    public Ice.AsyncResult begin_countAnnotationsUsedNotOwned(String annotationType, long userID, Ice.Callback __cb)
    {
        return begin_countAnnotationsUsedNotOwned(annotationType, userID, null, false, __cb);
    }

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_countAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_countAnnotationsUsedNotOwned(annotationType, userID, __ctx, true, __cb);
    }

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     **/
    public Ice.AsyncResult begin_countAnnotationsUsedNotOwned(String annotationType, long userID, Callback_IMetadata_countAnnotationsUsedNotOwned __cb)
    {
        return begin_countAnnotationsUsedNotOwned(annotationType, userID, null, false, __cb);
    }

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_countAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx, Callback_IMetadata_countAnnotationsUsedNotOwned __cb)
    {
        return begin_countAnnotationsUsedNotOwned(annotationType, userID, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_countAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__countAnnotationsUsedNotOwned_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __countAnnotationsUsedNotOwned_name, __cb);
        try
        {
            __result.__prepare(__countAnnotationsUsedNotOwned_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(annotationType);
            __os.writeLong(userID);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value)                  See above.
     **/
    public omero.RLong end_countAnnotationsUsedNotOwned(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __countAnnotationsUsedNotOwned_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.RLongHolder __ret = new omero.RLongHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     **/
    public boolean countAnnotationsUsedNotOwned_async(AMI_IMetadata_countAnnotationsUsedNotOwned __cb, String annotationType, long userID)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__countAnnotationsUsedNotOwned_name);
            __r = begin_countAnnotationsUsedNotOwned(annotationType, userID, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __countAnnotationsUsedNotOwned_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean countAnnotationsUsedNotOwned_async(AMI_IMetadata_countAnnotationsUsedNotOwned __cb, String annotationType, long userID, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__countAnnotationsUsedNotOwned_name);
            __r = begin_countAnnotationsUsedNotOwned(annotationType, userID, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __countAnnotationsUsedNotOwned_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __countSpecifiedAnnotations_name = "countSpecifiedAnnotations";

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param annotationType The type of annotations to load.
     * @param include   The collection of name space, one of the
     * constants defined by this class.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     * @return See above.
     **/
    public omero.RLong countSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options)
        throws omero.ServerError
    {
        return countSpecifiedAnnotations(annotationType, include, exclude, options, null, false);
    }

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param annotationType The type of annotations to load.
     * @param include   The collection of name space, one of the
     * constants defined by this class.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public omero.RLong countSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return countSpecifiedAnnotations(annotationType, include, exclude, options, __ctx, true);
    }

    private omero.RLong countSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "countSpecifiedAnnotations", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("countSpecifiedAnnotations");
                    __delBase = __getDelegate(false);
                    _IMetadataDel __del = (_IMetadataDel)__delBase;
                    return __del.countSpecifiedAnnotations(annotationType, include, exclude, options, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     **/
    public Ice.AsyncResult begin_countSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options)
    {
        return begin_countSpecifiedAnnotations(annotationType, include, exclude, options, null, false, null);
    }

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_countSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
    {
        return begin_countSpecifiedAnnotations(annotationType, include, exclude, options, __ctx, true, null);
    }

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     **/
    public Ice.AsyncResult begin_countSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, Ice.Callback __cb)
    {
        return begin_countSpecifiedAnnotations(annotationType, include, exclude, options, null, false, __cb);
    }

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_countSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_countSpecifiedAnnotations(annotationType, include, exclude, options, __ctx, true, __cb);
    }

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     **/
    public Ice.AsyncResult begin_countSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, Callback_IMetadata_countSpecifiedAnnotations __cb)
    {
        return begin_countSpecifiedAnnotations(annotationType, include, exclude, options, null, false, __cb);
    }

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_countSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Callback_IMetadata_countSpecifiedAnnotations __cb)
    {
        return begin_countSpecifiedAnnotations(annotationType, include, exclude, options, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_countSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__countSpecifiedAnnotations_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __countSpecifiedAnnotations_name, __cb);
        try
        {
            __result.__prepare(__countSpecifiedAnnotations_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(annotationType);
            StringSetHelper.write(__os, include);
            StringSetHelper.write(__os, exclude);
            __os.writeObject(options);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) See above.
     **/
    public omero.RLong end_countSpecifiedAnnotations(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __countSpecifiedAnnotations_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.RLongHolder __ret = new omero.RLongHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     **/
    public boolean countSpecifiedAnnotations_async(AMI_IMetadata_countSpecifiedAnnotations __cb, String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__countSpecifiedAnnotations_name);
            __r = begin_countSpecifiedAnnotations(annotationType, include, exclude, options, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __countSpecifiedAnnotations_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean countSpecifiedAnnotations_async(AMI_IMetadata_countSpecifiedAnnotations __cb, String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__countSpecifiedAnnotations_name);
            __r = begin_countSpecifiedAnnotations(annotationType, include, exclude, options, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __countSpecifiedAnnotations_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getTaggedObjectsCount_name = "getTaggedObjectsCount";

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param ids The collection of ids.
     * @param options The POJO options.
     * @return See above.
     **/
    public java.util.Map<Long,Long> getTaggedObjectsCount(java.util.List<Long> ids, omero.sys.Parameters options)
        throws omero.ServerError
    {
        return getTaggedObjectsCount(ids, options, null, false);
    }

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param ids The collection of ids.
     * @param options The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public java.util.Map<Long,Long> getTaggedObjectsCount(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getTaggedObjectsCount(ids, options, __ctx, true);
    }

    private java.util.Map<Long,Long> getTaggedObjectsCount(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getTaggedObjectsCount", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getTaggedObjectsCount");
                    __delBase = __getDelegate(false);
                    _IMetadataDel __del = (_IMetadataDel)__delBase;
                    return __del.getTaggedObjectsCount(ids, options, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of ids.
     **/
    public Ice.AsyncResult begin_getTaggedObjectsCount(java.util.List<Long> ids, omero.sys.Parameters options)
    {
        return begin_getTaggedObjectsCount(ids, options, null, false, null);
    }

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of ids.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTaggedObjectsCount(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
    {
        return begin_getTaggedObjectsCount(ids, options, __ctx, true, null);
    }

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of ids.
     **/
    public Ice.AsyncResult begin_getTaggedObjectsCount(java.util.List<Long> ids, omero.sys.Parameters options, Ice.Callback __cb)
    {
        return begin_getTaggedObjectsCount(ids, options, null, false, __cb);
    }

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of ids.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTaggedObjectsCount(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getTaggedObjectsCount(ids, options, __ctx, true, __cb);
    }

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of ids.
     **/
    public Ice.AsyncResult begin_getTaggedObjectsCount(java.util.List<Long> ids, omero.sys.Parameters options, Callback_IMetadata_getTaggedObjectsCount __cb)
    {
        return begin_getTaggedObjectsCount(ids, options, null, false, __cb);
    }

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of ids.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTaggedObjectsCount(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Callback_IMetadata_getTaggedObjectsCount __cb)
    {
        return begin_getTaggedObjectsCount(ids, options, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getTaggedObjectsCount(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getTaggedObjectsCount_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getTaggedObjectsCount_name, __cb);
        try
        {
            __result.__prepare(__getTaggedObjectsCount_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.sys.LongListHelper.write(__os, ids);
            __os.writeObject(options);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) See above.
     **/
    public java.util.Map<Long,Long> end_getTaggedObjectsCount(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getTaggedObjectsCount_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<Long,Long> __ret;
            __ret = omero.sys.CountMapHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of ids.
     **/
    public boolean getTaggedObjectsCount_async(AMI_IMetadata_getTaggedObjectsCount __cb, java.util.List<Long> ids, omero.sys.Parameters options)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getTaggedObjectsCount_name);
            __r = begin_getTaggedObjectsCount(ids, options, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getTaggedObjectsCount_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of ids.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getTaggedObjectsCount_async(AMI_IMetadata_getTaggedObjectsCount __cb, java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getTaggedObjectsCount_name);
            __r = begin_getTaggedObjectsCount(ids, options, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getTaggedObjectsCount_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __loadAnnotation_name = "loadAnnotation";

    /**
     * Loads the specified annotations.
     * 
     * @param annotationIds The collection of annotation ids.
     * @return              See above.
     **/
    public java.util.List<omero.model.Annotation> loadAnnotation(java.util.List<Long> annotationIds)
        throws omero.ServerError
    {
        return loadAnnotation(annotationIds, null, false);
    }

    /**
     * Loads the specified annotations.
     * 
     * @param annotationIds The collection of annotation ids.
     * @param __ctx The Context map to send with the invocation.
     * @return              See above.
     **/
    public java.util.List<omero.model.Annotation> loadAnnotation(java.util.List<Long> annotationIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return loadAnnotation(annotationIds, __ctx, true);
    }

    private java.util.List<omero.model.Annotation> loadAnnotation(java.util.List<Long> annotationIds, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "loadAnnotation", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("loadAnnotation");
                    __delBase = __getDelegate(false);
                    _IMetadataDel __del = (_IMetadataDel)__delBase;
                    return __del.loadAnnotation(annotationIds, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Loads the specified annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationIds The collection of annotation ids.
     **/
    public Ice.AsyncResult begin_loadAnnotation(java.util.List<Long> annotationIds)
    {
        return begin_loadAnnotation(annotationIds, null, false, null);
    }

    /**
     * Loads the specified annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationIds The collection of annotation ids.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadAnnotation(java.util.List<Long> annotationIds, java.util.Map<String, String> __ctx)
    {
        return begin_loadAnnotation(annotationIds, __ctx, true, null);
    }

    /**
     * Loads the specified annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationIds The collection of annotation ids.
     **/
    public Ice.AsyncResult begin_loadAnnotation(java.util.List<Long> annotationIds, Ice.Callback __cb)
    {
        return begin_loadAnnotation(annotationIds, null, false, __cb);
    }

    /**
     * Loads the specified annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationIds The collection of annotation ids.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadAnnotation(java.util.List<Long> annotationIds, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_loadAnnotation(annotationIds, __ctx, true, __cb);
    }

    /**
     * Loads the specified annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationIds The collection of annotation ids.
     **/
    public Ice.AsyncResult begin_loadAnnotation(java.util.List<Long> annotationIds, Callback_IMetadata_loadAnnotation __cb)
    {
        return begin_loadAnnotation(annotationIds, null, false, __cb);
    }

    /**
     * Loads the specified annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationIds The collection of annotation ids.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadAnnotation(java.util.List<Long> annotationIds, java.util.Map<String, String> __ctx, Callback_IMetadata_loadAnnotation __cb)
    {
        return begin_loadAnnotation(annotationIds, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_loadAnnotation(java.util.List<Long> annotationIds, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__loadAnnotation_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __loadAnnotation_name, __cb);
        try
        {
            __result.__prepare(__loadAnnotation_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.sys.LongListHelper.write(__os, annotationIds);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value)              See above.
     **/
    public java.util.List<omero.model.Annotation> end_loadAnnotation(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __loadAnnotation_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.Annotation> __ret;
            __ret = AnnotationListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Loads the specified annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationIds The collection of annotation ids.
     **/
    public boolean loadAnnotation_async(AMI_IMetadata_loadAnnotation __cb, java.util.List<Long> annotationIds)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadAnnotation_name);
            __r = begin_loadAnnotation(annotationIds, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadAnnotation_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Loads the specified annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationIds The collection of annotation ids.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadAnnotation_async(AMI_IMetadata_loadAnnotation __cb, java.util.List<Long> annotationIds, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadAnnotation_name);
            __r = begin_loadAnnotation(annotationIds, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadAnnotation_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __loadAnnotations_name = "loadAnnotations";

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotationType
     * The types of annotation to retrieve. If
     * <code>null</code> all annotations will be loaded.
     * String of the type
     * <code>omero.model.annotations.*</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     * @return A map whose key is rootId and value the
     * <code>Map</code> of all annotations for that node
     * or <code>null</code>.
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> loadAnnotations(String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options)
        throws omero.ServerError
    {
        return loadAnnotations(rootType, rootIds, annotationTypes, annotatorIds, options, null, false);
    }

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotationType
     * The types of annotation to retrieve. If
     * <code>null</code> all annotations will be loaded.
     * String of the type
     * <code>omero.model.annotations.*</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     * @param __ctx The Context map to send with the invocation.
     * @return A map whose key is rootId and value the
     * <code>Map</code> of all annotations for that node
     * or <code>null</code>.
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> loadAnnotations(String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return loadAnnotations(rootType, rootIds, annotationTypes, annotatorIds, options, __ctx, true);
    }

    private java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> loadAnnotations(String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "loadAnnotations", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("loadAnnotations");
                    __delBase = __getDelegate(false);
                    _IMetadataDel __del = (_IMetadataDel)__delBase;
                    return __del.loadAnnotations(rootType, rootIds, annotationTypes, annotatorIds, options, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param __cb The callback object for the operation.
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     **/
    public Ice.AsyncResult begin_loadAnnotations(String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options)
    {
        return begin_loadAnnotations(rootType, rootIds, annotationTypes, annotatorIds, options, null, false, null);
    }

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param __cb The callback object for the operation.
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadAnnotations(String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
    {
        return begin_loadAnnotations(rootType, rootIds, annotationTypes, annotatorIds, options, __ctx, true, null);
    }

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param __cb The callback object for the operation.
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     **/
    public Ice.AsyncResult begin_loadAnnotations(String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options, Ice.Callback __cb)
    {
        return begin_loadAnnotations(rootType, rootIds, annotationTypes, annotatorIds, options, null, false, __cb);
    }

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param __cb The callback object for the operation.
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadAnnotations(String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_loadAnnotations(rootType, rootIds, annotationTypes, annotatorIds, options, __ctx, true, __cb);
    }

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param __cb The callback object for the operation.
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     **/
    public Ice.AsyncResult begin_loadAnnotations(String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options, Callback_IMetadata_loadAnnotations __cb)
    {
        return begin_loadAnnotations(rootType, rootIds, annotationTypes, annotatorIds, options, null, false, __cb);
    }

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param __cb The callback object for the operation.
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadAnnotations(String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Callback_IMetadata_loadAnnotations __cb)
    {
        return begin_loadAnnotations(rootType, rootIds, annotationTypes, annotatorIds, options, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_loadAnnotations(String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__loadAnnotations_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __loadAnnotations_name, __cb);
        try
        {
            __result.__prepare(__loadAnnotations_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(rootType);
            omero.sys.LongListHelper.write(__os, rootIds);
            StringSetHelper.write(__os, annotationTypes);
            omero.sys.LongListHelper.write(__os, annotatorIds);
            __os.writeObject(options);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) A map whose key is rootId and value the
     * <code>Map</code> of all annotations for that node
     * or <code>null</code>.
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> end_loadAnnotations(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __loadAnnotations_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> __ret;
            __ret = LongIObjectListMapHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param __cb The callback object for the operation.
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     **/
    public boolean loadAnnotations_async(AMI_IMetadata_loadAnnotations __cb, String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadAnnotations_name);
            __r = begin_loadAnnotations(rootType, rootIds, annotationTypes, annotatorIds, options, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadAnnotations_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param __cb The callback object for the operation.
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadAnnotations_async(AMI_IMetadata_loadAnnotations __cb, String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadAnnotations_name);
            __r = begin_loadAnnotations(rootType, rootIds, annotationTypes, annotatorIds, options, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadAnnotations_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __loadAnnotationsUsedNotOwned_name = "loadAnnotationsUsedNotOwned";

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @param userID            The identifier of the user.
     * @return                  See above.
     **/
    public java.util.List<omero.model.IObject> loadAnnotationsUsedNotOwned(String annotationType, long userID)
        throws omero.ServerError
    {
        return loadAnnotationsUsedNotOwned(annotationType, userID, null, false);
    }

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param annotationType    The type of annotations to load.
     * @param userID            The identifier of the user.
     * @param __ctx The Context map to send with the invocation.
     * @return                  See above.
     **/
    public java.util.List<omero.model.IObject> loadAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return loadAnnotationsUsedNotOwned(annotationType, userID, __ctx, true);
    }

    private java.util.List<omero.model.IObject> loadAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "loadAnnotationsUsedNotOwned", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("loadAnnotationsUsedNotOwned");
                    __delBase = __getDelegate(false);
                    _IMetadataDel __del = (_IMetadataDel)__delBase;
                    return __del.loadAnnotationsUsedNotOwned(annotationType, userID, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     **/
    public Ice.AsyncResult begin_loadAnnotationsUsedNotOwned(String annotationType, long userID)
    {
        return begin_loadAnnotationsUsedNotOwned(annotationType, userID, null, false, null);
    }

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx)
    {
        return begin_loadAnnotationsUsedNotOwned(annotationType, userID, __ctx, true, null);
    }

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     **/
    public Ice.AsyncResult begin_loadAnnotationsUsedNotOwned(String annotationType, long userID, Ice.Callback __cb)
    {
        return begin_loadAnnotationsUsedNotOwned(annotationType, userID, null, false, __cb);
    }

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_loadAnnotationsUsedNotOwned(annotationType, userID, __ctx, true, __cb);
    }

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     **/
    public Ice.AsyncResult begin_loadAnnotationsUsedNotOwned(String annotationType, long userID, Callback_IMetadata_loadAnnotationsUsedNotOwned __cb)
    {
        return begin_loadAnnotationsUsedNotOwned(annotationType, userID, null, false, __cb);
    }

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx, Callback_IMetadata_loadAnnotationsUsedNotOwned __cb)
    {
        return begin_loadAnnotationsUsedNotOwned(annotationType, userID, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_loadAnnotationsUsedNotOwned(String annotationType, long userID, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__loadAnnotationsUsedNotOwned_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __loadAnnotationsUsedNotOwned_name, __cb);
        try
        {
            __result.__prepare(__loadAnnotationsUsedNotOwned_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(annotationType);
            __os.writeLong(userID);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value)                  See above.
     **/
    public java.util.List<omero.model.IObject> end_loadAnnotationsUsedNotOwned(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __loadAnnotationsUsedNotOwned_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.IObject> __ret;
            __ret = IObjectListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     **/
    public boolean loadAnnotationsUsedNotOwned_async(AMI_IMetadata_loadAnnotationsUsedNotOwned __cb, String annotationType, long userID)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadAnnotationsUsedNotOwned_name);
            __r = begin_loadAnnotationsUsedNotOwned(annotationType, userID, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadAnnotationsUsedNotOwned_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadAnnotationsUsedNotOwned_async(AMI_IMetadata_loadAnnotationsUsedNotOwned __cb, String annotationType, long userID, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadAnnotationsUsedNotOwned_name);
            __r = begin_loadAnnotationsUsedNotOwned(annotationType, userID, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadAnnotationsUsedNotOwned_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __loadChannelAcquisitionData_name = "loadChannelAcquisitionData";

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     * @return The collection of loaded logical channels.
     **/
    public java.util.List<omero.model.LogicalChannel> loadChannelAcquisitionData(java.util.List<Long> ids)
        throws omero.ServerError
    {
        return loadChannelAcquisitionData(ids, null, false);
    }

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     * @param __ctx The Context map to send with the invocation.
     * @return The collection of loaded logical channels.
     **/
    public java.util.List<omero.model.LogicalChannel> loadChannelAcquisitionData(java.util.List<Long> ids, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return loadChannelAcquisitionData(ids, __ctx, true);
    }

    private java.util.List<omero.model.LogicalChannel> loadChannelAcquisitionData(java.util.List<Long> ids, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "loadChannelAcquisitionData", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("loadChannelAcquisitionData");
                    __delBase = __getDelegate(false);
                    _IMetadataDel __del = (_IMetadataDel)__delBase;
                    return __del.loadChannelAcquisitionData(ids, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     **/
    public Ice.AsyncResult begin_loadChannelAcquisitionData(java.util.List<Long> ids)
    {
        return begin_loadChannelAcquisitionData(ids, null, false, null);
    }

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadChannelAcquisitionData(java.util.List<Long> ids, java.util.Map<String, String> __ctx)
    {
        return begin_loadChannelAcquisitionData(ids, __ctx, true, null);
    }

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     **/
    public Ice.AsyncResult begin_loadChannelAcquisitionData(java.util.List<Long> ids, Ice.Callback __cb)
    {
        return begin_loadChannelAcquisitionData(ids, null, false, __cb);
    }

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadChannelAcquisitionData(java.util.List<Long> ids, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_loadChannelAcquisitionData(ids, __ctx, true, __cb);
    }

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     **/
    public Ice.AsyncResult begin_loadChannelAcquisitionData(java.util.List<Long> ids, Callback_IMetadata_loadChannelAcquisitionData __cb)
    {
        return begin_loadChannelAcquisitionData(ids, null, false, __cb);
    }

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadChannelAcquisitionData(java.util.List<Long> ids, java.util.Map<String, String> __ctx, Callback_IMetadata_loadChannelAcquisitionData __cb)
    {
        return begin_loadChannelAcquisitionData(ids, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_loadChannelAcquisitionData(java.util.List<Long> ids, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__loadChannelAcquisitionData_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __loadChannelAcquisitionData_name, __cb);
        try
        {
            __result.__prepare(__loadChannelAcquisitionData_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.sys.LongListHelper.write(__os, ids);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) The collection of loaded logical channels.
     **/
    public java.util.List<omero.model.LogicalChannel> end_loadChannelAcquisitionData(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __loadChannelAcquisitionData_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.LogicalChannel> __ret;
            __ret = LogicalChannelListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     **/
    public boolean loadChannelAcquisitionData_async(AMI_IMetadata_loadChannelAcquisitionData __cb, java.util.List<Long> ids)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadChannelAcquisitionData_name);
            __r = begin_loadChannelAcquisitionData(ids, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadChannelAcquisitionData_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadChannelAcquisitionData_async(AMI_IMetadata_loadChannelAcquisitionData __cb, java.util.List<Long> ids, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadChannelAcquisitionData_name);
            __r = begin_loadChannelAcquisitionData(ids, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadChannelAcquisitionData_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __loadInstrument_name = "loadInstrument";

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param id    The id of the instrument to load.
     * @return      See above
     **/
    public omero.model.Instrument loadInstrument(long id)
        throws omero.ServerError
    {
        return loadInstrument(id, null, false);
    }

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param id    The id of the instrument to load.
     * @param __ctx The Context map to send with the invocation.
     * @return      See above
     **/
    public omero.model.Instrument loadInstrument(long id, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return loadInstrument(id, __ctx, true);
    }

    private omero.model.Instrument loadInstrument(long id, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "loadInstrument", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("loadInstrument");
                    __delBase = __getDelegate(false);
                    _IMetadataDel __del = (_IMetadataDel)__delBase;
                    return __del.loadInstrument(id, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param __cb The callback object for the operation.
     * @param id    The id of the instrument to load.
     **/
    public Ice.AsyncResult begin_loadInstrument(long id)
    {
        return begin_loadInstrument(id, null, false, null);
    }

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param __cb The callback object for the operation.
     * @param id    The id of the instrument to load.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadInstrument(long id, java.util.Map<String, String> __ctx)
    {
        return begin_loadInstrument(id, __ctx, true, null);
    }

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param __cb The callback object for the operation.
     * @param id    The id of the instrument to load.
     **/
    public Ice.AsyncResult begin_loadInstrument(long id, Ice.Callback __cb)
    {
        return begin_loadInstrument(id, null, false, __cb);
    }

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param __cb The callback object for the operation.
     * @param id    The id of the instrument to load.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadInstrument(long id, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_loadInstrument(id, __ctx, true, __cb);
    }

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param __cb The callback object for the operation.
     * @param id    The id of the instrument to load.
     **/
    public Ice.AsyncResult begin_loadInstrument(long id, Callback_IMetadata_loadInstrument __cb)
    {
        return begin_loadInstrument(id, null, false, __cb);
    }

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param __cb The callback object for the operation.
     * @param id    The id of the instrument to load.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadInstrument(long id, java.util.Map<String, String> __ctx, Callback_IMetadata_loadInstrument __cb)
    {
        return begin_loadInstrument(id, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_loadInstrument(long id, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__loadInstrument_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __loadInstrument_name, __cb);
        try
        {
            __result.__prepare(__loadInstrument_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(id);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value)      See above
     **/
    public omero.model.Instrument end_loadInstrument(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __loadInstrument_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.InstrumentHolder __ret = new omero.model.InstrumentHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param __cb The callback object for the operation.
     * @param id    The id of the instrument to load.
     **/
    public boolean loadInstrument_async(AMI_IMetadata_loadInstrument __cb, long id)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadInstrument_name);
            __r = begin_loadInstrument(id, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadInstrument_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param __cb The callback object for the operation.
     * @param id    The id of the instrument to load.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadInstrument_async(AMI_IMetadata_loadInstrument __cb, long id, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadInstrument_name);
            __r = begin_loadInstrument(id, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadInstrument_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __loadLogFiles_name = "loadLogFiles";

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param rootNodeType
     * the root node type, may be {@link omero.model.Image}
     * or {@link omero.model.Fileset}
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     * @return the original file IDs of the import logs
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> loadLogFiles(String rootType, java.util.List<Long> ids)
        throws omero.ServerError
    {
        return loadLogFiles(rootType, ids, null, false);
    }

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param rootNodeType
     * the root node type, may be {@link omero.model.Image}
     * or {@link omero.model.Fileset}
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     * @param __ctx The Context map to send with the invocation.
     * @return the original file IDs of the import logs
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> loadLogFiles(String rootType, java.util.List<Long> ids, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return loadLogFiles(rootType, ids, __ctx, true);
    }

    private java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> loadLogFiles(String rootType, java.util.List<Long> ids, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "loadLogFiles", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("loadLogFiles");
                    __delBase = __getDelegate(false);
                    _IMetadataDel __del = (_IMetadataDel)__delBase;
                    return __del.loadLogFiles(rootType, ids, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param __cb The callback object for the operation.
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     **/
    public Ice.AsyncResult begin_loadLogFiles(String rootType, java.util.List<Long> ids)
    {
        return begin_loadLogFiles(rootType, ids, null, false, null);
    }

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param __cb The callback object for the operation.
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadLogFiles(String rootType, java.util.List<Long> ids, java.util.Map<String, String> __ctx)
    {
        return begin_loadLogFiles(rootType, ids, __ctx, true, null);
    }

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param __cb The callback object for the operation.
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     **/
    public Ice.AsyncResult begin_loadLogFiles(String rootType, java.util.List<Long> ids, Ice.Callback __cb)
    {
        return begin_loadLogFiles(rootType, ids, null, false, __cb);
    }

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param __cb The callback object for the operation.
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadLogFiles(String rootType, java.util.List<Long> ids, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_loadLogFiles(rootType, ids, __ctx, true, __cb);
    }

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param __cb The callback object for the operation.
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     **/
    public Ice.AsyncResult begin_loadLogFiles(String rootType, java.util.List<Long> ids, Callback_IMetadata_loadLogFiles __cb)
    {
        return begin_loadLogFiles(rootType, ids, null, false, __cb);
    }

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param __cb The callback object for the operation.
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadLogFiles(String rootType, java.util.List<Long> ids, java.util.Map<String, String> __ctx, Callback_IMetadata_loadLogFiles __cb)
    {
        return begin_loadLogFiles(rootType, ids, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_loadLogFiles(String rootType, java.util.List<Long> ids, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__loadLogFiles_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __loadLogFiles_name, __cb);
        try
        {
            __result.__prepare(__loadLogFiles_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(rootType);
            omero.sys.LongListHelper.write(__os, ids);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) the original file IDs of the import logs
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> end_loadLogFiles(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __loadLogFiles_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> __ret;
            __ret = LongIObjectListMapHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param __cb The callback object for the operation.
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     **/
    public boolean loadLogFiles_async(AMI_IMetadata_loadLogFiles __cb, String rootType, java.util.List<Long> ids)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadLogFiles_name);
            __r = begin_loadLogFiles(rootType, ids, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadLogFiles_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param __cb The callback object for the operation.
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadLogFiles_async(AMI_IMetadata_loadLogFiles __cb, String rootType, java.util.List<Long> ids, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadLogFiles_name);
            __r = begin_loadLogFiles(rootType, ids, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadLogFiles_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __loadSpecifiedAnnotations_name = "loadSpecifiedAnnotations";

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param annotationType The type of annotations to load.
     * @param include
     * Include the annotations with the specified name spaces.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     * @return          A collection of found annotations.
     **/
    public java.util.List<omero.model.Annotation> loadSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options)
        throws omero.ServerError
    {
        return loadSpecifiedAnnotations(annotationType, include, exclude, options, null, false);
    }

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param annotationType The type of annotations to load.
     * @param include
     * Include the annotations with the specified name spaces.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @return          A collection of found annotations.
     **/
    public java.util.List<omero.model.Annotation> loadSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return loadSpecifiedAnnotations(annotationType, include, exclude, options, __ctx, true);
    }

    private java.util.List<omero.model.Annotation> loadSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "loadSpecifiedAnnotations", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("loadSpecifiedAnnotations");
                    __delBase = __getDelegate(false);
                    _IMetadataDel __del = (_IMetadataDel)__delBase;
                    return __del.loadSpecifiedAnnotations(annotationType, include, exclude, options, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options)
    {
        return begin_loadSpecifiedAnnotations(annotationType, include, exclude, options, null, false, null);
    }

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
    {
        return begin_loadSpecifiedAnnotations(annotationType, include, exclude, options, __ctx, true, null);
    }

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, Ice.Callback __cb)
    {
        return begin_loadSpecifiedAnnotations(annotationType, include, exclude, options, null, false, __cb);
    }

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_loadSpecifiedAnnotations(annotationType, include, exclude, options, __ctx, true, __cb);
    }

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, Callback_IMetadata_loadSpecifiedAnnotations __cb)
    {
        return begin_loadSpecifiedAnnotations(annotationType, include, exclude, options, null, false, __cb);
    }

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Callback_IMetadata_loadSpecifiedAnnotations __cb)
    {
        return begin_loadSpecifiedAnnotations(annotationType, include, exclude, options, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_loadSpecifiedAnnotations(String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__loadSpecifiedAnnotations_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __loadSpecifiedAnnotations_name, __cb);
        try
        {
            __result.__prepare(__loadSpecifiedAnnotations_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(annotationType);
            StringSetHelper.write(__os, include);
            StringSetHelper.write(__os, exclude);
            __os.writeObject(options);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value)          A collection of found annotations.
     **/
    public java.util.List<omero.model.Annotation> end_loadSpecifiedAnnotations(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __loadSpecifiedAnnotations_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.Annotation> __ret;
            __ret = AnnotationListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     **/
    public boolean loadSpecifiedAnnotations_async(AMI_IMetadata_loadSpecifiedAnnotations __cb, String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadSpecifiedAnnotations_name);
            __r = begin_loadSpecifiedAnnotations(annotationType, include, exclude, options, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadSpecifiedAnnotations_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadSpecifiedAnnotations_async(AMI_IMetadata_loadSpecifiedAnnotations __cb, String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadSpecifiedAnnotations_name);
            __r = begin_loadSpecifiedAnnotations(annotationType, include, exclude, options, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadSpecifiedAnnotations_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __loadSpecifiedAnnotationsLinkedTo_name = "loadSpecifiedAnnotationsLinkedTo";

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param annotationType  The type of annotations to load.
     * @param include
     * Include the annotations with the specified name spaces.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     * @param options       The POJO options.
     * @return              A collection of found annotations.
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.Annotation>> loadSpecifiedAnnotationsLinkedTo(String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options)
        throws omero.ServerError
    {
        return loadSpecifiedAnnotationsLinkedTo(annotationType, include, exclude, rootNodeType, rootNodeIds, options, null, false);
    }

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param annotationType  The type of annotations to load.
     * @param include
     * Include the annotations with the specified name spaces.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     * @param options       The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @return              A collection of found annotations.
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.Annotation>> loadSpecifiedAnnotationsLinkedTo(String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return loadSpecifiedAnnotationsLinkedTo(annotationType, include, exclude, rootNodeType, rootNodeIds, options, __ctx, true);
    }

    private java.util.Map<java.lang.Long, java.util.List<omero.model.Annotation>> loadSpecifiedAnnotationsLinkedTo(String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "loadSpecifiedAnnotationsLinkedTo", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("loadSpecifiedAnnotationsLinkedTo");
                    __delBase = __getDelegate(false);
                    _IMetadataDel __del = (_IMetadataDel)__delBase;
                    return __del.loadSpecifiedAnnotationsLinkedTo(annotationType, include, exclude, rootNodeType, rootNodeIds, options, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType  The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotationsLinkedTo(String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options)
    {
        return begin_loadSpecifiedAnnotationsLinkedTo(annotationType, include, exclude, rootNodeType, rootNodeIds, options, null, false, null);
    }

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType  The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotationsLinkedTo(String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
    {
        return begin_loadSpecifiedAnnotationsLinkedTo(annotationType, include, exclude, rootNodeType, rootNodeIds, options, __ctx, true, null);
    }

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType  The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotationsLinkedTo(String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options, Ice.Callback __cb)
    {
        return begin_loadSpecifiedAnnotationsLinkedTo(annotationType, include, exclude, rootNodeType, rootNodeIds, options, null, false, __cb);
    }

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType  The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotationsLinkedTo(String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_loadSpecifiedAnnotationsLinkedTo(annotationType, include, exclude, rootNodeType, rootNodeIds, options, __ctx, true, __cb);
    }

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType  The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotationsLinkedTo(String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options, Callback_IMetadata_loadSpecifiedAnnotationsLinkedTo __cb)
    {
        return begin_loadSpecifiedAnnotationsLinkedTo(annotationType, include, exclude, rootNodeType, rootNodeIds, options, null, false, __cb);
    }

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType  The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadSpecifiedAnnotationsLinkedTo(String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Callback_IMetadata_loadSpecifiedAnnotationsLinkedTo __cb)
    {
        return begin_loadSpecifiedAnnotationsLinkedTo(annotationType, include, exclude, rootNodeType, rootNodeIds, options, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_loadSpecifiedAnnotationsLinkedTo(String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__loadSpecifiedAnnotationsLinkedTo_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __loadSpecifiedAnnotationsLinkedTo_name, __cb);
        try
        {
            __result.__prepare(__loadSpecifiedAnnotationsLinkedTo_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(annotationType);
            StringSetHelper.write(__os, include);
            StringSetHelper.write(__os, exclude);
            __os.writeString(rootNodeType);
            omero.sys.LongListHelper.write(__os, rootNodeIds);
            __os.writeObject(options);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value)              A collection of found annotations.
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.Annotation>> end_loadSpecifiedAnnotationsLinkedTo(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __loadSpecifiedAnnotationsLinkedTo_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.Long, java.util.List<omero.model.Annotation>> __ret;
            __ret = LongAnnotationListMapHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType  The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     **/
    public boolean loadSpecifiedAnnotationsLinkedTo_async(AMI_IMetadata_loadSpecifiedAnnotationsLinkedTo __cb, String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadSpecifiedAnnotationsLinkedTo_name);
            __r = begin_loadSpecifiedAnnotationsLinkedTo(annotationType, include, exclude, rootNodeType, rootNodeIds, options, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadSpecifiedAnnotationsLinkedTo_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType  The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadSpecifiedAnnotationsLinkedTo_async(AMI_IMetadata_loadSpecifiedAnnotationsLinkedTo __cb, String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadSpecifiedAnnotationsLinkedTo_name);
            __r = begin_loadSpecifiedAnnotationsLinkedTo(annotationType, include, exclude, rootNodeType, rootNodeIds, options, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadSpecifiedAnnotationsLinkedTo_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __loadTagContent_name = "loadTagContent";

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param ids The id of the tag to load or <code>-1</code>.
     * @return Map whose key is a <code>Tag/TagSet</code> and the
     * value either a Map or a list of related
     * <code>DataObject</code>.
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> loadTagContent(java.util.List<Long> ids, omero.sys.Parameters options)
        throws omero.ServerError
    {
        return loadTagContent(ids, options, null, false);
    }

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param ids The id of the tag to load or <code>-1</code>.
     * @param __ctx The Context map to send with the invocation.
     * @return Map whose key is a <code>Tag/TagSet</code> and the
     * value either a Map or a list of related
     * <code>DataObject</code>.
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> loadTagContent(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return loadTagContent(ids, options, __ctx, true);
    }

    private java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> loadTagContent(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "loadTagContent", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("loadTagContent");
                    __delBase = __getDelegate(false);
                    _IMetadataDel __del = (_IMetadataDel)__delBase;
                    return __del.loadTagContent(ids, options, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The id of the tag to load or <code>-1</code>.
     **/
    public Ice.AsyncResult begin_loadTagContent(java.util.List<Long> ids, omero.sys.Parameters options)
    {
        return begin_loadTagContent(ids, options, null, false, null);
    }

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The id of the tag to load or <code>-1</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadTagContent(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
    {
        return begin_loadTagContent(ids, options, __ctx, true, null);
    }

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The id of the tag to load or <code>-1</code>.
     **/
    public Ice.AsyncResult begin_loadTagContent(java.util.List<Long> ids, omero.sys.Parameters options, Ice.Callback __cb)
    {
        return begin_loadTagContent(ids, options, null, false, __cb);
    }

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The id of the tag to load or <code>-1</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadTagContent(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_loadTagContent(ids, options, __ctx, true, __cb);
    }

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The id of the tag to load or <code>-1</code>.
     **/
    public Ice.AsyncResult begin_loadTagContent(java.util.List<Long> ids, omero.sys.Parameters options, Callback_IMetadata_loadTagContent __cb)
    {
        return begin_loadTagContent(ids, options, null, false, __cb);
    }

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The id of the tag to load or <code>-1</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadTagContent(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx, Callback_IMetadata_loadTagContent __cb)
    {
        return begin_loadTagContent(ids, options, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_loadTagContent(java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__loadTagContent_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __loadTagContent_name, __cb);
        try
        {
            __result.__prepare(__loadTagContent_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.sys.LongListHelper.write(__os, ids);
            __os.writeObject(options);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Map whose key is a <code>Tag/TagSet</code> and the
     * value either a Map or a list of related
     * <code>DataObject</code>.
     **/
    public java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> end_loadTagContent(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __loadTagContent_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.Long, java.util.List<omero.model.IObject>> __ret;
            __ret = LongIObjectListMapHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The id of the tag to load or <code>-1</code>.
     **/
    public boolean loadTagContent_async(AMI_IMetadata_loadTagContent __cb, java.util.List<Long> ids, omero.sys.Parameters options)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadTagContent_name);
            __r = begin_loadTagContent(ids, options, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadTagContent_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The id of the tag to load or <code>-1</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadTagContent_async(AMI_IMetadata_loadTagContent __cb, java.util.List<Long> ids, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadTagContent_name);
            __r = begin_loadTagContent(ids, options, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadTagContent_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __loadTagSets_name = "loadTagSets";

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param options The POJO options.
     * @return See above.
     **/
    public java.util.List<omero.model.IObject> loadTagSets(omero.sys.Parameters options)
        throws omero.ServerError
    {
        return loadTagSets(options, null, false);
    }

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param options The POJO options.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public java.util.List<omero.model.IObject> loadTagSets(omero.sys.Parameters options, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return loadTagSets(options, __ctx, true);
    }

    private java.util.List<omero.model.IObject> loadTagSets(omero.sys.Parameters options, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "loadTagSets", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("loadTagSets");
                    __delBase = __getDelegate(false);
                    _IMetadataDel __del = (_IMetadataDel)__delBase;
                    return __del.loadTagSets(options, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param __cb The callback object for the operation.
     * @param options The POJO options.
     **/
    public Ice.AsyncResult begin_loadTagSets(omero.sys.Parameters options)
    {
        return begin_loadTagSets(options, null, false, null);
    }

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param __cb The callback object for the operation.
     * @param options The POJO options.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadTagSets(omero.sys.Parameters options, java.util.Map<String, String> __ctx)
    {
        return begin_loadTagSets(options, __ctx, true, null);
    }

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param __cb The callback object for the operation.
     * @param options The POJO options.
     **/
    public Ice.AsyncResult begin_loadTagSets(omero.sys.Parameters options, Ice.Callback __cb)
    {
        return begin_loadTagSets(options, null, false, __cb);
    }

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param __cb The callback object for the operation.
     * @param options The POJO options.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadTagSets(omero.sys.Parameters options, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_loadTagSets(options, __ctx, true, __cb);
    }

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param __cb The callback object for the operation.
     * @param options The POJO options.
     **/
    public Ice.AsyncResult begin_loadTagSets(omero.sys.Parameters options, Callback_IMetadata_loadTagSets __cb)
    {
        return begin_loadTagSets(options, null, false, __cb);
    }

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param __cb The callback object for the operation.
     * @param options The POJO options.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadTagSets(omero.sys.Parameters options, java.util.Map<String, String> __ctx, Callback_IMetadata_loadTagSets __cb)
    {
        return begin_loadTagSets(options, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_loadTagSets(omero.sys.Parameters options, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__loadTagSets_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __loadTagSets_name, __cb);
        try
        {
            __result.__prepare(__loadTagSets_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(options);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) See above.
     **/
    public java.util.List<omero.model.IObject> end_loadTagSets(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __loadTagSets_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.IObject> __ret;
            __ret = IObjectListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param __cb The callback object for the operation.
     * @param options The POJO options.
     **/
    public boolean loadTagSets_async(AMI_IMetadata_loadTagSets __cb, omero.sys.Parameters options)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadTagSets_name);
            __r = begin_loadTagSets(options, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadTagSets_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param __cb The callback object for the operation.
     * @param options The POJO options.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadTagSets_async(AMI_IMetadata_loadTagSets __cb, omero.sys.Parameters options, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadTagSets_name);
            __r = begin_loadTagSets(options, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadTagSets_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static IMetadataPrx checkedCast(Ice.ObjectPrx __obj)
    {
        IMetadataPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IMetadataPrx)
            {
                __d = (IMetadataPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    IMetadataPrxHelper __h = new IMetadataPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static IMetadataPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        IMetadataPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IMetadataPrx)
            {
                __d = (IMetadataPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    IMetadataPrxHelper __h = new IMetadataPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static IMetadataPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        IMetadataPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    IMetadataPrxHelper __h = new IMetadataPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static IMetadataPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        IMetadataPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    IMetadataPrxHelper __h = new IMetadataPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static IMetadataPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        IMetadataPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IMetadataPrx)
            {
                __d = (IMetadataPrx)__obj;
            }
            else
            {
                IMetadataPrxHelper __h = new IMetadataPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static IMetadataPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        IMetadataPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            IMetadataPrxHelper __h = new IMetadataPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IMetadata",
        "::omero::api::ServiceInterface"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _IMetadataDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _IMetadataDelD();
    }

    public static void __write(IceInternal.BasicStream __os, IMetadataPrx v)
    {
        __os.writeProxy(v);
    }

    public static IMetadataPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            IMetadataPrxHelper result = new IMetadataPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
