// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IPixels.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Metadata gateway for the {@link omero.api.RenderingEngine} and
 * clients. This service provides all DB access that the rendering
 * engine needs as well as Pixels services to a client. It also allows
 * the rendering  engine to also be run external to the server (e.g.
 * client-side).
 * 
 **/
public interface IPixelsPrx extends ServiceInterfacePrx
{
    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @return Pixels object which matches <code>id</code>.
     **/
    public omero.model.Pixels retrievePixDescription(long pixId)
        throws omero.ServerError;

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     * @return Pixels object which matches <code>id</code>.
     **/
    public omero.model.Pixels retrievePixDescription(long pixId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrievePixDescription(long pixId);

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrievePixDescription(long pixId, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrievePixDescription(long pixId, Ice.Callback __cb);

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrievePixDescription(long pixId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrievePixDescription(long pixId, Callback_IPixels_retrievePixDescription __cb);

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrievePixDescription(long pixId, java.util.Map<String, String> __ctx, Callback_IPixels_retrievePixDescription __cb);

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param __result The asynchronous result object.
     * @return Pixels object which matches <code>id</code>.
     **/
    public omero.model.Pixels end_retrievePixDescription(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     **/
    public boolean retrievePixDescription_async(AMI_IPixels_retrievePixDescription __cb, long pixId);

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean retrievePixDescription_async(AMI_IPixels_retrievePixDescription __cb, long pixId, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @return Rendering definition.
     **/
    public omero.model.RenderingDef retrieveRndSettings(long pixId)
        throws omero.ServerError;

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     * @return Rendering definition.
     **/
    public omero.model.RenderingDef retrieveRndSettings(long pixId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrieveRndSettings(long pixId);

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrieveRndSettings(long pixId, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrieveRndSettings(long pixId, Ice.Callback __cb);

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrieveRndSettings(long pixId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrieveRndSettings(long pixId, Callback_IPixels_retrieveRndSettings __cb);

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrieveRndSettings(long pixId, java.util.Map<String, String> __ctx, Callback_IPixels_retrieveRndSettings __cb);

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __result The asynchronous result object.
     * @return Rendering definition.
     **/
    public omero.model.RenderingDef end_retrieveRndSettings(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     **/
    public boolean retrieveRndSettings_async(AMI_IPixels_retrieveRndSettings __cb, long pixId);

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean retrieveRndSettings_async(AMI_IPixels_retrieveRndSettings __cb, long pixId, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param userID  The id of the user.
     * @return Rendering definition.
     **/
    public omero.model.RenderingDef retrieveRndSettingsFor(long pixId, long userId)
        throws omero.ServerError;

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param userID  The id of the user.
     * @param __ctx The Context map to send with the invocation.
     * @return Rendering definition.
     **/
    public omero.model.RenderingDef retrieveRndSettingsFor(long pixId, long userId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrieveRndSettingsFor(long pixId, long userId);

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrieveRndSettingsFor(long pixId, long userId, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrieveRndSettingsFor(long pixId, long userId, Ice.Callback __cb);

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrieveRndSettingsFor(long pixId, long userId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrieveRndSettingsFor(long pixId, long userId, Callback_IPixels_retrieveRndSettingsFor __cb);

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrieveRndSettingsFor(long pixId, long userId, java.util.Map<String, String> __ctx, Callback_IPixels_retrieveRndSettingsFor __cb);

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __result The asynchronous result object.
     * @return Rendering definition.
     **/
    public omero.model.RenderingDef end_retrieveRndSettingsFor(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     **/
    public boolean retrieveRndSettingsFor_async(AMI_IPixels_retrieveRndSettingsFor __cb, long pixId, long userId);

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean retrieveRndSettingsFor_async(AMI_IPixels_retrieveRndSettingsFor __cb, long pixId, long userId, java.util.Map<String, String> __ctx);

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId    Pixels id.
     * @param userId   The id of the user.
     * @return Rendering definition.
     **/
    public java.util.List<omero.model.IObject> retrieveAllRndSettings(long pixId, long userId)
        throws omero.ServerError;

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId    Pixels id.
     * @param userId   The id of the user.
     * @param __ctx The Context map to send with the invocation.
     * @return Rendering definition.
     **/
    public java.util.List<omero.model.IObject> retrieveAllRndSettings(long pixId, long userId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId    Pixels id.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrieveAllRndSettings(long pixId, long userId);

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId    Pixels id.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrieveAllRndSettings(long pixId, long userId, java.util.Map<String, String> __ctx);

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId    Pixels id.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrieveAllRndSettings(long pixId, long userId, Ice.Callback __cb);

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId    Pixels id.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrieveAllRndSettings(long pixId, long userId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId    Pixels id.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrieveAllRndSettings(long pixId, long userId, Callback_IPixels_retrieveAllRndSettings __cb);

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId    Pixels id.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_retrieveAllRndSettings(long pixId, long userId, java.util.Map<String, String> __ctx, Callback_IPixels_retrieveAllRndSettings __cb);

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __result The asynchronous result object.
     * @return Rendering definition.
     **/
    public java.util.List<omero.model.IObject> end_retrieveAllRndSettings(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId    Pixels id.
     **/
    public boolean retrieveAllRndSettings_async(AMI_IPixels_retrieveAllRndSettings __cb, long pixId, long userId);

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId    Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean retrieveAllRndSettings_async(AMI_IPixels_retrieveAllRndSettings __cb, long pixId, long userId, java.util.Map<String, String> __ctx);

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param renderingSettingsId Rendering definition id.
     * @throws ValidationException If no <code>RenderingDef</code>
     * matches the ID <code>renderingDefId</code>.
     * @return Rendering definition.
     **/
    public omero.model.RenderingDef loadRndSettings(long renderingSettingsId)
        throws omero.ServerError;

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param renderingSettingsId Rendering definition id.
     * @throws ValidationException If no <code>RenderingDef</code>
     * matches the ID <code>renderingDefId</code>.
     * @param __ctx The Context map to send with the invocation.
     * @return Rendering definition.
     **/
    public omero.model.RenderingDef loadRndSettings(long renderingSettingsId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param renderingSettingsId Rendering definition id.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadRndSettings(long renderingSettingsId);

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param renderingSettingsId Rendering definition id.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadRndSettings(long renderingSettingsId, java.util.Map<String, String> __ctx);

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param renderingSettingsId Rendering definition id.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadRndSettings(long renderingSettingsId, Ice.Callback __cb);

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param renderingSettingsId Rendering definition id.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadRndSettings(long renderingSettingsId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param renderingSettingsId Rendering definition id.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadRndSettings(long renderingSettingsId, Callback_IPixels_loadRndSettings __cb);

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param renderingSettingsId Rendering definition id.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_loadRndSettings(long renderingSettingsId, java.util.Map<String, String> __ctx, Callback_IPixels_loadRndSettings __cb);

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __result The asynchronous result object.
     * @throws ValidationException If no <code>RenderingDef</code>
     * matches the ID <code>renderingDefId</code>.
     * @return Rendering definition.
     **/
    public omero.model.RenderingDef end_loadRndSettings(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param renderingSettingsId Rendering definition id.
     **/
    public boolean loadRndSettings_async(AMI_IPixels_loadRndSettings __cb, long renderingSettingsId);

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param renderingSettingsId Rendering definition id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadRndSettings_async(AMI_IPixels_loadRndSettings __cb, long renderingSettingsId, java.util.Map<String, String> __ctx);

    /**
     * Saves the specified rendering settings.
     * 
     * @param rndSettings Rendering settings.
     **/
    public void saveRndSettings(omero.model.RenderingDef rndSettings)
        throws omero.ServerError;

    /**
     * Saves the specified rendering settings.
     * 
     * @param rndSettings Rendering settings.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void saveRndSettings(omero.model.RenderingDef rndSettings, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Saves the specified rendering settings.
     * 
     * @param rndSettings Rendering settings.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_saveRndSettings(omero.model.RenderingDef rndSettings);

    /**
     * Saves the specified rendering settings.
     * 
     * @param rndSettings Rendering settings.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_saveRndSettings(omero.model.RenderingDef rndSettings, java.util.Map<String, String> __ctx);

    /**
     * Saves the specified rendering settings.
     * 
     * @param rndSettings Rendering settings.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_saveRndSettings(omero.model.RenderingDef rndSettings, Ice.Callback __cb);

    /**
     * Saves the specified rendering settings.
     * 
     * @param rndSettings Rendering settings.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_saveRndSettings(omero.model.RenderingDef rndSettings, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Saves the specified rendering settings.
     * 
     * @param rndSettings Rendering settings.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_saveRndSettings(omero.model.RenderingDef rndSettings, Callback_IPixels_saveRndSettings __cb);

    /**
     * Saves the specified rendering settings.
     * 
     * @param rndSettings Rendering settings.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_saveRndSettings(omero.model.RenderingDef rndSettings, java.util.Map<String, String> __ctx, Callback_IPixels_saveRndSettings __cb);

    /**
     * Saves the specified rendering settings.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_saveRndSettings(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Saves the specified rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param rndSettings Rendering settings.
     **/
    public boolean saveRndSettings_async(AMI_IPixels_saveRndSettings __cb, omero.model.RenderingDef rndSettings);

    /**
     * Saves the specified rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param rndSettings Rendering settings.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean saveRndSettings_async(AMI_IPixels_saveRndSettings __cb, omero.model.RenderingDef rndSettings, java.util.Map<String, String> __ctx);

    /**
     * Bit depth for a given pixel type.
     * 
     * @param type Pixels type.
     * @return Bit depth in bits.
     **/
    public int getBitDepth(omero.model.PixelsType type)
        throws omero.ServerError;

    /**
     * Bit depth for a given pixel type.
     * 
     * @param type Pixels type.
     * @param __ctx The Context map to send with the invocation.
     * @return Bit depth in bits.
     **/
    public int getBitDepth(omero.model.PixelsType type, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Bit depth for a given pixel type.
     * 
     * @param type Pixels type.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBitDepth(omero.model.PixelsType type);

    /**
     * Bit depth for a given pixel type.
     * 
     * @param type Pixels type.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBitDepth(omero.model.PixelsType type, java.util.Map<String, String> __ctx);

    /**
     * Bit depth for a given pixel type.
     * 
     * @param type Pixels type.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBitDepth(omero.model.PixelsType type, Ice.Callback __cb);

    /**
     * Bit depth for a given pixel type.
     * 
     * @param type Pixels type.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBitDepth(omero.model.PixelsType type, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Bit depth for a given pixel type.
     * 
     * @param type Pixels type.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBitDepth(omero.model.PixelsType type, Callback_IPixels_getBitDepth __cb);

    /**
     * Bit depth for a given pixel type.
     * 
     * @param type Pixels type.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBitDepth(omero.model.PixelsType type, java.util.Map<String, String> __ctx, Callback_IPixels_getBitDepth __cb);

    /**
     * Bit depth for a given pixel type.
     * 
     * @param __result The asynchronous result object.
     * @return Bit depth in bits.
     **/
    public int end_getBitDepth(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Bit depth for a given pixel type.
     * 
     * @param __cb The callback object for the operation.
     * @param type Pixels type.
     **/
    public boolean getBitDepth_async(AMI_IPixels_getBitDepth __cb, omero.model.PixelsType type);

    /**
     * Bit depth for a given pixel type.
     * 
     * @param __cb The callback object for the operation.
     * @param type Pixels type.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getBitDepth_async(AMI_IPixels_getBitDepth __cb, omero.model.PixelsType type, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param enumClass Enumeration class.
     * @param value Enumeration string value.
     * @return Enumeration object.
     * @deprecated This operation has been deprecated.
     **/
    public omero.model.IObject getEnumeration(String enumClass, String value)
        throws omero.ServerError;

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param enumClass Enumeration class.
     * @param value Enumeration string value.
     * @param __ctx The Context map to send with the invocation.
     * @return Enumeration object.
     * @deprecated This operation has been deprecated.
     **/
    public omero.model.IObject getEnumeration(String enumClass, String value, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param enumClass Enumeration class.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getEnumeration(String enumClass, String value);

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param enumClass Enumeration class.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getEnumeration(String enumClass, String value, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param enumClass Enumeration class.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getEnumeration(String enumClass, String value, Ice.Callback __cb);

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param enumClass Enumeration class.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getEnumeration(String enumClass, String value, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param enumClass Enumeration class.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getEnumeration(String enumClass, String value, Callback_IPixels_getEnumeration __cb);

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param enumClass Enumeration class.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getEnumeration(String enumClass, String value, java.util.Map<String, String> __ctx, Callback_IPixels_getEnumeration __cb);

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param __result The asynchronous result object.
     * @return Enumeration object.
     **/
    public omero.model.IObject end_getEnumeration(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @deprecated This operation has been deprecated.
     **/
    public boolean getEnumeration_async(AMI_IPixels_getEnumeration __cb, String enumClass, String value);

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean getEnumeration_async(AMI_IPixels_getEnumeration __cb, String enumClass, String value, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param enumClass Enumeration class.
     * @return List of all enumeration objects for the
     * <i>enumClass</i>.
     * @deprecated This operation has been deprecated.
     **/
    public java.util.List<omero.model.IObject> getAllEnumerations(String enumClass)
        throws omero.ServerError;

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param enumClass Enumeration class.
     * @param __ctx The Context map to send with the invocation.
     * @return List of all enumeration objects for the
     * <i>enumClass</i>.
     * @deprecated This operation has been deprecated.
     **/
    public java.util.List<omero.model.IObject> getAllEnumerations(String enumClass, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param enumClass Enumeration class.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getAllEnumerations(String enumClass);

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param enumClass Enumeration class.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getAllEnumerations(String enumClass, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param enumClass Enumeration class.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getAllEnumerations(String enumClass, Ice.Callback __cb);

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param enumClass Enumeration class.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getAllEnumerations(String enumClass, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param enumClass Enumeration class.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getAllEnumerations(String enumClass, Callback_IPixels_getAllEnumerations __cb);

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param enumClass Enumeration class.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getAllEnumerations(String enumClass, java.util.Map<String, String> __ctx, Callback_IPixels_getAllEnumerations __cb);

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param __result The asynchronous result object.
     * @return List of all enumeration objects for the
     * <i>enumClass</i>.
     **/
    public java.util.List<omero.model.IObject> end_getAllEnumerations(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @deprecated This operation has been deprecated.
     **/
    public boolean getAllEnumerations_async(AMI_IPixels_getAllEnumerations __cb, String enumClass);

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean getAllEnumerations_async(AMI_IPixels_getAllEnumerations __cb, String enumClass, java.util.Map<String, String> __ctx);

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param pixelsId The source Pixels set id.
     * @param sizeX The new size across the X-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @return Id of the new Pixels object on success or
     * <code>null</code> on failure.
     * @throws ValidationException If the X, Y, Z, T or
     * channelList dimensions are out of bounds or the
     * Pixels object corresponding to
     * <code>pixelsId</code> is unlocatable.
     **/
    public omero.RLong copyAndResizePixels(long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats)
        throws omero.ServerError;

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param pixelsId The source Pixels set id.
     * @param sizeX The new size across the X-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @param __ctx The Context map to send with the invocation.
     * @return Id of the new Pixels object on success or
     * <code>null</code> on failure.
     * @throws ValidationException If the X, Y, Z, T or
     * channelList dimensions are out of bounds or the
     * Pixels object corresponding to
     * <code>pixelsId</code> is unlocatable.
     **/
    public omero.RLong copyAndResizePixels(long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param pixelsId The source Pixels set id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_copyAndResizePixels(long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats);

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param pixelsId The source Pixels set id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_copyAndResizePixels(long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx);

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param pixelsId The source Pixels set id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_copyAndResizePixels(long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, Ice.Callback __cb);

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param pixelsId The source Pixels set id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_copyAndResizePixels(long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param pixelsId The source Pixels set id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_copyAndResizePixels(long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, Callback_IPixels_copyAndResizePixels __cb);

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param pixelsId The source Pixels set id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_copyAndResizePixels(long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx, Callback_IPixels_copyAndResizePixels __cb);

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __result The asynchronous result object.
     * @return Id of the new Pixels object on success or
     * <code>null</code> on failure.
     * @throws ValidationException If the X, Y, Z, T or
     * channelList dimensions are out of bounds or the
     * Pixels object corresponding to
     * <code>pixelsId</code> is unlocatable.
     **/
    public omero.RLong end_copyAndResizePixels(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     **/
    public boolean copyAndResizePixels_async(AMI_IPixels_copyAndResizePixels __cb, long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats);

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean copyAndResizePixels_async(AMI_IPixels_copyAndResizePixels __cb, long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx);

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param imageId The source Image id.
     * @param sizeX The new size across the X-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @return Id of the new Pixels object on success or
     * <code>null</code> on failure.
     * @throws ValidationException If the X, Y, Z, T or
     * channelList dimensions are out of bounds or the
     * Pixels object corresponding to
     * <code>pixelsId</code> is unlocatable.
     **/
    public omero.RLong copyAndResizeImage(long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats)
        throws omero.ServerError;

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param imageId The source Image id.
     * @param sizeX The new size across the X-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @param __ctx The Context map to send with the invocation.
     * @return Id of the new Pixels object on success or
     * <code>null</code> on failure.
     * @throws ValidationException If the X, Y, Z, T or
     * channelList dimensions are out of bounds or the
     * Pixels object corresponding to
     * <code>pixelsId</code> is unlocatable.
     **/
    public omero.RLong copyAndResizeImage(long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param imageId The source Image id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_copyAndResizeImage(long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats);

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param imageId The source Image id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_copyAndResizeImage(long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx);

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param imageId The source Image id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_copyAndResizeImage(long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, Ice.Callback __cb);

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param imageId The source Image id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_copyAndResizeImage(long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param imageId The source Image id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_copyAndResizeImage(long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, Callback_IPixels_copyAndResizeImage __cb);

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param imageId The source Image id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_copyAndResizeImage(long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx, Callback_IPixels_copyAndResizeImage __cb);

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __result The asynchronous result object.
     * @return Id of the new Pixels object on success or
     * <code>null</code> on failure.
     * @throws ValidationException If the X, Y, Z, T or
     * channelList dimensions are out of bounds or the
     * Pixels object corresponding to
     * <code>pixelsId</code> is unlocatable.
     **/
    public omero.RLong end_copyAndResizeImage(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The source Image id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     **/
    public boolean copyAndResizeImage_async(AMI_IPixels_copyAndResizeImage __cb, long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats);

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The source Image id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean copyAndResizeImage_async(AMI_IPixels_copyAndResizeImage __cb, long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx);

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param sizeX The new size across the X-axis.
     * @param sizeY The new size across the Y-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param sizeT The new number of timepoints.
     * @param pixelsType The pixelsType
     * @param name The name of the new Image.
     * @param description The description of the new Image.
     * @return Id of the new Image object on success or
     * <code>null</code> on failure.
     * @throws ValidationException If the channel list is
     * <code>null</code> or of size == 0.
     **/
    public omero.RLong createImage(int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description)
        throws omero.ServerError;

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param sizeX The new size across the X-axis.
     * @param sizeY The new size across the Y-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param sizeT The new number of timepoints.
     * @param pixelsType The pixelsType
     * @param name The name of the new Image.
     * @param description The description of the new Image.
     * @param __ctx The Context map to send with the invocation.
     * @return Id of the new Image object on success or
     * <code>null</code> on failure.
     * @throws ValidationException If the channel list is
     * <code>null</code> or of size == 0.
     **/
    public omero.RLong createImage(int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param sizeX The new size across the X-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param pixelsType The pixelsType
     * @param description The description of the new Image.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createImage(int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description);

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param sizeX The new size across the X-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param pixelsType The pixelsType
     * @param description The description of the new Image.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createImage(int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description, java.util.Map<String, String> __ctx);

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param sizeX The new size across the X-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param pixelsType The pixelsType
     * @param description The description of the new Image.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createImage(int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description, Ice.Callback __cb);

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param sizeX The new size across the X-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param pixelsType The pixelsType
     * @param description The description of the new Image.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createImage(int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param sizeX The new size across the X-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param pixelsType The pixelsType
     * @param description The description of the new Image.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createImage(int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description, Callback_IPixels_createImage __cb);

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param sizeX The new size across the X-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param pixelsType The pixelsType
     * @param description The description of the new Image.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createImage(int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description, java.util.Map<String, String> __ctx, Callback_IPixels_createImage __cb);

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param __result The asynchronous result object.
     * @return Id of the new Image object on success or
     * <code>null</code> on failure.
     * @throws ValidationException If the channel list is
     * <code>null</code> or of size == 0.
     **/
    public omero.RLong end_createImage(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX The new size across the X-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param pixelsType The pixelsType
     * @param description The description of the new Image.
     **/
    public boolean createImage_async(AMI_IPixels_createImage __cb, int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description);

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX The new size across the X-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param pixelsType The pixelsType
     * @param description The description of the new Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createImage_async(AMI_IPixels_createImage __cb, int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description, java.util.Map<String, String> __ctx);

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param pixelsId The source Pixels set id.
     * @param channelIndex The channel index within the Pixels set.
     * @param min The channel global minimum.
     * @param max The channel global maximum.
     **/
    public void setChannelGlobalMinMax(long pixelsId, int channelIndex, double min, double max)
        throws omero.ServerError;

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param pixelsId The source Pixels set id.
     * @param channelIndex The channel index within the Pixels set.
     * @param min The channel global minimum.
     * @param max The channel global maximum.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setChannelGlobalMinMax(long pixelsId, int channelIndex, double min, double max, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param pixelsId The source Pixels set id.
     * @param min The channel global minimum.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setChannelGlobalMinMax(long pixelsId, int channelIndex, double min, double max);

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param pixelsId The source Pixels set id.
     * @param min The channel global minimum.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setChannelGlobalMinMax(long pixelsId, int channelIndex, double min, double max, java.util.Map<String, String> __ctx);

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param pixelsId The source Pixels set id.
     * @param min The channel global minimum.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setChannelGlobalMinMax(long pixelsId, int channelIndex, double min, double max, Ice.Callback __cb);

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param pixelsId The source Pixels set id.
     * @param min The channel global minimum.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setChannelGlobalMinMax(long pixelsId, int channelIndex, double min, double max, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param pixelsId The source Pixels set id.
     * @param min The channel global minimum.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setChannelGlobalMinMax(long pixelsId, int channelIndex, double min, double max, Callback_IPixels_setChannelGlobalMinMax __cb);

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param pixelsId The source Pixels set id.
     * @param min The channel global minimum.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setChannelGlobalMinMax(long pixelsId, int channelIndex, double min, double max, java.util.Map<String, String> __ctx, Callback_IPixels_setChannelGlobalMinMax __cb);

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_setChannelGlobalMinMax(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param min The channel global minimum.
     **/
    public boolean setChannelGlobalMinMax_async(AMI_IPixels_setChannelGlobalMinMax __cb, long pixelsId, int channelIndex, double min, double max);

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param min The channel global minimum.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setChannelGlobalMinMax_async(AMI_IPixels_setChannelGlobalMinMax __cb, long pixelsId, int channelIndex, double min, double max, java.util.Map<String, String> __ctx);
}
