// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IPixels.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Metadata gateway for the {@link omero.api.RenderingEngine} and
 * clients. This service provides all DB access that the rendering
 * engine needs as well as Pixels services to a client. It also allows
 * the rendering  engine to also be run external to the server (e.g.
 * client-side).
 * 
 **/
public final class IPixelsPrxHelper extends Ice.ObjectPrxHelperBase implements IPixelsPrx
{
    private static final String __copyAndResizeImage_name = "copyAndResizeImage";

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param imageId The source Image id.
     * @param sizeX The new size across the X-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @return Id of the new Pixels object on success or
     * <code>null</code> on failure.
     * @throws ValidationException If the X, Y, Z, T or
     * channelList dimensions are out of bounds or the
     * Pixels object corresponding to
     * <code>pixelsId</code> is unlocatable.
     **/
    public omero.RLong copyAndResizeImage(long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats)
        throws omero.ServerError
    {
        return copyAndResizeImage(imageId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, null, false);
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param imageId The source Image id.
     * @param sizeX The new size across the X-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @param __ctx The Context map to send with the invocation.
     * @return Id of the new Pixels object on success or
     * <code>null</code> on failure.
     * @throws ValidationException If the X, Y, Z, T or
     * channelList dimensions are out of bounds or the
     * Pixels object corresponding to
     * <code>pixelsId</code> is unlocatable.
     **/
    public omero.RLong copyAndResizeImage(long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return copyAndResizeImage(imageId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, __ctx, true);
    }

    private omero.RLong copyAndResizeImage(long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "copyAndResizeImage", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("copyAndResizeImage");
                    __delBase = __getDelegate(false);
                    _IPixelsDel __del = (_IPixelsDel)__delBase;
                    return __del.copyAndResizeImage(imageId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The source Image id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     **/
    public Ice.AsyncResult begin_copyAndResizeImage(long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats)
    {
        return begin_copyAndResizeImage(imageId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, null, false, null);
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The source Image id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_copyAndResizeImage(long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx)
    {
        return begin_copyAndResizeImage(imageId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, __ctx, true, null);
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The source Image id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     **/
    public Ice.AsyncResult begin_copyAndResizeImage(long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, Ice.Callback __cb)
    {
        return begin_copyAndResizeImage(imageId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, null, false, __cb);
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The source Image id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_copyAndResizeImage(long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_copyAndResizeImage(imageId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, __ctx, true, __cb);
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The source Image id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     **/
    public Ice.AsyncResult begin_copyAndResizeImage(long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, Callback_IPixels_copyAndResizeImage __cb)
    {
        return begin_copyAndResizeImage(imageId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, null, false, __cb);
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The source Image id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_copyAndResizeImage(long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx, Callback_IPixels_copyAndResizeImage __cb)
    {
        return begin_copyAndResizeImage(imageId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_copyAndResizeImage(long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__copyAndResizeImage_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __copyAndResizeImage_name, __cb);
        try
        {
            __result.__prepare(__copyAndResizeImage_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(imageId);
            __os.writeObject(sizeX);
            __os.writeObject(sizeY);
            __os.writeObject(sizeZ);
            __os.writeObject(sizeT);
            omero.sys.IntListHelper.write(__os, channelList);
            __os.writeString(methodology);
            __os.writeBool(copyStats);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Id of the new Pixels object on success or
     * <code>null</code> on failure.
     **/
    public omero.RLong end_copyAndResizeImage(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __copyAndResizeImage_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.RLongHolder __ret = new omero.RLongHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The source Image id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     **/
    public boolean copyAndResizeImage_async(AMI_IPixels_copyAndResizeImage __cb, long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__copyAndResizeImage_name);
            __r = begin_copyAndResizeImage(imageId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __copyAndResizeImage_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The source Image id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean copyAndResizeImage_async(AMI_IPixels_copyAndResizeImage __cb, long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__copyAndResizeImage_name);
            __r = begin_copyAndResizeImage(imageId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __copyAndResizeImage_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __copyAndResizePixels_name = "copyAndResizePixels";

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param pixelsId The source Pixels set id.
     * @param sizeX The new size across the X-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @return Id of the new Pixels object on success or
     * <code>null</code> on failure.
     * @throws ValidationException If the X, Y, Z, T or
     * channelList dimensions are out of bounds or the
     * Pixels object corresponding to
     * <code>pixelsId</code> is unlocatable.
     **/
    public omero.RLong copyAndResizePixels(long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats)
        throws omero.ServerError
    {
        return copyAndResizePixels(pixelsId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, null, false);
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param pixelsId The source Pixels set id.
     * @param sizeX The new size across the X-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @param __ctx The Context map to send with the invocation.
     * @return Id of the new Pixels object on success or
     * <code>null</code> on failure.
     * @throws ValidationException If the X, Y, Z, T or
     * channelList dimensions are out of bounds or the
     * Pixels object corresponding to
     * <code>pixelsId</code> is unlocatable.
     **/
    public omero.RLong copyAndResizePixels(long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return copyAndResizePixels(pixelsId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, __ctx, true);
    }

    private omero.RLong copyAndResizePixels(long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "copyAndResizePixels", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("copyAndResizePixels");
                    __delBase = __getDelegate(false);
                    _IPixelsDel __del = (_IPixelsDel)__delBase;
                    return __del.copyAndResizePixels(pixelsId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     **/
    public Ice.AsyncResult begin_copyAndResizePixels(long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats)
    {
        return begin_copyAndResizePixels(pixelsId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, null, false, null);
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_copyAndResizePixels(long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx)
    {
        return begin_copyAndResizePixels(pixelsId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, __ctx, true, null);
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     **/
    public Ice.AsyncResult begin_copyAndResizePixels(long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, Ice.Callback __cb)
    {
        return begin_copyAndResizePixels(pixelsId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, null, false, __cb);
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_copyAndResizePixels(long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_copyAndResizePixels(pixelsId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, __ctx, true, __cb);
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     **/
    public Ice.AsyncResult begin_copyAndResizePixels(long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, Callback_IPixels_copyAndResizePixels __cb)
    {
        return begin_copyAndResizePixels(pixelsId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, null, false, __cb);
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_copyAndResizePixels(long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx, Callback_IPixels_copyAndResizePixels __cb)
    {
        return begin_copyAndResizePixels(pixelsId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_copyAndResizePixels(long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__copyAndResizePixels_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __copyAndResizePixels_name, __cb);
        try
        {
            __result.__prepare(__copyAndResizePixels_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(pixelsId);
            __os.writeObject(sizeX);
            __os.writeObject(sizeY);
            __os.writeObject(sizeZ);
            __os.writeObject(sizeT);
            omero.sys.IntListHelper.write(__os, channelList);
            __os.writeString(methodology);
            __os.writeBool(copyStats);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Id of the new Pixels object on success or
     * <code>null</code> on failure.
     **/
    public omero.RLong end_copyAndResizePixels(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __copyAndResizePixels_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.RLongHolder __ret = new omero.RLongHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     **/
    public boolean copyAndResizePixels_async(AMI_IPixels_copyAndResizePixels __cb, long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__copyAndResizePixels_name);
            __r = begin_copyAndResizePixels(pixelsId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __copyAndResizePixels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean copyAndResizePixels_async(AMI_IPixels_copyAndResizePixels __cb, long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__copyAndResizePixels_name);
            __r = begin_copyAndResizePixels(pixelsId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __copyAndResizePixels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __createImage_name = "createImage";

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param sizeX The new size across the X-axis.
     * @param sizeY The new size across the Y-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param sizeT The new number of timepoints.
     * @param pixelsType The pixelsType
     * @param name The name of the new Image.
     * @param description The description of the new Image.
     * @return Id of the new Image object on success or
     * <code>null</code> on failure.
     * @throws ValidationException If the channel list is
     * <code>null</code> or of size == 0.
     **/
    public omero.RLong createImage(int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description)
        throws omero.ServerError
    {
        return createImage(sizeX, sizeY, sizeZ, sizeT, channelList, pixelsType, name, description, null, false);
    }

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param sizeX The new size across the X-axis.
     * @param sizeY The new size across the Y-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param sizeT The new number of timepoints.
     * @param pixelsType The pixelsType
     * @param name The name of the new Image.
     * @param description The description of the new Image.
     * @param __ctx The Context map to send with the invocation.
     * @return Id of the new Image object on success or
     * <code>null</code> on failure.
     * @throws ValidationException If the channel list is
     * <code>null</code> or of size == 0.
     **/
    public omero.RLong createImage(int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return createImage(sizeX, sizeY, sizeZ, sizeT, channelList, pixelsType, name, description, __ctx, true);
    }

    private omero.RLong createImage(int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "createImage", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("createImage");
                    __delBase = __getDelegate(false);
                    _IPixelsDel __del = (_IPixelsDel)__delBase;
                    return __del.createImage(sizeX, sizeY, sizeZ, sizeT, channelList, pixelsType, name, description, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX The new size across the X-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param pixelsType The pixelsType
     * @param description The description of the new Image.
     **/
    public Ice.AsyncResult begin_createImage(int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description)
    {
        return begin_createImage(sizeX, sizeY, sizeZ, sizeT, channelList, pixelsType, name, description, null, false, null);
    }

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX The new size across the X-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param pixelsType The pixelsType
     * @param description The description of the new Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createImage(int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description, java.util.Map<String, String> __ctx)
    {
        return begin_createImage(sizeX, sizeY, sizeZ, sizeT, channelList, pixelsType, name, description, __ctx, true, null);
    }

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX The new size across the X-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param pixelsType The pixelsType
     * @param description The description of the new Image.
     **/
    public Ice.AsyncResult begin_createImage(int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description, Ice.Callback __cb)
    {
        return begin_createImage(sizeX, sizeY, sizeZ, sizeT, channelList, pixelsType, name, description, null, false, __cb);
    }

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX The new size across the X-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param pixelsType The pixelsType
     * @param description The description of the new Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createImage(int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_createImage(sizeX, sizeY, sizeZ, sizeT, channelList, pixelsType, name, description, __ctx, true, __cb);
    }

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX The new size across the X-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param pixelsType The pixelsType
     * @param description The description of the new Image.
     **/
    public Ice.AsyncResult begin_createImage(int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description, Callback_IPixels_createImage __cb)
    {
        return begin_createImage(sizeX, sizeY, sizeZ, sizeT, channelList, pixelsType, name, description, null, false, __cb);
    }

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX The new size across the X-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param pixelsType The pixelsType
     * @param description The description of the new Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createImage(int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description, java.util.Map<String, String> __ctx, Callback_IPixels_createImage __cb)
    {
        return begin_createImage(sizeX, sizeY, sizeZ, sizeT, channelList, pixelsType, name, description, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_createImage(int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__createImage_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __createImage_name, __cb);
        try
        {
            __result.__prepare(__createImage_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(sizeX);
            __os.writeInt(sizeY);
            __os.writeInt(sizeZ);
            __os.writeInt(sizeT);
            omero.sys.IntListHelper.write(__os, channelList);
            __os.writeObject(pixelsType);
            __os.writeString(name);
            __os.writeString(description);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Id of the new Image object on success or
     * <code>null</code> on failure.
     **/
    public omero.RLong end_createImage(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __createImage_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.RLongHolder __ret = new omero.RLongHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX The new size across the X-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param pixelsType The pixelsType
     * @param description The description of the new Image.
     **/
    public boolean createImage_async(AMI_IPixels_createImage __cb, int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createImage_name);
            __r = begin_createImage(sizeX, sizeY, sizeZ, sizeT, channelList, pixelsType, name, description, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createImage_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX The new size across the X-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param pixelsType The pixelsType
     * @param description The description of the new Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createImage_async(AMI_IPixels_createImage __cb, int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createImage_name);
            __r = begin_createImage(sizeX, sizeY, sizeZ, sizeT, channelList, pixelsType, name, description, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createImage_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getAllEnumerations_name = "getAllEnumerations";

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param enumClass Enumeration class.
     * @return List of all enumeration objects for the
     * <i>enumClass</i>.
     * @deprecated This operation has been deprecated.
     **/
    public java.util.List<omero.model.IObject> getAllEnumerations(String enumClass)
        throws omero.ServerError
    {
        return getAllEnumerations(enumClass, null, false);
    }

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param enumClass Enumeration class.
     * @param __ctx The Context map to send with the invocation.
     * @return List of all enumeration objects for the
     * <i>enumClass</i>.
     * @deprecated This operation has been deprecated.
     **/
    public java.util.List<omero.model.IObject> getAllEnumerations(String enumClass, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getAllEnumerations(enumClass, __ctx, true);
    }

    private java.util.List<omero.model.IObject> getAllEnumerations(String enumClass, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getAllEnumerations", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getAllEnumerations");
                    __delBase = __getDelegate(false);
                    _IPixelsDel __del = (_IPixelsDel)__delBase;
                    return __del.getAllEnumerations(enumClass, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getAllEnumerations(String enumClass)
    {
        return begin_getAllEnumerations(enumClass, null, false, null);
    }

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getAllEnumerations(String enumClass, java.util.Map<String, String> __ctx)
    {
        return begin_getAllEnumerations(enumClass, __ctx, true, null);
    }

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getAllEnumerations(String enumClass, Ice.Callback __cb)
    {
        return begin_getAllEnumerations(enumClass, null, false, __cb);
    }

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getAllEnumerations(String enumClass, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getAllEnumerations(enumClass, __ctx, true, __cb);
    }

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getAllEnumerations(String enumClass, Callback_IPixels_getAllEnumerations __cb)
    {
        return begin_getAllEnumerations(enumClass, null, false, __cb);
    }

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getAllEnumerations(String enumClass, java.util.Map<String, String> __ctx, Callback_IPixels_getAllEnumerations __cb)
    {
        return begin_getAllEnumerations(enumClass, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getAllEnumerations(String enumClass, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getAllEnumerations_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getAllEnumerations_name, __cb);
        try
        {
            __result.__prepare(__getAllEnumerations_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(enumClass);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) List of all enumeration objects for the
     * <i>enumClass</i>.
     **/
    public java.util.List<omero.model.IObject> end_getAllEnumerations(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getAllEnumerations_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.IObject> __ret;
            __ret = IObjectListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @deprecated This operation has been deprecated.
     **/
    public boolean getAllEnumerations_async(AMI_IPixels_getAllEnumerations __cb, String enumClass)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getAllEnumerations_name);
            __r = begin_getAllEnumerations(enumClass, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getAllEnumerations_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean getAllEnumerations_async(AMI_IPixels_getAllEnumerations __cb, String enumClass, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getAllEnumerations_name);
            __r = begin_getAllEnumerations(enumClass, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getAllEnumerations_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getBitDepth_name = "getBitDepth";

    /**
     * Bit depth for a given pixel type.
     * 
     * @param type Pixels type.
     * @return Bit depth in bits.
     **/
    public int getBitDepth(omero.model.PixelsType type)
        throws omero.ServerError
    {
        return getBitDepth(type, null, false);
    }

    /**
     * Bit depth for a given pixel type.
     * 
     * @param type Pixels type.
     * @param __ctx The Context map to send with the invocation.
     * @return Bit depth in bits.
     **/
    public int getBitDepth(omero.model.PixelsType type, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getBitDepth(type, __ctx, true);
    }

    private int getBitDepth(omero.model.PixelsType type, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getBitDepth", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getBitDepth");
                    __delBase = __getDelegate(false);
                    _IPixelsDel __del = (_IPixelsDel)__delBase;
                    return __del.getBitDepth(type, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Bit depth for a given pixel type.
     * 
     * @param __cb The callback object for the operation.
     * @param type Pixels type.
     **/
    public Ice.AsyncResult begin_getBitDepth(omero.model.PixelsType type)
    {
        return begin_getBitDepth(type, null, false, null);
    }

    /**
     * Bit depth for a given pixel type.
     * 
     * @param __cb The callback object for the operation.
     * @param type Pixels type.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getBitDepth(omero.model.PixelsType type, java.util.Map<String, String> __ctx)
    {
        return begin_getBitDepth(type, __ctx, true, null);
    }

    /**
     * Bit depth for a given pixel type.
     * 
     * @param __cb The callback object for the operation.
     * @param type Pixels type.
     **/
    public Ice.AsyncResult begin_getBitDepth(omero.model.PixelsType type, Ice.Callback __cb)
    {
        return begin_getBitDepth(type, null, false, __cb);
    }

    /**
     * Bit depth for a given pixel type.
     * 
     * @param __cb The callback object for the operation.
     * @param type Pixels type.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getBitDepth(omero.model.PixelsType type, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getBitDepth(type, __ctx, true, __cb);
    }

    /**
     * Bit depth for a given pixel type.
     * 
     * @param __cb The callback object for the operation.
     * @param type Pixels type.
     **/
    public Ice.AsyncResult begin_getBitDepth(omero.model.PixelsType type, Callback_IPixels_getBitDepth __cb)
    {
        return begin_getBitDepth(type, null, false, __cb);
    }

    /**
     * Bit depth for a given pixel type.
     * 
     * @param __cb The callback object for the operation.
     * @param type Pixels type.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getBitDepth(omero.model.PixelsType type, java.util.Map<String, String> __ctx, Callback_IPixels_getBitDepth __cb)
    {
        return begin_getBitDepth(type, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getBitDepth(omero.model.PixelsType type, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getBitDepth_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getBitDepth_name, __cb);
        try
        {
            __result.__prepare(__getBitDepth_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(type);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Bit depth in bits.
     **/
    public int end_getBitDepth(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getBitDepth_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int __ret;
            __ret = __is.readInt();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Bit depth for a given pixel type.
     * 
     * @param __cb The callback object for the operation.
     * @param type Pixels type.
     **/
    public boolean getBitDepth_async(AMI_IPixels_getBitDepth __cb, omero.model.PixelsType type)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getBitDepth_name);
            __r = begin_getBitDepth(type, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getBitDepth_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Bit depth for a given pixel type.
     * 
     * @param __cb The callback object for the operation.
     * @param type Pixels type.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getBitDepth_async(AMI_IPixels_getBitDepth __cb, omero.model.PixelsType type, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getBitDepth_name);
            __r = begin_getBitDepth(type, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getBitDepth_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getEnumeration_name = "getEnumeration";

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param enumClass Enumeration class.
     * @param value Enumeration string value.
     * @return Enumeration object.
     * @deprecated This operation has been deprecated.
     **/
    public omero.model.IObject getEnumeration(String enumClass, String value)
        throws omero.ServerError
    {
        return getEnumeration(enumClass, value, null, false);
    }

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param enumClass Enumeration class.
     * @param value Enumeration string value.
     * @param __ctx The Context map to send with the invocation.
     * @return Enumeration object.
     * @deprecated This operation has been deprecated.
     **/
    public omero.model.IObject getEnumeration(String enumClass, String value, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getEnumeration(enumClass, value, __ctx, true);
    }

    private omero.model.IObject getEnumeration(String enumClass, String value, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getEnumeration", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getEnumeration");
                    __delBase = __getDelegate(false);
                    _IPixelsDel __del = (_IPixelsDel)__delBase;
                    return __del.getEnumeration(enumClass, value, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getEnumeration(String enumClass, String value)
    {
        return begin_getEnumeration(enumClass, value, null, false, null);
    }

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getEnumeration(String enumClass, String value, java.util.Map<String, String> __ctx)
    {
        return begin_getEnumeration(enumClass, value, __ctx, true, null);
    }

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getEnumeration(String enumClass, String value, Ice.Callback __cb)
    {
        return begin_getEnumeration(enumClass, value, null, false, __cb);
    }

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getEnumeration(String enumClass, String value, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getEnumeration(enumClass, value, __ctx, true, __cb);
    }

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getEnumeration(String enumClass, String value, Callback_IPixels_getEnumeration __cb)
    {
        return begin_getEnumeration(enumClass, value, null, false, __cb);
    }

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_getEnumeration(String enumClass, String value, java.util.Map<String, String> __ctx, Callback_IPixels_getEnumeration __cb)
    {
        return begin_getEnumeration(enumClass, value, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getEnumeration(String enumClass, String value, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getEnumeration_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getEnumeration_name, __cb);
        try
        {
            __result.__prepare(__getEnumeration_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(enumClass);
            __os.writeString(value);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Enumeration object.
     **/
    public omero.model.IObject end_getEnumeration(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getEnumeration_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.IObjectHolder __ret = new omero.model.IObjectHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @deprecated This operation has been deprecated.
     **/
    public boolean getEnumeration_async(AMI_IPixels_getEnumeration __cb, String enumClass, String value)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getEnumeration_name);
            __r = begin_getEnumeration(enumClass, value, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getEnumeration_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean getEnumeration_async(AMI_IPixels_getEnumeration __cb, String enumClass, String value, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getEnumeration_name);
            __r = begin_getEnumeration(enumClass, value, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getEnumeration_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __loadRndSettings_name = "loadRndSettings";

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param renderingSettingsId Rendering definition id.
     * @throws ValidationException If no <code>RenderingDef</code>
     * matches the ID <code>renderingDefId</code>.
     * @return Rendering definition.
     **/
    public omero.model.RenderingDef loadRndSettings(long renderingSettingsId)
        throws omero.ServerError
    {
        return loadRndSettings(renderingSettingsId, null, false);
    }

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param renderingSettingsId Rendering definition id.
     * @throws ValidationException If no <code>RenderingDef</code>
     * matches the ID <code>renderingDefId</code>.
     * @param __ctx The Context map to send with the invocation.
     * @return Rendering definition.
     **/
    public omero.model.RenderingDef loadRndSettings(long renderingSettingsId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return loadRndSettings(renderingSettingsId, __ctx, true);
    }

    private omero.model.RenderingDef loadRndSettings(long renderingSettingsId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "loadRndSettings", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("loadRndSettings");
                    __delBase = __getDelegate(false);
                    _IPixelsDel __del = (_IPixelsDel)__delBase;
                    return __del.loadRndSettings(renderingSettingsId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param renderingSettingsId Rendering definition id.
     **/
    public Ice.AsyncResult begin_loadRndSettings(long renderingSettingsId)
    {
        return begin_loadRndSettings(renderingSettingsId, null, false, null);
    }

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param renderingSettingsId Rendering definition id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadRndSettings(long renderingSettingsId, java.util.Map<String, String> __ctx)
    {
        return begin_loadRndSettings(renderingSettingsId, __ctx, true, null);
    }

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param renderingSettingsId Rendering definition id.
     **/
    public Ice.AsyncResult begin_loadRndSettings(long renderingSettingsId, Ice.Callback __cb)
    {
        return begin_loadRndSettings(renderingSettingsId, null, false, __cb);
    }

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param renderingSettingsId Rendering definition id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadRndSettings(long renderingSettingsId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_loadRndSettings(renderingSettingsId, __ctx, true, __cb);
    }

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param renderingSettingsId Rendering definition id.
     **/
    public Ice.AsyncResult begin_loadRndSettings(long renderingSettingsId, Callback_IPixels_loadRndSettings __cb)
    {
        return begin_loadRndSettings(renderingSettingsId, null, false, __cb);
    }

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param renderingSettingsId Rendering definition id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadRndSettings(long renderingSettingsId, java.util.Map<String, String> __ctx, Callback_IPixels_loadRndSettings __cb)
    {
        return begin_loadRndSettings(renderingSettingsId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_loadRndSettings(long renderingSettingsId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__loadRndSettings_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __loadRndSettings_name, __cb);
        try
        {
            __result.__prepare(__loadRndSettings_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(renderingSettingsId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Rendering definition.
     **/
    public omero.model.RenderingDef end_loadRndSettings(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __loadRndSettings_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.RenderingDefHolder __ret = new omero.model.RenderingDefHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param renderingSettingsId Rendering definition id.
     **/
    public boolean loadRndSettings_async(AMI_IPixels_loadRndSettings __cb, long renderingSettingsId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadRndSettings_name);
            __r = begin_loadRndSettings(renderingSettingsId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadRndSettings_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param renderingSettingsId Rendering definition id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadRndSettings_async(AMI_IPixels_loadRndSettings __cb, long renderingSettingsId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadRndSettings_name);
            __r = begin_loadRndSettings(renderingSettingsId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadRndSettings_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __retrieveAllRndSettings_name = "retrieveAllRndSettings";

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId    Pixels id.
     * @param userId   The id of the user.
     * @return Rendering definition.
     **/
    public java.util.List<omero.model.IObject> retrieveAllRndSettings(long pixId, long userId)
        throws omero.ServerError
    {
        return retrieveAllRndSettings(pixId, userId, null, false);
    }

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId    Pixels id.
     * @param userId   The id of the user.
     * @param __ctx The Context map to send with the invocation.
     * @return Rendering definition.
     **/
    public java.util.List<omero.model.IObject> retrieveAllRndSettings(long pixId, long userId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return retrieveAllRndSettings(pixId, userId, __ctx, true);
    }

    private java.util.List<omero.model.IObject> retrieveAllRndSettings(long pixId, long userId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "retrieveAllRndSettings", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("retrieveAllRndSettings");
                    __delBase = __getDelegate(false);
                    _IPixelsDel __del = (_IPixelsDel)__delBase;
                    return __del.retrieveAllRndSettings(pixId, userId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId    Pixels id.
     **/
    public Ice.AsyncResult begin_retrieveAllRndSettings(long pixId, long userId)
    {
        return begin_retrieveAllRndSettings(pixId, userId, null, false, null);
    }

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId    Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_retrieveAllRndSettings(long pixId, long userId, java.util.Map<String, String> __ctx)
    {
        return begin_retrieveAllRndSettings(pixId, userId, __ctx, true, null);
    }

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId    Pixels id.
     **/
    public Ice.AsyncResult begin_retrieveAllRndSettings(long pixId, long userId, Ice.Callback __cb)
    {
        return begin_retrieveAllRndSettings(pixId, userId, null, false, __cb);
    }

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId    Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_retrieveAllRndSettings(long pixId, long userId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_retrieveAllRndSettings(pixId, userId, __ctx, true, __cb);
    }

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId    Pixels id.
     **/
    public Ice.AsyncResult begin_retrieveAllRndSettings(long pixId, long userId, Callback_IPixels_retrieveAllRndSettings __cb)
    {
        return begin_retrieveAllRndSettings(pixId, userId, null, false, __cb);
    }

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId    Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_retrieveAllRndSettings(long pixId, long userId, java.util.Map<String, String> __ctx, Callback_IPixels_retrieveAllRndSettings __cb)
    {
        return begin_retrieveAllRndSettings(pixId, userId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_retrieveAllRndSettings(long pixId, long userId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__retrieveAllRndSettings_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __retrieveAllRndSettings_name, __cb);
        try
        {
            __result.__prepare(__retrieveAllRndSettings_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(pixId);
            __os.writeLong(userId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Rendering definition.
     **/
    public java.util.List<omero.model.IObject> end_retrieveAllRndSettings(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __retrieveAllRndSettings_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.IObject> __ret;
            __ret = IObjectListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId    Pixels id.
     **/
    public boolean retrieveAllRndSettings_async(AMI_IPixels_retrieveAllRndSettings __cb, long pixId, long userId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__retrieveAllRndSettings_name);
            __r = begin_retrieveAllRndSettings(pixId, userId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __retrieveAllRndSettings_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId    Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean retrieveAllRndSettings_async(AMI_IPixels_retrieveAllRndSettings __cb, long pixId, long userId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__retrieveAllRndSettings_name);
            __r = begin_retrieveAllRndSettings(pixId, userId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __retrieveAllRndSettings_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __retrievePixDescription_name = "retrievePixDescription";

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @return Pixels object which matches <code>id</code>.
     **/
    public omero.model.Pixels retrievePixDescription(long pixId)
        throws omero.ServerError
    {
        return retrievePixDescription(pixId, null, false);
    }

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     * @return Pixels object which matches <code>id</code>.
     **/
    public omero.model.Pixels retrievePixDescription(long pixId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return retrievePixDescription(pixId, __ctx, true);
    }

    private omero.model.Pixels retrievePixDescription(long pixId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "retrievePixDescription", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("retrievePixDescription");
                    __delBase = __getDelegate(false);
                    _IPixelsDel __del = (_IPixelsDel)__delBase;
                    return __del.retrievePixDescription(pixId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     **/
    public Ice.AsyncResult begin_retrievePixDescription(long pixId)
    {
        return begin_retrievePixDescription(pixId, null, false, null);
    }

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_retrievePixDescription(long pixId, java.util.Map<String, String> __ctx)
    {
        return begin_retrievePixDescription(pixId, __ctx, true, null);
    }

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     **/
    public Ice.AsyncResult begin_retrievePixDescription(long pixId, Ice.Callback __cb)
    {
        return begin_retrievePixDescription(pixId, null, false, __cb);
    }

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_retrievePixDescription(long pixId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_retrievePixDescription(pixId, __ctx, true, __cb);
    }

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     **/
    public Ice.AsyncResult begin_retrievePixDescription(long pixId, Callback_IPixels_retrievePixDescription __cb)
    {
        return begin_retrievePixDescription(pixId, null, false, __cb);
    }

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_retrievePixDescription(long pixId, java.util.Map<String, String> __ctx, Callback_IPixels_retrievePixDescription __cb)
    {
        return begin_retrievePixDescription(pixId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_retrievePixDescription(long pixId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__retrievePixDescription_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __retrievePixDescription_name, __cb);
        try
        {
            __result.__prepare(__retrievePixDescription_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(pixId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Pixels object which matches <code>id</code>.
     **/
    public omero.model.Pixels end_retrievePixDescription(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __retrievePixDescription_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.PixelsHolder __ret = new omero.model.PixelsHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     **/
    public boolean retrievePixDescription_async(AMI_IPixels_retrievePixDescription __cb, long pixId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__retrievePixDescription_name);
            __r = begin_retrievePixDescription(pixId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __retrievePixDescription_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean retrievePixDescription_async(AMI_IPixels_retrievePixDescription __cb, long pixId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__retrievePixDescription_name);
            __r = begin_retrievePixDescription(pixId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __retrievePixDescription_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __retrieveRndSettings_name = "retrieveRndSettings";

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @return Rendering definition.
     **/
    public omero.model.RenderingDef retrieveRndSettings(long pixId)
        throws omero.ServerError
    {
        return retrieveRndSettings(pixId, null, false);
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     * @return Rendering definition.
     **/
    public omero.model.RenderingDef retrieveRndSettings(long pixId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return retrieveRndSettings(pixId, __ctx, true);
    }

    private omero.model.RenderingDef retrieveRndSettings(long pixId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "retrieveRndSettings", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("retrieveRndSettings");
                    __delBase = __getDelegate(false);
                    _IPixelsDel __del = (_IPixelsDel)__delBase;
                    return __del.retrieveRndSettings(pixId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     **/
    public Ice.AsyncResult begin_retrieveRndSettings(long pixId)
    {
        return begin_retrieveRndSettings(pixId, null, false, null);
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_retrieveRndSettings(long pixId, java.util.Map<String, String> __ctx)
    {
        return begin_retrieveRndSettings(pixId, __ctx, true, null);
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     **/
    public Ice.AsyncResult begin_retrieveRndSettings(long pixId, Ice.Callback __cb)
    {
        return begin_retrieveRndSettings(pixId, null, false, __cb);
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_retrieveRndSettings(long pixId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_retrieveRndSettings(pixId, __ctx, true, __cb);
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     **/
    public Ice.AsyncResult begin_retrieveRndSettings(long pixId, Callback_IPixels_retrieveRndSettings __cb)
    {
        return begin_retrieveRndSettings(pixId, null, false, __cb);
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_retrieveRndSettings(long pixId, java.util.Map<String, String> __ctx, Callback_IPixels_retrieveRndSettings __cb)
    {
        return begin_retrieveRndSettings(pixId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_retrieveRndSettings(long pixId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__retrieveRndSettings_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __retrieveRndSettings_name, __cb);
        try
        {
            __result.__prepare(__retrieveRndSettings_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(pixId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Rendering definition.
     **/
    public omero.model.RenderingDef end_retrieveRndSettings(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __retrieveRndSettings_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.RenderingDefHolder __ret = new omero.model.RenderingDefHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     **/
    public boolean retrieveRndSettings_async(AMI_IPixels_retrieveRndSettings __cb, long pixId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__retrieveRndSettings_name);
            __r = begin_retrieveRndSettings(pixId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __retrieveRndSettings_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean retrieveRndSettings_async(AMI_IPixels_retrieveRndSettings __cb, long pixId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__retrieveRndSettings_name);
            __r = begin_retrieveRndSettings(pixId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __retrieveRndSettings_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __retrieveRndSettingsFor_name = "retrieveRndSettingsFor";

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param userID  The id of the user.
     * @return Rendering definition.
     **/
    public omero.model.RenderingDef retrieveRndSettingsFor(long pixId, long userId)
        throws omero.ServerError
    {
        return retrieveRndSettingsFor(pixId, userId, null, false);
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param pixId Pixels id.
     * @param userID  The id of the user.
     * @param __ctx The Context map to send with the invocation.
     * @return Rendering definition.
     **/
    public omero.model.RenderingDef retrieveRndSettingsFor(long pixId, long userId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return retrieveRndSettingsFor(pixId, userId, __ctx, true);
    }

    private omero.model.RenderingDef retrieveRndSettingsFor(long pixId, long userId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "retrieveRndSettingsFor", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("retrieveRndSettingsFor");
                    __delBase = __getDelegate(false);
                    _IPixelsDel __del = (_IPixelsDel)__delBase;
                    return __del.retrieveRndSettingsFor(pixId, userId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     **/
    public Ice.AsyncResult begin_retrieveRndSettingsFor(long pixId, long userId)
    {
        return begin_retrieveRndSettingsFor(pixId, userId, null, false, null);
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_retrieveRndSettingsFor(long pixId, long userId, java.util.Map<String, String> __ctx)
    {
        return begin_retrieveRndSettingsFor(pixId, userId, __ctx, true, null);
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     **/
    public Ice.AsyncResult begin_retrieveRndSettingsFor(long pixId, long userId, Ice.Callback __cb)
    {
        return begin_retrieveRndSettingsFor(pixId, userId, null, false, __cb);
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_retrieveRndSettingsFor(long pixId, long userId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_retrieveRndSettingsFor(pixId, userId, __ctx, true, __cb);
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     **/
    public Ice.AsyncResult begin_retrieveRndSettingsFor(long pixId, long userId, Callback_IPixels_retrieveRndSettingsFor __cb)
    {
        return begin_retrieveRndSettingsFor(pixId, userId, null, false, __cb);
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_retrieveRndSettingsFor(long pixId, long userId, java.util.Map<String, String> __ctx, Callback_IPixels_retrieveRndSettingsFor __cb)
    {
        return begin_retrieveRndSettingsFor(pixId, userId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_retrieveRndSettingsFor(long pixId, long userId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__retrieveRndSettingsFor_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __retrieveRndSettingsFor_name, __cb);
        try
        {
            __result.__prepare(__retrieveRndSettingsFor_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(pixId);
            __os.writeLong(userId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Rendering definition.
     **/
    public omero.model.RenderingDef end_retrieveRndSettingsFor(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __retrieveRndSettingsFor_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.RenderingDefHolder __ret = new omero.model.RenderingDefHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     **/
    public boolean retrieveRndSettingsFor_async(AMI_IPixels_retrieveRndSettingsFor __cb, long pixId, long userId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__retrieveRndSettingsFor_name);
            __r = begin_retrieveRndSettingsFor(pixId, userId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __retrieveRndSettingsFor_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean retrieveRndSettingsFor_async(AMI_IPixels_retrieveRndSettingsFor __cb, long pixId, long userId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__retrieveRndSettingsFor_name);
            __r = begin_retrieveRndSettingsFor(pixId, userId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __retrieveRndSettingsFor_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __saveRndSettings_name = "saveRndSettings";

    /**
     * Saves the specified rendering settings.
     * 
     * @param rndSettings Rendering settings.
     **/
    public void saveRndSettings(omero.model.RenderingDef rndSettings)
        throws omero.ServerError
    {
        saveRndSettings(rndSettings, null, false);
    }

    /**
     * Saves the specified rendering settings.
     * 
     * @param rndSettings Rendering settings.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void saveRndSettings(omero.model.RenderingDef rndSettings, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        saveRndSettings(rndSettings, __ctx, true);
    }

    private void saveRndSettings(omero.model.RenderingDef rndSettings, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "saveRndSettings", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("saveRndSettings");
                    __delBase = __getDelegate(false);
                    _IPixelsDel __del = (_IPixelsDel)__delBase;
                    __del.saveRndSettings(rndSettings, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Saves the specified rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param rndSettings Rendering settings.
     **/
    public Ice.AsyncResult begin_saveRndSettings(omero.model.RenderingDef rndSettings)
    {
        return begin_saveRndSettings(rndSettings, null, false, null);
    }

    /**
     * Saves the specified rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param rndSettings Rendering settings.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_saveRndSettings(omero.model.RenderingDef rndSettings, java.util.Map<String, String> __ctx)
    {
        return begin_saveRndSettings(rndSettings, __ctx, true, null);
    }

    /**
     * Saves the specified rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param rndSettings Rendering settings.
     **/
    public Ice.AsyncResult begin_saveRndSettings(omero.model.RenderingDef rndSettings, Ice.Callback __cb)
    {
        return begin_saveRndSettings(rndSettings, null, false, __cb);
    }

    /**
     * Saves the specified rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param rndSettings Rendering settings.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_saveRndSettings(omero.model.RenderingDef rndSettings, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_saveRndSettings(rndSettings, __ctx, true, __cb);
    }

    /**
     * Saves the specified rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param rndSettings Rendering settings.
     **/
    public Ice.AsyncResult begin_saveRndSettings(omero.model.RenderingDef rndSettings, Callback_IPixels_saveRndSettings __cb)
    {
        return begin_saveRndSettings(rndSettings, null, false, __cb);
    }

    /**
     * Saves the specified rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param rndSettings Rendering settings.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_saveRndSettings(omero.model.RenderingDef rndSettings, java.util.Map<String, String> __ctx, Callback_IPixels_saveRndSettings __cb)
    {
        return begin_saveRndSettings(rndSettings, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_saveRndSettings(omero.model.RenderingDef rndSettings, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__saveRndSettings_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __saveRndSettings_name, __cb);
        try
        {
            __result.__prepare(__saveRndSettings_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(rndSettings);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_saveRndSettings(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __saveRndSettings_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Saves the specified rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param rndSettings Rendering settings.
     **/
    public boolean saveRndSettings_async(AMI_IPixels_saveRndSettings __cb, omero.model.RenderingDef rndSettings)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__saveRndSettings_name);
            __r = begin_saveRndSettings(rndSettings, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __saveRndSettings_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Saves the specified rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param rndSettings Rendering settings.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean saveRndSettings_async(AMI_IPixels_saveRndSettings __cb, omero.model.RenderingDef rndSettings, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__saveRndSettings_name);
            __r = begin_saveRndSettings(rndSettings, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __saveRndSettings_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setChannelGlobalMinMax_name = "setChannelGlobalMinMax";

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param pixelsId The source Pixels set id.
     * @param channelIndex The channel index within the Pixels set.
     * @param min The channel global minimum.
     * @param max The channel global maximum.
     **/
    public void setChannelGlobalMinMax(long pixelsId, int channelIndex, double min, double max)
        throws omero.ServerError
    {
        setChannelGlobalMinMax(pixelsId, channelIndex, min, max, null, false);
    }

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param pixelsId The source Pixels set id.
     * @param channelIndex The channel index within the Pixels set.
     * @param min The channel global minimum.
     * @param max The channel global maximum.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setChannelGlobalMinMax(long pixelsId, int channelIndex, double min, double max, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setChannelGlobalMinMax(pixelsId, channelIndex, min, max, __ctx, true);
    }

    private void setChannelGlobalMinMax(long pixelsId, int channelIndex, double min, double max, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setChannelGlobalMinMax", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setChannelGlobalMinMax");
                    __delBase = __getDelegate(false);
                    _IPixelsDel __del = (_IPixelsDel)__delBase;
                    __del.setChannelGlobalMinMax(pixelsId, channelIndex, min, max, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param min The channel global minimum.
     **/
    public Ice.AsyncResult begin_setChannelGlobalMinMax(long pixelsId, int channelIndex, double min, double max)
    {
        return begin_setChannelGlobalMinMax(pixelsId, channelIndex, min, max, null, false, null);
    }

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param min The channel global minimum.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setChannelGlobalMinMax(long pixelsId, int channelIndex, double min, double max, java.util.Map<String, String> __ctx)
    {
        return begin_setChannelGlobalMinMax(pixelsId, channelIndex, min, max, __ctx, true, null);
    }

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param min The channel global minimum.
     **/
    public Ice.AsyncResult begin_setChannelGlobalMinMax(long pixelsId, int channelIndex, double min, double max, Ice.Callback __cb)
    {
        return begin_setChannelGlobalMinMax(pixelsId, channelIndex, min, max, null, false, __cb);
    }

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param min The channel global minimum.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setChannelGlobalMinMax(long pixelsId, int channelIndex, double min, double max, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setChannelGlobalMinMax(pixelsId, channelIndex, min, max, __ctx, true, __cb);
    }

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param min The channel global minimum.
     **/
    public Ice.AsyncResult begin_setChannelGlobalMinMax(long pixelsId, int channelIndex, double min, double max, Callback_IPixels_setChannelGlobalMinMax __cb)
    {
        return begin_setChannelGlobalMinMax(pixelsId, channelIndex, min, max, null, false, __cb);
    }

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param min The channel global minimum.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setChannelGlobalMinMax(long pixelsId, int channelIndex, double min, double max, java.util.Map<String, String> __ctx, Callback_IPixels_setChannelGlobalMinMax __cb)
    {
        return begin_setChannelGlobalMinMax(pixelsId, channelIndex, min, max, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setChannelGlobalMinMax(long pixelsId, int channelIndex, double min, double max, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setChannelGlobalMinMax_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setChannelGlobalMinMax_name, __cb);
        try
        {
            __result.__prepare(__setChannelGlobalMinMax_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(pixelsId);
            __os.writeInt(channelIndex);
            __os.writeDouble(min);
            __os.writeDouble(max);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setChannelGlobalMinMax(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setChannelGlobalMinMax_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param min The channel global minimum.
     **/
    public boolean setChannelGlobalMinMax_async(AMI_IPixels_setChannelGlobalMinMax __cb, long pixelsId, int channelIndex, double min, double max)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setChannelGlobalMinMax_name);
            __r = begin_setChannelGlobalMinMax(pixelsId, channelIndex, min, max, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setChannelGlobalMinMax_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param min The channel global minimum.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setChannelGlobalMinMax_async(AMI_IPixels_setChannelGlobalMinMax __cb, long pixelsId, int channelIndex, double min, double max, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setChannelGlobalMinMax_name);
            __r = begin_setChannelGlobalMinMax(pixelsId, channelIndex, min, max, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setChannelGlobalMinMax_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static IPixelsPrx checkedCast(Ice.ObjectPrx __obj)
    {
        IPixelsPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IPixelsPrx)
            {
                __d = (IPixelsPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    IPixelsPrxHelper __h = new IPixelsPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static IPixelsPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        IPixelsPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IPixelsPrx)
            {
                __d = (IPixelsPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    IPixelsPrxHelper __h = new IPixelsPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static IPixelsPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        IPixelsPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    IPixelsPrxHelper __h = new IPixelsPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static IPixelsPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        IPixelsPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    IPixelsPrxHelper __h = new IPixelsPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static IPixelsPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        IPixelsPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IPixelsPrx)
            {
                __d = (IPixelsPrx)__obj;
            }
            else
            {
                IPixelsPrxHelper __h = new IPixelsPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static IPixelsPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        IPixelsPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            IPixelsPrxHelper __h = new IPixelsPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IPixels",
        "::omero::api::ServiceInterface"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _IPixelsDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _IPixelsDelD();
    }

    public static void __write(IceInternal.BasicStream __os, IPixelsPrx v)
    {
        __os.writeProxy(v);
    }

    public static IPixelsPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            IPixelsPrxHelper result = new IPixelsPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
