// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IProjection.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides methods for performing projections of Pixels sets.
 **/
public final class IProjectionPrxHelper extends Ice.ObjectPrxHelperBase implements IProjectionPrx
{
    private static final String __projectPixels_name = "projectPixels";

    /**
     * Performs a projection through selected optical sections and
     * optical sections for a given set of time points of a Pixels
     * set. The Image which is linked to the Pixels set will be
     * copied using
     * {@link omero.api.IPixels#copyAndResizeImage}.
     * 
     * @param pixelsId The source Pixels set Id.
     * @param pixelsType The destination Pixels type. If
     * <code>null</code>, the source Pixels set
     * pixels type will be used.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param tStart Timepoint to start projecting from.
     * @param tEnd Timepoint to finish projecting.
     * @param channels List of the channel indexes to use while
     * calculating the projection.
     * @param stepping Stepping value to use while calculating the
     * projection. For example,
     * <code>stepping=1</code> will use every
     * optical section from <code>start</code> to
     * <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param zStart Optical section to start projecting from.
     * @param zEnd Optical section to finish projecting.
     * @param name Name for the newly created image. If
     * <code>null</code> the name of the Image linked
     * to the Pixels qualified by
     * <code>pixelsId</code> will be used with a
     * <i>Projection</i> suffix. For example,
     * <i>GFP-H2B Image of HeLa Cells</i> will have an
     * Image name of
     * <i>GFP-H2B Image of HeLa Cells Projection</i>
     * used for the projection.
     * @return The Id of the newly created Image which has been
     * projected.
     * @throws ValidationException Where:
     * <ul>
     * <li><code>algorithm</code> is unknown</li>
     * <li><code>tStart</code> is out of range</li>
     * <li><code>tEnd</code> is out of range</li>
     * <li><code>tStart > tEnd</code></li>
     * <li><code>channels</code> is null or has indexes out of
     * range</li>
     * <li><code>zStart</code> is out of range</li>
     * <li><code>zEnd</code> is out of range</li>
     * <li><code>zStart > zEnd</code></li>
     * <li>the Pixels set qualified by <code>pixelsId</code> is
     * unlocatable.</li>
     * </ul>
     * @see #projectStack
     **/
    public long projectPixels(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int tStart, int tEnd, java.util.List<Integer> channelList, int stepping, int zStart, int zEnd, String name)
        throws omero.ServerError
    {
        return projectPixels(pixelsId, pixelsType, algorithm, tStart, tEnd, channelList, stepping, zStart, zEnd, name, null, false);
    }

    /**
     * Performs a projection through selected optical sections and
     * optical sections for a given set of time points of a Pixels
     * set. The Image which is linked to the Pixels set will be
     * copied using
     * {@link omero.api.IPixels#copyAndResizeImage}.
     * 
     * @param pixelsId The source Pixels set Id.
     * @param pixelsType The destination Pixels type. If
     * <code>null</code>, the source Pixels set
     * pixels type will be used.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param tStart Timepoint to start projecting from.
     * @param tEnd Timepoint to finish projecting.
     * @param channels List of the channel indexes to use while
     * calculating the projection.
     * @param stepping Stepping value to use while calculating the
     * projection. For example,
     * <code>stepping=1</code> will use every
     * optical section from <code>start</code> to
     * <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param zStart Optical section to start projecting from.
     * @param zEnd Optical section to finish projecting.
     * @param name Name for the newly created image. If
     * <code>null</code> the name of the Image linked
     * to the Pixels qualified by
     * <code>pixelsId</code> will be used with a
     * <i>Projection</i> suffix. For example,
     * <i>GFP-H2B Image of HeLa Cells</i> will have an
     * Image name of
     * <i>GFP-H2B Image of HeLa Cells Projection</i>
     * used for the projection.
     * @param __ctx The Context map to send with the invocation.
     * @return The Id of the newly created Image which has been
     * projected.
     * @throws ValidationException Where:
     * <ul>
     * <li><code>algorithm</code> is unknown</li>
     * <li><code>tStart</code> is out of range</li>
     * <li><code>tEnd</code> is out of range</li>
     * <li><code>tStart > tEnd</code></li>
     * <li><code>channels</code> is null or has indexes out of
     * range</li>
     * <li><code>zStart</code> is out of range</li>
     * <li><code>zEnd</code> is out of range</li>
     * <li><code>zStart > zEnd</code></li>
     * <li>the Pixels set qualified by <code>pixelsId</code> is
     * unlocatable.</li>
     * </ul>
     * @see #projectStack
     **/
    public long projectPixels(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int tStart, int tEnd, java.util.List<Integer> channelList, int stepping, int zStart, int zEnd, String name, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return projectPixels(pixelsId, pixelsType, algorithm, tStart, tEnd, channelList, stepping, zStart, zEnd, name, __ctx, true);
    }

    private long projectPixels(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int tStart, int tEnd, java.util.List<Integer> channelList, int stepping, int zStart, int zEnd, String name, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "projectPixels", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("projectPixels");
                    __delBase = __getDelegate(false);
                    _IProjectionDel __del = (_IProjectionDel)__delBase;
                    return __del.projectPixels(pixelsId, pixelsType, algorithm, tStart, tEnd, channelList, stepping, zStart, zEnd, name, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Performs a projection through selected optical sections and
     * optical sections for a given set of time points of a Pixels
     * set. The Image which is linked to the Pixels set will be
     * copied using
     * {@link omero.api.IPixels#copyAndResizeImage}.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param tStart Timepoint to start projecting from.
     * @param stepping Stepping value to use while calculating the
     * projection. For example,
     * <code>stepping=1</code> will use every
     * optical section from <code>start</code> to
     * <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param zStart Optical section to start projecting from.
     * @param name Name for the newly created image. If
     * <code>null</code> the name of the Image linked
     * to the Pixels qualified by
     * <code>pixelsId</code> will be used with a
     * <i>Projection</i> suffix. For example,
     * <i>GFP-H2B Image of HeLa Cells</i> will have an
     * Image name of
     * <i>GFP-H2B Image of HeLa Cells Projection</i>
     * used for the projection.
     **/
    public Ice.AsyncResult begin_projectPixels(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int tStart, int tEnd, java.util.List<Integer> channelList, int stepping, int zStart, int zEnd, String name)
    {
        return begin_projectPixels(pixelsId, pixelsType, algorithm, tStart, tEnd, channelList, stepping, zStart, zEnd, name, null, false, null);
    }

    /**
     * Performs a projection through selected optical sections and
     * optical sections for a given set of time points of a Pixels
     * set. The Image which is linked to the Pixels set will be
     * copied using
     * {@link omero.api.IPixels#copyAndResizeImage}.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param tStart Timepoint to start projecting from.
     * @param stepping Stepping value to use while calculating the
     * projection. For example,
     * <code>stepping=1</code> will use every
     * optical section from <code>start</code> to
     * <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param zStart Optical section to start projecting from.
     * @param name Name for the newly created image. If
     * <code>null</code> the name of the Image linked
     * to the Pixels qualified by
     * <code>pixelsId</code> will be used with a
     * <i>Projection</i> suffix. For example,
     * <i>GFP-H2B Image of HeLa Cells</i> will have an
     * Image name of
     * <i>GFP-H2B Image of HeLa Cells Projection</i>
     * used for the projection.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_projectPixels(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int tStart, int tEnd, java.util.List<Integer> channelList, int stepping, int zStart, int zEnd, String name, java.util.Map<String, String> __ctx)
    {
        return begin_projectPixels(pixelsId, pixelsType, algorithm, tStart, tEnd, channelList, stepping, zStart, zEnd, name, __ctx, true, null);
    }

    /**
     * Performs a projection through selected optical sections and
     * optical sections for a given set of time points of a Pixels
     * set. The Image which is linked to the Pixels set will be
     * copied using
     * {@link omero.api.IPixels#copyAndResizeImage}.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param tStart Timepoint to start projecting from.
     * @param stepping Stepping value to use while calculating the
     * projection. For example,
     * <code>stepping=1</code> will use every
     * optical section from <code>start</code> to
     * <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param zStart Optical section to start projecting from.
     * @param name Name for the newly created image. If
     * <code>null</code> the name of the Image linked
     * to the Pixels qualified by
     * <code>pixelsId</code> will be used with a
     * <i>Projection</i> suffix. For example,
     * <i>GFP-H2B Image of HeLa Cells</i> will have an
     * Image name of
     * <i>GFP-H2B Image of HeLa Cells Projection</i>
     * used for the projection.
     **/
    public Ice.AsyncResult begin_projectPixels(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int tStart, int tEnd, java.util.List<Integer> channelList, int stepping, int zStart, int zEnd, String name, Ice.Callback __cb)
    {
        return begin_projectPixels(pixelsId, pixelsType, algorithm, tStart, tEnd, channelList, stepping, zStart, zEnd, name, null, false, __cb);
    }

    /**
     * Performs a projection through selected optical sections and
     * optical sections for a given set of time points of a Pixels
     * set. The Image which is linked to the Pixels set will be
     * copied using
     * {@link omero.api.IPixels#copyAndResizeImage}.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param tStart Timepoint to start projecting from.
     * @param stepping Stepping value to use while calculating the
     * projection. For example,
     * <code>stepping=1</code> will use every
     * optical section from <code>start</code> to
     * <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param zStart Optical section to start projecting from.
     * @param name Name for the newly created image. If
     * <code>null</code> the name of the Image linked
     * to the Pixels qualified by
     * <code>pixelsId</code> will be used with a
     * <i>Projection</i> suffix. For example,
     * <i>GFP-H2B Image of HeLa Cells</i> will have an
     * Image name of
     * <i>GFP-H2B Image of HeLa Cells Projection</i>
     * used for the projection.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_projectPixels(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int tStart, int tEnd, java.util.List<Integer> channelList, int stepping, int zStart, int zEnd, String name, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_projectPixels(pixelsId, pixelsType, algorithm, tStart, tEnd, channelList, stepping, zStart, zEnd, name, __ctx, true, __cb);
    }

    /**
     * Performs a projection through selected optical sections and
     * optical sections for a given set of time points of a Pixels
     * set. The Image which is linked to the Pixels set will be
     * copied using
     * {@link omero.api.IPixels#copyAndResizeImage}.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param tStart Timepoint to start projecting from.
     * @param stepping Stepping value to use while calculating the
     * projection. For example,
     * <code>stepping=1</code> will use every
     * optical section from <code>start</code> to
     * <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param zStart Optical section to start projecting from.
     * @param name Name for the newly created image. If
     * <code>null</code> the name of the Image linked
     * to the Pixels qualified by
     * <code>pixelsId</code> will be used with a
     * <i>Projection</i> suffix. For example,
     * <i>GFP-H2B Image of HeLa Cells</i> will have an
     * Image name of
     * <i>GFP-H2B Image of HeLa Cells Projection</i>
     * used for the projection.
     **/
    public Ice.AsyncResult begin_projectPixels(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int tStart, int tEnd, java.util.List<Integer> channelList, int stepping, int zStart, int zEnd, String name, Callback_IProjection_projectPixels __cb)
    {
        return begin_projectPixels(pixelsId, pixelsType, algorithm, tStart, tEnd, channelList, stepping, zStart, zEnd, name, null, false, __cb);
    }

    /**
     * Performs a projection through selected optical sections and
     * optical sections for a given set of time points of a Pixels
     * set. The Image which is linked to the Pixels set will be
     * copied using
     * {@link omero.api.IPixels#copyAndResizeImage}.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param tStart Timepoint to start projecting from.
     * @param stepping Stepping value to use while calculating the
     * projection. For example,
     * <code>stepping=1</code> will use every
     * optical section from <code>start</code> to
     * <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param zStart Optical section to start projecting from.
     * @param name Name for the newly created image. If
     * <code>null</code> the name of the Image linked
     * to the Pixels qualified by
     * <code>pixelsId</code> will be used with a
     * <i>Projection</i> suffix. For example,
     * <i>GFP-H2B Image of HeLa Cells</i> will have an
     * Image name of
     * <i>GFP-H2B Image of HeLa Cells Projection</i>
     * used for the projection.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_projectPixels(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int tStart, int tEnd, java.util.List<Integer> channelList, int stepping, int zStart, int zEnd, String name, java.util.Map<String, String> __ctx, Callback_IProjection_projectPixels __cb)
    {
        return begin_projectPixels(pixelsId, pixelsType, algorithm, tStart, tEnd, channelList, stepping, zStart, zEnd, name, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_projectPixels(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int tStart, int tEnd, java.util.List<Integer> channelList, int stepping, int zStart, int zEnd, String name, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__projectPixels_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __projectPixels_name, __cb);
        try
        {
            __result.__prepare(__projectPixels_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(pixelsId);
            __os.writeObject(pixelsType);
            algorithm.__write(__os);
            __os.writeInt(tStart);
            __os.writeInt(tEnd);
            omero.sys.IntListHelper.write(__os, channelList);
            __os.writeInt(stepping);
            __os.writeInt(zStart);
            __os.writeInt(zEnd);
            __os.writeString(name);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) The Id of the newly created Image which has been
     * projected.
     **/
    public long end_projectPixels(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __projectPixels_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Performs a projection through selected optical sections and
     * optical sections for a given set of time points of a Pixels
     * set. The Image which is linked to the Pixels set will be
     * copied using
     * {@link omero.api.IPixels#copyAndResizeImage}.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param tStart Timepoint to start projecting from.
     * @param stepping Stepping value to use while calculating the
     * projection. For example,
     * <code>stepping=1</code> will use every
     * optical section from <code>start</code> to
     * <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param zStart Optical section to start projecting from.
     * @param name Name for the newly created image. If
     * <code>null</code> the name of the Image linked
     * to the Pixels qualified by
     * <code>pixelsId</code> will be used with a
     * <i>Projection</i> suffix. For example,
     * <i>GFP-H2B Image of HeLa Cells</i> will have an
     * Image name of
     * <i>GFP-H2B Image of HeLa Cells Projection</i>
     * used for the projection.
     **/
    public boolean projectPixels_async(AMI_IProjection_projectPixels __cb, long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int tStart, int tEnd, java.util.List<Integer> channelList, int stepping, int zStart, int zEnd, String name)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__projectPixels_name);
            __r = begin_projectPixels(pixelsId, pixelsType, algorithm, tStart, tEnd, channelList, stepping, zStart, zEnd, name, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __projectPixels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Performs a projection through selected optical sections and
     * optical sections for a given set of time points of a Pixels
     * set. The Image which is linked to the Pixels set will be
     * copied using
     * {@link omero.api.IPixels#copyAndResizeImage}.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param tStart Timepoint to start projecting from.
     * @param stepping Stepping value to use while calculating the
     * projection. For example,
     * <code>stepping=1</code> will use every
     * optical section from <code>start</code> to
     * <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param zStart Optical section to start projecting from.
     * @param name Name for the newly created image. If
     * <code>null</code> the name of the Image linked
     * to the Pixels qualified by
     * <code>pixelsId</code> will be used with a
     * <i>Projection</i> suffix. For example,
     * <i>GFP-H2B Image of HeLa Cells</i> will have an
     * Image name of
     * <i>GFP-H2B Image of HeLa Cells Projection</i>
     * used for the projection.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean projectPixels_async(AMI_IProjection_projectPixels __cb, long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int tStart, int tEnd, java.util.List<Integer> channelList, int stepping, int zStart, int zEnd, String name, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__projectPixels_name);
            __r = begin_projectPixels(pixelsId, pixelsType, algorithm, tStart, tEnd, channelList, stepping, zStart, zEnd, name, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __projectPixels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __projectStack_name = "projectStack";

    /**
     * Performs a projection through the optical sections of a
     * particular wavelength at a given time point of a Pixels set.
     * @param pixelsId The source Pixels set Id.
     * @param pixelsType The destination Pixels type. If
     * <code>null</code>, the source Pixels set
     * pixels type will be used.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param timepoint Timepoint to perform the projection.
     * @param channelIndex Index of the channel to perform the
     * projection.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param end Optical section to finish projecting.
     * @return A byte array of projected pixel values whose length
     * is equal to the Pixels set
     * 8         <code>sizeX * sizeY * bytesPerPixel</code> in
     * big-endian format.
     * @throws ValidationException Where:
     * <ul>
     * <li><code>algorithm</code> is unknown</li>
     * <li><code>timepoint</code> is out of range</li>
     * <li><code>channelIndex</code> is out of range</li>
     * <li><code>start</code> is out of range</li>
     * <li><code>end</code> is out of range</li>
     * <li><code>start > end</code></li>
     * <li>the Pixels set qualified by <code>pixelsId</code> is
     * unlocatable.</li>
     * </ul>
     * @see #projectPixels
     **/
    public byte[] projectStack(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int timepoint, int channelIndex, int stepping, int start, int end)
        throws omero.ServerError
    {
        return projectStack(pixelsId, pixelsType, algorithm, timepoint, channelIndex, stepping, start, end, null, false);
    }

    /**
     * Performs a projection through the optical sections of a
     * particular wavelength at a given time point of a Pixels set.
     * @param pixelsId The source Pixels set Id.
     * @param pixelsType The destination Pixels type. If
     * <code>null</code>, the source Pixels set
     * pixels type will be used.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param timepoint Timepoint to perform the projection.
     * @param channelIndex Index of the channel to perform the
     * projection.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param end Optical section to finish projecting.
     * @param __ctx The Context map to send with the invocation.
     * @return A byte array of projected pixel values whose length
     * is equal to the Pixels set
     * 8         <code>sizeX * sizeY * bytesPerPixel</code> in
     * big-endian format.
     * @throws ValidationException Where:
     * <ul>
     * <li><code>algorithm</code> is unknown</li>
     * <li><code>timepoint</code> is out of range</li>
     * <li><code>channelIndex</code> is out of range</li>
     * <li><code>start</code> is out of range</li>
     * <li><code>end</code> is out of range</li>
     * <li><code>start > end</code></li>
     * <li>the Pixels set qualified by <code>pixelsId</code> is
     * unlocatable.</li>
     * </ul>
     * @see #projectPixels
     **/
    public byte[] projectStack(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int timepoint, int channelIndex, int stepping, int start, int end, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return projectStack(pixelsId, pixelsType, algorithm, timepoint, channelIndex, stepping, start, end, __ctx, true);
    }

    private byte[] projectStack(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int timepoint, int channelIndex, int stepping, int start, int end, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "projectStack", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("projectStack");
                    __delBase = __getDelegate(false);
                    _IProjectionDel __del = (_IProjectionDel)__delBase;
                    return __del.projectStack(pixelsId, pixelsType, algorithm, timepoint, channelIndex, stepping, start, end, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Performs a projection through the optical sections of a
     * particular wavelength at a given time point of a Pixels set.
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param timepoint Timepoint to perform the projection.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     **/
    public Ice.AsyncResult begin_projectStack(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int timepoint, int channelIndex, int stepping, int start, int end)
    {
        return begin_projectStack(pixelsId, pixelsType, algorithm, timepoint, channelIndex, stepping, start, end, null, false, null);
    }

    /**
     * Performs a projection through the optical sections of a
     * particular wavelength at a given time point of a Pixels set.
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param timepoint Timepoint to perform the projection.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_projectStack(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int timepoint, int channelIndex, int stepping, int start, int end, java.util.Map<String, String> __ctx)
    {
        return begin_projectStack(pixelsId, pixelsType, algorithm, timepoint, channelIndex, stepping, start, end, __ctx, true, null);
    }

    /**
     * Performs a projection through the optical sections of a
     * particular wavelength at a given time point of a Pixels set.
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param timepoint Timepoint to perform the projection.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     **/
    public Ice.AsyncResult begin_projectStack(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int timepoint, int channelIndex, int stepping, int start, int end, Ice.Callback __cb)
    {
        return begin_projectStack(pixelsId, pixelsType, algorithm, timepoint, channelIndex, stepping, start, end, null, false, __cb);
    }

    /**
     * Performs a projection through the optical sections of a
     * particular wavelength at a given time point of a Pixels set.
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param timepoint Timepoint to perform the projection.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_projectStack(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int timepoint, int channelIndex, int stepping, int start, int end, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_projectStack(pixelsId, pixelsType, algorithm, timepoint, channelIndex, stepping, start, end, __ctx, true, __cb);
    }

    /**
     * Performs a projection through the optical sections of a
     * particular wavelength at a given time point of a Pixels set.
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param timepoint Timepoint to perform the projection.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     **/
    public Ice.AsyncResult begin_projectStack(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int timepoint, int channelIndex, int stepping, int start, int end, Callback_IProjection_projectStack __cb)
    {
        return begin_projectStack(pixelsId, pixelsType, algorithm, timepoint, channelIndex, stepping, start, end, null, false, __cb);
    }

    /**
     * Performs a projection through the optical sections of a
     * particular wavelength at a given time point of a Pixels set.
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param timepoint Timepoint to perform the projection.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_projectStack(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int timepoint, int channelIndex, int stepping, int start, int end, java.util.Map<String, String> __ctx, Callback_IProjection_projectStack __cb)
    {
        return begin_projectStack(pixelsId, pixelsType, algorithm, timepoint, channelIndex, stepping, start, end, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_projectStack(long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int timepoint, int channelIndex, int stepping, int start, int end, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__projectStack_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __projectStack_name, __cb);
        try
        {
            __result.__prepare(__projectStack_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(pixelsId);
            __os.writeObject(pixelsType);
            algorithm.__write(__os);
            __os.writeInt(timepoint);
            __os.writeInt(channelIndex);
            __os.writeInt(stepping);
            __os.writeInt(start);
            __os.writeInt(end);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) A byte array of projected pixel values whose length
     * is equal to the Pixels set
     * 8         <code>sizeX * sizeY * bytesPerPixel</code> in
     * big-endian format.
     **/
    public byte[] end_projectStack(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __projectStack_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Performs a projection through the optical sections of a
     * particular wavelength at a given time point of a Pixels set.
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param timepoint Timepoint to perform the projection.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     **/
    public boolean projectStack_async(AMI_IProjection_projectStack __cb, long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int timepoint, int channelIndex, int stepping, int start, int end)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__projectStack_name);
            __r = begin_projectStack(pixelsId, pixelsType, algorithm, timepoint, channelIndex, stepping, start, end, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __projectStack_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Performs a projection through the optical sections of a
     * particular wavelength at a given time point of a Pixels set.
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param timepoint Timepoint to perform the projection.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean projectStack_async(AMI_IProjection_projectStack __cb, long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int timepoint, int channelIndex, int stepping, int start, int end, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__projectStack_name);
            __r = begin_projectStack(pixelsId, pixelsType, algorithm, timepoint, channelIndex, stepping, start, end, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __projectStack_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static IProjectionPrx checkedCast(Ice.ObjectPrx __obj)
    {
        IProjectionPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IProjectionPrx)
            {
                __d = (IProjectionPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    IProjectionPrxHelper __h = new IProjectionPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static IProjectionPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        IProjectionPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IProjectionPrx)
            {
                __d = (IProjectionPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    IProjectionPrxHelper __h = new IProjectionPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static IProjectionPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        IProjectionPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    IProjectionPrxHelper __h = new IProjectionPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static IProjectionPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        IProjectionPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    IProjectionPrxHelper __h = new IProjectionPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static IProjectionPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        IProjectionPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IProjectionPrx)
            {
                __d = (IProjectionPrx)__obj;
            }
            else
            {
                IProjectionPrxHelper __h = new IProjectionPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static IProjectionPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        IProjectionPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            IProjectionPrxHelper __h = new IProjectionPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IProjection",
        "::omero::api::ServiceInterface"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _IProjectionDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _IProjectionDelD();
    }

    public static void __write(IceInternal.BasicStream __os, IProjectionPrx v)
    {
        __os.writeProxy(v);
    }

    public static IProjectionPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            IProjectionPrxHelper result = new IProjectionPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
