// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IQuery.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides methods for directly querying object graphs. As far as is
 * possible, IQuery should be considered the lowest level DB-access
 * (SELECT) interface.
 * Unlike the {@link omero.api.IUpdate} interface, using other methods
 * will most likely not leave the database in an inconsistent state,
 * but may provide stale data in some situations.
 * 
 * By convention, all methods that begin with <code>get</code> will
 * never return a null or empty {@link java.util.Collection}, but
 * instead will throw a {@link omero.ValidationException}.
 * 
 **/
public interface IQueryPrx extends ServiceInterfacePrx
{
    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param klass the type of the entity. Not null.
     * @param id the entity's id
     * @return an initialized entity
     * @throws ValidationException if the id doesn't exist.
     **/
    public omero.model.IObject get(String klass, long id)
        throws omero.ServerError;

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param klass the type of the entity. Not null.
     * @param id the entity's id
     * @param __ctx The Context map to send with the invocation.
     * @return an initialized entity
     * @throws ValidationException if the id doesn't exist.
     **/
    public omero.model.IObject get(String klass, long id, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param klass the type of the entity. Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(String klass, long id);

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param klass the type of the entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(String klass, long id, java.util.Map<String, String> __ctx);

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param klass the type of the entity. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(String klass, long id, Ice.Callback __cb);

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param klass the type of the entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(String klass, long id, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param klass the type of the entity. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(String klass, long id, Callback_IQuery_get __cb);

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param klass the type of the entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_get(String klass, long id, java.util.Map<String, String> __ctx, Callback_IQuery_get __cb);

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param __result The asynchronous result object.
     * @return an initialized entity
     * @throws ValidationException if the id doesn't exist.
     **/
    public omero.model.IObject end_get(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param klass the type of the entity. Not null.
     **/
    public boolean get_async(AMI_IQuery_get __cb, String klass, long id);

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param klass the type of the entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean get_async(AMI_IQuery_get __cb, String klass, long id, java.util.Map<String, String> __ctx);

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param klass klass the type of the entity. Not null.
     * @param id the entity's id
     * @return an initialized entity or null if id doesn't exist.
     **/
    public omero.model.IObject find(String klass, long id)
        throws omero.ServerError;

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param klass klass the type of the entity. Not null.
     * @param id the entity's id
     * @param __ctx The Context map to send with the invocation.
     * @return an initialized entity or null if id doesn't exist.
     **/
    public omero.model.IObject find(String klass, long id, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param klass klass the type of the entity. Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_find(String klass, long id);

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param klass klass the type of the entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_find(String klass, long id, java.util.Map<String, String> __ctx);

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param klass klass the type of the entity. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_find(String klass, long id, Ice.Callback __cb);

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param klass klass the type of the entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_find(String klass, long id, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param klass klass the type of the entity. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_find(String klass, long id, Callback_IQuery_find __cb);

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param klass klass the type of the entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_find(String klass, long id, java.util.Map<String, String> __ctx, Callback_IQuery_find __cb);

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param __result The asynchronous result object.
     * @return an initialized entity or null if id doesn't exist.
     **/
    public omero.model.IObject end_find(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param klass klass the type of the entity. Not null.
     **/
    public boolean find_async(AMI_IQuery_find __cb, String klass, long id);

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param klass klass the type of the entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean find_async(AMI_IQuery_find __cb, String klass, long id, java.util.Map<String, String> __ctx);

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param klass entity type to be searched. Not null.
     * @param filter filters the result set. Can be null.
     * @return a collection if initialized entities or an empty
     * List if none exist.
     **/
    public java.util.List<omero.model.IObject> findAll(String klass, omero.sys.Filter filter)
        throws omero.ServerError;

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param klass entity type to be searched. Not null.
     * @param filter filters the result set. Can be null.
     * @param __ctx The Context map to send with the invocation.
     * @return a collection if initialized entities or an empty
     * List if none exist.
     **/
    public java.util.List<omero.model.IObject> findAll(String klass, omero.sys.Filter filter, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param klass entity type to be searched. Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAll(String klass, omero.sys.Filter filter);

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param klass entity type to be searched. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAll(String klass, omero.sys.Filter filter, java.util.Map<String, String> __ctx);

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param klass entity type to be searched. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAll(String klass, omero.sys.Filter filter, Ice.Callback __cb);

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param klass entity type to be searched. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAll(String klass, omero.sys.Filter filter, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param klass entity type to be searched. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAll(String klass, omero.sys.Filter filter, Callback_IQuery_findAll __cb);

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param klass entity type to be searched. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAll(String klass, omero.sys.Filter filter, java.util.Map<String, String> __ctx, Callback_IQuery_findAll __cb);

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param __result The asynchronous result object.
     * @return a collection if initialized entities or an empty
     * List if none exist.
     **/
    public java.util.List<omero.model.IObject> end_findAll(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param __cb The callback object for the operation.
     * @param klass entity type to be searched. Not null.
     **/
    public boolean findAll_async(AMI_IQuery_findAll __cb, String klass, omero.sys.Filter filter);

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param __cb The callback object for the operation.
     * @param klass entity type to be searched. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findAll_async(AMI_IQuery_findAll __cb, String klass, omero.sys.Filter filter, java.util.Map<String, String> __ctx);

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param example Non-null example object.
     * @return Possibly null IObject result.
     * @throws ApiUsageException if more than one result is return.
     **/
    public omero.model.IObject findByExample(omero.model.IObject example)
        throws omero.ServerError;

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param example Non-null example object.
     * @param __ctx The Context map to send with the invocation.
     * @return Possibly null IObject result.
     * @throws ApiUsageException if more than one result is return.
     **/
    public omero.model.IObject findByExample(omero.model.IObject example, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param example Non-null example object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findByExample(omero.model.IObject example);

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param example Non-null example object.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findByExample(omero.model.IObject example, java.util.Map<String, String> __ctx);

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param example Non-null example object.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findByExample(omero.model.IObject example, Ice.Callback __cb);

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param example Non-null example object.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findByExample(omero.model.IObject example, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param example Non-null example object.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findByExample(omero.model.IObject example, Callback_IQuery_findByExample __cb);

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param example Non-null example object.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findByExample(omero.model.IObject example, java.util.Map<String, String> __ctx, Callback_IQuery_findByExample __cb);

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param __result The asynchronous result object.
     * @return Possibly null IObject result.
     * @throws ApiUsageException if more than one result is return.
     **/
    public omero.model.IObject end_findByExample(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     **/
    public boolean findByExample_async(AMI_IQuery_findByExample __cb, omero.model.IObject example);

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findByExample_async(AMI_IQuery_findByExample __cb, omero.model.IObject example, java.util.Map<String, String> __ctx);

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param example Non-null example object.
     * @param filter filters the result set. Can be null.
     * @return Possibly empty List of IObject results.
     **/
    public java.util.List<omero.model.IObject> findAllByExample(omero.model.IObject example, omero.sys.Filter filter)
        throws omero.ServerError;

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param example Non-null example object.
     * @param filter filters the result set. Can be null.
     * @param __ctx The Context map to send with the invocation.
     * @return Possibly empty List of IObject results.
     **/
    public java.util.List<omero.model.IObject> findAllByExample(omero.model.IObject example, omero.sys.Filter filter, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param example Non-null example object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByExample(omero.model.IObject example, omero.sys.Filter filter);

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param example Non-null example object.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByExample(omero.model.IObject example, omero.sys.Filter filter, java.util.Map<String, String> __ctx);

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param example Non-null example object.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByExample(omero.model.IObject example, omero.sys.Filter filter, Ice.Callback __cb);

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param example Non-null example object.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByExample(omero.model.IObject example, omero.sys.Filter filter, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param example Non-null example object.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByExample(omero.model.IObject example, omero.sys.Filter filter, Callback_IQuery_findAllByExample __cb);

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param example Non-null example object.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByExample(omero.model.IObject example, omero.sys.Filter filter, java.util.Map<String, String> __ctx, Callback_IQuery_findAllByExample __cb);

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param __result The asynchronous result object.
     * @return Possibly empty List of IObject results.
     **/
    public java.util.List<omero.model.IObject> end_findAllByExample(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     **/
    public boolean findAllByExample_async(AMI_IQuery_findAllByExample __cb, omero.model.IObject example, omero.sys.Filter filter);

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findAllByExample_async(AMI_IQuery_findAllByExample __cb, omero.model.IObject example, omero.sys.Filter filter, java.util.Map<String, String> __ctx);

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param klass type of entity to be searched
     * @param field the name of the field, either as simple string
     * or as public final static from the entity
     * class, e.g. {@link omero.model.Project#NAME}
     * @param value String used for search.
     * @return found entity or possibly null.
     * @throws ome.conditions.ApiUsageException
     * if more than one result.
     **/
    public omero.model.IObject findByString(String klass, String field, String value)
        throws omero.ServerError;

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param klass type of entity to be searched
     * @param field the name of the field, either as simple string
     * or as public final static from the entity
     * class, e.g. {@link omero.model.Project#NAME}
     * @param value String used for search.
     * @param __ctx The Context map to send with the invocation.
     * @return found entity or possibly null.
     * @throws ome.conditions.ApiUsageException
     * if more than one result.
     **/
    public omero.model.IObject findByString(String klass, String field, String value, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param klass type of entity to be searched
     * @param value String used for search.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findByString(String klass, String field, String value);

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param klass type of entity to be searched
     * @param value String used for search.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findByString(String klass, String field, String value, java.util.Map<String, String> __ctx);

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param klass type of entity to be searched
     * @param value String used for search.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findByString(String klass, String field, String value, Ice.Callback __cb);

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param klass type of entity to be searched
     * @param value String used for search.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findByString(String klass, String field, String value, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param klass type of entity to be searched
     * @param value String used for search.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findByString(String klass, String field, String value, Callback_IQuery_findByString __cb);

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param klass type of entity to be searched
     * @param value String used for search.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findByString(String klass, String field, String value, java.util.Map<String, String> __ctx, Callback_IQuery_findByString __cb);

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param __result The asynchronous result object.
     * @return found entity or possibly null.
     * @throws ome.conditions.ApiUsageException
     * if more than one result.
     **/
    public omero.model.IObject end_findByString(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched
     * @param value String used for search.
     **/
    public boolean findByString_async(AMI_IQuery_findByString __cb, String klass, String field, String value);

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched
     * @param value String used for search.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findByString_async(AMI_IQuery_findByString __cb, String klass, String field, String value, java.util.Map<String, String> __ctx);

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param klass type of entity to be searched. Not null.
     * @param field the name of the field, either as simple string
     * or as public final static from the entity
     * class, e.g. {@link omero.model.Project#NAME}.
     * Not null.
     * @param value String used for search. Not null.
     * @param caseSensitive whether to use LIKE or ILIKE
     * @param filter filters the result set. Can be null.
     * @return A list (possibly empty) with the results.
     **/
    public java.util.List<omero.model.IObject> findAllByString(String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter)
        throws omero.ServerError;

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param klass type of entity to be searched. Not null.
     * @param field the name of the field, either as simple string
     * or as public final static from the entity
     * class, e.g. {@link omero.model.Project#NAME}.
     * Not null.
     * @param value String used for search. Not null.
     * @param caseSensitive whether to use LIKE or ILIKE
     * @param filter filters the result set. Can be null.
     * @param __ctx The Context map to send with the invocation.
     * @return A list (possibly empty) with the results.
     **/
    public java.util.List<omero.model.IObject> findAllByString(String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param klass type of entity to be searched. Not null.
     * @param value String used for search. Not null.
     * @param filter filters the result set. Can be null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByString(String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter);

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param klass type of entity to be searched. Not null.
     * @param value String used for search. Not null.
     * @param filter filters the result set. Can be null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByString(String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter, java.util.Map<String, String> __ctx);

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param klass type of entity to be searched. Not null.
     * @param value String used for search. Not null.
     * @param filter filters the result set. Can be null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByString(String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter, Ice.Callback __cb);

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param klass type of entity to be searched. Not null.
     * @param value String used for search. Not null.
     * @param filter filters the result set. Can be null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByString(String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param klass type of entity to be searched. Not null.
     * @param value String used for search. Not null.
     * @param filter filters the result set. Can be null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByString(String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter, Callback_IQuery_findAllByString __cb);

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param klass type of entity to be searched. Not null.
     * @param value String used for search. Not null.
     * @param filter filters the result set. Can be null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByString(String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter, java.util.Map<String, String> __ctx, Callback_IQuery_findAllByString __cb);

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param __result The asynchronous result object.
     * @return A list (possibly empty) with the results.
     **/
    public java.util.List<omero.model.IObject> end_findAllByString(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched. Not null.
     * @param value String used for search. Not null.
     * @param filter filters the result set. Can be null.
     **/
    public boolean findAllByString_async(AMI_IQuery_findAllByString __cb, String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter);

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched. Not null.
     * @param value String used for search. Not null.
     * @param filter filters the result set. Can be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findAllByString_async(AMI_IQuery_findAllByString __cb, String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter, java.util.Map<String, String> __ctx);

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param query Query to execute
     * @param params
     * @return Possibly null IObject result.
     * @throws ValidationException
     **/
    public omero.model.IObject findByQuery(String query, omero.sys.Parameters params)
        throws omero.ServerError;

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param query Query to execute
     * @param params
     * @param __ctx The Context map to send with the invocation.
     * @return Possibly null IObject result.
     * @throws ValidationException
     **/
    public omero.model.IObject findByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param query Query to execute
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findByQuery(String query, omero.sys.Parameters params);

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param query Query to execute
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx);

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param query Query to execute
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findByQuery(String query, omero.sys.Parameters params, Ice.Callback __cb);

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param query Query to execute
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param query Query to execute
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findByQuery(String query, omero.sys.Parameters params, Callback_IQuery_findByQuery __cb);

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param query Query to execute
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Callback_IQuery_findByQuery __cb);

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param __result The asynchronous result object.
     * @return Possibly null IObject result.
     * @throws ValidationException
     **/
    public omero.model.IObject end_findByQuery(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute
     **/
    public boolean findByQuery_async(AMI_IQuery_findByQuery __cb, String query, omero.sys.Parameters params);

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findByQuery_async(AMI_IQuery_findByQuery __cb, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx);

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param query Query to execute. Not null.
     * @param params
     * @return Possibly empty List of IObject results.
     **/
    public java.util.List<omero.model.IObject> findAllByQuery(String query, omero.sys.Parameters params)
        throws omero.ServerError;

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param query Query to execute. Not null.
     * @param params
     * @param __ctx The Context map to send with the invocation.
     * @return Possibly empty List of IObject results.
     **/
    public java.util.List<omero.model.IObject> findAllByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param query Query to execute. Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByQuery(String query, omero.sys.Parameters params);

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param query Query to execute. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx);

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param query Query to execute. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByQuery(String query, omero.sys.Parameters params, Ice.Callback __cb);

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param query Query to execute. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param query Query to execute. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByQuery(String query, omero.sys.Parameters params, Callback_IQuery_findAllByQuery __cb);

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param query Query to execute. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Callback_IQuery_findAllByQuery __cb);

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param __result The asynchronous result object.
     * @return Possibly empty List of IObject results.
     **/
    public java.util.List<omero.model.IObject> end_findAllByQuery(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute. Not null.
     **/
    public boolean findAllByQuery_async(AMI_IQuery_findAllByQuery __cb, String query, omero.sys.Parameters params);

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findAllByQuery_async(AMI_IQuery_findAllByQuery __cb, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx);

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     * @return A list of loaded {@link omero.model.IObject}
     * instances. Never null.
     **/
    public java.util.List<omero.model.IObject> findAllByFullText(String klass, String query, omero.sys.Parameters params)
        throws omero.ServerError;

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     * @param __ctx The Context map to send with the invocation.
     * @return A list of loaded {@link omero.model.IObject}
     * instances. Never null.
     **/
    public java.util.List<omero.model.IObject> findAllByFullText(String klass, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByFullText(String klass, String query, omero.sys.Parameters params);

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByFullText(String klass, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx);

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByFullText(String klass, String query, omero.sys.Parameters params, Ice.Callback __cb);

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByFullText(String klass, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByFullText(String klass, String query, omero.sys.Parameters params, Callback_IQuery_findAllByFullText __cb);

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_findAllByFullText(String klass, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Callback_IQuery_findAllByFullText __cb);

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param __result The asynchronous result object.
     * @return A list of loaded {@link omero.model.IObject}
     * instances. Never null.
     **/
    public java.util.List<omero.model.IObject> end_findAllByFullText(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param __cb The callback object for the operation.
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     **/
    public boolean findAllByFullText_async(AMI_IQuery_findAllByFullText __cb, String klass, String query, omero.sys.Parameters params);

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param __cb The callback object for the operation.
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findAllByFullText_async(AMI_IQuery_findAllByFullText __cb, String klass, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx);

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     **/
    public java.util.List<java.util.List<omero.RType>> projection(String query, omero.sys.Parameters params)
        throws omero.ServerError;

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<java.util.List<omero.RType>> projection(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_projection(String query, omero.sys.Parameters params);

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_projection(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx);

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_projection(String query, omero.sys.Parameters params, Ice.Callback __cb);

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_projection(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_projection(String query, omero.sys.Parameters params, Callback_IQuery_projection __cb);

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_projection(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Callback_IQuery_projection __cb);

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __result The asynchronous result object.
     **/
    public java.util.List<java.util.List<omero.RType>> end_projection(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean projection_async(AMI_IQuery_projection __cb, String query, omero.sys.Parameters params);

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean projection_async(AMI_IQuery_projection __cb, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx);

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     * @return a similar {@link omero.model.IObject} graph (with
     * possible additions and deletions) which is in-sync
     * with the database.
     * @throws ApiUsageException if any non-managed entities are
     * found.
     **/
    public omero.model.IObject refresh(omero.model.IObject iObject)
        throws omero.ServerError;

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     * @param __ctx The Context map to send with the invocation.
     * @return a similar {@link omero.model.IObject} graph (with
     * possible additions and deletions) which is in-sync
     * with the database.
     * @throws ApiUsageException if any non-managed entities are
     * found.
     **/
    public omero.model.IObject refresh(omero.model.IObject iObject, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_refresh(omero.model.IObject iObject);

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_refresh(omero.model.IObject iObject, java.util.Map<String, String> __ctx);

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_refresh(omero.model.IObject iObject, Ice.Callback __cb);

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_refresh(omero.model.IObject iObject, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_refresh(omero.model.IObject iObject, Callback_IQuery_refresh __cb);

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_refresh(omero.model.IObject iObject, java.util.Map<String, String> __ctx, Callback_IQuery_refresh __cb);

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param __result The asynchronous result object.
     * @return a similar {@link omero.model.IObject} graph (with
     * possible additions and deletions) which is in-sync
     * with the database.
     * @throws ApiUsageException if any non-managed entities are
     * found.
     **/
    public omero.model.IObject end_refresh(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     **/
    public boolean refresh_async(AMI_IQuery_refresh __cb, omero.model.IObject iObject);

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean refresh_async(AMI_IQuery_refresh __cb, omero.model.IObject iObject, java.util.Map<String, String> __ctx);
}
