// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IQuery.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides methods for directly querying object graphs. As far as is
 * possible, IQuery should be considered the lowest level DB-access
 * (SELECT) interface.
 * Unlike the {@link omero.api.IUpdate} interface, using other methods
 * will most likely not leave the database in an inconsistent state,
 * but may provide stale data in some situations.
 * 
 * By convention, all methods that begin with <code>get</code> will
 * never return a null or empty {@link java.util.Collection}, but
 * instead will throw a {@link omero.ValidationException}.
 * 
 **/
public final class IQueryPrxHelper extends Ice.ObjectPrxHelperBase implements IQueryPrx
{
    private static final String __find_name = "find";

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param klass klass the type of the entity. Not null.
     * @param id the entity's id
     * @return an initialized entity or null if id doesn't exist.
     **/
    public omero.model.IObject find(String klass, long id)
        throws omero.ServerError
    {
        return find(klass, id, null, false);
    }

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param klass klass the type of the entity. Not null.
     * @param id the entity's id
     * @param __ctx The Context map to send with the invocation.
     * @return an initialized entity or null if id doesn't exist.
     **/
    public omero.model.IObject find(String klass, long id, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return find(klass, id, __ctx, true);
    }

    private omero.model.IObject find(String klass, long id, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "find", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("find");
                    __delBase = __getDelegate(false);
                    _IQueryDel __del = (_IQueryDel)__delBase;
                    return __del.find(klass, id, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param klass klass the type of the entity. Not null.
     **/
    public Ice.AsyncResult begin_find(String klass, long id)
    {
        return begin_find(klass, id, null, false, null);
    }

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param klass klass the type of the entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_find(String klass, long id, java.util.Map<String, String> __ctx)
    {
        return begin_find(klass, id, __ctx, true, null);
    }

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param klass klass the type of the entity. Not null.
     **/
    public Ice.AsyncResult begin_find(String klass, long id, Ice.Callback __cb)
    {
        return begin_find(klass, id, null, false, __cb);
    }

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param klass klass the type of the entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_find(String klass, long id, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_find(klass, id, __ctx, true, __cb);
    }

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param klass klass the type of the entity. Not null.
     **/
    public Ice.AsyncResult begin_find(String klass, long id, Callback_IQuery_find __cb)
    {
        return begin_find(klass, id, null, false, __cb);
    }

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param klass klass the type of the entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_find(String klass, long id, java.util.Map<String, String> __ctx, Callback_IQuery_find __cb)
    {
        return begin_find(klass, id, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_find(String klass, long id, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__find_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __find_name, __cb);
        try
        {
            __result.__prepare(__find_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(klass);
            __os.writeLong(id);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) an initialized entity or null if id doesn't exist.
     **/
    public omero.model.IObject end_find(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __find_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.IObjectHolder __ret = new omero.model.IObjectHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param klass klass the type of the entity. Not null.
     **/
    public boolean find_async(AMI_IQuery_find __cb, String klass, long id)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__find_name);
            __r = begin_find(klass, id, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __find_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param klass klass the type of the entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean find_async(AMI_IQuery_find __cb, String klass, long id, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__find_name);
            __r = begin_find(klass, id, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __find_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __findAll_name = "findAll";

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param klass entity type to be searched. Not null.
     * @param filter filters the result set. Can be null.
     * @return a collection if initialized entities or an empty
     * List if none exist.
     **/
    public java.util.List<omero.model.IObject> findAll(String klass, omero.sys.Filter filter)
        throws omero.ServerError
    {
        return findAll(klass, filter, null, false);
    }

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param klass entity type to be searched. Not null.
     * @param filter filters the result set. Can be null.
     * @param __ctx The Context map to send with the invocation.
     * @return a collection if initialized entities or an empty
     * List if none exist.
     **/
    public java.util.List<omero.model.IObject> findAll(String klass, omero.sys.Filter filter, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return findAll(klass, filter, __ctx, true);
    }

    private java.util.List<omero.model.IObject> findAll(String klass, omero.sys.Filter filter, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "findAll", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("findAll");
                    __delBase = __getDelegate(false);
                    _IQueryDel __del = (_IQueryDel)__delBase;
                    return __del.findAll(klass, filter, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param __cb The callback object for the operation.
     * @param klass entity type to be searched. Not null.
     **/
    public Ice.AsyncResult begin_findAll(String klass, omero.sys.Filter filter)
    {
        return begin_findAll(klass, filter, null, false, null);
    }

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param __cb The callback object for the operation.
     * @param klass entity type to be searched. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAll(String klass, omero.sys.Filter filter, java.util.Map<String, String> __ctx)
    {
        return begin_findAll(klass, filter, __ctx, true, null);
    }

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param __cb The callback object for the operation.
     * @param klass entity type to be searched. Not null.
     **/
    public Ice.AsyncResult begin_findAll(String klass, omero.sys.Filter filter, Ice.Callback __cb)
    {
        return begin_findAll(klass, filter, null, false, __cb);
    }

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param __cb The callback object for the operation.
     * @param klass entity type to be searched. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAll(String klass, omero.sys.Filter filter, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findAll(klass, filter, __ctx, true, __cb);
    }

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param __cb The callback object for the operation.
     * @param klass entity type to be searched. Not null.
     **/
    public Ice.AsyncResult begin_findAll(String klass, omero.sys.Filter filter, Callback_IQuery_findAll __cb)
    {
        return begin_findAll(klass, filter, null, false, __cb);
    }

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param __cb The callback object for the operation.
     * @param klass entity type to be searched. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAll(String klass, omero.sys.Filter filter, java.util.Map<String, String> __ctx, Callback_IQuery_findAll __cb)
    {
        return begin_findAll(klass, filter, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findAll(String klass, omero.sys.Filter filter, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findAll_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findAll_name, __cb);
        try
        {
            __result.__prepare(__findAll_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(klass);
            __os.writeObject(filter);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a collection if initialized entities or an empty
     * List if none exist.
     **/
    public java.util.List<omero.model.IObject> end_findAll(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __findAll_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.IObject> __ret;
            __ret = IObjectListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param __cb The callback object for the operation.
     * @param klass entity type to be searched. Not null.
     **/
    public boolean findAll_async(AMI_IQuery_findAll __cb, String klass, omero.sys.Filter filter)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findAll_name);
            __r = begin_findAll(klass, filter, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findAll_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param __cb The callback object for the operation.
     * @param klass entity type to be searched. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findAll_async(AMI_IQuery_findAll __cb, String klass, omero.sys.Filter filter, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findAll_name);
            __r = begin_findAll(klass, filter, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findAll_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __findAllByExample_name = "findAllByExample";

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param example Non-null example object.
     * @param filter filters the result set. Can be null.
     * @return Possibly empty List of IObject results.
     **/
    public java.util.List<omero.model.IObject> findAllByExample(omero.model.IObject example, omero.sys.Filter filter)
        throws omero.ServerError
    {
        return findAllByExample(example, filter, null, false);
    }

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param example Non-null example object.
     * @param filter filters the result set. Can be null.
     * @param __ctx The Context map to send with the invocation.
     * @return Possibly empty List of IObject results.
     **/
    public java.util.List<omero.model.IObject> findAllByExample(omero.model.IObject example, omero.sys.Filter filter, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return findAllByExample(example, filter, __ctx, true);
    }

    private java.util.List<omero.model.IObject> findAllByExample(omero.model.IObject example, omero.sys.Filter filter, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "findAllByExample", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("findAllByExample");
                    __delBase = __getDelegate(false);
                    _IQueryDel __del = (_IQueryDel)__delBase;
                    return __del.findAllByExample(example, filter, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     **/
    public Ice.AsyncResult begin_findAllByExample(omero.model.IObject example, omero.sys.Filter filter)
    {
        return begin_findAllByExample(example, filter, null, false, null);
    }

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAllByExample(omero.model.IObject example, omero.sys.Filter filter, java.util.Map<String, String> __ctx)
    {
        return begin_findAllByExample(example, filter, __ctx, true, null);
    }

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     **/
    public Ice.AsyncResult begin_findAllByExample(omero.model.IObject example, omero.sys.Filter filter, Ice.Callback __cb)
    {
        return begin_findAllByExample(example, filter, null, false, __cb);
    }

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAllByExample(omero.model.IObject example, omero.sys.Filter filter, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findAllByExample(example, filter, __ctx, true, __cb);
    }

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     **/
    public Ice.AsyncResult begin_findAllByExample(omero.model.IObject example, omero.sys.Filter filter, Callback_IQuery_findAllByExample __cb)
    {
        return begin_findAllByExample(example, filter, null, false, __cb);
    }

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAllByExample(omero.model.IObject example, omero.sys.Filter filter, java.util.Map<String, String> __ctx, Callback_IQuery_findAllByExample __cb)
    {
        return begin_findAllByExample(example, filter, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findAllByExample(omero.model.IObject example, omero.sys.Filter filter, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findAllByExample_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findAllByExample_name, __cb);
        try
        {
            __result.__prepare(__findAllByExample_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(example);
            __os.writeObject(filter);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Possibly empty List of IObject results.
     **/
    public java.util.List<omero.model.IObject> end_findAllByExample(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __findAllByExample_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.IObject> __ret;
            __ret = IObjectListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     **/
    public boolean findAllByExample_async(AMI_IQuery_findAllByExample __cb, omero.model.IObject example, omero.sys.Filter filter)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findAllByExample_name);
            __r = begin_findAllByExample(example, filter, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findAllByExample_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findAllByExample_async(AMI_IQuery_findAllByExample __cb, omero.model.IObject example, omero.sys.Filter filter, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findAllByExample_name);
            __r = begin_findAllByExample(example, filter, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findAllByExample_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __findAllByFullText_name = "findAllByFullText";

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     * @return A list of loaded {@link omero.model.IObject}
     * instances. Never null.
     **/
    public java.util.List<omero.model.IObject> findAllByFullText(String klass, String query, omero.sys.Parameters params)
        throws omero.ServerError
    {
        return findAllByFullText(klass, query, params, null, false);
    }

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     * @param __ctx The Context map to send with the invocation.
     * @return A list of loaded {@link omero.model.IObject}
     * instances. Never null.
     **/
    public java.util.List<omero.model.IObject> findAllByFullText(String klass, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return findAllByFullText(klass, query, params, __ctx, true);
    }

    private java.util.List<omero.model.IObject> findAllByFullText(String klass, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "findAllByFullText", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("findAllByFullText");
                    __delBase = __getDelegate(false);
                    _IQueryDel __del = (_IQueryDel)__delBase;
                    return __del.findAllByFullText(klass, query, params, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param __cb The callback object for the operation.
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     **/
    public Ice.AsyncResult begin_findAllByFullText(String klass, String query, omero.sys.Parameters params)
    {
        return begin_findAllByFullText(klass, query, params, null, false, null);
    }

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param __cb The callback object for the operation.
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAllByFullText(String klass, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
    {
        return begin_findAllByFullText(klass, query, params, __ctx, true, null);
    }

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param __cb The callback object for the operation.
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     **/
    public Ice.AsyncResult begin_findAllByFullText(String klass, String query, omero.sys.Parameters params, Ice.Callback __cb)
    {
        return begin_findAllByFullText(klass, query, params, null, false, __cb);
    }

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param __cb The callback object for the operation.
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAllByFullText(String klass, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findAllByFullText(klass, query, params, __ctx, true, __cb);
    }

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param __cb The callback object for the operation.
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     **/
    public Ice.AsyncResult begin_findAllByFullText(String klass, String query, omero.sys.Parameters params, Callback_IQuery_findAllByFullText __cb)
    {
        return begin_findAllByFullText(klass, query, params, null, false, __cb);
    }

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param __cb The callback object for the operation.
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAllByFullText(String klass, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Callback_IQuery_findAllByFullText __cb)
    {
        return begin_findAllByFullText(klass, query, params, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findAllByFullText(String klass, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findAllByFullText_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findAllByFullText_name, __cb);
        try
        {
            __result.__prepare(__findAllByFullText_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(klass);
            __os.writeString(query);
            __os.writeObject(params);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) A list of loaded {@link omero.model.IObject}
     * instances. Never null.
     **/
    public java.util.List<omero.model.IObject> end_findAllByFullText(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __findAllByFullText_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.IObject> __ret;
            __ret = IObjectListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param __cb The callback object for the operation.
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     **/
    public boolean findAllByFullText_async(AMI_IQuery_findAllByFullText __cb, String klass, String query, omero.sys.Parameters params)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findAllByFullText_name);
            __r = begin_findAllByFullText(klass, query, params, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findAllByFullText_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param __cb The callback object for the operation.
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findAllByFullText_async(AMI_IQuery_findAllByFullText __cb, String klass, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findAllByFullText_name);
            __r = begin_findAllByFullText(klass, query, params, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findAllByFullText_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __findAllByQuery_name = "findAllByQuery";

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param query Query to execute. Not null.
     * @param params
     * @return Possibly empty List of IObject results.
     **/
    public java.util.List<omero.model.IObject> findAllByQuery(String query, omero.sys.Parameters params)
        throws omero.ServerError
    {
        return findAllByQuery(query, params, null, false);
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param query Query to execute. Not null.
     * @param params
     * @param __ctx The Context map to send with the invocation.
     * @return Possibly empty List of IObject results.
     **/
    public java.util.List<omero.model.IObject> findAllByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return findAllByQuery(query, params, __ctx, true);
    }

    private java.util.List<omero.model.IObject> findAllByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "findAllByQuery", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("findAllByQuery");
                    __delBase = __getDelegate(false);
                    _IQueryDel __del = (_IQueryDel)__delBase;
                    return __del.findAllByQuery(query, params, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute. Not null.
     **/
    public Ice.AsyncResult begin_findAllByQuery(String query, omero.sys.Parameters params)
    {
        return begin_findAllByQuery(query, params, null, false, null);
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAllByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
    {
        return begin_findAllByQuery(query, params, __ctx, true, null);
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute. Not null.
     **/
    public Ice.AsyncResult begin_findAllByQuery(String query, omero.sys.Parameters params, Ice.Callback __cb)
    {
        return begin_findAllByQuery(query, params, null, false, __cb);
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAllByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findAllByQuery(query, params, __ctx, true, __cb);
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute. Not null.
     **/
    public Ice.AsyncResult begin_findAllByQuery(String query, omero.sys.Parameters params, Callback_IQuery_findAllByQuery __cb)
    {
        return begin_findAllByQuery(query, params, null, false, __cb);
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAllByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Callback_IQuery_findAllByQuery __cb)
    {
        return begin_findAllByQuery(query, params, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findAllByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findAllByQuery_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findAllByQuery_name, __cb);
        try
        {
            __result.__prepare(__findAllByQuery_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(query);
            __os.writeObject(params);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Possibly empty List of IObject results.
     **/
    public java.util.List<omero.model.IObject> end_findAllByQuery(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __findAllByQuery_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.IObject> __ret;
            __ret = IObjectListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute. Not null.
     **/
    public boolean findAllByQuery_async(AMI_IQuery_findAllByQuery __cb, String query, omero.sys.Parameters params)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findAllByQuery_name);
            __r = begin_findAllByQuery(query, params, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findAllByQuery_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findAllByQuery_async(AMI_IQuery_findAllByQuery __cb, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findAllByQuery_name);
            __r = begin_findAllByQuery(query, params, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findAllByQuery_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __findAllByString_name = "findAllByString";

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param klass type of entity to be searched. Not null.
     * @param field the name of the field, either as simple string
     * or as public final static from the entity
     * class, e.g. {@link omero.model.Project#NAME}.
     * Not null.
     * @param value String used for search. Not null.
     * @param caseSensitive whether to use LIKE or ILIKE
     * @param filter filters the result set. Can be null.
     * @return A list (possibly empty) with the results.
     **/
    public java.util.List<omero.model.IObject> findAllByString(String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter)
        throws omero.ServerError
    {
        return findAllByString(klass, field, value, caseSensitive, filter, null, false);
    }

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param klass type of entity to be searched. Not null.
     * @param field the name of the field, either as simple string
     * or as public final static from the entity
     * class, e.g. {@link omero.model.Project#NAME}.
     * Not null.
     * @param value String used for search. Not null.
     * @param caseSensitive whether to use LIKE or ILIKE
     * @param filter filters the result set. Can be null.
     * @param __ctx The Context map to send with the invocation.
     * @return A list (possibly empty) with the results.
     **/
    public java.util.List<omero.model.IObject> findAllByString(String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return findAllByString(klass, field, value, caseSensitive, filter, __ctx, true);
    }

    private java.util.List<omero.model.IObject> findAllByString(String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "findAllByString", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("findAllByString");
                    __delBase = __getDelegate(false);
                    _IQueryDel __del = (_IQueryDel)__delBase;
                    return __del.findAllByString(klass, field, value, caseSensitive, filter, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched. Not null.
     * @param value String used for search. Not null.
     * @param filter filters the result set. Can be null.
     **/
    public Ice.AsyncResult begin_findAllByString(String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter)
    {
        return begin_findAllByString(klass, field, value, caseSensitive, filter, null, false, null);
    }

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched. Not null.
     * @param value String used for search. Not null.
     * @param filter filters the result set. Can be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAllByString(String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter, java.util.Map<String, String> __ctx)
    {
        return begin_findAllByString(klass, field, value, caseSensitive, filter, __ctx, true, null);
    }

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched. Not null.
     * @param value String used for search. Not null.
     * @param filter filters the result set. Can be null.
     **/
    public Ice.AsyncResult begin_findAllByString(String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter, Ice.Callback __cb)
    {
        return begin_findAllByString(klass, field, value, caseSensitive, filter, null, false, __cb);
    }

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched. Not null.
     * @param value String used for search. Not null.
     * @param filter filters the result set. Can be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAllByString(String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findAllByString(klass, field, value, caseSensitive, filter, __ctx, true, __cb);
    }

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched. Not null.
     * @param value String used for search. Not null.
     * @param filter filters the result set. Can be null.
     **/
    public Ice.AsyncResult begin_findAllByString(String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter, Callback_IQuery_findAllByString __cb)
    {
        return begin_findAllByString(klass, field, value, caseSensitive, filter, null, false, __cb);
    }

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched. Not null.
     * @param value String used for search. Not null.
     * @param filter filters the result set. Can be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAllByString(String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter, java.util.Map<String, String> __ctx, Callback_IQuery_findAllByString __cb)
    {
        return begin_findAllByString(klass, field, value, caseSensitive, filter, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findAllByString(String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findAllByString_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findAllByString_name, __cb);
        try
        {
            __result.__prepare(__findAllByString_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(klass);
            __os.writeString(field);
            __os.writeString(value);
            __os.writeBool(caseSensitive);
            __os.writeObject(filter);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) A list (possibly empty) with the results.
     **/
    public java.util.List<omero.model.IObject> end_findAllByString(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __findAllByString_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.IObject> __ret;
            __ret = IObjectListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched. Not null.
     * @param value String used for search. Not null.
     * @param filter filters the result set. Can be null.
     **/
    public boolean findAllByString_async(AMI_IQuery_findAllByString __cb, String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findAllByString_name);
            __r = begin_findAllByString(klass, field, value, caseSensitive, filter, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findAllByString_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched. Not null.
     * @param value String used for search. Not null.
     * @param filter filters the result set. Can be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findAllByString_async(AMI_IQuery_findAllByString __cb, String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findAllByString_name);
            __r = begin_findAllByString(klass, field, value, caseSensitive, filter, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findAllByString_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __findByExample_name = "findByExample";

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param example Non-null example object.
     * @return Possibly null IObject result.
     * @throws ApiUsageException if more than one result is return.
     **/
    public omero.model.IObject findByExample(omero.model.IObject example)
        throws omero.ServerError
    {
        return findByExample(example, null, false);
    }

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param example Non-null example object.
     * @param __ctx The Context map to send with the invocation.
     * @return Possibly null IObject result.
     * @throws ApiUsageException if more than one result is return.
     **/
    public omero.model.IObject findByExample(omero.model.IObject example, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return findByExample(example, __ctx, true);
    }

    private omero.model.IObject findByExample(omero.model.IObject example, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "findByExample", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("findByExample");
                    __delBase = __getDelegate(false);
                    _IQueryDel __del = (_IQueryDel)__delBase;
                    return __del.findByExample(example, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     **/
    public Ice.AsyncResult begin_findByExample(omero.model.IObject example)
    {
        return begin_findByExample(example, null, false, null);
    }

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findByExample(omero.model.IObject example, java.util.Map<String, String> __ctx)
    {
        return begin_findByExample(example, __ctx, true, null);
    }

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     **/
    public Ice.AsyncResult begin_findByExample(omero.model.IObject example, Ice.Callback __cb)
    {
        return begin_findByExample(example, null, false, __cb);
    }

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findByExample(omero.model.IObject example, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findByExample(example, __ctx, true, __cb);
    }

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     **/
    public Ice.AsyncResult begin_findByExample(omero.model.IObject example, Callback_IQuery_findByExample __cb)
    {
        return begin_findByExample(example, null, false, __cb);
    }

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findByExample(omero.model.IObject example, java.util.Map<String, String> __ctx, Callback_IQuery_findByExample __cb)
    {
        return begin_findByExample(example, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findByExample(omero.model.IObject example, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findByExample_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findByExample_name, __cb);
        try
        {
            __result.__prepare(__findByExample_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(example);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Possibly null IObject result.
     **/
    public omero.model.IObject end_findByExample(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __findByExample_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.IObjectHolder __ret = new omero.model.IObjectHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     **/
    public boolean findByExample_async(AMI_IQuery_findByExample __cb, omero.model.IObject example)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findByExample_name);
            __r = begin_findByExample(example, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findByExample_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findByExample_async(AMI_IQuery_findByExample __cb, omero.model.IObject example, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findByExample_name);
            __r = begin_findByExample(example, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findByExample_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __findByQuery_name = "findByQuery";

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param query Query to execute
     * @param params
     * @return Possibly null IObject result.
     * @throws ValidationException
     **/
    public omero.model.IObject findByQuery(String query, omero.sys.Parameters params)
        throws omero.ServerError
    {
        return findByQuery(query, params, null, false);
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param query Query to execute
     * @param params
     * @param __ctx The Context map to send with the invocation.
     * @return Possibly null IObject result.
     * @throws ValidationException
     **/
    public omero.model.IObject findByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return findByQuery(query, params, __ctx, true);
    }

    private omero.model.IObject findByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "findByQuery", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("findByQuery");
                    __delBase = __getDelegate(false);
                    _IQueryDel __del = (_IQueryDel)__delBase;
                    return __del.findByQuery(query, params, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute
     **/
    public Ice.AsyncResult begin_findByQuery(String query, omero.sys.Parameters params)
    {
        return begin_findByQuery(query, params, null, false, null);
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
    {
        return begin_findByQuery(query, params, __ctx, true, null);
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute
     **/
    public Ice.AsyncResult begin_findByQuery(String query, omero.sys.Parameters params, Ice.Callback __cb)
    {
        return begin_findByQuery(query, params, null, false, __cb);
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findByQuery(query, params, __ctx, true, __cb);
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute
     **/
    public Ice.AsyncResult begin_findByQuery(String query, omero.sys.Parameters params, Callback_IQuery_findByQuery __cb)
    {
        return begin_findByQuery(query, params, null, false, __cb);
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Callback_IQuery_findByQuery __cb)
    {
        return begin_findByQuery(query, params, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findByQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findByQuery_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findByQuery_name, __cb);
        try
        {
            __result.__prepare(__findByQuery_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(query);
            __os.writeObject(params);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Possibly null IObject result.
     **/
    public omero.model.IObject end_findByQuery(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __findByQuery_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.IObjectHolder __ret = new omero.model.IObjectHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute
     **/
    public boolean findByQuery_async(AMI_IQuery_findByQuery __cb, String query, omero.sys.Parameters params)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findByQuery_name);
            __r = begin_findByQuery(query, params, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findByQuery_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findByQuery_async(AMI_IQuery_findByQuery __cb, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findByQuery_name);
            __r = begin_findByQuery(query, params, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findByQuery_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __findByString_name = "findByString";

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param klass type of entity to be searched
     * @param field the name of the field, either as simple string
     * or as public final static from the entity
     * class, e.g. {@link omero.model.Project#NAME}
     * @param value String used for search.
     * @return found entity or possibly null.
     * @throws ome.conditions.ApiUsageException
     * if more than one result.
     **/
    public omero.model.IObject findByString(String klass, String field, String value)
        throws omero.ServerError
    {
        return findByString(klass, field, value, null, false);
    }

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param klass type of entity to be searched
     * @param field the name of the field, either as simple string
     * or as public final static from the entity
     * class, e.g. {@link omero.model.Project#NAME}
     * @param value String used for search.
     * @param __ctx The Context map to send with the invocation.
     * @return found entity or possibly null.
     * @throws ome.conditions.ApiUsageException
     * if more than one result.
     **/
    public omero.model.IObject findByString(String klass, String field, String value, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return findByString(klass, field, value, __ctx, true);
    }

    private omero.model.IObject findByString(String klass, String field, String value, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "findByString", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("findByString");
                    __delBase = __getDelegate(false);
                    _IQueryDel __del = (_IQueryDel)__delBase;
                    return __del.findByString(klass, field, value, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched
     * @param value String used for search.
     **/
    public Ice.AsyncResult begin_findByString(String klass, String field, String value)
    {
        return begin_findByString(klass, field, value, null, false, null);
    }

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched
     * @param value String used for search.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findByString(String klass, String field, String value, java.util.Map<String, String> __ctx)
    {
        return begin_findByString(klass, field, value, __ctx, true, null);
    }

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched
     * @param value String used for search.
     **/
    public Ice.AsyncResult begin_findByString(String klass, String field, String value, Ice.Callback __cb)
    {
        return begin_findByString(klass, field, value, null, false, __cb);
    }

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched
     * @param value String used for search.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findByString(String klass, String field, String value, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findByString(klass, field, value, __ctx, true, __cb);
    }

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched
     * @param value String used for search.
     **/
    public Ice.AsyncResult begin_findByString(String klass, String field, String value, Callback_IQuery_findByString __cb)
    {
        return begin_findByString(klass, field, value, null, false, __cb);
    }

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched
     * @param value String used for search.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findByString(String klass, String field, String value, java.util.Map<String, String> __ctx, Callback_IQuery_findByString __cb)
    {
        return begin_findByString(klass, field, value, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findByString(String klass, String field, String value, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findByString_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findByString_name, __cb);
        try
        {
            __result.__prepare(__findByString_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(klass);
            __os.writeString(field);
            __os.writeString(value);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) found entity or possibly null.
     **/
    public omero.model.IObject end_findByString(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __findByString_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.IObjectHolder __ret = new omero.model.IObjectHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched
     * @param value String used for search.
     **/
    public boolean findByString_async(AMI_IQuery_findByString __cb, String klass, String field, String value)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findByString_name);
            __r = begin_findByString(klass, field, value, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findByString_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched
     * @param value String used for search.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean findByString_async(AMI_IQuery_findByString __cb, String klass, String field, String value, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findByString_name);
            __r = begin_findByString(klass, field, value, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findByString_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __get_name = "get";

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param klass the type of the entity. Not null.
     * @param id the entity's id
     * @return an initialized entity
     * @throws ValidationException if the id doesn't exist.
     **/
    public omero.model.IObject get(String klass, long id)
        throws omero.ServerError
    {
        return get(klass, id, null, false);
    }

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param klass the type of the entity. Not null.
     * @param id the entity's id
     * @param __ctx The Context map to send with the invocation.
     * @return an initialized entity
     * @throws ValidationException if the id doesn't exist.
     **/
    public omero.model.IObject get(String klass, long id, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return get(klass, id, __ctx, true);
    }

    private omero.model.IObject get(String klass, long id, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "get", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("get");
                    __delBase = __getDelegate(false);
                    _IQueryDel __del = (_IQueryDel)__delBase;
                    return __del.get(klass, id, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param klass the type of the entity. Not null.
     **/
    public Ice.AsyncResult begin_get(String klass, long id)
    {
        return begin_get(klass, id, null, false, null);
    }

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param klass the type of the entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_get(String klass, long id, java.util.Map<String, String> __ctx)
    {
        return begin_get(klass, id, __ctx, true, null);
    }

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param klass the type of the entity. Not null.
     **/
    public Ice.AsyncResult begin_get(String klass, long id, Ice.Callback __cb)
    {
        return begin_get(klass, id, null, false, __cb);
    }

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param klass the type of the entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_get(String klass, long id, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_get(klass, id, __ctx, true, __cb);
    }

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param klass the type of the entity. Not null.
     **/
    public Ice.AsyncResult begin_get(String klass, long id, Callback_IQuery_get __cb)
    {
        return begin_get(klass, id, null, false, __cb);
    }

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param klass the type of the entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_get(String klass, long id, java.util.Map<String, String> __ctx, Callback_IQuery_get __cb)
    {
        return begin_get(klass, id, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_get(String klass, long id, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__get_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __get_name, __cb);
        try
        {
            __result.__prepare(__get_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(klass);
            __os.writeLong(id);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) an initialized entity
     **/
    public omero.model.IObject end_get(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __get_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.IObjectHolder __ret = new omero.model.IObjectHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param klass the type of the entity. Not null.
     **/
    public boolean get_async(AMI_IQuery_get __cb, String klass, long id)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__get_name);
            __r = begin_get(klass, id, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __get_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param klass the type of the entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean get_async(AMI_IQuery_get __cb, String klass, long id, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__get_name);
            __r = begin_get(klass, id, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __get_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __projection_name = "projection";

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     **/
    public java.util.List<java.util.List<omero.RType>> projection(String query, omero.sys.Parameters params)
        throws omero.ServerError
    {
        return projection(query, params, null, false);
    }

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<java.util.List<omero.RType>> projection(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return projection(query, params, __ctx, true);
    }

    private java.util.List<java.util.List<omero.RType>> projection(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "projection", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("projection");
                    __delBase = __getDelegate(false);
                    _IQueryDel __del = (_IQueryDel)__delBase;
                    return __del.projection(query, params, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_projection(String query, omero.sys.Parameters params)
    {
        return begin_projection(query, params, null, false, null);
    }

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_projection(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
    {
        return begin_projection(query, params, __ctx, true, null);
    }

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_projection(String query, omero.sys.Parameters params, Ice.Callback __cb)
    {
        return begin_projection(query, params, null, false, __cb);
    }

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_projection(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_projection(query, params, __ctx, true, __cb);
    }

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_projection(String query, omero.sys.Parameters params, Callback_IQuery_projection __cb)
    {
        return begin_projection(query, params, null, false, __cb);
    }

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_projection(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Callback_IQuery_projection __cb)
    {
        return begin_projection(query, params, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_projection(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__projection_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __projection_name, __cb);
        try
        {
            __result.__prepare(__projection_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(query);
            __os.writeObject(params);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.List<java.util.List<omero.RType>> end_projection(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __projection_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<java.util.List<omero.RType>> __ret;
            __ret = omero.RTypeSeqSeqHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean projection_async(AMI_IQuery_projection __cb, String query, omero.sys.Parameters params)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__projection_name);
            __r = begin_projection(query, params, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __projection_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean projection_async(AMI_IQuery_projection __cb, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__projection_name);
            __r = begin_projection(query, params, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __projection_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __refresh_name = "refresh";

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     * @return a similar {@link omero.model.IObject} graph (with
     * possible additions and deletions) which is in-sync
     * with the database.
     * @throws ApiUsageException if any non-managed entities are
     * found.
     **/
    public omero.model.IObject refresh(omero.model.IObject iObject)
        throws omero.ServerError
    {
        return refresh(iObject, null, false);
    }

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     * @param __ctx The Context map to send with the invocation.
     * @return a similar {@link omero.model.IObject} graph (with
     * possible additions and deletions) which is in-sync
     * with the database.
     * @throws ApiUsageException if any non-managed entities are
     * found.
     **/
    public omero.model.IObject refresh(omero.model.IObject iObject, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return refresh(iObject, __ctx, true);
    }

    private omero.model.IObject refresh(omero.model.IObject iObject, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "refresh", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("refresh");
                    __delBase = __getDelegate(false);
                    _IQueryDel __del = (_IQueryDel)__delBase;
                    return __del.refresh(iObject, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     **/
    public Ice.AsyncResult begin_refresh(omero.model.IObject iObject)
    {
        return begin_refresh(iObject, null, false, null);
    }

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_refresh(omero.model.IObject iObject, java.util.Map<String, String> __ctx)
    {
        return begin_refresh(iObject, __ctx, true, null);
    }

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     **/
    public Ice.AsyncResult begin_refresh(omero.model.IObject iObject, Ice.Callback __cb)
    {
        return begin_refresh(iObject, null, false, __cb);
    }

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_refresh(omero.model.IObject iObject, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_refresh(iObject, __ctx, true, __cb);
    }

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     **/
    public Ice.AsyncResult begin_refresh(omero.model.IObject iObject, Callback_IQuery_refresh __cb)
    {
        return begin_refresh(iObject, null, false, __cb);
    }

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_refresh(omero.model.IObject iObject, java.util.Map<String, String> __ctx, Callback_IQuery_refresh __cb)
    {
        return begin_refresh(iObject, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_refresh(omero.model.IObject iObject, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__refresh_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __refresh_name, __cb);
        try
        {
            __result.__prepare(__refresh_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(iObject);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a similar {@link omero.model.IObject} graph (with
     * possible additions and deletions) which is in-sync
     * with the database.
     **/
    public omero.model.IObject end_refresh(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __refresh_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.IObjectHolder __ret = new omero.model.IObjectHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     **/
    public boolean refresh_async(AMI_IQuery_refresh __cb, omero.model.IObject iObject)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__refresh_name);
            __r = begin_refresh(iObject, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __refresh_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean refresh_async(AMI_IQuery_refresh __cb, omero.model.IObject iObject, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__refresh_name);
            __r = begin_refresh(iObject, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __refresh_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static IQueryPrx checkedCast(Ice.ObjectPrx __obj)
    {
        IQueryPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IQueryPrx)
            {
                __d = (IQueryPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    IQueryPrxHelper __h = new IQueryPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static IQueryPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        IQueryPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IQueryPrx)
            {
                __d = (IQueryPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    IQueryPrxHelper __h = new IQueryPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static IQueryPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        IQueryPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    IQueryPrxHelper __h = new IQueryPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static IQueryPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        IQueryPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    IQueryPrxHelper __h = new IQueryPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static IQueryPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        IQueryPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IQueryPrx)
            {
                __d = (IQueryPrx)__obj;
            }
            else
            {
                IQueryPrxHelper __h = new IQueryPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static IQueryPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        IQueryPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            IQueryPrxHelper __h = new IQueryPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IQuery",
        "::omero::api::ServiceInterface"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _IQueryDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _IQueryDelD();
    }

    public static void __write(IceInternal.BasicStream __os, IQueryPrx v)
    {
        __os.writeProxy(v);
    }

    public static IQueryPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            IQueryPrxHelper result = new IQueryPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
