// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IRenderingSettings.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides method to apply rendering settings to a collection of
 * images.
 * All methods will receive the id of the pixels set to copy the
 * rendering settings from.
 **/
public interface IRenderingSettingsPrx extends ServiceInterfacePrx
{
    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param pFrom The pixels set to copy the settings from.
     * @param pTo The pixels set to copy the settings to.
     * @return See above.
     **/
    public boolean sanityCheckPixels(omero.model.Pixels pFrom, omero.model.Pixels pTo)
        throws omero.ServerError;

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param pFrom The pixels set to copy the settings from.
     * @param pTo The pixels set to copy the settings to.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public boolean sanityCheckPixels(omero.model.Pixels pFrom, omero.model.Pixels pTo, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param pFrom The pixels set to copy the settings from.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sanityCheckPixels(omero.model.Pixels pFrom, omero.model.Pixels pTo);

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param pFrom The pixels set to copy the settings from.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sanityCheckPixels(omero.model.Pixels pFrom, omero.model.Pixels pTo, java.util.Map<String, String> __ctx);

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param pFrom The pixels set to copy the settings from.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sanityCheckPixels(omero.model.Pixels pFrom, omero.model.Pixels pTo, Ice.Callback __cb);

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param pFrom The pixels set to copy the settings from.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sanityCheckPixels(omero.model.Pixels pFrom, omero.model.Pixels pTo, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param pFrom The pixels set to copy the settings from.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sanityCheckPixels(omero.model.Pixels pFrom, omero.model.Pixels pTo, Callback_IRenderingSettings_sanityCheckPixels __cb);

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param pFrom The pixels set to copy the settings from.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sanityCheckPixels(omero.model.Pixels pFrom, omero.model.Pixels pTo, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_sanityCheckPixels __cb);

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param __result The asynchronous result object.
     * @return See above.
     **/
    public boolean end_sanityCheckPixels(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param pFrom The pixels set to copy the settings from.
     **/
    public boolean sanityCheckPixels_async(AMI_IRenderingSettings_sanityCheckPixels __cb, omero.model.Pixels pFrom, omero.model.Pixels pTo);

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param pFrom The pixels set to copy the settings from.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean sanityCheckPixels_async(AMI_IRenderingSettings_sanityCheckPixels __cb, omero.model.Pixels pFrom, omero.model.Pixels pTo, java.util.Map<String, String> __ctx);

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param pixelsId The Id of the Pixels
     * @return See above.
     * @throws ValidationException if the image qualified by
     * <code>imageId</code> is unlocatable.
     **/
    public omero.model.RenderingDef getRenderingSettings(long pixelsId)
        throws omero.ServerError;

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param pixelsId The Id of the Pixels
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     * @throws ValidationException if the image qualified by
     * <code>imageId</code> is unlocatable.
     **/
    public omero.model.RenderingDef getRenderingSettings(long pixelsId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param pixelsId The Id of the Pixels
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRenderingSettings(long pixelsId);

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param pixelsId The Id of the Pixels
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRenderingSettings(long pixelsId, java.util.Map<String, String> __ctx);

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param pixelsId The Id of the Pixels
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRenderingSettings(long pixelsId, Ice.Callback __cb);

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param pixelsId The Id of the Pixels
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRenderingSettings(long pixelsId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param pixelsId The Id of the Pixels
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRenderingSettings(long pixelsId, Callback_IRenderingSettings_getRenderingSettings __cb);

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param pixelsId The Id of the Pixels
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRenderingSettings(long pixelsId, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_getRenderingSettings __cb);

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param __result The asynchronous result object.
     * @return See above.
     * @throws ValidationException if the image qualified by
     * <code>imageId</code> is unlocatable.
     **/
    public omero.model.RenderingDef end_getRenderingSettings(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels
     **/
    public boolean getRenderingSettings_async(AMI_IRenderingSettings_getRenderingSettings __cb, long pixelsId);

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getRenderingSettings_async(AMI_IRenderingSettings_getRenderingSettings __cb, long pixelsId, java.util.Map<String, String> __ctx);

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param pixels The Pixels set to link to the rendering
     * definition.
     * @return A new, blank rendering definition and sub-objects.
     * <b>NOTE:</b> the linked Pixels has been unloaded.
     **/
    public omero.model.RenderingDef createNewRenderingDef(omero.model.Pixels pixels)
        throws omero.ServerError;

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param pixels The Pixels set to link to the rendering
     * definition.
     * @param __ctx The Context map to send with the invocation.
     * @return A new, blank rendering definition and sub-objects.
     * <b>NOTE:</b> the linked Pixels has been unloaded.
     **/
    public omero.model.RenderingDef createNewRenderingDef(omero.model.Pixels pixels, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param pixels The Pixels set to link to the rendering
     * definition.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createNewRenderingDef(omero.model.Pixels pixels);

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param pixels The Pixels set to link to the rendering
     * definition.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createNewRenderingDef(omero.model.Pixels pixels, java.util.Map<String, String> __ctx);

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param pixels The Pixels set to link to the rendering
     * definition.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createNewRenderingDef(omero.model.Pixels pixels, Ice.Callback __cb);

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param pixels The Pixels set to link to the rendering
     * definition.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createNewRenderingDef(omero.model.Pixels pixels, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param pixels The Pixels set to link to the rendering
     * definition.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createNewRenderingDef(omero.model.Pixels pixels, Callback_IRenderingSettings_createNewRenderingDef __cb);

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param pixels The Pixels set to link to the rendering
     * definition.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createNewRenderingDef(omero.model.Pixels pixels, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_createNewRenderingDef __cb);

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param __result The asynchronous result object.
     * @return A new, blank rendering definition and sub-objects.
     * <b>NOTE:</b> the linked Pixels has been unloaded.
     **/
    public omero.model.RenderingDef end_createNewRenderingDef(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param __cb The callback object for the operation.
     * @param pixels The Pixels set to link to the rendering
     * definition.
     **/
    public boolean createNewRenderingDef_async(AMI_IRenderingSettings_createNewRenderingDef __cb, omero.model.Pixels pixels);

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param __cb The callback object for the operation.
     * @param pixels The Pixels set to link to the rendering
     * definition.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createNewRenderingDef_async(AMI_IRenderingSettings_createNewRenderingDef __cb, omero.model.Pixels pixels, java.util.Map<String, String> __ctx);

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     **/
    public void resetDefaults(omero.model.RenderingDef def, omero.model.Pixels pixels)
        throws omero.ServerError;

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void resetDefaults(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaults(omero.model.RenderingDef def, omero.model.Pixels pixels);

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaults(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx);

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaults(omero.model.RenderingDef def, omero.model.Pixels pixels, Ice.Callback __cb);

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaults(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaults(omero.model.RenderingDef def, omero.model.Pixels pixels, Callback_IRenderingSettings_resetDefaults __cb);

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaults(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_resetDefaults __cb);

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_resetDefaults(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     **/
    public boolean resetDefaults_async(AMI_IRenderingSettings_resetDefaults __cb, omero.model.RenderingDef def, omero.model.Pixels pixels);

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaults_async(AMI_IRenderingSettings_resetDefaults __cb, omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx);

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @return <code>def</code> with the rendering settings reset.
     **/
    public omero.model.RenderingDef resetDefaultsNoSave(omero.model.RenderingDef def, omero.model.Pixels pixels)
        throws omero.ServerError;

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     * @return <code>def</code> with the rendering settings reset.
     **/
    public omero.model.RenderingDef resetDefaultsNoSave(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsNoSave(omero.model.RenderingDef def, omero.model.Pixels pixels);

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsNoSave(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx);

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsNoSave(omero.model.RenderingDef def, omero.model.Pixels pixels, Ice.Callback __cb);

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsNoSave(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsNoSave(omero.model.RenderingDef def, omero.model.Pixels pixels, Callback_IRenderingSettings_resetDefaultsNoSave __cb);

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsNoSave(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_resetDefaultsNoSave __cb);

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param __result The asynchronous result object.
     * @return <code>def</code> with the rendering settings reset.
     **/
    public omero.model.RenderingDef end_resetDefaultsNoSave(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     **/
    public boolean resetDefaultsNoSave_async(AMI_IRenderingSettings_resetDefaultsNoSave __cb, omero.model.RenderingDef def, omero.model.Pixels pixels);

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaultsNoSave_async(AMI_IRenderingSettings_resetDefaultsNoSave __cb, omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx);

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param imageId The Id of the Image.
     * @throws ValidationException if the image qualified by
     * <code>imageId</code> is unlocatable.
     **/
    public void resetDefaultsInImage(long imageId)
        throws omero.ServerError;

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param imageId The Id of the Image.
     * @throws ValidationException if the image qualified by
     * <code>imageId</code> is unlocatable.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void resetDefaultsInImage(long imageId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param imageId The Id of the Image.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsInImage(long imageId);

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param imageId The Id of the Image.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsInImage(long imageId, java.util.Map<String, String> __ctx);

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param imageId The Id of the Image.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsInImage(long imageId, Ice.Callback __cb);

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param imageId The Id of the Image.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsInImage(long imageId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param imageId The Id of the Image.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsInImage(long imageId, Callback_IRenderingSettings_resetDefaultsInImage __cb);

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param imageId The Id of the Image.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsInImage(long imageId, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_resetDefaultsInImage __cb);

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __result The asynchronous result object.
     * @throws ValidationException if the image qualified by
     * <code>imageId</code> is unlocatable.
     **/
    public void end_resetDefaultsInImage(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     **/
    public boolean resetDefaultsInImage_async(AMI_IRenderingSettings_resetDefaultsInImage __cb, long imageId);

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaultsInImage_async(AMI_IRenderingSettings_resetDefaultsInImage __cb, long imageId, java.util.Map<String, String> __ctx);

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param pixelsId The Id of the Pixels.
     * @throws ValidationException if the Pixels qualified by
     * <code>pixelsId</code> is unlocatable.
     **/
    public void resetDefaultsForPixels(long pixelsId)
        throws omero.ServerError;

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param pixelsId The Id of the Pixels.
     * @throws ValidationException if the Pixels qualified by
     * <code>pixelsId</code> is unlocatable.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void resetDefaultsForPixels(long pixelsId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param pixelsId The Id of the Pixels.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsForPixels(long pixelsId);

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param pixelsId The Id of the Pixels.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsForPixels(long pixelsId, java.util.Map<String, String> __ctx);

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param pixelsId The Id of the Pixels.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsForPixels(long pixelsId, Ice.Callback __cb);

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param pixelsId The Id of the Pixels.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsForPixels(long pixelsId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param pixelsId The Id of the Pixels.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsForPixels(long pixelsId, Callback_IRenderingSettings_resetDefaultsForPixels __cb);

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param pixelsId The Id of the Pixels.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsForPixels(long pixelsId, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_resetDefaultsForPixels __cb);

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __result The asynchronous result object.
     * @throws ValidationException if the Pixels qualified by
     * <code>pixelsId</code> is unlocatable.
     **/
    public void end_resetDefaultsForPixels(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels.
     **/
    public boolean resetDefaultsForPixels_async(AMI_IRenderingSettings_resetDefaultsForPixels __cb, long pixelsId);

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaultsForPixels_async(AMI_IRenderingSettings_resetDefaultsForPixels __cb, long pixelsId, java.util.Map<String, String> __ctx);

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param dataSetId The Id of the Dataset.
     * @return A {@link java.util.Set} of image IDs that have had
     * their rendering settings reset.
     * @throws ValidationException if the image qualified by
     * <code>dataSetId</code> is unlocatable.
     **/
    public java.util.List<Long> resetDefaultsInDataset(long dataSetId)
        throws omero.ServerError;

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param dataSetId The Id of the Dataset.
     * @param __ctx The Context map to send with the invocation.
     * @return A {@link java.util.Set} of image IDs that have had
     * their rendering settings reset.
     * @throws ValidationException if the image qualified by
     * <code>dataSetId</code> is unlocatable.
     **/
    public java.util.List<Long> resetDefaultsInDataset(long dataSetId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param dataSetId The Id of the Dataset.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsInDataset(long dataSetId);

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param dataSetId The Id of the Dataset.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsInDataset(long dataSetId, java.util.Map<String, String> __ctx);

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param dataSetId The Id of the Dataset.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsInDataset(long dataSetId, Ice.Callback __cb);

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param dataSetId The Id of the Dataset.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsInDataset(long dataSetId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param dataSetId The Id of the Dataset.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsInDataset(long dataSetId, Callback_IRenderingSettings_resetDefaultsInDataset __cb);

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param dataSetId The Id of the Dataset.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsInDataset(long dataSetId, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_resetDefaultsInDataset __cb);

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param __result The asynchronous result object.
     * @return A {@link java.util.Set} of image IDs that have had
     * their rendering settings reset.
     * @throws ValidationException if the image qualified by
     * <code>dataSetId</code> is unlocatable.
     **/
    public java.util.List<Long> end_resetDefaultsInDataset(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param dataSetId The Id of the Dataset.
     **/
    public boolean resetDefaultsInDataset_async(AMI_IRenderingSettings_resetDefaultsInDataset __cb, long dataSetId);

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param dataSetId The Id of the Dataset.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaultsInDataset_async(AMI_IRenderingSettings_resetDefaultsInDataset __cb, long dataSetId, java.util.Map<String, String> __ctx);

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @return A {@link java.util.Set} of image IDs that have had
     * their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> resetDefaultsInSet(String type, java.util.List<Long> nodeIds)
        throws omero.ServerError;

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @param __ctx The Context map to send with the invocation.
     * @return A {@link java.util.Set} of image IDs that have had
     * their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> resetDefaultsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsInSet(String type, java.util.List<Long> nodeIds);

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx);

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsInSet(String type, java.util.List<Long> nodeIds, Ice.Callback __cb);

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsInSet(String type, java.util.List<Long> nodeIds, Callback_IRenderingSettings_resetDefaultsInSet __cb);

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_resetDefaultsInSet __cb);

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __result The asynchronous result object.
     * @return A {@link java.util.Set} of image IDs that have had
     * their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> end_resetDefaultsInSet(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public boolean resetDefaultsInSet_async(AMI_IRenderingSettings_resetDefaultsInSet __cb, String type, java.util.List<Long> nodeIds);

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaultsInSet_async(AMI_IRenderingSettings_resetDefaultsInSet __cb, String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx);

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> resetDefaultsByOwnerInSet(String type, java.util.List<Long> nodeIds)
        throws omero.ServerError;

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @param __ctx The Context map to send with the invocation.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> resetDefaultsByOwnerInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsByOwnerInSet(String type, java.util.List<Long> nodeIds);

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsByOwnerInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx);

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsByOwnerInSet(String type, java.util.List<Long> nodeIds, Ice.Callback __cb);

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsByOwnerInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsByOwnerInSet(String type, java.util.List<Long> nodeIds, Callback_IRenderingSettings_resetDefaultsByOwnerInSet __cb);

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaultsByOwnerInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_resetDefaultsByOwnerInSet __cb);

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __result The asynchronous result object.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> end_resetDefaultsByOwnerInSet(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public boolean resetDefaultsByOwnerInSet_async(AMI_IRenderingSettings_resetDefaultsByOwnerInSet __cb, String type, java.util.List<Long> nodeIds);

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaultsByOwnerInSet_async(AMI_IRenderingSettings_resetDefaultsByOwnerInSet __cb, String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx);

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> resetMinMaxInSet(String type, java.util.List<Long> nodeIds)
        throws omero.ServerError;

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @param __ctx The Context map to send with the invocation.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> resetMinMaxInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetMinMaxInSet(String type, java.util.List<Long> nodeIds);

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetMinMaxInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx);

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetMinMaxInSet(String type, java.util.List<Long> nodeIds, Ice.Callback __cb);

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetMinMaxInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetMinMaxInSet(String type, java.util.List<Long> nodeIds, Callback_IRenderingSettings_resetMinMaxInSet __cb);

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetMinMaxInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_resetMinMaxInSet __cb);

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __result The asynchronous result object.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> end_resetMinMaxInSet(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public boolean resetMinMaxInSet_async(AMI_IRenderingSettings_resetMinMaxInSet __cb, String type, java.util.List<Long> nodeIds);

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetMinMaxInSet_async(AMI_IRenderingSettings_resetMinMaxInSet __cb, String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx);

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @return A map with two boolean keys. The value of the
     * <code>TRUE</code> is a collection of images ID, the
     * settings were successfully applied to.
     * The value of the <code>FALSE</code> is a collection
     * of images ID, the settings could not be applied to.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToSet(long from, String toType, java.util.List<Long> nodeIds)
        throws omero.ServerError;

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @param __ctx The Context map to send with the invocation.
     * @return A map with two boolean keys. The value of the
     * <code>TRUE</code> is a collection of images ID, the
     * settings were successfully applied to.
     * The value of the <code>FALSE</code> is a collection
     * of images ID, the settings could not be applied to.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToSet(long from, String toType, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToSet(long from, String toType, java.util.List<Long> nodeIds);

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToSet(long from, String toType, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx);

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToSet(long from, String toType, java.util.List<Long> nodeIds, Ice.Callback __cb);

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToSet(long from, String toType, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToSet(long from, String toType, java.util.List<Long> nodeIds, Callback_IRenderingSettings_applySettingsToSet __cb);

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToSet(long from, String toType, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_applySettingsToSet __cb);

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __result The asynchronous result object.
     * @return A map with two boolean keys. The value of the
     * <code>TRUE</code> is a collection of images ID, the
     * settings were successfully applied to.
     * The value of the <code>FALSE</code> is a collection
     * of images ID, the settings could not be applied to.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> end_applySettingsToSet(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     **/
    public boolean applySettingsToSet_async(AMI_IRenderingSettings_applySettingsToSet __cb, long from, String toType, java.util.List<Long> nodeIds);

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean applySettingsToSet_async(AMI_IRenderingSettings_applySettingsToSet __cb, long from, String toType, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx);

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     * @return A map with two boolean keys. The value of the
     * <code>TRUE</code> is a collection of images ID, the
     * settings were successfully applied to.
     * The value of the <code>FALSE</code> is a collection
     * of images ID, the settings could not be applied to.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the project
     * <code>to</code> is unlocatable.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToProject(long from, long to)
        throws omero.ServerError;

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @return A map with two boolean keys. The value of the
     * <code>TRUE</code> is a collection of images ID, the
     * settings were successfully applied to.
     * The value of the <code>FALSE</code> is a collection
     * of images ID, the settings could not be applied to.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the project
     * <code>to</code> is unlocatable.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToProject(long from, long to, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToProject(long from, long to);

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToProject(long from, long to, java.util.Map<String, String> __ctx);

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToProject(long from, long to, Ice.Callback __cb);

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToProject(long from, long to, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToProject(long from, long to, Callback_IRenderingSettings_applySettingsToProject __cb);

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToProject(long from, long to, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_applySettingsToProject __cb);

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param __result The asynchronous result object.
     * @return A map with two boolean keys. The value of the
     * <code>TRUE</code> is a collection of images ID, the
     * settings were successfully applied to.
     * The value of the <code>FALSE</code> is a collection
     * of images ID, the settings could not be applied to.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the project
     * <code>to</code> is unlocatable.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> end_applySettingsToProject(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     **/
    public boolean applySettingsToProject_async(AMI_IRenderingSettings_applySettingsToProject __cb, long from, long to);

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean applySettingsToProject_async(AMI_IRenderingSettings_applySettingsToProject __cb, long from, long to, java.util.Map<String, String> __ctx);

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     * @return A map with two boolean keys. The value of the
     * <code>TRUE</code> is a collection of images ID, the
     * settings were successfully applied to.
     * The value of the <code>FALSE</code> is a collection
     * of images ID, the settings could not be applied to.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the dataset
     * <code>to</code> is unlocatable.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToDataset(long from, long to)
        throws omero.ServerError;

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @return A map with two boolean keys. The value of the
     * <code>TRUE</code> is a collection of images ID, the
     * settings were successfully applied to.
     * The value of the <code>FALSE</code> is a collection
     * of images ID, the settings could not be applied to.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the dataset
     * <code>to</code> is unlocatable.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToDataset(long from, long to, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToDataset(long from, long to);

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToDataset(long from, long to, java.util.Map<String, String> __ctx);

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToDataset(long from, long to, Ice.Callback __cb);

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToDataset(long from, long to, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToDataset(long from, long to, Callback_IRenderingSettings_applySettingsToDataset __cb);

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToDataset(long from, long to, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_applySettingsToDataset __cb);

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param __result The asynchronous result object.
     * @return A map with two boolean keys. The value of the
     * <code>TRUE</code> is a collection of images ID, the
     * settings were successfully applied to.
     * The value of the <code>FALSE</code> is a collection
     * of images ID, the settings could not be applied to.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the dataset
     * <code>to</code> is unlocatable.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> end_applySettingsToDataset(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     **/
    public boolean applySettingsToDataset_async(AMI_IRenderingSettings_applySettingsToDataset __cb, long from, long to);

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean applySettingsToDataset_async(AMI_IRenderingSettings_applySettingsToDataset __cb, long from, long to, java.util.Map<String, String> __ctx);

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @return <code>true</code> if the settings were successfully
     * applied, <code>false</code> otherwise.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the image
     * <code>to</code> is unlocatable.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToImages(long from, java.util.List<Long> to)
        throws omero.ServerError;

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @return <code>true</code> if the settings were successfully
     * applied, <code>false</code> otherwise.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the image
     * <code>to</code> is unlocatable.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToImages(long from, java.util.List<Long> to, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToImages(long from, java.util.List<Long> to);

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToImages(long from, java.util.List<Long> to, java.util.Map<String, String> __ctx);

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToImages(long from, java.util.List<Long> to, Ice.Callback __cb);

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToImages(long from, java.util.List<Long> to, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToImages(long from, java.util.List<Long> to, Callback_IRenderingSettings_applySettingsToImages __cb);

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToImages(long from, java.util.List<Long> to, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_applySettingsToImages __cb);

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __result The asynchronous result object.
     * @return <code>true</code> if the settings were successfully
     * applied, <code>false</code> otherwise.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the image
     * <code>to</code> is unlocatable.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> end_applySettingsToImages(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     **/
    public boolean applySettingsToImages_async(AMI_IRenderingSettings_applySettingsToImages __cb, long from, java.util.List<Long> to);

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean applySettingsToImages_async(AMI_IRenderingSettings_applySettingsToImages __cb, long from, java.util.List<Long> to, java.util.Map<String, String> __ctx);

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @return <code>true</code> if the settings were successfully
     * applied, <code>false</code> otherwise.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the image
     * <code>to</code> is unlocatable.
     **/
    public boolean applySettingsToImage(long from, long to)
        throws omero.ServerError;

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @return <code>true</code> if the settings were successfully
     * applied, <code>false</code> otherwise.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the image
     * <code>to</code> is unlocatable.
     **/
    public boolean applySettingsToImage(long from, long to, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToImage(long from, long to);

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToImage(long from, long to, java.util.Map<String, String> __ctx);

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToImage(long from, long to, Ice.Callback __cb);

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToImage(long from, long to, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToImage(long from, long to, Callback_IRenderingSettings_applySettingsToImage __cb);

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToImage(long from, long to, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_applySettingsToImage __cb);

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __result The asynchronous result object.
     * @return <code>true</code> if the settings were successfully
     * applied, <code>false</code> otherwise.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the image
     * <code>to</code> is unlocatable.
     **/
    public boolean end_applySettingsToImage(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     **/
    public boolean applySettingsToImage_async(AMI_IRenderingSettings_applySettingsToImage __cb, long from, long to);

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean applySettingsToImage_async(AMI_IRenderingSettings_applySettingsToImage __cb, long from, long to, java.util.Map<String, String> __ctx);

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     * @return See above.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the
     * pixels<code>to</code> is unlocatable.
     **/
    public boolean applySettingsToPixels(long from, long to)
        throws omero.ServerError;

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the
     * pixels<code>to</code> is unlocatable.
     **/
    public boolean applySettingsToPixels(long from, long to, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToPixels(long from, long to);

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToPixels(long from, long to, java.util.Map<String, String> __ctx);

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToPixels(long from, long to, Ice.Callback __cb);

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToPixels(long from, long to, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToPixels(long from, long to, Callback_IRenderingSettings_applySettingsToPixels __cb);

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_applySettingsToPixels(long from, long to, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_applySettingsToPixels __cb);

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param __result The asynchronous result object.
     * @return See above.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the
     * pixels<code>to</code> is unlocatable.
     **/
    public boolean end_applySettingsToPixels(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     **/
    public boolean applySettingsToPixels_async(AMI_IRenderingSettings_applySettingsToPixels __cb, long from, long to);

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean applySettingsToPixels_async(AMI_IRenderingSettings_applySettingsToPixels __cb, long from, long to, java.util.Map<String, String> __ctx);

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param imageId The Id of the Image.
     * @throws ValidationException if the image qualified by
     * <code>imageId</code> is unlocatable.
     **/
    public void setOriginalSettingsInImage(long imageId)
        throws omero.ServerError;

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param imageId The Id of the Image.
     * @throws ValidationException if the image qualified by
     * <code>imageId</code> is unlocatable.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setOriginalSettingsInImage(long imageId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param imageId The Id of the Image.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInImage(long imageId);

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param imageId The Id of the Image.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInImage(long imageId, java.util.Map<String, String> __ctx);

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param imageId The Id of the Image.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInImage(long imageId, Ice.Callback __cb);

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param imageId The Id of the Image.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInImage(long imageId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param imageId The Id of the Image.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInImage(long imageId, Callback_IRenderingSettings_setOriginalSettingsInImage __cb);

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param imageId The Id of the Image.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInImage(long imageId, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_setOriginalSettingsInImage __cb);

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __result The asynchronous result object.
     * @throws ValidationException if the image qualified by
     * <code>imageId</code> is unlocatable.
     **/
    public void end_setOriginalSettingsInImage(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     **/
    public boolean setOriginalSettingsInImage_async(AMI_IRenderingSettings_setOriginalSettingsInImage __cb, long imageId);

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setOriginalSettingsInImage_async(AMI_IRenderingSettings_setOriginalSettingsInImage __cb, long imageId, java.util.Map<String, String> __ctx);

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param pixelsId The Id of the Pixels set.
     * @throws ValidationException if the image qualified by
     * <code>pixelsId</code> is unlocatable.
     **/
    public void setOriginalSettingsForPixels(long pixelsId)
        throws omero.ServerError;

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param pixelsId The Id of the Pixels set.
     * @throws ValidationException if the image qualified by
     * <code>pixelsId</code> is unlocatable.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setOriginalSettingsForPixels(long pixelsId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param pixelsId The Id of the Pixels set.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsForPixels(long pixelsId);

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param pixelsId The Id of the Pixels set.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsForPixels(long pixelsId, java.util.Map<String, String> __ctx);

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param pixelsId The Id of the Pixels set.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsForPixels(long pixelsId, Ice.Callback __cb);

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param pixelsId The Id of the Pixels set.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsForPixels(long pixelsId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param pixelsId The Id of the Pixels set.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsForPixels(long pixelsId, Callback_IRenderingSettings_setOriginalSettingsForPixels __cb);

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param pixelsId The Id of the Pixels set.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsForPixels(long pixelsId, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_setOriginalSettingsForPixels __cb);

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __result The asynchronous result object.
     * @throws ValidationException if the image qualified by
     * <code>pixelsId</code> is unlocatable.
     **/
    public void end_setOriginalSettingsForPixels(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels set.
     **/
    public boolean setOriginalSettingsForPixels_async(AMI_IRenderingSettings_setOriginalSettingsForPixels __cb, long pixelsId);

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels set.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setOriginalSettingsForPixels_async(AMI_IRenderingSettings_setOriginalSettingsForPixels __cb, long pixelsId, java.util.Map<String, String> __ctx);

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param datasetId The id of the dataset to handle.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if the image qualified by
     * <code>datasetId</code> is unlocatable.
     **/
    public java.util.List<Long> setOriginalSettingsInDataset(long dataSetId)
        throws omero.ServerError;

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param datasetId The id of the dataset to handle.
     * @param __ctx The Context map to send with the invocation.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if the image qualified by
     * <code>datasetId</code> is unlocatable.
     **/
    public java.util.List<Long> setOriginalSettingsInDataset(long dataSetId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInDataset(long dataSetId);

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInDataset(long dataSetId, java.util.Map<String, String> __ctx);

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInDataset(long dataSetId, Ice.Callback __cb);

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInDataset(long dataSetId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInDataset(long dataSetId, Callback_IRenderingSettings_setOriginalSettingsInDataset __cb);

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInDataset(long dataSetId, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_setOriginalSettingsInDataset __cb);

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param __result The asynchronous result object.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if the image qualified by
     * <code>datasetId</code> is unlocatable.
     **/
    public java.util.List<Long> end_setOriginalSettingsInDataset(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean setOriginalSettingsInDataset_async(AMI_IRenderingSettings_setOriginalSettingsInDataset __cb, long dataSetId);

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setOriginalSettingsInDataset_async(AMI_IRenderingSettings_setOriginalSettingsInDataset __cb, long dataSetId, java.util.Map<String, String> __ctx);

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param type The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> setOriginalSettingsInSet(String type, java.util.List<Long> nodeIds)
        throws omero.ServerError;

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param type The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @param __ctx The Context map to send with the invocation.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> setOriginalSettingsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param type The type of nodes to handle.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInSet(String type, java.util.List<Long> nodeIds);

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx);

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param type The type of nodes to handle.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInSet(String type, java.util.List<Long> nodeIds, Ice.Callback __cb);

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param type The type of nodes to handle.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInSet(String type, java.util.List<Long> nodeIds, Callback_IRenderingSettings_setOriginalSettingsInSet __cb);

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_setOriginalSettingsInSet __cb);

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __result The asynchronous result object.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> end_setOriginalSettingsInSet(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public boolean setOriginalSettingsInSet_async(AMI_IRenderingSettings_setOriginalSettingsInSet __cb, String type, java.util.List<Long> nodeIds);

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setOriginalSettingsInSet_async(AMI_IRenderingSettings_setOriginalSettingsInSet __cb, String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx);
}
