// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IRepositoryInfo.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides methods for obtaining information for server repository
 * disk space allocation. Could be used generically to obtain usage
 * information for any mount point, however, this interface is
 * prepared for the API to provide methods to obtain usage info for
 * the server filesystem containing the image uploads. For the OMERO
 * server base this is /OMERO. For this implementation it could be
 * anything e.g. /Data1.
 * 
 * Methods that fail or cannot execute on the server will throw an
 * InternalException. This would not be normal and would indicate some
 * server or disk failure.
 **/
public interface IRepositoryInfoPrx extends ServiceInterfacePrx
{
    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @return Total space used on this file system.
     * @throws ResourceError If there is a problem retrieving disk
     * space used.
     **/
    public long getUsedSpaceInKilobytes()
        throws omero.ServerError;

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return Total space used on this file system.
     * @throws ResourceError If there is a problem retrieving disk
     * space used.
     **/
    public long getUsedSpaceInKilobytes(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getUsedSpaceInKilobytes();

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getUsedSpaceInKilobytes(java.util.Map<String, String> __ctx);

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getUsedSpaceInKilobytes(Ice.Callback __cb);

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getUsedSpaceInKilobytes(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getUsedSpaceInKilobytes(Callback_IRepositoryInfo_getUsedSpaceInKilobytes __cb);

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getUsedSpaceInKilobytes(java.util.Map<String, String> __ctx, Callback_IRepositoryInfo_getUsedSpaceInKilobytes __cb);

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __result The asynchronous result object.
     * @return Total space used on this file system.
     * @throws ResourceError If there is a problem retrieving disk
     * space used.
     **/
    public long end_getUsedSpaceInKilobytes(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getUsedSpaceInKilobytes_async(AMI_IRepositoryInfo_getUsedSpaceInKilobytes __cb);

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getUsedSpaceInKilobytes_async(AMI_IRepositoryInfo_getUsedSpaceInKilobytes __cb, java.util.Map<String, String> __ctx);

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @return Free space on this file system in KB.
     * @throws ResourceError If there is a problem retrieving disk
     * space free.
     **/
    public long getFreeSpaceInKilobytes()
        throws omero.ServerError;

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return Free space on this file system in KB.
     * @throws ResourceError If there is a problem retrieving disk
     * space free.
     **/
    public long getFreeSpaceInKilobytes(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFreeSpaceInKilobytes();

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFreeSpaceInKilobytes(java.util.Map<String, String> __ctx);

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFreeSpaceInKilobytes(Ice.Callback __cb);

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFreeSpaceInKilobytes(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFreeSpaceInKilobytes(Callback_IRepositoryInfo_getFreeSpaceInKilobytes __cb);

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFreeSpaceInKilobytes(java.util.Map<String, String> __ctx, Callback_IRepositoryInfo_getFreeSpaceInKilobytes __cb);

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __result The asynchronous result object.
     * @return Free space on this file system in KB.
     * @throws ResourceError If there is a problem retrieving disk
     * space free.
     **/
    public long end_getFreeSpaceInKilobytes(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getFreeSpaceInKilobytes_async(AMI_IRepositoryInfo_getFreeSpaceInKilobytes __cb);

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getFreeSpaceInKilobytes_async(AMI_IRepositoryInfo_getFreeSpaceInKilobytes __cb, java.util.Map<String, String> __ctx);

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @return Fraction of used/free.
     * @throws ResourceError If there is a problem calculating the
     * usage fraction.
     **/
    public double getUsageFraction()
        throws omero.ServerError;

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return Fraction of used/free.
     * @throws ResourceError If there is a problem calculating the
     * usage fraction.
     **/
    public double getUsageFraction(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getUsageFraction();

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getUsageFraction(java.util.Map<String, String> __ctx);

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getUsageFraction(Ice.Callback __cb);

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getUsageFraction(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getUsageFraction(Callback_IRepositoryInfo_getUsageFraction __cb);

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getUsageFraction(java.util.Map<String, String> __ctx, Callback_IRepositoryInfo_getUsageFraction __cb);

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __result The asynchronous result object.
     * @return Fraction of used/free.
     * @throws ResourceError If there is a problem calculating the
     * usage fraction.
     **/
    public double end_getUsageFraction(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getUsageFraction_async(AMI_IRepositoryInfo_getUsageFraction __cb);

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getUsageFraction_async(AMI_IRepositoryInfo_getUsageFraction __cb, java.util.Map<String, String> __ctx);

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @throws ResourceError If the repository usage has exceeded
     * 95%.
     * @throws InternalException If there is a critical failure
     * while sanity checking the repository.
     **/
    public void sanityCheckRepository()
        throws omero.ServerError;

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @throws ResourceError If the repository usage has exceeded
     * 95%.
     * @throws InternalException If there is a critical failure
     * while sanity checking the repository.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void sanityCheckRepository(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sanityCheckRepository();

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sanityCheckRepository(java.util.Map<String, String> __ctx);

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sanityCheckRepository(Ice.Callback __cb);

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sanityCheckRepository(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sanityCheckRepository(Callback_IRepositoryInfo_sanityCheckRepository __cb);

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sanityCheckRepository(java.util.Map<String, String> __ctx, Callback_IRepositoryInfo_sanityCheckRepository __cb);

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @param __result The asynchronous result object.
     * @throws ResourceError If the repository usage has exceeded
     * 95%.
     * @throws InternalException If there is a critical failure
     * while sanity checking the repository.
     **/
    public void end_sanityCheckRepository(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @param __cb The callback object for the operation.
     **/
    public boolean sanityCheckRepository_async(AMI_IRepositoryInfo_sanityCheckRepository __cb);

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean sanityCheckRepository_async(AMI_IRepositoryInfo_sanityCheckRepository __cb, java.util.Map<String, String> __ctx);

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @throws ResourceError If deletion fails.
     **/
    public void removeUnusedFiles()
        throws omero.ServerError;

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @throws ResourceError If deletion fails.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeUnusedFiles(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeUnusedFiles();

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeUnusedFiles(java.util.Map<String, String> __ctx);

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeUnusedFiles(Ice.Callback __cb);

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeUnusedFiles(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeUnusedFiles(Callback_IRepositoryInfo_removeUnusedFiles __cb);

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeUnusedFiles(java.util.Map<String, String> __ctx, Callback_IRepositoryInfo_removeUnusedFiles __cb);

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @param __result The asynchronous result object.
     * @throws ResourceError If deletion fails.
     **/
    public void end_removeUnusedFiles(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean removeUnusedFiles_async(AMI_IRepositoryInfo_removeUnusedFiles __cb);

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeUnusedFiles_async(AMI_IRepositoryInfo_removeUnusedFiles __cb, java.util.Map<String, String> __ctx);
}
