// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IRepositoryInfo.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides methods for obtaining information for server repository
 * disk space allocation. Could be used generically to obtain usage
 * information for any mount point, however, this interface is
 * prepared for the API to provide methods to obtain usage info for
 * the server filesystem containing the image uploads. For the OMERO
 * server base this is /OMERO. For this implementation it could be
 * anything e.g. /Data1.
 * 
 * Methods that fail or cannot execute on the server will throw an
 * InternalException. This would not be normal and would indicate some
 * server or disk failure.
 **/
public final class IRepositoryInfoPrxHelper extends Ice.ObjectPrxHelperBase implements IRepositoryInfoPrx
{
    private static final String __getFreeSpaceInKilobytes_name = "getFreeSpaceInKilobytes";

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @return Free space on this file system in KB.
     * @throws ResourceError If there is a problem retrieving disk
     * space free.
     **/
    public long getFreeSpaceInKilobytes()
        throws omero.ServerError
    {
        return getFreeSpaceInKilobytes(null, false);
    }

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return Free space on this file system in KB.
     * @throws ResourceError If there is a problem retrieving disk
     * space free.
     **/
    public long getFreeSpaceInKilobytes(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getFreeSpaceInKilobytes(__ctx, true);
    }

    private long getFreeSpaceInKilobytes(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getFreeSpaceInKilobytes", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getFreeSpaceInKilobytes");
                    __delBase = __getDelegate(false);
                    _IRepositoryInfoDel __del = (_IRepositoryInfoDel)__delBase;
                    return __del.getFreeSpaceInKilobytes(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getFreeSpaceInKilobytes()
    {
        return begin_getFreeSpaceInKilobytes(null, false, null);
    }

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getFreeSpaceInKilobytes(java.util.Map<String, String> __ctx)
    {
        return begin_getFreeSpaceInKilobytes(__ctx, true, null);
    }

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getFreeSpaceInKilobytes(Ice.Callback __cb)
    {
        return begin_getFreeSpaceInKilobytes(null, false, __cb);
    }

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getFreeSpaceInKilobytes(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getFreeSpaceInKilobytes(__ctx, true, __cb);
    }

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getFreeSpaceInKilobytes(Callback_IRepositoryInfo_getFreeSpaceInKilobytes __cb)
    {
        return begin_getFreeSpaceInKilobytes(null, false, __cb);
    }

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getFreeSpaceInKilobytes(java.util.Map<String, String> __ctx, Callback_IRepositoryInfo_getFreeSpaceInKilobytes __cb)
    {
        return begin_getFreeSpaceInKilobytes(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getFreeSpaceInKilobytes(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getFreeSpaceInKilobytes_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getFreeSpaceInKilobytes_name, __cb);
        try
        {
            __result.__prepare(__getFreeSpaceInKilobytes_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Free space on this file system in KB.
     **/
    public long end_getFreeSpaceInKilobytes(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getFreeSpaceInKilobytes_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getFreeSpaceInKilobytes_async(AMI_IRepositoryInfo_getFreeSpaceInKilobytes __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getFreeSpaceInKilobytes_name);
            __r = begin_getFreeSpaceInKilobytes(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getFreeSpaceInKilobytes_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getFreeSpaceInKilobytes_async(AMI_IRepositoryInfo_getFreeSpaceInKilobytes __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getFreeSpaceInKilobytes_name);
            __r = begin_getFreeSpaceInKilobytes(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getFreeSpaceInKilobytes_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getUsageFraction_name = "getUsageFraction";

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @return Fraction of used/free.
     * @throws ResourceError If there is a problem calculating the
     * usage fraction.
     **/
    public double getUsageFraction()
        throws omero.ServerError
    {
        return getUsageFraction(null, false);
    }

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return Fraction of used/free.
     * @throws ResourceError If there is a problem calculating the
     * usage fraction.
     **/
    public double getUsageFraction(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getUsageFraction(__ctx, true);
    }

    private double getUsageFraction(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getUsageFraction", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getUsageFraction");
                    __delBase = __getDelegate(false);
                    _IRepositoryInfoDel __del = (_IRepositoryInfoDel)__delBase;
                    return __del.getUsageFraction(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getUsageFraction()
    {
        return begin_getUsageFraction(null, false, null);
    }

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getUsageFraction(java.util.Map<String, String> __ctx)
    {
        return begin_getUsageFraction(__ctx, true, null);
    }

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getUsageFraction(Ice.Callback __cb)
    {
        return begin_getUsageFraction(null, false, __cb);
    }

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getUsageFraction(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getUsageFraction(__ctx, true, __cb);
    }

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getUsageFraction(Callback_IRepositoryInfo_getUsageFraction __cb)
    {
        return begin_getUsageFraction(null, false, __cb);
    }

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getUsageFraction(java.util.Map<String, String> __ctx, Callback_IRepositoryInfo_getUsageFraction __cb)
    {
        return begin_getUsageFraction(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getUsageFraction(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getUsageFraction_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getUsageFraction_name, __cb);
        try
        {
            __result.__prepare(__getUsageFraction_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Fraction of used/free.
     **/
    public double end_getUsageFraction(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getUsageFraction_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            double __ret;
            __ret = __is.readDouble();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getUsageFraction_async(AMI_IRepositoryInfo_getUsageFraction __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getUsageFraction_name);
            __r = begin_getUsageFraction(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getUsageFraction_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getUsageFraction_async(AMI_IRepositoryInfo_getUsageFraction __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getUsageFraction_name);
            __r = begin_getUsageFraction(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getUsageFraction_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getUsedSpaceInKilobytes_name = "getUsedSpaceInKilobytes";

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @return Total space used on this file system.
     * @throws ResourceError If there is a problem retrieving disk
     * space used.
     **/
    public long getUsedSpaceInKilobytes()
        throws omero.ServerError
    {
        return getUsedSpaceInKilobytes(null, false);
    }

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return Total space used on this file system.
     * @throws ResourceError If there is a problem retrieving disk
     * space used.
     **/
    public long getUsedSpaceInKilobytes(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getUsedSpaceInKilobytes(__ctx, true);
    }

    private long getUsedSpaceInKilobytes(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getUsedSpaceInKilobytes", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getUsedSpaceInKilobytes");
                    __delBase = __getDelegate(false);
                    _IRepositoryInfoDel __del = (_IRepositoryInfoDel)__delBase;
                    return __del.getUsedSpaceInKilobytes(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getUsedSpaceInKilobytes()
    {
        return begin_getUsedSpaceInKilobytes(null, false, null);
    }

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getUsedSpaceInKilobytes(java.util.Map<String, String> __ctx)
    {
        return begin_getUsedSpaceInKilobytes(__ctx, true, null);
    }

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getUsedSpaceInKilobytes(Ice.Callback __cb)
    {
        return begin_getUsedSpaceInKilobytes(null, false, __cb);
    }

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getUsedSpaceInKilobytes(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getUsedSpaceInKilobytes(__ctx, true, __cb);
    }

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getUsedSpaceInKilobytes(Callback_IRepositoryInfo_getUsedSpaceInKilobytes __cb)
    {
        return begin_getUsedSpaceInKilobytes(null, false, __cb);
    }

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getUsedSpaceInKilobytes(java.util.Map<String, String> __ctx, Callback_IRepositoryInfo_getUsedSpaceInKilobytes __cb)
    {
        return begin_getUsedSpaceInKilobytes(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getUsedSpaceInKilobytes(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getUsedSpaceInKilobytes_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getUsedSpaceInKilobytes_name, __cb);
        try
        {
            __result.__prepare(__getUsedSpaceInKilobytes_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Total space used on this file system.
     **/
    public long end_getUsedSpaceInKilobytes(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getUsedSpaceInKilobytes_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getUsedSpaceInKilobytes_async(AMI_IRepositoryInfo_getUsedSpaceInKilobytes __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getUsedSpaceInKilobytes_name);
            __r = begin_getUsedSpaceInKilobytes(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getUsedSpaceInKilobytes_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getUsedSpaceInKilobytes_async(AMI_IRepositoryInfo_getUsedSpaceInKilobytes __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getUsedSpaceInKilobytes_name);
            __r = begin_getUsedSpaceInKilobytes(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getUsedSpaceInKilobytes_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __removeUnusedFiles_name = "removeUnusedFiles";

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @throws ResourceError If deletion fails.
     **/
    public void removeUnusedFiles()
        throws omero.ServerError
    {
        removeUnusedFiles(null, false);
    }

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @throws ResourceError If deletion fails.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeUnusedFiles(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        removeUnusedFiles(__ctx, true);
    }

    private void removeUnusedFiles(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "removeUnusedFiles", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("removeUnusedFiles");
                    __delBase = __getDelegate(false);
                    _IRepositoryInfoDel __del = (_IRepositoryInfoDel)__delBase;
                    __del.removeUnusedFiles(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeUnusedFiles()
    {
        return begin_removeUnusedFiles(null, false, null);
    }

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeUnusedFiles(java.util.Map<String, String> __ctx)
    {
        return begin_removeUnusedFiles(__ctx, true, null);
    }

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeUnusedFiles(Ice.Callback __cb)
    {
        return begin_removeUnusedFiles(null, false, __cb);
    }

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeUnusedFiles(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_removeUnusedFiles(__ctx, true, __cb);
    }

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeUnusedFiles(Callback_IRepositoryInfo_removeUnusedFiles __cb)
    {
        return begin_removeUnusedFiles(null, false, __cb);
    }

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeUnusedFiles(java.util.Map<String, String> __ctx, Callback_IRepositoryInfo_removeUnusedFiles __cb)
    {
        return begin_removeUnusedFiles(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_removeUnusedFiles(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__removeUnusedFiles_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __removeUnusedFiles_name, __cb);
        try
        {
            __result.__prepare(__removeUnusedFiles_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_removeUnusedFiles(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __removeUnusedFiles_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean removeUnusedFiles_async(AMI_IRepositoryInfo_removeUnusedFiles __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeUnusedFiles_name);
            __r = begin_removeUnusedFiles(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeUnusedFiles_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeUnusedFiles_async(AMI_IRepositoryInfo_removeUnusedFiles __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeUnusedFiles_name);
            __r = begin_removeUnusedFiles(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeUnusedFiles_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __sanityCheckRepository_name = "sanityCheckRepository";

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @throws ResourceError If the repository usage has exceeded
     * 95%.
     * @throws InternalException If there is a critical failure
     * while sanity checking the repository.
     **/
    public void sanityCheckRepository()
        throws omero.ServerError
    {
        sanityCheckRepository(null, false);
    }

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @throws ResourceError If the repository usage has exceeded
     * 95%.
     * @throws InternalException If there is a critical failure
     * while sanity checking the repository.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void sanityCheckRepository(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        sanityCheckRepository(__ctx, true);
    }

    private void sanityCheckRepository(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "sanityCheckRepository", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("sanityCheckRepository");
                    __delBase = __getDelegate(false);
                    _IRepositoryInfoDel __del = (_IRepositoryInfoDel)__delBase;
                    __del.sanityCheckRepository(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_sanityCheckRepository()
    {
        return begin_sanityCheckRepository(null, false, null);
    }

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_sanityCheckRepository(java.util.Map<String, String> __ctx)
    {
        return begin_sanityCheckRepository(__ctx, true, null);
    }

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_sanityCheckRepository(Ice.Callback __cb)
    {
        return begin_sanityCheckRepository(null, false, __cb);
    }

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_sanityCheckRepository(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_sanityCheckRepository(__ctx, true, __cb);
    }

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_sanityCheckRepository(Callback_IRepositoryInfo_sanityCheckRepository __cb)
    {
        return begin_sanityCheckRepository(null, false, __cb);
    }

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_sanityCheckRepository(java.util.Map<String, String> __ctx, Callback_IRepositoryInfo_sanityCheckRepository __cb)
    {
        return begin_sanityCheckRepository(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_sanityCheckRepository(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__sanityCheckRepository_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __sanityCheckRepository_name, __cb);
        try
        {
            __result.__prepare(__sanityCheckRepository_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_sanityCheckRepository(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __sanityCheckRepository_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @param __cb The callback object for the operation.
     **/
    public boolean sanityCheckRepository_async(AMI_IRepositoryInfo_sanityCheckRepository __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__sanityCheckRepository_name);
            __r = begin_sanityCheckRepository(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __sanityCheckRepository_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean sanityCheckRepository_async(AMI_IRepositoryInfo_sanityCheckRepository __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__sanityCheckRepository_name);
            __r = begin_sanityCheckRepository(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __sanityCheckRepository_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static IRepositoryInfoPrx checkedCast(Ice.ObjectPrx __obj)
    {
        IRepositoryInfoPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IRepositoryInfoPrx)
            {
                __d = (IRepositoryInfoPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    IRepositoryInfoPrxHelper __h = new IRepositoryInfoPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static IRepositoryInfoPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        IRepositoryInfoPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IRepositoryInfoPrx)
            {
                __d = (IRepositoryInfoPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    IRepositoryInfoPrxHelper __h = new IRepositoryInfoPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static IRepositoryInfoPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        IRepositoryInfoPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    IRepositoryInfoPrxHelper __h = new IRepositoryInfoPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static IRepositoryInfoPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        IRepositoryInfoPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    IRepositoryInfoPrxHelper __h = new IRepositoryInfoPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static IRepositoryInfoPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        IRepositoryInfoPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IRepositoryInfoPrx)
            {
                __d = (IRepositoryInfoPrx)__obj;
            }
            else
            {
                IRepositoryInfoPrxHelper __h = new IRepositoryInfoPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static IRepositoryInfoPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        IRepositoryInfoPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            IRepositoryInfoPrxHelper __h = new IRepositoryInfoPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IRepositoryInfo",
        "::omero::api::ServiceInterface"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _IRepositoryInfoDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _IRepositoryInfoDelD();
    }

    public static void __write(IceInternal.BasicStream __os, IRepositoryInfoPrx v)
    {
        __os.writeProxy(v);
    }

    public static IRepositoryInfoPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            IRepositoryInfoPrxHelper result = new IRepositoryInfoPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
