// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IScript.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Utility service for managing and launching scripts for execution by the Processor API.
 * 
 * Typical usage might include (PYTHON):
 * <pre>
 * 
 * sf = client.createSession()
 * svc = sf.getScriptService()
 * scripts = svc.getScripts()
 * 
 * if len(scripts) >= 1:
 * script_id = svc.keys()\[-1]
 * else:
 * script_id = svc.uploadScript('/test/my_script.py', SCRIPT_TEXT)
 * 
 * params = svc.getParams(script_id)
 * 
 * # You will need to parse the params to create the proper input
 * inputs = {}
 * 
 * # The last parameter is how long to wait as an RInt
 * proc = svc.runScript(script_id, inputs, None)
 * try:
 * cb = omero.scripts.ProcessCallbackI(client, proc)
 * while not cb.block(1000): # ms.
 * pass
 * cb.close()
 * rv = proc.getResults(0)
 * finally:
 * proc.close(False)
 * 
 * </pre>
 * See <a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/scripts/">OMERO.scripts</a> for more information.
 **/
public interface IScript extends Ice.Object,
                                 _IScriptOperations, _IScriptOperationsNC,
                                 ServiceInterface
{
    public static final long serialVersionUID = -8058459721628856189L;
}
