// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `ISession.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * {@link omero.model.Session} creation service for OMERO. Access to
 * all other services is dependent upon a properly created and still
 * active {@link omero.model.Session}.
 * 
 * The session uuid ({@link omero.model.Session#getUuid}) can be
 * considered a capability token, or temporary single use password.
 * Simply by possessing it the client has access to all information
 * available to the {@link omero.model.Session}.
 * 
 * Note: Both the RMI <code>ome.system.ServiceFactory</code> as well
 * as the Ice {@link omero.api.ServiceFactory} use
 * {@link omero.api.ISession} to acquire a
 * {@link omero.model.Session}. In the Ice case, Glacier2
 * contacts {@link omero.api.ISession} itself and returns a
 * ServiceFactory remote proxy. From both ServiceFactory
 * instances, it is possible but not necessary to access
 * {@link omero.api.ISession}.
 **/
public interface ISessionPrx extends ServiceInterfacePrx
{
    /**
     * Creates a new session and returns it to the user.
     * 
     * @throws ApiUsageException if principal is null
     * @throws SecurityViolation if the password check fails
     **/
    public omero.model.Session createSession(omero.sys.Principal p, String credentials)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError;

    /**
     * Creates a new session and returns it to the user.
     * 
     * @throws ApiUsageException if principal is null
     * @throws SecurityViolation if the password check fails
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.Session createSession(omero.sys.Principal p, String credentials, java.util.Map<String, String> __ctx)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError;

    /**
     * Creates a new session and returns it to the user.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSession(omero.sys.Principal p, String credentials);

    /**
     * Creates a new session and returns it to the user.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSession(omero.sys.Principal p, String credentials, java.util.Map<String, String> __ctx);

    /**
     * Creates a new session and returns it to the user.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSession(omero.sys.Principal p, String credentials, Ice.Callback __cb);

    /**
     * Creates a new session and returns it to the user.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSession(omero.sys.Principal p, String credentials, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Creates a new session and returns it to the user.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSession(omero.sys.Principal p, String credentials, Callback_ISession_createSession __cb);

    /**
     * Creates a new session and returns it to the user.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSession(omero.sys.Principal p, String credentials, java.util.Map<String, String> __ctx, Callback_ISession_createSession __cb);

    /**
     * Creates a new session and returns it to the user.
     * 
     * @param __result The asynchronous result object.
     * @throws ApiUsageException if principal is null
     * @throws SecurityViolation if the password check fails
     **/
    public omero.model.Session end_createSession(Ice.AsyncResult __result)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError;

    /**
     * Creates a new session and returns it to the user.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean createSession_async(AMI_ISession_createSession __cb, omero.sys.Principal p, String credentials);

    /**
     * Creates a new session and returns it to the user.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createSession_async(AMI_ISession_createSession __cb, omero.sys.Principal p, String credentials, java.util.Map<String, String> __ctx);

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     **/
    public omero.model.Session createUserSession(long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError;

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.Session createUserSession(long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup, java.util.Map<String, String> __ctx)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError;

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createUserSession(long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup);

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createUserSession(long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup, java.util.Map<String, String> __ctx);

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createUserSession(long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup, Ice.Callback __cb);

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createUserSession(long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createUserSession(long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup, Callback_ISession_createUserSession __cb);

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createUserSession(long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup, java.util.Map<String, String> __ctx, Callback_ISession_createUserSession __cb);

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __result The asynchronous result object.
     **/
    public omero.model.Session end_createUserSession(Ice.AsyncResult __result)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError;

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __cb The callback object for the operation.
     **/
    public boolean createUserSession_async(AMI_ISession_createUserSession __cb, long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup);

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createUserSession_async(AMI_ISession_createUserSession __cb, long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup, java.util.Map<String, String> __ctx);

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param principal
     * Non-null {@link omero.sys.Principal} with the
     * target user's name
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     **/
    public omero.model.Session createSessionWithTimeout(omero.sys.Principal p, long timeToLiveMilliseconds)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError;

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param principal
     * Non-null {@link omero.sys.Principal} with the
     * target user's name
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.Session createSessionWithTimeout(omero.sys.Principal p, long timeToLiveMilliseconds, java.util.Map<String, String> __ctx)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError;

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeout(omero.sys.Principal p, long timeToLiveMilliseconds);

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeout(omero.sys.Principal p, long timeToLiveMilliseconds, java.util.Map<String, String> __ctx);

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeout(omero.sys.Principal p, long timeToLiveMilliseconds, Ice.Callback __cb);

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeout(omero.sys.Principal p, long timeToLiveMilliseconds, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeout(omero.sys.Principal p, long timeToLiveMilliseconds, Callback_ISession_createSessionWithTimeout __cb);

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeout(omero.sys.Principal p, long timeToLiveMilliseconds, java.util.Map<String, String> __ctx, Callback_ISession_createSessionWithTimeout __cb);

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param __result The asynchronous result object.
     **/
    public omero.model.Session end_createSessionWithTimeout(Ice.AsyncResult __result)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError;

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     **/
    public boolean createSessionWithTimeout_async(AMI_ISession_createSessionWithTimeout __cb, omero.sys.Principal p, long timeToLiveMilliseconds);

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createSessionWithTimeout_async(AMI_ISession_createSessionWithTimeout __cb, omero.sys.Principal p, long timeToLiveMilliseconds, java.util.Map<String, String> __ctx);

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param principal
     * Non-null {@link omero.sys.Principal} with the
     * target user's name
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     **/
    public omero.model.Session createSessionWithTimeouts(omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError;

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param principal
     * Non-null {@link omero.sys.Principal} with the
     * target user's name
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.Session createSessionWithTimeouts(omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds, java.util.Map<String, String> __ctx)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError;

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeouts(omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds);

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeouts(omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds, java.util.Map<String, String> __ctx);

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeouts(omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds, Ice.Callback __cb);

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeouts(omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeouts(omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds, Callback_ISession_createSessionWithTimeouts __cb);

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeouts(omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds, java.util.Map<String, String> __ctx, Callback_ISession_createSessionWithTimeouts __cb);

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param __result The asynchronous result object.
     **/
    public omero.model.Session end_createSessionWithTimeouts(Ice.AsyncResult __result)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError;

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     **/
    public boolean createSessionWithTimeouts_async(AMI_ISession_createSessionWithTimeouts __cb, omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds);

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createSessionWithTimeouts_async(AMI_ISession_createSessionWithTimeouts __cb, omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     **/
    public omero.model.Session getSession(String sessionUuid)
        throws omero.ServerError;

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.Session getSession(String sessionUuid, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSession(String sessionUuid);

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSession(String sessionUuid, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSession(String sessionUuid, Ice.Callback __cb);

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSession(String sessionUuid, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSession(String sessionUuid, Callback_ISession_getSession __cb);

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSession(String sessionUuid, java.util.Map<String, String> __ctx, Callback_ISession_getSession __cb);

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __result The asynchronous result object.
     **/
    public omero.model.Session end_getSession(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __cb The callback object for the operation.
     **/
    public boolean getSession_async(AMI_ISession_getSession __cb, String sessionUuid);

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getSession_async(AMI_ISession_getSession __cb, String sessionUuid, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     **/
    public int getReferenceCount(String sessionUuid)
        throws omero.ServerError;

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public int getReferenceCount(String sessionUuid, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getReferenceCount(String sessionUuid);

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getReferenceCount(String sessionUuid, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getReferenceCount(String sessionUuid, Ice.Callback __cb);

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getReferenceCount(String sessionUuid, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getReferenceCount(String sessionUuid, Callback_ISession_getReferenceCount __cb);

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getReferenceCount(String sessionUuid, java.util.Map<String, String> __ctx, Callback_ISession_getReferenceCount __cb);

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __result The asynchronous result object.
     **/
    public int end_getReferenceCount(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __cb The callback object for the operation.
     **/
    public boolean getReferenceCount_async(AMI_ISession_getReferenceCount __cb, String sessionUuid);

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getReferenceCount_async(AMI_ISession_getReferenceCount __cb, String sessionUuid, java.util.Map<String, String> __ctx);

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     **/
    public int closeSession(omero.model.Session sess)
        throws omero.ServerError;

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __ctx The Context map to send with the invocation.
     **/
    public int closeSession(omero.model.Session sess, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_closeSession(omero.model.Session sess);

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_closeSession(omero.model.Session sess, java.util.Map<String, String> __ctx);

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_closeSession(omero.model.Session sess, Ice.Callback __cb);

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_closeSession(omero.model.Session sess, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_closeSession(omero.model.Session sess, Callback_ISession_closeSession __cb);

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_closeSession(omero.model.Session sess, java.util.Map<String, String> __ctx, Callback_ISession_closeSession __cb);

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __result The asynchronous result object.
     **/
    public int end_closeSession(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __cb The callback object for the operation.
     **/
    public boolean closeSession_async(AMI_ISession_closeSession __cb, omero.model.Session sess);

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean closeSession_async(AMI_ISession_closeSession __cb, omero.model.Session sess, java.util.Map<String, String> __ctx);

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     **/
    public java.util.List<omero.model.Session> getMyOpenSessions()
        throws omero.ServerError;

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.Session> getMyOpenSessions(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyOpenSessions();

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyOpenSessions(java.util.Map<String, String> __ctx);

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyOpenSessions(Ice.Callback __cb);

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyOpenSessions(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyOpenSessions(Callback_ISession_getMyOpenSessions __cb);

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyOpenSessions(java.util.Map<String, String> __ctx, Callback_ISession_getMyOpenSessions __cb);

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __result The asynchronous result object.
     **/
    public java.util.List<omero.model.Session> end_getMyOpenSessions(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __cb The callback object for the operation.
     **/
    public boolean getMyOpenSessions_async(AMI_ISession_getMyOpenSessions __cb);

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getMyOpenSessions_async(AMI_ISession_getMyOpenSessions __cb, java.util.Map<String, String> __ctx);

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     **/
    public java.util.List<omero.model.Session> getMyOpenAgentSessions(String agent)
        throws omero.ServerError;

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.Session> getMyOpenAgentSessions(String agent, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyOpenAgentSessions(String agent);

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyOpenAgentSessions(String agent, java.util.Map<String, String> __ctx);

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyOpenAgentSessions(String agent, Ice.Callback __cb);

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyOpenAgentSessions(String agent, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyOpenAgentSessions(String agent, Callback_ISession_getMyOpenAgentSessions __cb);

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyOpenAgentSessions(String agent, java.util.Map<String, String> __ctx, Callback_ISession_getMyOpenAgentSessions __cb);

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __result The asynchronous result object.
     **/
    public java.util.List<omero.model.Session> end_getMyOpenAgentSessions(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __cb The callback object for the operation.
     **/
    public boolean getMyOpenAgentSessions_async(AMI_ISession_getMyOpenAgentSessions __cb, String agent);

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getMyOpenAgentSessions_async(AMI_ISession_getMyOpenAgentSessions __cb, String agent, java.util.Map<String, String> __ctx);

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     **/
    public java.util.List<omero.model.Session> getMyOpenClientSessions()
        throws omero.ServerError;

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.Session> getMyOpenClientSessions(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyOpenClientSessions();

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyOpenClientSessions(java.util.Map<String, String> __ctx);

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyOpenClientSessions(Ice.Callback __cb);

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyOpenClientSessions(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyOpenClientSessions(Callback_ISession_getMyOpenClientSessions __cb);

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyOpenClientSessions(java.util.Map<String, String> __ctx, Callback_ISession_getMyOpenClientSessions __cb);

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __result The asynchronous result object.
     **/
    public java.util.List<omero.model.Session> end_getMyOpenClientSessions(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __cb The callback object for the operation.
     **/
    public boolean getMyOpenClientSessions_async(AMI_ISession_getMyOpenClientSessions __cb);

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getMyOpenClientSessions_async(AMI_ISession_getMyOpenClientSessions __cb, java.util.Map<String, String> __ctx);

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     **/
    public omero.RType getInput(String sess, String key)
        throws omero.ServerError;

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.RType getInput(String sess, String key, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getInput(String sess, String key);

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getInput(String sess, String key, java.util.Map<String, String> __ctx);

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getInput(String sess, String key, Ice.Callback __cb);

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getInput(String sess, String key, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getInput(String sess, String key, Callback_ISession_getInput __cb);

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getInput(String sess, String key, java.util.Map<String, String> __ctx, Callback_ISession_getInput __cb);

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __result The asynchronous result object.
     **/
    public omero.RType end_getInput(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     **/
    public boolean getInput_async(AMI_ISession_getInput __cb, String sess, String key);

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getInput_async(AMI_ISession_getInput __cb, String sess, String key, java.util.Map<String, String> __ctx);

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     **/
    public omero.RType getOutput(String sess, String key)
        throws omero.ServerError;

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.RType getOutput(String sess, String key, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOutput(String sess, String key);

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOutput(String sess, String key, java.util.Map<String, String> __ctx);

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOutput(String sess, String key, Ice.Callback __cb);

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOutput(String sess, String key, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOutput(String sess, String key, Callback_ISession_getOutput __cb);

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOutput(String sess, String key, java.util.Map<String, String> __ctx, Callback_ISession_getOutput __cb);

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __result The asynchronous result object.
     **/
    public omero.RType end_getOutput(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     **/
    public boolean getOutput_async(AMI_ISession_getOutput __cb, String sess, String key);

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getOutput_async(AMI_ISession_getOutput __cb, String sess, String key, java.util.Map<String, String> __ctx);

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     **/
    public void setInput(String sess, String key, omero.RType value)
        throws omero.ServerError;

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setInput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setInput(String sess, String key, omero.RType value);

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setInput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx);

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setInput(String sess, String key, omero.RType value, Ice.Callback __cb);

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setInput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setInput(String sess, String key, omero.RType value, Callback_ISession_setInput __cb);

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setInput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx, Callback_ISession_setInput __cb);

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __result The asynchronous result object.
     **/
    public void end_setInput(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __cb The callback object for the operation.
     **/
    public boolean setInput_async(AMI_ISession_setInput __cb, String sess, String key, omero.RType value);

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setInput_async(AMI_ISession_setInput __cb, String sess, String key, omero.RType value, java.util.Map<String, String> __ctx);

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     **/
    public void setOutput(String sess, String key, omero.RType value)
        throws omero.ServerError;

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setOutput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOutput(String sess, String key, omero.RType value);

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOutput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx);

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOutput(String sess, String key, omero.RType value, Ice.Callback __cb);

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOutput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOutput(String sess, String key, omero.RType value, Callback_ISession_setOutput __cb);

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setOutput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx, Callback_ISession_setOutput __cb);

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __result The asynchronous result object.
     **/
    public void end_setOutput(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __cb The callback object for the operation.
     **/
    public boolean setOutput_async(AMI_ISession_setOutput __cb, String sess, String key, omero.RType value);

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setOutput_async(AMI_ISession_setOutput __cb, String sess, String key, omero.RType value, java.util.Map<String, String> __ctx);

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @return a {@link StringSet} of keys
     **/
    public java.util.List<String> getInputKeys(String sess)
        throws omero.ServerError;

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return a {@link StringSet} of keys
     **/
    public java.util.List<String> getInputKeys(String sess, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getInputKeys(String sess);

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getInputKeys(String sess, java.util.Map<String, String> __ctx);

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getInputKeys(String sess, Ice.Callback __cb);

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getInputKeys(String sess, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getInputKeys(String sess, Callback_ISession_getInputKeys __cb);

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getInputKeys(String sess, java.util.Map<String, String> __ctx, Callback_ISession_getInputKeys __cb);

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __result The asynchronous result object.
     * @return a {@link StringSet} of keys
     **/
    public java.util.List<String> end_getInputKeys(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getInputKeys_async(AMI_ISession_getInputKeys __cb, String sess);

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getInputKeys_async(AMI_ISession_getInputKeys __cb, String sess, java.util.Map<String, String> __ctx);

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     **/
    public java.util.List<String> getOutputKeys(String sess)
        throws omero.ServerError;

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<String> getOutputKeys(String sess, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOutputKeys(String sess);

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOutputKeys(String sess, java.util.Map<String, String> __ctx);

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOutputKeys(String sess, Ice.Callback __cb);

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOutputKeys(String sess, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOutputKeys(String sess, Callback_ISession_getOutputKeys __cb);

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOutputKeys(String sess, java.util.Map<String, String> __ctx, Callback_ISession_getOutputKeys __cb);

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __result The asynchronous result object.
     **/
    public java.util.List<String> end_getOutputKeys(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     **/
    public boolean getOutputKeys_async(AMI_ISession_getOutputKeys __cb, String sess);

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getOutputKeys_async(AMI_ISession_getOutputKeys __cb, String sess, java.util.Map<String, String> __ctx);

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     **/
    public java.util.Map<java.lang.String, omero.RType> getInputs(String sess)
        throws omero.ServerError;

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.Map<java.lang.String, omero.RType> getInputs(String sess, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getInputs(String sess);

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getInputs(String sess, java.util.Map<String, String> __ctx);

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getInputs(String sess, Ice.Callback __cb);

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getInputs(String sess, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getInputs(String sess, Callback_ISession_getInputs __cb);

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getInputs(String sess, java.util.Map<String, String> __ctx, Callback_ISession_getInputs __cb);

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __result The asynchronous result object.
     **/
    public java.util.Map<java.lang.String, omero.RType> end_getInputs(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     **/
    public boolean getInputs_async(AMI_ISession_getInputs __cb, String sess);

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getInputs_async(AMI_ISession_getInputs __cb, String sess, java.util.Map<String, String> __ctx);

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     **/
    public java.util.Map<java.lang.String, omero.RType> getOutputs(String sess)
        throws omero.ServerError;

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.Map<java.lang.String, omero.RType> getOutputs(String sess, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOutputs(String sess);

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOutputs(String sess, java.util.Map<String, String> __ctx);

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOutputs(String sess, Ice.Callback __cb);

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOutputs(String sess, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOutputs(String sess, Callback_ISession_getOutputs __cb);

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOutputs(String sess, java.util.Map<String, String> __ctx, Callback_ISession_getOutputs __cb);

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __result The asynchronous result object.
     **/
    public java.util.Map<java.lang.String, omero.RType> end_getOutputs(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     **/
    public boolean getOutputs_async(AMI_ISession_getOutputs __cb, String sess);

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getOutputs_async(AMI_ISession_getOutputs __cb, String sess, java.util.Map<String, String> __ctx);
}
