// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `ISession.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * {@link omero.model.Session} creation service for OMERO. Access to
 * all other services is dependent upon a properly created and still
 * active {@link omero.model.Session}.
 * 
 * The session uuid ({@link omero.model.Session#getUuid}) can be
 * considered a capability token, or temporary single use password.
 * Simply by possessing it the client has access to all information
 * available to the {@link omero.model.Session}.
 * 
 * Note: Both the RMI <code>ome.system.ServiceFactory</code> as well
 * as the Ice {@link omero.api.ServiceFactory} use
 * {@link omero.api.ISession} to acquire a
 * {@link omero.model.Session}. In the Ice case, Glacier2
 * contacts {@link omero.api.ISession} itself and returns a
 * ServiceFactory remote proxy. From both ServiceFactory
 * instances, it is possible but not necessary to access
 * {@link omero.api.ISession}.
 **/
public final class ISessionPrxHelper extends Ice.ObjectPrxHelperBase implements ISessionPrx
{
    private static final String __closeSession_name = "closeSession";

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     **/
    public int closeSession(omero.model.Session sess)
        throws omero.ServerError
    {
        return closeSession(sess, null, false);
    }

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __ctx The Context map to send with the invocation.
     **/
    public int closeSession(omero.model.Session sess, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return closeSession(sess, __ctx, true);
    }

    private int closeSession(omero.model.Session sess, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "closeSession", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("closeSession");
                    __delBase = __getDelegate(false);
                    _ISessionDel __del = (_ISessionDel)__delBase;
                    return __del.closeSession(sess, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_closeSession(omero.model.Session sess)
    {
        return begin_closeSession(sess, null, false, null);
    }

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_closeSession(omero.model.Session sess, java.util.Map<String, String> __ctx)
    {
        return begin_closeSession(sess, __ctx, true, null);
    }

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_closeSession(omero.model.Session sess, Ice.Callback __cb)
    {
        return begin_closeSession(sess, null, false, __cb);
    }

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_closeSession(omero.model.Session sess, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_closeSession(sess, __ctx, true, __cb);
    }

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_closeSession(omero.model.Session sess, Callback_ISession_closeSession __cb)
    {
        return begin_closeSession(sess, null, false, __cb);
    }

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_closeSession(omero.model.Session sess, java.util.Map<String, String> __ctx, Callback_ISession_closeSession __cb)
    {
        return begin_closeSession(sess, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_closeSession(omero.model.Session sess, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__closeSession_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __closeSession_name, __cb);
        try
        {
            __result.__prepare(__closeSession_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(sess);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public int end_closeSession(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __closeSession_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int __ret;
            __ret = __is.readInt();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __cb The callback object for the operation.
     **/
    public boolean closeSession_async(AMI_ISession_closeSession __cb, omero.model.Session sess)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__closeSession_name);
            __r = begin_closeSession(sess, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __closeSession_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean closeSession_async(AMI_ISession_closeSession __cb, omero.model.Session sess, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__closeSession_name);
            __r = begin_closeSession(sess, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __closeSession_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __createSession_name = "createSession";

    /**
     * Creates a new session and returns it to the user.
     * 
     * @throws ApiUsageException if principal is null
     * @throws SecurityViolation if the password check fails
     **/
    public omero.model.Session createSession(omero.sys.Principal p, String credentials)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        return createSession(p, credentials, null, false);
    }

    /**
     * Creates a new session and returns it to the user.
     * 
     * @throws ApiUsageException if principal is null
     * @throws SecurityViolation if the password check fails
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.Session createSession(omero.sys.Principal p, String credentials, java.util.Map<String, String> __ctx)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        return createSession(p, credentials, __ctx, true);
    }

    private omero.model.Session createSession(omero.sys.Principal p, String credentials, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "createSession", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("createSession");
                    __delBase = __getDelegate(false);
                    _ISessionDel __del = (_ISessionDel)__delBase;
                    return __del.createSession(p, credentials, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Creates a new session and returns it to the user.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_createSession(omero.sys.Principal p, String credentials)
    {
        return begin_createSession(p, credentials, null, false, null);
    }

    /**
     * Creates a new session and returns it to the user.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createSession(omero.sys.Principal p, String credentials, java.util.Map<String, String> __ctx)
    {
        return begin_createSession(p, credentials, __ctx, true, null);
    }

    /**
     * Creates a new session and returns it to the user.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_createSession(omero.sys.Principal p, String credentials, Ice.Callback __cb)
    {
        return begin_createSession(p, credentials, null, false, __cb);
    }

    /**
     * Creates a new session and returns it to the user.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createSession(omero.sys.Principal p, String credentials, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_createSession(p, credentials, __ctx, true, __cb);
    }

    /**
     * Creates a new session and returns it to the user.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_createSession(omero.sys.Principal p, String credentials, Callback_ISession_createSession __cb)
    {
        return begin_createSession(p, credentials, null, false, __cb);
    }

    /**
     * Creates a new session and returns it to the user.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createSession(omero.sys.Principal p, String credentials, java.util.Map<String, String> __ctx, Callback_ISession_createSession __cb)
    {
        return begin_createSession(p, credentials, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_createSession(omero.sys.Principal p, String credentials, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__createSession_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __createSession_name, __cb);
        try
        {
            __result.__prepare(__createSession_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(p);
            __os.writeString(credentials);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.model.Session end_createSession(Ice.AsyncResult __result)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __createSession_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Glacier2.CannotCreateSessionException __ex)
                {
                    throw __ex;
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.SessionHolder __ret = new omero.model.SessionHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Creates a new session and returns it to the user.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean createSession_async(AMI_ISession_createSession __cb, omero.sys.Principal p, String credentials)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createSession_name);
            __r = begin_createSession(p, credentials, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createSession_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Creates a new session and returns it to the user.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createSession_async(AMI_ISession_createSession __cb, omero.sys.Principal p, String credentials, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createSession_name);
            __r = begin_createSession(p, credentials, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createSession_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __createSessionWithTimeout_name = "createSessionWithTimeout";

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param principal
     * Non-null {@link omero.sys.Principal} with the
     * target user's name
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     **/
    public omero.model.Session createSessionWithTimeout(omero.sys.Principal p, long timeToLiveMilliseconds)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        return createSessionWithTimeout(p, timeToLiveMilliseconds, null, false);
    }

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param principal
     * Non-null {@link omero.sys.Principal} with the
     * target user's name
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.Session createSessionWithTimeout(omero.sys.Principal p, long timeToLiveMilliseconds, java.util.Map<String, String> __ctx)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        return createSessionWithTimeout(p, timeToLiveMilliseconds, __ctx, true);
    }

    private omero.model.Session createSessionWithTimeout(omero.sys.Principal p, long timeToLiveMilliseconds, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "createSessionWithTimeout", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("createSessionWithTimeout");
                    __delBase = __getDelegate(false);
                    _ISessionDel __del = (_ISessionDel)__delBase;
                    return __del.createSessionWithTimeout(p, timeToLiveMilliseconds, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeout(omero.sys.Principal p, long timeToLiveMilliseconds)
    {
        return begin_createSessionWithTimeout(p, timeToLiveMilliseconds, null, false, null);
    }

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeout(omero.sys.Principal p, long timeToLiveMilliseconds, java.util.Map<String, String> __ctx)
    {
        return begin_createSessionWithTimeout(p, timeToLiveMilliseconds, __ctx, true, null);
    }

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeout(omero.sys.Principal p, long timeToLiveMilliseconds, Ice.Callback __cb)
    {
        return begin_createSessionWithTimeout(p, timeToLiveMilliseconds, null, false, __cb);
    }

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeout(omero.sys.Principal p, long timeToLiveMilliseconds, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_createSessionWithTimeout(p, timeToLiveMilliseconds, __ctx, true, __cb);
    }

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeout(omero.sys.Principal p, long timeToLiveMilliseconds, Callback_ISession_createSessionWithTimeout __cb)
    {
        return begin_createSessionWithTimeout(p, timeToLiveMilliseconds, null, false, __cb);
    }

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeout(omero.sys.Principal p, long timeToLiveMilliseconds, java.util.Map<String, String> __ctx, Callback_ISession_createSessionWithTimeout __cb)
    {
        return begin_createSessionWithTimeout(p, timeToLiveMilliseconds, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_createSessionWithTimeout(omero.sys.Principal p, long timeToLiveMilliseconds, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__createSessionWithTimeout_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __createSessionWithTimeout_name, __cb);
        try
        {
            __result.__prepare(__createSessionWithTimeout_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(p);
            __os.writeLong(timeToLiveMilliseconds);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.model.Session end_createSessionWithTimeout(Ice.AsyncResult __result)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __createSessionWithTimeout_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Glacier2.CannotCreateSessionException __ex)
                {
                    throw __ex;
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.SessionHolder __ret = new omero.model.SessionHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     **/
    public boolean createSessionWithTimeout_async(AMI_ISession_createSessionWithTimeout __cb, omero.sys.Principal p, long timeToLiveMilliseconds)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createSessionWithTimeout_name);
            __r = begin_createSessionWithTimeout(p, timeToLiveMilliseconds, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createSessionWithTimeout_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createSessionWithTimeout_async(AMI_ISession_createSessionWithTimeout __cb, omero.sys.Principal p, long timeToLiveMilliseconds, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createSessionWithTimeout_name);
            __r = begin_createSessionWithTimeout(p, timeToLiveMilliseconds, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createSessionWithTimeout_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __createSessionWithTimeouts_name = "createSessionWithTimeouts";

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param principal
     * Non-null {@link omero.sys.Principal} with the
     * target user's name
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     **/
    public omero.model.Session createSessionWithTimeouts(omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        return createSessionWithTimeouts(p, timeToLiveMilliseconds, timeToIdleMilliseconds, null, false);
    }

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param principal
     * Non-null {@link omero.sys.Principal} with the
     * target user's name
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.Session createSessionWithTimeouts(omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds, java.util.Map<String, String> __ctx)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        return createSessionWithTimeouts(p, timeToLiveMilliseconds, timeToIdleMilliseconds, __ctx, true);
    }

    private omero.model.Session createSessionWithTimeouts(omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "createSessionWithTimeouts", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("createSessionWithTimeouts");
                    __delBase = __getDelegate(false);
                    _ISessionDel __del = (_ISessionDel)__delBase;
                    return __del.createSessionWithTimeouts(p, timeToLiveMilliseconds, timeToIdleMilliseconds, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeouts(omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds)
    {
        return begin_createSessionWithTimeouts(p, timeToLiveMilliseconds, timeToIdleMilliseconds, null, false, null);
    }

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeouts(omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds, java.util.Map<String, String> __ctx)
    {
        return begin_createSessionWithTimeouts(p, timeToLiveMilliseconds, timeToIdleMilliseconds, __ctx, true, null);
    }

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeouts(omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds, Ice.Callback __cb)
    {
        return begin_createSessionWithTimeouts(p, timeToLiveMilliseconds, timeToIdleMilliseconds, null, false, __cb);
    }

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeouts(omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_createSessionWithTimeouts(p, timeToLiveMilliseconds, timeToIdleMilliseconds, __ctx, true, __cb);
    }

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeouts(omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds, Callback_ISession_createSessionWithTimeouts __cb)
    {
        return begin_createSessionWithTimeouts(p, timeToLiveMilliseconds, timeToIdleMilliseconds, null, false, __cb);
    }

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createSessionWithTimeouts(omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds, java.util.Map<String, String> __ctx, Callback_ISession_createSessionWithTimeouts __cb)
    {
        return begin_createSessionWithTimeouts(p, timeToLiveMilliseconds, timeToIdleMilliseconds, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_createSessionWithTimeouts(omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__createSessionWithTimeouts_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __createSessionWithTimeouts_name, __cb);
        try
        {
            __result.__prepare(__createSessionWithTimeouts_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(p);
            __os.writeLong(timeToLiveMilliseconds);
            __os.writeLong(timeToIdleMilliseconds);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.model.Session end_createSessionWithTimeouts(Ice.AsyncResult __result)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __createSessionWithTimeouts_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Glacier2.CannotCreateSessionException __ex)
                {
                    throw __ex;
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.SessionHolder __ret = new omero.model.SessionHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     **/
    public boolean createSessionWithTimeouts_async(AMI_ISession_createSessionWithTimeouts __cb, omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createSessionWithTimeouts_name);
            __r = begin_createSessionWithTimeouts(p, timeToLiveMilliseconds, timeToIdleMilliseconds, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createSessionWithTimeouts_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createSessionWithTimeouts_async(AMI_ISession_createSessionWithTimeouts __cb, omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createSessionWithTimeouts_name);
            __r = begin_createSessionWithTimeouts(p, timeToLiveMilliseconds, timeToIdleMilliseconds, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createSessionWithTimeouts_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __createUserSession_name = "createUserSession";

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     **/
    public omero.model.Session createUserSession(long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        return createUserSession(timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup, null, false);
    }

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.Session createUserSession(long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup, java.util.Map<String, String> __ctx)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        return createUserSession(timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup, __ctx, true);
    }

    private omero.model.Session createUserSession(long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "createUserSession", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("createUserSession");
                    __delBase = __getDelegate(false);
                    _ISessionDel __del = (_ISessionDel)__delBase;
                    return __del.createUserSession(timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_createUserSession(long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup)
    {
        return begin_createUserSession(timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup, null, false, null);
    }

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createUserSession(long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup, java.util.Map<String, String> __ctx)
    {
        return begin_createUserSession(timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup, __ctx, true, null);
    }

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_createUserSession(long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup, Ice.Callback __cb)
    {
        return begin_createUserSession(timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup, null, false, __cb);
    }

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createUserSession(long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_createUserSession(timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup, __ctx, true, __cb);
    }

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_createUserSession(long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup, Callback_ISession_createUserSession __cb)
    {
        return begin_createUserSession(timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup, null, false, __cb);
    }

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createUserSession(long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup, java.util.Map<String, String> __ctx, Callback_ISession_createUserSession __cb)
    {
        return begin_createUserSession(timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_createUserSession(long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__createUserSession_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __createUserSession_name, __cb);
        try
        {
            __result.__prepare(__createUserSession_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(timeToLiveMilliseconds);
            __os.writeLong(timeToIdleMilliseconds);
            __os.writeString(defaultGroup);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.model.Session end_createUserSession(Ice.AsyncResult __result)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __createUserSession_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Glacier2.CannotCreateSessionException __ex)
                {
                    throw __ex;
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.SessionHolder __ret = new omero.model.SessionHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __cb The callback object for the operation.
     **/
    public boolean createUserSession_async(AMI_ISession_createUserSession __cb, long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createUserSession_name);
            __r = begin_createUserSession(timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createUserSession_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createUserSession_async(AMI_ISession_createUserSession __cb, long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createUserSession_name);
            __r = begin_createUserSession(timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createUserSession_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getInput_name = "getInput";

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     **/
    public omero.RType getInput(String sess, String key)
        throws omero.ServerError
    {
        return getInput(sess, key, null, false);
    }

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.RType getInput(String sess, String key, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getInput(sess, key, __ctx, true);
    }

    private omero.RType getInput(String sess, String key, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getInput", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getInput");
                    __delBase = __getDelegate(false);
                    _ISessionDel __del = (_ISessionDel)__delBase;
                    return __del.getInput(sess, key, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getInput(String sess, String key)
    {
        return begin_getInput(sess, key, null, false, null);
    }

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getInput(String sess, String key, java.util.Map<String, String> __ctx)
    {
        return begin_getInput(sess, key, __ctx, true, null);
    }

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getInput(String sess, String key, Ice.Callback __cb)
    {
        return begin_getInput(sess, key, null, false, __cb);
    }

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getInput(String sess, String key, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getInput(sess, key, __ctx, true, __cb);
    }

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getInput(String sess, String key, Callback_ISession_getInput __cb)
    {
        return begin_getInput(sess, key, null, false, __cb);
    }

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getInput(String sess, String key, java.util.Map<String, String> __ctx, Callback_ISession_getInput __cb)
    {
        return begin_getInput(sess, key, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getInput(String sess, String key, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getInput_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getInput_name, __cb);
        try
        {
            __result.__prepare(__getInput_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(sess);
            __os.writeString(key);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.RType end_getInput(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getInput_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.RTypeHolder __ret = new omero.RTypeHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     **/
    public boolean getInput_async(AMI_ISession_getInput __cb, String sess, String key)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getInput_name);
            __r = begin_getInput(sess, key, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getInput_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getInput_async(AMI_ISession_getInput __cb, String sess, String key, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getInput_name);
            __r = begin_getInput(sess, key, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getInput_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getInputKeys_name = "getInputKeys";

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @return a {@link StringSet} of keys
     **/
    public java.util.List<String> getInputKeys(String sess)
        throws omero.ServerError
    {
        return getInputKeys(sess, null, false);
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return a {@link StringSet} of keys
     **/
    public java.util.List<String> getInputKeys(String sess, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getInputKeys(sess, __ctx, true);
    }

    private java.util.List<String> getInputKeys(String sess, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getInputKeys", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getInputKeys");
                    __delBase = __getDelegate(false);
                    _ISessionDel __del = (_ISessionDel)__delBase;
                    return __del.getInputKeys(sess, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getInputKeys(String sess)
    {
        return begin_getInputKeys(sess, null, false, null);
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getInputKeys(String sess, java.util.Map<String, String> __ctx)
    {
        return begin_getInputKeys(sess, __ctx, true, null);
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getInputKeys(String sess, Ice.Callback __cb)
    {
        return begin_getInputKeys(sess, null, false, __cb);
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getInputKeys(String sess, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getInputKeys(sess, __ctx, true, __cb);
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getInputKeys(String sess, Callback_ISession_getInputKeys __cb)
    {
        return begin_getInputKeys(sess, null, false, __cb);
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getInputKeys(String sess, java.util.Map<String, String> __ctx, Callback_ISession_getInputKeys __cb)
    {
        return begin_getInputKeys(sess, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getInputKeys(String sess, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getInputKeys_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getInputKeys_name, __cb);
        try
        {
            __result.__prepare(__getInputKeys_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(sess);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a {@link StringSet} of keys
     **/
    public java.util.List<String> end_getInputKeys(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getInputKeys_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<String> __ret;
            __ret = StringSetHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getInputKeys_async(AMI_ISession_getInputKeys __cb, String sess)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getInputKeys_name);
            __r = begin_getInputKeys(sess, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getInputKeys_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getInputKeys_async(AMI_ISession_getInputKeys __cb, String sess, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getInputKeys_name);
            __r = begin_getInputKeys(sess, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getInputKeys_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getInputs_name = "getInputs";

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     **/
    public java.util.Map<java.lang.String, omero.RType> getInputs(String sess)
        throws omero.ServerError
    {
        return getInputs(sess, null, false);
    }

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.Map<java.lang.String, omero.RType> getInputs(String sess, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getInputs(sess, __ctx, true);
    }

    private java.util.Map<java.lang.String, omero.RType> getInputs(String sess, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getInputs", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getInputs");
                    __delBase = __getDelegate(false);
                    _ISessionDel __del = (_ISessionDel)__delBase;
                    return __del.getInputs(sess, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getInputs(String sess)
    {
        return begin_getInputs(sess, null, false, null);
    }

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getInputs(String sess, java.util.Map<String, String> __ctx)
    {
        return begin_getInputs(sess, __ctx, true, null);
    }

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getInputs(String sess, Ice.Callback __cb)
    {
        return begin_getInputs(sess, null, false, __cb);
    }

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getInputs(String sess, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getInputs(sess, __ctx, true, __cb);
    }

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getInputs(String sess, Callback_ISession_getInputs __cb)
    {
        return begin_getInputs(sess, null, false, __cb);
    }

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getInputs(String sess, java.util.Map<String, String> __ctx, Callback_ISession_getInputs __cb)
    {
        return begin_getInputs(sess, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getInputs(String sess, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getInputs_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getInputs_name, __cb);
        try
        {
            __result.__prepare(__getInputs_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(sess);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.Map<java.lang.String, omero.RType> end_getInputs(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getInputs_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.String, omero.RType> __ret;
            __ret = omero.RTypeDictHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     **/
    public boolean getInputs_async(AMI_ISession_getInputs __cb, String sess)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getInputs_name);
            __r = begin_getInputs(sess, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getInputs_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getInputs_async(AMI_ISession_getInputs __cb, String sess, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getInputs_name);
            __r = begin_getInputs(sess, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getInputs_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getMyOpenAgentSessions_name = "getMyOpenAgentSessions";

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     **/
    public java.util.List<omero.model.Session> getMyOpenAgentSessions(String agent)
        throws omero.ServerError
    {
        return getMyOpenAgentSessions(agent, null, false);
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.Session> getMyOpenAgentSessions(String agent, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getMyOpenAgentSessions(agent, __ctx, true);
    }

    private java.util.List<omero.model.Session> getMyOpenAgentSessions(String agent, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getMyOpenAgentSessions", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getMyOpenAgentSessions");
                    __delBase = __getDelegate(false);
                    _ISessionDel __del = (_ISessionDel)__delBase;
                    return __del.getMyOpenAgentSessions(agent, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMyOpenAgentSessions(String agent)
    {
        return begin_getMyOpenAgentSessions(agent, null, false, null);
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMyOpenAgentSessions(String agent, java.util.Map<String, String> __ctx)
    {
        return begin_getMyOpenAgentSessions(agent, __ctx, true, null);
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMyOpenAgentSessions(String agent, Ice.Callback __cb)
    {
        return begin_getMyOpenAgentSessions(agent, null, false, __cb);
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMyOpenAgentSessions(String agent, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getMyOpenAgentSessions(agent, __ctx, true, __cb);
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMyOpenAgentSessions(String agent, Callback_ISession_getMyOpenAgentSessions __cb)
    {
        return begin_getMyOpenAgentSessions(agent, null, false, __cb);
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMyOpenAgentSessions(String agent, java.util.Map<String, String> __ctx, Callback_ISession_getMyOpenAgentSessions __cb)
    {
        return begin_getMyOpenAgentSessions(agent, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getMyOpenAgentSessions(String agent, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getMyOpenAgentSessions_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getMyOpenAgentSessions_name, __cb);
        try
        {
            __result.__prepare(__getMyOpenAgentSessions_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(agent);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.List<omero.model.Session> end_getMyOpenAgentSessions(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getMyOpenAgentSessions_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.Session> __ret;
            __ret = SessionListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __cb The callback object for the operation.
     **/
    public boolean getMyOpenAgentSessions_async(AMI_ISession_getMyOpenAgentSessions __cb, String agent)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getMyOpenAgentSessions_name);
            __r = begin_getMyOpenAgentSessions(agent, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getMyOpenAgentSessions_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getMyOpenAgentSessions_async(AMI_ISession_getMyOpenAgentSessions __cb, String agent, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getMyOpenAgentSessions_name);
            __r = begin_getMyOpenAgentSessions(agent, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getMyOpenAgentSessions_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getMyOpenClientSessions_name = "getMyOpenClientSessions";

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     **/
    public java.util.List<omero.model.Session> getMyOpenClientSessions()
        throws omero.ServerError
    {
        return getMyOpenClientSessions(null, false);
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.Session> getMyOpenClientSessions(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getMyOpenClientSessions(__ctx, true);
    }

    private java.util.List<omero.model.Session> getMyOpenClientSessions(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getMyOpenClientSessions", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getMyOpenClientSessions");
                    __delBase = __getDelegate(false);
                    _ISessionDel __del = (_ISessionDel)__delBase;
                    return __del.getMyOpenClientSessions(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMyOpenClientSessions()
    {
        return begin_getMyOpenClientSessions(null, false, null);
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMyOpenClientSessions(java.util.Map<String, String> __ctx)
    {
        return begin_getMyOpenClientSessions(__ctx, true, null);
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMyOpenClientSessions(Ice.Callback __cb)
    {
        return begin_getMyOpenClientSessions(null, false, __cb);
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMyOpenClientSessions(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getMyOpenClientSessions(__ctx, true, __cb);
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMyOpenClientSessions(Callback_ISession_getMyOpenClientSessions __cb)
    {
        return begin_getMyOpenClientSessions(null, false, __cb);
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMyOpenClientSessions(java.util.Map<String, String> __ctx, Callback_ISession_getMyOpenClientSessions __cb)
    {
        return begin_getMyOpenClientSessions(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getMyOpenClientSessions(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getMyOpenClientSessions_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getMyOpenClientSessions_name, __cb);
        try
        {
            __result.__prepare(__getMyOpenClientSessions_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.List<omero.model.Session> end_getMyOpenClientSessions(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getMyOpenClientSessions_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.Session> __ret;
            __ret = SessionListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __cb The callback object for the operation.
     **/
    public boolean getMyOpenClientSessions_async(AMI_ISession_getMyOpenClientSessions __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getMyOpenClientSessions_name);
            __r = begin_getMyOpenClientSessions(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getMyOpenClientSessions_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getMyOpenClientSessions_async(AMI_ISession_getMyOpenClientSessions __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getMyOpenClientSessions_name);
            __r = begin_getMyOpenClientSessions(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getMyOpenClientSessions_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getMyOpenSessions_name = "getMyOpenSessions";

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     **/
    public java.util.List<omero.model.Session> getMyOpenSessions()
        throws omero.ServerError
    {
        return getMyOpenSessions(null, false);
    }

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.Session> getMyOpenSessions(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getMyOpenSessions(__ctx, true);
    }

    private java.util.List<omero.model.Session> getMyOpenSessions(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getMyOpenSessions", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getMyOpenSessions");
                    __delBase = __getDelegate(false);
                    _ISessionDel __del = (_ISessionDel)__delBase;
                    return __del.getMyOpenSessions(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMyOpenSessions()
    {
        return begin_getMyOpenSessions(null, false, null);
    }

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMyOpenSessions(java.util.Map<String, String> __ctx)
    {
        return begin_getMyOpenSessions(__ctx, true, null);
    }

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMyOpenSessions(Ice.Callback __cb)
    {
        return begin_getMyOpenSessions(null, false, __cb);
    }

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMyOpenSessions(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getMyOpenSessions(__ctx, true, __cb);
    }

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMyOpenSessions(Callback_ISession_getMyOpenSessions __cb)
    {
        return begin_getMyOpenSessions(null, false, __cb);
    }

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMyOpenSessions(java.util.Map<String, String> __ctx, Callback_ISession_getMyOpenSessions __cb)
    {
        return begin_getMyOpenSessions(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getMyOpenSessions(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getMyOpenSessions_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getMyOpenSessions_name, __cb);
        try
        {
            __result.__prepare(__getMyOpenSessions_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.List<omero.model.Session> end_getMyOpenSessions(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getMyOpenSessions_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.Session> __ret;
            __ret = SessionListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __cb The callback object for the operation.
     **/
    public boolean getMyOpenSessions_async(AMI_ISession_getMyOpenSessions __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getMyOpenSessions_name);
            __r = begin_getMyOpenSessions(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getMyOpenSessions_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getMyOpenSessions_async(AMI_ISession_getMyOpenSessions __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getMyOpenSessions_name);
            __r = begin_getMyOpenSessions(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getMyOpenSessions_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getOutput_name = "getOutput";

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     **/
    public omero.RType getOutput(String sess, String key)
        throws omero.ServerError
    {
        return getOutput(sess, key, null, false);
    }

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.RType getOutput(String sess, String key, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getOutput(sess, key, __ctx, true);
    }

    private omero.RType getOutput(String sess, String key, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getOutput", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getOutput");
                    __delBase = __getDelegate(false);
                    _ISessionDel __del = (_ISessionDel)__delBase;
                    return __del.getOutput(sess, key, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getOutput(String sess, String key)
    {
        return begin_getOutput(sess, key, null, false, null);
    }

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getOutput(String sess, String key, java.util.Map<String, String> __ctx)
    {
        return begin_getOutput(sess, key, __ctx, true, null);
    }

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getOutput(String sess, String key, Ice.Callback __cb)
    {
        return begin_getOutput(sess, key, null, false, __cb);
    }

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getOutput(String sess, String key, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getOutput(sess, key, __ctx, true, __cb);
    }

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getOutput(String sess, String key, Callback_ISession_getOutput __cb)
    {
        return begin_getOutput(sess, key, null, false, __cb);
    }

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getOutput(String sess, String key, java.util.Map<String, String> __ctx, Callback_ISession_getOutput __cb)
    {
        return begin_getOutput(sess, key, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getOutput(String sess, String key, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getOutput_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getOutput_name, __cb);
        try
        {
            __result.__prepare(__getOutput_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(sess);
            __os.writeString(key);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.RType end_getOutput(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getOutput_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.RTypeHolder __ret = new omero.RTypeHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     **/
    public boolean getOutput_async(AMI_ISession_getOutput __cb, String sess, String key)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getOutput_name);
            __r = begin_getOutput(sess, key, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getOutput_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getOutput_async(AMI_ISession_getOutput __cb, String sess, String key, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getOutput_name);
            __r = begin_getOutput(sess, key, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getOutput_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getOutputKeys_name = "getOutputKeys";

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     **/
    public java.util.List<String> getOutputKeys(String sess)
        throws omero.ServerError
    {
        return getOutputKeys(sess, null, false);
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<String> getOutputKeys(String sess, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getOutputKeys(sess, __ctx, true);
    }

    private java.util.List<String> getOutputKeys(String sess, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getOutputKeys", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getOutputKeys");
                    __delBase = __getDelegate(false);
                    _ISessionDel __del = (_ISessionDel)__delBase;
                    return __del.getOutputKeys(sess, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getOutputKeys(String sess)
    {
        return begin_getOutputKeys(sess, null, false, null);
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getOutputKeys(String sess, java.util.Map<String, String> __ctx)
    {
        return begin_getOutputKeys(sess, __ctx, true, null);
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getOutputKeys(String sess, Ice.Callback __cb)
    {
        return begin_getOutputKeys(sess, null, false, __cb);
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getOutputKeys(String sess, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getOutputKeys(sess, __ctx, true, __cb);
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getOutputKeys(String sess, Callback_ISession_getOutputKeys __cb)
    {
        return begin_getOutputKeys(sess, null, false, __cb);
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getOutputKeys(String sess, java.util.Map<String, String> __ctx, Callback_ISession_getOutputKeys __cb)
    {
        return begin_getOutputKeys(sess, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getOutputKeys(String sess, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getOutputKeys_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getOutputKeys_name, __cb);
        try
        {
            __result.__prepare(__getOutputKeys_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(sess);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.List<String> end_getOutputKeys(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getOutputKeys_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<String> __ret;
            __ret = StringSetHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     **/
    public boolean getOutputKeys_async(AMI_ISession_getOutputKeys __cb, String sess)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getOutputKeys_name);
            __r = begin_getOutputKeys(sess, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getOutputKeys_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getOutputKeys_async(AMI_ISession_getOutputKeys __cb, String sess, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getOutputKeys_name);
            __r = begin_getOutputKeys(sess, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getOutputKeys_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getOutputs_name = "getOutputs";

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     **/
    public java.util.Map<java.lang.String, omero.RType> getOutputs(String sess)
        throws omero.ServerError
    {
        return getOutputs(sess, null, false);
    }

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.Map<java.lang.String, omero.RType> getOutputs(String sess, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getOutputs(sess, __ctx, true);
    }

    private java.util.Map<java.lang.String, omero.RType> getOutputs(String sess, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getOutputs", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getOutputs");
                    __delBase = __getDelegate(false);
                    _ISessionDel __del = (_ISessionDel)__delBase;
                    return __del.getOutputs(sess, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getOutputs(String sess)
    {
        return begin_getOutputs(sess, null, false, null);
    }

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getOutputs(String sess, java.util.Map<String, String> __ctx)
    {
        return begin_getOutputs(sess, __ctx, true, null);
    }

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getOutputs(String sess, Ice.Callback __cb)
    {
        return begin_getOutputs(sess, null, false, __cb);
    }

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getOutputs(String sess, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getOutputs(sess, __ctx, true, __cb);
    }

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getOutputs(String sess, Callback_ISession_getOutputs __cb)
    {
        return begin_getOutputs(sess, null, false, __cb);
    }

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getOutputs(String sess, java.util.Map<String, String> __ctx, Callback_ISession_getOutputs __cb)
    {
        return begin_getOutputs(sess, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getOutputs(String sess, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getOutputs_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getOutputs_name, __cb);
        try
        {
            __result.__prepare(__getOutputs_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(sess);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.Map<java.lang.String, omero.RType> end_getOutputs(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getOutputs_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.String, omero.RType> __ret;
            __ret = omero.RTypeDictHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     **/
    public boolean getOutputs_async(AMI_ISession_getOutputs __cb, String sess)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getOutputs_name);
            __r = begin_getOutputs(sess, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getOutputs_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getOutputs_async(AMI_ISession_getOutputs __cb, String sess, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getOutputs_name);
            __r = begin_getOutputs(sess, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getOutputs_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getReferenceCount_name = "getReferenceCount";

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     **/
    public int getReferenceCount(String sessionUuid)
        throws omero.ServerError
    {
        return getReferenceCount(sessionUuid, null, false);
    }

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public int getReferenceCount(String sessionUuid, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getReferenceCount(sessionUuid, __ctx, true);
    }

    private int getReferenceCount(String sessionUuid, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getReferenceCount", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getReferenceCount");
                    __delBase = __getDelegate(false);
                    _ISessionDel __del = (_ISessionDel)__delBase;
                    return __del.getReferenceCount(sessionUuid, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getReferenceCount(String sessionUuid)
    {
        return begin_getReferenceCount(sessionUuid, null, false, null);
    }

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getReferenceCount(String sessionUuid, java.util.Map<String, String> __ctx)
    {
        return begin_getReferenceCount(sessionUuid, __ctx, true, null);
    }

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getReferenceCount(String sessionUuid, Ice.Callback __cb)
    {
        return begin_getReferenceCount(sessionUuid, null, false, __cb);
    }

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getReferenceCount(String sessionUuid, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getReferenceCount(sessionUuid, __ctx, true, __cb);
    }

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getReferenceCount(String sessionUuid, Callback_ISession_getReferenceCount __cb)
    {
        return begin_getReferenceCount(sessionUuid, null, false, __cb);
    }

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getReferenceCount(String sessionUuid, java.util.Map<String, String> __ctx, Callback_ISession_getReferenceCount __cb)
    {
        return begin_getReferenceCount(sessionUuid, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getReferenceCount(String sessionUuid, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getReferenceCount_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getReferenceCount_name, __cb);
        try
        {
            __result.__prepare(__getReferenceCount_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(sessionUuid);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public int end_getReferenceCount(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getReferenceCount_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int __ret;
            __ret = __is.readInt();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __cb The callback object for the operation.
     **/
    public boolean getReferenceCount_async(AMI_ISession_getReferenceCount __cb, String sessionUuid)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getReferenceCount_name);
            __r = begin_getReferenceCount(sessionUuid, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getReferenceCount_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getReferenceCount_async(AMI_ISession_getReferenceCount __cb, String sessionUuid, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getReferenceCount_name);
            __r = begin_getReferenceCount(sessionUuid, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getReferenceCount_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getSession_name = "getSession";

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     **/
    public omero.model.Session getSession(String sessionUuid)
        throws omero.ServerError
    {
        return getSession(sessionUuid, null, false);
    }

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.Session getSession(String sessionUuid, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getSession(sessionUuid, __ctx, true);
    }

    private omero.model.Session getSession(String sessionUuid, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getSession", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getSession");
                    __delBase = __getDelegate(false);
                    _ISessionDel __del = (_ISessionDel)__delBase;
                    return __del.getSession(sessionUuid, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getSession(String sessionUuid)
    {
        return begin_getSession(sessionUuid, null, false, null);
    }

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getSession(String sessionUuid, java.util.Map<String, String> __ctx)
    {
        return begin_getSession(sessionUuid, __ctx, true, null);
    }

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getSession(String sessionUuid, Ice.Callback __cb)
    {
        return begin_getSession(sessionUuid, null, false, __cb);
    }

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getSession(String sessionUuid, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getSession(sessionUuid, __ctx, true, __cb);
    }

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getSession(String sessionUuid, Callback_ISession_getSession __cb)
    {
        return begin_getSession(sessionUuid, null, false, __cb);
    }

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getSession(String sessionUuid, java.util.Map<String, String> __ctx, Callback_ISession_getSession __cb)
    {
        return begin_getSession(sessionUuid, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getSession(String sessionUuid, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getSession_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getSession_name, __cb);
        try
        {
            __result.__prepare(__getSession_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(sessionUuid);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.model.Session end_getSession(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getSession_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.SessionHolder __ret = new omero.model.SessionHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __cb The callback object for the operation.
     **/
    public boolean getSession_async(AMI_ISession_getSession __cb, String sessionUuid)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getSession_name);
            __r = begin_getSession(sessionUuid, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getSession_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getSession_async(AMI_ISession_getSession __cb, String sessionUuid, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getSession_name);
            __r = begin_getSession(sessionUuid, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getSession_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setInput_name = "setInput";

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     **/
    public void setInput(String sess, String key, omero.RType value)
        throws omero.ServerError
    {
        setInput(sess, key, value, null, false);
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setInput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setInput(sess, key, value, __ctx, true);
    }

    private void setInput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setInput", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setInput");
                    __delBase = __getDelegate(false);
                    _ISessionDel __del = (_ISessionDel)__delBase;
                    __del.setInput(sess, key, value, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setInput(String sess, String key, omero.RType value)
    {
        return begin_setInput(sess, key, value, null, false, null);
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setInput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx)
    {
        return begin_setInput(sess, key, value, __ctx, true, null);
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setInput(String sess, String key, omero.RType value, Ice.Callback __cb)
    {
        return begin_setInput(sess, key, value, null, false, __cb);
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setInput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setInput(sess, key, value, __ctx, true, __cb);
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setInput(String sess, String key, omero.RType value, Callback_ISession_setInput __cb)
    {
        return begin_setInput(sess, key, value, null, false, __cb);
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setInput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx, Callback_ISession_setInput __cb)
    {
        return begin_setInput(sess, key, value, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setInput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setInput_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setInput_name, __cb);
        try
        {
            __result.__prepare(__setInput_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(sess);
            __os.writeString(key);
            __os.writeObject(value);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setInput(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setInput_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __cb The callback object for the operation.
     **/
    public boolean setInput_async(AMI_ISession_setInput __cb, String sess, String key, omero.RType value)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setInput_name);
            __r = begin_setInput(sess, key, value, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setInput_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setInput_async(AMI_ISession_setInput __cb, String sess, String key, omero.RType value, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setInput_name);
            __r = begin_setInput(sess, key, value, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setInput_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setOutput_name = "setOutput";

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     **/
    public void setOutput(String sess, String key, omero.RType value)
        throws omero.ServerError
    {
        setOutput(sess, key, value, null, false);
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setOutput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setOutput(sess, key, value, __ctx, true);
    }

    private void setOutput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setOutput", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setOutput");
                    __delBase = __getDelegate(false);
                    _ISessionDel __del = (_ISessionDel)__delBase;
                    __del.setOutput(sess, key, value, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setOutput(String sess, String key, omero.RType value)
    {
        return begin_setOutput(sess, key, value, null, false, null);
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setOutput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx)
    {
        return begin_setOutput(sess, key, value, __ctx, true, null);
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setOutput(String sess, String key, omero.RType value, Ice.Callback __cb)
    {
        return begin_setOutput(sess, key, value, null, false, __cb);
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setOutput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setOutput(sess, key, value, __ctx, true, __cb);
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setOutput(String sess, String key, omero.RType value, Callback_ISession_setOutput __cb)
    {
        return begin_setOutput(sess, key, value, null, false, __cb);
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setOutput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx, Callback_ISession_setOutput __cb)
    {
        return begin_setOutput(sess, key, value, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setOutput(String sess, String key, omero.RType value, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setOutput_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setOutput_name, __cb);
        try
        {
            __result.__prepare(__setOutput_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(sess);
            __os.writeString(key);
            __os.writeObject(value);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setOutput(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setOutput_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __cb The callback object for the operation.
     **/
    public boolean setOutput_async(AMI_ISession_setOutput __cb, String sess, String key, omero.RType value)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setOutput_name);
            __r = begin_setOutput(sess, key, value, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setOutput_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setOutput_async(AMI_ISession_setOutput __cb, String sess, String key, omero.RType value, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setOutput_name);
            __r = begin_setOutput(sess, key, value, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setOutput_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static ISessionPrx checkedCast(Ice.ObjectPrx __obj)
    {
        ISessionPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ISessionPrx)
            {
                __d = (ISessionPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    ISessionPrxHelper __h = new ISessionPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ISessionPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        ISessionPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ISessionPrx)
            {
                __d = (ISessionPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    ISessionPrxHelper __h = new ISessionPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ISessionPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ISessionPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    ISessionPrxHelper __h = new ISessionPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ISessionPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        ISessionPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    ISessionPrxHelper __h = new ISessionPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ISessionPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        ISessionPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ISessionPrx)
            {
                __d = (ISessionPrx)__obj;
            }
            else
            {
                ISessionPrxHelper __h = new ISessionPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static ISessionPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ISessionPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            ISessionPrxHelper __h = new ISessionPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::ISession",
        "::omero::api::ServiceInterface"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _ISessionDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _ISessionDelD();
    }

    public static void __write(IceInternal.BasicStream __os, ISessionPrx v)
    {
        __os.writeProxy(v);
    }

    public static ISessionPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            ISessionPrxHelper result = new ISessionPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
