// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IShare.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides method for sharing - collaboration process for images,
 * datasets, projects.
 **/
public interface ISharePrx extends ServiceInterfacePrx
{
    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     **/
    public void activate(long shareId)
        throws omero.ServerError;

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void activate(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_activate(long shareId);

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_activate(long shareId, java.util.Map<String, String> __ctx);

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_activate(long shareId, Ice.Callback __cb);

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_activate(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_activate(long shareId, Callback_IShare_activate __cb);

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_activate(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_activate __cb);

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __result The asynchronous result object.
     **/
    public void end_activate(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __cb The callback object for the operation.
     **/
    public boolean activate_async(AMI_IShare_activate __cb, long shareId);

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean activate_async(AMI_IShare_activate __cb, long shareId, java.util.Map<String, String> __ctx);

    /**
     * Turns off the access control lists with the current share.
     **/
    public void deactivate()
        throws omero.ServerError;

    /**
     * Turns off the access control lists with the current share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void deactivate(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Turns off the access control lists with the current share.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deactivate();

    /**
     * Turns off the access control lists with the current share.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deactivate(java.util.Map<String, String> __ctx);

    /**
     * Turns off the access control lists with the current share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deactivate(Ice.Callback __cb);

    /**
     * Turns off the access control lists with the current share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deactivate(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Turns off the access control lists with the current share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deactivate(Callback_IShare_deactivate __cb);

    /**
     * Turns off the access control lists with the current share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deactivate(java.util.Map<String, String> __ctx, Callback_IShare_deactivate __cb);

    /**
     * Turns off the access control lists with the current share.
     * @param __result The asynchronous result object.
     **/
    public void end_deactivate(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Turns off the access control lists with the current share.
     * @param __cb The callback object for the operation.
     **/
    public boolean deactivate_async(AMI_IShare_deactivate __cb);

    /**
     * Turns off the access control lists with the current share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean deactivate_async(AMI_IShare_deactivate __cb, java.util.Map<String, String> __ctx);

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @return a {@link omero.model.Session} with id and
     * {@link omero.model.Details} set or null.
     * The owner in the Details object is the true owner,
     * and the group in the Details has all member users
     * linked. {@link omero.model.Annotation} instances
     * of the share are linked to the
     * {@link omero.model.Session}. Missing is a list of
     * share guests.
     **/
    public omero.model.Share getShare(long shareId)
        throws omero.ServerError;

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return a {@link omero.model.Session} with id and
     * {@link omero.model.Details} set or null.
     * The owner in the Details object is the true owner,
     * and the group in the Details has all member users
     * linked. {@link omero.model.Annotation} instances
     * of the share are linked to the
     * {@link omero.model.Session}. Missing is a list of
     * share guests.
     **/
    public omero.model.Share getShare(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getShare(long shareId);

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getShare(long shareId, java.util.Map<String, String> __ctx);

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getShare(long shareId, Ice.Callback __cb);

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getShare(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getShare(long shareId, Callback_IShare_getShare __cb);

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getShare(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getShare __cb);

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __result The asynchronous result object.
     * @return a {@link omero.model.Session} with id and
     * {@link omero.model.Details} set or null.
     * The owner in the Details object is the true owner,
     * and the group in the Details has all member users
     * linked. {@link omero.model.Annotation} instances
     * of the share are linked to the
     * {@link omero.model.Session}. Missing is a list of
     * share guests.
     **/
    public omero.model.Share end_getShare(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getShare_async(AMI_IShare_getShare __cb, long shareId);

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getShare_async(AMI_IShare_getShare __cb, long shareId, java.util.Map<String, String> __ctx);

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param shareIds Not null.
     * @return Map with all ids present.
     * @throws ValidationException if a given share does not exist
     **/
    public java.util.Map<Long,Long> getMemberCount(java.util.List<Long> shareIds)
        throws omero.ServerError;

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return Map with all ids present.
     * @throws ValidationException if a given share does not exist
     **/
    public java.util.Map<Long,Long> getMemberCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param shareIds Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberCount(java.util.List<Long> shareIds);

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx);

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param shareIds Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberCount(java.util.List<Long> shareIds, Ice.Callback __cb);

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param shareIds Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberCount(java.util.List<Long> shareIds, Callback_IShare_getMemberCount __cb);

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx, Callback_IShare_getMemberCount __cb);

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param __result The asynchronous result object.
     * @return Map with all ids present.
     * @throws ValidationException if a given share does not exist
     **/
    public java.util.Map<Long,Long> end_getMemberCount(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     **/
    public boolean getMemberCount_async(AMI_IShare_getMemberCount __cb, java.util.List<Long> shareIds);

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getMemberCount_async(AMI_IShare_getMemberCount __cb, java.util.List<Long> shareIds, java.util.Map<String, String> __ctx);

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param onlyActive
     * if true, then only shares which can be used for
     * login will be returned. All <i>draft</i> shares
     * (see {@link #createShare}) and closed shares (see
     * {@link #closeShare}) will be filtered.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> getOwnShares(boolean active)
        throws omero.ServerError;

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param onlyActive
     * if true, then only shares which can be used for
     * login will be returned. All <i>draft</i> shares
     * (see {@link #createShare}) and closed shares (see
     * {@link #closeShare}) will be filtered.
     * @param __ctx The Context map to send with the invocation.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> getOwnShares(boolean active, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOwnShares(boolean active);

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOwnShares(boolean active, java.util.Map<String, String> __ctx);

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOwnShares(boolean active, Ice.Callback __cb);

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOwnShares(boolean active, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOwnShares(boolean active, Callback_IShare_getOwnShares __cb);

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOwnShares(boolean active, java.util.Map<String, String> __ctx, Callback_IShare_getOwnShares __cb);

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param __result The asynchronous result object.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> end_getOwnShares(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getOwnShares_async(AMI_IShare_getOwnShares __cb, boolean active);

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getOwnShares_async(AMI_IShare_getOwnShares __cb, boolean active, java.util.Map<String, String> __ctx);

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param onlyActive
     * if true, then only shares which can be used for
     * login will be returned. All <i>draft</i> shares
     * (see {@link #createShare}) and closed shares (see
     * {@link #closeShare}) will be filtered.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> getMemberShares(boolean active)
        throws omero.ServerError;

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param onlyActive
     * if true, then only shares which can be used for
     * login will be returned. All <i>draft</i> shares
     * (see {@link #createShare}) and closed shares (see
     * {@link #closeShare}) will be filtered.
     * @param __ctx The Context map to send with the invocation.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> getMemberShares(boolean active, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberShares(boolean active);

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberShares(boolean active, java.util.Map<String, String> __ctx);

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberShares(boolean active, Ice.Callback __cb);

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberShares(boolean active, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberShares(boolean active, Callback_IShare_getMemberShares __cb);

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberShares(boolean active, java.util.Map<String, String> __ctx, Callback_IShare_getMemberShares __cb);

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __result The asynchronous result object.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> end_getMemberShares(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getMemberShares_async(AMI_IShare_getMemberShares __cb, boolean active);

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getMemberShares_async(AMI_IShare_getMemberShares __cb, boolean active, java.util.Map<String, String> __ctx);

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param onlyActive
     * if true, then only shares which can be used for
     * login will be returned. All <i>draft</i> shares
     * (see {@link #createShare}) and closed shares (see
     * {@link #closeShare}) will be filtered.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> getSharesOwnedBy(omero.model.Experimenter user, boolean active)
        throws omero.ServerError;

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param onlyActive
     * if true, then only shares which can be used for
     * login will be returned. All <i>draft</i> shares
     * (see {@link #createShare}) and closed shares (see
     * {@link #closeShare}) will be filtered.
     * @param __ctx The Context map to send with the invocation.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> getSharesOwnedBy(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSharesOwnedBy(omero.model.Experimenter user, boolean active);

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSharesOwnedBy(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx);

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSharesOwnedBy(omero.model.Experimenter user, boolean active, Ice.Callback __cb);

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSharesOwnedBy(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSharesOwnedBy(omero.model.Experimenter user, boolean active, Callback_IShare_getSharesOwnedBy __cb);

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSharesOwnedBy(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx, Callback_IShare_getSharesOwnedBy __cb);

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param __result The asynchronous result object.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> end_getSharesOwnedBy(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getSharesOwnedBy_async(AMI_IShare_getSharesOwnedBy __cb, omero.model.Experimenter user, boolean active);

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getSharesOwnedBy_async(AMI_IShare_getSharesOwnedBy __cb, omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx);

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param onlyActive
     * if true, then only shares which can be used for
     * login will be returned. All <i>draft</i> shares
     * (see {@link #createShare}) and closed shares (see
     * {@link #closeShare}) will be filtered.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> getMemberSharesFor(omero.model.Experimenter user, boolean active)
        throws omero.ServerError;

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param onlyActive
     * if true, then only shares which can be used for
     * login will be returned. All <i>draft</i> shares
     * (see {@link #createShare}) and closed shares (see
     * {@link #closeShare}) will be filtered.
     * @param __ctx The Context map to send with the invocation.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> getMemberSharesFor(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberSharesFor(omero.model.Experimenter user, boolean active);

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberSharesFor(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx);

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberSharesFor(omero.model.Experimenter user, boolean active, Ice.Callback __cb);

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberSharesFor(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberSharesFor(omero.model.Experimenter user, boolean active, Callback_IShare_getMemberSharesFor __cb);

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberSharesFor(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx, Callback_IShare_getMemberSharesFor __cb);

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __result The asynchronous result object.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> end_getMemberSharesFor(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getMemberSharesFor_async(AMI_IShare_getMemberSharesFor __cb, omero.model.Experimenter user, boolean active);

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getMemberSharesFor_async(AMI_IShare_getMemberSharesFor __cb, omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx);

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @return list of objects. Not null. Probably not empty.
     **/
    public java.util.List<omero.model.IObject> getContents(long shareId)
        throws omero.ServerError;

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return list of objects. Not null. Probably not empty.
     **/
    public java.util.List<omero.model.IObject> getContents(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContents(long shareId);

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContents(long shareId, java.util.Map<String, String> __ctx);

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContents(long shareId, Ice.Callback __cb);

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContents(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContents(long shareId, Callback_IShare_getContents __cb);

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContents(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getContents __cb);

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __result The asynchronous result object.
     * @return list of objects. Not null. Probably not empty.
     **/
    public java.util.List<omero.model.IObject> end_getContents(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getContents_async(AMI_IShare_getContents __cb, long shareId);

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getContents_async(AMI_IShare_getContents __cb, long shareId, java.util.Map<String, String> __ctx);

    /**
     * Returns a range of items from the share.
     * 
     * @see #getContents
     **/
    public java.util.List<omero.model.IObject> getContentSubList(long shareId, int start, int finish)
        throws omero.ServerError;

    /**
     * Returns a range of items from the share.
     * 
     * @see #getContents
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.IObject> getContentSubList(long shareId, int start, int finish, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns a range of items from the share.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContentSubList(long shareId, int start, int finish);

    /**
     * Returns a range of items from the share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContentSubList(long shareId, int start, int finish, java.util.Map<String, String> __ctx);

    /**
     * Returns a range of items from the share.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContentSubList(long shareId, int start, int finish, Ice.Callback __cb);

    /**
     * Returns a range of items from the share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContentSubList(long shareId, int start, int finish, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns a range of items from the share.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContentSubList(long shareId, int start, int finish, Callback_IShare_getContentSubList __cb);

    /**
     * Returns a range of items from the share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContentSubList(long shareId, int start, int finish, java.util.Map<String, String> __ctx, Callback_IShare_getContentSubList __cb);

    /**
     * Returns a range of items from the share.
     * 
     * @param __result The asynchronous result object.
     * @see #getContents
     **/
    public java.util.List<omero.model.IObject> end_getContentSubList(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns a range of items from the share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getContentSubList_async(AMI_IShare_getContentSubList __cb, long shareId, int start, int finish);

    /**
     * Returns a range of items from the share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getContentSubList_async(AMI_IShare_getContentSubList __cb, long shareId, int start, int finish, java.util.Map<String, String> __ctx);

    /**
     * Returns the number of items in the share.
     **/
    public int getContentSize(long shareId)
        throws omero.ServerError;

    /**
     * Returns the number of items in the share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public int getContentSize(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the number of items in the share.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContentSize(long shareId);

    /**
     * Returns the number of items in the share.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContentSize(long shareId, java.util.Map<String, String> __ctx);

    /**
     * Returns the number of items in the share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContentSize(long shareId, Ice.Callback __cb);

    /**
     * Returns the number of items in the share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContentSize(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the number of items in the share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContentSize(long shareId, Callback_IShare_getContentSize __cb);

    /**
     * Returns the number of items in the share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContentSize(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getContentSize __cb);

    /**
     * Returns the number of items in the share.
     * @param __result The asynchronous result object.
     **/
    public int end_getContentSize(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the number of items in the share.
     * @param __cb The callback object for the operation.
     **/
    public boolean getContentSize_async(AMI_IShare_getContentSize __cb, long shareId);

    /**
     * Returns the number of items in the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getContentSize_async(AMI_IShare_getContentSize __cb, long shareId, java.util.Map<String, String> __ctx);

    /**
     * Returns the contents of the share keyed by type.
     **/
    public java.util.Map<java.lang.String, long[]> getContentMap(long shareId)
        throws omero.ServerError;

    /**
     * Returns the contents of the share keyed by type.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.Map<java.lang.String, long[]> getContentMap(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the contents of the share keyed by type.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContentMap(long shareId);

    /**
     * Returns the contents of the share keyed by type.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContentMap(long shareId, java.util.Map<String, String> __ctx);

    /**
     * Returns the contents of the share keyed by type.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContentMap(long shareId, Ice.Callback __cb);

    /**
     * Returns the contents of the share keyed by type.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContentMap(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the contents of the share keyed by type.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContentMap(long shareId, Callback_IShare_getContentMap __cb);

    /**
     * Returns the contents of the share keyed by type.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getContentMap(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getContentMap __cb);

    /**
     * Returns the contents of the share keyed by type.
     * @param __result The asynchronous result object.
     **/
    public java.util.Map<java.lang.String, long[]> end_getContentMap(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the contents of the share keyed by type.
     * @param __cb The callback object for the operation.
     **/
    public boolean getContentMap_async(AMI_IShare_getContentMap __cb, long shareId);

    /**
     * Returns the contents of the share keyed by type.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getContentMap_async(AMI_IShare_getContentMap __cb, long shareId, java.util.Map<String, String> __ctx);

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     **/
    public long createShare(String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled)
        throws omero.ServerError;

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     * @param __ctx The Context map to send with the invocation.
     **/
    public long createShare(String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createShare(String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled);

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createShare(String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled, java.util.Map<String, String> __ctx);

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createShare(String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled, Ice.Callback __cb);

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createShare(String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createShare(String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled, Callback_IShare_createShare __cb);

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createShare(String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled, java.util.Map<String, String> __ctx, Callback_IShare_createShare __cb);

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param __result The asynchronous result object.
     **/
    public long end_createShare(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param __cb The callback object for the operation.
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     **/
    public boolean createShare_async(AMI_IShare_createShare __cb, String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled);

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param __cb The callback object for the operation.
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createShare_async(AMI_IShare_createShare __cb, String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled, java.util.Map<String, String> __ctx);

    public void setDescription(long shareId, String description)
        throws omero.ServerError;

    public void setDescription(long shareId, String description, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_setDescription(long shareId, String description);

    public Ice.AsyncResult begin_setDescription(long shareId, String description, java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_setDescription(long shareId, String description, Ice.Callback __cb);

    public Ice.AsyncResult begin_setDescription(long shareId, String description, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_setDescription(long shareId, String description, Callback_IShare_setDescription __cb);

    public Ice.AsyncResult begin_setDescription(long shareId, String description, java.util.Map<String, String> __ctx, Callback_IShare_setDescription __cb);

    public void end_setDescription(Ice.AsyncResult __result)
        throws omero.ServerError;

    public boolean setDescription_async(AMI_IShare_setDescription __cb, long shareId, String description);

    public boolean setDescription_async(AMI_IShare_setDescription __cb, long shareId, String description, java.util.Map<String, String> __ctx);

    public void setExpiration(long shareId, omero.RTime expiration)
        throws omero.ServerError;

    public void setExpiration(long shareId, omero.RTime expiration, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_setExpiration(long shareId, omero.RTime expiration);

    public Ice.AsyncResult begin_setExpiration(long shareId, omero.RTime expiration, java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_setExpiration(long shareId, omero.RTime expiration, Ice.Callback __cb);

    public Ice.AsyncResult begin_setExpiration(long shareId, omero.RTime expiration, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_setExpiration(long shareId, omero.RTime expiration, Callback_IShare_setExpiration __cb);

    public Ice.AsyncResult begin_setExpiration(long shareId, omero.RTime expiration, java.util.Map<String, String> __ctx, Callback_IShare_setExpiration __cb);

    public void end_setExpiration(Ice.AsyncResult __result)
        throws omero.ServerError;

    public boolean setExpiration_async(AMI_IShare_setExpiration __cb, long shareId, omero.RTime expiration);

    public boolean setExpiration_async(AMI_IShare_setExpiration __cb, long shareId, omero.RTime expiration, java.util.Map<String, String> __ctx);

    public void setActive(long shareId, boolean active)
        throws omero.ServerError;

    public void setActive(long shareId, boolean active, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_setActive(long shareId, boolean active);

    public Ice.AsyncResult begin_setActive(long shareId, boolean active, java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_setActive(long shareId, boolean active, Ice.Callback __cb);

    public Ice.AsyncResult begin_setActive(long shareId, boolean active, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_setActive(long shareId, boolean active, Callback_IShare_setActive __cb);

    public Ice.AsyncResult begin_setActive(long shareId, boolean active, java.util.Map<String, String> __ctx, Callback_IShare_setActive __cb);

    public void end_setActive(Ice.AsyncResult __result)
        throws omero.ServerError;

    public boolean setActive_async(AMI_IShare_setActive __cb, long shareId, boolean active);

    public boolean setActive_async(AMI_IShare_setActive __cb, long shareId, boolean active, java.util.Map<String, String> __ctx);

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     **/
    public void closeShare(long shareId)
        throws omero.ServerError;

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void closeShare(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_closeShare(long shareId);

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_closeShare(long shareId, java.util.Map<String, String> __ctx);

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_closeShare(long shareId, Ice.Callback __cb);

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_closeShare(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_closeShare(long shareId, Callback_IShare_closeShare __cb);

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_closeShare(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_closeShare __cb);

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __result The asynchronous result object.
     **/
    public void end_closeShare(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __cb The callback object for the operation.
     **/
    public boolean closeShare_async(AMI_IShare_closeShare __cb, long shareId);

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean closeShare_async(AMI_IShare_closeShare __cb, long shareId, java.util.Map<String, String> __ctx);

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     **/
    public void addObjects(long shareId, java.util.List<omero.model.IObject> iobjects)
        throws omero.ServerError;

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addObjects(long shareId, java.util.List<omero.model.IObject> iobjects);

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx);

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addObjects(long shareId, java.util.List<omero.model.IObject> iobjects, Ice.Callback __cb);

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addObjects(long shareId, java.util.List<omero.model.IObject> iobjects, Callback_IShare_addObjects __cb);

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx, Callback_IShare_addObjects __cb);

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __result The asynchronous result object.
     **/
    public void end_addObjects(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __cb The callback object for the operation.
     **/
    public boolean addObjects_async(AMI_IShare_addObjects __cb, long shareId, java.util.List<omero.model.IObject> iobjects);

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addObjects_async(AMI_IShare_addObjects __cb, long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx);

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     **/
    public void addObject(long shareId, omero.model.IObject iobject)
        throws omero.ServerError;

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addObject(long shareId, omero.model.IObject iobject);

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx);

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addObject(long shareId, omero.model.IObject iobject, Ice.Callback __cb);

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addObject(long shareId, omero.model.IObject iobject, Callback_IShare_addObject __cb);

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx, Callback_IShare_addObject __cb);

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __result The asynchronous result object.
     **/
    public void end_addObject(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __cb The callback object for the operation.
     **/
    public boolean addObject_async(AMI_IShare_addObject __cb, long shareId, omero.model.IObject iobject);

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addObject_async(AMI_IShare_addObject __cb, long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx);

    /**
     * Remove existing items from the share.
     **/
    public void removeObjects(long shareId, java.util.List<omero.model.IObject> iobjects)
        throws omero.ServerError;

    /**
     * Remove existing items from the share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Remove existing items from the share.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeObjects(long shareId, java.util.List<omero.model.IObject> iobjects);

    /**
     * Remove existing items from the share.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx);

    /**
     * Remove existing items from the share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeObjects(long shareId, java.util.List<omero.model.IObject> iobjects, Ice.Callback __cb);

    /**
     * Remove existing items from the share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Remove existing items from the share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeObjects(long shareId, java.util.List<omero.model.IObject> iobjects, Callback_IShare_removeObjects __cb);

    /**
     * Remove existing items from the share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx, Callback_IShare_removeObjects __cb);

    /**
     * Remove existing items from the share.
     * @param __result The asynchronous result object.
     **/
    public void end_removeObjects(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Remove existing items from the share.
     * @param __cb The callback object for the operation.
     **/
    public boolean removeObjects_async(AMI_IShare_removeObjects __cb, long shareId, java.util.List<omero.model.IObject> iobjects);

    /**
     * Remove existing items from the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeObjects_async(AMI_IShare_removeObjects __cb, long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx);

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     **/
    public void removeObject(long shareId, omero.model.IObject iobject)
        throws omero.ServerError;

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeObject(long shareId, omero.model.IObject iobject);

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx);

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeObject(long shareId, omero.model.IObject iobject, Ice.Callback __cb);

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeObject(long shareId, omero.model.IObject iobject, Callback_IShare_removeObject __cb);

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx, Callback_IShare_removeObject __cb);

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __result The asynchronous result object.
     **/
    public void end_removeObject(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public boolean removeObject_async(AMI_IShare_removeObject __cb, long shareId, omero.model.IObject iobject);

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeObject_async(AMI_IShare_removeObject __cb, long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx);

    /**
     * Returns a map from share id to comment count.
     * 
     * @param shareIds Not null.
     * @return Map with all ids present and 0 if no count exists.
     * @throws ValidationException if a given share does not exist
     **/
    public java.util.Map<Long,Long> getCommentCount(java.util.List<Long> shareIds)
        throws omero.ServerError;

    /**
     * Returns a map from share id to comment count.
     * 
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return Map with all ids present and 0 if no count exists.
     * @throws ValidationException if a given share does not exist
     **/
    public java.util.Map<Long,Long> getCommentCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns a map from share id to comment count.
     * 
     * @param shareIds Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getCommentCount(java.util.List<Long> shareIds);

    /**
     * Returns a map from share id to comment count.
     * 
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getCommentCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx);

    /**
     * Returns a map from share id to comment count.
     * 
     * @param shareIds Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getCommentCount(java.util.List<Long> shareIds, Ice.Callback __cb);

    /**
     * Returns a map from share id to comment count.
     * 
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getCommentCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns a map from share id to comment count.
     * 
     * @param shareIds Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getCommentCount(java.util.List<Long> shareIds, Callback_IShare_getCommentCount __cb);

    /**
     * Returns a map from share id to comment count.
     * 
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getCommentCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx, Callback_IShare_getCommentCount __cb);

    /**
     * Returns a map from share id to comment count.
     * 
     * @param __result The asynchronous result object.
     * @return Map with all ids present and 0 if no count exists.
     * @throws ValidationException if a given share does not exist
     **/
    public java.util.Map<Long,Long> end_getCommentCount(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns a map from share id to comment count.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     **/
    public boolean getCommentCount_async(AMI_IShare_getCommentCount __cb, java.util.List<Long> shareIds);

    /**
     * Returns a map from share id to comment count.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getCommentCount_async(AMI_IShare_getCommentCount __cb, java.util.List<Long> shareIds, java.util.Map<String, String> __ctx);

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @return list of Annotation
     **/
    public java.util.List<omero.model.Annotation> getComments(long shareId)
        throws omero.ServerError;

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return list of Annotation
     **/
    public java.util.List<omero.model.Annotation> getComments(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getComments(long shareId);

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getComments(long shareId, java.util.Map<String, String> __ctx);

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getComments(long shareId, Ice.Callback __cb);

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getComments(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getComments(long shareId, Callback_IShare_getComments __cb);

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getComments(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getComments __cb);

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __result The asynchronous result object.
     * @return list of Annotation
     **/
    public java.util.List<omero.model.Annotation> end_getComments(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getComments_async(AMI_IShare_getComments __cb, long shareId);

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getComments_async(AMI_IShare_getComments __cb, long shareId, java.util.Map<String, String> __ctx);

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     **/
    public omero.model.TextAnnotation addComment(long shareId, String comment)
        throws omero.ServerError;

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.TextAnnotation addComment(long shareId, String comment, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addComment(long shareId, String comment);

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addComment(long shareId, String comment, java.util.Map<String, String> __ctx);

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addComment(long shareId, String comment, Ice.Callback __cb);

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addComment(long shareId, String comment, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addComment(long shareId, String comment, Callback_IShare_addComment __cb);

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addComment(long shareId, String comment, java.util.Map<String, String> __ctx, Callback_IShare_addComment __cb);

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __result The asynchronous result object.
     **/
    public omero.model.TextAnnotation end_addComment(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public boolean addComment_async(AMI_IShare_addComment __cb, long shareId, String comment);

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addComment_async(AMI_IShare_addComment __cb, long shareId, String comment, java.util.Map<String, String> __ctx);

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @return the new {@link omero.model.TextAnnotation}
     **/
    public omero.model.TextAnnotation addReply(long shareId, String comment, omero.model.TextAnnotation replyTo)
        throws omero.ServerError;

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return the new {@link omero.model.TextAnnotation}
     **/
    public omero.model.TextAnnotation addReply(long shareId, String comment, omero.model.TextAnnotation replyTo, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addReply(long shareId, String comment, omero.model.TextAnnotation replyTo);

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addReply(long shareId, String comment, omero.model.TextAnnotation replyTo, java.util.Map<String, String> __ctx);

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addReply(long shareId, String comment, omero.model.TextAnnotation replyTo, Ice.Callback __cb);

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addReply(long shareId, String comment, omero.model.TextAnnotation replyTo, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addReply(long shareId, String comment, omero.model.TextAnnotation replyTo, Callback_IShare_addReply __cb);

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addReply(long shareId, String comment, omero.model.TextAnnotation replyTo, java.util.Map<String, String> __ctx, Callback_IShare_addReply __cb);

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __result The asynchronous result object.
     * @return the new {@link omero.model.TextAnnotation}
     **/
    public omero.model.TextAnnotation end_addReply(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean addReply_async(AMI_IShare_addReply __cb, long shareId, String comment, omero.model.TextAnnotation replyTo);

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addReply_async(AMI_IShare_addReply __cb, long shareId, String comment, omero.model.TextAnnotation replyTo, java.util.Map<String, String> __ctx);

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     **/
    public void deleteComment(omero.model.Annotation comment)
        throws omero.ServerError;

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void deleteComment(omero.model.Annotation comment, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deleteComment(omero.model.Annotation comment);

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deleteComment(omero.model.Annotation comment, java.util.Map<String, String> __ctx);

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deleteComment(omero.model.Annotation comment, Ice.Callback __cb);

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deleteComment(omero.model.Annotation comment, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deleteComment(omero.model.Annotation comment, Callback_IShare_deleteComment __cb);

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deleteComment(omero.model.Annotation comment, java.util.Map<String, String> __ctx, Callback_IShare_deleteComment __cb);

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __result The asynchronous result object.
     **/
    public void end_deleteComment(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __cb The callback object for the operation.
     **/
    public boolean deleteComment_async(AMI_IShare_deleteComment __cb, omero.model.Annotation comment);

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean deleteComment_async(AMI_IShare_deleteComment __cb, omero.model.Annotation comment, java.util.Map<String, String> __ctx);

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     **/
    public java.util.List<omero.model.Experimenter> getAllMembers(long shareId)
        throws omero.ServerError;

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.Experimenter> getAllMembers(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getAllMembers(long shareId);

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getAllMembers(long shareId, java.util.Map<String, String> __ctx);

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getAllMembers(long shareId, Ice.Callback __cb);

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getAllMembers(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getAllMembers(long shareId, Callback_IShare_getAllMembers __cb);

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getAllMembers(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getAllMembers __cb);

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __result The asynchronous result object.
     **/
    public java.util.List<omero.model.Experimenter> end_getAllMembers(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __cb The callback object for the operation.
     **/
    public boolean getAllMembers_async(AMI_IShare_getAllMembers __cb, long shareId);

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getAllMembers_async(AMI_IShare_getAllMembers __cb, long shareId, java.util.Map<String, String> __ctx);

    /**
     * Get the email addresses for all share guests.
     **/
    public java.util.List<String> getAllGuests(long shareId)
        throws omero.ServerError;

    /**
     * Get the email addresses for all share guests.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<String> getAllGuests(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Get the email addresses for all share guests.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getAllGuests(long shareId);

    /**
     * Get the email addresses for all share guests.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getAllGuests(long shareId, java.util.Map<String, String> __ctx);

    /**
     * Get the email addresses for all share guests.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getAllGuests(long shareId, Ice.Callback __cb);

    /**
     * Get the email addresses for all share guests.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getAllGuests(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Get the email addresses for all share guests.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getAllGuests(long shareId, Callback_IShare_getAllGuests __cb);

    /**
     * Get the email addresses for all share guests.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getAllGuests(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getAllGuests __cb);

    /**
     * Get the email addresses for all share guests.
     * @param __result The asynchronous result object.
     **/
    public java.util.List<String> end_getAllGuests(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Get the email addresses for all share guests.
     * @param __cb The callback object for the operation.
     **/
    public boolean getAllGuests_async(AMI_IShare_getAllGuests __cb, long shareId);

    /**
     * Get the email addresses for all share guests.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getAllGuests_async(AMI_IShare_getAllGuests __cb, long shareId, java.util.Map<String, String> __ctx);

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param shareId
     * @return a {@link StringSet} containing the login of all
     * users
     * @throws ValidationException
     * if there is a conflict between email addresses and
     * user names.
     **/
    public java.util.List<String> getAllUsers(long shareId)
        throws omero.ServerError,
               omero.ValidationException;

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param shareId
     * @param __ctx The Context map to send with the invocation.
     * @return a {@link StringSet} containing the login of all
     * users
     * @throws ValidationException
     * if there is a conflict between email addresses and
     * user names.
     **/
    public java.util.List<String> getAllUsers(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError,
               omero.ValidationException;

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param shareId
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getAllUsers(long shareId);

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param shareId
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getAllUsers(long shareId, java.util.Map<String, String> __ctx);

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param shareId
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getAllUsers(long shareId, Ice.Callback __cb);

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param shareId
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getAllUsers(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param shareId
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getAllUsers(long shareId, Callback_IShare_getAllUsers __cb);

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param shareId
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getAllUsers(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getAllUsers __cb);

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param __result The asynchronous result object.
     * @return a {@link StringSet} containing the login of all
     * users
     * @throws ValidationException
     * if there is a conflict between email addresses and
     * user names.
     **/
    public java.util.List<String> end_getAllUsers(Ice.AsyncResult __result)
        throws omero.ServerError,
               omero.ValidationException;

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param __cb The callback object for the operation.
     * @param shareId
     **/
    public boolean getAllUsers_async(AMI_IShare_getAllUsers __cb, long shareId);

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param __cb The callback object for the operation.
     * @param shareId
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getAllUsers_async(AMI_IShare_getAllUsers __cb, long shareId, java.util.Map<String, String> __ctx);

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     **/
    public void addUsers(long shareId, java.util.List<omero.model.Experimenter> exps)
        throws omero.ServerError;

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addUsers(long shareId, java.util.List<omero.model.Experimenter> exps);

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx);

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addUsers(long shareId, java.util.List<omero.model.Experimenter> exps, Ice.Callback __cb);

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addUsers(long shareId, java.util.List<omero.model.Experimenter> exps, Callback_IShare_addUsers __cb);

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx, Callback_IShare_addUsers __cb);

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __result The asynchronous result object.
     **/
    public void end_addUsers(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public boolean addUsers_async(AMI_IShare_addUsers __cb, long shareId, java.util.List<omero.model.Experimenter> exps);

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addUsers_async(AMI_IShare_addUsers __cb, long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx);

    /**
     * Adds guest email addresses to the share.
     **/
    public void addGuests(long shareId, java.util.List<String> emailAddresses)
        throws omero.ServerError;

    /**
     * Adds guest email addresses to the share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Adds guest email addresses to the share.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGuests(long shareId, java.util.List<String> emailAddresses);

    /**
     * Adds guest email addresses to the share.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx);

    /**
     * Adds guest email addresses to the share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGuests(long shareId, java.util.List<String> emailAddresses, Ice.Callback __cb);

    /**
     * Adds guest email addresses to the share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Adds guest email addresses to the share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGuests(long shareId, java.util.List<String> emailAddresses, Callback_IShare_addGuests __cb);

    /**
     * Adds guest email addresses to the share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx, Callback_IShare_addGuests __cb);

    /**
     * Adds guest email addresses to the share.
     * @param __result The asynchronous result object.
     **/
    public void end_addGuests(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Adds guest email addresses to the share.
     * @param __cb The callback object for the operation.
     **/
    public boolean addGuests_async(AMI_IShare_addGuests __cb, long shareId, java.util.List<String> emailAddresses);

    /**
     * Adds guest email addresses to the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addGuests_async(AMI_IShare_addGuests __cb, long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx);

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     **/
    public void removeUsers(long shareId, java.util.List<omero.model.Experimenter> exps)
        throws omero.ServerError;

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeUsers(long shareId, java.util.List<omero.model.Experimenter> exps);

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx);

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeUsers(long shareId, java.util.List<omero.model.Experimenter> exps, Ice.Callback __cb);

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeUsers(long shareId, java.util.List<omero.model.Experimenter> exps, Callback_IShare_removeUsers __cb);

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx, Callback_IShare_removeUsers __cb);

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __result The asynchronous result object.
     **/
    public void end_removeUsers(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public boolean removeUsers_async(AMI_IShare_removeUsers __cb, long shareId, java.util.List<omero.model.Experimenter> exps);

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeUsers_async(AMI_IShare_removeUsers __cb, long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx);

    /**
     * Removes guest email addresses from the share.
     **/
    public void removeGuests(long shareId, java.util.List<String> emailAddresses)
        throws omero.ServerError;

    /**
     * Removes guest email addresses from the share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Removes guest email addresses from the share.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGuests(long shareId, java.util.List<String> emailAddresses);

    /**
     * Removes guest email addresses from the share.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx);

    /**
     * Removes guest email addresses from the share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGuests(long shareId, java.util.List<String> emailAddresses, Ice.Callback __cb);

    /**
     * Removes guest email addresses from the share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Removes guest email addresses from the share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGuests(long shareId, java.util.List<String> emailAddresses, Callback_IShare_removeGuests __cb);

    /**
     * Removes guest email addresses from the share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx, Callback_IShare_removeGuests __cb);

    /**
     * Removes guest email addresses from the share.
     * @param __result The asynchronous result object.
     **/
    public void end_removeGuests(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Removes guest email addresses from the share.
     * @param __cb The callback object for the operation.
     **/
    public boolean removeGuests_async(AMI_IShare_removeGuests __cb, long shareId, java.util.List<String> emailAddresses);

    /**
     * Removes guest email addresses from the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeGuests_async(AMI_IShare_removeGuests __cb, long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx);

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     **/
    public void addUser(long shareId, omero.model.Experimenter exp)
        throws omero.ServerError;

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addUser(long shareId, omero.model.Experimenter exp);

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx);

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addUser(long shareId, omero.model.Experimenter exp, Ice.Callback __cb);

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addUser(long shareId, omero.model.Experimenter exp, Callback_IShare_addUser __cb);

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Callback_IShare_addUser __cb);

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __result The asynchronous result object.
     **/
    public void end_addUser(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public boolean addUser_async(AMI_IShare_addUser __cb, long shareId, omero.model.Experimenter exp);

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addUser_async(AMI_IShare_addUser __cb, long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx);

    /**
     * Adds guest email address to the share.
     **/
    public void addGuest(long shareId, String emailAddress)
        throws omero.ServerError;

    /**
     * Adds guest email address to the share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Adds guest email address to the share.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGuest(long shareId, String emailAddress);

    /**
     * Adds guest email address to the share.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx);

    /**
     * Adds guest email address to the share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGuest(long shareId, String emailAddress, Ice.Callback __cb);

    /**
     * Adds guest email address to the share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Adds guest email address to the share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGuest(long shareId, String emailAddress, Callback_IShare_addGuest __cb);

    /**
     * Adds guest email address to the share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx, Callback_IShare_addGuest __cb);

    /**
     * Adds guest email address to the share.
     * @param __result The asynchronous result object.
     **/
    public void end_addGuest(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Adds guest email address to the share.
     * @param __cb The callback object for the operation.
     **/
    public boolean addGuest_async(AMI_IShare_addGuest __cb, long shareId, String emailAddress);

    /**
     * Adds guest email address to the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addGuest_async(AMI_IShare_addGuest __cb, long shareId, String emailAddress, java.util.Map<String, String> __ctx);

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     **/
    public void removeUser(long shareId, omero.model.Experimenter exp)
        throws omero.ServerError;

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeUser(long shareId, omero.model.Experimenter exp);

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx);

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeUser(long shareId, omero.model.Experimenter exp, Ice.Callback __cb);

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeUser(long shareId, omero.model.Experimenter exp, Callback_IShare_removeUser __cb);

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Callback_IShare_removeUser __cb);

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __result The asynchronous result object.
     **/
    public void end_removeUser(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public boolean removeUser_async(AMI_IShare_removeUser __cb, long shareId, omero.model.Experimenter exp);

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeUser_async(AMI_IShare_removeUser __cb, long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx);

    /**
     * Removes guest email address from share.
     **/
    public void removeGuest(long shareId, String emailAddress)
        throws omero.ServerError;

    /**
     * Removes guest email address from share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Removes guest email address from share.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGuest(long shareId, String emailAddress);

    /**
     * Removes guest email address from share.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx);

    /**
     * Removes guest email address from share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGuest(long shareId, String emailAddress, Ice.Callback __cb);

    /**
     * Removes guest email address from share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Removes guest email address from share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGuest(long shareId, String emailAddress, Callback_IShare_removeGuest __cb);

    /**
     * Removes guest email address from share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx, Callback_IShare_removeGuest __cb);

    /**
     * Removes guest email address from share.
     * @param __result The asynchronous result object.
     **/
    public void end_removeGuest(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Removes guest email address from share.
     * @param __cb The callback object for the operation.
     **/
    public boolean removeGuest_async(AMI_IShare_removeGuest __cb, long shareId, String emailAddress);

    /**
     * Removes guest email address from share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeGuest_async(AMI_IShare_removeGuest __cb, long shareId, String emailAddress, java.util.Map<String, String> __ctx);

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @return map of experimenter and IP address
     **/
    public java.util.Map<java.lang.String, omero.model.Experimenter> getActiveConnections(long shareId)
        throws omero.ServerError;

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return map of experimenter and IP address
     **/
    public java.util.Map<java.lang.String, omero.model.Experimenter> getActiveConnections(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getActiveConnections(long shareId);

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getActiveConnections(long shareId, java.util.Map<String, String> __ctx);

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getActiveConnections(long shareId, Ice.Callback __cb);

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getActiveConnections(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getActiveConnections(long shareId, Callback_IShare_getActiveConnections __cb);

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getActiveConnections(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getActiveConnections __cb);

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __result The asynchronous result object.
     * @return map of experimenter and IP address
     **/
    public java.util.Map<java.lang.String, omero.model.Experimenter> end_getActiveConnections(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getActiveConnections_async(AMI_IShare_getActiveConnections __cb, long shareId);

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getActiveConnections_async(AMI_IShare_getActiveConnections __cb, long shareId, java.util.Map<String, String> __ctx);

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @return map of experimenter and IP address
     **/
    public java.util.Map<java.lang.String, omero.model.Experimenter> getPastConnections(long shareId)
        throws omero.ServerError;

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return map of experimenter and IP address
     **/
    public java.util.Map<java.lang.String, omero.model.Experimenter> getPastConnections(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPastConnections(long shareId);

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPastConnections(long shareId, java.util.Map<String, String> __ctx);

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPastConnections(long shareId, Ice.Callback __cb);

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPastConnections(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPastConnections(long shareId, Callback_IShare_getPastConnections __cb);

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPastConnections(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getPastConnections __cb);

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __result The asynchronous result object.
     * @return map of experimenter and IP address
     **/
    public java.util.Map<java.lang.String, omero.model.Experimenter> end_getPastConnections(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getPastConnections_async(AMI_IShare_getPastConnections __cb, long shareId);

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getPastConnections_async(AMI_IShare_getPastConnections __cb, long shareId, java.util.Map<String, String> __ctx);

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     **/
    public void invalidateConnection(long shareId, omero.model.Experimenter exp)
        throws omero.ServerError;

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void invalidateConnection(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_invalidateConnection(long shareId, omero.model.Experimenter exp);

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_invalidateConnection(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx);

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_invalidateConnection(long shareId, omero.model.Experimenter exp, Ice.Callback __cb);

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_invalidateConnection(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_invalidateConnection(long shareId, omero.model.Experimenter exp, Callback_IShare_invalidateConnection __cb);

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_invalidateConnection(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Callback_IShare_invalidateConnection __cb);

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __result The asynchronous result object.
     **/
    public void end_invalidateConnection(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __cb The callback object for the operation.
     **/
    public boolean invalidateConnection_async(AMI_IShare_invalidateConnection __cb, long shareId, omero.model.Experimenter exp);

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean invalidateConnection_async(AMI_IShare_invalidateConnection __cb, long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx);

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @return List of events
     **/
    public java.util.List<omero.model.IObject> getEvents(long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to)
        throws omero.ServerError;

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __ctx The Context map to send with the invocation.
     * @return List of events
     **/
    public java.util.List<omero.model.IObject> getEvents(long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getEvents(long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to);

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getEvents(long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to, java.util.Map<String, String> __ctx);

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getEvents(long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to, Ice.Callback __cb);

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getEvents(long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getEvents(long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to, Callback_IShare_getEvents __cb);

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getEvents(long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to, java.util.Map<String, String> __ctx, Callback_IShare_getEvents __cb);

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __result The asynchronous result object.
     * @return List of events
     **/
    public java.util.List<omero.model.IObject> end_getEvents(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __cb The callback object for the operation.
     **/
    public boolean getEvents_async(AMI_IShare_getEvents __cb, long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to);

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getEvents_async(AMI_IShare_getEvents __cb, long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to, java.util.Map<String, String> __ctx);

    /**
     * Notifies via email selected members of share.
     **/
    public void notifyMembersOfShare(long shareId, String subject, String message, boolean html)
        throws omero.ServerError;

    /**
     * Notifies via email selected members of share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void notifyMembersOfShare(long shareId, String subject, String message, boolean html, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Notifies via email selected members of share.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_notifyMembersOfShare(long shareId, String subject, String message, boolean html);

    /**
     * Notifies via email selected members of share.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_notifyMembersOfShare(long shareId, String subject, String message, boolean html, java.util.Map<String, String> __ctx);

    /**
     * Notifies via email selected members of share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_notifyMembersOfShare(long shareId, String subject, String message, boolean html, Ice.Callback __cb);

    /**
     * Notifies via email selected members of share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_notifyMembersOfShare(long shareId, String subject, String message, boolean html, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Notifies via email selected members of share.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_notifyMembersOfShare(long shareId, String subject, String message, boolean html, Callback_IShare_notifyMembersOfShare __cb);

    /**
     * Notifies via email selected members of share.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_notifyMembersOfShare(long shareId, String subject, String message, boolean html, java.util.Map<String, String> __ctx, Callback_IShare_notifyMembersOfShare __cb);

    /**
     * Notifies via email selected members of share.
     * @param __result The asynchronous result object.
     **/
    public void end_notifyMembersOfShare(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Notifies via email selected members of share.
     * @param __cb The callback object for the operation.
     **/
    public boolean notifyMembersOfShare_async(AMI_IShare_notifyMembersOfShare __cb, long shareId, String subject, String message, boolean html);

    /**
     * Notifies via email selected members of share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean notifyMembersOfShare_async(AMI_IShare_notifyMembersOfShare __cb, long shareId, String subject, String message, boolean html, java.util.Map<String, String> __ctx);
}
