// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IUpdate.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides methods for directly updating object graphs. IUpdate is
 * the lowest level (level-1) interface which may make changes
 * (INSERT, UPDATE, DELETE) to the database. All other methods of
 * changing the database may leave it in an inconsistent state.
 * 
 * <p>
 * All the save* methods act recursively on the entire object graph,
 * replacing placeholders and details where necessary, and then
 * <i>merging</i> the final graph.
 * This means that the objects that are passed into IUpdate.save*
 * methods are copied over to new instances which are then returned.
 * The original objects <b>should be discarded</b>.
 * </p>
 * 
 * <p>{@link #saveAndReturnIds} behaves slightly differently in that
 * it does <em>not</em> handle object modifications. The graph of
 * objects passed in can consist <em>ONLY</em> if either newly created
 * objects without ids or of unloaded objects with ids. <em>Note:</em>
 * The ids of the saved values may not be in order. This is caused by
 * persistence-by-transitivity. Hibernate may detect an item later in
 * the array if they are interconnected and therefore choose to save
 * it first.
 * </p>
 * 
 * <p>
 * All methods throw {@link omero.ValidationException} if the input
 * objects do not pass validation, and
 * {@link omero.OptimisticLockException} if the version of a given has
 * already been incremented.
 **/
public interface IUpdatePrx extends ServiceInterfacePrx
{
    public void saveObject(omero.model.IObject obj)
        throws omero.ServerError;

    public void saveObject(omero.model.IObject obj, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_saveObject(omero.model.IObject obj);

    public Ice.AsyncResult begin_saveObject(omero.model.IObject obj, java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_saveObject(omero.model.IObject obj, Ice.Callback __cb);

    public Ice.AsyncResult begin_saveObject(omero.model.IObject obj, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_saveObject(omero.model.IObject obj, Callback_IUpdate_saveObject __cb);

    public Ice.AsyncResult begin_saveObject(omero.model.IObject obj, java.util.Map<String, String> __ctx, Callback_IUpdate_saveObject __cb);

    public void end_saveObject(Ice.AsyncResult __result)
        throws omero.ServerError;

    public boolean saveObject_async(AMI_IUpdate_saveObject __cb, omero.model.IObject obj);

    public boolean saveObject_async(AMI_IUpdate_saveObject __cb, omero.model.IObject obj, java.util.Map<String, String> __ctx);

    public void saveCollection(java.util.List<omero.model.IObject> objs)
        throws omero.ServerError;

    public void saveCollection(java.util.List<omero.model.IObject> objs, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_saveCollection(java.util.List<omero.model.IObject> objs);

    public Ice.AsyncResult begin_saveCollection(java.util.List<omero.model.IObject> objs, java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_saveCollection(java.util.List<omero.model.IObject> objs, Ice.Callback __cb);

    public Ice.AsyncResult begin_saveCollection(java.util.List<omero.model.IObject> objs, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_saveCollection(java.util.List<omero.model.IObject> objs, Callback_IUpdate_saveCollection __cb);

    public Ice.AsyncResult begin_saveCollection(java.util.List<omero.model.IObject> objs, java.util.Map<String, String> __ctx, Callback_IUpdate_saveCollection __cb);

    public void end_saveCollection(Ice.AsyncResult __result)
        throws omero.ServerError;

    public boolean saveCollection_async(AMI_IUpdate_saveCollection __cb, java.util.List<omero.model.IObject> objs);

    public boolean saveCollection_async(AMI_IUpdate_saveCollection __cb, java.util.List<omero.model.IObject> objs, java.util.Map<String, String> __ctx);

    public omero.model.IObject saveAndReturnObject(omero.model.IObject obj)
        throws omero.ServerError;

    public omero.model.IObject saveAndReturnObject(omero.model.IObject obj, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_saveAndReturnObject(omero.model.IObject obj);

    public Ice.AsyncResult begin_saveAndReturnObject(omero.model.IObject obj, java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_saveAndReturnObject(omero.model.IObject obj, Ice.Callback __cb);

    public Ice.AsyncResult begin_saveAndReturnObject(omero.model.IObject obj, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_saveAndReturnObject(omero.model.IObject obj, Callback_IUpdate_saveAndReturnObject __cb);

    public Ice.AsyncResult begin_saveAndReturnObject(omero.model.IObject obj, java.util.Map<String, String> __ctx, Callback_IUpdate_saveAndReturnObject __cb);

    public omero.model.IObject end_saveAndReturnObject(Ice.AsyncResult __result)
        throws omero.ServerError;

    public boolean saveAndReturnObject_async(AMI_IUpdate_saveAndReturnObject __cb, omero.model.IObject obj);

    public boolean saveAndReturnObject_async(AMI_IUpdate_saveAndReturnObject __cb, omero.model.IObject obj, java.util.Map<String, String> __ctx);

    public void saveArray(java.util.List<omero.model.IObject> graph)
        throws omero.ServerError;

    public void saveArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_saveArray(java.util.List<omero.model.IObject> graph);

    public Ice.AsyncResult begin_saveArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_saveArray(java.util.List<omero.model.IObject> graph, Ice.Callback __cb);

    public Ice.AsyncResult begin_saveArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_saveArray(java.util.List<omero.model.IObject> graph, Callback_IUpdate_saveArray __cb);

    public Ice.AsyncResult begin_saveArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx, Callback_IUpdate_saveArray __cb);

    public void end_saveArray(Ice.AsyncResult __result)
        throws omero.ServerError;

    public boolean saveArray_async(AMI_IUpdate_saveArray __cb, java.util.List<omero.model.IObject> graph);

    public boolean saveArray_async(AMI_IUpdate_saveArray __cb, java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx);

    public java.util.List<omero.model.IObject> saveAndReturnArray(java.util.List<omero.model.IObject> graph)
        throws omero.ServerError;

    public java.util.List<omero.model.IObject> saveAndReturnArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_saveAndReturnArray(java.util.List<omero.model.IObject> graph);

    public Ice.AsyncResult begin_saveAndReturnArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_saveAndReturnArray(java.util.List<omero.model.IObject> graph, Ice.Callback __cb);

    public Ice.AsyncResult begin_saveAndReturnArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_saveAndReturnArray(java.util.List<omero.model.IObject> graph, Callback_IUpdate_saveAndReturnArray __cb);

    public Ice.AsyncResult begin_saveAndReturnArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx, Callback_IUpdate_saveAndReturnArray __cb);

    public java.util.List<omero.model.IObject> end_saveAndReturnArray(Ice.AsyncResult __result)
        throws omero.ServerError;

    public boolean saveAndReturnArray_async(AMI_IUpdate_saveAndReturnArray __cb, java.util.List<omero.model.IObject> graph);

    public boolean saveAndReturnArray_async(AMI_IUpdate_saveAndReturnArray __cb, java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx);

    public java.util.List<Long> saveAndReturnIds(java.util.List<omero.model.IObject> graph)
        throws omero.ServerError;

    public java.util.List<Long> saveAndReturnIds(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_saveAndReturnIds(java.util.List<omero.model.IObject> graph);

    public Ice.AsyncResult begin_saveAndReturnIds(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_saveAndReturnIds(java.util.List<omero.model.IObject> graph, Ice.Callback __cb);

    public Ice.AsyncResult begin_saveAndReturnIds(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_saveAndReturnIds(java.util.List<omero.model.IObject> graph, Callback_IUpdate_saveAndReturnIds __cb);

    public Ice.AsyncResult begin_saveAndReturnIds(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx, Callback_IUpdate_saveAndReturnIds __cb);

    public java.util.List<Long> end_saveAndReturnIds(Ice.AsyncResult __result)
        throws omero.ServerError;

    public boolean saveAndReturnIds_async(AMI_IUpdate_saveAndReturnIds __cb, java.util.List<omero.model.IObject> graph);

    public boolean saveAndReturnIds_async(AMI_IUpdate_saveAndReturnIds __cb, java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx);

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void deleteObject(omero.model.IObject row)
        throws omero.ServerError;

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void deleteObject(omero.model.IObject row, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_deleteObject(omero.model.IObject row);

    /**
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_deleteObject(omero.model.IObject row, java.util.Map<String, String> __ctx);

    /**
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_deleteObject(omero.model.IObject row, Ice.Callback __cb);

    /**
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_deleteObject(omero.model.IObject row, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_deleteObject(omero.model.IObject row, Callback_IUpdate_deleteObject __cb);

    /**
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_deleteObject(omero.model.IObject row, java.util.Map<String, String> __ctx, Callback_IUpdate_deleteObject __cb);

    /**
     * @param __result The asynchronous result object.
     **/
    public void end_deleteObject(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean deleteObject_async(AMI_IUpdate_deleteObject __cb, omero.model.IObject row);

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean deleteObject_async(AMI_IUpdate_deleteObject __cb, omero.model.IObject row, java.util.Map<String, String> __ctx);

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param row
     * a persistent {@link IObject} to be deleted
     * @throws ValidationException
     * if the object does not exist or is nul
     **/
    public void indexObject(omero.model.IObject row)
        throws omero.ServerError;

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param row
     * a persistent {@link IObject} to be deleted
     * @throws ValidationException
     * if the object does not exist or is nul
     * @param __ctx The Context map to send with the invocation.
     **/
    public void indexObject(omero.model.IObject row, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param row
     * a persistent {@link IObject} to be deleted
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_indexObject(omero.model.IObject row);

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param row
     * a persistent {@link IObject} to be deleted
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_indexObject(omero.model.IObject row, java.util.Map<String, String> __ctx);

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param row
     * a persistent {@link IObject} to be deleted
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_indexObject(omero.model.IObject row, Ice.Callback __cb);

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param row
     * a persistent {@link IObject} to be deleted
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_indexObject(omero.model.IObject row, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param row
     * a persistent {@link IObject} to be deleted
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_indexObject(omero.model.IObject row, Callback_IUpdate_indexObject __cb);

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param row
     * a persistent {@link IObject} to be deleted
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_indexObject(omero.model.IObject row, java.util.Map<String, String> __ctx, Callback_IUpdate_indexObject __cb);

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param __result The asynchronous result object.
     * @throws ValidationException
     * if the object does not exist or is nul
     **/
    public void end_indexObject(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param __cb The callback object for the operation.
     * @param row
     * a persistent {@link IObject} to be deleted
     **/
    public boolean indexObject_async(AMI_IUpdate_indexObject __cb, omero.model.IObject row);

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param __cb The callback object for the operation.
     * @param row
     * a persistent {@link IObject} to be deleted
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean indexObject_async(AMI_IUpdate_indexObject __cb, omero.model.IObject row, java.util.Map<String, String> __ctx);
}
