// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IUpdate.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides methods for directly updating object graphs. IUpdate is
 * the lowest level (level-1) interface which may make changes
 * (INSERT, UPDATE, DELETE) to the database. All other methods of
 * changing the database may leave it in an inconsistent state.
 * 
 * <p>
 * All the save* methods act recursively on the entire object graph,
 * replacing placeholders and details where necessary, and then
 * <i>merging</i> the final graph.
 * This means that the objects that are passed into IUpdate.save*
 * methods are copied over to new instances which are then returned.
 * The original objects <b>should be discarded</b>.
 * </p>
 * 
 * <p>{@link #saveAndReturnIds} behaves slightly differently in that
 * it does <em>not</em> handle object modifications. The graph of
 * objects passed in can consist <em>ONLY</em> if either newly created
 * objects without ids or of unloaded objects with ids. <em>Note:</em>
 * The ids of the saved values may not be in order. This is caused by
 * persistence-by-transitivity. Hibernate may detect an item later in
 * the array if they are interconnected and therefore choose to save
 * it first.
 * </p>
 * 
 * <p>
 * All methods throw {@link omero.ValidationException} if the input
 * objects do not pass validation, and
 * {@link omero.OptimisticLockException} if the version of a given has
 * already been incremented.
 **/
public final class IUpdatePrxHelper extends Ice.ObjectPrxHelperBase implements IUpdatePrx
{
    private static final String __deleteObject_name = "deleteObject";

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void deleteObject(omero.model.IObject row)
        throws omero.ServerError
    {
        deleteObject(row, null, false);
    }

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void deleteObject(omero.model.IObject row, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        deleteObject(row, __ctx, true);
    }

    private void deleteObject(omero.model.IObject row, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "deleteObject", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("deleteObject");
                    __delBase = __getDelegate(false);
                    _IUpdateDel __del = (_IUpdateDel)__delBase;
                    __del.deleteObject(row, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_deleteObject(omero.model.IObject row)
    {
        return begin_deleteObject(row, null, false, null);
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_deleteObject(omero.model.IObject row, java.util.Map<String, String> __ctx)
    {
        return begin_deleteObject(row, __ctx, true, null);
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_deleteObject(omero.model.IObject row, Ice.Callback __cb)
    {
        return begin_deleteObject(row, null, false, __cb);
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_deleteObject(omero.model.IObject row, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_deleteObject(row, __ctx, true, __cb);
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_deleteObject(omero.model.IObject row, Callback_IUpdate_deleteObject __cb)
    {
        return begin_deleteObject(row, null, false, __cb);
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_deleteObject(omero.model.IObject row, java.util.Map<String, String> __ctx, Callback_IUpdate_deleteObject __cb)
    {
        return begin_deleteObject(row, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_deleteObject(omero.model.IObject row, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__deleteObject_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __deleteObject_name, __cb);
        try
        {
            __result.__prepare(__deleteObject_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(row);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_deleteObject(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __deleteObject_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean deleteObject_async(AMI_IUpdate_deleteObject __cb, omero.model.IObject row)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__deleteObject_name);
            __r = begin_deleteObject(row, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __deleteObject_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean deleteObject_async(AMI_IUpdate_deleteObject __cb, omero.model.IObject row, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__deleteObject_name);
            __r = begin_deleteObject(row, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __deleteObject_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __indexObject_name = "indexObject";

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param row
     * a persistent {@link IObject} to be deleted
     * @throws ValidationException
     * if the object does not exist or is nul
     **/
    public void indexObject(omero.model.IObject row)
        throws omero.ServerError
    {
        indexObject(row, null, false);
    }

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param row
     * a persistent {@link IObject} to be deleted
     * @throws ValidationException
     * if the object does not exist or is nul
     * @param __ctx The Context map to send with the invocation.
     **/
    public void indexObject(omero.model.IObject row, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        indexObject(row, __ctx, true);
    }

    private void indexObject(omero.model.IObject row, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "indexObject", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("indexObject");
                    __delBase = __getDelegate(false);
                    _IUpdateDel __del = (_IUpdateDel)__delBase;
                    __del.indexObject(row, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param __cb The callback object for the operation.
     * @param row
     * a persistent {@link IObject} to be deleted
     **/
    public Ice.AsyncResult begin_indexObject(omero.model.IObject row)
    {
        return begin_indexObject(row, null, false, null);
    }

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param __cb The callback object for the operation.
     * @param row
     * a persistent {@link IObject} to be deleted
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_indexObject(omero.model.IObject row, java.util.Map<String, String> __ctx)
    {
        return begin_indexObject(row, __ctx, true, null);
    }

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param __cb The callback object for the operation.
     * @param row
     * a persistent {@link IObject} to be deleted
     **/
    public Ice.AsyncResult begin_indexObject(omero.model.IObject row, Ice.Callback __cb)
    {
        return begin_indexObject(row, null, false, __cb);
    }

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param __cb The callback object for the operation.
     * @param row
     * a persistent {@link IObject} to be deleted
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_indexObject(omero.model.IObject row, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_indexObject(row, __ctx, true, __cb);
    }

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param __cb The callback object for the operation.
     * @param row
     * a persistent {@link IObject} to be deleted
     **/
    public Ice.AsyncResult begin_indexObject(omero.model.IObject row, Callback_IUpdate_indexObject __cb)
    {
        return begin_indexObject(row, null, false, __cb);
    }

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param __cb The callback object for the operation.
     * @param row
     * a persistent {@link IObject} to be deleted
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_indexObject(omero.model.IObject row, java.util.Map<String, String> __ctx, Callback_IUpdate_indexObject __cb)
    {
        return begin_indexObject(row, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_indexObject(omero.model.IObject row, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__indexObject_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __indexObject_name, __cb);
        try
        {
            __result.__prepare(__indexObject_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(row);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_indexObject(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __indexObject_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param __cb The callback object for the operation.
     * @param row
     * a persistent {@link IObject} to be deleted
     **/
    public boolean indexObject_async(AMI_IUpdate_indexObject __cb, omero.model.IObject row)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__indexObject_name);
            __r = begin_indexObject(row, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __indexObject_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param __cb The callback object for the operation.
     * @param row
     * a persistent {@link IObject} to be deleted
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean indexObject_async(AMI_IUpdate_indexObject __cb, omero.model.IObject row, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__indexObject_name);
            __r = begin_indexObject(row, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __indexObject_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __saveAndReturnArray_name = "saveAndReturnArray";

    public java.util.List<omero.model.IObject> saveAndReturnArray(java.util.List<omero.model.IObject> graph)
        throws omero.ServerError
    {
        return saveAndReturnArray(graph, null, false);
    }

    public java.util.List<omero.model.IObject> saveAndReturnArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return saveAndReturnArray(graph, __ctx, true);
    }

    private java.util.List<omero.model.IObject> saveAndReturnArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "saveAndReturnArray", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("saveAndReturnArray");
                    __delBase = __getDelegate(false);
                    _IUpdateDel __del = (_IUpdateDel)__delBase;
                    return __del.saveAndReturnArray(graph, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_saveAndReturnArray(java.util.List<omero.model.IObject> graph)
    {
        return begin_saveAndReturnArray(graph, null, false, null);
    }

    public Ice.AsyncResult begin_saveAndReturnArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx)
    {
        return begin_saveAndReturnArray(graph, __ctx, true, null);
    }

    public Ice.AsyncResult begin_saveAndReturnArray(java.util.List<omero.model.IObject> graph, Ice.Callback __cb)
    {
        return begin_saveAndReturnArray(graph, null, false, __cb);
    }

    public Ice.AsyncResult begin_saveAndReturnArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_saveAndReturnArray(graph, __ctx, true, __cb);
    }

    public Ice.AsyncResult begin_saveAndReturnArray(java.util.List<omero.model.IObject> graph, Callback_IUpdate_saveAndReturnArray __cb)
    {
        return begin_saveAndReturnArray(graph, null, false, __cb);
    }

    public Ice.AsyncResult begin_saveAndReturnArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx, Callback_IUpdate_saveAndReturnArray __cb)
    {
        return begin_saveAndReturnArray(graph, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_saveAndReturnArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__saveAndReturnArray_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __saveAndReturnArray_name, __cb);
        try
        {
            __result.__prepare(__saveAndReturnArray_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            IObjectListHelper.write(__os, graph);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public java.util.List<omero.model.IObject> end_saveAndReturnArray(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __saveAndReturnArray_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.IObject> __ret;
            __ret = IObjectListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public boolean saveAndReturnArray_async(AMI_IUpdate_saveAndReturnArray __cb, java.util.List<omero.model.IObject> graph)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__saveAndReturnArray_name);
            __r = begin_saveAndReturnArray(graph, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __saveAndReturnArray_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public boolean saveAndReturnArray_async(AMI_IUpdate_saveAndReturnArray __cb, java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__saveAndReturnArray_name);
            __r = begin_saveAndReturnArray(graph, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __saveAndReturnArray_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __saveAndReturnIds_name = "saveAndReturnIds";

    public java.util.List<Long> saveAndReturnIds(java.util.List<omero.model.IObject> graph)
        throws omero.ServerError
    {
        return saveAndReturnIds(graph, null, false);
    }

    public java.util.List<Long> saveAndReturnIds(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return saveAndReturnIds(graph, __ctx, true);
    }

    private java.util.List<Long> saveAndReturnIds(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "saveAndReturnIds", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("saveAndReturnIds");
                    __delBase = __getDelegate(false);
                    _IUpdateDel __del = (_IUpdateDel)__delBase;
                    return __del.saveAndReturnIds(graph, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_saveAndReturnIds(java.util.List<omero.model.IObject> graph)
    {
        return begin_saveAndReturnIds(graph, null, false, null);
    }

    public Ice.AsyncResult begin_saveAndReturnIds(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx)
    {
        return begin_saveAndReturnIds(graph, __ctx, true, null);
    }

    public Ice.AsyncResult begin_saveAndReturnIds(java.util.List<omero.model.IObject> graph, Ice.Callback __cb)
    {
        return begin_saveAndReturnIds(graph, null, false, __cb);
    }

    public Ice.AsyncResult begin_saveAndReturnIds(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_saveAndReturnIds(graph, __ctx, true, __cb);
    }

    public Ice.AsyncResult begin_saveAndReturnIds(java.util.List<omero.model.IObject> graph, Callback_IUpdate_saveAndReturnIds __cb)
    {
        return begin_saveAndReturnIds(graph, null, false, __cb);
    }

    public Ice.AsyncResult begin_saveAndReturnIds(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx, Callback_IUpdate_saveAndReturnIds __cb)
    {
        return begin_saveAndReturnIds(graph, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_saveAndReturnIds(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__saveAndReturnIds_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __saveAndReturnIds_name, __cb);
        try
        {
            __result.__prepare(__saveAndReturnIds_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            IObjectListHelper.write(__os, graph);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public java.util.List<Long> end_saveAndReturnIds(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __saveAndReturnIds_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<Long> __ret;
            __ret = omero.sys.LongListHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public boolean saveAndReturnIds_async(AMI_IUpdate_saveAndReturnIds __cb, java.util.List<omero.model.IObject> graph)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__saveAndReturnIds_name);
            __r = begin_saveAndReturnIds(graph, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __saveAndReturnIds_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public boolean saveAndReturnIds_async(AMI_IUpdate_saveAndReturnIds __cb, java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__saveAndReturnIds_name);
            __r = begin_saveAndReturnIds(graph, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __saveAndReturnIds_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __saveAndReturnObject_name = "saveAndReturnObject";

    public omero.model.IObject saveAndReturnObject(omero.model.IObject obj)
        throws omero.ServerError
    {
        return saveAndReturnObject(obj, null, false);
    }

    public omero.model.IObject saveAndReturnObject(omero.model.IObject obj, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return saveAndReturnObject(obj, __ctx, true);
    }

    private omero.model.IObject saveAndReturnObject(omero.model.IObject obj, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "saveAndReturnObject", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("saveAndReturnObject");
                    __delBase = __getDelegate(false);
                    _IUpdateDel __del = (_IUpdateDel)__delBase;
                    return __del.saveAndReturnObject(obj, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_saveAndReturnObject(omero.model.IObject obj)
    {
        return begin_saveAndReturnObject(obj, null, false, null);
    }

    public Ice.AsyncResult begin_saveAndReturnObject(omero.model.IObject obj, java.util.Map<String, String> __ctx)
    {
        return begin_saveAndReturnObject(obj, __ctx, true, null);
    }

    public Ice.AsyncResult begin_saveAndReturnObject(omero.model.IObject obj, Ice.Callback __cb)
    {
        return begin_saveAndReturnObject(obj, null, false, __cb);
    }

    public Ice.AsyncResult begin_saveAndReturnObject(omero.model.IObject obj, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_saveAndReturnObject(obj, __ctx, true, __cb);
    }

    public Ice.AsyncResult begin_saveAndReturnObject(omero.model.IObject obj, Callback_IUpdate_saveAndReturnObject __cb)
    {
        return begin_saveAndReturnObject(obj, null, false, __cb);
    }

    public Ice.AsyncResult begin_saveAndReturnObject(omero.model.IObject obj, java.util.Map<String, String> __ctx, Callback_IUpdate_saveAndReturnObject __cb)
    {
        return begin_saveAndReturnObject(obj, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_saveAndReturnObject(omero.model.IObject obj, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__saveAndReturnObject_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __saveAndReturnObject_name, __cb);
        try
        {
            __result.__prepare(__saveAndReturnObject_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(obj);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public omero.model.IObject end_saveAndReturnObject(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __saveAndReturnObject_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.IObjectHolder __ret = new omero.model.IObjectHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public boolean saveAndReturnObject_async(AMI_IUpdate_saveAndReturnObject __cb, omero.model.IObject obj)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__saveAndReturnObject_name);
            __r = begin_saveAndReturnObject(obj, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __saveAndReturnObject_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public boolean saveAndReturnObject_async(AMI_IUpdate_saveAndReturnObject __cb, omero.model.IObject obj, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__saveAndReturnObject_name);
            __r = begin_saveAndReturnObject(obj, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __saveAndReturnObject_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __saveArray_name = "saveArray";

    public void saveArray(java.util.List<omero.model.IObject> graph)
        throws omero.ServerError
    {
        saveArray(graph, null, false);
    }

    public void saveArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        saveArray(graph, __ctx, true);
    }

    private void saveArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "saveArray", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("saveArray");
                    __delBase = __getDelegate(false);
                    _IUpdateDel __del = (_IUpdateDel)__delBase;
                    __del.saveArray(graph, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_saveArray(java.util.List<omero.model.IObject> graph)
    {
        return begin_saveArray(graph, null, false, null);
    }

    public Ice.AsyncResult begin_saveArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx)
    {
        return begin_saveArray(graph, __ctx, true, null);
    }

    public Ice.AsyncResult begin_saveArray(java.util.List<omero.model.IObject> graph, Ice.Callback __cb)
    {
        return begin_saveArray(graph, null, false, __cb);
    }

    public Ice.AsyncResult begin_saveArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_saveArray(graph, __ctx, true, __cb);
    }

    public Ice.AsyncResult begin_saveArray(java.util.List<omero.model.IObject> graph, Callback_IUpdate_saveArray __cb)
    {
        return begin_saveArray(graph, null, false, __cb);
    }

    public Ice.AsyncResult begin_saveArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx, Callback_IUpdate_saveArray __cb)
    {
        return begin_saveArray(graph, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_saveArray(java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__saveArray_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __saveArray_name, __cb);
        try
        {
            __result.__prepare(__saveArray_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            IObjectListHelper.write(__os, graph);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public void end_saveArray(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __saveArray_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public boolean saveArray_async(AMI_IUpdate_saveArray __cb, java.util.List<omero.model.IObject> graph)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__saveArray_name);
            __r = begin_saveArray(graph, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __saveArray_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public boolean saveArray_async(AMI_IUpdate_saveArray __cb, java.util.List<omero.model.IObject> graph, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__saveArray_name);
            __r = begin_saveArray(graph, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __saveArray_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __saveCollection_name = "saveCollection";

    public void saveCollection(java.util.List<omero.model.IObject> objs)
        throws omero.ServerError
    {
        saveCollection(objs, null, false);
    }

    public void saveCollection(java.util.List<omero.model.IObject> objs, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        saveCollection(objs, __ctx, true);
    }

    private void saveCollection(java.util.List<omero.model.IObject> objs, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "saveCollection", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("saveCollection");
                    __delBase = __getDelegate(false);
                    _IUpdateDel __del = (_IUpdateDel)__delBase;
                    __del.saveCollection(objs, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_saveCollection(java.util.List<omero.model.IObject> objs)
    {
        return begin_saveCollection(objs, null, false, null);
    }

    public Ice.AsyncResult begin_saveCollection(java.util.List<omero.model.IObject> objs, java.util.Map<String, String> __ctx)
    {
        return begin_saveCollection(objs, __ctx, true, null);
    }

    public Ice.AsyncResult begin_saveCollection(java.util.List<omero.model.IObject> objs, Ice.Callback __cb)
    {
        return begin_saveCollection(objs, null, false, __cb);
    }

    public Ice.AsyncResult begin_saveCollection(java.util.List<omero.model.IObject> objs, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_saveCollection(objs, __ctx, true, __cb);
    }

    public Ice.AsyncResult begin_saveCollection(java.util.List<omero.model.IObject> objs, Callback_IUpdate_saveCollection __cb)
    {
        return begin_saveCollection(objs, null, false, __cb);
    }

    public Ice.AsyncResult begin_saveCollection(java.util.List<omero.model.IObject> objs, java.util.Map<String, String> __ctx, Callback_IUpdate_saveCollection __cb)
    {
        return begin_saveCollection(objs, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_saveCollection(java.util.List<omero.model.IObject> objs, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__saveCollection_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __saveCollection_name, __cb);
        try
        {
            __result.__prepare(__saveCollection_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            IObjectListHelper.write(__os, objs);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public void end_saveCollection(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __saveCollection_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public boolean saveCollection_async(AMI_IUpdate_saveCollection __cb, java.util.List<omero.model.IObject> objs)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__saveCollection_name);
            __r = begin_saveCollection(objs, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __saveCollection_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public boolean saveCollection_async(AMI_IUpdate_saveCollection __cb, java.util.List<omero.model.IObject> objs, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__saveCollection_name);
            __r = begin_saveCollection(objs, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __saveCollection_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __saveObject_name = "saveObject";

    public void saveObject(omero.model.IObject obj)
        throws omero.ServerError
    {
        saveObject(obj, null, false);
    }

    public void saveObject(omero.model.IObject obj, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        saveObject(obj, __ctx, true);
    }

    private void saveObject(omero.model.IObject obj, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "saveObject", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("saveObject");
                    __delBase = __getDelegate(false);
                    _IUpdateDel __del = (_IUpdateDel)__delBase;
                    __del.saveObject(obj, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_saveObject(omero.model.IObject obj)
    {
        return begin_saveObject(obj, null, false, null);
    }

    public Ice.AsyncResult begin_saveObject(omero.model.IObject obj, java.util.Map<String, String> __ctx)
    {
        return begin_saveObject(obj, __ctx, true, null);
    }

    public Ice.AsyncResult begin_saveObject(omero.model.IObject obj, Ice.Callback __cb)
    {
        return begin_saveObject(obj, null, false, __cb);
    }

    public Ice.AsyncResult begin_saveObject(omero.model.IObject obj, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_saveObject(obj, __ctx, true, __cb);
    }

    public Ice.AsyncResult begin_saveObject(omero.model.IObject obj, Callback_IUpdate_saveObject __cb)
    {
        return begin_saveObject(obj, null, false, __cb);
    }

    public Ice.AsyncResult begin_saveObject(omero.model.IObject obj, java.util.Map<String, String> __ctx, Callback_IUpdate_saveObject __cb)
    {
        return begin_saveObject(obj, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_saveObject(omero.model.IObject obj, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__saveObject_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __saveObject_name, __cb);
        try
        {
            __result.__prepare(__saveObject_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(obj);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public void end_saveObject(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __saveObject_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public boolean saveObject_async(AMI_IUpdate_saveObject __cb, omero.model.IObject obj)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__saveObject_name);
            __r = begin_saveObject(obj, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __saveObject_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public boolean saveObject_async(AMI_IUpdate_saveObject __cb, omero.model.IObject obj, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__saveObject_name);
            __r = begin_saveObject(obj, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __saveObject_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static IUpdatePrx checkedCast(Ice.ObjectPrx __obj)
    {
        IUpdatePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IUpdatePrx)
            {
                __d = (IUpdatePrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    IUpdatePrxHelper __h = new IUpdatePrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static IUpdatePrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        IUpdatePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IUpdatePrx)
            {
                __d = (IUpdatePrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    IUpdatePrxHelper __h = new IUpdatePrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static IUpdatePrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        IUpdatePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    IUpdatePrxHelper __h = new IUpdatePrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static IUpdatePrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        IUpdatePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    IUpdatePrxHelper __h = new IUpdatePrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static IUpdatePrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        IUpdatePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IUpdatePrx)
            {
                __d = (IUpdatePrx)__obj;
            }
            else
            {
                IUpdatePrxHelper __h = new IUpdatePrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static IUpdatePrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        IUpdatePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            IUpdatePrxHelper __h = new IUpdatePrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IUpdate",
        "::omero::api::ServiceInterface"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _IUpdateDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _IUpdateDelD();
    }

    public static void __write(IceInternal.BasicStream __os, IUpdatePrx v)
    {
        __os.writeProxy(v);
    }

    public static IUpdatePrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            IUpdatePrxHelper result = new IUpdatePrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
