// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `JobHandle.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Allows submission of asynchronous jobs.
 * <p>
 * NOTE: The calling order for the service is as follows:
 * <ol>
 * <li>{@link #submit} <em>or</em> {@link #attach}</li>
 * <li>any of the other methods</li>
 * <li>{@link #close}</li>
 * </ol>
 * </p>
 * Calling {@link #close} does not cancel or otherwise change
 * the Job state. See {@link #cancelJob}.
 **/
public final class JobHandlePrxHelper extends Ice.ObjectPrxHelperBase implements JobHandlePrx
{
    private static final String __attach_name = "attach";

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @throws ApiUsageException
     * if the {@link Job id} does not exist.
     **/
    public omero.model.JobStatus attach(long jobId)
        throws omero.ServerError
    {
        return attach(jobId, null, false);
    }

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @throws ApiUsageException
     * if the {@link Job id} does not exist.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.JobStatus attach(long jobId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return attach(jobId, __ctx, true);
    }

    private omero.model.JobStatus attach(long jobId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "attach", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("attach");
                    __delBase = __getDelegate(false);
                    _JobHandleDel __del = (_JobHandleDel)__delBase;
                    return __del.attach(jobId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_attach(long jobId)
    {
        return begin_attach(jobId, null, false, null);
    }

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_attach(long jobId, java.util.Map<String, String> __ctx)
    {
        return begin_attach(jobId, __ctx, true, null);
    }

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_attach(long jobId, Ice.Callback __cb)
    {
        return begin_attach(jobId, null, false, __cb);
    }

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_attach(long jobId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_attach(jobId, __ctx, true, __cb);
    }

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_attach(long jobId, Callback_JobHandle_attach __cb)
    {
        return begin_attach(jobId, null, false, __cb);
    }

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_attach(long jobId, java.util.Map<String, String> __ctx, Callback_JobHandle_attach __cb)
    {
        return begin_attach(jobId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_attach(long jobId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__attach_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __attach_name, __cb);
        try
        {
            __result.__prepare(__attach_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(jobId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.model.JobStatus end_attach(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __attach_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.JobStatusHolder __ret = new omero.model.JobStatusHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean attach_async(AMI_JobHandle_attach __cb, long jobId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__attach_name);
            __r = begin_attach(jobId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __attach_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean attach_async(AMI_JobHandle_attach __cb, long jobId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__attach_name);
            __r = begin_attach(jobId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __attach_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __cancelJob_name = "cancelJob";

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     **/
    public void cancelJob()
        throws omero.ServerError
    {
        cancelJob(null, false);
    }

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void cancelJob(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        cancelJob(__ctx, true);
    }

    private void cancelJob(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "cancelJob", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("cancelJob");
                    __delBase = __getDelegate(false);
                    _JobHandleDel __del = (_JobHandleDel)__delBase;
                    __del.cancelJob(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_cancelJob()
    {
        return begin_cancelJob(null, false, null);
    }

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_cancelJob(java.util.Map<String, String> __ctx)
    {
        return begin_cancelJob(__ctx, true, null);
    }

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_cancelJob(Ice.Callback __cb)
    {
        return begin_cancelJob(null, false, __cb);
    }

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_cancelJob(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_cancelJob(__ctx, true, __cb);
    }

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_cancelJob(Callback_JobHandle_cancelJob __cb)
    {
        return begin_cancelJob(null, false, __cb);
    }

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_cancelJob(java.util.Map<String, String> __ctx, Callback_JobHandle_cancelJob __cb)
    {
        return begin_cancelJob(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_cancelJob(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__cancelJob_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __cancelJob_name, __cb);
        try
        {
            __result.__prepare(__cancelJob_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_cancelJob(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __cancelJob_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __cb The callback object for the operation.
     **/
    public boolean cancelJob_async(AMI_JobHandle_cancelJob __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__cancelJob_name);
            __r = begin_cancelJob(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __cancelJob_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean cancelJob_async(AMI_JobHandle_cancelJob __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__cancelJob_name);
            __r = begin_cancelJob(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __cancelJob_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getJob_name = "getJob";

    /**
     * Returns the current {@link omero.model.Job}
     **/
    public omero.model.Job getJob()
        throws omero.ServerError
    {
        return getJob(null, false);
    }

    /**
     * Returns the current {@link omero.model.Job}
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.Job getJob(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getJob(__ctx, true);
    }

    private omero.model.Job getJob(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getJob", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getJob");
                    __delBase = __getDelegate(false);
                    _JobHandleDel __del = (_JobHandleDel)__delBase;
                    return __del.getJob(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the current {@link omero.model.Job}
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getJob()
    {
        return begin_getJob(null, false, null);
    }

    /**
     * Returns the current {@link omero.model.Job}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx)
    {
        return begin_getJob(__ctx, true, null);
    }

    /**
     * Returns the current {@link omero.model.Job}
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getJob(Ice.Callback __cb)
    {
        return begin_getJob(null, false, __cb);
    }

    /**
     * Returns the current {@link omero.model.Job}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getJob(__ctx, true, __cb);
    }

    /**
     * Returns the current {@link omero.model.Job}
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getJob(Callback_JobHandle_getJob __cb)
    {
        return begin_getJob(null, false, __cb);
    }

    /**
     * Returns the current {@link omero.model.Job}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx, Callback_JobHandle_getJob __cb)
    {
        return begin_getJob(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getJob_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getJob_name, __cb);
        try
        {
            __result.__prepare(__getJob_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.model.Job end_getJob(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getJob_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.JobHolder __ret = new omero.model.JobHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the current {@link omero.model.Job}
     * @param __cb The callback object for the operation.
     **/
    public boolean getJob_async(AMI_JobHandle_getJob __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getJob_name);
            __r = begin_getJob(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getJob_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the current {@link omero.model.Job}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getJob_async(AMI_JobHandle_getJob __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getJob_name);
            __r = begin_getJob(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getJob_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __jobError_name = "jobError";

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     **/
    public boolean jobError()
        throws omero.ServerError
    {
        return jobError(null, false);
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean jobError(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return jobError(__ctx, true);
    }

    private boolean jobError(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "jobError", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("jobError");
                    __delBase = __getDelegate(false);
                    _JobHandleDel __del = (_JobHandleDel)__delBase;
                    return __del.jobError(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_jobError()
    {
        return begin_jobError(null, false, null);
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_jobError(java.util.Map<String, String> __ctx)
    {
        return begin_jobError(__ctx, true, null);
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_jobError(Ice.Callback __cb)
    {
        return begin_jobError(null, false, __cb);
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_jobError(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_jobError(__ctx, true, __cb);
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_jobError(Callback_JobHandle_jobError __cb)
    {
        return begin_jobError(null, false, __cb);
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_jobError(java.util.Map<String, String> __ctx, Callback_JobHandle_jobError __cb)
    {
        return begin_jobError(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_jobError(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__jobError_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __jobError_name, __cb);
        try
        {
            __result.__prepare(__jobError_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_jobError(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __jobError_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __cb The callback object for the operation.
     **/
    public boolean jobError_async(AMI_JobHandle_jobError __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__jobError_name);
            __r = begin_jobError(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __jobError_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean jobError_async(AMI_JobHandle_jobError __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__jobError_name);
            __r = begin_jobError(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __jobError_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __jobFinished_name = "jobFinished";

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     **/
    public omero.RTime jobFinished()
        throws omero.ServerError
    {
        return jobFinished(null, false);
    }

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.RTime jobFinished(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return jobFinished(__ctx, true);
    }

    private omero.RTime jobFinished(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "jobFinished", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("jobFinished");
                    __delBase = __getDelegate(false);
                    _JobHandleDel __del = (_JobHandleDel)__delBase;
                    return __del.jobFinished(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_jobFinished()
    {
        return begin_jobFinished(null, false, null);
    }

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_jobFinished(java.util.Map<String, String> __ctx)
    {
        return begin_jobFinished(__ctx, true, null);
    }

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_jobFinished(Ice.Callback __cb)
    {
        return begin_jobFinished(null, false, __cb);
    }

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_jobFinished(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_jobFinished(__ctx, true, __cb);
    }

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_jobFinished(Callback_JobHandle_jobFinished __cb)
    {
        return begin_jobFinished(null, false, __cb);
    }

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_jobFinished(java.util.Map<String, String> __ctx, Callback_JobHandle_jobFinished __cb)
    {
        return begin_jobFinished(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_jobFinished(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__jobFinished_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __jobFinished_name, __cb);
        try
        {
            __result.__prepare(__jobFinished_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.RTime end_jobFinished(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __jobFinished_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.RTimeHolder __ret = new omero.RTimeHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __cb The callback object for the operation.
     **/
    public boolean jobFinished_async(AMI_JobHandle_jobFinished __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__jobFinished_name);
            __r = begin_jobFinished(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __jobFinished_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean jobFinished_async(AMI_JobHandle_jobFinished __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__jobFinished_name);
            __r = begin_jobFinished(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __jobFinished_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __jobMessage_name = "jobMessage";

    /**
     * Returns the current message for job. May be set during
     * processing.
     **/
    public String jobMessage()
        throws omero.ServerError
    {
        return jobMessage(null, false);
    }

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __ctx The Context map to send with the invocation.
     **/
    public String jobMessage(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return jobMessage(__ctx, true);
    }

    private String jobMessage(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "jobMessage", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("jobMessage");
                    __delBase = __getDelegate(false);
                    _JobHandleDel __del = (_JobHandleDel)__delBase;
                    return __del.jobMessage(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_jobMessage()
    {
        return begin_jobMessage(null, false, null);
    }

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_jobMessage(java.util.Map<String, String> __ctx)
    {
        return begin_jobMessage(__ctx, true, null);
    }

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_jobMessage(Ice.Callback __cb)
    {
        return begin_jobMessage(null, false, __cb);
    }

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_jobMessage(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_jobMessage(__ctx, true, __cb);
    }

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_jobMessage(Callback_JobHandle_jobMessage __cb)
    {
        return begin_jobMessage(null, false, __cb);
    }

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_jobMessage(java.util.Map<String, String> __ctx, Callback_JobHandle_jobMessage __cb)
    {
        return begin_jobMessage(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_jobMessage(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__jobMessage_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __jobMessage_name, __cb);
        try
        {
            __result.__prepare(__jobMessage_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public String end_jobMessage(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __jobMessage_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            String __ret;
            __ret = __is.readString();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __cb The callback object for the operation.
     **/
    public boolean jobMessage_async(AMI_JobHandle_jobMessage __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__jobMessage_name);
            __r = begin_jobMessage(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __jobMessage_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean jobMessage_async(AMI_JobHandle_jobMessage __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__jobMessage_name);
            __r = begin_jobMessage(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __jobMessage_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __jobRunning_name = "jobRunning";

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     **/
    public boolean jobRunning()
        throws omero.ServerError
    {
        return jobRunning(null, false);
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean jobRunning(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return jobRunning(__ctx, true);
    }

    private boolean jobRunning(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "jobRunning", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("jobRunning");
                    __delBase = __getDelegate(false);
                    _JobHandleDel __del = (_JobHandleDel)__delBase;
                    return __del.jobRunning(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_jobRunning()
    {
        return begin_jobRunning(null, false, null);
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_jobRunning(java.util.Map<String, String> __ctx)
    {
        return begin_jobRunning(__ctx, true, null);
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_jobRunning(Ice.Callback __cb)
    {
        return begin_jobRunning(null, false, __cb);
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_jobRunning(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_jobRunning(__ctx, true, __cb);
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_jobRunning(Callback_JobHandle_jobRunning __cb)
    {
        return begin_jobRunning(null, false, __cb);
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_jobRunning(java.util.Map<String, String> __ctx, Callback_JobHandle_jobRunning __cb)
    {
        return begin_jobRunning(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_jobRunning(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__jobRunning_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __jobRunning_name, __cb);
        try
        {
            __result.__prepare(__jobRunning_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_jobRunning(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __jobRunning_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __cb The callback object for the operation.
     **/
    public boolean jobRunning_async(AMI_JobHandle_jobRunning __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__jobRunning_name);
            __r = begin_jobRunning(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __jobRunning_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean jobRunning_async(AMI_JobHandle_jobRunning __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__jobRunning_name);
            __r = begin_jobRunning(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __jobRunning_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __jobStatus_name = "jobStatus";

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     **/
    public omero.model.JobStatus jobStatus()
        throws omero.ServerError
    {
        return jobStatus(null, false);
    }

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.JobStatus jobStatus(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return jobStatus(__ctx, true);
    }

    private omero.model.JobStatus jobStatus(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "jobStatus", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("jobStatus");
                    __delBase = __getDelegate(false);
                    _JobHandleDel __del = (_JobHandleDel)__delBase;
                    return __del.jobStatus(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_jobStatus()
    {
        return begin_jobStatus(null, false, null);
    }

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_jobStatus(java.util.Map<String, String> __ctx)
    {
        return begin_jobStatus(__ctx, true, null);
    }

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_jobStatus(Ice.Callback __cb)
    {
        return begin_jobStatus(null, false, __cb);
    }

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_jobStatus(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_jobStatus(__ctx, true, __cb);
    }

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_jobStatus(Callback_JobHandle_jobStatus __cb)
    {
        return begin_jobStatus(null, false, __cb);
    }

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_jobStatus(java.util.Map<String, String> __ctx, Callback_JobHandle_jobStatus __cb)
    {
        return begin_jobStatus(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_jobStatus(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__jobStatus_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __jobStatus_name, __cb);
        try
        {
            __result.__prepare(__jobStatus_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.model.JobStatus end_jobStatus(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __jobStatus_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.JobStatusHolder __ret = new omero.model.JobStatusHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __cb The callback object for the operation.
     **/
    public boolean jobStatus_async(AMI_JobHandle_jobStatus __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__jobStatus_name);
            __r = begin_jobStatus(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __jobStatus_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean jobStatus_async(AMI_JobHandle_jobStatus __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__jobStatus_name);
            __r = begin_jobStatus(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __jobStatus_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setMessage_name = "setMessage";

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @return the previous message value
     **/
    public String setMessage(String message)
        throws omero.ServerError
    {
        return setMessage(message, null, false);
    }

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return the previous message value
     **/
    public String setMessage(String message, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return setMessage(message, __ctx, true);
    }

    private String setMessage(String message, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setMessage", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setMessage");
                    __delBase = __getDelegate(false);
                    _JobHandleDel __del = (_JobHandleDel)__delBase;
                    return __del.setMessage(message, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setMessage(String message)
    {
        return begin_setMessage(message, null, false, null);
    }

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setMessage(String message, java.util.Map<String, String> __ctx)
    {
        return begin_setMessage(message, __ctx, true, null);
    }

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setMessage(String message, Ice.Callback __cb)
    {
        return begin_setMessage(message, null, false, __cb);
    }

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setMessage(String message, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setMessage(message, __ctx, true, __cb);
    }

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setMessage(String message, Callback_JobHandle_setMessage __cb)
    {
        return begin_setMessage(message, null, false, __cb);
    }

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setMessage(String message, java.util.Map<String, String> __ctx, Callback_JobHandle_setMessage __cb)
    {
        return begin_setMessage(message, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setMessage(String message, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setMessage_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setMessage_name, __cb);
        try
        {
            __result.__prepare(__setMessage_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(message);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) the previous message value
     **/
    public String end_setMessage(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setMessage_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            String __ret;
            __ret = __is.readString();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean setMessage_async(AMI_JobHandle_setMessage __cb, String message)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setMessage_name);
            __r = begin_setMessage(message, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setMessage_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setMessage_async(AMI_JobHandle_setMessage __cb, String message, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setMessage_name);
            __r = begin_setMessage(message, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setMessage_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setStatus_name = "setStatus";

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     **/
    public String setStatus(String status)
        throws omero.ServerError
    {
        return setStatus(status, null, false);
    }

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public String setStatus(String status, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return setStatus(status, __ctx, true);
    }

    private String setStatus(String status, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setStatus", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setStatus");
                    __delBase = __getDelegate(false);
                    _JobHandleDel __del = (_JobHandleDel)__delBase;
                    return __del.setStatus(status, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setStatus(String status)
    {
        return begin_setStatus(status, null, false, null);
    }

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setStatus(String status, java.util.Map<String, String> __ctx)
    {
        return begin_setStatus(status, __ctx, true, null);
    }

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setStatus(String status, Ice.Callback __cb)
    {
        return begin_setStatus(status, null, false, __cb);
    }

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setStatus(String status, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setStatus(status, __ctx, true, __cb);
    }

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setStatus(String status, Callback_JobHandle_setStatus __cb)
    {
        return begin_setStatus(status, null, false, __cb);
    }

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setStatus(String status, java.util.Map<String, String> __ctx, Callback_JobHandle_setStatus __cb)
    {
        return begin_setStatus(status, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setStatus(String status, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setStatus_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setStatus_name, __cb);
        try
        {
            __result.__prepare(__setStatus_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(status);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public String end_setStatus(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setStatus_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            String __ret;
            __ret = __is.readString();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __cb The callback object for the operation.
     **/
    public boolean setStatus_async(AMI_JobHandle_setStatus __cb, String status)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setStatus_name);
            __r = begin_setStatus(status, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setStatus_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setStatus_async(AMI_JobHandle_setStatus __cb, String status, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setStatus_name);
            __r = begin_setStatus(status, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setStatus_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setStatusAndMessage_name = "setStatusAndMessage";

    /**
     * Like {@link #setStatus} but also sets the message.
     **/
    public String setStatusAndMessage(String status, omero.RString message)
        throws omero.ServerError
    {
        return setStatusAndMessage(status, message, null, false);
    }

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __ctx The Context map to send with the invocation.
     **/
    public String setStatusAndMessage(String status, omero.RString message, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return setStatusAndMessage(status, message, __ctx, true);
    }

    private String setStatusAndMessage(String status, omero.RString message, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setStatusAndMessage", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setStatusAndMessage");
                    __delBase = __getDelegate(false);
                    _JobHandleDel __del = (_JobHandleDel)__delBase;
                    return __del.setStatusAndMessage(status, message, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setStatusAndMessage(String status, omero.RString message)
    {
        return begin_setStatusAndMessage(status, message, null, false, null);
    }

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setStatusAndMessage(String status, omero.RString message, java.util.Map<String, String> __ctx)
    {
        return begin_setStatusAndMessage(status, message, __ctx, true, null);
    }

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setStatusAndMessage(String status, omero.RString message, Ice.Callback __cb)
    {
        return begin_setStatusAndMessage(status, message, null, false, __cb);
    }

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setStatusAndMessage(String status, omero.RString message, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setStatusAndMessage(status, message, __ctx, true, __cb);
    }

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setStatusAndMessage(String status, omero.RString message, Callback_JobHandle_setStatusAndMessage __cb)
    {
        return begin_setStatusAndMessage(status, message, null, false, __cb);
    }

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setStatusAndMessage(String status, omero.RString message, java.util.Map<String, String> __ctx, Callback_JobHandle_setStatusAndMessage __cb)
    {
        return begin_setStatusAndMessage(status, message, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setStatusAndMessage(String status, omero.RString message, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setStatusAndMessage_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setStatusAndMessage_name, __cb);
        try
        {
            __result.__prepare(__setStatusAndMessage_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(status);
            __os.writeObject(message);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public String end_setStatusAndMessage(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setStatusAndMessage_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            String __ret;
            __ret = __is.readString();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __cb The callback object for the operation.
     **/
    public boolean setStatusAndMessage_async(AMI_JobHandle_setStatusAndMessage __cb, String status, omero.RString message)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setStatusAndMessage_name);
            __r = begin_setStatusAndMessage(status, message, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setStatusAndMessage_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setStatusAndMessage_async(AMI_JobHandle_setStatusAndMessage __cb, String status, omero.RString message, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setStatusAndMessage_name);
            __r = begin_setStatusAndMessage(status, message, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setStatusAndMessage_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __submit_name = "submit";

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param job Not null
     **/
    public long submit(omero.model.Job j)
        throws omero.ServerError
    {
        return submit(j, null, false);
    }

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param job Not null
     * @param __ctx The Context map to send with the invocation.
     **/
    public long submit(omero.model.Job j, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return submit(j, __ctx, true);
    }

    private long submit(omero.model.Job j, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "submit", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("submit");
                    __delBase = __getDelegate(false);
                    _JobHandleDel __del = (_JobHandleDel)__delBase;
                    return __del.submit(j, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_submit(omero.model.Job j)
    {
        return begin_submit(j, null, false, null);
    }

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_submit(omero.model.Job j, java.util.Map<String, String> __ctx)
    {
        return begin_submit(j, __ctx, true, null);
    }

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_submit(omero.model.Job j, Ice.Callback __cb)
    {
        return begin_submit(j, null, false, __cb);
    }

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_submit(omero.model.Job j, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_submit(j, __ctx, true, __cb);
    }

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_submit(omero.model.Job j, Callback_JobHandle_submit __cb)
    {
        return begin_submit(j, null, false, __cb);
    }

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_submit(omero.model.Job j, java.util.Map<String, String> __ctx, Callback_JobHandle_submit __cb)
    {
        return begin_submit(j, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_submit(omero.model.Job j, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__submit_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __submit_name, __cb);
        try
        {
            __result.__prepare(__submit_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(j);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public long end_submit(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __submit_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean submit_async(AMI_JobHandle_submit __cb, omero.model.Job j)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__submit_name);
            __r = begin_submit(j, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __submit_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean submit_async(AMI_JobHandle_submit __cb, omero.model.Job j, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__submit_name);
            __r = begin_submit(j, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __submit_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __activate_name = "activate";

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     **/
    public void activate()
        throws omero.ServerError
    {
        activate(null, false);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void activate(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        activate(__ctx, true);
    }

    private void activate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "activate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("activate");
                    __delBase = __getDelegate(false);
                    _JobHandleDel __del = (_JobHandleDel)__delBase;
                    __del.activate(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate()
    {
        return begin_activate(null, false, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx)
    {
        return begin_activate(__ctx, true, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate(Ice.Callback __cb)
    {
        return begin_activate(null, false, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_activate(__ctx, true, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate(Callback_StatefulServiceInterface_activate __cb)
    {
        return begin_activate(null, false, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_activate __cb)
    {
        return begin_activate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__activate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
        try
        {
            __result.__prepare(__activate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_activate(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __activate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public boolean activate_async(AMI_StatefulServiceInterface_activate __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__activate_name);
            __r = begin_activate(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean activate_async(AMI_StatefulServiceInterface_activate __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__activate_name);
            __r = begin_activate(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __close_name = "close";

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     **/
    public void close()
        throws omero.ServerError
    {
        close(null, false);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void close(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        close(__ctx, true);
    }

    private void close(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "close", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("close");
                    __delBase = __getDelegate(false);
                    _JobHandleDel __del = (_JobHandleDel)__delBase;
                    __del.close(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close()
    {
        return begin_close(null, false, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx)
    {
        return begin_close(__ctx, true, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close(Ice.Callback __cb)
    {
        return begin_close(null, false, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_close(__ctx, true, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close(Callback_StatefulServiceInterface_close __cb)
    {
        return begin_close(null, false, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_close __cb)
    {
        return begin_close(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__close_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __close_name, __cb);
        try
        {
            __result.__prepare(__close_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_close(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __close_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public boolean close_async(AMI_StatefulServiceInterface_close __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__close_name);
            __r = begin_close(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __close_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean close_async(AMI_StatefulServiceInterface_close __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__close_name);
            __r = begin_close(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __close_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getCurrentEventContext_name = "getCurrentEventContext";

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     **/
    public omero.sys.EventContext getCurrentEventContext()
        throws omero.ServerError
    {
        return getCurrentEventContext(null, false);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.sys.EventContext getCurrentEventContext(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getCurrentEventContext(__ctx, true);
    }

    private omero.sys.EventContext getCurrentEventContext(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getCurrentEventContext", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getCurrentEventContext");
                    __delBase = __getDelegate(false);
                    _JobHandleDel __del = (_JobHandleDel)__delBase;
                    return __del.getCurrentEventContext(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext()
    {
        return begin_getCurrentEventContext(null, false, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx)
    {
        return begin_getCurrentEventContext(__ctx, true, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(Ice.Callback __cb)
    {
        return begin_getCurrentEventContext(null, false, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getCurrentEventContext(__ctx, true, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(Callback_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        return begin_getCurrentEventContext(null, false, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        return begin_getCurrentEventContext(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getCurrentEventContext_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
        try
        {
            __result.__prepare(__getCurrentEventContext_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.sys.EventContext end_getCurrentEventContext(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getCurrentEventContext_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.sys.EventContextHolder __ret = new omero.sys.EventContextHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public boolean getCurrentEventContext_async(AMI_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCurrentEventContext_name);
            __r = begin_getCurrentEventContext(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getCurrentEventContext_async(AMI_StatefulServiceInterface_getCurrentEventContext __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCurrentEventContext_name);
            __r = begin_getCurrentEventContext(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __passivate_name = "passivate";

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     **/
    public void passivate()
        throws omero.ServerError
    {
        passivate(null, false);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void passivate(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        passivate(__ctx, true);
    }

    private void passivate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "passivate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("passivate");
                    __delBase = __getDelegate(false);
                    _JobHandleDel __del = (_JobHandleDel)__delBase;
                    __del.passivate(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate()
    {
        return begin_passivate(null, false, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx)
    {
        return begin_passivate(__ctx, true, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate(Ice.Callback __cb)
    {
        return begin_passivate(null, false, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_passivate(__ctx, true, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate(Callback_StatefulServiceInterface_passivate __cb)
    {
        return begin_passivate(null, false, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_passivate __cb)
    {
        return begin_passivate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__passivate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
        try
        {
            __result.__prepare(__passivate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_passivate(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __passivate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public boolean passivate_async(AMI_StatefulServiceInterface_passivate __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__passivate_name);
            __r = begin_passivate(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean passivate_async(AMI_StatefulServiceInterface_passivate __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__passivate_name);
            __r = begin_passivate(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static JobHandlePrx checkedCast(Ice.ObjectPrx __obj)
    {
        JobHandlePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof JobHandlePrx)
            {
                __d = (JobHandlePrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    JobHandlePrxHelper __h = new JobHandlePrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static JobHandlePrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        JobHandlePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof JobHandlePrx)
            {
                __d = (JobHandlePrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    JobHandlePrxHelper __h = new JobHandlePrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static JobHandlePrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        JobHandlePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    JobHandlePrxHelper __h = new JobHandlePrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static JobHandlePrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        JobHandlePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    JobHandlePrxHelper __h = new JobHandlePrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static JobHandlePrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        JobHandlePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof JobHandlePrx)
            {
                __d = (JobHandlePrx)__obj;
            }
            else
            {
                JobHandlePrxHelper __h = new JobHandlePrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static JobHandlePrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        JobHandlePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            JobHandlePrxHelper __h = new JobHandlePrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::JobHandle",
        "::omero::api::ServiceInterface",
        "::omero::api::StatefulServiceInterface"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _JobHandleDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _JobHandleDelD();
    }

    public static void __write(IceInternal.BasicStream __os, JobHandlePrx v)
    {
        __os.writeProxy(v);
    }

    public static JobHandlePrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            JobHandlePrxHelper result = new JobHandlePrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
