// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `PyramidService.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

public interface PyramidServicePrx extends StatefulServiceInterfacePrx
{
    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @return <code>true</code> if the pixels store requires a
     * pixels pyramid and <code>false</code> otherwise.
     **/
    public boolean requiresPixelsPyramid()
        throws omero.ServerError;

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __ctx The Context map to send with the invocation.
     * @return <code>true</code> if the pixels store requires a
     * pixels pyramid and <code>false</code> otherwise.
     **/
    public boolean requiresPixelsPyramid(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requiresPixelsPyramid();

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requiresPixelsPyramid(java.util.Map<String, String> __ctx);

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requiresPixelsPyramid(Ice.Callback __cb);

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requiresPixelsPyramid(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requiresPixelsPyramid(Callback_PyramidService_requiresPixelsPyramid __cb);

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requiresPixelsPyramid(java.util.Map<String, String> __ctx, Callback_PyramidService_requiresPixelsPyramid __cb);

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __result The asynchronous result object.
     * @return <code>true</code> if the pixels store requires a
     * pixels pyramid and <code>false</code> otherwise.
     **/
    public boolean end_requiresPixelsPyramid(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     **/
    public boolean requiresPixelsPyramid_async(AMI_PyramidService_requiresPixelsPyramid __cb);

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean requiresPixelsPyramid_async(AMI_PyramidService_requiresPixelsPyramid __cb, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @return The number of resolution levels. This value does not
     * necessarily indicate either the presence or absence of a
     * pixels pyramid.
     **/
    public int getResolutionLevels()
        throws omero.ServerError;

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __ctx The Context map to send with the invocation.
     * @return The number of resolution levels. This value does not
     * necessarily indicate either the presence or absence of a
     * pixels pyramid.
     **/
    public int getResolutionLevels(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResolutionLevels();

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResolutionLevels(java.util.Map<String, String> __ctx);

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResolutionLevels(Ice.Callback __cb);

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResolutionLevels(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResolutionLevels(Callback_PyramidService_getResolutionLevels __cb);

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResolutionLevels(java.util.Map<String, String> __ctx, Callback_PyramidService_getResolutionLevels __cb);

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __result The asynchronous result object.
     * @return The number of resolution levels. This value does not
     * necessarily indicate either the presence or absence of a
     * pixels pyramid.
     **/
    public int end_getResolutionLevels(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     **/
    public boolean getResolutionLevels_async(AMI_PyramidService_getResolutionLevels __cb);

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getResolutionLevels_async(AMI_PyramidService_getResolutionLevels __cb, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     **/
    public ResolutionDescription[] getResolutionDescriptions()
        throws omero.ServerError;

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public ResolutionDescription[] getResolutionDescriptions(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResolutionDescriptions();

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResolutionDescriptions(java.util.Map<String, String> __ctx);

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResolutionDescriptions(Ice.Callback __cb);

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResolutionDescriptions(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResolutionDescriptions(Callback_PyramidService_getResolutionDescriptions __cb);

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResolutionDescriptions(java.util.Map<String, String> __ctx, Callback_PyramidService_getResolutionDescriptions __cb);

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __result The asynchronous result object.
     **/
    public ResolutionDescription[] end_getResolutionDescriptions(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     **/
    public boolean getResolutionDescriptions_async(AMI_PyramidService_getResolutionDescriptions __cb);

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getResolutionDescriptions_async(AMI_PyramidService_getResolutionDescriptions __cb, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the active resolution level.
     * @return The active resolution level.
     **/
    public int getResolutionLevel()
        throws omero.ServerError;

    /**
     * Retrieves the active resolution level.
     * @param __ctx The Context map to send with the invocation.
     * @return The active resolution level.
     **/
    public int getResolutionLevel(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the active resolution level.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResolutionLevel();

    /**
     * Retrieves the active resolution level.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResolutionLevel(java.util.Map<String, String> __ctx);

    /**
     * Retrieves the active resolution level.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResolutionLevel(Ice.Callback __cb);

    /**
     * Retrieves the active resolution level.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResolutionLevel(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the active resolution level.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResolutionLevel(Callback_PyramidService_getResolutionLevel __cb);

    /**
     * Retrieves the active resolution level.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResolutionLevel(java.util.Map<String, String> __ctx, Callback_PyramidService_getResolutionLevel __cb);

    /**
     * Retrieves the active resolution level.
     * @param __result The asynchronous result object.
     * @return The active resolution level.
     **/
    public int end_getResolutionLevel(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     **/
    public boolean getResolutionLevel_async(AMI_PyramidService_getResolutionLevel __cb);

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getResolutionLevel_async(AMI_PyramidService_getResolutionLevel __cb, java.util.Map<String, String> __ctx);

    /**
     * Sets the active resolution level.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     **/
    public void setResolutionLevel(int resolutionLevel)
        throws omero.ServerError;

    /**
     * Sets the active resolution level.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setResolutionLevel(int resolutionLevel, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Sets the active resolution level.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel);

    /**
     * Sets the active resolution level.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel, java.util.Map<String, String> __ctx);

    /**
     * Sets the active resolution level.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel, Ice.Callback __cb);

    /**
     * Sets the active resolution level.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Sets the active resolution level.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel, Callback_PyramidService_setResolutionLevel __cb);

    /**
     * Sets the active resolution level.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel, java.util.Map<String, String> __ctx, Callback_PyramidService_setResolutionLevel __cb);

    /**
     * Sets the active resolution level.
     * @param __result The asynchronous result object.
     **/
    public void end_setResolutionLevel(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     **/
    public boolean setResolutionLevel_async(AMI_PyramidService_setResolutionLevel __cb, int resolutionLevel);

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setResolutionLevel_async(AMI_PyramidService_setResolutionLevel __cb, int resolutionLevel, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the tile size for the pixel store.
     * @return An array of <code>length = 2</code> where the first
     * value of the array is the tile width and the second value is
     * the tile height.
     **/
    public int[] getTileSize()
        throws omero.ServerError;

    /**
     * Retrieves the tile size for the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return An array of <code>length = 2</code> where the first
     * value of the array is the tile width and the second value is
     * the tile height.
     **/
    public int[] getTileSize(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the tile size for the pixel store.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTileSize();

    /**
     * Retrieves the tile size for the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTileSize(java.util.Map<String, String> __ctx);

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTileSize(Ice.Callback __cb);

    /**
     * Retrieves the tile size for the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTileSize(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTileSize(Callback_PyramidService_getTileSize __cb);

    /**
     * Retrieves the tile size for the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTileSize(java.util.Map<String, String> __ctx, Callback_PyramidService_getTileSize __cb);

    /**
     * Retrieves the tile size for the pixel store.
     * @param __result The asynchronous result object.
     * @return An array of <code>length = 2</code> where the first
     * value of the array is the tile width and the second value is
     * the tile height.
     **/
    public int[] end_getTileSize(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     **/
    public boolean getTileSize_async(AMI_PyramidService_getTileSize __cb);

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getTileSize_async(AMI_PyramidService_getTileSize __cb, java.util.Map<String, String> __ctx);
}
