// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `RawFileStore.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Raw file gateway which provides access to the OMERO file repository.
 * 
 * Note: methods on this service are protected by a <i>DOWNLOAD</i>
 * restriction.
 **/
public interface RawFileStorePrx extends StatefulServiceInterfacePrx
{
    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     **/
    public void setFileId(long fileId)
        throws omero.ServerError;

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setFileId(long fileId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId);

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, java.util.Map<String, String> __ctx);

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, Ice.Callback __cb);

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, Callback_RawFileStore_setFileId __cb);

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, java.util.Map<String, String> __ctx, Callback_RawFileStore_setFileId __cb);

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __result The asynchronous result object.
     **/
    public void end_setFileId(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __cb The callback object for the operation.
     **/
    public boolean setFileId_async(AMI_RawFileStore_setFileId __cb, long fileId);

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setFileId_async(AMI_RawFileStore_setFileId __cb, long fileId, java.util.Map<String, String> __ctx);

    /**
     * Returns the current file id or null if none has been set.
     **/
    public omero.RLong getFileId()
        throws omero.ServerError;

    /**
     * Returns the current file id or null if none has been set.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.RLong getFileId(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the current file id or null if none has been set.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileId();

    /**
     * Returns the current file id or null if none has been set.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileId(java.util.Map<String, String> __ctx);

    /**
     * Returns the current file id or null if none has been set.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileId(Ice.Callback __cb);

    /**
     * Returns the current file id or null if none has been set.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileId(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the current file id or null if none has been set.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileId(Callback_RawFileStore_getFileId __cb);

    /**
     * Returns the current file id or null if none has been set.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getFileId(java.util.Map<String, String> __ctx, Callback_RawFileStore_getFileId __cb);

    /**
     * Returns the current file id or null if none has been set.
     * @param __result The asynchronous result object.
     **/
    public omero.RLong end_getFileId(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the current file id or null if none has been set.
     * @param __cb The callback object for the operation.
     **/
    public boolean getFileId_async(AMI_RawFileStore_getFileId __cb);

    /**
     * Returns the current file id or null if none has been set.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getFileId_async(AMI_RawFileStore_getFileId __cb, java.util.Map<String, String> __ctx);

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     **/
    public byte[] read(long position, int length)
        throws omero.ServerError;

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __ctx The Context map to send with the invocation.
     **/
    public byte[] read(long position, int length, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_read(long position, int length);

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_read(long position, int length, java.util.Map<String, String> __ctx);

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_read(long position, int length, Ice.Callback __cb);

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_read(long position, int length, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_read(long position, int length, Callback_RawFileStore_read __cb);

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_read(long position, int length, java.util.Map<String, String> __ctx, Callback_RawFileStore_read __cb);

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __result The asynchronous result object.
     **/
    public byte[] end_read(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __cb The callback object for the operation.
     **/
    public boolean read_async(AMI_RawFileStore_read __cb, long position, int length);

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean read_async(AMI_RawFileStore_read __cb, long position, int length, java.util.Map<String, String> __ctx);

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     **/
    public long size()
        throws omero.ServerError;

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __ctx The Context map to send with the invocation.
     **/
    public long size(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_size();

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_size(java.util.Map<String, String> __ctx);

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_size(Ice.Callback __cb);

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_size(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_size(Callback_RawFileStore_size __cb);

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_size(java.util.Map<String, String> __ctx, Callback_RawFileStore_size __cb);

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __result The asynchronous result object.
     **/
    public long end_size(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __cb The callback object for the operation.
     **/
    public boolean size_async(AMI_RawFileStore_size __cb);

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean size_async(AMI_RawFileStore_size __cb, java.util.Map<String, String> __ctx);

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     **/
    public boolean truncate(long length)
        throws omero.ServerError;

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean truncate(long length, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_truncate(long length);

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_truncate(long length, java.util.Map<String, String> __ctx);

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_truncate(long length, Ice.Callback __cb);

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_truncate(long length, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_truncate(long length, Callback_RawFileStore_truncate __cb);

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_truncate(long length, java.util.Map<String, String> __ctx, Callback_RawFileStore_truncate __cb);

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __result The asynchronous result object.
     **/
    public boolean end_truncate(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __cb The callback object for the operation.
     **/
    public boolean truncate_async(AMI_RawFileStore_truncate __cb, long length);

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean truncate_async(AMI_RawFileStore_truncate __cb, long length, java.util.Map<String, String> __ctx);

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     **/
    public void write(byte[] buf, long position, int length)
        throws omero.ServerError;

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void write(byte[] buf, long position, int length, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_write(byte[] buf, long position, int length);

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_write(byte[] buf, long position, int length, java.util.Map<String, String> __ctx);

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_write(byte[] buf, long position, int length, Ice.Callback __cb);

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_write(byte[] buf, long position, int length, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_write(byte[] buf, long position, int length, Callback_RawFileStore_write __cb);

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_write(byte[] buf, long position, int length, java.util.Map<String, String> __ctx, Callback_RawFileStore_write __cb);

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __result The asynchronous result object.
     **/
    public void end_write(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __cb The callback object for the operation.
     **/
    public boolean write_async(AMI_RawFileStore_write __cb, byte[] buf, long position, int length);

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean write_async(AMI_RawFileStore_write __cb, byte[] buf, long position, int length, java.util.Map<String, String> __ctx);

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @return <code>true</code> if there is an accessible file
     * within the original file repository with the
     * correct ID. Otherwise <code>false</code>.
     * @throws ResourceError if there is a problem accessing the
     * file due to permissions errors within the
     * repository or any other I/O error.
     **/
    public boolean exists()
        throws omero.ServerError;

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return <code>true</code> if there is an accessible file
     * within the original file repository with the
     * correct ID. Otherwise <code>false</code>.
     * @throws ResourceError if there is a problem accessing the
     * file due to permissions errors within the
     * repository or any other I/O error.
     **/
    public boolean exists(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_exists();

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_exists(java.util.Map<String, String> __ctx);

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_exists(Ice.Callback __cb);

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_exists(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_exists(Callback_RawFileStore_exists __cb);

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_exists(java.util.Map<String, String> __ctx, Callback_RawFileStore_exists __cb);

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __result The asynchronous result object.
     * @return <code>true</code> if there is an accessible file
     * within the original file repository with the
     * correct ID. Otherwise <code>false</code>.
     * @throws ResourceError if there is a problem accessing the
     * file due to permissions errors within the
     * repository or any other I/O error.
     **/
    public boolean end_exists(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean exists_async(AMI_RawFileStore_exists __cb);

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean exists_async(AMI_RawFileStore_exists __cb, java.util.Map<String, String> __ctx);

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     **/
    public omero.model.OriginalFile save()
        throws omero.ServerError;

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.OriginalFile save(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_save();

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx);

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_save(Ice.Callback __cb);

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_save(Callback_RawFileStore_save __cb);

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx, Callback_RawFileStore_save __cb);

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __result The asynchronous result object.
     **/
    public omero.model.OriginalFile end_save(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __cb The callback object for the operation.
     **/
    public boolean save_async(AMI_RawFileStore_save __cb);

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean save_async(AMI_RawFileStore_save __cb, java.util.Map<String, String> __ctx);
}
