// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `RawFileStore.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Raw file gateway which provides access to the OMERO file repository.
 * 
 * Note: methods on this service are protected by a <i>DOWNLOAD</i>
 * restriction.
 **/
public final class RawFileStorePrxHelper extends Ice.ObjectPrxHelperBase implements RawFileStorePrx
{
    private static final String __exists_name = "exists";

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @return <code>true</code> if there is an accessible file
     * within the original file repository with the
     * correct ID. Otherwise <code>false</code>.
     * @throws ResourceError if there is a problem accessing the
     * file due to permissions errors within the
     * repository or any other I/O error.
     **/
    public boolean exists()
        throws omero.ServerError
    {
        return exists(null, false);
    }

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return <code>true</code> if there is an accessible file
     * within the original file repository with the
     * correct ID. Otherwise <code>false</code>.
     * @throws ResourceError if there is a problem accessing the
     * file due to permissions errors within the
     * repository or any other I/O error.
     **/
    public boolean exists(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return exists(__ctx, true);
    }

    private boolean exists(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "exists", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("exists");
                    __delBase = __getDelegate(false);
                    _RawFileStoreDel __del = (_RawFileStoreDel)__delBase;
                    return __del.exists(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_exists()
    {
        return begin_exists(null, false, null);
    }

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_exists(java.util.Map<String, String> __ctx)
    {
        return begin_exists(__ctx, true, null);
    }

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_exists(Ice.Callback __cb)
    {
        return begin_exists(null, false, __cb);
    }

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_exists(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_exists(__ctx, true, __cb);
    }

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_exists(Callback_RawFileStore_exists __cb)
    {
        return begin_exists(null, false, __cb);
    }

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_exists(java.util.Map<String, String> __ctx, Callback_RawFileStore_exists __cb)
    {
        return begin_exists(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_exists(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__exists_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __exists_name, __cb);
        try
        {
            __result.__prepare(__exists_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) <code>true</code> if there is an accessible file
     * within the original file repository with the
     * correct ID. Otherwise <code>false</code>.
     **/
    public boolean end_exists(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __exists_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean exists_async(AMI_RawFileStore_exists __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__exists_name);
            __r = begin_exists(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __exists_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean exists_async(AMI_RawFileStore_exists __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__exists_name);
            __r = begin_exists(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __exists_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getFileId_name = "getFileId";

    /**
     * Returns the current file id or null if none has been set.
     **/
    public omero.RLong getFileId()
        throws omero.ServerError
    {
        return getFileId(null, false);
    }

    /**
     * Returns the current file id or null if none has been set.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.RLong getFileId(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getFileId(__ctx, true);
    }

    private omero.RLong getFileId(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getFileId", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getFileId");
                    __delBase = __getDelegate(false);
                    _RawFileStoreDel __del = (_RawFileStoreDel)__delBase;
                    return __del.getFileId(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the current file id or null if none has been set.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getFileId()
    {
        return begin_getFileId(null, false, null);
    }

    /**
     * Returns the current file id or null if none has been set.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getFileId(java.util.Map<String, String> __ctx)
    {
        return begin_getFileId(__ctx, true, null);
    }

    /**
     * Returns the current file id or null if none has been set.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getFileId(Ice.Callback __cb)
    {
        return begin_getFileId(null, false, __cb);
    }

    /**
     * Returns the current file id or null if none has been set.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getFileId(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getFileId(__ctx, true, __cb);
    }

    /**
     * Returns the current file id or null if none has been set.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getFileId(Callback_RawFileStore_getFileId __cb)
    {
        return begin_getFileId(null, false, __cb);
    }

    /**
     * Returns the current file id or null if none has been set.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getFileId(java.util.Map<String, String> __ctx, Callback_RawFileStore_getFileId __cb)
    {
        return begin_getFileId(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getFileId(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getFileId_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getFileId_name, __cb);
        try
        {
            __result.__prepare(__getFileId_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.RLong end_getFileId(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getFileId_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.RLongHolder __ret = new omero.RLongHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the current file id or null if none has been set.
     * @param __cb The callback object for the operation.
     **/
    public boolean getFileId_async(AMI_RawFileStore_getFileId __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getFileId_name);
            __r = begin_getFileId(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getFileId_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the current file id or null if none has been set.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getFileId_async(AMI_RawFileStore_getFileId __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getFileId_name);
            __r = begin_getFileId(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getFileId_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __read_name = "read";

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     **/
    public byte[] read(long position, int length)
        throws omero.ServerError
    {
        return read(position, length, null, false);
    }

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __ctx The Context map to send with the invocation.
     **/
    public byte[] read(long position, int length, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return read(position, length, __ctx, true);
    }

    private byte[] read(long position, int length, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "read", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("read");
                    __delBase = __getDelegate(false);
                    _RawFileStoreDel __del = (_RawFileStoreDel)__delBase;
                    return __del.read(position, length, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_read(long position, int length)
    {
        return begin_read(position, length, null, false, null);
    }

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_read(long position, int length, java.util.Map<String, String> __ctx)
    {
        return begin_read(position, length, __ctx, true, null);
    }

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_read(long position, int length, Ice.Callback __cb)
    {
        return begin_read(position, length, null, false, __cb);
    }

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_read(long position, int length, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_read(position, length, __ctx, true, __cb);
    }

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_read(long position, int length, Callback_RawFileStore_read __cb)
    {
        return begin_read(position, length, null, false, __cb);
    }

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_read(long position, int length, java.util.Map<String, String> __ctx, Callback_RawFileStore_read __cb)
    {
        return begin_read(position, length, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_read(long position, int length, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__read_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __read_name, __cb);
        try
        {
            __result.__prepare(__read_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(position);
            __os.writeInt(length);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public byte[] end_read(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __read_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __cb The callback object for the operation.
     **/
    public boolean read_async(AMI_RawFileStore_read __cb, long position, int length)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__read_name);
            __r = begin_read(position, length, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __read_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean read_async(AMI_RawFileStore_read __cb, long position, int length, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__read_name);
            __r = begin_read(position, length, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __read_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __save_name = "save";

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     **/
    public omero.model.OriginalFile save()
        throws omero.ServerError
    {
        return save(null, false);
    }

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.OriginalFile save(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return save(__ctx, true);
    }

    private omero.model.OriginalFile save(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "save", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("save");
                    __delBase = __getDelegate(false);
                    _RawFileStoreDel __del = (_RawFileStoreDel)__delBase;
                    return __del.save(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_save()
    {
        return begin_save(null, false, null);
    }

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx)
    {
        return begin_save(__ctx, true, null);
    }

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_save(Ice.Callback __cb)
    {
        return begin_save(null, false, __cb);
    }

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_save(__ctx, true, __cb);
    }

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_save(Callback_RawFileStore_save __cb)
    {
        return begin_save(null, false, __cb);
    }

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx, Callback_RawFileStore_save __cb)
    {
        return begin_save(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__save_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __save_name, __cb);
        try
        {
            __result.__prepare(__save_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.model.OriginalFile end_save(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __save_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.OriginalFileHolder __ret = new omero.model.OriginalFileHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __cb The callback object for the operation.
     **/
    public boolean save_async(AMI_RawFileStore_save __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__save_name);
            __r = begin_save(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __save_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean save_async(AMI_RawFileStore_save __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__save_name);
            __r = begin_save(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __save_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setFileId_name = "setFileId";

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     **/
    public void setFileId(long fileId)
        throws omero.ServerError
    {
        setFileId(fileId, null, false);
    }

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setFileId(long fileId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setFileId(fileId, __ctx, true);
    }

    private void setFileId(long fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setFileId", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setFileId");
                    __delBase = __getDelegate(false);
                    _RawFileStoreDel __del = (_RawFileStoreDel)__delBase;
                    __del.setFileId(fileId, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId)
    {
        return begin_setFileId(fileId, null, false, null);
    }

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, java.util.Map<String, String> __ctx)
    {
        return begin_setFileId(fileId, __ctx, true, null);
    }

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, Ice.Callback __cb)
    {
        return begin_setFileId(fileId, null, false, __cb);
    }

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setFileId(fileId, __ctx, true, __cb);
    }

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, Callback_RawFileStore_setFileId __cb)
    {
        return begin_setFileId(fileId, null, false, __cb);
    }

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setFileId(long fileId, java.util.Map<String, String> __ctx, Callback_RawFileStore_setFileId __cb)
    {
        return begin_setFileId(fileId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setFileId(long fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setFileId_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setFileId_name, __cb);
        try
        {
            __result.__prepare(__setFileId_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(fileId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setFileId(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setFileId_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __cb The callback object for the operation.
     **/
    public boolean setFileId_async(AMI_RawFileStore_setFileId __cb, long fileId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setFileId_name);
            __r = begin_setFileId(fileId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setFileId_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setFileId_async(AMI_RawFileStore_setFileId __cb, long fileId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setFileId_name);
            __r = begin_setFileId(fileId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setFileId_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __size_name = "size";

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     **/
    public long size()
        throws omero.ServerError
    {
        return size(null, false);
    }

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __ctx The Context map to send with the invocation.
     **/
    public long size(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return size(__ctx, true);
    }

    private long size(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "size", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("size");
                    __delBase = __getDelegate(false);
                    _RawFileStoreDel __del = (_RawFileStoreDel)__delBase;
                    return __del.size(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_size()
    {
        return begin_size(null, false, null);
    }

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_size(java.util.Map<String, String> __ctx)
    {
        return begin_size(__ctx, true, null);
    }

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_size(Ice.Callback __cb)
    {
        return begin_size(null, false, __cb);
    }

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_size(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_size(__ctx, true, __cb);
    }

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_size(Callback_RawFileStore_size __cb)
    {
        return begin_size(null, false, __cb);
    }

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_size(java.util.Map<String, String> __ctx, Callback_RawFileStore_size __cb)
    {
        return begin_size(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_size(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__size_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __size_name, __cb);
        try
        {
            __result.__prepare(__size_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public long end_size(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __size_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __cb The callback object for the operation.
     **/
    public boolean size_async(AMI_RawFileStore_size __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__size_name);
            __r = begin_size(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __size_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean size_async(AMI_RawFileStore_size __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__size_name);
            __r = begin_size(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __size_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __truncate_name = "truncate";

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     **/
    public boolean truncate(long length)
        throws omero.ServerError
    {
        return truncate(length, null, false);
    }

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean truncate(long length, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return truncate(length, __ctx, true);
    }

    private boolean truncate(long length, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "truncate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("truncate");
                    __delBase = __getDelegate(false);
                    _RawFileStoreDel __del = (_RawFileStoreDel)__delBase;
                    return __del.truncate(length, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_truncate(long length)
    {
        return begin_truncate(length, null, false, null);
    }

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_truncate(long length, java.util.Map<String, String> __ctx)
    {
        return begin_truncate(length, __ctx, true, null);
    }

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_truncate(long length, Ice.Callback __cb)
    {
        return begin_truncate(length, null, false, __cb);
    }

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_truncate(long length, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_truncate(length, __ctx, true, __cb);
    }

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_truncate(long length, Callback_RawFileStore_truncate __cb)
    {
        return begin_truncate(length, null, false, __cb);
    }

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_truncate(long length, java.util.Map<String, String> __ctx, Callback_RawFileStore_truncate __cb)
    {
        return begin_truncate(length, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_truncate(long length, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__truncate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __truncate_name, __cb);
        try
        {
            __result.__prepare(__truncate_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(length);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_truncate(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __truncate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __cb The callback object for the operation.
     **/
    public boolean truncate_async(AMI_RawFileStore_truncate __cb, long length)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__truncate_name);
            __r = begin_truncate(length, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __truncate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean truncate_async(AMI_RawFileStore_truncate __cb, long length, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__truncate_name);
            __r = begin_truncate(length, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __truncate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __write_name = "write";

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     **/
    public void write(byte[] buf, long position, int length)
        throws omero.ServerError
    {
        write(buf, position, length, null, false);
    }

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void write(byte[] buf, long position, int length, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        write(buf, position, length, __ctx, true);
    }

    private void write(byte[] buf, long position, int length, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "write", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("write");
                    __delBase = __getDelegate(false);
                    _RawFileStoreDel __del = (_RawFileStoreDel)__delBase;
                    __del.write(buf, position, length, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_write(byte[] buf, long position, int length)
    {
        return begin_write(buf, position, length, null, false, null);
    }

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_write(byte[] buf, long position, int length, java.util.Map<String, String> __ctx)
    {
        return begin_write(buf, position, length, __ctx, true, null);
    }

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_write(byte[] buf, long position, int length, Ice.Callback __cb)
    {
        return begin_write(buf, position, length, null, false, __cb);
    }

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_write(byte[] buf, long position, int length, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_write(buf, position, length, __ctx, true, __cb);
    }

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_write(byte[] buf, long position, int length, Callback_RawFileStore_write __cb)
    {
        return begin_write(buf, position, length, null, false, __cb);
    }

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_write(byte[] buf, long position, int length, java.util.Map<String, String> __ctx, Callback_RawFileStore_write __cb)
    {
        return begin_write(buf, position, length, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_write(byte[] buf, long position, int length, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__write_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __write_name, __cb);
        try
        {
            __result.__prepare(__write_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            Ice.ByteSeqHelper.write(__os, buf);
            __os.writeLong(position);
            __os.writeInt(length);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_write(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __write_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __cb The callback object for the operation.
     **/
    public boolean write_async(AMI_RawFileStore_write __cb, byte[] buf, long position, int length)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__write_name);
            __r = begin_write(buf, position, length, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __write_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean write_async(AMI_RawFileStore_write __cb, byte[] buf, long position, int length, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__write_name);
            __r = begin_write(buf, position, length, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __write_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __activate_name = "activate";

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     **/
    public void activate()
        throws omero.ServerError
    {
        activate(null, false);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void activate(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        activate(__ctx, true);
    }

    private void activate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "activate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("activate");
                    __delBase = __getDelegate(false);
                    _RawFileStoreDel __del = (_RawFileStoreDel)__delBase;
                    __del.activate(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate()
    {
        return begin_activate(null, false, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx)
    {
        return begin_activate(__ctx, true, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate(Ice.Callback __cb)
    {
        return begin_activate(null, false, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_activate(__ctx, true, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate(Callback_StatefulServiceInterface_activate __cb)
    {
        return begin_activate(null, false, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_activate __cb)
    {
        return begin_activate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__activate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
        try
        {
            __result.__prepare(__activate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_activate(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __activate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public boolean activate_async(AMI_StatefulServiceInterface_activate __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__activate_name);
            __r = begin_activate(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean activate_async(AMI_StatefulServiceInterface_activate __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__activate_name);
            __r = begin_activate(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __close_name = "close";

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     **/
    public void close()
        throws omero.ServerError
    {
        close(null, false);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void close(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        close(__ctx, true);
    }

    private void close(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "close", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("close");
                    __delBase = __getDelegate(false);
                    _RawFileStoreDel __del = (_RawFileStoreDel)__delBase;
                    __del.close(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close()
    {
        return begin_close(null, false, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx)
    {
        return begin_close(__ctx, true, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close(Ice.Callback __cb)
    {
        return begin_close(null, false, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_close(__ctx, true, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close(Callback_StatefulServiceInterface_close __cb)
    {
        return begin_close(null, false, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_close __cb)
    {
        return begin_close(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__close_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __close_name, __cb);
        try
        {
            __result.__prepare(__close_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_close(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __close_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public boolean close_async(AMI_StatefulServiceInterface_close __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__close_name);
            __r = begin_close(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __close_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean close_async(AMI_StatefulServiceInterface_close __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__close_name);
            __r = begin_close(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __close_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getCurrentEventContext_name = "getCurrentEventContext";

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     **/
    public omero.sys.EventContext getCurrentEventContext()
        throws omero.ServerError
    {
        return getCurrentEventContext(null, false);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.sys.EventContext getCurrentEventContext(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getCurrentEventContext(__ctx, true);
    }

    private omero.sys.EventContext getCurrentEventContext(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getCurrentEventContext", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getCurrentEventContext");
                    __delBase = __getDelegate(false);
                    _RawFileStoreDel __del = (_RawFileStoreDel)__delBase;
                    return __del.getCurrentEventContext(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext()
    {
        return begin_getCurrentEventContext(null, false, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx)
    {
        return begin_getCurrentEventContext(__ctx, true, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(Ice.Callback __cb)
    {
        return begin_getCurrentEventContext(null, false, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getCurrentEventContext(__ctx, true, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(Callback_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        return begin_getCurrentEventContext(null, false, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        return begin_getCurrentEventContext(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getCurrentEventContext_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
        try
        {
            __result.__prepare(__getCurrentEventContext_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.sys.EventContext end_getCurrentEventContext(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getCurrentEventContext_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.sys.EventContextHolder __ret = new omero.sys.EventContextHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public boolean getCurrentEventContext_async(AMI_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCurrentEventContext_name);
            __r = begin_getCurrentEventContext(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getCurrentEventContext_async(AMI_StatefulServiceInterface_getCurrentEventContext __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCurrentEventContext_name);
            __r = begin_getCurrentEventContext(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __passivate_name = "passivate";

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     **/
    public void passivate()
        throws omero.ServerError
    {
        passivate(null, false);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void passivate(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        passivate(__ctx, true);
    }

    private void passivate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "passivate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("passivate");
                    __delBase = __getDelegate(false);
                    _RawFileStoreDel __del = (_RawFileStoreDel)__delBase;
                    __del.passivate(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate()
    {
        return begin_passivate(null, false, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx)
    {
        return begin_passivate(__ctx, true, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate(Ice.Callback __cb)
    {
        return begin_passivate(null, false, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_passivate(__ctx, true, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate(Callback_StatefulServiceInterface_passivate __cb)
    {
        return begin_passivate(null, false, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_passivate __cb)
    {
        return begin_passivate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__passivate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
        try
        {
            __result.__prepare(__passivate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_passivate(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __passivate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public boolean passivate_async(AMI_StatefulServiceInterface_passivate __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__passivate_name);
            __r = begin_passivate(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean passivate_async(AMI_StatefulServiceInterface_passivate __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__passivate_name);
            __r = begin_passivate(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static RawFileStorePrx checkedCast(Ice.ObjectPrx __obj)
    {
        RawFileStorePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof RawFileStorePrx)
            {
                __d = (RawFileStorePrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    RawFileStorePrxHelper __h = new RawFileStorePrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static RawFileStorePrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        RawFileStorePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof RawFileStorePrx)
            {
                __d = (RawFileStorePrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    RawFileStorePrxHelper __h = new RawFileStorePrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static RawFileStorePrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        RawFileStorePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    RawFileStorePrxHelper __h = new RawFileStorePrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static RawFileStorePrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        RawFileStorePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    RawFileStorePrxHelper __h = new RawFileStorePrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static RawFileStorePrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        RawFileStorePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof RawFileStorePrx)
            {
                __d = (RawFileStorePrx)__obj;
            }
            else
            {
                RawFileStorePrxHelper __h = new RawFileStorePrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static RawFileStorePrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        RawFileStorePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            RawFileStorePrxHelper __h = new RawFileStorePrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::RawFileStore",
        "::omero::api::ServiceInterface",
        "::omero::api::StatefulServiceInterface"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _RawFileStoreDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _RawFileStoreDelD();
    }

    public static void __write(IceInternal.BasicStream __os, RawFileStorePrx v)
    {
        __os.writeProxy(v);
    }

    public static RawFileStorePrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            RawFileStorePrxHelper result = new RawFileStorePrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
