// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `RawPixelsStore.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Binary data provider. Initialized with the ID of a
 * {@link omero.model.Pixels} instance, this service can provide
 * various slices, stacks, regions of the 5-dimensional (X-Y planes with
 * multiple Z-sections and Channels over Time). The byte array returned
 * by the getter methods and passed to the setter methods can and will
 * be interpreted according to results of {@link #getByteWidth},
 * {@link #isFloat}, and {@link #isSigned}.
 * 
 * <p>
 * <b>Read-only caveat</b>:
 * 
 * Mutating methods (set*) are only available during the first access.
 * Once the Pixels data has been successfully saved (via the save or
 * close methods on this interface), then the data should be treated
 * read-only. If Pixels data writing fails and the service is
 * inadvertently closed, delete the Pixels object, and create a new
 * one. Any partially written data will be removed.
 **/
public interface RawPixelsStorePrx extends PyramidServicePrx
{
    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param pixelsId Pixels set identifier.
     * @param bypassOriginalFile Whether or not to bypass checking
     * for an original file to back the pixel buffer used
     * by this service. If requests are predominantly
     * <code>write-only</code> or involve the population of
     * a brand new pixel buffer using <code>true</code>
     * here is a safe optimization otherwise
     * <code>false</code> is expected.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public void setPixelsId(long pixelsId, boolean bypassOriginalFile)
        throws omero.ServerError;

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param pixelsId Pixels set identifier.
     * @param bypassOriginalFile Whether or not to bypass checking
     * for an original file to back the pixel buffer used
     * by this service. If requests are predominantly
     * <code>write-only</code> or involve the population of
     * a brand new pixel buffer using <code>true</code>
     * here is a safe optimization otherwise
     * <code>false</code> is expected.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setPixelsId(long pixelsId, boolean bypassOriginalFile, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param pixelsId Pixels set identifier.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, boolean bypassOriginalFile);

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param pixelsId Pixels set identifier.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, boolean bypassOriginalFile, java.util.Map<String, String> __ctx);

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param pixelsId Pixels set identifier.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, boolean bypassOriginalFile, Ice.Callback __cb);

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param pixelsId Pixels set identifier.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, boolean bypassOriginalFile, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param pixelsId Pixels set identifier.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, boolean bypassOriginalFile, Callback_RawPixelsStore_setPixelsId __cb);

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param pixelsId Pixels set identifier.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, boolean bypassOriginalFile, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_setPixelsId __cb);

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_setPixelsId(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId Pixels set identifier.
     **/
    public boolean setPixelsId_async(AMI_RawPixelsStore_setPixelsId __cb, long pixelsId, boolean bypassOriginalFile);

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId Pixels set identifier.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setPixelsId_async(AMI_RawPixelsStore_setPixelsId __cb, long pixelsId, boolean bypassOriginalFile, java.util.Map<String, String> __ctx);

    /**
     * Returns the current Pixels set identifier.
     * @return See above.
     **/
    public long getPixelsId()
        throws omero.ServerError;

    /**
     * Returns the current Pixels set identifier.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public long getPixelsId(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the current Pixels set identifier.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPixelsId();

    /**
     * Returns the current Pixels set identifier.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPixelsId(java.util.Map<String, String> __ctx);

    /**
     * Returns the current Pixels set identifier.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPixelsId(Ice.Callback __cb);

    /**
     * Returns the current Pixels set identifier.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPixelsId(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the current Pixels set identifier.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPixelsId(Callback_RawPixelsStore_getPixelsId __cb);

    /**
     * Returns the current Pixels set identifier.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPixelsId(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getPixelsId __cb);

    /**
     * Returns the current Pixels set identifier.
     * @param __result The asynchronous result object.
     * @return See above.
     **/
    public long end_getPixelsId(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the current Pixels set identifier.
     * @param __cb The callback object for the operation.
     **/
    public boolean getPixelsId_async(AMI_RawPixelsStore_getPixelsId __cb);

    /**
     * Returns the current Pixels set identifier.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getPixelsId_async(AMI_RawPixelsStore_getPixelsId __cb, java.util.Map<String, String> __ctx);

    /**
     * Returns the current Pixels path.
     * @return See above.
     **/
    public String getPixelsPath()
        throws omero.ServerError;

    /**
     * Returns the current Pixels path.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public String getPixelsPath(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the current Pixels path.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPixelsPath();

    /**
     * Returns the current Pixels path.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPixelsPath(java.util.Map<String, String> __ctx);

    /**
     * Returns the current Pixels path.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPixelsPath(Ice.Callback __cb);

    /**
     * Returns the current Pixels path.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPixelsPath(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the current Pixels path.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPixelsPath(Callback_RawPixelsStore_getPixelsPath __cb);

    /**
     * Returns the current Pixels path.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPixelsPath(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getPixelsPath __cb);

    /**
     * Returns the current Pixels path.
     * @param __result The asynchronous result object.
     * @return See above.
     **/
    public String end_getPixelsPath(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the current Pixels path.
     * @param __cb The callback object for the operation.
     **/
    public boolean getPixelsPath_async(AMI_RawPixelsStore_getPixelsPath __cb);

    /**
     * Returns the current Pixels path.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getPixelsPath_async(AMI_RawPixelsStore_getPixelsPath __cb, java.util.Map<String, String> __ctx);

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param pixelsIds Pixels IDs to cache.
     **/
    public void prepare(java.util.List<Long> pixelsIds)
        throws omero.ServerError;

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param pixelsIds Pixels IDs to cache.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void prepare(java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param pixelsIds Pixels IDs to cache.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_prepare(java.util.List<Long> pixelsIds);

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param pixelsIds Pixels IDs to cache.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_prepare(java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx);

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param pixelsIds Pixels IDs to cache.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_prepare(java.util.List<Long> pixelsIds, Ice.Callback __cb);

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param pixelsIds Pixels IDs to cache.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_prepare(java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param pixelsIds Pixels IDs to cache.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_prepare(java.util.List<Long> pixelsIds, Callback_RawPixelsStore_prepare __cb);

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param pixelsIds Pixels IDs to cache.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_prepare(java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_prepare __cb);

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_prepare(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsIds Pixels IDs to cache.
     **/
    public boolean prepare_async(AMI_RawPixelsStore_prepare __cb, java.util.List<Long> pixelsIds);

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsIds Pixels IDs to cache.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean prepare_async(AMI_RawPixelsStore_prepare __cb, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @return 2D image plane size in bytes
     * <code>sizeX*sizeY*byteWidth</code>.
     **/
    public long getPlaneSize()
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return 2D image plane size in bytes
     * <code>sizeX*sizeY*byteWidth</code>.
     **/
    public long getPlaneSize(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlaneSize();

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlaneSize(java.util.Map<String, String> __ctx);

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlaneSize(Ice.Callback __cb);

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlaneSize(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlaneSize(Callback_RawPixelsStore_getPlaneSize __cb);

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlaneSize(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getPlaneSize __cb);

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __result The asynchronous result object.
     * @return 2D image plane size in bytes
     * <code>sizeX*sizeY*byteWidth</code>.
     **/
    public long end_getPlaneSize(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __cb The callback object for the operation.
     **/
    public boolean getPlaneSize_async(AMI_RawPixelsStore_getPlaneSize __cb);

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getPlaneSize_async(AMI_RawPixelsStore_getPlaneSize __cb, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @return row or scanline size in bytes
     * <codesizeX*byteWidth</code>
     **/
    public int getRowSize()
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return row or scanline size in bytes
     * <codesizeX*byteWidth</code>
     **/
    public int getRowSize(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRowSize();

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRowSize(java.util.Map<String, String> __ctx);

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRowSize(Ice.Callback __cb);

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRowSize(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRowSize(Callback_RawPixelsStore_getRowSize __cb);

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRowSize(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getRowSize __cb);

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __result The asynchronous result object.
     * @return row or scanline size in bytes
     * <codesizeX*byteWidth</code>
     **/
    public int end_getRowSize(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __cb The callback object for the operation.
     **/
    public boolean getRowSize_async(AMI_RawPixelsStore_getRowSize __cb);

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getRowSize_async(AMI_RawPixelsStore_getRowSize __cb, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @return stack size in bytes
     * <code>sizeX*sizeY*byteWidth</code>.
     **/
    public long getStackSize()
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return stack size in bytes
     * <code>sizeX*sizeY*byteWidth</code>.
     **/
    public long getStackSize(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStackSize();

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStackSize(java.util.Map<String, String> __ctx);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStackSize(Ice.Callback __cb);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStackSize(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStackSize(Callback_RawPixelsStore_getStackSize __cb);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStackSize(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getStackSize __cb);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __result The asynchronous result object.
     * @return stack size in bytes
     * <code>sizeX*sizeY*byteWidth</code>.
     **/
    public long end_getStackSize(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getStackSize_async(AMI_RawPixelsStore_getStackSize __cb);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getStackSize_async(AMI_RawPixelsStore_getStackSize __cb, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @return timepoint size in bytes
     * <code>sizeX*sizeY*sizeZ*sizeC*byteWidth</code>.
     **/
    public long getTimepointSize()
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return timepoint size in bytes
     * <code>sizeX*sizeY*sizeZ*sizeC*byteWidth</code>.
     **/
    public long getTimepointSize(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTimepointSize();

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTimepointSize(java.util.Map<String, String> __ctx);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTimepointSize(Ice.Callback __cb);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTimepointSize(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTimepointSize(Callback_RawPixelsStore_getTimepointSize __cb);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTimepointSize(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getTimepointSize __cb);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __result The asynchronous result object.
     * @return timepoint size in bytes
     * <code>sizeX*sizeY*sizeZ*sizeC*byteWidth</code>.
     **/
    public long end_getTimepointSize(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     **/
    public boolean getTimepointSize_async(AMI_RawPixelsStore_getTimepointSize __cb);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getTimepointSize_async(AMI_RawPixelsStore_getTimepointSize __cb, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @return total size of the pixel size in bytes
     * <code>sizeX*sizeY*sizeZ*sizeC*sizeT*byteWidth</code>.
     **/
    public long getTotalSize()
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return total size of the pixel size in bytes
     * <code>sizeX*sizeY*sizeZ*sizeC*sizeT*byteWidth</code>.
     **/
    public long getTotalSize(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTotalSize();

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTotalSize(java.util.Map<String, String> __ctx);

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTotalSize(Ice.Callback __cb);

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTotalSize(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTotalSize(Callback_RawPixelsStore_getTotalSize __cb);

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTotalSize(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getTotalSize __cb);

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __result The asynchronous result object.
     * @return total size of the pixel size in bytes
     * <code>sizeX*sizeY*sizeZ*sizeC*sizeT*byteWidth</code>.
     **/
    public long end_getTotalSize(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __cb The callback object for the operation.
     **/
    public boolean getTotalSize_async(AMI_RawPixelsStore_getTotalSize __cb);

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getTotalSize_async(AMI_RawPixelsStore_getTotalSize __cb, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @return offset of the row or scanline.
     **/
    public long getRowOffset(int y, int z, int c, int t)
        throws omero.ServerError;

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @return offset of the row or scanline.
     **/
    public long getRowOffset(int y, int z, int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRowOffset(int y, int z, int c, int t);

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRowOffset(int y, int z, int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRowOffset(int y, int z, int c, int t, Ice.Callback __cb);

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRowOffset(int y, int z, int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRowOffset(int y, int z, int c, int t, Callback_RawPixelsStore_getRowOffset __cb);

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRowOffset(int y, int z, int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getRowOffset __cb);

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param __result The asynchronous result object.
     * @return offset of the row or scanline.
     **/
    public long end_getRowOffset(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     **/
    public boolean getRowOffset_async(AMI_RawPixelsStore_getRowOffset __cb, int y, int z, int c, int t);

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getRowOffset_async(AMI_RawPixelsStore_getRowOffset __cb, int y, int z, int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @return offset of the 2D image plane.
     **/
    public long getPlaneOffset(int z, int c, int t)
        throws omero.ServerError;

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @return offset of the 2D image plane.
     **/
    public long getPlaneOffset(int z, int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlaneOffset(int z, int c, int t);

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlaneOffset(int z, int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlaneOffset(int z, int c, int t, Ice.Callback __cb);

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlaneOffset(int z, int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlaneOffset(int z, int c, int t, Callback_RawPixelsStore_getPlaneOffset __cb);

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlaneOffset(int z, int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getPlaneOffset __cb);

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param __result The asynchronous result object.
     * @return offset of the 2D image plane.
     **/
    public long end_getPlaneOffset(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     **/
    public boolean getPlaneOffset_async(AMI_RawPixelsStore_getPlaneOffset __cb, int z, int c, int t);

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getPlaneOffset_async(AMI_RawPixelsStore_getPlaneOffset __cb, int z, int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @return offset of the stack.
     **/
    public long getStackOffset(int c, int t)
        throws omero.ServerError;

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @return offset of the stack.
     **/
    public long getStackOffset(int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param c offset across the C-axis of the pixel buffer.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStackOffset(int c, int t);

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param c offset across the C-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStackOffset(int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param c offset across the C-axis of the pixel buffer.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStackOffset(int c, int t, Ice.Callback __cb);

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param c offset across the C-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStackOffset(int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param c offset across the C-axis of the pixel buffer.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStackOffset(int c, int t, Callback_RawPixelsStore_getStackOffset __cb);

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param c offset across the C-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStackOffset(int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getStackOffset __cb);

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param __result The asynchronous result object.
     * @return offset of the stack.
     **/
    public long end_getStackOffset(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel buffer.
     **/
    public boolean getStackOffset_async(AMI_RawPixelsStore_getStackOffset __cb, int c, int t);

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getStackOffset_async(AMI_RawPixelsStore_getStackOffset __cb, int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param t offset across the T-axis of the pixel buffer.
     * @return offset of the timepoint.
     **/
    public long getTimepointOffset(int t)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @return offset of the timepoint.
     **/
    public long getTimepointOffset(int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param t offset across the T-axis of the pixel buffer.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTimepointOffset(int t);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTimepointOffset(int t, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param t offset across the T-axis of the pixel buffer.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTimepointOffset(int t, Ice.Callback __cb);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTimepointOffset(int t, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param t offset across the T-axis of the pixel buffer.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTimepointOffset(int t, Callback_RawPixelsStore_getTimepointOffset __cb);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTimepointOffset(int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getTimepointOffset __cb);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param __result The asynchronous result object.
     * @return offset of the timepoint.
     **/
    public long end_getTimepointOffset(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel buffer.
     **/
    public boolean getTimepointOffset_async(AMI_RawPixelsStore_getTimepointOffset __cb, int t);

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getTimepointOffset_async(AMI_RawPixelsStore_getTimepointOffset __cb, int t, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a tile from this pixel buffer.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param y Top left corner of the tile, Y offset.
     * @param w Width of the tile.
     * @param h Height of the tile.
     * @return buffer containing the data.
     **/
    public byte[] getTile(int z, int c, int t, int x, int y, int w, int h)
        throws omero.ServerError;

    /**
     * Retrieves a tile from this pixel buffer.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param y Top left corner of the tile, Y offset.
     * @param w Width of the tile.
     * @param h Height of the tile.
     * @param __ctx The Context map to send with the invocation.
     * @return buffer containing the data.
     **/
    public byte[] getTile(int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves a tile from this pixel buffer.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param y Top left corner of the tile, Y offset.
     * @param h Height of the tile.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTile(int z, int c, int t, int x, int y, int w, int h);

    /**
     * Retrieves a tile from this pixel buffer.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param y Top left corner of the tile, Y offset.
     * @param h Height of the tile.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTile(int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a tile from this pixel buffer.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param y Top left corner of the tile, Y offset.
     * @param h Height of the tile.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTile(int z, int c, int t, int x, int y, int w, int h, Ice.Callback __cb);

    /**
     * Retrieves a tile from this pixel buffer.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param y Top left corner of the tile, Y offset.
     * @param h Height of the tile.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTile(int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves a tile from this pixel buffer.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param y Top left corner of the tile, Y offset.
     * @param h Height of the tile.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTile(int z, int c, int t, int x, int y, int w, int h, Callback_RawPixelsStore_getTile __cb);

    /**
     * Retrieves a tile from this pixel buffer.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param y Top left corner of the tile, Y offset.
     * @param h Height of the tile.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTile(int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getTile __cb);

    /**
     * Retrieves a tile from this pixel buffer.
     * @param __result The asynchronous result object.
     * @return buffer containing the data.
     **/
    public byte[] end_getTile(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves a tile from this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param y Top left corner of the tile, Y offset.
     * @param h Height of the tile.
     **/
    public boolean getTile_async(AMI_RawPixelsStore_getTile __cb, int z, int c, int t, int x, int y, int w, int h);

    /**
     * Retrieves a tile from this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param y Top left corner of the tile, Y offset.
     * @param h Height of the tile.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getTile_async(AMI_RawPixelsStore_getTile __cb, int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param start offset for each dimension within pixel store.
     * @param size of each dimension (dependent on dimension).
     * @param step needed of each dimension (dependent on
     * dimension).
     * @return buffer containing the data.
     **/
    public byte[] getHypercube(java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step)
        throws omero.ServerError;

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param start offset for each dimension within pixel store.
     * @param size of each dimension (dependent on dimension).
     * @param step needed of each dimension (dependent on
     * dimension).
     * @param __ctx The Context map to send with the invocation.
     * @return buffer containing the data.
     **/
    public byte[] getHypercube(java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param size of each dimension (dependent on dimension).
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getHypercube(java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step);

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param size of each dimension (dependent on dimension).
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getHypercube(java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param size of each dimension (dependent on dimension).
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getHypercube(java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step, Ice.Callback __cb);

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param size of each dimension (dependent on dimension).
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getHypercube(java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param size of each dimension (dependent on dimension).
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getHypercube(java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step, Callback_RawPixelsStore_getHypercube __cb);

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param size of each dimension (dependent on dimension).
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getHypercube(java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getHypercube __cb);

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param __result The asynchronous result object.
     * @return buffer containing the data.
     **/
    public byte[] end_getHypercube(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size of each dimension (dependent on dimension).
     **/
    public boolean getHypercube_async(AMI_RawPixelsStore_getHypercube __cb, java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step);

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size of each dimension (dependent on dimension).
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getHypercube_async(AMI_RawPixelsStore_getHypercube __cb, java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a region from this pixel store.
     * @param size byte width of the region to retrieve.
     * @param offset offset within the pixel store.
     * @return buffer containing the data.
     **/
    public byte[] getRegion(int size, long offset)
        throws omero.ServerError;

    /**
     * Retrieves a region from this pixel store.
     * @param size byte width of the region to retrieve.
     * @param offset offset within the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return buffer containing the data.
     **/
    public byte[] getRegion(int size, long offset, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves a region from this pixel store.
     * @param size byte width of the region to retrieve.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRegion(int size, long offset);

    /**
     * Retrieves a region from this pixel store.
     * @param size byte width of the region to retrieve.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRegion(int size, long offset, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a region from this pixel store.
     * @param size byte width of the region to retrieve.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRegion(int size, long offset, Ice.Callback __cb);

    /**
     * Retrieves a region from this pixel store.
     * @param size byte width of the region to retrieve.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRegion(int size, long offset, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves a region from this pixel store.
     * @param size byte width of the region to retrieve.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRegion(int size, long offset, Callback_RawPixelsStore_getRegion __cb);

    /**
     * Retrieves a region from this pixel store.
     * @param size byte width of the region to retrieve.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRegion(int size, long offset, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getRegion __cb);

    /**
     * Retrieves a region from this pixel store.
     * @param __result The asynchronous result object.
     * @return buffer containing the data.
     **/
    public byte[] end_getRegion(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves a region from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to retrieve.
     **/
    public boolean getRegion_async(AMI_RawPixelsStore_getRegion __cb, int size, long offset);

    /**
     * Retrieves a region from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to retrieve.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getRegion_async(AMI_RawPixelsStore_getRegion __cb, int size, long offset, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param y offset across the Y-axis of the pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @return buffer containing the data which comprises this row
     * or scanline.
     **/
    public byte[] getRow(int y, int z, int c, int t)
        throws omero.ServerError;

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param y offset across the Y-axis of the pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return buffer containing the data which comprises this row
     * or scanline.
     **/
    public byte[] getRow(int y, int z, int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param y offset across the Y-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRow(int y, int z, int c, int t);

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param y offset across the Y-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRow(int y, int z, int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param y offset across the Y-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRow(int y, int z, int c, int t, Ice.Callback __cb);

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param y offset across the Y-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRow(int y, int z, int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param y offset across the Y-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRow(int y, int z, int c, int t, Callback_RawPixelsStore_getRow __cb);

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param y offset across the Y-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRow(int y, int z, int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getRow __cb);

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param __result The asynchronous result object.
     * @return buffer containing the data which comprises this row
     * or scanline.
     **/
    public byte[] end_getRow(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     **/
    public boolean getRow_async(AMI_RawPixelsStore_getRow __cb, int y, int z, int c, int t);

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getRow_async(AMI_RawPixelsStore_getRow __cb, int y, int z, int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a particular column from this pixel store.
     * @param x offset across the X-axis of the pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @return buffer containing the data which comprises this column.
     **/
    public byte[] getCol(int x, int z, int c, int t)
        throws omero.ServerError;

    /**
     * Retrieves a particular column from this pixel store.
     * @param x offset across the X-axis of the pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return buffer containing the data which comprises this column.
     **/
    public byte[] getCol(int x, int z, int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves a particular column from this pixel store.
     * @param x offset across the X-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getCol(int x, int z, int c, int t);

    /**
     * Retrieves a particular column from this pixel store.
     * @param x offset across the X-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getCol(int x, int z, int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a particular column from this pixel store.
     * @param x offset across the X-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getCol(int x, int z, int c, int t, Ice.Callback __cb);

    /**
     * Retrieves a particular column from this pixel store.
     * @param x offset across the X-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getCol(int x, int z, int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves a particular column from this pixel store.
     * @param x offset across the X-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getCol(int x, int z, int c, int t, Callback_RawPixelsStore_getCol __cb);

    /**
     * Retrieves a particular column from this pixel store.
     * @param x offset across the X-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getCol(int x, int z, int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getCol __cb);

    /**
     * Retrieves a particular column from this pixel store.
     * @param __result The asynchronous result object.
     * @return buffer containing the data which comprises this column.
     **/
    public byte[] end_getCol(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves a particular column from this pixel store.
     * @param __cb The callback object for the operation.
     * @param x offset across the X-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     **/
    public boolean getCol_async(AMI_RawPixelsStore_getCol __cb, int x, int z, int c, int t);

    /**
     * Retrieves a particular column from this pixel store.
     * @param __cb The callback object for the operation.
     * @param x offset across the X-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getCol_async(AMI_RawPixelsStore_getCol __cb, int x, int z, int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @return buffer containing the data which comprises this 2D image plane.
     **/
    public byte[] getPlane(int z, int c, int t)
        throws omero.ServerError;

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return buffer containing the data which comprises this 2D image plane.
     **/
    public byte[] getPlane(int z, int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlane(int z, int c, int t);

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlane(int z, int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlane(int z, int c, int t, Ice.Callback __cb);

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlane(int z, int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlane(int z, int c, int t, Callback_RawPixelsStore_getPlane __cb);

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlane(int z, int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getPlane __cb);

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param __result The asynchronous result object.
     * @return buffer containing the data which comprises this 2D image plane.
     **/
    public byte[] end_getPlane(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     **/
    public boolean getPlane_async(AMI_RawPixelsStore_getPlane __cb, int z, int c, int t);

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getPlane_async(AMI_RawPixelsStore_getPlane __cb, int z, int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param count the number of pixels to retrieve.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     * @return buffer containing the data which comprises the region of the
     * given 2D image plane. It is guaranteed that this buffer will have been
     * byte swapped.
     **/
    public byte[] getPlaneRegion(int z, int c, int t, int size, int offset)
        throws omero.ServerError;

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param count the number of pixels to retrieve.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     * @param __ctx The Context map to send with the invocation.
     * @return buffer containing the data which comprises the region of the
     * given 2D image plane. It is guaranteed that this buffer will have been
     * byte swapped.
     **/
    public byte[] getPlaneRegion(int z, int c, int t, int size, int offset, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlaneRegion(int z, int c, int t, int size, int offset);

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlaneRegion(int z, int c, int t, int size, int offset, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlaneRegion(int z, int c, int t, int size, int offset, Ice.Callback __cb);

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlaneRegion(int z, int c, int t, int size, int offset, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlaneRegion(int z, int c, int t, int size, int offset, Callback_RawPixelsStore_getPlaneRegion __cb);

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getPlaneRegion(int z, int c, int t, int size, int offset, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getPlaneRegion __cb);

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param __result The asynchronous result object.
     * @return buffer containing the data which comprises the region of the
     * given 2D image plane. It is guaranteed that this buffer will have been
     * byte swapped.
     **/
    public byte[] end_getPlaneRegion(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     **/
    public boolean getPlaneRegion_async(AMI_RawPixelsStore_getPlaneRegion __cb, int z, int c, int t, int size, int offset);

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getPlaneRegion_async(AMI_RawPixelsStore_getPlaneRegion __cb, int z, int c, int t, int size, int offset, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @return buffer containing the data which comprises this stack.
     **/
    public byte[] getStack(int c, int t)
        throws omero.ServerError;

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return buffer containing the data which comprises this stack.
     **/
    public byte[] getStack(int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStack(int c, int t);

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStack(int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStack(int c, int t, Ice.Callback __cb);

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStack(int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStack(int c, int t, Callback_RawPixelsStore_getStack __cb);

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStack(int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getStack __cb);

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __result The asynchronous result object.
     * @return buffer containing the data which comprises this stack.
     **/
    public byte[] end_getStack(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel store.
     **/
    public boolean getStack_async(AMI_RawPixelsStore_getStack __cb, int c, int t);

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getStack_async(AMI_RawPixelsStore_getStack __cb, int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param t offset across the T-axis of the pixel store.
     **/
    public byte[] getTimepoint(int t)
        throws omero.ServerError;

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public byte[] getTimepoint(int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTimepoint(int t);

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTimepoint(int t, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTimepoint(int t, Ice.Callback __cb);

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTimepoint(int t, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTimepoint(int t, Callback_RawPixelsStore_getTimepoint __cb);

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getTimepoint(int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getTimepoint __cb);

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __result The asynchronous result object.
     **/
    public byte[] end_getTimepoint(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel store.
     **/
    public boolean getTimepoint_async(AMI_RawPixelsStore_getTimepoint __cb, int t);

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getTimepoint_async(AMI_RawPixelsStore_getTimepoint __cb, int t, java.util.Map<String, String> __ctx);

    /**
     * Sets a tile in this pixel buffer.
     * @param buf A byte array of the data.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param y Top left corner of the tile, Y offset.
     * @param w Width of the tile.
     * @param h Height of the tile.
     * @throws IOException if there is a problem writing to the pixel buffer.
     * @throws BufferOverflowException if an attempt is made to write off the
     * end of the file.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public void setTile(byte[] buf, int z, int c, int t, int x, int y, int w, int h)
        throws omero.ServerError;

    /**
     * Sets a tile in this pixel buffer.
     * @param buf A byte array of the data.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param y Top left corner of the tile, Y offset.
     * @param w Width of the tile.
     * @param h Height of the tile.
     * @throws IOException if there is a problem writing to the pixel buffer.
     * @throws BufferOverflowException if an attempt is made to write off the
     * end of the file.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setTile(byte[] buf, int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Sets a tile in this pixel buffer.
     * @param buf A byte array of the data.
     * @param c offset across the C-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param w Width of the tile.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setTile(byte[] buf, int z, int c, int t, int x, int y, int w, int h);

    /**
     * Sets a tile in this pixel buffer.
     * @param buf A byte array of the data.
     * @param c offset across the C-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param w Width of the tile.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setTile(byte[] buf, int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx);

    /**
     * Sets a tile in this pixel buffer.
     * @param buf A byte array of the data.
     * @param c offset across the C-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param w Width of the tile.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setTile(byte[] buf, int z, int c, int t, int x, int y, int w, int h, Ice.Callback __cb);

    /**
     * Sets a tile in this pixel buffer.
     * @param buf A byte array of the data.
     * @param c offset across the C-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param w Width of the tile.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setTile(byte[] buf, int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Sets a tile in this pixel buffer.
     * @param buf A byte array of the data.
     * @param c offset across the C-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param w Width of the tile.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setTile(byte[] buf, int z, int c, int t, int x, int y, int w, int h, Callback_RawPixelsStore_setTile __cb);

    /**
     * Sets a tile in this pixel buffer.
     * @param buf A byte array of the data.
     * @param c offset across the C-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param w Width of the tile.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setTile(byte[] buf, int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_setTile __cb);

    /**
     * Sets a tile in this pixel buffer.
     * @param __result The asynchronous result object.
     * @throws IOException if there is a problem writing to the pixel buffer.
     * @throws BufferOverflowException if an attempt is made to write off the
     * end of the file.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public void end_setTile(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Sets a tile in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param buf A byte array of the data.
     * @param c offset across the C-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param w Width of the tile.
     **/
    public boolean setTile_async(AMI_RawPixelsStore_setTile __cb, byte[] buf, int z, int c, int t, int x, int y, int w, int h);

    /**
     * Sets a tile in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param buf A byte array of the data.
     * @param c offset across the C-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param w Width of the tile.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setTile_async(AMI_RawPixelsStore_setTile __cb, byte[] buf, int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx);

    /**
     * Sets a region in this pixel buffer.
     * @param size byte width of the region to set.
     * @param offset offset within the pixel buffer.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public void setRegion(int size, long offset, byte[] buf)
        throws omero.ServerError;

    /**
     * Sets a region in this pixel buffer.
     * @param size byte width of the region to set.
     * @param offset offset within the pixel buffer.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setRegion(int size, long offset, byte[] buf, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Sets a region in this pixel buffer.
     * @param size byte width of the region to set.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setRegion(int size, long offset, byte[] buf);

    /**
     * Sets a region in this pixel buffer.
     * @param size byte width of the region to set.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setRegion(int size, long offset, byte[] buf, java.util.Map<String, String> __ctx);

    /**
     * Sets a region in this pixel buffer.
     * @param size byte width of the region to set.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setRegion(int size, long offset, byte[] buf, Ice.Callback __cb);

    /**
     * Sets a region in this pixel buffer.
     * @param size byte width of the region to set.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setRegion(int size, long offset, byte[] buf, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Sets a region in this pixel buffer.
     * @param size byte width of the region to set.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setRegion(int size, long offset, byte[] buf, Callback_RawPixelsStore_setRegion __cb);

    /**
     * Sets a region in this pixel buffer.
     * @param size byte width of the region to set.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setRegion(int size, long offset, byte[] buf, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_setRegion __cb);

    /**
     * Sets a region in this pixel buffer.
     * @param __result The asynchronous result object.
     **/
    public void end_setRegion(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Sets a region in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to set.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public boolean setRegion_async(AMI_RawPixelsStore_setRegion __cb, int size, long offset, byte[] buf);

    /**
     * Sets a region in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to set.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setRegion_async(AMI_RawPixelsStore_setRegion __cb, int size, long offset, byte[] buf, java.util.Map<String, String> __ctx);

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param y offset across the Y-axis of the pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public void setRow(byte[] buf, int y, int z, int c, int t)
        throws omero.ServerError;

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param y offset across the Y-axis of the pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setRow(byte[] buf, int y, int z, int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setRow(byte[] buf, int y, int z, int c, int t);

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setRow(byte[] buf, int y, int z, int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setRow(byte[] buf, int y, int z, int c, int t, Ice.Callback __cb);

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setRow(byte[] buf, int y, int z, int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setRow(byte[] buf, int y, int z, int c, int t, Callback_RawPixelsStore_setRow __cb);

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setRow(byte[] buf, int y, int z, int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_setRow __cb);

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param __result The asynchronous result object.
     **/
    public void end_setRow(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public boolean setRow_async(AMI_RawPixelsStore_setRow __cb, byte[] buf, int y, int z, int c, int t);

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setRow_async(AMI_RawPixelsStore_setRow __cb, byte[] buf, int y, int z, int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public void setPlane(byte[] buf, int z, int c, int t)
        throws omero.ServerError;

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setPlane(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param c offset across the C-axis of the pixel store.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setPlane(byte[] buf, int z, int c, int t);

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setPlane(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param c offset across the C-axis of the pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setPlane(byte[] buf, int z, int c, int t, Ice.Callback __cb);

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setPlane(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param c offset across the C-axis of the pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setPlane(byte[] buf, int z, int c, int t, Callback_RawPixelsStore_setPlane __cb);

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setPlane(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_setPlane __cb);

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param __result The asynchronous result object.
     **/
    public void end_setPlane(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param c offset across the C-axis of the pixel store.
     **/
    public boolean setPlane_async(AMI_RawPixelsStore_setPlane __cb, byte[] buf, int z, int c, int t);

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setPlane_async(AMI_RawPixelsStore_setPlane __cb, byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this stack.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public void setStack(byte[] buf, int z, int c, int t)
        throws omero.ServerError;

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this stack.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setStack(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this stack.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStack(byte[] buf, int z, int c, int t);

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this stack.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStack(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this stack.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStack(byte[] buf, int z, int c, int t, Ice.Callback __cb);

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this stack.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStack(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this stack.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStack(byte[] buf, int z, int c, int t, Callback_RawPixelsStore_setStack __cb);

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this stack.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setStack(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_setStack __cb);

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __result The asynchronous result object.
     **/
    public void end_setStack(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this stack.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public boolean setStack_async(AMI_RawPixelsStore_setStack __cb, byte[] buf, int z, int c, int t);

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this stack.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setStack_async(AMI_RawPixelsStore_setStack __cb, byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx);

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this timepoint.
     * @param t offset across the T-axis of the pixel buffer.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public void setTimepoint(byte[] buf, int t)
        throws omero.ServerError;

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this timepoint.
     * @param t offset across the T-axis of the pixel buffer.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setTimepoint(byte[] buf, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this timepoint.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setTimepoint(byte[] buf, int t);

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this timepoint.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setTimepoint(byte[] buf, int t, java.util.Map<String, String> __ctx);

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this timepoint.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setTimepoint(byte[] buf, int t, Ice.Callback __cb);

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this timepoint.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setTimepoint(byte[] buf, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this timepoint.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setTimepoint(byte[] buf, int t, Callback_RawPixelsStore_setTimepoint __cb);

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this timepoint.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setTimepoint(byte[] buf, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_setTimepoint __cb);

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __result The asynchronous result object.
     **/
    public void end_setTimepoint(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this timepoint.
     **/
    public boolean setTimepoint_async(AMI_RawPixelsStore_setTimepoint __cb, byte[] buf, int t);

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this timepoint.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setTimepoint_async(AMI_RawPixelsStore_setTimepoint __cb, byte[] buf, int t, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param channels the channels to generate the histogram data for
     * @param binCount the number of the histogram bins (optional, default: 256)
     * @param plane the plane (optional, default: whole region of first z/t plane)
     * @param globalRange use the global minimum/maximum to determine the histogram range, otherwise use plane minimum/maximum value
     * @return See above.
     **/
    public java.util.Map<java.lang.Integer, int[]> getHistogram(int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane)
        throws omero.ServerError;

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param channels the channels to generate the histogram data for
     * @param binCount the number of the histogram bins (optional, default: 256)
     * @param plane the plane (optional, default: whole region of first z/t plane)
     * @param globalRange use the global minimum/maximum to determine the histogram range, otherwise use plane minimum/maximum value
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public java.util.Map<java.lang.Integer, int[]> getHistogram(int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param channels the channels to generate the histogram data for
     * @param plane the plane (optional, default: whole region of first z/t plane)
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getHistogram(int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane);

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param channels the channels to generate the histogram data for
     * @param plane the plane (optional, default: whole region of first z/t plane)
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getHistogram(int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param channels the channels to generate the histogram data for
     * @param plane the plane (optional, default: whole region of first z/t plane)
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getHistogram(int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane, Ice.Callback __cb);

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param channels the channels to generate the histogram data for
     * @param plane the plane (optional, default: whole region of first z/t plane)
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getHistogram(int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param channels the channels to generate the histogram data for
     * @param plane the plane (optional, default: whole region of first z/t plane)
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getHistogram(int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane, Callback_RawPixelsStore_getHistogram __cb);

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param channels the channels to generate the histogram data for
     * @param plane the plane (optional, default: whole region of first z/t plane)
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getHistogram(int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getHistogram __cb);

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param __result The asynchronous result object.
     * @return See above.
     **/
    public java.util.Map<java.lang.Integer, int[]> end_getHistogram(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param __cb The callback object for the operation.
     * @param channels the channels to generate the histogram data for
     * @param plane the plane (optional, default: whole region of first z/t plane)
     **/
    public boolean getHistogram_async(AMI_RawPixelsStore_getHistogram __cb, int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane);

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param __cb The callback object for the operation.
     * @param channels the channels to generate the histogram data for
     * @param plane the plane (optional, default: whole region of first z/t plane)
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getHistogram_async(AMI_RawPixelsStore_getHistogram __cb, int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane, java.util.Map<String, String> __ctx);

    /**
     * Returns the byte width for the pixel store.
     * @return See above.
     **/
    public int getByteWidth()
        throws omero.ServerError;

    /**
     * Returns the byte width for the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public int getByteWidth(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the byte width for the pixel store.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getByteWidth();

    /**
     * Returns the byte width for the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getByteWidth(java.util.Map<String, String> __ctx);

    /**
     * Returns the byte width for the pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getByteWidth(Ice.Callback __cb);

    /**
     * Returns the byte width for the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getByteWidth(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the byte width for the pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getByteWidth(Callback_RawPixelsStore_getByteWidth __cb);

    /**
     * Returns the byte width for the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getByteWidth(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getByteWidth __cb);

    /**
     * Returns the byte width for the pixel store.
     * @param __result The asynchronous result object.
     * @return See above.
     **/
    public int end_getByteWidth(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the byte width for the pixel store.
     * @param __cb The callback object for the operation.
     **/
    public boolean getByteWidth_async(AMI_RawPixelsStore_getByteWidth __cb);

    /**
     * Returns the byte width for the pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getByteWidth_async(AMI_RawPixelsStore_getByteWidth __cb, java.util.Map<String, String> __ctx);

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @return See above.
     **/
    public boolean isSigned()
        throws omero.ServerError;

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public boolean isSigned(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isSigned();

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isSigned(java.util.Map<String, String> __ctx);

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isSigned(Ice.Callback __cb);

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isSigned(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isSigned(Callback_RawPixelsStore_isSigned __cb);

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isSigned(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_isSigned __cb);

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __result The asynchronous result object.
     * @return See above.
     **/
    public boolean end_isSigned(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __cb The callback object for the operation.
     **/
    public boolean isSigned_async(AMI_RawPixelsStore_isSigned __cb);

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isSigned_async(AMI_RawPixelsStore_isSigned __cb, java.util.Map<String, String> __ctx);

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @return
     **/
    public boolean isFloat()
        throws omero.ServerError;

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __ctx The Context map to send with the invocation.
     * @return
     **/
    public boolean isFloat(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isFloat();

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isFloat(java.util.Map<String, String> __ctx);

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isFloat(Ice.Callback __cb);

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isFloat(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isFloat(Callback_RawPixelsStore_isFloat __cb);

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isFloat(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_isFloat __cb);

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __result The asynchronous result object.
     * @return
     **/
    public boolean end_isFloat(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __cb The callback object for the operation.
     **/
    public boolean isFloat_async(AMI_RawPixelsStore_isFloat __cb);

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isFloat_async(AMI_RawPixelsStore_isFloat __cb, java.util.Map<String, String> __ctx);

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @return byte array containing the message digest.
     **/
    public byte[] calculateMessageDigest()
        throws omero.ServerError;

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return byte array containing the message digest.
     **/
    public byte[] calculateMessageDigest(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_calculateMessageDigest();

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_calculateMessageDigest(java.util.Map<String, String> __ctx);

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_calculateMessageDigest(Ice.Callback __cb);

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_calculateMessageDigest(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_calculateMessageDigest(Callback_RawPixelsStore_calculateMessageDigest __cb);

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_calculateMessageDigest(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_calculateMessageDigest __cb);

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __result The asynchronous result object.
     * @return byte array containing the message digest.
     **/
    public byte[] end_calculateMessageDigest(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __cb The callback object for the operation.
     **/
    public boolean calculateMessageDigest_async(AMI_RawPixelsStore_calculateMessageDigest __cb);

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean calculateMessageDigest_async(AMI_RawPixelsStore_calculateMessageDigest __cb, java.util.Map<String, String> __ctx);

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     **/
    public omero.model.Pixels save()
        throws omero.ServerError;

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.Pixels save(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_save();

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx);

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_save(Ice.Callback __cb);

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_save(Callback_RawPixelsStore_save __cb);

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_save __cb);

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __result The asynchronous result object.
     **/
    public omero.model.Pixels end_save(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean save_async(AMI_RawPixelsStore_save __cb);

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean save_async(AMI_RawPixelsStore_save __cb, java.util.Map<String, String> __ctx);
}
