// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `RenderingEngine.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Defines a service to render a given pixels set.
 * 
 * A pixels set is a <i>5D</i> array that stores the pixels data of an
 * image, that is the pixels intensity values. Every instance of this
 * service is paired up to a pixels set. Use this service to transform
 * planes within the pixels set onto an <i>RGB</i> image.
 * 
 * The RenderingEngine allows to fine-tune the settings that
 * define the transformation context &#151; that is, a specification
 * of how raw pixels data is to be transformed into an image that can
 * be displayed on screen. Those settings are referred to as rendering
 * settings or display options. After tuning those settings it is
 * possible to save them to the metadata repository so that they can
 * be used the next time the pixels set is accessed for rendering; for
 * example by another RenderingEngine instance. Note that the display
 * options are specific to the given pixels set and are experimenter
 * scoped &#151; that is, two different users can specify different
 * display options for the <i>same</i> pixels set. (A RenderingEngine
 * instance takes this into account automatically as it is always
 * bound to a given experimenter.)
 * 
 * This service is <b>thread-safe</b>.
 **/
public interface RenderingEngine extends Ice.Object,
                                         _RenderingEngineOperations, _RenderingEngineOperationsNC,
                                         PyramidService
{
    public static final long serialVersionUID = 3617224330328304062L;
}
