// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `API.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Starting point for all OMERO.blitz interaction.
 * 
 * <p> A ServiceFactory once acquired can be used to create any number
 * of service proxies to the server. Most services implement
 * {@link ServiceInterface} or its subinterface
 * {@link StatefulServiceInterface}. </p>
 **/
public interface ServiceFactoryPrx extends omero.cmd.SessionPrx
{
    /**
     * Provides a list of all valid security contexts for this session.
     * Each of the returned {@link omero.model.IObject} instances can
     * be passed to {@link #setSecurityContext}.
     **/
    public java.util.List<omero.model.IObject> getSecurityContexts()
        throws omero.ServerError;

    /**
     * Provides a list of all valid security contexts for this session.
     * Each of the returned {@link omero.model.IObject} instances can
     * be passed to {@link #setSecurityContext}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.IObject> getSecurityContexts(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Provides a list of all valid security contexts for this session.
     * Each of the returned {@link omero.model.IObject} instances can
     * be passed to {@link #setSecurityContext}.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSecurityContexts();

    /**
     * Provides a list of all valid security contexts for this session.
     * Each of the returned {@link omero.model.IObject} instances can
     * be passed to {@link #setSecurityContext}.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSecurityContexts(java.util.Map<String, String> __ctx);

    /**
     * Provides a list of all valid security contexts for this session.
     * Each of the returned {@link omero.model.IObject} instances can
     * be passed to {@link #setSecurityContext}.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSecurityContexts(Ice.Callback __cb);

    /**
     * Provides a list of all valid security contexts for this session.
     * Each of the returned {@link omero.model.IObject} instances can
     * be passed to {@link #setSecurityContext}.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSecurityContexts(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Provides a list of all valid security contexts for this session.
     * Each of the returned {@link omero.model.IObject} instances can
     * be passed to {@link #setSecurityContext}.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSecurityContexts(Callback_ServiceFactory_getSecurityContexts __cb);

    /**
     * Provides a list of all valid security contexts for this session.
     * Each of the returned {@link omero.model.IObject} instances can
     * be passed to {@link #setSecurityContext}.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSecurityContexts(java.util.Map<String, String> __ctx, Callback_ServiceFactory_getSecurityContexts __cb);

    /**
     * Provides a list of all valid security contexts for this session.
     * Each of the returned {@link omero.model.IObject} instances can
     * be passed to {@link #setSecurityContext}.
     * @param __result The asynchronous result object.
     **/
    public java.util.List<omero.model.IObject> end_getSecurityContexts(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Changes the security context for the current session.
     * 
     * <p> A security context limits the set of objects which will
     * be returned by all queries and restricts what updates
     * can be made. </p>
     * 
     * <p> Current valid values for security context:
     * <ul>
     * <li>{@link omero.model.ExperimenterGroup} - logs into a
     * specific group</li>
     * <li>{@link omero.model.Share} - uses IShare to activate a
     * share</li>
     * </ul> </p>
     * 
     * <p> Passing an unloaded version of either object type will change
     * the way the current session operates. Note: only objects which
     * are returned by the {@link #getSecurityContexts} method are
     * considered valid. Any other instance will cause an exception to
     * be thrown. </p>
     * 
     * <h4>Example usage in Python:<h4>
     * <pre>
     * sf = client.createSession()
     * objs = sf.getSecurityContexts()
     * old = sf.setSecurityContext(objs\[-1])
     * </pre>
     * 
     **/
    public omero.model.IObject setSecurityContext(omero.model.IObject obj)
        throws omero.ServerError;

    /**
     * Changes the security context for the current session.
     * 
     * <p> A security context limits the set of objects which will
     * be returned by all queries and restricts what updates
     * can be made. </p>
     * 
     * <p> Current valid values for security context:
     * <ul>
     * <li>{@link omero.model.ExperimenterGroup} - logs into a
     * specific group</li>
     * <li>{@link omero.model.Share} - uses IShare to activate a
     * share</li>
     * </ul> </p>
     * 
     * <p> Passing an unloaded version of either object type will change
     * the way the current session operates. Note: only objects which
     * are returned by the {@link #getSecurityContexts} method are
     * considered valid. Any other instance will cause an exception to
     * be thrown. </p>
     * 
     * <h4>Example usage in Python:<h4>
     * <pre>
     * sf = client.createSession()
     * objs = sf.getSecurityContexts()
     * old = sf.setSecurityContext(objs\[-1])
     * </pre>
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.IObject setSecurityContext(omero.model.IObject obj, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Changes the security context for the current session.
     * 
     * <p> A security context limits the set of objects which will
     * be returned by all queries and restricts what updates
     * can be made. </p>
     * 
     * <p> Current valid values for security context:
     * <ul>
     * <li>{@link omero.model.ExperimenterGroup} - logs into a
     * specific group</li>
     * <li>{@link omero.model.Share} - uses IShare to activate a
     * share</li>
     * </ul> </p>
     * 
     * <p> Passing an unloaded version of either object type will change
     * the way the current session operates. Note: only objects which
     * are returned by the {@link #getSecurityContexts} method are
     * considered valid. Any other instance will cause an exception to
     * be thrown. </p>
     * 
     * <h4>Example usage in Python:<h4>
     * <pre>
     * sf = client.createSession()
     * objs = sf.getSecurityContexts()
     * old = sf.setSecurityContext(objs\[-1])
     * </pre>
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setSecurityContext(omero.model.IObject obj);

    /**
     * Changes the security context for the current session.
     * 
     * <p> A security context limits the set of objects which will
     * be returned by all queries and restricts what updates
     * can be made. </p>
     * 
     * <p> Current valid values for security context:
     * <ul>
     * <li>{@link omero.model.ExperimenterGroup} - logs into a
     * specific group</li>
     * <li>{@link omero.model.Share} - uses IShare to activate a
     * share</li>
     * </ul> </p>
     * 
     * <p> Passing an unloaded version of either object type will change
     * the way the current session operates. Note: only objects which
     * are returned by the {@link #getSecurityContexts} method are
     * considered valid. Any other instance will cause an exception to
     * be thrown. </p>
     * 
     * <h4>Example usage in Python:<h4>
     * <pre>
     * sf = client.createSession()
     * objs = sf.getSecurityContexts()
     * old = sf.setSecurityContext(objs\[-1])
     * </pre>
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setSecurityContext(omero.model.IObject obj, java.util.Map<String, String> __ctx);

    /**
     * Changes the security context for the current session.
     * 
     * <p> A security context limits the set of objects which will
     * be returned by all queries and restricts what updates
     * can be made. </p>
     * 
     * <p> Current valid values for security context:
     * <ul>
     * <li>{@link omero.model.ExperimenterGroup} - logs into a
     * specific group</li>
     * <li>{@link omero.model.Share} - uses IShare to activate a
     * share</li>
     * </ul> </p>
     * 
     * <p> Passing an unloaded version of either object type will change
     * the way the current session operates. Note: only objects which
     * are returned by the {@link #getSecurityContexts} method are
     * considered valid. Any other instance will cause an exception to
     * be thrown. </p>
     * 
     * <h4>Example usage in Python:<h4>
     * <pre>
     * sf = client.createSession()
     * objs = sf.getSecurityContexts()
     * old = sf.setSecurityContext(objs\[-1])
     * </pre>
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setSecurityContext(omero.model.IObject obj, Ice.Callback __cb);

    /**
     * Changes the security context for the current session.
     * 
     * <p> A security context limits the set of objects which will
     * be returned by all queries and restricts what updates
     * can be made. </p>
     * 
     * <p> Current valid values for security context:
     * <ul>
     * <li>{@link omero.model.ExperimenterGroup} - logs into a
     * specific group</li>
     * <li>{@link omero.model.Share} - uses IShare to activate a
     * share</li>
     * </ul> </p>
     * 
     * <p> Passing an unloaded version of either object type will change
     * the way the current session operates. Note: only objects which
     * are returned by the {@link #getSecurityContexts} method are
     * considered valid. Any other instance will cause an exception to
     * be thrown. </p>
     * 
     * <h4>Example usage in Python:<h4>
     * <pre>
     * sf = client.createSession()
     * objs = sf.getSecurityContexts()
     * old = sf.setSecurityContext(objs\[-1])
     * </pre>
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setSecurityContext(omero.model.IObject obj, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Changes the security context for the current session.
     * 
     * <p> A security context limits the set of objects which will
     * be returned by all queries and restricts what updates
     * can be made. </p>
     * 
     * <p> Current valid values for security context:
     * <ul>
     * <li>{@link omero.model.ExperimenterGroup} - logs into a
     * specific group</li>
     * <li>{@link omero.model.Share} - uses IShare to activate a
     * share</li>
     * </ul> </p>
     * 
     * <p> Passing an unloaded version of either object type will change
     * the way the current session operates. Note: only objects which
     * are returned by the {@link #getSecurityContexts} method are
     * considered valid. Any other instance will cause an exception to
     * be thrown. </p>
     * 
     * <h4>Example usage in Python:<h4>
     * <pre>
     * sf = client.createSession()
     * objs = sf.getSecurityContexts()
     * old = sf.setSecurityContext(objs\[-1])
     * </pre>
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setSecurityContext(omero.model.IObject obj, Callback_ServiceFactory_setSecurityContext __cb);

    /**
     * Changes the security context for the current session.
     * 
     * <p> A security context limits the set of objects which will
     * be returned by all queries and restricts what updates
     * can be made. </p>
     * 
     * <p> Current valid values for security context:
     * <ul>
     * <li>{@link omero.model.ExperimenterGroup} - logs into a
     * specific group</li>
     * <li>{@link omero.model.Share} - uses IShare to activate a
     * share</li>
     * </ul> </p>
     * 
     * <p> Passing an unloaded version of either object type will change
     * the way the current session operates. Note: only objects which
     * are returned by the {@link #getSecurityContexts} method are
     * considered valid. Any other instance will cause an exception to
     * be thrown. </p>
     * 
     * <h4>Example usage in Python:<h4>
     * <pre>
     * sf = client.createSession()
     * objs = sf.getSecurityContexts()
     * old = sf.setSecurityContext(objs\[-1])
     * </pre>
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setSecurityContext(omero.model.IObject obj, java.util.Map<String, String> __ctx, Callback_ServiceFactory_setSecurityContext __cb);

    /**
     * Changes the security context for the current session.
     * 
     * <p> A security context limits the set of objects which will
     * be returned by all queries and restricts what updates
     * can be made. </p>
     * 
     * <p> Current valid values for security context:
     * <ul>
     * <li>{@link omero.model.ExperimenterGroup} - logs into a
     * specific group</li>
     * <li>{@link omero.model.Share} - uses IShare to activate a
     * share</li>
     * </ul> </p>
     * 
     * <p> Passing an unloaded version of either object type will change
     * the way the current session operates. Note: only objects which
     * are returned by the {@link #getSecurityContexts} method are
     * considered valid. Any other instance will cause an exception to
     * be thrown. </p>
     * 
     * <h4>Example usage in Python:<h4>
     * <pre>
     * sf = client.createSession()
     * objs = sf.getSecurityContexts()
     * old = sf.setSecurityContext(objs\[-1])
     * </pre>
     * 
     * @param __result The asynchronous result object.
     **/
    public omero.model.IObject end_setSecurityContext(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Re-validates the password for the current session. This prevents
     * 
     * See methods that mention "HasPassword".
     **/
    public void setSecurityPassword(String password)
        throws omero.ServerError;

    /**
     * Re-validates the password for the current session. This prevents
     * 
     * See methods that mention "HasPassword".
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setSecurityPassword(String password, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Re-validates the password for the current session. This prevents
     * 
     * See methods that mention "HasPassword".
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setSecurityPassword(String password);

    /**
     * Re-validates the password for the current session. This prevents
     * 
     * See methods that mention "HasPassword".
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setSecurityPassword(String password, java.util.Map<String, String> __ctx);

    /**
     * Re-validates the password for the current session. This prevents
     * 
     * See methods that mention "HasPassword".
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setSecurityPassword(String password, Ice.Callback __cb);

    /**
     * Re-validates the password for the current session. This prevents
     * 
     * See methods that mention "HasPassword".
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setSecurityPassword(String password, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Re-validates the password for the current session. This prevents
     * 
     * See methods that mention "HasPassword".
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setSecurityPassword(String password, Callback_ServiceFactory_setSecurityPassword __cb);

    /**
     * Re-validates the password for the current session. This prevents
     * 
     * See methods that mention "HasPassword".
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setSecurityPassword(String password, java.util.Map<String, String> __ctx, Callback_ServiceFactory_setSecurityPassword __cb);

    /**
     * Re-validates the password for the current session. This prevents
     * 
     * See methods that mention "HasPassword".
     * @param __result The asynchronous result object.
     **/
    public void end_setSecurityPassword(Ice.AsyncResult __result)
        throws omero.ServerError;

    public IAdminPrx getAdminService()
        throws omero.ServerError;

    public IAdminPrx getAdminService(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_getAdminService();

    public Ice.AsyncResult begin_getAdminService(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_getAdminService(Ice.Callback __cb);

    public Ice.AsyncResult begin_getAdminService(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_getAdminService(Callback_ServiceFactory_getAdminService __cb);

    public Ice.AsyncResult begin_getAdminService(java.util.Map<String, String> __ctx, Callback_ServiceFactory_getAdminService __cb);

    public IAdminPrx end_getAdminService(Ice.AsyncResult __result)
        throws omero.ServerError;

    public IConfigPrx getConfigService()
        throws omero.ServerError;

    public IConfigPrx getConfigService(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_getConfigService();

    public Ice.AsyncResult begin_getConfigService(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_getConfigService(Ice.Callback __cb);

    public Ice.AsyncResult begin_getConfigService(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_getConfigService(Callback_ServiceFactory_getConfigService __cb);

    public Ice.AsyncResult begin_getConfigService(java.util.Map<String, String> __ctx, Callback_ServiceFactory_getConfigService __cb);

    public IConfigPrx end_getConfigService(Ice.AsyncResult __result)
        throws omero.ServerError;

    public IContainerPrx getContainerService()
        throws omero.ServerError;

    public IContainerPrx getContainerService(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_getContainerService();

    public Ice.AsyncResult begin_getContainerService(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_getContainerService(Ice.Callback __cb);

    public Ice.AsyncResult begin_getContainerService(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_getContainerService(Callback_ServiceFactory_getContainerService __cb);

    public Ice.AsyncResult begin_getContainerService(java.util.Map<String, String> __ctx, Callback_ServiceFactory_getContainerService __cb);

    public IContainerPrx end_getContainerService(Ice.AsyncResult __result)
        throws omero.ServerError;

    public ILdapPrx getLdapService()
        throws omero.ServerError;

    public ILdapPrx getLdapService(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_getLdapService();

    public Ice.AsyncResult begin_getLdapService(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_getLdapService(Ice.Callback __cb);

    public Ice.AsyncResult begin_getLdapService(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_getLdapService(Callback_ServiceFactory_getLdapService __cb);

    public Ice.AsyncResult begin_getLdapService(java.util.Map<String, String> __ctx, Callback_ServiceFactory_getLdapService __cb);

    public ILdapPrx end_getLdapService(Ice.AsyncResult __result)
        throws omero.ServerError;

    public IPixelsPrx getPixelsService()
        throws omero.ServerError;

    public IPixelsPrx getPixelsService(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_getPixelsService();

    public Ice.AsyncResult begin_getPixelsService(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_getPixelsService(Ice.Callback __cb);

    public Ice.AsyncResult begin_getPixelsService(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_getPixelsService(Callback_ServiceFactory_getPixelsService __cb);

    public Ice.AsyncResult begin_getPixelsService(java.util.Map<String, String> __ctx, Callback_ServiceFactory_getPixelsService __cb);

    public IPixelsPrx end_getPixelsService(Ice.AsyncResult __result)
        throws omero.ServerError;

    public IProjectionPrx getProjectionService()
        throws omero.ServerError;

    public IProjectionPrx getProjectionService(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_getProjectionService();

    public Ice.AsyncResult begin_getProjectionService(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_getProjectionService(Ice.Callback __cb);

    public Ice.AsyncResult begin_getProjectionService(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_getProjectionService(Callback_ServiceFactory_getProjectionService __cb);

    public Ice.AsyncResult begin_getProjectionService(java.util.Map<String, String> __ctx, Callback_ServiceFactory_getProjectionService __cb);

    public IProjectionPrx end_getProjectionService(Ice.AsyncResult __result)
        throws omero.ServerError;

    public IQueryPrx getQueryService()
        throws omero.ServerError;

    public IQueryPrx getQueryService(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_getQueryService();

    public Ice.AsyncResult begin_getQueryService(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_getQueryService(Ice.Callback __cb);

    public Ice.AsyncResult begin_getQueryService(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_getQueryService(Callback_ServiceFactory_getQueryService __cb);

    public Ice.AsyncResult begin_getQueryService(java.util.Map<String, String> __ctx, Callback_ServiceFactory_getQueryService __cb);

    public IQueryPrx end_getQueryService(Ice.AsyncResult __result)
        throws omero.ServerError;

    public IRenderingSettingsPrx getRenderingSettingsService()
        throws omero.ServerError;

    public IRenderingSettingsPrx getRenderingSettingsService(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_getRenderingSettingsService();

    public Ice.AsyncResult begin_getRenderingSettingsService(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_getRenderingSettingsService(Ice.Callback __cb);

    public Ice.AsyncResult begin_getRenderingSettingsService(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_getRenderingSettingsService(Callback_ServiceFactory_getRenderingSettingsService __cb);

    public Ice.AsyncResult begin_getRenderingSettingsService(java.util.Map<String, String> __ctx, Callback_ServiceFactory_getRenderingSettingsService __cb);

    public IRenderingSettingsPrx end_getRenderingSettingsService(Ice.AsyncResult __result)
        throws omero.ServerError;

    public IRepositoryInfoPrx getRepositoryInfoService()
        throws omero.ServerError;

    public IRepositoryInfoPrx getRepositoryInfoService(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_getRepositoryInfoService();

    public Ice.AsyncResult begin_getRepositoryInfoService(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_getRepositoryInfoService(Ice.Callback __cb);

    public Ice.AsyncResult begin_getRepositoryInfoService(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_getRepositoryInfoService(Callback_ServiceFactory_getRepositoryInfoService __cb);

    public Ice.AsyncResult begin_getRepositoryInfoService(java.util.Map<String, String> __ctx, Callback_ServiceFactory_getRepositoryInfoService __cb);

    public IRepositoryInfoPrx end_getRepositoryInfoService(Ice.AsyncResult __result)
        throws omero.ServerError;

    public IRoiPrx getRoiService()
        throws omero.ServerError;

    public IRoiPrx getRoiService(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_getRoiService();

    public Ice.AsyncResult begin_getRoiService(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_getRoiService(Ice.Callback __cb);

    public Ice.AsyncResult begin_getRoiService(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_getRoiService(Callback_ServiceFactory_getRoiService __cb);

    public Ice.AsyncResult begin_getRoiService(java.util.Map<String, String> __ctx, Callback_ServiceFactory_getRoiService __cb);

    public IRoiPrx end_getRoiService(Ice.AsyncResult __result)
        throws omero.ServerError;

    public IScriptPrx getScriptService()
        throws omero.ServerError;

    public IScriptPrx getScriptService(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_getScriptService();

    public Ice.AsyncResult begin_getScriptService(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_getScriptService(Ice.Callback __cb);

    public Ice.AsyncResult begin_getScriptService(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_getScriptService(Callback_ServiceFactory_getScriptService __cb);

    public Ice.AsyncResult begin_getScriptService(java.util.Map<String, String> __ctx, Callback_ServiceFactory_getScriptService __cb);

    public IScriptPrx end_getScriptService(Ice.AsyncResult __result)
        throws omero.ServerError;

    public ISessionPrx getSessionService()
        throws omero.ServerError;

    public ISessionPrx getSessionService(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_getSessionService();

    public Ice.AsyncResult begin_getSessionService(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_getSessionService(Ice.Callback __cb);

    public Ice.AsyncResult begin_getSessionService(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_getSessionService(Callback_ServiceFactory_getSessionService __cb);

    public Ice.AsyncResult begin_getSessionService(java.util.Map<String, String> __ctx, Callback_ServiceFactory_getSessionService __cb);

    public ISessionPrx end_getSessionService(Ice.AsyncResult __result)
        throws omero.ServerError;

    public ISharePrx getShareService()
        throws omero.ServerError;

    public ISharePrx getShareService(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_getShareService();

    public Ice.AsyncResult begin_getShareService(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_getShareService(Ice.Callback __cb);

    public Ice.AsyncResult begin_getShareService(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_getShareService(Callback_ServiceFactory_getShareService __cb);

    public Ice.AsyncResult begin_getShareService(java.util.Map<String, String> __ctx, Callback_ServiceFactory_getShareService __cb);

    public ISharePrx end_getShareService(Ice.AsyncResult __result)
        throws omero.ServerError;

    public ITimelinePrx getTimelineService()
        throws omero.ServerError;

    public ITimelinePrx getTimelineService(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_getTimelineService();

    public Ice.AsyncResult begin_getTimelineService(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_getTimelineService(Ice.Callback __cb);

    public Ice.AsyncResult begin_getTimelineService(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_getTimelineService(Callback_ServiceFactory_getTimelineService __cb);

    public Ice.AsyncResult begin_getTimelineService(java.util.Map<String, String> __ctx, Callback_ServiceFactory_getTimelineService __cb);

    public ITimelinePrx end_getTimelineService(Ice.AsyncResult __result)
        throws omero.ServerError;

    public ITypesPrx getTypesService()
        throws omero.ServerError;

    public ITypesPrx getTypesService(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_getTypesService();

    public Ice.AsyncResult begin_getTypesService(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_getTypesService(Ice.Callback __cb);

    public Ice.AsyncResult begin_getTypesService(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_getTypesService(Callback_ServiceFactory_getTypesService __cb);

    public Ice.AsyncResult begin_getTypesService(java.util.Map<String, String> __ctx, Callback_ServiceFactory_getTypesService __cb);

    public ITypesPrx end_getTypesService(Ice.AsyncResult __result)
        throws omero.ServerError;

    public IUpdatePrx getUpdateService()
        throws omero.ServerError;

    public IUpdatePrx getUpdateService(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_getUpdateService();

    public Ice.AsyncResult begin_getUpdateService(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_getUpdateService(Ice.Callback __cb);

    public Ice.AsyncResult begin_getUpdateService(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_getUpdateService(Callback_ServiceFactory_getUpdateService __cb);

    public Ice.AsyncResult begin_getUpdateService(java.util.Map<String, String> __ctx, Callback_ServiceFactory_getUpdateService __cb);

    public IUpdatePrx end_getUpdateService(Ice.AsyncResult __result)
        throws omero.ServerError;

    public IMetadataPrx getMetadataService()
        throws omero.ServerError;

    public IMetadataPrx getMetadataService(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_getMetadataService();

    public Ice.AsyncResult begin_getMetadataService(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_getMetadataService(Ice.Callback __cb);

    public Ice.AsyncResult begin_getMetadataService(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_getMetadataService(Callback_ServiceFactory_getMetadataService __cb);

    public Ice.AsyncResult begin_getMetadataService(java.util.Map<String, String> __ctx, Callback_ServiceFactory_getMetadataService __cb);

    public IMetadataPrx end_getMetadataService(Ice.AsyncResult __result)
        throws omero.ServerError;

    public ExporterPrx createExporter()
        throws omero.ServerError;

    public ExporterPrx createExporter(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_createExporter();

    public Ice.AsyncResult begin_createExporter(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_createExporter(Ice.Callback __cb);

    public Ice.AsyncResult begin_createExporter(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_createExporter(Callback_ServiceFactory_createExporter __cb);

    public Ice.AsyncResult begin_createExporter(java.util.Map<String, String> __ctx, Callback_ServiceFactory_createExporter __cb);

    public ExporterPrx end_createExporter(Ice.AsyncResult __result)
        throws omero.ServerError;

    public JobHandlePrx createJobHandle()
        throws omero.ServerError;

    public JobHandlePrx createJobHandle(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_createJobHandle();

    public Ice.AsyncResult begin_createJobHandle(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_createJobHandle(Ice.Callback __cb);

    public Ice.AsyncResult begin_createJobHandle(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_createJobHandle(Callback_ServiceFactory_createJobHandle __cb);

    public Ice.AsyncResult begin_createJobHandle(java.util.Map<String, String> __ctx, Callback_ServiceFactory_createJobHandle __cb);

    public JobHandlePrx end_createJobHandle(Ice.AsyncResult __result)
        throws omero.ServerError;

    public RawFileStorePrx createRawFileStore()
        throws omero.ServerError;

    public RawFileStorePrx createRawFileStore(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_createRawFileStore();

    public Ice.AsyncResult begin_createRawFileStore(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_createRawFileStore(Ice.Callback __cb);

    public Ice.AsyncResult begin_createRawFileStore(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_createRawFileStore(Callback_ServiceFactory_createRawFileStore __cb);

    public Ice.AsyncResult begin_createRawFileStore(java.util.Map<String, String> __ctx, Callback_ServiceFactory_createRawFileStore __cb);

    public RawFileStorePrx end_createRawFileStore(Ice.AsyncResult __result)
        throws omero.ServerError;

    public RawPixelsStorePrx createRawPixelsStore()
        throws omero.ServerError;

    public RawPixelsStorePrx createRawPixelsStore(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_createRawPixelsStore();

    public Ice.AsyncResult begin_createRawPixelsStore(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_createRawPixelsStore(Ice.Callback __cb);

    public Ice.AsyncResult begin_createRawPixelsStore(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_createRawPixelsStore(Callback_ServiceFactory_createRawPixelsStore __cb);

    public Ice.AsyncResult begin_createRawPixelsStore(java.util.Map<String, String> __ctx, Callback_ServiceFactory_createRawPixelsStore __cb);

    public RawPixelsStorePrx end_createRawPixelsStore(Ice.AsyncResult __result)
        throws omero.ServerError;

    public RenderingEnginePrx createRenderingEngine()
        throws omero.ServerError;

    public RenderingEnginePrx createRenderingEngine(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_createRenderingEngine();

    public Ice.AsyncResult begin_createRenderingEngine(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_createRenderingEngine(Ice.Callback __cb);

    public Ice.AsyncResult begin_createRenderingEngine(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_createRenderingEngine(Callback_ServiceFactory_createRenderingEngine __cb);

    public Ice.AsyncResult begin_createRenderingEngine(java.util.Map<String, String> __ctx, Callback_ServiceFactory_createRenderingEngine __cb);

    public RenderingEnginePrx end_createRenderingEngine(Ice.AsyncResult __result)
        throws omero.ServerError;

    public SearchPrx createSearchService()
        throws omero.ServerError;

    public SearchPrx createSearchService(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_createSearchService();

    public Ice.AsyncResult begin_createSearchService(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_createSearchService(Ice.Callback __cb);

    public Ice.AsyncResult begin_createSearchService(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_createSearchService(Callback_ServiceFactory_createSearchService __cb);

    public Ice.AsyncResult begin_createSearchService(java.util.Map<String, String> __ctx, Callback_ServiceFactory_createSearchService __cb);

    public SearchPrx end_createSearchService(Ice.AsyncResult __result)
        throws omero.ServerError;

    public ThumbnailStorePrx createThumbnailStore()
        throws omero.ServerError;

    public ThumbnailStorePrx createThumbnailStore(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_createThumbnailStore();

    public Ice.AsyncResult begin_createThumbnailStore(java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_createThumbnailStore(Ice.Callback __cb);

    public Ice.AsyncResult begin_createThumbnailStore(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_createThumbnailStore(Callback_ServiceFactory_createThumbnailStore __cb);

    public Ice.AsyncResult begin_createThumbnailStore(java.util.Map<String, String> __ctx, Callback_ServiceFactory_createThumbnailStore __cb);

    public ThumbnailStorePrx end_createThumbnailStore(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns a reference to a back-end manager. The
     * {@link omero.grid.SharedResources} service provides look ups
     * for various facilities offered by OMERO:
     * <ul>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/scripts/">OMERO.scripts</a>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/Tables.html">OMERO.tables</a>
     * </ul>
     * These facilities may or may not be available on first request.
     * 
     * @see omero.grid.SharedResources
     **/
    public omero.grid.SharedResourcesPrx sharedResources()
        throws omero.ServerError;

    /**
     * Returns a reference to a back-end manager. The
     * {@link omero.grid.SharedResources} service provides look ups
     * for various facilities offered by OMERO:
     * <ul>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/scripts/">OMERO.scripts</a>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/Tables.html">OMERO.tables</a>
     * </ul>
     * These facilities may or may not be available on first request.
     * 
     * @see omero.grid.SharedResources
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.grid.SharedResourcesPrx sharedResources(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns a reference to a back-end manager. The
     * {@link omero.grid.SharedResources} service provides look ups
     * for various facilities offered by OMERO:
     * <ul>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/scripts/">OMERO.scripts</a>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/Tables.html">OMERO.tables</a>
     * </ul>
     * These facilities may or may not be available on first request.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sharedResources();

    /**
     * Returns a reference to a back-end manager. The
     * {@link omero.grid.SharedResources} service provides look ups
     * for various facilities offered by OMERO:
     * <ul>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/scripts/">OMERO.scripts</a>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/Tables.html">OMERO.tables</a>
     * </ul>
     * These facilities may or may not be available on first request.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sharedResources(java.util.Map<String, String> __ctx);

    /**
     * Returns a reference to a back-end manager. The
     * {@link omero.grid.SharedResources} service provides look ups
     * for various facilities offered by OMERO:
     * <ul>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/scripts/">OMERO.scripts</a>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/Tables.html">OMERO.tables</a>
     * </ul>
     * These facilities may or may not be available on first request.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sharedResources(Ice.Callback __cb);

    /**
     * Returns a reference to a back-end manager. The
     * {@link omero.grid.SharedResources} service provides look ups
     * for various facilities offered by OMERO:
     * <ul>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/scripts/">OMERO.scripts</a>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/Tables.html">OMERO.tables</a>
     * </ul>
     * These facilities may or may not be available on first request.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sharedResources(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns a reference to a back-end manager. The
     * {@link omero.grid.SharedResources} service provides look ups
     * for various facilities offered by OMERO:
     * <ul>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/scripts/">OMERO.scripts</a>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/Tables.html">OMERO.tables</a>
     * </ul>
     * These facilities may or may not be available on first request.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sharedResources(Callback_ServiceFactory_sharedResources __cb);

    /**
     * Returns a reference to a back-end manager. The
     * {@link omero.grid.SharedResources} service provides look ups
     * for various facilities offered by OMERO:
     * <ul>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/scripts/">OMERO.scripts</a>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/Tables.html">OMERO.tables</a>
     * </ul>
     * These facilities may or may not be available on first request.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_sharedResources(java.util.Map<String, String> __ctx, Callback_ServiceFactory_sharedResources __cb);

    /**
     * Returns a reference to a back-end manager. The
     * {@link omero.grid.SharedResources} service provides look ups
     * for various facilities offered by OMERO:
     * <ul>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/scripts/">OMERO.scripts</a>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/Tables.html">OMERO.tables</a>
     * </ul>
     * These facilities may or may not be available on first request.
     * 
     * @param __result The asynchronous result object.
     * @see omero.grid.SharedResources
     **/
    public omero.grid.SharedResourcesPrx end_sharedResources(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Allows looking up any stateless service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * getByName can be used even though no concrete
     * method is available.
     **/
    public ServiceInterfacePrx getByName(String name)
        throws omero.ServerError;

    /**
     * Allows looking up any stateless service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * getByName can be used even though no concrete
     * method is available.
     * @param __ctx The Context map to send with the invocation.
     **/
    public ServiceInterfacePrx getByName(String name, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Allows looking up any stateless service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * getByName can be used even though no concrete
     * method is available.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getByName(String name);

    /**
     * Allows looking up any stateless service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * getByName can be used even though no concrete
     * method is available.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getByName(String name, java.util.Map<String, String> __ctx);

    /**
     * Allows looking up any stateless service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * getByName can be used even though no concrete
     * method is available.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getByName(String name, Ice.Callback __cb);

    /**
     * Allows looking up any stateless service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * getByName can be used even though no concrete
     * method is available.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getByName(String name, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Allows looking up any stateless service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * getByName can be used even though no concrete
     * method is available.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getByName(String name, Callback_ServiceFactory_getByName __cb);

    /**
     * Allows looking up any stateless service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * getByName can be used even though no concrete
     * method is available.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getByName(String name, java.util.Map<String, String> __ctx, Callback_ServiceFactory_getByName __cb);

    /**
     * Allows looking up any stateless service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * getByName can be used even though no concrete
     * method is available.
     * @param __result The asynchronous result object.
     **/
    public ServiceInterfacePrx end_getByName(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Allows looking up any stateful service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * createByName can be used even though no concrete
     * method is available.
     **/
    public StatefulServiceInterfacePrx createByName(String name)
        throws omero.ServerError;

    /**
     * Allows looking up any stateful service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * createByName can be used even though no concrete
     * method is available.
     * @param __ctx The Context map to send with the invocation.
     **/
    public StatefulServiceInterfacePrx createByName(String name, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Allows looking up any stateful service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * createByName can be used even though no concrete
     * method is available.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createByName(String name);

    /**
     * Allows looking up any stateful service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * createByName can be used even though no concrete
     * method is available.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createByName(String name, java.util.Map<String, String> __ctx);

    /**
     * Allows looking up any stateful service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * createByName can be used even though no concrete
     * method is available.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createByName(String name, Ice.Callback __cb);

    /**
     * Allows looking up any stateful service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * createByName can be used even though no concrete
     * method is available.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createByName(String name, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Allows looking up any stateful service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * createByName can be used even though no concrete
     * method is available.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createByName(String name, Callback_ServiceFactory_createByName __cb);

    /**
     * Allows looking up any stateful service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * createByName can be used even though no concrete
     * method is available.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createByName(String name, java.util.Map<String, String> __ctx, Callback_ServiceFactory_createByName __cb);

    /**
     * Allows looking up any stateful service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * createByName can be used even though no concrete
     * method is available.
     * @param __result The asynchronous result object.
     **/
    public StatefulServiceInterfacePrx end_createByName(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Subscribe to a given topic. The topic must exist and the user must
     * have sufficient permissions for that topic. Further the proxy object
     * must match the required type for the topic as encoded in the topic
     * name.
     **/
    public void subscribe(String topicName, Ice.ObjectPrx prx)
        throws omero.ServerError;

    /**
     * Subscribe to a given topic. The topic must exist and the user must
     * have sufficient permissions for that topic. Further the proxy object
     * must match the required type for the topic as encoded in the topic
     * name.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void subscribe(String topicName, Ice.ObjectPrx prx, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Subscribe to a given topic. The topic must exist and the user must
     * have sufficient permissions for that topic. Further the proxy object
     * must match the required type for the topic as encoded in the topic
     * name.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_subscribe(String topicName, Ice.ObjectPrx prx);

    /**
     * Subscribe to a given topic. The topic must exist and the user must
     * have sufficient permissions for that topic. Further the proxy object
     * must match the required type for the topic as encoded in the topic
     * name.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_subscribe(String topicName, Ice.ObjectPrx prx, java.util.Map<String, String> __ctx);

    /**
     * Subscribe to a given topic. The topic must exist and the user must
     * have sufficient permissions for that topic. Further the proxy object
     * must match the required type for the topic as encoded in the topic
     * name.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_subscribe(String topicName, Ice.ObjectPrx prx, Ice.Callback __cb);

    /**
     * Subscribe to a given topic. The topic must exist and the user must
     * have sufficient permissions for that topic. Further the proxy object
     * must match the required type for the topic as encoded in the topic
     * name.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_subscribe(String topicName, Ice.ObjectPrx prx, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Subscribe to a given topic. The topic must exist and the user must
     * have sufficient permissions for that topic. Further the proxy object
     * must match the required type for the topic as encoded in the topic
     * name.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_subscribe(String topicName, Ice.ObjectPrx prx, Callback_ServiceFactory_subscribe __cb);

    /**
     * Subscribe to a given topic. The topic must exist and the user must
     * have sufficient permissions for that topic. Further the proxy object
     * must match the required type for the topic as encoded in the topic
     * name.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_subscribe(String topicName, Ice.ObjectPrx prx, java.util.Map<String, String> __ctx, Callback_ServiceFactory_subscribe __cb);

    /**
     * Subscribe to a given topic. The topic must exist and the user must
     * have sufficient permissions for that topic. Further the proxy object
     * must match the required type for the topic as encoded in the topic
     * name.
     * @param __result The asynchronous result object.
     **/
    public void end_subscribe(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Sets the single callback used by the ServiceFactory
     * to communicate with the client application. A default
     * callback is set by the omero::client object on
     * session creation which should suffice for most usage.
     * 
     * See the client object's documentation in each language
     * mapping for ways to use the callback.
     **/
    public void setCallback(ClientCallbackPrx callback)
        throws omero.ServerError;

    /**
     * Sets the single callback used by the ServiceFactory
     * to communicate with the client application. A default
     * callback is set by the omero::client object on
     * session creation which should suffice for most usage.
     * 
     * See the client object's documentation in each language
     * mapping for ways to use the callback.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setCallback(ClientCallbackPrx callback, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Sets the single callback used by the ServiceFactory
     * to communicate with the client application. A default
     * callback is set by the omero::client object on
     * session creation which should suffice for most usage.
     * 
     * See the client object's documentation in each language
     * mapping for ways to use the callback.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setCallback(ClientCallbackPrx callback);

    /**
     * Sets the single callback used by the ServiceFactory
     * to communicate with the client application. A default
     * callback is set by the omero::client object on
     * session creation which should suffice for most usage.
     * 
     * See the client object's documentation in each language
     * mapping for ways to use the callback.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setCallback(ClientCallbackPrx callback, java.util.Map<String, String> __ctx);

    /**
     * Sets the single callback used by the ServiceFactory
     * to communicate with the client application. A default
     * callback is set by the omero::client object on
     * session creation which should suffice for most usage.
     * 
     * See the client object's documentation in each language
     * mapping for ways to use the callback.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setCallback(ClientCallbackPrx callback, Ice.Callback __cb);

    /**
     * Sets the single callback used by the ServiceFactory
     * to communicate with the client application. A default
     * callback is set by the omero::client object on
     * session creation which should suffice for most usage.
     * 
     * See the client object's documentation in each language
     * mapping for ways to use the callback.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setCallback(ClientCallbackPrx callback, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Sets the single callback used by the ServiceFactory
     * to communicate with the client application. A default
     * callback is set by the omero::client object on
     * session creation which should suffice for most usage.
     * 
     * See the client object's documentation in each language
     * mapping for ways to use the callback.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setCallback(ClientCallbackPrx callback, Callback_ServiceFactory_setCallback __cb);

    /**
     * Sets the single callback used by the ServiceFactory
     * to communicate with the client application. A default
     * callback is set by the omero::client object on
     * session creation which should suffice for most usage.
     * 
     * See the client object's documentation in each language
     * mapping for ways to use the callback.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setCallback(ClientCallbackPrx callback, java.util.Map<String, String> __ctx, Callback_ServiceFactory_setCallback __cb);

    /**
     * Sets the single callback used by the ServiceFactory
     * to communicate with the client application. A default
     * callback is set by the omero::client object on
     * session creation which should suffice for most usage.
     * 
     * See the client object's documentation in each language
     * mapping for ways to use the callback.
     * @param __result The asynchronous result object.
     **/
    public void end_setCallback(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Marks the session for closure rather than detachment, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * Closing the session rather the detaching is more secure, since all
     * resources are removed from the server and can safely be set once
     * it is clear that a client is finished with those resources.
     **/
    public void closeOnDestroy()
        throws omero.ServerError;

    /**
     * Marks the session for closure rather than detachment, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * Closing the session rather the detaching is more secure, since all
     * resources are removed from the server and can safely be set once
     * it is clear that a client is finished with those resources.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void closeOnDestroy(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Marks the session for closure rather than detachment, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * Closing the session rather the detaching is more secure, since all
     * resources are removed from the server and can safely be set once
     * it is clear that a client is finished with those resources.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_closeOnDestroy();

    /**
     * Marks the session for closure rather than detachment, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * Closing the session rather the detaching is more secure, since all
     * resources are removed from the server and can safely be set once
     * it is clear that a client is finished with those resources.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_closeOnDestroy(java.util.Map<String, String> __ctx);

    /**
     * Marks the session for closure rather than detachment, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * Closing the session rather the detaching is more secure, since all
     * resources are removed from the server and can safely be set once
     * it is clear that a client is finished with those resources.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_closeOnDestroy(Ice.Callback __cb);

    /**
     * Marks the session for closure rather than detachment, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * Closing the session rather the detaching is more secure, since all
     * resources are removed from the server and can safely be set once
     * it is clear that a client is finished with those resources.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_closeOnDestroy(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Marks the session for closure rather than detachment, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * Closing the session rather the detaching is more secure, since all
     * resources are removed from the server and can safely be set once
     * it is clear that a client is finished with those resources.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_closeOnDestroy(Callback_ServiceFactory_closeOnDestroy __cb);

    /**
     * Marks the session for closure rather than detachment, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * Closing the session rather the detaching is more secure, since all
     * resources are removed from the server and can safely be set once
     * it is clear that a client is finished with those resources.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_closeOnDestroy(java.util.Map<String, String> __ctx, Callback_ServiceFactory_closeOnDestroy __cb);

    /**
     * Marks the session for closure rather than detachment, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * Closing the session rather the detaching is more secure, since all
     * resources are removed from the server and can safely be set once
     * it is clear that a client is finished with those resources.
     * @param __result The asynchronous result object.
     **/
    public void end_closeOnDestroy(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Marks the session for detachment rather than closure, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * This is the default and allows a lost session to be reconnected,
     * at a slight security cost since the session will persist longer
     * and can be used by others if the UUID is intercepted.
     **/
    public void detachOnDestroy()
        throws omero.ServerError;

    /**
     * Marks the session for detachment rather than closure, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * This is the default and allows a lost session to be reconnected,
     * at a slight security cost since the session will persist longer
     * and can be used by others if the UUID is intercepted.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void detachOnDestroy(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Marks the session for detachment rather than closure, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * This is the default and allows a lost session to be reconnected,
     * at a slight security cost since the session will persist longer
     * and can be used by others if the UUID is intercepted.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_detachOnDestroy();

    /**
     * Marks the session for detachment rather than closure, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * This is the default and allows a lost session to be reconnected,
     * at a slight security cost since the session will persist longer
     * and can be used by others if the UUID is intercepted.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_detachOnDestroy(java.util.Map<String, String> __ctx);

    /**
     * Marks the session for detachment rather than closure, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * This is the default and allows a lost session to be reconnected,
     * at a slight security cost since the session will persist longer
     * and can be used by others if the UUID is intercepted.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_detachOnDestroy(Ice.Callback __cb);

    /**
     * Marks the session for detachment rather than closure, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * This is the default and allows a lost session to be reconnected,
     * at a slight security cost since the session will persist longer
     * and can be used by others if the UUID is intercepted.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_detachOnDestroy(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Marks the session for detachment rather than closure, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * This is the default and allows a lost session to be reconnected,
     * at a slight security cost since the session will persist longer
     * and can be used by others if the UUID is intercepted.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_detachOnDestroy(Callback_ServiceFactory_detachOnDestroy __cb);

    /**
     * Marks the session for detachment rather than closure, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * This is the default and allows a lost session to be reconnected,
     * at a slight security cost since the session will persist longer
     * and can be used by others if the UUID is intercepted.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_detachOnDestroy(java.util.Map<String, String> __ctx, Callback_ServiceFactory_detachOnDestroy __cb);

    /**
     * Marks the session for detachment rather than closure, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * This is the default and allows a lost session to be reconnected,
     * at a slight security cost since the session will persist longer
     * and can be used by others if the UUID is intercepted.
     * @param __result The asynchronous result object.
     **/
    public void end_detachOnDestroy(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns a list of string ids for currently active services. This will
     * _not_ keep services alive, and in fact checks for all expired services
     * and removes them.
     **/
    public java.util.List<String> activeServices()
        throws omero.ServerError;

    /**
     * Returns a list of string ids for currently active services. This will
     * _not_ keep services alive, and in fact checks for all expired services
     * and removes them.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<String> activeServices(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns a list of string ids for currently active services. This will
     * _not_ keep services alive, and in fact checks for all expired services
     * and removes them.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_activeServices();

    /**
     * Returns a list of string ids for currently active services. This will
     * _not_ keep services alive, and in fact checks for all expired services
     * and removes them.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_activeServices(java.util.Map<String, String> __ctx);

    /**
     * Returns a list of string ids for currently active services. This will
     * _not_ keep services alive, and in fact checks for all expired services
     * and removes them.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_activeServices(Ice.Callback __cb);

    /**
     * Returns a list of string ids for currently active services. This will
     * _not_ keep services alive, and in fact checks for all expired services
     * and removes them.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_activeServices(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns a list of string ids for currently active services. This will
     * _not_ keep services alive, and in fact checks for all expired services
     * and removes them.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_activeServices(Callback_ServiceFactory_activeServices __cb);

    /**
     * Returns a list of string ids for currently active services. This will
     * _not_ keep services alive, and in fact checks for all expired services
     * and removes them.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_activeServices(java.util.Map<String, String> __ctx, Callback_ServiceFactory_activeServices __cb);

    /**
     * Returns a list of string ids for currently active services. This will
     * _not_ keep services alive, and in fact checks for all expired services
     * and removes them.
     * @param __result The asynchronous result object.
     **/
    public java.util.List<String> end_activeServices(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Requests that the given services be marked as alive. It is
     * possible that one of the services has already timed out, in which
     * case the returned long value will be non-zero.
     * 
     * Specifically, the bit representing the 0-based index will be 1:
     * 
     * if (retval & 1&lt;&lt;idx == 1&lt;&lt;idx) { // not alive }
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     **/
    public long keepAllAlive(ServiceInterfacePrx[] proxies)
        throws omero.ServerError;

    /**
     * Requests that the given services be marked as alive. It is
     * possible that one of the services has already timed out, in which
     * case the returned long value will be non-zero.
     * 
     * Specifically, the bit representing the 0-based index will be 1:
     * 
     * if (retval & 1&lt;&lt;idx == 1&lt;&lt;idx) { // not alive }
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     * @param __ctx The Context map to send with the invocation.
     **/
    public long keepAllAlive(ServiceInterfacePrx[] proxies, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Requests that the given services be marked as alive. It is
     * possible that one of the services has already timed out, in which
     * case the returned long value will be non-zero.
     * 
     * Specifically, the bit representing the 0-based index will be 1:
     * 
     * if (retval & 1&lt;&lt;idx == 1&lt;&lt;idx) { // not alive }
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_keepAllAlive(ServiceInterfacePrx[] proxies);

    /**
     * Requests that the given services be marked as alive. It is
     * possible that one of the services has already timed out, in which
     * case the returned long value will be non-zero.
     * 
     * Specifically, the bit representing the 0-based index will be 1:
     * 
     * if (retval & 1&lt;&lt;idx == 1&lt;&lt;idx) { // not alive }
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_keepAllAlive(ServiceInterfacePrx[] proxies, java.util.Map<String, String> __ctx);

    /**
     * Requests that the given services be marked as alive. It is
     * possible that one of the services has already timed out, in which
     * case the returned long value will be non-zero.
     * 
     * Specifically, the bit representing the 0-based index will be 1:
     * 
     * if (retval & 1&lt;&lt;idx == 1&lt;&lt;idx) { // not alive }
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_keepAllAlive(ServiceInterfacePrx[] proxies, Ice.Callback __cb);

    /**
     * Requests that the given services be marked as alive. It is
     * possible that one of the services has already timed out, in which
     * case the returned long value will be non-zero.
     * 
     * Specifically, the bit representing the 0-based index will be 1:
     * 
     * if (retval & 1&lt;&lt;idx == 1&lt;&lt;idx) { // not alive }
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_keepAllAlive(ServiceInterfacePrx[] proxies, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Requests that the given services be marked as alive. It is
     * possible that one of the services has already timed out, in which
     * case the returned long value will be non-zero.
     * 
     * Specifically, the bit representing the 0-based index will be 1:
     * 
     * if (retval & 1&lt;&lt;idx == 1&lt;&lt;idx) { // not alive }
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_keepAllAlive(ServiceInterfacePrx[] proxies, Callback_ServiceFactory_keepAllAlive __cb);

    /**
     * Requests that the given services be marked as alive. It is
     * possible that one of the services has already timed out, in which
     * case the returned long value will be non-zero.
     * 
     * Specifically, the bit representing the 0-based index will be 1:
     * 
     * if (retval & 1&lt;&lt;idx == 1&lt;&lt;idx) { // not alive }
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_keepAllAlive(ServiceInterfacePrx[] proxies, java.util.Map<String, String> __ctx, Callback_ServiceFactory_keepAllAlive __cb);

    /**
     * Requests that the given services be marked as alive. It is
     * possible that one of the services has already timed out, in which
     * case the returned long value will be non-zero.
     * 
     * Specifically, the bit representing the 0-based index will be 1:
     * 
     * if (retval & 1&lt;&lt;idx == 1&lt;&lt;idx) { // not alive }
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     * @param __result The asynchronous result object.
     **/
    public long end_keepAllAlive(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns true if the given service is alive.
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     **/
    public boolean keepAlive(ServiceInterfacePrx proxy)
        throws omero.ServerError;

    /**
     * Returns true if the given service is alive.
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean keepAlive(ServiceInterfacePrx proxy, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns true if the given service is alive.
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_keepAlive(ServiceInterfacePrx proxy);

    /**
     * Returns true if the given service is alive.
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_keepAlive(ServiceInterfacePrx proxy, java.util.Map<String, String> __ctx);

    /**
     * Returns true if the given service is alive.
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_keepAlive(ServiceInterfacePrx proxy, Ice.Callback __cb);

    /**
     * Returns true if the given service is alive.
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_keepAlive(ServiceInterfacePrx proxy, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns true if the given service is alive.
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_keepAlive(ServiceInterfacePrx proxy, Callback_ServiceFactory_keepAlive __cb);

    /**
     * Returns true if the given service is alive.
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_keepAlive(ServiceInterfacePrx proxy, java.util.Map<String, String> __ctx, Callback_ServiceFactory_keepAlive __cb);

    /**
     * Returns true if the given service is alive.
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     * @param __result The asynchronous result object.
     **/
    public boolean end_keepAlive(Ice.AsyncResult __result)
        throws omero.ServerError;
}
