// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `ThumbnailStore.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides methods for dealing with thumbnails. Provision is provided
 * to retrieve thumbnails using the on-disk cache (provided by
 * <i>ROMIO</i>) or on the fly.
 * <p>
 * NOTE: The calling order for the service is as follows:
 * <ol>
 * <li>{@link #setPixelsId}</li>
 * <li>any of the thumbnail accessor methods or
 * {@link #resetDefaults}</li>
 * </ol>
 * </p>
 **/
public interface ThumbnailStorePrx extends StatefulServiceInterfacePrx
{
    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param pixelsId an {@link omero.model.Pixels} id.
     * @throws ApiUsageException if no pixels object exists with
     * the ID <code>pixelsId</code>.
     * @return <code>true</code> if a
     * {@link omero.model.RenderingDef} exists for the
     * {@link omero.model.Pixels} set, otherwise
     * <code>false</code>
     **/
    public boolean setPixelsId(long pixelsId)
        throws omero.ServerError;

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param pixelsId an {@link omero.model.Pixels} id.
     * @throws ApiUsageException if no pixels object exists with
     * the ID <code>pixelsId</code>.
     * @param __ctx The Context map to send with the invocation.
     * @return <code>true</code> if a
     * {@link omero.model.RenderingDef} exists for the
     * {@link omero.model.Pixels} set, otherwise
     * <code>false</code>
     **/
    public boolean setPixelsId(long pixelsId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param pixelsId an {@link omero.model.Pixels} id.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId);

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param pixelsId an {@link omero.model.Pixels} id.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, java.util.Map<String, String> __ctx);

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param pixelsId an {@link omero.model.Pixels} id.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, Ice.Callback __cb);

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param pixelsId an {@link omero.model.Pixels} id.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param pixelsId an {@link omero.model.Pixels} id.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, Callback_ThumbnailStore_setPixelsId __cb);

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param pixelsId an {@link omero.model.Pixels} id.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_setPixelsId __cb);

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param __result The asynchronous result object.
     * @throws ApiUsageException if no pixels object exists with
     * the ID <code>pixelsId</code>.
     * @return <code>true</code> if a
     * {@link omero.model.RenderingDef} exists for the
     * {@link omero.model.Pixels} set, otherwise
     * <code>false</code>
     **/
    public boolean end_setPixelsId(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId an {@link omero.model.Pixels} id.
     **/
    public boolean setPixelsId_async(AMI_ThumbnailStore_setPixelsId __cb, long pixelsId);

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId an {@link omero.model.Pixels} id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setPixelsId_async(AMI_ThumbnailStore_setPixelsId __cb, long pixelsId, java.util.Map<String, String> __ctx);

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @return <code>true</code> if the image is in the process of
     * being imported or a pyramid is being generated for
     * it.
     * 
     **/
    public boolean isInProgress()
        throws omero.ServerError;

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __ctx The Context map to send with the invocation.
     * @return <code>true</code> if the image is in the process of
     * being imported or a pyramid is being generated for
     * it.
     * 
     **/
    public boolean isInProgress(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isInProgress();

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isInProgress(java.util.Map<String, String> __ctx);

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isInProgress(Ice.Callback __cb);

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isInProgress(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isInProgress(Callback_ThumbnailStore_isInProgress __cb);

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isInProgress(java.util.Map<String, String> __ctx, Callback_ThumbnailStore_isInProgress __cb);

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __result The asynchronous result object.
     * @return <code>true</code> if the image is in the process of
     * being imported or a pyramid is being generated for
     * it.
     * 
     **/
    public boolean end_isInProgress(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __cb The callback object for the operation.
     **/
    public boolean isInProgress_async(AMI_ThumbnailStore_isInProgress __cb);

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isInProgress_async(AMI_ThumbnailStore_isInProgress __cb, java.util.Map<String, String> __ctx);

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     * @throws ValidationException
     * if no rendering definition exists with the ID
     * <code>renderingDefId</code>.
     **/
    public void setRenderingDefId(long renderingDefId)
        throws omero.ServerError;

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     * @throws ValidationException
     * if no rendering definition exists with the ID
     * <code>renderingDefId</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setRenderingDefId(long renderingDefId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setRenderingDefId(long renderingDefId);

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setRenderingDefId(long renderingDefId, java.util.Map<String, String> __ctx);

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setRenderingDefId(long renderingDefId, Ice.Callback __cb);

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setRenderingDefId(long renderingDefId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setRenderingDefId(long renderingDefId, Callback_ThumbnailStore_setRenderingDefId __cb);

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setRenderingDefId(long renderingDefId, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_setRenderingDefId __cb);

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param __result The asynchronous result object.
     * @throws ValidationException
     * if no rendering definition exists with the ID
     * <code>renderingDefId</code>.
     **/
    public void end_setRenderingDefId(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     **/
    public boolean setRenderingDefId_async(AMI_ThumbnailStore_setRenderingDefId __cb, long renderingDefId);

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setRenderingDefId_async(AMI_ThumbnailStore_setRenderingDefId __cb, long renderingDefId, java.util.Map<String, String> __ctx);

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     **/
    public long getRenderingDefId()
        throws omero.ServerError;

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __ctx The Context map to send with the invocation.
     **/
    public long getRenderingDefId(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRenderingDefId();

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRenderingDefId(java.util.Map<String, String> __ctx);

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRenderingDefId(Ice.Callback __cb);

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRenderingDefId(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRenderingDefId(Callback_ThumbnailStore_getRenderingDefId __cb);

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getRenderingDefId(java.util.Map<String, String> __ctx, Callback_ThumbnailStore_getRenderingDefId __cb);

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __result The asynchronous result object.
     **/
    public long end_getRenderingDefId(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __cb The callback object for the operation.
     **/
    public boolean getRenderingDefId_async(AMI_ThumbnailStore_getRenderingDefId __cb);

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getRenderingDefId_async(AMI_ThumbnailStore_getRenderingDefId __cb, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnailDirect
     **/
    public byte[] getThumbnail(omero.RInt sizeX, omero.RInt sizeY)
        throws omero.ServerError;

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @param __ctx The Context map to send with the invocation.
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnailDirect
     **/
    public byte[] getThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnail(omero.RInt sizeX, omero.RInt sizeY);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnail(omero.RInt sizeX, omero.RInt sizeY, Ice.Callback __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnail(omero.RInt sizeX, omero.RInt sizeY, Callback_ThumbnailStore_getThumbnail __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_getThumbnail __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param __result The asynchronous result object.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnailDirect
     **/
    public byte[] end_getThumbnail(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public boolean getThumbnail_async(AMI_ThumbnailStore_getThumbnail __cb, omero.RInt sizeX, omero.RInt sizeY);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getThumbnail_async(AMI_ThumbnailStore_getThumbnail __cb, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @return a map whose keys are pixels ids and values are JPEG
     * thumbnail byte buffers or <code>null</code> if an
     * exception was thrown while attempting to retrieve
     * the thumbnail for that particular Pixels set.
     * @see #getThumbnail
     **/
    public java.util.Map<java.lang.Long, byte[]> getThumbnailSet(omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds)
        throws omero.ServerError;

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     * @return a map whose keys are pixels ids and values are JPEG
     * thumbnail byte buffers or <code>null</code> if an
     * exception was thrown while attempting to retrieve
     * the thumbnail for that particular Pixels set.
     * @see #getThumbnail
     **/
    public java.util.Map<java.lang.Long, byte[]> getThumbnailSet(omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailSet(omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds);

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailSet(omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailSet(omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds, Ice.Callback __cb);

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailSet(omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailSet(omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds, Callback_ThumbnailStore_getThumbnailSet __cb);

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailSet(omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_getThumbnailSet __cb);

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param __result The asynchronous result object.
     * @return a map whose keys are pixels ids and values are JPEG
     * thumbnail byte buffers or <code>null</code> if an
     * exception was thrown while attempting to retrieve
     * the thumbnail for that particular Pixels set.
     * @see #getThumbnail
     **/
    public java.util.Map<java.lang.Long, byte[]> end_getThumbnailSet(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     **/
    public boolean getThumbnailSet_async(AMI_ThumbnailStore_getThumbnailSet __cb, omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds);

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getThumbnailSet_async(AMI_ThumbnailStore_getThumbnailSet __cb, omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @return a map whose keys are pixels ids and values are JPEG
     * thumbnail byte buffers or <code>null</code> if an
     * exception was thrown while attempting to retrieve
     * the thumbnail for that particular Pixels set.
     * @see #getThumbnailSet
     **/
    public java.util.Map<java.lang.Long, byte[]> getThumbnailByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds)
        throws omero.ServerError;

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     * @return a map whose keys are pixels ids and values are JPEG
     * thumbnail byte buffers or <code>null</code> if an
     * exception was thrown while attempting to retrieve
     * the thumbnail for that particular Pixels set.
     * @see #getThumbnailSet
     **/
    public java.util.Map<java.lang.Long, byte[]> getThumbnailByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds);

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, Ice.Callback __cb);

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, Callback_ThumbnailStore_getThumbnailByLongestSideSet __cb);

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_getThumbnailByLongestSideSet __cb);

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param __result The asynchronous result object.
     * @return a map whose keys are pixels ids and values are JPEG
     * thumbnail byte buffers or <code>null</code> if an
     * exception was thrown while attempting to retrieve
     * the thumbnail for that particular Pixels set.
     * @see #getThumbnailSet
     **/
    public java.util.Map<java.lang.Long, byte[]> end_getThumbnailByLongestSideSet(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     **/
    public boolean getThumbnailByLongestSideSet_async(AMI_ThumbnailStore_getThumbnailByLongestSideSet __cb, omero.RInt size, java.util.List<Long> pixelsIds);

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getThumbnailByLongestSideSet_async(AMI_ThumbnailStore_getThumbnailByLongestSideSet __cb, omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @throws ApiUsageException if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnail
     **/
    public byte[] getThumbnailByLongestSide(omero.RInt size)
        throws omero.ServerError;

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @throws ApiUsageException if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @param __ctx The Context map to send with the invocation.
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnail
     **/
    public byte[] getThumbnailByLongestSide(omero.RInt size, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSide(omero.RInt size);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSide(omero.RInt size, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSide(omero.RInt size, Ice.Callback __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSide(omero.RInt size, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSide(omero.RInt size, Callback_ThumbnailStore_getThumbnailByLongestSide __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSide(omero.RInt size, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_getThumbnailByLongestSide __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param __result The asynchronous result object.
     * @throws ApiUsageException if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnail
     **/
    public byte[] end_getThumbnailByLongestSide(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     **/
    public boolean getThumbnailByLongestSide_async(AMI_ThumbnailStore_getThumbnailByLongestSide __cb, omero.RInt size);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getThumbnailByLongestSide_async(AMI_ThumbnailStore_getThumbnailByLongestSide __cb, omero.RInt size, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnailDirect
     **/
    public byte[] getThumbnailByLongestSideDirect(omero.RInt size)
        throws omero.ServerError;

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @param __ctx The Context map to send with the invocation.
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnailDirect
     **/
    public byte[] getThumbnailByLongestSideDirect(omero.RInt size, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideDirect(omero.RInt size);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideDirect(omero.RInt size, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideDirect(omero.RInt size, Ice.Callback __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideDirect(omero.RInt size, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideDirect(omero.RInt size, Callback_ThumbnailStore_getThumbnailByLongestSideDirect __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideDirect(omero.RInt size, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_getThumbnailByLongestSideDirect __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param __result The asynchronous result object.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnailDirect
     **/
    public byte[] end_getThumbnailByLongestSideDirect(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     **/
    public boolean getThumbnailByLongestSideDirect_async(AMI_ThumbnailStore_getThumbnailByLongestSideDirect __cb, omero.RInt size);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getThumbnailByLongestSideDirect_async(AMI_ThumbnailStore_getThumbnailByLongestSideDirect __cb, omero.RInt size, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnail
     **/
    public byte[] getThumbnailDirect(omero.RInt sizeX, omero.RInt sizeY)
        throws omero.ServerError;

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @param __ctx The Context map to send with the invocation.
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnail
     **/
    public byte[] getThumbnailDirect(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailDirect(omero.RInt sizeX, omero.RInt sizeY);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailDirect(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailDirect(omero.RInt sizeX, omero.RInt sizeY, Ice.Callback __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailDirect(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailDirect(omero.RInt sizeX, omero.RInt sizeY, Callback_ThumbnailStore_getThumbnailDirect __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailDirect(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_getThumbnailDirect __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param __result The asynchronous result object.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnail
     **/
    public byte[] end_getThumbnailDirect(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public boolean getThumbnailDirect_async(AMI_ThumbnailStore_getThumbnailDirect __cb, omero.RInt sizeX, omero.RInt sizeY);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getThumbnailDirect_async(AMI_ThumbnailStore_getThumbnailDirect __cb, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li><code>theZ</code> is out of range</li>
     * <li><code>theT</code> is out of range</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnail
     **/
    public byte[] getThumbnailForSectionDirect(int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY)
        throws omero.ServerError;

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li><code>theZ</code> is out of range</li>
     * <li><code>theT</code> is out of range</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @param __ctx The Context map to send with the invocation.
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnail
     **/
    public byte[] getThumbnailForSectionDirect(int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionDirect(int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionDirect(int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionDirect(int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY, Ice.Callback __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionDirect(int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionDirect(int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY, Callback_ThumbnailStore_getThumbnailForSectionDirect __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionDirect(int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_getThumbnailForSectionDirect __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param __result The asynchronous result object.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li><code>theZ</code> is out of range</li>
     * <li><code>theT</code> is out of range</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnail
     **/
    public byte[] end_getThumbnailForSectionDirect(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public boolean getThumbnailForSectionDirect_async(AMI_ThumbnailStore_getThumbnailForSectionDirect __cb, int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getThumbnailForSectionDirect_async(AMI_ThumbnailStore_getThumbnailForSectionDirect __cb, int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnailDirect
     **/
    public byte[] getThumbnailForSectionByLongestSideDirect(int theZ, int theT, omero.RInt size)
        throws omero.ServerError;

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @param __ctx The Context map to send with the invocation.
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnailDirect
     **/
    public byte[] getThumbnailForSectionByLongestSideDirect(int theZ, int theT, omero.RInt size, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionByLongestSideDirect(int theZ, int theT, omero.RInt size);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionByLongestSideDirect(int theZ, int theT, omero.RInt size, java.util.Map<String, String> __ctx);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionByLongestSideDirect(int theZ, int theT, omero.RInt size, Ice.Callback __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionByLongestSideDirect(int theZ, int theT, omero.RInt size, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionByLongestSideDirect(int theZ, int theT, omero.RInt size, Callback_ThumbnailStore_getThumbnailForSectionByLongestSideDirect __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionByLongestSideDirect(int theZ, int theT, omero.RInt size, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_getThumbnailForSectionByLongestSideDirect __cb);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param __result The asynchronous result object.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnailDirect
     **/
    public byte[] end_getThumbnailForSectionByLongestSideDirect(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     **/
    public boolean getThumbnailForSectionByLongestSideDirect_async(AMI_ThumbnailStore_getThumbnailForSectionByLongestSideDirect __cb, int theZ, int theT, omero.RInt size);

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getThumbnailForSectionByLongestSideDirect_async(AMI_ThumbnailStore_getThumbnailForSectionByLongestSideDirect __cb, int theZ, int theT, omero.RInt size, java.util.Map<String, String> __ctx);

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @see #getThumbnail
     * @see #getThumbnailDirect
     **/
    public void createThumbnails()
        throws omero.ServerError;

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @see #getThumbnail
     * @see #getThumbnailDirect
     * @param __ctx The Context map to send with the invocation.
     **/
    public void createThumbnails(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createThumbnails();

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createThumbnails(java.util.Map<String, String> __ctx);

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createThumbnails(Ice.Callback __cb);

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createThumbnails(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createThumbnails(Callback_ThumbnailStore_createThumbnails __cb);

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createThumbnails(java.util.Map<String, String> __ctx, Callback_ThumbnailStore_createThumbnails __cb);

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @param __result The asynchronous result object.
     * @see #getThumbnail
     * @see #getThumbnailDirect
     **/
    public void end_createThumbnails(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean createThumbnails_async(AMI_ThumbnailStore_createThumbnails __cb);

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createThumbnails_async(AMI_ThumbnailStore_createThumbnails __cb, java.util.Map<String, String> __ctx);

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @see #getThumbnail
     * @see #getThumbnailDirect
     **/
    public void createThumbnail(omero.RInt sizeX, omero.RInt sizeY)
        throws omero.ServerError;

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @see #getThumbnail
     * @see #getThumbnailDirect
     * @param __ctx The Context map to send with the invocation.
     **/
    public void createThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createThumbnail(omero.RInt sizeX, omero.RInt sizeY);

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx);

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createThumbnail(omero.RInt sizeX, omero.RInt sizeY, Ice.Callback __cb);

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createThumbnail(omero.RInt sizeX, omero.RInt sizeY, Callback_ThumbnailStore_createThumbnail __cb);

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_createThumbnail __cb);

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param __result The asynchronous result object.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @see #getThumbnail
     * @see #getThumbnailDirect
     **/
    public void end_createThumbnail(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public boolean createThumbnail_async(AMI_ThumbnailStore_createThumbnail __cb, omero.RInt sizeX, omero.RInt sizeY);

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createThumbnail_async(AMI_ThumbnailStore_createThumbnail __cb, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx);

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li><code>size</code> is negative</li>
     * </ul>
     * @see #createThumbnail
     * @see #createThumbnails
     **/
    public void createThumbnailsByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds)
        throws omero.ServerError;

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li><code>size</code> is negative</li>
     * </ul>
     * @see #createThumbnail
     * @see #createThumbnails
     * @param __ctx The Context map to send with the invocation.
     **/
    public void createThumbnailsByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createThumbnailsByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds);

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createThumbnailsByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx);

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createThumbnailsByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, Ice.Callback __cb);

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createThumbnailsByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createThumbnailsByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, Callback_ThumbnailStore_createThumbnailsByLongestSideSet __cb);

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createThumbnailsByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_createThumbnailsByLongestSideSet __cb);

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param __result The asynchronous result object.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li><code>size</code> is negative</li>
     * </ul>
     * @see #createThumbnail
     * @see #createThumbnails
     **/
    public void end_createThumbnailsByLongestSideSet(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     **/
    public boolean createThumbnailsByLongestSideSet_async(AMI_ThumbnailStore_createThumbnailsByLongestSideSet __cb, omero.RInt size, java.util.List<Long> pixelsIds);

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createThumbnailsByLongestSideSet_async(AMI_ThumbnailStore_createThumbnailsByLongestSideSet __cb, omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx);

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @see #getThumbnail
     * @see #getThumbnailDirect
     **/
    public boolean thumbnailExists(omero.RInt sizeX, omero.RInt sizeY)
        throws omero.ServerError;

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @see #getThumbnail
     * @see #getThumbnailDirect
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean thumbnailExists(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_thumbnailExists(omero.RInt sizeX, omero.RInt sizeY);

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_thumbnailExists(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx);

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_thumbnailExists(omero.RInt sizeX, omero.RInt sizeY, Ice.Callback __cb);

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_thumbnailExists(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_thumbnailExists(omero.RInt sizeX, omero.RInt sizeY, Callback_ThumbnailStore_thumbnailExists __cb);

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_thumbnailExists(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_thumbnailExists __cb);

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param __result The asynchronous result object.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @see #getThumbnail
     * @see #getThumbnailDirect
     **/
    public boolean end_thumbnailExists(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public boolean thumbnailExists_async(AMI_ThumbnailStore_thumbnailExists __cb, omero.RInt sizeX, omero.RInt sizeY);

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean thumbnailExists_async(AMI_ThumbnailStore_thumbnailExists __cb, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx);

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     **/
    public void resetDefaults()
        throws omero.ServerError;

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void resetDefaults(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaults();

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaults(java.util.Map<String, String> __ctx);

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaults(Ice.Callback __cb);

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaults(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaults(Callback_ThumbnailStore_resetDefaults __cb);

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaults(java.util.Map<String, String> __ctx, Callback_ThumbnailStore_resetDefaults __cb);

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __result The asynchronous result object.
     **/
    public void end_resetDefaults(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __cb The callback object for the operation.
     **/
    public boolean resetDefaults_async(AMI_ThumbnailStore_resetDefaults __cb);

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaults_async(AMI_ThumbnailStore_resetDefaults __cb, java.util.Map<String, String> __ctx);
}
