// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Exporter.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Stateful service for generating OME-XML or OME-TIFF from data stored
 * in OMERO. Intended usage:
 * <pre>
 * 
 * ExporterPrx e = sf.createExporter();
 * 
 * // Exporter is currently in the <i>configuration</i> state
 * // Objects can be added by id which should be present
 * // in the output.
 * 
 * e.addImage(1);
 * 
 * 
 * // As soon as a generate method is called, the objects
 * // added to the Exporter are converted to the specified
 * // format. The length of the file produced is returned.
 * // No more objects can be added to the Exporter, nor can
 * // another generate method be called.
 * 
 * long length = e.generateTiff();
 * 
 * // As soon as the server-side file is generated, read()
 * // can be called to get file segments. To create another
 * // file, create a second Exporter. Be sure to close all
 * // Exporter instances.
 * 
 * long read = 0
 * byte\[] buf;
 * while (true) {
 * buf = e.read(read, 1000000);
 * // Store to file locally here
 * if (buf.length < 1000000) {
 * break;
 * }
 * read += buf.length;
 * }
 * e.close();
 * 
 * </pre>
 **/
public abstract class _ExporterDisp extends Ice.ObjectImpl implements Exporter
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::Exporter",
        "::omero::api::ServiceInterface",
        "::omero::api::StatefulServiceInterface"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __cb The callback object for the operation.
     **/
    public final void addImage_async(AMD_Exporter_addImage __cb, long id)
        throws omero.ServerError
    {
        addImage_async(__cb, id, null);
    }

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __cb The callback object for the operation.
     **/
    public final void generateTiff_async(AMD_Exporter_generateTiff __cb)
        throws omero.ServerError
    {
        generateTiff_async(__cb, null);
    }

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __cb The callback object for the operation.
     **/
    public final void generateXml_async(AMD_Exporter_generateXml __cb)
        throws omero.ServerError
    {
        generateXml_async(__cb, null);
    }

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __cb The callback object for the operation.
     **/
    public final void read_async(AMD_Exporter_read __cb, long position, int length)
        throws omero.ServerError
    {
        read_async(__cb, position, length, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public final void activate_async(AMD_StatefulServiceInterface_activate __cb)
        throws omero.ServerError
    {
        activate_async(__cb, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public final void close_async(AMD_StatefulServiceInterface_close __cb)
        throws omero.ServerError
    {
        close_async(__cb, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public final void getCurrentEventContext_async(AMD_StatefulServiceInterface_getCurrentEventContext __cb)
        throws omero.ServerError
    {
        getCurrentEventContext_async(__cb, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public final void passivate_async(AMD_StatefulServiceInterface_passivate __cb)
        throws omero.ServerError
    {
        passivate_async(__cb, null);
    }

    public static Ice.DispatchStatus ___addImage(Exporter __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long id;
        id = __is.readLong();
        __inS.endReadParams();
        AMD_Exporter_addImage __cb = new _AMD_Exporter_addImage(__inS);
        try
        {
            __obj.addImage_async(__cb, id, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___generateXml(Exporter __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        AMD_Exporter_generateXml __cb = new _AMD_Exporter_generateXml(__inS);
        try
        {
            __obj.generateXml_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___generateTiff(Exporter __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        AMD_Exporter_generateTiff __cb = new _AMD_Exporter_generateTiff(__inS);
        try
        {
            __obj.generateTiff_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___read(Exporter __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long position;
        int length;
        position = __is.readLong();
        length = __is.readInt();
        __inS.endReadParams();
        AMD_Exporter_read __cb = new _AMD_Exporter_read(__inS);
        try
        {
            __obj.read_async(__cb, position, length, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "activate",
        "addImage",
        "close",
        "generateTiff",
        "generateXml",
        "getCurrentEventContext",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "passivate",
        "read"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return _StatefulServiceInterfaceDisp.___activate(this, in, __current);
            }
            case 1:
            {
                return ___addImage(this, in, __current);
            }
            case 2:
            {
                return _StatefulServiceInterfaceDisp.___close(this, in, __current);
            }
            case 3:
            {
                return ___generateTiff(this, in, __current);
            }
            case 4:
            {
                return ___generateXml(this, in, __current);
            }
            case 5:
            {
                return _StatefulServiceInterfaceDisp.___getCurrentEventContext(this, in, __current);
            }
            case 6:
            {
                return ___ice_id(this, in, __current);
            }
            case 7:
            {
                return ___ice_ids(this, in, __current);
            }
            case 8:
            {
                return ___ice_isA(this, in, __current);
            }
            case 9:
            {
                return ___ice_ping(this, in, __current);
            }
            case 10:
            {
                return _StatefulServiceInterfaceDisp.___passivate(this, in, __current);
            }
            case 11:
            {
                return ___read(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
