// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Exporter.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Stateful service for generating OME-XML or OME-TIFF from data stored
 * in OMERO. Intended usage:
 * <pre>
 * 
 * ExporterPrx e = sf.createExporter();
 * 
 * // Exporter is currently in the <i>configuration</i> state
 * // Objects can be added by id which should be present
 * // in the output.
 * 
 * e.addImage(1);
 * 
 * 
 * // As soon as a generate method is called, the objects
 * // added to the Exporter are converted to the specified
 * // format. The length of the file produced is returned.
 * // No more objects can be added to the Exporter, nor can
 * // another generate method be called.
 * 
 * long length = e.generateTiff();
 * 
 * // As soon as the server-side file is generated, read()
 * // can be called to get file segments. To create another
 * // file, create a second Exporter. Be sure to close all
 * // Exporter instances.
 * 
 * long read = 0
 * byte\[] buf;
 * while (true) {
 * buf = e.read(read, 1000000);
 * // Store to file locally here
 * if (buf.length < 1000000) {
 * break;
 * }
 * read += buf.length;
 * }
 * e.close();
 * 
 * </pre>
 **/
public interface _ExporterOperationsNC extends _StatefulServiceInterfaceOperationsNC
{
    /**
     * Adds a single image with basic metadata to the Exporter for inclusion
     * on the next call to getBytes().
     * @param __cb The callback object for the operation.
     **/
    void addImage_async(AMD_Exporter_addImage __cb, long id)
        throws omero.ServerError;

    /**
     * Generates an OME-XML file. The return value is the length
     * of the file produced.
     * @param __cb The callback object for the operation.
     **/
    void generateXml_async(AMD_Exporter_generateXml __cb)
        throws omero.ServerError;

    /**
     * Generates an OME-TIFF file. The return value is the length
     * of the file produced. This method ends configuration.
     * @param __cb The callback object for the operation.
     **/
    void generateTiff_async(AMD_Exporter_generateTiff __cb)
        throws omero.ServerError;

    /**
     * Returns <code>length</code> bytes from the output file. The
     * file can be safely read until reset() is called.
     * @param __cb The callback object for the operation.
     **/
    void read_async(AMD_Exporter_read __cb, long position, int length)
        throws omero.ServerError;
}
