// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IAdmin.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Administration interface providing access to admin-only
 * functionality as well as JMX-based server access and selected user
 * functions. Most methods require membership in privileged
 * {@link omero.model.ExperimenterGroup groups}.
 * 
 * Methods which return {@link omero.model.Experimenter} or
 * {@link omero.model.ExperimenterGroup} instances fetch and load all
 * related instances of {@link omero.model.ExperimenterGroup} or
 * {@link omero.model.Experimenter}, respectively.
 * 
 **/
public abstract class _IAdminDisp extends Ice.ObjectImpl implements IAdmin
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IAdmin",
        "::omero::api::ServiceInterface"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     **/
    public final void addGroupOwners_async(AMD_IAdmin_addGroupOwners __cb, omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners)
        throws omero.ServerError
    {
        addGroupOwners_async(__cb, group, owners, null);
    }

    /**
     * Adds a user to the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     **/
    public final void addGroups_async(AMD_IAdmin_addGroups __cb, omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups)
        throws omero.ServerError
    {
        addGroups_async(__cb, user, groups, null);
    }

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __cb The callback object for the operation.
     **/
    public final void canUpdate_async(AMD_IAdmin_canUpdate __cb, omero.model.IObject obj)
        throws omero.ServerError
    {
        canUpdate_async(__cb, obj, null);
    }

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __cb The callback object for the operation.
     **/
    public final void changeExpiredCredentials_async(AMD_IAdmin_changeExpiredCredentials __cb, String name, String oldCred, String newCred)
        throws omero.ServerError
    {
        changeExpiredCredentials_async(__cb, name, oldCred, newCred, null);
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public final void changeGroup_async(AMD_IAdmin_changeGroup __cb, omero.model.IObject obj, String omeName)
        throws omero.ServerError
    {
        changeGroup_async(__cb, obj, omeName, null);
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public final void changeOwner_async(AMD_IAdmin_changeOwner __cb, omero.model.IObject obj, String omeName)
        throws omero.ServerError
    {
        changeOwner_async(__cb, obj, omeName, null);
    }

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     **/
    public final void changePassword_async(AMD_IAdmin_changePassword __cb, omero.RString newPassword)
        throws omero.ServerError
    {
        changePassword_async(__cb, newPassword, null);
    }

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param __cb The callback object for the operation.
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     **/
    public final void changePasswordWithOldPassword_async(AMD_IAdmin_changePasswordWithOldPassword __cb, omero.RString oldPassword, omero.RString newPassword)
        throws omero.ServerError
    {
        changePasswordWithOldPassword_async(__cb, oldPassword, newPassword, null);
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public final void changePermissions_async(AMD_IAdmin_changePermissions __cb, omero.model.IObject obj, omero.model.Permissions perms)
        throws omero.ServerError
    {
        changePermissions_async(__cb, obj, perms, null);
    }

    /**
     * Changes the password for the a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     **/
    public final void changeUserPassword_async(AMD_IAdmin_changeUserPassword __cb, String omeName, omero.RString newPassword)
        throws omero.ServerError
    {
        changeUserPassword_async(__cb, omeName, newPassword, null);
    }

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param groupId id of the ExperimenterGroup
     **/
    public final void containedExperimenters_async(AMD_IAdmin_containedExperimenters __cb, long groupId)
        throws omero.ServerError
    {
        containedExperimenters_async(__cb, groupId, null);
    }

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId id of the Experimenter. Not null.
     **/
    public final void containedGroups_async(AMD_IAdmin_containedGroups __cb, long experimenterId)
        throws omero.ServerError
    {
        containedGroups_async(__cb, experimenterId, null);
    }

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     **/
    public final void createExperimenter_async(AMD_IAdmin_createExperimenter __cb, omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups)
        throws omero.ServerError
    {
        createExperimenter_async(__cb, user, defaultGroup, groups, null);
    }

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     **/
    public final void createExperimenterWithPassword_async(AMD_IAdmin_createExperimenterWithPassword __cb, omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups)
        throws omero.ServerError
    {
        createExperimenterWithPassword_async(__cb, user, password, defaultGroup, groups, null);
    }

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param __cb The callback object for the operation.
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     **/
    public final void createGroup_async(AMD_IAdmin_createGroup __cb, omero.model.ExperimenterGroup group)
        throws omero.ServerError
    {
        createGroup_async(__cb, group, null);
    }

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     **/
    public final void createSystemUser_async(AMD_IAdmin_createSystemUser __cb, omero.model.Experimenter experimenter)
        throws omero.ServerError
    {
        createSystemUser_async(__cb, experimenter, null);
    }

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     **/
    public final void createUser_async(AMD_IAdmin_createUser __cb, omero.model.Experimenter experimenter, String group)
        throws omero.ServerError
    {
        createUser_async(__cb, experimenter, group, null);
    }

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param __cb The callback object for the operation.
     * @param user Experimenter to be deleted. Not null.
     **/
    public final void deleteExperimenter_async(AMD_IAdmin_deleteExperimenter __cb, omero.model.Experimenter user)
        throws omero.ServerError
    {
        deleteExperimenter_async(__cb, user, null);
    }

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     **/
    public final void deleteGroup_async(AMD_IAdmin_deleteGroup __cb, omero.model.ExperimenterGroup group)
        throws omero.ServerError
    {
        deleteGroup_async(__cb, group, null);
    }

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId of the Experimenter. Not null.
     **/
    public final void getDefaultGroup_async(AMD_IAdmin_getDefaultGroup __cb, long experimenterId)
        throws omero.ServerError
    {
        getDefaultGroup_async(__cb, experimenterId, null);
    }

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getEventContext_async(AMD_IAdmin_getEventContext __cb)
        throws omero.ServerError
    {
        getEventContext_async(__cb, null);
    }

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the Experimenter
     **/
    public final void getExperimenter_async(AMD_IAdmin_getExperimenter __cb, long id)
        throws omero.ServerError
    {
        getExperimenter_async(__cb, id, null);
    }

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the ExperimenterGroup
     **/
    public final void getGroup_async(AMD_IAdmin_getGroup __cb, long id)
        throws omero.ServerError
    {
        getGroup_async(__cb, id, null);
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     **/
    public final void getLeaderOfGroupIds_async(AMD_IAdmin_getLeaderOfGroupIds __cb, omero.model.Experimenter exp)
        throws omero.ServerError
    {
        getLeaderOfGroupIds_async(__cb, exp, null);
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     **/
    public final void getMemberOfGroupIds_async(AMD_IAdmin_getMemberOfGroupIds __cb, omero.model.Experimenter exp)
        throws omero.ServerError
    {
        getMemberOfGroupIds_async(__cb, exp, null);
    }

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getMyUserPhotos_async(AMD_IAdmin_getMyUserPhotos __cb)
        throws omero.ServerError
    {
        getMyUserPhotos_async(__cb, null);
    }

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getSecurityRoles_async(AMD_IAdmin_getSecurityRoles __cb)
        throws omero.ServerError
    {
        getSecurityRoles_async(__cb, null);
    }

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the Experimenter
     **/
    public final void lookupExperimenter_async(AMD_IAdmin_lookupExperimenter __cb, String name)
        throws omero.ServerError
    {
        lookupExperimenter_async(__cb, name, null);
    }

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void lookupExperimenters_async(AMD_IAdmin_lookupExperimenters __cb)
        throws omero.ServerError
    {
        lookupExperimenters_async(__cb, null);
    }

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the ExperimenterGroup
     **/
    public final void lookupGroup_async(AMD_IAdmin_lookupGroup __cb, String name)
        throws omero.ServerError
    {
        lookupGroup_async(__cb, name, null);
    }

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void lookupGroups_async(AMD_IAdmin_lookupGroups __cb)
        throws omero.ServerError
    {
        lookupGroups_async(__cb, null);
    }

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void lookupLdapAuthExperimenter_async(AMD_IAdmin_lookupLdapAuthExperimenter __cb, long id)
        throws omero.ServerError
    {
        lookupLdapAuthExperimenter_async(__cb, id, null);
    }

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void lookupLdapAuthExperimenters_async(AMD_IAdmin_lookupLdapAuthExperimenters __cb)
        throws omero.ServerError
    {
        lookupLdapAuthExperimenters_async(__cb, null);
    }

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param __cb The callback object for the operation.
     * @param objects
     **/
    public final void moveToCommonSpace_async(AMD_IAdmin_moveToCommonSpace __cb, java.util.List<omero.model.IObject> objects)
        throws omero.ServerError
    {
        moveToCommonSpace_async(__cb, objects, null);
    }

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     **/
    public final void removeGroupOwners_async(AMD_IAdmin_removeGroupOwners __cb, omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners)
        throws omero.ServerError
    {
        removeGroupOwners_async(__cb, group, owners, null);
    }

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     **/
    public final void removeGroups_async(AMD_IAdmin_removeGroups __cb, omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups)
        throws omero.ServerError
    {
        removeGroups_async(__cb, user, groups, null);
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public final void reportForgottenPassword_async(AMD_IAdmin_reportForgottenPassword __cb, String name, String email)
        throws omero.ServerError
    {
        reportForgottenPassword_async(__cb, name, email, null);
    }

    /**
     * Sets the default group for a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     **/
    public final void setDefaultGroup_async(AMD_IAdmin_setDefaultGroup __cb, omero.model.Experimenter user, omero.model.ExperimenterGroup group)
        throws omero.ServerError
    {
        setDefaultGroup_async(__cb, user, group, null);
    }

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     **/
    public final void setGroupOwner_async(AMD_IAdmin_setGroupOwner __cb, omero.model.ExperimenterGroup group, omero.model.Experimenter owner)
        throws omero.ServerError
    {
        setGroupOwner_async(__cb, group, owner, null);
    }

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __cb The callback object for the operation.
     **/
    public final void synchronizeLoginCache_async(AMD_IAdmin_synchronizeLoginCache __cb)
        throws omero.ServerError
    {
        synchronizeLoginCache_async(__cb, null);
    }

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     **/
    public final void unsetGroupOwner_async(AMD_IAdmin_unsetGroupOwner __cb, omero.model.ExperimenterGroup group, omero.model.Experimenter owner)
        throws omero.ServerError
    {
        unsetGroupOwner_async(__cb, group, owner, null);
    }

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     **/
    public final void updateExperimenter_async(AMD_IAdmin_updateExperimenter __cb, omero.model.Experimenter experimenter)
        throws omero.ServerError
    {
        updateExperimenter_async(__cb, experimenter, null);
    }

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     **/
    public final void updateExperimenterWithPassword_async(AMD_IAdmin_updateExperimenterWithPassword __cb, omero.model.Experimenter experimenter, omero.RString password)
        throws omero.ServerError
    {
        updateExperimenterWithPassword_async(__cb, experimenter, password, null);
    }

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param __cb The callback object for the operation.
     * @param group the ExperimenterGroup to update.
     **/
    public final void updateGroup_async(AMD_IAdmin_updateGroup __cb, omero.model.ExperimenterGroup group)
        throws omero.ServerError
    {
        updateGroup_async(__cb, group, null);
    }

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     **/
    public final void updateSelf_async(AMD_IAdmin_updateSelf __cb, omero.model.Experimenter experimenter)
        throws omero.ServerError
    {
        updateSelf_async(__cb, experimenter, null);
    }

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param __cb The callback object for the operation.
     * @param filename Not null. String name which will be used.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     **/
    public final void uploadMyUserPhoto_async(AMD_IAdmin_uploadMyUserPhoto __cb, String filename, String format, byte[] data)
        throws omero.ServerError
    {
        uploadMyUserPhoto_async(__cb, filename, format, data, null);
    }

    public static Ice.DispatchStatus ___canUpdate(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.IObjectHolder obj = new omero.model.IObjectHolder();
        __is.readObject(obj);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_canUpdate __cb = new _AMD_IAdmin_canUpdate(__inS);
        try
        {
            __obj.canUpdate_async(__cb, obj.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getExperimenter(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long id;
        id = __is.readLong();
        __inS.endReadParams();
        AMD_IAdmin_getExperimenter __cb = new _AMD_IAdmin_getExperimenter(__inS);
        try
        {
            __obj.getExperimenter_async(__cb, id, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___lookupExperimenter(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String name;
        name = __is.readString();
        __inS.endReadParams();
        AMD_IAdmin_lookupExperimenter __cb = new _AMD_IAdmin_lookupExperimenter(__inS);
        try
        {
            __obj.lookupExperimenter_async(__cb, name, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___lookupExperimenters(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_IAdmin_lookupExperimenters __cb = new _AMD_IAdmin_lookupExperimenters(__inS);
        try
        {
            __obj.lookupExperimenters_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getGroup(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long id;
        id = __is.readLong();
        __inS.endReadParams();
        AMD_IAdmin_getGroup __cb = new _AMD_IAdmin_getGroup(__inS);
        try
        {
            __obj.getGroup_async(__cb, id, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___lookupGroup(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String name;
        name = __is.readString();
        __inS.endReadParams();
        AMD_IAdmin_lookupGroup __cb = new _AMD_IAdmin_lookupGroup(__inS);
        try
        {
            __obj.lookupGroup_async(__cb, name, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___lookupGroups(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_IAdmin_lookupGroups __cb = new _AMD_IAdmin_lookupGroups(__inS);
        try
        {
            __obj.lookupGroups_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___containedExperimenters(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long groupId;
        groupId = __is.readLong();
        __inS.endReadParams();
        AMD_IAdmin_containedExperimenters __cb = new _AMD_IAdmin_containedExperimenters(__inS);
        try
        {
            __obj.containedExperimenters_async(__cb, groupId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___containedGroups(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long experimenterId;
        experimenterId = __is.readLong();
        __inS.endReadParams();
        AMD_IAdmin_containedGroups __cb = new _AMD_IAdmin_containedGroups(__inS);
        try
        {
            __obj.containedGroups_async(__cb, experimenterId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getDefaultGroup(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long experimenterId;
        experimenterId = __is.readLong();
        __inS.endReadParams();
        AMD_IAdmin_getDefaultGroup __cb = new _AMD_IAdmin_getDefaultGroup(__inS);
        try
        {
            __obj.getDefaultGroup_async(__cb, experimenterId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___lookupLdapAuthExperimenter(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long id;
        id = __is.readLong();
        __inS.endReadParams();
        AMD_IAdmin_lookupLdapAuthExperimenter __cb = new _AMD_IAdmin_lookupLdapAuthExperimenter(__inS);
        try
        {
            __obj.lookupLdapAuthExperimenter_async(__cb, id, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___lookupLdapAuthExperimenters(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_IAdmin_lookupLdapAuthExperimenters __cb = new _AMD_IAdmin_lookupLdapAuthExperimenters(__inS);
        try
        {
            __obj.lookupLdapAuthExperimenters_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getMemberOfGroupIds(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterHolder exp = new omero.model.ExperimenterHolder();
        __is.readObject(exp);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_getMemberOfGroupIds __cb = new _AMD_IAdmin_getMemberOfGroupIds(__inS);
        try
        {
            __obj.getMemberOfGroupIds_async(__cb, exp.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getLeaderOfGroupIds(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterHolder exp = new omero.model.ExperimenterHolder();
        __is.readObject(exp);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_getLeaderOfGroupIds __cb = new _AMD_IAdmin_getLeaderOfGroupIds(__inS);
        try
        {
            __obj.getLeaderOfGroupIds_async(__cb, exp.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___updateSelf(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterHolder experimenter = new omero.model.ExperimenterHolder();
        __is.readObject(experimenter);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_updateSelf __cb = new _AMD_IAdmin_updateSelf(__inS);
        try
        {
            __obj.updateSelf_async(__cb, experimenter.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___uploadMyUserPhoto(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String filename;
        String format;
        byte[] data;
        filename = __is.readString();
        format = __is.readString();
        data = Ice.ByteSeqHelper.read(__is);
        __inS.endReadParams();
        AMD_IAdmin_uploadMyUserPhoto __cb = new _AMD_IAdmin_uploadMyUserPhoto(__inS);
        try
        {
            __obj.uploadMyUserPhoto_async(__cb, filename, format, data, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getMyUserPhotos(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_IAdmin_getMyUserPhotos __cb = new _AMD_IAdmin_getMyUserPhotos(__inS);
        try
        {
            __obj.getMyUserPhotos_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___updateExperimenter(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterHolder experimenter = new omero.model.ExperimenterHolder();
        __is.readObject(experimenter);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_updateExperimenter __cb = new _AMD_IAdmin_updateExperimenter(__inS);
        try
        {
            __obj.updateExperimenter_async(__cb, experimenter.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___updateExperimenterWithPassword(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterHolder experimenter = new omero.model.ExperimenterHolder();
        omero.RStringHolder password = new omero.RStringHolder();
        __is.readObject(experimenter);
        __is.readObject(password);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_updateExperimenterWithPassword __cb = new _AMD_IAdmin_updateExperimenterWithPassword(__inS);
        try
        {
            __obj.updateExperimenterWithPassword_async(__cb, experimenter.value, password.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___updateGroup(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterGroupHolder group = new omero.model.ExperimenterGroupHolder();
        __is.readObject(group);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_updateGroup __cb = new _AMD_IAdmin_updateGroup(__inS);
        try
        {
            __obj.updateGroup_async(__cb, group.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___createUser(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterHolder experimenter = new omero.model.ExperimenterHolder();
        String group;
        __is.readObject(experimenter);
        group = __is.readString();
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_createUser __cb = new _AMD_IAdmin_createUser(__inS);
        try
        {
            __obj.createUser_async(__cb, experimenter.value, group, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___createSystemUser(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterHolder experimenter = new omero.model.ExperimenterHolder();
        __is.readObject(experimenter);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_createSystemUser __cb = new _AMD_IAdmin_createSystemUser(__inS);
        try
        {
            __obj.createSystemUser_async(__cb, experimenter.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___createExperimenter(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterHolder user = new omero.model.ExperimenterHolder();
        omero.model.ExperimenterGroupHolder defaultGroup = new omero.model.ExperimenterGroupHolder();
        java.util.List<omero.model.ExperimenterGroup> groups;
        __is.readObject(user);
        __is.readObject(defaultGroup);
        groups = ExperimenterGroupListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_createExperimenter __cb = new _AMD_IAdmin_createExperimenter(__inS);
        try
        {
            __obj.createExperimenter_async(__cb, user.value, defaultGroup.value, groups, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___createExperimenterWithPassword(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterHolder user = new omero.model.ExperimenterHolder();
        omero.RStringHolder password = new omero.RStringHolder();
        omero.model.ExperimenterGroupHolder defaultGroup = new omero.model.ExperimenterGroupHolder();
        java.util.List<omero.model.ExperimenterGroup> groups;
        __is.readObject(user);
        __is.readObject(password);
        __is.readObject(defaultGroup);
        groups = ExperimenterGroupListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_createExperimenterWithPassword __cb = new _AMD_IAdmin_createExperimenterWithPassword(__inS);
        try
        {
            __obj.createExperimenterWithPassword_async(__cb, user.value, password.value, defaultGroup.value, groups, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___createGroup(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterGroupHolder group = new omero.model.ExperimenterGroupHolder();
        __is.readObject(group);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_createGroup __cb = new _AMD_IAdmin_createGroup(__inS);
        try
        {
            __obj.createGroup_async(__cb, group.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___addGroups(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterHolder user = new omero.model.ExperimenterHolder();
        java.util.List<omero.model.ExperimenterGroup> groups;
        __is.readObject(user);
        groups = ExperimenterGroupListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_addGroups __cb = new _AMD_IAdmin_addGroups(__inS);
        try
        {
            __obj.addGroups_async(__cb, user.value, groups, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___removeGroups(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterHolder user = new omero.model.ExperimenterHolder();
        java.util.List<omero.model.ExperimenterGroup> groups;
        __is.readObject(user);
        groups = ExperimenterGroupListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_removeGroups __cb = new _AMD_IAdmin_removeGroups(__inS);
        try
        {
            __obj.removeGroups_async(__cb, user.value, groups, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setDefaultGroup(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterHolder user = new omero.model.ExperimenterHolder();
        omero.model.ExperimenterGroupHolder group = new omero.model.ExperimenterGroupHolder();
        __is.readObject(user);
        __is.readObject(group);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_setDefaultGroup __cb = new _AMD_IAdmin_setDefaultGroup(__inS);
        try
        {
            __obj.setDefaultGroup_async(__cb, user.value, group.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setGroupOwner(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterGroupHolder group = new omero.model.ExperimenterGroupHolder();
        omero.model.ExperimenterHolder owner = new omero.model.ExperimenterHolder();
        __is.readObject(group);
        __is.readObject(owner);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_setGroupOwner __cb = new _AMD_IAdmin_setGroupOwner(__inS);
        try
        {
            __obj.setGroupOwner_async(__cb, group.value, owner.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___unsetGroupOwner(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterGroupHolder group = new omero.model.ExperimenterGroupHolder();
        omero.model.ExperimenterHolder owner = new omero.model.ExperimenterHolder();
        __is.readObject(group);
        __is.readObject(owner);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_unsetGroupOwner __cb = new _AMD_IAdmin_unsetGroupOwner(__inS);
        try
        {
            __obj.unsetGroupOwner_async(__cb, group.value, owner.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___addGroupOwners(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterGroupHolder group = new omero.model.ExperimenterGroupHolder();
        java.util.List<omero.model.Experimenter> owners;
        __is.readObject(group);
        owners = ExperimenterListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_addGroupOwners __cb = new _AMD_IAdmin_addGroupOwners(__inS);
        try
        {
            __obj.addGroupOwners_async(__cb, group.value, owners, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___removeGroupOwners(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterGroupHolder group = new omero.model.ExperimenterGroupHolder();
        java.util.List<omero.model.Experimenter> owners;
        __is.readObject(group);
        owners = ExperimenterListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_removeGroupOwners __cb = new _AMD_IAdmin_removeGroupOwners(__inS);
        try
        {
            __obj.removeGroupOwners_async(__cb, group.value, owners, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___deleteExperimenter(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterHolder user = new omero.model.ExperimenterHolder();
        __is.readObject(user);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_deleteExperimenter __cb = new _AMD_IAdmin_deleteExperimenter(__inS);
        try
        {
            __obj.deleteExperimenter_async(__cb, user.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___deleteGroup(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterGroupHolder group = new omero.model.ExperimenterGroupHolder();
        __is.readObject(group);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_deleteGroup __cb = new _AMD_IAdmin_deleteGroup(__inS);
        try
        {
            __obj.deleteGroup_async(__cb, group.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___changeOwner(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.IObjectHolder obj = new omero.model.IObjectHolder();
        String omeName;
        __is.readObject(obj);
        omeName = __is.readString();
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_changeOwner __cb = new _AMD_IAdmin_changeOwner(__inS);
        try
        {
            __obj.changeOwner_async(__cb, obj.value, omeName, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___changeGroup(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.IObjectHolder obj = new omero.model.IObjectHolder();
        String omeName;
        __is.readObject(obj);
        omeName = __is.readString();
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_changeGroup __cb = new _AMD_IAdmin_changeGroup(__inS);
        try
        {
            __obj.changeGroup_async(__cb, obj.value, omeName, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___changePermissions(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.IObjectHolder obj = new omero.model.IObjectHolder();
        omero.model.PermissionsHolder perms = new omero.model.PermissionsHolder();
        __is.readObject(obj);
        __is.readObject(perms);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_changePermissions __cb = new _AMD_IAdmin_changePermissions(__inS);
        try
        {
            __obj.changePermissions_async(__cb, obj.value, perms.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___moveToCommonSpace(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<omero.model.IObject> objects;
        objects = IObjectListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_moveToCommonSpace __cb = new _AMD_IAdmin_moveToCommonSpace(__inS);
        try
        {
            __obj.moveToCommonSpace_async(__cb, objects, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___changePassword(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.RStringHolder newPassword = new omero.RStringHolder();
        __is.readObject(newPassword);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_changePassword __cb = new _AMD_IAdmin_changePassword(__inS);
        try
        {
            __obj.changePassword_async(__cb, newPassword.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___changePasswordWithOldPassword(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.RStringHolder oldPassword = new omero.RStringHolder();
        omero.RStringHolder newPassword = new omero.RStringHolder();
        __is.readObject(oldPassword);
        __is.readObject(newPassword);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_changePasswordWithOldPassword __cb = new _AMD_IAdmin_changePasswordWithOldPassword(__inS);
        try
        {
            __obj.changePasswordWithOldPassword_async(__cb, oldPassword.value, newPassword.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___changeUserPassword(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String omeName;
        omero.RStringHolder newPassword = new omero.RStringHolder();
        omeName = __is.readString();
        __is.readObject(newPassword);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IAdmin_changeUserPassword __cb = new _AMD_IAdmin_changeUserPassword(__inS);
        try
        {
            __obj.changeUserPassword_async(__cb, omeName, newPassword.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___synchronizeLoginCache(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_IAdmin_synchronizeLoginCache __cb = new _AMD_IAdmin_synchronizeLoginCache(__inS);
        try
        {
            __obj.synchronizeLoginCache_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___changeExpiredCredentials(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String name;
        String oldCred;
        String newCred;
        name = __is.readString();
        oldCred = __is.readString();
        newCred = __is.readString();
        __inS.endReadParams();
        AMD_IAdmin_changeExpiredCredentials __cb = new _AMD_IAdmin_changeExpiredCredentials(__inS);
        try
        {
            __obj.changeExpiredCredentials_async(__cb, name, oldCred, newCred, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___reportForgottenPassword(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String name;
        String email;
        name = __is.readString();
        email = __is.readString();
        __inS.endReadParams();
        AMD_IAdmin_reportForgottenPassword __cb = new _AMD_IAdmin_reportForgottenPassword(__inS);
        try
        {
            __obj.reportForgottenPassword_async(__cb, name, email, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getSecurityRoles(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_IAdmin_getSecurityRoles __cb = new _AMD_IAdmin_getSecurityRoles(__inS);
        try
        {
            __obj.getSecurityRoles_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getEventContext(IAdmin __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_IAdmin_getEventContext __cb = new _AMD_IAdmin_getEventContext(__inS);
        try
        {
            __obj.getEventContext_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "addGroupOwners",
        "addGroups",
        "canUpdate",
        "changeExpiredCredentials",
        "changeGroup",
        "changeOwner",
        "changePassword",
        "changePasswordWithOldPassword",
        "changePermissions",
        "changeUserPassword",
        "containedExperimenters",
        "containedGroups",
        "createExperimenter",
        "createExperimenterWithPassword",
        "createGroup",
        "createSystemUser",
        "createUser",
        "deleteExperimenter",
        "deleteGroup",
        "getDefaultGroup",
        "getEventContext",
        "getExperimenter",
        "getGroup",
        "getLeaderOfGroupIds",
        "getMemberOfGroupIds",
        "getMyUserPhotos",
        "getSecurityRoles",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "lookupExperimenter",
        "lookupExperimenters",
        "lookupGroup",
        "lookupGroups",
        "lookupLdapAuthExperimenter",
        "lookupLdapAuthExperimenters",
        "moveToCommonSpace",
        "removeGroupOwners",
        "removeGroups",
        "reportForgottenPassword",
        "setDefaultGroup",
        "setGroupOwner",
        "synchronizeLoginCache",
        "unsetGroupOwner",
        "updateExperimenter",
        "updateExperimenterWithPassword",
        "updateGroup",
        "updateSelf",
        "uploadMyUserPhoto"
    };

    @SuppressWarnings("deprecation")
    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___addGroupOwners(this, in, __current);
            }
            case 1:
            {
                return ___addGroups(this, in, __current);
            }
            case 2:
            {
                return ___canUpdate(this, in, __current);
            }
            case 3:
            {
                return ___changeExpiredCredentials(this, in, __current);
            }
            case 4:
            {
                return ___changeGroup(this, in, __current);
            }
            case 5:
            {
                return ___changeOwner(this, in, __current);
            }
            case 6:
            {
                return ___changePassword(this, in, __current);
            }
            case 7:
            {
                return ___changePasswordWithOldPassword(this, in, __current);
            }
            case 8:
            {
                return ___changePermissions(this, in, __current);
            }
            case 9:
            {
                return ___changeUserPassword(this, in, __current);
            }
            case 10:
            {
                return ___containedExperimenters(this, in, __current);
            }
            case 11:
            {
                return ___containedGroups(this, in, __current);
            }
            case 12:
            {
                return ___createExperimenter(this, in, __current);
            }
            case 13:
            {
                return ___createExperimenterWithPassword(this, in, __current);
            }
            case 14:
            {
                return ___createGroup(this, in, __current);
            }
            case 15:
            {
                return ___createSystemUser(this, in, __current);
            }
            case 16:
            {
                return ___createUser(this, in, __current);
            }
            case 17:
            {
                return ___deleteExperimenter(this, in, __current);
            }
            case 18:
            {
                return ___deleteGroup(this, in, __current);
            }
            case 19:
            {
                return ___getDefaultGroup(this, in, __current);
            }
            case 20:
            {
                return ___getEventContext(this, in, __current);
            }
            case 21:
            {
                return ___getExperimenter(this, in, __current);
            }
            case 22:
            {
                return ___getGroup(this, in, __current);
            }
            case 23:
            {
                return ___getLeaderOfGroupIds(this, in, __current);
            }
            case 24:
            {
                return ___getMemberOfGroupIds(this, in, __current);
            }
            case 25:
            {
                return ___getMyUserPhotos(this, in, __current);
            }
            case 26:
            {
                return ___getSecurityRoles(this, in, __current);
            }
            case 27:
            {
                return ___ice_id(this, in, __current);
            }
            case 28:
            {
                return ___ice_ids(this, in, __current);
            }
            case 29:
            {
                return ___ice_isA(this, in, __current);
            }
            case 30:
            {
                return ___ice_ping(this, in, __current);
            }
            case 31:
            {
                return ___lookupExperimenter(this, in, __current);
            }
            case 32:
            {
                return ___lookupExperimenters(this, in, __current);
            }
            case 33:
            {
                return ___lookupGroup(this, in, __current);
            }
            case 34:
            {
                return ___lookupGroups(this, in, __current);
            }
            case 35:
            {
                return ___lookupLdapAuthExperimenter(this, in, __current);
            }
            case 36:
            {
                return ___lookupLdapAuthExperimenters(this, in, __current);
            }
            case 37:
            {
                return ___moveToCommonSpace(this, in, __current);
            }
            case 38:
            {
                return ___removeGroupOwners(this, in, __current);
            }
            case 39:
            {
                return ___removeGroups(this, in, __current);
            }
            case 40:
            {
                return ___reportForgottenPassword(this, in, __current);
            }
            case 41:
            {
                return ___setDefaultGroup(this, in, __current);
            }
            case 42:
            {
                return ___setGroupOwner(this, in, __current);
            }
            case 43:
            {
                return ___synchronizeLoginCache(this, in, __current);
            }
            case 44:
            {
                return ___unsetGroupOwner(this, in, __current);
            }
            case 45:
            {
                return ___updateExperimenter(this, in, __current);
            }
            case 46:
            {
                return ___updateExperimenterWithPassword(this, in, __current);
            }
            case 47:
            {
                return ___updateGroup(this, in, __current);
            }
            case 48:
            {
                return ___updateSelf(this, in, __current);
            }
            case 49:
            {
                return ___uploadMyUserPhoto(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
