// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IAdmin.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Administration interface providing access to admin-only
 * functionality as well as JMX-based server access and selected user
 * functions. Most methods require membership in privileged
 * {@link omero.model.ExperimenterGroup groups}.
 * 
 * Methods which return {@link omero.model.Experimenter} or
 * {@link omero.model.ExperimenterGroup} instances fetch and load all
 * related instances of {@link omero.model.ExperimenterGroup} or
 * {@link omero.model.Experimenter}, respectively.
 * 
 **/
public interface _IAdminOperations extends _ServiceInterfaceOperations
{
    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void canUpdate_async(AMD_IAdmin_canUpdate __cb, omero.model.IObject obj, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the Experimenter
     * @param __current The Current object for the invocation.
     **/
    void getExperimenter_async(AMD_IAdmin_getExperimenter __cb, long id, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the Experimenter
     * @param __current The Current object for the invocation.
     **/
    void lookupExperimenter_async(AMD_IAdmin_lookupExperimenter __cb, String name, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void lookupExperimenters_async(AMD_IAdmin_lookupExperimenters __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the ExperimenterGroup
     * @param __current The Current object for the invocation.
     **/
    void getGroup_async(AMD_IAdmin_getGroup __cb, long id, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the ExperimenterGroup
     * @param __current The Current object for the invocation.
     **/
    void lookupGroup_async(AMD_IAdmin_lookupGroup __cb, String name, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void lookupGroups_async(AMD_IAdmin_lookupGroups __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param groupId id of the ExperimenterGroup
     * @param __current The Current object for the invocation.
     **/
    void containedExperimenters_async(AMD_IAdmin_containedExperimenters __cb, long groupId, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId id of the Experimenter. Not null.
     * @param __current The Current object for the invocation.
     **/
    void containedGroups_async(AMD_IAdmin_containedGroups __cb, long experimenterId, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId of the Experimenter. Not null.
     * @param __current The Current object for the invocation.
     **/
    void getDefaultGroup_async(AMD_IAdmin_getDefaultGroup __cb, long experimenterId, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void lookupLdapAuthExperimenter_async(AMD_IAdmin_lookupLdapAuthExperimenter __cb, long id, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void lookupLdapAuthExperimenters_async(AMD_IAdmin_lookupLdapAuthExperimenters __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     * @param __current The Current object for the invocation.
     **/
    void getMemberOfGroupIds_async(AMD_IAdmin_getMemberOfGroupIds __cb, omero.model.Experimenter exp, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     * @param __current The Current object for the invocation.
     **/
    void getLeaderOfGroupIds_async(AMD_IAdmin_getLeaderOfGroupIds __cb, omero.model.Experimenter exp, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     * @param __current The Current object for the invocation.
     **/
    void updateSelf_async(AMD_IAdmin_updateSelf __cb, omero.model.Experimenter experimenter, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param __cb The callback object for the operation.
     * @param filename Not null. String name which will be used.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     * @param __current The Current object for the invocation.
     **/
    void uploadMyUserPhoto_async(AMD_IAdmin_uploadMyUserPhoto __cb, String filename, String format, byte[] data, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getMyUserPhotos_async(AMD_IAdmin_getMyUserPhotos __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     * @param __current The Current object for the invocation.
     **/
    void updateExperimenter_async(AMD_IAdmin_updateExperimenter __cb, omero.model.Experimenter experimenter, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     * @param __current The Current object for the invocation.
     **/
    void updateExperimenterWithPassword_async(AMD_IAdmin_updateExperimenterWithPassword __cb, omero.model.Experimenter experimenter, omero.RString password, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param __cb The callback object for the operation.
     * @param group the ExperimenterGroup to update.
     * @param __current The Current object for the invocation.
     **/
    void updateGroup_async(AMD_IAdmin_updateGroup __cb, omero.model.ExperimenterGroup group, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     * @param __current The Current object for the invocation.
     **/
    void createUser_async(AMD_IAdmin_createUser __cb, omero.model.Experimenter experimenter, String group, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param __current The Current object for the invocation.
     **/
    void createSystemUser_async(AMD_IAdmin_createSystemUser __cb, omero.model.Experimenter experimenter, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __current The Current object for the invocation.
     **/
    void createExperimenter_async(AMD_IAdmin_createExperimenter __cb, omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __current The Current object for the invocation.
     **/
    void createExperimenterWithPassword_async(AMD_IAdmin_createExperimenterWithPassword __cb, omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param __cb The callback object for the operation.
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     * @param __current The Current object for the invocation.
     **/
    void createGroup_async(AMD_IAdmin_createGroup __cb, omero.model.ExperimenterGroup group, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Adds a user to the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     * @param __current The Current object for the invocation.
     **/
    void addGroups_async(AMD_IAdmin_addGroups __cb, omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     * @param __current The Current object for the invocation.
     **/
    void removeGroups_async(AMD_IAdmin_removeGroups __cb, omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Sets the default group for a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     * @param __current The Current object for the invocation.
     **/
    void setDefaultGroup_async(AMD_IAdmin_setDefaultGroup __cb, omero.model.Experimenter user, omero.model.ExperimenterGroup group, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __current The Current object for the invocation.
     **/
    void setGroupOwner_async(AMD_IAdmin_setGroupOwner __cb, omero.model.ExperimenterGroup group, omero.model.Experimenter owner, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __current The Current object for the invocation.
     **/
    void unsetGroupOwner_async(AMD_IAdmin_unsetGroupOwner __cb, omero.model.ExperimenterGroup group, omero.model.Experimenter owner, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __current The Current object for the invocation.
     **/
    void addGroupOwners_async(AMD_IAdmin_addGroupOwners __cb, omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, Ice.Current __current)
        throws omero.ServerError;

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __current The Current object for the invocation.
     **/
    void removeGroupOwners_async(AMD_IAdmin_removeGroupOwners __cb, omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param __cb The callback object for the operation.
     * @param user Experimenter to be deleted. Not null.
     * @param __current The Current object for the invocation.
     **/
    void deleteExperimenter_async(AMD_IAdmin_deleteExperimenter __cb, omero.model.Experimenter user, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     * @param __current The Current object for the invocation.
     **/
    void deleteGroup_async(AMD_IAdmin_deleteGroup __cb, omero.model.ExperimenterGroup group, Ice.Current __current)
        throws omero.ServerError;

    /**
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void changeOwner_async(AMD_IAdmin_changeOwner __cb, omero.model.IObject obj, String omeName, Ice.Current __current)
        throws omero.ServerError;

    /**
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void changeGroup_async(AMD_IAdmin_changeGroup __cb, omero.model.IObject obj, String omeName, Ice.Current __current)
        throws omero.ServerError;

    /**
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void changePermissions_async(AMD_IAdmin_changePermissions __cb, omero.model.IObject obj, omero.model.Permissions perms, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param __cb The callback object for the operation.
     * @param objects
     * @param __current The Current object for the invocation.
     **/
    void moveToCommonSpace_async(AMD_IAdmin_moveToCommonSpace __cb, java.util.List<omero.model.IObject> objects, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __current The Current object for the invocation.
     **/
    void changePassword_async(AMD_IAdmin_changePassword __cb, omero.RString newPassword, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param __cb The callback object for the operation.
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __current The Current object for the invocation.
     **/
    void changePasswordWithOldPassword_async(AMD_IAdmin_changePasswordWithOldPassword __cb, omero.RString oldPassword, omero.RString newPassword, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Changes the password for the a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     * @param __current The Current object for the invocation.
     **/
    void changeUserPassword_async(AMD_IAdmin_changeUserPassword __cb, String omeName, omero.RString newPassword, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void synchronizeLoginCache_async(AMD_IAdmin_synchronizeLoginCache __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void changeExpiredCredentials_async(AMD_IAdmin_changeExpiredCredentials __cb, String name, String oldCred, String newCred, Ice.Current __current)
        throws omero.ServerError;

    /**
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void reportForgottenPassword_async(AMD_IAdmin_reportForgottenPassword __cb, String name, String email, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getSecurityRoles_async(AMD_IAdmin_getSecurityRoles __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getEventContext_async(AMD_IAdmin_getEventContext __cb, Ice.Current __current)
        throws omero.ServerError;
}
