// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `ILdap.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Administration interface providing access to admin-only
 * functionality as well as JMX-based server access and selected user
 * functions. Most methods require membership in privileged
 * {@link omero.model.ExperimenterGroup} groups.
 * 
 * Methods which return {@link omero.model.Experimenter} or
 * {@link omero.model.ExperimenterGroup} instances fetch and load all
 * related instances of {@link omero.model.ExperimenterGroup} or
 * {@link omero.model.Experimenter}, respectively.
 **/
public abstract class _ILdapDisp extends Ice.ObjectImpl implements ILdap
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::ILdap",
        "::omero::api::ServiceInterface"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param __cb The callback object for the operation.
     * @param username
     **/
    public final void createUser_async(AMD_ILdap_createUser __cb, String username)
        throws omero.ServerError
    {
        createUser_async(__cb, username, null);
    }

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void discover_async(AMD_ILdap_discover __cb)
        throws omero.ServerError
    {
        discover_async(__cb, null);
    }

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void discoverGroups_async(AMD_ILdap_discoverGroups __cb)
        throws omero.ServerError
    {
        discoverGroups_async(__cb, null);
    }

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     **/
    public final void findDN_async(AMD_ILdap_findDN __cb, String username)
        throws omero.ServerError
    {
        findDN_async(__cb, username, null);
    }

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     **/
    public final void findExperimenter_async(AMD_ILdap_findExperimenter __cb, String username)
        throws omero.ServerError
    {
        findExperimenter_async(__cb, username, null);
    }

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param groupname
     **/
    public final void findGroup_async(AMD_ILdap_findGroup __cb, String groupname)
        throws omero.ServerError
    {
        findGroup_async(__cb, groupname, null);
    }

    /**
     * Looks up the DN for a group.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void findGroupDN_async(AMD_ILdap_findGroupDN __cb, String groupname)
        throws omero.ServerError
    {
        findGroupDN_async(__cb, groupname, null);
    }

    /**
     * Gets config value from properties.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getSetting_async(AMD_ILdap_getSetting __cb)
        throws omero.ServerError
    {
        getSetting_async(__cb, null);
    }

    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void searchAll_async(AMD_ILdap_searchAll __cb)
        throws omero.ServerError
    {
        searchAll_async(__cb, null);
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param __cb The callback object for the operation.
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     **/
    public final void searchByAttribute_async(AMD_ILdap_searchByAttribute __cb, String dn, String attribute, String value)
        throws omero.ServerError
    {
        searchByAttribute_async(__cb, dn, attribute, value, null);
    }

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param __cb The callback object for the operation.
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     **/
    public final void searchByAttributes_async(AMD_ILdap_searchByAttributes __cb, String dn, java.util.List<String> attributes, java.util.List<String> values)
        throws omero.ServerError
    {
        searchByAttributes_async(__cb, dn, attributes, values, null);
    }

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param __cb The callback object for the operation.
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     **/
    public final void searchByDN_async(AMD_ILdap_searchByDN __cb, String userdn)
        throws omero.ServerError
    {
        searchByDN_async(__cb, userdn, null);
    }

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param __cb The callback object for the operation.
     * @param attr   Name of member attribute. Never null or empty.
     **/
    public final void searchDnInGroups_async(AMD_ILdap_searchDnInGroups __cb, String attr, String value)
        throws omero.ServerError
    {
        searchDnInGroups_async(__cb, attr, value, null);
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public final void setDN_async(AMD_ILdap_setDN __cb, omero.RLong experimenterID, String dn)
        throws omero.ServerError
    {
        setDN_async(__cb, experimenterID, dn, null);
    }

    public static Ice.DispatchStatus ___searchAll(ILdap __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_ILdap_searchAll __cb = new _AMD_ILdap_searchAll(__inS);
        try
        {
            __obj.searchAll_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___searchDnInGroups(ILdap __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String attr;
        String value;
        attr = __is.readString();
        value = __is.readString();
        __inS.endReadParams();
        AMD_ILdap_searchDnInGroups __cb = new _AMD_ILdap_searchDnInGroups(__inS);
        try
        {
            __obj.searchDnInGroups_async(__cb, attr, value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___searchByAttribute(ILdap __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String dn;
        String attribute;
        String value;
        dn = __is.readString();
        attribute = __is.readString();
        value = __is.readString();
        __inS.endReadParams();
        AMD_ILdap_searchByAttribute __cb = new _AMD_ILdap_searchByAttribute(__inS);
        try
        {
            __obj.searchByAttribute_async(__cb, dn, attribute, value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___searchByAttributes(ILdap __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String dn;
        java.util.List<String> attributes;
        java.util.List<String> values;
        dn = __is.readString();
        attributes = StringSetHelper.read(__is);
        values = StringSetHelper.read(__is);
        __inS.endReadParams();
        AMD_ILdap_searchByAttributes __cb = new _AMD_ILdap_searchByAttributes(__inS);
        try
        {
            __obj.searchByAttributes_async(__cb, dn, attributes, values, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___searchByDN(ILdap __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String userdn;
        userdn = __is.readString();
        __inS.endReadParams();
        AMD_ILdap_searchByDN __cb = new _AMD_ILdap_searchByDN(__inS);
        try
        {
            __obj.searchByDN_async(__cb, userdn, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___findDN(ILdap __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String username;
        username = __is.readString();
        __inS.endReadParams();
        AMD_ILdap_findDN __cb = new _AMD_ILdap_findDN(__inS);
        try
        {
            __obj.findDN_async(__cb, username, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___findGroupDN(ILdap __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String groupname;
        groupname = __is.readString();
        __inS.endReadParams();
        AMD_ILdap_findGroupDN __cb = new _AMD_ILdap_findGroupDN(__inS);
        try
        {
            __obj.findGroupDN_async(__cb, groupname, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___findExperimenter(ILdap __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String username;
        username = __is.readString();
        __inS.endReadParams();
        AMD_ILdap_findExperimenter __cb = new _AMD_ILdap_findExperimenter(__inS);
        try
        {
            __obj.findExperimenter_async(__cb, username, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___findGroup(ILdap __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String groupname;
        groupname = __is.readString();
        __inS.endReadParams();
        AMD_ILdap_findGroup __cb = new _AMD_ILdap_findGroup(__inS);
        try
        {
            __obj.findGroup_async(__cb, groupname, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___setDN(ILdap __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.RLongHolder experimenterID = new omero.RLongHolder();
        String dn;
        __is.readObject(experimenterID);
        dn = __is.readString();
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_ILdap_setDN __cb = new _AMD_ILdap_setDN(__inS);
        try
        {
            __obj.setDN_async(__cb, experimenterID.value, dn, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getSetting(ILdap __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_ILdap_getSetting __cb = new _AMD_ILdap_getSetting(__inS);
        try
        {
            __obj.getSetting_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___discover(ILdap __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_ILdap_discover __cb = new _AMD_ILdap_discover(__inS);
        try
        {
            __obj.discover_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___discoverGroups(ILdap __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_ILdap_discoverGroups __cb = new _AMD_ILdap_discoverGroups(__inS);
        try
        {
            __obj.discoverGroups_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___createUser(ILdap __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String username;
        username = __is.readString();
        __inS.endReadParams();
        AMD_ILdap_createUser __cb = new _AMD_ILdap_createUser(__inS);
        try
        {
            __obj.createUser_async(__cb, username, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "createUser",
        "discover",
        "discoverGroups",
        "findDN",
        "findExperimenter",
        "findGroup",
        "findGroupDN",
        "getSetting",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "searchAll",
        "searchByAttribute",
        "searchByAttributes",
        "searchByDN",
        "searchDnInGroups",
        "setDN"
    };

    @SuppressWarnings("deprecation")
    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___createUser(this, in, __current);
            }
            case 1:
            {
                return ___discover(this, in, __current);
            }
            case 2:
            {
                return ___discoverGroups(this, in, __current);
            }
            case 3:
            {
                return ___findDN(this, in, __current);
            }
            case 4:
            {
                return ___findExperimenter(this, in, __current);
            }
            case 5:
            {
                return ___findGroup(this, in, __current);
            }
            case 6:
            {
                return ___findGroupDN(this, in, __current);
            }
            case 7:
            {
                return ___getSetting(this, in, __current);
            }
            case 8:
            {
                return ___ice_id(this, in, __current);
            }
            case 9:
            {
                return ___ice_ids(this, in, __current);
            }
            case 10:
            {
                return ___ice_isA(this, in, __current);
            }
            case 11:
            {
                return ___ice_ping(this, in, __current);
            }
            case 12:
            {
                return ___searchAll(this, in, __current);
            }
            case 13:
            {
                return ___searchByAttribute(this, in, __current);
            }
            case 14:
            {
                return ___searchByAttributes(this, in, __current);
            }
            case 15:
            {
                return ___searchByDN(this, in, __current);
            }
            case 16:
            {
                return ___searchDnInGroups(this, in, __current);
            }
            case 17:
            {
                return ___setDN(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
