// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `ILdap.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Administration interface providing access to admin-only
 * functionality as well as JMX-based server access and selected user
 * functions. Most methods require membership in privileged
 * {@link omero.model.ExperimenterGroup} groups.
 * 
 * Methods which return {@link omero.model.Experimenter} or
 * {@link omero.model.ExperimenterGroup} instances fetch and load all
 * related instances of {@link omero.model.ExperimenterGroup} or
 * {@link omero.model.Experimenter}, respectively.
 **/
public interface _ILdapOperations extends _ServiceInterfaceOperations
{
    /**
     * Searches all {@link omero.model.Experimenter} list on LDAP
     * for attribute objectClass = person.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void searchAll_async(AMD_ILdap_searchAll __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Searches Distinguished Name in groups.
     * 
     * @param __cb The callback object for the operation.
     * @param attr   Name of member attribute. Never null or empty.
     * @param __current The Current object for the invocation.
     **/
    void searchDnInGroups_async(AMD_ILdap_searchDnInGroups __cb, String attr, String value, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attribute.
     * 
     * @param __cb The callback object for the operation.
     * @param dn        Distinguished Name base for search. Never
     * null.
     * @param attribute Name of attribute. Never null or empty.
     * @param __current The Current object for the invocation.
     **/
    void searchByAttribute_async(AMD_ILdap_searchByAttribute __cb, String dn, String attribute, String value, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Searches all {@link omero.model.Experimenter} in LDAP for
     * specified attributes. Attributes should be specified in
     * StringSet and their values should be set in equivalent
     * StringSet.
     * 
     * @param __cb The callback object for the operation.
     * @param dn         Distinguished Name base for search. Never
     * null.
     * @param attributes Name of attribute. Never null or empty.
     * @param __current The Current object for the invocation.
     **/
    void searchByAttributes_async(AMD_ILdap_searchByAttributes __cb, String dn, java.util.List<String> attributes, java.util.List<String> values, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Searches one {@link omero.model.Experimenter} in LDAP for
     * specified Distinguished Name.
     * 
     * @param __cb The callback object for the operation.
     * @param userdn
     * unique Distinguished Name - string of user,
     * Never null or empty.
     * @param __current The Current object for the invocation.
     **/
    void searchByDN_async(AMD_ILdap_searchByDN __cb, String userdn, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Searches unique Distinguished Name - string in LDAP for
     * Common Name equals username. Common Name should be unique
     * under the specified base. If list of cn's contains more
     * then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __current The Current object for the invocation.
     **/
    void findDN_async(AMD_ILdap_findDN __cb, String username, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Looks up the DN for a group.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void findGroupDN_async(AMD_ILdap_findGroupDN __cb, String groupname, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Searches Experimenter by unique Distinguished Name -
     * string in LDAP for Common Name equals username. Common
     * Name should be unique under the specified base. If list of
     * cn's contains more then one DN will return exception.
     * 
     * @param __cb The callback object for the operation.
     * @param username
     * Name of the Experimenter equals CommonName.
     * @param __current The Current object for the invocation.
     **/
    void findExperimenter_async(AMD_ILdap_findExperimenter __cb, String username, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Looks up a specific {@link omero.model.ExperimenterGroup}
     * in LDAP using the provided group name. It is expected that
     * the group name will be unique in the searched LDAP base
     * tree. If more than one group with the specified name has
     * been found, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param groupname
     * @param __current The Current object for the invocation.
     **/
    void findGroup_async(AMD_ILdap_findGroup __cb, String groupname, Ice.Current __current)
        throws omero.ServerError;

    /**
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void setDN_async(AMD_ILdap_setDN __cb, omero.RLong experimenterID, String dn, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Gets config value from properties.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getSetting_async(AMD_ILdap_getSetting __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Discovers and lists {@link omero.model.Experimenter}s who
     * are present in the remote LDAP server and in the local DB
     * but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void discover_async(AMD_ILdap_discover __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Discovers and lists {@link omero.model.ExperimenterGroup}s
     * which are present in the remote LDAP server and in the local
     * DB but have the <code>ldap</code> property set to
     * <code>false</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void discoverGroups_async(AMD_ILdap_discoverGroups __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Creates an {@link omero.model.Experimenter} entry in the
     * OMERO DB based on the supplied LDAP username.
     * @param __cb The callback object for the operation.
     * @param username
     * @param __current The Current object for the invocation.
     **/
    void createUser_async(AMD_ILdap_createUser __cb, String username, Ice.Current __current)
        throws omero.ServerError;
}
