// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IMetadata.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides method to interact with acquisition metadata and
 * annotations.
 **/
public abstract class _IMetadataDisp extends Ice.ObjectImpl implements IMetadata
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IMetadata",
        "::omero::api::ServiceInterface"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     **/
    public final void countAnnotationsUsedNotOwned_async(AMD_IMetadata_countAnnotationsUsedNotOwned __cb, String annotationType, long userID)
        throws omero.ServerError
    {
        countAnnotationsUsedNotOwned_async(__cb, annotationType, userID, null);
    }

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     **/
    public final void countSpecifiedAnnotations_async(AMD_IMetadata_countSpecifiedAnnotations __cb, String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options)
        throws omero.ServerError
    {
        countSpecifiedAnnotations_async(__cb, annotationType, include, exclude, options, null);
    }

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of ids.
     **/
    public final void getTaggedObjectsCount_async(AMD_IMetadata_getTaggedObjectsCount __cb, java.util.List<Long> ids, omero.sys.Parameters options)
        throws omero.ServerError
    {
        getTaggedObjectsCount_async(__cb, ids, options, null);
    }

    /**
     * Loads the specified annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationIds The collection of annotation ids.
     **/
    public final void loadAnnotation_async(AMD_IMetadata_loadAnnotation __cb, java.util.List<Long> annotationIds)
        throws omero.ServerError
    {
        loadAnnotation_async(__cb, annotationIds, null);
    }

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param __cb The callback object for the operation.
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     **/
    public final void loadAnnotations_async(AMD_IMetadata_loadAnnotations __cb, String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options)
        throws omero.ServerError
    {
        loadAnnotations_async(__cb, rootType, rootIds, annotationTypes, annotatorIds, options, null);
    }

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     **/
    public final void loadAnnotationsUsedNotOwned_async(AMD_IMetadata_loadAnnotationsUsedNotOwned __cb, String annotationType, long userID)
        throws omero.ServerError
    {
        loadAnnotationsUsedNotOwned_async(__cb, annotationType, userID, null);
    }

    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     **/
    public final void loadChannelAcquisitionData_async(AMD_IMetadata_loadChannelAcquisitionData __cb, java.util.List<Long> ids)
        throws omero.ServerError
    {
        loadChannelAcquisitionData_async(__cb, ids, null);
    }

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param __cb The callback object for the operation.
     * @param id    The id of the instrument to load.
     **/
    public final void loadInstrument_async(AMD_IMetadata_loadInstrument __cb, long id)
        throws omero.ServerError
    {
        loadInstrument_async(__cb, id, null);
    }

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param __cb The callback object for the operation.
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     **/
    public final void loadLogFiles_async(AMD_IMetadata_loadLogFiles __cb, String rootType, java.util.List<Long> ids)
        throws omero.ServerError
    {
        loadLogFiles_async(__cb, rootType, ids, null);
    }

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     **/
    public final void loadSpecifiedAnnotations_async(AMD_IMetadata_loadSpecifiedAnnotations __cb, String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options)
        throws omero.ServerError
    {
        loadSpecifiedAnnotations_async(__cb, annotationType, include, exclude, options, null);
    }

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType  The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     **/
    public final void loadSpecifiedAnnotationsLinkedTo_async(AMD_IMetadata_loadSpecifiedAnnotationsLinkedTo __cb, String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options)
        throws omero.ServerError
    {
        loadSpecifiedAnnotationsLinkedTo_async(__cb, annotationType, include, exclude, rootNodeType, rootNodeIds, options, null);
    }

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The id of the tag to load or <code>-1</code>.
     **/
    public final void loadTagContent_async(AMD_IMetadata_loadTagContent __cb, java.util.List<Long> ids, omero.sys.Parameters options)
        throws omero.ServerError
    {
        loadTagContent_async(__cb, ids, options, null);
    }

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param __cb The callback object for the operation.
     * @param options The POJO options.
     **/
    public final void loadTagSets_async(AMD_IMetadata_loadTagSets __cb, omero.sys.Parameters options)
        throws omero.ServerError
    {
        loadTagSets_async(__cb, options, null);
    }

    public static Ice.DispatchStatus ___loadChannelAcquisitionData(IMetadata __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<Long> ids;
        ids = omero.sys.LongListHelper.read(__is);
        __inS.endReadParams();
        AMD_IMetadata_loadChannelAcquisitionData __cb = new _AMD_IMetadata_loadChannelAcquisitionData(__inS);
        try
        {
            __obj.loadChannelAcquisitionData_async(__cb, ids, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___loadAnnotations(IMetadata __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String rootType;
        java.util.List<Long> rootIds;
        java.util.List<String> annotationTypes;
        java.util.List<Long> annotatorIds;
        omero.sys.ParametersHolder options = new omero.sys.ParametersHolder();
        rootType = __is.readString();
        rootIds = omero.sys.LongListHelper.read(__is);
        annotationTypes = StringSetHelper.read(__is);
        annotatorIds = omero.sys.LongListHelper.read(__is);
        __is.readObject(options);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IMetadata_loadAnnotations __cb = new _AMD_IMetadata_loadAnnotations(__inS);
        try
        {
            __obj.loadAnnotations_async(__cb, rootType, rootIds, annotationTypes, annotatorIds, options.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___loadSpecifiedAnnotations(IMetadata __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String annotationType;
        java.util.List<String> include;
        java.util.List<String> exclude;
        omero.sys.ParametersHolder options = new omero.sys.ParametersHolder();
        annotationType = __is.readString();
        include = StringSetHelper.read(__is);
        exclude = StringSetHelper.read(__is);
        __is.readObject(options);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IMetadata_loadSpecifiedAnnotations __cb = new _AMD_IMetadata_loadSpecifiedAnnotations(__inS);
        try
        {
            __obj.loadSpecifiedAnnotations_async(__cb, annotationType, include, exclude, options.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___loadTagContent(IMetadata __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<Long> ids;
        omero.sys.ParametersHolder options = new omero.sys.ParametersHolder();
        ids = omero.sys.LongListHelper.read(__is);
        __is.readObject(options);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IMetadata_loadTagContent __cb = new _AMD_IMetadata_loadTagContent(__inS);
        try
        {
            __obj.loadTagContent_async(__cb, ids, options.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___loadTagSets(IMetadata __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.sys.ParametersHolder options = new omero.sys.ParametersHolder();
        __is.readObject(options);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IMetadata_loadTagSets __cb = new _AMD_IMetadata_loadTagSets(__inS);
        try
        {
            __obj.loadTagSets_async(__cb, options.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getTaggedObjectsCount(IMetadata __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<Long> ids;
        omero.sys.ParametersHolder options = new omero.sys.ParametersHolder();
        ids = omero.sys.LongListHelper.read(__is);
        __is.readObject(options);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IMetadata_getTaggedObjectsCount __cb = new _AMD_IMetadata_getTaggedObjectsCount(__inS);
        try
        {
            __obj.getTaggedObjectsCount_async(__cb, ids, options.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___countSpecifiedAnnotations(IMetadata __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String annotationType;
        java.util.List<String> include;
        java.util.List<String> exclude;
        omero.sys.ParametersHolder options = new omero.sys.ParametersHolder();
        annotationType = __is.readString();
        include = StringSetHelper.read(__is);
        exclude = StringSetHelper.read(__is);
        __is.readObject(options);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IMetadata_countSpecifiedAnnotations __cb = new _AMD_IMetadata_countSpecifiedAnnotations(__inS);
        try
        {
            __obj.countSpecifiedAnnotations_async(__cb, annotationType, include, exclude, options.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___loadAnnotation(IMetadata __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<Long> annotationIds;
        annotationIds = omero.sys.LongListHelper.read(__is);
        __inS.endReadParams();
        AMD_IMetadata_loadAnnotation __cb = new _AMD_IMetadata_loadAnnotation(__inS);
        try
        {
            __obj.loadAnnotation_async(__cb, annotationIds, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___loadInstrument(IMetadata __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long id;
        id = __is.readLong();
        __inS.endReadParams();
        AMD_IMetadata_loadInstrument __cb = new _AMD_IMetadata_loadInstrument(__inS);
        try
        {
            __obj.loadInstrument_async(__cb, id, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___loadAnnotationsUsedNotOwned(IMetadata __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String annotationType;
        long userID;
        annotationType = __is.readString();
        userID = __is.readLong();
        __inS.endReadParams();
        AMD_IMetadata_loadAnnotationsUsedNotOwned __cb = new _AMD_IMetadata_loadAnnotationsUsedNotOwned(__inS);
        try
        {
            __obj.loadAnnotationsUsedNotOwned_async(__cb, annotationType, userID, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___countAnnotationsUsedNotOwned(IMetadata __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String annotationType;
        long userID;
        annotationType = __is.readString();
        userID = __is.readLong();
        __inS.endReadParams();
        AMD_IMetadata_countAnnotationsUsedNotOwned __cb = new _AMD_IMetadata_countAnnotationsUsedNotOwned(__inS);
        try
        {
            __obj.countAnnotationsUsedNotOwned_async(__cb, annotationType, userID, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___loadSpecifiedAnnotationsLinkedTo(IMetadata __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String annotationType;
        java.util.List<String> include;
        java.util.List<String> exclude;
        String rootNodeType;
        java.util.List<Long> rootNodeIds;
        omero.sys.ParametersHolder options = new omero.sys.ParametersHolder();
        annotationType = __is.readString();
        include = StringSetHelper.read(__is);
        exclude = StringSetHelper.read(__is);
        rootNodeType = __is.readString();
        rootNodeIds = omero.sys.LongListHelper.read(__is);
        __is.readObject(options);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IMetadata_loadSpecifiedAnnotationsLinkedTo __cb = new _AMD_IMetadata_loadSpecifiedAnnotationsLinkedTo(__inS);
        try
        {
            __obj.loadSpecifiedAnnotationsLinkedTo_async(__cb, annotationType, include, exclude, rootNodeType, rootNodeIds, options.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___loadLogFiles(IMetadata __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String rootType;
        java.util.List<Long> ids;
        rootType = __is.readString();
        ids = omero.sys.LongListHelper.read(__is);
        __inS.endReadParams();
        AMD_IMetadata_loadLogFiles __cb = new _AMD_IMetadata_loadLogFiles(__inS);
        try
        {
            __obj.loadLogFiles_async(__cb, rootType, ids, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "countAnnotationsUsedNotOwned",
        "countSpecifiedAnnotations",
        "getTaggedObjectsCount",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "loadAnnotation",
        "loadAnnotations",
        "loadAnnotationsUsedNotOwned",
        "loadChannelAcquisitionData",
        "loadInstrument",
        "loadLogFiles",
        "loadSpecifiedAnnotations",
        "loadSpecifiedAnnotationsLinkedTo",
        "loadTagContent",
        "loadTagSets"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___countAnnotationsUsedNotOwned(this, in, __current);
            }
            case 1:
            {
                return ___countSpecifiedAnnotations(this, in, __current);
            }
            case 2:
            {
                return ___getTaggedObjectsCount(this, in, __current);
            }
            case 3:
            {
                return ___ice_id(this, in, __current);
            }
            case 4:
            {
                return ___ice_ids(this, in, __current);
            }
            case 5:
            {
                return ___ice_isA(this, in, __current);
            }
            case 6:
            {
                return ___ice_ping(this, in, __current);
            }
            case 7:
            {
                return ___loadAnnotation(this, in, __current);
            }
            case 8:
            {
                return ___loadAnnotations(this, in, __current);
            }
            case 9:
            {
                return ___loadAnnotationsUsedNotOwned(this, in, __current);
            }
            case 10:
            {
                return ___loadChannelAcquisitionData(this, in, __current);
            }
            case 11:
            {
                return ___loadInstrument(this, in, __current);
            }
            case 12:
            {
                return ___loadLogFiles(this, in, __current);
            }
            case 13:
            {
                return ___loadSpecifiedAnnotations(this, in, __current);
            }
            case 14:
            {
                return ___loadSpecifiedAnnotationsLinkedTo(this, in, __current);
            }
            case 15:
            {
                return ___loadTagContent(this, in, __current);
            }
            case 16:
            {
                return ___loadTagSets(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
