// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IMetadata.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides method to interact with acquisition metadata and
 * annotations.
 **/
public interface _IMetadataOperationsNC extends _ServiceInterfaceOperationsNC
{
    /**
     * Loads the logical channels and the acquisition metadata
     * related to them.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of logical channel's ids.
     * Mustn't be <code>null</code>.
     **/
    void loadChannelAcquisitionData_async(AMD_IMetadata_loadChannelAcquisitionData __cb, java.util.List<Long> ids)
        throws omero.ServerError;

    /**
     * Loads all the annotations of given types, that have been
     * attached to the specified <code>rootNodes</code> for the
     * specified <code>annotatorIds</code>.
     * If no types specified, all annotations will be loaded.
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, then the entry will be <code>null</code>.
     * Otherwise it will be a <code>Map</code> containing
     * {@link omero.model.Annotation} objects.
     * 
     * @param __cb The callback object for the operation.
     * @param rootType
     * The type of the nodes the annotations are linked to.
     * Mustn't be <code>null</code>.
     * @param rootIds
     * Ids of the objects of type <code>rootType</code>.
     * Mustn't be <code>null</code>.
     * @param annotatorIds
     * Ids of the users for whom annotations should be
     * retrieved. If <code>null</code>, all annotations
     * returned.
     * @param options
     **/
    void loadAnnotations_async(AMD_IMetadata_loadAnnotations __cb, String rootType, java.util.List<Long> rootIds, java.util.List<String> annotationTypes, java.util.List<Long> annotatorIds, omero.sys.Parameters options)
        throws omero.ServerError;

    /**
     * Loads all the annotations of a given type.
     * It is possible to filter the annotations by including or
     * excluding name spaces set on the annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param options   The POJO options.
     **/
    void loadSpecifiedAnnotations_async(AMD_IMetadata_loadSpecifiedAnnotations __cb, String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options)
        throws omero.ServerError;

    /**
     * Loads the TagSet if the id is specified otherwise loads
     * all the TagSet.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The id of the tag to load or <code>-1</code>.
     **/
    void loadTagContent_async(AMD_IMetadata_loadTagContent __cb, java.util.List<Long> ids, omero.sys.Parameters options)
        throws omero.ServerError;

    /**
     * Loads all the TagSets. Returns a collection of
     * <code>AnnotationAnnotatioLink</code> objects and, if the
     * <code>orphan</code> parameters is <code>true</code>, the
     * <code>TagAnnotation</code> object.
     * Note that the difference between a TagSet and a Tag is made
     * using the NS_INSIGHT_TAG_SET namespace.
     * 
     * @param __cb The callback object for the operation.
     * @param options The POJO options.
     **/
    void loadTagSets_async(AMD_IMetadata_loadTagSets __cb, omero.sys.Parameters options)
        throws omero.ServerError;

    /**
     * Returns a map whose key is a tag id and the value the
     * number of Projects, Datasets, and Images linked to that tag.
     * 
     * @param __cb The callback object for the operation.
     * @param ids The collection of ids.
     **/
    void getTaggedObjectsCount_async(AMD_IMetadata_getTaggedObjectsCount __cb, java.util.List<Long> ids, omero.sys.Parameters options)
        throws omero.ServerError;

    /**
     * Counts the number of annotation of a given type.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType The type of annotations to load.
     * @param exclude   The collection of name space, one of the
     * constants defined by this class.
     * @param options	The POJO options.
     **/
    void countSpecifiedAnnotations_async(AMD_IMetadata_countSpecifiedAnnotations __cb, String annotationType, java.util.List<String> include, java.util.List<String> exclude, omero.sys.Parameters options)
        throws omero.ServerError;

    /**
     * Loads the specified annotations.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationIds The collection of annotation ids.
     **/
    void loadAnnotation_async(AMD_IMetadata_loadAnnotation __cb, java.util.List<Long> annotationIds)
        throws omero.ServerError;

    /**
     * Loads the instrument and its components i.e. detectors,
     * objectives, etc.
     * 
     * @param __cb The callback object for the operation.
     * @param id    The id of the instrument to load.
     **/
    void loadInstrument_async(AMD_IMetadata_loadInstrument __cb, long id)
        throws omero.ServerError;

    /**
     * Loads the annotations of a given type used by the specified
     * user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     **/
    void loadAnnotationsUsedNotOwned_async(AMD_IMetadata_loadAnnotationsUsedNotOwned __cb, String annotationType, long userID)
        throws omero.ServerError;

    /**
     * Counts the number of annotation of a given type used by the
     * specified user but not owned by the user.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType    The type of annotations to load.
     **/
    void countAnnotationsUsedNotOwned_async(AMD_IMetadata_countAnnotationsUsedNotOwned __cb, String annotationType, long userID)
        throws omero.ServerError;

    /**
     * Loads the annotations of a given type linked to the
     * specified objects. It is possible to filter the annotations
     * by including or excluding name spaces set on the
     * annotations.
     * 
     * This method looks for the annotations that have been
     * attached to each of the specified objects. It then maps
     * each <code>rootNodeId</code> onto the set of annotations
     * that were found for that node. If no annotations were found
     * for that node, the map will not contain an entry for that
     * node. Otherwise it will be a <code>Set</code> containing
     * {@link omero.model.Annotation} objects.
     * The <code>rootNodeType</code> supported are:
     * Project, Dataset, Image, Pixels, Screen, Plate,
     * PlateAcquisition, Well, Fileset.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationType  The type of annotations to load.
     * @param exclude
     * Exclude the annotations with the specified name spaces.
     * @param rootNodeType
     * The type of objects the annotations are linked to.
     * @param rootNodeIds   The identifiers of the objects.
     **/
    void loadSpecifiedAnnotationsLinkedTo_async(AMD_IMetadata_loadSpecifiedAnnotationsLinkedTo __cb, String annotationType, java.util.List<String> include, java.util.List<String> exclude, String rootNodeType, java.util.List<Long> rootNodeIds, omero.sys.Parameters options)
        throws omero.ServerError;

    /**
     * Finds the original file IDs for the import logs
     * corresponding to the given Image or Fileset IDs.
     * 
     * @param __cb The callback object for the operation.
     * @param ids
     * the IDs of the entities for which the import log
     * original file IDs are required
     **/
    void loadLogFiles_async(AMD_IMetadata_loadLogFiles __cb, String rootType, java.util.List<Long> ids)
        throws omero.ServerError;
}
