// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IPixels.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Metadata gateway for the {@link omero.api.RenderingEngine} and
 * clients. This service provides all DB access that the rendering
 * engine needs as well as Pixels services to a client. It also allows
 * the rendering  engine to also be run external to the server (e.g.
 * client-side).
 * 
 **/
public abstract class _IPixelsDisp extends Ice.ObjectImpl implements IPixels
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IPixels",
        "::omero::api::ServiceInterface"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The source Image id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     **/
    public final void copyAndResizeImage_async(AMD_IPixels_copyAndResizeImage __cb, long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats)
        throws omero.ServerError
    {
        copyAndResizeImage_async(__cb, imageId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, null);
    }

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     **/
    public final void copyAndResizePixels_async(AMD_IPixels_copyAndResizePixels __cb, long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats)
        throws omero.ServerError
    {
        copyAndResizePixels_async(__cb, pixelsId, sizeX, sizeY, sizeZ, sizeT, channelList, methodology, copyStats, null);
    }

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX The new size across the X-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param pixelsType The pixelsType
     * @param description The description of the new Image.
     **/
    public final void createImage_async(AMD_IPixels_createImage __cb, int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description)
        throws omero.ServerError
    {
        createImage_async(__cb, sizeX, sizeY, sizeZ, sizeT, channelList, pixelsType, name, description, null);
    }

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @deprecated This operation has been deprecated.
     **/
    public final void getAllEnumerations_async(AMD_IPixels_getAllEnumerations __cb, String enumClass)
        throws omero.ServerError
    {
        getAllEnumerations_async(__cb, enumClass, null);
    }

    /**
     * Bit depth for a given pixel type.
     * 
     * @param __cb The callback object for the operation.
     * @param type Pixels type.
     **/
    public final void getBitDepth_async(AMD_IPixels_getBitDepth __cb, omero.model.PixelsType type)
        throws omero.ServerError
    {
        getBitDepth_async(__cb, type, null);
    }

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @deprecated This operation has been deprecated.
     **/
    public final void getEnumeration_async(AMD_IPixels_getEnumeration __cb, String enumClass, String value)
        throws omero.ServerError
    {
        getEnumeration_async(__cb, enumClass, value, null);
    }

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param renderingSettingsId Rendering definition id.
     **/
    public final void loadRndSettings_async(AMD_IPixels_loadRndSettings __cb, long renderingSettingsId)
        throws omero.ServerError
    {
        loadRndSettings_async(__cb, renderingSettingsId, null);
    }

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId    Pixels id.
     **/
    public final void retrieveAllRndSettings_async(AMD_IPixels_retrieveAllRndSettings __cb, long pixId, long userId)
        throws omero.ServerError
    {
        retrieveAllRndSettings_async(__cb, pixId, userId, null);
    }

    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     **/
    public final void retrievePixDescription_async(AMD_IPixels_retrievePixDescription __cb, long pixId)
        throws omero.ServerError
    {
        retrievePixDescription_async(__cb, pixId, null);
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     **/
    public final void retrieveRndSettings_async(AMD_IPixels_retrieveRndSettings __cb, long pixId)
        throws omero.ServerError
    {
        retrieveRndSettings_async(__cb, pixId, null);
    }

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     **/
    public final void retrieveRndSettingsFor_async(AMD_IPixels_retrieveRndSettingsFor __cb, long pixId, long userId)
        throws omero.ServerError
    {
        retrieveRndSettingsFor_async(__cb, pixId, userId, null);
    }

    /**
     * Saves the specified rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param rndSettings Rendering settings.
     **/
    public final void saveRndSettings_async(AMD_IPixels_saveRndSettings __cb, omero.model.RenderingDef rndSettings)
        throws omero.ServerError
    {
        saveRndSettings_async(__cb, rndSettings, null);
    }

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param min The channel global minimum.
     **/
    public final void setChannelGlobalMinMax_async(AMD_IPixels_setChannelGlobalMinMax __cb, long pixelsId, int channelIndex, double min, double max)
        throws omero.ServerError
    {
        setChannelGlobalMinMax_async(__cb, pixelsId, channelIndex, min, max, null);
    }

    public static Ice.DispatchStatus ___retrievePixDescription(IPixels __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long pixId;
        pixId = __is.readLong();
        __inS.endReadParams();
        AMD_IPixels_retrievePixDescription __cb = new _AMD_IPixels_retrievePixDescription(__inS);
        try
        {
            __obj.retrievePixDescription_async(__cb, pixId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___retrieveRndSettings(IPixels __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long pixId;
        pixId = __is.readLong();
        __inS.endReadParams();
        AMD_IPixels_retrieveRndSettings __cb = new _AMD_IPixels_retrieveRndSettings(__inS);
        try
        {
            __obj.retrieveRndSettings_async(__cb, pixId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___retrieveRndSettingsFor(IPixels __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long pixId;
        long userId;
        pixId = __is.readLong();
        userId = __is.readLong();
        __inS.endReadParams();
        AMD_IPixels_retrieveRndSettingsFor __cb = new _AMD_IPixels_retrieveRndSettingsFor(__inS);
        try
        {
            __obj.retrieveRndSettingsFor_async(__cb, pixId, userId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___retrieveAllRndSettings(IPixels __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long pixId;
        long userId;
        pixId = __is.readLong();
        userId = __is.readLong();
        __inS.endReadParams();
        AMD_IPixels_retrieveAllRndSettings __cb = new _AMD_IPixels_retrieveAllRndSettings(__inS);
        try
        {
            __obj.retrieveAllRndSettings_async(__cb, pixId, userId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___loadRndSettings(IPixels __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long renderingSettingsId;
        renderingSettingsId = __is.readLong();
        __inS.endReadParams();
        AMD_IPixels_loadRndSettings __cb = new _AMD_IPixels_loadRndSettings(__inS);
        try
        {
            __obj.loadRndSettings_async(__cb, renderingSettingsId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___saveRndSettings(IPixels __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.RenderingDefHolder rndSettings = new omero.model.RenderingDefHolder();
        __is.readObject(rndSettings);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IPixels_saveRndSettings __cb = new _AMD_IPixels_saveRndSettings(__inS);
        try
        {
            __obj.saveRndSettings_async(__cb, rndSettings.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getBitDepth(IPixels __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.PixelsTypeHolder type = new omero.model.PixelsTypeHolder();
        __is.readObject(type);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IPixels_getBitDepth __cb = new _AMD_IPixels_getBitDepth(__inS);
        try
        {
            __obj.getBitDepth_async(__cb, type.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___getEnumeration(IPixels __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String enumClass;
        String value;
        enumClass = __is.readString();
        value = __is.readString();
        __inS.endReadParams();
        AMD_IPixels_getEnumeration __cb = new _AMD_IPixels_getEnumeration(__inS);
        try
        {
            __obj.getEnumeration_async(__cb, enumClass, value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___getAllEnumerations(IPixels __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String enumClass;
        enumClass = __is.readString();
        __inS.endReadParams();
        AMD_IPixels_getAllEnumerations __cb = new _AMD_IPixels_getAllEnumerations(__inS);
        try
        {
            __obj.getAllEnumerations_async(__cb, enumClass, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___copyAndResizePixels(IPixels __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long pixelsId;
        omero.RIntHolder sizeX = new omero.RIntHolder();
        omero.RIntHolder sizeY = new omero.RIntHolder();
        omero.RIntHolder sizeZ = new omero.RIntHolder();
        omero.RIntHolder sizeT = new omero.RIntHolder();
        java.util.List<Integer> channelList;
        String methodology;
        boolean copyStats;
        pixelsId = __is.readLong();
        __is.readObject(sizeX);
        __is.readObject(sizeY);
        __is.readObject(sizeZ);
        __is.readObject(sizeT);
        channelList = omero.sys.IntListHelper.read(__is);
        methodology = __is.readString();
        copyStats = __is.readBool();
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IPixels_copyAndResizePixels __cb = new _AMD_IPixels_copyAndResizePixels(__inS);
        try
        {
            __obj.copyAndResizePixels_async(__cb, pixelsId, sizeX.value, sizeY.value, sizeZ.value, sizeT.value, channelList, methodology, copyStats, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___copyAndResizeImage(IPixels __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long imageId;
        omero.RIntHolder sizeX = new omero.RIntHolder();
        omero.RIntHolder sizeY = new omero.RIntHolder();
        omero.RIntHolder sizeZ = new omero.RIntHolder();
        omero.RIntHolder sizeT = new omero.RIntHolder();
        java.util.List<Integer> channelList;
        String methodology;
        boolean copyStats;
        imageId = __is.readLong();
        __is.readObject(sizeX);
        __is.readObject(sizeY);
        __is.readObject(sizeZ);
        __is.readObject(sizeT);
        channelList = omero.sys.IntListHelper.read(__is);
        methodology = __is.readString();
        copyStats = __is.readBool();
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IPixels_copyAndResizeImage __cb = new _AMD_IPixels_copyAndResizeImage(__inS);
        try
        {
            __obj.copyAndResizeImage_async(__cb, imageId, sizeX.value, sizeY.value, sizeZ.value, sizeT.value, channelList, methodology, copyStats, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___createImage(IPixels __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int sizeX;
        int sizeY;
        int sizeZ;
        int sizeT;
        java.util.List<Integer> channelList;
        omero.model.PixelsTypeHolder pixelsType = new omero.model.PixelsTypeHolder();
        String name;
        String description;
        sizeX = __is.readInt();
        sizeY = __is.readInt();
        sizeZ = __is.readInt();
        sizeT = __is.readInt();
        channelList = omero.sys.IntListHelper.read(__is);
        __is.readObject(pixelsType);
        name = __is.readString();
        description = __is.readString();
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IPixels_createImage __cb = new _AMD_IPixels_createImage(__inS);
        try
        {
            __obj.createImage_async(__cb, sizeX, sizeY, sizeZ, sizeT, channelList, pixelsType.value, name, description, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setChannelGlobalMinMax(IPixels __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long pixelsId;
        int channelIndex;
        double min;
        double max;
        pixelsId = __is.readLong();
        channelIndex = __is.readInt();
        min = __is.readDouble();
        max = __is.readDouble();
        __inS.endReadParams();
        AMD_IPixels_setChannelGlobalMinMax __cb = new _AMD_IPixels_setChannelGlobalMinMax(__inS);
        try
        {
            __obj.setChannelGlobalMinMax_async(__cb, pixelsId, channelIndex, min, max, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "copyAndResizeImage",
        "copyAndResizePixels",
        "createImage",
        "getAllEnumerations",
        "getBitDepth",
        "getEnumeration",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "loadRndSettings",
        "retrieveAllRndSettings",
        "retrievePixDescription",
        "retrieveRndSettings",
        "retrieveRndSettingsFor",
        "saveRndSettings",
        "setChannelGlobalMinMax"
    };

    @SuppressWarnings("deprecation")
    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___copyAndResizeImage(this, in, __current);
            }
            case 1:
            {
                return ___copyAndResizePixels(this, in, __current);
            }
            case 2:
            {
                return ___createImage(this, in, __current);
            }
            case 3:
            {
                return ___getAllEnumerations(this, in, __current);
            }
            case 4:
            {
                return ___getBitDepth(this, in, __current);
            }
            case 5:
            {
                return ___getEnumeration(this, in, __current);
            }
            case 6:
            {
                return ___ice_id(this, in, __current);
            }
            case 7:
            {
                return ___ice_ids(this, in, __current);
            }
            case 8:
            {
                return ___ice_isA(this, in, __current);
            }
            case 9:
            {
                return ___ice_ping(this, in, __current);
            }
            case 10:
            {
                return ___loadRndSettings(this, in, __current);
            }
            case 11:
            {
                return ___retrieveAllRndSettings(this, in, __current);
            }
            case 12:
            {
                return ___retrievePixDescription(this, in, __current);
            }
            case 13:
            {
                return ___retrieveRndSettings(this, in, __current);
            }
            case 14:
            {
                return ___retrieveRndSettingsFor(this, in, __current);
            }
            case 15:
            {
                return ___saveRndSettings(this, in, __current);
            }
            case 16:
            {
                return ___setChannelGlobalMinMax(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
