// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IPixels.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Metadata gateway for the {@link omero.api.RenderingEngine} and
 * clients. This service provides all DB access that the rendering
 * engine needs as well as Pixels services to a client. It also allows
 * the rendering  engine to also be run external to the server (e.g.
 * client-side).
 * 
 **/
public interface _IPixelsOperations extends _ServiceInterfaceOperations
{
    /**
     * Retrieves the pixels metadata. The following objects are
     * pre-linked:
     * <ul>
     * <li>pixels.pixelsType</li>
     * <li>pixels.pixelsDimensions</li>
     * <li>pixels.channels</li>
     * <li>pixels.channnels.statsInfo</li>
     * <li>pixels.channnels.colorComponent</li>
     * <li>pixels.channnels.logicalChannel</li>
     * <li>pixels.channnels.logicalChannel.photometricInterpretation</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     * @param __current The Current object for the invocation.
     **/
    void retrievePixDescription_async(AMD_IPixels_retrievePixDescription __cb, long pixId, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the currently logged in user. If the current user has no
     * {@link omero.model.RenderingDef}, and the user is an
     * administrator, then a {@link omero.model.RenderingDef} may
     * be returned for the owner of the
     * {@link omero.model.Pixels}. This matches the behavior of the
     * Rendering service.
     * 
     * The following objects will be pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     * @param __current The Current object for the invocation.
     **/
    void retrieveRndSettings_async(AMD_IPixels_retrieveRndSettings __cb, long pixId, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves the rendering settings for a given pixels set and
     * the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId Pixels id.
     * @param __current The Current object for the invocation.
     **/
    void retrieveRndSettingsFor_async(AMD_IPixels_retrieveRndSettingsFor __cb, long pixId, long userId, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves all the rendering settings for a given pixels set
     * and the passed user. The following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param pixId    Pixels id.
     * @param __current The Current object for the invocation.
     **/
    void retrieveAllRndSettings_async(AMD_IPixels_retrieveAllRndSettings __cb, long pixId, long userId, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Loads a specific set of rendering settings. The
     * following objects are pre-linked:
     * <ul>
     * <li>renderingDef.quantization</li>
     * <li>renderingDef.model</li>
     * <li>renderingDef.waveRendering</li>
     * <li>renderingDef.waveRendering.color</li>
     * <li>renderingDef.waveRendering.family</li>
     * <li>renderingDef.spatialDomainEnhancement</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param renderingSettingsId Rendering definition id.
     * @param __current The Current object for the invocation.
     **/
    void loadRndSettings_async(AMD_IPixels_loadRndSettings __cb, long renderingSettingsId, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Saves the specified rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param rndSettings Rendering settings.
     * @param __current The Current object for the invocation.
     **/
    void saveRndSettings_async(AMD_IPixels_saveRndSettings __cb, omero.model.RenderingDef rndSettings, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Bit depth for a given pixel type.
     * 
     * @param __cb The callback object for the operation.
     * @param type Pixels type.
     * @param __current The Current object for the invocation.
     **/
    void getBitDepth_async(AMD_IPixels_getBitDepth __cb, omero.model.PixelsType type, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves a particular enumeration for a given enumeration
     * class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void getEnumeration_async(AMD_IPixels_getEnumeration __cb, String enumClass, String value, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves the exhaustive list of enumerations for a given
     * enumeration class.
     * 
     * @param __cb The callback object for the operation.
     * @param enumClass Enumeration class.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void getAllEnumerations_async(AMD_IPixels_getAllEnumerations __cb, String enumClass, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Pixels object into a new Pixels object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology An optional string signifying the
     * methodology that will be used to produce
     * this new Pixels set.
     * @param copyStats Whether or not to copy the
     * {@link omero.model.StatsInfo} for each
     * channel.
     * @param __current The Current object for the invocation.
     **/
    void copyAndResizePixels_async(AMD_IPixels_copyAndResizePixels __cb, long pixelsId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Copies the metadata, and <b>only</b> the metadata linked to
     * a Image object into a new Image object of equal or
     * differing size across one or many of its three physical
     * dimensions or temporal dimension.
     * It is beyond the scope of this method to handle updates or
     * changes to  the raw pixel data available through
     * {@link omero.api.RawPixelsStore} or to add
     * and link {@link omero.model.PlaneInfo} and/or other Pixels
     * set specific metadata.
     * It is also assumed that the caller wishes the pixels
     * dimensions and {@link omero.model.PixelsType} to remain the
     * same; changing these is outside the scope of this method.
     * <b>NOTE:</b> As {@link omero.model.Channel} objects are
     * only able to apply to a single set of Pixels any
     * annotations or linkage to these objects will be lost.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The source Image id.
     * @param sizeY The new size across the Y-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeZ The new size across the Z-axis.
     * <code>null</code> if the copy should maintain
     * the same size.
     * @param sizeT The new number of timepoints.
     * <code>null</code> if the copy should maintain
     * the same number.
     * @param channelList The channels that should be copied into
     * the new Pixels set.
     * @param methodology The name of the new Image.
     * @param __current The Current object for the invocation.
     **/
    void copyAndResizeImage_async(AMD_IPixels_copyAndResizeImage __cb, long imageId, omero.RInt sizeX, omero.RInt sizeY, omero.RInt sizeZ, omero.RInt sizeT, java.util.List<Integer> channelList, String methodology, boolean copyStats, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Creates the metadata, and <b>only</b> the metadata linked
     * to an Image object. It is beyond the scope of this method
     * to handle updates or changes to the raw pixel data
     * available through {@link omero.api.RawPixelsStore} or to
     * add and link {@link omero.model.PlaneInfo} or
     * {@link omero.model.StatsInfo} objects and/or other Pixels
     * set specific metadata. It is also up to the caller to
     * update the pixels dimensions.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX The new size across the X-axis.
     * @param sizeZ The new size across the Z-axis.
     * @param pixelsType The pixelsType
     * @param description The description of the new Image.
     * @param __current The Current object for the invocation.
     **/
    void createImage_async(AMD_IPixels_createImage __cb, int sizeX, int sizeY, int sizeZ, int sizeT, java.util.List<Integer> channelList, omero.model.PixelsType pixelsType, String name, String description, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Sets the channel global (all 2D optical sections
     * corresponding to a particular channel) minimum and maximum
     * for a Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set id.
     * @param min The channel global minimum.
     * @param __current The Current object for the invocation.
     **/
    void setChannelGlobalMinMax_async(AMD_IPixels_setChannelGlobalMinMax __cb, long pixelsId, int channelIndex, double min, double max, Ice.Current __current)
        throws omero.ServerError;
}
