// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IProjection.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides methods for performing projections of Pixels sets.
 **/
public abstract class _IProjectionDisp extends Ice.ObjectImpl implements IProjection
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IProjection",
        "::omero::api::ServiceInterface"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Performs a projection through selected optical sections and
     * optical sections for a given set of time points of a Pixels
     * set. The Image which is linked to the Pixels set will be
     * copied using
     * {@link omero.api.IPixels#copyAndResizeImage}.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param tStart Timepoint to start projecting from.
     * @param stepping Stepping value to use while calculating the
     * projection. For example,
     * <code>stepping=1</code> will use every
     * optical section from <code>start</code> to
     * <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param zStart Optical section to start projecting from.
     * @param name Name for the newly created image. If
     * <code>null</code> the name of the Image linked
     * to the Pixels qualified by
     * <code>pixelsId</code> will be used with a
     * <i>Projection</i> suffix. For example,
     * <i>GFP-H2B Image of HeLa Cells</i> will have an
     * Image name of
     * <i>GFP-H2B Image of HeLa Cells Projection</i>
     * used for the projection.
     **/
    public final void projectPixels_async(AMD_IProjection_projectPixels __cb, long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int tStart, int tEnd, java.util.List<Integer> channelList, int stepping, int zStart, int zEnd, String name)
        throws omero.ServerError
    {
        projectPixels_async(__cb, pixelsId, pixelsType, algorithm, tStart, tEnd, channelList, stepping, zStart, zEnd, name, null);
    }

    /**
     * Performs a projection through the optical sections of a
     * particular wavelength at a given time point of a Pixels set.
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param timepoint Timepoint to perform the projection.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     **/
    public final void projectStack_async(AMD_IProjection_projectStack __cb, long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int timepoint, int channelIndex, int stepping, int start, int end)
        throws omero.ServerError
    {
        projectStack_async(__cb, pixelsId, pixelsType, algorithm, timepoint, channelIndex, stepping, start, end, null);
    }

    public static Ice.DispatchStatus ___projectStack(IProjection __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long pixelsId;
        omero.model.PixelsTypeHolder pixelsType = new omero.model.PixelsTypeHolder();
        omero.constants.projection.ProjectionType algorithm;
        int timepoint;
        int channelIndex;
        int stepping;
        int start;
        int end;
        pixelsId = __is.readLong();
        __is.readObject(pixelsType);
        algorithm = omero.constants.projection.ProjectionType.__read(__is);
        timepoint = __is.readInt();
        channelIndex = __is.readInt();
        stepping = __is.readInt();
        start = __is.readInt();
        end = __is.readInt();
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IProjection_projectStack __cb = new _AMD_IProjection_projectStack(__inS);
        try
        {
            __obj.projectStack_async(__cb, pixelsId, pixelsType.value, algorithm, timepoint, channelIndex, stepping, start, end, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___projectPixels(IProjection __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long pixelsId;
        omero.model.PixelsTypeHolder pixelsType = new omero.model.PixelsTypeHolder();
        omero.constants.projection.ProjectionType algorithm;
        int tStart;
        int tEnd;
        java.util.List<Integer> channelList;
        int stepping;
        int zStart;
        int zEnd;
        String name;
        pixelsId = __is.readLong();
        __is.readObject(pixelsType);
        algorithm = omero.constants.projection.ProjectionType.__read(__is);
        tStart = __is.readInt();
        tEnd = __is.readInt();
        channelList = omero.sys.IntListHelper.read(__is);
        stepping = __is.readInt();
        zStart = __is.readInt();
        zEnd = __is.readInt();
        name = __is.readString();
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IProjection_projectPixels __cb = new _AMD_IProjection_projectPixels(__inS);
        try
        {
            __obj.projectPixels_async(__cb, pixelsId, pixelsType.value, algorithm, tStart, tEnd, channelList, stepping, zStart, zEnd, name, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "projectPixels",
        "projectStack"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___ice_id(this, in, __current);
            }
            case 1:
            {
                return ___ice_ids(this, in, __current);
            }
            case 2:
            {
                return ___ice_isA(this, in, __current);
            }
            case 3:
            {
                return ___ice_ping(this, in, __current);
            }
            case 4:
            {
                return ___projectPixels(this, in, __current);
            }
            case 5:
            {
                return ___projectStack(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
