// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IProjection.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides methods for performing projections of Pixels sets.
 **/
public interface _IProjectionOperations extends _ServiceInterfaceOperations
{
    /**
     * Performs a projection through the optical sections of a
     * particular wavelength at a given time point of a Pixels set.
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param timepoint Timepoint to perform the projection.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param __current The Current object for the invocation.
     **/
    void projectStack_async(AMD_IProjection_projectStack __cb, long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int timepoint, int channelIndex, int stepping, int start, int end, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Performs a projection through selected optical sections and
     * optical sections for a given set of time points of a Pixels
     * set. The Image which is linked to the Pixels set will be
     * copied using
     * {@link omero.api.IPixels#copyAndResizeImage}.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The source Pixels set Id.
     * @param algorithm <code>MAXIMUM_INTENSITY</code>,
     * <code>MEAN_INTENSITY</code> or
     * <code>SUM_INTENSITY</code>. <b>NOTE:</b>
     * When performing a
     * <code>SUM_INTENSITY</code> projection,
     * pixel values will be <i>pinned</i> to the
     * maximum pixel value of the destination
     * Pixels type.
     * @param tStart Timepoint to start projecting from.
     * @param stepping Stepping value to use while calculating the
     * projection. For example,
     * <code>stepping=1</code> will use every
     * optical section from <code>start</code> to
     * <code>end</code> where
     * <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param zStart Optical section to start projecting from.
     * @param name Name for the newly created image. If
     * <code>null</code> the name of the Image linked
     * to the Pixels qualified by
     * <code>pixelsId</code> will be used with a
     * <i>Projection</i> suffix. For example,
     * <i>GFP-H2B Image of HeLa Cells</i> will have an
     * Image name of
     * <i>GFP-H2B Image of HeLa Cells Projection</i>
     * used for the projection.
     * @param __current The Current object for the invocation.
     **/
    void projectPixels_async(AMD_IProjection_projectPixels __cb, long pixelsId, omero.model.PixelsType pixelsType, omero.constants.projection.ProjectionType algorithm, int tStart, int tEnd, java.util.List<Integer> channelList, int stepping, int zStart, int zEnd, String name, Ice.Current __current)
        throws omero.ServerError;
}
