// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IQuery.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides methods for directly querying object graphs. As far as is
 * possible, IQuery should be considered the lowest level DB-access
 * (SELECT) interface.
 * Unlike the {@link omero.api.IUpdate} interface, using other methods
 * will most likely not leave the database in an inconsistent state,
 * but may provide stale data in some situations.
 * 
 * By convention, all methods that begin with <code>get</code> will
 * never return a null or empty {@link java.util.Collection}, but
 * instead will throw a {@link omero.ValidationException}.
 * 
 **/
public abstract class _IQueryDisp extends Ice.ObjectImpl implements IQuery
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IQuery",
        "::omero::api::ServiceInterface"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Looks up an entity by class and id. If no such objects
     * exists, return a <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param klass klass the type of the entity. Not null.
     **/
    public final void find_async(AMD_IQuery_find __cb, String klass, long id)
        throws omero.ServerError
    {
        find_async(__cb, klass, id, null);
    }

    /**
     * Looks up all entities that belong to this class and match
     * filter.
     * 
     * @param __cb The callback object for the operation.
     * @param klass entity type to be searched. Not null.
     **/
    public final void findAll_async(AMD_IQuery_findAll __cb, String klass, omero.sys.Filter filter)
        throws omero.ServerError
    {
        findAll_async(__cb, klass, filter, null);
    }

    /**
     * Searches based on provided example entity. The returned
     * entities will be limited by the {@link omero.sys.Filter}
     * object.
     * 
     * Note: findAllbyExample does not operate on the
     * <code>id</code> field.
     * For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     **/
    public final void findAllByExample_async(AMD_IQuery_findAllByExample __cb, omero.model.IObject example, omero.sys.Filter filter)
        throws omero.ServerError
    {
        findAllByExample_async(__cb, example, filter, null);
    }

    /**
     * Executes a full text search based on Lucene. Each term in
     * the query can also be prefixed by the name of the field to
     * which is should be restricted.
     * 
     * Examples:
     * <ul>
     * <li>owner:root AND annotation:someTag</li>
     * <li>file:xml AND name:*hoechst*</li>
     * </ul>
     * 
     * For more information, see
     * <a href="http://lucene.apache.org/java/docs/queryparsersyntax.html">Query Parser Syntax</a>
     * 
     * The return values are first filtered by the security system.
     * 
     * @param __cb The callback object for the operation.
     * @param klass A non-null class specification of which type
     * should be searched.
     * @param query A non-null query string. An empty string will
     * return no results.
     * @param params
     * Currently the parameters themselves are unused.
     * But the {@link omero.sys.Parameters#theFilter}
     * can be used to limit the number of results
     * returned ({@link omero.sys.Filter#limit}) or the
     * user for who the results will be found
     * ({@link omero.sys.Filter#ownerId}).
     **/
    public final void findAllByFullText_async(AMD_IQuery_findAllByFullText __cb, String klass, String query, omero.sys.Parameters params)
        throws omero.ServerError
    {
        findAllByFullText_async(__cb, klass, query, params, null);
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * Queries can only return lists of
     * {@link omero.model.IObject} instances. This means
     * all must be of the form:
     * 
     * <pre>
     * select this from SomeModelClass this ...
     * </pre>
     * 
     * though the alias <i>this</i> is unimportant. Do not try to
     * return multiple classes in one call like:
     * 
     * <pre>
     * select this, that from SomeClass this, SomeOtherClass that ...
     * </pre>
     * 
     * nor to project values out of an object:
     * 
     * <pre>
     * select this.name from SomeClass this ...
     * </pre>
     * 
     * If a page is desired, add it to the query parameters.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute. Not null.
     **/
    public final void findAllByQuery_async(AMD_IQuery_findAllByQuery __cb, String query, omero.sys.Parameters params)
        throws omero.ServerError
    {
        findAllByQuery_async(__cb, query, params, null);
    }

    /**
     * Searches a given field matching against a String. Method
     * allows for case sensitive or insensitive searching using
     * the (I)LIKE comparators. Result set will be reduced by the
     * {@link omero.sys.Filter} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched. Not null.
     * @param value String used for search. Not null.
     * @param filter filters the result set. Can be null.
     **/
    public final void findAllByString_async(AMD_IQuery_findAllByString __cb, String klass, String field, String value, boolean caseSensitive, omero.sys.Filter filter)
        throws omero.ServerError
    {
        findAllByString_async(__cb, klass, field, value, caseSensitive, filter, null);
    }

    /**
     * Searches based on provided example entity. The example
     * entity should <em>uniquely</em> specify the entity or an
     * exception will be thrown.
     * 
     * Note: findByExample does not operate on the <code>id</code>
     * field. For that, use {@link #find}, {@link #get},
     * {@link #findByQuery}, or {@link #findAllByQuery}.
     * 
     * @param __cb The callback object for the operation.
     * @param example Non-null example object.
     **/
    public final void findByExample_async(AMD_IQuery_findByExample __cb, omero.model.IObject example)
        throws omero.ServerError
    {
        findByExample_async(__cb, example, null);
    }

    /**
     * Executes the stored query with the given name. If a query
     * with the name cannot be found, an exception will be thrown.
     * 
     * The queryName parameter can be an actual query String if the
     * StringQuerySource is configured on the server and the user
     * running the query has proper permissions.
     * 
     * @param __cb The callback object for the operation.
     * @param query Query to execute
     **/
    public final void findByQuery_async(AMD_IQuery_findByQuery __cb, String query, omero.sys.Parameters params)
        throws omero.ServerError
    {
        findByQuery_async(__cb, query, params, null);
    }

    /**
     * Searches a given field matching against a String. Method
     * does <em>not</em> allow for case sensitive or insensitive
     * searching since this is essentially a lookup. The existence
     * of more than one result will result in an exception.
     * 
     * @param __cb The callback object for the operation.
     * @param klass type of entity to be searched
     * @param value String used for search.
     **/
    public final void findByString_async(AMD_IQuery_findByString __cb, String klass, String field, String value)
        throws omero.ServerError
    {
        findByString_async(__cb, klass, field, value, null);
    }

    /**
     * Looks up an entity by class and id. If no such object
     * exists, an exception will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param klass the type of the entity. Not null.
     **/
    public final void get_async(AMD_IQuery_get __cb, String klass, long id)
        throws omero.ServerError
    {
        get_async(__cb, klass, id, null);
    }

    /**
     * Return a sequence of {@link omero.RType} sequences.
     * 
     * <p>
     * Each element of the outer sequence is one row in the return
     * value.
     * Each element of the inner sequence is one column specified
     * in the HQL.
     * </p>
     * 
     * <p>
     * {@link omero.model.IObject} instances are returned wrapped
     * in an {@link omero.RObject} instance. Primitives are
     * mapped to the expected {@link omero.RType} subclass. Types
     * without an {@link omero.RType} mapper if returned will
     * throw an exception if present in the select except where a
     * manual conversion is present on the server. This includes:
     * </p>
     * 
     * <ul>
     * <li>
     * {@link omero.model.Permissions} instances are
     * serialized to an {@link omero.RMap} containing the
     * keys: perms, canAnnotate, canEdit, canLink, canDelete
     * </li>
     * <li>
     * The quantity types like {@link omero.model.Length} are
     * serialized to an {@link omero.RMap} containing the
     * keys: value, unit, symbol
     * </li>
     * </ul>
     * 
     * <p>
     * As with SQL, if an aggregation statement is used, a group
     * by clause must be added.
     * </p>
     * 
     * <p>
     * Examples:
     * <pre>
     * select i.name, i.description from Image i where i.name like '%.dv'
     * 
     * select tag.textValue, tagset.textValue from TagAnnotation tag join tag.annotationLinks l join l.child tagset
     * 
     * select p.pixelsType.value, count(p.id) from Pixel p group by p.pixelsType.value
     * </pre>
     * </p>
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void projection_async(AMD_IQuery_projection __cb, String query, omero.sys.Parameters params)
        throws omero.ServerError
    {
        projection_async(__cb, query, params, null);
    }

    /**
     * Refreshes an entire {@link omero.model.IObject} graph,
     * recursive loading all data for the managed instances in the
     * graph from the database. If any non-managed entities are
     * detected (e.g. without ids), an
     * {@link omero.ApiUsageException} will be thrown.
     * 
     * @param __cb The callback object for the operation.
     * @param iObject Non-null managed {@link omero.model.IObject}
     * graph which should have all values
     * re-assigned from the database
     **/
    public final void refresh_async(AMD_IQuery_refresh __cb, omero.model.IObject iObject)
        throws omero.ServerError
    {
        refresh_async(__cb, iObject, null);
    }

    public static Ice.DispatchStatus ___get(IQuery __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String klass;
        long id;
        klass = __is.readString();
        id = __is.readLong();
        __inS.endReadParams();
        AMD_IQuery_get __cb = new _AMD_IQuery_get(__inS);
        try
        {
            __obj.get_async(__cb, klass, id, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___find(IQuery __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String klass;
        long id;
        klass = __is.readString();
        id = __is.readLong();
        __inS.endReadParams();
        AMD_IQuery_find __cb = new _AMD_IQuery_find(__inS);
        try
        {
            __obj.find_async(__cb, klass, id, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___findAll(IQuery __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String klass;
        omero.sys.FilterHolder filter = new omero.sys.FilterHolder();
        klass = __is.readString();
        __is.readObject(filter);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IQuery_findAll __cb = new _AMD_IQuery_findAll(__inS);
        try
        {
            __obj.findAll_async(__cb, klass, filter.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___findByExample(IQuery __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.IObjectHolder example = new omero.model.IObjectHolder();
        __is.readObject(example);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IQuery_findByExample __cb = new _AMD_IQuery_findByExample(__inS);
        try
        {
            __obj.findByExample_async(__cb, example.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___findAllByExample(IQuery __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.IObjectHolder example = new omero.model.IObjectHolder();
        omero.sys.FilterHolder filter = new omero.sys.FilterHolder();
        __is.readObject(example);
        __is.readObject(filter);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IQuery_findAllByExample __cb = new _AMD_IQuery_findAllByExample(__inS);
        try
        {
            __obj.findAllByExample_async(__cb, example.value, filter.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___findByString(IQuery __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String klass;
        String field;
        String value;
        klass = __is.readString();
        field = __is.readString();
        value = __is.readString();
        __inS.endReadParams();
        AMD_IQuery_findByString __cb = new _AMD_IQuery_findByString(__inS);
        try
        {
            __obj.findByString_async(__cb, klass, field, value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___findAllByString(IQuery __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String klass;
        String field;
        String value;
        boolean caseSensitive;
        omero.sys.FilterHolder filter = new omero.sys.FilterHolder();
        klass = __is.readString();
        field = __is.readString();
        value = __is.readString();
        caseSensitive = __is.readBool();
        __is.readObject(filter);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IQuery_findAllByString __cb = new _AMD_IQuery_findAllByString(__inS);
        try
        {
            __obj.findAllByString_async(__cb, klass, field, value, caseSensitive, filter.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___findByQuery(IQuery __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String query;
        omero.sys.ParametersHolder params = new omero.sys.ParametersHolder();
        query = __is.readString();
        __is.readObject(params);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IQuery_findByQuery __cb = new _AMD_IQuery_findByQuery(__inS);
        try
        {
            __obj.findByQuery_async(__cb, query, params.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___findAllByQuery(IQuery __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String query;
        omero.sys.ParametersHolder params = new omero.sys.ParametersHolder();
        query = __is.readString();
        __is.readObject(params);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IQuery_findAllByQuery __cb = new _AMD_IQuery_findAllByQuery(__inS);
        try
        {
            __obj.findAllByQuery_async(__cb, query, params.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___findAllByFullText(IQuery __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String klass;
        String query;
        omero.sys.ParametersHolder params = new omero.sys.ParametersHolder();
        klass = __is.readString();
        query = __is.readString();
        __is.readObject(params);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IQuery_findAllByFullText __cb = new _AMD_IQuery_findAllByFullText(__inS);
        try
        {
            __obj.findAllByFullText_async(__cb, klass, query, params.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___projection(IQuery __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String query;
        omero.sys.ParametersHolder params = new omero.sys.ParametersHolder();
        query = __is.readString();
        __is.readObject(params);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IQuery_projection __cb = new _AMD_IQuery_projection(__inS);
        try
        {
            __obj.projection_async(__cb, query, params.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___refresh(IQuery __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.IObjectHolder iObject = new omero.model.IObjectHolder();
        __is.readObject(iObject);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IQuery_refresh __cb = new _AMD_IQuery_refresh(__inS);
        try
        {
            __obj.refresh_async(__cb, iObject.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "find",
        "findAll",
        "findAllByExample",
        "findAllByFullText",
        "findAllByQuery",
        "findAllByString",
        "findByExample",
        "findByQuery",
        "findByString",
        "get",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "projection",
        "refresh"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___find(this, in, __current);
            }
            case 1:
            {
                return ___findAll(this, in, __current);
            }
            case 2:
            {
                return ___findAllByExample(this, in, __current);
            }
            case 3:
            {
                return ___findAllByFullText(this, in, __current);
            }
            case 4:
            {
                return ___findAllByQuery(this, in, __current);
            }
            case 5:
            {
                return ___findAllByString(this, in, __current);
            }
            case 6:
            {
                return ___findByExample(this, in, __current);
            }
            case 7:
            {
                return ___findByQuery(this, in, __current);
            }
            case 8:
            {
                return ___findByString(this, in, __current);
            }
            case 9:
            {
                return ___get(this, in, __current);
            }
            case 10:
            {
                return ___ice_id(this, in, __current);
            }
            case 11:
            {
                return ___ice_ids(this, in, __current);
            }
            case 12:
            {
                return ___ice_isA(this, in, __current);
            }
            case 13:
            {
                return ___ice_ping(this, in, __current);
            }
            case 14:
            {
                return ___projection(this, in, __current);
            }
            case 15:
            {
                return ___refresh(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
