// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IRenderingSettings.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides method to apply rendering settings to a collection of
 * images.
 * All methods will receive the id of the pixels set to copy the
 * rendering settings from.
 **/
public abstract class _IRenderingSettingsDisp extends Ice.ObjectImpl implements IRenderingSettings
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IRenderingSettings",
        "::omero::api::ServiceInterface"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     **/
    public final void applySettingsToDataset_async(AMD_IRenderingSettings_applySettingsToDataset __cb, long from, long to)
        throws omero.ServerError
    {
        applySettingsToDataset_async(__cb, from, to, null);
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     **/
    public final void applySettingsToImage_async(AMD_IRenderingSettings_applySettingsToImage __cb, long from, long to)
        throws omero.ServerError
    {
        applySettingsToImage_async(__cb, from, to, null);
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     **/
    public final void applySettingsToImages_async(AMD_IRenderingSettings_applySettingsToImages __cb, long from, java.util.List<Long> to)
        throws omero.ServerError
    {
        applySettingsToImages_async(__cb, from, to, null);
    }

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     **/
    public final void applySettingsToPixels_async(AMD_IRenderingSettings_applySettingsToPixels __cb, long from, long to)
        throws omero.ServerError
    {
        applySettingsToPixels_async(__cb, from, to, null);
    }

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     **/
    public final void applySettingsToProject_async(AMD_IRenderingSettings_applySettingsToProject __cb, long from, long to)
        throws omero.ServerError
    {
        applySettingsToProject_async(__cb, from, to, null);
    }

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     **/
    public final void applySettingsToSet_async(AMD_IRenderingSettings_applySettingsToSet __cb, long from, String toType, java.util.List<Long> nodeIds)
        throws omero.ServerError
    {
        applySettingsToSet_async(__cb, from, toType, nodeIds, null);
    }

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param __cb The callback object for the operation.
     * @param pixels The Pixels set to link to the rendering
     * definition.
     **/
    public final void createNewRenderingDef_async(AMD_IRenderingSettings_createNewRenderingDef __cb, omero.model.Pixels pixels)
        throws omero.ServerError
    {
        createNewRenderingDef_async(__cb, pixels, null);
    }

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels
     **/
    public final void getRenderingSettings_async(AMD_IRenderingSettings_getRenderingSettings __cb, long pixelsId)
        throws omero.ServerError
    {
        getRenderingSettings_async(__cb, pixelsId, null);
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     **/
    public final void resetDefaults_async(AMD_IRenderingSettings_resetDefaults __cb, omero.model.RenderingDef def, omero.model.Pixels pixels)
        throws omero.ServerError
    {
        resetDefaults_async(__cb, def, pixels, null);
    }

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public final void resetDefaultsByOwnerInSet_async(AMD_IRenderingSettings_resetDefaultsByOwnerInSet __cb, String type, java.util.List<Long> nodeIds)
        throws omero.ServerError
    {
        resetDefaultsByOwnerInSet_async(__cb, type, nodeIds, null);
    }

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels.
     **/
    public final void resetDefaultsForPixels_async(AMD_IRenderingSettings_resetDefaultsForPixels __cb, long pixelsId)
        throws omero.ServerError
    {
        resetDefaultsForPixels_async(__cb, pixelsId, null);
    }

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param dataSetId The Id of the Dataset.
     **/
    public final void resetDefaultsInDataset_async(AMD_IRenderingSettings_resetDefaultsInDataset __cb, long dataSetId)
        throws omero.ServerError
    {
        resetDefaultsInDataset_async(__cb, dataSetId, null);
    }

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     **/
    public final void resetDefaultsInImage_async(AMD_IRenderingSettings_resetDefaultsInImage __cb, long imageId)
        throws omero.ServerError
    {
        resetDefaultsInImage_async(__cb, imageId, null);
    }

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public final void resetDefaultsInSet_async(AMD_IRenderingSettings_resetDefaultsInSet __cb, String type, java.util.List<Long> nodeIds)
        throws omero.ServerError
    {
        resetDefaultsInSet_async(__cb, type, nodeIds, null);
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     **/
    public final void resetDefaultsNoSave_async(AMD_IRenderingSettings_resetDefaultsNoSave __cb, omero.model.RenderingDef def, omero.model.Pixels pixels)
        throws omero.ServerError
    {
        resetDefaultsNoSave_async(__cb, def, pixels, null);
    }

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public final void resetMinMaxInSet_async(AMD_IRenderingSettings_resetMinMaxInSet __cb, String type, java.util.List<Long> nodeIds)
        throws omero.ServerError
    {
        resetMinMaxInSet_async(__cb, type, nodeIds, null);
    }

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param pFrom The pixels set to copy the settings from.
     **/
    public final void sanityCheckPixels_async(AMD_IRenderingSettings_sanityCheckPixels __cb, omero.model.Pixels pFrom, omero.model.Pixels pTo)
        throws omero.ServerError
    {
        sanityCheckPixels_async(__cb, pFrom, pTo, null);
    }

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels set.
     **/
    public final void setOriginalSettingsForPixels_async(AMD_IRenderingSettings_setOriginalSettingsForPixels __cb, long pixelsId)
        throws omero.ServerError
    {
        setOriginalSettingsForPixels_async(__cb, pixelsId, null);
    }

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void setOriginalSettingsInDataset_async(AMD_IRenderingSettings_setOriginalSettingsInDataset __cb, long dataSetId)
        throws omero.ServerError
    {
        setOriginalSettingsInDataset_async(__cb, dataSetId, null);
    }

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     **/
    public final void setOriginalSettingsInImage_async(AMD_IRenderingSettings_setOriginalSettingsInImage __cb, long imageId)
        throws omero.ServerError
    {
        setOriginalSettingsInImage_async(__cb, imageId, null);
    }

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public final void setOriginalSettingsInSet_async(AMD_IRenderingSettings_setOriginalSettingsInSet __cb, String type, java.util.List<Long> nodeIds)
        throws omero.ServerError
    {
        setOriginalSettingsInSet_async(__cb, type, nodeIds, null);
    }

    public static Ice.DispatchStatus ___sanityCheckPixels(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.PixelsHolder pFrom = new omero.model.PixelsHolder();
        omero.model.PixelsHolder pTo = new omero.model.PixelsHolder();
        __is.readObject(pFrom);
        __is.readObject(pTo);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IRenderingSettings_sanityCheckPixels __cb = new _AMD_IRenderingSettings_sanityCheckPixels(__inS);
        try
        {
            __obj.sanityCheckPixels_async(__cb, pFrom.value, pTo.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getRenderingSettings(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long pixelsId;
        pixelsId = __is.readLong();
        __inS.endReadParams();
        AMD_IRenderingSettings_getRenderingSettings __cb = new _AMD_IRenderingSettings_getRenderingSettings(__inS);
        try
        {
            __obj.getRenderingSettings_async(__cb, pixelsId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___createNewRenderingDef(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.PixelsHolder pixels = new omero.model.PixelsHolder();
        __is.readObject(pixels);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IRenderingSettings_createNewRenderingDef __cb = new _AMD_IRenderingSettings_createNewRenderingDef(__inS);
        try
        {
            __obj.createNewRenderingDef_async(__cb, pixels.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___resetDefaults(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.RenderingDefHolder def = new omero.model.RenderingDefHolder();
        omero.model.PixelsHolder pixels = new omero.model.PixelsHolder();
        __is.readObject(def);
        __is.readObject(pixels);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IRenderingSettings_resetDefaults __cb = new _AMD_IRenderingSettings_resetDefaults(__inS);
        try
        {
            __obj.resetDefaults_async(__cb, def.value, pixels.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___resetDefaultsNoSave(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.RenderingDefHolder def = new omero.model.RenderingDefHolder();
        omero.model.PixelsHolder pixels = new omero.model.PixelsHolder();
        __is.readObject(def);
        __is.readObject(pixels);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IRenderingSettings_resetDefaultsNoSave __cb = new _AMD_IRenderingSettings_resetDefaultsNoSave(__inS);
        try
        {
            __obj.resetDefaultsNoSave_async(__cb, def.value, pixels.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___resetDefaultsInImage(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long imageId;
        imageId = __is.readLong();
        __inS.endReadParams();
        AMD_IRenderingSettings_resetDefaultsInImage __cb = new _AMD_IRenderingSettings_resetDefaultsInImage(__inS);
        try
        {
            __obj.resetDefaultsInImage_async(__cb, imageId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___resetDefaultsForPixels(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long pixelsId;
        pixelsId = __is.readLong();
        __inS.endReadParams();
        AMD_IRenderingSettings_resetDefaultsForPixels __cb = new _AMD_IRenderingSettings_resetDefaultsForPixels(__inS);
        try
        {
            __obj.resetDefaultsForPixels_async(__cb, pixelsId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___resetDefaultsInDataset(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long dataSetId;
        dataSetId = __is.readLong();
        __inS.endReadParams();
        AMD_IRenderingSettings_resetDefaultsInDataset __cb = new _AMD_IRenderingSettings_resetDefaultsInDataset(__inS);
        try
        {
            __obj.resetDefaultsInDataset_async(__cb, dataSetId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___resetDefaultsInSet(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String type;
        java.util.List<Long> nodeIds;
        type = __is.readString();
        nodeIds = omero.sys.LongListHelper.read(__is);
        __inS.endReadParams();
        AMD_IRenderingSettings_resetDefaultsInSet __cb = new _AMD_IRenderingSettings_resetDefaultsInSet(__inS);
        try
        {
            __obj.resetDefaultsInSet_async(__cb, type, nodeIds, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___resetDefaultsByOwnerInSet(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String type;
        java.util.List<Long> nodeIds;
        type = __is.readString();
        nodeIds = omero.sys.LongListHelper.read(__is);
        __inS.endReadParams();
        AMD_IRenderingSettings_resetDefaultsByOwnerInSet __cb = new _AMD_IRenderingSettings_resetDefaultsByOwnerInSet(__inS);
        try
        {
            __obj.resetDefaultsByOwnerInSet_async(__cb, type, nodeIds, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___resetMinMaxInSet(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String type;
        java.util.List<Long> nodeIds;
        type = __is.readString();
        nodeIds = omero.sys.LongListHelper.read(__is);
        __inS.endReadParams();
        AMD_IRenderingSettings_resetMinMaxInSet __cb = new _AMD_IRenderingSettings_resetMinMaxInSet(__inS);
        try
        {
            __obj.resetMinMaxInSet_async(__cb, type, nodeIds, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___applySettingsToSet(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long from;
        String toType;
        java.util.List<Long> nodeIds;
        from = __is.readLong();
        toType = __is.readString();
        nodeIds = omero.sys.LongListHelper.read(__is);
        __inS.endReadParams();
        AMD_IRenderingSettings_applySettingsToSet __cb = new _AMD_IRenderingSettings_applySettingsToSet(__inS);
        try
        {
            __obj.applySettingsToSet_async(__cb, from, toType, nodeIds, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___applySettingsToProject(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long from;
        long to;
        from = __is.readLong();
        to = __is.readLong();
        __inS.endReadParams();
        AMD_IRenderingSettings_applySettingsToProject __cb = new _AMD_IRenderingSettings_applySettingsToProject(__inS);
        try
        {
            __obj.applySettingsToProject_async(__cb, from, to, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___applySettingsToDataset(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long from;
        long to;
        from = __is.readLong();
        to = __is.readLong();
        __inS.endReadParams();
        AMD_IRenderingSettings_applySettingsToDataset __cb = new _AMD_IRenderingSettings_applySettingsToDataset(__inS);
        try
        {
            __obj.applySettingsToDataset_async(__cb, from, to, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___applySettingsToImages(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long from;
        java.util.List<Long> to;
        from = __is.readLong();
        to = omero.sys.LongListHelper.read(__is);
        __inS.endReadParams();
        AMD_IRenderingSettings_applySettingsToImages __cb = new _AMD_IRenderingSettings_applySettingsToImages(__inS);
        try
        {
            __obj.applySettingsToImages_async(__cb, from, to, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___applySettingsToImage(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long from;
        long to;
        from = __is.readLong();
        to = __is.readLong();
        __inS.endReadParams();
        AMD_IRenderingSettings_applySettingsToImage __cb = new _AMD_IRenderingSettings_applySettingsToImage(__inS);
        try
        {
            __obj.applySettingsToImage_async(__cb, from, to, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___applySettingsToPixels(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long from;
        long to;
        from = __is.readLong();
        to = __is.readLong();
        __inS.endReadParams();
        AMD_IRenderingSettings_applySettingsToPixels __cb = new _AMD_IRenderingSettings_applySettingsToPixels(__inS);
        try
        {
            __obj.applySettingsToPixels_async(__cb, from, to, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setOriginalSettingsInImage(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long imageId;
        imageId = __is.readLong();
        __inS.endReadParams();
        AMD_IRenderingSettings_setOriginalSettingsInImage __cb = new _AMD_IRenderingSettings_setOriginalSettingsInImage(__inS);
        try
        {
            __obj.setOriginalSettingsInImage_async(__cb, imageId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setOriginalSettingsForPixels(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long pixelsId;
        pixelsId = __is.readLong();
        __inS.endReadParams();
        AMD_IRenderingSettings_setOriginalSettingsForPixels __cb = new _AMD_IRenderingSettings_setOriginalSettingsForPixels(__inS);
        try
        {
            __obj.setOriginalSettingsForPixels_async(__cb, pixelsId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setOriginalSettingsInDataset(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long dataSetId;
        dataSetId = __is.readLong();
        __inS.endReadParams();
        AMD_IRenderingSettings_setOriginalSettingsInDataset __cb = new _AMD_IRenderingSettings_setOriginalSettingsInDataset(__inS);
        try
        {
            __obj.setOriginalSettingsInDataset_async(__cb, dataSetId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setOriginalSettingsInSet(IRenderingSettings __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String type;
        java.util.List<Long> nodeIds;
        type = __is.readString();
        nodeIds = omero.sys.LongListHelper.read(__is);
        __inS.endReadParams();
        AMD_IRenderingSettings_setOriginalSettingsInSet __cb = new _AMD_IRenderingSettings_setOriginalSettingsInSet(__inS);
        try
        {
            __obj.setOriginalSettingsInSet_async(__cb, type, nodeIds, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "applySettingsToDataset",
        "applySettingsToImage",
        "applySettingsToImages",
        "applySettingsToPixels",
        "applySettingsToProject",
        "applySettingsToSet",
        "createNewRenderingDef",
        "getRenderingSettings",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "resetDefaults",
        "resetDefaultsByOwnerInSet",
        "resetDefaultsForPixels",
        "resetDefaultsInDataset",
        "resetDefaultsInImage",
        "resetDefaultsInSet",
        "resetDefaultsNoSave",
        "resetMinMaxInSet",
        "sanityCheckPixels",
        "setOriginalSettingsForPixels",
        "setOriginalSettingsInDataset",
        "setOriginalSettingsInImage",
        "setOriginalSettingsInSet"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___applySettingsToDataset(this, in, __current);
            }
            case 1:
            {
                return ___applySettingsToImage(this, in, __current);
            }
            case 2:
            {
                return ___applySettingsToImages(this, in, __current);
            }
            case 3:
            {
                return ___applySettingsToPixels(this, in, __current);
            }
            case 4:
            {
                return ___applySettingsToProject(this, in, __current);
            }
            case 5:
            {
                return ___applySettingsToSet(this, in, __current);
            }
            case 6:
            {
                return ___createNewRenderingDef(this, in, __current);
            }
            case 7:
            {
                return ___getRenderingSettings(this, in, __current);
            }
            case 8:
            {
                return ___ice_id(this, in, __current);
            }
            case 9:
            {
                return ___ice_ids(this, in, __current);
            }
            case 10:
            {
                return ___ice_isA(this, in, __current);
            }
            case 11:
            {
                return ___ice_ping(this, in, __current);
            }
            case 12:
            {
                return ___resetDefaults(this, in, __current);
            }
            case 13:
            {
                return ___resetDefaultsByOwnerInSet(this, in, __current);
            }
            case 14:
            {
                return ___resetDefaultsForPixels(this, in, __current);
            }
            case 15:
            {
                return ___resetDefaultsInDataset(this, in, __current);
            }
            case 16:
            {
                return ___resetDefaultsInImage(this, in, __current);
            }
            case 17:
            {
                return ___resetDefaultsInSet(this, in, __current);
            }
            case 18:
            {
                return ___resetDefaultsNoSave(this, in, __current);
            }
            case 19:
            {
                return ___resetMinMaxInSet(this, in, __current);
            }
            case 20:
            {
                return ___sanityCheckPixels(this, in, __current);
            }
            case 21:
            {
                return ___setOriginalSettingsForPixels(this, in, __current);
            }
            case 22:
            {
                return ___setOriginalSettingsInDataset(this, in, __current);
            }
            case 23:
            {
                return ___setOriginalSettingsInImage(this, in, __current);
            }
            case 24:
            {
                return ___setOriginalSettingsInSet(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
