// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IRepositoryInfo.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides methods for obtaining information for server repository
 * disk space allocation. Could be used generically to obtain usage
 * information for any mount point, however, this interface is
 * prepared for the API to provide methods to obtain usage info for
 * the server filesystem containing the image uploads. For the OMERO
 * server base this is /OMERO. For this implementation it could be
 * anything e.g. /Data1.
 * 
 * Methods that fail or cannot execute on the server will throw an
 * InternalException. This would not be normal and would indicate some
 * server or disk failure.
 **/
public abstract class _IRepositoryInfoDisp extends Ice.ObjectImpl implements IRepositoryInfo
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IRepositoryInfo",
        "::omero::api::ServiceInterface"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getFreeSpaceInKilobytes_async(AMD_IRepositoryInfo_getFreeSpaceInKilobytes __cb)
        throws omero.ServerError
    {
        getFreeSpaceInKilobytes_async(__cb, null);
    }

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getUsageFraction_async(AMD_IRepositoryInfo_getUsageFraction __cb)
        throws omero.ServerError
    {
        getUsageFraction_async(__cb, null);
    }

    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getUsedSpaceInKilobytes_async(AMD_IRepositoryInfo_getUsedSpaceInKilobytes __cb)
        throws omero.ServerError
    {
        getUsedSpaceInKilobytes_async(__cb, null);
    }

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void removeUnusedFiles_async(AMD_IRepositoryInfo_removeUnusedFiles __cb)
        throws omero.ServerError
    {
        removeUnusedFiles_async(__cb, null);
    }

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @param __cb The callback object for the operation.
     **/
    public final void sanityCheckRepository_async(AMD_IRepositoryInfo_sanityCheckRepository __cb)
        throws omero.ServerError
    {
        sanityCheckRepository_async(__cb, null);
    }

    public static Ice.DispatchStatus ___getUsedSpaceInKilobytes(IRepositoryInfo __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_IRepositoryInfo_getUsedSpaceInKilobytes __cb = new _AMD_IRepositoryInfo_getUsedSpaceInKilobytes(__inS);
        try
        {
            __obj.getUsedSpaceInKilobytes_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getFreeSpaceInKilobytes(IRepositoryInfo __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_IRepositoryInfo_getFreeSpaceInKilobytes __cb = new _AMD_IRepositoryInfo_getFreeSpaceInKilobytes(__inS);
        try
        {
            __obj.getFreeSpaceInKilobytes_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getUsageFraction(IRepositoryInfo __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_IRepositoryInfo_getUsageFraction __cb = new _AMD_IRepositoryInfo_getUsageFraction(__inS);
        try
        {
            __obj.getUsageFraction_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___sanityCheckRepository(IRepositoryInfo __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        AMD_IRepositoryInfo_sanityCheckRepository __cb = new _AMD_IRepositoryInfo_sanityCheckRepository(__inS);
        try
        {
            __obj.sanityCheckRepository_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___removeUnusedFiles(IRepositoryInfo __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        AMD_IRepositoryInfo_removeUnusedFiles __cb = new _AMD_IRepositoryInfo_removeUnusedFiles(__inS);
        try
        {
            __obj.removeUnusedFiles_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "getFreeSpaceInKilobytes",
        "getUsageFraction",
        "getUsedSpaceInKilobytes",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "removeUnusedFiles",
        "sanityCheckRepository"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___getFreeSpaceInKilobytes(this, in, __current);
            }
            case 1:
            {
                return ___getUsageFraction(this, in, __current);
            }
            case 2:
            {
                return ___getUsedSpaceInKilobytes(this, in, __current);
            }
            case 3:
            {
                return ___ice_id(this, in, __current);
            }
            case 4:
            {
                return ___ice_ids(this, in, __current);
            }
            case 5:
            {
                return ___ice_isA(this, in, __current);
            }
            case 6:
            {
                return ___ice_ping(this, in, __current);
            }
            case 7:
            {
                return ___removeUnusedFiles(this, in, __current);
            }
            case 8:
            {
                return ___sanityCheckRepository(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
