// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IRepositoryInfo.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides methods for obtaining information for server repository
 * disk space allocation. Could be used generically to obtain usage
 * information for any mount point, however, this interface is
 * prepared for the API to provide methods to obtain usage info for
 * the server filesystem containing the image uploads. For the OMERO
 * server base this is /OMERO. For this implementation it could be
 * anything e.g. /Data1.
 * 
 * Methods that fail or cannot execute on the server will throw an
 * InternalException. This would not be normal and would indicate some
 * server or disk failure.
 **/
public interface _IRepositoryInfoOperations extends _ServiceInterfaceOperations
{
    /**
     * Returns the total space in bytes for this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getUsedSpaceInKilobytes_async(AMD_IRepositoryInfo_getUsedSpaceInKilobytes __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns the free or available space on this file system
     * including nested subdirectories.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getFreeSpaceInKilobytes_async(AMD_IRepositoryInfo_getFreeSpaceInKilobytes __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns a double of the used space divided by the free
     * space.
     * This method will be called by a client to watch the
     * repository filesystem so that it doesn't exceed 95% full.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getUsageFraction_async(AMD_IRepositoryInfo_getUsageFraction __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Checks that image data repository has not exceeded 95% disk
     * space use level.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void sanityCheckRepository_async(AMD_IRepositoryInfo_sanityCheckRepository __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Removes all files from the server that do not have an
     * OriginalFile complement in the database, all the Pixels
     * that do not have a complement in the database and all the
     * Thumbnail's that do not have a complement in the database.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void removeUnusedFiles_async(AMD_IRepositoryInfo_removeUnusedFiles __cb, Ice.Current __current)
        throws omero.ServerError;
}
