// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IRoi.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Interface for working with regions of interest.
 **/
public abstract class _IRoiDisp extends Ice.ObjectImpl implements IRoi
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IRoi",
        "::omero::api::ServiceInterface"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Returns all the Rois in an Image, indexed via Shape.
     * 
     * Loads Rois as findByRoi.
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public final void findByImage_async(AMD_IRoi_findByImage __cb, long imageId, RoiOptions opts)
        throws omero.ServerError
    {
        findByImage_async(__cb, imageId, opts, null);
    }

    /**
     * Returns all the Rois on the given plane, indexed via Shape.
     * 
     * Loads Rois as findByRoi.
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public final void findByPlane_async(AMD_IRoi_findByPlane __cb, long imageId, int z, int t, RoiOptions opts)
        throws omero.ServerError
    {
        findByPlane_async(__cb, imageId, z, t, opts, null);
    }

    /**
     * Returns a RoiResult with a single Roi member.
     * Shape linkages are properly created.
     * All Shapes are loaded, as is the Pixels and Image object.
     * TODO: Annotations?
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public final void findByRoi_async(AMD_IRoi_findByRoi __cb, long roiId, RoiOptions opts)
        throws omero.ServerError
    {
        findByRoi_async(__cb, roiId, opts, null);
    }

    /**
     * Loads the ROIs which are linked to by the given
     * {@link omero.model.FileAnnotation} id for the given image.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationId if -1, logic is identical to findByImage(imageId, opts)
     * @deprecated This operation has been deprecated.
     **/
    public final void getMeasuredRois_async(AMD_IRoi_getMeasuredRois __cb, long imageId, long annotationId, RoiOptions opts)
        throws omero.ServerError
    {
        getMeasuredRois_async(__cb, imageId, annotationId, opts, null);
    }

    /**
     * Returns a map from {@link omero.model.FileAnnotation} ids
     * to {@link RoiResult} instances.
     * Logic is identical to getMeasuredRois, but Roi data will not be duplicated. (i.e.
     * the objects are referentially identical)
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public final void getMeasuredRoisMap_async(AMD_IRoi_getMeasuredRoisMap __cb, long imageId, java.util.List<Long> annotationIds, RoiOptions opts)
        throws omero.ServerError
    {
        getMeasuredRoisMap_async(__cb, imageId, annotationIds, opts, null);
    }

    /**
     * Calculate the points contained within a given shape
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public final void getPoints_async(AMD_IRoi_getPoints __cb, long shapeId)
        throws omero.ServerError
    {
        getPoints_async(__cb, shapeId, null);
    }

    /**
     * Returns a list of {@link omero.model.FileAnnotation}
     * instances with the namespace
     * <i>openmicroscopy.org/measurements</i> which are attached
     * to the {@link omero.model.Plate} containing the given image
     * AND which are attached to at least one
     * {@link omero.model.Roi}
     * 
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public final void getRoiMeasurements_async(AMD_IRoi_getRoiMeasurements __cb, long imageId, RoiOptions opts)
        throws omero.ServerError
    {
        getRoiMeasurements_async(__cb, imageId, opts, null);
    }

    /**
     * Calculate stats for all the shapes within the given Roi.
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public final void getRoiStats_async(AMD_IRoi_getRoiStats __cb, long roiId)
        throws omero.ServerError
    {
        getRoiStats_async(__cb, roiId, null);
    }

    /**
     * Calculate the stats for the points within the given Shape.
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public final void getShapeStats_async(AMD_IRoi_getShapeStats __cb, long shapeId)
        throws omero.ServerError
    {
        getShapeStats_async(__cb, shapeId, null);
    }

    /**
     * Calculate the stats for the points within the given Shapes.
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public final void getShapeStatsList_async(AMD_IRoi_getShapeStatsList __cb, java.util.List<Long> shapeIdList)
        throws omero.ServerError
    {
        getShapeStatsList_async(__cb, shapeIdList, null);
    }

    /**
     * Returns the OMERO.tables service via the
     * {@link omero.model.FileAnnotation} id returned
     * by {@link #getImageMeasurements}.
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public final void getTable_async(AMD_IRoi_getTable __cb, long annotationId)
        throws omero.ServerError
    {
        getTable_async(__cb, annotationId, null);
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public final void uploadMask_async(AMD_IRoi_uploadMask __cb, long roiId, int z, int t, byte[] bytes)
        throws omero.ServerError
    {
        uploadMask_async(__cb, roiId, z, t, bytes, null);
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___findByRoi(IRoi __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long roiId;
        RoiOptionsHolder opts = new RoiOptionsHolder();
        roiId = __is.readLong();
        __is.readObject(opts);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IRoi_findByRoi __cb = new _AMD_IRoi_findByRoi(__inS);
        try
        {
            __obj.findByRoi_async(__cb, roiId, opts.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___findByImage(IRoi __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long imageId;
        RoiOptionsHolder opts = new RoiOptionsHolder();
        imageId = __is.readLong();
        __is.readObject(opts);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IRoi_findByImage __cb = new _AMD_IRoi_findByImage(__inS);
        try
        {
            __obj.findByImage_async(__cb, imageId, opts.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___findByPlane(IRoi __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long imageId;
        int z;
        int t;
        RoiOptionsHolder opts = new RoiOptionsHolder();
        imageId = __is.readLong();
        z = __is.readInt();
        t = __is.readInt();
        __is.readObject(opts);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IRoi_findByPlane __cb = new _AMD_IRoi_findByPlane(__inS);
        try
        {
            __obj.findByPlane_async(__cb, imageId, z, t, opts.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___getPoints(IRoi __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shapeId;
        shapeId = __is.readLong();
        __inS.endReadParams();
        AMD_IRoi_getPoints __cb = new _AMD_IRoi_getPoints(__inS);
        try
        {
            __obj.getPoints_async(__cb, shapeId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___getRoiStats(IRoi __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long roiId;
        roiId = __is.readLong();
        __inS.endReadParams();
        AMD_IRoi_getRoiStats __cb = new _AMD_IRoi_getRoiStats(__inS);
        try
        {
            __obj.getRoiStats_async(__cb, roiId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___getShapeStats(IRoi __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shapeId;
        shapeId = __is.readLong();
        __inS.endReadParams();
        AMD_IRoi_getShapeStats __cb = new _AMD_IRoi_getShapeStats(__inS);
        try
        {
            __obj.getShapeStats_async(__cb, shapeId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___getShapeStatsList(IRoi __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<Long> shapeIdList;
        shapeIdList = LongListHelper.read(__is);
        __inS.endReadParams();
        AMD_IRoi_getShapeStatsList __cb = new _AMD_IRoi_getShapeStatsList(__inS);
        try
        {
            __obj.getShapeStatsList_async(__cb, shapeIdList, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___getRoiMeasurements(IRoi __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long imageId;
        RoiOptionsHolder opts = new RoiOptionsHolder();
        imageId = __is.readLong();
        __is.readObject(opts);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IRoi_getRoiMeasurements __cb = new _AMD_IRoi_getRoiMeasurements(__inS);
        try
        {
            __obj.getRoiMeasurements_async(__cb, imageId, opts.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___getMeasuredRois(IRoi __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long imageId;
        long annotationId;
        RoiOptionsHolder opts = new RoiOptionsHolder();
        imageId = __is.readLong();
        annotationId = __is.readLong();
        __is.readObject(opts);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IRoi_getMeasuredRois __cb = new _AMD_IRoi_getMeasuredRois(__inS);
        try
        {
            __obj.getMeasuredRois_async(__cb, imageId, annotationId, opts.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___getMeasuredRoisMap(IRoi __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long imageId;
        java.util.List<Long> annotationIds;
        RoiOptionsHolder opts = new RoiOptionsHolder();
        imageId = __is.readLong();
        annotationIds = LongListHelper.read(__is);
        __is.readObject(opts);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IRoi_getMeasuredRoisMap __cb = new _AMD_IRoi_getMeasuredRoisMap(__inS);
        try
        {
            __obj.getMeasuredRoisMap_async(__cb, imageId, annotationIds, opts.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___getTable(IRoi __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long annotationId;
        annotationId = __is.readLong();
        __inS.endReadParams();
        AMD_IRoi_getTable __cb = new _AMD_IRoi_getTable(__inS);
        try
        {
            __obj.getTable_async(__cb, annotationId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___uploadMask(IRoi __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long roiId;
        int z;
        int t;
        byte[] bytes;
        roiId = __is.readLong();
        z = __is.readInt();
        t = __is.readInt();
        bytes = Ice.ByteSeqHelper.read(__is);
        __inS.endReadParams();
        AMD_IRoi_uploadMask __cb = new _AMD_IRoi_uploadMask(__inS);
        try
        {
            __obj.uploadMask_async(__cb, roiId, z, t, bytes, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "findByImage",
        "findByPlane",
        "findByRoi",
        "getMeasuredRois",
        "getMeasuredRoisMap",
        "getPoints",
        "getRoiMeasurements",
        "getRoiStats",
        "getShapeStats",
        "getShapeStatsList",
        "getTable",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "uploadMask"
    };

    @SuppressWarnings("deprecation")
    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___findByImage(this, in, __current);
            }
            case 1:
            {
                return ___findByPlane(this, in, __current);
            }
            case 2:
            {
                return ___findByRoi(this, in, __current);
            }
            case 3:
            {
                return ___getMeasuredRois(this, in, __current);
            }
            case 4:
            {
                return ___getMeasuredRoisMap(this, in, __current);
            }
            case 5:
            {
                return ___getPoints(this, in, __current);
            }
            case 6:
            {
                return ___getRoiMeasurements(this, in, __current);
            }
            case 7:
            {
                return ___getRoiStats(this, in, __current);
            }
            case 8:
            {
                return ___getShapeStats(this, in, __current);
            }
            case 9:
            {
                return ___getShapeStatsList(this, in, __current);
            }
            case 10:
            {
                return ___getTable(this, in, __current);
            }
            case 11:
            {
                return ___ice_id(this, in, __current);
            }
            case 12:
            {
                return ___ice_ids(this, in, __current);
            }
            case 13:
            {
                return ___ice_isA(this, in, __current);
            }
            case 14:
            {
                return ___ice_ping(this, in, __current);
            }
            case 15:
            {
                return ___uploadMask(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
