// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IRoi.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Interface for working with regions of interest.
 **/
public interface _IRoiOperations extends _ServiceInterfaceOperations
{
    /**
     * Returns a RoiResult with a single Roi member.
     * Shape linkages are properly created.
     * All Shapes are loaded, as is the Pixels and Image object.
     * TODO: Annotations?
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void findByRoi_async(AMD_IRoi_findByRoi __cb, long roiId, RoiOptions opts, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns all the Rois in an Image, indexed via Shape.
     * 
     * Loads Rois as findByRoi.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void findByImage_async(AMD_IRoi_findByImage __cb, long imageId, RoiOptions opts, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns all the Rois on the given plane, indexed via Shape.
     * 
     * Loads Rois as findByRoi.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void findByPlane_async(AMD_IRoi_findByPlane __cb, long imageId, int z, int t, RoiOptions opts, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Calculate the points contained within a given shape
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void getPoints_async(AMD_IRoi_getPoints __cb, long shapeId, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Calculate stats for all the shapes within the given Roi.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void getRoiStats_async(AMD_IRoi_getRoiStats __cb, long roiId, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Calculate the stats for the points within the given Shape.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void getShapeStats_async(AMD_IRoi_getShapeStats __cb, long shapeId, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Calculate the stats for the points within the given Shapes.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void getShapeStatsList_async(AMD_IRoi_getShapeStatsList __cb, java.util.List<Long> shapeIdList, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns a list of {@link omero.model.FileAnnotation}
     * instances with the namespace
     * <i>openmicroscopy.org/measurements</i> which are attached
     * to the {@link omero.model.Plate} containing the given image
     * AND which are attached to at least one
     * {@link omero.model.Roi}
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void getRoiMeasurements_async(AMD_IRoi_getRoiMeasurements __cb, long imageId, RoiOptions opts, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Loads the ROIs which are linked to by the given
     * {@link omero.model.FileAnnotation} id for the given image.
     * 
     * @param __cb The callback object for the operation.
     * @param annotationId if -1, logic is identical to findByImage(imageId, opts)
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void getMeasuredRois_async(AMD_IRoi_getMeasuredRois __cb, long imageId, long annotationId, RoiOptions opts, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns a map from {@link omero.model.FileAnnotation} ids
     * to {@link RoiResult} instances.
     * Logic is identical to getMeasuredRois, but Roi data will not be duplicated. (i.e.
     * the objects are referentially identical)
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void getMeasuredRoisMap_async(AMD_IRoi_getMeasuredRoisMap __cb, long imageId, java.util.List<Long> annotationIds, RoiOptions opts, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns the OMERO.tables service via the
     * {@link omero.model.FileAnnotation} id returned
     * by {@link #getImageMeasurements}.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void getTable_async(AMD_IRoi_getTable __cb, long annotationId, Ice.Current __current)
        throws omero.ServerError;

    /**
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void uploadMask_async(AMD_IRoi_uploadMask __cb, long roiId, int z, int t, byte[] bytes, Ice.Current __current)
        throws omero.ServerError;
}
