// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `ISession.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * {@link omero.model.Session} creation service for OMERO. Access to
 * all other services is dependent upon a properly created and still
 * active {@link omero.model.Session}.
 * 
 * The session uuid ({@link omero.model.Session#getUuid}) can be
 * considered a capability token, or temporary single use password.
 * Simply by possessing it the client has access to all information
 * available to the {@link omero.model.Session}.
 * 
 * Note: Both the RMI <code>ome.system.ServiceFactory</code> as well
 * as the Ice {@link omero.api.ServiceFactory} use
 * {@link omero.api.ISession} to acquire a
 * {@link omero.model.Session}. In the Ice case, Glacier2
 * contacts {@link omero.api.ISession} itself and returns a
 * ServiceFactory remote proxy. From both ServiceFactory
 * instances, it is possible but not necessary to access
 * {@link omero.api.ISession}.
 **/
public abstract class _ISessionDisp extends Ice.ObjectImpl implements ISession
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::ISession",
        "::omero::api::ServiceInterface"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Closes session and releases all resources. It is preferred
     * that all clients call this method as soon as possible to
     * free memory, but it is possible to not call close, and
     * rejoin a session later.
     * 
     * The current reference count for the session is returned. If
     * the session does not exist, -1. If this call caused the
     * death of the session, then -2.
     * @param __cb The callback object for the operation.
     **/
    public final void closeSession_async(AMD_ISession_closeSession __cb, omero.model.Session sess)
        throws omero.ServerError
    {
        closeSession_async(__cb, sess, null);
    }

    /**
     * Creates a new session and returns it to the user.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void createSession_async(AMD_ISession_createSession __cb, omero.sys.Principal p, String credentials)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        createSession_async(__cb, p, credentials, null);
    }

    /**
     * Allows an admin to create a {@link Session} for the give
     * {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. This is useful to
     * override the server default so that an initial
     * delay before the user is given the token will
     * not be construed as idle time. A value less than
     * 1 will cause the default max timeToLive to be
     * used; but timeToIdle will be disabled.
     **/
    public final void createSessionWithTimeout_async(AMD_ISession_createSessionWithTimeout __cb, omero.sys.Principal p, long timeToLiveMilliseconds)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        createSessionWithTimeout_async(__cb, p, timeToLiveMilliseconds, null);
    }

    /**
     * Allows an admin to create a {@link omero.model.Session} for
     * the given {@link omero.sys.Principal}.
     * 
     * @param __cb The callback object for the operation.
     * @param timeToLiveMilliseconds
     * The time that this {@link omero.model.Session}
     * has until destruction. Setting the value to 0
     * will prevent destruction unless the session
     * remains idle.
     * @param timeToIdleMilliseconds
     * The time that this {@link omero.model.Session}
     * can remain idle before being destroyed. Setting
     * the value to 0 will prevent idleness based
     * destruction.
     **/
    public final void createSessionWithTimeouts_async(AMD_ISession_createSessionWithTimeouts __cb, omero.sys.Principal p, long timeToLiveMilliseconds, long timeToIdleMilliseconds)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        createSessionWithTimeouts_async(__cb, p, timeToLiveMilliseconds, timeToIdleMilliseconds, null);
    }

    /**
     * Allows a user to open up another session for him/herself with the given
     * defaults without needing to re-enter password.
     * @param __cb The callback object for the operation.
     **/
    public final void createUserSession_async(AMD_ISession_createUserSession __cb, long timeToLiveMilliseconds, long timeToIdleMilliseconds, String defaultGroup)
        throws Glacier2.CannotCreateSessionException,
               omero.ServerError
    {
        createUserSession_async(__cb, timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup, null);
    }

    /**
     * Retrieves an entry from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     **/
    public final void getInput_async(AMD_ISession_getInput __cb, String sess, String key)
        throws omero.ServerError
    {
        getInput_async(__cb, sess, key, null);
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session} input
     * environment.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getInputKeys_async(AMD_ISession_getInputKeys __cb, String sess)
        throws omero.ServerError
    {
        getInputKeys_async(__cb, sess, null);
    }

    /**
     * Retrieves all inputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     **/
    public final void getInputs_async(AMD_ISession_getInputs __cb, String sess)
        throws omero.ServerError
    {
        getInputs_async(__cb, sess, null);
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions with the given agent string.
     * @param __cb The callback object for the operation.
     **/
    public final void getMyOpenAgentSessions_async(AMD_ISession_getMyOpenAgentSessions __cb, String agent)
        throws omero.ServerError
    {
        getMyOpenAgentSessions_async(__cb, agent, null);
    }

    /**
     * Like {@link #getMyOpenSessions} but returns only those
     * sessions started by official OMERO clients.
     * @param __cb The callback object for the operation.
     **/
    public final void getMyOpenClientSessions_async(AMD_ISession_getMyOpenClientSessions __cb)
        throws omero.ServerError
    {
        getMyOpenClientSessions_async(__cb, null);
    }

    /**
     * Returns a list of open sessions for the current user. The
     * list is ordered by session creation time, so that the last
     * item was created last.
     * @param __cb The callback object for the operation.
     **/
    public final void getMyOpenSessions_async(AMD_ISession_getMyOpenSessions __cb)
        throws omero.ServerError
    {
        getMyOpenSessions_async(__cb, null);
    }

    /**
     * Retrieves an entry from the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     **/
    public final void getOutput_async(AMD_ISession_getOutput __cb, String sess, String key)
        throws omero.ServerError
    {
        getOutput_async(__cb, sess, key, null);
    }

    /**
     * Retrieves all keys in the {@link omero.model.Session}
     * output environment.
     * @param __cb The callback object for the operation.
     **/
    public final void getOutputKeys_async(AMD_ISession_getOutputKeys __cb, String sess)
        throws omero.ServerError
    {
        getOutputKeys_async(__cb, sess, null);
    }

    /**
     * Retrieves all outputs from the given
     * {@link omero.model.Session} input environment.
     * @param __cb The callback object for the operation.
     **/
    public final void getOutputs_async(AMD_ISession_getOutputs __cb, String sess)
        throws omero.ServerError
    {
        getOutputs_async(__cb, sess, null);
    }

    /**
     * Retrieves the current reference count for the given uuid.
     * Has the same semantics as {@link #getSession}.
     * @param __cb The callback object for the operation.
     **/
    public final void getReferenceCount_async(AMD_ISession_getReferenceCount __cb, String sessionUuid)
        throws omero.ServerError
    {
        getReferenceCount_async(__cb, sessionUuid, null);
    }

    /**
     * Retrieves the session associated with this uuid, updating
     * the last access time as well. Throws a
     * {@link RemovedSessionException} if not present, or
     * a {@link SessionTimeoutException} if expired.
     * 
     * This method can be used as a {@link Session} ping.
     * @param __cb The callback object for the operation.
     **/
    public final void getSession_async(AMD_ISession_getSession __cb, String sessionUuid)
        throws omero.ServerError
    {
        getSession_async(__cb, sessionUuid, null);
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * input environment.
     * If the value is null, the key will be removed.
     * @param __cb The callback object for the operation.
     **/
    public final void setInput_async(AMD_ISession_setInput __cb, String sess, String key, omero.RType value)
        throws omero.ServerError
    {
        setInput_async(__cb, sess, key, value, null);
    }

    /**
     * Places an entry in the given {@link omero.model.Session}
     * output environment. If the value is null, the key will be
     * removed.
     * @param __cb The callback object for the operation.
     **/
    public final void setOutput_async(AMD_ISession_setOutput __cb, String sess, String key, omero.RType value)
        throws omero.ServerError
    {
        setOutput_async(__cb, sess, key, value, null);
    }

    public static Ice.DispatchStatus ___createSession(ISession __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.sys.PrincipalHolder p = new omero.sys.PrincipalHolder();
        String credentials;
        __is.readObject(p);
        credentials = __is.readString();
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_ISession_createSession __cb = new _AMD_ISession_createSession(__inS);
        try
        {
            __obj.createSession_async(__cb, p.value, credentials, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___createUserSession(ISession __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long timeToLiveMilliseconds;
        long timeToIdleMilliseconds;
        String defaultGroup;
        timeToLiveMilliseconds = __is.readLong();
        timeToIdleMilliseconds = __is.readLong();
        defaultGroup = __is.readString();
        __inS.endReadParams();
        AMD_ISession_createUserSession __cb = new _AMD_ISession_createUserSession(__inS);
        try
        {
            __obj.createUserSession_async(__cb, timeToLiveMilliseconds, timeToIdleMilliseconds, defaultGroup, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___createSessionWithTimeout(ISession __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.sys.PrincipalHolder p = new omero.sys.PrincipalHolder();
        long timeToLiveMilliseconds;
        __is.readObject(p);
        timeToLiveMilliseconds = __is.readLong();
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_ISession_createSessionWithTimeout __cb = new _AMD_ISession_createSessionWithTimeout(__inS);
        try
        {
            __obj.createSessionWithTimeout_async(__cb, p.value, timeToLiveMilliseconds, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___createSessionWithTimeouts(ISession __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.sys.PrincipalHolder p = new omero.sys.PrincipalHolder();
        long timeToLiveMilliseconds;
        long timeToIdleMilliseconds;
        __is.readObject(p);
        timeToLiveMilliseconds = __is.readLong();
        timeToIdleMilliseconds = __is.readLong();
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_ISession_createSessionWithTimeouts __cb = new _AMD_ISession_createSessionWithTimeouts(__inS);
        try
        {
            __obj.createSessionWithTimeouts_async(__cb, p.value, timeToLiveMilliseconds, timeToIdleMilliseconds, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getSession(ISession __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String sessionUuid;
        sessionUuid = __is.readString();
        __inS.endReadParams();
        AMD_ISession_getSession __cb = new _AMD_ISession_getSession(__inS);
        try
        {
            __obj.getSession_async(__cb, sessionUuid, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getReferenceCount(ISession __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String sessionUuid;
        sessionUuid = __is.readString();
        __inS.endReadParams();
        AMD_ISession_getReferenceCount __cb = new _AMD_ISession_getReferenceCount(__inS);
        try
        {
            __obj.getReferenceCount_async(__cb, sessionUuid, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___closeSession(ISession __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.SessionHolder sess = new omero.model.SessionHolder();
        __is.readObject(sess);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_ISession_closeSession __cb = new _AMD_ISession_closeSession(__inS);
        try
        {
            __obj.closeSession_async(__cb, sess.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getMyOpenSessions(ISession __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_ISession_getMyOpenSessions __cb = new _AMD_ISession_getMyOpenSessions(__inS);
        try
        {
            __obj.getMyOpenSessions_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getMyOpenAgentSessions(ISession __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String agent;
        agent = __is.readString();
        __inS.endReadParams();
        AMD_ISession_getMyOpenAgentSessions __cb = new _AMD_ISession_getMyOpenAgentSessions(__inS);
        try
        {
            __obj.getMyOpenAgentSessions_async(__cb, agent, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getMyOpenClientSessions(ISession __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_ISession_getMyOpenClientSessions __cb = new _AMD_ISession_getMyOpenClientSessions(__inS);
        try
        {
            __obj.getMyOpenClientSessions_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getInput(ISession __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String sess;
        String key;
        sess = __is.readString();
        key = __is.readString();
        __inS.endReadParams();
        AMD_ISession_getInput __cb = new _AMD_ISession_getInput(__inS);
        try
        {
            __obj.getInput_async(__cb, sess, key, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getOutput(ISession __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String sess;
        String key;
        sess = __is.readString();
        key = __is.readString();
        __inS.endReadParams();
        AMD_ISession_getOutput __cb = new _AMD_ISession_getOutput(__inS);
        try
        {
            __obj.getOutput_async(__cb, sess, key, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setInput(ISession __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String sess;
        String key;
        omero.RTypeHolder value = new omero.RTypeHolder();
        sess = __is.readString();
        key = __is.readString();
        __is.readObject(value);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_ISession_setInput __cb = new _AMD_ISession_setInput(__inS);
        try
        {
            __obj.setInput_async(__cb, sess, key, value.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setOutput(ISession __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String sess;
        String key;
        omero.RTypeHolder value = new omero.RTypeHolder();
        sess = __is.readString();
        key = __is.readString();
        __is.readObject(value);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_ISession_setOutput __cb = new _AMD_ISession_setOutput(__inS);
        try
        {
            __obj.setOutput_async(__cb, sess, key, value.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getInputKeys(ISession __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String sess;
        sess = __is.readString();
        __inS.endReadParams();
        AMD_ISession_getInputKeys __cb = new _AMD_ISession_getInputKeys(__inS);
        try
        {
            __obj.getInputKeys_async(__cb, sess, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getOutputKeys(ISession __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String sess;
        sess = __is.readString();
        __inS.endReadParams();
        AMD_ISession_getOutputKeys __cb = new _AMD_ISession_getOutputKeys(__inS);
        try
        {
            __obj.getOutputKeys_async(__cb, sess, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getInputs(ISession __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String sess;
        sess = __is.readString();
        __inS.endReadParams();
        AMD_ISession_getInputs __cb = new _AMD_ISession_getInputs(__inS);
        try
        {
            __obj.getInputs_async(__cb, sess, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getOutputs(ISession __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String sess;
        sess = __is.readString();
        __inS.endReadParams();
        AMD_ISession_getOutputs __cb = new _AMD_ISession_getOutputs(__inS);
        try
        {
            __obj.getOutputs_async(__cb, sess, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "closeSession",
        "createSession",
        "createSessionWithTimeout",
        "createSessionWithTimeouts",
        "createUserSession",
        "getInput",
        "getInputKeys",
        "getInputs",
        "getMyOpenAgentSessions",
        "getMyOpenClientSessions",
        "getMyOpenSessions",
        "getOutput",
        "getOutputKeys",
        "getOutputs",
        "getReferenceCount",
        "getSession",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "setInput",
        "setOutput"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___closeSession(this, in, __current);
            }
            case 1:
            {
                return ___createSession(this, in, __current);
            }
            case 2:
            {
                return ___createSessionWithTimeout(this, in, __current);
            }
            case 3:
            {
                return ___createSessionWithTimeouts(this, in, __current);
            }
            case 4:
            {
                return ___createUserSession(this, in, __current);
            }
            case 5:
            {
                return ___getInput(this, in, __current);
            }
            case 6:
            {
                return ___getInputKeys(this, in, __current);
            }
            case 7:
            {
                return ___getInputs(this, in, __current);
            }
            case 8:
            {
                return ___getMyOpenAgentSessions(this, in, __current);
            }
            case 9:
            {
                return ___getMyOpenClientSessions(this, in, __current);
            }
            case 10:
            {
                return ___getMyOpenSessions(this, in, __current);
            }
            case 11:
            {
                return ___getOutput(this, in, __current);
            }
            case 12:
            {
                return ___getOutputKeys(this, in, __current);
            }
            case 13:
            {
                return ___getOutputs(this, in, __current);
            }
            case 14:
            {
                return ___getReferenceCount(this, in, __current);
            }
            case 15:
            {
                return ___getSession(this, in, __current);
            }
            case 16:
            {
                return ___ice_id(this, in, __current);
            }
            case 17:
            {
                return ___ice_ids(this, in, __current);
            }
            case 18:
            {
                return ___ice_isA(this, in, __current);
            }
            case 19:
            {
                return ___ice_ping(this, in, __current);
            }
            case 20:
            {
                return ___setInput(this, in, __current);
            }
            case 21:
            {
                return ___setOutput(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
