// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IShare.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides method for sharing - collaboration process for images,
 * datasets, projects.
 **/
public abstract class _IShareDisp extends Ice.ObjectImpl implements IShare
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IShare",
        "::omero::api::ServiceInterface"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __cb The callback object for the operation.
     **/
    public final void activate_async(AMD_IShare_activate __cb, long shareId)
        throws omero.ServerError
    {
        activate_async(__cb, shareId, null);
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public final void addComment_async(AMD_IShare_addComment __cb, long shareId, String comment)
        throws omero.ServerError
    {
        addComment_async(__cb, shareId, comment, null);
    }

    /**
     * Adds guest email address to the share.
     * @param __cb The callback object for the operation.
     **/
    public final void addGuest_async(AMD_IShare_addGuest __cb, long shareId, String emailAddress)
        throws omero.ServerError
    {
        addGuest_async(__cb, shareId, emailAddress, null);
    }

    /**
     * Adds guest email addresses to the share.
     * @param __cb The callback object for the operation.
     **/
    public final void addGuests_async(AMD_IShare_addGuests __cb, long shareId, java.util.List<String> emailAddresses)
        throws omero.ServerError
    {
        addGuests_async(__cb, shareId, emailAddresses, null);
    }

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __cb The callback object for the operation.
     **/
    public final void addObject_async(AMD_IShare_addObject __cb, long shareId, omero.model.IObject iobject)
        throws omero.ServerError
    {
        addObject_async(__cb, shareId, iobject, null);
    }

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __cb The callback object for the operation.
     **/
    public final void addObjects_async(AMD_IShare_addObjects __cb, long shareId, java.util.List<omero.model.IObject> iobjects)
        throws omero.ServerError
    {
        addObjects_async(__cb, shareId, iobjects, null);
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void addReply_async(AMD_IShare_addReply __cb, long shareId, String comment, omero.model.TextAnnotation replyTo)
        throws omero.ServerError
    {
        addReply_async(__cb, shareId, comment, replyTo, null);
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public final void addUser_async(AMD_IShare_addUser __cb, long shareId, omero.model.Experimenter exp)
        throws omero.ServerError
    {
        addUser_async(__cb, shareId, exp, null);
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public final void addUsers_async(AMD_IShare_addUsers __cb, long shareId, java.util.List<omero.model.Experimenter> exps)
        throws omero.ServerError
    {
        addUsers_async(__cb, shareId, exps, null);
    }

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __cb The callback object for the operation.
     **/
    public final void closeShare_async(AMD_IShare_closeShare __cb, long shareId)
        throws omero.ServerError
    {
        closeShare_async(__cb, shareId, null);
    }

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param __cb The callback object for the operation.
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     **/
    public final void createShare_async(AMD_IShare_createShare __cb, String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled)
        throws omero.ServerError
    {
        createShare_async(__cb, description, expiration, items, exps, guests, enabled, null);
    }

    /**
     * Turns off the access control lists with the current share.
     * @param __cb The callback object for the operation.
     **/
    public final void deactivate_async(AMD_IShare_deactivate __cb)
        throws omero.ServerError
    {
        deactivate_async(__cb, null);
    }

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __cb The callback object for the operation.
     **/
    public final void deleteComment_async(AMD_IShare_deleteComment __cb, omero.model.Annotation comment)
        throws omero.ServerError
    {
        deleteComment_async(__cb, comment, null);
    }

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getActiveConnections_async(AMD_IShare_getActiveConnections __cb, long shareId)
        throws omero.ServerError
    {
        getActiveConnections_async(__cb, shareId, null);
    }

    /**
     * Get the email addresses for all share guests.
     * @param __cb The callback object for the operation.
     **/
    public final void getAllGuests_async(AMD_IShare_getAllGuests __cb, long shareId)
        throws omero.ServerError
    {
        getAllGuests_async(__cb, shareId, null);
    }

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __cb The callback object for the operation.
     **/
    public final void getAllMembers_async(AMD_IShare_getAllMembers __cb, long shareId)
        throws omero.ServerError
    {
        getAllMembers_async(__cb, shareId, null);
    }

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param __cb The callback object for the operation.
     * @param shareId
     **/
    public final void getAllUsers_async(AMD_IShare_getAllUsers __cb, long shareId)
        throws omero.ServerError,
               omero.ValidationException
    {
        getAllUsers_async(__cb, shareId, null);
    }

    /**
     * Returns a map from share id to comment count.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     **/
    public final void getCommentCount_async(AMD_IShare_getCommentCount __cb, java.util.List<Long> shareIds)
        throws omero.ServerError
    {
        getCommentCount_async(__cb, shareIds, null);
    }

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getComments_async(AMD_IShare_getComments __cb, long shareId)
        throws omero.ServerError
    {
        getComments_async(__cb, shareId, null);
    }

    /**
     * Returns the contents of the share keyed by type.
     * @param __cb The callback object for the operation.
     **/
    public final void getContentMap_async(AMD_IShare_getContentMap __cb, long shareId)
        throws omero.ServerError
    {
        getContentMap_async(__cb, shareId, null);
    }

    /**
     * Returns the number of items in the share.
     * @param __cb The callback object for the operation.
     **/
    public final void getContentSize_async(AMD_IShare_getContentSize __cb, long shareId)
        throws omero.ServerError
    {
        getContentSize_async(__cb, shareId, null);
    }

    /**
     * Returns a range of items from the share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getContentSubList_async(AMD_IShare_getContentSubList __cb, long shareId, int start, int finish)
        throws omero.ServerError
    {
        getContentSubList_async(__cb, shareId, start, finish, null);
    }

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getContents_async(AMD_IShare_getContents __cb, long shareId)
        throws omero.ServerError
    {
        getContents_async(__cb, shareId, null);
    }

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __cb The callback object for the operation.
     **/
    public final void getEvents_async(AMD_IShare_getEvents __cb, long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to)
        throws omero.ServerError
    {
        getEvents_async(__cb, shareId, exp, from, to, null);
    }

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     **/
    public final void getMemberCount_async(AMD_IShare_getMemberCount __cb, java.util.List<Long> shareIds)
        throws omero.ServerError
    {
        getMemberCount_async(__cb, shareIds, null);
    }

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getMemberShares_async(AMD_IShare_getMemberShares __cb, boolean active)
        throws omero.ServerError
    {
        getMemberShares_async(__cb, active, null);
    }

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getMemberSharesFor_async(AMD_IShare_getMemberSharesFor __cb, omero.model.Experimenter user, boolean active)
        throws omero.ServerError
    {
        getMemberSharesFor_async(__cb, user, active, null);
    }

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getOwnShares_async(AMD_IShare_getOwnShares __cb, boolean active)
        throws omero.ServerError
    {
        getOwnShares_async(__cb, active, null);
    }

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getPastConnections_async(AMD_IShare_getPastConnections __cb, long shareId)
        throws omero.ServerError
    {
        getPastConnections_async(__cb, shareId, null);
    }

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getShare_async(AMD_IShare_getShare __cb, long shareId)
        throws omero.ServerError
    {
        getShare_async(__cb, shareId, null);
    }

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getSharesOwnedBy_async(AMD_IShare_getSharesOwnedBy __cb, omero.model.Experimenter user, boolean active)
        throws omero.ServerError
    {
        getSharesOwnedBy_async(__cb, user, active, null);
    }

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __cb The callback object for the operation.
     **/
    public final void invalidateConnection_async(AMD_IShare_invalidateConnection __cb, long shareId, omero.model.Experimenter exp)
        throws omero.ServerError
    {
        invalidateConnection_async(__cb, shareId, exp, null);
    }

    /**
     * Notifies via email selected members of share.
     * @param __cb The callback object for the operation.
     **/
    public final void notifyMembersOfShare_async(AMD_IShare_notifyMembersOfShare __cb, long shareId, String subject, String message, boolean html)
        throws omero.ServerError
    {
        notifyMembersOfShare_async(__cb, shareId, subject, message, html, null);
    }

    /**
     * Removes guest email address from share.
     * @param __cb The callback object for the operation.
     **/
    public final void removeGuest_async(AMD_IShare_removeGuest __cb, long shareId, String emailAddress)
        throws omero.ServerError
    {
        removeGuest_async(__cb, shareId, emailAddress, null);
    }

    /**
     * Removes guest email addresses from the share.
     * @param __cb The callback object for the operation.
     **/
    public final void removeGuests_async(AMD_IShare_removeGuests __cb, long shareId, java.util.List<String> emailAddresses)
        throws omero.ServerError
    {
        removeGuests_async(__cb, shareId, emailAddresses, null);
    }

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public final void removeObject_async(AMD_IShare_removeObject __cb, long shareId, omero.model.IObject iobject)
        throws omero.ServerError
    {
        removeObject_async(__cb, shareId, iobject, null);
    }

    /**
     * Remove existing items from the share.
     * @param __cb The callback object for the operation.
     **/
    public final void removeObjects_async(AMD_IShare_removeObjects __cb, long shareId, java.util.List<omero.model.IObject> iobjects)
        throws omero.ServerError
    {
        removeObjects_async(__cb, shareId, iobjects, null);
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public final void removeUser_async(AMD_IShare_removeUser __cb, long shareId, omero.model.Experimenter exp)
        throws omero.ServerError
    {
        removeUser_async(__cb, shareId, exp, null);
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public final void removeUsers_async(AMD_IShare_removeUsers __cb, long shareId, java.util.List<omero.model.Experimenter> exps)
        throws omero.ServerError
    {
        removeUsers_async(__cb, shareId, exps, null);
    }

    public final void setActive_async(AMD_IShare_setActive __cb, long shareId, boolean active)
        throws omero.ServerError
    {
        setActive_async(__cb, shareId, active, null);
    }

    public final void setDescription_async(AMD_IShare_setDescription __cb, long shareId, String description)
        throws omero.ServerError
    {
        setDescription_async(__cb, shareId, description, null);
    }

    public final void setExpiration_async(AMD_IShare_setExpiration __cb, long shareId, omero.RTime expiration)
        throws omero.ServerError
    {
        setExpiration_async(__cb, shareId, expiration, null);
    }

    public static Ice.DispatchStatus ___activate(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        shareId = __is.readLong();
        __inS.endReadParams();
        AMD_IShare_activate __cb = new _AMD_IShare_activate(__inS);
        try
        {
            __obj.activate_async(__cb, shareId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___deactivate(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_IShare_deactivate __cb = new _AMD_IShare_deactivate(__inS);
        try
        {
            __obj.deactivate_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getShare(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        shareId = __is.readLong();
        __inS.endReadParams();
        AMD_IShare_getShare __cb = new _AMD_IShare_getShare(__inS);
        try
        {
            __obj.getShare_async(__cb, shareId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getMemberCount(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<Long> shareIds;
        shareIds = omero.sys.LongListHelper.read(__is);
        __inS.endReadParams();
        AMD_IShare_getMemberCount __cb = new _AMD_IShare_getMemberCount(__inS);
        try
        {
            __obj.getMemberCount_async(__cb, shareIds, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getOwnShares(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean active;
        active = __is.readBool();
        __inS.endReadParams();
        AMD_IShare_getOwnShares __cb = new _AMD_IShare_getOwnShares(__inS);
        try
        {
            __obj.getOwnShares_async(__cb, active, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getMemberShares(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean active;
        active = __is.readBool();
        __inS.endReadParams();
        AMD_IShare_getMemberShares __cb = new _AMD_IShare_getMemberShares(__inS);
        try
        {
            __obj.getMemberShares_async(__cb, active, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getSharesOwnedBy(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterHolder user = new omero.model.ExperimenterHolder();
        boolean active;
        __is.readObject(user);
        active = __is.readBool();
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IShare_getSharesOwnedBy __cb = new _AMD_IShare_getSharesOwnedBy(__inS);
        try
        {
            __obj.getSharesOwnedBy_async(__cb, user.value, active, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getMemberSharesFor(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterHolder user = new omero.model.ExperimenterHolder();
        boolean active;
        __is.readObject(user);
        active = __is.readBool();
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IShare_getMemberSharesFor __cb = new _AMD_IShare_getMemberSharesFor(__inS);
        try
        {
            __obj.getMemberSharesFor_async(__cb, user.value, active, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getContents(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        shareId = __is.readLong();
        __inS.endReadParams();
        AMD_IShare_getContents __cb = new _AMD_IShare_getContents(__inS);
        try
        {
            __obj.getContents_async(__cb, shareId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getContentSubList(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        int start;
        int finish;
        shareId = __is.readLong();
        start = __is.readInt();
        finish = __is.readInt();
        __inS.endReadParams();
        AMD_IShare_getContentSubList __cb = new _AMD_IShare_getContentSubList(__inS);
        try
        {
            __obj.getContentSubList_async(__cb, shareId, start, finish, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getContentSize(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        shareId = __is.readLong();
        __inS.endReadParams();
        AMD_IShare_getContentSize __cb = new _AMD_IShare_getContentSize(__inS);
        try
        {
            __obj.getContentSize_async(__cb, shareId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getContentMap(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        shareId = __is.readLong();
        __inS.endReadParams();
        AMD_IShare_getContentMap __cb = new _AMD_IShare_getContentMap(__inS);
        try
        {
            __obj.getContentMap_async(__cb, shareId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___createShare(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String description;
        omero.RTimeHolder expiration = new omero.RTimeHolder();
        java.util.List<omero.model.IObject> items;
        java.util.List<omero.model.Experimenter> exps;
        java.util.List<String> guests;
        boolean enabled;
        description = __is.readString();
        __is.readObject(expiration);
        items = IObjectListHelper.read(__is);
        exps = ExperimenterListHelper.read(__is);
        guests = StringSetHelper.read(__is);
        enabled = __is.readBool();
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IShare_createShare __cb = new _AMD_IShare_createShare(__inS);
        try
        {
            __obj.createShare_async(__cb, description, expiration.value, items, exps, guests, enabled, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setDescription(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        String description;
        shareId = __is.readLong();
        description = __is.readString();
        __inS.endReadParams();
        AMD_IShare_setDescription __cb = new _AMD_IShare_setDescription(__inS);
        try
        {
            __obj.setDescription_async(__cb, shareId, description, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setExpiration(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        omero.RTimeHolder expiration = new omero.RTimeHolder();
        shareId = __is.readLong();
        __is.readObject(expiration);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IShare_setExpiration __cb = new _AMD_IShare_setExpiration(__inS);
        try
        {
            __obj.setExpiration_async(__cb, shareId, expiration.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setActive(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        boolean active;
        shareId = __is.readLong();
        active = __is.readBool();
        __inS.endReadParams();
        AMD_IShare_setActive __cb = new _AMD_IShare_setActive(__inS);
        try
        {
            __obj.setActive_async(__cb, shareId, active, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___closeShare(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        shareId = __is.readLong();
        __inS.endReadParams();
        AMD_IShare_closeShare __cb = new _AMD_IShare_closeShare(__inS);
        try
        {
            __obj.closeShare_async(__cb, shareId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___addObjects(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        java.util.List<omero.model.IObject> iobjects;
        shareId = __is.readLong();
        iobjects = IObjectListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IShare_addObjects __cb = new _AMD_IShare_addObjects(__inS);
        try
        {
            __obj.addObjects_async(__cb, shareId, iobjects, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___addObject(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        omero.model.IObjectHolder iobject = new omero.model.IObjectHolder();
        shareId = __is.readLong();
        __is.readObject(iobject);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IShare_addObject __cb = new _AMD_IShare_addObject(__inS);
        try
        {
            __obj.addObject_async(__cb, shareId, iobject.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___removeObjects(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        java.util.List<omero.model.IObject> iobjects;
        shareId = __is.readLong();
        iobjects = IObjectListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IShare_removeObjects __cb = new _AMD_IShare_removeObjects(__inS);
        try
        {
            __obj.removeObjects_async(__cb, shareId, iobjects, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___removeObject(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        omero.model.IObjectHolder iobject = new omero.model.IObjectHolder();
        shareId = __is.readLong();
        __is.readObject(iobject);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IShare_removeObject __cb = new _AMD_IShare_removeObject(__inS);
        try
        {
            __obj.removeObject_async(__cb, shareId, iobject.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getCommentCount(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<Long> shareIds;
        shareIds = omero.sys.LongListHelper.read(__is);
        __inS.endReadParams();
        AMD_IShare_getCommentCount __cb = new _AMD_IShare_getCommentCount(__inS);
        try
        {
            __obj.getCommentCount_async(__cb, shareIds, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getComments(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        shareId = __is.readLong();
        __inS.endReadParams();
        AMD_IShare_getComments __cb = new _AMD_IShare_getComments(__inS);
        try
        {
            __obj.getComments_async(__cb, shareId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___addComment(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        String comment;
        shareId = __is.readLong();
        comment = __is.readString();
        __inS.endReadParams();
        AMD_IShare_addComment __cb = new _AMD_IShare_addComment(__inS);
        try
        {
            __obj.addComment_async(__cb, shareId, comment, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___addReply(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        String comment;
        omero.model.TextAnnotationHolder replyTo = new omero.model.TextAnnotationHolder();
        shareId = __is.readLong();
        comment = __is.readString();
        __is.readObject(replyTo);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IShare_addReply __cb = new _AMD_IShare_addReply(__inS);
        try
        {
            __obj.addReply_async(__cb, shareId, comment, replyTo.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___deleteComment(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.AnnotationHolder comment = new omero.model.AnnotationHolder();
        __is.readObject(comment);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IShare_deleteComment __cb = new _AMD_IShare_deleteComment(__inS);
        try
        {
            __obj.deleteComment_async(__cb, comment.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getAllMembers(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        shareId = __is.readLong();
        __inS.endReadParams();
        AMD_IShare_getAllMembers __cb = new _AMD_IShare_getAllMembers(__inS);
        try
        {
            __obj.getAllMembers_async(__cb, shareId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getAllGuests(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        shareId = __is.readLong();
        __inS.endReadParams();
        AMD_IShare_getAllGuests __cb = new _AMD_IShare_getAllGuests(__inS);
        try
        {
            __obj.getAllGuests_async(__cb, shareId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getAllUsers(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        shareId = __is.readLong();
        __inS.endReadParams();
        AMD_IShare_getAllUsers __cb = new _AMD_IShare_getAllUsers(__inS);
        try
        {
            __obj.getAllUsers_async(__cb, shareId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___addUsers(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        java.util.List<omero.model.Experimenter> exps;
        shareId = __is.readLong();
        exps = ExperimenterListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IShare_addUsers __cb = new _AMD_IShare_addUsers(__inS);
        try
        {
            __obj.addUsers_async(__cb, shareId, exps, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___addGuests(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        java.util.List<String> emailAddresses;
        shareId = __is.readLong();
        emailAddresses = StringSetHelper.read(__is);
        __inS.endReadParams();
        AMD_IShare_addGuests __cb = new _AMD_IShare_addGuests(__inS);
        try
        {
            __obj.addGuests_async(__cb, shareId, emailAddresses, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___removeUsers(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        java.util.List<omero.model.Experimenter> exps;
        shareId = __is.readLong();
        exps = ExperimenterListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IShare_removeUsers __cb = new _AMD_IShare_removeUsers(__inS);
        try
        {
            __obj.removeUsers_async(__cb, shareId, exps, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___removeGuests(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        java.util.List<String> emailAddresses;
        shareId = __is.readLong();
        emailAddresses = StringSetHelper.read(__is);
        __inS.endReadParams();
        AMD_IShare_removeGuests __cb = new _AMD_IShare_removeGuests(__inS);
        try
        {
            __obj.removeGuests_async(__cb, shareId, emailAddresses, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___addUser(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        omero.model.ExperimenterHolder exp = new omero.model.ExperimenterHolder();
        shareId = __is.readLong();
        __is.readObject(exp);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IShare_addUser __cb = new _AMD_IShare_addUser(__inS);
        try
        {
            __obj.addUser_async(__cb, shareId, exp.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___addGuest(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        String emailAddress;
        shareId = __is.readLong();
        emailAddress = __is.readString();
        __inS.endReadParams();
        AMD_IShare_addGuest __cb = new _AMD_IShare_addGuest(__inS);
        try
        {
            __obj.addGuest_async(__cb, shareId, emailAddress, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___removeUser(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        omero.model.ExperimenterHolder exp = new omero.model.ExperimenterHolder();
        shareId = __is.readLong();
        __is.readObject(exp);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IShare_removeUser __cb = new _AMD_IShare_removeUser(__inS);
        try
        {
            __obj.removeUser_async(__cb, shareId, exp.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___removeGuest(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        String emailAddress;
        shareId = __is.readLong();
        emailAddress = __is.readString();
        __inS.endReadParams();
        AMD_IShare_removeGuest __cb = new _AMD_IShare_removeGuest(__inS);
        try
        {
            __obj.removeGuest_async(__cb, shareId, emailAddress, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getActiveConnections(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        shareId = __is.readLong();
        __inS.endReadParams();
        AMD_IShare_getActiveConnections __cb = new _AMD_IShare_getActiveConnections(__inS);
        try
        {
            __obj.getActiveConnections_async(__cb, shareId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getPastConnections(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        shareId = __is.readLong();
        __inS.endReadParams();
        AMD_IShare_getPastConnections __cb = new _AMD_IShare_getPastConnections(__inS);
        try
        {
            __obj.getPastConnections_async(__cb, shareId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___invalidateConnection(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        omero.model.ExperimenterHolder exp = new omero.model.ExperimenterHolder();
        shareId = __is.readLong();
        __is.readObject(exp);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IShare_invalidateConnection __cb = new _AMD_IShare_invalidateConnection(__inS);
        try
        {
            __obj.invalidateConnection_async(__cb, shareId, exp.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getEvents(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        omero.model.ExperimenterHolder exp = new omero.model.ExperimenterHolder();
        omero.RTimeHolder from = new omero.RTimeHolder();
        omero.RTimeHolder to = new omero.RTimeHolder();
        shareId = __is.readLong();
        __is.readObject(exp);
        __is.readObject(from);
        __is.readObject(to);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IShare_getEvents __cb = new _AMD_IShare_getEvents(__inS);
        try
        {
            __obj.getEvents_async(__cb, shareId, exp.value, from.value, to.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___notifyMembersOfShare(IShare __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long shareId;
        String subject;
        String message;
        boolean html;
        shareId = __is.readLong();
        subject = __is.readString();
        message = __is.readString();
        html = __is.readBool();
        __inS.endReadParams();
        AMD_IShare_notifyMembersOfShare __cb = new _AMD_IShare_notifyMembersOfShare(__inS);
        try
        {
            __obj.notifyMembersOfShare_async(__cb, shareId, subject, message, html, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "activate",
        "addComment",
        "addGuest",
        "addGuests",
        "addObject",
        "addObjects",
        "addReply",
        "addUser",
        "addUsers",
        "closeShare",
        "createShare",
        "deactivate",
        "deleteComment",
        "getActiveConnections",
        "getAllGuests",
        "getAllMembers",
        "getAllUsers",
        "getCommentCount",
        "getComments",
        "getContentMap",
        "getContentSize",
        "getContentSubList",
        "getContents",
        "getEvents",
        "getMemberCount",
        "getMemberShares",
        "getMemberSharesFor",
        "getOwnShares",
        "getPastConnections",
        "getShare",
        "getSharesOwnedBy",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "invalidateConnection",
        "notifyMembersOfShare",
        "removeGuest",
        "removeGuests",
        "removeObject",
        "removeObjects",
        "removeUser",
        "removeUsers",
        "setActive",
        "setDescription",
        "setExpiration"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___activate(this, in, __current);
            }
            case 1:
            {
                return ___addComment(this, in, __current);
            }
            case 2:
            {
                return ___addGuest(this, in, __current);
            }
            case 3:
            {
                return ___addGuests(this, in, __current);
            }
            case 4:
            {
                return ___addObject(this, in, __current);
            }
            case 5:
            {
                return ___addObjects(this, in, __current);
            }
            case 6:
            {
                return ___addReply(this, in, __current);
            }
            case 7:
            {
                return ___addUser(this, in, __current);
            }
            case 8:
            {
                return ___addUsers(this, in, __current);
            }
            case 9:
            {
                return ___closeShare(this, in, __current);
            }
            case 10:
            {
                return ___createShare(this, in, __current);
            }
            case 11:
            {
                return ___deactivate(this, in, __current);
            }
            case 12:
            {
                return ___deleteComment(this, in, __current);
            }
            case 13:
            {
                return ___getActiveConnections(this, in, __current);
            }
            case 14:
            {
                return ___getAllGuests(this, in, __current);
            }
            case 15:
            {
                return ___getAllMembers(this, in, __current);
            }
            case 16:
            {
                return ___getAllUsers(this, in, __current);
            }
            case 17:
            {
                return ___getCommentCount(this, in, __current);
            }
            case 18:
            {
                return ___getComments(this, in, __current);
            }
            case 19:
            {
                return ___getContentMap(this, in, __current);
            }
            case 20:
            {
                return ___getContentSize(this, in, __current);
            }
            case 21:
            {
                return ___getContentSubList(this, in, __current);
            }
            case 22:
            {
                return ___getContents(this, in, __current);
            }
            case 23:
            {
                return ___getEvents(this, in, __current);
            }
            case 24:
            {
                return ___getMemberCount(this, in, __current);
            }
            case 25:
            {
                return ___getMemberShares(this, in, __current);
            }
            case 26:
            {
                return ___getMemberSharesFor(this, in, __current);
            }
            case 27:
            {
                return ___getOwnShares(this, in, __current);
            }
            case 28:
            {
                return ___getPastConnections(this, in, __current);
            }
            case 29:
            {
                return ___getShare(this, in, __current);
            }
            case 30:
            {
                return ___getSharesOwnedBy(this, in, __current);
            }
            case 31:
            {
                return ___ice_id(this, in, __current);
            }
            case 32:
            {
                return ___ice_ids(this, in, __current);
            }
            case 33:
            {
                return ___ice_isA(this, in, __current);
            }
            case 34:
            {
                return ___ice_ping(this, in, __current);
            }
            case 35:
            {
                return ___invalidateConnection(this, in, __current);
            }
            case 36:
            {
                return ___notifyMembersOfShare(this, in, __current);
            }
            case 37:
            {
                return ___removeGuest(this, in, __current);
            }
            case 38:
            {
                return ___removeGuests(this, in, __current);
            }
            case 39:
            {
                return ___removeObject(this, in, __current);
            }
            case 40:
            {
                return ___removeObjects(this, in, __current);
            }
            case 41:
            {
                return ___removeUser(this, in, __current);
            }
            case 42:
            {
                return ___removeUsers(this, in, __current);
            }
            case 43:
            {
                return ___setActive(this, in, __current);
            }
            case 44:
            {
                return ___setDescription(this, in, __current);
            }
            case 45:
            {
                return ___setExpiration(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
