// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `ITypes.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Access to reflective type information. Also provides simplified
 * access to special types like enumerations.
 **/
public interface _ITypesOperations extends _ServiceInterfaceOperations
{
    void createEnumeration_async(AMD_ITypes_createEnumeration __cb, omero.model.IObject newEnum, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Lookup an enumeration value. As with the get-methods of
     * {@link omero.api.IQuery} queries returning no results
     * will through an exception.
     * 
     * @param __cb The callback object for the operation.
     * @param type An enumeration class which should be searched.
     * @param __current The Current object for the invocation.
     **/
    void getEnumeration_async(AMD_ITypes_getEnumeration __cb, String type, String value, Ice.Current __current)
        throws omero.ServerError;

    void allEnumerations_async(AMD_ITypes_allEnumerations __cb, String type, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Updates enumeration value specified by object.
     * 
     * @param __cb The callback object for the operation.
     * @param oldEnum An enumeration object which should be
     * searched.
     * @param __current The Current object for the invocation.
     **/
    void updateEnumeration_async(AMD_ITypes_updateEnumeration __cb, omero.model.IObject oldEnum, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Updates enumeration value specified by object.
     * 
     * @param __cb The callback object for the operation.
     * @param oldEnums An enumeration collection of objects which
     * should be searched.
     * @param __current The Current object for the invocation.
     **/
    void updateEnumerations_async(AMD_ITypes_updateEnumerations __cb, java.util.List<omero.model.IObject> oldEnums, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Deletes enumeration value specified by object.
     * 
     * @param __cb The callback object for the operation.
     * @param oldEnum An enumeration object which should be
     * searched.
     * @param __current The Current object for the invocation.
     **/
    void deleteEnumeration_async(AMD_ITypes_deleteEnumeration __cb, omero.model.IObject oldEnum, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Gets all metadata classes which are IEnum type.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getEnumerationTypes_async(AMD_ITypes_getEnumerationTypes __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns a list of classes which implement
     * {@link omero.model.IAnnotated}. These can
     * be used in combination with {@link omero.api.Search}.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getAnnotationTypes_async(AMD_ITypes_getAnnotationTypes __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Gets all metadata classes which are IEnum type with
     * contained objects.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getEnumerationsWithEntries_async(AMD_ITypes_getEnumerationsWithEntries __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Gets all original values.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getOriginalEnumerations_async(AMD_ITypes_getOriginalEnumerations __cb, Ice.Current __current)
        throws omero.ServerError;

    void resetEnumerations_async(AMD_ITypes_resetEnumerations __cb, String enumClass, Ice.Current __current)
        throws omero.ServerError;
}
