// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IUpdate.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides methods for directly updating object graphs. IUpdate is
 * the lowest level (level-1) interface which may make changes
 * (INSERT, UPDATE, DELETE) to the database. All other methods of
 * changing the database may leave it in an inconsistent state.
 * 
 * <p>
 * All the save* methods act recursively on the entire object graph,
 * replacing placeholders and details where necessary, and then
 * <i>merging</i> the final graph.
 * This means that the objects that are passed into IUpdate.save*
 * methods are copied over to new instances which are then returned.
 * The original objects <b>should be discarded</b>.
 * </p>
 * 
 * <p>{@link #saveAndReturnIds} behaves slightly differently in that
 * it does <em>not</em> handle object modifications. The graph of
 * objects passed in can consist <em>ONLY</em> if either newly created
 * objects without ids or of unloaded objects with ids. <em>Note:</em>
 * The ids of the saved values may not be in order. This is caused by
 * persistence-by-transitivity. Hibernate may detect an item later in
 * the array if they are interconnected and therefore choose to save
 * it first.
 * </p>
 * 
 * <p>
 * All methods throw {@link omero.ValidationException} if the input
 * objects do not pass validation, and
 * {@link omero.OptimisticLockException} if the version of a given has
 * already been incremented.
 **/
public abstract class _IUpdateDisp extends Ice.ObjectImpl implements IUpdate
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IUpdate",
        "::omero::api::ServiceInterface"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public final void deleteObject_async(AMD_IUpdate_deleteObject __cb, omero.model.IObject row)
        throws omero.ServerError
    {
        deleteObject_async(__cb, row, null);
    }

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param __cb The callback object for the operation.
     * @param row
     * a persistent {@link IObject} to be deleted
     **/
    public final void indexObject_async(AMD_IUpdate_indexObject __cb, omero.model.IObject row)
        throws omero.ServerError
    {
        indexObject_async(__cb, row, null);
    }

    public final void saveAndReturnArray_async(AMD_IUpdate_saveAndReturnArray __cb, java.util.List<omero.model.IObject> graph)
        throws omero.ServerError
    {
        saveAndReturnArray_async(__cb, graph, null);
    }

    public final void saveAndReturnIds_async(AMD_IUpdate_saveAndReturnIds __cb, java.util.List<omero.model.IObject> graph)
        throws omero.ServerError
    {
        saveAndReturnIds_async(__cb, graph, null);
    }

    public final void saveAndReturnObject_async(AMD_IUpdate_saveAndReturnObject __cb, omero.model.IObject obj)
        throws omero.ServerError
    {
        saveAndReturnObject_async(__cb, obj, null);
    }

    public final void saveArray_async(AMD_IUpdate_saveArray __cb, java.util.List<omero.model.IObject> graph)
        throws omero.ServerError
    {
        saveArray_async(__cb, graph, null);
    }

    public final void saveCollection_async(AMD_IUpdate_saveCollection __cb, java.util.List<omero.model.IObject> objs)
        throws omero.ServerError
    {
        saveCollection_async(__cb, objs, null);
    }

    public final void saveObject_async(AMD_IUpdate_saveObject __cb, omero.model.IObject obj)
        throws omero.ServerError
    {
        saveObject_async(__cb, obj, null);
    }

    public static Ice.DispatchStatus ___saveObject(IUpdate __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.IObjectHolder obj = new omero.model.IObjectHolder();
        __is.readObject(obj);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IUpdate_saveObject __cb = new _AMD_IUpdate_saveObject(__inS);
        try
        {
            __obj.saveObject_async(__cb, obj.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___saveCollection(IUpdate __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<omero.model.IObject> objs;
        objs = IObjectListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IUpdate_saveCollection __cb = new _AMD_IUpdate_saveCollection(__inS);
        try
        {
            __obj.saveCollection_async(__cb, objs, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___saveAndReturnObject(IUpdate __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.IObjectHolder obj = new omero.model.IObjectHolder();
        __is.readObject(obj);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IUpdate_saveAndReturnObject __cb = new _AMD_IUpdate_saveAndReturnObject(__inS);
        try
        {
            __obj.saveAndReturnObject_async(__cb, obj.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___saveArray(IUpdate __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<omero.model.IObject> graph;
        graph = IObjectListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IUpdate_saveArray __cb = new _AMD_IUpdate_saveArray(__inS);
        try
        {
            __obj.saveArray_async(__cb, graph, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___saveAndReturnArray(IUpdate __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<omero.model.IObject> graph;
        graph = IObjectListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IUpdate_saveAndReturnArray __cb = new _AMD_IUpdate_saveAndReturnArray(__inS);
        try
        {
            __obj.saveAndReturnArray_async(__cb, graph, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___saveAndReturnIds(IUpdate __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<omero.model.IObject> graph;
        graph = IObjectListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IUpdate_saveAndReturnIds __cb = new _AMD_IUpdate_saveAndReturnIds(__inS);
        try
        {
            __obj.saveAndReturnIds_async(__cb, graph, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___deleteObject(IUpdate __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.IObjectHolder row = new omero.model.IObjectHolder();
        __is.readObject(row);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IUpdate_deleteObject __cb = new _AMD_IUpdate_deleteObject(__inS);
        try
        {
            __obj.deleteObject_async(__cb, row.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___indexObject(IUpdate __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.IObjectHolder row = new omero.model.IObjectHolder();
        __is.readObject(row);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_IUpdate_indexObject __cb = new _AMD_IUpdate_indexObject(__inS);
        try
        {
            __obj.indexObject_async(__cb, row.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "deleteObject",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "indexObject",
        "saveAndReturnArray",
        "saveAndReturnIds",
        "saveAndReturnObject",
        "saveArray",
        "saveCollection",
        "saveObject"
    };

    @SuppressWarnings("deprecation")
    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___deleteObject(this, in, __current);
            }
            case 1:
            {
                return ___ice_id(this, in, __current);
            }
            case 2:
            {
                return ___ice_ids(this, in, __current);
            }
            case 3:
            {
                return ___ice_isA(this, in, __current);
            }
            case 4:
            {
                return ___ice_ping(this, in, __current);
            }
            case 5:
            {
                return ___indexObject(this, in, __current);
            }
            case 6:
            {
                return ___saveAndReturnArray(this, in, __current);
            }
            case 7:
            {
                return ___saveAndReturnIds(this, in, __current);
            }
            case 8:
            {
                return ___saveAndReturnObject(this, in, __current);
            }
            case 9:
            {
                return ___saveArray(this, in, __current);
            }
            case 10:
            {
                return ___saveCollection(this, in, __current);
            }
            case 11:
            {
                return ___saveObject(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
