// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IUpdate.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides methods for directly updating object graphs. IUpdate is
 * the lowest level (level-1) interface which may make changes
 * (INSERT, UPDATE, DELETE) to the database. All other methods of
 * changing the database may leave it in an inconsistent state.
 * 
 * <p>
 * All the save* methods act recursively on the entire object graph,
 * replacing placeholders and details where necessary, and then
 * <i>merging</i> the final graph.
 * This means that the objects that are passed into IUpdate.save*
 * methods are copied over to new instances which are then returned.
 * The original objects <b>should be discarded</b>.
 * </p>
 * 
 * <p>{@link #saveAndReturnIds} behaves slightly differently in that
 * it does <em>not</em> handle object modifications. The graph of
 * objects passed in can consist <em>ONLY</em> if either newly created
 * objects without ids or of unloaded objects with ids. <em>Note:</em>
 * The ids of the saved values may not be in order. This is caused by
 * persistence-by-transitivity. Hibernate may detect an item later in
 * the array if they are interconnected and therefore choose to save
 * it first.
 * </p>
 * 
 * <p>
 * All methods throw {@link omero.ValidationException} if the input
 * objects do not pass validation, and
 * {@link omero.OptimisticLockException} if the version of a given has
 * already been incremented.
 **/
public interface _IUpdateOperations extends _ServiceInterfaceOperations
{
    void saveObject_async(AMD_IUpdate_saveObject __cb, omero.model.IObject obj, Ice.Current __current)
        throws omero.ServerError;

    void saveCollection_async(AMD_IUpdate_saveCollection __cb, java.util.List<omero.model.IObject> objs, Ice.Current __current)
        throws omero.ServerError;

    void saveAndReturnObject_async(AMD_IUpdate_saveAndReturnObject __cb, omero.model.IObject obj, Ice.Current __current)
        throws omero.ServerError;

    void saveArray_async(AMD_IUpdate_saveArray __cb, java.util.List<omero.model.IObject> graph, Ice.Current __current)
        throws omero.ServerError;

    void saveAndReturnArray_async(AMD_IUpdate_saveAndReturnArray __cb, java.util.List<omero.model.IObject> graph, Ice.Current __current)
        throws omero.ServerError;

    void saveAndReturnIds_async(AMD_IUpdate_saveAndReturnIds __cb, java.util.List<omero.model.IObject> graph, Ice.Current __current)
        throws omero.ServerError;

    /**
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     * @deprecated This operation has been deprecated.
     **/
    void deleteObject_async(AMD_IUpdate_deleteObject __cb, omero.model.IObject row, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Initiates full-text indexing for the given object. This may
     * have to wait
     * for the current {@code FullTextThread} to finish.
     * Can only be executed by an admin. Other users must wait for
     * the background {@link Thread} to complete.
     * 
     * @param __cb The callback object for the operation.
     * @param row
     * a persistent {@link IObject} to be deleted
     * @param __current The Current object for the invocation.
     **/
    void indexObject_async(AMD_IUpdate_indexObject __cb, omero.model.IObject row, Ice.Current __current)
        throws omero.ServerError;
}
