// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `JobHandle.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Allows submission of asynchronous jobs.
 * <p>
 * NOTE: The calling order for the service is as follows:
 * <ol>
 * <li>{@link #submit} <em>or</em> {@link #attach}</li>
 * <li>any of the other methods</li>
 * <li>{@link #close}</li>
 * </ol>
 * </p>
 * Calling {@link #close} does not cancel or otherwise change
 * the Job state. See {@link #cancelJob}.
 **/
public abstract class _JobHandleDisp extends Ice.ObjectImpl implements JobHandle
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::JobHandle",
        "::omero::api::ServiceInterface",
        "::omero::api::StatefulServiceInterface"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void attach_async(AMD_JobHandle_attach __cb, long jobId)
        throws omero.ServerError
    {
        attach_async(__cb, jobId, null);
    }

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __cb The callback object for the operation.
     **/
    public final void cancelJob_async(AMD_JobHandle_cancelJob __cb)
        throws omero.ServerError
    {
        cancelJob_async(__cb, null);
    }

    /**
     * Returns the current {@link omero.model.Job}
     * @param __cb The callback object for the operation.
     **/
    public final void getJob_async(AMD_JobHandle_getJob __cb)
        throws omero.ServerError
    {
        getJob_async(__cb, null);
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __cb The callback object for the operation.
     **/
    public final void jobError_async(AMD_JobHandle_jobError __cb)
        throws omero.ServerError
    {
        jobError_async(__cb, null);
    }

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __cb The callback object for the operation.
     **/
    public final void jobFinished_async(AMD_JobHandle_jobFinished __cb)
        throws omero.ServerError
    {
        jobFinished_async(__cb, null);
    }

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __cb The callback object for the operation.
     **/
    public final void jobMessage_async(AMD_JobHandle_jobMessage __cb)
        throws omero.ServerError
    {
        jobMessage_async(__cb, null);
    }

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __cb The callback object for the operation.
     **/
    public final void jobRunning_async(AMD_JobHandle_jobRunning __cb)
        throws omero.ServerError
    {
        jobRunning_async(__cb, null);
    }

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __cb The callback object for the operation.
     **/
    public final void jobStatus_async(AMD_JobHandle_jobStatus __cb)
        throws omero.ServerError
    {
        jobStatus_async(__cb, null);
    }

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void setMessage_async(AMD_JobHandle_setMessage __cb, String message)
        throws omero.ServerError
    {
        setMessage_async(__cb, message, null);
    }

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __cb The callback object for the operation.
     **/
    public final void setStatus_async(AMD_JobHandle_setStatus __cb, String status)
        throws omero.ServerError
    {
        setStatus_async(__cb, status, null);
    }

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __cb The callback object for the operation.
     **/
    public final void setStatusAndMessage_async(AMD_JobHandle_setStatusAndMessage __cb, String status, omero.RString message)
        throws omero.ServerError
    {
        setStatusAndMessage_async(__cb, status, message, null);
    }

    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void submit_async(AMD_JobHandle_submit __cb, omero.model.Job j)
        throws omero.ServerError
    {
        submit_async(__cb, j, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public final void activate_async(AMD_StatefulServiceInterface_activate __cb)
        throws omero.ServerError
    {
        activate_async(__cb, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public final void close_async(AMD_StatefulServiceInterface_close __cb)
        throws omero.ServerError
    {
        close_async(__cb, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public final void getCurrentEventContext_async(AMD_StatefulServiceInterface_getCurrentEventContext __cb)
        throws omero.ServerError
    {
        getCurrentEventContext_async(__cb, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public final void passivate_async(AMD_StatefulServiceInterface_passivate __cb)
        throws omero.ServerError
    {
        passivate_async(__cb, null);
    }

    public static Ice.DispatchStatus ___submit(JobHandle __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.JobHolder j = new omero.model.JobHolder();
        __is.readObject(j);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_JobHandle_submit __cb = new _AMD_JobHandle_submit(__inS);
        try
        {
            __obj.submit_async(__cb, j.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___attach(JobHandle __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long jobId;
        jobId = __is.readLong();
        __inS.endReadParams();
        AMD_JobHandle_attach __cb = new _AMD_JobHandle_attach(__inS);
        try
        {
            __obj.attach_async(__cb, jobId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getJob(JobHandle __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_JobHandle_getJob __cb = new _AMD_JobHandle_getJob(__inS);
        try
        {
            __obj.getJob_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___jobStatus(JobHandle __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_JobHandle_jobStatus __cb = new _AMD_JobHandle_jobStatus(__inS);
        try
        {
            __obj.jobStatus_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___jobFinished(JobHandle __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_JobHandle_jobFinished __cb = new _AMD_JobHandle_jobFinished(__inS);
        try
        {
            __obj.jobFinished_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___jobMessage(JobHandle __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_JobHandle_jobMessage __cb = new _AMD_JobHandle_jobMessage(__inS);
        try
        {
            __obj.jobMessage_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___jobRunning(JobHandle __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_JobHandle_jobRunning __cb = new _AMD_JobHandle_jobRunning(__inS);
        try
        {
            __obj.jobRunning_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___jobError(JobHandle __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_JobHandle_jobError __cb = new _AMD_JobHandle_jobError(__inS);
        try
        {
            __obj.jobError_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___cancelJob(JobHandle __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        AMD_JobHandle_cancelJob __cb = new _AMD_JobHandle_cancelJob(__inS);
        try
        {
            __obj.cancelJob_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setStatus(JobHandle __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String status;
        status = __is.readString();
        __inS.endReadParams();
        AMD_JobHandle_setStatus __cb = new _AMD_JobHandle_setStatus(__inS);
        try
        {
            __obj.setStatus_async(__cb, status, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setMessage(JobHandle __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String message;
        message = __is.readString();
        __inS.endReadParams();
        AMD_JobHandle_setMessage __cb = new _AMD_JobHandle_setMessage(__inS);
        try
        {
            __obj.setMessage_async(__cb, message, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setStatusAndMessage(JobHandle __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String status;
        omero.RStringHolder message = new omero.RStringHolder();
        status = __is.readString();
        __is.readObject(message);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_JobHandle_setStatusAndMessage __cb = new _AMD_JobHandle_setStatusAndMessage(__inS);
        try
        {
            __obj.setStatusAndMessage_async(__cb, status, message.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "activate",
        "attach",
        "cancelJob",
        "close",
        "getCurrentEventContext",
        "getJob",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "jobError",
        "jobFinished",
        "jobMessage",
        "jobRunning",
        "jobStatus",
        "passivate",
        "setMessage",
        "setStatus",
        "setStatusAndMessage",
        "submit"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return _StatefulServiceInterfaceDisp.___activate(this, in, __current);
            }
            case 1:
            {
                return ___attach(this, in, __current);
            }
            case 2:
            {
                return ___cancelJob(this, in, __current);
            }
            case 3:
            {
                return _StatefulServiceInterfaceDisp.___close(this, in, __current);
            }
            case 4:
            {
                return _StatefulServiceInterfaceDisp.___getCurrentEventContext(this, in, __current);
            }
            case 5:
            {
                return ___getJob(this, in, __current);
            }
            case 6:
            {
                return ___ice_id(this, in, __current);
            }
            case 7:
            {
                return ___ice_ids(this, in, __current);
            }
            case 8:
            {
                return ___ice_isA(this, in, __current);
            }
            case 9:
            {
                return ___ice_ping(this, in, __current);
            }
            case 10:
            {
                return ___jobError(this, in, __current);
            }
            case 11:
            {
                return ___jobFinished(this, in, __current);
            }
            case 12:
            {
                return ___jobMessage(this, in, __current);
            }
            case 13:
            {
                return ___jobRunning(this, in, __current);
            }
            case 14:
            {
                return ___jobStatus(this, in, __current);
            }
            case 15:
            {
                return _StatefulServiceInterfaceDisp.___passivate(this, in, __current);
            }
            case 16:
            {
                return ___setMessage(this, in, __current);
            }
            case 17:
            {
                return ___setStatus(this, in, __current);
            }
            case 18:
            {
                return ___setStatusAndMessage(this, in, __current);
            }
            case 19:
            {
                return ___submit(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
