// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `JobHandle.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Allows submission of asynchronous jobs.
 * <p>
 * NOTE: The calling order for the service is as follows:
 * <ol>
 * <li>{@link #submit} <em>or</em> {@link #attach}</li>
 * <li>any of the other methods</li>
 * <li>{@link #close}</li>
 * </ol>
 * </p>
 * Calling {@link #close} does not cancel or otherwise change
 * the Job state. See {@link #cancelJob}.
 **/
public interface _JobHandleOperations extends _StatefulServiceInterfaceOperations
{
    /**
     * Submits a {@link omero.model.Job} and returns its database
     * id. The only fields directly on status which are editable
     * are <em>message</em>, <em>scheduledFor</em> and
     * <em>status</em>. The latter two must be sensible.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void submit_async(AMD_JobHandle_submit __cb, omero.model.Job j, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns the current {@link omero.model.JobStatus} for the
     * Job id.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void attach_async(AMD_JobHandle_attach __cb, long jobId, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns the current {@link omero.model.Job}
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getJob_async(AMD_JobHandle_getJob __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns the current {@link omero.model.JobStatus}. Will
     * never return null.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void jobStatus_async(AMD_JobHandle_jobStatus __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns <code>null</code> if the {@link omero.model.Job} is
     * not finished, otherwise the {@link omero.RTime} for when it
     * completed.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void jobFinished_async(AMD_JobHandle_jobFinished __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns the current message for job. May be set during
     * processing.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void jobMessage_async(AMD_JobHandle_jobMessage __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns <code>true</code> if the {@link omero.model.Job} is
     * running, i.e. has an attached process.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void jobRunning_async(AMD_JobHandle_jobRunning __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns <code>true</code> if the {@link omero.model.Job}
     * has thrown an error.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void jobError_async(AMD_JobHandle_jobError __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Marks a job for cancellation. Not every processor will
     * check for the cancelled flag for a running job, but no
     * non-running job will start if it has been cancelled.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void cancelJob_async(AMD_JobHandle_cancelJob __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Updates the {@link omero.model.JobStatus} for the current
     * job. The previous status is returned as a string. If the
     * status is {@link #CANCELLED}, this method is equivalent to
     * {@link #cancelJob}.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void setStatus_async(AMD_JobHandle_setStatus __cb, String status, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Sets the job's message string, and returns the previous
     * value.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void setMessage_async(AMD_JobHandle_setMessage __cb, String message, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Like {@link #setStatus} but also sets the message.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void setStatusAndMessage_async(AMD_JobHandle_setStatusAndMessage __cb, String status, omero.RString message, Ice.Current __current)
        throws omero.ServerError;
}
