// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `RawFileStore.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Raw file gateway which provides access to the OMERO file repository.
 * 
 * Note: methods on this service are protected by a <i>DOWNLOAD</i>
 * restriction.
 **/
public abstract class _RawFileStoreDisp extends Ice.ObjectImpl implements RawFileStore
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::RawFileStore",
        "::omero::api::ServiceInterface",
        "::omero::api::StatefulServiceInterface"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void exists_async(AMD_RawFileStore_exists __cb)
        throws omero.ServerError
    {
        exists_async(__cb, null);
    }

    /**
     * Returns the current file id or null if none has been set.
     * @param __cb The callback object for the operation.
     **/
    public final void getFileId_async(AMD_RawFileStore_getFileId __cb)
        throws omero.ServerError
    {
        getFileId_async(__cb, null);
    }

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __cb The callback object for the operation.
     **/
    public final void read_async(AMD_RawFileStore_read __cb, long position, int length)
        throws omero.ServerError
    {
        read_async(__cb, position, length, null);
    }

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __cb The callback object for the operation.
     **/
    public final void save_async(AMD_RawFileStore_save __cb)
        throws omero.ServerError
    {
        save_async(__cb, null);
    }

    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __cb The callback object for the operation.
     **/
    public final void setFileId_async(AMD_RawFileStore_setFileId __cb, long fileId)
        throws omero.ServerError
    {
        setFileId_async(__cb, fileId, null);
    }

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __cb The callback object for the operation.
     **/
    public final void size_async(AMD_RawFileStore_size __cb)
        throws omero.ServerError
    {
        size_async(__cb, null);
    }

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __cb The callback object for the operation.
     **/
    public final void truncate_async(AMD_RawFileStore_truncate __cb, long length)
        throws omero.ServerError
    {
        truncate_async(__cb, length, null);
    }

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __cb The callback object for the operation.
     **/
    public final void write_async(AMD_RawFileStore_write __cb, byte[] buf, long position, int length)
        throws omero.ServerError
    {
        write_async(__cb, buf, position, length, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public final void activate_async(AMD_StatefulServiceInterface_activate __cb)
        throws omero.ServerError
    {
        activate_async(__cb, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public final void close_async(AMD_StatefulServiceInterface_close __cb)
        throws omero.ServerError
    {
        close_async(__cb, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public final void getCurrentEventContext_async(AMD_StatefulServiceInterface_getCurrentEventContext __cb)
        throws omero.ServerError
    {
        getCurrentEventContext_async(__cb, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public final void passivate_async(AMD_StatefulServiceInterface_passivate __cb)
        throws omero.ServerError
    {
        passivate_async(__cb, null);
    }

    public static Ice.DispatchStatus ___setFileId(RawFileStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long fileId;
        fileId = __is.readLong();
        __inS.endReadParams();
        AMD_RawFileStore_setFileId __cb = new _AMD_RawFileStore_setFileId(__inS);
        try
        {
            __obj.setFileId_async(__cb, fileId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getFileId(RawFileStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RawFileStore_getFileId __cb = new _AMD_RawFileStore_getFileId(__inS);
        try
        {
            __obj.getFileId_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___read(RawFileStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long position;
        int length;
        position = __is.readLong();
        length = __is.readInt();
        __inS.endReadParams();
        AMD_RawFileStore_read __cb = new _AMD_RawFileStore_read(__inS);
        try
        {
            __obj.read_async(__cb, position, length, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___size(RawFileStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RawFileStore_size __cb = new _AMD_RawFileStore_size(__inS);
        try
        {
            __obj.size_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___truncate(RawFileStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long length;
        length = __is.readLong();
        __inS.endReadParams();
        AMD_RawFileStore_truncate __cb = new _AMD_RawFileStore_truncate(__inS);
        try
        {
            __obj.truncate_async(__cb, length, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___write(RawFileStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        byte[] buf;
        long position;
        int length;
        buf = Ice.ByteSeqHelper.read(__is);
        position = __is.readLong();
        length = __is.readInt();
        __inS.endReadParams();
        AMD_RawFileStore_write __cb = new _AMD_RawFileStore_write(__inS);
        try
        {
            __obj.write_async(__cb, buf, position, length, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___exists(RawFileStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RawFileStore_exists __cb = new _AMD_RawFileStore_exists(__inS);
        try
        {
            __obj.exists_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___save(RawFileStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RawFileStore_save __cb = new _AMD_RawFileStore_save(__inS);
        try
        {
            __obj.save_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "activate",
        "close",
        "exists",
        "getCurrentEventContext",
        "getFileId",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "passivate",
        "read",
        "save",
        "setFileId",
        "size",
        "truncate",
        "write"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return _StatefulServiceInterfaceDisp.___activate(this, in, __current);
            }
            case 1:
            {
                return _StatefulServiceInterfaceDisp.___close(this, in, __current);
            }
            case 2:
            {
                return ___exists(this, in, __current);
            }
            case 3:
            {
                return _StatefulServiceInterfaceDisp.___getCurrentEventContext(this, in, __current);
            }
            case 4:
            {
                return ___getFileId(this, in, __current);
            }
            case 5:
            {
                return ___ice_id(this, in, __current);
            }
            case 6:
            {
                return ___ice_ids(this, in, __current);
            }
            case 7:
            {
                return ___ice_isA(this, in, __current);
            }
            case 8:
            {
                return ___ice_ping(this, in, __current);
            }
            case 9:
            {
                return _StatefulServiceInterfaceDisp.___passivate(this, in, __current);
            }
            case 10:
            {
                return ___read(this, in, __current);
            }
            case 11:
            {
                return ___save(this, in, __current);
            }
            case 12:
            {
                return ___setFileId(this, in, __current);
            }
            case 13:
            {
                return ___size(this, in, __current);
            }
            case 14:
            {
                return ___truncate(this, in, __current);
            }
            case 15:
            {
                return ___write(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
