// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `RawFileStore.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Raw file gateway which provides access to the OMERO file repository.
 * 
 * Note: methods on this service are protected by a <i>DOWNLOAD</i>
 * restriction.
 **/
public interface _RawFileStoreOperationsNC extends _StatefulServiceInterfaceOperationsNC
{
    /**
     * This method manages the state of the service. This method
     * will throw a {@link omero.SecurityViolation} if for the
     * current user context either the file is not readable or a
     * {@link omero.constants.permissions#DOWNLOAD} restriction is
     * in place.
     * @param __cb The callback object for the operation.
     **/
    void setFileId_async(AMD_RawFileStore_setFileId __cb, long fileId)
        throws omero.ServerError;

    /**
     * Returns the current file id or null if none has been set.
     * @param __cb The callback object for the operation.
     **/
    void getFileId_async(AMD_RawFileStore_getFileId __cb)
        throws omero.ServerError;

    /**
     * Reads <code>length</code> bytes of data at the
     * <code>position</code> from the raw file into an array of
     * bytes.
     * @param __cb The callback object for the operation.
     **/
    void read_async(AMD_RawFileStore_read __cb, long position, int length)
        throws omero.ServerError;

    /**
     * Returns the size of the file on disk (not as stored in the
     * database since that value will only be updated on
     * {@link #save}. If the file has not yet been written to, and
     * therefore does not exist, a {@link omero.ResourceError}
     * will be thrown.
     * @param __cb The callback object for the operation.
     **/
    void size_async(AMD_RawFileStore_size __cb)
        throws omero.ServerError;

    /**
     * Limits the size of a file to the given length. If the file
     * is already shorter than length, no action is taken in which
     * case false is returned.
     * @param __cb The callback object for the operation.
     **/
    void truncate_async(AMD_RawFileStore_truncate __cb, long length)
        throws omero.ServerError;

    /**
     * Writes <code>length</code> bytes of data from the specified
     * <code>buf</code> byte array starting at at
     * <code>position</code> to the raw file.
     * @param __cb The callback object for the operation.
     **/
    void write_async(AMD_RawFileStore_write __cb, byte[] buf, long position, int length)
        throws omero.ServerError;

    /**
     * Checks to see if a raw file exists with the file ID that
     * the service was initialized with.
     * 
     * @param __cb The callback object for the operation.
     **/
    void exists_async(AMD_RawFileStore_exists __cb)
        throws omero.ServerError;

    /**
     * Saves the {@link omero.model.OriginalFile} associated with
     * the service if it has been modified. The returned valued
     * should replace all instances of the
     * {@link omero.model.OriginalFile} in the client.
     * 
     * If save has not been called, {@link omero.api.RawFileStore}
     * instances will save the {@link omero.model.OriginalFile}
     * object associated with it on {@link #close}.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1651">ticket 1651</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/2161">ticket 2161</a>.
     * @param __cb The callback object for the operation.
     **/
    void save_async(AMD_RawFileStore_save __cb)
        throws omero.ServerError;
}
