// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `RawPixelsStore.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Binary data provider. Initialized with the ID of a
 * {@link omero.model.Pixels} instance, this service can provide
 * various slices, stacks, regions of the 5-dimensional (X-Y planes with
 * multiple Z-sections and Channels over Time). The byte array returned
 * by the getter methods and passed to the setter methods can and will
 * be interpreted according to results of {@link #getByteWidth},
 * {@link #isFloat}, and {@link #isSigned}.
 * 
 * <p>
 * <b>Read-only caveat</b>:
 * 
 * Mutating methods (set*) are only available during the first access.
 * Once the Pixels data has been successfully saved (via the save or
 * close methods on this interface), then the data should be treated
 * read-only. If Pixels data writing fails and the service is
 * inadvertently closed, delete the Pixels object, and create a new
 * one. Any partially written data will be removed.
 **/
public abstract class _RawPixelsStoreDisp extends Ice.ObjectImpl implements RawPixelsStore
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::PyramidService",
        "::omero::api::RawPixelsStore",
        "::omero::api::ServiceInterface",
        "::omero::api::StatefulServiceInterface"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[2];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[2];
    }

    public static String ice_staticId()
    {
        return __ids[2];
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     **/
    public final void getResolutionDescriptions_async(AMD_PyramidService_getResolutionDescriptions __cb)
        throws omero.ServerError
    {
        getResolutionDescriptions_async(__cb, null);
    }

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     **/
    public final void getResolutionLevel_async(AMD_PyramidService_getResolutionLevel __cb)
        throws omero.ServerError
    {
        getResolutionLevel_async(__cb, null);
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     **/
    public final void getResolutionLevels_async(AMD_PyramidService_getResolutionLevels __cb)
        throws omero.ServerError
    {
        getResolutionLevels_async(__cb, null);
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     **/
    public final void getTileSize_async(AMD_PyramidService_getTileSize __cb)
        throws omero.ServerError
    {
        getTileSize_async(__cb, null);
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     **/
    public final void requiresPixelsPyramid_async(AMD_PyramidService_requiresPixelsPyramid __cb)
        throws omero.ServerError
    {
        requiresPixelsPyramid_async(__cb, null);
    }

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     **/
    public final void setResolutionLevel_async(AMD_PyramidService_setResolutionLevel __cb, int resolutionLevel)
        throws omero.ServerError
    {
        setResolutionLevel_async(__cb, resolutionLevel, null);
    }

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __cb The callback object for the operation.
     **/
    public final void calculateMessageDigest_async(AMD_RawPixelsStore_calculateMessageDigest __cb)
        throws omero.ServerError
    {
        calculateMessageDigest_async(__cb, null);
    }

    /**
     * Returns the byte width for the pixel store.
     * @param __cb The callback object for the operation.
     **/
    public final void getByteWidth_async(AMD_RawPixelsStore_getByteWidth __cb)
        throws omero.ServerError
    {
        getByteWidth_async(__cb, null);
    }

    /**
     * Retrieves a particular column from this pixel store.
     * @param __cb The callback object for the operation.
     * @param x offset across the X-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     **/
    public final void getCol_async(AMD_RawPixelsStore_getCol __cb, int x, int z, int c, int t)
        throws omero.ServerError
    {
        getCol_async(__cb, x, z, c, t, null);
    }

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param __cb The callback object for the operation.
     * @param channels the channels to generate the histogram data for
     * @param plane the plane (optional, default: whole region of first z/t plane)
     **/
    public final void getHistogram_async(AMD_RawPixelsStore_getHistogram __cb, int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane)
        throws omero.ServerError
    {
        getHistogram_async(__cb, channels, binCount, globalRange, plane, null);
    }

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size of each dimension (dependent on dimension).
     **/
    public final void getHypercube_async(AMD_RawPixelsStore_getHypercube __cb, java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step)
        throws omero.ServerError
    {
        getHypercube_async(__cb, offset, size, step, null);
    }

    /**
     * Returns the current Pixels set identifier.
     * @param __cb The callback object for the operation.
     **/
    public final void getPixelsId_async(AMD_RawPixelsStore_getPixelsId __cb)
        throws omero.ServerError
    {
        getPixelsId_async(__cb, null);
    }

    /**
     * Returns the current Pixels path.
     * @param __cb The callback object for the operation.
     **/
    public final void getPixelsPath_async(AMD_RawPixelsStore_getPixelsPath __cb)
        throws omero.ServerError
    {
        getPixelsPath_async(__cb, null);
    }

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     **/
    public final void getPlane_async(AMD_RawPixelsStore_getPlane __cb, int z, int c, int t)
        throws omero.ServerError
    {
        getPlane_async(__cb, z, c, t, null);
    }

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     **/
    public final void getPlaneOffset_async(AMD_RawPixelsStore_getPlaneOffset __cb, int z, int c, int t)
        throws omero.ServerError
    {
        getPlaneOffset_async(__cb, z, c, t, null);
    }

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     **/
    public final void getPlaneRegion_async(AMD_RawPixelsStore_getPlaneRegion __cb, int z, int c, int t, int size, int offset)
        throws omero.ServerError
    {
        getPlaneRegion_async(__cb, z, c, t, size, offset, null);
    }

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __cb The callback object for the operation.
     **/
    public final void getPlaneSize_async(AMD_RawPixelsStore_getPlaneSize __cb)
        throws omero.ServerError
    {
        getPlaneSize_async(__cb, null);
    }

    /**
     * Retrieves a region from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to retrieve.
     **/
    public final void getRegion_async(AMD_RawPixelsStore_getRegion __cb, int size, long offset)
        throws omero.ServerError
    {
        getRegion_async(__cb, size, offset, null);
    }

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     **/
    public final void getRow_async(AMD_RawPixelsStore_getRow __cb, int y, int z, int c, int t)
        throws omero.ServerError
    {
        getRow_async(__cb, y, z, c, t, null);
    }

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     **/
    public final void getRowOffset_async(AMD_RawPixelsStore_getRowOffset __cb, int y, int z, int c, int t)
        throws omero.ServerError
    {
        getRowOffset_async(__cb, y, z, c, t, null);
    }

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __cb The callback object for the operation.
     **/
    public final void getRowSize_async(AMD_RawPixelsStore_getRowSize __cb)
        throws omero.ServerError
    {
        getRowSize_async(__cb, null);
    }

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel store.
     **/
    public final void getStack_async(AMD_RawPixelsStore_getStack __cb, int c, int t)
        throws omero.ServerError
    {
        getStack_async(__cb, c, t, null);
    }

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel buffer.
     **/
    public final void getStackOffset_async(AMD_RawPixelsStore_getStackOffset __cb, int c, int t)
        throws omero.ServerError
    {
        getStackOffset_async(__cb, c, t, null);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getStackSize_async(AMD_RawPixelsStore_getStackSize __cb)
        throws omero.ServerError
    {
        getStackSize_async(__cb, null);
    }

    /**
     * Retrieves a tile from this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param y Top left corner of the tile, Y offset.
     * @param h Height of the tile.
     **/
    public final void getTile_async(AMD_RawPixelsStore_getTile __cb, int z, int c, int t, int x, int y, int w, int h)
        throws omero.ServerError
    {
        getTile_async(__cb, z, c, t, x, y, w, h, null);
    }

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel store.
     **/
    public final void getTimepoint_async(AMD_RawPixelsStore_getTimepoint __cb, int t)
        throws omero.ServerError
    {
        getTimepoint_async(__cb, t, null);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel buffer.
     **/
    public final void getTimepointOffset_async(AMD_RawPixelsStore_getTimepointOffset __cb, int t)
        throws omero.ServerError
    {
        getTimepointOffset_async(__cb, t, null);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     **/
    public final void getTimepointSize_async(AMD_RawPixelsStore_getTimepointSize __cb)
        throws omero.ServerError
    {
        getTimepointSize_async(__cb, null);
    }

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __cb The callback object for the operation.
     **/
    public final void getTotalSize_async(AMD_RawPixelsStore_getTotalSize __cb)
        throws omero.ServerError
    {
        getTotalSize_async(__cb, null);
    }

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __cb The callback object for the operation.
     **/
    public final void isFloat_async(AMD_RawPixelsStore_isFloat __cb)
        throws omero.ServerError
    {
        isFloat_async(__cb, null);
    }

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __cb The callback object for the operation.
     **/
    public final void isSigned_async(AMD_RawPixelsStore_isSigned __cb)
        throws omero.ServerError
    {
        isSigned_async(__cb, null);
    }

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsIds Pixels IDs to cache.
     **/
    public final void prepare_async(AMD_RawPixelsStore_prepare __cb, java.util.List<Long> pixelsIds)
        throws omero.ServerError
    {
        prepare_async(__cb, pixelsIds, null);
    }

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void save_async(AMD_RawPixelsStore_save __cb)
        throws omero.ServerError
    {
        save_async(__cb, null);
    }

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId Pixels set identifier.
     **/
    public final void setPixelsId_async(AMD_RawPixelsStore_setPixelsId __cb, long pixelsId, boolean bypassOriginalFile)
        throws omero.ServerError
    {
        setPixelsId_async(__cb, pixelsId, bypassOriginalFile, null);
    }

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param c offset across the C-axis of the pixel store.
     **/
    public final void setPlane_async(AMD_RawPixelsStore_setPlane __cb, byte[] buf, int z, int c, int t)
        throws omero.ServerError
    {
        setPlane_async(__cb, buf, z, c, t, null);
    }

    /**
     * Sets a region in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to set.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public final void setRegion_async(AMD_RawPixelsStore_setRegion __cb, int size, long offset, byte[] buf)
        throws omero.ServerError
    {
        setRegion_async(__cb, size, offset, buf, null);
    }

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public final void setRow_async(AMD_RawPixelsStore_setRow __cb, byte[] buf, int y, int z, int c, int t)
        throws omero.ServerError
    {
        setRow_async(__cb, buf, y, z, c, t, null);
    }

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this stack.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public final void setStack_async(AMD_RawPixelsStore_setStack __cb, byte[] buf, int z, int c, int t)
        throws omero.ServerError
    {
        setStack_async(__cb, buf, z, c, t, null);
    }

    /**
     * Sets a tile in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param buf A byte array of the data.
     * @param c offset across the C-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param w Width of the tile.
     **/
    public final void setTile_async(AMD_RawPixelsStore_setTile __cb, byte[] buf, int z, int c, int t, int x, int y, int w, int h)
        throws omero.ServerError
    {
        setTile_async(__cb, buf, z, c, t, x, y, w, h, null);
    }

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this timepoint.
     **/
    public final void setTimepoint_async(AMD_RawPixelsStore_setTimepoint __cb, byte[] buf, int t)
        throws omero.ServerError
    {
        setTimepoint_async(__cb, buf, t, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public final void activate_async(AMD_StatefulServiceInterface_activate __cb)
        throws omero.ServerError
    {
        activate_async(__cb, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public final void close_async(AMD_StatefulServiceInterface_close __cb)
        throws omero.ServerError
    {
        close_async(__cb, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public final void getCurrentEventContext_async(AMD_StatefulServiceInterface_getCurrentEventContext __cb)
        throws omero.ServerError
    {
        getCurrentEventContext_async(__cb, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public final void passivate_async(AMD_StatefulServiceInterface_passivate __cb)
        throws omero.ServerError
    {
        passivate_async(__cb, null);
    }

    public static Ice.DispatchStatus ___setPixelsId(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long pixelsId;
        boolean bypassOriginalFile;
        pixelsId = __is.readLong();
        bypassOriginalFile = __is.readBool();
        __inS.endReadParams();
        AMD_RawPixelsStore_setPixelsId __cb = new _AMD_RawPixelsStore_setPixelsId(__inS);
        try
        {
            __obj.setPixelsId_async(__cb, pixelsId, bypassOriginalFile, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getPixelsId(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RawPixelsStore_getPixelsId __cb = new _AMD_RawPixelsStore_getPixelsId(__inS);
        try
        {
            __obj.getPixelsId_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getPixelsPath(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RawPixelsStore_getPixelsPath __cb = new _AMD_RawPixelsStore_getPixelsPath(__inS);
        try
        {
            __obj.getPixelsPath_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___prepare(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<Long> pixelsIds;
        pixelsIds = omero.sys.LongListHelper.read(__is);
        __inS.endReadParams();
        AMD_RawPixelsStore_prepare __cb = new _AMD_RawPixelsStore_prepare(__inS);
        try
        {
            __obj.prepare_async(__cb, pixelsIds, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getPlaneSize(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RawPixelsStore_getPlaneSize __cb = new _AMD_RawPixelsStore_getPlaneSize(__inS);
        try
        {
            __obj.getPlaneSize_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getRowSize(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RawPixelsStore_getRowSize __cb = new _AMD_RawPixelsStore_getRowSize(__inS);
        try
        {
            __obj.getRowSize_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getStackSize(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RawPixelsStore_getStackSize __cb = new _AMD_RawPixelsStore_getStackSize(__inS);
        try
        {
            __obj.getStackSize_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getTimepointSize(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RawPixelsStore_getTimepointSize __cb = new _AMD_RawPixelsStore_getTimepointSize(__inS);
        try
        {
            __obj.getTimepointSize_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getTotalSize(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RawPixelsStore_getTotalSize __cb = new _AMD_RawPixelsStore_getTotalSize(__inS);
        try
        {
            __obj.getTotalSize_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getRowOffset(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int y;
        int z;
        int c;
        int t;
        y = __is.readInt();
        z = __is.readInt();
        c = __is.readInt();
        t = __is.readInt();
        __inS.endReadParams();
        AMD_RawPixelsStore_getRowOffset __cb = new _AMD_RawPixelsStore_getRowOffset(__inS);
        try
        {
            __obj.getRowOffset_async(__cb, y, z, c, t, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getPlaneOffset(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int z;
        int c;
        int t;
        z = __is.readInt();
        c = __is.readInt();
        t = __is.readInt();
        __inS.endReadParams();
        AMD_RawPixelsStore_getPlaneOffset __cb = new _AMD_RawPixelsStore_getPlaneOffset(__inS);
        try
        {
            __obj.getPlaneOffset_async(__cb, z, c, t, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getStackOffset(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int c;
        int t;
        c = __is.readInt();
        t = __is.readInt();
        __inS.endReadParams();
        AMD_RawPixelsStore_getStackOffset __cb = new _AMD_RawPixelsStore_getStackOffset(__inS);
        try
        {
            __obj.getStackOffset_async(__cb, c, t, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getTimepointOffset(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int t;
        t = __is.readInt();
        __inS.endReadParams();
        AMD_RawPixelsStore_getTimepointOffset __cb = new _AMD_RawPixelsStore_getTimepointOffset(__inS);
        try
        {
            __obj.getTimepointOffset_async(__cb, t, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getTile(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int z;
        int c;
        int t;
        int x;
        int y;
        int w;
        int h;
        z = __is.readInt();
        c = __is.readInt();
        t = __is.readInt();
        x = __is.readInt();
        y = __is.readInt();
        w = __is.readInt();
        h = __is.readInt();
        __inS.endReadParams();
        AMD_RawPixelsStore_getTile __cb = new _AMD_RawPixelsStore_getTile(__inS);
        try
        {
            __obj.getTile_async(__cb, z, c, t, x, y, w, h, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getHypercube(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<Integer> offset;
        java.util.List<Integer> size;
        java.util.List<Integer> step;
        offset = omero.sys.IntListHelper.read(__is);
        size = omero.sys.IntListHelper.read(__is);
        step = omero.sys.IntListHelper.read(__is);
        __inS.endReadParams();
        AMD_RawPixelsStore_getHypercube __cb = new _AMD_RawPixelsStore_getHypercube(__inS);
        try
        {
            __obj.getHypercube_async(__cb, offset, size, step, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getRegion(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int size;
        long offset;
        size = __is.readInt();
        offset = __is.readLong();
        __inS.endReadParams();
        AMD_RawPixelsStore_getRegion __cb = new _AMD_RawPixelsStore_getRegion(__inS);
        try
        {
            __obj.getRegion_async(__cb, size, offset, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getRow(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int y;
        int z;
        int c;
        int t;
        y = __is.readInt();
        z = __is.readInt();
        c = __is.readInt();
        t = __is.readInt();
        __inS.endReadParams();
        AMD_RawPixelsStore_getRow __cb = new _AMD_RawPixelsStore_getRow(__inS);
        try
        {
            __obj.getRow_async(__cb, y, z, c, t, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getCol(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int x;
        int z;
        int c;
        int t;
        x = __is.readInt();
        z = __is.readInt();
        c = __is.readInt();
        t = __is.readInt();
        __inS.endReadParams();
        AMD_RawPixelsStore_getCol __cb = new _AMD_RawPixelsStore_getCol(__inS);
        try
        {
            __obj.getCol_async(__cb, x, z, c, t, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getPlane(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int z;
        int c;
        int t;
        z = __is.readInt();
        c = __is.readInt();
        t = __is.readInt();
        __inS.endReadParams();
        AMD_RawPixelsStore_getPlane __cb = new _AMD_RawPixelsStore_getPlane(__inS);
        try
        {
            __obj.getPlane_async(__cb, z, c, t, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getPlaneRegion(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int z;
        int c;
        int t;
        int size;
        int offset;
        z = __is.readInt();
        c = __is.readInt();
        t = __is.readInt();
        size = __is.readInt();
        offset = __is.readInt();
        __inS.endReadParams();
        AMD_RawPixelsStore_getPlaneRegion __cb = new _AMD_RawPixelsStore_getPlaneRegion(__inS);
        try
        {
            __obj.getPlaneRegion_async(__cb, z, c, t, size, offset, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getStack(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int c;
        int t;
        c = __is.readInt();
        t = __is.readInt();
        __inS.endReadParams();
        AMD_RawPixelsStore_getStack __cb = new _AMD_RawPixelsStore_getStack(__inS);
        try
        {
            __obj.getStack_async(__cb, c, t, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getTimepoint(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int t;
        t = __is.readInt();
        __inS.endReadParams();
        AMD_RawPixelsStore_getTimepoint __cb = new _AMD_RawPixelsStore_getTimepoint(__inS);
        try
        {
            __obj.getTimepoint_async(__cb, t, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setTile(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        byte[] buf;
        int z;
        int c;
        int t;
        int x;
        int y;
        int w;
        int h;
        buf = Ice.ByteSeqHelper.read(__is);
        z = __is.readInt();
        c = __is.readInt();
        t = __is.readInt();
        x = __is.readInt();
        y = __is.readInt();
        w = __is.readInt();
        h = __is.readInt();
        __inS.endReadParams();
        AMD_RawPixelsStore_setTile __cb = new _AMD_RawPixelsStore_setTile(__inS);
        try
        {
            __obj.setTile_async(__cb, buf, z, c, t, x, y, w, h, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setRegion(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int size;
        long offset;
        byte[] buf;
        size = __is.readInt();
        offset = __is.readLong();
        buf = Ice.ByteSeqHelper.read(__is);
        __inS.endReadParams();
        AMD_RawPixelsStore_setRegion __cb = new _AMD_RawPixelsStore_setRegion(__inS);
        try
        {
            __obj.setRegion_async(__cb, size, offset, buf, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setRow(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        byte[] buf;
        int y;
        int z;
        int c;
        int t;
        buf = Ice.ByteSeqHelper.read(__is);
        y = __is.readInt();
        z = __is.readInt();
        c = __is.readInt();
        t = __is.readInt();
        __inS.endReadParams();
        AMD_RawPixelsStore_setRow __cb = new _AMD_RawPixelsStore_setRow(__inS);
        try
        {
            __obj.setRow_async(__cb, buf, y, z, c, t, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setPlane(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        byte[] buf;
        int z;
        int c;
        int t;
        buf = Ice.ByteSeqHelper.read(__is);
        z = __is.readInt();
        c = __is.readInt();
        t = __is.readInt();
        __inS.endReadParams();
        AMD_RawPixelsStore_setPlane __cb = new _AMD_RawPixelsStore_setPlane(__inS);
        try
        {
            __obj.setPlane_async(__cb, buf, z, c, t, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setStack(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        byte[] buf;
        int z;
        int c;
        int t;
        buf = Ice.ByteSeqHelper.read(__is);
        z = __is.readInt();
        c = __is.readInt();
        t = __is.readInt();
        __inS.endReadParams();
        AMD_RawPixelsStore_setStack __cb = new _AMD_RawPixelsStore_setStack(__inS);
        try
        {
            __obj.setStack_async(__cb, buf, z, c, t, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setTimepoint(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        byte[] buf;
        int t;
        buf = Ice.ByteSeqHelper.read(__is);
        t = __is.readInt();
        __inS.endReadParams();
        AMD_RawPixelsStore_setTimepoint __cb = new _AMD_RawPixelsStore_setTimepoint(__inS);
        try
        {
            __obj.setTimepoint_async(__cb, buf, t, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getHistogram(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int[] channels;
        int binCount;
        boolean globalRange;
        omero.romio.PlaneDefHolder plane = new omero.romio.PlaneDefHolder();
        channels = IntegerArrayHelper.read(__is);
        binCount = __is.readInt();
        globalRange = __is.readBool();
        __is.readObject(plane);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_RawPixelsStore_getHistogram __cb = new _AMD_RawPixelsStore_getHistogram(__inS);
        try
        {
            __obj.getHistogram_async(__cb, channels, binCount, globalRange, plane.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getByteWidth(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RawPixelsStore_getByteWidth __cb = new _AMD_RawPixelsStore_getByteWidth(__inS);
        try
        {
            __obj.getByteWidth_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___isSigned(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RawPixelsStore_isSigned __cb = new _AMD_RawPixelsStore_isSigned(__inS);
        try
        {
            __obj.isSigned_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___isFloat(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RawPixelsStore_isFloat __cb = new _AMD_RawPixelsStore_isFloat(__inS);
        try
        {
            __obj.isFloat_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___calculateMessageDigest(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RawPixelsStore_calculateMessageDigest __cb = new _AMD_RawPixelsStore_calculateMessageDigest(__inS);
        try
        {
            __obj.calculateMessageDigest_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___save(RawPixelsStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RawPixelsStore_save __cb = new _AMD_RawPixelsStore_save(__inS);
        try
        {
            __obj.save_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "activate",
        "calculateMessageDigest",
        "close",
        "getByteWidth",
        "getCol",
        "getCurrentEventContext",
        "getHistogram",
        "getHypercube",
        "getPixelsId",
        "getPixelsPath",
        "getPlane",
        "getPlaneOffset",
        "getPlaneRegion",
        "getPlaneSize",
        "getRegion",
        "getResolutionDescriptions",
        "getResolutionLevel",
        "getResolutionLevels",
        "getRow",
        "getRowOffset",
        "getRowSize",
        "getStack",
        "getStackOffset",
        "getStackSize",
        "getTile",
        "getTileSize",
        "getTimepoint",
        "getTimepointOffset",
        "getTimepointSize",
        "getTotalSize",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "isFloat",
        "isSigned",
        "passivate",
        "prepare",
        "requiresPixelsPyramid",
        "save",
        "setPixelsId",
        "setPlane",
        "setRegion",
        "setResolutionLevel",
        "setRow",
        "setStack",
        "setTile",
        "setTimepoint"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return _StatefulServiceInterfaceDisp.___activate(this, in, __current);
            }
            case 1:
            {
                return ___calculateMessageDigest(this, in, __current);
            }
            case 2:
            {
                return _StatefulServiceInterfaceDisp.___close(this, in, __current);
            }
            case 3:
            {
                return ___getByteWidth(this, in, __current);
            }
            case 4:
            {
                return ___getCol(this, in, __current);
            }
            case 5:
            {
                return _StatefulServiceInterfaceDisp.___getCurrentEventContext(this, in, __current);
            }
            case 6:
            {
                return ___getHistogram(this, in, __current);
            }
            case 7:
            {
                return ___getHypercube(this, in, __current);
            }
            case 8:
            {
                return ___getPixelsId(this, in, __current);
            }
            case 9:
            {
                return ___getPixelsPath(this, in, __current);
            }
            case 10:
            {
                return ___getPlane(this, in, __current);
            }
            case 11:
            {
                return ___getPlaneOffset(this, in, __current);
            }
            case 12:
            {
                return ___getPlaneRegion(this, in, __current);
            }
            case 13:
            {
                return ___getPlaneSize(this, in, __current);
            }
            case 14:
            {
                return ___getRegion(this, in, __current);
            }
            case 15:
            {
                return _PyramidServiceDisp.___getResolutionDescriptions(this, in, __current);
            }
            case 16:
            {
                return _PyramidServiceDisp.___getResolutionLevel(this, in, __current);
            }
            case 17:
            {
                return _PyramidServiceDisp.___getResolutionLevels(this, in, __current);
            }
            case 18:
            {
                return ___getRow(this, in, __current);
            }
            case 19:
            {
                return ___getRowOffset(this, in, __current);
            }
            case 20:
            {
                return ___getRowSize(this, in, __current);
            }
            case 21:
            {
                return ___getStack(this, in, __current);
            }
            case 22:
            {
                return ___getStackOffset(this, in, __current);
            }
            case 23:
            {
                return ___getStackSize(this, in, __current);
            }
            case 24:
            {
                return ___getTile(this, in, __current);
            }
            case 25:
            {
                return _PyramidServiceDisp.___getTileSize(this, in, __current);
            }
            case 26:
            {
                return ___getTimepoint(this, in, __current);
            }
            case 27:
            {
                return ___getTimepointOffset(this, in, __current);
            }
            case 28:
            {
                return ___getTimepointSize(this, in, __current);
            }
            case 29:
            {
                return ___getTotalSize(this, in, __current);
            }
            case 30:
            {
                return ___ice_id(this, in, __current);
            }
            case 31:
            {
                return ___ice_ids(this, in, __current);
            }
            case 32:
            {
                return ___ice_isA(this, in, __current);
            }
            case 33:
            {
                return ___ice_ping(this, in, __current);
            }
            case 34:
            {
                return ___isFloat(this, in, __current);
            }
            case 35:
            {
                return ___isSigned(this, in, __current);
            }
            case 36:
            {
                return _StatefulServiceInterfaceDisp.___passivate(this, in, __current);
            }
            case 37:
            {
                return ___prepare(this, in, __current);
            }
            case 38:
            {
                return _PyramidServiceDisp.___requiresPixelsPyramid(this, in, __current);
            }
            case 39:
            {
                return ___save(this, in, __current);
            }
            case 40:
            {
                return ___setPixelsId(this, in, __current);
            }
            case 41:
            {
                return ___setPlane(this, in, __current);
            }
            case 42:
            {
                return ___setRegion(this, in, __current);
            }
            case 43:
            {
                return _PyramidServiceDisp.___setResolutionLevel(this, in, __current);
            }
            case 44:
            {
                return ___setRow(this, in, __current);
            }
            case 45:
            {
                return ___setStack(this, in, __current);
            }
            case 46:
            {
                return ___setTile(this, in, __current);
            }
            case 47:
            {
                return ___setTimepoint(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
