// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `RawPixelsStore.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Binary data provider. Initialized with the ID of a
 * {@link omero.model.Pixels} instance, this service can provide
 * various slices, stacks, regions of the 5-dimensional (X-Y planes with
 * multiple Z-sections and Channels over Time). The byte array returned
 * by the getter methods and passed to the setter methods can and will
 * be interpreted according to results of {@link #getByteWidth},
 * {@link #isFloat}, and {@link #isSigned}.
 * 
 * <p>
 * <b>Read-only caveat</b>:
 * 
 * Mutating methods (set*) are only available during the first access.
 * Once the Pixels data has been successfully saved (via the save or
 * close methods on this interface), then the data should be treated
 * read-only. If Pixels data writing fails and the service is
 * inadvertently closed, delete the Pixels object, and create a new
 * one. Any partially written data will be removed.
 **/
public interface _RawPixelsStoreOperations extends _PyramidServiceOperations
{
    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId Pixels set identifier.
     * @param __current The Current object for the invocation.
     **/
    void setPixelsId_async(AMD_RawPixelsStore_setPixelsId __cb, long pixelsId, boolean bypassOriginalFile, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns the current Pixels set identifier.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getPixelsId_async(AMD_RawPixelsStore_getPixelsId __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns the current Pixels path.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getPixelsPath_async(AMD_RawPixelsStore_getPixelsPath __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsIds Pixels IDs to cache.
     * @param __current The Current object for the invocation.
     **/
    void prepare_async(AMD_RawPixelsStore_prepare __cb, java.util.List<Long> pixelsIds, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getPlaneSize_async(AMD_RawPixelsStore_getPlaneSize __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getRowSize_async(AMD_RawPixelsStore_getRowSize __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getStackSize_async(AMD_RawPixelsStore_getStackSize __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getTimepointSize_async(AMD_RawPixelsStore_getTimepointSize __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getTotalSize_async(AMD_RawPixelsStore_getTotalSize __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param __current The Current object for the invocation.
     **/
    void getRowOffset_async(AMD_RawPixelsStore_getRowOffset __cb, int y, int z, int c, int t, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __current The Current object for the invocation.
     **/
    void getPlaneOffset_async(AMD_RawPixelsStore_getPlaneOffset __cb, int z, int c, int t, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel buffer.
     * @param __current The Current object for the invocation.
     **/
    void getStackOffset_async(AMD_RawPixelsStore_getStackOffset __cb, int c, int t, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __current The Current object for the invocation.
     **/
    void getTimepointOffset_async(AMD_RawPixelsStore_getTimepointOffset __cb, int t, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves a tile from this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param y Top left corner of the tile, Y offset.
     * @param h Height of the tile.
     * @param __current The Current object for the invocation.
     **/
    void getTile_async(AMD_RawPixelsStore_getTile __cb, int z, int c, int t, int x, int y, int w, int h, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size of each dimension (dependent on dimension).
     * @param __current The Current object for the invocation.
     **/
    void getHypercube_async(AMD_RawPixelsStore_getHypercube __cb, java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves a region from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to retrieve.
     * @param __current The Current object for the invocation.
     **/
    void getRegion_async(AMD_RawPixelsStore_getRegion __cb, int size, long offset, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __current The Current object for the invocation.
     **/
    void getRow_async(AMD_RawPixelsStore_getRow __cb, int y, int z, int c, int t, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves a particular column from this pixel store.
     * @param __cb The callback object for the operation.
     * @param x offset across the X-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __current The Current object for the invocation.
     **/
    void getCol_async(AMD_RawPixelsStore_getCol __cb, int x, int z, int c, int t, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __current The Current object for the invocation.
     **/
    void getPlane_async(AMD_RawPixelsStore_getPlane __cb, int z, int c, int t, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     * @param __current The Current object for the invocation.
     **/
    void getPlaneRegion_async(AMD_RawPixelsStore_getPlaneRegion __cb, int z, int c, int t, int size, int offset, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel store.
     * @param __current The Current object for the invocation.
     **/
    void getStack_async(AMD_RawPixelsStore_getStack __cb, int c, int t, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel store.
     * @param __current The Current object for the invocation.
     **/
    void getTimepoint_async(AMD_RawPixelsStore_getTimepoint __cb, int t, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Sets a tile in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param buf A byte array of the data.
     * @param c offset across the C-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param w Width of the tile.
     * @param __current The Current object for the invocation.
     **/
    void setTile_async(AMD_RawPixelsStore_setTile __cb, byte[] buf, int z, int c, int t, int x, int y, int w, int h, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Sets a region in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to set.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __current The Current object for the invocation.
     **/
    void setRegion_async(AMD_RawPixelsStore_setRegion __cb, int size, long offset, byte[] buf, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __current The Current object for the invocation.
     **/
    void setRow_async(AMD_RawPixelsStore_setRow __cb, byte[] buf, int y, int z, int c, int t, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param c offset across the C-axis of the pixel store.
     * @param __current The Current object for the invocation.
     **/
    void setPlane_async(AMD_RawPixelsStore_setPlane __cb, byte[] buf, int z, int c, int t, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this stack.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __current The Current object for the invocation.
     **/
    void setStack_async(AMD_RawPixelsStore_setStack __cb, byte[] buf, int z, int c, int t, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this timepoint.
     * @param __current The Current object for the invocation.
     **/
    void setTimepoint_async(AMD_RawPixelsStore_setTimepoint __cb, byte[] buf, int t, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param __cb The callback object for the operation.
     * @param channels the channels to generate the histogram data for
     * @param plane the plane (optional, default: whole region of first z/t plane)
     * @param __current The Current object for the invocation.
     **/
    void getHistogram_async(AMD_RawPixelsStore_getHistogram __cb, int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns the byte width for the pixel store.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getByteWidth_async(AMD_RawPixelsStore_getByteWidth __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void isSigned_async(AMD_RawPixelsStore_isSigned __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void isFloat_async(AMD_RawPixelsStore_isFloat __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void calculateMessageDigest_async(AMD_RawPixelsStore_calculateMessageDigest __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void save_async(AMD_RawPixelsStore_save __cb, Ice.Current __current)
        throws omero.ServerError;
}
