// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `RenderingEngine.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Defines a service to render a given pixels set.
 * 
 * A pixels set is a <i>5D</i> array that stores the pixels data of an
 * image, that is the pixels intensity values. Every instance of this
 * service is paired up to a pixels set. Use this service to transform
 * planes within the pixels set onto an <i>RGB</i> image.
 * 
 * The RenderingEngine allows to fine-tune the settings that
 * define the transformation context &#151; that is, a specification
 * of how raw pixels data is to be transformed into an image that can
 * be displayed on screen. Those settings are referred to as rendering
 * settings or display options. After tuning those settings it is
 * possible to save them to the metadata repository so that they can
 * be used the next time the pixels set is accessed for rendering; for
 * example by another RenderingEngine instance. Note that the display
 * options are specific to the given pixels set and are experimenter
 * scoped &#151; that is, two different users can specify different
 * display options for the <i>same</i> pixels set. (A RenderingEngine
 * instance takes this into account automatically as it is always
 * bound to a given experimenter.)
 * 
 * This service is <b>thread-safe</b>.
 **/
public abstract class _RenderingEngineDisp extends Ice.ObjectImpl implements RenderingEngine
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::PyramidService",
        "::omero::api::RenderingEngine",
        "::omero::api::ServiceInterface",
        "::omero::api::StatefulServiceInterface"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[2];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[2];
    }

    public static String ice_staticId()
    {
        return __ids[2];
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     **/
    public final void getResolutionDescriptions_async(AMD_PyramidService_getResolutionDescriptions __cb)
        throws omero.ServerError
    {
        getResolutionDescriptions_async(__cb, null);
    }

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     **/
    public final void getResolutionLevel_async(AMD_PyramidService_getResolutionLevel __cb)
        throws omero.ServerError
    {
        getResolutionLevel_async(__cb, null);
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     **/
    public final void getResolutionLevels_async(AMD_PyramidService_getResolutionLevels __cb)
        throws omero.ServerError
    {
        getResolutionLevels_async(__cb, null);
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     **/
    public final void getTileSize_async(AMD_PyramidService_getTileSize __cb)
        throws omero.ServerError
    {
        getTileSize_async(__cb, null);
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     **/
    public final void requiresPixelsPyramid_async(AMD_PyramidService_requiresPixelsPyramid __cb)
        throws omero.ServerError
    {
        requiresPixelsPyramid_async(__cb, null);
    }

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     **/
    public final void setResolutionLevel_async(AMD_PyramidService_setResolutionLevel __cb, int resolutionLevel)
        throws omero.ServerError
    {
        setResolutionLevel_async(__cb, resolutionLevel, null);
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to add.
     * @deprecated This operation has been deprecated.
     **/
    public final void addCodomainMap_async(AMD_RenderingEngine_addCodomainMap __cb, omero.romio.CodomainMapContext mapCtx)
        throws omero.ServerError
    {
        addCodomainMap_async(__cb, mapCtx, null);
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to add.
     **/
    public final void addCodomainMapToChannel_async(AMD_RenderingEngine_addCodomainMapToChannel __cb, omero.romio.CodomainMapContext mapCtx, int w)
        throws omero.ServerError
    {
        addCodomainMapToChannel_async(__cb, mapCtx, w, null);
    }

    /**
     * Returns the list of mapping families supported by the
     * Rendering engine.
     * @param __cb The callback object for the operation.
     **/
    public final void getAvailableFamilies_async(AMD_RenderingEngine_getAvailableFamilies __cb)
        throws omero.ServerError
    {
        getAvailableFamilies_async(__cb, null);
    }

    /**
     * Returns the list of color models supported by the Rendering
     * engine.
     * @param __cb The callback object for the operation.
     **/
    public final void getAvailableModels_async(AMD_RenderingEngine_getAvailableModels __cb)
        throws omero.ServerError
    {
        getAvailableModels_async(__cb, null);
    }

    /**
     * Returns the coefficient identifying a map in the family.
     * Each channel has a map associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public final void getChannelCurveCoefficient_async(AMD_RenderingEngine_getChannelCurveCoefficient __cb, int w)
        throws omero.ServerError
    {
        getChannelCurveCoefficient_async(__cb, w, null);
    }

    /**
     * Returns the family associated to the specified channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public final void getChannelFamily_async(AMD_RenderingEngine_getChannelFamily __cb, int w)
        throws omero.ServerError
    {
        getChannelFamily_async(__cb, w, null);
    }

    public final void getChannelLookupTable_async(AMD_RenderingEngine_getChannelLookupTable __cb, int w)
        throws omero.ServerError
    {
        getChannelLookupTable_async(__cb, w, null);
    }

    /**
     * Returns <code>true</code> if the noise reduction algorithm
     * used to map the pixels intensity values is turned on,
     * <code>false</code> if the algorithm is turned off. Each
     * channel has an algorithm associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public final void getChannelNoiseReduction_async(AMD_RenderingEngine_getChannelNoiseReduction __cb, int w)
        throws omero.ServerError
    {
        getChannelNoiseReduction_async(__cb, w, null);
    }

    public final void getChannelStats_async(AMD_RenderingEngine_getChannelStats __cb, int w)
        throws omero.ServerError
    {
        getChannelStats_async(__cb, w, null);
    }

    /**
     * Returns the upper bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public final void getChannelWindowEnd_async(AMD_RenderingEngine_getChannelWindowEnd __cb, int w)
        throws omero.ServerError
    {
        getChannelWindowEnd_async(__cb, w, null);
    }

    /**
     * Returns the lower bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public final void getChannelWindowStart_async(AMD_RenderingEngine_getChannelWindowStart __cb, int w)
        throws omero.ServerError
    {
        getChannelWindowStart_async(__cb, w, null);
    }

    /**
     * Returns the list of codomain contexts for the specified
     * channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public final void getCodomainMapContext_async(AMD_RenderingEngine_getCodomainMapContext __cb, int w)
        throws omero.ServerError
    {
        getCodomainMapContext_async(__cb, w, null);
    }

    /**
     * Returns the current compression level for the service.
     * @param __cb The callback object for the operation.
     **/
    public final void getCompressionLevel_async(AMD_RenderingEngine_getCompressionLevel __cb)
        throws omero.ServerError
    {
        getCompressionLevel_async(__cb, null);
    }

    /**
     * Returns the default timepoint index.
     * @param __cb The callback object for the operation.
     **/
    public final void getDefaultT_async(AMD_RenderingEngine_getDefaultT __cb)
        throws omero.ServerError
    {
        getDefaultT_async(__cb, null);
    }

    /**
     * Returns the index of the default focal section.
     * @param __cb The callback object for the operation.
     **/
    public final void getDefaultZ_async(AMD_RenderingEngine_getDefaultZ __cb)
        throws omero.ServerError
    {
        getDefaultZ_async(__cb, null);
    }

    /**
     * Returns the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * @param __cb The callback object for the operation.
     **/
    public final void getModel_async(AMD_RenderingEngine_getModel __cb)
        throws omero.ServerError
    {
        getModel_async(__cb, null);
    }

    /**
     * Returns the {@link omero.model.Pixels} set the Rendering
     * engine is for.
     * @param __cb The callback object for the operation.
     **/
    public final void getPixels_async(AMD_RenderingEngine_getPixels __cb)
        throws omero.ServerError
    {
        getPixels_async(__cb, null);
    }

    /**
     * Returns the maximum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public final void getPixelsTypeLowerBound_async(AMD_RenderingEngine_getPixelsTypeLowerBound __cb, int w)
        throws omero.ServerError
    {
        getPixelsTypeLowerBound_async(__cb, w, null);
    }

    /**
     * Returns the minimum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public final void getPixelsTypeUpperBound_async(AMD_RenderingEngine_getPixelsTypeUpperBound __cb, int w)
        throws omero.ServerError
    {
        getPixelsTypeUpperBound_async(__cb, w, null);
    }

    /**
     * Returns the quantization object.
     * @param __cb The callback object for the operation.
     **/
    public final void getQuantumDef_async(AMD_RenderingEngine_getQuantumDef __cb)
        throws omero.ServerError
    {
        getQuantumDef_async(__cb, null);
    }

    /**
     * Returns a 4D-array representing the color associated to the
     * specified channel. The first element corresponds to the red
     * component (value between 0 and 255). The second corresponds
     * to the green component (value between 0 and 255). The third
     * corresponds to the blue component (value between 0 and
     * 255). The fourth corresponds to the alpha component (value
     * between 0 and 255).
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public final void getRGBA_async(AMD_RenderingEngine_getRGBA __cb, int w)
        throws omero.ServerError
    {
        getRGBA_async(__cb, w, null);
    }

    /**
     * Returns the id of the {@link omero.model.RenderingDef}
     * loaded by either {@link #lookupRenderingDef} or
     * {@link #loadRenderingDef}.
     * @param __cb The callback object for the operation.
     **/
    public final void getRenderingDefId_async(AMD_RenderingEngine_getRenderingDefId __cb)
        throws omero.ServerError
    {
        getRenderingDefId_async(__cb, null);
    }

    /**
     * Returns <code>true</code> if the channel is mapped,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public final void isActive_async(AMD_RenderingEngine_isActive __cb, int w)
        throws omero.ServerError
    {
        isActive_async(__cb, w, null);
    }

    /**
     * Returns <code>true</code> if the pixels type is signed,
     * <code>false</code> otherwise.
     * @param __cb The callback object for the operation.
     **/
    public final void isPixelsTypeSigned_async(AMD_RenderingEngine_isPixelsTypeSigned __cb)
        throws omero.ServerError
    {
        isPixelsTypeSigned_async(__cb, null);
    }

    /**
     * Creates an instance of the rendering engine.
     * @param __cb The callback object for the operation.
     **/
    public final void load_async(AMD_RenderingEngine_load __cb)
        throws omero.ServerError
    {
        load_async(__cb, null);
    }

    /**
     * Loads a specific set of rendering settings that does not
     * necessarily have to be linked to the given Pixels set.
     * However, the rendering settings <b>must</b> be linked to a
     * compatible Pixels set as defined by
     * {@link omero.api.IRenderingSettings#sanityCheckPixels}.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId The rendering definition ID.
     **/
    public final void loadRenderingDef_async(AMD_RenderingEngine_loadRenderingDef __cb, long renderingDefId)
        throws omero.ServerError
    {
        loadRenderingDef_async(__cb, renderingDefId, null);
    }

    /**
     * Loads the Pixels set this Rendering Engine is for.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The pixels set ID.
     **/
    public final void lookupPixels_async(AMD_RenderingEngine_lookupPixels __cb, long pixelsId)
        throws omero.ServerError
    {
        lookupPixels_async(__cb, pixelsId, null);
    }

    /**
     * Loads the rendering settings associated to the specified
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The pixels set ID.
     **/
    public final void lookupRenderingDef_async(AMD_RenderingEngine_lookupRenderingDef __cb, long pixelsId)
        throws omero.ServerError
    {
        lookupRenderingDef_async(__cb, pixelsId, null);
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to remove.
     * @deprecated This operation has been deprecated.
     **/
    public final void removeCodomainMap_async(AMD_RenderingEngine_removeCodomainMap __cb, omero.romio.CodomainMapContext mapCtx)
        throws omero.ServerError
    {
        removeCodomainMap_async(__cb, mapCtx, null);
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to remove.
     **/
    public final void removeCodomainMapFromChannel_async(AMD_RenderingEngine_removeCodomainMapFromChannel __cb, omero.romio.CodomainMapContext mapCtx, int w)
        throws omero.ServerError
    {
        removeCodomainMapFromChannel_async(__cb, mapCtx, w, null);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     **/
    public final void render_async(AMD_RenderingEngine_render __cb, omero.romio.PlaneDef def)
        throws omero.ServerError
    {
        render_async(__cb, def, null);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     **/
    public final void renderAsPackedInt_async(AMD_RenderingEngine_renderAsPackedInt __cb, omero.romio.PlaneDef def)
        throws omero.ServerError
    {
        renderAsPackedInt_async(__cb, def, null);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings and compresses the resulting
     * RGBA composite image.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i> or <i>Z</i> axes.
     **/
    public final void renderCompressed_async(AMD_RenderingEngine_renderCompressed __cb, omero.romio.PlaneDef def)
        throws omero.ServerError
    {
        renderCompressed_async(__cb, def, null);
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels
     * and renders the data for display.
     * 
     * @param __cb The callback object for the operation.
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     **/
    public final void renderProjectedAsPackedInt_async(AMD_RenderingEngine_renderProjectedAsPackedInt __cb, omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end)
        throws omero.ServerError
    {
        renderProjectedAsPackedInt_async(__cb, algorithm, timepoint, stepping, start, end, null);
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels,
     * renders the data for display and compresses the resulting
     * RGBA composite image.
     * 
     * @param __cb The callback object for the operation.
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     **/
    public final void renderProjectedCompressed_async(AMD_RenderingEngine_renderProjectedCompressed __cb, omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end)
        throws omero.ServerError
    {
        renderProjectedCompressed_async(__cb, algorithm, timepoint, stepping, start, end, null);
    }

    /**
     * Resets the default settings i.e. the default values
     * internal to the Rendering engine. The settings will be
     * saved.
     * 
     * @param __cb The callback object for the operation.
     * @param save Pass <code>true</code> to save the settings,
     * <code>false</code> otherwise.
     **/
    public final void resetDefaultSettings_async(AMD_RenderingEngine_resetDefaultSettings __cb, boolean save)
        throws omero.ServerError
    {
        resetDefaultSettings_async(__cb, save, null);
    }

    /**
     * Saves the current rendering settings in the database
     * as a new {@link omero.model.RenderingDef} and loads the
     * object into the current {@link omero.api.RenderingEngine}.
     * @param __cb The callback object for the operation.
     **/
    public final void saveAsNewSettings_async(AMD_RenderingEngine_saveAsNewSettings __cb)
        throws omero.ServerError
    {
        saveAsNewSettings_async(__cb, null);
    }

    /**
     * Saves the current rendering settings in the database.
     * @param __cb The callback object for the operation.
     **/
    public final void saveCurrentSettings_async(AMD_RenderingEngine_saveCurrentSettings __cb)
        throws omero.ServerError
    {
        saveCurrentSettings_async(__cb, null);
    }

    /**
     * Maps the specified channel if <code>true</code>, unmaps the
     * channel otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public final void setActive_async(AMD_RenderingEngine_setActive __cb, int w, boolean active)
        throws omero.ServerError
    {
        setActive_async(__cb, w, active, null);
    }

    public final void setChannelLookupTable_async(AMD_RenderingEngine_setChannelLookupTable __cb, int w, String lookup)
        throws omero.ServerError
    {
        setChannelLookupTable_async(__cb, w, lookup, null);
    }

    /**
     * Returns the pixels intensity interval. Each channel has a
     * pixels intensity interval associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param end The upper bound of the interval.
     **/
    public final void setChannelWindow_async(AMD_RenderingEngine_setChannelWindow __cb, int w, double start, double end)
        throws omero.ServerError
    {
        setChannelWindow_async(__cb, w, start, end, null);
    }

    /**
     * Sets the sub-interval of the device space i.e. a discrete
     * sub-interval of \[0, 255].
     * 
     * @param __cb The callback object for the operation.
     * @param start The lower bound of the interval.
     **/
    public final void setCodomainInterval_async(AMD_RenderingEngine_setCodomainInterval __cb, int start, int end)
        throws omero.ServerError
    {
        setCodomainInterval_async(__cb, start, end, null);
    }

    /**
     * Sets the current compression level for the service. (The
     * default is 85%)
     * 
     * @param __cb The callback object for the operation.
     * @param percentage A percentage compression level from 1.00
     * (100%) to 0.01 (1%).
     **/
    public final void setCompressionLevel_async(AMD_RenderingEngine_setCompressionLevel __cb, float percentage)
        throws omero.ServerError
    {
        setCompressionLevel_async(__cb, percentage, null);
    }

    /**
     * Sets the default timepoint index. This index is used to
     * define a default plane.
     * 
     * @param __cb The callback object for the operation.
     * @param t The value to set.
     **/
    public final void setDefaultT_async(AMD_RenderingEngine_setDefaultT __cb, int t)
        throws omero.ServerError
    {
        setDefaultT_async(__cb, t, null);
    }

    /**
     * Sets the index of the default focal section. This index is
     * used to define a default plane.
     * 
     * @param __cb The callback object for the operation.
     * @param z The value to set.
     **/
    public final void setDefaultZ_async(AMD_RenderingEngine_setDefaultZ __cb, int z)
        throws omero.ServerError
    {
        setDefaultZ_async(__cb, z, null);
    }

    /**
     * Specifies the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * 
     * @param __cb The callback object for the operation.
     * @param model Identifies the color space model.
     **/
    public final void setModel_async(AMD_RenderingEngine_setModel __cb, omero.model.RenderingModel model)
        throws omero.ServerError
    {
        setModel_async(__cb, model, null);
    }

    /**
     * Informs the rendering engine that it should render a set of
     * overlays on each rendered frame. These are expected to be
     * binary masks.
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public final void setOverlays_async(AMD_RenderingEngine_setOverlays __cb, omero.RLong tablesId, omero.RLong imageId, java.util.Map<java.lang.Long, java.lang.Integer> rowColorMap)
        throws omero.ServerError
    {
        setOverlays_async(__cb, tablesId, imageId, rowColorMap, null);
    }

    /**
     * Sets the quantization map, one per channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w  The channel index.
     * @param coefficient The coefficient identifying a curve in
     * the family.
     * @param noiseReduction Pass <code>true</code> to turn the
     * noise reduction algorithm on,
     * <code>false</code> otherwise.
     **/
    public final void setQuantizationMap_async(AMD_RenderingEngine_setQuantizationMap __cb, int w, omero.model.Family fam, double coefficient, boolean noiseReduction)
        throws omero.ServerError
    {
        setQuantizationMap_async(__cb, w, fam, coefficient, noiseReduction, null);
    }

    /**
     * Sets the quantization strategy. The strategy is common to
     * all channels.
     * 
     * @param __cb The callback object for the operation.
     * @param bitResolution The bit resolution defining associated
     * to the strategy.
     **/
    public final void setQuantumStrategy_async(AMD_RenderingEngine_setQuantumStrategy __cb, int bitResolution)
        throws omero.ServerError
    {
        setQuantumStrategy_async(__cb, bitResolution, null);
    }

    /**
     * Sets the four components composing the color associated to
     * the specified channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param green The green component. A value between 0 and 255.
     * @param alpha The alpha component. A value between 0 and 255.
     **/
    public final void setRGBA_async(AMD_RenderingEngine_setRGBA __cb, int w, int red, int green, int blue, int alpha)
        throws omero.ServerError
    {
        setRGBA_async(__cb, w, red, green, blue, alpha, null);
    }

    /**
     * Updates the specified context. The codomain chain already
     * contains the specified context. Each time a new context is
     * updated, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to update.
     * @deprecated This operation has been deprecated.
     **/
    public final void updateCodomainMap_async(AMD_RenderingEngine_updateCodomainMap __cb, omero.romio.CodomainMapContext mapCtx)
        throws omero.ServerError
    {
        updateCodomainMap_async(__cb, mapCtx, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public final void activate_async(AMD_StatefulServiceInterface_activate __cb)
        throws omero.ServerError
    {
        activate_async(__cb, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public final void close_async(AMD_StatefulServiceInterface_close __cb)
        throws omero.ServerError
    {
        close_async(__cb, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public final void getCurrentEventContext_async(AMD_StatefulServiceInterface_getCurrentEventContext __cb)
        throws omero.ServerError
    {
        getCurrentEventContext_async(__cb, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public final void passivate_async(AMD_StatefulServiceInterface_passivate __cb)
        throws omero.ServerError
    {
        passivate_async(__cb, null);
    }

    public static Ice.DispatchStatus ___render(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.romio.PlaneDefHolder def = new omero.romio.PlaneDefHolder();
        __is.readObject(def);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_RenderingEngine_render __cb = new _AMD_RenderingEngine_render(__inS);
        try
        {
            __obj.render_async(__cb, def.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___renderAsPackedInt(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.romio.PlaneDefHolder def = new omero.romio.PlaneDefHolder();
        __is.readObject(def);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_RenderingEngine_renderAsPackedInt __cb = new _AMD_RenderingEngine_renderAsPackedInt(__inS);
        try
        {
            __obj.renderAsPackedInt_async(__cb, def.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___renderProjectedAsPackedInt(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.constants.projection.ProjectionType algorithm;
        int timepoint;
        int stepping;
        int start;
        int end;
        algorithm = omero.constants.projection.ProjectionType.__read(__is);
        timepoint = __is.readInt();
        stepping = __is.readInt();
        start = __is.readInt();
        end = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_renderProjectedAsPackedInt __cb = new _AMD_RenderingEngine_renderProjectedAsPackedInt(__inS);
        try
        {
            __obj.renderProjectedAsPackedInt_async(__cb, algorithm, timepoint, stepping, start, end, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___renderCompressed(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.romio.PlaneDefHolder def = new omero.romio.PlaneDefHolder();
        __is.readObject(def);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_RenderingEngine_renderCompressed __cb = new _AMD_RenderingEngine_renderCompressed(__inS);
        try
        {
            __obj.renderCompressed_async(__cb, def.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___renderProjectedCompressed(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.constants.projection.ProjectionType algorithm;
        int timepoint;
        int stepping;
        int start;
        int end;
        algorithm = omero.constants.projection.ProjectionType.__read(__is);
        timepoint = __is.readInt();
        stepping = __is.readInt();
        start = __is.readInt();
        end = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_renderProjectedCompressed __cb = new _AMD_RenderingEngine_renderProjectedCompressed(__inS);
        try
        {
            __obj.renderProjectedCompressed_async(__cb, algorithm, timepoint, stepping, start, end, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getRenderingDefId(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RenderingEngine_getRenderingDefId __cb = new _AMD_RenderingEngine_getRenderingDefId(__inS);
        try
        {
            __obj.getRenderingDefId_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___lookupPixels(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long pixelsId;
        pixelsId = __is.readLong();
        __inS.endReadParams();
        AMD_RenderingEngine_lookupPixels __cb = new _AMD_RenderingEngine_lookupPixels(__inS);
        try
        {
            __obj.lookupPixels_async(__cb, pixelsId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___lookupRenderingDef(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long pixelsId;
        pixelsId = __is.readLong();
        __inS.endReadParams();
        AMD_RenderingEngine_lookupRenderingDef __cb = new _AMD_RenderingEngine_lookupRenderingDef(__inS);
        try
        {
            __obj.lookupRenderingDef_async(__cb, pixelsId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___loadRenderingDef(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long renderingDefId;
        renderingDefId = __is.readLong();
        __inS.endReadParams();
        AMD_RenderingEngine_loadRenderingDef __cb = new _AMD_RenderingEngine_loadRenderingDef(__inS);
        try
        {
            __obj.loadRenderingDef_async(__cb, renderingDefId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___setOverlays(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.RLongHolder tablesId = new omero.RLongHolder();
        omero.RLongHolder imageId = new omero.RLongHolder();
        java.util.Map<java.lang.Long, java.lang.Integer> rowColorMap;
        __is.readObject(tablesId);
        __is.readObject(imageId);
        rowColorMap = LongIntMapHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_RenderingEngine_setOverlays __cb = new _AMD_RenderingEngine_setOverlays(__inS);
        try
        {
            __obj.setOverlays_async(__cb, tablesId.value, imageId.value, rowColorMap, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___load(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RenderingEngine_load __cb = new _AMD_RenderingEngine_load(__inS);
        try
        {
            __obj.load_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setModel(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.RenderingModelHolder model = new omero.model.RenderingModelHolder();
        __is.readObject(model);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_RenderingEngine_setModel __cb = new _AMD_RenderingEngine_setModel(__inS);
        try
        {
            __obj.setModel_async(__cb, model.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getModel(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RenderingEngine_getModel __cb = new _AMD_RenderingEngine_getModel(__inS);
        try
        {
            __obj.getModel_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getDefaultZ(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RenderingEngine_getDefaultZ __cb = new _AMD_RenderingEngine_getDefaultZ(__inS);
        try
        {
            __obj.getDefaultZ_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getDefaultT(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RenderingEngine_getDefaultT __cb = new _AMD_RenderingEngine_getDefaultT(__inS);
        try
        {
            __obj.getDefaultT_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setDefaultZ(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int z;
        z = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_setDefaultZ __cb = new _AMD_RenderingEngine_setDefaultZ(__inS);
        try
        {
            __obj.setDefaultZ_async(__cb, z, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setDefaultT(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int t;
        t = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_setDefaultT __cb = new _AMD_RenderingEngine_setDefaultT(__inS);
        try
        {
            __obj.setDefaultT_async(__cb, t, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getPixels(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RenderingEngine_getPixels __cb = new _AMD_RenderingEngine_getPixels(__inS);
        try
        {
            __obj.getPixels_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getAvailableModels(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RenderingEngine_getAvailableModels __cb = new _AMD_RenderingEngine_getAvailableModels(__inS);
        try
        {
            __obj.getAvailableModels_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getAvailableFamilies(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RenderingEngine_getAvailableFamilies __cb = new _AMD_RenderingEngine_getAvailableFamilies(__inS);
        try
        {
            __obj.getAvailableFamilies_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setQuantumStrategy(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int bitResolution;
        bitResolution = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_setQuantumStrategy __cb = new _AMD_RenderingEngine_setQuantumStrategy(__inS);
        try
        {
            __obj.setQuantumStrategy_async(__cb, bitResolution, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setCodomainInterval(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int start;
        int end;
        start = __is.readInt();
        end = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_setCodomainInterval __cb = new _AMD_RenderingEngine_setCodomainInterval(__inS);
        try
        {
            __obj.setCodomainInterval_async(__cb, start, end, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getQuantumDef(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RenderingEngine_getQuantumDef __cb = new _AMD_RenderingEngine_getQuantumDef(__inS);
        try
        {
            __obj.getQuantumDef_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setQuantizationMap(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int w;
        omero.model.FamilyHolder fam = new omero.model.FamilyHolder();
        double coefficient;
        boolean noiseReduction;
        w = __is.readInt();
        __is.readObject(fam);
        coefficient = __is.readDouble();
        noiseReduction = __is.readBool();
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_RenderingEngine_setQuantizationMap __cb = new _AMD_RenderingEngine_setQuantizationMap(__inS);
        try
        {
            __obj.setQuantizationMap_async(__cb, w, fam.value, coefficient, noiseReduction, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getChannelFamily(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int w;
        w = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_getChannelFamily __cb = new _AMD_RenderingEngine_getChannelFamily(__inS);
        try
        {
            __obj.getChannelFamily_async(__cb, w, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getChannelNoiseReduction(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int w;
        w = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_getChannelNoiseReduction __cb = new _AMD_RenderingEngine_getChannelNoiseReduction(__inS);
        try
        {
            __obj.getChannelNoiseReduction_async(__cb, w, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getChannelStats(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int w;
        w = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_getChannelStats __cb = new _AMD_RenderingEngine_getChannelStats(__inS);
        try
        {
            __obj.getChannelStats_async(__cb, w, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getChannelCurveCoefficient(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int w;
        w = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_getChannelCurveCoefficient __cb = new _AMD_RenderingEngine_getChannelCurveCoefficient(__inS);
        try
        {
            __obj.getChannelCurveCoefficient_async(__cb, w, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setChannelWindow(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int w;
        double start;
        double end;
        w = __is.readInt();
        start = __is.readDouble();
        end = __is.readDouble();
        __inS.endReadParams();
        AMD_RenderingEngine_setChannelWindow __cb = new _AMD_RenderingEngine_setChannelWindow(__inS);
        try
        {
            __obj.setChannelWindow_async(__cb, w, start, end, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getChannelWindowStart(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int w;
        w = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_getChannelWindowStart __cb = new _AMD_RenderingEngine_getChannelWindowStart(__inS);
        try
        {
            __obj.getChannelWindowStart_async(__cb, w, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getChannelWindowEnd(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int w;
        w = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_getChannelWindowEnd __cb = new _AMD_RenderingEngine_getChannelWindowEnd(__inS);
        try
        {
            __obj.getChannelWindowEnd_async(__cb, w, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setRGBA(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int w;
        int red;
        int green;
        int blue;
        int alpha;
        w = __is.readInt();
        red = __is.readInt();
        green = __is.readInt();
        blue = __is.readInt();
        alpha = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_setRGBA __cb = new _AMD_RenderingEngine_setRGBA(__inS);
        try
        {
            __obj.setRGBA_async(__cb, w, red, green, blue, alpha, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getRGBA(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int w;
        w = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_getRGBA __cb = new _AMD_RenderingEngine_getRGBA(__inS);
        try
        {
            __obj.getRGBA_async(__cb, w, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setActive(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int w;
        boolean active;
        w = __is.readInt();
        active = __is.readBool();
        __inS.endReadParams();
        AMD_RenderingEngine_setActive __cb = new _AMD_RenderingEngine_setActive(__inS);
        try
        {
            __obj.setActive_async(__cb, w, active, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___isActive(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int w;
        w = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_isActive __cb = new _AMD_RenderingEngine_isActive(__inS);
        try
        {
            __obj.isActive_async(__cb, w, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setChannelLookupTable(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int w;
        String lookup;
        w = __is.readInt();
        lookup = __is.readString();
        __inS.endReadParams();
        AMD_RenderingEngine_setChannelLookupTable __cb = new _AMD_RenderingEngine_setChannelLookupTable(__inS);
        try
        {
            __obj.setChannelLookupTable_async(__cb, w, lookup, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getChannelLookupTable(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int w;
        w = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_getChannelLookupTable __cb = new _AMD_RenderingEngine_getChannelLookupTable(__inS);
        try
        {
            __obj.getChannelLookupTable_async(__cb, w, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___addCodomainMap(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.romio.CodomainMapContextHolder mapCtx = new omero.romio.CodomainMapContextHolder();
        __is.readObject(mapCtx);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_RenderingEngine_addCodomainMap __cb = new _AMD_RenderingEngine_addCodomainMap(__inS);
        try
        {
            __obj.addCodomainMap_async(__cb, mapCtx.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___updateCodomainMap(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.romio.CodomainMapContextHolder mapCtx = new omero.romio.CodomainMapContextHolder();
        __is.readObject(mapCtx);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_RenderingEngine_updateCodomainMap __cb = new _AMD_RenderingEngine_updateCodomainMap(__inS);
        try
        {
            __obj.updateCodomainMap_async(__cb, mapCtx.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    /** @deprecated **/
    public static Ice.DispatchStatus ___removeCodomainMap(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.romio.CodomainMapContextHolder mapCtx = new omero.romio.CodomainMapContextHolder();
        __is.readObject(mapCtx);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_RenderingEngine_removeCodomainMap __cb = new _AMD_RenderingEngine_removeCodomainMap(__inS);
        try
        {
            __obj.removeCodomainMap_async(__cb, mapCtx.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___addCodomainMapToChannel(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.romio.CodomainMapContextHolder mapCtx = new omero.romio.CodomainMapContextHolder();
        int w;
        __is.readObject(mapCtx);
        w = __is.readInt();
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_RenderingEngine_addCodomainMapToChannel __cb = new _AMD_RenderingEngine_addCodomainMapToChannel(__inS);
        try
        {
            __obj.addCodomainMapToChannel_async(__cb, mapCtx.value, w, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___removeCodomainMapFromChannel(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.romio.CodomainMapContextHolder mapCtx = new omero.romio.CodomainMapContextHolder();
        int w;
        __is.readObject(mapCtx);
        w = __is.readInt();
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_RenderingEngine_removeCodomainMapFromChannel __cb = new _AMD_RenderingEngine_removeCodomainMapFromChannel(__inS);
        try
        {
            __obj.removeCodomainMapFromChannel_async(__cb, mapCtx.value, w, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___saveCurrentSettings(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        AMD_RenderingEngine_saveCurrentSettings __cb = new _AMD_RenderingEngine_saveCurrentSettings(__inS);
        try
        {
            __obj.saveCurrentSettings_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___saveAsNewSettings(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        AMD_RenderingEngine_saveAsNewSettings __cb = new _AMD_RenderingEngine_saveAsNewSettings(__inS);
        try
        {
            __obj.saveAsNewSettings_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___resetDefaultSettings(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean save;
        save = __is.readBool();
        __inS.endReadParams();
        AMD_RenderingEngine_resetDefaultSettings __cb = new _AMD_RenderingEngine_resetDefaultSettings(__inS);
        try
        {
            __obj.resetDefaultSettings_async(__cb, save, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setCompressionLevel(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        float percentage;
        percentage = __is.readFloat();
        __inS.endReadParams();
        AMD_RenderingEngine_setCompressionLevel __cb = new _AMD_RenderingEngine_setCompressionLevel(__inS);
        try
        {
            __obj.setCompressionLevel_async(__cb, percentage, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getCompressionLevel(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RenderingEngine_getCompressionLevel __cb = new _AMD_RenderingEngine_getCompressionLevel(__inS);
        try
        {
            __obj.getCompressionLevel_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___isPixelsTypeSigned(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_RenderingEngine_isPixelsTypeSigned __cb = new _AMD_RenderingEngine_isPixelsTypeSigned(__inS);
        try
        {
            __obj.isPixelsTypeSigned_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getPixelsTypeUpperBound(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int w;
        w = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_getPixelsTypeUpperBound __cb = new _AMD_RenderingEngine_getPixelsTypeUpperBound(__inS);
        try
        {
            __obj.getPixelsTypeUpperBound_async(__cb, w, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getPixelsTypeLowerBound(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int w;
        w = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_getPixelsTypeLowerBound __cb = new _AMD_RenderingEngine_getPixelsTypeLowerBound(__inS);
        try
        {
            __obj.getPixelsTypeLowerBound_async(__cb, w, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getCodomainMapContext(RenderingEngine __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int w;
        w = __is.readInt();
        __inS.endReadParams();
        AMD_RenderingEngine_getCodomainMapContext __cb = new _AMD_RenderingEngine_getCodomainMapContext(__inS);
        try
        {
            __obj.getCodomainMapContext_async(__cb, w, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "activate",
        "addCodomainMap",
        "addCodomainMapToChannel",
        "close",
        "getAvailableFamilies",
        "getAvailableModels",
        "getChannelCurveCoefficient",
        "getChannelFamily",
        "getChannelLookupTable",
        "getChannelNoiseReduction",
        "getChannelStats",
        "getChannelWindowEnd",
        "getChannelWindowStart",
        "getCodomainMapContext",
        "getCompressionLevel",
        "getCurrentEventContext",
        "getDefaultT",
        "getDefaultZ",
        "getModel",
        "getPixels",
        "getPixelsTypeLowerBound",
        "getPixelsTypeUpperBound",
        "getQuantumDef",
        "getRGBA",
        "getRenderingDefId",
        "getResolutionDescriptions",
        "getResolutionLevel",
        "getResolutionLevels",
        "getTileSize",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "isActive",
        "isPixelsTypeSigned",
        "load",
        "loadRenderingDef",
        "lookupPixels",
        "lookupRenderingDef",
        "passivate",
        "removeCodomainMap",
        "removeCodomainMapFromChannel",
        "render",
        "renderAsPackedInt",
        "renderCompressed",
        "renderProjectedAsPackedInt",
        "renderProjectedCompressed",
        "requiresPixelsPyramid",
        "resetDefaultSettings",
        "saveAsNewSettings",
        "saveCurrentSettings",
        "setActive",
        "setChannelLookupTable",
        "setChannelWindow",
        "setCodomainInterval",
        "setCompressionLevel",
        "setDefaultT",
        "setDefaultZ",
        "setModel",
        "setOverlays",
        "setQuantizationMap",
        "setQuantumStrategy",
        "setRGBA",
        "setResolutionLevel",
        "updateCodomainMap"
    };

    @SuppressWarnings("deprecation")
    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return _StatefulServiceInterfaceDisp.___activate(this, in, __current);
            }
            case 1:
            {
                return ___addCodomainMap(this, in, __current);
            }
            case 2:
            {
                return ___addCodomainMapToChannel(this, in, __current);
            }
            case 3:
            {
                return _StatefulServiceInterfaceDisp.___close(this, in, __current);
            }
            case 4:
            {
                return ___getAvailableFamilies(this, in, __current);
            }
            case 5:
            {
                return ___getAvailableModels(this, in, __current);
            }
            case 6:
            {
                return ___getChannelCurveCoefficient(this, in, __current);
            }
            case 7:
            {
                return ___getChannelFamily(this, in, __current);
            }
            case 8:
            {
                return ___getChannelLookupTable(this, in, __current);
            }
            case 9:
            {
                return ___getChannelNoiseReduction(this, in, __current);
            }
            case 10:
            {
                return ___getChannelStats(this, in, __current);
            }
            case 11:
            {
                return ___getChannelWindowEnd(this, in, __current);
            }
            case 12:
            {
                return ___getChannelWindowStart(this, in, __current);
            }
            case 13:
            {
                return ___getCodomainMapContext(this, in, __current);
            }
            case 14:
            {
                return ___getCompressionLevel(this, in, __current);
            }
            case 15:
            {
                return _StatefulServiceInterfaceDisp.___getCurrentEventContext(this, in, __current);
            }
            case 16:
            {
                return ___getDefaultT(this, in, __current);
            }
            case 17:
            {
                return ___getDefaultZ(this, in, __current);
            }
            case 18:
            {
                return ___getModel(this, in, __current);
            }
            case 19:
            {
                return ___getPixels(this, in, __current);
            }
            case 20:
            {
                return ___getPixelsTypeLowerBound(this, in, __current);
            }
            case 21:
            {
                return ___getPixelsTypeUpperBound(this, in, __current);
            }
            case 22:
            {
                return ___getQuantumDef(this, in, __current);
            }
            case 23:
            {
                return ___getRGBA(this, in, __current);
            }
            case 24:
            {
                return ___getRenderingDefId(this, in, __current);
            }
            case 25:
            {
                return _PyramidServiceDisp.___getResolutionDescriptions(this, in, __current);
            }
            case 26:
            {
                return _PyramidServiceDisp.___getResolutionLevel(this, in, __current);
            }
            case 27:
            {
                return _PyramidServiceDisp.___getResolutionLevels(this, in, __current);
            }
            case 28:
            {
                return _PyramidServiceDisp.___getTileSize(this, in, __current);
            }
            case 29:
            {
                return ___ice_id(this, in, __current);
            }
            case 30:
            {
                return ___ice_ids(this, in, __current);
            }
            case 31:
            {
                return ___ice_isA(this, in, __current);
            }
            case 32:
            {
                return ___ice_ping(this, in, __current);
            }
            case 33:
            {
                return ___isActive(this, in, __current);
            }
            case 34:
            {
                return ___isPixelsTypeSigned(this, in, __current);
            }
            case 35:
            {
                return ___load(this, in, __current);
            }
            case 36:
            {
                return ___loadRenderingDef(this, in, __current);
            }
            case 37:
            {
                return ___lookupPixels(this, in, __current);
            }
            case 38:
            {
                return ___lookupRenderingDef(this, in, __current);
            }
            case 39:
            {
                return _StatefulServiceInterfaceDisp.___passivate(this, in, __current);
            }
            case 40:
            {
                return ___removeCodomainMap(this, in, __current);
            }
            case 41:
            {
                return ___removeCodomainMapFromChannel(this, in, __current);
            }
            case 42:
            {
                return ___render(this, in, __current);
            }
            case 43:
            {
                return ___renderAsPackedInt(this, in, __current);
            }
            case 44:
            {
                return ___renderCompressed(this, in, __current);
            }
            case 45:
            {
                return ___renderProjectedAsPackedInt(this, in, __current);
            }
            case 46:
            {
                return ___renderProjectedCompressed(this, in, __current);
            }
            case 47:
            {
                return _PyramidServiceDisp.___requiresPixelsPyramid(this, in, __current);
            }
            case 48:
            {
                return ___resetDefaultSettings(this, in, __current);
            }
            case 49:
            {
                return ___saveAsNewSettings(this, in, __current);
            }
            case 50:
            {
                return ___saveCurrentSettings(this, in, __current);
            }
            case 51:
            {
                return ___setActive(this, in, __current);
            }
            case 52:
            {
                return ___setChannelLookupTable(this, in, __current);
            }
            case 53:
            {
                return ___setChannelWindow(this, in, __current);
            }
            case 54:
            {
                return ___setCodomainInterval(this, in, __current);
            }
            case 55:
            {
                return ___setCompressionLevel(this, in, __current);
            }
            case 56:
            {
                return ___setDefaultT(this, in, __current);
            }
            case 57:
            {
                return ___setDefaultZ(this, in, __current);
            }
            case 58:
            {
                return ___setModel(this, in, __current);
            }
            case 59:
            {
                return ___setOverlays(this, in, __current);
            }
            case 60:
            {
                return ___setQuantizationMap(this, in, __current);
            }
            case 61:
            {
                return ___setQuantumStrategy(this, in, __current);
            }
            case 62:
            {
                return ___setRGBA(this, in, __current);
            }
            case 63:
            {
                return _PyramidServiceDisp.___setResolutionLevel(this, in, __current);
            }
            case 64:
            {
                return ___updateCodomainMap(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
