// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Search.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Central search interface, allowing Web2.0 style queries. Each
 * {@link omero.api.Search} instance keeps up with several queries and
 * lazily-loads the results as {@link #hasNext}, {@link #next} and
 * {@link #results} are called. These queries are created by the
 * <i>by*</i> methods.
 * 
 * Each instance also has a number of settings which can all be
 * changed from their defaults via accessors, e.g.
 * {@link #setBatchSize} or {@link #setCaseSentivice}.
 * 
 * The only methods which are required for the proper functioning of a
 * {@link Search} instance are:
 * <ul>
 * <li>{@link #onlyType}, {@link #onlyTypes} OR
 * {@link #allTypes}</li>
 * <li>Any <i>by*</i> method to create a query</li>
 * </ul>
 * Use of the {@link #allTypes} method is discouraged, since it is
 * possibly very resource intensive, which is why any attempt to
 * receive results without specifically setting types or allowing all
 * is prohibited.
 * 
 * @see omero.api.IQuery
 **/
public abstract class _SearchDisp extends Ice.ObjectImpl implements Search
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::Search",
        "::omero::api::ServiceInterface",
        "::omero::api::StatefulServiceInterface"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void activeQueries_async(AMD_Search_activeQueries __cb)
        throws omero.ServerError
    {
        activeQueries_async(__cb, null);
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     **/
    public final void addOrderByAsc_async(AMD_Search_addOrderByAsc __cb, String path)
        throws omero.ServerError
    {
        addOrderByAsc_async(__cb, path, null);
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     **/
    public final void addOrderByDesc_async(AMD_Search_addOrderByDesc __cb, String path)
        throws omero.ServerError
    {
        addOrderByDesc_async(__cb, path, null);
    }

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __cb The callback object for the operation.
     **/
    public final void allTypes_async(AMD_Search_allTypes __cb)
        throws omero.ServerError
    {
        allTypes_async(__cb, null);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __cb The callback object for the operation.
     **/
    public final void and_async(AMD_Search_and __cb)
        throws omero.ServerError
    {
        and_async(__cb, null);
    }

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param examples Not empty.
     **/
    public final void byAnnotatedWith_async(AMD_Search_byAnnotatedWith __cb, java.util.List<omero.model.Annotation> examples)
        throws omero.ServerError
    {
        byAnnotatedWith_async(__cb, examples, null);
    }

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param query May not be null or of zero length.
     **/
    public final void byFullText_async(AMD_Search_byFullText __cb, String query)
        throws omero.ServerError
    {
        byFullText_async(__cb, query, null);
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param group Can be null or empty to return all tags.
     **/
    public final void byGroupForTags_async(AMD_Search_byGroupForTags __cb, String group)
        throws omero.ServerError
    {
        byGroupForTags_async(__cb, group, null);
    }

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param __cb The callback object for the operation.
     * @param query Not null.
     **/
    public final void byHqlQuery_async(AMD_Search_byHqlQuery __cb, String query, omero.sys.Parameters params)
        throws omero.ServerError
    {
        byHqlQuery_async(__cb, query, params, null);
    }

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     **/
    public final void byLuceneQueryBuilder_async(AMD_Search_byLuceneQueryBuilder __cb, String fields, String from, String to, String dateType, String query)
        throws omero.ServerError
    {
        byLuceneQueryBuilder_async(__cb, fields, from, to, dateType, query, null);
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param __cb The callback object for the operation.
     * @param terms Cannot be empty.
     **/
    public final void bySimilarTerms_async(AMD_Search_bySimilarTerms __cb, java.util.List<String> terms)
        throws omero.ServerError
    {
        bySimilarTerms_async(__cb, terms, null);
    }

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param __cb The callback object for the operation.
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     **/
    public final void bySomeMustNone_async(AMD_Search_bySomeMustNone __cb, java.util.List<String> some, java.util.List<String> must, java.util.List<String> none)
        throws omero.ServerError
    {
        bySomeMustNone_async(__cb, some, must, none, null);
    }

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param tag Can be null or empty to return all groups.
     **/
    public final void byTagForGroups_async(AMD_Search_byTagForGroups __cb, String tag)
        throws omero.ServerError
    {
        byTagForGroups_async(__cb, tag, null);
    }

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __cb The callback object for the operation.
     **/
    public final void clearQueries_async(AMD_Search_clearQueries __cb)
        throws omero.ServerError
    {
        clearQueries_async(__cb, null);
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __cb The callback object for the operation.
     **/
    public final void currentMetadata_async(AMD_Search_currentMetadata __cb)
        throws omero.ServerError
    {
        currentMetadata_async(__cb, null);
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __cb The callback object for the operation.
     **/
    public final void currentMetadataList_async(AMD_Search_currentMetadataList __cb)
        throws omero.ServerError
    {
        currentMetadataList_async(__cb, null);
    }

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param __cb The callback object for the operation.
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     **/
    public final void fetchAlso_async(AMD_Search_fetchAlso __cb, java.util.List<String> fetches)
        throws omero.ServerError
    {
        fetchAlso_async(__cb, fetches, null);
    }

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, which removes previous fetch
     * setting.
     **/
    public final void fetchAnnotations_async(AMD_Search_fetchAnnotations __cb, java.util.List<String> classes)
        throws omero.ServerError
    {
        fetchAnnotations_async(__cb, classes, null);
    }

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void getBatchSize_async(AMD_Search_getBatchSize __cb)
        throws omero.ServerError
    {
        getBatchSize_async(__cb, null);
    }

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __cb The callback object for the operation.
     **/
    public final void hasNext_async(AMD_Search_hasNext __cb)
        throws omero.ServerError
    {
        hasNext_async(__cb, null);
    }

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __cb The callback object for the operation.
     **/
    public final void isAllowLeadingWildcard_async(AMD_Search_isAllowLeadingWildcard __cb)
        throws omero.ServerError
    {
        isAllowLeadingWildcard_async(__cb, null);
    }

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public final void isCaseSensitive_async(AMD_Search_isCaseSensitive __cb)
        throws omero.ServerError
    {
        isCaseSensitive_async(__cb, null);
    }

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public final void isMergedBatches_async(AMD_Search_isMergedBatches __cb)
        throws omero.ServerError
    {
        isMergedBatches_async(__cb, null);
    }

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public final void isReturnUnloaded_async(AMD_Search_isReturnUnloaded __cb)
        throws omero.ServerError
    {
        isReturnUnloaded_async(__cb, null);
    }

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public final void isUseProjections_async(AMD_Search_isUseProjections __cb)
        throws omero.ServerError
    {
        isUseProjections_async(__cb, null);
    }

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void next_async(AMD_Search_next __cb)
        throws omero.ServerError
    {
        next_async(__cb, null);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __cb The callback object for the operation.
     **/
    public final void not_async(AMD_Search_not __cb)
        throws omero.ServerError
    {
        not_async(__cb, null);
    }

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     **/
    public final void notAnnotatedBy_async(AMD_Search_notAnnotatedBy __cb, omero.model.Details d)
        throws omero.ServerError
    {
        notAnnotatedBy_async(__cb, d, null);
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     **/
    public final void notOwnedBy_async(AMD_Search_notOwnedBy __cb, omero.model.Details d)
        throws omero.ServerError
    {
        notOwnedBy_async(__cb, d, null);
    }

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     **/
    public final void onlyAnnotatedBetween_async(AMD_Search_onlyAnnotatedBetween __cb, omero.RTime start, omero.RTime stop)
        throws omero.ServerError
    {
        onlyAnnotatedBetween_async(__cb, start, stop, null);
    }

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     **/
    public final void onlyAnnotatedBy_async(AMD_Search_onlyAnnotatedBy __cb, omero.model.Details d)
        throws omero.ServerError
    {
        onlyAnnotatedBy_async(__cb, d, null);
    }

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, in which case restriction is
     * removed.
     **/
    public final void onlyAnnotatedWith_async(AMD_Search_onlyAnnotatedWith __cb, java.util.List<String> classes)
        throws omero.ServerError
    {
        onlyAnnotatedWith_async(__cb, classes, null);
    }

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     **/
    public final void onlyCreatedBetween_async(AMD_Search_onlyCreatedBetween __cb, omero.RTime start, omero.RTime stop)
        throws omero.ServerError
    {
        onlyCreatedBetween_async(__cb, start, stop, null);
    }

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param __cb The callback object for the operation.
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     **/
    public final void onlyIds_async(AMD_Search_onlyIds __cb, java.util.List<Long> ids)
        throws omero.ServerError
    {
        onlyIds_async(__cb, ids, null);
    }

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     **/
    public final void onlyModifiedBetween_async(AMD_Search_onlyModifiedBetween __cb, omero.RTime start, omero.RTime stop)
        throws omero.ServerError
    {
        onlyModifiedBetween_async(__cb, start, stop, null);
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     **/
    public final void onlyOwnedBy_async(AMD_Search_onlyOwnedBy __cb, omero.model.Details d)
        throws omero.ServerError
    {
        onlyOwnedBy_async(__cb, d, null);
    }

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __cb The callback object for the operation.
     **/
    public final void onlyType_async(AMD_Search_onlyType __cb, String klass)
        throws omero.ServerError
    {
        onlyType_async(__cb, klass, null);
    }

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __cb The callback object for the operation.
     **/
    public final void onlyTypes_async(AMD_Search_onlyTypes __cb, java.util.List<String> classes)
        throws omero.ServerError
    {
        onlyTypes_async(__cb, classes, null);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __cb The callback object for the operation.
     **/
    public final void or_async(AMD_Search_or __cb)
        throws omero.ServerError
    {
        or_async(__cb, null);
    }

    /**
     * Unsupported operation.
     * @param __cb The callback object for the operation.
     **/
    public final void remove_async(AMD_Search_remove __cb)
        throws omero.ServerError
    {
        remove_async(__cb, null);
    }

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __cb The callback object for the operation.
     **/
    public final void resetDefaults_async(AMD_Search_resetDefaults __cb)
        throws omero.ServerError
    {
        resetDefaults_async(__cb, null);
    }

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void results_async(AMD_Search_results __cb)
        throws omero.ServerError
    {
        results_async(__cb, null);
    }

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void setAllowLeadingWildcard_async(AMD_Search_setAllowLeadingWildcard __cb, boolean allowLeadingWildcard)
        throws omero.ServerError
    {
        setAllowLeadingWildcard_async(__cb, allowLeadingWildcard, null);
    }

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param __cb The callback object for the operation.
     * @param size maximum number of results per call to
     * {@link #results}
     **/
    public final void setBatchSize_async(AMD_Search_setBatchSize __cb, int size)
        throws omero.ServerError
    {
        setBatchSize_async(__cb, size, null);
    }

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __cb The callback object for the operation.
     **/
    public final void setCaseSentivice_async(AMD_Search_setCaseSentivice __cb, boolean caseSensitive)
        throws omero.ServerError
    {
        setCaseSentivice_async(__cb, caseSensitive, null);
    }

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __cb The callback object for the operation.
     **/
    public final void setMergedBatches_async(AMD_Search_setMergedBatches __cb, boolean merge)
        throws omero.ServerError
    {
        setMergedBatches_async(__cb, merge, null);
    }

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __cb The callback object for the operation.
     **/
    public final void setReturnUnloaded_async(AMD_Search_setReturnUnloaded __cb, boolean returnUnloaded)
        throws omero.ServerError
    {
        setReturnUnloaded_async(__cb, returnUnloaded, null);
    }

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __cb The callback object for the operation.
     **/
    public final void setUseProjections_async(AMD_Search_setUseProjections __cb, boolean useProjections)
        throws omero.ServerError
    {
        setUseProjections_async(__cb, useProjections, null);
    }

    /**
     * Removes the current stack of order statements.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void unordered_async(AMD_Search_unordered __cb)
        throws omero.ServerError
    {
        unordered_async(__cb, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public final void activate_async(AMD_StatefulServiceInterface_activate __cb)
        throws omero.ServerError
    {
        activate_async(__cb, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public final void close_async(AMD_StatefulServiceInterface_close __cb)
        throws omero.ServerError
    {
        close_async(__cb, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public final void getCurrentEventContext_async(AMD_StatefulServiceInterface_getCurrentEventContext __cb)
        throws omero.ServerError
    {
        getCurrentEventContext_async(__cb, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public final void passivate_async(AMD_StatefulServiceInterface_passivate __cb)
        throws omero.ServerError
    {
        passivate_async(__cb, null);
    }

    public static Ice.DispatchStatus ___activeQueries(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_activeQueries __cb = new _AMD_Search_activeQueries(__inS);
        try
        {
            __obj.activeQueries_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setBatchSize(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int size;
        size = __is.readInt();
        __inS.endReadParams();
        AMD_Search_setBatchSize __cb = new _AMD_Search_setBatchSize(__inS);
        try
        {
            __obj.setBatchSize_async(__cb, size, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getBatchSize(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_getBatchSize __cb = new _AMD_Search_getBatchSize(__inS);
        try
        {
            __obj.getBatchSize_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setMergedBatches(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean merge;
        merge = __is.readBool();
        __inS.endReadParams();
        AMD_Search_setMergedBatches __cb = new _AMD_Search_setMergedBatches(__inS);
        try
        {
            __obj.setMergedBatches_async(__cb, merge, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___isMergedBatches(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_isMergedBatches __cb = new _AMD_Search_isMergedBatches(__inS);
        try
        {
            __obj.isMergedBatches_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setCaseSentivice(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean caseSensitive;
        caseSensitive = __is.readBool();
        __inS.endReadParams();
        AMD_Search_setCaseSentivice __cb = new _AMD_Search_setCaseSentivice(__inS);
        try
        {
            __obj.setCaseSentivice_async(__cb, caseSensitive, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___isCaseSensitive(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_isCaseSensitive __cb = new _AMD_Search_isCaseSensitive(__inS);
        try
        {
            __obj.isCaseSensitive_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setUseProjections(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean useProjections;
        useProjections = __is.readBool();
        __inS.endReadParams();
        AMD_Search_setUseProjections __cb = new _AMD_Search_setUseProjections(__inS);
        try
        {
            __obj.setUseProjections_async(__cb, useProjections, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___isUseProjections(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_isUseProjections __cb = new _AMD_Search_isUseProjections(__inS);
        try
        {
            __obj.isUseProjections_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setReturnUnloaded(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean returnUnloaded;
        returnUnloaded = __is.readBool();
        __inS.endReadParams();
        AMD_Search_setReturnUnloaded __cb = new _AMD_Search_setReturnUnloaded(__inS);
        try
        {
            __obj.setReturnUnloaded_async(__cb, returnUnloaded, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___isReturnUnloaded(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_isReturnUnloaded __cb = new _AMD_Search_isReturnUnloaded(__inS);
        try
        {
            __obj.isReturnUnloaded_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setAllowLeadingWildcard(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean allowLeadingWildcard;
        allowLeadingWildcard = __is.readBool();
        __inS.endReadParams();
        AMD_Search_setAllowLeadingWildcard __cb = new _AMD_Search_setAllowLeadingWildcard(__inS);
        try
        {
            __obj.setAllowLeadingWildcard_async(__cb, allowLeadingWildcard, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___isAllowLeadingWildcard(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_isAllowLeadingWildcard __cb = new _AMD_Search_isAllowLeadingWildcard(__inS);
        try
        {
            __obj.isAllowLeadingWildcard_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___onlyType(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String klass;
        klass = __is.readString();
        __inS.endReadParams();
        AMD_Search_onlyType __cb = new _AMD_Search_onlyType(__inS);
        try
        {
            __obj.onlyType_async(__cb, klass, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___onlyTypes(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<String> classes;
        classes = StringSetHelper.read(__is);
        __inS.endReadParams();
        AMD_Search_onlyTypes __cb = new _AMD_Search_onlyTypes(__inS);
        try
        {
            __obj.onlyTypes_async(__cb, classes, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___allTypes(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_allTypes __cb = new _AMD_Search_allTypes(__inS);
        try
        {
            __obj.allTypes_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___onlyIds(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<Long> ids;
        ids = omero.sys.LongListHelper.read(__is);
        __inS.endReadParams();
        AMD_Search_onlyIds __cb = new _AMD_Search_onlyIds(__inS);
        try
        {
            __obj.onlyIds_async(__cb, ids, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___onlyOwnedBy(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.DetailsHolder d = new omero.model.DetailsHolder();
        __is.readObject(d);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_Search_onlyOwnedBy __cb = new _AMD_Search_onlyOwnedBy(__inS);
        try
        {
            __obj.onlyOwnedBy_async(__cb, d.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___notOwnedBy(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.DetailsHolder d = new omero.model.DetailsHolder();
        __is.readObject(d);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_Search_notOwnedBy __cb = new _AMD_Search_notOwnedBy(__inS);
        try
        {
            __obj.notOwnedBy_async(__cb, d.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___onlyCreatedBetween(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.RTimeHolder start = new omero.RTimeHolder();
        omero.RTimeHolder stop = new omero.RTimeHolder();
        __is.readObject(start);
        __is.readObject(stop);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_Search_onlyCreatedBetween __cb = new _AMD_Search_onlyCreatedBetween(__inS);
        try
        {
            __obj.onlyCreatedBetween_async(__cb, start.value, stop.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___onlyModifiedBetween(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.RTimeHolder start = new omero.RTimeHolder();
        omero.RTimeHolder stop = new omero.RTimeHolder();
        __is.readObject(start);
        __is.readObject(stop);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_Search_onlyModifiedBetween __cb = new _AMD_Search_onlyModifiedBetween(__inS);
        try
        {
            __obj.onlyModifiedBetween_async(__cb, start.value, stop.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___onlyAnnotatedBetween(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.RTimeHolder start = new omero.RTimeHolder();
        omero.RTimeHolder stop = new omero.RTimeHolder();
        __is.readObject(start);
        __is.readObject(stop);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_Search_onlyAnnotatedBetween __cb = new _AMD_Search_onlyAnnotatedBetween(__inS);
        try
        {
            __obj.onlyAnnotatedBetween_async(__cb, start.value, stop.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___onlyAnnotatedBy(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.DetailsHolder d = new omero.model.DetailsHolder();
        __is.readObject(d);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_Search_onlyAnnotatedBy __cb = new _AMD_Search_onlyAnnotatedBy(__inS);
        try
        {
            __obj.onlyAnnotatedBy_async(__cb, d.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___notAnnotatedBy(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.DetailsHolder d = new omero.model.DetailsHolder();
        __is.readObject(d);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_Search_notAnnotatedBy __cb = new _AMD_Search_notAnnotatedBy(__inS);
        try
        {
            __obj.notAnnotatedBy_async(__cb, d.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___onlyAnnotatedWith(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<String> classes;
        classes = StringSetHelper.read(__is);
        __inS.endReadParams();
        AMD_Search_onlyAnnotatedWith __cb = new _AMD_Search_onlyAnnotatedWith(__inS);
        try
        {
            __obj.onlyAnnotatedWith_async(__cb, classes, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___addOrderByAsc(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String path;
        path = __is.readString();
        __inS.endReadParams();
        AMD_Search_addOrderByAsc __cb = new _AMD_Search_addOrderByAsc(__inS);
        try
        {
            __obj.addOrderByAsc_async(__cb, path, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___addOrderByDesc(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String path;
        path = __is.readString();
        __inS.endReadParams();
        AMD_Search_addOrderByDesc __cb = new _AMD_Search_addOrderByDesc(__inS);
        try
        {
            __obj.addOrderByDesc_async(__cb, path, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___unordered(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_unordered __cb = new _AMD_Search_unordered(__inS);
        try
        {
            __obj.unordered_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___fetchAnnotations(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<String> classes;
        classes = StringSetHelper.read(__is);
        __inS.endReadParams();
        AMD_Search_fetchAnnotations __cb = new _AMD_Search_fetchAnnotations(__inS);
        try
        {
            __obj.fetchAnnotations_async(__cb, classes, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___fetchAlso(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<String> fetches;
        fetches = StringSetHelper.read(__is);
        __inS.endReadParams();
        AMD_Search_fetchAlso __cb = new _AMD_Search_fetchAlso(__inS);
        try
        {
            __obj.fetchAlso_async(__cb, fetches, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___resetDefaults(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_resetDefaults __cb = new _AMD_Search_resetDefaults(__inS);
        try
        {
            __obj.resetDefaults_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___byGroupForTags(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String group;
        group = __is.readString();
        __inS.endReadParams();
        AMD_Search_byGroupForTags __cb = new _AMD_Search_byGroupForTags(__inS);
        try
        {
            __obj.byGroupForTags_async(__cb, group, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___byTagForGroups(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String tag;
        tag = __is.readString();
        __inS.endReadParams();
        AMD_Search_byTagForGroups __cb = new _AMD_Search_byTagForGroups(__inS);
        try
        {
            __obj.byTagForGroups_async(__cb, tag, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___byFullText(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String query;
        query = __is.readString();
        __inS.endReadParams();
        AMD_Search_byFullText __cb = new _AMD_Search_byFullText(__inS);
        try
        {
            __obj.byFullText_async(__cb, query, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___byLuceneQueryBuilder(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String fields;
        String from;
        String to;
        String dateType;
        String query;
        fields = __is.readString();
        from = __is.readString();
        to = __is.readString();
        dateType = __is.readString();
        query = __is.readString();
        __inS.endReadParams();
        AMD_Search_byLuceneQueryBuilder __cb = new _AMD_Search_byLuceneQueryBuilder(__inS);
        try
        {
            __obj.byLuceneQueryBuilder_async(__cb, fields, from, to, dateType, query, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___bySimilarTerms(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<String> terms;
        terms = StringSetHelper.read(__is);
        __inS.endReadParams();
        AMD_Search_bySimilarTerms __cb = new _AMD_Search_bySimilarTerms(__inS);
        try
        {
            __obj.bySimilarTerms_async(__cb, terms, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___byHqlQuery(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String query;
        omero.sys.ParametersHolder params = new omero.sys.ParametersHolder();
        query = __is.readString();
        __is.readObject(params);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_Search_byHqlQuery __cb = new _AMD_Search_byHqlQuery(__inS);
        try
        {
            __obj.byHqlQuery_async(__cb, query, params.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___bySomeMustNone(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<String> some;
        java.util.List<String> must;
        java.util.List<String> none;
        some = StringSetHelper.read(__is);
        must = StringSetHelper.read(__is);
        none = StringSetHelper.read(__is);
        __inS.endReadParams();
        AMD_Search_bySomeMustNone __cb = new _AMD_Search_bySomeMustNone(__inS);
        try
        {
            __obj.bySomeMustNone_async(__cb, some, must, none, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___byAnnotatedWith(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<omero.model.Annotation> examples;
        examples = AnnotationListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_Search_byAnnotatedWith __cb = new _AMD_Search_byAnnotatedWith(__inS);
        try
        {
            __obj.byAnnotatedWith_async(__cb, examples, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___clearQueries(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_clearQueries __cb = new _AMD_Search_clearQueries(__inS);
        try
        {
            __obj.clearQueries_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___and(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_and __cb = new _AMD_Search_and(__inS);
        try
        {
            __obj.and_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___or(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_or __cb = new _AMD_Search_or(__inS);
        try
        {
            __obj.or_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___not(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_not __cb = new _AMD_Search_not(__inS);
        try
        {
            __obj.not_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___hasNext(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_hasNext __cb = new _AMD_Search_hasNext(__inS);
        try
        {
            __obj.hasNext_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___next(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_next __cb = new _AMD_Search_next(__inS);
        try
        {
            __obj.next_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___results(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_results __cb = new _AMD_Search_results(__inS);
        try
        {
            __obj.results_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___currentMetadata(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_currentMetadata __cb = new _AMD_Search_currentMetadata(__inS);
        try
        {
            __obj.currentMetadata_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___currentMetadataList(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_currentMetadataList __cb = new _AMD_Search_currentMetadataList(__inS);
        try
        {
            __obj.currentMetadataList_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___remove(Search __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        AMD_Search_remove __cb = new _AMD_Search_remove(__inS);
        try
        {
            __obj.remove_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "activate",
        "activeQueries",
        "addOrderByAsc",
        "addOrderByDesc",
        "allTypes",
        "and",
        "byAnnotatedWith",
        "byFullText",
        "byGroupForTags",
        "byHqlQuery",
        "byLuceneQueryBuilder",
        "bySimilarTerms",
        "bySomeMustNone",
        "byTagForGroups",
        "clearQueries",
        "close",
        "currentMetadata",
        "currentMetadataList",
        "fetchAlso",
        "fetchAnnotations",
        "getBatchSize",
        "getCurrentEventContext",
        "hasNext",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "isAllowLeadingWildcard",
        "isCaseSensitive",
        "isMergedBatches",
        "isReturnUnloaded",
        "isUseProjections",
        "next",
        "not",
        "notAnnotatedBy",
        "notOwnedBy",
        "onlyAnnotatedBetween",
        "onlyAnnotatedBy",
        "onlyAnnotatedWith",
        "onlyCreatedBetween",
        "onlyIds",
        "onlyModifiedBetween",
        "onlyOwnedBy",
        "onlyType",
        "onlyTypes",
        "or",
        "passivate",
        "remove",
        "resetDefaults",
        "results",
        "setAllowLeadingWildcard",
        "setBatchSize",
        "setCaseSentivice",
        "setMergedBatches",
        "setReturnUnloaded",
        "setUseProjections",
        "unordered"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return _StatefulServiceInterfaceDisp.___activate(this, in, __current);
            }
            case 1:
            {
                return ___activeQueries(this, in, __current);
            }
            case 2:
            {
                return ___addOrderByAsc(this, in, __current);
            }
            case 3:
            {
                return ___addOrderByDesc(this, in, __current);
            }
            case 4:
            {
                return ___allTypes(this, in, __current);
            }
            case 5:
            {
                return ___and(this, in, __current);
            }
            case 6:
            {
                return ___byAnnotatedWith(this, in, __current);
            }
            case 7:
            {
                return ___byFullText(this, in, __current);
            }
            case 8:
            {
                return ___byGroupForTags(this, in, __current);
            }
            case 9:
            {
                return ___byHqlQuery(this, in, __current);
            }
            case 10:
            {
                return ___byLuceneQueryBuilder(this, in, __current);
            }
            case 11:
            {
                return ___bySimilarTerms(this, in, __current);
            }
            case 12:
            {
                return ___bySomeMustNone(this, in, __current);
            }
            case 13:
            {
                return ___byTagForGroups(this, in, __current);
            }
            case 14:
            {
                return ___clearQueries(this, in, __current);
            }
            case 15:
            {
                return _StatefulServiceInterfaceDisp.___close(this, in, __current);
            }
            case 16:
            {
                return ___currentMetadata(this, in, __current);
            }
            case 17:
            {
                return ___currentMetadataList(this, in, __current);
            }
            case 18:
            {
                return ___fetchAlso(this, in, __current);
            }
            case 19:
            {
                return ___fetchAnnotations(this, in, __current);
            }
            case 20:
            {
                return ___getBatchSize(this, in, __current);
            }
            case 21:
            {
                return _StatefulServiceInterfaceDisp.___getCurrentEventContext(this, in, __current);
            }
            case 22:
            {
                return ___hasNext(this, in, __current);
            }
            case 23:
            {
                return ___ice_id(this, in, __current);
            }
            case 24:
            {
                return ___ice_ids(this, in, __current);
            }
            case 25:
            {
                return ___ice_isA(this, in, __current);
            }
            case 26:
            {
                return ___ice_ping(this, in, __current);
            }
            case 27:
            {
                return ___isAllowLeadingWildcard(this, in, __current);
            }
            case 28:
            {
                return ___isCaseSensitive(this, in, __current);
            }
            case 29:
            {
                return ___isMergedBatches(this, in, __current);
            }
            case 30:
            {
                return ___isReturnUnloaded(this, in, __current);
            }
            case 31:
            {
                return ___isUseProjections(this, in, __current);
            }
            case 32:
            {
                return ___next(this, in, __current);
            }
            case 33:
            {
                return ___not(this, in, __current);
            }
            case 34:
            {
                return ___notAnnotatedBy(this, in, __current);
            }
            case 35:
            {
                return ___notOwnedBy(this, in, __current);
            }
            case 36:
            {
                return ___onlyAnnotatedBetween(this, in, __current);
            }
            case 37:
            {
                return ___onlyAnnotatedBy(this, in, __current);
            }
            case 38:
            {
                return ___onlyAnnotatedWith(this, in, __current);
            }
            case 39:
            {
                return ___onlyCreatedBetween(this, in, __current);
            }
            case 40:
            {
                return ___onlyIds(this, in, __current);
            }
            case 41:
            {
                return ___onlyModifiedBetween(this, in, __current);
            }
            case 42:
            {
                return ___onlyOwnedBy(this, in, __current);
            }
            case 43:
            {
                return ___onlyType(this, in, __current);
            }
            case 44:
            {
                return ___onlyTypes(this, in, __current);
            }
            case 45:
            {
                return ___or(this, in, __current);
            }
            case 46:
            {
                return _StatefulServiceInterfaceDisp.___passivate(this, in, __current);
            }
            case 47:
            {
                return ___remove(this, in, __current);
            }
            case 48:
            {
                return ___resetDefaults(this, in, __current);
            }
            case 49:
            {
                return ___results(this, in, __current);
            }
            case 50:
            {
                return ___setAllowLeadingWildcard(this, in, __current);
            }
            case 51:
            {
                return ___setBatchSize(this, in, __current);
            }
            case 52:
            {
                return ___setCaseSentivice(this, in, __current);
            }
            case 53:
            {
                return ___setMergedBatches(this, in, __current);
            }
            case 54:
            {
                return ___setReturnUnloaded(this, in, __current);
            }
            case 55:
            {
                return ___setUseProjections(this, in, __current);
            }
            case 56:
            {
                return ___unordered(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
