// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `API.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Starting point for all OMERO.blitz interaction.
 * 
 * <p> A ServiceFactory once acquired can be used to create any number
 * of service proxies to the server. Most services implement
 * {@link ServiceInterface} or its subinterface
 * {@link StatefulServiceInterface}. </p>
 **/
public abstract class _ServiceFactoryDisp extends Ice.ObjectImpl implements ServiceFactory
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Glacier2::Session",
        "::Ice::Object",
        "::omero::api::ServiceFactory",
        "::omero::cmd::Session"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[2];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[2];
    }

    public static String ice_staticId()
    {
        return __ids[2];
    }

    /**
     * Destroy the session. This is called automatically when the
     * {@link Router} is destroyed.
     * 
     **/
    public final void destroy()
    {
        destroy(null);
    }

    /**
     * Returns a list of string ids for currently active services. This will
     * _not_ keep services alive, and in fact checks for all expired services
     * and removes them.
     **/
    public final java.util.List<String> activeServices()
        throws omero.ServerError
    {
        return activeServices(null);
    }

    /**
     * Marks the session for closure rather than detachment, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * Closing the session rather the detaching is more secure, since all
     * resources are removed from the server and can safely be set once
     * it is clear that a client is finished with those resources.
     **/
    public final void closeOnDestroy()
        throws omero.ServerError
    {
        closeOnDestroy(null);
    }

    /**
     * Allows looking up any stateful service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * createByName can be used even though no concrete
     * method is available.
     **/
    public final StatefulServiceInterfacePrx createByName(String name)
        throws omero.ServerError
    {
        return createByName(name, null);
    }

    public final ExporterPrx createExporter()
        throws omero.ServerError
    {
        return createExporter(null);
    }

    public final JobHandlePrx createJobHandle()
        throws omero.ServerError
    {
        return createJobHandle(null);
    }

    public final RawFileStorePrx createRawFileStore()
        throws omero.ServerError
    {
        return createRawFileStore(null);
    }

    public final RawPixelsStorePrx createRawPixelsStore()
        throws omero.ServerError
    {
        return createRawPixelsStore(null);
    }

    public final RenderingEnginePrx createRenderingEngine()
        throws omero.ServerError
    {
        return createRenderingEngine(null);
    }

    public final SearchPrx createSearchService()
        throws omero.ServerError
    {
        return createSearchService(null);
    }

    public final ThumbnailStorePrx createThumbnailStore()
        throws omero.ServerError
    {
        return createThumbnailStore(null);
    }

    /**
     * Marks the session for detachment rather than closure, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * This is the default and allows a lost session to be reconnected,
     * at a slight security cost since the session will persist longer
     * and can be used by others if the UUID is intercepted.
     **/
    public final void detachOnDestroy()
        throws omero.ServerError
    {
        detachOnDestroy(null);
    }

    public final IAdminPrx getAdminService()
        throws omero.ServerError
    {
        return getAdminService(null);
    }

    /**
     * Allows looking up any stateless service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * getByName can be used even though no concrete
     * method is available.
     **/
    public final ServiceInterfacePrx getByName(String name)
        throws omero.ServerError
    {
        return getByName(name, null);
    }

    public final IConfigPrx getConfigService()
        throws omero.ServerError
    {
        return getConfigService(null);
    }

    public final IContainerPrx getContainerService()
        throws omero.ServerError
    {
        return getContainerService(null);
    }

    public final ILdapPrx getLdapService()
        throws omero.ServerError
    {
        return getLdapService(null);
    }

    public final IMetadataPrx getMetadataService()
        throws omero.ServerError
    {
        return getMetadataService(null);
    }

    public final IPixelsPrx getPixelsService()
        throws omero.ServerError
    {
        return getPixelsService(null);
    }

    public final IProjectionPrx getProjectionService()
        throws omero.ServerError
    {
        return getProjectionService(null);
    }

    public final IQueryPrx getQueryService()
        throws omero.ServerError
    {
        return getQueryService(null);
    }

    public final IRenderingSettingsPrx getRenderingSettingsService()
        throws omero.ServerError
    {
        return getRenderingSettingsService(null);
    }

    public final IRepositoryInfoPrx getRepositoryInfoService()
        throws omero.ServerError
    {
        return getRepositoryInfoService(null);
    }

    public final IRoiPrx getRoiService()
        throws omero.ServerError
    {
        return getRoiService(null);
    }

    public final IScriptPrx getScriptService()
        throws omero.ServerError
    {
        return getScriptService(null);
    }

    /**
     * Provides a list of all valid security contexts for this session.
     * Each of the returned {@link omero.model.IObject} instances can
     * be passed to {@link #setSecurityContext}.
     **/
    public final java.util.List<omero.model.IObject> getSecurityContexts()
        throws omero.ServerError
    {
        return getSecurityContexts(null);
    }

    public final ISessionPrx getSessionService()
        throws omero.ServerError
    {
        return getSessionService(null);
    }

    public final ISharePrx getShareService()
        throws omero.ServerError
    {
        return getShareService(null);
    }

    public final ITimelinePrx getTimelineService()
        throws omero.ServerError
    {
        return getTimelineService(null);
    }

    public final ITypesPrx getTypesService()
        throws omero.ServerError
    {
        return getTypesService(null);
    }

    public final IUpdatePrx getUpdateService()
        throws omero.ServerError
    {
        return getUpdateService(null);
    }

    /**
     * Returns true if the given service is alive.
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     **/
    public final boolean keepAlive(ServiceInterfacePrx proxy)
        throws omero.ServerError
    {
        return keepAlive(proxy, null);
    }

    /**
     * Requests that the given services be marked as alive. It is
     * possible that one of the services has already timed out, in which
     * case the returned long value will be non-zero.
     * 
     * Specifically, the bit representing the 0-based index will be 1:
     * 
     * if (retval & 1&lt;&lt;idx == 1&lt;&lt;idx) { // not alive }
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     **/
    public final long keepAllAlive(ServiceInterfacePrx[] proxies)
        throws omero.ServerError
    {
        return keepAllAlive(proxies, null);
    }

    /**
     * Sets the single callback used by the ServiceFactory
     * to communicate with the client application. A default
     * callback is set by the omero::client object on
     * session creation which should suffice for most usage.
     * 
     * See the client object's documentation in each language
     * mapping for ways to use the callback.
     **/
    public final void setCallback(ClientCallbackPrx callback)
        throws omero.ServerError
    {
        setCallback(callback, null);
    }

    /**
     * Changes the security context for the current session.
     * 
     * <p> A security context limits the set of objects which will
     * be returned by all queries and restricts what updates
     * can be made. </p>
     * 
     * <p> Current valid values for security context:
     * <ul>
     * <li>{@link omero.model.ExperimenterGroup} - logs into a
     * specific group</li>
     * <li>{@link omero.model.Share} - uses IShare to activate a
     * share</li>
     * </ul> </p>
     * 
     * <p> Passing an unloaded version of either object type will change
     * the way the current session operates. Note: only objects which
     * are returned by the {@link #getSecurityContexts} method are
     * considered valid. Any other instance will cause an exception to
     * be thrown. </p>
     * 
     * <h4>Example usage in Python:<h4>
     * <pre>
     * sf = client.createSession()
     * objs = sf.getSecurityContexts()
     * old = sf.setSecurityContext(objs\[-1])
     * </pre>
     * 
     **/
    public final omero.model.IObject setSecurityContext(omero.model.IObject obj)
        throws omero.ServerError
    {
        return setSecurityContext(obj, null);
    }

    /**
     * Re-validates the password for the current session. This prevents
     * 
     * See methods that mention "HasPassword".
     **/
    public final void setSecurityPassword(String password)
        throws omero.ServerError
    {
        setSecurityPassword(password, null);
    }

    /**
     * Returns a reference to a back-end manager. The
     * {@link omero.grid.SharedResources} service provides look ups
     * for various facilities offered by OMERO:
     * <ul>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/scripts/">OMERO.scripts</a>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/Tables.html">OMERO.tables</a>
     * </ul>
     * These facilities may or may not be available on first request.
     * 
     * @see omero.grid.SharedResources
     **/
    public final omero.grid.SharedResourcesPrx sharedResources()
        throws omero.ServerError
    {
        return sharedResources(null);
    }

    /**
     * Subscribe to a given topic. The topic must exist and the user must
     * have sufficient permissions for that topic. Further the proxy object
     * must match the required type for the topic as encoded in the topic
     * name.
     **/
    public final void subscribe(String topicName, Ice.ObjectPrx prx)
        throws omero.ServerError
    {
        subscribe(topicName, prx, null);
    }

    public final void submit_async(omero.cmd.AMD_Session_submit __cb, omero.cmd.Request req)
    {
        submit_async(__cb, req, null);
    }

    public static Ice.DispatchStatus ___getSecurityContexts(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            java.util.List<omero.model.IObject> __ret = __obj.getSecurityContexts(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            IObjectListHelper.write(__os, __ret);
            __os.writePendingObjects();
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___setSecurityContext(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.IObjectHolder obj = new omero.model.IObjectHolder();
        __is.readObject(obj);
        __is.readPendingObjects();
        __inS.endReadParams();
        try
        {
            omero.model.IObject __ret = __obj.setSecurityContext(obj.value, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(__ret);
            __os.writePendingObjects();
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___setSecurityPassword(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String password;
        password = __is.readString();
        __inS.endReadParams();
        try
        {
            __obj.setSecurityPassword(password, __current);
            __inS.__writeEmptyParams();
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getAdminService(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            IAdminPrx __ret = __obj.getAdminService(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            IAdminPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getConfigService(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            IConfigPrx __ret = __obj.getConfigService(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            IConfigPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getContainerService(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            IContainerPrx __ret = __obj.getContainerService(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            IContainerPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getLdapService(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            ILdapPrx __ret = __obj.getLdapService(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            ILdapPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getPixelsService(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            IPixelsPrx __ret = __obj.getPixelsService(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            IPixelsPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getProjectionService(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            IProjectionPrx __ret = __obj.getProjectionService(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            IProjectionPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getQueryService(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            IQueryPrx __ret = __obj.getQueryService(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            IQueryPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getRenderingSettingsService(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            IRenderingSettingsPrx __ret = __obj.getRenderingSettingsService(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            IRenderingSettingsPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getRepositoryInfoService(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            IRepositoryInfoPrx __ret = __obj.getRepositoryInfoService(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            IRepositoryInfoPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getRoiService(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            IRoiPrx __ret = __obj.getRoiService(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            IRoiPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getScriptService(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            IScriptPrx __ret = __obj.getScriptService(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            IScriptPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getSessionService(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            ISessionPrx __ret = __obj.getSessionService(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            ISessionPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getShareService(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            ISharePrx __ret = __obj.getShareService(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            ISharePrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getTimelineService(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            ITimelinePrx __ret = __obj.getTimelineService(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            ITimelinePrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getTypesService(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            ITypesPrx __ret = __obj.getTypesService(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            ITypesPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getUpdateService(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            IUpdatePrx __ret = __obj.getUpdateService(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            IUpdatePrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getMetadataService(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            IMetadataPrx __ret = __obj.getMetadataService(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            IMetadataPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___createExporter(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            ExporterPrx __ret = __obj.createExporter(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            ExporterPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___createJobHandle(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            JobHandlePrx __ret = __obj.createJobHandle(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            JobHandlePrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___createRawFileStore(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            RawFileStorePrx __ret = __obj.createRawFileStore(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            RawFileStorePrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___createRawPixelsStore(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            RawPixelsStorePrx __ret = __obj.createRawPixelsStore(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            RawPixelsStorePrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___createRenderingEngine(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            RenderingEnginePrx __ret = __obj.createRenderingEngine(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            RenderingEnginePrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___createSearchService(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            SearchPrx __ret = __obj.createSearchService(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            SearchPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___createThumbnailStore(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            ThumbnailStorePrx __ret = __obj.createThumbnailStore(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            ThumbnailStorePrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___sharedResources(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            omero.grid.SharedResourcesPrx __ret = __obj.sharedResources(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.grid.SharedResourcesPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getByName(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String name;
        name = __is.readString();
        __inS.endReadParams();
        try
        {
            ServiceInterfacePrx __ret = __obj.getByName(name, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            ServiceInterfacePrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___createByName(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String name;
        name = __is.readString();
        __inS.endReadParams();
        try
        {
            StatefulServiceInterfacePrx __ret = __obj.createByName(name, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            StatefulServiceInterfacePrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___subscribe(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String topicName;
        Ice.ObjectPrx prx;
        topicName = __is.readString();
        prx = __is.readProxy();
        __inS.endReadParams();
        try
        {
            __obj.subscribe(topicName, prx, __current);
            __inS.__writeEmptyParams();
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___setCallback(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        ClientCallbackPrx callback;
        callback = ClientCallbackPrxHelper.__read(__is);
        __inS.endReadParams();
        try
        {
            __obj.setCallback(callback, __current);
            __inS.__writeEmptyParams();
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___closeOnDestroy(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            __obj.closeOnDestroy(__current);
            __inS.__writeEmptyParams();
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___detachOnDestroy(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            __obj.detachOnDestroy(__current);
            __inS.__writeEmptyParams();
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___activeServices(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            java.util.List<String> __ret = __obj.activeServices(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            StringSetHelper.write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___keepAllAlive(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        ServiceInterfacePrx[] proxies;
        proxies = ServiceListHelper.read(__is);
        __inS.endReadParams();
        try
        {
            long __ret = __obj.keepAllAlive(proxies, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(__ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___keepAlive(ServiceFactory __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        ServiceInterfacePrx proxy;
        proxy = ServiceInterfacePrxHelper.__read(__is);
        __inS.endReadParams();
        try
        {
            boolean __ret = __obj.keepAlive(proxy, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(__ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    private final static String[] __all =
    {
        "activeServices",
        "closeOnDestroy",
        "createByName",
        "createExporter",
        "createJobHandle",
        "createRawFileStore",
        "createRawPixelsStore",
        "createRenderingEngine",
        "createSearchService",
        "createThumbnailStore",
        "destroy",
        "detachOnDestroy",
        "getAdminService",
        "getByName",
        "getConfigService",
        "getContainerService",
        "getLdapService",
        "getMetadataService",
        "getPixelsService",
        "getProjectionService",
        "getQueryService",
        "getRenderingSettingsService",
        "getRepositoryInfoService",
        "getRoiService",
        "getScriptService",
        "getSecurityContexts",
        "getSessionService",
        "getShareService",
        "getTimelineService",
        "getTypesService",
        "getUpdateService",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "keepAlive",
        "keepAllAlive",
        "setCallback",
        "setSecurityContext",
        "setSecurityPassword",
        "sharedResources",
        "submit",
        "subscribe"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___activeServices(this, in, __current);
            }
            case 1:
            {
                return ___closeOnDestroy(this, in, __current);
            }
            case 2:
            {
                return ___createByName(this, in, __current);
            }
            case 3:
            {
                return ___createExporter(this, in, __current);
            }
            case 4:
            {
                return ___createJobHandle(this, in, __current);
            }
            case 5:
            {
                return ___createRawFileStore(this, in, __current);
            }
            case 6:
            {
                return ___createRawPixelsStore(this, in, __current);
            }
            case 7:
            {
                return ___createRenderingEngine(this, in, __current);
            }
            case 8:
            {
                return ___createSearchService(this, in, __current);
            }
            case 9:
            {
                return ___createThumbnailStore(this, in, __current);
            }
            case 10:
            {
                return Glacier2._SessionDisp.___destroy(this, in, __current);
            }
            case 11:
            {
                return ___detachOnDestroy(this, in, __current);
            }
            case 12:
            {
                return ___getAdminService(this, in, __current);
            }
            case 13:
            {
                return ___getByName(this, in, __current);
            }
            case 14:
            {
                return ___getConfigService(this, in, __current);
            }
            case 15:
            {
                return ___getContainerService(this, in, __current);
            }
            case 16:
            {
                return ___getLdapService(this, in, __current);
            }
            case 17:
            {
                return ___getMetadataService(this, in, __current);
            }
            case 18:
            {
                return ___getPixelsService(this, in, __current);
            }
            case 19:
            {
                return ___getProjectionService(this, in, __current);
            }
            case 20:
            {
                return ___getQueryService(this, in, __current);
            }
            case 21:
            {
                return ___getRenderingSettingsService(this, in, __current);
            }
            case 22:
            {
                return ___getRepositoryInfoService(this, in, __current);
            }
            case 23:
            {
                return ___getRoiService(this, in, __current);
            }
            case 24:
            {
                return ___getScriptService(this, in, __current);
            }
            case 25:
            {
                return ___getSecurityContexts(this, in, __current);
            }
            case 26:
            {
                return ___getSessionService(this, in, __current);
            }
            case 27:
            {
                return ___getShareService(this, in, __current);
            }
            case 28:
            {
                return ___getTimelineService(this, in, __current);
            }
            case 29:
            {
                return ___getTypesService(this, in, __current);
            }
            case 30:
            {
                return ___getUpdateService(this, in, __current);
            }
            case 31:
            {
                return ___ice_id(this, in, __current);
            }
            case 32:
            {
                return ___ice_ids(this, in, __current);
            }
            case 33:
            {
                return ___ice_isA(this, in, __current);
            }
            case 34:
            {
                return ___ice_ping(this, in, __current);
            }
            case 35:
            {
                return ___keepAlive(this, in, __current);
            }
            case 36:
            {
                return ___keepAllAlive(this, in, __current);
            }
            case 37:
            {
                return ___setCallback(this, in, __current);
            }
            case 38:
            {
                return ___setSecurityContext(this, in, __current);
            }
            case 39:
            {
                return ___setSecurityPassword(this, in, __current);
            }
            case 40:
            {
                return ___sharedResources(this, in, __current);
            }
            case 41:
            {
                return omero.cmd._SessionDisp.___submit(this, in, __current);
            }
            case 42:
            {
                return ___subscribe(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
