// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `API.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Starting point for all OMERO.blitz interaction.
 * 
 * <p> A ServiceFactory once acquired can be used to create any number
 * of service proxies to the server. Most services implement
 * {@link ServiceInterface} or its subinterface
 * {@link StatefulServiceInterface}. </p>
 **/
public interface _ServiceFactoryOperations extends omero.cmd._SessionOperations
{
    /**
     * Provides a list of all valid security contexts for this session.
     * Each of the returned {@link omero.model.IObject} instances can
     * be passed to {@link #setSecurityContext}.
     * @param __current The Current object for the invocation.
     **/
    java.util.List<omero.model.IObject> getSecurityContexts(Ice.Current __current)
        throws omero.ServerError;

    /**
     * Changes the security context for the current session.
     * 
     * <p> A security context limits the set of objects which will
     * be returned by all queries and restricts what updates
     * can be made. </p>
     * 
     * <p> Current valid values for security context:
     * <ul>
     * <li>{@link omero.model.ExperimenterGroup} - logs into a
     * specific group</li>
     * <li>{@link omero.model.Share} - uses IShare to activate a
     * share</li>
     * </ul> </p>
     * 
     * <p> Passing an unloaded version of either object type will change
     * the way the current session operates. Note: only objects which
     * are returned by the {@link #getSecurityContexts} method are
     * considered valid. Any other instance will cause an exception to
     * be thrown. </p>
     * 
     * <h4>Example usage in Python:<h4>
     * <pre>
     * sf = client.createSession()
     * objs = sf.getSecurityContexts()
     * old = sf.setSecurityContext(objs\[-1])
     * </pre>
     * 
     * @param __current The Current object for the invocation.
     **/
    omero.model.IObject setSecurityContext(omero.model.IObject obj, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Re-validates the password for the current session. This prevents
     * 
     * See methods that mention "HasPassword".
     * @param __current The Current object for the invocation.
     **/
    void setSecurityPassword(String password, Ice.Current __current)
        throws omero.ServerError;

    IAdminPrx getAdminService(Ice.Current __current)
        throws omero.ServerError;

    IConfigPrx getConfigService(Ice.Current __current)
        throws omero.ServerError;

    IContainerPrx getContainerService(Ice.Current __current)
        throws omero.ServerError;

    ILdapPrx getLdapService(Ice.Current __current)
        throws omero.ServerError;

    IPixelsPrx getPixelsService(Ice.Current __current)
        throws omero.ServerError;

    IProjectionPrx getProjectionService(Ice.Current __current)
        throws omero.ServerError;

    IQueryPrx getQueryService(Ice.Current __current)
        throws omero.ServerError;

    IRenderingSettingsPrx getRenderingSettingsService(Ice.Current __current)
        throws omero.ServerError;

    IRepositoryInfoPrx getRepositoryInfoService(Ice.Current __current)
        throws omero.ServerError;

    IRoiPrx getRoiService(Ice.Current __current)
        throws omero.ServerError;

    IScriptPrx getScriptService(Ice.Current __current)
        throws omero.ServerError;

    ISessionPrx getSessionService(Ice.Current __current)
        throws omero.ServerError;

    ISharePrx getShareService(Ice.Current __current)
        throws omero.ServerError;

    ITimelinePrx getTimelineService(Ice.Current __current)
        throws omero.ServerError;

    ITypesPrx getTypesService(Ice.Current __current)
        throws omero.ServerError;

    IUpdatePrx getUpdateService(Ice.Current __current)
        throws omero.ServerError;

    IMetadataPrx getMetadataService(Ice.Current __current)
        throws omero.ServerError;

    ExporterPrx createExporter(Ice.Current __current)
        throws omero.ServerError;

    JobHandlePrx createJobHandle(Ice.Current __current)
        throws omero.ServerError;

    RawFileStorePrx createRawFileStore(Ice.Current __current)
        throws omero.ServerError;

    RawPixelsStorePrx createRawPixelsStore(Ice.Current __current)
        throws omero.ServerError;

    RenderingEnginePrx createRenderingEngine(Ice.Current __current)
        throws omero.ServerError;

    SearchPrx createSearchService(Ice.Current __current)
        throws omero.ServerError;

    ThumbnailStorePrx createThumbnailStore(Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns a reference to a back-end manager. The
     * {@link omero.grid.SharedResources} service provides look ups
     * for various facilities offered by OMERO:
     * <ul>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/scripts/">OMERO.scripts</a>
     * <li><a href="http://www.openmicroscopy.org/site/support/omero5.2/developers/Tables.html">OMERO.tables</a>
     * </ul>
     * These facilities may or may not be available on first request.
     * 
     * @see omero.grid.SharedResources
     * @param __current The Current object for the invocation.
     **/
    omero.grid.SharedResourcesPrx sharedResources(Ice.Current __current)
        throws omero.ServerError;

    /**
     * Allows looking up any stateless service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * getByName can be used even though no concrete
     * method is available.
     * @param __current The Current object for the invocation.
     **/
    ServiceInterfacePrx getByName(String name, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Allows looking up any stateful service by name.
     * 
     * See Constants.ice for examples of services.
     * If a service has been added by third-parties,
     * createByName can be used even though no concrete
     * method is available.
     * @param __current The Current object for the invocation.
     **/
    StatefulServiceInterfacePrx createByName(String name, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Subscribe to a given topic. The topic must exist and the user must
     * have sufficient permissions for that topic. Further the proxy object
     * must match the required type for the topic as encoded in the topic
     * name.
     * @param __current The Current object for the invocation.
     **/
    void subscribe(String topicName, Ice.ObjectPrx prx, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Sets the single callback used by the ServiceFactory
     * to communicate with the client application. A default
     * callback is set by the omero::client object on
     * session creation which should suffice for most usage.
     * 
     * See the client object's documentation in each language
     * mapping for ways to use the callback.
     * @param __current The Current object for the invocation.
     **/
    void setCallback(ClientCallbackPrx callback, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Marks the session for closure rather than detachment, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * Closing the session rather the detaching is more secure, since all
     * resources are removed from the server and can safely be set once
     * it is clear that a client is finished with those resources.
     * @param __current The Current object for the invocation.
     **/
    void closeOnDestroy(Ice.Current __current)
        throws omero.ServerError;

    /**
     * Marks the session for detachment rather than closure, which will
     * be triggered by the destruction of the Glacier2 connection via
     * router.destroySession()
     * 
     * This is the default and allows a lost session to be reconnected,
     * at a slight security cost since the session will persist longer
     * and can be used by others if the UUID is intercepted.
     * @param __current The Current object for the invocation.
     **/
    void detachOnDestroy(Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns a list of string ids for currently active services. This will
     * _not_ keep services alive, and in fact checks for all expired services
     * and removes them.
     * @param __current The Current object for the invocation.
     **/
    java.util.List<String> activeServices(Ice.Current __current)
        throws omero.ServerError;

    /**
     * Requests that the given services be marked as alive. It is
     * possible that one of the services has already timed out, in which
     * case the returned long value will be non-zero.
     * 
     * Specifically, the bit representing the 0-based index will be 1:
     * 
     * if (retval & 1&lt;&lt;idx == 1&lt;&lt;idx) { // not alive }
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     * @param __current The Current object for the invocation.
     **/
    long keepAllAlive(ServiceInterfacePrx[] proxies, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns true if the given service is alive.
     * 
     * Except for fatal server or session errors, this method should never
     * throw an exception.
     * @param __current The Current object for the invocation.
     **/
    boolean keepAlive(ServiceInterfacePrx proxy, Ice.Current __current)
        throws omero.ServerError;
}
