// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `ServicesF.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Service marker for stateful services which permits the closing
 * of a particular service before the destruction of the session.
 **/
public interface _StatefulServiceInterfaceOperations extends _ServiceInterfaceOperations
{
    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void passivate_async(AMD_StatefulServiceInterface_passivate __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void activate_async(AMD_StatefulServiceInterface_activate __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void close_async(AMD_StatefulServiceInterface_close __cb, Ice.Current __current)
        throws omero.ServerError;

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __current The Current object for the invocation.
     **/
    void getCurrentEventContext_async(AMD_StatefulServiceInterface_getCurrentEventContext __cb, Ice.Current __current)
        throws omero.ServerError;
}
