// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `ThumbnailStore.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides methods for dealing with thumbnails. Provision is provided
 * to retrieve thumbnails using the on-disk cache (provided by
 * <i>ROMIO</i>) or on the fly.
 * <p>
 * NOTE: The calling order for the service is as follows:
 * <ol>
 * <li>{@link #setPixelsId}</li>
 * <li>any of the thumbnail accessor methods or
 * {@link #resetDefaults}</li>
 * </ol>
 * </p>
 **/
public abstract class _ThumbnailStoreDisp extends Ice.ObjectImpl implements ThumbnailStore
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::ServiceInterface",
        "::omero::api::StatefulServiceInterface",
        "::omero::api::ThumbnailStore"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[3];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[3];
    }

    public static String ice_staticId()
    {
        return __ids[3];
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public final void activate_async(AMD_StatefulServiceInterface_activate __cb)
        throws omero.ServerError
    {
        activate_async(__cb, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public final void close_async(AMD_StatefulServiceInterface_close __cb)
        throws omero.ServerError
    {
        close_async(__cb, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public final void getCurrentEventContext_async(AMD_StatefulServiceInterface_getCurrentEventContext __cb)
        throws omero.ServerError
    {
        getCurrentEventContext_async(__cb, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public final void passivate_async(AMD_StatefulServiceInterface_passivate __cb)
        throws omero.ServerError
    {
        passivate_async(__cb, null);
    }

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public final void createThumbnail_async(AMD_ThumbnailStore_createThumbnail __cb, omero.RInt sizeX, omero.RInt sizeY)
        throws omero.ServerError
    {
        createThumbnail_async(__cb, sizeX, sizeY, null);
    }

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @param __cb The callback object for the operation.
     **/
    public final void createThumbnails_async(AMD_ThumbnailStore_createThumbnails __cb)
        throws omero.ServerError
    {
        createThumbnails_async(__cb, null);
    }

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     **/
    public final void createThumbnailsByLongestSideSet_async(AMD_ThumbnailStore_createThumbnailsByLongestSideSet __cb, omero.RInt size, java.util.List<Long> pixelsIds)
        throws omero.ServerError
    {
        createThumbnailsByLongestSideSet_async(__cb, size, pixelsIds, null);
    }

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __cb The callback object for the operation.
     **/
    public final void getRenderingDefId_async(AMD_ThumbnailStore_getRenderingDefId __cb)
        throws omero.ServerError
    {
        getRenderingDefId_async(__cb, null);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public final void getThumbnail_async(AMD_ThumbnailStore_getThumbnail __cb, omero.RInt sizeX, omero.RInt sizeY)
        throws omero.ServerError
    {
        getThumbnail_async(__cb, sizeX, sizeY, null);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     **/
    public final void getThumbnailByLongestSide_async(AMD_ThumbnailStore_getThumbnailByLongestSide __cb, omero.RInt size)
        throws omero.ServerError
    {
        getThumbnailByLongestSide_async(__cb, size, null);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     **/
    public final void getThumbnailByLongestSideDirect_async(AMD_ThumbnailStore_getThumbnailByLongestSideDirect __cb, omero.RInt size)
        throws omero.ServerError
    {
        getThumbnailByLongestSideDirect_async(__cb, size, null);
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     **/
    public final void getThumbnailByLongestSideSet_async(AMD_ThumbnailStore_getThumbnailByLongestSideSet __cb, omero.RInt size, java.util.List<Long> pixelsIds)
        throws omero.ServerError
    {
        getThumbnailByLongestSideSet_async(__cb, size, pixelsIds, null);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public final void getThumbnailDirect_async(AMD_ThumbnailStore_getThumbnailDirect __cb, omero.RInt sizeX, omero.RInt sizeY)
        throws omero.ServerError
    {
        getThumbnailDirect_async(__cb, sizeX, sizeY, null);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     **/
    public final void getThumbnailForSectionByLongestSideDirect_async(AMD_ThumbnailStore_getThumbnailForSectionByLongestSideDirect __cb, int theZ, int theT, omero.RInt size)
        throws omero.ServerError
    {
        getThumbnailForSectionByLongestSideDirect_async(__cb, theZ, theT, size, null);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public final void getThumbnailForSectionDirect_async(AMD_ThumbnailStore_getThumbnailForSectionDirect __cb, int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY)
        throws omero.ServerError
    {
        getThumbnailForSectionDirect_async(__cb, theZ, theT, sizeX, sizeY, null);
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     **/
    public final void getThumbnailSet_async(AMD_ThumbnailStore_getThumbnailSet __cb, omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds)
        throws omero.ServerError
    {
        getThumbnailSet_async(__cb, sizeX, sizeY, pixelsIds, null);
    }

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __cb The callback object for the operation.
     **/
    public final void isInProgress_async(AMD_ThumbnailStore_isInProgress __cb)
        throws omero.ServerError
    {
        isInProgress_async(__cb, null);
    }

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __cb The callback object for the operation.
     **/
    public final void resetDefaults_async(AMD_ThumbnailStore_resetDefaults __cb)
        throws omero.ServerError
    {
        resetDefaults_async(__cb, null);
    }

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId an {@link omero.model.Pixels} id.
     **/
    public final void setPixelsId_async(AMD_ThumbnailStore_setPixelsId __cb, long pixelsId)
        throws omero.ServerError
    {
        setPixelsId_async(__cb, pixelsId, null);
    }

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     **/
    public final void setRenderingDefId_async(AMD_ThumbnailStore_setRenderingDefId __cb, long renderingDefId)
        throws omero.ServerError
    {
        setRenderingDefId_async(__cb, renderingDefId, null);
    }

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public final void thumbnailExists_async(AMD_ThumbnailStore_thumbnailExists __cb, omero.RInt sizeX, omero.RInt sizeY)
        throws omero.ServerError
    {
        thumbnailExists_async(__cb, sizeX, sizeY, null);
    }

    public static Ice.DispatchStatus ___setPixelsId(ThumbnailStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long pixelsId;
        pixelsId = __is.readLong();
        __inS.endReadParams();
        AMD_ThumbnailStore_setPixelsId __cb = new _AMD_ThumbnailStore_setPixelsId(__inS);
        try
        {
            __obj.setPixelsId_async(__cb, pixelsId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___isInProgress(ThumbnailStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_ThumbnailStore_isInProgress __cb = new _AMD_ThumbnailStore_isInProgress(__inS);
        try
        {
            __obj.isInProgress_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___setRenderingDefId(ThumbnailStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long renderingDefId;
        renderingDefId = __is.readLong();
        __inS.endReadParams();
        AMD_ThumbnailStore_setRenderingDefId __cb = new _AMD_ThumbnailStore_setRenderingDefId(__inS);
        try
        {
            __obj.setRenderingDefId_async(__cb, renderingDefId, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getRenderingDefId(ThumbnailStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_ThumbnailStore_getRenderingDefId __cb = new _AMD_ThumbnailStore_getRenderingDefId(__inS);
        try
        {
            __obj.getRenderingDefId_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getThumbnail(ThumbnailStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.RIntHolder sizeX = new omero.RIntHolder();
        omero.RIntHolder sizeY = new omero.RIntHolder();
        __is.readObject(sizeX);
        __is.readObject(sizeY);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_ThumbnailStore_getThumbnail __cb = new _AMD_ThumbnailStore_getThumbnail(__inS);
        try
        {
            __obj.getThumbnail_async(__cb, sizeX.value, sizeY.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getThumbnailSet(ThumbnailStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.RIntHolder sizeX = new omero.RIntHolder();
        omero.RIntHolder sizeY = new omero.RIntHolder();
        java.util.List<Long> pixelsIds;
        __is.readObject(sizeX);
        __is.readObject(sizeY);
        pixelsIds = omero.sys.LongListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_ThumbnailStore_getThumbnailSet __cb = new _AMD_ThumbnailStore_getThumbnailSet(__inS);
        try
        {
            __obj.getThumbnailSet_async(__cb, sizeX.value, sizeY.value, pixelsIds, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getThumbnailByLongestSideSet(ThumbnailStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.RIntHolder size = new omero.RIntHolder();
        java.util.List<Long> pixelsIds;
        __is.readObject(size);
        pixelsIds = omero.sys.LongListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_ThumbnailStore_getThumbnailByLongestSideSet __cb = new _AMD_ThumbnailStore_getThumbnailByLongestSideSet(__inS);
        try
        {
            __obj.getThumbnailByLongestSideSet_async(__cb, size.value, pixelsIds, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getThumbnailByLongestSide(ThumbnailStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.RIntHolder size = new omero.RIntHolder();
        __is.readObject(size);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_ThumbnailStore_getThumbnailByLongestSide __cb = new _AMD_ThumbnailStore_getThumbnailByLongestSide(__inS);
        try
        {
            __obj.getThumbnailByLongestSide_async(__cb, size.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getThumbnailByLongestSideDirect(ThumbnailStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.RIntHolder size = new omero.RIntHolder();
        __is.readObject(size);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_ThumbnailStore_getThumbnailByLongestSideDirect __cb = new _AMD_ThumbnailStore_getThumbnailByLongestSideDirect(__inS);
        try
        {
            __obj.getThumbnailByLongestSideDirect_async(__cb, size.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getThumbnailDirect(ThumbnailStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.RIntHolder sizeX = new omero.RIntHolder();
        omero.RIntHolder sizeY = new omero.RIntHolder();
        __is.readObject(sizeX);
        __is.readObject(sizeY);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_ThumbnailStore_getThumbnailDirect __cb = new _AMD_ThumbnailStore_getThumbnailDirect(__inS);
        try
        {
            __obj.getThumbnailDirect_async(__cb, sizeX.value, sizeY.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getThumbnailForSectionDirect(ThumbnailStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int theZ;
        int theT;
        omero.RIntHolder sizeX = new omero.RIntHolder();
        omero.RIntHolder sizeY = new omero.RIntHolder();
        theZ = __is.readInt();
        theT = __is.readInt();
        __is.readObject(sizeX);
        __is.readObject(sizeY);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_ThumbnailStore_getThumbnailForSectionDirect __cb = new _AMD_ThumbnailStore_getThumbnailForSectionDirect(__inS);
        try
        {
            __obj.getThumbnailForSectionDirect_async(__cb, theZ, theT, sizeX.value, sizeY.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___getThumbnailForSectionByLongestSideDirect(ThumbnailStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int theZ;
        int theT;
        omero.RIntHolder size = new omero.RIntHolder();
        theZ = __is.readInt();
        theT = __is.readInt();
        __is.readObject(size);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_ThumbnailStore_getThumbnailForSectionByLongestSideDirect __cb = new _AMD_ThumbnailStore_getThumbnailForSectionByLongestSideDirect(__inS);
        try
        {
            __obj.getThumbnailForSectionByLongestSideDirect_async(__cb, theZ, theT, size.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___createThumbnails(ThumbnailStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        AMD_ThumbnailStore_createThumbnails __cb = new _AMD_ThumbnailStore_createThumbnails(__inS);
        try
        {
            __obj.createThumbnails_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___createThumbnail(ThumbnailStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.RIntHolder sizeX = new omero.RIntHolder();
        omero.RIntHolder sizeY = new omero.RIntHolder();
        __is.readObject(sizeX);
        __is.readObject(sizeY);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_ThumbnailStore_createThumbnail __cb = new _AMD_ThumbnailStore_createThumbnail(__inS);
        try
        {
            __obj.createThumbnail_async(__cb, sizeX.value, sizeY.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___createThumbnailsByLongestSideSet(ThumbnailStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.RIntHolder size = new omero.RIntHolder();
        java.util.List<Long> pixelsIds;
        __is.readObject(size);
        pixelsIds = omero.sys.LongListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_ThumbnailStore_createThumbnailsByLongestSideSet __cb = new _AMD_ThumbnailStore_createThumbnailsByLongestSideSet(__inS);
        try
        {
            __obj.createThumbnailsByLongestSideSet_async(__cb, size.value, pixelsIds, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___thumbnailExists(ThumbnailStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.RIntHolder sizeX = new omero.RIntHolder();
        omero.RIntHolder sizeY = new omero.RIntHolder();
        __is.readObject(sizeX);
        __is.readObject(sizeY);
        __is.readPendingObjects();
        __inS.endReadParams();
        AMD_ThumbnailStore_thumbnailExists __cb = new _AMD_ThumbnailStore_thumbnailExists(__inS);
        try
        {
            __obj.thumbnailExists_async(__cb, sizeX.value, sizeY.value, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    public static Ice.DispatchStatus ___resetDefaults(ThumbnailStore __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        AMD_ThumbnailStore_resetDefaults __cb = new _AMD_ThumbnailStore_resetDefaults(__inS);
        try
        {
            __obj.resetDefaults_async(__cb, __current);
        }
        catch(java.lang.Exception ex)
        {
            __cb.ice_exception(ex);
        }
        return Ice.DispatchStatus.DispatchAsync;
    }

    private final static String[] __all =
    {
        "activate",
        "close",
        "createThumbnail",
        "createThumbnails",
        "createThumbnailsByLongestSideSet",
        "getCurrentEventContext",
        "getRenderingDefId",
        "getThumbnail",
        "getThumbnailByLongestSide",
        "getThumbnailByLongestSideDirect",
        "getThumbnailByLongestSideSet",
        "getThumbnailDirect",
        "getThumbnailForSectionByLongestSideDirect",
        "getThumbnailForSectionDirect",
        "getThumbnailSet",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "isInProgress",
        "passivate",
        "resetDefaults",
        "setPixelsId",
        "setRenderingDefId",
        "thumbnailExists"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return _StatefulServiceInterfaceDisp.___activate(this, in, __current);
            }
            case 1:
            {
                return _StatefulServiceInterfaceDisp.___close(this, in, __current);
            }
            case 2:
            {
                return ___createThumbnail(this, in, __current);
            }
            case 3:
            {
                return ___createThumbnails(this, in, __current);
            }
            case 4:
            {
                return ___createThumbnailsByLongestSideSet(this, in, __current);
            }
            case 5:
            {
                return _StatefulServiceInterfaceDisp.___getCurrentEventContext(this, in, __current);
            }
            case 6:
            {
                return ___getRenderingDefId(this, in, __current);
            }
            case 7:
            {
                return ___getThumbnail(this, in, __current);
            }
            case 8:
            {
                return ___getThumbnailByLongestSide(this, in, __current);
            }
            case 9:
            {
                return ___getThumbnailByLongestSideDirect(this, in, __current);
            }
            case 10:
            {
                return ___getThumbnailByLongestSideSet(this, in, __current);
            }
            case 11:
            {
                return ___getThumbnailDirect(this, in, __current);
            }
            case 12:
            {
                return ___getThumbnailForSectionByLongestSideDirect(this, in, __current);
            }
            case 13:
            {
                return ___getThumbnailForSectionDirect(this, in, __current);
            }
            case 14:
            {
                return ___getThumbnailSet(this, in, __current);
            }
            case 15:
            {
                return ___ice_id(this, in, __current);
            }
            case 16:
            {
                return ___ice_ids(this, in, __current);
            }
            case 17:
            {
                return ___ice_isA(this, in, __current);
            }
            case 18:
            {
                return ___ice_ping(this, in, __current);
            }
            case 19:
            {
                return ___isInProgress(this, in, __current);
            }
            case 20:
            {
                return _StatefulServiceInterfaceDisp.___passivate(this, in, __current);
            }
            case 21:
            {
                return ___resetDefaults(this, in, __current);
            }
            case 22:
            {
                return ___setPixelsId(this, in, __current);
            }
            case 23:
            {
                return ___setRenderingDefId(this, in, __current);
            }
            case 24:
            {
                return ___thumbnailExists(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
