// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `API.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.cmd;

public final class CmdCallbackPrxHelper extends Ice.ObjectPrxHelperBase implements CmdCallbackPrx
{
    private static final String __finished_name = "finished";

    /**
     * Called when the command has completed in any fashion
     * including cancellation. The {@link Status#flags} list will
     * contain information about whether or not the process
     * was cancelled.
     **/
    public void finished(Response rsp, Status s)
    {
        finished(rsp, s, null, false);
    }

    /**
     * Called when the command has completed in any fashion
     * including cancellation. The {@link Status#flags} list will
     * contain information about whether or not the process
     * was cancelled.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void finished(Response rsp, Status s, java.util.Map<String, String> __ctx)
    {
        finished(rsp, s, __ctx, true);
    }

    private void finished(Response rsp, Status s, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "finished", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _CmdCallbackDel __del = (_CmdCallbackDel)__delBase;
                    __del.finished(rsp, s, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Called when the command has completed in any fashion
     * including cancellation. The {@link Status#flags} list will
     * contain information about whether or not the process
     * was cancelled.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_finished(Response rsp, Status s)
    {
        return begin_finished(rsp, s, null, false, null);
    }

    /**
     * Called when the command has completed in any fashion
     * including cancellation. The {@link Status#flags} list will
     * contain information about whether or not the process
     * was cancelled.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_finished(Response rsp, Status s, java.util.Map<String, String> __ctx)
    {
        return begin_finished(rsp, s, __ctx, true, null);
    }

    /**
     * Called when the command has completed in any fashion
     * including cancellation. The {@link Status#flags} list will
     * contain information about whether or not the process
     * was cancelled.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_finished(Response rsp, Status s, Ice.Callback __cb)
    {
        return begin_finished(rsp, s, null, false, __cb);
    }

    /**
     * Called when the command has completed in any fashion
     * including cancellation. The {@link Status#flags} list will
     * contain information about whether or not the process
     * was cancelled.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_finished(Response rsp, Status s, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_finished(rsp, s, __ctx, true, __cb);
    }

    /**
     * Called when the command has completed in any fashion
     * including cancellation. The {@link Status#flags} list will
     * contain information about whether or not the process
     * was cancelled.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_finished(Response rsp, Status s, Callback_CmdCallback_finished __cb)
    {
        return begin_finished(rsp, s, null, false, __cb);
    }

    /**
     * Called when the command has completed in any fashion
     * including cancellation. The {@link Status#flags} list will
     * contain information about whether or not the process
     * was cancelled.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_finished(Response rsp, Status s, java.util.Map<String, String> __ctx, Callback_CmdCallback_finished __cb)
    {
        return begin_finished(rsp, s, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_finished(Response rsp, Status s, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __finished_name, __cb);
        try
        {
            __result.__prepare(__finished_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(rsp);
            __os.writeObject(s);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_finished(Ice.AsyncResult __result)
    {
        __end(__result, __finished_name);
    }

    private static final String __step_name = "step";

    /**
     * Notifies clients that the given number of steps
     * from the total is complete. This method will not
     * necessarily be called for every step.
     **/
    public void step(int complete, int total)
    {
        step(complete, total, null, false);
    }

    /**
     * Notifies clients that the given number of steps
     * from the total is complete. This method will not
     * necessarily be called for every step.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void step(int complete, int total, java.util.Map<String, String> __ctx)
    {
        step(complete, total, __ctx, true);
    }

    private void step(int complete, int total, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "step", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _CmdCallbackDel __del = (_CmdCallbackDel)__delBase;
                    __del.step(complete, total, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Notifies clients that the given number of steps
     * from the total is complete. This method will not
     * necessarily be called for every step.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_step(int complete, int total)
    {
        return begin_step(complete, total, null, false, null);
    }

    /**
     * Notifies clients that the given number of steps
     * from the total is complete. This method will not
     * necessarily be called for every step.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_step(int complete, int total, java.util.Map<String, String> __ctx)
    {
        return begin_step(complete, total, __ctx, true, null);
    }

    /**
     * Notifies clients that the given number of steps
     * from the total is complete. This method will not
     * necessarily be called for every step.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_step(int complete, int total, Ice.Callback __cb)
    {
        return begin_step(complete, total, null, false, __cb);
    }

    /**
     * Notifies clients that the given number of steps
     * from the total is complete. This method will not
     * necessarily be called for every step.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_step(int complete, int total, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_step(complete, total, __ctx, true, __cb);
    }

    /**
     * Notifies clients that the given number of steps
     * from the total is complete. This method will not
     * necessarily be called for every step.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_step(int complete, int total, Callback_CmdCallback_step __cb)
    {
        return begin_step(complete, total, null, false, __cb);
    }

    /**
     * Notifies clients that the given number of steps
     * from the total is complete. This method will not
     * necessarily be called for every step.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_step(int complete, int total, java.util.Map<String, String> __ctx, Callback_CmdCallback_step __cb)
    {
        return begin_step(complete, total, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_step(int complete, int total, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __step_name, __cb);
        try
        {
            __result.__prepare(__step_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(complete);
            __os.writeInt(total);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_step(Ice.AsyncResult __result)
    {
        __end(__result, __step_name);
    }

    public static CmdCallbackPrx checkedCast(Ice.ObjectPrx __obj)
    {
        CmdCallbackPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof CmdCallbackPrx)
            {
                __d = (CmdCallbackPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    CmdCallbackPrxHelper __h = new CmdCallbackPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static CmdCallbackPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        CmdCallbackPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof CmdCallbackPrx)
            {
                __d = (CmdCallbackPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    CmdCallbackPrxHelper __h = new CmdCallbackPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static CmdCallbackPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        CmdCallbackPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    CmdCallbackPrxHelper __h = new CmdCallbackPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static CmdCallbackPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        CmdCallbackPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    CmdCallbackPrxHelper __h = new CmdCallbackPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static CmdCallbackPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        CmdCallbackPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof CmdCallbackPrx)
            {
                __d = (CmdCallbackPrx)__obj;
            }
            else
            {
                CmdCallbackPrxHelper __h = new CmdCallbackPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static CmdCallbackPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        CmdCallbackPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            CmdCallbackPrxHelper __h = new CmdCallbackPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::cmd::CmdCallback"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _CmdCallbackDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _CmdCallbackDelD();
    }

    public static void __write(IceInternal.BasicStream __os, CmdCallbackPrx v)
    {
        __os.writeProxy(v);
    }

    public static CmdCallbackPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            CmdCallbackPrxHelper result = new CmdCallbackPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
