// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `FS.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.cmd;

/**
 * Queries and modifies the various binary artifacts
 * which may be linked to an {@link omero.model.Image}.
 * 
 * This can be useful, e.g., after converting pre-OMERO-5
 * archived original files into {@link omero.model.Fileset}.
 * 
 * The command works in several stages:
 * 
 * 1. loads an {@link omero.model.Image} by id, failing if none
 * present.
 * 2. renames Pixels file to '*_bak'
 * 3. deletes existing Pyramidfiles if present;
 * 
 * This command can be run multiple times with different settings
 * to iteratively test if the migration is working.
 **/
public class ManageImageBinaries extends Request
{
    public ManageImageBinaries()
    {
        super();
    }

    public ManageImageBinaries(long imageId, boolean togglePixels, boolean deletePyramid)
    {
        this.imageId = imageId;
        this.togglePixels = togglePixels;
        this.deletePyramid = deletePyramid;
    }

    private static class __F implements Ice.ObjectFactory
    {
        public Ice.Object create(String type)
        {
            assert(type.equals(ice_staticId()));
            return new ManageImageBinaries();
        }

        public void destroy()
        {
        }
    }
    private static Ice.ObjectFactory _factory = new __F();

    public static Ice.ObjectFactory
    ice_factory()
    {
        return _factory;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::cmd::ManageImageBinaries",
        "::omero::cmd::Request"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, false);
        __os.writeLong(imageId);
        __os.writeBool(togglePixels);
        __os.writeBool(deletePyramid);
        __os.endWriteSlice();
        super.__writeImpl(__os);
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        imageId = __is.readLong();
        togglePixels = __is.readBool();
        deletePyramid = __is.readBool();
        __is.endReadSlice();
        super.__readImpl(__is);
    }

    public long imageId;

    public boolean togglePixels;

    public boolean deletePyramid;

    public static final long serialVersionUID = -2589991475559298808L;
}
