// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `FS.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.cmd;

/**
 * Successful response for {@link OriginalMetadataRequest}. Contains
 * both the global and the series metadata as maps. Only one
 * of {@link #filesetId} or {@link #filesetAnnotationId} will be set.
 * Pre-FS images will have {@link #filesetAnnotationId} set; otherwise
 * {@link #filesetId} will be set.
 **/
public class OriginalMetadataResponse extends Response
{
    public OriginalMetadataResponse()
    {
        super();
    }

    public OriginalMetadataResponse(omero.RLong filesetId, omero.RLong fileAnnotationId, java.util.Map<java.lang.String, omero.RType> globalMetadata, java.util.Map<java.lang.String, omero.RType> seriesMetadata)
    {
        this.filesetId = filesetId;
        this.fileAnnotationId = fileAnnotationId;
        this.globalMetadata = globalMetadata;
        this.seriesMetadata = seriesMetadata;
    }

    private static class __F implements Ice.ObjectFactory
    {
        public Ice.Object create(String type)
        {
            assert(type.equals(ice_staticId()));
            return new OriginalMetadataResponse();
        }

        public void destroy()
        {
        }
    }
    private static Ice.ObjectFactory _factory = new __F();

    public static Ice.ObjectFactory
    ice_factory()
    {
        return _factory;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::cmd::OriginalMetadataResponse",
        "::omero::cmd::Response"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, false);
        __os.writeObject(filesetId);
        __os.writeObject(fileAnnotationId);
        omero.RTypeDictHelper.write(__os, globalMetadata);
        omero.RTypeDictHelper.write(__os, seriesMetadata);
        __os.endWriteSlice();
        super.__writeImpl(__os);
    }

    private class Patcher implements IceInternal.Patcher
    {
        Patcher(int member)
        {
            __member = member;
        }

        public void
        patch(Ice.Object v)
        {
            switch(__member)
            {
            case 0:
                __typeId = "::omero::RLong";
                if(v == null || v instanceof omero.RLong)
                {
                    filesetId = (omero.RLong)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            case 1:
                __typeId = "::omero::RLong";
                if(v == null || v instanceof omero.RLong)
                {
                    fileAnnotationId = (omero.RLong)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            }
        }

        public String
        type()
        {
            return __typeId;
        }

        private int __member;
        private String __typeId;
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.readObject(new Patcher(0));
        __is.readObject(new Patcher(1));
        globalMetadata = omero.RTypeDictHelper.read(__is);
        seriesMetadata = omero.RTypeDictHelper.read(__is);
        __is.endReadSlice();
        super.__readImpl(__is);
    }

    /**
     * Set to the id of the {@link omero.model.Fileset} that this
     * {@link omero.model.Image} contained in if one exists.
     **/
    public omero.RLong filesetId;

    /**
     * Set to the id of the {@link omero.model.FilesetAnnotation}
     * linked to this {@link omero.model.Image} if one exists.
     **/
    public omero.RLong fileAnnotationId;

    /**
     * Metadata which applies to the entire
     * {@link omero.model.Fileset}
     **/
    public java.util.Map<java.lang.String, omero.RType> globalMetadata;

    /**
     * Metadata specific to the series id of this
     * {@link omero.model.Image}.
     * In the {@link omero.model.Fileset} that this
     * {@link omero.model.Image] is contained in, there may be a large
     * number of other images, but the series metadata applies only to
     * this specific one.
     **/
    public java.util.Map<java.lang.String, omero.RType> seriesMetadata;

    public static final long serialVersionUID = 2745496058229807120L;
}
