// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Mail.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.cmd;

/**
 * Requests an email to be send to all users of the omero
 * determines inactive users, an active members of given groups
 * and/or specific users.
 * 
 * examples:
 * - omero.cmd.SendEmailRequest(subject, body, everyone=True)
 * sends message to everyone who has email set
 * and is an active user
 * - omero.cmd.SendEmailRequest(subject, body, everyone=True, inactive=True)
 * sends message to everyone who has email set,
 * even inactive users
 * - omero.cmd.SendEmailRequest(subject, body, groupIds=\[...],
 * userIds=\[...] )
 * sends email to active members of given groups and selected users
 * - extra=\[...] allows to set extra email address if not in DB
 **/
public class SendEmailRequest extends Request
{
    public SendEmailRequest()
    {
        super();
    }

    public SendEmailRequest(String subject, String body, boolean html, java.util.List<Long> userIds, java.util.List<Long> groupIds, java.util.List<String> extra, boolean inactive, boolean everyone)
    {
        this.subject = subject;
        this.body = body;
        this.html = html;
        this.userIds = userIds;
        this.groupIds = groupIds;
        this.extra = extra;
        this.inactive = inactive;
        this.everyone = everyone;
    }

    private static class __F implements Ice.ObjectFactory
    {
        public Ice.Object create(String type)
        {
            assert(type.equals(ice_staticId()));
            return new SendEmailRequest();
        }

        public void destroy()
        {
        }
    }
    private static Ice.ObjectFactory _factory = new __F();

    public static Ice.ObjectFactory
    ice_factory()
    {
        return _factory;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::cmd::Request",
        "::omero::cmd::SendEmailRequest"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[2];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[2];
    }

    public static String ice_staticId()
    {
        return __ids[2];
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, false);
        __os.writeString(subject);
        __os.writeString(body);
        __os.writeBool(html);
        omero.sys.LongListHelper.write(__os, userIds);
        omero.sys.LongListHelper.write(__os, groupIds);
        omero.api.StringSetHelper.write(__os, extra);
        __os.writeBool(inactive);
        __os.writeBool(everyone);
        __os.endWriteSlice();
        super.__writeImpl(__os);
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        subject = __is.readString();
        body = __is.readString();
        html = __is.readBool();
        userIds = omero.sys.LongListHelper.read(__is);
        groupIds = omero.sys.LongListHelper.read(__is);
        extra = omero.api.StringSetHelper.read(__is);
        inactive = __is.readBool();
        everyone = __is.readBool();
        __is.endReadSlice();
        super.__readImpl(__is);
    }

    public String subject;

    public String body;

    public boolean html;

    public java.util.List<Long> userIds;

    public java.util.List<Long> groupIds;

    public java.util.List<String> extra;

    public boolean inactive;

    public boolean everyone;

    public static final long serialVersionUID = -7552608019366238602L;
}
