// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Graphs.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.cmd;

/**
 * Perform a request skipping the top-most model objects in the
 * graph. This permits operating upon the (possibly indirect)
 * children of given objects. The arguments of this SkipHead
 * request override those of the given request only until the
 * targeted children are reached, except that if this SkipHead
 * request's dryRun is set to true then the dryRun override
 * persists throughout the operation. The response from SkipHead
 * is as from the given request.
 **/
public class SkipHead extends GraphModify2
{
    public SkipHead()
    {
        super();
    }

    public SkipHead(java.util.Map<java.lang.String, java.util.List<Long>> targetObjects, java.util.List<omero.cmd.graphs.ChildOption> childOptions, boolean dryRun, java.util.List<String> startFrom, GraphModify2 request)
    {
        super(targetObjects, childOptions, dryRun);
        this.startFrom = startFrom;
        this.request = request;
    }

    private static class __F implements Ice.ObjectFactory
    {
        public Ice.Object create(String type)
        {
            assert(type.equals(ice_staticId()));
            return new SkipHead();
        }

        public void destroy()
        {
        }
    }
    private static Ice.ObjectFactory _factory = new __F();

    public static Ice.ObjectFactory
    ice_factory()
    {
        return _factory;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::cmd::GraphModify2",
        "::omero::cmd::GraphQuery",
        "::omero::cmd::Request",
        "::omero::cmd::SkipHead"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[4];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[4];
    }

    public static String ice_staticId()
    {
        return __ids[4];
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, false);
        omero.api.StringSetHelper.write(__os, startFrom);
        __os.writeObject(request);
        __os.endWriteSlice();
        super.__writeImpl(__os);
    }

    private class Patcher implements IceInternal.Patcher
    {
        public void
        patch(Ice.Object v)
        {
            if(v == null || v instanceof GraphModify2)
            {
                request = (GraphModify2)v;
            }
            else
            {
                IceInternal.Ex.throwUOE(type(), v);
            }
        }

        public String
        type()
        {
            return "::omero::cmd::GraphModify2";
        }
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        startFrom = omero.api.StringSetHelper.read(__is);
        __is.readObject(new Patcher());
        __is.endReadSlice();
        super.__readImpl(__is);
    }

    /**
     * Classes of model objects from which to actually start the
     * operation. These are children, directly or indirectly, of
     * the target objects. These children become the true target
     * objects of the underlying request.
     **/
    public java.util.List<String> startFrom;

    /**
     * The operation to perform on the targeted model objects.
     * The given request's targetObjects property is ignored: it
     * is the SkipHead request that specifies the parent objects.
     * Only specific request types are supported
     * (those implementing WrappableRequest).
     **/
    public GraphModify2 request;

    public static final long serialVersionUID = -78779856007764527L;
}
