// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Graphs.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.cmd.graphs;

/**
 * How GraphModify2 requests should deal with kinds of children,
 * related to the target objects.
 * By default, it is usual for only orphans to be operated on.
 * At least one of includeType or excludeType must be used;
 * if a type matches both, then it is included.
 * No more than one of includeNs and excludeNs may be used.
 **/
public class ChildOption extends Ice.ObjectImpl
{
    public ChildOption()
    {
    }

    public ChildOption(java.util.List<String> includeType, java.util.List<String> excludeType, java.util.List<String> includeNs, java.util.List<String> excludeNs)
    {
        this.includeType = includeType;
        this.excludeType = excludeType;
        this.includeNs = includeNs;
        this.excludeNs = excludeNs;
    }

    private static class __F implements Ice.ObjectFactory
    {
        public Ice.Object create(String type)
        {
            assert(type.equals(ice_staticId()));
            return new ChildOption();
        }

        public void destroy()
        {
        }
    }
    private static Ice.ObjectFactory _factory = new __F();

    public static Ice.ObjectFactory
    ice_factory()
    {
        return _factory;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::cmd::graphs::ChildOption"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        omero.api.StringSetHelper.write(__os, includeType);
        omero.api.StringSetHelper.write(__os, excludeType);
        omero.api.StringSetHelper.write(__os, includeNs);
        omero.api.StringSetHelper.write(__os, excludeNs);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        includeType = omero.api.StringSetHelper.read(__is);
        excludeType = omero.api.StringSetHelper.read(__is);
        includeNs = omero.api.StringSetHelper.read(__is);
        excludeNs = omero.api.StringSetHelper.read(__is);
        __is.endReadSlice();
    }

    /**
     * Include in the operation all children of these types.
     * Cf. use of HARD in GraphModify's options.
     **/
    public java.util.List<String> includeType;

    /**
     * Include in the operation no children of these types.
     * Cf. use of KEEP in GraphModify's options.
     **/
    public java.util.List<String> excludeType;

    /**
     * For annotations, limit the applicability of this option
     * to only those in these namespaces.
     **/
    public java.util.List<String> includeNs;

    /**
     * For annotations, limit the applicability of this option
     * to only those not in these namespaces.
     **/
    public java.util.List<String> excludeNs;

    public static final long serialVersionUID = -8134136139655871913L;
}
