// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Repositories.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Delete several individual paths. Internally, this converts
 * all of the paths into a single {@link omero.cmd.Delete2} command
 * and submits it.
 * 
 * If a ""recursively"" is true, then directories will be searched
 * and all of their contained files will be placed before them in
 * the delete order. When the directory is removed from the database,
 * it will removed from the filesystem if and only if it is empty.
 * 
 * If ""recursively"" is false, then the delete will produce an error
 * according to the ""force"" flag.
 * 
 * If ""force"" is false, this method attempts the delete of all given
 * paths in a single transaction, and any failure will cause the
 * entire transaction to fail.
 * 
 * If ""force"" is true, however, then all the other deletes will succeed.
 * which could possibly leave dangling files within no longer extant
 * directories.
 * 
 **/

public abstract class AMI_Repository_deletePaths extends Callback_Repository_deletePaths
{
    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public abstract void ice_response(omero.cmd.HandlePrx __ret);

    /**
     * ice_exception indicates to the caller that
     * the operation completed with an exception.
     * @param ex The Ice run-time exception to be raised.
     **/
    public abstract void ice_exception(Ice.LocalException ex);

    /**
     * ice_exception indicates to the caller that
     * the operation completed with an exception.
     * @param ex The user exception to be raised.
     **/
    public abstract void ice_exception(Ice.UserException ex);

    public final void response(omero.cmd.HandlePrx __ret)
    {
        ice_response(__ret);
    }

    public final void exception(Ice.UserException __ex)
    {
        ice_exception(__ex);
    }

    public final void exception(Ice.LocalException __ex)
    {
        ice_exception(__ex);
    }

    @Override public final void sent(boolean sentSynchronously)
    {
        if(!sentSynchronously && this instanceof Ice.AMISentCallback)
        {
            ((Ice.AMISentCallback)this).ice_sent();
        }
    }
}
