// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Repositories.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Returned by {@link ManagedRepository#importFileset} with
 * the information needed to proceed with an FS import.
 * For the examples that follow, assume that the used
 * files passed to importFileset were:
 * 
 * <pre>
 * /Users/jack/Documents/Data/Experiment-1/1.dv
 * /Users/jack/Documents/Data/Experiment-1/1.dv.log
 * /Users/jack/Documents/Data/Experiment-2/2.dv
 * /Users/jack/Documents/Data/Experiment-2/2.dv.log
 * </pre>
 * 
 **/
public class ImportLocation extends Ice.ObjectImpl
{
    public ImportLocation()
    {
    }

    public ImportLocation(String sharedPath, int omittedLevels, java.util.List<String> usedFiles, omero.model.OriginalFile directory)
    {
        this.sharedPath = sharedPath;
        this.omittedLevels = omittedLevels;
        this.usedFiles = usedFiles;
        this.directory = directory;
    }

    private static class __F implements Ice.ObjectFactory
    {
        public Ice.Object create(String type)
        {
            assert(type.equals(ice_staticId()));
            return new ImportLocation();
        }

        public void destroy()
        {
        }
    }
    private static Ice.ObjectFactory _factory = new __F();

    public static Ice.ObjectFactory
    ice_factory()
    {
        return _factory;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::ImportLocation"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.writeString(sharedPath);
        __os.writeInt(omittedLevels);
        omero.api.StringSetHelper.write(__os, usedFiles);
        __os.writeObject(directory);
        __os.endWriteSlice();
    }

    private class Patcher implements IceInternal.Patcher
    {
        public void
        patch(Ice.Object v)
        {
            if(v == null || v instanceof omero.model.OriginalFile)
            {
                directory = (omero.model.OriginalFile)v;
            }
            else
            {
                IceInternal.Ex.throwUOE(type(), v);
            }
        }

        public String
        type()
        {
            return "::omero::model::OriginalFile";
        }
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        sharedPath = __is.readString();
        omittedLevels = __is.readInt();
        usedFiles = omero.api.StringSetHelper.read(__is);
        __is.readObject(new Patcher());
        __is.endReadSlice();
    }

    /**
     * The shared base of all the paths passed to
     * the server.
     **/
    public String sharedPath;

    /**
     * Number of directories which have been omitted
     * from the original paths passed to the server.
     **/
    public int omittedLevels;

    /**
     * Parsed string names which should be used by the
     * clients during upload. This array will be of the
     * same length as the argument passed to
     * {@link ManagedRepository#importFileset} but will have
     * shortened paths.
     * 
     * <pre>
     * Experiment/1.dv
     * Experiment/1.dv.log
     * </pre>
     **/
    public java.util.List<String> usedFiles;

    /**
     * Represents the directory to which all files
     * will be uploaded.
     **/
    public omero.model.OriginalFile directory;

    public static final long serialVersionUID = -4397442247127850109L;
}
