// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Repositories.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Command object which will be used to create
 * the {@link omero.cmd.Handle} instances passed
 * back by the {@link ImportProcess}.
 **/
public class ImportRequest extends omero.cmd.Request
{
    public ImportRequest()
    {
        super();
    }

    public ImportRequest(String clientUuid, String repoUuid, ImportProcessPrx process, omero.model.FilesetJobLink activity, ImportSettings settings, ImportLocation location, omero.model.OriginalFile logFile)
    {
        this.clientUuid = clientUuid;
        this.repoUuid = repoUuid;
        this.process = process;
        this.activity = activity;
        this.settings = settings;
        this.location = location;
        this.logFile = logFile;
    }

    private static class __F implements Ice.ObjectFactory
    {
        public Ice.Object create(String type)
        {
            assert(type.equals(ice_staticId()));
            return new ImportRequest();
        }

        public void destroy()
        {
        }
    }
    private static Ice.ObjectFactory _factory = new __F();

    public static Ice.ObjectFactory
    ice_factory()
    {
        return _factory;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::cmd::Request",
        "::omero::grid::ImportRequest"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[2];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[2];
    }

    public static String ice_staticId()
    {
        return __ids[2];
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, false);
        __os.writeString(clientUuid);
        __os.writeString(repoUuid);
        ImportProcessPrxHelper.__write(__os, process);
        __os.writeObject(activity);
        __os.writeObject(settings);
        __os.writeObject(location);
        __os.writeObject(logFile);
        __os.endWriteSlice();
        super.__writeImpl(__os);
    }

    private class Patcher implements IceInternal.Patcher
    {
        Patcher(int member)
        {
            __member = member;
        }

        public void
        patch(Ice.Object v)
        {
            switch(__member)
            {
            case 0:
                __typeId = "::omero::model::FilesetJobLink";
                if(v == null || v instanceof omero.model.FilesetJobLink)
                {
                    activity = (omero.model.FilesetJobLink)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            case 1:
                __typeId = "::omero::grid::ImportSettings";
                if(v == null || v instanceof ImportSettings)
                {
                    settings = (ImportSettings)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            case 2:
                __typeId = "::omero::grid::ImportLocation";
                if(v == null || v instanceof ImportLocation)
                {
                    location = (ImportLocation)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            case 3:
                __typeId = "::omero::model::OriginalFile";
                if(v == null || v instanceof omero.model.OriginalFile)
                {
                    logFile = (omero.model.OriginalFile)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            }
        }

        public String
        type()
        {
            return __typeId;
        }

        private int __member;
        private String __typeId;
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        clientUuid = __is.readString();
        repoUuid = __is.readString();
        process = ImportProcessPrxHelper.__read(__is);
        __is.readObject(new Patcher(0));
        __is.readObject(new Patcher(1));
        __is.readObject(new Patcher(2));
        __is.readObject(new Patcher(3));
        __is.endReadSlice();
        super.__readImpl(__is);
    }

    /**
     * Lookup value for the session that import is taking
     * part in.
     **/
    public String clientUuid;

    /**
     * Repository which is responsible for this import.
     * All files which are uploaded will be available
     * from it.
     **/
    public String repoUuid;

    /**
     * Proxy of the process which this request
     * will be running in. This value will be
     * filled in for possible later re-use, but
     * is not read by the server.
     **/
    public ImportProcessPrx process;

    /**
     * Activity that this will be filling
     * out in the database. This always points to a
     * {@link omero.model.MetadataImportJob} which is the
     * first server-side phase after the
     * {@link omero.model.UploadJob}.
     **/
    public omero.model.FilesetJobLink activity;

    /**
     * {@link ImportSettings} which are provided by the
     * client on the call to {@link ManagedRepository#importFileset}.
     **/
    public ImportSettings settings;

    /**
     * {@link ImportLocation} which is calculated during
     * the call to {@link ManagedRepository#importFileset}.
     **/
    public ImportLocation location;

    /**
     * {@link OriginalFile} object representing the import log file.
     **/
    public omero.model.OriginalFile logFile;

    public static final long serialVersionUID = -535757269405741420L;
}
