// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Scripts.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Client facing interface to the background processing
 * framework. If a user needs interactivity, one of these
 * processors should be acquired from the ServiceFactory.
 * Otherwise, a Job can be submitted via JobHandle.
 **/
public interface InteractiveProcessorPrx extends Ice.ObjectPrx
{
    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     **/
    public long expires();

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __ctx The Context map to send with the invocation.
     **/
    public long expires(java.util.Map<String, String> __ctx);

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_expires();

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_expires(java.util.Map<String, String> __ctx);

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_expires(Ice.Callback __cb);

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_expires(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_expires(Callback_InteractiveProcessor_expires __cb);

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_expires(java.util.Map<String, String> __ctx, Callback_InteractiveProcessor_expires __cb);

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __result The asynchronous result object.
     **/
    public long end_expires(Ice.AsyncResult __result);

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __cb The callback object for the operation.
     **/
    public boolean expires_async(AMI_InteractiveProcessor_expires __cb);

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean expires_async(AMI_InteractiveProcessor_expires __cb, java.util.Map<String, String> __ctx);

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     **/
    public omero.model.Job getJob();

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.Job getJob(java.util.Map<String, String> __ctx);

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob();

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx);

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(Ice.Callback __cb);

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(Callback_InteractiveProcessor_getJob __cb);

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx, Callback_InteractiveProcessor_getJob __cb);

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __result The asynchronous result object.
     **/
    public omero.model.Job end_getJob(Ice.AsyncResult __result);

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __cb The callback object for the operation.
     **/
    public boolean getJob_async(AMI_InteractiveProcessor_getJob __cb);

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getJob_async(AMI_InteractiveProcessor_getJob __cb, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     **/
    public JobParams params()
        throws omero.ServerError;

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __ctx The Context map to send with the invocation.
     **/
    public JobParams params(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_params();

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_params(java.util.Map<String, String> __ctx);

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_params(Ice.Callback __cb);

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_params(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_params(Callback_InteractiveProcessor_params __cb);

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_params(java.util.Map<String, String> __ctx, Callback_InteractiveProcessor_params __cb);

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __result The asynchronous result object.
     **/
    public JobParams end_params(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __cb The callback object for the operation.
     **/
    public boolean params_async(AMI_InteractiveProcessor_params __cb);

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean params_async(AMI_InteractiveProcessor_params __cb, java.util.Map<String, String> __ctx);

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     **/
    public ProcessPrx execute(omero.RMap inputs)
        throws omero.ServerError;

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __ctx The Context map to send with the invocation.
     **/
    public ProcessPrx execute(omero.RMap inputs, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_execute(omero.RMap inputs);

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_execute(omero.RMap inputs, java.util.Map<String, String> __ctx);

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_execute(omero.RMap inputs, Ice.Callback __cb);

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_execute(omero.RMap inputs, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_execute(omero.RMap inputs, Callback_InteractiveProcessor_execute __cb);

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_execute(omero.RMap inputs, java.util.Map<String, String> __ctx, Callback_InteractiveProcessor_execute __cb);

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __result The asynchronous result object.
     **/
    public ProcessPrx end_execute(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __cb The callback object for the operation.
     **/
    public boolean execute_async(AMI_InteractiveProcessor_execute __cb, omero.RMap inputs);

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean execute_async(AMI_InteractiveProcessor_execute __cb, omero.RMap inputs, java.util.Map<String, String> __ctx);

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     **/
    public omero.RMap getResults(ProcessPrx proc)
        throws omero.ServerError;

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.RMap getResults(ProcessPrx proc, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResults(ProcessPrx proc);

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResults(ProcessPrx proc, java.util.Map<String, String> __ctx);

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResults(ProcessPrx proc, Ice.Callback __cb);

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResults(ProcessPrx proc, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResults(ProcessPrx proc, Callback_InteractiveProcessor_getResults __cb);

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResults(ProcessPrx proc, java.util.Map<String, String> __ctx, Callback_InteractiveProcessor_getResults __cb);

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __result The asynchronous result object.
     **/
    public omero.RMap end_getResults(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __cb The callback object for the operation.
     **/
    public boolean getResults_async(AMI_InteractiveProcessor_getResults __cb, ProcessPrx proc);

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getResults_async(AMI_InteractiveProcessor_getResults __cb, ProcessPrx proc, java.util.Map<String, String> __ctx);

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     **/
    public boolean setDetach(boolean detach)
        throws omero.ServerError;

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setDetach(boolean detach, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setDetach(boolean detach);

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setDetach(boolean detach, java.util.Map<String, String> __ctx);

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setDetach(boolean detach, Ice.Callback __cb);

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setDetach(boolean detach, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setDetach(boolean detach, Callback_InteractiveProcessor_setDetach __cb);

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setDetach(boolean detach, java.util.Map<String, String> __ctx, Callback_InteractiveProcessor_setDetach __cb);

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __result The asynchronous result object.
     **/
    public boolean end_setDetach(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean setDetach_async(AMI_InteractiveProcessor_setDetach __cb, boolean detach);

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setDetach_async(AMI_InteractiveProcessor_setDetach __cb, boolean detach, java.util.Map<String, String> __ctx);

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     **/
    public void stop()
        throws omero.ServerError;

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void stop(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_stop();

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_stop(java.util.Map<String, String> __ctx);

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_stop(Ice.Callback __cb);

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_stop(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_stop(Callback_InteractiveProcessor_stop __cb);

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_stop(java.util.Map<String, String> __ctx, Callback_InteractiveProcessor_stop __cb);

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __result The asynchronous result object.
     **/
    public void end_stop(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __cb The callback object for the operation.
     **/
    public boolean stop_async(AMI_InteractiveProcessor_stop __cb);

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean stop_async(AMI_InteractiveProcessor_stop __cb, java.util.Map<String, String> __ctx);
}
