// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Scripts.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Client facing interface to the background processing
 * framework. If a user needs interactivity, one of these
 * processors should be acquired from the ServiceFactory.
 * Otherwise, a Job can be submitted via JobHandle.
 **/
public final class InteractiveProcessorPrxHelper extends Ice.ObjectPrxHelperBase implements InteractiveProcessorPrx
{
    private static final String __execute_name = "execute";

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     **/
    public ProcessPrx execute(omero.RMap inputs)
        throws omero.ServerError
    {
        return execute(inputs, null, false);
    }

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __ctx The Context map to send with the invocation.
     **/
    public ProcessPrx execute(omero.RMap inputs, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return execute(inputs, __ctx, true);
    }

    private ProcessPrx execute(omero.RMap inputs, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "execute", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("execute");
                    __delBase = __getDelegate(false);
                    _InteractiveProcessorDel __del = (_InteractiveProcessorDel)__delBase;
                    return __del.execute(inputs, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_execute(omero.RMap inputs)
    {
        return begin_execute(inputs, null, false, null);
    }

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_execute(omero.RMap inputs, java.util.Map<String, String> __ctx)
    {
        return begin_execute(inputs, __ctx, true, null);
    }

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_execute(omero.RMap inputs, Ice.Callback __cb)
    {
        return begin_execute(inputs, null, false, __cb);
    }

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_execute(omero.RMap inputs, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_execute(inputs, __ctx, true, __cb);
    }

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_execute(omero.RMap inputs, Callback_InteractiveProcessor_execute __cb)
    {
        return begin_execute(inputs, null, false, __cb);
    }

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_execute(omero.RMap inputs, java.util.Map<String, String> __ctx, Callback_InteractiveProcessor_execute __cb)
    {
        return begin_execute(inputs, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_execute(omero.RMap inputs, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__execute_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __execute_name, __cb);
        try
        {
            __result.__prepare(__execute_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(inputs);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public ProcessPrx end_execute(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __execute_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            ProcessPrx __ret;
            __ret = ProcessPrxHelper.__read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __cb The callback object for the operation.
     **/
    public boolean execute_async(AMI_InteractiveProcessor_execute __cb, omero.RMap inputs)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__execute_name);
            __r = begin_execute(inputs, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __execute_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean execute_async(AMI_InteractiveProcessor_execute __cb, omero.RMap inputs, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__execute_name);
            __r = begin_execute(inputs, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __execute_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __expires_name = "expires";

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     **/
    public long expires()
    {
        return expires(null, false);
    }

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __ctx The Context map to send with the invocation.
     **/
    public long expires(java.util.Map<String, String> __ctx)
    {
        return expires(__ctx, true);
    }

    private long expires(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "expires", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("expires");
                    __delBase = __getDelegate(false);
                    _InteractiveProcessorDel __del = (_InteractiveProcessorDel)__delBase;
                    return __del.expires(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_expires()
    {
        return begin_expires(null, false, null);
    }

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_expires(java.util.Map<String, String> __ctx)
    {
        return begin_expires(__ctx, true, null);
    }

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_expires(Ice.Callback __cb)
    {
        return begin_expires(null, false, __cb);
    }

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_expires(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_expires(__ctx, true, __cb);
    }

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_expires(Callback_InteractiveProcessor_expires __cb)
    {
        return begin_expires(null, false, __cb);
    }

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_expires(java.util.Map<String, String> __ctx, Callback_InteractiveProcessor_expires __cb)
    {
        return begin_expires(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_expires(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__expires_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __expires_name, __cb);
        try
        {
            __result.__prepare(__expires_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public long end_expires(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __expires_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __cb The callback object for the operation.
     **/
    public boolean expires_async(AMI_InteractiveProcessor_expires __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__expires_name);
            __r = begin_expires(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __expires_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean expires_async(AMI_InteractiveProcessor_expires __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__expires_name);
            __r = begin_expires(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __expires_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getJob_name = "getJob";

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     **/
    public omero.model.Job getJob()
    {
        return getJob(null, false);
    }

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.Job getJob(java.util.Map<String, String> __ctx)
    {
        return getJob(__ctx, true);
    }

    private omero.model.Job getJob(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getJob", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getJob");
                    __delBase = __getDelegate(false);
                    _InteractiveProcessorDel __del = (_InteractiveProcessorDel)__delBase;
                    return __del.getJob(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getJob()
    {
        return begin_getJob(null, false, null);
    }

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx)
    {
        return begin_getJob(__ctx, true, null);
    }

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getJob(Ice.Callback __cb)
    {
        return begin_getJob(null, false, __cb);
    }

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getJob(__ctx, true, __cb);
    }

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getJob(Callback_InteractiveProcessor_getJob __cb)
    {
        return begin_getJob(null, false, __cb);
    }

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx, Callback_InteractiveProcessor_getJob __cb)
    {
        return begin_getJob(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getJob_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getJob_name, __cb);
        try
        {
            __result.__prepare(__getJob_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.model.Job end_getJob(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __getJob_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.JobHolder __ret = new omero.model.JobHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __cb The callback object for the operation.
     **/
    public boolean getJob_async(AMI_InteractiveProcessor_getJob __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getJob_name);
            __r = begin_getJob(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getJob_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getJob_async(AMI_InteractiveProcessor_getJob __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getJob_name);
            __r = begin_getJob(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getJob_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getResults_name = "getResults";

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     **/
    public omero.RMap getResults(ProcessPrx proc)
        throws omero.ServerError
    {
        return getResults(proc, null, false);
    }

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.RMap getResults(ProcessPrx proc, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getResults(proc, __ctx, true);
    }

    private omero.RMap getResults(ProcessPrx proc, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getResults", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getResults");
                    __delBase = __getDelegate(false);
                    _InteractiveProcessorDel __del = (_InteractiveProcessorDel)__delBase;
                    return __del.getResults(proc, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResults(ProcessPrx proc)
    {
        return begin_getResults(proc, null, false, null);
    }

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResults(ProcessPrx proc, java.util.Map<String, String> __ctx)
    {
        return begin_getResults(proc, __ctx, true, null);
    }

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResults(ProcessPrx proc, Ice.Callback __cb)
    {
        return begin_getResults(proc, null, false, __cb);
    }

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResults(ProcessPrx proc, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getResults(proc, __ctx, true, __cb);
    }

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResults(ProcessPrx proc, Callback_InteractiveProcessor_getResults __cb)
    {
        return begin_getResults(proc, null, false, __cb);
    }

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResults(ProcessPrx proc, java.util.Map<String, String> __ctx, Callback_InteractiveProcessor_getResults __cb)
    {
        return begin_getResults(proc, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getResults(ProcessPrx proc, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getResults_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getResults_name, __cb);
        try
        {
            __result.__prepare(__getResults_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            ProcessPrxHelper.__write(__os, proc);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.RMap end_getResults(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getResults_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.RMapHolder __ret = new omero.RMapHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __cb The callback object for the operation.
     **/
    public boolean getResults_async(AMI_InteractiveProcessor_getResults __cb, ProcessPrx proc)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getResults_name);
            __r = begin_getResults(proc, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getResults_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getResults_async(AMI_InteractiveProcessor_getResults __cb, ProcessPrx proc, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getResults_name);
            __r = begin_getResults(proc, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getResults_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __params_name = "params";

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     **/
    public JobParams params()
        throws omero.ServerError
    {
        return params(null, false);
    }

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __ctx The Context map to send with the invocation.
     **/
    public JobParams params(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return params(__ctx, true);
    }

    private JobParams params(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "params", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("params");
                    __delBase = __getDelegate(false);
                    _InteractiveProcessorDel __del = (_InteractiveProcessorDel)__delBase;
                    return __del.params(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_params()
    {
        return begin_params(null, false, null);
    }

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_params(java.util.Map<String, String> __ctx)
    {
        return begin_params(__ctx, true, null);
    }

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_params(Ice.Callback __cb)
    {
        return begin_params(null, false, __cb);
    }

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_params(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_params(__ctx, true, __cb);
    }

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_params(Callback_InteractiveProcessor_params __cb)
    {
        return begin_params(null, false, __cb);
    }

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_params(java.util.Map<String, String> __ctx, Callback_InteractiveProcessor_params __cb)
    {
        return begin_params(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_params(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__params_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __params_name, __cb);
        try
        {
            __result.__prepare(__params_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public JobParams end_params(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __params_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            JobParamsHolder __ret = new JobParamsHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __cb The callback object for the operation.
     **/
    public boolean params_async(AMI_InteractiveProcessor_params __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__params_name);
            __r = begin_params(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __params_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean params_async(AMI_InteractiveProcessor_params __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__params_name);
            __r = begin_params(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __params_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setDetach_name = "setDetach";

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     **/
    public boolean setDetach(boolean detach)
        throws omero.ServerError
    {
        return setDetach(detach, null, false);
    }

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setDetach(boolean detach, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return setDetach(detach, __ctx, true);
    }

    private boolean setDetach(boolean detach, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setDetach", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setDetach");
                    __delBase = __getDelegate(false);
                    _InteractiveProcessorDel __del = (_InteractiveProcessorDel)__delBase;
                    return __del.setDetach(detach, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setDetach(boolean detach)
    {
        return begin_setDetach(detach, null, false, null);
    }

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setDetach(boolean detach, java.util.Map<String, String> __ctx)
    {
        return begin_setDetach(detach, __ctx, true, null);
    }

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setDetach(boolean detach, Ice.Callback __cb)
    {
        return begin_setDetach(detach, null, false, __cb);
    }

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setDetach(boolean detach, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setDetach(detach, __ctx, true, __cb);
    }

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setDetach(boolean detach, Callback_InteractiveProcessor_setDetach __cb)
    {
        return begin_setDetach(detach, null, false, __cb);
    }

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setDetach(boolean detach, java.util.Map<String, String> __ctx, Callback_InteractiveProcessor_setDetach __cb)
    {
        return begin_setDetach(detach, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setDetach(boolean detach, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setDetach_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setDetach_name, __cb);
        try
        {
            __result.__prepare(__setDetach_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(detach);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_setDetach(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setDetach_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean setDetach_async(AMI_InteractiveProcessor_setDetach __cb, boolean detach)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setDetach_name);
            __r = begin_setDetach(detach, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setDetach_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setDetach_async(AMI_InteractiveProcessor_setDetach __cb, boolean detach, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setDetach_name);
            __r = begin_setDetach(detach, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setDetach_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __stop_name = "stop";

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     **/
    public void stop()
        throws omero.ServerError
    {
        stop(null, false);
    }

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void stop(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        stop(__ctx, true);
    }

    private void stop(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "stop", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("stop");
                    __delBase = __getDelegate(false);
                    _InteractiveProcessorDel __del = (_InteractiveProcessorDel)__delBase;
                    __del.stop(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_stop()
    {
        return begin_stop(null, false, null);
    }

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_stop(java.util.Map<String, String> __ctx)
    {
        return begin_stop(__ctx, true, null);
    }

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_stop(Ice.Callback __cb)
    {
        return begin_stop(null, false, __cb);
    }

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_stop(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_stop(__ctx, true, __cb);
    }

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_stop(Callback_InteractiveProcessor_stop __cb)
    {
        return begin_stop(null, false, __cb);
    }

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_stop(java.util.Map<String, String> __ctx, Callback_InteractiveProcessor_stop __cb)
    {
        return begin_stop(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_stop(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__stop_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __stop_name, __cb);
        try
        {
            __result.__prepare(__stop_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_stop(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __stop_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __cb The callback object for the operation.
     **/
    public boolean stop_async(AMI_InteractiveProcessor_stop __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__stop_name);
            __r = begin_stop(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __stop_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean stop_async(AMI_InteractiveProcessor_stop __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__stop_name);
            __r = begin_stop(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __stop_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static InteractiveProcessorPrx checkedCast(Ice.ObjectPrx __obj)
    {
        InteractiveProcessorPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof InteractiveProcessorPrx)
            {
                __d = (InteractiveProcessorPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    InteractiveProcessorPrxHelper __h = new InteractiveProcessorPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static InteractiveProcessorPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        InteractiveProcessorPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof InteractiveProcessorPrx)
            {
                __d = (InteractiveProcessorPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    InteractiveProcessorPrxHelper __h = new InteractiveProcessorPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static InteractiveProcessorPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        InteractiveProcessorPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    InteractiveProcessorPrxHelper __h = new InteractiveProcessorPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static InteractiveProcessorPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        InteractiveProcessorPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    InteractiveProcessorPrxHelper __h = new InteractiveProcessorPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static InteractiveProcessorPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        InteractiveProcessorPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof InteractiveProcessorPrx)
            {
                __d = (InteractiveProcessorPrx)__obj;
            }
            else
            {
                InteractiveProcessorPrxHelper __h = new InteractiveProcessorPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static InteractiveProcessorPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        InteractiveProcessorPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            InteractiveProcessorPrxHelper __h = new InteractiveProcessorPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::InteractiveProcessor"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _InteractiveProcessorDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _InteractiveProcessorDelD();
    }

    public static void __write(IceInternal.BasicStream __os, InteractiveProcessorPrx v)
    {
        __os.writeProxy(v);
    }

    public static InteractiveProcessorPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            InteractiveProcessorPrxHelper result = new InteractiveProcessorPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
