// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Scripts.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Complete job description with all input and output Params.
 * 
 * JobParams contain information about who wrote a script, what its
 * purpose is, and how it should be used, and are defined via the
 * "omero.scripts.client" method.
 * 
 * <pre>
 * c = omero.scripts.client(name="my algorithm", version="0.0.1")
 * </pre>
 * 
 * Alternatively, a JobParams instance can be passed into the constructor:
 * 
 * <pre>
 * params = omero.grid.JobParams()
 * params.authors = \["Andy", "Kathy"]
 * params.version = "0.0.1"
 * params.description = """
 * Clever way to count to 5
 * """
 * c = omero.scripts.client(params)
 * </pre>
 * 
 * A single JobParam instance is parsed from a script and stored by the server.
 * Later invocations re-use this instance until the script changes.
 **/
public class JobParams extends omero.Internal
{
    public JobParams()
    {
        super();
    }

    public JobParams(String name, String version, String description, String contact, String[] authors, String[] institutions, int[][] authorsInstitutions, java.util.Map<java.lang.String, Param> inputs, java.util.Map<java.lang.String, Param> outputs, String stdoutFormat, String stderrFormat, java.util.List<String> namespaces)
    {
        this.name = name;
        this.version = version;
        this.description = description;
        this.contact = contact;
        this.authors = authors;
        this.institutions = institutions;
        this.authorsInstitutions = authorsInstitutions;
        this.inputs = inputs;
        this.outputs = outputs;
        this.stdoutFormat = stdoutFormat;
        this.stderrFormat = stderrFormat;
        this.namespaces = namespaces;
    }

    private static class __F implements Ice.ObjectFactory
    {
        public Ice.Object create(String type)
        {
            assert(type.equals(ice_staticId()));
            return new JobParams();
        }

        public void destroy()
        {
        }
    }
    private static Ice.ObjectFactory _factory = new __F();

    public static Ice.ObjectFactory
    ice_factory()
    {
        return _factory;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::Internal",
        "::omero::grid::JobParams"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[2];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[2];
    }

    public static String ice_staticId()
    {
        return __ids[2];
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, false);
        __os.writeString(name);
        __os.writeString(version);
        __os.writeString(description);
        __os.writeString(contact);
        omero.api.StringArrayHelper.write(__os, authors);
        omero.api.StringArrayHelper.write(__os, institutions);
        omero.api.IntegerArrayArrayHelper.write(__os, authorsInstitutions);
        ParamMapHelper.write(__os, inputs);
        ParamMapHelper.write(__os, outputs);
        __os.writeString(stdoutFormat);
        __os.writeString(stderrFormat);
        omero.api.StringSetHelper.write(__os, namespaces);
        __os.endWriteSlice();
        super.__writeImpl(__os);
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        name = __is.readString();
        version = __is.readString();
        description = __is.readString();
        contact = __is.readString();
        authors = omero.api.StringArrayHelper.read(__is);
        institutions = omero.api.StringArrayHelper.read(__is);
        authorsInstitutions = omero.api.IntegerArrayArrayHelper.read(__is);
        inputs = ParamMapHelper.read(__is);
        outputs = ParamMapHelper.read(__is);
        stdoutFormat = __is.readString();
        stderrFormat = __is.readString();
        namespaces = omero.api.StringSetHelper.read(__is);
        __is.endReadSlice();
        super.__readImpl(__is);
    }

    /**
     * Descriptive name for this script. This value should be unique where
     * possible, but no assurance is provided by the server that multiple
     * scripts with the same name are not present.
     **/
    public String name;

    /**
     * Author-given version number for this script. Please see the script
     * authors' guide for information about choosing version numbers.
     **/
    public String version;

    /**
     * A general description of a script, including documentation on how
     * it should be used, what data it will access, and other metrics
     * like how long it takes to execute, etc.
     **/
    public String description;

    /**
     * Single, human-readable string for how to contact the script author.
     **/
    public String contact;

    /**
     * Information about the authors who took part in creating this script.
     * No particular format is required.
     **/
    public String[] authors;

    /**
     * Information about the institutions which took part in creating this script.
     * No particular format is required.
     **/
    public String[] institutions;

    /**
     * For authors\[i], authorInstitutions\[i] should be
     * and array of indexes j such that author i is a member
     * of authorsInstitutions\[i]\[j].
     * 
     * Example:
     * authors = \["Jane", "Mike"]
     * institutions = \["Acme U.", "Private Corp."]
     * authorsInstitutions = \[\[1, 2], \[1]]
     * 
     * which means that Jane is a member of both "Acme U."
     * and "Private Corp." while Mike is only a member of
     * "Acme U."
     * 
     * An empty authorsInstitutions array implies that all
     * authors are from all institutions.
     **/
    public int[][] authorsInstitutions;

    /**
     * Definitive list of the inputs which MAY or MUST be provided
     * to the script, based on the "optional" flag.
     **/
    public java.util.Map<java.lang.String, Param> inputs;

    /**
     * Definitive list of the outputs which MAY or MUST be provided
     * to the script, based on the "optional" flag.
     **/
    public java.util.Map<java.lang.String, Param> outputs;

    /**
     * {@link omero.model.Format#value} of the stdout stream produced
     * by the script. If this value is not otherwise set (i.e. is
     * None), the default of "text/plain" will be set. This is
     * typically a good idea if the script uses "print" or the logging
     * module.
     * 
     * If you would like to disable stdout upload, set the value to ""
     * (the empty string).
     * 
     * "text/html" or "application/octet-stream" might also be values of interest.
     **/
    public String stdoutFormat;

    /**
     * {@link omero.model.Format#value} of the stderr stream produced by
     * the script. If this value is not otherwise set (i.e. is None),
     * the default of "text/plain" will be set. This is typically a
     * good idea if the script uses "print" or the logging module.
     * 
     * If you would like to disable stderr upload, set the value to ""
     * (the empty string).
     * 
     * "text/html" or "application/octet-stream" might also be values of interest.
     **/
    public String stderrFormat;

    /**
     * Defines machine readable interpretations for this
     * {@link JobParams}.
     * 
     * <p>
     * Where the description field should provide information for
     * users, the assigned namespaces can define how clients may
     * interpret the script, including which categories or algorithm
     * types the script belongs to.
     * </p>
     * 
     **/
    public java.util.List<String> namespaces;

    public static final long serialVersionUID = 2621171303233824508L;
}
