// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Repositories.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * FS-enabled repository which can convert uploaded files
 * into Images by using Bio-Formats to import them.
 **/
public interface ManagedRepositoryPrx extends RepositoryPrx
{
    /**
     * Returns an {@link ImportProcess} which can be used to upload files.
     * On {@link ImportProcess#verifyUpload}, an {@link omero.cmd.Handle} will be
     * returned which can be watched for knowing when the server-side import
     * is complete.
     * 
     * Client paths set in the fileset entries must /-separate their components.
     * 
     * Once the upload is complete, the {@link ImportProcess} must be closed.
     * Once {@link omero.cmd.Handle#getResponse} returns a non-null value, the
     * handle instance can and must be closed.
     **/
    public ImportProcessPrx importFileset(omero.model.Fileset fs, ImportSettings settings)
        throws omero.ServerError;

    /**
     * Returns an {@link ImportProcess} which can be used to upload files.
     * On {@link ImportProcess#verifyUpload}, an {@link omero.cmd.Handle} will be
     * returned which can be watched for knowing when the server-side import
     * is complete.
     * 
     * Client paths set in the fileset entries must /-separate their components.
     * 
     * Once the upload is complete, the {@link ImportProcess} must be closed.
     * Once {@link omero.cmd.Handle#getResponse} returns a non-null value, the
     * handle instance can and must be closed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public ImportProcessPrx importFileset(omero.model.Fileset fs, ImportSettings settings, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns an {@link ImportProcess} which can be used to upload files.
     * On {@link ImportProcess#verifyUpload}, an {@link omero.cmd.Handle} will be
     * returned which can be watched for knowing when the server-side import
     * is complete.
     * 
     * Client paths set in the fileset entries must /-separate their components.
     * 
     * Once the upload is complete, the {@link ImportProcess} must be closed.
     * Once {@link omero.cmd.Handle#getResponse} returns a non-null value, the
     * handle instance can and must be closed.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_importFileset(omero.model.Fileset fs, ImportSettings settings);

    /**
     * Returns an {@link ImportProcess} which can be used to upload files.
     * On {@link ImportProcess#verifyUpload}, an {@link omero.cmd.Handle} will be
     * returned which can be watched for knowing when the server-side import
     * is complete.
     * 
     * Client paths set in the fileset entries must /-separate their components.
     * 
     * Once the upload is complete, the {@link ImportProcess} must be closed.
     * Once {@link omero.cmd.Handle#getResponse} returns a non-null value, the
     * handle instance can and must be closed.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_importFileset(omero.model.Fileset fs, ImportSettings settings, java.util.Map<String, String> __ctx);

    /**
     * Returns an {@link ImportProcess} which can be used to upload files.
     * On {@link ImportProcess#verifyUpload}, an {@link omero.cmd.Handle} will be
     * returned which can be watched for knowing when the server-side import
     * is complete.
     * 
     * Client paths set in the fileset entries must /-separate their components.
     * 
     * Once the upload is complete, the {@link ImportProcess} must be closed.
     * Once {@link omero.cmd.Handle#getResponse} returns a non-null value, the
     * handle instance can and must be closed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_importFileset(omero.model.Fileset fs, ImportSettings settings, Ice.Callback __cb);

    /**
     * Returns an {@link ImportProcess} which can be used to upload files.
     * On {@link ImportProcess#verifyUpload}, an {@link omero.cmd.Handle} will be
     * returned which can be watched for knowing when the server-side import
     * is complete.
     * 
     * Client paths set in the fileset entries must /-separate their components.
     * 
     * Once the upload is complete, the {@link ImportProcess} must be closed.
     * Once {@link omero.cmd.Handle#getResponse} returns a non-null value, the
     * handle instance can and must be closed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_importFileset(omero.model.Fileset fs, ImportSettings settings, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns an {@link ImportProcess} which can be used to upload files.
     * On {@link ImportProcess#verifyUpload}, an {@link omero.cmd.Handle} will be
     * returned which can be watched for knowing when the server-side import
     * is complete.
     * 
     * Client paths set in the fileset entries must /-separate their components.
     * 
     * Once the upload is complete, the {@link ImportProcess} must be closed.
     * Once {@link omero.cmd.Handle#getResponse} returns a non-null value, the
     * handle instance can and must be closed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_importFileset(omero.model.Fileset fs, ImportSettings settings, Callback_ManagedRepository_importFileset __cb);

    /**
     * Returns an {@link ImportProcess} which can be used to upload files.
     * On {@link ImportProcess#verifyUpload}, an {@link omero.cmd.Handle} will be
     * returned which can be watched for knowing when the server-side import
     * is complete.
     * 
     * Client paths set in the fileset entries must /-separate their components.
     * 
     * Once the upload is complete, the {@link ImportProcess} must be closed.
     * Once {@link omero.cmd.Handle#getResponse} returns a non-null value, the
     * handle instance can and must be closed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_importFileset(omero.model.Fileset fs, ImportSettings settings, java.util.Map<String, String> __ctx, Callback_ManagedRepository_importFileset __cb);

    /**
     * Returns an {@link ImportProcess} which can be used to upload files.
     * On {@link ImportProcess#verifyUpload}, an {@link omero.cmd.Handle} will be
     * returned which can be watched for knowing when the server-side import
     * is complete.
     * 
     * Client paths set in the fileset entries must /-separate their components.
     * 
     * Once the upload is complete, the {@link ImportProcess} must be closed.
     * Once {@link omero.cmd.Handle#getResponse} returns a non-null value, the
     * handle instance can and must be closed.
     * @param __result The asynchronous result object.
     **/
    public ImportProcessPrx end_importFileset(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns an {@link ImportProcess} which can be used to upload files.
     * On {@link ImportProcess#verifyUpload}, an {@link omero.cmd.Handle} will be
     * returned which can be watched for knowing when the server-side import
     * is complete.
     * 
     * Client paths set in the fileset entries must /-separate their components.
     * 
     * Once the upload is complete, the {@link ImportProcess} must be closed.
     * Once {@link omero.cmd.Handle#getResponse} returns a non-null value, the
     * handle instance can and must be closed.
     * @param __cb The callback object for the operation.
     **/
    public boolean importFileset_async(AMI_ManagedRepository_importFileset __cb, omero.model.Fileset fs, ImportSettings settings);

    /**
     * Returns an {@link ImportProcess} which can be used to upload files.
     * On {@link ImportProcess#verifyUpload}, an {@link omero.cmd.Handle} will be
     * returned which can be watched for knowing when the server-side import
     * is complete.
     * 
     * Client paths set in the fileset entries must /-separate their components.
     * 
     * Once the upload is complete, the {@link ImportProcess} must be closed.
     * Once {@link omero.cmd.Handle#getResponse} returns a non-null value, the
     * handle instance can and must be closed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean importFileset_async(AMI_ManagedRepository_importFileset __cb, omero.model.Fileset fs, ImportSettings settings, java.util.Map<String, String> __ctx);

    /**
     * For clients without access to Bio-Formats, the simplified
     * {@link #importPaths} method allows passing solely the absolute
     * path of the files to be uploaded (no directories) and all
     * configuration happens server-side. Much of the functionality
     * provided via {@link omero.model.Fileset} and
     * {@link omero.grid.ImportSettings} is of course lost.
     **/
    public ImportProcessPrx importPaths(java.util.List<String> filePaths)
        throws omero.ServerError;

    /**
     * For clients without access to Bio-Formats, the simplified
     * {@link #importPaths} method allows passing solely the absolute
     * path of the files to be uploaded (no directories) and all
     * configuration happens server-side. Much of the functionality
     * provided via {@link omero.model.Fileset} and
     * {@link omero.grid.ImportSettings} is of course lost.
     * @param __ctx The Context map to send with the invocation.
     **/
    public ImportProcessPrx importPaths(java.util.List<String> filePaths, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * For clients without access to Bio-Formats, the simplified
     * {@link #importPaths} method allows passing solely the absolute
     * path of the files to be uploaded (no directories) and all
     * configuration happens server-side. Much of the functionality
     * provided via {@link omero.model.Fileset} and
     * {@link omero.grid.ImportSettings} is of course lost.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_importPaths(java.util.List<String> filePaths);

    /**
     * For clients without access to Bio-Formats, the simplified
     * {@link #importPaths} method allows passing solely the absolute
     * path of the files to be uploaded (no directories) and all
     * configuration happens server-side. Much of the functionality
     * provided via {@link omero.model.Fileset} and
     * {@link omero.grid.ImportSettings} is of course lost.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_importPaths(java.util.List<String> filePaths, java.util.Map<String, String> __ctx);

    /**
     * For clients without access to Bio-Formats, the simplified
     * {@link #importPaths} method allows passing solely the absolute
     * path of the files to be uploaded (no directories) and all
     * configuration happens server-side. Much of the functionality
     * provided via {@link omero.model.Fileset} and
     * {@link omero.grid.ImportSettings} is of course lost.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_importPaths(java.util.List<String> filePaths, Ice.Callback __cb);

    /**
     * For clients without access to Bio-Formats, the simplified
     * {@link #importPaths} method allows passing solely the absolute
     * path of the files to be uploaded (no directories) and all
     * configuration happens server-side. Much of the functionality
     * provided via {@link omero.model.Fileset} and
     * {@link omero.grid.ImportSettings} is of course lost.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_importPaths(java.util.List<String> filePaths, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * For clients without access to Bio-Formats, the simplified
     * {@link #importPaths} method allows passing solely the absolute
     * path of the files to be uploaded (no directories) and all
     * configuration happens server-side. Much of the functionality
     * provided via {@link omero.model.Fileset} and
     * {@link omero.grid.ImportSettings} is of course lost.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_importPaths(java.util.List<String> filePaths, Callback_ManagedRepository_importPaths __cb);

    /**
     * For clients without access to Bio-Formats, the simplified
     * {@link #importPaths} method allows passing solely the absolute
     * path of the files to be uploaded (no directories) and all
     * configuration happens server-side. Much of the functionality
     * provided via {@link omero.model.Fileset} and
     * {@link omero.grid.ImportSettings} is of course lost.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_importPaths(java.util.List<String> filePaths, java.util.Map<String, String> __ctx, Callback_ManagedRepository_importPaths __cb);

    /**
     * For clients without access to Bio-Formats, the simplified
     * {@link #importPaths} method allows passing solely the absolute
     * path of the files to be uploaded (no directories) and all
     * configuration happens server-side. Much of the functionality
     * provided via {@link omero.model.Fileset} and
     * {@link omero.grid.ImportSettings} is of course lost.
     * @param __result The asynchronous result object.
     **/
    public ImportProcessPrx end_importPaths(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * For clients without access to Bio-Formats, the simplified
     * {@link #importPaths} method allows passing solely the absolute
     * path of the files to be uploaded (no directories) and all
     * configuration happens server-side. Much of the functionality
     * provided via {@link omero.model.Fileset} and
     * {@link omero.grid.ImportSettings} is of course lost.
     * @param __cb The callback object for the operation.
     **/
    public boolean importPaths_async(AMI_ManagedRepository_importPaths __cb, java.util.List<String> filePaths);

    /**
     * For clients without access to Bio-Formats, the simplified
     * {@link #importPaths} method allows passing solely the absolute
     * path of the files to be uploaded (no directories) and all
     * configuration happens server-side. Much of the functionality
     * provided via {@link omero.model.Fileset} and
     * {@link omero.grid.ImportSettings} is of course lost.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean importPaths_async(AMI_ManagedRepository_importPaths __cb, java.util.List<String> filePaths, java.util.Map<String, String> __ctx);

    /**
     * List imports that are currently running in this importer.
     * These will be limited based on user/group membership for
     * the {@link omero.model.Fileset} object which is being created
     * by the import. If the user has write permissions for the
     * fileset, then the import will be included.
     **/
    public java.util.List<omero.grid.ImportProcessPrx> listImports()
        throws omero.ServerError;

    /**
     * List imports that are currently running in this importer.
     * These will be limited based on user/group membership for
     * the {@link omero.model.Fileset} object which is being created
     * by the import. If the user has write permissions for the
     * fileset, then the import will be included.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.grid.ImportProcessPrx> listImports(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * List imports that are currently running in this importer.
     * These will be limited based on user/group membership for
     * the {@link omero.model.Fileset} object which is being created
     * by the import. If the user has write permissions for the
     * fileset, then the import will be included.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_listImports();

    /**
     * List imports that are currently running in this importer.
     * These will be limited based on user/group membership for
     * the {@link omero.model.Fileset} object which is being created
     * by the import. If the user has write permissions for the
     * fileset, then the import will be included.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_listImports(java.util.Map<String, String> __ctx);

    /**
     * List imports that are currently running in this importer.
     * These will be limited based on user/group membership for
     * the {@link omero.model.Fileset} object which is being created
     * by the import. If the user has write permissions for the
     * fileset, then the import will be included.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_listImports(Ice.Callback __cb);

    /**
     * List imports that are currently running in this importer.
     * These will be limited based on user/group membership for
     * the {@link omero.model.Fileset} object which is being created
     * by the import. If the user has write permissions for the
     * fileset, then the import will be included.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_listImports(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * List imports that are currently running in this importer.
     * These will be limited based on user/group membership for
     * the {@link omero.model.Fileset} object which is being created
     * by the import. If the user has write permissions for the
     * fileset, then the import will be included.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_listImports(Callback_ManagedRepository_listImports __cb);

    /**
     * List imports that are currently running in this importer.
     * These will be limited based on user/group membership for
     * the {@link omero.model.Fileset} object which is being created
     * by the import. If the user has write permissions for the
     * fileset, then the import will be included.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_listImports(java.util.Map<String, String> __ctx, Callback_ManagedRepository_listImports __cb);

    /**
     * List imports that are currently running in this importer.
     * These will be limited based on user/group membership for
     * the {@link omero.model.Fileset} object which is being created
     * by the import. If the user has write permissions for the
     * fileset, then the import will be included.
     * @param __result The asynchronous result object.
     **/
    public java.util.List<omero.grid.ImportProcessPrx> end_listImports(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * List imports that are currently running in this importer.
     * These will be limited based on user/group membership for
     * the {@link omero.model.Fileset} object which is being created
     * by the import. If the user has write permissions for the
     * fileset, then the import will be included.
     * @param __cb The callback object for the operation.
     **/
    public boolean listImports_async(AMI_ManagedRepository_listImports __cb);

    /**
     * List imports that are currently running in this importer.
     * These will be limited based on user/group membership for
     * the {@link omero.model.Fileset} object which is being created
     * by the import. If the user has write permissions for the
     * fileset, then the import will be included.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean listImports_async(AMI_ManagedRepository_listImports __cb, java.util.Map<String, String> __ctx);

    /**
     * Return the list of checksum algorithms supported by this repository
     * for verifying the integrity of uploaded files.
     * They are named as ""algorithm-integer"",
     * integer being the bit width of the resulting hash code.
     * It is possible for the same algorithm to be offered with
     * different bit widths.
     * They are listed in descending order of preference,
     * as set by the server administrator, and any of them may
     * be specified for {@link ImportSettings#checksumAlgorithm}.
     **/
    public java.util.List<omero.model.ChecksumAlgorithm> listChecksumAlgorithms();

    /**
     * Return the list of checksum algorithms supported by this repository
     * for verifying the integrity of uploaded files.
     * They are named as ""algorithm-integer"",
     * integer being the bit width of the resulting hash code.
     * It is possible for the same algorithm to be offered with
     * different bit widths.
     * They are listed in descending order of preference,
     * as set by the server administrator, and any of them may
     * be specified for {@link ImportSettings#checksumAlgorithm}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.ChecksumAlgorithm> listChecksumAlgorithms(java.util.Map<String, String> __ctx);

    /**
     * Return the list of checksum algorithms supported by this repository
     * for verifying the integrity of uploaded files.
     * They are named as ""algorithm-integer"",
     * integer being the bit width of the resulting hash code.
     * It is possible for the same algorithm to be offered with
     * different bit widths.
     * They are listed in descending order of preference,
     * as set by the server administrator, and any of them may
     * be specified for {@link ImportSettings#checksumAlgorithm}.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_listChecksumAlgorithms();

    /**
     * Return the list of checksum algorithms supported by this repository
     * for verifying the integrity of uploaded files.
     * They are named as ""algorithm-integer"",
     * integer being the bit width of the resulting hash code.
     * It is possible for the same algorithm to be offered with
     * different bit widths.
     * They are listed in descending order of preference,
     * as set by the server administrator, and any of them may
     * be specified for {@link ImportSettings#checksumAlgorithm}.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_listChecksumAlgorithms(java.util.Map<String, String> __ctx);

    /**
     * Return the list of checksum algorithms supported by this repository
     * for verifying the integrity of uploaded files.
     * They are named as ""algorithm-integer"",
     * integer being the bit width of the resulting hash code.
     * It is possible for the same algorithm to be offered with
     * different bit widths.
     * They are listed in descending order of preference,
     * as set by the server administrator, and any of them may
     * be specified for {@link ImportSettings#checksumAlgorithm}.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_listChecksumAlgorithms(Ice.Callback __cb);

    /**
     * Return the list of checksum algorithms supported by this repository
     * for verifying the integrity of uploaded files.
     * They are named as ""algorithm-integer"",
     * integer being the bit width of the resulting hash code.
     * It is possible for the same algorithm to be offered with
     * different bit widths.
     * They are listed in descending order of preference,
     * as set by the server administrator, and any of them may
     * be specified for {@link ImportSettings#checksumAlgorithm}.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_listChecksumAlgorithms(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Return the list of checksum algorithms supported by this repository
     * for verifying the integrity of uploaded files.
     * They are named as ""algorithm-integer"",
     * integer being the bit width of the resulting hash code.
     * It is possible for the same algorithm to be offered with
     * different bit widths.
     * They are listed in descending order of preference,
     * as set by the server administrator, and any of them may
     * be specified for {@link ImportSettings#checksumAlgorithm}.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_listChecksumAlgorithms(Callback_ManagedRepository_listChecksumAlgorithms __cb);

    /**
     * Return the list of checksum algorithms supported by this repository
     * for verifying the integrity of uploaded files.
     * They are named as ""algorithm-integer"",
     * integer being the bit width of the resulting hash code.
     * It is possible for the same algorithm to be offered with
     * different bit widths.
     * They are listed in descending order of preference,
     * as set by the server administrator, and any of them may
     * be specified for {@link ImportSettings#checksumAlgorithm}.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_listChecksumAlgorithms(java.util.Map<String, String> __ctx, Callback_ManagedRepository_listChecksumAlgorithms __cb);

    /**
     * Return the list of checksum algorithms supported by this repository
     * for verifying the integrity of uploaded files.
     * They are named as ""algorithm-integer"",
     * integer being the bit width of the resulting hash code.
     * It is possible for the same algorithm to be offered with
     * different bit widths.
     * They are listed in descending order of preference,
     * as set by the server administrator, and any of them may
     * be specified for {@link ImportSettings#checksumAlgorithm}.
     * @param __result The asynchronous result object.
     **/
    public java.util.List<omero.model.ChecksumAlgorithm> end_listChecksumAlgorithms(Ice.AsyncResult __result);

    /**
     * Return the list of checksum algorithms supported by this repository
     * for verifying the integrity of uploaded files.
     * They are named as ""algorithm-integer"",
     * integer being the bit width of the resulting hash code.
     * It is possible for the same algorithm to be offered with
     * different bit widths.
     * They are listed in descending order of preference,
     * as set by the server administrator, and any of them may
     * be specified for {@link ImportSettings#checksumAlgorithm}.
     * @param __cb The callback object for the operation.
     **/
    public boolean listChecksumAlgorithms_async(AMI_ManagedRepository_listChecksumAlgorithms __cb);

    /**
     * Return the list of checksum algorithms supported by this repository
     * for verifying the integrity of uploaded files.
     * They are named as ""algorithm-integer"",
     * integer being the bit width of the resulting hash code.
     * It is possible for the same algorithm to be offered with
     * different bit widths.
     * They are listed in descending order of preference,
     * as set by the server administrator, and any of them may
     * be specified for {@link ImportSettings#checksumAlgorithm}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean listChecksumAlgorithms_async(AMI_ManagedRepository_listChecksumAlgorithms __cb, java.util.Map<String, String> __ctx);

    /**
     * Suggest a checksum algorithm to use for
     * {@link ImportSettings#checksumAlgorithm} according to the
     * preferences set by the server administrator. Provide a
     * list of the algorithms supported by the client, and the
     * server will report which of them is most preferred by
     * the server, or return null if none of them are supported.
     **/
    public omero.model.ChecksumAlgorithm suggestChecksumAlgorithm(java.util.List<omero.model.ChecksumAlgorithm> supported);

    /**
     * Suggest a checksum algorithm to use for
     * {@link ImportSettings#checksumAlgorithm} according to the
     * preferences set by the server administrator. Provide a
     * list of the algorithms supported by the client, and the
     * server will report which of them is most preferred by
     * the server, or return null if none of them are supported.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.ChecksumAlgorithm suggestChecksumAlgorithm(java.util.List<omero.model.ChecksumAlgorithm> supported, java.util.Map<String, String> __ctx);

    /**
     * Suggest a checksum algorithm to use for
     * {@link ImportSettings#checksumAlgorithm} according to the
     * preferences set by the server administrator. Provide a
     * list of the algorithms supported by the client, and the
     * server will report which of them is most preferred by
     * the server, or return null if none of them are supported.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_suggestChecksumAlgorithm(java.util.List<omero.model.ChecksumAlgorithm> supported);

    /**
     * Suggest a checksum algorithm to use for
     * {@link ImportSettings#checksumAlgorithm} according to the
     * preferences set by the server administrator. Provide a
     * list of the algorithms supported by the client, and the
     * server will report which of them is most preferred by
     * the server, or return null if none of them are supported.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_suggestChecksumAlgorithm(java.util.List<omero.model.ChecksumAlgorithm> supported, java.util.Map<String, String> __ctx);

    /**
     * Suggest a checksum algorithm to use for
     * {@link ImportSettings#checksumAlgorithm} according to the
     * preferences set by the server administrator. Provide a
     * list of the algorithms supported by the client, and the
     * server will report which of them is most preferred by
     * the server, or return null if none of them are supported.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_suggestChecksumAlgorithm(java.util.List<omero.model.ChecksumAlgorithm> supported, Ice.Callback __cb);

    /**
     * Suggest a checksum algorithm to use for
     * {@link ImportSettings#checksumAlgorithm} according to the
     * preferences set by the server administrator. Provide a
     * list of the algorithms supported by the client, and the
     * server will report which of them is most preferred by
     * the server, or return null if none of them are supported.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_suggestChecksumAlgorithm(java.util.List<omero.model.ChecksumAlgorithm> supported, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Suggest a checksum algorithm to use for
     * {@link ImportSettings#checksumAlgorithm} according to the
     * preferences set by the server administrator. Provide a
     * list of the algorithms supported by the client, and the
     * server will report which of them is most preferred by
     * the server, or return null if none of them are supported.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_suggestChecksumAlgorithm(java.util.List<omero.model.ChecksumAlgorithm> supported, Callback_ManagedRepository_suggestChecksumAlgorithm __cb);

    /**
     * Suggest a checksum algorithm to use for
     * {@link ImportSettings#checksumAlgorithm} according to the
     * preferences set by the server administrator. Provide a
     * list of the algorithms supported by the client, and the
     * server will report which of them is most preferred by
     * the server, or return null if none of them are supported.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_suggestChecksumAlgorithm(java.util.List<omero.model.ChecksumAlgorithm> supported, java.util.Map<String, String> __ctx, Callback_ManagedRepository_suggestChecksumAlgorithm __cb);

    /**
     * Suggest a checksum algorithm to use for
     * {@link ImportSettings#checksumAlgorithm} according to the
     * preferences set by the server administrator. Provide a
     * list of the algorithms supported by the client, and the
     * server will report which of them is most preferred by
     * the server, or return null if none of them are supported.
     * @param __result The asynchronous result object.
     **/
    public omero.model.ChecksumAlgorithm end_suggestChecksumAlgorithm(Ice.AsyncResult __result);

    /**
     * Suggest a checksum algorithm to use for
     * {@link ImportSettings#checksumAlgorithm} according to the
     * preferences set by the server administrator. Provide a
     * list of the algorithms supported by the client, and the
     * server will report which of them is most preferred by
     * the server, or return null if none of them are supported.
     * @param __cb The callback object for the operation.
     **/
    public boolean suggestChecksumAlgorithm_async(AMI_ManagedRepository_suggestChecksumAlgorithm __cb, java.util.List<omero.model.ChecksumAlgorithm> supported);

    /**
     * Suggest a checksum algorithm to use for
     * {@link ImportSettings#checksumAlgorithm} according to the
     * preferences set by the server administrator. Provide a
     * list of the algorithms supported by the client, and the
     * server will report which of them is most preferred by
     * the server, or return null if none of them are supported.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean suggestChecksumAlgorithm_async(AMI_ManagedRepository_suggestChecksumAlgorithm __cb, java.util.List<omero.model.ChecksumAlgorithm> supported, java.util.Map<String, String> __ctx);

    /**
     * Verify the checksum for the original files identified by
     * the given IDs.
     * The files must be in this repository.
     * Returns the IDs of the original files whose checksums
     * do not match the file on disk.
     **/
    public java.util.List<Long> verifyChecksums(java.util.List<Long> ids)
        throws omero.ServerError;

    /**
     * Verify the checksum for the original files identified by
     * the given IDs.
     * The files must be in this repository.
     * Returns the IDs of the original files whose checksums
     * do not match the file on disk.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<Long> verifyChecksums(java.util.List<Long> ids, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Verify the checksum for the original files identified by
     * the given IDs.
     * The files must be in this repository.
     * Returns the IDs of the original files whose checksums
     * do not match the file on disk.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_verifyChecksums(java.util.List<Long> ids);

    /**
     * Verify the checksum for the original files identified by
     * the given IDs.
     * The files must be in this repository.
     * Returns the IDs of the original files whose checksums
     * do not match the file on disk.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_verifyChecksums(java.util.List<Long> ids, java.util.Map<String, String> __ctx);

    /**
     * Verify the checksum for the original files identified by
     * the given IDs.
     * The files must be in this repository.
     * Returns the IDs of the original files whose checksums
     * do not match the file on disk.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_verifyChecksums(java.util.List<Long> ids, Ice.Callback __cb);

    /**
     * Verify the checksum for the original files identified by
     * the given IDs.
     * The files must be in this repository.
     * Returns the IDs of the original files whose checksums
     * do not match the file on disk.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_verifyChecksums(java.util.List<Long> ids, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Verify the checksum for the original files identified by
     * the given IDs.
     * The files must be in this repository.
     * Returns the IDs of the original files whose checksums
     * do not match the file on disk.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_verifyChecksums(java.util.List<Long> ids, Callback_ManagedRepository_verifyChecksums __cb);

    /**
     * Verify the checksum for the original files identified by
     * the given IDs.
     * The files must be in this repository.
     * Returns the IDs of the original files whose checksums
     * do not match the file on disk.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_verifyChecksums(java.util.List<Long> ids, java.util.Map<String, String> __ctx, Callback_ManagedRepository_verifyChecksums __cb);

    /**
     * Verify the checksum for the original files identified by
     * the given IDs.
     * The files must be in this repository.
     * Returns the IDs of the original files whose checksums
     * do not match the file on disk.
     * @param __result The asynchronous result object.
     **/
    public java.util.List<Long> end_verifyChecksums(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Verify the checksum for the original files identified by
     * the given IDs.
     * The files must be in this repository.
     * Returns the IDs of the original files whose checksums
     * do not match the file on disk.
     * @param __cb The callback object for the operation.
     **/
    public boolean verifyChecksums_async(AMI_ManagedRepository_verifyChecksums __cb, java.util.List<Long> ids);

    /**
     * Verify the checksum for the original files identified by
     * the given IDs.
     * The files must be in this repository.
     * Returns the IDs of the original files whose checksums
     * do not match the file on disk.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean verifyChecksums_async(AMI_ManagedRepository_verifyChecksums __cb, java.util.List<Long> ids, java.util.Map<String, String> __ctx);

    /**
     * Set the checksum algorithm for the original files identified
     * by the given IDs and calculate their checksum accordingly.
     * The files must be in this repository.
     * Existing checksums are checked before being changed.
     * If a checksum does not match, ServerError will be thrown;
     * in this case some other files may already have had their
     * checksum algorithm set.
     * Returns the IDs of the original files that did not already
     * have a checksum set for the given algorithm.
     **/
    public java.util.List<Long> setChecksumAlgorithm(omero.model.ChecksumAlgorithm hasher, java.util.List<Long> ids)
        throws omero.ServerError;

    /**
     * Set the checksum algorithm for the original files identified
     * by the given IDs and calculate their checksum accordingly.
     * The files must be in this repository.
     * Existing checksums are checked before being changed.
     * If a checksum does not match, ServerError will be thrown;
     * in this case some other files may already have had their
     * checksum algorithm set.
     * Returns the IDs of the original files that did not already
     * have a checksum set for the given algorithm.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<Long> setChecksumAlgorithm(omero.model.ChecksumAlgorithm hasher, java.util.List<Long> ids, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Set the checksum algorithm for the original files identified
     * by the given IDs and calculate their checksum accordingly.
     * The files must be in this repository.
     * Existing checksums are checked before being changed.
     * If a checksum does not match, ServerError will be thrown;
     * in this case some other files may already have had their
     * checksum algorithm set.
     * Returns the IDs of the original files that did not already
     * have a checksum set for the given algorithm.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setChecksumAlgorithm(omero.model.ChecksumAlgorithm hasher, java.util.List<Long> ids);

    /**
     * Set the checksum algorithm for the original files identified
     * by the given IDs and calculate their checksum accordingly.
     * The files must be in this repository.
     * Existing checksums are checked before being changed.
     * If a checksum does not match, ServerError will be thrown;
     * in this case some other files may already have had their
     * checksum algorithm set.
     * Returns the IDs of the original files that did not already
     * have a checksum set for the given algorithm.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setChecksumAlgorithm(omero.model.ChecksumAlgorithm hasher, java.util.List<Long> ids, java.util.Map<String, String> __ctx);

    /**
     * Set the checksum algorithm for the original files identified
     * by the given IDs and calculate their checksum accordingly.
     * The files must be in this repository.
     * Existing checksums are checked before being changed.
     * If a checksum does not match, ServerError will be thrown;
     * in this case some other files may already have had their
     * checksum algorithm set.
     * Returns the IDs of the original files that did not already
     * have a checksum set for the given algorithm.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setChecksumAlgorithm(omero.model.ChecksumAlgorithm hasher, java.util.List<Long> ids, Ice.Callback __cb);

    /**
     * Set the checksum algorithm for the original files identified
     * by the given IDs and calculate their checksum accordingly.
     * The files must be in this repository.
     * Existing checksums are checked before being changed.
     * If a checksum does not match, ServerError will be thrown;
     * in this case some other files may already have had their
     * checksum algorithm set.
     * Returns the IDs of the original files that did not already
     * have a checksum set for the given algorithm.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setChecksumAlgorithm(omero.model.ChecksumAlgorithm hasher, java.util.List<Long> ids, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Set the checksum algorithm for the original files identified
     * by the given IDs and calculate their checksum accordingly.
     * The files must be in this repository.
     * Existing checksums are checked before being changed.
     * If a checksum does not match, ServerError will be thrown;
     * in this case some other files may already have had their
     * checksum algorithm set.
     * Returns the IDs of the original files that did not already
     * have a checksum set for the given algorithm.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setChecksumAlgorithm(omero.model.ChecksumAlgorithm hasher, java.util.List<Long> ids, Callback_ManagedRepository_setChecksumAlgorithm __cb);

    /**
     * Set the checksum algorithm for the original files identified
     * by the given IDs and calculate their checksum accordingly.
     * The files must be in this repository.
     * Existing checksums are checked before being changed.
     * If a checksum does not match, ServerError will be thrown;
     * in this case some other files may already have had their
     * checksum algorithm set.
     * Returns the IDs of the original files that did not already
     * have a checksum set for the given algorithm.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setChecksumAlgorithm(omero.model.ChecksumAlgorithm hasher, java.util.List<Long> ids, java.util.Map<String, String> __ctx, Callback_ManagedRepository_setChecksumAlgorithm __cb);

    /**
     * Set the checksum algorithm for the original files identified
     * by the given IDs and calculate their checksum accordingly.
     * The files must be in this repository.
     * Existing checksums are checked before being changed.
     * If a checksum does not match, ServerError will be thrown;
     * in this case some other files may already have had their
     * checksum algorithm set.
     * Returns the IDs of the original files that did not already
     * have a checksum set for the given algorithm.
     * @param __result The asynchronous result object.
     **/
    public java.util.List<Long> end_setChecksumAlgorithm(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Set the checksum algorithm for the original files identified
     * by the given IDs and calculate their checksum accordingly.
     * The files must be in this repository.
     * Existing checksums are checked before being changed.
     * If a checksum does not match, ServerError will be thrown;
     * in this case some other files may already have had their
     * checksum algorithm set.
     * Returns the IDs of the original files that did not already
     * have a checksum set for the given algorithm.
     * @param __cb The callback object for the operation.
     **/
    public boolean setChecksumAlgorithm_async(AMI_ManagedRepository_setChecksumAlgorithm __cb, omero.model.ChecksumAlgorithm hasher, java.util.List<Long> ids);

    /**
     * Set the checksum algorithm for the original files identified
     * by the given IDs and calculate their checksum accordingly.
     * The files must be in this repository.
     * Existing checksums are checked before being changed.
     * If a checksum does not match, ServerError will be thrown;
     * in this case some other files may already have had their
     * checksum algorithm set.
     * Returns the IDs of the original files that did not already
     * have a checksum set for the given algorithm.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setChecksumAlgorithm_async(AMI_ManagedRepository_setChecksumAlgorithm __cb, omero.model.ChecksumAlgorithm hasher, java.util.List<Long> ids, java.util.Map<String, String> __ctx);
}
