// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Scripts.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * A single parameter to a Job. For example, used by
 * ScriptJobs to define what the input and output
 * environment variables should be. Helper classes are available
 * in the Python omero.scripts module, so that the following are
 * equivalent:
 * 
 * <pre># 1
 * a = omero.grid.Params()
 * a.optional = True
 * a.prototype = omero.rtypes.rstring("")
 * a.description = "An optional string which will be ignored by the script"
 * omero.scripts.client(inputs = {"a":a})
 * </pre>
 * 
 * <pre># 2
 * a = omero.scripts.String("a", optional=True, description=         * "An optional string which will be ignored by the script")
 * omero.scripts.client(a)
 * </pre>
 * 
 * For advanced setters not available on the Type classes (like omero.script.String)
 * use the getter type.param() and then set values directly.
 * 
 * <pre>
 * a = omero.scripts.String("a")
 * a.param().values = \["hi", "bye"]
 * </pre>
 **/
public class Param extends Ice.ObjectImpl
{
    public Param()
    {
    }

    public Param(String description, boolean optional, boolean useDefault, omero.RType prototype, omero.RType min, omero.RType max, omero.RList values, String grouping, java.util.List<String> namespaces)
    {
        this.description = description;
        this.optional = optional;
        this.useDefault = useDefault;
        this.prototype = prototype;
        this.min = min;
        this.max = max;
        this.values = values;
        this.grouping = grouping;
        this.namespaces = namespaces;
    }

    private static class __F implements Ice.ObjectFactory
    {
        public Ice.Object create(String type)
        {
            assert(type.equals(ice_staticId()));
            return new Param();
        }

        public void destroy()
        {
        }
    }
    private static Ice.ObjectFactory _factory = new __F();

    public static Ice.ObjectFactory
    ice_factory()
    {
        return _factory;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::Param"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.writeString(description);
        __os.writeBool(optional);
        __os.writeBool(useDefault);
        __os.writeObject(prototype);
        __os.writeObject(min);
        __os.writeObject(max);
        __os.writeObject(values);
        __os.writeString(grouping);
        omero.api.StringSetHelper.write(__os, namespaces);
        __os.endWriteSlice();
    }

    private class Patcher implements IceInternal.Patcher
    {
        Patcher(int member)
        {
            __member = member;
        }

        public void
        patch(Ice.Object v)
        {
            switch(__member)
            {
            case 0:
                __typeId = "::omero::RType";
                if(v == null || v instanceof omero.RType)
                {
                    prototype = (omero.RType)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            case 1:
                __typeId = "::omero::RType";
                if(v == null || v instanceof omero.RType)
                {
                    min = (omero.RType)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            case 2:
                __typeId = "::omero::RType";
                if(v == null || v instanceof omero.RType)
                {
                    max = (omero.RType)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            case 3:
                __typeId = "::omero::RList";
                if(v == null || v instanceof omero.RList)
                {
                    values = (omero.RList)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            }
        }

        public String
        type()
        {
            return __typeId;
        }

        private int __member;
        private String __typeId;
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        description = __is.readString();
        optional = __is.readBool();
        useDefault = __is.readBool();
        __is.readObject(new Patcher(0));
        __is.readObject(new Patcher(1));
        __is.readObject(new Patcher(2));
        __is.readObject(new Patcher(3));
        grouping = __is.readString();
        namespaces = omero.api.StringSetHelper.read(__is);
        __is.endReadSlice();
    }

    /**
     * Usage documentation of this param for script users.
     * 
     * Example of a bad description: ""a long value""
     * 
     * Example of a good description: ""long representing
     * the number of bins to be used by <some algorithm>. A sensible
     * value would be between 16 and 32""
     * 
     **/
    public String description;

    /**
     * Whether or not a script will require this value to be present
     * in the input or output. If an input is missing or None when
     * non-optional, then a {@link omero.ValidationException} will be
     * thrown on {@link #processJob}. A missing output param will be
     * marked after execution.
     **/
    public boolean optional;

    /**
     * Whether or not the prototype should be used as a default.
     * If true, then if the value is missing from the input OR
     * output values, the prototype will be substituted.
     * 
     * <pre>
     * param = ...;
     * inputs = ...;
     * if name in inputs:
     * value = inputs\[name]
     * elif param.inputs\[name].useDefault:
     * value = param.inputs\[name].prototype
     * </pre>
     **/
    public boolean useDefault;

    /**
     * {@link omero.RType} which represents what the input or output
     * value should look like. If this is a collection type (i.e.
     * {@link omero.RCollection} or {@link omero.RMap} or their
     * subclasses), then the first contents of the collection will be
     * used (recursively).
     * 
     * <pre>
     * param.prototype = rlist(rlist(rstring)))
     * </pre>
     * requires that a list of list of strings be passed.
     **/
    public omero.RType prototype;

    /**
     * Minimum value which an input may contain. If the prototype
     * is a collection type, then the min type must match the type
     * of the innermost non-collection instance.
     * 
     * For example,
     * <pre>
     * param.prototype = rlong(0)
     * param.min = rlong(-5)
     * </pre>
     * but
     * <pre>
     * param.prototype = rlist(rlong(0))
     * param.min = rlong(-5)
     * </pre>
     **/
    public omero.RType min;

    /**
     * Maximum value which an input may contain. If the prototype
     * is a collection type, then the max type must match the type
     * of the innermost non-collection instance.
     * 
     * For example,
     * <pre>
     * param.prototype = rlong(0)
     * param.max = rlong(5)
     * </pre>
     * but
     * <pre>
     * param.prototype = rlist(rlong(0))
     * param.max = rlong(5)
     * </pre>
     **/
    public omero.RType max;

    /**
     * An enumeration of acceptable values which can be used
     * for this parameter. If {@link #min} and {@link #max} are set,
     * this value will be ignored. If {@link prototype} is an
     * {@link omero.RCollection} or {@link omero.RMap} instance, then
     * the values in this {@link omero.RList} will be of the member
     * types of the collection or map, and not a collection or map
     * instance.
     **/
    public omero.RList values;

    /**
     * Defines the grouping strategy for this {@link Param}.
     * 
     * <p>
     * A set of {@link Param} objects in a single {@link JobParams} can
     * use dot notation to specify that they belong together,
     * and in which order they should be presented to the user.
     * </p>
     * 
     * <pre>
     * inputs = {"a" : Param(..., grouping = "1.1"),
     * "b" : Param(..., grouping = "1.2"),
     * "c" : Param(..., grouping = "2.2"),
     * "d" : Param(..., grouping = "2.1")}
     * </pre>
     * defines two groups of parameters which might be
     * display to the user so:
     * 
     * <pre>
     * Group 1:                  Group 2:
     * +-----------------------+ +-----------------------+
     * | a:                    | | d:                    |
     * +-----------------------+ +-----------------------+
     * | b:                    | | c:                    |
     * +-----------------------+ +-----------------------+
     * </pre>
     * 
     * <p>
     * Further dots (e.g. "1.2.3.5") can be used to specify
     * deeper trees of parameters.
     * </p>
     * 
     * <p>
     * By most clients, Params missing grouping values (e.g. "") will
     * be ordered <em>after</em> params with grouping values.
     * </p>
     * 
     * <p>
     * A group which has a boolean as the top-level object
     * can be thought of as a checkbox which turns on or off
     * all of the other group members. For example,
     * </p>
     * 
     * <pre>
     * inputs = {"Image_Ids" : Param(prototype=rlist(), grouping = "1"),
     * "Scale_Bar" : Param(prototype=rbool(), grouping = "2"),
     * "Color"     : Param(prototype=rinternal(Color()), grouping = "2.1"),
     * "Size"      : Param(prototype=rlong(), grouping = "2.2")}
     * </pre>
     * 
     * <p>
     * might be displayed as:
     * </p>
     * 
     * <pre>
     * 
     * Scale Bar: \[ on/off ]
     * ======================
     * Color:  \[rgb]
     * Size:   \[ 10]
     * 
     * </pre>
     * 
     **/
    public String grouping;

    /**
     * Defines machine readable interpretations for this parameter.
     * 
     * <p>
     * Where the description field should provide information for
     * users, the assigned namespaces can define how clients may
     * interpret the param.
     * </p>
     * 
     * <p>
     * {@link omero.constants.namespaces.NSDOWNLOAD}, for example,
     * indicates that users may want to download the resulting
     * file. The {@link #prototype} of the {@link Param} should be one
     * of: {@link omero.model.OriginalFile},
     * {@link omero.model.FileAnnotation},
     * or an annotation link (like
     * {@link omero.model.ImageAnnotationLink})
     * which points to a file annotation.
     * </p>
     **/
    public java.util.List<String> namespaces;

    public static final long serialVersionUID = -5167398490128068452L;
}
