// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Scripts.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * A single parameter to a Job. For example, used by
 * ScriptJobs to define what the input and output
 * environment variables should be. Helper classes are available
 * in the Python omero.scripts module, so that the following are
 * equivalent:
 * 
 * <pre># 1
 * a = omero.grid.Params()
 * a.optional = True
 * a.prototype = omero.rtypes.rstring("")
 * a.description = "An optional string which will be ignored by the script"
 * omero.scripts.client(inputs = {"a":a})
 * </pre>
 * 
 * <pre># 2
 * a = omero.scripts.String("a", optional=True, description=         * "An optional string which will be ignored by the script")
 * omero.scripts.client(a)
 * </pre>
 * 
 * For advanced setters not available on the Type classes (like omero.script.String)
 * use the getter type.param() and then set values directly.
 * 
 * <pre>
 * a = omero.scripts.String("a")
 * a.param().values = \["hi", "bye"]
 * </pre>
 **/
public final class ParamPrxHelper extends Ice.ObjectPrxHelperBase implements ParamPrx
{
    public static ParamPrx checkedCast(Ice.ObjectPrx __obj)
    {
        ParamPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ParamPrx)
            {
                __d = (ParamPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    ParamPrxHelper __h = new ParamPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ParamPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        ParamPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ParamPrx)
            {
                __d = (ParamPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    ParamPrxHelper __h = new ParamPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ParamPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ParamPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    ParamPrxHelper __h = new ParamPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ParamPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        ParamPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    ParamPrxHelper __h = new ParamPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ParamPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        ParamPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ParamPrx)
            {
                __d = (ParamPrx)__obj;
            }
            else
            {
                ParamPrxHelper __h = new ParamPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static ParamPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ParamPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            ParamPrxHelper __h = new ParamPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::Param"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _ParamDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _ParamDelD();
    }

    public static void __write(IceInternal.BasicStream __os, ParamPrx v)
    {
        __os.writeProxy(v);
    }

    public static ParamPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            ParamPrxHelper result = new ParamPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
