// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Scripts.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Callback which can be attached to a Process
 * with notification of any of the possible
 * ends-of-life that a Process might experience
 **/
public interface ProcessCallbackPrx extends Ice.ObjectPrx
{
    /**
     * Process terminated normally. Return code provided.
     * In the case that a non-Blitz process sent a signal
     * (KILL, TERM, ... ), that will represented in the
     * return code.
     **/
    public void processFinished(int returncode);

    /**
     * Process terminated normally. Return code provided.
     * In the case that a non-Blitz process sent a signal
     * (KILL, TERM, ... ), that will represented in the
     * return code.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void processFinished(int returncode, java.util.Map<String, String> __ctx);

    /**
     * Process terminated normally. Return code provided.
     * In the case that a non-Blitz process sent a signal
     * (KILL, TERM, ... ), that will represented in the
     * return code.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processFinished(int returncode);

    /**
     * Process terminated normally. Return code provided.
     * In the case that a non-Blitz process sent a signal
     * (KILL, TERM, ... ), that will represented in the
     * return code.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processFinished(int returncode, java.util.Map<String, String> __ctx);

    /**
     * Process terminated normally. Return code provided.
     * In the case that a non-Blitz process sent a signal
     * (KILL, TERM, ... ), that will represented in the
     * return code.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processFinished(int returncode, Ice.Callback __cb);

    /**
     * Process terminated normally. Return code provided.
     * In the case that a non-Blitz process sent a signal
     * (KILL, TERM, ... ), that will represented in the
     * return code.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processFinished(int returncode, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Process terminated normally. Return code provided.
     * In the case that a non-Blitz process sent a signal
     * (KILL, TERM, ... ), that will represented in the
     * return code.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processFinished(int returncode, Callback_ProcessCallback_processFinished __cb);

    /**
     * Process terminated normally. Return code provided.
     * In the case that a non-Blitz process sent a signal
     * (KILL, TERM, ... ), that will represented in the
     * return code.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processFinished(int returncode, java.util.Map<String, String> __ctx, Callback_ProcessCallback_processFinished __cb);

    /**
     * Process terminated normally. Return code provided.
     * In the case that a non-Blitz process sent a signal
     * (KILL, TERM, ... ), that will represented in the
     * return code.
     * @param __result The asynchronous result object.
     **/
    public void end_processFinished(Ice.AsyncResult __result);

    /**
     * Process terminated normally. Return code provided.
     * In the case that a non-Blitz process sent a signal
     * (KILL, TERM, ... ), that will represented in the
     * return code.
     * @param __cb The callback object for the operation.
     **/
    public boolean processFinished_async(AMI_ProcessCallback_processFinished __cb, int returncode);

    /**
     * Process terminated normally. Return code provided.
     * In the case that a non-Blitz process sent a signal
     * (KILL, TERM, ... ), that will represented in the
     * return code.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean processFinished_async(AMI_ProcessCallback_processFinished __cb, int returncode, java.util.Map<String, String> __ctx);

    /**
     * cancel() was called on this Process. If the Process
     * failed to terminate, argument is false, in which calling
     * kill() is the last resort.
     **/
    public void processCancelled(boolean success);

    /**
     * cancel() was called on this Process. If the Process
     * failed to terminate, argument is false, in which calling
     * kill() is the last resort.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void processCancelled(boolean success, java.util.Map<String, String> __ctx);

    /**
     * cancel() was called on this Process. If the Process
     * failed to terminate, argument is false, in which calling
     * kill() is the last resort.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processCancelled(boolean success);

    /**
     * cancel() was called on this Process. If the Process
     * failed to terminate, argument is false, in which calling
     * kill() is the last resort.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processCancelled(boolean success, java.util.Map<String, String> __ctx);

    /**
     * cancel() was called on this Process. If the Process
     * failed to terminate, argument is false, in which calling
     * kill() is the last resort.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processCancelled(boolean success, Ice.Callback __cb);

    /**
     * cancel() was called on this Process. If the Process
     * failed to terminate, argument is false, in which calling
     * kill() is the last resort.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processCancelled(boolean success, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * cancel() was called on this Process. If the Process
     * failed to terminate, argument is false, in which calling
     * kill() is the last resort.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processCancelled(boolean success, Callback_ProcessCallback_processCancelled __cb);

    /**
     * cancel() was called on this Process. If the Process
     * failed to terminate, argument is false, in which calling
     * kill() is the last resort.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processCancelled(boolean success, java.util.Map<String, String> __ctx, Callback_ProcessCallback_processCancelled __cb);

    /**
     * cancel() was called on this Process. If the Process
     * failed to terminate, argument is false, in which calling
     * kill() is the last resort.
     * @param __result The asynchronous result object.
     **/
    public void end_processCancelled(Ice.AsyncResult __result);

    /**
     * cancel() was called on this Process. If the Process
     * failed to terminate, argument is false, in which calling
     * kill() is the last resort.
     * @param __cb The callback object for the operation.
     **/
    public boolean processCancelled_async(AMI_ProcessCallback_processCancelled __cb, boolean success);

    /**
     * cancel() was called on this Process. If the Process
     * failed to terminate, argument is false, in which calling
     * kill() is the last resort.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean processCancelled_async(AMI_ProcessCallback_processCancelled __cb, boolean success, java.util.Map<String, String> __ctx);

    /**
     * kill() was called on this Process. If this does not
     * succeed, there is nothing else that Blitz can do to
     * stop its execution.
     **/
    public void processKilled(boolean success);

    /**
     * kill() was called on this Process. If this does not
     * succeed, there is nothing else that Blitz can do to
     * stop its execution.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void processKilled(boolean success, java.util.Map<String, String> __ctx);

    /**
     * kill() was called on this Process. If this does not
     * succeed, there is nothing else that Blitz can do to
     * stop its execution.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processKilled(boolean success);

    /**
     * kill() was called on this Process. If this does not
     * succeed, there is nothing else that Blitz can do to
     * stop its execution.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processKilled(boolean success, java.util.Map<String, String> __ctx);

    /**
     * kill() was called on this Process. If this does not
     * succeed, there is nothing else that Blitz can do to
     * stop its execution.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processKilled(boolean success, Ice.Callback __cb);

    /**
     * kill() was called on this Process. If this does not
     * succeed, there is nothing else that Blitz can do to
     * stop its execution.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processKilled(boolean success, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * kill() was called on this Process. If this does not
     * succeed, there is nothing else that Blitz can do to
     * stop its execution.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processKilled(boolean success, Callback_ProcessCallback_processKilled __cb);

    /**
     * kill() was called on this Process. If this does not
     * succeed, there is nothing else that Blitz can do to
     * stop its execution.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processKilled(boolean success, java.util.Map<String, String> __ctx, Callback_ProcessCallback_processKilled __cb);

    /**
     * kill() was called on this Process. If this does not
     * succeed, there is nothing else that Blitz can do to
     * stop its execution.
     * @param __result The asynchronous result object.
     **/
    public void end_processKilled(Ice.AsyncResult __result);

    /**
     * kill() was called on this Process. If this does not
     * succeed, there is nothing else that Blitz can do to
     * stop its execution.
     * @param __cb The callback object for the operation.
     **/
    public boolean processKilled_async(AMI_ProcessCallback_processKilled __cb, boolean success);

    /**
     * kill() was called on this Process. If this does not
     * succeed, there is nothing else that Blitz can do to
     * stop its execution.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean processKilled_async(AMI_ProcessCallback_processKilled __cb, boolean success, java.util.Map<String, String> __ctx);
}
