// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Scripts.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Thin wrapper around a system-level process. Most closely
 * resembles Python's subprocess.Popen class.
 **/
public final class ProcessPrxHelper extends Ice.ObjectPrxHelperBase implements ProcessPrx
{
    private static final String __cancel_name = "cancel";

    /**
     * Signal to the Process that it should terminate. This may
     * be done "softly" for a given time period.
     **/
    public boolean cancel()
        throws omero.ServerError
    {
        return cancel(null, false);
    }

    /**
     * Signal to the Process that it should terminate. This may
     * be done "softly" for a given time period.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean cancel(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return cancel(__ctx, true);
    }

    private boolean cancel(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "cancel", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("cancel");
                    __delBase = __getDelegate(false);
                    _ProcessDel __del = (_ProcessDel)__delBase;
                    return __del.cancel(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Signal to the Process that it should terminate. This may
     * be done "softly" for a given time period.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_cancel()
    {
        return begin_cancel(null, false, null);
    }

    /**
     * Signal to the Process that it should terminate. This may
     * be done "softly" for a given time period.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_cancel(java.util.Map<String, String> __ctx)
    {
        return begin_cancel(__ctx, true, null);
    }

    /**
     * Signal to the Process that it should terminate. This may
     * be done "softly" for a given time period.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_cancel(Ice.Callback __cb)
    {
        return begin_cancel(null, false, __cb);
    }

    /**
     * Signal to the Process that it should terminate. This may
     * be done "softly" for a given time period.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_cancel(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_cancel(__ctx, true, __cb);
    }

    /**
     * Signal to the Process that it should terminate. This may
     * be done "softly" for a given time period.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_cancel(Callback_Process_cancel __cb)
    {
        return begin_cancel(null, false, __cb);
    }

    /**
     * Signal to the Process that it should terminate. This may
     * be done "softly" for a given time period.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_cancel(java.util.Map<String, String> __ctx, Callback_Process_cancel __cb)
    {
        return begin_cancel(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_cancel(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__cancel_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __cancel_name, __cb);
        try
        {
            __result.__prepare(__cancel_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_cancel(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __cancel_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Signal to the Process that it should terminate. This may
     * be done "softly" for a given time period.
     * @param __cb The callback object for the operation.
     **/
    public boolean cancel_async(AMI_Process_cancel __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__cancel_name);
            __r = begin_cancel(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __cancel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Signal to the Process that it should terminate. This may
     * be done "softly" for a given time period.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean cancel_async(AMI_Process_cancel __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__cancel_name);
            __r = begin_cancel(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __cancel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __kill_name = "kill";

    /**
     * Terminate the Process immediately.
     **/
    public boolean kill()
    {
        return kill(null, false);
    }

    /**
     * Terminate the Process immediately.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean kill(java.util.Map<String, String> __ctx)
    {
        return kill(__ctx, true);
    }

    private boolean kill(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "kill", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("kill");
                    __delBase = __getDelegate(false);
                    _ProcessDel __del = (_ProcessDel)__delBase;
                    return __del.kill(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Terminate the Process immediately.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_kill()
    {
        return begin_kill(null, false, null);
    }

    /**
     * Terminate the Process immediately.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_kill(java.util.Map<String, String> __ctx)
    {
        return begin_kill(__ctx, true, null);
    }

    /**
     * Terminate the Process immediately.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_kill(Ice.Callback __cb)
    {
        return begin_kill(null, false, __cb);
    }

    /**
     * Terminate the Process immediately.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_kill(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_kill(__ctx, true, __cb);
    }

    /**
     * Terminate the Process immediately.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_kill(Callback_Process_kill __cb)
    {
        return begin_kill(null, false, __cb);
    }

    /**
     * Terminate the Process immediately.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_kill(java.util.Map<String, String> __ctx, Callback_Process_kill __cb)
    {
        return begin_kill(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_kill(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__kill_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __kill_name, __cb);
        try
        {
            __result.__prepare(__kill_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_kill(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __kill_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Terminate the Process immediately.
     * @param __cb The callback object for the operation.
     **/
    public boolean kill_async(AMI_Process_kill __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__kill_name);
            __r = begin_kill(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __kill_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Terminate the Process immediately.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean kill_async(AMI_Process_kill __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__kill_name);
            __r = begin_kill(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __kill_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __poll_name = "poll";

    /**
     * Returns the return code of the process, or null
     * if unfinished.
     **/
    public omero.RInt poll()
        throws omero.ServerError
    {
        return poll(null, false);
    }

    /**
     * Returns the return code of the process, or null
     * if unfinished.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.RInt poll(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return poll(__ctx, true);
    }

    private omero.RInt poll(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "poll", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("poll");
                    __delBase = __getDelegate(false);
                    _ProcessDel __del = (_ProcessDel)__delBase;
                    return __del.poll(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the return code of the process, or null
     * if unfinished.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_poll()
    {
        return begin_poll(null, false, null);
    }

    /**
     * Returns the return code of the process, or null
     * if unfinished.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_poll(java.util.Map<String, String> __ctx)
    {
        return begin_poll(__ctx, true, null);
    }

    /**
     * Returns the return code of the process, or null
     * if unfinished.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_poll(Ice.Callback __cb)
    {
        return begin_poll(null, false, __cb);
    }

    /**
     * Returns the return code of the process, or null
     * if unfinished.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_poll(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_poll(__ctx, true, __cb);
    }

    /**
     * Returns the return code of the process, or null
     * if unfinished.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_poll(Callback_Process_poll __cb)
    {
        return begin_poll(null, false, __cb);
    }

    /**
     * Returns the return code of the process, or null
     * if unfinished.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_poll(java.util.Map<String, String> __ctx, Callback_Process_poll __cb)
    {
        return begin_poll(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_poll(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__poll_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __poll_name, __cb);
        try
        {
            __result.__prepare(__poll_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.RInt end_poll(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __poll_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.RIntHolder __ret = new omero.RIntHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the return code of the process, or null
     * if unfinished.
     * @param __cb The callback object for the operation.
     **/
    public boolean poll_async(AMI_Process_poll __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__poll_name);
            __r = begin_poll(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __poll_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the return code of the process, or null
     * if unfinished.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean poll_async(AMI_Process_poll __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__poll_name);
            __r = begin_poll(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __poll_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __registerCallback_name = "registerCallback";

    /**
     * Add a callback for end-of-life events
     **/
    public void registerCallback(ProcessCallbackPrx cb)
        throws omero.ServerError
    {
        registerCallback(cb, null, false);
    }

    /**
     * Add a callback for end-of-life events
     * @param __ctx The Context map to send with the invocation.
     **/
    public void registerCallback(ProcessCallbackPrx cb, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        registerCallback(cb, __ctx, true);
    }

    private void registerCallback(ProcessCallbackPrx cb, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "registerCallback", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("registerCallback");
                    __delBase = __getDelegate(false);
                    _ProcessDel __del = (_ProcessDel)__delBase;
                    __del.registerCallback(cb, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Add a callback for end-of-life events
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_registerCallback(ProcessCallbackPrx cb)
    {
        return begin_registerCallback(cb, null, false, null);
    }

    /**
     * Add a callback for end-of-life events
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_registerCallback(ProcessCallbackPrx cb, java.util.Map<String, String> __ctx)
    {
        return begin_registerCallback(cb, __ctx, true, null);
    }

    /**
     * Add a callback for end-of-life events
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_registerCallback(ProcessCallbackPrx cb, Ice.Callback __cb)
    {
        return begin_registerCallback(cb, null, false, __cb);
    }

    /**
     * Add a callback for end-of-life events
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_registerCallback(ProcessCallbackPrx cb, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_registerCallback(cb, __ctx, true, __cb);
    }

    /**
     * Add a callback for end-of-life events
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_registerCallback(ProcessCallbackPrx cb, Callback_Process_registerCallback __cb)
    {
        return begin_registerCallback(cb, null, false, __cb);
    }

    /**
     * Add a callback for end-of-life events
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_registerCallback(ProcessCallbackPrx cb, java.util.Map<String, String> __ctx, Callback_Process_registerCallback __cb)
    {
        return begin_registerCallback(cb, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_registerCallback(ProcessCallbackPrx cb, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__registerCallback_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __registerCallback_name, __cb);
        try
        {
            __result.__prepare(__registerCallback_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            ProcessCallbackPrxHelper.__write(__os, cb);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_registerCallback(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __registerCallback_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Add a callback for end-of-life events
     * @param __cb The callback object for the operation.
     **/
    public boolean registerCallback_async(AMI_Process_registerCallback __cb, ProcessCallbackPrx cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__registerCallback_name);
            __r = begin_registerCallback(cb, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __registerCallback_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Add a callback for end-of-life events
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean registerCallback_async(AMI_Process_registerCallback __cb, ProcessCallbackPrx cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__registerCallback_name);
            __r = begin_registerCallback(cb, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __registerCallback_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __shutdown_name = "shutdown";

    /**
     * First attempts cancel() several times and finally
     * resorts to kill to force the process to shutdown
     * cleanly. This method doesn't return any value or
     * throw an exception so that it can be called oneway.
     **/
    public void shutdown()
    {
        shutdown(null, false);
    }

    /**
     * First attempts cancel() several times and finally
     * resorts to kill to force the process to shutdown
     * cleanly. This method doesn't return any value or
     * throw an exception so that it can be called oneway.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void shutdown(java.util.Map<String, String> __ctx)
    {
        shutdown(__ctx, true);
    }

    private void shutdown(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "shutdown", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _ProcessDel __del = (_ProcessDel)__delBase;
                    __del.shutdown(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * First attempts cancel() several times and finally
     * resorts to kill to force the process to shutdown
     * cleanly. This method doesn't return any value or
     * throw an exception so that it can be called oneway.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_shutdown()
    {
        return begin_shutdown(null, false, null);
    }

    /**
     * First attempts cancel() several times and finally
     * resorts to kill to force the process to shutdown
     * cleanly. This method doesn't return any value or
     * throw an exception so that it can be called oneway.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_shutdown(java.util.Map<String, String> __ctx)
    {
        return begin_shutdown(__ctx, true, null);
    }

    /**
     * First attempts cancel() several times and finally
     * resorts to kill to force the process to shutdown
     * cleanly. This method doesn't return any value or
     * throw an exception so that it can be called oneway.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_shutdown(Ice.Callback __cb)
    {
        return begin_shutdown(null, false, __cb);
    }

    /**
     * First attempts cancel() several times and finally
     * resorts to kill to force the process to shutdown
     * cleanly. This method doesn't return any value or
     * throw an exception so that it can be called oneway.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_shutdown(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_shutdown(__ctx, true, __cb);
    }

    /**
     * First attempts cancel() several times and finally
     * resorts to kill to force the process to shutdown
     * cleanly. This method doesn't return any value or
     * throw an exception so that it can be called oneway.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_shutdown(Callback_Process_shutdown __cb)
    {
        return begin_shutdown(null, false, __cb);
    }

    /**
     * First attempts cancel() several times and finally
     * resorts to kill to force the process to shutdown
     * cleanly. This method doesn't return any value or
     * throw an exception so that it can be called oneway.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_shutdown(java.util.Map<String, String> __ctx, Callback_Process_shutdown __cb)
    {
        return begin_shutdown(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_shutdown(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __shutdown_name, __cb);
        try
        {
            __result.__prepare(__shutdown_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_shutdown(Ice.AsyncResult __result)
    {
        __end(__result, __shutdown_name);
    }

    /**
     * First attempts cancel() several times and finally
     * resorts to kill to force the process to shutdown
     * cleanly. This method doesn't return any value or
     * throw an exception so that it can be called oneway.
     * @param __cb The callback object for the operation.
     **/
    public boolean shutdown_async(AMI_Process_shutdown __cb)
    {
        Ice.AsyncResult __r = begin_shutdown(null, false, __cb);
        return __r.sentSynchronously();
    }

    /**
     * First attempts cancel() several times and finally
     * resorts to kill to force the process to shutdown
     * cleanly. This method doesn't return any value or
     * throw an exception so that it can be called oneway.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean shutdown_async(AMI_Process_shutdown __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r = begin_shutdown(__ctx, true, __cb);
        return __r.sentSynchronously();
    }

    private static final String __unregisterCallback_name = "unregisterCallback";

    /**
     * Remove a callback for end-of-life events
     **/
    public void unregisterCallback(ProcessCallbackPrx cb)
        throws omero.ServerError
    {
        unregisterCallback(cb, null, false);
    }

    /**
     * Remove a callback for end-of-life events
     * @param __ctx The Context map to send with the invocation.
     **/
    public void unregisterCallback(ProcessCallbackPrx cb, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        unregisterCallback(cb, __ctx, true);
    }

    private void unregisterCallback(ProcessCallbackPrx cb, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "unregisterCallback", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("unregisterCallback");
                    __delBase = __getDelegate(false);
                    _ProcessDel __del = (_ProcessDel)__delBase;
                    __del.unregisterCallback(cb, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Remove a callback for end-of-life events
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_unregisterCallback(ProcessCallbackPrx cb)
    {
        return begin_unregisterCallback(cb, null, false, null);
    }

    /**
     * Remove a callback for end-of-life events
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_unregisterCallback(ProcessCallbackPrx cb, java.util.Map<String, String> __ctx)
    {
        return begin_unregisterCallback(cb, __ctx, true, null);
    }

    /**
     * Remove a callback for end-of-life events
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_unregisterCallback(ProcessCallbackPrx cb, Ice.Callback __cb)
    {
        return begin_unregisterCallback(cb, null, false, __cb);
    }

    /**
     * Remove a callback for end-of-life events
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_unregisterCallback(ProcessCallbackPrx cb, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_unregisterCallback(cb, __ctx, true, __cb);
    }

    /**
     * Remove a callback for end-of-life events
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_unregisterCallback(ProcessCallbackPrx cb, Callback_Process_unregisterCallback __cb)
    {
        return begin_unregisterCallback(cb, null, false, __cb);
    }

    /**
     * Remove a callback for end-of-life events
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_unregisterCallback(ProcessCallbackPrx cb, java.util.Map<String, String> __ctx, Callback_Process_unregisterCallback __cb)
    {
        return begin_unregisterCallback(cb, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_unregisterCallback(ProcessCallbackPrx cb, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__unregisterCallback_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __unregisterCallback_name, __cb);
        try
        {
            __result.__prepare(__unregisterCallback_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            ProcessCallbackPrxHelper.__write(__os, cb);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_unregisterCallback(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __unregisterCallback_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Remove a callback for end-of-life events
     * @param __cb The callback object for the operation.
     **/
    public boolean unregisterCallback_async(AMI_Process_unregisterCallback __cb, ProcessCallbackPrx cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__unregisterCallback_name);
            __r = begin_unregisterCallback(cb, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __unregisterCallback_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Remove a callback for end-of-life events
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean unregisterCallback_async(AMI_Process_unregisterCallback __cb, ProcessCallbackPrx cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__unregisterCallback_name);
            __r = begin_unregisterCallback(cb, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __unregisterCallback_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __wait_name = "wait";

    /**
     * Blocks until poll() would return a non-null return code.
     **/
    public int _wait()
        throws omero.ServerError
    {
        return _wait(null, false);
    }

    /**
     * Blocks until poll() would return a non-null return code.
     * @param __ctx The Context map to send with the invocation.
     **/
    public int _wait(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return _wait(__ctx, true);
    }

    private int _wait(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "_wait", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("_wait");
                    __delBase = __getDelegate(false);
                    _ProcessDel __del = (_ProcessDel)__delBase;
                    return __del._wait(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Blocks until poll() would return a non-null return code.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_wait()
    {
        return begin_wait(null, false, null);
    }

    /**
     * Blocks until poll() would return a non-null return code.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_wait(java.util.Map<String, String> __ctx)
    {
        return begin_wait(__ctx, true, null);
    }

    /**
     * Blocks until poll() would return a non-null return code.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_wait(Ice.Callback __cb)
    {
        return begin_wait(null, false, __cb);
    }

    /**
     * Blocks until poll() would return a non-null return code.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_wait(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_wait(__ctx, true, __cb);
    }

    /**
     * Blocks until poll() would return a non-null return code.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_wait(Callback_Process_wait __cb)
    {
        return begin_wait(null, false, __cb);
    }

    /**
     * Blocks until poll() would return a non-null return code.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_wait(java.util.Map<String, String> __ctx, Callback_Process_wait __cb)
    {
        return begin_wait(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_wait(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__wait_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __wait_name, __cb);
        try
        {
            __result.__prepare(__wait_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public int end_wait(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __wait_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int __ret;
            __ret = __is.readInt();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Blocks until poll() would return a non-null return code.
     * @param __cb The callback object for the operation.
     **/
    public boolean wait_async(AMI_Process_wait __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__wait_name);
            __r = begin_wait(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __wait_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Blocks until poll() would return a non-null return code.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean wait_async(AMI_Process_wait __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__wait_name);
            __r = begin_wait(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __wait_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static ProcessPrx checkedCast(Ice.ObjectPrx __obj)
    {
        ProcessPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ProcessPrx)
            {
                __d = (ProcessPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    ProcessPrxHelper __h = new ProcessPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ProcessPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        ProcessPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ProcessPrx)
            {
                __d = (ProcessPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    ProcessPrxHelper __h = new ProcessPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ProcessPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ProcessPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    ProcessPrxHelper __h = new ProcessPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ProcessPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        ProcessPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    ProcessPrxHelper __h = new ProcessPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ProcessPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        ProcessPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ProcessPrx)
            {
                __d = (ProcessPrx)__obj;
            }
            else
            {
                ProcessPrxHelper __h = new ProcessPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static ProcessPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ProcessPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            ProcessPrxHelper __h = new ProcessPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::Process"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _ProcessDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _ProcessDelD();
    }

    public static void __write(IceInternal.BasicStream __os, ProcessPrx v)
    {
        __os.writeProxy(v);
    }

    public static ProcessPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            ProcessPrxHelper result = new ProcessPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
