// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Scripts.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Simple controller for Processes. Uses the session
 * id given to create an Ice.Config file which is used
 * as the sole argument to an execution of the given job.
 * 
 * Jobs are responsible for loading arguments from the
 * environment via the session id.
 **/
public interface ProcessorPrx extends Ice.ObjectPrx
{
    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     **/
    public void willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb);

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx);

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb);

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx);

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb, Ice.Callback __cb);

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb, Callback_Processor_willAccept __cb);

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx, Callback_Processor_willAccept __cb);

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __result The asynchronous result object.
     **/
    public void end_willAccept(Ice.AsyncResult __result);

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __cb The callback object for the operation.
     **/
    public boolean willAccept_async(AMI_Processor_willAccept __cb, omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb);

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean willAccept_async(AMI_Processor_willAccept __cb, omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx);

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     **/
    public void requestRunning(ProcessorCallbackPrx cb);

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __ctx The Context map to send with the invocation.
     **/
    public void requestRunning(ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx);

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requestRunning(ProcessorCallbackPrx cb);

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requestRunning(ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx);

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requestRunning(ProcessorCallbackPrx cb, Ice.Callback __cb);

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requestRunning(ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requestRunning(ProcessorCallbackPrx cb, Callback_Processor_requestRunning __cb);

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_requestRunning(ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx, Callback_Processor_requestRunning __cb);

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __result The asynchronous result object.
     **/
    public void end_requestRunning(Ice.AsyncResult __result);

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __cb The callback object for the operation.
     **/
    public boolean requestRunning_async(AMI_Processor_requestRunning __cb, ProcessorCallbackPrx cb);

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean requestRunning_async(AMI_Processor_requestRunning __cb, ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx);

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     **/
    public JobParams parseJob(String session, omero.model.Job jobObject)
        throws omero.ServerError;

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __ctx The Context map to send with the invocation.
     **/
    public JobParams parseJob(String session, omero.model.Job jobObject, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_parseJob(String session, omero.model.Job jobObject);

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_parseJob(String session, omero.model.Job jobObject, java.util.Map<String, String> __ctx);

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_parseJob(String session, omero.model.Job jobObject, Ice.Callback __cb);

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_parseJob(String session, omero.model.Job jobObject, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_parseJob(String session, omero.model.Job jobObject, Callback_Processor_parseJob __cb);

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_parseJob(String session, omero.model.Job jobObject, java.util.Map<String, String> __ctx, Callback_Processor_parseJob __cb);

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __result The asynchronous result object.
     **/
    public JobParams end_parseJob(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __cb The callback object for the operation.
     **/
    public boolean parseJob_async(AMI_Processor_parseJob __cb, String session, omero.model.Job jobObject);

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean parseJob_async(AMI_Processor_parseJob __cb, String session, omero.model.Job jobObject, java.util.Map<String, String> __ctx);

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     **/
    public ProcessPrx processJob(String session, JobParams params, omero.model.Job jobObject)
        throws omero.ServerError;

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public ProcessPrx processJob(String session, JobParams params, omero.model.Job jobObject, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processJob(String session, JobParams params, omero.model.Job jobObject);

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processJob(String session, JobParams params, omero.model.Job jobObject, java.util.Map<String, String> __ctx);

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processJob(String session, JobParams params, omero.model.Job jobObject, Ice.Callback __cb);

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processJob(String session, JobParams params, omero.model.Job jobObject, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processJob(String session, JobParams params, omero.model.Job jobObject, Callback_Processor_processJob __cb);

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_processJob(String session, JobParams params, omero.model.Job jobObject, java.util.Map<String, String> __ctx, Callback_Processor_processJob __cb);

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __result The asynchronous result object.
     **/
    public ProcessPrx end_processJob(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __cb The callback object for the operation.
     **/
    public boolean processJob_async(AMI_Processor_processJob __cb, String session, JobParams params, omero.model.Job jobObject);

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean processJob_async(AMI_Processor_processJob __cb, String session, JobParams params, omero.model.Job jobObject, java.util.Map<String, String> __ctx);
}
