// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Scripts.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Simple controller for Processes. Uses the session
 * id given to create an Ice.Config file which is used
 * as the sole argument to an execution of the given job.
 * 
 * Jobs are responsible for loading arguments from the
 * environment via the session id.
 **/
public final class ProcessorPrxHelper extends Ice.ObjectPrxHelperBase implements ProcessorPrx
{
    private static final String __parseJob_name = "parseJob";

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     **/
    public JobParams parseJob(String session, omero.model.Job jobObject)
        throws omero.ServerError
    {
        return parseJob(session, jobObject, null, false);
    }

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __ctx The Context map to send with the invocation.
     **/
    public JobParams parseJob(String session, omero.model.Job jobObject, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return parseJob(session, jobObject, __ctx, true);
    }

    private JobParams parseJob(String session, omero.model.Job jobObject, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "parseJob", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("parseJob");
                    __delBase = __getDelegate(false);
                    _ProcessorDel __del = (_ProcessorDel)__delBase;
                    return __del.parseJob(session, jobObject, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_parseJob(String session, omero.model.Job jobObject)
    {
        return begin_parseJob(session, jobObject, null, false, null);
    }

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_parseJob(String session, omero.model.Job jobObject, java.util.Map<String, String> __ctx)
    {
        return begin_parseJob(session, jobObject, __ctx, true, null);
    }

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_parseJob(String session, omero.model.Job jobObject, Ice.Callback __cb)
    {
        return begin_parseJob(session, jobObject, null, false, __cb);
    }

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_parseJob(String session, omero.model.Job jobObject, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_parseJob(session, jobObject, __ctx, true, __cb);
    }

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_parseJob(String session, omero.model.Job jobObject, Callback_Processor_parseJob __cb)
    {
        return begin_parseJob(session, jobObject, null, false, __cb);
    }

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_parseJob(String session, omero.model.Job jobObject, java.util.Map<String, String> __ctx, Callback_Processor_parseJob __cb)
    {
        return begin_parseJob(session, jobObject, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_parseJob(String session, omero.model.Job jobObject, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__parseJob_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __parseJob_name, __cb);
        try
        {
            __result.__prepare(__parseJob_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(session);
            __os.writeObject(jobObject);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public JobParams end_parseJob(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __parseJob_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            JobParamsHolder __ret = new JobParamsHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __cb The callback object for the operation.
     **/
    public boolean parseJob_async(AMI_Processor_parseJob __cb, String session, omero.model.Job jobObject)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__parseJob_name);
            __r = begin_parseJob(session, jobObject, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __parseJob_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean parseJob_async(AMI_Processor_parseJob __cb, String session, omero.model.Job jobObject, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__parseJob_name);
            __r = begin_parseJob(session, jobObject, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __parseJob_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __processJob_name = "processJob";

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     **/
    public ProcessPrx processJob(String session, JobParams params, omero.model.Job jobObject)
        throws omero.ServerError
    {
        return processJob(session, params, jobObject, null, false);
    }

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public ProcessPrx processJob(String session, JobParams params, omero.model.Job jobObject, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return processJob(session, params, jobObject, __ctx, true);
    }

    private ProcessPrx processJob(String session, JobParams params, omero.model.Job jobObject, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "processJob", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("processJob");
                    __delBase = __getDelegate(false);
                    _ProcessorDel __del = (_ProcessorDel)__delBase;
                    return __del.processJob(session, params, jobObject, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_processJob(String session, JobParams params, omero.model.Job jobObject)
    {
        return begin_processJob(session, params, jobObject, null, false, null);
    }

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_processJob(String session, JobParams params, omero.model.Job jobObject, java.util.Map<String, String> __ctx)
    {
        return begin_processJob(session, params, jobObject, __ctx, true, null);
    }

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_processJob(String session, JobParams params, omero.model.Job jobObject, Ice.Callback __cb)
    {
        return begin_processJob(session, params, jobObject, null, false, __cb);
    }

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_processJob(String session, JobParams params, omero.model.Job jobObject, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_processJob(session, params, jobObject, __ctx, true, __cb);
    }

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_processJob(String session, JobParams params, omero.model.Job jobObject, Callback_Processor_processJob __cb)
    {
        return begin_processJob(session, params, jobObject, null, false, __cb);
    }

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_processJob(String session, JobParams params, omero.model.Job jobObject, java.util.Map<String, String> __ctx, Callback_Processor_processJob __cb)
    {
        return begin_processJob(session, params, jobObject, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_processJob(String session, JobParams params, omero.model.Job jobObject, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__processJob_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __processJob_name, __cb);
        try
        {
            __result.__prepare(__processJob_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(session);
            __os.writeObject(params);
            __os.writeObject(jobObject);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public ProcessPrx end_processJob(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __processJob_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            ProcessPrx __ret;
            __ret = ProcessPrxHelper.__read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __cb The callback object for the operation.
     **/
    public boolean processJob_async(AMI_Processor_processJob __cb, String session, JobParams params, omero.model.Job jobObject)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__processJob_name);
            __r = begin_processJob(session, params, jobObject, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __processJob_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean processJob_async(AMI_Processor_processJob __cb, String session, JobParams params, omero.model.Job jobObject, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__processJob_name);
            __r = begin_processJob(session, params, jobObject, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __processJob_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __requestRunning_name = "requestRunning";

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     **/
    public void requestRunning(ProcessorCallbackPrx cb)
    {
        requestRunning(cb, null, false);
    }

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __ctx The Context map to send with the invocation.
     **/
    public void requestRunning(ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx)
    {
        requestRunning(cb, __ctx, true);
    }

    private void requestRunning(ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "requestRunning", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _ProcessorDel __del = (_ProcessorDel)__delBase;
                    __del.requestRunning(cb, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_requestRunning(ProcessorCallbackPrx cb)
    {
        return begin_requestRunning(cb, null, false, null);
    }

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_requestRunning(ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx)
    {
        return begin_requestRunning(cb, __ctx, true, null);
    }

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_requestRunning(ProcessorCallbackPrx cb, Ice.Callback __cb)
    {
        return begin_requestRunning(cb, null, false, __cb);
    }

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_requestRunning(ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_requestRunning(cb, __ctx, true, __cb);
    }

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_requestRunning(ProcessorCallbackPrx cb, Callback_Processor_requestRunning __cb)
    {
        return begin_requestRunning(cb, null, false, __cb);
    }

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_requestRunning(ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx, Callback_Processor_requestRunning __cb)
    {
        return begin_requestRunning(cb, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_requestRunning(ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __requestRunning_name, __cb);
        try
        {
            __result.__prepare(__requestRunning_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            ProcessorCallbackPrxHelper.__write(__os, cb);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_requestRunning(Ice.AsyncResult __result)
    {
        __end(__result, __requestRunning_name);
    }

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __cb The callback object for the operation.
     **/
    public boolean requestRunning_async(AMI_Processor_requestRunning __cb, ProcessorCallbackPrx cb)
    {
        Ice.AsyncResult __r = begin_requestRunning(cb, null, false, __cb);
        return __r.sentSynchronously();
    }

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean requestRunning_async(AMI_Processor_requestRunning __cb, ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r = begin_requestRunning(cb, __ctx, true, __cb);
        return __r.sentSynchronously();
    }

    private static final String __willAccept_name = "willAccept";

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     **/
    public void willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb)
    {
        willAccept(userContext, groupContext, scriptContext, cb, null, false);
    }

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx)
    {
        willAccept(userContext, groupContext, scriptContext, cb, __ctx, true);
    }

    private void willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "willAccept", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _ProcessorDel __del = (_ProcessorDel)__delBase;
                    __del.willAccept(userContext, groupContext, scriptContext, cb, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb)
    {
        return begin_willAccept(userContext, groupContext, scriptContext, cb, null, false, null);
    }

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx)
    {
        return begin_willAccept(userContext, groupContext, scriptContext, cb, __ctx, true, null);
    }

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb, Ice.Callback __cb)
    {
        return begin_willAccept(userContext, groupContext, scriptContext, cb, null, false, __cb);
    }

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_willAccept(userContext, groupContext, scriptContext, cb, __ctx, true, __cb);
    }

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb, Callback_Processor_willAccept __cb)
    {
        return begin_willAccept(userContext, groupContext, scriptContext, cb, null, false, __cb);
    }

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx, Callback_Processor_willAccept __cb)
    {
        return begin_willAccept(userContext, groupContext, scriptContext, cb, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __willAccept_name, __cb);
        try
        {
            __result.__prepare(__willAccept_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(userContext);
            __os.writeObject(groupContext);
            __os.writeObject(scriptContext);
            ProcessorCallbackPrxHelper.__write(__os, cb);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_willAccept(Ice.AsyncResult __result)
    {
        __end(__result, __willAccept_name);
    }

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __cb The callback object for the operation.
     **/
    public boolean willAccept_async(AMI_Processor_willAccept __cb, omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb)
    {
        Ice.AsyncResult __r = begin_willAccept(userContext, groupContext, scriptContext, cb, null, false, __cb);
        return __r.sentSynchronously();
    }

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean willAccept_async(AMI_Processor_willAccept __cb, omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r = begin_willAccept(userContext, groupContext, scriptContext, cb, __ctx, true, __cb);
        return __r.sentSynchronously();
    }

    public static ProcessorPrx checkedCast(Ice.ObjectPrx __obj)
    {
        ProcessorPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ProcessorPrx)
            {
                __d = (ProcessorPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    ProcessorPrxHelper __h = new ProcessorPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ProcessorPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        ProcessorPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ProcessorPrx)
            {
                __d = (ProcessorPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    ProcessorPrxHelper __h = new ProcessorPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ProcessorPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ProcessorPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    ProcessorPrxHelper __h = new ProcessorPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ProcessorPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        ProcessorPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    ProcessorPrxHelper __h = new ProcessorPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ProcessorPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        ProcessorPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ProcessorPrx)
            {
                __d = (ProcessorPrx)__obj;
            }
            else
            {
                ProcessorPrxHelper __h = new ProcessorPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static ProcessorPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ProcessorPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            ProcessorPrxHelper __h = new ProcessorPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::Processor"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _ProcessorDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _ProcessorDelD();
    }

    public static void __write(IceInternal.BasicStream __os, ProcessorPrx v)
    {
        __os.writeProxy(v);
    }

    public static ProcessorPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            ProcessorPrxHelper result = new ProcessorPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
