// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Repositories.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Client-accessible interface representing a single mount point on the server-side.
 **/
public interface RepositoryPrx extends Ice.ObjectPrx
{
    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     **/
    public omero.model.OriginalFile root()
        throws omero.ServerError;

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.OriginalFile root(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_root();

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_root(java.util.Map<String, String> __ctx);

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_root(Ice.Callback __cb);

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_root(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_root(Callback_Repository_root __cb);

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_root(java.util.Map<String, String> __ctx, Callback_Repository_root __cb);

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @param __result The asynchronous result object.
     **/
    public omero.model.OriginalFile end_root(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @param __cb The callback object for the operation.
     **/
    public boolean root_async(AMI_Repository_root __cb);

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean root_async(AMI_Repository_root __cb, java.util.Map<String, String> __ctx);

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     **/
    public String mimetype(String path)
        throws omero.ServerError;

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public String mimetype(String path, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_mimetype(String path);

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_mimetype(String path, java.util.Map<String, String> __ctx);

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_mimetype(String path, Ice.Callback __cb);

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_mimetype(String path, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_mimetype(String path, Callback_Repository_mimetype __cb);

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_mimetype(String path, java.util.Map<String, String> __ctx, Callback_Repository_mimetype __cb);

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @param __result The asynchronous result object.
     **/
    public String end_mimetype(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean mimetype_async(AMI_Repository_mimetype __cb, String path);

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean mimetype_async(AMI_Repository_mimetype __cb, String path, java.util.Map<String, String> __ctx);

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     **/
    public java.util.List<String> list(String path)
        throws omero.ServerError;

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<String> list(String path, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_list(String path);

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_list(String path, java.util.Map<String, String> __ctx);

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_list(String path, Ice.Callback __cb);

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_list(String path, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_list(String path, Callback_Repository_list __cb);

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_list(String path, java.util.Map<String, String> __ctx, Callback_Repository_list __cb);

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @param __result The asynchronous result object.
     **/
    public java.util.List<String> end_list(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @param __cb The callback object for the operation.
     **/
    public boolean list_async(AMI_Repository_list __cb, String path);

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean list_async(AMI_Repository_list __cb, String path, java.util.Map<String, String> __ctx);

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     **/
    public java.util.List<omero.model.OriginalFile> listFiles(String path)
        throws omero.ServerError;

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.OriginalFile> listFiles(String path, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_listFiles(String path);

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_listFiles(String path, java.util.Map<String, String> __ctx);

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_listFiles(String path, Ice.Callback __cb);

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_listFiles(String path, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_listFiles(String path, Callback_Repository_listFiles __cb);

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_listFiles(String path, java.util.Map<String, String> __ctx, Callback_Repository_listFiles __cb);

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @param __result The asynchronous result object.
     **/
    public java.util.List<omero.model.OriginalFile> end_listFiles(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @param __cb The callback object for the operation.
     **/
    public boolean listFiles_async(AMI_Repository_listFiles __cb, String path);

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean listFiles_async(AMI_Repository_listFiles __cb, String path, java.util.Map<String, String> __ctx);

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     **/
    public omero.model.OriginalFile register(String path, omero.RString mimetype)
        throws omero.ServerError;

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.OriginalFile register(String path, omero.RString mimetype, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_register(String path, omero.RString mimetype);

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_register(String path, omero.RString mimetype, java.util.Map<String, String> __ctx);

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_register(String path, omero.RString mimetype, Ice.Callback __cb);

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_register(String path, omero.RString mimetype, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_register(String path, omero.RString mimetype, Callback_Repository_register __cb);

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_register(String path, omero.RString mimetype, java.util.Map<String, String> __ctx, Callback_Repository_register __cb);

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @param __result The asynchronous result object.
     **/
    public omero.model.OriginalFile end_register(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean register_async(AMI_Repository_register __cb, String path, omero.RString mimetype);

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean register_async(AMI_Repository_register __cb, String path, omero.RString mimetype, java.util.Map<String, String> __ctx);

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     **/
    public omero.api.RawFileStorePrx file(String path, String mode)
        throws omero.ServerError;

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.api.RawFileStorePrx file(String path, String mode, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_file(String path, String mode);

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_file(String path, String mode, java.util.Map<String, String> __ctx);

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_file(String path, String mode, Ice.Callback __cb);

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_file(String path, String mode, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_file(String path, String mode, Callback_Repository_file __cb);

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_file(String path, String mode, java.util.Map<String, String> __ctx, Callback_Repository_file __cb);

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @param __result The asynchronous result object.
     **/
    public omero.api.RawFileStorePrx end_file(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @param __cb The callback object for the operation.
     **/
    public boolean file_async(AMI_Repository_file __cb, String path, String mode);

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean file_async(AMI_Repository_file __cb, String path, String mode, java.util.Map<String, String> __ctx);

    public omero.api.RawPixelsStorePrx pixels(String path)
        throws omero.ServerError;

    public omero.api.RawPixelsStorePrx pixels(String path, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_pixels(String path);

    public Ice.AsyncResult begin_pixels(String path, java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_pixels(String path, Ice.Callback __cb);

    public Ice.AsyncResult begin_pixels(String path, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_pixels(String path, Callback_Repository_pixels __cb);

    public Ice.AsyncResult begin_pixels(String path, java.util.Map<String, String> __ctx, Callback_Repository_pixels __cb);

    public omero.api.RawPixelsStorePrx end_pixels(Ice.AsyncResult __result)
        throws omero.ServerError;

    public boolean pixels_async(AMI_Repository_pixels __cb, String path);

    public boolean pixels_async(AMI_Repository_pixels __cb, String path, java.util.Map<String, String> __ctx);

    public omero.api.RawFileStorePrx fileById(long id)
        throws omero.ServerError;

    public omero.api.RawFileStorePrx fileById(long id, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    public Ice.AsyncResult begin_fileById(long id);

    public Ice.AsyncResult begin_fileById(long id, java.util.Map<String, String> __ctx);

    public Ice.AsyncResult begin_fileById(long id, Ice.Callback __cb);

    public Ice.AsyncResult begin_fileById(long id, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    public Ice.AsyncResult begin_fileById(long id, Callback_Repository_fileById __cb);

    public Ice.AsyncResult begin_fileById(long id, java.util.Map<String, String> __ctx, Callback_Repository_fileById __cb);

    public omero.api.RawFileStorePrx end_fileById(Ice.AsyncResult __result)
        throws omero.ServerError;

    public boolean fileById_async(AMI_Repository_fileById __cb, long id);

    public boolean fileById_async(AMI_Repository_fileById __cb, long id, java.util.Map<String, String> __ctx);

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     **/
    public boolean fileExists(String path)
        throws omero.ServerError;

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean fileExists(String path, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fileExists(String path);

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fileExists(String path, java.util.Map<String, String> __ctx);

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fileExists(String path, Ice.Callback __cb);

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fileExists(String path, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fileExists(String path, Callback_Repository_fileExists __cb);

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fileExists(String path, java.util.Map<String, String> __ctx, Callback_Repository_fileExists __cb);

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @param __result The asynchronous result object.
     **/
    public boolean end_fileExists(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @param __cb The callback object for the operation.
     **/
    public boolean fileExists_async(AMI_Repository_fileExists __cb, String path);

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean fileExists_async(AMI_Repository_fileExists __cb, String path, java.util.Map<String, String> __ctx);

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     **/
    public void makeDir(String path, boolean parents)
        throws omero.ServerError;

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void makeDir(String path, boolean parents, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_makeDir(String path, boolean parents);

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_makeDir(String path, boolean parents, java.util.Map<String, String> __ctx);

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_makeDir(String path, boolean parents, Ice.Callback __cb);

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_makeDir(String path, boolean parents, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_makeDir(String path, boolean parents, Callback_Repository_makeDir __cb);

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_makeDir(String path, boolean parents, java.util.Map<String, String> __ctx, Callback_Repository_makeDir __cb);

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @param __result The asynchronous result object.
     **/
    public void end_makeDir(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @param __cb The callback object for the operation.
     **/
    public boolean makeDir_async(AMI_Repository_makeDir __cb, String path, boolean parents);

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean makeDir_async(AMI_Repository_makeDir __cb, String path, boolean parents, java.util.Map<String, String> __ctx);

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     **/
    public omero.RMap treeList(String path)
        throws omero.ServerError;

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.RMap treeList(String path, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_treeList(String path);

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_treeList(String path, java.util.Map<String, String> __ctx);

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_treeList(String path, Ice.Callback __cb);

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_treeList(String path, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_treeList(String path, Callback_Repository_treeList __cb);

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_treeList(String path, java.util.Map<String, String> __ctx, Callback_Repository_treeList __cb);

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @param __result The asynchronous result object.
     **/
    public omero.RMap end_treeList(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @param __cb The callback object for the operation.
     **/
    public boolean treeList_async(AMI_Repository_treeList __cb, String path);

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean treeList_async(AMI_Repository_treeList __cb, String path, java.util.Map<String, String> __ctx);

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     **/
    public omero.cmd.HandlePrx deletePaths(String[] paths, boolean recursively, boolean force)
        throws omero.ServerError;

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.cmd.HandlePrx deletePaths(String[] paths, boolean recursively, boolean force, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deletePaths(String[] paths, boolean recursively, boolean force);

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deletePaths(String[] paths, boolean recursively, boolean force, java.util.Map<String, String> __ctx);

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deletePaths(String[] paths, boolean recursively, boolean force, Ice.Callback __cb);

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deletePaths(String[] paths, boolean recursively, boolean force, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deletePaths(String[] paths, boolean recursively, boolean force, Callback_Repository_deletePaths __cb);

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deletePaths(String[] paths, boolean recursively, boolean force, java.util.Map<String, String> __ctx, Callback_Repository_deletePaths __cb);

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @param __result The asynchronous result object.
     **/
    public omero.cmd.HandlePrx end_deletePaths(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean deletePaths_async(AMI_Repository_deletePaths __cb, String[] paths, boolean recursively, boolean force);

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean deletePaths_async(AMI_Repository_deletePaths __cb, String[] paths, boolean recursively, boolean force, java.util.Map<String, String> __ctx);
}
