// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Repositories.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Client-accessible interface representing a single mount point on the server-side.
 **/
public final class RepositoryPrxHelper extends Ice.ObjectPrxHelperBase implements RepositoryPrx
{
    private static final String __deletePaths_name = "deletePaths";

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     **/
    public omero.cmd.HandlePrx deletePaths(String[] paths, boolean recursively, boolean force)
        throws omero.ServerError
    {
        return deletePaths(paths, recursively, force, null, false);
    }

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.cmd.HandlePrx deletePaths(String[] paths, boolean recursively, boolean force, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return deletePaths(paths, recursively, force, __ctx, true);
    }

    private omero.cmd.HandlePrx deletePaths(String[] paths, boolean recursively, boolean force, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "deletePaths", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("deletePaths");
                    __delBase = __getDelegate(false);
                    _RepositoryDel __del = (_RepositoryDel)__delBase;
                    return __del.deletePaths(paths, recursively, force, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_deletePaths(String[] paths, boolean recursively, boolean force)
    {
        return begin_deletePaths(paths, recursively, force, null, false, null);
    }

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_deletePaths(String[] paths, boolean recursively, boolean force, java.util.Map<String, String> __ctx)
    {
        return begin_deletePaths(paths, recursively, force, __ctx, true, null);
    }

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_deletePaths(String[] paths, boolean recursively, boolean force, Ice.Callback __cb)
    {
        return begin_deletePaths(paths, recursively, force, null, false, __cb);
    }

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_deletePaths(String[] paths, boolean recursively, boolean force, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_deletePaths(paths, recursively, force, __ctx, true, __cb);
    }

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_deletePaths(String[] paths, boolean recursively, boolean force, Callback_Repository_deletePaths __cb)
    {
        return begin_deletePaths(paths, recursively, force, null, false, __cb);
    }

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_deletePaths(String[] paths, boolean recursively, boolean force, java.util.Map<String, String> __ctx, Callback_Repository_deletePaths __cb)
    {
        return begin_deletePaths(paths, recursively, force, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_deletePaths(String[] paths, boolean recursively, boolean force, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__deletePaths_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __deletePaths_name, __cb);
        try
        {
            __result.__prepare(__deletePaths_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.api.StringArrayHelper.write(__os, paths);
            __os.writeBool(recursively);
            __os.writeBool(force);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.cmd.HandlePrx end_deletePaths(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __deletePaths_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.cmd.HandlePrx __ret;
            __ret = omero.cmd.HandlePrxHelper.__read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean deletePaths_async(AMI_Repository_deletePaths __cb, String[] paths, boolean recursively, boolean force)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__deletePaths_name);
            __r = begin_deletePaths(paths, recursively, force, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __deletePaths_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean deletePaths_async(AMI_Repository_deletePaths __cb, String[] paths, boolean recursively, boolean force, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__deletePaths_name);
            __r = begin_deletePaths(paths, recursively, force, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __deletePaths_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __file_name = "file";

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     **/
    public omero.api.RawFileStorePrx file(String path, String mode)
        throws omero.ServerError
    {
        return file(path, mode, null, false);
    }

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.api.RawFileStorePrx file(String path, String mode, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return file(path, mode, __ctx, true);
    }

    private omero.api.RawFileStorePrx file(String path, String mode, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "file", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("file");
                    __delBase = __getDelegate(false);
                    _RepositoryDel __del = (_RepositoryDel)__delBase;
                    return __del.file(path, mode, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_file(String path, String mode)
    {
        return begin_file(path, mode, null, false, null);
    }

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_file(String path, String mode, java.util.Map<String, String> __ctx)
    {
        return begin_file(path, mode, __ctx, true, null);
    }

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_file(String path, String mode, Ice.Callback __cb)
    {
        return begin_file(path, mode, null, false, __cb);
    }

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_file(String path, String mode, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_file(path, mode, __ctx, true, __cb);
    }

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_file(String path, String mode, Callback_Repository_file __cb)
    {
        return begin_file(path, mode, null, false, __cb);
    }

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_file(String path, String mode, java.util.Map<String, String> __ctx, Callback_Repository_file __cb)
    {
        return begin_file(path, mode, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_file(String path, String mode, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__file_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __file_name, __cb);
        try
        {
            __result.__prepare(__file_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(path);
            __os.writeString(mode);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.api.RawFileStorePrx end_file(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __file_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.api.RawFileStorePrx __ret;
            __ret = omero.api.RawFileStorePrxHelper.__read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @param __cb The callback object for the operation.
     **/
    public boolean file_async(AMI_Repository_file __cb, String path, String mode)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__file_name);
            __r = begin_file(path, mode, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __file_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean file_async(AMI_Repository_file __cb, String path, String mode, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__file_name);
            __r = begin_file(path, mode, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __file_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __fileById_name = "fileById";

    public omero.api.RawFileStorePrx fileById(long id)
        throws omero.ServerError
    {
        return fileById(id, null, false);
    }

    public omero.api.RawFileStorePrx fileById(long id, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return fileById(id, __ctx, true);
    }

    private omero.api.RawFileStorePrx fileById(long id, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "fileById", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("fileById");
                    __delBase = __getDelegate(false);
                    _RepositoryDel __del = (_RepositoryDel)__delBase;
                    return __del.fileById(id, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_fileById(long id)
    {
        return begin_fileById(id, null, false, null);
    }

    public Ice.AsyncResult begin_fileById(long id, java.util.Map<String, String> __ctx)
    {
        return begin_fileById(id, __ctx, true, null);
    }

    public Ice.AsyncResult begin_fileById(long id, Ice.Callback __cb)
    {
        return begin_fileById(id, null, false, __cb);
    }

    public Ice.AsyncResult begin_fileById(long id, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_fileById(id, __ctx, true, __cb);
    }

    public Ice.AsyncResult begin_fileById(long id, Callback_Repository_fileById __cb)
    {
        return begin_fileById(id, null, false, __cb);
    }

    public Ice.AsyncResult begin_fileById(long id, java.util.Map<String, String> __ctx, Callback_Repository_fileById __cb)
    {
        return begin_fileById(id, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_fileById(long id, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__fileById_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __fileById_name, __cb);
        try
        {
            __result.__prepare(__fileById_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(id);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public omero.api.RawFileStorePrx end_fileById(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __fileById_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.api.RawFileStorePrx __ret;
            __ret = omero.api.RawFileStorePrxHelper.__read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public boolean fileById_async(AMI_Repository_fileById __cb, long id)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__fileById_name);
            __r = begin_fileById(id, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __fileById_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public boolean fileById_async(AMI_Repository_fileById __cb, long id, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__fileById_name);
            __r = begin_fileById(id, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __fileById_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __fileExists_name = "fileExists";

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     **/
    public boolean fileExists(String path)
        throws omero.ServerError
    {
        return fileExists(path, null, false);
    }

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean fileExists(String path, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return fileExists(path, __ctx, true);
    }

    private boolean fileExists(String path, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "fileExists", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("fileExists");
                    __delBase = __getDelegate(false);
                    _RepositoryDel __del = (_RepositoryDel)__delBase;
                    return __del.fileExists(path, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_fileExists(String path)
    {
        return begin_fileExists(path, null, false, null);
    }

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_fileExists(String path, java.util.Map<String, String> __ctx)
    {
        return begin_fileExists(path, __ctx, true, null);
    }

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_fileExists(String path, Ice.Callback __cb)
    {
        return begin_fileExists(path, null, false, __cb);
    }

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_fileExists(String path, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_fileExists(path, __ctx, true, __cb);
    }

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_fileExists(String path, Callback_Repository_fileExists __cb)
    {
        return begin_fileExists(path, null, false, __cb);
    }

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_fileExists(String path, java.util.Map<String, String> __ctx, Callback_Repository_fileExists __cb)
    {
        return begin_fileExists(path, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_fileExists(String path, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__fileExists_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __fileExists_name, __cb);
        try
        {
            __result.__prepare(__fileExists_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(path);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_fileExists(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __fileExists_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @param __cb The callback object for the operation.
     **/
    public boolean fileExists_async(AMI_Repository_fileExists __cb, String path)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__fileExists_name);
            __r = begin_fileExists(path, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __fileExists_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean fileExists_async(AMI_Repository_fileExists __cb, String path, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__fileExists_name);
            __r = begin_fileExists(path, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __fileExists_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __list_name = "list";

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     **/
    public java.util.List<String> list(String path)
        throws omero.ServerError
    {
        return list(path, null, false);
    }

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<String> list(String path, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return list(path, __ctx, true);
    }

    private java.util.List<String> list(String path, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "list", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("list");
                    __delBase = __getDelegate(false);
                    _RepositoryDel __del = (_RepositoryDel)__delBase;
                    return __del.list(path, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_list(String path)
    {
        return begin_list(path, null, false, null);
    }

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_list(String path, java.util.Map<String, String> __ctx)
    {
        return begin_list(path, __ctx, true, null);
    }

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_list(String path, Ice.Callback __cb)
    {
        return begin_list(path, null, false, __cb);
    }

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_list(String path, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_list(path, __ctx, true, __cb);
    }

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_list(String path, Callback_Repository_list __cb)
    {
        return begin_list(path, null, false, __cb);
    }

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_list(String path, java.util.Map<String, String> __ctx, Callback_Repository_list __cb)
    {
        return begin_list(path, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_list(String path, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__list_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __list_name, __cb);
        try
        {
            __result.__prepare(__list_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(path);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.List<String> end_list(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __list_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<String> __ret;
            __ret = omero.api.StringSetHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @param __cb The callback object for the operation.
     **/
    public boolean list_async(AMI_Repository_list __cb, String path)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__list_name);
            __r = begin_list(path, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __list_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean list_async(AMI_Repository_list __cb, String path, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__list_name);
            __r = begin_list(path, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __list_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __listFiles_name = "listFiles";

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     **/
    public java.util.List<omero.model.OriginalFile> listFiles(String path)
        throws omero.ServerError
    {
        return listFiles(path, null, false);
    }

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.OriginalFile> listFiles(String path, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return listFiles(path, __ctx, true);
    }

    private java.util.List<omero.model.OriginalFile> listFiles(String path, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "listFiles", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("listFiles");
                    __delBase = __getDelegate(false);
                    _RepositoryDel __del = (_RepositoryDel)__delBase;
                    return __del.listFiles(path, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_listFiles(String path)
    {
        return begin_listFiles(path, null, false, null);
    }

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_listFiles(String path, java.util.Map<String, String> __ctx)
    {
        return begin_listFiles(path, __ctx, true, null);
    }

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_listFiles(String path, Ice.Callback __cb)
    {
        return begin_listFiles(path, null, false, __cb);
    }

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_listFiles(String path, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_listFiles(path, __ctx, true, __cb);
    }

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_listFiles(String path, Callback_Repository_listFiles __cb)
    {
        return begin_listFiles(path, null, false, __cb);
    }

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_listFiles(String path, java.util.Map<String, String> __ctx, Callback_Repository_listFiles __cb)
    {
        return begin_listFiles(path, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_listFiles(String path, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__listFiles_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __listFiles_name, __cb);
        try
        {
            __result.__prepare(__listFiles_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(path);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.List<omero.model.OriginalFile> end_listFiles(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __listFiles_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.OriginalFile> __ret;
            __ret = omero.api.OriginalFileListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @param __cb The callback object for the operation.
     **/
    public boolean listFiles_async(AMI_Repository_listFiles __cb, String path)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__listFiles_name);
            __r = begin_listFiles(path, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __listFiles_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean listFiles_async(AMI_Repository_listFiles __cb, String path, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__listFiles_name);
            __r = begin_listFiles(path, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __listFiles_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __makeDir_name = "makeDir";

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     **/
    public void makeDir(String path, boolean parents)
        throws omero.ServerError
    {
        makeDir(path, parents, null, false);
    }

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void makeDir(String path, boolean parents, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        makeDir(path, parents, __ctx, true);
    }

    private void makeDir(String path, boolean parents, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "makeDir", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("makeDir");
                    __delBase = __getDelegate(false);
                    _RepositoryDel __del = (_RepositoryDel)__delBase;
                    __del.makeDir(path, parents, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_makeDir(String path, boolean parents)
    {
        return begin_makeDir(path, parents, null, false, null);
    }

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_makeDir(String path, boolean parents, java.util.Map<String, String> __ctx)
    {
        return begin_makeDir(path, parents, __ctx, true, null);
    }

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_makeDir(String path, boolean parents, Ice.Callback __cb)
    {
        return begin_makeDir(path, parents, null, false, __cb);
    }

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_makeDir(String path, boolean parents, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_makeDir(path, parents, __ctx, true, __cb);
    }

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_makeDir(String path, boolean parents, Callback_Repository_makeDir __cb)
    {
        return begin_makeDir(path, parents, null, false, __cb);
    }

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_makeDir(String path, boolean parents, java.util.Map<String, String> __ctx, Callback_Repository_makeDir __cb)
    {
        return begin_makeDir(path, parents, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_makeDir(String path, boolean parents, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__makeDir_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __makeDir_name, __cb);
        try
        {
            __result.__prepare(__makeDir_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(path);
            __os.writeBool(parents);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_makeDir(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __makeDir_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @param __cb The callback object for the operation.
     **/
    public boolean makeDir_async(AMI_Repository_makeDir __cb, String path, boolean parents)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__makeDir_name);
            __r = begin_makeDir(path, parents, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __makeDir_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean makeDir_async(AMI_Repository_makeDir __cb, String path, boolean parents, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__makeDir_name);
            __r = begin_makeDir(path, parents, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __makeDir_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __mimetype_name = "mimetype";

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     **/
    public String mimetype(String path)
        throws omero.ServerError
    {
        return mimetype(path, null, false);
    }

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public String mimetype(String path, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return mimetype(path, __ctx, true);
    }

    private String mimetype(String path, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "mimetype", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("mimetype");
                    __delBase = __getDelegate(false);
                    _RepositoryDel __del = (_RepositoryDel)__delBase;
                    return __del.mimetype(path, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_mimetype(String path)
    {
        return begin_mimetype(path, null, false, null);
    }

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_mimetype(String path, java.util.Map<String, String> __ctx)
    {
        return begin_mimetype(path, __ctx, true, null);
    }

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_mimetype(String path, Ice.Callback __cb)
    {
        return begin_mimetype(path, null, false, __cb);
    }

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_mimetype(String path, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_mimetype(path, __ctx, true, __cb);
    }

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_mimetype(String path, Callback_Repository_mimetype __cb)
    {
        return begin_mimetype(path, null, false, __cb);
    }

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_mimetype(String path, java.util.Map<String, String> __ctx, Callback_Repository_mimetype __cb)
    {
        return begin_mimetype(path, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_mimetype(String path, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__mimetype_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __mimetype_name, __cb);
        try
        {
            __result.__prepare(__mimetype_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(path);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public String end_mimetype(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __mimetype_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            String __ret;
            __ret = __is.readString();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean mimetype_async(AMI_Repository_mimetype __cb, String path)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__mimetype_name);
            __r = begin_mimetype(path, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __mimetype_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean mimetype_async(AMI_Repository_mimetype __cb, String path, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__mimetype_name);
            __r = begin_mimetype(path, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __mimetype_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __pixels_name = "pixels";

    public omero.api.RawPixelsStorePrx pixels(String path)
        throws omero.ServerError
    {
        return pixels(path, null, false);
    }

    public omero.api.RawPixelsStorePrx pixels(String path, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return pixels(path, __ctx, true);
    }

    private omero.api.RawPixelsStorePrx pixels(String path, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "pixels", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("pixels");
                    __delBase = __getDelegate(false);
                    _RepositoryDel __del = (_RepositoryDel)__delBase;
                    return __del.pixels(path, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_pixels(String path)
    {
        return begin_pixels(path, null, false, null);
    }

    public Ice.AsyncResult begin_pixels(String path, java.util.Map<String, String> __ctx)
    {
        return begin_pixels(path, __ctx, true, null);
    }

    public Ice.AsyncResult begin_pixels(String path, Ice.Callback __cb)
    {
        return begin_pixels(path, null, false, __cb);
    }

    public Ice.AsyncResult begin_pixels(String path, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_pixels(path, __ctx, true, __cb);
    }

    public Ice.AsyncResult begin_pixels(String path, Callback_Repository_pixels __cb)
    {
        return begin_pixels(path, null, false, __cb);
    }

    public Ice.AsyncResult begin_pixels(String path, java.util.Map<String, String> __ctx, Callback_Repository_pixels __cb)
    {
        return begin_pixels(path, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_pixels(String path, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__pixels_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __pixels_name, __cb);
        try
        {
            __result.__prepare(__pixels_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(path);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public omero.api.RawPixelsStorePrx end_pixels(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __pixels_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.api.RawPixelsStorePrx __ret;
            __ret = omero.api.RawPixelsStorePrxHelper.__read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public boolean pixels_async(AMI_Repository_pixels __cb, String path)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__pixels_name);
            __r = begin_pixels(path, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __pixels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public boolean pixels_async(AMI_Repository_pixels __cb, String path, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__pixels_name);
            __r = begin_pixels(path, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __pixels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __register_name = "register";

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     **/
    public omero.model.OriginalFile register(String path, omero.RString mimetype)
        throws omero.ServerError
    {
        return register(path, mimetype, null, false);
    }

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.OriginalFile register(String path, omero.RString mimetype, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return register(path, mimetype, __ctx, true);
    }

    private omero.model.OriginalFile register(String path, omero.RString mimetype, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "register", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("register");
                    __delBase = __getDelegate(false);
                    _RepositoryDel __del = (_RepositoryDel)__delBase;
                    return __del.register(path, mimetype, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_register(String path, omero.RString mimetype)
    {
        return begin_register(path, mimetype, null, false, null);
    }

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_register(String path, omero.RString mimetype, java.util.Map<String, String> __ctx)
    {
        return begin_register(path, mimetype, __ctx, true, null);
    }

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_register(String path, omero.RString mimetype, Ice.Callback __cb)
    {
        return begin_register(path, mimetype, null, false, __cb);
    }

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_register(String path, omero.RString mimetype, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_register(path, mimetype, __ctx, true, __cb);
    }

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_register(String path, omero.RString mimetype, Callback_Repository_register __cb)
    {
        return begin_register(path, mimetype, null, false, __cb);
    }

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_register(String path, omero.RString mimetype, java.util.Map<String, String> __ctx, Callback_Repository_register __cb)
    {
        return begin_register(path, mimetype, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_register(String path, omero.RString mimetype, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__register_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __register_name, __cb);
        try
        {
            __result.__prepare(__register_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(path);
            __os.writeObject(mimetype);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.model.OriginalFile end_register(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __register_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.OriginalFileHolder __ret = new omero.model.OriginalFileHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean register_async(AMI_Repository_register __cb, String path, omero.RString mimetype)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__register_name);
            __r = begin_register(path, mimetype, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __register_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean register_async(AMI_Repository_register __cb, String path, omero.RString mimetype, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__register_name);
            __r = begin_register(path, mimetype, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __register_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __root_name = "root";

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     **/
    public omero.model.OriginalFile root()
        throws omero.ServerError
    {
        return root(null, false);
    }

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.OriginalFile root(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return root(__ctx, true);
    }

    private omero.model.OriginalFile root(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "root", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("root");
                    __delBase = __getDelegate(false);
                    _RepositoryDel __del = (_RepositoryDel)__delBase;
                    return __del.root(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_root()
    {
        return begin_root(null, false, null);
    }

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_root(java.util.Map<String, String> __ctx)
    {
        return begin_root(__ctx, true, null);
    }

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_root(Ice.Callback __cb)
    {
        return begin_root(null, false, __cb);
    }

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_root(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_root(__ctx, true, __cb);
    }

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_root(Callback_Repository_root __cb)
    {
        return begin_root(null, false, __cb);
    }

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_root(java.util.Map<String, String> __ctx, Callback_Repository_root __cb)
    {
        return begin_root(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_root(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__root_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __root_name, __cb);
        try
        {
            __result.__prepare(__root_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.model.OriginalFile end_root(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __root_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.OriginalFileHolder __ret = new omero.model.OriginalFileHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @param __cb The callback object for the operation.
     **/
    public boolean root_async(AMI_Repository_root __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__root_name);
            __r = begin_root(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __root_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean root_async(AMI_Repository_root __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__root_name);
            __r = begin_root(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __root_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __treeList_name = "treeList";

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     **/
    public omero.RMap treeList(String path)
        throws omero.ServerError
    {
        return treeList(path, null, false);
    }

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.RMap treeList(String path, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return treeList(path, __ctx, true);
    }

    private omero.RMap treeList(String path, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "treeList", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("treeList");
                    __delBase = __getDelegate(false);
                    _RepositoryDel __del = (_RepositoryDel)__delBase;
                    return __del.treeList(path, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_treeList(String path)
    {
        return begin_treeList(path, null, false, null);
    }

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_treeList(String path, java.util.Map<String, String> __ctx)
    {
        return begin_treeList(path, __ctx, true, null);
    }

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_treeList(String path, Ice.Callback __cb)
    {
        return begin_treeList(path, null, false, __cb);
    }

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_treeList(String path, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_treeList(path, __ctx, true, __cb);
    }

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_treeList(String path, Callback_Repository_treeList __cb)
    {
        return begin_treeList(path, null, false, __cb);
    }

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_treeList(String path, java.util.Map<String, String> __ctx, Callback_Repository_treeList __cb)
    {
        return begin_treeList(path, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_treeList(String path, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__treeList_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __treeList_name, __cb);
        try
        {
            __result.__prepare(__treeList_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(path);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.RMap end_treeList(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __treeList_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.RMapHolder __ret = new omero.RMapHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @param __cb The callback object for the operation.
     **/
    public boolean treeList_async(AMI_Repository_treeList __cb, String path)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__treeList_name);
            __r = begin_treeList(path, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __treeList_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean treeList_async(AMI_Repository_treeList __cb, String path, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__treeList_name);
            __r = begin_treeList(path, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __treeList_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static RepositoryPrx checkedCast(Ice.ObjectPrx __obj)
    {
        RepositoryPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof RepositoryPrx)
            {
                __d = (RepositoryPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    RepositoryPrxHelper __h = new RepositoryPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static RepositoryPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        RepositoryPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof RepositoryPrx)
            {
                __d = (RepositoryPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    RepositoryPrxHelper __h = new RepositoryPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static RepositoryPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        RepositoryPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    RepositoryPrxHelper __h = new RepositoryPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static RepositoryPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        RepositoryPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    RepositoryPrxHelper __h = new RepositoryPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static RepositoryPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        RepositoryPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof RepositoryPrx)
            {
                __d = (RepositoryPrx)__obj;
            }
            else
            {
                RepositoryPrxHelper __h = new RepositoryPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static RepositoryPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        RepositoryPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            RepositoryPrxHelper __h = new RepositoryPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::Repository"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _RepositoryDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _RepositoryDelD();
    }

    public static void __write(IceInternal.BasicStream __os, RepositoryPrx v)
    {
        __os.writeProxy(v);
    }

    public static RepositoryPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            RepositoryPrxHelper result = new RepositoryPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
