// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Scripts.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Extension of the {@link Process} interface which is returned by
 * {@link IScript} when an {@link omero.model.ScriptJob} is launched.
 * It is critical that instances of (@link ScriptProcess} are closed
 * on completetion. See the {@link #close} method for more information.
 **/
public interface ScriptProcessPrx extends ProcessPrx
{
    /**
     * Returns the job which started this process. Several
     * scheduling fields (submitted, scheduledFor, started, finished)
     * may be of interest.
     **/
    public omero.model.ScriptJob getJob()
        throws omero.ServerError;

    /**
     * Returns the job which started this process. Several
     * scheduling fields (submitted, scheduledFor, started, finished)
     * may be of interest.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.ScriptJob getJob(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the job which started this process. Several
     * scheduling fields (submitted, scheduledFor, started, finished)
     * may be of interest.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob();

    /**
     * Returns the job which started this process. Several
     * scheduling fields (submitted, scheduledFor, started, finished)
     * may be of interest.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx);

    /**
     * Returns the job which started this process. Several
     * scheduling fields (submitted, scheduledFor, started, finished)
     * may be of interest.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(Ice.Callback __cb);

    /**
     * Returns the job which started this process. Several
     * scheduling fields (submitted, scheduledFor, started, finished)
     * may be of interest.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the job which started this process. Several
     * scheduling fields (submitted, scheduledFor, started, finished)
     * may be of interest.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(Callback_ScriptProcess_getJob __cb);

    /**
     * Returns the job which started this process. Several
     * scheduling fields (submitted, scheduledFor, started, finished)
     * may be of interest.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getJob(java.util.Map<String, String> __ctx, Callback_ScriptProcess_getJob __cb);

    /**
     * Returns the job which started this process. Several
     * scheduling fields (submitted, scheduledFor, started, finished)
     * may be of interest.
     * @param __result The asynchronous result object.
     **/
    public omero.model.ScriptJob end_getJob(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the results immediately if present. If the process
     * is not yet finished, waits "waitSecs" before throwing an
     * {@link omero.ApiUsageException}. If poll has returned a non-null
     * value, then this method will always return a non-null value.
     **/
    public java.util.Map<java.lang.String, omero.RType> getResults(int waitSecs)
        throws omero.ServerError;

    /**
     * Returns the results immediately if present. If the process
     * is not yet finished, waits "waitSecs" before throwing an
     * {@link omero.ApiUsageException}. If poll has returned a non-null
     * value, then this method will always return a non-null value.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.Map<java.lang.String, omero.RType> getResults(int waitSecs, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the results immediately if present. If the process
     * is not yet finished, waits "waitSecs" before throwing an
     * {@link omero.ApiUsageException}. If poll has returned a non-null
     * value, then this method will always return a non-null value.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResults(int waitSecs);

    /**
     * Returns the results immediately if present. If the process
     * is not yet finished, waits "waitSecs" before throwing an
     * {@link omero.ApiUsageException}. If poll has returned a non-null
     * value, then this method will always return a non-null value.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResults(int waitSecs, java.util.Map<String, String> __ctx);

    /**
     * Returns the results immediately if present. If the process
     * is not yet finished, waits "waitSecs" before throwing an
     * {@link omero.ApiUsageException}. If poll has returned a non-null
     * value, then this method will always return a non-null value.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResults(int waitSecs, Ice.Callback __cb);

    /**
     * Returns the results immediately if present. If the process
     * is not yet finished, waits "waitSecs" before throwing an
     * {@link omero.ApiUsageException}. If poll has returned a non-null
     * value, then this method will always return a non-null value.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResults(int waitSecs, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the results immediately if present. If the process
     * is not yet finished, waits "waitSecs" before throwing an
     * {@link omero.ApiUsageException}. If poll has returned a non-null
     * value, then this method will always return a non-null value.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResults(int waitSecs, Callback_ScriptProcess_getResults __cb);

    /**
     * Returns the results immediately if present. If the process
     * is not yet finished, waits "waitSecs" before throwing an
     * {@link omero.ApiUsageException}. If poll has returned a non-null
     * value, then this method will always return a non-null value.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getResults(int waitSecs, java.util.Map<String, String> __ctx, Callback_ScriptProcess_getResults __cb);

    /**
     * Returns the results immediately if present. If the process
     * is not yet finished, waits "waitSecs" before throwing an
     * {@link omero.ApiUsageException}. If poll has returned a non-null
     * value, then this method will always return a non-null value.
     * @param __result The asynchronous result object.
     **/
    public java.util.Map<java.lang.String, omero.RType> end_getResults(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Sets the message on the {@link omero.model.ScriptJob} object.
     * This value MAY be overwritten by the server if the script
     * fails.
     **/
    public String setMessage(String message)
        throws omero.ServerError;

    /**
     * Sets the message on the {@link omero.model.ScriptJob} object.
     * This value MAY be overwritten by the server if the script
     * fails.
     * @param __ctx The Context map to send with the invocation.
     **/
    public String setMessage(String message, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Sets the message on the {@link omero.model.ScriptJob} object.
     * This value MAY be overwritten by the server if the script
     * fails.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMessage(String message);

    /**
     * Sets the message on the {@link omero.model.ScriptJob} object.
     * This value MAY be overwritten by the server if the script
     * fails.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMessage(String message, java.util.Map<String, String> __ctx);

    /**
     * Sets the message on the {@link omero.model.ScriptJob} object.
     * This value MAY be overwritten by the server if the script
     * fails.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMessage(String message, Ice.Callback __cb);

    /**
     * Sets the message on the {@link omero.model.ScriptJob} object.
     * This value MAY be overwritten by the server if the script
     * fails.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMessage(String message, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Sets the message on the {@link omero.model.ScriptJob} object.
     * This value MAY be overwritten by the server if the script
     * fails.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMessage(String message, Callback_ScriptProcess_setMessage __cb);

    /**
     * Sets the message on the {@link omero.model.ScriptJob} object.
     * This value MAY be overwritten by the server if the script
     * fails.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMessage(String message, java.util.Map<String, String> __ctx, Callback_ScriptProcess_setMessage __cb);

    /**
     * Sets the message on the {@link omero.model.ScriptJob} object.
     * This value MAY be overwritten by the server if the script
     * fails.
     * @param __result The asynchronous result object.
     **/
    public String end_setMessage(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Closes this process and frees server resources attached to it.
     * If the detach argument is True, then the background process
     * will continue executing. The user can reconnect to the process
     * via the {@link IScript} service.
     * 
     * If the detach argument is False, then the background process
     * will be shutdown immediately, and all intermediate results
     * (stdout, stderr, ...) will be uploaded.
     **/
    public void close(boolean detach)
        throws omero.ServerError;

    /**
     * Closes this process and frees server resources attached to it.
     * If the detach argument is True, then the background process
     * will continue executing. The user can reconnect to the process
     * via the {@link IScript} service.
     * 
     * If the detach argument is False, then the background process
     * will be shutdown immediately, and all intermediate results
     * (stdout, stderr, ...) will be uploaded.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void close(boolean detach, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Closes this process and frees server resources attached to it.
     * If the detach argument is True, then the background process
     * will continue executing. The user can reconnect to the process
     * via the {@link IScript} service.
     * 
     * If the detach argument is False, then the background process
     * will be shutdown immediately, and all intermediate results
     * (stdout, stderr, ...) will be uploaded.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_close(boolean detach);

    /**
     * Closes this process and frees server resources attached to it.
     * If the detach argument is True, then the background process
     * will continue executing. The user can reconnect to the process
     * via the {@link IScript} service.
     * 
     * If the detach argument is False, then the background process
     * will be shutdown immediately, and all intermediate results
     * (stdout, stderr, ...) will be uploaded.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_close(boolean detach, java.util.Map<String, String> __ctx);

    /**
     * Closes this process and frees server resources attached to it.
     * If the detach argument is True, then the background process
     * will continue executing. The user can reconnect to the process
     * via the {@link IScript} service.
     * 
     * If the detach argument is False, then the background process
     * will be shutdown immediately, and all intermediate results
     * (stdout, stderr, ...) will be uploaded.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_close(boolean detach, Ice.Callback __cb);

    /**
     * Closes this process and frees server resources attached to it.
     * If the detach argument is True, then the background process
     * will continue executing. The user can reconnect to the process
     * via the {@link IScript} service.
     * 
     * If the detach argument is False, then the background process
     * will be shutdown immediately, and all intermediate results
     * (stdout, stderr, ...) will be uploaded.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_close(boolean detach, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Closes this process and frees server resources attached to it.
     * If the detach argument is True, then the background process
     * will continue executing. The user can reconnect to the process
     * via the {@link IScript} service.
     * 
     * If the detach argument is False, then the background process
     * will be shutdown immediately, and all intermediate results
     * (stdout, stderr, ...) will be uploaded.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_close(boolean detach, Callback_ScriptProcess_close __cb);

    /**
     * Closes this process and frees server resources attached to it.
     * If the detach argument is True, then the background process
     * will continue executing. The user can reconnect to the process
     * via the {@link IScript} service.
     * 
     * If the detach argument is False, then the background process
     * will be shutdown immediately, and all intermediate results
     * (stdout, stderr, ...) will be uploaded.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_close(boolean detach, java.util.Map<String, String> __ctx, Callback_ScriptProcess_close __cb);

    /**
     * Closes this process and frees server resources attached to it.
     * If the detach argument is True, then the background process
     * will continue executing. The user can reconnect to the process
     * via the {@link IScript} service.
     * 
     * If the detach argument is False, then the background process
     * will be shutdown immediately, and all intermediate results
     * (stdout, stderr, ...) will be uploaded.
     * @param __result The asynchronous result object.
     **/
    public void end_close(Ice.AsyncResult __result)
        throws omero.ServerError;
}
