// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `SharedResources.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Resource manager provided by each Blitz session for acquiring
 * shared resources in the OmeroGrid. Unlike the other services
 * provided by ServiceFactory instances, it is not guaranteed
 * that a service instance returned from this interface will be
 * returned if that resource happens to be busy. In that case,
 * a null will be returned.
 **/
public interface SharedResourcesPrx extends Ice.ObjectPrx
{
    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     **/
    public InteractiveProcessorPrx acquireProcessor(omero.model.Job job, int seconds)
        throws omero.ServerError;

    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     * @param __ctx The Context map to send with the invocation.
     **/
    public InteractiveProcessorPrx acquireProcessor(omero.model.Job job, int seconds, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_acquireProcessor(omero.model.Job job, int seconds);

    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_acquireProcessor(omero.model.Job job, int seconds, java.util.Map<String, String> __ctx);

    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_acquireProcessor(omero.model.Job job, int seconds, Ice.Callback __cb);

    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_acquireProcessor(omero.model.Job job, int seconds, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_acquireProcessor(omero.model.Job job, int seconds, Callback_SharedResources_acquireProcessor __cb);

    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_acquireProcessor(omero.model.Job job, int seconds, java.util.Map<String, String> __ctx, Callback_SharedResources_acquireProcessor __cb);

    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     * @param __result The asynchronous result object.
     **/
    public InteractiveProcessorPrx end_acquireProcessor(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     **/
    public void addProcessor(ProcessorPrx proc)
        throws omero.ServerError;

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addProcessor(ProcessorPrx proc);

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx);

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addProcessor(ProcessorPrx proc, Ice.Callback __cb);

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addProcessor(ProcessorPrx proc, Callback_SharedResources_addProcessor __cb);

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx, Callback_SharedResources_addProcessor __cb);

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     * @param __result The asynchronous result object.
     **/
    public void end_addProcessor(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     **/
    public void removeProcessor(ProcessorPrx proc)
        throws omero.ServerError;

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeProcessor(ProcessorPrx proc);

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx);

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeProcessor(ProcessorPrx proc, Ice.Callback __cb);

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeProcessor(ProcessorPrx proc, Callback_SharedResources_removeProcessor __cb);

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx, Callback_SharedResources_removeProcessor __cb);

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     * @param __result The asynchronous result object.
     **/
    public void end_removeProcessor(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     **/
    public RepositoryMap repositories()
        throws omero.ServerError;

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     * @param __ctx The Context map to send with the invocation.
     **/
    public RepositoryMap repositories(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_repositories();

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_repositories(java.util.Map<String, String> __ctx);

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_repositories(Ice.Callback __cb);

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_repositories(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_repositories(Callback_SharedResources_repositories __cb);

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_repositories(java.util.Map<String, String> __ctx, Callback_SharedResources_repositories __cb);

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     * @param __result The asynchronous result object.
     **/
    public RepositoryMap end_repositories(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     **/
    public RepositoryPrx getScriptRepository()
        throws omero.ServerError;

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     * @param __ctx The Context map to send with the invocation.
     **/
    public RepositoryPrx getScriptRepository(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getScriptRepository();

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getScriptRepository(java.util.Map<String, String> __ctx);

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getScriptRepository(Ice.Callback __cb);

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getScriptRepository(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getScriptRepository(Callback_SharedResources_getScriptRepository __cb);

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getScriptRepository(java.util.Map<String, String> __ctx, Callback_SharedResources_getScriptRepository __cb);

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     * @param __result The asynchronous result object.
     **/
    public RepositoryPrx end_getScriptRepository(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     **/
    public boolean areTablesEnabled()
        throws omero.ServerError;

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean areTablesEnabled(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_areTablesEnabled();

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_areTablesEnabled(java.util.Map<String, String> __ctx);

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_areTablesEnabled(Ice.Callback __cb);

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_areTablesEnabled(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_areTablesEnabled(Callback_SharedResources_areTablesEnabled __cb);

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_areTablesEnabled(java.util.Map<String, String> __ctx, Callback_SharedResources_areTablesEnabled __cb);

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     * @param __result The asynchronous result object.
     **/
    public boolean end_areTablesEnabled(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     **/
    public TablePrx newTable(long repoId, String path)
        throws omero.ServerError;

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     * @param __ctx The Context map to send with the invocation.
     **/
    public TablePrx newTable(long repoId, String path, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_newTable(long repoId, String path);

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_newTable(long repoId, String path, java.util.Map<String, String> __ctx);

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_newTable(long repoId, String path, Ice.Callback __cb);

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_newTable(long repoId, String path, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_newTable(long repoId, String path, Callback_SharedResources_newTable __cb);

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_newTable(long repoId, String path, java.util.Map<String, String> __ctx, Callback_SharedResources_newTable __cb);

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     * @param __result The asynchronous result object.
     **/
    public TablePrx end_newTable(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     **/
    public TablePrx openTable(omero.model.OriginalFile file)
        throws omero.ServerError;

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     * @param __ctx The Context map to send with the invocation.
     **/
    public TablePrx openTable(omero.model.OriginalFile file, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_openTable(omero.model.OriginalFile file);

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_openTable(omero.model.OriginalFile file, java.util.Map<String, String> __ctx);

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_openTable(omero.model.OriginalFile file, Ice.Callback __cb);

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_openTable(omero.model.OriginalFile file, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_openTable(omero.model.OriginalFile file, Callback_SharedResources_openTable __cb);

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_openTable(omero.model.OriginalFile file, java.util.Map<String, String> __ctx, Callback_SharedResources_openTable __cb);

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     * @param __result The asynchronous result object.
     **/
    public TablePrx end_openTable(Ice.AsyncResult __result)
        throws omero.ServerError;
}
