// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `SharedResources.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Resource manager provided by each Blitz session for acquiring
 * shared resources in the OmeroGrid. Unlike the other services
 * provided by ServiceFactory instances, it is not guaranteed
 * that a service instance returned from this interface will be
 * returned if that resource happens to be busy. In that case,
 * a null will be returned.
 **/
public final class SharedResourcesPrxHelper extends Ice.ObjectPrxHelperBase implements SharedResourcesPrx
{
    private static final String __acquireProcessor_name = "acquireProcessor";

    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     **/
    public InteractiveProcessorPrx acquireProcessor(omero.model.Job job, int seconds)
        throws omero.ServerError
    {
        return acquireProcessor(job, seconds, null, false);
    }

    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     * @param __ctx The Context map to send with the invocation.
     **/
    public InteractiveProcessorPrx acquireProcessor(omero.model.Job job, int seconds, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return acquireProcessor(job, seconds, __ctx, true);
    }

    private InteractiveProcessorPrx acquireProcessor(omero.model.Job job, int seconds, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "acquireProcessor", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("acquireProcessor");
                    __delBase = __getDelegate(false);
                    _SharedResourcesDel __del = (_SharedResourcesDel)__delBase;
                    return __del.acquireProcessor(job, seconds, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_acquireProcessor(omero.model.Job job, int seconds)
    {
        return begin_acquireProcessor(job, seconds, null, false, null);
    }

    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_acquireProcessor(omero.model.Job job, int seconds, java.util.Map<String, String> __ctx)
    {
        return begin_acquireProcessor(job, seconds, __ctx, true, null);
    }

    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_acquireProcessor(omero.model.Job job, int seconds, Ice.Callback __cb)
    {
        return begin_acquireProcessor(job, seconds, null, false, __cb);
    }

    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_acquireProcessor(omero.model.Job job, int seconds, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_acquireProcessor(job, seconds, __ctx, true, __cb);
    }

    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_acquireProcessor(omero.model.Job job, int seconds, Callback_SharedResources_acquireProcessor __cb)
    {
        return begin_acquireProcessor(job, seconds, null, false, __cb);
    }

    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_acquireProcessor(omero.model.Job job, int seconds, java.util.Map<String, String> __ctx, Callback_SharedResources_acquireProcessor __cb)
    {
        return begin_acquireProcessor(job, seconds, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_acquireProcessor(omero.model.Job job, int seconds, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__acquireProcessor_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __acquireProcessor_name, __cb);
        try
        {
            __result.__prepare(__acquireProcessor_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(job);
            __os.writeInt(seconds);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public InteractiveProcessorPrx end_acquireProcessor(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __acquireProcessor_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            InteractiveProcessorPrx __ret;
            __ret = InteractiveProcessorPrxHelper.__read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __addProcessor_name = "addProcessor";

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     **/
    public void addProcessor(ProcessorPrx proc)
        throws omero.ServerError
    {
        addProcessor(proc, null, false);
    }

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        addProcessor(proc, __ctx, true);
    }

    private void addProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "addProcessor", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("addProcessor");
                    __delBase = __getDelegate(false);
                    _SharedResourcesDel __del = (_SharedResourcesDel)__delBase;
                    __del.addProcessor(proc, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addProcessor(ProcessorPrx proc)
    {
        return begin_addProcessor(proc, null, false, null);
    }

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx)
    {
        return begin_addProcessor(proc, __ctx, true, null);
    }

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addProcessor(ProcessorPrx proc, Ice.Callback __cb)
    {
        return begin_addProcessor(proc, null, false, __cb);
    }

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_addProcessor(proc, __ctx, true, __cb);
    }

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addProcessor(ProcessorPrx proc, Callback_SharedResources_addProcessor __cb)
    {
        return begin_addProcessor(proc, null, false, __cb);
    }

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx, Callback_SharedResources_addProcessor __cb)
    {
        return begin_addProcessor(proc, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_addProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__addProcessor_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __addProcessor_name, __cb);
        try
        {
            __result.__prepare(__addProcessor_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            ProcessorPrxHelper.__write(__os, proc);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_addProcessor(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __addProcessor_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __areTablesEnabled_name = "areTablesEnabled";

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     **/
    public boolean areTablesEnabled()
        throws omero.ServerError
    {
        return areTablesEnabled(null, false);
    }

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean areTablesEnabled(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return areTablesEnabled(__ctx, true);
    }

    private boolean areTablesEnabled(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "areTablesEnabled", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("areTablesEnabled");
                    __delBase = __getDelegate(false);
                    _SharedResourcesDel __del = (_SharedResourcesDel)__delBase;
                    return __del.areTablesEnabled(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_areTablesEnabled()
    {
        return begin_areTablesEnabled(null, false, null);
    }

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_areTablesEnabled(java.util.Map<String, String> __ctx)
    {
        return begin_areTablesEnabled(__ctx, true, null);
    }

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_areTablesEnabled(Ice.Callback __cb)
    {
        return begin_areTablesEnabled(null, false, __cb);
    }

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_areTablesEnabled(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_areTablesEnabled(__ctx, true, __cb);
    }

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_areTablesEnabled(Callback_SharedResources_areTablesEnabled __cb)
    {
        return begin_areTablesEnabled(null, false, __cb);
    }

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_areTablesEnabled(java.util.Map<String, String> __ctx, Callback_SharedResources_areTablesEnabled __cb)
    {
        return begin_areTablesEnabled(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_areTablesEnabled(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__areTablesEnabled_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __areTablesEnabled_name, __cb);
        try
        {
            __result.__prepare(__areTablesEnabled_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_areTablesEnabled(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __areTablesEnabled_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __getScriptRepository_name = "getScriptRepository";

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     **/
    public RepositoryPrx getScriptRepository()
        throws omero.ServerError
    {
        return getScriptRepository(null, false);
    }

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     * @param __ctx The Context map to send with the invocation.
     **/
    public RepositoryPrx getScriptRepository(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getScriptRepository(__ctx, true);
    }

    private RepositoryPrx getScriptRepository(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getScriptRepository", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getScriptRepository");
                    __delBase = __getDelegate(false);
                    _SharedResourcesDel __del = (_SharedResourcesDel)__delBase;
                    return __del.getScriptRepository(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getScriptRepository()
    {
        return begin_getScriptRepository(null, false, null);
    }

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getScriptRepository(java.util.Map<String, String> __ctx)
    {
        return begin_getScriptRepository(__ctx, true, null);
    }

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getScriptRepository(Ice.Callback __cb)
    {
        return begin_getScriptRepository(null, false, __cb);
    }

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getScriptRepository(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getScriptRepository(__ctx, true, __cb);
    }

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getScriptRepository(Callback_SharedResources_getScriptRepository __cb)
    {
        return begin_getScriptRepository(null, false, __cb);
    }

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getScriptRepository(java.util.Map<String, String> __ctx, Callback_SharedResources_getScriptRepository __cb)
    {
        return begin_getScriptRepository(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getScriptRepository(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getScriptRepository_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getScriptRepository_name, __cb);
        try
        {
            __result.__prepare(__getScriptRepository_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public RepositoryPrx end_getScriptRepository(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getScriptRepository_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            RepositoryPrx __ret;
            __ret = RepositoryPrxHelper.__read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __newTable_name = "newTable";

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     **/
    public TablePrx newTable(long repoId, String path)
        throws omero.ServerError
    {
        return newTable(repoId, path, null, false);
    }

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     * @param __ctx The Context map to send with the invocation.
     **/
    public TablePrx newTable(long repoId, String path, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return newTable(repoId, path, __ctx, true);
    }

    private TablePrx newTable(long repoId, String path, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "newTable", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("newTable");
                    __delBase = __getDelegate(false);
                    _SharedResourcesDel __del = (_SharedResourcesDel)__delBase;
                    return __del.newTable(repoId, path, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_newTable(long repoId, String path)
    {
        return begin_newTable(repoId, path, null, false, null);
    }

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_newTable(long repoId, String path, java.util.Map<String, String> __ctx)
    {
        return begin_newTable(repoId, path, __ctx, true, null);
    }

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_newTable(long repoId, String path, Ice.Callback __cb)
    {
        return begin_newTable(repoId, path, null, false, __cb);
    }

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_newTable(long repoId, String path, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_newTable(repoId, path, __ctx, true, __cb);
    }

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_newTable(long repoId, String path, Callback_SharedResources_newTable __cb)
    {
        return begin_newTable(repoId, path, null, false, __cb);
    }

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_newTable(long repoId, String path, java.util.Map<String, String> __ctx, Callback_SharedResources_newTable __cb)
    {
        return begin_newTable(repoId, path, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_newTable(long repoId, String path, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__newTable_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __newTable_name, __cb);
        try
        {
            __result.__prepare(__newTable_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(repoId);
            __os.writeString(path);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public TablePrx end_newTable(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __newTable_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            TablePrx __ret;
            __ret = TablePrxHelper.__read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __openTable_name = "openTable";

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     **/
    public TablePrx openTable(omero.model.OriginalFile file)
        throws omero.ServerError
    {
        return openTable(file, null, false);
    }

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     * @param __ctx The Context map to send with the invocation.
     **/
    public TablePrx openTable(omero.model.OriginalFile file, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return openTable(file, __ctx, true);
    }

    private TablePrx openTable(omero.model.OriginalFile file, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "openTable", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("openTable");
                    __delBase = __getDelegate(false);
                    _SharedResourcesDel __del = (_SharedResourcesDel)__delBase;
                    return __del.openTable(file, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_openTable(omero.model.OriginalFile file)
    {
        return begin_openTable(file, null, false, null);
    }

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_openTable(omero.model.OriginalFile file, java.util.Map<String, String> __ctx)
    {
        return begin_openTable(file, __ctx, true, null);
    }

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_openTable(omero.model.OriginalFile file, Ice.Callback __cb)
    {
        return begin_openTable(file, null, false, __cb);
    }

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_openTable(omero.model.OriginalFile file, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_openTable(file, __ctx, true, __cb);
    }

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_openTable(omero.model.OriginalFile file, Callback_SharedResources_openTable __cb)
    {
        return begin_openTable(file, null, false, __cb);
    }

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_openTable(omero.model.OriginalFile file, java.util.Map<String, String> __ctx, Callback_SharedResources_openTable __cb)
    {
        return begin_openTable(file, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_openTable(omero.model.OriginalFile file, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__openTable_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __openTable_name, __cb);
        try
        {
            __result.__prepare(__openTable_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(file);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public TablePrx end_openTable(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __openTable_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            TablePrx __ret;
            __ret = TablePrxHelper.__read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __removeProcessor_name = "removeProcessor";

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     **/
    public void removeProcessor(ProcessorPrx proc)
        throws omero.ServerError
    {
        removeProcessor(proc, null, false);
    }

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        removeProcessor(proc, __ctx, true);
    }

    private void removeProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "removeProcessor", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("removeProcessor");
                    __delBase = __getDelegate(false);
                    _SharedResourcesDel __del = (_SharedResourcesDel)__delBase;
                    __del.removeProcessor(proc, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeProcessor(ProcessorPrx proc)
    {
        return begin_removeProcessor(proc, null, false, null);
    }

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx)
    {
        return begin_removeProcessor(proc, __ctx, true, null);
    }

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeProcessor(ProcessorPrx proc, Ice.Callback __cb)
    {
        return begin_removeProcessor(proc, null, false, __cb);
    }

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_removeProcessor(proc, __ctx, true, __cb);
    }

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeProcessor(ProcessorPrx proc, Callback_SharedResources_removeProcessor __cb)
    {
        return begin_removeProcessor(proc, null, false, __cb);
    }

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx, Callback_SharedResources_removeProcessor __cb)
    {
        return begin_removeProcessor(proc, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_removeProcessor(ProcessorPrx proc, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__removeProcessor_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __removeProcessor_name, __cb);
        try
        {
            __result.__prepare(__removeProcessor_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            ProcessorPrxHelper.__write(__os, proc);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_removeProcessor(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __removeProcessor_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __repositories_name = "repositories";

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     **/
    public RepositoryMap repositories()
        throws omero.ServerError
    {
        return repositories(null, false);
    }

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     * @param __ctx The Context map to send with the invocation.
     **/
    public RepositoryMap repositories(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return repositories(__ctx, true);
    }

    private RepositoryMap repositories(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "repositories", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("repositories");
                    __delBase = __getDelegate(false);
                    _SharedResourcesDel __del = (_SharedResourcesDel)__delBase;
                    return __del.repositories(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_repositories()
    {
        return begin_repositories(null, false, null);
    }

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_repositories(java.util.Map<String, String> __ctx)
    {
        return begin_repositories(__ctx, true, null);
    }

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_repositories(Ice.Callback __cb)
    {
        return begin_repositories(null, false, __cb);
    }

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_repositories(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_repositories(__ctx, true, __cb);
    }

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_repositories(Callback_SharedResources_repositories __cb)
    {
        return begin_repositories(null, false, __cb);
    }

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_repositories(java.util.Map<String, String> __ctx, Callback_SharedResources_repositories __cb)
    {
        return begin_repositories(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_repositories(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__repositories_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __repositories_name, __cb);
        try
        {
            __result.__prepare(__repositories_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public RepositoryMap end_repositories(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __repositories_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            RepositoryMap __ret;
            __ret = new RepositoryMap();
            __ret.__read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public static SharedResourcesPrx checkedCast(Ice.ObjectPrx __obj)
    {
        SharedResourcesPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof SharedResourcesPrx)
            {
                __d = (SharedResourcesPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    SharedResourcesPrxHelper __h = new SharedResourcesPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static SharedResourcesPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        SharedResourcesPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof SharedResourcesPrx)
            {
                __d = (SharedResourcesPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    SharedResourcesPrxHelper __h = new SharedResourcesPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static SharedResourcesPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        SharedResourcesPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    SharedResourcesPrxHelper __h = new SharedResourcesPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static SharedResourcesPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        SharedResourcesPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    SharedResourcesPrxHelper __h = new SharedResourcesPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static SharedResourcesPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        SharedResourcesPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof SharedResourcesPrx)
            {
                __d = (SharedResourcesPrx)__obj;
            }
            else
            {
                SharedResourcesPrxHelper __h = new SharedResourcesPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static SharedResourcesPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        SharedResourcesPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            SharedResourcesPrxHelper __h = new SharedResourcesPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::SharedResources"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _SharedResourcesDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _SharedResourcesDelD();
    }

    public static void __write(IceInternal.BasicStream __os, SharedResourcesPrx v)
    {
        __os.writeProxy(v);
    }

    public static SharedResourcesPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            SharedResourcesPrxHelper result = new SharedResourcesPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
