// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Repositories.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * User configuration options. These are likely set in the UI
 * before the import is initiated.
 **/
public interface _ImportProcessOperations extends omero.api._StatefulServiceInterfaceOperations
{
    /**
     * Step 1: Returns a RawFileStore that can be used to upload one of
     * the used files. The index is the same as the used file listed in
     * {@link ImportLocation}. {@link omero.api.RawFileStore#close}
     * should be called once all data has been transferred. If the
     * file must be re-written, call {@link #getUploader} with the
     * same index again. Once all uploads have been completed,
     * {@link verifyUpload} should be called to initiate background
     * processing
     * @param __current The Current object for the invocation.
     **/
    omero.api.RawFileStorePrx getUploader(int i, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Step 2: Passes a set of client-side calculated hashes to the
     * server for verifying that all of the files were correctly
     * uploaded. If this passes then a {@link omero.cmd.Handle}
     * proxy is returned, which completes all the necessary import
     * steps. A successful import will return an
     * {@link ImportResponse}. Otherwise, some {@link omero.cmd.ERR}
     * will be returned.
     * @param __current The Current object for the invocation.
     **/
    omero.cmd.HandlePrx verifyUpload(java.util.List<String> hash, Ice.Current __current)
        throws omero.ServerError;

    /**
     * In case an upload must be resumed, this provides the
     * location of the last successful upload.
     * @param __current The Current object for the invocation.
     **/
    long getUploadOffset(int i, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Reacquire the handle which was returned by
     * {@link #verifyUpload}. This is useful in case a new
     * client is re-attaching to a running import.
     * From the {@link omero.cmd.Handle} instance, the
     * original {@link ImportRequest} can also be found.
     * @param __current The Current object for the invocation.
     **/
    omero.cmd.HandlePrx getHandle(Ice.Current __current)
        throws omero.ServerError;

    ImportSettings getImportSettings(Ice.Current __current);
}
