// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Scripts.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Client facing interface to the background processing
 * framework. If a user needs interactivity, one of these
 * processors should be acquired from the ServiceFactory.
 * Otherwise, a Job can be submitted via JobHandle.
 **/
public abstract class _InteractiveProcessorDisp extends Ice.ObjectImpl implements InteractiveProcessor
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::InteractiveProcessor"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     **/
    public final ProcessPrx execute(omero.RMap inputs)
        throws omero.ServerError
    {
        return execute(inputs, null);
    }

    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     **/
    public final long expires()
    {
        return expires(null);
    }

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     **/
    public final omero.model.Job getJob()
    {
        return getJob(null);
    }

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     **/
    public final omero.RMap getResults(ProcessPrx proc)
        throws omero.ServerError
    {
        return getResults(proc, null);
    }

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     **/
    public final JobParams params()
        throws omero.ServerError
    {
        return params(null);
    }

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     **/
    public final boolean setDetach(boolean detach)
        throws omero.ServerError
    {
        return setDetach(detach, null);
    }

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     **/
    public final void stop()
        throws omero.ServerError
    {
        stop(null);
    }

    public static Ice.DispatchStatus ___expires(InteractiveProcessor __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        long __ret = __obj.expires(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeLong(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___getJob(InteractiveProcessor __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        omero.model.Job __ret = __obj.getJob(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeObject(__ret);
        __os.writePendingObjects();
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___params(InteractiveProcessor __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        try
        {
            JobParams __ret = __obj.params(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(__ret);
            __os.writePendingObjects();
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___execute(InteractiveProcessor __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.RMapHolder inputs = new omero.RMapHolder();
        __is.readObject(inputs);
        __is.readPendingObjects();
        __inS.endReadParams();
        try
        {
            ProcessPrx __ret = __obj.execute(inputs.value, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            ProcessPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getResults(InteractiveProcessor __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        ProcessPrx proc;
        proc = ProcessPrxHelper.__read(__is);
        __inS.endReadParams();
        try
        {
            omero.RMap __ret = __obj.getResults(proc, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(__ret);
            __os.writePendingObjects();
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___setDetach(InteractiveProcessor __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean detach;
        detach = __is.readBool();
        __inS.endReadParams();
        try
        {
            boolean __ret = __obj.setDetach(detach, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(__ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___stop(InteractiveProcessor __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        try
        {
            __obj.stop(__current);
            __inS.__writeEmptyParams();
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    private final static String[] __all =
    {
        "execute",
        "expires",
        "getJob",
        "getResults",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "params",
        "setDetach",
        "stop"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___execute(this, in, __current);
            }
            case 1:
            {
                return ___expires(this, in, __current);
            }
            case 2:
            {
                return ___getJob(this, in, __current);
            }
            case 3:
            {
                return ___getResults(this, in, __current);
            }
            case 4:
            {
                return ___ice_id(this, in, __current);
            }
            case 5:
            {
                return ___ice_ids(this, in, __current);
            }
            case 6:
            {
                return ___ice_isA(this, in, __current);
            }
            case 7:
            {
                return ___ice_ping(this, in, __current);
            }
            case 8:
            {
                return ___params(this, in, __current);
            }
            case 9:
            {
                return ___setDetach(this, in, __current);
            }
            case 10:
            {
                return ___stop(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
