// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Scripts.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Client facing interface to the background processing
 * framework. If a user needs interactivity, one of these
 * processors should be acquired from the ServiceFactory.
 * Otherwise, a Job can be submitted via JobHandle.
 **/
public interface _InteractiveProcessorOperations
{
    /**
     * Returns the system clock time in milliseconds since the epoch
     * at which this processor will be reaped.
     * @param __current The Current object for the invocation.
     **/
    long expires(Ice.Current __current);

    /**
     * Returns the job which defines this processor. This may be
     * only the last job associated with the processor if execute
     * is called multiple times.
     * @param __current The Current object for the invocation.
     **/
    omero.model.Job getJob(Ice.Current __current);

    /**
     * Retrieves the parameters needed to be passed in an execution
     * and the results which will be passed back out.
     * 
     * This method is guaranteed to return a non-null value or throw an exception.
     * @param __current The Current object for the invocation.
     **/
    JobParams params(Ice.Current __current)
        throws omero.ServerError;

    /**
     * Executes an instance of the job returned by getJob() using
     * the given map as inputs.
     * @param __current The Current object for the invocation.
     **/
    ProcessPrx execute(omero.RMap inputs, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Retrieve the results for the given process. This will throw
     * an ApiUsageException if called before the process has returned.
     * Use either process.poll() or process.wait() or a ProcessCallback
     * to wait for completion before calling.
     * 
     * If the user has not overridden or disabled the output values
     * "stdout" and "stderr", these will be filled with the OriginalFile
     * instances uploaded after completion under the key values of the
     * same name.
     * @param __current The Current object for the invocation.
     **/
    omero.RMap getResults(ProcessPrx proc, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Sets whether or not cancel will be called on the current
     * {@link Process} on stop. If detach is true, then the
     * {@link Process} will continue running. Otherwise,
     * {@link Process#cancel} will be called, before preparing for
     * another run.
     * 
     * false by default
     * 
     * @param __current The Current object for the invocation.
     **/
    boolean setDetach(boolean detach, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Clears the current execution of {@link omero.model.Job} from
     * the processor to prepare for another execution.
     * 
     * cancel() will be called on the current {@link Process}
     * if detach is set to false.
     * @param __current The Current object for the invocation.
     **/
    void stop(Ice.Current __current)
        throws omero.ServerError;
}
