// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Repositories.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * FS-enabled repository which can convert uploaded files
 * into Images by using Bio-Formats to import them.
 **/
public abstract class _ManagedRepositoryDisp extends Ice.ObjectImpl implements ManagedRepository
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::ManagedRepository",
        "::omero::grid::Repository"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Returns an {@link ImportProcess} which can be used to upload files.
     * On {@link ImportProcess#verifyUpload}, an {@link omero.cmd.Handle} will be
     * returned which can be watched for knowing when the server-side import
     * is complete.
     * 
     * Client paths set in the fileset entries must /-separate their components.
     * 
     * Once the upload is complete, the {@link ImportProcess} must be closed.
     * Once {@link omero.cmd.Handle#getResponse} returns a non-null value, the
     * handle instance can and must be closed.
     **/
    public final ImportProcessPrx importFileset(omero.model.Fileset fs, ImportSettings settings)
        throws omero.ServerError
    {
        return importFileset(fs, settings, null);
    }

    /**
     * For clients without access to Bio-Formats, the simplified
     * {@link #importPaths} method allows passing solely the absolute
     * path of the files to be uploaded (no directories) and all
     * configuration happens server-side. Much of the functionality
     * provided via {@link omero.model.Fileset} and
     * {@link omero.grid.ImportSettings} is of course lost.
     **/
    public final ImportProcessPrx importPaths(java.util.List<String> filePaths)
        throws omero.ServerError
    {
        return importPaths(filePaths, null);
    }

    /**
     * Return the list of checksum algorithms supported by this repository
     * for verifying the integrity of uploaded files.
     * They are named as ""algorithm-integer"",
     * integer being the bit width of the resulting hash code.
     * It is possible for the same algorithm to be offered with
     * different bit widths.
     * They are listed in descending order of preference,
     * as set by the server administrator, and any of them may
     * be specified for {@link ImportSettings#checksumAlgorithm}.
     **/
    public final java.util.List<omero.model.ChecksumAlgorithm> listChecksumAlgorithms()
    {
        return listChecksumAlgorithms(null);
    }

    /**
     * List imports that are currently running in this importer.
     * These will be limited based on user/group membership for
     * the {@link omero.model.Fileset} object which is being created
     * by the import. If the user has write permissions for the
     * fileset, then the import will be included.
     **/
    public final java.util.List<omero.grid.ImportProcessPrx> listImports()
        throws omero.ServerError
    {
        return listImports(null);
    }

    /**
     * Set the checksum algorithm for the original files identified
     * by the given IDs and calculate their checksum accordingly.
     * The files must be in this repository.
     * Existing checksums are checked before being changed.
     * If a checksum does not match, ServerError will be thrown;
     * in this case some other files may already have had their
     * checksum algorithm set.
     * Returns the IDs of the original files that did not already
     * have a checksum set for the given algorithm.
     **/
    public final java.util.List<Long> setChecksumAlgorithm(omero.model.ChecksumAlgorithm hasher, java.util.List<Long> ids)
        throws omero.ServerError
    {
        return setChecksumAlgorithm(hasher, ids, null);
    }

    /**
     * Suggest a checksum algorithm to use for
     * {@link ImportSettings#checksumAlgorithm} according to the
     * preferences set by the server administrator. Provide a
     * list of the algorithms supported by the client, and the
     * server will report which of them is most preferred by
     * the server, or return null if none of them are supported.
     **/
    public final omero.model.ChecksumAlgorithm suggestChecksumAlgorithm(java.util.List<omero.model.ChecksumAlgorithm> supported)
    {
        return suggestChecksumAlgorithm(supported, null);
    }

    /**
     * Verify the checksum for the original files identified by
     * the given IDs.
     * The files must be in this repository.
     * Returns the IDs of the original files whose checksums
     * do not match the file on disk.
     **/
    public final java.util.List<Long> verifyChecksums(java.util.List<Long> ids)
        throws omero.ServerError
    {
        return verifyChecksums(ids, null);
    }

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     **/
    public final omero.cmd.HandlePrx deletePaths(String[] paths, boolean recursively, boolean force)
        throws omero.ServerError
    {
        return deletePaths(paths, recursively, force, null);
    }

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     **/
    public final omero.api.RawFileStorePrx file(String path, String mode)
        throws omero.ServerError
    {
        return file(path, mode, null);
    }

    public final omero.api.RawFileStorePrx fileById(long id)
        throws omero.ServerError
    {
        return fileById(id, null);
    }

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     **/
    public final boolean fileExists(String path)
        throws omero.ServerError
    {
        return fileExists(path, null);
    }

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     **/
    public final java.util.List<String> list(String path)
        throws omero.ServerError
    {
        return list(path, null);
    }

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     **/
    public final java.util.List<omero.model.OriginalFile> listFiles(String path)
        throws omero.ServerError
    {
        return listFiles(path, null);
    }

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     **/
    public final void makeDir(String path, boolean parents)
        throws omero.ServerError
    {
        makeDir(path, parents, null);
    }

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     **/
    public final String mimetype(String path)
        throws omero.ServerError
    {
        return mimetype(path, null);
    }

    public final omero.api.RawPixelsStorePrx pixels(String path)
        throws omero.ServerError
    {
        return pixels(path, null);
    }

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     **/
    public final omero.model.OriginalFile register(String path, omero.RString mimetype)
        throws omero.ServerError
    {
        return register(path, mimetype, null);
    }

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     **/
    public final omero.model.OriginalFile root()
        throws omero.ServerError
    {
        return root(null);
    }

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     **/
    public final omero.RMap treeList(String path)
        throws omero.ServerError
    {
        return treeList(path, null);
    }

    public static Ice.DispatchStatus ___importFileset(ManagedRepository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.FilesetHolder fs = new omero.model.FilesetHolder();
        ImportSettingsHolder settings = new ImportSettingsHolder();
        __is.readObject(fs);
        __is.readObject(settings);
        __is.readPendingObjects();
        __inS.endReadParams();
        try
        {
            ImportProcessPrx __ret = __obj.importFileset(fs.value, settings.value, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            ImportProcessPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___importPaths(ManagedRepository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<String> filePaths;
        filePaths = omero.api.StringSetHelper.read(__is);
        __inS.endReadParams();
        try
        {
            ImportProcessPrx __ret = __obj.importPaths(filePaths, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            ImportProcessPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___listImports(ManagedRepository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            java.util.List<omero.grid.ImportProcessPrx> __ret = __obj.listImports(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            ImportProcessListHelper.write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___listChecksumAlgorithms(ManagedRepository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        java.util.List<omero.model.ChecksumAlgorithm> __ret = __obj.listChecksumAlgorithms(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        omero.api.ChecksumAlgorithmListHelper.write(__os, __ret);
        __os.writePendingObjects();
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___suggestChecksumAlgorithm(ManagedRepository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<omero.model.ChecksumAlgorithm> supported;
        supported = omero.api.ChecksumAlgorithmListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        omero.model.ChecksumAlgorithm __ret = __obj.suggestChecksumAlgorithm(supported, __current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeObject(__ret);
        __os.writePendingObjects();
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___verifyChecksums(ManagedRepository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        java.util.List<Long> ids;
        ids = omero.api.LongListHelper.read(__is);
        __inS.endReadParams();
        try
        {
            java.util.List<Long> __ret = __obj.verifyChecksums(ids, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.api.LongListHelper.write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___setChecksumAlgorithm(ManagedRepository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ChecksumAlgorithmHolder hasher = new omero.model.ChecksumAlgorithmHolder();
        java.util.List<Long> ids;
        __is.readObject(hasher);
        ids = omero.api.LongListHelper.read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        try
        {
            java.util.List<Long> __ret = __obj.setChecksumAlgorithm(hasher.value, ids, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.api.LongListHelper.write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    private final static String[] __all =
    {
        "deletePaths",
        "file",
        "fileById",
        "fileExists",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "importFileset",
        "importPaths",
        "list",
        "listChecksumAlgorithms",
        "listFiles",
        "listImports",
        "makeDir",
        "mimetype",
        "pixels",
        "register",
        "root",
        "setChecksumAlgorithm",
        "suggestChecksumAlgorithm",
        "treeList",
        "verifyChecksums"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return _RepositoryDisp.___deletePaths(this, in, __current);
            }
            case 1:
            {
                return _RepositoryDisp.___file(this, in, __current);
            }
            case 2:
            {
                return _RepositoryDisp.___fileById(this, in, __current);
            }
            case 3:
            {
                return _RepositoryDisp.___fileExists(this, in, __current);
            }
            case 4:
            {
                return ___ice_id(this, in, __current);
            }
            case 5:
            {
                return ___ice_ids(this, in, __current);
            }
            case 6:
            {
                return ___ice_isA(this, in, __current);
            }
            case 7:
            {
                return ___ice_ping(this, in, __current);
            }
            case 8:
            {
                return ___importFileset(this, in, __current);
            }
            case 9:
            {
                return ___importPaths(this, in, __current);
            }
            case 10:
            {
                return _RepositoryDisp.___list(this, in, __current);
            }
            case 11:
            {
                return ___listChecksumAlgorithms(this, in, __current);
            }
            case 12:
            {
                return _RepositoryDisp.___listFiles(this, in, __current);
            }
            case 13:
            {
                return ___listImports(this, in, __current);
            }
            case 14:
            {
                return _RepositoryDisp.___makeDir(this, in, __current);
            }
            case 15:
            {
                return _RepositoryDisp.___mimetype(this, in, __current);
            }
            case 16:
            {
                return _RepositoryDisp.___pixels(this, in, __current);
            }
            case 17:
            {
                return _RepositoryDisp.___register(this, in, __current);
            }
            case 18:
            {
                return _RepositoryDisp.___root(this, in, __current);
            }
            case 19:
            {
                return ___setChecksumAlgorithm(this, in, __current);
            }
            case 20:
            {
                return ___suggestChecksumAlgorithm(this, in, __current);
            }
            case 21:
            {
                return _RepositoryDisp.___treeList(this, in, __current);
            }
            case 22:
            {
                return ___verifyChecksums(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
