// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Repositories.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * FS-enabled repository which can convert uploaded files
 * into Images by using Bio-Formats to import them.
 **/
public interface _ManagedRepositoryOperations extends _RepositoryOperations
{
    /**
     * Returns an {@link ImportProcess} which can be used to upload files.
     * On {@link ImportProcess#verifyUpload}, an {@link omero.cmd.Handle} will be
     * returned which can be watched for knowing when the server-side import
     * is complete.
     * 
     * Client paths set in the fileset entries must /-separate their components.
     * 
     * Once the upload is complete, the {@link ImportProcess} must be closed.
     * Once {@link omero.cmd.Handle#getResponse} returns a non-null value, the
     * handle instance can and must be closed.
     * @param __current The Current object for the invocation.
     **/
    ImportProcessPrx importFileset(omero.model.Fileset fs, ImportSettings settings, Ice.Current __current)
        throws omero.ServerError;

    /**
     * For clients without access to Bio-Formats, the simplified
     * {@link #importPaths} method allows passing solely the absolute
     * path of the files to be uploaded (no directories) and all
     * configuration happens server-side. Much of the functionality
     * provided via {@link omero.model.Fileset} and
     * {@link omero.grid.ImportSettings} is of course lost.
     * @param __current The Current object for the invocation.
     **/
    ImportProcessPrx importPaths(java.util.List<String> filePaths, Ice.Current __current)
        throws omero.ServerError;

    /**
     * List imports that are currently running in this importer.
     * These will be limited based on user/group membership for
     * the {@link omero.model.Fileset} object which is being created
     * by the import. If the user has write permissions for the
     * fileset, then the import will be included.
     * @param __current The Current object for the invocation.
     **/
    java.util.List<omero.grid.ImportProcessPrx> listImports(Ice.Current __current)
        throws omero.ServerError;

    /**
     * Return the list of checksum algorithms supported by this repository
     * for verifying the integrity of uploaded files.
     * They are named as ""algorithm-integer"",
     * integer being the bit width of the resulting hash code.
     * It is possible for the same algorithm to be offered with
     * different bit widths.
     * They are listed in descending order of preference,
     * as set by the server administrator, and any of them may
     * be specified for {@link ImportSettings#checksumAlgorithm}.
     * @param __current The Current object for the invocation.
     **/
    java.util.List<omero.model.ChecksumAlgorithm> listChecksumAlgorithms(Ice.Current __current);

    /**
     * Suggest a checksum algorithm to use for
     * {@link ImportSettings#checksumAlgorithm} according to the
     * preferences set by the server administrator. Provide a
     * list of the algorithms supported by the client, and the
     * server will report which of them is most preferred by
     * the server, or return null if none of them are supported.
     * @param __current The Current object for the invocation.
     **/
    omero.model.ChecksumAlgorithm suggestChecksumAlgorithm(java.util.List<omero.model.ChecksumAlgorithm> supported, Ice.Current __current);

    /**
     * Verify the checksum for the original files identified by
     * the given IDs.
     * The files must be in this repository.
     * Returns the IDs of the original files whose checksums
     * do not match the file on disk.
     * @param __current The Current object for the invocation.
     **/
    java.util.List<Long> verifyChecksums(java.util.List<Long> ids, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Set the checksum algorithm for the original files identified
     * by the given IDs and calculate their checksum accordingly.
     * The files must be in this repository.
     * Existing checksums are checked before being changed.
     * If a checksum does not match, ServerError will be thrown;
     * in this case some other files may already have had their
     * checksum algorithm set.
     * Returns the IDs of the original files that did not already
     * have a checksum set for the given algorithm.
     * @param __current The Current object for the invocation.
     **/
    java.util.List<Long> setChecksumAlgorithm(omero.model.ChecksumAlgorithm hasher, java.util.List<Long> ids, Ice.Current __current)
        throws omero.ServerError;
}
