// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Scripts.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Simple controller for Processes. Uses the session
 * id given to create an Ice.Config file which is used
 * as the sole argument to an execution of the given job.
 * 
 * Jobs are responsible for loading arguments from the
 * environment via the session id.
 **/
public abstract class _ProcessorDisp extends Ice.ObjectImpl implements Processor
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::Processor"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     **/
    public final JobParams parseJob(String session, omero.model.Job jobObject)
        throws omero.ServerError
    {
        return parseJob(session, jobObject, null);
    }

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     **/
    public final ProcessPrx processJob(String session, JobParams params, omero.model.Job jobObject)
        throws omero.ServerError
    {
        return processJob(session, params, jobObject, null);
    }

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     **/
    public final void requestRunning(ProcessorCallbackPrx cb)
    {
        requestRunning(cb, null);
    }

    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     **/
    public final void willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb)
    {
        willAccept(userContext, groupContext, scriptContext, cb, null);
    }

    public static Ice.DispatchStatus ___willAccept(Processor __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.ExperimenterHolder userContext = new omero.model.ExperimenterHolder();
        omero.model.ExperimenterGroupHolder groupContext = new omero.model.ExperimenterGroupHolder();
        omero.model.JobHolder scriptContext = new omero.model.JobHolder();
        ProcessorCallbackPrx cb;
        __is.readObject(userContext);
        __is.readObject(groupContext);
        __is.readObject(scriptContext);
        cb = ProcessorCallbackPrxHelper.__read(__is);
        __is.readPendingObjects();
        __inS.endReadParams();
        __obj.willAccept(userContext.value, groupContext.value, scriptContext.value, cb, __current);
        __inS.__writeEmptyParams();
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___requestRunning(Processor __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        ProcessorCallbackPrx cb;
        cb = ProcessorCallbackPrxHelper.__read(__is);
        __inS.endReadParams();
        __obj.requestRunning(cb, __current);
        __inS.__writeEmptyParams();
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___parseJob(Processor __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String session;
        omero.model.JobHolder jobObject = new omero.model.JobHolder();
        session = __is.readString();
        __is.readObject(jobObject);
        __is.readPendingObjects();
        __inS.endReadParams();
        try
        {
            JobParams __ret = __obj.parseJob(session, jobObject.value, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(__ret);
            __os.writePendingObjects();
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___processJob(Processor __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String session;
        JobParamsHolder params = new JobParamsHolder();
        omero.model.JobHolder jobObject = new omero.model.JobHolder();
        session = __is.readString();
        __is.readObject(params);
        __is.readObject(jobObject);
        __is.readPendingObjects();
        __inS.endReadParams();
        try
        {
            ProcessPrx __ret = __obj.processJob(session, params.value, jobObject.value, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            ProcessPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    private final static String[] __all =
    {
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "parseJob",
        "processJob",
        "requestRunning",
        "willAccept"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___ice_id(this, in, __current);
            }
            case 1:
            {
                return ___ice_ids(this, in, __current);
            }
            case 2:
            {
                return ___ice_isA(this, in, __current);
            }
            case 3:
            {
                return ___ice_ping(this, in, __current);
            }
            case 4:
            {
                return ___parseJob(this, in, __current);
            }
            case 5:
            {
                return ___processJob(this, in, __current);
            }
            case 6:
            {
                return ___requestRunning(this, in, __current);
            }
            case 7:
            {
                return ___willAccept(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
