// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Scripts.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Simple controller for Processes. Uses the session
 * id given to create an Ice.Config file which is used
 * as the sole argument to an execution of the given job.
 * 
 * Jobs are responsible for loading arguments from the
 * environment via the session id.
 **/
public interface _ProcessorOperations
{
    /**
     * Called by {@link omero.grid.SharedResources} to find a suitable
     * target for {@link omero.grid.SharedResources#acquireProcessor}.
     * New processor instances are added to the checklist by using
     * {@link omero.grid.SharedResources#addProcessor}. All processors
     * must respond with their session uuid in order to authorize
     * the action.
     * @param __current The Current object for the invocation.
     **/
    void willAccept(omero.model.Experimenter userContext, omero.model.ExperimenterGroup groupContext, omero.model.Job scriptContext, ProcessorCallbackPrx cb, Ice.Current __current);

    /**
     * Used by servers to find out what jobs are still active.
     * Response will be sent to
     * {@link ProcessorCallback#responseRunning}
     * @param __current The Current object for the invocation.
     **/
    void requestRunning(ProcessorCallbackPrx cb, Ice.Current __current);

    /**
     * Parses a job and returns metadata definition required
     * for properly submitting the job. This object will be
     * cached by the server, and passed back into {@link #processJob}
     * @param __current The Current object for the invocation.
     **/
    JobParams parseJob(String session, omero.model.Job jobObject, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Starts a process based on the given job
     * If this processor cannot handle the given job, a
     * null process will be returned. The {@param params} argument
     * was created by a previously call to {@link #parseJob}.
     * @param __current The Current object for the invocation.
     **/
    ProcessPrx processJob(String session, JobParams params, omero.model.Job jobObject, Ice.Current __current)
        throws omero.ServerError;
}
