// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Repositories.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Client-accessible interface representing a single mount point on the server-side.
 **/
public abstract class _RepositoryDisp extends Ice.ObjectImpl implements Repository
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::Repository"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     **/
    public final omero.cmd.HandlePrx deletePaths(String[] paths, boolean recursively, boolean force)
        throws omero.ServerError
    {
        return deletePaths(paths, recursively, force, null);
    }

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     **/
    public final omero.api.RawFileStorePrx file(String path, String mode)
        throws omero.ServerError
    {
        return file(path, mode, null);
    }

    public final omero.api.RawFileStorePrx fileById(long id)
        throws omero.ServerError
    {
        return fileById(id, null);
    }

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     **/
    public final boolean fileExists(String path)
        throws omero.ServerError
    {
        return fileExists(path, null);
    }

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     **/
    public final java.util.List<String> list(String path)
        throws omero.ServerError
    {
        return list(path, null);
    }

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     **/
    public final java.util.List<omero.model.OriginalFile> listFiles(String path)
        throws omero.ServerError
    {
        return listFiles(path, null);
    }

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     **/
    public final void makeDir(String path, boolean parents)
        throws omero.ServerError
    {
        makeDir(path, parents, null);
    }

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     **/
    public final String mimetype(String path)
        throws omero.ServerError
    {
        return mimetype(path, null);
    }

    public final omero.api.RawPixelsStorePrx pixels(String path)
        throws omero.ServerError
    {
        return pixels(path, null);
    }

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     **/
    public final omero.model.OriginalFile register(String path, omero.RString mimetype)
        throws omero.ServerError
    {
        return register(path, mimetype, null);
    }

    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     **/
    public final omero.model.OriginalFile root()
        throws omero.ServerError
    {
        return root(null);
    }

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     **/
    public final omero.RMap treeList(String path)
        throws omero.ServerError
    {
        return treeList(path, null);
    }

    public static Ice.DispatchStatus ___root(Repository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        try
        {
            omero.model.OriginalFile __ret = __obj.root(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(__ret);
            __os.writePendingObjects();
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___mimetype(Repository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String path;
        path = __is.readString();
        __inS.endReadParams();
        try
        {
            String __ret = __obj.mimetype(path, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(__ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___list(Repository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String path;
        path = __is.readString();
        __inS.endReadParams();
        try
        {
            java.util.List<String> __ret = __obj.list(path, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.api.StringSetHelper.write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___listFiles(Repository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String path;
        path = __is.readString();
        __inS.endReadParams();
        try
        {
            java.util.List<omero.model.OriginalFile> __ret = __obj.listFiles(path, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.api.OriginalFileListHelper.write(__os, __ret);
            __os.writePendingObjects();
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___register(Repository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String path;
        omero.RStringHolder mimetype = new omero.RStringHolder();
        path = __is.readString();
        __is.readObject(mimetype);
        __is.readPendingObjects();
        __inS.endReadParams();
        try
        {
            omero.model.OriginalFile __ret = __obj.register(path, mimetype.value, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(__ret);
            __os.writePendingObjects();
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___file(Repository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String path;
        String mode;
        path = __is.readString();
        mode = __is.readString();
        __inS.endReadParams();
        try
        {
            omero.api.RawFileStorePrx __ret = __obj.file(path, mode, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.api.RawFileStorePrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___pixels(Repository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String path;
        path = __is.readString();
        __inS.endReadParams();
        try
        {
            omero.api.RawPixelsStorePrx __ret = __obj.pixels(path, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.api.RawPixelsStorePrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___fileById(Repository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long id;
        id = __is.readLong();
        __inS.endReadParams();
        try
        {
            omero.api.RawFileStorePrx __ret = __obj.fileById(id, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.api.RawFileStorePrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___fileExists(Repository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String path;
        path = __is.readString();
        __inS.endReadParams();
        try
        {
            boolean __ret = __obj.fileExists(path, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(__ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___makeDir(Repository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String path;
        boolean parents;
        path = __is.readString();
        parents = __is.readBool();
        __inS.endReadParams();
        try
        {
            __obj.makeDir(path, parents, __current);
            __inS.__writeEmptyParams();
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___treeList(Repository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String path;
        path = __is.readString();
        __inS.endReadParams();
        try
        {
            omero.RMap __ret = __obj.treeList(path, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(__ret);
            __os.writePendingObjects();
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___deletePaths(Repository __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String[] paths;
        boolean recursively;
        boolean force;
        paths = omero.api.StringArrayHelper.read(__is);
        recursively = __is.readBool();
        force = __is.readBool();
        __inS.endReadParams();
        try
        {
            omero.cmd.HandlePrx __ret = __obj.deletePaths(paths, recursively, force, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.cmd.HandlePrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    private final static String[] __all =
    {
        "deletePaths",
        "file",
        "fileById",
        "fileExists",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "list",
        "listFiles",
        "makeDir",
        "mimetype",
        "pixels",
        "register",
        "root",
        "treeList"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___deletePaths(this, in, __current);
            }
            case 1:
            {
                return ___file(this, in, __current);
            }
            case 2:
            {
                return ___fileById(this, in, __current);
            }
            case 3:
            {
                return ___fileExists(this, in, __current);
            }
            case 4:
            {
                return ___ice_id(this, in, __current);
            }
            case 5:
            {
                return ___ice_ids(this, in, __current);
            }
            case 6:
            {
                return ___ice_isA(this, in, __current);
            }
            case 7:
            {
                return ___ice_ping(this, in, __current);
            }
            case 8:
            {
                return ___list(this, in, __current);
            }
            case 9:
            {
                return ___listFiles(this, in, __current);
            }
            case 10:
            {
                return ___makeDir(this, in, __current);
            }
            case 11:
            {
                return ___mimetype(this, in, __current);
            }
            case 12:
            {
                return ___pixels(this, in, __current);
            }
            case 13:
            {
                return ___register(this, in, __current);
            }
            case 14:
            {
                return ___root(this, in, __current);
            }
            case 15:
            {
                return ___treeList(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
