// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Repositories.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Client-accessible interface representing a single mount point on the server-side.
 **/
public interface _RepositoryOperationsNC
{
    /**
     * Return the OriginalFile descriptor for this Repository. It will have
     * the path of the repository's root on the underlying filesystem.
     **/
    omero.model.OriginalFile root()
        throws omero.ServerError;

    /**
     * Returns the best-guess mimetype for the given path.
     * 
     **/
    String mimetype(String path)
        throws omero.ServerError;

    /**
     * Returns a set of strings naming the files and directories in
     * the directory denoted by an abstract pathname.
     **/
    java.util.List<String> list(String path)
        throws omero.ServerError;

    /**
     * Returns an array of abstract pathname objects denoting the
     * files in the directory denoted by an abstract pathname.  It
     * is expected that at a minimum the ""name"", ""path"", ""size"" and
     * ""mtime"" attributes will be present for each
     * {@link omero.model.OriginalFile} instance.
     **/
    java.util.List<omero.model.OriginalFile> listFiles(String path)
        throws omero.ServerError;

    /**
     * Create an OriginalFile in the database for the given path.
     * 
     **/
    omero.model.OriginalFile register(String path, omero.RString mimetype)
        throws omero.ServerError;

    /**
     * Returns a special RawFileStore which permits only the operations
     * set out in the options string ""wb"", ""a+"", etc.
     * FIXME: Initially only ""r"" and ""rw"" are supported as these are
     * handled directly by RandomAccessFile and so don't break the current
     * implementation.
     * Any call to that tries to break the options will throw an
     * ApiUsageException. If a file exists at the given path, a
     * ValidationException will be thrown.
     **/
    omero.api.RawFileStorePrx file(String path, String mode)
        throws omero.ServerError;

    omero.api.RawPixelsStorePrx pixels(String path)
        throws omero.ServerError;

    omero.api.RawFileStorePrx fileById(long id)
        throws omero.ServerError;

    /**
     * Returns true if the file or path exists within the repository.
     * In other words, if a call on `dirname path` to
     * {@link #listFiles} would return an object for this path.
     **/
    boolean fileExists(String path)
        throws omero.ServerError;

    /**
     * Create a directory at the given path. If parents is true,
     * then all preceding paths will be generated and no exception
     * will be thrown if the directory already exists. Otherwise,
     * all parent directories must exist in both the DB and on the
     * filesystem and be readable.
     **/
    void makeDir(String path, boolean parents)
        throws omero.ServerError;

    /**
     * Similar to {@link #list} but recursive and returns only
     * primitive values for the file at each location. Guaranteed for
     * each path is only the values id and mimetype.
     * 
     * After a call to unwrap, the returned {@link omero.RMap} for a
     * call to treeList("/user_1/dir0") might look something like:
     * 
     * <pre>
     * {
     * "/user_1/dir0/file1.txt" :
     * {
     * "id":10,
     * "mimetype":
     * "binary",
     * "size": 10000L
     * },
     * 
     * "/user_1/dir0/dir1" :
     * {
     * "id": 100,
     * "mimetype": "Directory",
     * "size": 0L,
     * "files":
     * {
     * "/user_1/dir0/dir1/file1indir.txt" :
     * {
     * "id": 1,
     * "mimetype": "png",
     * "size": 500
     * }
     * }
     * }
     * }
     * </pre>
     **/
    omero.RMap treeList(String path)
        throws omero.ServerError;

    /**
     * Delete several individual paths. Internally, this converts
     * all of the paths into a single {@link omero.cmd.Delete2} command
     * and submits it.
     * 
     * If a ""recursively"" is true, then directories will be searched
     * and all of their contained files will be placed before them in
     * the delete order. When the directory is removed from the database,
     * it will removed from the filesystem if and only if it is empty.
     * 
     * If ""recursively"" is false, then the delete will produce an error
     * according to the ""force"" flag.
     * 
     * If ""force"" is false, this method attempts the delete of all given
     * paths in a single transaction, and any failure will cause the
     * entire transaction to fail.
     * 
     * If ""force"" is true, however, then all the other deletes will succeed.
     * which could possibly leave dangling files within no longer extant
     * directories.
     * 
     **/
    omero.cmd.HandlePrx deletePaths(String[] paths, boolean recursively, boolean force)
        throws omero.ServerError;
}
