// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Scripts.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Extension of the {@link Process} interface which is returned by
 * {@link IScript} when an {@link omero.model.ScriptJob} is launched.
 * It is critical that instances of (@link ScriptProcess} are closed
 * on completetion. See the {@link #close} method for more information.
 **/
public abstract class _ScriptProcessDisp extends Ice.ObjectImpl implements ScriptProcess
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::Process",
        "::omero::grid::ScriptProcess"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[2];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[2];
    }

    public static String ice_staticId()
    {
        return __ids[2];
    }

    /**
     * Signal to the Process that it should terminate. This may
     * be done "softly" for a given time period.
     **/
    public final boolean cancel()
        throws omero.ServerError
    {
        return cancel(null);
    }

    /**
     * Terminate the Process immediately.
     **/
    public final boolean kill()
    {
        return kill(null);
    }

    /**
     * Returns the return code of the process, or null
     * if unfinished.
     **/
    public final omero.RInt poll()
        throws omero.ServerError
    {
        return poll(null);
    }

    /**
     * Add a callback for end-of-life events
     **/
    public final void registerCallback(ProcessCallbackPrx cb)
        throws omero.ServerError
    {
        registerCallback(cb, null);
    }

    /**
     * First attempts cancel() several times and finally
     * resorts to kill to force the process to shutdown
     * cleanly. This method doesn't return any value or
     * throw an exception so that it can be called oneway.
     **/
    public final void shutdown()
    {
        shutdown(null);
    }

    /**
     * Remove a callback for end-of-life events
     **/
    public final void unregisterCallback(ProcessCallbackPrx cb)
        throws omero.ServerError
    {
        unregisterCallback(cb, null);
    }

    /**
     * Blocks until poll() would return a non-null return code.
     **/
    public final int _wait()
        throws omero.ServerError
    {
        return _wait(null);
    }

    /**
     * Closes this process and frees server resources attached to it.
     * If the detach argument is True, then the background process
     * will continue executing. The user can reconnect to the process
     * via the {@link IScript} service.
     * 
     * If the detach argument is False, then the background process
     * will be shutdown immediately, and all intermediate results
     * (stdout, stderr, ...) will be uploaded.
     **/
    public final void close(boolean detach)
        throws omero.ServerError
    {
        close(detach, null);
    }

    /**
     * Returns the job which started this process. Several
     * scheduling fields (submitted, scheduledFor, started, finished)
     * may be of interest.
     **/
    public final omero.model.ScriptJob getJob()
        throws omero.ServerError
    {
        return getJob(null);
    }

    /**
     * Returns the results immediately if present. If the process
     * is not yet finished, waits "waitSecs" before throwing an
     * {@link omero.ApiUsageException}. If poll has returned a non-null
     * value, then this method will always return a non-null value.
     **/
    public final java.util.Map<java.lang.String, omero.RType> getResults(int waitSecs)
        throws omero.ServerError
    {
        return getResults(waitSecs, null);
    }

    /**
     * Sets the message on the {@link omero.model.ScriptJob} object.
     * This value MAY be overwritten by the server if the script
     * fails.
     **/
    public final String setMessage(String message)
        throws omero.ServerError
    {
        return setMessage(message, null);
    }

    public static Ice.DispatchStatus ___getJob(ScriptProcess __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        try
        {
            omero.model.ScriptJob __ret = __obj.getJob(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(__ret);
            __os.writePendingObjects();
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getResults(ScriptProcess __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int waitSecs;
        waitSecs = __is.readInt();
        __inS.endReadParams();
        try
        {
            java.util.Map<java.lang.String, omero.RType> __ret = __obj.getResults(waitSecs, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.RTypeDictHelper.write(__os, __ret);
            __os.writePendingObjects();
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___setMessage(ScriptProcess __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String message;
        message = __is.readString();
        __inS.endReadParams();
        try
        {
            String __ret = __obj.setMessage(message, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(__ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___close(ScriptProcess __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean detach;
        detach = __is.readBool();
        __inS.endReadParams();
        try
        {
            __obj.close(detach, __current);
            __inS.__writeEmptyParams();
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    private final static String[] __all =
    {
        "cancel",
        "close",
        "getJob",
        "getResults",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "kill",
        "poll",
        "registerCallback",
        "setMessage",
        "shutdown",
        "unregisterCallback",
        "wait"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return _ProcessDisp.___cancel(this, in, __current);
            }
            case 1:
            {
                return ___close(this, in, __current);
            }
            case 2:
            {
                return ___getJob(this, in, __current);
            }
            case 3:
            {
                return ___getResults(this, in, __current);
            }
            case 4:
            {
                return ___ice_id(this, in, __current);
            }
            case 5:
            {
                return ___ice_ids(this, in, __current);
            }
            case 6:
            {
                return ___ice_isA(this, in, __current);
            }
            case 7:
            {
                return ___ice_ping(this, in, __current);
            }
            case 8:
            {
                return _ProcessDisp.___kill(this, in, __current);
            }
            case 9:
            {
                return _ProcessDisp.___poll(this, in, __current);
            }
            case 10:
            {
                return _ProcessDisp.___registerCallback(this, in, __current);
            }
            case 11:
            {
                return ___setMessage(this, in, __current);
            }
            case 12:
            {
                return _ProcessDisp.___shutdown(this, in, __current);
            }
            case 13:
            {
                return _ProcessDisp.___unregisterCallback(this, in, __current);
            }
            case 14:
            {
                return _ProcessDisp.___wait(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
