// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Scripts.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Extension of the {@link Process} interface which is returned by
 * {@link IScript} when an {@link omero.model.ScriptJob} is launched.
 * It is critical that instances of (@link ScriptProcess} are closed
 * on completetion. See the {@link #close} method for more information.
 **/
public interface _ScriptProcessOperations extends _ProcessOperations
{
    /**
     * Returns the job which started this process. Several
     * scheduling fields (submitted, scheduledFor, started, finished)
     * may be of interest.
     * @param __current The Current object for the invocation.
     **/
    omero.model.ScriptJob getJob(Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns the results immediately if present. If the process
     * is not yet finished, waits "waitSecs" before throwing an
     * {@link omero.ApiUsageException}. If poll has returned a non-null
     * value, then this method will always return a non-null value.
     * @param __current The Current object for the invocation.
     **/
    java.util.Map<java.lang.String, omero.RType> getResults(int waitSecs, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Sets the message on the {@link omero.model.ScriptJob} object.
     * This value MAY be overwritten by the server if the script
     * fails.
     * @param __current The Current object for the invocation.
     **/
    String setMessage(String message, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Closes this process and frees server resources attached to it.
     * If the detach argument is True, then the background process
     * will continue executing. The user can reconnect to the process
     * via the {@link IScript} service.
     * 
     * If the detach argument is False, then the background process
     * will be shutdown immediately, and all intermediate results
     * (stdout, stderr, ...) will be uploaded.
     * @param __current The Current object for the invocation.
     **/
    void close(boolean detach, Ice.Current __current)
        throws omero.ServerError;
}
