// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `SharedResources.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Resource manager provided by each Blitz session for acquiring
 * shared resources in the OmeroGrid. Unlike the other services
 * provided by ServiceFactory instances, it is not guaranteed
 * that a service instance returned from this interface will be
 * returned if that resource happens to be busy. In that case,
 * a null will be returned.
 **/
public abstract class _SharedResourcesDisp extends Ice.ObjectImpl implements SharedResources
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::SharedResources"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     **/
    public final InteractiveProcessorPrx acquireProcessor(omero.model.Job job, int seconds)
        throws omero.ServerError
    {
        return acquireProcessor(job, seconds, null);
    }

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     **/
    public final void addProcessor(ProcessorPrx proc)
        throws omero.ServerError
    {
        addProcessor(proc, null);
    }

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     **/
    public final boolean areTablesEnabled()
        throws omero.ServerError
    {
        return areTablesEnabled(null);
    }

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     **/
    public final RepositoryPrx getScriptRepository()
        throws omero.ServerError
    {
        return getScriptRepository(null);
    }

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     **/
    public final TablePrx newTable(long repoId, String path)
        throws omero.ServerError
    {
        return newTable(repoId, path, null);
    }

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     **/
    public final TablePrx openTable(omero.model.OriginalFile file)
        throws omero.ServerError
    {
        return openTable(file, null);
    }

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     **/
    public final void removeProcessor(ProcessorPrx proc)
        throws omero.ServerError
    {
        removeProcessor(proc, null);
    }

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     **/
    public final RepositoryMap repositories()
        throws omero.ServerError
    {
        return repositories(null);
    }

    public static Ice.DispatchStatus ___acquireProcessor(SharedResources __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.JobHolder job = new omero.model.JobHolder();
        int seconds;
        __is.readObject(job);
        seconds = __is.readInt();
        __is.readPendingObjects();
        __inS.endReadParams();
        try
        {
            InteractiveProcessorPrx __ret = __obj.acquireProcessor(job.value, seconds, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            InteractiveProcessorPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___addProcessor(SharedResources __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        ProcessorPrx proc;
        proc = ProcessorPrxHelper.__read(__is);
        __inS.endReadParams();
        try
        {
            __obj.addProcessor(proc, __current);
            __inS.__writeEmptyParams();
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___removeProcessor(SharedResources __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        ProcessorPrx proc;
        proc = ProcessorPrxHelper.__read(__is);
        __inS.endReadParams();
        try
        {
            __obj.removeProcessor(proc, __current);
            __inS.__writeEmptyParams();
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___repositories(SharedResources __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        try
        {
            RepositoryMap __ret = __obj.repositories(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __ret.__write(__os);
            __os.writePendingObjects();
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getScriptRepository(SharedResources __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        try
        {
            RepositoryPrx __ret = __obj.getScriptRepository(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            RepositoryPrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___areTablesEnabled(SharedResources __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        __inS.readEmptyParams();
        try
        {
            boolean __ret = __obj.areTablesEnabled(__current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(__ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___newTable(SharedResources __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long repoId;
        String path;
        repoId = __is.readLong();
        path = __is.readString();
        __inS.endReadParams();
        try
        {
            TablePrx __ret = __obj.newTable(repoId, path, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            TablePrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___openTable(SharedResources __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.model.OriginalFileHolder file = new omero.model.OriginalFileHolder();
        __is.readObject(file);
        __is.readPendingObjects();
        __inS.endReadParams();
        try
        {
            TablePrx __ret = __obj.openTable(file.value, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            TablePrxHelper.__write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.ServerError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    private final static String[] __all =
    {
        "acquireProcessor",
        "addProcessor",
        "areTablesEnabled",
        "getScriptRepository",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "newTable",
        "openTable",
        "removeProcessor",
        "repositories"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___acquireProcessor(this, in, __current);
            }
            case 1:
            {
                return ___addProcessor(this, in, __current);
            }
            case 2:
            {
                return ___areTablesEnabled(this, in, __current);
            }
            case 3:
            {
                return ___getScriptRepository(this, in, __current);
            }
            case 4:
            {
                return ___ice_id(this, in, __current);
            }
            case 5:
            {
                return ___ice_ids(this, in, __current);
            }
            case 6:
            {
                return ___ice_isA(this, in, __current);
            }
            case 7:
            {
                return ___ice_ping(this, in, __current);
            }
            case 8:
            {
                return ___newTable(this, in, __current);
            }
            case 9:
            {
                return ___openTable(this, in, __current);
            }
            case 10:
            {
                return ___removeProcessor(this, in, __current);
            }
            case 11:
            {
                return ___repositories(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
