// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `SharedResources.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

/**
 * Resource manager provided by each Blitz session for acquiring
 * shared resources in the OmeroGrid. Unlike the other services
 * provided by ServiceFactory instances, it is not guaranteed
 * that a service instance returned from this interface will be
 * returned if that resource happens to be busy. In that case,
 * a null will be returned.
 **/
public interface _SharedResourcesOperations
{
    /**
     * Waits up to seconds to acquire a slot in a processor
     * which can handle the given job.
     * @param __current The Current object for the invocation.
     **/
    InteractiveProcessorPrx acquireProcessor(omero.model.Job job, int seconds, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Registers a {@link omero.grid.Processor} for Storm notifications
     * so that other sessions can query whether or not a given
     * processor would accept a given task.
     * @param __current The Current object for the invocation.
     **/
    void addProcessor(ProcessorPrx proc, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Unregisters a {@link omero.grid.Processor} from Storm
     * notifications. If the processor was not already registered via
     * {@link #addProcessor} this is a no-op.
     * @param __current The Current object for the invocation.
     **/
    void removeProcessor(ProcessorPrx proc, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns a map between Repository descriptions (omero::model::OriginalFile
     * instances) and RepositoryPrx instances (possibly null).
     * @param __current The Current object for the invocation.
     **/
    RepositoryMap repositories(Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns the single (possibly mirrored) script repository which makes
     * all official scripts available.
     * @param __current The Current object for the invocation.
     **/
    RepositoryPrx getScriptRepository(Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns true if a {@link Tables} service is active in the grid.
     * If this value is false, then all calls to {@link #newTable}
     * or {@link #openTable} will either fail or return null (possibly
     * blocking while waiting for a service to startup)
     * @param __current The Current object for the invocation.
     **/
    boolean areTablesEnabled(Ice.Current __current)
        throws omero.ServerError;

    /**
     * Creates a new Format(""OMERO.tables"") file at the given path
     * on the given repository. The returned Table proxy follows
     * the same semantics as the openTable method.
     * @param __current The Current object for the invocation.
     **/
    TablePrx newTable(long repoId, String path, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns a Table instance or null. Table instances are not
     * exclusively owned by the client and may throw an OptimisticLockException
     * if background modifications take place.
     * 
     * The file instance must be managed (i.e. have a non-null id) and
     * be of the format ""OMERO.tables"". Use newTable() to create
     * a new instance.
     * @param __current The Current object for the invocation.
     **/
    TablePrx openTable(omero.model.OriginalFile file, Ice.Current __current)
        throws omero.ServerError;
}
