// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Tables.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid;

public interface _TableOperations
{
    omero.model.OriginalFile getOriginalFile(Ice.Current __current)
        throws omero.ServerError;

    /**
     * Returns empty columns.
     * @param __current The Current object for the invocation.
     **/
    Column[] getHeaders(Ice.Current __current)
        throws omero.ServerError;

    long getNumberOfRows(Ice.Current __current)
        throws omero.ServerError;

    /**
     * http://www.pytables.org/docs/manual/apb.html
     * 
     * Leave all three of start, stop, step to 0 to disable.
     * 
     * TODO:Test effect of returning a billion rows matching getWhereList()
     * 
     * @param __current The Current object for the invocation.
     **/
    long[] getWhereList(String condition, java.util.Map<java.lang.String, omero.RType> variables, long start, long stop, long step, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Read the given rows of data.
     * 
     * {@param rowNumbers} must contain at least one element or an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __current The Current object for the invocation.
     **/
    Data readCoordinates(long[] rowNumbers, Ice.Current __current)
        throws omero.ServerError;

    /**
     * http://www.pytables.org/docs/manual/ch04.html#Table.read
     * @param __current The Current object for the invocation.
     **/
    Data read(long[] colNumbers, long start, long stop, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Simple slice method which will return only the given columns
     * and rows in the order supplied.
     * 
     * If colNumbers or rowNumbers is empty (or None), then all values
     * will be returned.
     * 
     * <h4>Python examples:</h4>
     * <pre>
     * data = table.slice(None, None)
     * assert len(data.rowNumbers) == table.getNumberOfRows()
     * 
     * data = table.slice(None, \[3,2,1])
     * assert data.rowNumbers == \[3,2,1]
     * </pre>
     * @param __current The Current object for the invocation.
     **/
    Data slice(long[] colNumbers, long[] rowNumbers, Ice.Current __current)
        throws omero.ServerError;

    void addData(Column[] cols, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Allows the user to modify a Data instance passed back
     * from a query method and have the values modified. It
     * is critical that the {@link Data#lastModification} and the
     * {@link Data#rowNumbers} fields are properly set. An exception
     * will be thrown if the data has since been modified.
     * @param __current The Current object for the invocation.
     **/
    void update(Data modifiedData, Ice.Current __current)
        throws omero.ServerError;

    java.util.Map<java.lang.String, omero.RType> getAllMetadata(Ice.Current __current)
        throws omero.ServerError;

    omero.RType getMetadata(String key, Ice.Current __current)
        throws omero.ServerError;

    void setAllMetadata(java.util.Map<java.lang.String, omero.RType> dict, Ice.Current __current)
        throws omero.ServerError;

    void setMetadata(String key, omero.RType value, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Initializes the structure based on
     * @param __current The Current object for the invocation.
     **/
    void initialize(Column[] cols, Ice.Current __current)
        throws omero.ServerError;

    /**
     * Adds a column and returns the position index of the new column.
     * @param __current The Current object for the invocation.
     **/
    int addColumn(Column col, Ice.Current __current)
        throws omero.ServerError;

    void delete(Ice.Current __current)
        throws omero.ServerError;

    void close(Ice.Current __current)
        throws omero.ServerError;
}
