// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `FS.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid.monitors;

public interface FileServerPrx extends Ice.ObjectPrx
{
    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain just the file names for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param absPath, an absolute path on the monitor's watch path (string).
     * @param filter, a filter to apply to the listing, cf. ls (string).
     * @return, a directory listing (Ice::StringSeq).
     * @throws omero::OmeroFSError
     **/
    public String[] getDirectory(String absPath, String filter)
        throws omero.OmeroFSError;

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain just the file names for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param absPath, an absolute path on the monitor's watch path (string).
     * @param filter, a filter to apply to the listing, cf. ls (string).
     * @param __ctx The Context map to send with the invocation.
     * @return, a directory listing (Ice::StringSeq).
     * @throws omero::OmeroFSError
     **/
    public String[] getDirectory(String absPath, String filter, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain just the file names for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDirectory(String absPath, String filter);

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain just the file names for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDirectory(String absPath, String filter, java.util.Map<String, String> __ctx);

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain just the file names for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDirectory(String absPath, String filter, Ice.Callback __cb);

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain just the file names for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDirectory(String absPath, String filter, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain just the file names for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDirectory(String absPath, String filter, Callback_FileServer_getDirectory __cb);

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain just the file names for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDirectory(String absPath, String filter, java.util.Map<String, String> __ctx, Callback_FileServer_getDirectory __cb);

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain just the file names for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __result The asynchronous result object.
     * @return, a directory listing (Ice::StringSeq).
     * @throws omero::OmeroFSError
     **/
    public String[] end_getDirectory(Ice.AsyncResult __result)
        throws omero.OmeroFSError;

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain the file stats for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param absPath, an absolute path on the monitor's watch path (string).
     * @param filter, a filter to apply to the listing, cf. ls (string).
     * @return, a directory listing (FileStatsList).
     * @throws omero::OmeroFSError
     **/
    public FileStats[] getBulkDirectory(String absPath, String filter)
        throws omero.OmeroFSError;

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain the file stats for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param absPath, an absolute path on the monitor's watch path (string).
     * @param filter, a filter to apply to the listing, cf. ls (string).
     * @param __ctx The Context map to send with the invocation.
     * @return, a directory listing (FileStatsList).
     * @throws omero::OmeroFSError
     **/
    public FileStats[] getBulkDirectory(String absPath, String filter, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain the file stats for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBulkDirectory(String absPath, String filter);

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain the file stats for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBulkDirectory(String absPath, String filter, java.util.Map<String, String> __ctx);

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain the file stats for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBulkDirectory(String absPath, String filter, Ice.Callback __cb);

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain the file stats for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBulkDirectory(String absPath, String filter, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain the file stats for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBulkDirectory(String absPath, String filter, Callback_FileServer_getBulkDirectory __cb);

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain the file stats for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBulkDirectory(String absPath, String filter, java.util.Map<String, String> __ctx, Callback_FileServer_getBulkDirectory __cb);

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain the file stats for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __result The asynchronous result object.
     * @return, a directory listing (FileStatsList).
     * @throws omero::OmeroFSError
     **/
    public FileStats[] end_getBulkDirectory(Ice.AsyncResult __result)
        throws omero.OmeroFSError;

    /**
     * Query the existence of a file
     * 
     * An exception will be raised if the method fails to determine the existence.
     * 
     * @param fileId, see above.
     * @return existence of file.
     * @throws omero::OmeroFSError
     **/
    public boolean fileExists(String fileId)
        throws omero.OmeroFSError;

    /**
     * Query the existence of a file
     * 
     * An exception will be raised if the method fails to determine the existence.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return existence of file.
     * @throws omero::OmeroFSError
     **/
    public boolean fileExists(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * Query the existence of a file
     * 
     * An exception will be raised if the method fails to determine the existence.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fileExists(String fileId);

    /**
     * Query the existence of a file
     * 
     * An exception will be raised if the method fails to determine the existence.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fileExists(String fileId, java.util.Map<String, String> __ctx);

    /**
     * Query the existence of a file
     * 
     * An exception will be raised if the method fails to determine the existence.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fileExists(String fileId, Ice.Callback __cb);

    /**
     * Query the existence of a file
     * 
     * An exception will be raised if the method fails to determine the existence.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fileExists(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Query the existence of a file
     * 
     * An exception will be raised if the method fails to determine the existence.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fileExists(String fileId, Callback_FileServer_fileExists __cb);

    /**
     * Query the existence of a file
     * 
     * An exception will be raised if the method fails to determine the existence.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fileExists(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_fileExists __cb);

    /**
     * Query the existence of a file
     * 
     * An exception will be raised if the method fails to determine the existence.
     * 
     * @param __result The asynchronous result object.
     * @return existence of file.
     * @throws omero::OmeroFSError
     **/
    public boolean end_fileExists(Ice.AsyncResult __result)
        throws omero.OmeroFSError;

    /**
     * Get base name of a file, this is the name
     * stripped of any path, e.g. file.ext
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return base name.
     * @throws omero::OmeroFSError
     **/
    public String getBaseName(String fileId)
        throws omero.OmeroFSError;

    /**
     * Get base name of a file, this is the name
     * stripped of any path, e.g. file.ext
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return base name.
     * @throws omero::OmeroFSError
     **/
    public String getBaseName(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * Get base name of a file, this is the name
     * stripped of any path, e.g. file.ext
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBaseName(String fileId);

    /**
     * Get base name of a file, this is the name
     * stripped of any path, e.g. file.ext
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBaseName(String fileId, java.util.Map<String, String> __ctx);

    /**
     * Get base name of a file, this is the name
     * stripped of any path, e.g. file.ext
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBaseName(String fileId, Ice.Callback __cb);

    /**
     * Get base name of a file, this is the name
     * stripped of any path, e.g. file.ext
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBaseName(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Get base name of a file, this is the name
     * stripped of any path, e.g. file.ext
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBaseName(String fileId, Callback_FileServer_getBaseName __cb);

    /**
     * Get base name of a file, this is the name
     * stripped of any path, e.g. file.ext
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBaseName(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_getBaseName __cb);

    /**
     * Get base name of a file, this is the name
     * stripped of any path, e.g. file.ext
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __result The asynchronous result object.
     * @return base name.
     * @throws omero::OmeroFSError
     **/
    public String end_getBaseName(Ice.AsyncResult __result)
        throws omero.OmeroFSError;

    /**
     * Get all FileStats of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return file stats (FileStats).
     * @throws omero::OmeroFSError
     **/
    public FileStats getStats(String fileId)
        throws omero.OmeroFSError;

    /**
     * Get all FileStats of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return file stats (FileStats).
     * @throws omero::OmeroFSError
     **/
    public FileStats getStats(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * Get all FileStats of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStats(String fileId);

    /**
     * Get all FileStats of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStats(String fileId, java.util.Map<String, String> __ctx);

    /**
     * Get all FileStats of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStats(String fileId, Ice.Callback __cb);

    /**
     * Get all FileStats of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStats(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Get all FileStats of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStats(String fileId, Callback_FileServer_getStats __cb);

    /**
     * Get all FileStats of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getStats(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_getStats __cb);

    /**
     * Get all FileStats of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __result The asynchronous result object.
     * @return file stats (FileStats).
     * @throws omero::OmeroFSError
     **/
    public FileStats end_getStats(Ice.AsyncResult __result)
        throws omero.OmeroFSError;

    /**
     * Get size of a file in bytes
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return byte size of file (long).
     * @throws omero::OmeroFSError
     **/
    public long getSize(String fileId)
        throws omero.OmeroFSError;

    /**
     * Get size of a file in bytes
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return byte size of file (long).
     * @throws omero::OmeroFSError
     **/
    public long getSize(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * Get size of a file in bytes
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSize(String fileId);

    /**
     * Get size of a file in bytes
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSize(String fileId, java.util.Map<String, String> __ctx);

    /**
     * Get size of a file in bytes
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSize(String fileId, Ice.Callback __cb);

    /**
     * Get size of a file in bytes
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSize(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Get size of a file in bytes
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSize(String fileId, Callback_FileServer_getSize __cb);

    /**
     * Get size of a file in bytes
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSize(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_getSize __cb);

    /**
     * Get size of a file in bytes
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __result The asynchronous result object.
     * @return byte size of file (long).
     * @throws omero::OmeroFSError
     **/
    public long end_getSize(Ice.AsyncResult __result)
        throws omero.OmeroFSError;

    /**
     * Get owner of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return owner of file (string).
     * @throws omero::OmeroFSError
     **/
    public String getOwner(String fileId)
        throws omero.OmeroFSError;

    /**
     * Get owner of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return owner of file (string).
     * @throws omero::OmeroFSError
     **/
    public String getOwner(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * Get owner of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOwner(String fileId);

    /**
     * Get owner of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOwner(String fileId, java.util.Map<String, String> __ctx);

    /**
     * Get owner of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOwner(String fileId, Ice.Callback __cb);

    /**
     * Get owner of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOwner(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Get owner of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOwner(String fileId, Callback_FileServer_getOwner __cb);

    /**
     * Get owner of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getOwner(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_getOwner __cb);

    /**
     * Get owner of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __result The asynchronous result object.
     * @return owner of file (string).
     * @throws omero::OmeroFSError
     **/
    public String end_getOwner(Ice.AsyncResult __result)
        throws omero.OmeroFSError;

    /**
     * Get ctime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return ctime of file (float).
     * @throws omero::OmeroFSError
     **/
    public float getCTime(String fileId)
        throws omero.OmeroFSError;

    /**
     * Get ctime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return ctime of file (float).
     * @throws omero::OmeroFSError
     **/
    public float getCTime(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * Get ctime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getCTime(String fileId);

    /**
     * Get ctime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getCTime(String fileId, java.util.Map<String, String> __ctx);

    /**
     * Get ctime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getCTime(String fileId, Ice.Callback __cb);

    /**
     * Get ctime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getCTime(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Get ctime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getCTime(String fileId, Callback_FileServer_getCTime __cb);

    /**
     * Get ctime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getCTime(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_getCTime __cb);

    /**
     * Get ctime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __result The asynchronous result object.
     * @return ctime of file (float).
     * @throws omero::OmeroFSError
     **/
    public float end_getCTime(Ice.AsyncResult __result)
        throws omero.OmeroFSError;

    /**
     * Get mtime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return mtime of file (float).
     * @throws omero::OmeroFSError
     **/
    public float getMTime(String fileId)
        throws omero.OmeroFSError;

    /**
     * Get mtime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return mtime of file (float).
     * @throws omero::OmeroFSError
     **/
    public float getMTime(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * Get mtime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMTime(String fileId);

    /**
     * Get mtime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMTime(String fileId, java.util.Map<String, String> __ctx);

    /**
     * Get mtime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMTime(String fileId, Ice.Callback __cb);

    /**
     * Get mtime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMTime(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Get mtime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMTime(String fileId, Callback_FileServer_getMTime __cb);

    /**
     * Get mtime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMTime(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_getMTime __cb);

    /**
     * Get mtime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __result The asynchronous result object.
     * @return mtime of file (float).
     * @throws omero::OmeroFSError
     **/
    public float end_getMTime(Ice.AsyncResult __result)
        throws omero.OmeroFSError;

    /**
     * Get atime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return atime of file (float).
     * @throws omero::OmeroFSError
     **/
    public float getATime(String fileId)
        throws omero.OmeroFSError;

    /**
     * Get atime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return atime of file (float).
     * @throws omero::OmeroFSError
     **/
    public float getATime(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * Get atime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getATime(String fileId);

    /**
     * Get atime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getATime(String fileId, java.util.Map<String, String> __ctx);

    /**
     * Get atime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getATime(String fileId, Ice.Callback __cb);

    /**
     * Get atime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getATime(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Get atime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getATime(String fileId, Callback_FileServer_getATime __cb);

    /**
     * Get atime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getATime(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_getATime __cb);

    /**
     * Get atime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __result The asynchronous result object.
     * @return atime of file (float).
     * @throws omero::OmeroFSError
     **/
    public float end_getATime(Ice.AsyncResult __result)
        throws omero.OmeroFSError;

    /**
     * Query whether file is a directory
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return true is directory (bool).
     * @throws omero::OmeroFSError
     **/
    public boolean isDir(String fileId)
        throws omero.OmeroFSError;

    /**
     * Query whether file is a directory
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return true is directory (bool).
     * @throws omero::OmeroFSError
     **/
    public boolean isDir(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * Query whether file is a directory
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isDir(String fileId);

    /**
     * Query whether file is a directory
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isDir(String fileId, java.util.Map<String, String> __ctx);

    /**
     * Query whether file is a directory
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isDir(String fileId, Ice.Callback __cb);

    /**
     * Query whether file is a directory
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isDir(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Query whether file is a directory
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isDir(String fileId, Callback_FileServer_isDir __cb);

    /**
     * Query whether file is a directory
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isDir(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_isDir __cb);

    /**
     * Query whether file is a directory
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __result The asynchronous result object.
     * @return true is directory (bool).
     * @throws omero::OmeroFSError
     **/
    public boolean end_isDir(Ice.AsyncResult __result)
        throws omero.OmeroFSError;

    /**
     * Query whether file is a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return true if file (bool).
     * @throws omero::OmeroFSError
     **/
    public boolean isFile(String fileId)
        throws omero.OmeroFSError;

    /**
     * Query whether file is a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return true if file (bool).
     * @throws omero::OmeroFSError
     **/
    public boolean isFile(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * Query whether file is a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isFile(String fileId);

    /**
     * Query whether file is a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isFile(String fileId, java.util.Map<String, String> __ctx);

    /**
     * Query whether file is a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isFile(String fileId, Ice.Callback __cb);

    /**
     * Query whether file is a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isFile(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Query whether file is a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isFile(String fileId, Callback_FileServer_isFile __cb);

    /**
     * Query whether file is a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isFile(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_isFile __cb);

    /**
     * Query whether file is a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __result The asynchronous result object.
     * @return true if file (bool).
     * @throws omero::OmeroFSError
     **/
    public boolean end_isFile(Ice.AsyncResult __result)
        throws omero.OmeroFSError;

    /**
     * Get SHA1 of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the SHA1 cannot be generated for any reason.
     * 
     * @param fileId, see above.
     * @return SHA1 hex hash digest of file (string).
     * @throws omero::OmeroFSError
     **/
    public String getSHA1(String fileId)
        throws omero.OmeroFSError;

    /**
     * Get SHA1 of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the SHA1 cannot be generated for any reason.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return SHA1 hex hash digest of file (string).
     * @throws omero::OmeroFSError
     **/
    public String getSHA1(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * Get SHA1 of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the SHA1 cannot be generated for any reason.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSHA1(String fileId);

    /**
     * Get SHA1 of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the SHA1 cannot be generated for any reason.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSHA1(String fileId, java.util.Map<String, String> __ctx);

    /**
     * Get SHA1 of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the SHA1 cannot be generated for any reason.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSHA1(String fileId, Ice.Callback __cb);

    /**
     * Get SHA1 of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the SHA1 cannot be generated for any reason.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSHA1(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Get SHA1 of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the SHA1 cannot be generated for any reason.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSHA1(String fileId, Callback_FileServer_getSHA1 __cb);

    /**
     * Get SHA1 of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the SHA1 cannot be generated for any reason.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSHA1(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_getSHA1 __cb);

    /**
     * Get SHA1 of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the SHA1 cannot be generated for any reason.
     * 
     * @param __result The asynchronous result object.
     * @return SHA1 hex hash digest of file (string).
     * @throws omero::OmeroFSError
     **/
    public String end_getSHA1(Ice.AsyncResult __result)
        throws omero.OmeroFSError;

    /**
     * readBlock should open, read size bytes from offset
     * and then close the file.
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the file read fails for any other reason.
     * 
     * @param fileId, see above.
     * @param offset, byte offset into file from where read should begin (long).
     * @param size, number of bytes that should be read (int).
     * @return byte sequence of upto size bytes.
     * @throws omero::OmeroFSError
     **/
    public byte[] readBlock(String fileId, long offset, int size)
        throws omero.OmeroFSError;

    /**
     * readBlock should open, read size bytes from offset
     * and then close the file.
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the file read fails for any other reason.
     * 
     * @param fileId, see above.
     * @param offset, byte offset into file from where read should begin (long).
     * @param size, number of bytes that should be read (int).
     * @param __ctx The Context map to send with the invocation.
     * @return byte sequence of upto size bytes.
     * @throws omero::OmeroFSError
     **/
    public byte[] readBlock(String fileId, long offset, int size, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * readBlock should open, read size bytes from offset
     * and then close the file.
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the file read fails for any other reason.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_readBlock(String fileId, long offset, int size);

    /**
     * readBlock should open, read size bytes from offset
     * and then close the file.
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the file read fails for any other reason.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_readBlock(String fileId, long offset, int size, java.util.Map<String, String> __ctx);

    /**
     * readBlock should open, read size bytes from offset
     * and then close the file.
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the file read fails for any other reason.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_readBlock(String fileId, long offset, int size, Ice.Callback __cb);

    /**
     * readBlock should open, read size bytes from offset
     * and then close the file.
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the file read fails for any other reason.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_readBlock(String fileId, long offset, int size, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * readBlock should open, read size bytes from offset
     * and then close the file.
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the file read fails for any other reason.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_readBlock(String fileId, long offset, int size, Callback_FileServer_readBlock __cb);

    /**
     * readBlock should open, read size bytes from offset
     * and then close the file.
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the file read fails for any other reason.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_readBlock(String fileId, long offset, int size, java.util.Map<String, String> __ctx, Callback_FileServer_readBlock __cb);

    /**
     * readBlock should open, read size bytes from offset
     * and then close the file.
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the file read fails for any other reason.
     * 
     * @param __result The asynchronous result object.
     * @return byte sequence of upto size bytes.
     * @throws omero::OmeroFSError
     **/
    public byte[] end_readBlock(Ice.AsyncResult __result)
        throws omero.OmeroFSError;
}
