// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `FS.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid.monitors;

public final class FileServerPrxHelper extends Ice.ObjectPrxHelperBase implements FileServerPrx
{
    private static final String __fileExists_name = "fileExists";

    /**
     * Query the existence of a file
     * 
     * An exception will be raised if the method fails to determine the existence.
     * 
     * @param fileId, see above.
     * @return existence of file.
     * @throws omero::OmeroFSError
     **/
    public boolean fileExists(String fileId)
        throws omero.OmeroFSError
    {
        return fileExists(fileId, null, false);
    }

    /**
     * Query the existence of a file
     * 
     * An exception will be raised if the method fails to determine the existence.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return existence of file.
     * @throws omero::OmeroFSError
     **/
    public boolean fileExists(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        return fileExists(fileId, __ctx, true);
    }

    private boolean fileExists(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "fileExists", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("fileExists");
                    __delBase = __getDelegate(false);
                    _FileServerDel __del = (_FileServerDel)__delBase;
                    return __del.fileExists(fileId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Query the existence of a file
     * 
     * An exception will be raised if the method fails to determine the existence.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_fileExists(String fileId)
    {
        return begin_fileExists(fileId, null, false, null);
    }

    /**
     * Query the existence of a file
     * 
     * An exception will be raised if the method fails to determine the existence.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_fileExists(String fileId, java.util.Map<String, String> __ctx)
    {
        return begin_fileExists(fileId, __ctx, true, null);
    }

    /**
     * Query the existence of a file
     * 
     * An exception will be raised if the method fails to determine the existence.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_fileExists(String fileId, Ice.Callback __cb)
    {
        return begin_fileExists(fileId, null, false, __cb);
    }

    /**
     * Query the existence of a file
     * 
     * An exception will be raised if the method fails to determine the existence.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_fileExists(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_fileExists(fileId, __ctx, true, __cb);
    }

    /**
     * Query the existence of a file
     * 
     * An exception will be raised if the method fails to determine the existence.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_fileExists(String fileId, Callback_FileServer_fileExists __cb)
    {
        return begin_fileExists(fileId, null, false, __cb);
    }

    /**
     * Query the existence of a file
     * 
     * An exception will be raised if the method fails to determine the existence.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_fileExists(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_fileExists __cb)
    {
        return begin_fileExists(fileId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_fileExists(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__fileExists_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __fileExists_name, __cb);
        try
        {
            __result.__prepare(__fileExists_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(fileId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) existence of file.
     **/
    public boolean end_fileExists(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __fileExists_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __getATime_name = "getATime";

    /**
     * Get atime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return atime of file (float).
     * @throws omero::OmeroFSError
     **/
    public float getATime(String fileId)
        throws omero.OmeroFSError
    {
        return getATime(fileId, null, false);
    }

    /**
     * Get atime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return atime of file (float).
     * @throws omero::OmeroFSError
     **/
    public float getATime(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        return getATime(fileId, __ctx, true);
    }

    private float getATime(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getATime", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getATime");
                    __delBase = __getDelegate(false);
                    _FileServerDel __del = (_FileServerDel)__delBase;
                    return __del.getATime(fileId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Get atime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getATime(String fileId)
    {
        return begin_getATime(fileId, null, false, null);
    }

    /**
     * Get atime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getATime(String fileId, java.util.Map<String, String> __ctx)
    {
        return begin_getATime(fileId, __ctx, true, null);
    }

    /**
     * Get atime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getATime(String fileId, Ice.Callback __cb)
    {
        return begin_getATime(fileId, null, false, __cb);
    }

    /**
     * Get atime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getATime(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getATime(fileId, __ctx, true, __cb);
    }

    /**
     * Get atime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getATime(String fileId, Callback_FileServer_getATime __cb)
    {
        return begin_getATime(fileId, null, false, __cb);
    }

    /**
     * Get atime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getATime(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_getATime __cb)
    {
        return begin_getATime(fileId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getATime(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getATime_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getATime_name, __cb);
        try
        {
            __result.__prepare(__getATime_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(fileId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) atime of file (float).
     **/
    public float end_getATime(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __getATime_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            float __ret;
            __ret = __is.readFloat();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __getBaseName_name = "getBaseName";

    /**
     * Get base name of a file, this is the name
     * stripped of any path, e.g. file.ext
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return base name.
     * @throws omero::OmeroFSError
     **/
    public String getBaseName(String fileId)
        throws omero.OmeroFSError
    {
        return getBaseName(fileId, null, false);
    }

    /**
     * Get base name of a file, this is the name
     * stripped of any path, e.g. file.ext
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return base name.
     * @throws omero::OmeroFSError
     **/
    public String getBaseName(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        return getBaseName(fileId, __ctx, true);
    }

    private String getBaseName(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getBaseName", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getBaseName");
                    __delBase = __getDelegate(false);
                    _FileServerDel __del = (_FileServerDel)__delBase;
                    return __del.getBaseName(fileId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Get base name of a file, this is the name
     * stripped of any path, e.g. file.ext
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getBaseName(String fileId)
    {
        return begin_getBaseName(fileId, null, false, null);
    }

    /**
     * Get base name of a file, this is the name
     * stripped of any path, e.g. file.ext
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getBaseName(String fileId, java.util.Map<String, String> __ctx)
    {
        return begin_getBaseName(fileId, __ctx, true, null);
    }

    /**
     * Get base name of a file, this is the name
     * stripped of any path, e.g. file.ext
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getBaseName(String fileId, Ice.Callback __cb)
    {
        return begin_getBaseName(fileId, null, false, __cb);
    }

    /**
     * Get base name of a file, this is the name
     * stripped of any path, e.g. file.ext
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getBaseName(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getBaseName(fileId, __ctx, true, __cb);
    }

    /**
     * Get base name of a file, this is the name
     * stripped of any path, e.g. file.ext
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getBaseName(String fileId, Callback_FileServer_getBaseName __cb)
    {
        return begin_getBaseName(fileId, null, false, __cb);
    }

    /**
     * Get base name of a file, this is the name
     * stripped of any path, e.g. file.ext
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getBaseName(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_getBaseName __cb)
    {
        return begin_getBaseName(fileId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getBaseName(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getBaseName_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getBaseName_name, __cb);
        try
        {
            __result.__prepare(__getBaseName_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(fileId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) base name.
     **/
    public String end_getBaseName(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __getBaseName_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            String __ret;
            __ret = __is.readString();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __getBulkDirectory_name = "getBulkDirectory";

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain the file stats for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param absPath, an absolute path on the monitor's watch path (string).
     * @param filter, a filter to apply to the listing, cf. ls (string).
     * @return, a directory listing (FileStatsList).
     * @throws omero::OmeroFSError
     **/
    public FileStats[] getBulkDirectory(String absPath, String filter)
        throws omero.OmeroFSError
    {
        return getBulkDirectory(absPath, filter, null, false);
    }

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain the file stats for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param absPath, an absolute path on the monitor's watch path (string).
     * @param filter, a filter to apply to the listing, cf. ls (string).
     * @param __ctx The Context map to send with the invocation.
     * @return, a directory listing (FileStatsList).
     * @throws omero::OmeroFSError
     **/
    public FileStats[] getBulkDirectory(String absPath, String filter, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        return getBulkDirectory(absPath, filter, __ctx, true);
    }

    private FileStats[] getBulkDirectory(String absPath, String filter, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getBulkDirectory", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getBulkDirectory");
                    __delBase = __getDelegate(false);
                    _FileServerDel __del = (_FileServerDel)__delBase;
                    return __del.getBulkDirectory(absPath, filter, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain the file stats for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getBulkDirectory(String absPath, String filter)
    {
        return begin_getBulkDirectory(absPath, filter, null, false, null);
    }

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain the file stats for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getBulkDirectory(String absPath, String filter, java.util.Map<String, String> __ctx)
    {
        return begin_getBulkDirectory(absPath, filter, __ctx, true, null);
    }

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain the file stats for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getBulkDirectory(String absPath, String filter, Ice.Callback __cb)
    {
        return begin_getBulkDirectory(absPath, filter, null, false, __cb);
    }

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain the file stats for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getBulkDirectory(String absPath, String filter, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getBulkDirectory(absPath, filter, __ctx, true, __cb);
    }

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain the file stats for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getBulkDirectory(String absPath, String filter, Callback_FileServer_getBulkDirectory __cb)
    {
        return begin_getBulkDirectory(absPath, filter, null, false, __cb);
    }

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain the file stats for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getBulkDirectory(String absPath, String filter, java.util.Map<String, String> __ctx, Callback_FileServer_getBulkDirectory __cb)
    {
        return begin_getBulkDirectory(absPath, filter, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getBulkDirectory(String absPath, String filter, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getBulkDirectory_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getBulkDirectory_name, __cb);
        try
        {
            __result.__prepare(__getBulkDirectory_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(absPath);
            __os.writeString(filter);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value), a directory listing (FileStatsList).
     **/
    public FileStats[] end_getBulkDirectory(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __getBulkDirectory_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            FileStats[] __ret;
            __ret = FileStatsListHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __getCTime_name = "getCTime";

    /**
     * Get ctime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return ctime of file (float).
     * @throws omero::OmeroFSError
     **/
    public float getCTime(String fileId)
        throws omero.OmeroFSError
    {
        return getCTime(fileId, null, false);
    }

    /**
     * Get ctime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return ctime of file (float).
     * @throws omero::OmeroFSError
     **/
    public float getCTime(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        return getCTime(fileId, __ctx, true);
    }

    private float getCTime(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getCTime", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getCTime");
                    __delBase = __getDelegate(false);
                    _FileServerDel __del = (_FileServerDel)__delBase;
                    return __del.getCTime(fileId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Get ctime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCTime(String fileId)
    {
        return begin_getCTime(fileId, null, false, null);
    }

    /**
     * Get ctime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCTime(String fileId, java.util.Map<String, String> __ctx)
    {
        return begin_getCTime(fileId, __ctx, true, null);
    }

    /**
     * Get ctime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCTime(String fileId, Ice.Callback __cb)
    {
        return begin_getCTime(fileId, null, false, __cb);
    }

    /**
     * Get ctime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCTime(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getCTime(fileId, __ctx, true, __cb);
    }

    /**
     * Get ctime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCTime(String fileId, Callback_FileServer_getCTime __cb)
    {
        return begin_getCTime(fileId, null, false, __cb);
    }

    /**
     * Get ctime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCTime(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_getCTime __cb)
    {
        return begin_getCTime(fileId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getCTime(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getCTime_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getCTime_name, __cb);
        try
        {
            __result.__prepare(__getCTime_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(fileId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) ctime of file (float).
     **/
    public float end_getCTime(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __getCTime_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            float __ret;
            __ret = __is.readFloat();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __getDirectory_name = "getDirectory";

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain just the file names for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param absPath, an absolute path on the monitor's watch path (string).
     * @param filter, a filter to apply to the listing, cf. ls (string).
     * @return, a directory listing (Ice::StringSeq).
     * @throws omero::OmeroFSError
     **/
    public String[] getDirectory(String absPath, String filter)
        throws omero.OmeroFSError
    {
        return getDirectory(absPath, filter, null, false);
    }

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain just the file names for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param absPath, an absolute path on the monitor's watch path (string).
     * @param filter, a filter to apply to the listing, cf. ls (string).
     * @param __ctx The Context map to send with the invocation.
     * @return, a directory listing (Ice::StringSeq).
     * @throws omero::OmeroFSError
     **/
    public String[] getDirectory(String absPath, String filter, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        return getDirectory(absPath, filter, __ctx, true);
    }

    private String[] getDirectory(String absPath, String filter, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getDirectory", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getDirectory");
                    __delBase = __getDelegate(false);
                    _FileServerDel __del = (_FileServerDel)__delBase;
                    return __del.getDirectory(absPath, filter, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain just the file names for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getDirectory(String absPath, String filter)
    {
        return begin_getDirectory(absPath, filter, null, false, null);
    }

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain just the file names for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getDirectory(String absPath, String filter, java.util.Map<String, String> __ctx)
    {
        return begin_getDirectory(absPath, filter, __ctx, true, null);
    }

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain just the file names for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getDirectory(String absPath, String filter, Ice.Callback __cb)
    {
        return begin_getDirectory(absPath, filter, null, false, __cb);
    }

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain just the file names for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getDirectory(String absPath, String filter, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getDirectory(absPath, filter, __ctx, true, __cb);
    }

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain just the file names for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getDirectory(String absPath, String filter, Callback_FileServer_getDirectory __cb)
    {
        return begin_getDirectory(absPath, filter, null, false, __cb);
    }

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain just the file names for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getDirectory(String absPath, String filter, java.util.Map<String, String> __ctx, Callback_FileServer_getDirectory __cb)
    {
        return begin_getDirectory(absPath, filter, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getDirectory(String absPath, String filter, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getDirectory_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getDirectory_name, __cb);
        try
        {
            __result.__prepare(__getDirectory_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(absPath);
            __os.writeString(filter);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value), a directory listing (Ice::StringSeq).
     **/
    public String[] end_getDirectory(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __getDirectory_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            String[] __ret;
            __ret = Ice.StringSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __getMTime_name = "getMTime";

    /**
     * Get mtime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return mtime of file (float).
     * @throws omero::OmeroFSError
     **/
    public float getMTime(String fileId)
        throws omero.OmeroFSError
    {
        return getMTime(fileId, null, false);
    }

    /**
     * Get mtime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return mtime of file (float).
     * @throws omero::OmeroFSError
     **/
    public float getMTime(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        return getMTime(fileId, __ctx, true);
    }

    private float getMTime(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getMTime", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getMTime");
                    __delBase = __getDelegate(false);
                    _FileServerDel __del = (_FileServerDel)__delBase;
                    return __del.getMTime(fileId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Get mtime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMTime(String fileId)
    {
        return begin_getMTime(fileId, null, false, null);
    }

    /**
     * Get mtime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMTime(String fileId, java.util.Map<String, String> __ctx)
    {
        return begin_getMTime(fileId, __ctx, true, null);
    }

    /**
     * Get mtime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMTime(String fileId, Ice.Callback __cb)
    {
        return begin_getMTime(fileId, null, false, __cb);
    }

    /**
     * Get mtime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMTime(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getMTime(fileId, __ctx, true, __cb);
    }

    /**
     * Get mtime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMTime(String fileId, Callback_FileServer_getMTime __cb)
    {
        return begin_getMTime(fileId, null, false, __cb);
    }

    /**
     * Get mtime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMTime(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_getMTime __cb)
    {
        return begin_getMTime(fileId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getMTime(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getMTime_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getMTime_name, __cb);
        try
        {
            __result.__prepare(__getMTime_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(fileId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) mtime of file (float).
     **/
    public float end_getMTime(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __getMTime_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            float __ret;
            __ret = __is.readFloat();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __getOwner_name = "getOwner";

    /**
     * Get owner of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return owner of file (string).
     * @throws omero::OmeroFSError
     **/
    public String getOwner(String fileId)
        throws omero.OmeroFSError
    {
        return getOwner(fileId, null, false);
    }

    /**
     * Get owner of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return owner of file (string).
     * @throws omero::OmeroFSError
     **/
    public String getOwner(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        return getOwner(fileId, __ctx, true);
    }

    private String getOwner(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getOwner", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getOwner");
                    __delBase = __getDelegate(false);
                    _FileServerDel __del = (_FileServerDel)__delBase;
                    return __del.getOwner(fileId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Get owner of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getOwner(String fileId)
    {
        return begin_getOwner(fileId, null, false, null);
    }

    /**
     * Get owner of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getOwner(String fileId, java.util.Map<String, String> __ctx)
    {
        return begin_getOwner(fileId, __ctx, true, null);
    }

    /**
     * Get owner of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getOwner(String fileId, Ice.Callback __cb)
    {
        return begin_getOwner(fileId, null, false, __cb);
    }

    /**
     * Get owner of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getOwner(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getOwner(fileId, __ctx, true, __cb);
    }

    /**
     * Get owner of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getOwner(String fileId, Callback_FileServer_getOwner __cb)
    {
        return begin_getOwner(fileId, null, false, __cb);
    }

    /**
     * Get owner of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getOwner(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_getOwner __cb)
    {
        return begin_getOwner(fileId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getOwner(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getOwner_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getOwner_name, __cb);
        try
        {
            __result.__prepare(__getOwner_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(fileId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) owner of file (string).
     **/
    public String end_getOwner(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __getOwner_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            String __ret;
            __ret = __is.readString();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __getSHA1_name = "getSHA1";

    /**
     * Get SHA1 of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the SHA1 cannot be generated for any reason.
     * 
     * @param fileId, see above.
     * @return SHA1 hex hash digest of file (string).
     * @throws omero::OmeroFSError
     **/
    public String getSHA1(String fileId)
        throws omero.OmeroFSError
    {
        return getSHA1(fileId, null, false);
    }

    /**
     * Get SHA1 of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the SHA1 cannot be generated for any reason.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return SHA1 hex hash digest of file (string).
     * @throws omero::OmeroFSError
     **/
    public String getSHA1(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        return getSHA1(fileId, __ctx, true);
    }

    private String getSHA1(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getSHA1", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getSHA1");
                    __delBase = __getDelegate(false);
                    _FileServerDel __del = (_FileServerDel)__delBase;
                    return __del.getSHA1(fileId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Get SHA1 of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the SHA1 cannot be generated for any reason.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getSHA1(String fileId)
    {
        return begin_getSHA1(fileId, null, false, null);
    }

    /**
     * Get SHA1 of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the SHA1 cannot be generated for any reason.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getSHA1(String fileId, java.util.Map<String, String> __ctx)
    {
        return begin_getSHA1(fileId, __ctx, true, null);
    }

    /**
     * Get SHA1 of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the SHA1 cannot be generated for any reason.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getSHA1(String fileId, Ice.Callback __cb)
    {
        return begin_getSHA1(fileId, null, false, __cb);
    }

    /**
     * Get SHA1 of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the SHA1 cannot be generated for any reason.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getSHA1(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getSHA1(fileId, __ctx, true, __cb);
    }

    /**
     * Get SHA1 of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the SHA1 cannot be generated for any reason.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getSHA1(String fileId, Callback_FileServer_getSHA1 __cb)
    {
        return begin_getSHA1(fileId, null, false, __cb);
    }

    /**
     * Get SHA1 of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the SHA1 cannot be generated for any reason.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getSHA1(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_getSHA1 __cb)
    {
        return begin_getSHA1(fileId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getSHA1(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getSHA1_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getSHA1_name, __cb);
        try
        {
            __result.__prepare(__getSHA1_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(fileId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) SHA1 hex hash digest of file (string).
     **/
    public String end_getSHA1(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __getSHA1_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            String __ret;
            __ret = __is.readString();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __getSize_name = "getSize";

    /**
     * Get size of a file in bytes
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return byte size of file (long).
     * @throws omero::OmeroFSError
     **/
    public long getSize(String fileId)
        throws omero.OmeroFSError
    {
        return getSize(fileId, null, false);
    }

    /**
     * Get size of a file in bytes
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return byte size of file (long).
     * @throws omero::OmeroFSError
     **/
    public long getSize(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        return getSize(fileId, __ctx, true);
    }

    private long getSize(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getSize", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getSize");
                    __delBase = __getDelegate(false);
                    _FileServerDel __del = (_FileServerDel)__delBase;
                    return __del.getSize(fileId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Get size of a file in bytes
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getSize(String fileId)
    {
        return begin_getSize(fileId, null, false, null);
    }

    /**
     * Get size of a file in bytes
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getSize(String fileId, java.util.Map<String, String> __ctx)
    {
        return begin_getSize(fileId, __ctx, true, null);
    }

    /**
     * Get size of a file in bytes
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getSize(String fileId, Ice.Callback __cb)
    {
        return begin_getSize(fileId, null, false, __cb);
    }

    /**
     * Get size of a file in bytes
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getSize(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getSize(fileId, __ctx, true, __cb);
    }

    /**
     * Get size of a file in bytes
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getSize(String fileId, Callback_FileServer_getSize __cb)
    {
        return begin_getSize(fileId, null, false, __cb);
    }

    /**
     * Get size of a file in bytes
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getSize(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_getSize __cb)
    {
        return begin_getSize(fileId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getSize(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getSize_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getSize_name, __cb);
        try
        {
            __result.__prepare(__getSize_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(fileId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) byte size of file (long).
     **/
    public long end_getSize(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __getSize_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __getStats_name = "getStats";

    /**
     * Get all FileStats of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return file stats (FileStats).
     * @throws omero::OmeroFSError
     **/
    public FileStats getStats(String fileId)
        throws omero.OmeroFSError
    {
        return getStats(fileId, null, false);
    }

    /**
     * Get all FileStats of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return file stats (FileStats).
     * @throws omero::OmeroFSError
     **/
    public FileStats getStats(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        return getStats(fileId, __ctx, true);
    }

    private FileStats getStats(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getStats", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getStats");
                    __delBase = __getDelegate(false);
                    _FileServerDel __del = (_FileServerDel)__delBase;
                    return __del.getStats(fileId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Get all FileStats of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getStats(String fileId)
    {
        return begin_getStats(fileId, null, false, null);
    }

    /**
     * Get all FileStats of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getStats(String fileId, java.util.Map<String, String> __ctx)
    {
        return begin_getStats(fileId, __ctx, true, null);
    }

    /**
     * Get all FileStats of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getStats(String fileId, Ice.Callback __cb)
    {
        return begin_getStats(fileId, null, false, __cb);
    }

    /**
     * Get all FileStats of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getStats(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getStats(fileId, __ctx, true, __cb);
    }

    /**
     * Get all FileStats of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getStats(String fileId, Callback_FileServer_getStats __cb)
    {
        return begin_getStats(fileId, null, false, __cb);
    }

    /**
     * Get all FileStats of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getStats(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_getStats __cb)
    {
        return begin_getStats(fileId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getStats(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getStats_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getStats_name, __cb);
        try
        {
            __result.__prepare(__getStats_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(fileId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) file stats (FileStats).
     **/
    public FileStats end_getStats(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __getStats_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            FileStats __ret;
            __ret = new FileStats();
            __ret.__read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __isDir_name = "isDir";

    /**
     * Query whether file is a directory
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return true is directory (bool).
     * @throws omero::OmeroFSError
     **/
    public boolean isDir(String fileId)
        throws omero.OmeroFSError
    {
        return isDir(fileId, null, false);
    }

    /**
     * Query whether file is a directory
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return true is directory (bool).
     * @throws omero::OmeroFSError
     **/
    public boolean isDir(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        return isDir(fileId, __ctx, true);
    }

    private boolean isDir(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isDir", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isDir");
                    __delBase = __getDelegate(false);
                    _FileServerDel __del = (_FileServerDel)__delBase;
                    return __del.isDir(fileId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Query whether file is a directory
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isDir(String fileId)
    {
        return begin_isDir(fileId, null, false, null);
    }

    /**
     * Query whether file is a directory
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isDir(String fileId, java.util.Map<String, String> __ctx)
    {
        return begin_isDir(fileId, __ctx, true, null);
    }

    /**
     * Query whether file is a directory
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isDir(String fileId, Ice.Callback __cb)
    {
        return begin_isDir(fileId, null, false, __cb);
    }

    /**
     * Query whether file is a directory
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isDir(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isDir(fileId, __ctx, true, __cb);
    }

    /**
     * Query whether file is a directory
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isDir(String fileId, Callback_FileServer_isDir __cb)
    {
        return begin_isDir(fileId, null, false, __cb);
    }

    /**
     * Query whether file is a directory
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isDir(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_isDir __cb)
    {
        return begin_isDir(fileId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isDir(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isDir_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isDir_name, __cb);
        try
        {
            __result.__prepare(__isDir_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(fileId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) true is directory (bool).
     **/
    public boolean end_isDir(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __isDir_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __isFile_name = "isFile";

    /**
     * Query whether file is a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return true if file (bool).
     * @throws omero::OmeroFSError
     **/
    public boolean isFile(String fileId)
        throws omero.OmeroFSError
    {
        return isFile(fileId, null, false);
    }

    /**
     * Query whether file is a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @param __ctx The Context map to send with the invocation.
     * @return true if file (bool).
     * @throws omero::OmeroFSError
     **/
    public boolean isFile(String fileId, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        return isFile(fileId, __ctx, true);
    }

    private boolean isFile(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isFile", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isFile");
                    __delBase = __getDelegate(false);
                    _FileServerDel __del = (_FileServerDel)__delBase;
                    return __del.isFile(fileId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Query whether file is a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isFile(String fileId)
    {
        return begin_isFile(fileId, null, false, null);
    }

    /**
     * Query whether file is a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isFile(String fileId, java.util.Map<String, String> __ctx)
    {
        return begin_isFile(fileId, __ctx, true, null);
    }

    /**
     * Query whether file is a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isFile(String fileId, Ice.Callback __cb)
    {
        return begin_isFile(fileId, null, false, __cb);
    }

    /**
     * Query whether file is a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isFile(String fileId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isFile(fileId, __ctx, true, __cb);
    }

    /**
     * Query whether file is a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isFile(String fileId, Callback_FileServer_isFile __cb)
    {
        return begin_isFile(fileId, null, false, __cb);
    }

    /**
     * Query whether file is a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isFile(String fileId, java.util.Map<String, String> __ctx, Callback_FileServer_isFile __cb)
    {
        return begin_isFile(fileId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isFile(String fileId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isFile_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isFile_name, __cb);
        try
        {
            __result.__prepare(__isFile_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(fileId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) true if file (bool).
     **/
    public boolean end_isFile(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __isFile_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __readBlock_name = "readBlock";

    /**
     * readBlock should open, read size bytes from offset
     * and then close the file.
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the file read fails for any other reason.
     * 
     * @param fileId, see above.
     * @param offset, byte offset into file from where read should begin (long).
     * @param size, number of bytes that should be read (int).
     * @return byte sequence of upto size bytes.
     * @throws omero::OmeroFSError
     **/
    public byte[] readBlock(String fileId, long offset, int size)
        throws omero.OmeroFSError
    {
        return readBlock(fileId, offset, size, null, false);
    }

    /**
     * readBlock should open, read size bytes from offset
     * and then close the file.
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the file read fails for any other reason.
     * 
     * @param fileId, see above.
     * @param offset, byte offset into file from where read should begin (long).
     * @param size, number of bytes that should be read (int).
     * @param __ctx The Context map to send with the invocation.
     * @return byte sequence of upto size bytes.
     * @throws omero::OmeroFSError
     **/
    public byte[] readBlock(String fileId, long offset, int size, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        return readBlock(fileId, offset, size, __ctx, true);
    }

    private byte[] readBlock(String fileId, long offset, int size, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "readBlock", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("readBlock");
                    __delBase = __getDelegate(false);
                    _FileServerDel __del = (_FileServerDel)__delBase;
                    return __del.readBlock(fileId, offset, size, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * readBlock should open, read size bytes from offset
     * and then close the file.
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the file read fails for any other reason.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_readBlock(String fileId, long offset, int size)
    {
        return begin_readBlock(fileId, offset, size, null, false, null);
    }

    /**
     * readBlock should open, read size bytes from offset
     * and then close the file.
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the file read fails for any other reason.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_readBlock(String fileId, long offset, int size, java.util.Map<String, String> __ctx)
    {
        return begin_readBlock(fileId, offset, size, __ctx, true, null);
    }

    /**
     * readBlock should open, read size bytes from offset
     * and then close the file.
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the file read fails for any other reason.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_readBlock(String fileId, long offset, int size, Ice.Callback __cb)
    {
        return begin_readBlock(fileId, offset, size, null, false, __cb);
    }

    /**
     * readBlock should open, read size bytes from offset
     * and then close the file.
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the file read fails for any other reason.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_readBlock(String fileId, long offset, int size, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_readBlock(fileId, offset, size, __ctx, true, __cb);
    }

    /**
     * readBlock should open, read size bytes from offset
     * and then close the file.
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the file read fails for any other reason.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_readBlock(String fileId, long offset, int size, Callback_FileServer_readBlock __cb)
    {
        return begin_readBlock(fileId, offset, size, null, false, __cb);
    }

    /**
     * readBlock should open, read size bytes from offset
     * and then close the file.
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the file read fails for any other reason.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_readBlock(String fileId, long offset, int size, java.util.Map<String, String> __ctx, Callback_FileServer_readBlock __cb)
    {
        return begin_readBlock(fileId, offset, size, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_readBlock(String fileId, long offset, int size, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__readBlock_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __readBlock_name, __cb);
        try
        {
            __result.__prepare(__readBlock_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(fileId);
            __os.writeLong(offset);
            __os.writeInt(size);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) byte sequence of upto size bytes.
     **/
    public byte[] end_readBlock(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __readBlock_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public static FileServerPrx checkedCast(Ice.ObjectPrx __obj)
    {
        FileServerPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof FileServerPrx)
            {
                __d = (FileServerPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    FileServerPrxHelper __h = new FileServerPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static FileServerPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        FileServerPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof FileServerPrx)
            {
                __d = (FileServerPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    FileServerPrxHelper __h = new FileServerPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static FileServerPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        FileServerPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    FileServerPrxHelper __h = new FileServerPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static FileServerPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        FileServerPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    FileServerPrxHelper __h = new FileServerPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static FileServerPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        FileServerPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof FileServerPrx)
            {
                __d = (FileServerPrx)__obj;
            }
            else
            {
                FileServerPrxHelper __h = new FileServerPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static FileServerPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        FileServerPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            FileServerPrxHelper __h = new FileServerPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::monitors::FileServer"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _FileServerDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _FileServerDelD();
    }

    public static void __write(IceInternal.BasicStream __os, FileServerPrx v)
    {
        __os.writeProxy(v);
    }

    public static FileServerPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            FileServerPrxHelper result = new FileServerPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
