// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `FS.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid.monitors;

/**
 * This interface must be implemented by a client that
 * wishes to subscribe to an OMERO.fs server.
 **/
public final class MonitorClientPrxHelper extends Ice.ObjectPrxHelperBase implements MonitorClientPrx
{
    private static final String __fsEventHappened_name = "fsEventHappened";

    /**
     * Callback, called by the monitor upon the proxy of the OMERO.fs client.
     * 
     * @param id, monitor Id from which the event was reported (string).
     * @param el, list of events (EventList).
     * @return, no explicit return value.
     **/
    public void fsEventHappened(String id, EventInfo[] el)
        throws omero.ServerError
    {
        fsEventHappened(id, el, null, false);
    }

    /**
     * Callback, called by the monitor upon the proxy of the OMERO.fs client.
     * 
     * @param id, monitor Id from which the event was reported (string).
     * @param el, list of events (EventList).
     * @param __ctx The Context map to send with the invocation.
     * @return, no explicit return value.
     **/
    public void fsEventHappened(String id, EventInfo[] el, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        fsEventHappened(id, el, __ctx, true);
    }

    private void fsEventHappened(String id, EventInfo[] el, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "fsEventHappened", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("fsEventHappened");
                    __delBase = __getDelegate(false);
                    _MonitorClientDel __del = (_MonitorClientDel)__delBase;
                    __del.fsEventHappened(id, el, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Callback, called by the monitor upon the proxy of the OMERO.fs client.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_fsEventHappened(String id, EventInfo[] el)
    {
        return begin_fsEventHappened(id, el, null, false, null);
    }

    /**
     * Callback, called by the monitor upon the proxy of the OMERO.fs client.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_fsEventHappened(String id, EventInfo[] el, java.util.Map<String, String> __ctx)
    {
        return begin_fsEventHappened(id, el, __ctx, true, null);
    }

    /**
     * Callback, called by the monitor upon the proxy of the OMERO.fs client.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_fsEventHappened(String id, EventInfo[] el, Ice.Callback __cb)
    {
        return begin_fsEventHappened(id, el, null, false, __cb);
    }

    /**
     * Callback, called by the monitor upon the proxy of the OMERO.fs client.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_fsEventHappened(String id, EventInfo[] el, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_fsEventHappened(id, el, __ctx, true, __cb);
    }

    /**
     * Callback, called by the monitor upon the proxy of the OMERO.fs client.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_fsEventHappened(String id, EventInfo[] el, Callback_MonitorClient_fsEventHappened __cb)
    {
        return begin_fsEventHappened(id, el, null, false, __cb);
    }

    /**
     * Callback, called by the monitor upon the proxy of the OMERO.fs client.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_fsEventHappened(String id, EventInfo[] el, java.util.Map<String, String> __ctx, Callback_MonitorClient_fsEventHappened __cb)
    {
        return begin_fsEventHappened(id, el, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_fsEventHappened(String id, EventInfo[] el, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__fsEventHappened_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __fsEventHappened_name, __cb);
        try
        {
            __result.__prepare(__fsEventHappened_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(id);
            EventListHelper.write(__os, el);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value), no explicit return value.
     **/
    public void end_fsEventHappened(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __fsEventHappened_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public static MonitorClientPrx checkedCast(Ice.ObjectPrx __obj)
    {
        MonitorClientPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof MonitorClientPrx)
            {
                __d = (MonitorClientPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    MonitorClientPrxHelper __h = new MonitorClientPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static MonitorClientPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        MonitorClientPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof MonitorClientPrx)
            {
                __d = (MonitorClientPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    MonitorClientPrxHelper __h = new MonitorClientPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static MonitorClientPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        MonitorClientPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    MonitorClientPrxHelper __h = new MonitorClientPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static MonitorClientPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        MonitorClientPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    MonitorClientPrxHelper __h = new MonitorClientPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static MonitorClientPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        MonitorClientPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof MonitorClientPrx)
            {
                __d = (MonitorClientPrx)__obj;
            }
            else
            {
                MonitorClientPrxHelper __h = new MonitorClientPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static MonitorClientPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        MonitorClientPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            MonitorClientPrxHelper __h = new MonitorClientPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::monitors::MonitorClient"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _MonitorClientDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _MonitorClientDelD();
    }

    public static void __write(IceInternal.BasicStream __os, MonitorClientPrx v)
    {
        __os.writeProxy(v);
    }

    public static MonitorClientPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            MonitorClientPrxHelper result = new MonitorClientPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
