// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `FS.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid.monitors;

public interface MonitorServerPrx extends Ice.ObjectPrx
{
    /**
     * Create a monitor of events.
     * 
     * A exception will be raised if the event type or path mode is not supported by
     * the Monitor implementation for a given OS. An exception will be raised if the
     * path does not exist or is inaccessible to the monitor. An exception will be raised
     * if a monitor cannot be created for any other reason.
     * 
     * @param mType, type of monitor to create (MonitorType).
     * @param eTypes, a sequence of watch event type to monitor (WatchEventTypeList).
     * @param pathString, full path of directory of interest (string).
     * @param whitelist, list of files or extensions of interest (Ice::StringSeq).
     * @param blacklist, list of directories, files or extensions that are not of interest (Ice::StringSeq).
     * @param pMode, path mode of monitor (PathMode).
     * @param proxy, a proxy of the client to which notifications will be sent (MonitorClient*).
     * @param timeout, time in seconds fo monitor to time out (float).
     * @param blockSize, the number of events to pack into each notification (int).
     * @param ignoreSysFiles, ignore system files or not (bool).
     * @param ignoreDirEvents, ignore directory events (bool).
     * @param platformCheck, if true strictly check platform (bool).
     * @return monitorId, a uuid1 (string).
     * @throws omero::OmeroFSError
     **/
    public String createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy)
        throws omero.OmeroFSError;

    /**
     * Create a monitor of events.
     * 
     * A exception will be raised if the event type or path mode is not supported by
     * the Monitor implementation for a given OS. An exception will be raised if the
     * path does not exist or is inaccessible to the monitor. An exception will be raised
     * if a monitor cannot be created for any other reason.
     * 
     * @param mType, type of monitor to create (MonitorType).
     * @param eTypes, a sequence of watch event type to monitor (WatchEventTypeList).
     * @param pathString, full path of directory of interest (string).
     * @param whitelist, list of files or extensions of interest (Ice::StringSeq).
     * @param blacklist, list of directories, files or extensions that are not of interest (Ice::StringSeq).
     * @param pMode, path mode of monitor (PathMode).
     * @param proxy, a proxy of the client to which notifications will be sent (MonitorClient*).
     * @param timeout, time in seconds fo monitor to time out (float).
     * @param blockSize, the number of events to pack into each notification (int).
     * @param ignoreSysFiles, ignore system files or not (bool).
     * @param ignoreDirEvents, ignore directory events (bool).
     * @param platformCheck, if true strictly check platform (bool).
     * @param __ctx The Context map to send with the invocation.
     * @return monitorId, a uuid1 (string).
     * @throws omero::OmeroFSError
     **/
    public String createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * Create a monitor of events.
     * 
     * A exception will be raised if the event type or path mode is not supported by
     * the Monitor implementation for a given OS. An exception will be raised if the
     * path does not exist or is inaccessible to the monitor. An exception will be raised
     * if a monitor cannot be created for any other reason.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy);

    /**
     * Create a monitor of events.
     * 
     * A exception will be raised if the event type or path mode is not supported by
     * the Monitor implementation for a given OS. An exception will be raised if the
     * path does not exist or is inaccessible to the monitor. An exception will be raised
     * if a monitor cannot be created for any other reason.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy, java.util.Map<String, String> __ctx);

    /**
     * Create a monitor of events.
     * 
     * A exception will be raised if the event type or path mode is not supported by
     * the Monitor implementation for a given OS. An exception will be raised if the
     * path does not exist or is inaccessible to the monitor. An exception will be raised
     * if a monitor cannot be created for any other reason.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy, Ice.Callback __cb);

    /**
     * Create a monitor of events.
     * 
     * A exception will be raised if the event type or path mode is not supported by
     * the Monitor implementation for a given OS. An exception will be raised if the
     * path does not exist or is inaccessible to the monitor. An exception will be raised
     * if a monitor cannot be created for any other reason.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Create a monitor of events.
     * 
     * A exception will be raised if the event type or path mode is not supported by
     * the Monitor implementation for a given OS. An exception will be raised if the
     * path does not exist or is inaccessible to the monitor. An exception will be raised
     * if a monitor cannot be created for any other reason.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy, Callback_MonitorServer_createMonitor __cb);

    /**
     * Create a monitor of events.
     * 
     * A exception will be raised if the event type or path mode is not supported by
     * the Monitor implementation for a given OS. An exception will be raised if the
     * path does not exist or is inaccessible to the monitor. An exception will be raised
     * if a monitor cannot be created for any other reason.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy, java.util.Map<String, String> __ctx, Callback_MonitorServer_createMonitor __cb);

    /**
     * Create a monitor of events.
     * 
     * A exception will be raised if the event type or path mode is not supported by
     * the Monitor implementation for a given OS. An exception will be raised if the
     * path does not exist or is inaccessible to the monitor. An exception will be raised
     * if a monitor cannot be created for any other reason.
     * 
     * @param __result The asynchronous result object.
     * @return monitorId, a uuid1 (string).
     * @throws omero::OmeroFSError
     **/
    public String end_createMonitor(Ice.AsyncResult __result)
        throws omero.OmeroFSError;

    /**
     * Start an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be started for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param id, monitor id (string).
     * @return, no explicit return value.
     * @throws omero::OmeroFSError
     **/
    public void startMonitor(String id)
        throws omero.OmeroFSError;

    /**
     * Start an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be started for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param id, monitor id (string).
     * @param __ctx The Context map to send with the invocation.
     * @return, no explicit return value.
     * @throws omero::OmeroFSError
     **/
    public void startMonitor(String id, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * Start an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be started for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_startMonitor(String id);

    /**
     * Start an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be started for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_startMonitor(String id, java.util.Map<String, String> __ctx);

    /**
     * Start an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be started for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_startMonitor(String id, Ice.Callback __cb);

    /**
     * Start an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be started for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_startMonitor(String id, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Start an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be started for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_startMonitor(String id, Callback_MonitorServer_startMonitor __cb);

    /**
     * Start an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be started for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_startMonitor(String id, java.util.Map<String, String> __ctx, Callback_MonitorServer_startMonitor __cb);

    /**
     * Start an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be started for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __result The asynchronous result object.
     * @return, no explicit return value.
     * @throws omero::OmeroFSError
     **/
    public void end_startMonitor(Ice.AsyncResult __result)
        throws omero.OmeroFSError;

    /**
     * Stop an existing monitor.
     * 
     * Attempting to stop a monitor that is not running raises no exception.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be stopped for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param id, monitor id (string).
     * @return, no explicit return value.
     * @throws omero::OmeroFSError
     **/
    public void stopMonitor(String id)
        throws omero.OmeroFSError;

    /**
     * Stop an existing monitor.
     * 
     * Attempting to stop a monitor that is not running raises no exception.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be stopped for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param id, monitor id (string).
     * @param __ctx The Context map to send with the invocation.
     * @return, no explicit return value.
     * @throws omero::OmeroFSError
     **/
    public void stopMonitor(String id, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * Stop an existing monitor.
     * 
     * Attempting to stop a monitor that is not running raises no exception.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be stopped for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_stopMonitor(String id);

    /**
     * Stop an existing monitor.
     * 
     * Attempting to stop a monitor that is not running raises no exception.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be stopped for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_stopMonitor(String id, java.util.Map<String, String> __ctx);

    /**
     * Stop an existing monitor.
     * 
     * Attempting to stop a monitor that is not running raises no exception.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be stopped for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_stopMonitor(String id, Ice.Callback __cb);

    /**
     * Stop an existing monitor.
     * 
     * Attempting to stop a monitor that is not running raises no exception.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be stopped for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_stopMonitor(String id, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Stop an existing monitor.
     * 
     * Attempting to stop a monitor that is not running raises no exception.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be stopped for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_stopMonitor(String id, Callback_MonitorServer_stopMonitor __cb);

    /**
     * Stop an existing monitor.
     * 
     * Attempting to stop a monitor that is not running raises no exception.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be stopped for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_stopMonitor(String id, java.util.Map<String, String> __ctx, Callback_MonitorServer_stopMonitor __cb);

    /**
     * Stop an existing monitor.
     * 
     * Attempting to stop a monitor that is not running raises no exception.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be stopped for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __result The asynchronous result object.
     * @return, no explicit return value.
     * @throws omero::OmeroFSError
     **/
    public void end_stopMonitor(Ice.AsyncResult __result)
        throws omero.OmeroFSError;

    /**
     * Destroy an existing monitor.
     * 
     * Attempting to destroy a monitor that is running will try to first stop
     * the monitor and then destroy it.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be destroyed (or stopped and destroyed)
     * for any other reason, in this case the monitor's state cannot be assumed.
     * 
     * @param id, monitor id (string).
     * @return, no explicit return value.
     * @throws omero::OmeroFSError
     **/
    public void destroyMonitor(String id)
        throws omero.OmeroFSError;

    /**
     * Destroy an existing monitor.
     * 
     * Attempting to destroy a monitor that is running will try to first stop
     * the monitor and then destroy it.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be destroyed (or stopped and destroyed)
     * for any other reason, in this case the monitor's state cannot be assumed.
     * 
     * @param id, monitor id (string).
     * @param __ctx The Context map to send with the invocation.
     * @return, no explicit return value.
     * @throws omero::OmeroFSError
     **/
    public void destroyMonitor(String id, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * Destroy an existing monitor.
     * 
     * Attempting to destroy a monitor that is running will try to first stop
     * the monitor and then destroy it.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be destroyed (or stopped and destroyed)
     * for any other reason, in this case the monitor's state cannot be assumed.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_destroyMonitor(String id);

    /**
     * Destroy an existing monitor.
     * 
     * Attempting to destroy a monitor that is running will try to first stop
     * the monitor and then destroy it.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be destroyed (or stopped and destroyed)
     * for any other reason, in this case the monitor's state cannot be assumed.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_destroyMonitor(String id, java.util.Map<String, String> __ctx);

    /**
     * Destroy an existing monitor.
     * 
     * Attempting to destroy a monitor that is running will try to first stop
     * the monitor and then destroy it.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be destroyed (or stopped and destroyed)
     * for any other reason, in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_destroyMonitor(String id, Ice.Callback __cb);

    /**
     * Destroy an existing monitor.
     * 
     * Attempting to destroy a monitor that is running will try to first stop
     * the monitor and then destroy it.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be destroyed (or stopped and destroyed)
     * for any other reason, in this case the monitor's state cannot be assumed.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_destroyMonitor(String id, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Destroy an existing monitor.
     * 
     * Attempting to destroy a monitor that is running will try to first stop
     * the monitor and then destroy it.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be destroyed (or stopped and destroyed)
     * for any other reason, in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_destroyMonitor(String id, Callback_MonitorServer_destroyMonitor __cb);

    /**
     * Destroy an existing monitor.
     * 
     * Attempting to destroy a monitor that is running will try to first stop
     * the monitor and then destroy it.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be destroyed (or stopped and destroyed)
     * for any other reason, in this case the monitor's state cannot be assumed.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_destroyMonitor(String id, java.util.Map<String, String> __ctx, Callback_MonitorServer_destroyMonitor __cb);

    /**
     * Destroy an existing monitor.
     * 
     * Attempting to destroy a monitor that is running will try to first stop
     * the monitor and then destroy it.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be destroyed (or stopped and destroyed)
     * for any other reason, in this case the monitor's state cannot be assumed.
     * 
     * @param __result The asynchronous result object.
     * @return, no explicit return value.
     * @throws omero::OmeroFSError
     **/
    public void end_destroyMonitor(Ice.AsyncResult __result)
        throws omero.OmeroFSError;

    /**
     * Get the state of an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * 
     * @param id, monitor id (string).
     * @return, the monitor state (MonitorState).
     * @throws omero::OmeroFSError
     **/
    public MonitorState getMonitorState(String id)
        throws omero.OmeroFSError;

    /**
     * Get the state of an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * 
     * @param id, monitor id (string).
     * @param __ctx The Context map to send with the invocation.
     * @return, the monitor state (MonitorState).
     * @throws omero::OmeroFSError
     **/
    public MonitorState getMonitorState(String id, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError;

    /**
     * Get the state of an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMonitorState(String id);

    /**
     * Get the state of an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMonitorState(String id, java.util.Map<String, String> __ctx);

    /**
     * Get the state of an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMonitorState(String id, Ice.Callback __cb);

    /**
     * Get the state of an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMonitorState(String id, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Get the state of an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMonitorState(String id, Callback_MonitorServer_getMonitorState __cb);

    /**
     * Get the state of an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMonitorState(String id, java.util.Map<String, String> __ctx, Callback_MonitorServer_getMonitorState __cb);

    /**
     * Get the state of an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * 
     * @param __result The asynchronous result object.
     * @return, the monitor state (MonitorState).
     * @throws omero::OmeroFSError
     **/
    public MonitorState end_getMonitorState(Ice.AsyncResult __result)
        throws omero.OmeroFSError;
}
