// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `FS.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid.monitors;

public final class MonitorServerPrxHelper extends Ice.ObjectPrxHelperBase implements MonitorServerPrx
{
    private static final String __createMonitor_name = "createMonitor";

    /**
     * Create a monitor of events.
     * 
     * A exception will be raised if the event type or path mode is not supported by
     * the Monitor implementation for a given OS. An exception will be raised if the
     * path does not exist or is inaccessible to the monitor. An exception will be raised
     * if a monitor cannot be created for any other reason.
     * 
     * @param mType, type of monitor to create (MonitorType).
     * @param eTypes, a sequence of watch event type to monitor (WatchEventTypeList).
     * @param pathString, full path of directory of interest (string).
     * @param whitelist, list of files or extensions of interest (Ice::StringSeq).
     * @param blacklist, list of directories, files or extensions that are not of interest (Ice::StringSeq).
     * @param pMode, path mode of monitor (PathMode).
     * @param proxy, a proxy of the client to which notifications will be sent (MonitorClient*).
     * @param timeout, time in seconds fo monitor to time out (float).
     * @param blockSize, the number of events to pack into each notification (int).
     * @param ignoreSysFiles, ignore system files or not (bool).
     * @param ignoreDirEvents, ignore directory events (bool).
     * @param platformCheck, if true strictly check platform (bool).
     * @return monitorId, a uuid1 (string).
     * @throws omero::OmeroFSError
     **/
    public String createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy)
        throws omero.OmeroFSError
    {
        return createMonitor(mType, eTypes, pMode, pathString, whitelist, blacklist, timeout, blockSize, ignoreSysFiles, ignoreDirEvents, platformCheck, proxy, null, false);
    }

    /**
     * Create a monitor of events.
     * 
     * A exception will be raised if the event type or path mode is not supported by
     * the Monitor implementation for a given OS. An exception will be raised if the
     * path does not exist or is inaccessible to the monitor. An exception will be raised
     * if a monitor cannot be created for any other reason.
     * 
     * @param mType, type of monitor to create (MonitorType).
     * @param eTypes, a sequence of watch event type to monitor (WatchEventTypeList).
     * @param pathString, full path of directory of interest (string).
     * @param whitelist, list of files or extensions of interest (Ice::StringSeq).
     * @param blacklist, list of directories, files or extensions that are not of interest (Ice::StringSeq).
     * @param pMode, path mode of monitor (PathMode).
     * @param proxy, a proxy of the client to which notifications will be sent (MonitorClient*).
     * @param timeout, time in seconds fo monitor to time out (float).
     * @param blockSize, the number of events to pack into each notification (int).
     * @param ignoreSysFiles, ignore system files or not (bool).
     * @param ignoreDirEvents, ignore directory events (bool).
     * @param platformCheck, if true strictly check platform (bool).
     * @param __ctx The Context map to send with the invocation.
     * @return monitorId, a uuid1 (string).
     * @throws omero::OmeroFSError
     **/
    public String createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        return createMonitor(mType, eTypes, pMode, pathString, whitelist, blacklist, timeout, blockSize, ignoreSysFiles, ignoreDirEvents, platformCheck, proxy, __ctx, true);
    }

    private String createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "createMonitor", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("createMonitor");
                    __delBase = __getDelegate(false);
                    _MonitorServerDel __del = (_MonitorServerDel)__delBase;
                    return __del.createMonitor(mType, eTypes, pMode, pathString, whitelist, blacklist, timeout, blockSize, ignoreSysFiles, ignoreDirEvents, platformCheck, proxy, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Create a monitor of events.
     * 
     * A exception will be raised if the event type or path mode is not supported by
     * the Monitor implementation for a given OS. An exception will be raised if the
     * path does not exist or is inaccessible to the monitor. An exception will be raised
     * if a monitor cannot be created for any other reason.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy)
    {
        return begin_createMonitor(mType, eTypes, pMode, pathString, whitelist, blacklist, timeout, blockSize, ignoreSysFiles, ignoreDirEvents, platformCheck, proxy, null, false, null);
    }

    /**
     * Create a monitor of events.
     * 
     * A exception will be raised if the event type or path mode is not supported by
     * the Monitor implementation for a given OS. An exception will be raised if the
     * path does not exist or is inaccessible to the monitor. An exception will be raised
     * if a monitor cannot be created for any other reason.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy, java.util.Map<String, String> __ctx)
    {
        return begin_createMonitor(mType, eTypes, pMode, pathString, whitelist, blacklist, timeout, blockSize, ignoreSysFiles, ignoreDirEvents, platformCheck, proxy, __ctx, true, null);
    }

    /**
     * Create a monitor of events.
     * 
     * A exception will be raised if the event type or path mode is not supported by
     * the Monitor implementation for a given OS. An exception will be raised if the
     * path does not exist or is inaccessible to the monitor. An exception will be raised
     * if a monitor cannot be created for any other reason.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy, Ice.Callback __cb)
    {
        return begin_createMonitor(mType, eTypes, pMode, pathString, whitelist, blacklist, timeout, blockSize, ignoreSysFiles, ignoreDirEvents, platformCheck, proxy, null, false, __cb);
    }

    /**
     * Create a monitor of events.
     * 
     * A exception will be raised if the event type or path mode is not supported by
     * the Monitor implementation for a given OS. An exception will be raised if the
     * path does not exist or is inaccessible to the monitor. An exception will be raised
     * if a monitor cannot be created for any other reason.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_createMonitor(mType, eTypes, pMode, pathString, whitelist, blacklist, timeout, blockSize, ignoreSysFiles, ignoreDirEvents, platformCheck, proxy, __ctx, true, __cb);
    }

    /**
     * Create a monitor of events.
     * 
     * A exception will be raised if the event type or path mode is not supported by
     * the Monitor implementation for a given OS. An exception will be raised if the
     * path does not exist or is inaccessible to the monitor. An exception will be raised
     * if a monitor cannot be created for any other reason.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy, Callback_MonitorServer_createMonitor __cb)
    {
        return begin_createMonitor(mType, eTypes, pMode, pathString, whitelist, blacklist, timeout, blockSize, ignoreSysFiles, ignoreDirEvents, platformCheck, proxy, null, false, __cb);
    }

    /**
     * Create a monitor of events.
     * 
     * A exception will be raised if the event type or path mode is not supported by
     * the Monitor implementation for a given OS. An exception will be raised if the
     * path does not exist or is inaccessible to the monitor. An exception will be raised
     * if a monitor cannot be created for any other reason.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy, java.util.Map<String, String> __ctx, Callback_MonitorServer_createMonitor __cb)
    {
        return begin_createMonitor(mType, eTypes, pMode, pathString, whitelist, blacklist, timeout, blockSize, ignoreSysFiles, ignoreDirEvents, platformCheck, proxy, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__createMonitor_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __createMonitor_name, __cb);
        try
        {
            __result.__prepare(__createMonitor_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            mType.__write(__os);
            WatchEventListHelper.write(__os, eTypes);
            pMode.__write(__os);
            __os.writeString(pathString);
            Ice.StringSeqHelper.write(__os, whitelist);
            Ice.StringSeqHelper.write(__os, blacklist);
            __os.writeFloat(timeout);
            __os.writeInt(blockSize);
            __os.writeBool(ignoreSysFiles);
            __os.writeBool(ignoreDirEvents);
            __os.writeBool(platformCheck);
            MonitorClientPrxHelper.__write(__os, proxy);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) monitorId, a uuid1 (string).
     **/
    public String end_createMonitor(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __createMonitor_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            String __ret;
            __ret = __is.readString();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __destroyMonitor_name = "destroyMonitor";

    /**
     * Destroy an existing monitor.
     * 
     * Attempting to destroy a monitor that is running will try to first stop
     * the monitor and then destroy it.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be destroyed (or stopped and destroyed)
     * for any other reason, in this case the monitor's state cannot be assumed.
     * 
     * @param id, monitor id (string).
     * @return, no explicit return value.
     * @throws omero::OmeroFSError
     **/
    public void destroyMonitor(String id)
        throws omero.OmeroFSError
    {
        destroyMonitor(id, null, false);
    }

    /**
     * Destroy an existing monitor.
     * 
     * Attempting to destroy a monitor that is running will try to first stop
     * the monitor and then destroy it.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be destroyed (or stopped and destroyed)
     * for any other reason, in this case the monitor's state cannot be assumed.
     * 
     * @param id, monitor id (string).
     * @param __ctx The Context map to send with the invocation.
     * @return, no explicit return value.
     * @throws omero::OmeroFSError
     **/
    public void destroyMonitor(String id, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        destroyMonitor(id, __ctx, true);
    }

    private void destroyMonitor(String id, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "destroyMonitor", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("destroyMonitor");
                    __delBase = __getDelegate(false);
                    _MonitorServerDel __del = (_MonitorServerDel)__delBase;
                    __del.destroyMonitor(id, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Destroy an existing monitor.
     * 
     * Attempting to destroy a monitor that is running will try to first stop
     * the monitor and then destroy it.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be destroyed (or stopped and destroyed)
     * for any other reason, in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_destroyMonitor(String id)
    {
        return begin_destroyMonitor(id, null, false, null);
    }

    /**
     * Destroy an existing monitor.
     * 
     * Attempting to destroy a monitor that is running will try to first stop
     * the monitor and then destroy it.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be destroyed (or stopped and destroyed)
     * for any other reason, in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_destroyMonitor(String id, java.util.Map<String, String> __ctx)
    {
        return begin_destroyMonitor(id, __ctx, true, null);
    }

    /**
     * Destroy an existing monitor.
     * 
     * Attempting to destroy a monitor that is running will try to first stop
     * the monitor and then destroy it.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be destroyed (or stopped and destroyed)
     * for any other reason, in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_destroyMonitor(String id, Ice.Callback __cb)
    {
        return begin_destroyMonitor(id, null, false, __cb);
    }

    /**
     * Destroy an existing monitor.
     * 
     * Attempting to destroy a monitor that is running will try to first stop
     * the monitor and then destroy it.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be destroyed (or stopped and destroyed)
     * for any other reason, in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_destroyMonitor(String id, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_destroyMonitor(id, __ctx, true, __cb);
    }

    /**
     * Destroy an existing monitor.
     * 
     * Attempting to destroy a monitor that is running will try to first stop
     * the monitor and then destroy it.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be destroyed (or stopped and destroyed)
     * for any other reason, in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_destroyMonitor(String id, Callback_MonitorServer_destroyMonitor __cb)
    {
        return begin_destroyMonitor(id, null, false, __cb);
    }

    /**
     * Destroy an existing monitor.
     * 
     * Attempting to destroy a monitor that is running will try to first stop
     * the monitor and then destroy it.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be destroyed (or stopped and destroyed)
     * for any other reason, in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_destroyMonitor(String id, java.util.Map<String, String> __ctx, Callback_MonitorServer_destroyMonitor __cb)
    {
        return begin_destroyMonitor(id, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_destroyMonitor(String id, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__destroyMonitor_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __destroyMonitor_name, __cb);
        try
        {
            __result.__prepare(__destroyMonitor_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(id);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value), no explicit return value.
     **/
    public void end_destroyMonitor(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __destroyMonitor_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __getMonitorState_name = "getMonitorState";

    /**
     * Get the state of an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * 
     * @param id, monitor id (string).
     * @return, the monitor state (MonitorState).
     * @throws omero::OmeroFSError
     **/
    public MonitorState getMonitorState(String id)
        throws omero.OmeroFSError
    {
        return getMonitorState(id, null, false);
    }

    /**
     * Get the state of an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * 
     * @param id, monitor id (string).
     * @param __ctx The Context map to send with the invocation.
     * @return, the monitor state (MonitorState).
     * @throws omero::OmeroFSError
     **/
    public MonitorState getMonitorState(String id, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        return getMonitorState(id, __ctx, true);
    }

    private MonitorState getMonitorState(String id, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getMonitorState", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getMonitorState");
                    __delBase = __getDelegate(false);
                    _MonitorServerDel __del = (_MonitorServerDel)__delBase;
                    return __del.getMonitorState(id, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Get the state of an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMonitorState(String id)
    {
        return begin_getMonitorState(id, null, false, null);
    }

    /**
     * Get the state of an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMonitorState(String id, java.util.Map<String, String> __ctx)
    {
        return begin_getMonitorState(id, __ctx, true, null);
    }

    /**
     * Get the state of an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMonitorState(String id, Ice.Callback __cb)
    {
        return begin_getMonitorState(id, null, false, __cb);
    }

    /**
     * Get the state of an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMonitorState(String id, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getMonitorState(id, __ctx, true, __cb);
    }

    /**
     * Get the state of an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMonitorState(String id, Callback_MonitorServer_getMonitorState __cb)
    {
        return begin_getMonitorState(id, null, false, __cb);
    }

    /**
     * Get the state of an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMonitorState(String id, java.util.Map<String, String> __ctx, Callback_MonitorServer_getMonitorState __cb)
    {
        return begin_getMonitorState(id, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getMonitorState(String id, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getMonitorState_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getMonitorState_name, __cb);
        try
        {
            __result.__prepare(__getMonitorState_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(id);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value), the monitor state (MonitorState).
     **/
    public MonitorState end_getMonitorState(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __getMonitorState_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            MonitorState __ret;
            __ret = MonitorState.__read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __startMonitor_name = "startMonitor";

    /**
     * Start an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be started for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param id, monitor id (string).
     * @return, no explicit return value.
     * @throws omero::OmeroFSError
     **/
    public void startMonitor(String id)
        throws omero.OmeroFSError
    {
        startMonitor(id, null, false);
    }

    /**
     * Start an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be started for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param id, monitor id (string).
     * @param __ctx The Context map to send with the invocation.
     * @return, no explicit return value.
     * @throws omero::OmeroFSError
     **/
    public void startMonitor(String id, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        startMonitor(id, __ctx, true);
    }

    private void startMonitor(String id, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "startMonitor", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("startMonitor");
                    __delBase = __getDelegate(false);
                    _MonitorServerDel __del = (_MonitorServerDel)__delBase;
                    __del.startMonitor(id, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Start an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be started for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_startMonitor(String id)
    {
        return begin_startMonitor(id, null, false, null);
    }

    /**
     * Start an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be started for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_startMonitor(String id, java.util.Map<String, String> __ctx)
    {
        return begin_startMonitor(id, __ctx, true, null);
    }

    /**
     * Start an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be started for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_startMonitor(String id, Ice.Callback __cb)
    {
        return begin_startMonitor(id, null, false, __cb);
    }

    /**
     * Start an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be started for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_startMonitor(String id, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_startMonitor(id, __ctx, true, __cb);
    }

    /**
     * Start an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be started for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_startMonitor(String id, Callback_MonitorServer_startMonitor __cb)
    {
        return begin_startMonitor(id, null, false, __cb);
    }

    /**
     * Start an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be started for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_startMonitor(String id, java.util.Map<String, String> __ctx, Callback_MonitorServer_startMonitor __cb)
    {
        return begin_startMonitor(id, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_startMonitor(String id, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__startMonitor_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __startMonitor_name, __cb);
        try
        {
            __result.__prepare(__startMonitor_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(id);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value), no explicit return value.
     **/
    public void end_startMonitor(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __startMonitor_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __stopMonitor_name = "stopMonitor";

    /**
     * Stop an existing monitor.
     * 
     * Attempting to stop a monitor that is not running raises no exception.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be stopped for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param id, monitor id (string).
     * @return, no explicit return value.
     * @throws omero::OmeroFSError
     **/
    public void stopMonitor(String id)
        throws omero.OmeroFSError
    {
        stopMonitor(id, null, false);
    }

    /**
     * Stop an existing monitor.
     * 
     * Attempting to stop a monitor that is not running raises no exception.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be stopped for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param id, monitor id (string).
     * @param __ctx The Context map to send with the invocation.
     * @return, no explicit return value.
     * @throws omero::OmeroFSError
     **/
    public void stopMonitor(String id, java.util.Map<String, String> __ctx)
        throws omero.OmeroFSError
    {
        stopMonitor(id, __ctx, true);
    }

    private void stopMonitor(String id, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.OmeroFSError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "stopMonitor", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("stopMonitor");
                    __delBase = __getDelegate(false);
                    _MonitorServerDel __del = (_MonitorServerDel)__delBase;
                    __del.stopMonitor(id, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Stop an existing monitor.
     * 
     * Attempting to stop a monitor that is not running raises no exception.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be stopped for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_stopMonitor(String id)
    {
        return begin_stopMonitor(id, null, false, null);
    }

    /**
     * Stop an existing monitor.
     * 
     * Attempting to stop a monitor that is not running raises no exception.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be stopped for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_stopMonitor(String id, java.util.Map<String, String> __ctx)
    {
        return begin_stopMonitor(id, __ctx, true, null);
    }

    /**
     * Stop an existing monitor.
     * 
     * Attempting to stop a monitor that is not running raises no exception.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be stopped for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_stopMonitor(String id, Ice.Callback __cb)
    {
        return begin_stopMonitor(id, null, false, __cb);
    }

    /**
     * Stop an existing monitor.
     * 
     * Attempting to stop a monitor that is not running raises no exception.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be stopped for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_stopMonitor(String id, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_stopMonitor(id, __ctx, true, __cb);
    }

    /**
     * Stop an existing monitor.
     * 
     * Attempting to stop a monitor that is not running raises no exception.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be stopped for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_stopMonitor(String id, Callback_MonitorServer_stopMonitor __cb)
    {
        return begin_stopMonitor(id, null, false, __cb);
    }

    /**
     * Stop an existing monitor.
     * 
     * Attempting to stop a monitor that is not running raises no exception.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be stopped for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_stopMonitor(String id, java.util.Map<String, String> __ctx, Callback_MonitorServer_stopMonitor __cb)
    {
        return begin_stopMonitor(id, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_stopMonitor(String id, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__stopMonitor_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __stopMonitor_name, __cb);
        try
        {
            __result.__prepare(__stopMonitor_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(id);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value), no explicit return value.
     **/
    public void end_stopMonitor(Ice.AsyncResult __result)
        throws omero.OmeroFSError
    {
        Ice.AsyncResult.__check(__result, this, __stopMonitor_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.OmeroFSError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public static MonitorServerPrx checkedCast(Ice.ObjectPrx __obj)
    {
        MonitorServerPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof MonitorServerPrx)
            {
                __d = (MonitorServerPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    MonitorServerPrxHelper __h = new MonitorServerPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static MonitorServerPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        MonitorServerPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof MonitorServerPrx)
            {
                __d = (MonitorServerPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    MonitorServerPrxHelper __h = new MonitorServerPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static MonitorServerPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        MonitorServerPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    MonitorServerPrxHelper __h = new MonitorServerPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static MonitorServerPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        MonitorServerPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    MonitorServerPrxHelper __h = new MonitorServerPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static MonitorServerPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        MonitorServerPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof MonitorServerPrx)
            {
                __d = (MonitorServerPrx)__obj;
            }
            else
            {
                MonitorServerPrxHelper __h = new MonitorServerPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static MonitorServerPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        MonitorServerPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            MonitorServerPrxHelper __h = new MonitorServerPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::monitors::MonitorServer"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _MonitorServerDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _MonitorServerDelD();
    }

    public static void __write(IceInternal.BasicStream __os, MonitorServerPrx v)
    {
        __os.writeProxy(v);
    }

    public static MonitorServerPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            MonitorServerPrxHelper result = new MonitorServerPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
