// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `FS.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid.monitors;

public abstract class _FileServerDisp extends Ice.ObjectImpl implements FileServer
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::monitors::FileServer"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Query the existence of a file
     * 
     * An exception will be raised if the method fails to determine the existence.
     * 
     * @param fileId, see above.
     * @return existence of file.
     * @throws omero::OmeroFSError
     **/
    public final boolean fileExists(String fileId)
        throws omero.OmeroFSError
    {
        return fileExists(fileId, null);
    }

    /**
     * Get atime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return atime of file (float).
     * @throws omero::OmeroFSError
     **/
    public final float getATime(String fileId)
        throws omero.OmeroFSError
    {
        return getATime(fileId, null);
    }

    /**
     * Get base name of a file, this is the name
     * stripped of any path, e.g. file.ext
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return base name.
     * @throws omero::OmeroFSError
     **/
    public final String getBaseName(String fileId)
        throws omero.OmeroFSError
    {
        return getBaseName(fileId, null);
    }

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain the file stats for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param absPath, an absolute path on the monitor's watch path (string).
     * @param filter, a filter to apply to the listing, cf. ls (string).
     * @return, a directory listing (FileStatsList).
     * @throws omero::OmeroFSError
     **/
    public final FileStats[] getBulkDirectory(String absPath, String filter)
        throws omero.OmeroFSError
    {
        return getBulkDirectory(absPath, filter, null);
    }

    /**
     * Get ctime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return ctime of file (float).
     * @throws omero::OmeroFSError
     **/
    public final float getCTime(String fileId)
        throws omero.OmeroFSError
    {
        return getCTime(fileId, null);
    }

    /**
     * Get an absolute directory from an OMERO.fs server.
     * 
     * The returned list will contain just the file names for each directory entry.
     * 
     * An exception will be raised if the path does not exist or is inaccessible to the
     * OMERO.fs server. An exception will be raised if directory list cannot be
     * returned for any other reason.
     * 
     * @param absPath, an absolute path on the monitor's watch path (string).
     * @param filter, a filter to apply to the listing, cf. ls (string).
     * @return, a directory listing (Ice::StringSeq).
     * @throws omero::OmeroFSError
     **/
    public final String[] getDirectory(String absPath, String filter)
        throws omero.OmeroFSError
    {
        return getDirectory(absPath, filter, null);
    }

    /**
     * Get mtime of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return mtime of file (float).
     * @throws omero::OmeroFSError
     **/
    public final float getMTime(String fileId)
        throws omero.OmeroFSError
    {
        return getMTime(fileId, null);
    }

    /**
     * Get owner of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return owner of file (string).
     * @throws omero::OmeroFSError
     **/
    public final String getOwner(String fileId)
        throws omero.OmeroFSError
    {
        return getOwner(fileId, null);
    }

    /**
     * Get SHA1 of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the SHA1 cannot be generated for any reason.
     * 
     * @param fileId, see above.
     * @return SHA1 hex hash digest of file (string).
     * @throws omero::OmeroFSError
     **/
    public final String getSHA1(String fileId)
        throws omero.OmeroFSError
    {
        return getSHA1(fileId, null);
    }

    /**
     * Get size of a file in bytes
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return byte size of file (long).
     * @throws omero::OmeroFSError
     **/
    public final long getSize(String fileId)
        throws omero.OmeroFSError
    {
        return getSize(fileId, null);
    }

    /**
     * Get all FileStats of a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return file stats (FileStats).
     * @throws omero::OmeroFSError
     **/
    public final FileStats getStats(String fileId)
        throws omero.OmeroFSError
    {
        return getStats(fileId, null);
    }

    /**
     * Query whether file is a directory
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return true is directory (bool).
     * @throws omero::OmeroFSError
     **/
    public final boolean isDir(String fileId)
        throws omero.OmeroFSError
    {
        return isDir(fileId, null);
    }

    /**
     * Query whether file is a file
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * 
     * @param fileId, see above.
     * @return true if file (bool).
     * @throws omero::OmeroFSError
     **/
    public final boolean isFile(String fileId)
        throws omero.OmeroFSError
    {
        return isFile(fileId, null);
    }

    /**
     * readBlock should open, read size bytes from offset
     * and then close the file.
     * 
     * An exception will be raised if the file no longer exists or is inaccessible.
     * An exception will be raised if the file read fails for any other reason.
     * 
     * @param fileId, see above.
     * @param offset, byte offset into file from where read should begin (long).
     * @param size, number of bytes that should be read (int).
     * @return byte sequence of upto size bytes.
     * @throws omero::OmeroFSError
     **/
    public final byte[] readBlock(String fileId, long offset, int size)
        throws omero.OmeroFSError
    {
        return readBlock(fileId, offset, size, null);
    }

    public static Ice.DispatchStatus ___getDirectory(FileServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String absPath;
        String filter;
        absPath = __is.readString();
        filter = __is.readString();
        __inS.endReadParams();
        try
        {
            String[] __ret = __obj.getDirectory(absPath, filter, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            Ice.StringSeqHelper.write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getBulkDirectory(FileServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String absPath;
        String filter;
        absPath = __is.readString();
        filter = __is.readString();
        __inS.endReadParams();
        try
        {
            FileStats[] __ret = __obj.getBulkDirectory(absPath, filter, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            FileStatsListHelper.write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___fileExists(FileServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String fileId;
        fileId = __is.readString();
        __inS.endReadParams();
        try
        {
            boolean __ret = __obj.fileExists(fileId, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(__ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getBaseName(FileServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String fileId;
        fileId = __is.readString();
        __inS.endReadParams();
        try
        {
            String __ret = __obj.getBaseName(fileId, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(__ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getStats(FileServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String fileId;
        fileId = __is.readString();
        __inS.endReadParams();
        try
        {
            FileStats __ret = __obj.getStats(fileId, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __ret.__write(__os);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getSize(FileServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String fileId;
        fileId = __is.readString();
        __inS.endReadParams();
        try
        {
            long __ret = __obj.getSize(fileId, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(__ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getOwner(FileServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String fileId;
        fileId = __is.readString();
        __inS.endReadParams();
        try
        {
            String __ret = __obj.getOwner(fileId, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(__ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getCTime(FileServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String fileId;
        fileId = __is.readString();
        __inS.endReadParams();
        try
        {
            float __ret = __obj.getCTime(fileId, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeFloat(__ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getMTime(FileServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String fileId;
        fileId = __is.readString();
        __inS.endReadParams();
        try
        {
            float __ret = __obj.getMTime(fileId, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeFloat(__ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getATime(FileServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String fileId;
        fileId = __is.readString();
        __inS.endReadParams();
        try
        {
            float __ret = __obj.getATime(fileId, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeFloat(__ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___isDir(FileServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String fileId;
        fileId = __is.readString();
        __inS.endReadParams();
        try
        {
            boolean __ret = __obj.isDir(fileId, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(__ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___isFile(FileServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String fileId;
        fileId = __is.readString();
        __inS.endReadParams();
        try
        {
            boolean __ret = __obj.isFile(fileId, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(__ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getSHA1(FileServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String fileId;
        fileId = __is.readString();
        __inS.endReadParams();
        try
        {
            String __ret = __obj.getSHA1(fileId, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(__ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___readBlock(FileServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String fileId;
        long offset;
        int size;
        fileId = __is.readString();
        offset = __is.readLong();
        size = __is.readInt();
        __inS.endReadParams();
        try
        {
            byte[] __ret = __obj.readBlock(fileId, offset, size, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            Ice.ByteSeqHelper.write(__os, __ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    private final static String[] __all =
    {
        "fileExists",
        "getATime",
        "getBaseName",
        "getBulkDirectory",
        "getCTime",
        "getDirectory",
        "getMTime",
        "getOwner",
        "getSHA1",
        "getSize",
        "getStats",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "isDir",
        "isFile",
        "readBlock"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___fileExists(this, in, __current);
            }
            case 1:
            {
                return ___getATime(this, in, __current);
            }
            case 2:
            {
                return ___getBaseName(this, in, __current);
            }
            case 3:
            {
                return ___getBulkDirectory(this, in, __current);
            }
            case 4:
            {
                return ___getCTime(this, in, __current);
            }
            case 5:
            {
                return ___getDirectory(this, in, __current);
            }
            case 6:
            {
                return ___getMTime(this, in, __current);
            }
            case 7:
            {
                return ___getOwner(this, in, __current);
            }
            case 8:
            {
                return ___getSHA1(this, in, __current);
            }
            case 9:
            {
                return ___getSize(this, in, __current);
            }
            case 10:
            {
                return ___getStats(this, in, __current);
            }
            case 11:
            {
                return ___ice_id(this, in, __current);
            }
            case 12:
            {
                return ___ice_ids(this, in, __current);
            }
            case 13:
            {
                return ___ice_isA(this, in, __current);
            }
            case 14:
            {
                return ___ice_ping(this, in, __current);
            }
            case 15:
            {
                return ___isDir(this, in, __current);
            }
            case 16:
            {
                return ___isFile(this, in, __current);
            }
            case 17:
            {
                return ___readBlock(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
