// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `FS.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.grid.monitors;

public abstract class _MonitorServerDisp extends Ice.ObjectImpl implements MonitorServer
{
    protected void
    ice_copyStateFrom(Ice.Object __obj)
        throws java.lang.CloneNotSupportedException
    {
        throw new java.lang.CloneNotSupportedException();
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::grid::monitors::MonitorServer"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Create a monitor of events.
     * 
     * A exception will be raised if the event type or path mode is not supported by
     * the Monitor implementation for a given OS. An exception will be raised if the
     * path does not exist or is inaccessible to the monitor. An exception will be raised
     * if a monitor cannot be created for any other reason.
     * 
     * @param mType, type of monitor to create (MonitorType).
     * @param eTypes, a sequence of watch event type to monitor (WatchEventTypeList).
     * @param pathString, full path of directory of interest (string).
     * @param whitelist, list of files or extensions of interest (Ice::StringSeq).
     * @param blacklist, list of directories, files or extensions that are not of interest (Ice::StringSeq).
     * @param pMode, path mode of monitor (PathMode).
     * @param proxy, a proxy of the client to which notifications will be sent (MonitorClient*).
     * @param timeout, time in seconds fo monitor to time out (float).
     * @param blockSize, the number of events to pack into each notification (int).
     * @param ignoreSysFiles, ignore system files or not (bool).
     * @param ignoreDirEvents, ignore directory events (bool).
     * @param platformCheck, if true strictly check platform (bool).
     * @return monitorId, a uuid1 (string).
     * @throws omero::OmeroFSError
     **/
    public final String createMonitor(MonitorType mType, WatchEventType[] eTypes, PathMode pMode, String pathString, String[] whitelist, String[] blacklist, float timeout, int blockSize, boolean ignoreSysFiles, boolean ignoreDirEvents, boolean platformCheck, MonitorClientPrx proxy)
        throws omero.OmeroFSError
    {
        return createMonitor(mType, eTypes, pMode, pathString, whitelist, blacklist, timeout, blockSize, ignoreSysFiles, ignoreDirEvents, platformCheck, proxy, null);
    }

    /**
     * Destroy an existing monitor.
     * 
     * Attempting to destroy a monitor that is running will try to first stop
     * the monitor and then destroy it.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be destroyed (or stopped and destroyed)
     * for any other reason, in this case the monitor's state cannot be assumed.
     * 
     * @param id, monitor id (string).
     * @return, no explicit return value.
     * @throws omero::OmeroFSError
     **/
    public final void destroyMonitor(String id)
        throws omero.OmeroFSError
    {
        destroyMonitor(id, null);
    }

    /**
     * Get the state of an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * 
     * @param id, monitor id (string).
     * @return, the monitor state (MonitorState).
     * @throws omero::OmeroFSError
     **/
    public final MonitorState getMonitorState(String id)
        throws omero.OmeroFSError
    {
        return getMonitorState(id, null);
    }

    /**
     * Start an existing monitor.
     * 
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be started for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param id, monitor id (string).
     * @return, no explicit return value.
     * @throws omero::OmeroFSError
     **/
    public final void startMonitor(String id)
        throws omero.OmeroFSError
    {
        startMonitor(id, null);
    }

    /**
     * Stop an existing monitor.
     * 
     * Attempting to stop a monitor that is not running raises no exception.
     * An exception will be raised if the id does not correspond to an existing monitor.
     * An exception will be raised if a monitor cannot be stopped for any other reason,
     * in this case the monitor's state cannot be assumed.
     * 
     * @param id, monitor id (string).
     * @return, no explicit return value.
     * @throws omero::OmeroFSError
     **/
    public final void stopMonitor(String id)
        throws omero.OmeroFSError
    {
        stopMonitor(id, null);
    }

    public static Ice.DispatchStatus ___createMonitor(MonitorServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        MonitorType mType;
        WatchEventType[] eTypes;
        PathMode pMode;
        String pathString;
        String[] whitelist;
        String[] blacklist;
        float timeout;
        int blockSize;
        boolean ignoreSysFiles;
        boolean ignoreDirEvents;
        boolean platformCheck;
        MonitorClientPrx proxy;
        mType = MonitorType.__read(__is);
        eTypes = WatchEventListHelper.read(__is);
        pMode = PathMode.__read(__is);
        pathString = __is.readString();
        whitelist = Ice.StringSeqHelper.read(__is);
        blacklist = Ice.StringSeqHelper.read(__is);
        timeout = __is.readFloat();
        blockSize = __is.readInt();
        ignoreSysFiles = __is.readBool();
        ignoreDirEvents = __is.readBool();
        platformCheck = __is.readBool();
        proxy = MonitorClientPrxHelper.__read(__is);
        __inS.endReadParams();
        try
        {
            String __ret = __obj.createMonitor(mType, eTypes, pMode, pathString, whitelist, blacklist, timeout, blockSize, ignoreSysFiles, ignoreDirEvents, platformCheck, proxy, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(__ret);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___startMonitor(MonitorServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String id;
        id = __is.readString();
        __inS.endReadParams();
        try
        {
            __obj.startMonitor(id, __current);
            __inS.__writeEmptyParams();
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___stopMonitor(MonitorServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String id;
        id = __is.readString();
        __inS.endReadParams();
        try
        {
            __obj.stopMonitor(id, __current);
            __inS.__writeEmptyParams();
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___destroyMonitor(MonitorServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String id;
        id = __is.readString();
        __inS.endReadParams();
        try
        {
            __obj.destroyMonitor(id, __current);
            __inS.__writeEmptyParams();
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    public static Ice.DispatchStatus ___getMonitorState(MonitorServer __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Idempotent, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String id;
        id = __is.readString();
        __inS.endReadParams();
        try
        {
            MonitorState __ret = __obj.getMonitorState(id, __current);
            IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
            __ret.__write(__os);
            __inS.__endWriteParams(true);
            return Ice.DispatchStatus.DispatchOK;
        }
        catch(omero.OmeroFSError ex)
        {
            __inS.__writeUserException(ex, Ice.FormatType.DefaultFormat);
            return Ice.DispatchStatus.DispatchUserException;
        }
    }

    private final static String[] __all =
    {
        "createMonitor",
        "destroyMonitor",
        "getMonitorState",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "startMonitor",
        "stopMonitor"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___createMonitor(this, in, __current);
            }
            case 1:
            {
                return ___destroyMonitor(this, in, __current);
            }
            case 2:
            {
                return ___getMonitorState(this, in, __current);
            }
            case 3:
            {
                return ___ice_id(this, in, __current);
            }
            case 4:
            {
                return ___ice_ids(this, in, __current);
            }
            case 5:
            {
                return ___ice_isA(this, in, __current);
            }
            case 6:
            {
                return ___ice_ping(this, in, __current);
            }
            case 7:
            {
                return ___startMonitor(this, in, __current);
            }
            case 8:
            {
                return ___stopMonitor(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.endReadSlice();
    }

    public static final long serialVersionUID = 0L;
}
