// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IObject.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.model;

/**
 * Base class of all model types. On the
 * server, the interface ome.model.IObject
 * unifies the model. In Ice, interfaces have
 * a more remote connotation.
 **/
public abstract class IObject extends Ice.ObjectImpl
                              implements _IObjectOperations,
                                         _IObjectOperationsNC
{
    public IObject()
    {
    }

    public IObject(omero.RLong id, Details details, boolean loaded)
    {
        this.id = id;
        this.details = details;
        this.loaded = loaded;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::model::IObject"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    public final Details getDetails()
    {
        return getDetails(null);
    }

    public final omero.RLong getId()
    {
        return getId(null);
    }

    /**
     * Allows for the attachment of any omero.model.Annotation
     * subclasses. Methods provided are:
     * 
     * - linkAnnotation(Annotation)
     * -
     **/
    public final boolean isAnnotated()
    {
        return isAnnotated(null);
    }

    /**
     * Marker interface which means that special rules apply
     * for both reading and writing these instances.
     **/
    public final boolean isGlobal()
    {
        return isGlobal(null);
    }

    /**
     * A link between two other types.
     * Methods provided:
     * 
     * - getParent()
     * - getChild()
     **/
    public final boolean isLink()
    {
        return isLink(null);
    }

    /**
     * Tests for unloadedness. If this value is false, then
     * any method call on this instance other than getId
     * or setId will result in an exception.
     **/
    public final boolean isLoaded()
    {
        return isLoaded(null);
    }

    /**
     * The server will persist changes made to these types.
     * Methods provided:
     * 
     * - getVersion()
     * - setVersion()
     * 
     **/
    public final boolean isMutable()
    {
        return isMutable(null);
    }

    /**
     * Return another instance of the same type as this instance
     * constructed as if by: new InstanceI( this.id.val, false );
     **/
    public final IObject proxy()
    {
        return proxy(null);
    }

    public final void setId(omero.RLong id)
    {
        setId(id, null);
    }

    /**
     * Return another instance of the same type as this instance
     * with all single-value entities unloaded and all members of
     * collections also unloaded.
     **/
    public final IObject shallowCopy()
    {
        return shallowCopy(null);
    }

    /**
     * Sets the loaded boolean to false and empties all state
     * from this entity to make sending it over the network
     * less costly.
     **/
    public final void unload()
    {
        unload(null);
    }

    /**
     * Each collection can also be unloaded, independently
     * of the object itself. To unload all collections, use:
     * 
     * object.unloadCollections();
     * 
     * This is useful when it is possible that a collection no
     * longer represents the state in the database, and passing the
     * collections back to the server might delete some entities.
     * 
     * Sending back empty collections can also save a significant
     * amount of bandwidth, when working with large data graphs.
     **/
    public final void unloadCollections()
    {
        unloadCollections(null);
    }

    /**
     * As with collections, the objects under details can link
     * to many other objects. Unloading the details can same
     * bandwidth and simplify the server logic.
     **/
    public final void unloadDetails()
    {
        unloadDetails(null);
    }

    public static Ice.DispatchStatus ___getId(IObject __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        omero.RLong __ret = __obj.getId(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeObject(__ret);
        __os.writePendingObjects();
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___setId(IObject __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        omero.RLongHolder id = new omero.RLongHolder();
        __is.readObject(id);
        __is.readPendingObjects();
        __inS.endReadParams();
        __obj.setId(id.value, __current);
        __inS.__writeEmptyParams();
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___getDetails(IObject __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        Details __ret = __obj.getDetails(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeObject(__ret);
        __os.writePendingObjects();
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___proxy(IObject __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        IObject __ret = __obj.proxy(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeObject(__ret);
        __os.writePendingObjects();
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___shallowCopy(IObject __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        IObject __ret = __obj.shallowCopy(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeObject(__ret);
        __os.writePendingObjects();
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___unload(IObject __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        __obj.unload(__current);
        __inS.__writeEmptyParams();
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___unloadCollections(IObject __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        __obj.unloadCollections(__current);
        __inS.__writeEmptyParams();
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___unloadDetails(IObject __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        __obj.unloadDetails(__current);
        __inS.__writeEmptyParams();
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___isLoaded(IObject __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        boolean __ret = __obj.isLoaded(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___isGlobal(IObject __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        boolean __ret = __obj.isGlobal(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___isLink(IObject __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        boolean __ret = __obj.isLink(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___isMutable(IObject __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        boolean __ret = __obj.isMutable(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___isAnnotated(IObject __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        boolean __ret = __obj.isAnnotated(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    private final static String[] __all =
    {
        "getDetails",
        "getId",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "isAnnotated",
        "isGlobal",
        "isLink",
        "isLoaded",
        "isMutable",
        "proxy",
        "setId",
        "shallowCopy",
        "unload",
        "unloadCollections",
        "unloadDetails"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___getDetails(this, in, __current);
            }
            case 1:
            {
                return ___getId(this, in, __current);
            }
            case 2:
            {
                return ___ice_id(this, in, __current);
            }
            case 3:
            {
                return ___ice_ids(this, in, __current);
            }
            case 4:
            {
                return ___ice_isA(this, in, __current);
            }
            case 5:
            {
                return ___ice_ping(this, in, __current);
            }
            case 6:
            {
                return ___isAnnotated(this, in, __current);
            }
            case 7:
            {
                return ___isGlobal(this, in, __current);
            }
            case 8:
            {
                return ___isLink(this, in, __current);
            }
            case 9:
            {
                return ___isLoaded(this, in, __current);
            }
            case 10:
            {
                return ___isMutable(this, in, __current);
            }
            case 11:
            {
                return ___proxy(this, in, __current);
            }
            case 12:
            {
                return ___setId(this, in, __current);
            }
            case 13:
            {
                return ___shallowCopy(this, in, __current);
            }
            case 14:
            {
                return ___unload(this, in, __current);
            }
            case 15:
            {
                return ___unloadCollections(this, in, __current);
            }
            case 16:
            {
                return ___unloadDetails(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.writeObject(id);
        __os.writeObject(details);
        __os.writeBool(loaded);
        __os.endWriteSlice();
    }

    private class Patcher implements IceInternal.Patcher
    {
        Patcher(int member)
        {
            __member = member;
        }

        public void
        patch(Ice.Object v)
        {
            switch(__member)
            {
            case 0:
                __typeId = "::omero::RLong";
                if(v == null || v instanceof omero.RLong)
                {
                    id = (omero.RLong)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            case 1:
                __typeId = "::omero::model::Details";
                if(v == null || v instanceof Details)
                {
                    details = (Details)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            }
        }

        public String
        type()
        {
            return __typeId;
        }

        private int __member;
        private String __typeId;
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.readObject(new Patcher(0));
        __is.readObject(new Patcher(1));
        loaded = __is.readBool();
        __is.endReadSlice();
    }

    /**
     * The database id for this entity. Of RLong value
     * so that transient entities can have a null id.
     **/
    protected omero.RLong id;

    /**
     * Internal details (permissions, owner, etc.) for
     * this entity. All entities have Details, and even
     * a newly created object will have a non-null
     * Details instance. (In the OMERO provided mapping!)
     **/
    protected Details details;

    /**
     * An unloaded object contains no state other than id. An
     * exception will be raised if any field other than id is
     * accessed via the OMERO-generated methods. Unloaded objects
     * are useful as pointers or proxies to server-side state.
     **/
    protected boolean loaded;

    public static final long serialVersionUID = -5706843249997448745L;
}
