// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Permissions.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.model;

/**
 * Row-level permissions definition available on
 * every OMERO.blitz type. Represents a similar
 * logic to the Unix filesystem.
 **/
public abstract class Permissions extends Ice.ObjectImpl
                                  implements _PermissionsOperations,
                                             _PermissionsOperationsNC
{
    public Permissions()
    {
    }

    public Permissions(boolean[] restrictions, java.util.List<String> extendedRestrictions, long perm1)
    {
        this.restrictions = restrictions;
        this.extendedRestrictions = extendedRestrictions;
        this.perm1 = perm1;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::model::Permissions"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    /**
     * Whether the current user has permissions
     * for annotating this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     **/
    public final boolean canAnnotate()
    {
        return canAnnotate(null);
    }

    /**
     * Whether the current user has the ""delete"" permissions
     * for this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     **/
    public final boolean canDelete()
    {
        return canDelete(null);
    }

    /**
     * Whether the current user has the ""edit"" permissions
     * for this object. This includes changing the values
     * of the object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     **/
    public final boolean canEdit()
    {
        return canEdit(null);
    }

    /**
     * Whether the current user has the ""link"" permissions
     * for this object. This includes adding it to data graphs.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     **/
    public final boolean canLink()
    {
        return canLink(null);
    }

    /**
     * Do not use!
     **/
    public final long getPerm1()
    {
        return getPerm1(null);
    }

    /**
     * The basis for the other canX() methods. If the restriction
     * at the given offset in the restriction array is true, then
     * this method returns true (otherwise false) and the canX()
     * methods return the opposite, i.e.
     * 
     * isDisallow(ANNOTATERESTRICTION) == ! canAnnotate()
     * 
     **/
    public final boolean isDisallow(int restriction)
    {
        return isDisallow(restriction, null);
    }

    public final boolean isGroupAnnotate()
    {
        return isGroupAnnotate(null);
    }

    public final boolean isGroupRead()
    {
        return isGroupRead(null);
    }

    public final boolean isGroupWrite()
    {
        return isGroupWrite(null);
    }

    /**
     * Returns true if the given argument is present in the
     * extendedRestrictions set. This implies that some
     * service-specific behavior is disallowed.
     **/
    public final boolean isRestricted(String restriction)
    {
        return isRestricted(restriction, null);
    }

    public final boolean isUserAnnotate()
    {
        return isUserAnnotate(null);
    }

    public final boolean isUserRead()
    {
        return isUserRead(null);
    }

    public final boolean isUserWrite()
    {
        return isUserWrite(null);
    }

    public final boolean isWorldAnnotate()
    {
        return isWorldAnnotate(null);
    }

    public final boolean isWorldRead()
    {
        return isWorldRead(null);
    }

    public final boolean isWorldWrite()
    {
        return isWorldWrite(null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public final void setGroupAnnotate(boolean value)
    {
        setGroupAnnotate(value, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public final void setGroupRead(boolean value)
    {
        setGroupRead(value, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public final void setGroupWrite(boolean value)
    {
        setGroupWrite(value, null);
    }

    /**
     * Do not use!
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public final void setPerm1(long value)
    {
        setPerm1(value, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public final void setUserAnnotate(boolean value)
    {
        setUserAnnotate(value, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public final void setUserRead(boolean value)
    {
        setUserRead(value, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public final void setUserWrite(boolean value)
    {
        setUserWrite(value, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public final void setWorldAnnotate(boolean value)
    {
        setWorldAnnotate(value, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public final void setWorldRead(boolean value)
    {
        setWorldRead(value, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public final void setWorldWrite(boolean value)
    {
        setWorldWrite(value, null);
    }

    public static Ice.DispatchStatus ___getPerm1(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        long __ret = __obj.getPerm1(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeLong(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___setPerm1(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        long value;
        value = __is.readLong();
        __inS.endReadParams();
        __obj.setPerm1(value, __current);
        __inS.__writeEmptyParams();
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___isDisallow(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        int restriction;
        restriction = __is.readInt();
        __inS.endReadParams();
        boolean __ret = __obj.isDisallow(restriction, __current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___isRestricted(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        String restriction;
        restriction = __is.readString();
        __inS.endReadParams();
        boolean __ret = __obj.isRestricted(restriction, __current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___canAnnotate(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        boolean __ret = __obj.canAnnotate(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___canEdit(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        boolean __ret = __obj.canEdit(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___canLink(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        boolean __ret = __obj.canLink(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___canDelete(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        boolean __ret = __obj.canDelete(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___isUserRead(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        boolean __ret = __obj.isUserRead(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___isUserAnnotate(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        boolean __ret = __obj.isUserAnnotate(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___isUserWrite(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        boolean __ret = __obj.isUserWrite(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___isGroupRead(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        boolean __ret = __obj.isGroupRead(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___isGroupAnnotate(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        boolean __ret = __obj.isGroupAnnotate(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___isGroupWrite(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        boolean __ret = __obj.isGroupWrite(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___isWorldRead(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        boolean __ret = __obj.isWorldRead(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___isWorldAnnotate(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        boolean __ret = __obj.isWorldAnnotate(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___isWorldWrite(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        __inS.readEmptyParams();
        boolean __ret = __obj.isWorldWrite(__current);
        IceInternal.BasicStream __os = __inS.__startWriteParams(Ice.FormatType.DefaultFormat);
        __os.writeBool(__ret);
        __inS.__endWriteParams(true);
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___setUserRead(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean value;
        value = __is.readBool();
        __inS.endReadParams();
        __obj.setUserRead(value, __current);
        __inS.__writeEmptyParams();
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___setUserAnnotate(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean value;
        value = __is.readBool();
        __inS.endReadParams();
        __obj.setUserAnnotate(value, __current);
        __inS.__writeEmptyParams();
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___setUserWrite(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean value;
        value = __is.readBool();
        __inS.endReadParams();
        __obj.setUserWrite(value, __current);
        __inS.__writeEmptyParams();
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___setGroupRead(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean value;
        value = __is.readBool();
        __inS.endReadParams();
        __obj.setGroupRead(value, __current);
        __inS.__writeEmptyParams();
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___setGroupAnnotate(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean value;
        value = __is.readBool();
        __inS.endReadParams();
        __obj.setGroupAnnotate(value, __current);
        __inS.__writeEmptyParams();
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___setGroupWrite(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean value;
        value = __is.readBool();
        __inS.endReadParams();
        __obj.setGroupWrite(value, __current);
        __inS.__writeEmptyParams();
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___setWorldRead(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean value;
        value = __is.readBool();
        __inS.endReadParams();
        __obj.setWorldRead(value, __current);
        __inS.__writeEmptyParams();
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___setWorldAnnotate(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean value;
        value = __is.readBool();
        __inS.endReadParams();
        __obj.setWorldAnnotate(value, __current);
        __inS.__writeEmptyParams();
        return Ice.DispatchStatus.DispatchOK;
    }

    public static Ice.DispatchStatus ___setWorldWrite(Permissions __obj, IceInternal.Incoming __inS, Ice.Current __current)
    {
        __checkMode(Ice.OperationMode.Normal, __current.mode);
        IceInternal.BasicStream __is = __inS.startReadParams();
        boolean value;
        value = __is.readBool();
        __inS.endReadParams();
        __obj.setWorldWrite(value, __current);
        __inS.__writeEmptyParams();
        return Ice.DispatchStatus.DispatchOK;
    }

    private final static String[] __all =
    {
        "canAnnotate",
        "canDelete",
        "canEdit",
        "canLink",
        "getPerm1",
        "ice_id",
        "ice_ids",
        "ice_isA",
        "ice_ping",
        "isDisallow",
        "isGroupAnnotate",
        "isGroupRead",
        "isGroupWrite",
        "isRestricted",
        "isUserAnnotate",
        "isUserRead",
        "isUserWrite",
        "isWorldAnnotate",
        "isWorldRead",
        "isWorldWrite",
        "setGroupAnnotate",
        "setGroupRead",
        "setGroupWrite",
        "setPerm1",
        "setUserAnnotate",
        "setUserRead",
        "setUserWrite",
        "setWorldAnnotate",
        "setWorldRead",
        "setWorldWrite"
    };

    public Ice.DispatchStatus __dispatch(IceInternal.Incoming in, Ice.Current __current)
    {
        int pos = java.util.Arrays.binarySearch(__all, __current.operation);
        if(pos < 0)
        {
            throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
        }

        switch(pos)
        {
            case 0:
            {
                return ___canAnnotate(this, in, __current);
            }
            case 1:
            {
                return ___canDelete(this, in, __current);
            }
            case 2:
            {
                return ___canEdit(this, in, __current);
            }
            case 3:
            {
                return ___canLink(this, in, __current);
            }
            case 4:
            {
                return ___getPerm1(this, in, __current);
            }
            case 5:
            {
                return ___ice_id(this, in, __current);
            }
            case 6:
            {
                return ___ice_ids(this, in, __current);
            }
            case 7:
            {
                return ___ice_isA(this, in, __current);
            }
            case 8:
            {
                return ___ice_ping(this, in, __current);
            }
            case 9:
            {
                return ___isDisallow(this, in, __current);
            }
            case 10:
            {
                return ___isGroupAnnotate(this, in, __current);
            }
            case 11:
            {
                return ___isGroupRead(this, in, __current);
            }
            case 12:
            {
                return ___isGroupWrite(this, in, __current);
            }
            case 13:
            {
                return ___isRestricted(this, in, __current);
            }
            case 14:
            {
                return ___isUserAnnotate(this, in, __current);
            }
            case 15:
            {
                return ___isUserRead(this, in, __current);
            }
            case 16:
            {
                return ___isUserWrite(this, in, __current);
            }
            case 17:
            {
                return ___isWorldAnnotate(this, in, __current);
            }
            case 18:
            {
                return ___isWorldRead(this, in, __current);
            }
            case 19:
            {
                return ___isWorldWrite(this, in, __current);
            }
            case 20:
            {
                return ___setGroupAnnotate(this, in, __current);
            }
            case 21:
            {
                return ___setGroupRead(this, in, __current);
            }
            case 22:
            {
                return ___setGroupWrite(this, in, __current);
            }
            case 23:
            {
                return ___setPerm1(this, in, __current);
            }
            case 24:
            {
                return ___setUserAnnotate(this, in, __current);
            }
            case 25:
            {
                return ___setUserRead(this, in, __current);
            }
            case 26:
            {
                return ___setUserWrite(this, in, __current);
            }
            case 27:
            {
                return ___setWorldAnnotate(this, in, __current);
            }
            case 28:
            {
                return ___setWorldRead(this, in, __current);
            }
            case 29:
            {
                return ___setWorldWrite(this, in, __current);
            }
        }

        assert(false);
        throw new Ice.OperationNotExistException(__current.id, __current.facet, __current.operation);
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        omero.api.BoolArrayHelper.write(__os, restrictions);
        omero.api.StringSetHelper.write(__os, extendedRestrictions);
        __os.writeLong(perm1);
        __os.endWriteSlice();
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        restrictions = omero.api.BoolArrayHelper.read(__is);
        extendedRestrictions = omero.api.StringSetHelper.read(__is);
        perm1 = __is.readLong();
        __is.endReadSlice();
    }

    /**
     * Restrictions placed on the current object for the current
     * user. Indexes into this array are based on constants
     * in the {@link omero.constants.permissions} module. If a
     * restriction index is not present, then it is safe to
     * assume that there is no such restriction.
     * 
     * If null, this should be assumed to have no restrictions.
     **/
    protected boolean[] restrictions;

    /**
     * Further restrictions which are specified by services
     * at runtime. Individual service methods will specify
     * which strings MAY NOT be present in this field for
     * execution to be successful. For example, if an
     * {@link omero.model.Image} contains a ""DOWNLOAD"" restriction,
     * then an attempt to call {@link omero.api.RawFileStore#read}
     * will fail with an {@link omero.SecurityViolation}.
     **/
    protected java.util.List<String> extendedRestrictions;

    /**
     * Internal representation. May change!
     * To make working with this object more straight-forward
     * accessors are provided for the perm1 instance though it
     * is protected, though NO GUARANTEES are made on the
     * representation.
     **/
    protected long perm1;

    public static final long serialVersionUID = 3520806921619299399L;
}
