// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Permissions.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.model;

/**
 * Row-level permissions definition available on
 * every OMERO.blitz type. Represents a similar
 * logic to the Unix filesystem.
 **/
public final class PermissionsPrxHelper extends Ice.ObjectPrxHelperBase implements PermissionsPrx
{
    private static final String __canAnnotate_name = "canAnnotate";

    /**
     * Whether the current user has permissions
     * for annotating this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     **/
    public boolean canAnnotate()
    {
        return canAnnotate(null, false);
    }

    /**
     * Whether the current user has permissions
     * for annotating this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean canAnnotate(java.util.Map<String, String> __ctx)
    {
        return canAnnotate(__ctx, true);
    }

    private boolean canAnnotate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "canAnnotate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("canAnnotate");
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    return __del.canAnnotate(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Whether the current user has permissions
     * for annotating this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_canAnnotate()
    {
        return begin_canAnnotate(null, false, null);
    }

    /**
     * Whether the current user has permissions
     * for annotating this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_canAnnotate(java.util.Map<String, String> __ctx)
    {
        return begin_canAnnotate(__ctx, true, null);
    }

    /**
     * Whether the current user has permissions
     * for annotating this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_canAnnotate(Ice.Callback __cb)
    {
        return begin_canAnnotate(null, false, __cb);
    }

    /**
     * Whether the current user has permissions
     * for annotating this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_canAnnotate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_canAnnotate(__ctx, true, __cb);
    }

    /**
     * Whether the current user has permissions
     * for annotating this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_canAnnotate(Callback_Permissions_canAnnotate __cb)
    {
        return begin_canAnnotate(null, false, __cb);
    }

    /**
     * Whether the current user has permissions
     * for annotating this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_canAnnotate(java.util.Map<String, String> __ctx, Callback_Permissions_canAnnotate __cb)
    {
        return begin_canAnnotate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_canAnnotate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__canAnnotate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __canAnnotate_name, __cb);
        try
        {
            __result.__prepare(__canAnnotate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_canAnnotate(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __canAnnotate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __canDelete_name = "canDelete";

    /**
     * Whether the current user has the ""delete"" permissions
     * for this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     **/
    public boolean canDelete()
    {
        return canDelete(null, false);
    }

    /**
     * Whether the current user has the ""delete"" permissions
     * for this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean canDelete(java.util.Map<String, String> __ctx)
    {
        return canDelete(__ctx, true);
    }

    private boolean canDelete(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "canDelete", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("canDelete");
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    return __del.canDelete(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Whether the current user has the ""delete"" permissions
     * for this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_canDelete()
    {
        return begin_canDelete(null, false, null);
    }

    /**
     * Whether the current user has the ""delete"" permissions
     * for this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_canDelete(java.util.Map<String, String> __ctx)
    {
        return begin_canDelete(__ctx, true, null);
    }

    /**
     * Whether the current user has the ""delete"" permissions
     * for this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_canDelete(Ice.Callback __cb)
    {
        return begin_canDelete(null, false, __cb);
    }

    /**
     * Whether the current user has the ""delete"" permissions
     * for this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_canDelete(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_canDelete(__ctx, true, __cb);
    }

    /**
     * Whether the current user has the ""delete"" permissions
     * for this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_canDelete(Callback_Permissions_canDelete __cb)
    {
        return begin_canDelete(null, false, __cb);
    }

    /**
     * Whether the current user has the ""delete"" permissions
     * for this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_canDelete(java.util.Map<String, String> __ctx, Callback_Permissions_canDelete __cb)
    {
        return begin_canDelete(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_canDelete(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__canDelete_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __canDelete_name, __cb);
        try
        {
            __result.__prepare(__canDelete_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_canDelete(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __canDelete_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __canEdit_name = "canEdit";

    /**
     * Whether the current user has the ""edit"" permissions
     * for this object. This includes changing the values
     * of the object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     **/
    public boolean canEdit()
    {
        return canEdit(null, false);
    }

    /**
     * Whether the current user has the ""edit"" permissions
     * for this object. This includes changing the values
     * of the object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean canEdit(java.util.Map<String, String> __ctx)
    {
        return canEdit(__ctx, true);
    }

    private boolean canEdit(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "canEdit", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("canEdit");
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    return __del.canEdit(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Whether the current user has the ""edit"" permissions
     * for this object. This includes changing the values
     * of the object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_canEdit()
    {
        return begin_canEdit(null, false, null);
    }

    /**
     * Whether the current user has the ""edit"" permissions
     * for this object. This includes changing the values
     * of the object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_canEdit(java.util.Map<String, String> __ctx)
    {
        return begin_canEdit(__ctx, true, null);
    }

    /**
     * Whether the current user has the ""edit"" permissions
     * for this object. This includes changing the values
     * of the object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_canEdit(Ice.Callback __cb)
    {
        return begin_canEdit(null, false, __cb);
    }

    /**
     * Whether the current user has the ""edit"" permissions
     * for this object. This includes changing the values
     * of the object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_canEdit(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_canEdit(__ctx, true, __cb);
    }

    /**
     * Whether the current user has the ""edit"" permissions
     * for this object. This includes changing the values
     * of the object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_canEdit(Callback_Permissions_canEdit __cb)
    {
        return begin_canEdit(null, false, __cb);
    }

    /**
     * Whether the current user has the ""edit"" permissions
     * for this object. This includes changing the values
     * of the object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_canEdit(java.util.Map<String, String> __ctx, Callback_Permissions_canEdit __cb)
    {
        return begin_canEdit(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_canEdit(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__canEdit_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __canEdit_name, __cb);
        try
        {
            __result.__prepare(__canEdit_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_canEdit(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __canEdit_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __canLink_name = "canLink";

    /**
     * Whether the current user has the ""link"" permissions
     * for this object. This includes adding it to data graphs.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     **/
    public boolean canLink()
    {
        return canLink(null, false);
    }

    /**
     * Whether the current user has the ""link"" permissions
     * for this object. This includes adding it to data graphs.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean canLink(java.util.Map<String, String> __ctx)
    {
        return canLink(__ctx, true);
    }

    private boolean canLink(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "canLink", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("canLink");
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    return __del.canLink(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Whether the current user has the ""link"" permissions
     * for this object. This includes adding it to data graphs.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_canLink()
    {
        return begin_canLink(null, false, null);
    }

    /**
     * Whether the current user has the ""link"" permissions
     * for this object. This includes adding it to data graphs.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_canLink(java.util.Map<String, String> __ctx)
    {
        return begin_canLink(__ctx, true, null);
    }

    /**
     * Whether the current user has the ""link"" permissions
     * for this object. This includes adding it to data graphs.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_canLink(Ice.Callback __cb)
    {
        return begin_canLink(null, false, __cb);
    }

    /**
     * Whether the current user has the ""link"" permissions
     * for this object. This includes adding it to data graphs.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_canLink(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_canLink(__ctx, true, __cb);
    }

    /**
     * Whether the current user has the ""link"" permissions
     * for this object. This includes adding it to data graphs.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_canLink(Callback_Permissions_canLink __cb)
    {
        return begin_canLink(null, false, __cb);
    }

    /**
     * Whether the current user has the ""link"" permissions
     * for this object. This includes adding it to data graphs.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_canLink(java.util.Map<String, String> __ctx, Callback_Permissions_canLink __cb)
    {
        return begin_canLink(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_canLink(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__canLink_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __canLink_name, __cb);
        try
        {
            __result.__prepare(__canLink_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_canLink(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __canLink_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __getPerm1_name = "getPerm1";

    /**
     * Do not use!
     **/
    public long getPerm1()
    {
        return getPerm1(null, false);
    }

    /**
     * Do not use!
     * @param __ctx The Context map to send with the invocation.
     **/
    public long getPerm1(java.util.Map<String, String> __ctx)
    {
        return getPerm1(__ctx, true);
    }

    private long getPerm1(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getPerm1", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getPerm1");
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    return __del.getPerm1(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Do not use!
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getPerm1()
    {
        return begin_getPerm1(null, false, null);
    }

    /**
     * Do not use!
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPerm1(java.util.Map<String, String> __ctx)
    {
        return begin_getPerm1(__ctx, true, null);
    }

    /**
     * Do not use!
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getPerm1(Ice.Callback __cb)
    {
        return begin_getPerm1(null, false, __cb);
    }

    /**
     * Do not use!
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPerm1(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getPerm1(__ctx, true, __cb);
    }

    /**
     * Do not use!
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getPerm1(Callback_Permissions_getPerm1 __cb)
    {
        return begin_getPerm1(null, false, __cb);
    }

    /**
     * Do not use!
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPerm1(java.util.Map<String, String> __ctx, Callback_Permissions_getPerm1 __cb)
    {
        return begin_getPerm1(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getPerm1(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getPerm1_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getPerm1_name, __cb);
        try
        {
            __result.__prepare(__getPerm1_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public long end_getPerm1(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __getPerm1_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __isDisallow_name = "isDisallow";

    /**
     * The basis for the other canX() methods. If the restriction
     * at the given offset in the restriction array is true, then
     * this method returns true (otherwise false) and the canX()
     * methods return the opposite, i.e.
     * 
     * isDisallow(ANNOTATERESTRICTION) == ! canAnnotate()
     * 
     **/
    public boolean isDisallow(int restriction)
    {
        return isDisallow(restriction, null, false);
    }

    /**
     * The basis for the other canX() methods. If the restriction
     * at the given offset in the restriction array is true, then
     * this method returns true (otherwise false) and the canX()
     * methods return the opposite, i.e.
     * 
     * isDisallow(ANNOTATERESTRICTION) == ! canAnnotate()
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isDisallow(int restriction, java.util.Map<String, String> __ctx)
    {
        return isDisallow(restriction, __ctx, true);
    }

    private boolean isDisallow(int restriction, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isDisallow", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isDisallow");
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    return __del.isDisallow(restriction, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * The basis for the other canX() methods. If the restriction
     * at the given offset in the restriction array is true, then
     * this method returns true (otherwise false) and the canX()
     * methods return the opposite, i.e.
     * 
     * isDisallow(ANNOTATERESTRICTION) == ! canAnnotate()
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isDisallow(int restriction)
    {
        return begin_isDisallow(restriction, null, false, null);
    }

    /**
     * The basis for the other canX() methods. If the restriction
     * at the given offset in the restriction array is true, then
     * this method returns true (otherwise false) and the canX()
     * methods return the opposite, i.e.
     * 
     * isDisallow(ANNOTATERESTRICTION) == ! canAnnotate()
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isDisallow(int restriction, java.util.Map<String, String> __ctx)
    {
        return begin_isDisallow(restriction, __ctx, true, null);
    }

    /**
     * The basis for the other canX() methods. If the restriction
     * at the given offset in the restriction array is true, then
     * this method returns true (otherwise false) and the canX()
     * methods return the opposite, i.e.
     * 
     * isDisallow(ANNOTATERESTRICTION) == ! canAnnotate()
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isDisallow(int restriction, Ice.Callback __cb)
    {
        return begin_isDisallow(restriction, null, false, __cb);
    }

    /**
     * The basis for the other canX() methods. If the restriction
     * at the given offset in the restriction array is true, then
     * this method returns true (otherwise false) and the canX()
     * methods return the opposite, i.e.
     * 
     * isDisallow(ANNOTATERESTRICTION) == ! canAnnotate()
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isDisallow(int restriction, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isDisallow(restriction, __ctx, true, __cb);
    }

    /**
     * The basis for the other canX() methods. If the restriction
     * at the given offset in the restriction array is true, then
     * this method returns true (otherwise false) and the canX()
     * methods return the opposite, i.e.
     * 
     * isDisallow(ANNOTATERESTRICTION) == ! canAnnotate()
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isDisallow(int restriction, Callback_Permissions_isDisallow __cb)
    {
        return begin_isDisallow(restriction, null, false, __cb);
    }

    /**
     * The basis for the other canX() methods. If the restriction
     * at the given offset in the restriction array is true, then
     * this method returns true (otherwise false) and the canX()
     * methods return the opposite, i.e.
     * 
     * isDisallow(ANNOTATERESTRICTION) == ! canAnnotate()
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isDisallow(int restriction, java.util.Map<String, String> __ctx, Callback_Permissions_isDisallow __cb)
    {
        return begin_isDisallow(restriction, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isDisallow(int restriction, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isDisallow_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isDisallow_name, __cb);
        try
        {
            __result.__prepare(__isDisallow_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(restriction);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_isDisallow(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __isDisallow_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __isGroupAnnotate_name = "isGroupAnnotate";

    public boolean isGroupAnnotate()
    {
        return isGroupAnnotate(null, false);
    }

    public boolean isGroupAnnotate(java.util.Map<String, String> __ctx)
    {
        return isGroupAnnotate(__ctx, true);
    }

    private boolean isGroupAnnotate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isGroupAnnotate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isGroupAnnotate");
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    return __del.isGroupAnnotate(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_isGroupAnnotate()
    {
        return begin_isGroupAnnotate(null, false, null);
    }

    public Ice.AsyncResult begin_isGroupAnnotate(java.util.Map<String, String> __ctx)
    {
        return begin_isGroupAnnotate(__ctx, true, null);
    }

    public Ice.AsyncResult begin_isGroupAnnotate(Ice.Callback __cb)
    {
        return begin_isGroupAnnotate(null, false, __cb);
    }

    public Ice.AsyncResult begin_isGroupAnnotate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isGroupAnnotate(__ctx, true, __cb);
    }

    public Ice.AsyncResult begin_isGroupAnnotate(Callback_Permissions_isGroupAnnotate __cb)
    {
        return begin_isGroupAnnotate(null, false, __cb);
    }

    public Ice.AsyncResult begin_isGroupAnnotate(java.util.Map<String, String> __ctx, Callback_Permissions_isGroupAnnotate __cb)
    {
        return begin_isGroupAnnotate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isGroupAnnotate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isGroupAnnotate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isGroupAnnotate_name, __cb);
        try
        {
            __result.__prepare(__isGroupAnnotate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public boolean end_isGroupAnnotate(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __isGroupAnnotate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __isGroupRead_name = "isGroupRead";

    public boolean isGroupRead()
    {
        return isGroupRead(null, false);
    }

    public boolean isGroupRead(java.util.Map<String, String> __ctx)
    {
        return isGroupRead(__ctx, true);
    }

    private boolean isGroupRead(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isGroupRead", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isGroupRead");
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    return __del.isGroupRead(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_isGroupRead()
    {
        return begin_isGroupRead(null, false, null);
    }

    public Ice.AsyncResult begin_isGroupRead(java.util.Map<String, String> __ctx)
    {
        return begin_isGroupRead(__ctx, true, null);
    }

    public Ice.AsyncResult begin_isGroupRead(Ice.Callback __cb)
    {
        return begin_isGroupRead(null, false, __cb);
    }

    public Ice.AsyncResult begin_isGroupRead(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isGroupRead(__ctx, true, __cb);
    }

    public Ice.AsyncResult begin_isGroupRead(Callback_Permissions_isGroupRead __cb)
    {
        return begin_isGroupRead(null, false, __cb);
    }

    public Ice.AsyncResult begin_isGroupRead(java.util.Map<String, String> __ctx, Callback_Permissions_isGroupRead __cb)
    {
        return begin_isGroupRead(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isGroupRead(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isGroupRead_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isGroupRead_name, __cb);
        try
        {
            __result.__prepare(__isGroupRead_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public boolean end_isGroupRead(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __isGroupRead_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __isGroupWrite_name = "isGroupWrite";

    public boolean isGroupWrite()
    {
        return isGroupWrite(null, false);
    }

    public boolean isGroupWrite(java.util.Map<String, String> __ctx)
    {
        return isGroupWrite(__ctx, true);
    }

    private boolean isGroupWrite(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isGroupWrite", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isGroupWrite");
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    return __del.isGroupWrite(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_isGroupWrite()
    {
        return begin_isGroupWrite(null, false, null);
    }

    public Ice.AsyncResult begin_isGroupWrite(java.util.Map<String, String> __ctx)
    {
        return begin_isGroupWrite(__ctx, true, null);
    }

    public Ice.AsyncResult begin_isGroupWrite(Ice.Callback __cb)
    {
        return begin_isGroupWrite(null, false, __cb);
    }

    public Ice.AsyncResult begin_isGroupWrite(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isGroupWrite(__ctx, true, __cb);
    }

    public Ice.AsyncResult begin_isGroupWrite(Callback_Permissions_isGroupWrite __cb)
    {
        return begin_isGroupWrite(null, false, __cb);
    }

    public Ice.AsyncResult begin_isGroupWrite(java.util.Map<String, String> __ctx, Callback_Permissions_isGroupWrite __cb)
    {
        return begin_isGroupWrite(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isGroupWrite(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isGroupWrite_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isGroupWrite_name, __cb);
        try
        {
            __result.__prepare(__isGroupWrite_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public boolean end_isGroupWrite(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __isGroupWrite_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __isRestricted_name = "isRestricted";

    /**
     * Returns true if the given argument is present in the
     * extendedRestrictions set. This implies that some
     * service-specific behavior is disallowed.
     **/
    public boolean isRestricted(String restriction)
    {
        return isRestricted(restriction, null, false);
    }

    /**
     * Returns true if the given argument is present in the
     * extendedRestrictions set. This implies that some
     * service-specific behavior is disallowed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isRestricted(String restriction, java.util.Map<String, String> __ctx)
    {
        return isRestricted(restriction, __ctx, true);
    }

    private boolean isRestricted(String restriction, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isRestricted", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isRestricted");
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    return __del.isRestricted(restriction, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns true if the given argument is present in the
     * extendedRestrictions set. This implies that some
     * service-specific behavior is disallowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isRestricted(String restriction)
    {
        return begin_isRestricted(restriction, null, false, null);
    }

    /**
     * Returns true if the given argument is present in the
     * extendedRestrictions set. This implies that some
     * service-specific behavior is disallowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isRestricted(String restriction, java.util.Map<String, String> __ctx)
    {
        return begin_isRestricted(restriction, __ctx, true, null);
    }

    /**
     * Returns true if the given argument is present in the
     * extendedRestrictions set. This implies that some
     * service-specific behavior is disallowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isRestricted(String restriction, Ice.Callback __cb)
    {
        return begin_isRestricted(restriction, null, false, __cb);
    }

    /**
     * Returns true if the given argument is present in the
     * extendedRestrictions set. This implies that some
     * service-specific behavior is disallowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isRestricted(String restriction, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isRestricted(restriction, __ctx, true, __cb);
    }

    /**
     * Returns true if the given argument is present in the
     * extendedRestrictions set. This implies that some
     * service-specific behavior is disallowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isRestricted(String restriction, Callback_Permissions_isRestricted __cb)
    {
        return begin_isRestricted(restriction, null, false, __cb);
    }

    /**
     * Returns true if the given argument is present in the
     * extendedRestrictions set. This implies that some
     * service-specific behavior is disallowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isRestricted(String restriction, java.util.Map<String, String> __ctx, Callback_Permissions_isRestricted __cb)
    {
        return begin_isRestricted(restriction, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isRestricted(String restriction, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isRestricted_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isRestricted_name, __cb);
        try
        {
            __result.__prepare(__isRestricted_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(restriction);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_isRestricted(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __isRestricted_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __isUserAnnotate_name = "isUserAnnotate";

    public boolean isUserAnnotate()
    {
        return isUserAnnotate(null, false);
    }

    public boolean isUserAnnotate(java.util.Map<String, String> __ctx)
    {
        return isUserAnnotate(__ctx, true);
    }

    private boolean isUserAnnotate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isUserAnnotate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isUserAnnotate");
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    return __del.isUserAnnotate(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_isUserAnnotate()
    {
        return begin_isUserAnnotate(null, false, null);
    }

    public Ice.AsyncResult begin_isUserAnnotate(java.util.Map<String, String> __ctx)
    {
        return begin_isUserAnnotate(__ctx, true, null);
    }

    public Ice.AsyncResult begin_isUserAnnotate(Ice.Callback __cb)
    {
        return begin_isUserAnnotate(null, false, __cb);
    }

    public Ice.AsyncResult begin_isUserAnnotate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isUserAnnotate(__ctx, true, __cb);
    }

    public Ice.AsyncResult begin_isUserAnnotate(Callback_Permissions_isUserAnnotate __cb)
    {
        return begin_isUserAnnotate(null, false, __cb);
    }

    public Ice.AsyncResult begin_isUserAnnotate(java.util.Map<String, String> __ctx, Callback_Permissions_isUserAnnotate __cb)
    {
        return begin_isUserAnnotate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isUserAnnotate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isUserAnnotate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isUserAnnotate_name, __cb);
        try
        {
            __result.__prepare(__isUserAnnotate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public boolean end_isUserAnnotate(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __isUserAnnotate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __isUserRead_name = "isUserRead";

    public boolean isUserRead()
    {
        return isUserRead(null, false);
    }

    public boolean isUserRead(java.util.Map<String, String> __ctx)
    {
        return isUserRead(__ctx, true);
    }

    private boolean isUserRead(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isUserRead", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isUserRead");
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    return __del.isUserRead(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_isUserRead()
    {
        return begin_isUserRead(null, false, null);
    }

    public Ice.AsyncResult begin_isUserRead(java.util.Map<String, String> __ctx)
    {
        return begin_isUserRead(__ctx, true, null);
    }

    public Ice.AsyncResult begin_isUserRead(Ice.Callback __cb)
    {
        return begin_isUserRead(null, false, __cb);
    }

    public Ice.AsyncResult begin_isUserRead(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isUserRead(__ctx, true, __cb);
    }

    public Ice.AsyncResult begin_isUserRead(Callback_Permissions_isUserRead __cb)
    {
        return begin_isUserRead(null, false, __cb);
    }

    public Ice.AsyncResult begin_isUserRead(java.util.Map<String, String> __ctx, Callback_Permissions_isUserRead __cb)
    {
        return begin_isUserRead(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isUserRead(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isUserRead_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isUserRead_name, __cb);
        try
        {
            __result.__prepare(__isUserRead_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public boolean end_isUserRead(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __isUserRead_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __isUserWrite_name = "isUserWrite";

    public boolean isUserWrite()
    {
        return isUserWrite(null, false);
    }

    public boolean isUserWrite(java.util.Map<String, String> __ctx)
    {
        return isUserWrite(__ctx, true);
    }

    private boolean isUserWrite(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isUserWrite", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isUserWrite");
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    return __del.isUserWrite(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_isUserWrite()
    {
        return begin_isUserWrite(null, false, null);
    }

    public Ice.AsyncResult begin_isUserWrite(java.util.Map<String, String> __ctx)
    {
        return begin_isUserWrite(__ctx, true, null);
    }

    public Ice.AsyncResult begin_isUserWrite(Ice.Callback __cb)
    {
        return begin_isUserWrite(null, false, __cb);
    }

    public Ice.AsyncResult begin_isUserWrite(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isUserWrite(__ctx, true, __cb);
    }

    public Ice.AsyncResult begin_isUserWrite(Callback_Permissions_isUserWrite __cb)
    {
        return begin_isUserWrite(null, false, __cb);
    }

    public Ice.AsyncResult begin_isUserWrite(java.util.Map<String, String> __ctx, Callback_Permissions_isUserWrite __cb)
    {
        return begin_isUserWrite(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isUserWrite(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isUserWrite_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isUserWrite_name, __cb);
        try
        {
            __result.__prepare(__isUserWrite_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public boolean end_isUserWrite(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __isUserWrite_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __isWorldAnnotate_name = "isWorldAnnotate";

    public boolean isWorldAnnotate()
    {
        return isWorldAnnotate(null, false);
    }

    public boolean isWorldAnnotate(java.util.Map<String, String> __ctx)
    {
        return isWorldAnnotate(__ctx, true);
    }

    private boolean isWorldAnnotate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isWorldAnnotate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isWorldAnnotate");
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    return __del.isWorldAnnotate(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_isWorldAnnotate()
    {
        return begin_isWorldAnnotate(null, false, null);
    }

    public Ice.AsyncResult begin_isWorldAnnotate(java.util.Map<String, String> __ctx)
    {
        return begin_isWorldAnnotate(__ctx, true, null);
    }

    public Ice.AsyncResult begin_isWorldAnnotate(Ice.Callback __cb)
    {
        return begin_isWorldAnnotate(null, false, __cb);
    }

    public Ice.AsyncResult begin_isWorldAnnotate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isWorldAnnotate(__ctx, true, __cb);
    }

    public Ice.AsyncResult begin_isWorldAnnotate(Callback_Permissions_isWorldAnnotate __cb)
    {
        return begin_isWorldAnnotate(null, false, __cb);
    }

    public Ice.AsyncResult begin_isWorldAnnotate(java.util.Map<String, String> __ctx, Callback_Permissions_isWorldAnnotate __cb)
    {
        return begin_isWorldAnnotate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isWorldAnnotate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isWorldAnnotate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isWorldAnnotate_name, __cb);
        try
        {
            __result.__prepare(__isWorldAnnotate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public boolean end_isWorldAnnotate(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __isWorldAnnotate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __isWorldRead_name = "isWorldRead";

    public boolean isWorldRead()
    {
        return isWorldRead(null, false);
    }

    public boolean isWorldRead(java.util.Map<String, String> __ctx)
    {
        return isWorldRead(__ctx, true);
    }

    private boolean isWorldRead(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isWorldRead", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isWorldRead");
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    return __del.isWorldRead(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_isWorldRead()
    {
        return begin_isWorldRead(null, false, null);
    }

    public Ice.AsyncResult begin_isWorldRead(java.util.Map<String, String> __ctx)
    {
        return begin_isWorldRead(__ctx, true, null);
    }

    public Ice.AsyncResult begin_isWorldRead(Ice.Callback __cb)
    {
        return begin_isWorldRead(null, false, __cb);
    }

    public Ice.AsyncResult begin_isWorldRead(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isWorldRead(__ctx, true, __cb);
    }

    public Ice.AsyncResult begin_isWorldRead(Callback_Permissions_isWorldRead __cb)
    {
        return begin_isWorldRead(null, false, __cb);
    }

    public Ice.AsyncResult begin_isWorldRead(java.util.Map<String, String> __ctx, Callback_Permissions_isWorldRead __cb)
    {
        return begin_isWorldRead(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isWorldRead(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isWorldRead_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isWorldRead_name, __cb);
        try
        {
            __result.__prepare(__isWorldRead_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public boolean end_isWorldRead(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __isWorldRead_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __isWorldWrite_name = "isWorldWrite";

    public boolean isWorldWrite()
    {
        return isWorldWrite(null, false);
    }

    public boolean isWorldWrite(java.util.Map<String, String> __ctx)
    {
        return isWorldWrite(__ctx, true);
    }

    private boolean isWorldWrite(java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isWorldWrite", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isWorldWrite");
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    return __del.isWorldWrite(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_isWorldWrite()
    {
        return begin_isWorldWrite(null, false, null);
    }

    public Ice.AsyncResult begin_isWorldWrite(java.util.Map<String, String> __ctx)
    {
        return begin_isWorldWrite(__ctx, true, null);
    }

    public Ice.AsyncResult begin_isWorldWrite(Ice.Callback __cb)
    {
        return begin_isWorldWrite(null, false, __cb);
    }

    public Ice.AsyncResult begin_isWorldWrite(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isWorldWrite(__ctx, true, __cb);
    }

    public Ice.AsyncResult begin_isWorldWrite(Callback_Permissions_isWorldWrite __cb)
    {
        return begin_isWorldWrite(null, false, __cb);
    }

    public Ice.AsyncResult begin_isWorldWrite(java.util.Map<String, String> __ctx, Callback_Permissions_isWorldWrite __cb)
    {
        return begin_isWorldWrite(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isWorldWrite(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isWorldWrite_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isWorldWrite_name, __cb);
        try
        {
            __result.__prepare(__isWorldWrite_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public boolean end_isWorldWrite(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __isWorldWrite_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    private static final String __setGroupAnnotate_name = "setGroupAnnotate";

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public void setGroupAnnotate(boolean value)
    {
        setGroupAnnotate(value, null, false);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setGroupAnnotate(boolean value, java.util.Map<String, String> __ctx)
    {
        setGroupAnnotate(value, __ctx, true);
    }

    private void setGroupAnnotate(boolean value, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setGroupAnnotate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    __del.setGroupAnnotate(value, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setGroupAnnotate(boolean value)
    {
        return begin_setGroupAnnotate(value, null, false, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setGroupAnnotate(boolean value, java.util.Map<String, String> __ctx)
    {
        return begin_setGroupAnnotate(value, __ctx, true, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setGroupAnnotate(boolean value, Ice.Callback __cb)
    {
        return begin_setGroupAnnotate(value, null, false, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setGroupAnnotate(boolean value, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setGroupAnnotate(value, __ctx, true, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setGroupAnnotate(boolean value, Callback_Permissions_setGroupAnnotate __cb)
    {
        return begin_setGroupAnnotate(value, null, false, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setGroupAnnotate(boolean value, java.util.Map<String, String> __ctx, Callback_Permissions_setGroupAnnotate __cb)
    {
        return begin_setGroupAnnotate(value, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setGroupAnnotate(boolean value, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setGroupAnnotate_name, __cb);
        try
        {
            __result.__prepare(__setGroupAnnotate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(value);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setGroupAnnotate(Ice.AsyncResult __result)
    {
        __end(__result, __setGroupAnnotate_name);
    }

    private static final String __setGroupRead_name = "setGroupRead";

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public void setGroupRead(boolean value)
    {
        setGroupRead(value, null, false);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setGroupRead(boolean value, java.util.Map<String, String> __ctx)
    {
        setGroupRead(value, __ctx, true);
    }

    private void setGroupRead(boolean value, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setGroupRead", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    __del.setGroupRead(value, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setGroupRead(boolean value)
    {
        return begin_setGroupRead(value, null, false, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setGroupRead(boolean value, java.util.Map<String, String> __ctx)
    {
        return begin_setGroupRead(value, __ctx, true, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setGroupRead(boolean value, Ice.Callback __cb)
    {
        return begin_setGroupRead(value, null, false, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setGroupRead(boolean value, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setGroupRead(value, __ctx, true, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setGroupRead(boolean value, Callback_Permissions_setGroupRead __cb)
    {
        return begin_setGroupRead(value, null, false, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setGroupRead(boolean value, java.util.Map<String, String> __ctx, Callback_Permissions_setGroupRead __cb)
    {
        return begin_setGroupRead(value, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setGroupRead(boolean value, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setGroupRead_name, __cb);
        try
        {
            __result.__prepare(__setGroupRead_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(value);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setGroupRead(Ice.AsyncResult __result)
    {
        __end(__result, __setGroupRead_name);
    }

    private static final String __setGroupWrite_name = "setGroupWrite";

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public void setGroupWrite(boolean value)
    {
        setGroupWrite(value, null, false);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setGroupWrite(boolean value, java.util.Map<String, String> __ctx)
    {
        setGroupWrite(value, __ctx, true);
    }

    private void setGroupWrite(boolean value, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setGroupWrite", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    __del.setGroupWrite(value, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setGroupWrite(boolean value)
    {
        return begin_setGroupWrite(value, null, false, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setGroupWrite(boolean value, java.util.Map<String, String> __ctx)
    {
        return begin_setGroupWrite(value, __ctx, true, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setGroupWrite(boolean value, Ice.Callback __cb)
    {
        return begin_setGroupWrite(value, null, false, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setGroupWrite(boolean value, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setGroupWrite(value, __ctx, true, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setGroupWrite(boolean value, Callback_Permissions_setGroupWrite __cb)
    {
        return begin_setGroupWrite(value, null, false, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setGroupWrite(boolean value, java.util.Map<String, String> __ctx, Callback_Permissions_setGroupWrite __cb)
    {
        return begin_setGroupWrite(value, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setGroupWrite(boolean value, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setGroupWrite_name, __cb);
        try
        {
            __result.__prepare(__setGroupWrite_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(value);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setGroupWrite(Ice.AsyncResult __result)
    {
        __end(__result, __setGroupWrite_name);
    }

    private static final String __setPerm1_name = "setPerm1";

    /**
     * Do not use!
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public void setPerm1(long value)
    {
        setPerm1(value, null, false);
    }

    /**
     * Do not use!
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setPerm1(long value, java.util.Map<String, String> __ctx)
    {
        setPerm1(value, __ctx, true);
    }

    private void setPerm1(long value, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setPerm1", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    __del.setPerm1(value, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Do not use!
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setPerm1(long value)
    {
        return begin_setPerm1(value, null, false, null);
    }

    /**
     * Do not use!
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setPerm1(long value, java.util.Map<String, String> __ctx)
    {
        return begin_setPerm1(value, __ctx, true, null);
    }

    /**
     * Do not use!
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setPerm1(long value, Ice.Callback __cb)
    {
        return begin_setPerm1(value, null, false, __cb);
    }

    /**
     * Do not use!
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setPerm1(long value, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setPerm1(value, __ctx, true, __cb);
    }

    /**
     * Do not use!
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setPerm1(long value, Callback_Permissions_setPerm1 __cb)
    {
        return begin_setPerm1(value, null, false, __cb);
    }

    /**
     * Do not use!
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setPerm1(long value, java.util.Map<String, String> __ctx, Callback_Permissions_setPerm1 __cb)
    {
        return begin_setPerm1(value, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setPerm1(long value, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setPerm1_name, __cb);
        try
        {
            __result.__prepare(__setPerm1_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(value);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setPerm1(Ice.AsyncResult __result)
    {
        __end(__result, __setPerm1_name);
    }

    private static final String __setUserAnnotate_name = "setUserAnnotate";

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public void setUserAnnotate(boolean value)
    {
        setUserAnnotate(value, null, false);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setUserAnnotate(boolean value, java.util.Map<String, String> __ctx)
    {
        setUserAnnotate(value, __ctx, true);
    }

    private void setUserAnnotate(boolean value, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setUserAnnotate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    __del.setUserAnnotate(value, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setUserAnnotate(boolean value)
    {
        return begin_setUserAnnotate(value, null, false, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setUserAnnotate(boolean value, java.util.Map<String, String> __ctx)
    {
        return begin_setUserAnnotate(value, __ctx, true, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setUserAnnotate(boolean value, Ice.Callback __cb)
    {
        return begin_setUserAnnotate(value, null, false, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setUserAnnotate(boolean value, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setUserAnnotate(value, __ctx, true, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setUserAnnotate(boolean value, Callback_Permissions_setUserAnnotate __cb)
    {
        return begin_setUserAnnotate(value, null, false, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setUserAnnotate(boolean value, java.util.Map<String, String> __ctx, Callback_Permissions_setUserAnnotate __cb)
    {
        return begin_setUserAnnotate(value, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setUserAnnotate(boolean value, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setUserAnnotate_name, __cb);
        try
        {
            __result.__prepare(__setUserAnnotate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(value);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setUserAnnotate(Ice.AsyncResult __result)
    {
        __end(__result, __setUserAnnotate_name);
    }

    private static final String __setUserRead_name = "setUserRead";

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public void setUserRead(boolean value)
    {
        setUserRead(value, null, false);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setUserRead(boolean value, java.util.Map<String, String> __ctx)
    {
        setUserRead(value, __ctx, true);
    }

    private void setUserRead(boolean value, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setUserRead", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    __del.setUserRead(value, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setUserRead(boolean value)
    {
        return begin_setUserRead(value, null, false, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setUserRead(boolean value, java.util.Map<String, String> __ctx)
    {
        return begin_setUserRead(value, __ctx, true, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setUserRead(boolean value, Ice.Callback __cb)
    {
        return begin_setUserRead(value, null, false, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setUserRead(boolean value, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setUserRead(value, __ctx, true, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setUserRead(boolean value, Callback_Permissions_setUserRead __cb)
    {
        return begin_setUserRead(value, null, false, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setUserRead(boolean value, java.util.Map<String, String> __ctx, Callback_Permissions_setUserRead __cb)
    {
        return begin_setUserRead(value, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setUserRead(boolean value, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setUserRead_name, __cb);
        try
        {
            __result.__prepare(__setUserRead_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(value);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setUserRead(Ice.AsyncResult __result)
    {
        __end(__result, __setUserRead_name);
    }

    private static final String __setUserWrite_name = "setUserWrite";

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public void setUserWrite(boolean value)
    {
        setUserWrite(value, null, false);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setUserWrite(boolean value, java.util.Map<String, String> __ctx)
    {
        setUserWrite(value, __ctx, true);
    }

    private void setUserWrite(boolean value, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setUserWrite", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    __del.setUserWrite(value, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setUserWrite(boolean value)
    {
        return begin_setUserWrite(value, null, false, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setUserWrite(boolean value, java.util.Map<String, String> __ctx)
    {
        return begin_setUserWrite(value, __ctx, true, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setUserWrite(boolean value, Ice.Callback __cb)
    {
        return begin_setUserWrite(value, null, false, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setUserWrite(boolean value, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setUserWrite(value, __ctx, true, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setUserWrite(boolean value, Callback_Permissions_setUserWrite __cb)
    {
        return begin_setUserWrite(value, null, false, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setUserWrite(boolean value, java.util.Map<String, String> __ctx, Callback_Permissions_setUserWrite __cb)
    {
        return begin_setUserWrite(value, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setUserWrite(boolean value, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setUserWrite_name, __cb);
        try
        {
            __result.__prepare(__setUserWrite_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(value);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setUserWrite(Ice.AsyncResult __result)
    {
        __end(__result, __setUserWrite_name);
    }

    private static final String __setWorldAnnotate_name = "setWorldAnnotate";

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public void setWorldAnnotate(boolean value)
    {
        setWorldAnnotate(value, null, false);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setWorldAnnotate(boolean value, java.util.Map<String, String> __ctx)
    {
        setWorldAnnotate(value, __ctx, true);
    }

    private void setWorldAnnotate(boolean value, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setWorldAnnotate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    __del.setWorldAnnotate(value, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setWorldAnnotate(boolean value)
    {
        return begin_setWorldAnnotate(value, null, false, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setWorldAnnotate(boolean value, java.util.Map<String, String> __ctx)
    {
        return begin_setWorldAnnotate(value, __ctx, true, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setWorldAnnotate(boolean value, Ice.Callback __cb)
    {
        return begin_setWorldAnnotate(value, null, false, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setWorldAnnotate(boolean value, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setWorldAnnotate(value, __ctx, true, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setWorldAnnotate(boolean value, Callback_Permissions_setWorldAnnotate __cb)
    {
        return begin_setWorldAnnotate(value, null, false, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setWorldAnnotate(boolean value, java.util.Map<String, String> __ctx, Callback_Permissions_setWorldAnnotate __cb)
    {
        return begin_setWorldAnnotate(value, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setWorldAnnotate(boolean value, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setWorldAnnotate_name, __cb);
        try
        {
            __result.__prepare(__setWorldAnnotate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(value);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setWorldAnnotate(Ice.AsyncResult __result)
    {
        __end(__result, __setWorldAnnotate_name);
    }

    private static final String __setWorldRead_name = "setWorldRead";

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public void setWorldRead(boolean value)
    {
        setWorldRead(value, null, false);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setWorldRead(boolean value, java.util.Map<String, String> __ctx)
    {
        setWorldRead(value, __ctx, true);
    }

    private void setWorldRead(boolean value, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setWorldRead", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    __del.setWorldRead(value, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setWorldRead(boolean value)
    {
        return begin_setWorldRead(value, null, false, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setWorldRead(boolean value, java.util.Map<String, String> __ctx)
    {
        return begin_setWorldRead(value, __ctx, true, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setWorldRead(boolean value, Ice.Callback __cb)
    {
        return begin_setWorldRead(value, null, false, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setWorldRead(boolean value, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setWorldRead(value, __ctx, true, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setWorldRead(boolean value, Callback_Permissions_setWorldRead __cb)
    {
        return begin_setWorldRead(value, null, false, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setWorldRead(boolean value, java.util.Map<String, String> __ctx, Callback_Permissions_setWorldRead __cb)
    {
        return begin_setWorldRead(value, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setWorldRead(boolean value, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setWorldRead_name, __cb);
        try
        {
            __result.__prepare(__setWorldRead_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(value);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setWorldRead(Ice.AsyncResult __result)
    {
        __end(__result, __setWorldRead_name);
    }

    private static final String __setWorldWrite_name = "setWorldWrite";

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    public void setWorldWrite(boolean value)
    {
        setWorldWrite(value, null, false);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setWorldWrite(boolean value, java.util.Map<String, String> __ctx)
    {
        setWorldWrite(value, __ctx, true);
    }

    private void setWorldWrite(boolean value, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setWorldWrite", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _PermissionsDel __del = (_PermissionsDel)__delBase;
                    __del.setWorldWrite(value, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setWorldWrite(boolean value)
    {
        return begin_setWorldWrite(value, null, false, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setWorldWrite(boolean value, java.util.Map<String, String> __ctx)
    {
        return begin_setWorldWrite(value, __ctx, true, null);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setWorldWrite(boolean value, Ice.Callback __cb)
    {
        return begin_setWorldWrite(value, null, false, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setWorldWrite(boolean value, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setWorldWrite(value, __ctx, true, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setWorldWrite(boolean value, Callback_Permissions_setWorldWrite __cb)
    {
        return begin_setWorldWrite(value, null, false, __cb);
    }

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setWorldWrite(boolean value, java.util.Map<String, String> __ctx, Callback_Permissions_setWorldWrite __cb)
    {
        return begin_setWorldWrite(value, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setWorldWrite(boolean value, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setWorldWrite_name, __cb);
        try
        {
            __result.__prepare(__setWorldWrite_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(value);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setWorldWrite(Ice.AsyncResult __result)
    {
        __end(__result, __setWorldWrite_name);
    }

    public static PermissionsPrx checkedCast(Ice.ObjectPrx __obj)
    {
        PermissionsPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof PermissionsPrx)
            {
                __d = (PermissionsPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    PermissionsPrxHelper __h = new PermissionsPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static PermissionsPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        PermissionsPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof PermissionsPrx)
            {
                __d = (PermissionsPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    PermissionsPrxHelper __h = new PermissionsPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static PermissionsPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        PermissionsPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    PermissionsPrxHelper __h = new PermissionsPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static PermissionsPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        PermissionsPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    PermissionsPrxHelper __h = new PermissionsPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static PermissionsPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        PermissionsPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof PermissionsPrx)
            {
                __d = (PermissionsPrx)__obj;
            }
            else
            {
                PermissionsPrxHelper __h = new PermissionsPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static PermissionsPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        PermissionsPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            PermissionsPrxHelper __h = new PermissionsPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::model::Permissions"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _PermissionsDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _PermissionsDelD();
    }

    public static void __write(IceInternal.BasicStream __os, PermissionsPrx v)
    {
        __os.writeProxy(v);
    }

    public static PermissionsPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            PermissionsPrxHelper result = new PermissionsPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
