// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IObject.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.model;

/**
 * Base class of all model types. On the
 * server, the interface ome.model.IObject
 * unifies the model. In Ice, interfaces have
 * a more remote connotation.
 **/
public interface _IObjectOperations
{
    omero.RLong getId(Ice.Current __current);

    void setId(omero.RLong id, Ice.Current __current);

    Details getDetails(Ice.Current __current);

    /**
     * Return another instance of the same type as this instance
     * constructed as if by: new InstanceI( this.id.val, false );
     * @param __current The Current object for the invocation.
     **/
    IObject proxy(Ice.Current __current);

    /**
     * Return another instance of the same type as this instance
     * with all single-value entities unloaded and all members of
     * collections also unloaded.
     * @param __current The Current object for the invocation.
     **/
    IObject shallowCopy(Ice.Current __current);

    /**
     * Sets the loaded boolean to false and empties all state
     * from this entity to make sending it over the network
     * less costly.
     * @param __current The Current object for the invocation.
     **/
    void unload(Ice.Current __current);

    /**
     * Each collection can also be unloaded, independently
     * of the object itself. To unload all collections, use:
     * 
     * object.unloadCollections();
     * 
     * This is useful when it is possible that a collection no
     * longer represents the state in the database, and passing the
     * collections back to the server might delete some entities.
     * 
     * Sending back empty collections can also save a significant
     * amount of bandwidth, when working with large data graphs.
     * @param __current The Current object for the invocation.
     **/
    void unloadCollections(Ice.Current __current);

    /**
     * As with collections, the objects under details can link
     * to many other objects. Unloading the details can same
     * bandwidth and simplify the server logic.
     * @param __current The Current object for the invocation.
     **/
    void unloadDetails(Ice.Current __current);

    /**
     * Tests for unloadedness. If this value is false, then
     * any method call on this instance other than getId
     * or setId will result in an exception.
     * @param __current The Current object for the invocation.
     **/
    boolean isLoaded(Ice.Current __current);

    /**
     * Marker interface which means that special rules apply
     * for both reading and writing these instances.
     * @param __current The Current object for the invocation.
     **/
    boolean isGlobal(Ice.Current __current);

    /**
     * A link between two other types.
     * Methods provided:
     * 
     * - getParent()
     * - getChild()
     * @param __current The Current object for the invocation.
     **/
    boolean isLink(Ice.Current __current);

    /**
     * The server will persist changes made to these types.
     * Methods provided:
     * 
     * - getVersion()
     * - setVersion()
     * 
     * @param __current The Current object for the invocation.
     **/
    boolean isMutable(Ice.Current __current);

    /**
     * Allows for the attachment of any omero.model.Annotation
     * subclasses. Methods provided are:
     * 
     * - linkAnnotation(Annotation)
     * -
     * @param __current The Current object for the invocation.
     **/
    boolean isAnnotated(Ice.Current __current);
}
