// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Permissions.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.model;

/**
 * Row-level permissions definition available on
 * every OMERO.blitz type. Represents a similar
 * logic to the Unix filesystem.
 **/
public interface _PermissionsOperations
{
    /**
     * Do not use!
     * @param __current The Current object for the invocation.
     **/
    long getPerm1(Ice.Current __current);

    /**
     * Do not use!
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __current The Current object for the invocation.
     **/
    void setPerm1(long value, Ice.Current __current);

    /**
     * The basis for the other canX() methods. If the restriction
     * at the given offset in the restriction array is true, then
     * this method returns true (otherwise false) and the canX()
     * methods return the opposite, i.e.
     * 
     * isDisallow(ANNOTATERESTRICTION) == ! canAnnotate()
     * 
     * @param __current The Current object for the invocation.
     **/
    boolean isDisallow(int restriction, Ice.Current __current);

    /**
     * Returns true if the given argument is present in the
     * extendedRestrictions set. This implies that some
     * service-specific behavior is disallowed.
     * @param __current The Current object for the invocation.
     **/
    boolean isRestricted(String restriction, Ice.Current __current);

    /**
     * Whether the current user has permissions
     * for annotating this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __current The Current object for the invocation.
     **/
    boolean canAnnotate(Ice.Current __current);

    /**
     * Whether the current user has the ""edit"" permissions
     * for this object. This includes changing the values
     * of the object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __current The Current object for the invocation.
     **/
    boolean canEdit(Ice.Current __current);

    /**
     * Whether the current user has the ""link"" permissions
     * for this object. This includes adding it to data graphs.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __current The Current object for the invocation.
     **/
    boolean canLink(Ice.Current __current);

    /**
     * Whether the current user has the ""delete"" permissions
     * for this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     * @param __current The Current object for the invocation.
     **/
    boolean canDelete(Ice.Current __current);

    boolean isUserRead(Ice.Current __current);

    boolean isUserAnnotate(Ice.Current __current);

    boolean isUserWrite(Ice.Current __current);

    boolean isGroupRead(Ice.Current __current);

    boolean isGroupAnnotate(Ice.Current __current);

    boolean isGroupWrite(Ice.Current __current);

    boolean isWorldRead(Ice.Current __current);

    boolean isWorldAnnotate(Ice.Current __current);

    boolean isWorldWrite(Ice.Current __current);

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __current The Current object for the invocation.
     **/
    void setUserRead(boolean value, Ice.Current __current);

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __current The Current object for the invocation.
     **/
    void setUserAnnotate(boolean value, Ice.Current __current);

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __current The Current object for the invocation.
     **/
    void setUserWrite(boolean value, Ice.Current __current);

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __current The Current object for the invocation.
     **/
    void setGroupRead(boolean value, Ice.Current __current);

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __current The Current object for the invocation.
     **/
    void setGroupAnnotate(boolean value, Ice.Current __current);

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __current The Current object for the invocation.
     **/
    void setGroupWrite(boolean value, Ice.Current __current);

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __current The Current object for the invocation.
     **/
    void setWorldRead(boolean value, Ice.Current __current);

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __current The Current object for the invocation.
     **/
    void setWorldAnnotate(boolean value, Ice.Current __current);

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     * @param __current The Current object for the invocation.
     **/
    void setWorldWrite(boolean value, Ice.Current __current);
}
