// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Permissions.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.model;

/**
 * Row-level permissions definition available on
 * every OMERO.blitz type. Represents a similar
 * logic to the Unix filesystem.
 **/
public interface _PermissionsOperationsNC
{
    /**
     * Do not use!
     **/
    long getPerm1();

    /**
     * Do not use!
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    void setPerm1(long value);

    /**
     * The basis for the other canX() methods. If the restriction
     * at the given offset in the restriction array is true, then
     * this method returns true (otherwise false) and the canX()
     * methods return the opposite, i.e.
     * 
     * isDisallow(ANNOTATERESTRICTION) == ! canAnnotate()
     * 
     **/
    boolean isDisallow(int restriction);

    /**
     * Returns true if the given argument is present in the
     * extendedRestrictions set. This implies that some
     * service-specific behavior is disallowed.
     **/
    boolean isRestricted(String restriction);

    /**
     * Whether the current user has permissions
     * for annotating this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     **/
    boolean canAnnotate();

    /**
     * Whether the current user has the ""edit"" permissions
     * for this object. This includes changing the values
     * of the object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     **/
    boolean canEdit();

    /**
     * Whether the current user has the ""link"" permissions
     * for this object. This includes adding it to data graphs.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     **/
    boolean canLink();

    /**
     * Whether the current user has the ""delete"" permissions
     * for this object.
     * 
     * The fact that the user has this object in hand
     * already identifies that it's readable.
     **/
    boolean canDelete();

    boolean isUserRead();

    boolean isUserAnnotate();

    boolean isUserWrite();

    boolean isGroupRead();

    boolean isGroupAnnotate();

    boolean isGroupWrite();

    boolean isWorldRead();

    boolean isWorldAnnotate();

    boolean isWorldWrite();

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    void setUserRead(boolean value);

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    void setUserAnnotate(boolean value);

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    void setUserWrite(boolean value);

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    void setGroupRead(boolean value);

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    void setGroupAnnotate(boolean value);

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    void setGroupWrite(boolean value);

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    void setWorldRead(boolean value);

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    void setWorldAnnotate(boolean value);

    /**
     * Throws {@link omero.ClientError} if mutation not allowed.
     **/
    void setWorldWrite(boolean value);
}
