// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `System.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.sys;

/**
 * Provides common filters which MAY be applied to a
 * query. Check the documentation for the particular
 * method for more information on how these values will
 * be interpreted as well as default values if they
 * are missing. In general they are intended to mean:
 * 
 * unique        := similar to SQL's ""DISTINCT"" keyword
 * 
 * ownerId       := (some) objects queried should belong
 * to this user
 * 
 * groupId       := (some) objects queried should belong
 * to this group
 * 
 * preferOwner   := true implies if if ownerId and groupId
 * are both defined, use only ownerId
 * 
 * offset/limit  := represent a page which should be loaded
 * Note: servers may choose to impose a
 * maximum limit.
 * 
 * start/endTime := (some) objects queried shoud have been
 * created and/or modified within time span.
 * 
 **/
public class Filter extends Ice.ObjectImpl
{
    public Filter()
    {
    }

    public Filter(omero.RBool unique, omero.RLong ownerId, omero.RLong groupId, omero.RInt offset, omero.RInt limit, omero.RTime startTime, omero.RTime endTime)
    {
        this.unique = unique;
        this.ownerId = ownerId;
        this.groupId = groupId;
        this.offset = offset;
        this.limit = limit;
        this.startTime = startTime;
        this.endTime = endTime;
    }

    private static class __F implements Ice.ObjectFactory
    {
        public Ice.Object create(String type)
        {
            assert(type.equals(ice_staticId()));
            return new Filter();
        }

        public void destroy()
        {
        }
    }
    private static Ice.ObjectFactory _factory = new __F();

    public static Ice.ObjectFactory
    ice_factory()
    {
        return _factory;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::sys::Filter"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current __current)
    {
        return java.util.Arrays.binarySearch(__ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return __ids;
    }

    public String[] ice_ids(Ice.Current __current)
    {
        return __ids;
    }

    public String ice_id()
    {
        return __ids[1];
    }

    public String ice_id(Ice.Current __current)
    {
        return __ids[1];
    }

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected void __writeImpl(IceInternal.BasicStream __os)
    {
        __os.startWriteSlice(ice_staticId(), -1, true);
        __os.writeObject(unique);
        __os.writeObject(ownerId);
        __os.writeObject(groupId);
        __os.writeObject(offset);
        __os.writeObject(limit);
        __os.writeObject(startTime);
        __os.writeObject(endTime);
        __os.endWriteSlice();
    }

    private class Patcher implements IceInternal.Patcher
    {
        Patcher(int member)
        {
            __member = member;
        }

        public void
        patch(Ice.Object v)
        {
            switch(__member)
            {
            case 0:
                __typeId = "::omero::RBool";
                if(v == null || v instanceof omero.RBool)
                {
                    unique = (omero.RBool)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            case 1:
                __typeId = "::omero::RLong";
                if(v == null || v instanceof omero.RLong)
                {
                    ownerId = (omero.RLong)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            case 2:
                __typeId = "::omero::RLong";
                if(v == null || v instanceof omero.RLong)
                {
                    groupId = (omero.RLong)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            case 3:
                __typeId = "::omero::RInt";
                if(v == null || v instanceof omero.RInt)
                {
                    offset = (omero.RInt)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            case 4:
                __typeId = "::omero::RInt";
                if(v == null || v instanceof omero.RInt)
                {
                    limit = (omero.RInt)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            case 5:
                __typeId = "::omero::RTime";
                if(v == null || v instanceof omero.RTime)
                {
                    startTime = (omero.RTime)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            case 6:
                __typeId = "::omero::RTime";
                if(v == null || v instanceof omero.RTime)
                {
                    endTime = (omero.RTime)v;
                }
                else
                {
                    IceInternal.Ex.throwUOE(type(), v);
                }
                break;
            }
        }

        public String
        type()
        {
            return __typeId;
        }

        private int __member;
        private String __typeId;
    }

    protected void __readImpl(IceInternal.BasicStream __is)
    {
        __is.startReadSlice();
        __is.readObject(new Patcher(0));
        __is.readObject(new Patcher(1));
        __is.readObject(new Patcher(2));
        __is.readObject(new Patcher(3));
        __is.readObject(new Patcher(4));
        __is.readObject(new Patcher(5));
        __is.readObject(new Patcher(6));
        __is.endReadSlice();
    }

    public omero.RBool unique;

    public omero.RLong ownerId;

    public omero.RLong groupId;

    public omero.RInt offset;

    public omero.RInt limit;

    public omero.RTime startTime;

    public omero.RTime endTime;

    public static final long serialVersionUID = 4233571155385835247L;
}
