
/*
 *   Copyright 2006 University of Dundee. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 * 
 */

package omero.util;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;


/**
 * Code-generated
 */
public class IceMap {

        private final static Map<Class, Class> _ome2omero = new HashMap<Class, Class>();
        private final static Map<Class, Class> _omero2ome = new HashMap<Class, Class>();

        /**
         * Unmodifiable map of ome.model.* classes to omero.model.* classes.
         */
        public final static Map<Class, Class> OMEtoOMERO;

        /**
         * Unmodifiable map of omero.model.* classes to ome.model.* classes.
         */
        public final static Map<Class, Class> OMEROtoOME;

        static {

        _ome2omero.put(ome.model.enums.AcquisitionMode.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.AcquisitionMode.class,omero.model.AcquisitionModeI.class);
        _omero2ome.put(omero.model.AcquisitionMode.class,ome.model.enums.AcquisitionMode.class);
        _omero2ome.put(omero.model.AcquisitionModeI.class,ome.model.enums.AcquisitionMode.class);

        _ome2omero.put(ome.model.enums.AdminPrivilege.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.AdminPrivilege.class,omero.model.AdminPrivilegeI.class);
        _omero2ome.put(omero.model.AdminPrivilege.class,ome.model.enums.AdminPrivilege.class);
        _omero2ome.put(omero.model.AdminPrivilegeI.class,ome.model.enums.AdminPrivilege.class);

        _ome2omero.put(ome.model.roi.AffineTransform.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.roi.AffineTransform.class,omero.model.AffineTransformI.class);
        _omero2ome.put(omero.model.AffineTransform.class,ome.model.roi.AffineTransform.class);
        _omero2ome.put(omero.model.AffineTransformI.class,ome.model.roi.AffineTransform.class);

        _ome2omero.put(ome.model.annotations.AnnotationAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.AnnotationAnnotationLink.class,omero.model.AnnotationAnnotationLinkI.class);
        _omero2ome.put(omero.model.AnnotationAnnotationLink.class,ome.model.annotations.AnnotationAnnotationLink.class);
        _omero2ome.put(omero.model.AnnotationAnnotationLinkI.class,ome.model.annotations.AnnotationAnnotationLink.class);

        _ome2omero.put(ome.model.acquisition.Arc.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.Arc.class,omero.model.ArcI.class);
        _omero2ome.put(omero.model.Arc.class,ome.model.acquisition.Arc.class);
        _omero2ome.put(omero.model.ArcI.class,ome.model.acquisition.Arc.class);

        _ome2omero.put(ome.model.enums.ArcType.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.ArcType.class,omero.model.ArcTypeI.class);
        _omero2ome.put(omero.model.ArcType.class,ome.model.enums.ArcType.class);
        _omero2ome.put(omero.model.ArcTypeI.class,ome.model.enums.ArcType.class);

        _ome2omero.put(ome.model.enums.Binning.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.Binning.class,omero.model.BinningI.class);
        _omero2ome.put(omero.model.Binning.class,ome.model.enums.Binning.class);
        _omero2ome.put(omero.model.BinningI.class,ome.model.enums.Binning.class);

        _ome2omero.put(ome.model.annotations.BooleanAnnotation.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.BooleanAnnotation.class,omero.model.BooleanAnnotationI.class);
        _omero2ome.put(omero.model.BooleanAnnotation.class,ome.model.annotations.BooleanAnnotation.class);
        _omero2ome.put(omero.model.BooleanAnnotationI.class,ome.model.annotations.BooleanAnnotation.class);

        _ome2omero.put(ome.model.core.Channel.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.core.Channel.class,omero.model.ChannelI.class);
        _omero2ome.put(omero.model.Channel.class,ome.model.core.Channel.class);
        _omero2ome.put(omero.model.ChannelI.class,ome.model.core.Channel.class);

        _ome2omero.put(ome.model.annotations.ChannelAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.ChannelAnnotationLink.class,omero.model.ChannelAnnotationLinkI.class);
        _omero2ome.put(omero.model.ChannelAnnotationLink.class,ome.model.annotations.ChannelAnnotationLink.class);
        _omero2ome.put(omero.model.ChannelAnnotationLinkI.class,ome.model.annotations.ChannelAnnotationLink.class);

        _ome2omero.put(ome.model.display.ChannelBinding.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.display.ChannelBinding.class,omero.model.ChannelBindingI.class);
        _omero2ome.put(omero.model.ChannelBinding.class,ome.model.display.ChannelBinding.class);
        _omero2ome.put(omero.model.ChannelBindingI.class,ome.model.display.ChannelBinding.class);

        _ome2omero.put(ome.model.enums.ChecksumAlgorithm.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.ChecksumAlgorithm.class,omero.model.ChecksumAlgorithmI.class);
        _omero2ome.put(omero.model.ChecksumAlgorithm.class,ome.model.enums.ChecksumAlgorithm.class);
        _omero2ome.put(omero.model.ChecksumAlgorithmI.class,ome.model.enums.ChecksumAlgorithm.class);

        _ome2omero.put(ome.model.annotations.CommentAnnotation.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.CommentAnnotation.class,omero.model.CommentAnnotationI.class);
        _omero2ome.put(omero.model.CommentAnnotation.class,ome.model.annotations.CommentAnnotation.class);
        _omero2ome.put(omero.model.CommentAnnotationI.class,ome.model.annotations.CommentAnnotation.class);

        _ome2omero.put(ome.model.enums.ContrastMethod.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.ContrastMethod.class,omero.model.ContrastMethodI.class);
        _omero2ome.put(omero.model.ContrastMethod.class,ome.model.enums.ContrastMethod.class);
        _omero2ome.put(omero.model.ContrastMethodI.class,ome.model.enums.ContrastMethod.class);

        _ome2omero.put(ome.model.display.ContrastStretchingContext.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.display.ContrastStretchingContext.class,omero.model.ContrastStretchingContextI.class);
        _omero2ome.put(omero.model.ContrastStretchingContext.class,ome.model.display.ContrastStretchingContext.class);
        _omero2ome.put(omero.model.ContrastStretchingContextI.class,ome.model.display.ContrastStretchingContext.class);

        _ome2omero.put(ome.model.enums.Correction.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.Correction.class,omero.model.CorrectionI.class);
        _omero2ome.put(omero.model.Correction.class,ome.model.enums.Correction.class);
        _omero2ome.put(omero.model.CorrectionI.class,ome.model.enums.Correction.class);

        _ome2omero.put(ome.model.meta.DBPatch.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.meta.DBPatch.class,omero.model.DBPatchI.class);
        _omero2ome.put(omero.model.DBPatch.class,ome.model.meta.DBPatch.class);
        _omero2ome.put(omero.model.DBPatchI.class,ome.model.meta.DBPatch.class);

        _ome2omero.put(ome.model.containers.Dataset.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.containers.Dataset.class,omero.model.DatasetI.class);
        _omero2ome.put(omero.model.Dataset.class,ome.model.containers.Dataset.class);
        _omero2ome.put(omero.model.DatasetI.class,ome.model.containers.Dataset.class);

        _ome2omero.put(ome.model.annotations.DatasetAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.DatasetAnnotationLink.class,omero.model.DatasetAnnotationLinkI.class);
        _omero2ome.put(omero.model.DatasetAnnotationLink.class,ome.model.annotations.DatasetAnnotationLink.class);
        _omero2ome.put(omero.model.DatasetAnnotationLinkI.class,ome.model.annotations.DatasetAnnotationLink.class);

        _ome2omero.put(ome.model.containers.DatasetImageLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.containers.DatasetImageLink.class,omero.model.DatasetImageLinkI.class);
        _omero2ome.put(omero.model.DatasetImageLink.class,ome.model.containers.DatasetImageLink.class);
        _omero2ome.put(omero.model.DatasetImageLinkI.class,ome.model.containers.DatasetImageLink.class);

        _ome2omero.put(ome.model.acquisition.Detector.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.Detector.class,omero.model.DetectorI.class);
        _omero2ome.put(omero.model.Detector.class,ome.model.acquisition.Detector.class);
        _omero2ome.put(omero.model.DetectorI.class,ome.model.acquisition.Detector.class);

        _ome2omero.put(ome.model.annotations.DetectorAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.DetectorAnnotationLink.class,omero.model.DetectorAnnotationLinkI.class);
        _omero2ome.put(omero.model.DetectorAnnotationLink.class,ome.model.annotations.DetectorAnnotationLink.class);
        _omero2ome.put(omero.model.DetectorAnnotationLinkI.class,ome.model.annotations.DetectorAnnotationLink.class);

        _ome2omero.put(ome.model.acquisition.DetectorSettings.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.DetectorSettings.class,omero.model.DetectorSettingsI.class);
        _omero2ome.put(omero.model.DetectorSettings.class,ome.model.acquisition.DetectorSettings.class);
        _omero2ome.put(omero.model.DetectorSettingsI.class,ome.model.acquisition.DetectorSettings.class);

        _ome2omero.put(ome.model.enums.DetectorType.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.DetectorType.class,omero.model.DetectorTypeI.class);
        _omero2ome.put(omero.model.DetectorType.class,ome.model.enums.DetectorType.class);
        _omero2ome.put(omero.model.DetectorTypeI.class,ome.model.enums.DetectorType.class);

        _ome2omero.put(ome.model.acquisition.Dichroic.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.Dichroic.class,omero.model.DichroicI.class);
        _omero2ome.put(omero.model.Dichroic.class,ome.model.acquisition.Dichroic.class);
        _omero2ome.put(omero.model.DichroicI.class,ome.model.acquisition.Dichroic.class);

        _ome2omero.put(ome.model.annotations.DichroicAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.DichroicAnnotationLink.class,omero.model.DichroicAnnotationLinkI.class);
        _omero2ome.put(omero.model.DichroicAnnotationLink.class,ome.model.annotations.DichroicAnnotationLink.class);
        _omero2ome.put(omero.model.DichroicAnnotationLinkI.class,ome.model.annotations.DichroicAnnotationLink.class);

        _ome2omero.put(ome.model.enums.DimensionOrder.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.DimensionOrder.class,omero.model.DimensionOrderI.class);
        _omero2ome.put(omero.model.DimensionOrder.class,ome.model.enums.DimensionOrder.class);
        _omero2ome.put(omero.model.DimensionOrderI.class,ome.model.enums.DimensionOrder.class);

        _ome2omero.put(ome.model.annotations.DoubleAnnotation.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.DoubleAnnotation.class,omero.model.DoubleAnnotationI.class);
        _omero2ome.put(omero.model.DoubleAnnotation.class,ome.model.annotations.DoubleAnnotation.class);
        _omero2ome.put(omero.model.DoubleAnnotationI.class,ome.model.annotations.DoubleAnnotation.class);

        _ome2omero.put(ome.model.roi.Ellipse.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.roi.Ellipse.class,omero.model.EllipseI.class);
        _omero2ome.put(omero.model.Ellipse.class,ome.model.roi.Ellipse.class);
        _omero2ome.put(omero.model.EllipseI.class,ome.model.roi.Ellipse.class);

        _ome2omero.put(ome.model.meta.Event.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.meta.Event.class,omero.model.EventI.class);
        _omero2ome.put(omero.model.Event.class,ome.model.meta.Event.class);
        _omero2ome.put(omero.model.EventI.class,ome.model.meta.Event.class);

        _ome2omero.put(ome.model.meta.EventLog.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.meta.EventLog.class,omero.model.EventLogI.class);
        _omero2ome.put(omero.model.EventLog.class,ome.model.meta.EventLog.class);
        _omero2ome.put(omero.model.EventLogI.class,ome.model.meta.EventLog.class);

        _ome2omero.put(ome.model.enums.EventType.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.EventType.class,omero.model.EventTypeI.class);
        _omero2ome.put(omero.model.EventType.class,ome.model.enums.EventType.class);
        _omero2ome.put(omero.model.EventTypeI.class,ome.model.enums.EventType.class);

        _ome2omero.put(ome.model.experiment.Experiment.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.experiment.Experiment.class,omero.model.ExperimentI.class);
        _omero2ome.put(omero.model.Experiment.class,ome.model.experiment.Experiment.class);
        _omero2ome.put(omero.model.ExperimentI.class,ome.model.experiment.Experiment.class);

        _ome2omero.put(ome.model.enums.ExperimentType.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.ExperimentType.class,omero.model.ExperimentTypeI.class);
        _omero2ome.put(omero.model.ExperimentType.class,ome.model.enums.ExperimentType.class);
        _omero2ome.put(omero.model.ExperimentTypeI.class,ome.model.enums.ExperimentType.class);

        _ome2omero.put(ome.model.meta.Experimenter.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.meta.Experimenter.class,omero.model.ExperimenterI.class);
        _omero2ome.put(omero.model.Experimenter.class,ome.model.meta.Experimenter.class);
        _omero2ome.put(omero.model.ExperimenterI.class,ome.model.meta.Experimenter.class);

        _ome2omero.put(ome.model.annotations.ExperimenterAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.ExperimenterAnnotationLink.class,omero.model.ExperimenterAnnotationLinkI.class);
        _omero2ome.put(omero.model.ExperimenterAnnotationLink.class,ome.model.annotations.ExperimenterAnnotationLink.class);
        _omero2ome.put(omero.model.ExperimenterAnnotationLinkI.class,ome.model.annotations.ExperimenterAnnotationLink.class);

        _ome2omero.put(ome.model.meta.ExperimenterGroup.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.meta.ExperimenterGroup.class,omero.model.ExperimenterGroupI.class);
        _omero2ome.put(omero.model.ExperimenterGroup.class,ome.model.meta.ExperimenterGroup.class);
        _omero2ome.put(omero.model.ExperimenterGroupI.class,ome.model.meta.ExperimenterGroup.class);

        _ome2omero.put(ome.model.annotations.ExperimenterGroupAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.ExperimenterGroupAnnotationLink.class,omero.model.ExperimenterGroupAnnotationLinkI.class);
        _omero2ome.put(omero.model.ExperimenterGroupAnnotationLink.class,ome.model.annotations.ExperimenterGroupAnnotationLink.class);
        _omero2ome.put(omero.model.ExperimenterGroupAnnotationLinkI.class,ome.model.annotations.ExperimenterGroupAnnotationLink.class);

        _ome2omero.put(ome.model.meta.ExternalInfo.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.meta.ExternalInfo.class,omero.model.ExternalInfoI.class);
        _omero2ome.put(omero.model.ExternalInfo.class,ome.model.meta.ExternalInfo.class);
        _omero2ome.put(omero.model.ExternalInfoI.class,ome.model.meta.ExternalInfo.class);

        _ome2omero.put(ome.model.enums.Family.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.Family.class,omero.model.FamilyI.class);
        _omero2ome.put(omero.model.Family.class,ome.model.enums.Family.class);
        _omero2ome.put(omero.model.FamilyI.class,ome.model.enums.Family.class);

        _ome2omero.put(ome.model.acquisition.Filament.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.Filament.class,omero.model.FilamentI.class);
        _omero2ome.put(omero.model.Filament.class,ome.model.acquisition.Filament.class);
        _omero2ome.put(omero.model.FilamentI.class,ome.model.acquisition.Filament.class);

        _ome2omero.put(ome.model.enums.FilamentType.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.FilamentType.class,omero.model.FilamentTypeI.class);
        _omero2ome.put(omero.model.FilamentType.class,ome.model.enums.FilamentType.class);
        _omero2ome.put(omero.model.FilamentTypeI.class,ome.model.enums.FilamentType.class);

        _ome2omero.put(ome.model.annotations.FileAnnotation.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.FileAnnotation.class,omero.model.FileAnnotationI.class);
        _omero2ome.put(omero.model.FileAnnotation.class,ome.model.annotations.FileAnnotation.class);
        _omero2ome.put(omero.model.FileAnnotationI.class,ome.model.annotations.FileAnnotation.class);

        _ome2omero.put(ome.model.fs.Fileset.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.fs.Fileset.class,omero.model.FilesetI.class);
        _omero2ome.put(omero.model.Fileset.class,ome.model.fs.Fileset.class);
        _omero2ome.put(omero.model.FilesetI.class,ome.model.fs.Fileset.class);

        _ome2omero.put(ome.model.annotations.FilesetAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.FilesetAnnotationLink.class,omero.model.FilesetAnnotationLinkI.class);
        _omero2ome.put(omero.model.FilesetAnnotationLink.class,ome.model.annotations.FilesetAnnotationLink.class);
        _omero2ome.put(omero.model.FilesetAnnotationLinkI.class,ome.model.annotations.FilesetAnnotationLink.class);

        _ome2omero.put(ome.model.fs.FilesetEntry.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.fs.FilesetEntry.class,omero.model.FilesetEntryI.class);
        _omero2ome.put(omero.model.FilesetEntry.class,ome.model.fs.FilesetEntry.class);
        _omero2ome.put(omero.model.FilesetEntryI.class,ome.model.fs.FilesetEntry.class);

        _ome2omero.put(ome.model.fs.FilesetJobLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.fs.FilesetJobLink.class,omero.model.FilesetJobLinkI.class);
        _omero2ome.put(omero.model.FilesetJobLink.class,ome.model.fs.FilesetJobLink.class);
        _omero2ome.put(omero.model.FilesetJobLinkI.class,ome.model.fs.FilesetJobLink.class);

        _ome2omero.put(ome.model.acquisition.Filter.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.Filter.class,omero.model.FilterI.class);
        _omero2ome.put(omero.model.Filter.class,ome.model.acquisition.Filter.class);
        _omero2ome.put(omero.model.FilterI.class,ome.model.acquisition.Filter.class);

        _ome2omero.put(ome.model.annotations.FilterAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.FilterAnnotationLink.class,omero.model.FilterAnnotationLinkI.class);
        _omero2ome.put(omero.model.FilterAnnotationLink.class,ome.model.annotations.FilterAnnotationLink.class);
        _omero2ome.put(omero.model.FilterAnnotationLinkI.class,ome.model.annotations.FilterAnnotationLink.class);

        _ome2omero.put(ome.model.acquisition.FilterSet.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.FilterSet.class,omero.model.FilterSetI.class);
        _omero2ome.put(omero.model.FilterSet.class,ome.model.acquisition.FilterSet.class);
        _omero2ome.put(omero.model.FilterSetI.class,ome.model.acquisition.FilterSet.class);

        _ome2omero.put(ome.model.acquisition.FilterSetEmissionFilterLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.FilterSetEmissionFilterLink.class,omero.model.FilterSetEmissionFilterLinkI.class);
        _omero2ome.put(omero.model.FilterSetEmissionFilterLink.class,ome.model.acquisition.FilterSetEmissionFilterLink.class);
        _omero2ome.put(omero.model.FilterSetEmissionFilterLinkI.class,ome.model.acquisition.FilterSetEmissionFilterLink.class);

        _ome2omero.put(ome.model.acquisition.FilterSetExcitationFilterLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.FilterSetExcitationFilterLink.class,omero.model.FilterSetExcitationFilterLinkI.class);
        _omero2ome.put(omero.model.FilterSetExcitationFilterLink.class,ome.model.acquisition.FilterSetExcitationFilterLink.class);
        _omero2ome.put(omero.model.FilterSetExcitationFilterLinkI.class,ome.model.acquisition.FilterSetExcitationFilterLink.class);

        _ome2omero.put(ome.model.enums.FilterType.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.FilterType.class,omero.model.FilterTypeI.class);
        _omero2ome.put(omero.model.FilterType.class,ome.model.enums.FilterType.class);
        _omero2ome.put(omero.model.FilterTypeI.class,ome.model.enums.FilterType.class);

        _ome2omero.put(ome.model.containers.Folder.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.containers.Folder.class,omero.model.FolderI.class);
        _omero2ome.put(omero.model.Folder.class,ome.model.containers.Folder.class);
        _omero2ome.put(omero.model.FolderI.class,ome.model.containers.Folder.class);

        _ome2omero.put(ome.model.annotations.FolderAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.FolderAnnotationLink.class,omero.model.FolderAnnotationLinkI.class);
        _omero2ome.put(omero.model.FolderAnnotationLink.class,ome.model.annotations.FolderAnnotationLink.class);
        _omero2ome.put(omero.model.FolderAnnotationLinkI.class,ome.model.annotations.FolderAnnotationLink.class);

        _ome2omero.put(ome.model.containers.FolderImageLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.containers.FolderImageLink.class,omero.model.FolderImageLinkI.class);
        _omero2ome.put(omero.model.FolderImageLink.class,ome.model.containers.FolderImageLink.class);
        _omero2ome.put(omero.model.FolderImageLinkI.class,ome.model.containers.FolderImageLink.class);

        _ome2omero.put(ome.model.containers.FolderRoiLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.containers.FolderRoiLink.class,omero.model.FolderRoiLinkI.class);
        _omero2ome.put(omero.model.FolderRoiLink.class,ome.model.containers.FolderRoiLink.class);
        _omero2ome.put(omero.model.FolderRoiLinkI.class,ome.model.containers.FolderRoiLink.class);

        _ome2omero.put(ome.model.enums.Format.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.Format.class,omero.model.FormatI.class);
        _omero2ome.put(omero.model.Format.class,ome.model.enums.Format.class);
        _omero2ome.put(omero.model.FormatI.class,ome.model.enums.Format.class);

        _ome2omero.put(ome.model.acquisition.GenericExcitationSource.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.GenericExcitationSource.class,omero.model.GenericExcitationSourceI.class);
        _omero2ome.put(omero.model.GenericExcitationSource.class,ome.model.acquisition.GenericExcitationSource.class);
        _omero2ome.put(omero.model.GenericExcitationSourceI.class,ome.model.acquisition.GenericExcitationSource.class);

        _ome2omero.put(ome.model.meta.GroupExperimenterMap.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.meta.GroupExperimenterMap.class,omero.model.GroupExperimenterMapI.class);
        _omero2ome.put(omero.model.GroupExperimenterMap.class,ome.model.meta.GroupExperimenterMap.class);
        _omero2ome.put(omero.model.GroupExperimenterMapI.class,ome.model.meta.GroupExperimenterMap.class);

        _ome2omero.put(ome.model.enums.Illumination.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.Illumination.class,omero.model.IlluminationI.class);
        _omero2ome.put(omero.model.Illumination.class,ome.model.enums.Illumination.class);
        _omero2ome.put(omero.model.IlluminationI.class,ome.model.enums.Illumination.class);

        _ome2omero.put(ome.model.core.Image.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.core.Image.class,omero.model.ImageI.class);
        _omero2ome.put(omero.model.Image.class,ome.model.core.Image.class);
        _omero2ome.put(omero.model.ImageI.class,ome.model.core.Image.class);

        _ome2omero.put(ome.model.annotations.ImageAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.ImageAnnotationLink.class,omero.model.ImageAnnotationLinkI.class);
        _omero2ome.put(omero.model.ImageAnnotationLink.class,ome.model.annotations.ImageAnnotationLink.class);
        _omero2ome.put(omero.model.ImageAnnotationLinkI.class,ome.model.annotations.ImageAnnotationLink.class);

        _ome2omero.put(ome.model.acquisition.ImagingEnvironment.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.ImagingEnvironment.class,omero.model.ImagingEnvironmentI.class);
        _omero2ome.put(omero.model.ImagingEnvironment.class,ome.model.acquisition.ImagingEnvironment.class);
        _omero2ome.put(omero.model.ImagingEnvironmentI.class,ome.model.acquisition.ImagingEnvironment.class);

        _ome2omero.put(ome.model.enums.Immersion.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.Immersion.class,omero.model.ImmersionI.class);
        _omero2ome.put(omero.model.Immersion.class,ome.model.enums.Immersion.class);
        _omero2ome.put(omero.model.ImmersionI.class,ome.model.enums.Immersion.class);

        _ome2omero.put(ome.model.jobs.ImportJob.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.jobs.ImportJob.class,omero.model.ImportJobI.class);
        _omero2ome.put(omero.model.ImportJob.class,ome.model.jobs.ImportJob.class);
        _omero2ome.put(omero.model.ImportJobI.class,ome.model.jobs.ImportJob.class);

        _ome2omero.put(ome.model.jobs.IndexingJob.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.jobs.IndexingJob.class,omero.model.IndexingJobI.class);
        _omero2ome.put(omero.model.IndexingJob.class,ome.model.jobs.IndexingJob.class);
        _omero2ome.put(omero.model.IndexingJobI.class,ome.model.jobs.IndexingJob.class);

        _ome2omero.put(ome.model.acquisition.Instrument.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.Instrument.class,omero.model.InstrumentI.class);
        _omero2ome.put(omero.model.Instrument.class,ome.model.acquisition.Instrument.class);
        _omero2ome.put(omero.model.InstrumentI.class,ome.model.acquisition.Instrument.class);

        _ome2omero.put(ome.model.annotations.InstrumentAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.InstrumentAnnotationLink.class,omero.model.InstrumentAnnotationLinkI.class);
        _omero2ome.put(omero.model.InstrumentAnnotationLink.class,ome.model.annotations.InstrumentAnnotationLink.class);
        _omero2ome.put(omero.model.InstrumentAnnotationLinkI.class,ome.model.annotations.InstrumentAnnotationLink.class);

        _ome2omero.put(ome.model.jobs.IntegrityCheckJob.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.jobs.IntegrityCheckJob.class,omero.model.IntegrityCheckJobI.class);
        _omero2ome.put(omero.model.IntegrityCheckJob.class,ome.model.jobs.IntegrityCheckJob.class);
        _omero2ome.put(omero.model.IntegrityCheckJobI.class,ome.model.jobs.IntegrityCheckJob.class);

        _ome2omero.put(ome.model.jobs.JobOriginalFileLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.jobs.JobOriginalFileLink.class,omero.model.JobOriginalFileLinkI.class);
        _omero2ome.put(omero.model.JobOriginalFileLink.class,ome.model.jobs.JobOriginalFileLink.class);
        _omero2ome.put(omero.model.JobOriginalFileLinkI.class,ome.model.jobs.JobOriginalFileLink.class);

        _ome2omero.put(ome.model.jobs.JobStatus.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.jobs.JobStatus.class,omero.model.JobStatusI.class);
        _omero2ome.put(omero.model.JobStatus.class,ome.model.jobs.JobStatus.class);
        _omero2ome.put(omero.model.JobStatusI.class,ome.model.jobs.JobStatus.class);

        _ome2omero.put(ome.model.roi.Label.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.roi.Label.class,omero.model.LabelI.class);
        _omero2ome.put(omero.model.Label.class,ome.model.roi.Label.class);
        _omero2ome.put(omero.model.LabelI.class,ome.model.roi.Label.class);

        _ome2omero.put(ome.model.acquisition.Laser.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.Laser.class,omero.model.LaserI.class);
        _omero2ome.put(omero.model.Laser.class,ome.model.acquisition.Laser.class);
        _omero2ome.put(omero.model.LaserI.class,ome.model.acquisition.Laser.class);

        _ome2omero.put(ome.model.enums.LaserMedium.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.LaserMedium.class,omero.model.LaserMediumI.class);
        _omero2ome.put(omero.model.LaserMedium.class,ome.model.enums.LaserMedium.class);
        _omero2ome.put(omero.model.LaserMediumI.class,ome.model.enums.LaserMedium.class);

        _ome2omero.put(ome.model.enums.LaserType.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.LaserType.class,omero.model.LaserTypeI.class);
        _omero2ome.put(omero.model.LaserType.class,ome.model.enums.LaserType.class);
        _omero2ome.put(omero.model.LaserTypeI.class,ome.model.enums.LaserType.class);

        _ome2omero.put(ome.model.acquisition.LightEmittingDiode.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.LightEmittingDiode.class,omero.model.LightEmittingDiodeI.class);
        _omero2ome.put(omero.model.LightEmittingDiode.class,ome.model.acquisition.LightEmittingDiode.class);
        _omero2ome.put(omero.model.LightEmittingDiodeI.class,ome.model.acquisition.LightEmittingDiode.class);

        _ome2omero.put(ome.model.acquisition.LightPath.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.LightPath.class,omero.model.LightPathI.class);
        _omero2ome.put(omero.model.LightPath.class,ome.model.acquisition.LightPath.class);
        _omero2ome.put(omero.model.LightPathI.class,ome.model.acquisition.LightPath.class);

        _ome2omero.put(ome.model.annotations.LightPathAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.LightPathAnnotationLink.class,omero.model.LightPathAnnotationLinkI.class);
        _omero2ome.put(omero.model.LightPathAnnotationLink.class,ome.model.annotations.LightPathAnnotationLink.class);
        _omero2ome.put(omero.model.LightPathAnnotationLinkI.class,ome.model.annotations.LightPathAnnotationLink.class);

        _ome2omero.put(ome.model.acquisition.LightPathEmissionFilterLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.LightPathEmissionFilterLink.class,omero.model.LightPathEmissionFilterLinkI.class);
        _omero2ome.put(omero.model.LightPathEmissionFilterLink.class,ome.model.acquisition.LightPathEmissionFilterLink.class);
        _omero2ome.put(omero.model.LightPathEmissionFilterLinkI.class,ome.model.acquisition.LightPathEmissionFilterLink.class);

        _ome2omero.put(ome.model.acquisition.LightPathExcitationFilterLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.LightPathExcitationFilterLink.class,omero.model.LightPathExcitationFilterLinkI.class);
        _omero2ome.put(omero.model.LightPathExcitationFilterLink.class,ome.model.acquisition.LightPathExcitationFilterLink.class);
        _omero2ome.put(omero.model.LightPathExcitationFilterLinkI.class,ome.model.acquisition.LightPathExcitationFilterLink.class);

        _ome2omero.put(ome.model.acquisition.LightSettings.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.LightSettings.class,omero.model.LightSettingsI.class);
        _omero2ome.put(omero.model.LightSettings.class,ome.model.acquisition.LightSettings.class);
        _omero2ome.put(omero.model.LightSettingsI.class,ome.model.acquisition.LightSettings.class);

        _ome2omero.put(ome.model.annotations.LightSourceAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.LightSourceAnnotationLink.class,omero.model.LightSourceAnnotationLinkI.class);
        _omero2ome.put(omero.model.LightSourceAnnotationLink.class,ome.model.annotations.LightSourceAnnotationLink.class);
        _omero2ome.put(omero.model.LightSourceAnnotationLinkI.class,ome.model.annotations.LightSourceAnnotationLink.class);

        _ome2omero.put(ome.model.roi.Line.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.roi.Line.class,omero.model.LineI.class);
        _omero2ome.put(omero.model.Line.class,ome.model.roi.Line.class);
        _omero2ome.put(omero.model.LineI.class,ome.model.roi.Line.class);

        _ome2omero.put(ome.model.internal.Link.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.internal.Link.class,omero.model.LinkI.class);
        _omero2ome.put(omero.model.Link.class,ome.model.internal.Link.class);
        _omero2ome.put(omero.model.LinkI.class,ome.model.internal.Link.class);

        _ome2omero.put(ome.model.annotations.ListAnnotation.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.ListAnnotation.class,omero.model.ListAnnotationI.class);
        _omero2ome.put(omero.model.ListAnnotation.class,ome.model.annotations.ListAnnotation.class);
        _omero2ome.put(omero.model.ListAnnotationI.class,ome.model.annotations.ListAnnotation.class);

        _ome2omero.put(ome.model.core.LogicalChannel.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.core.LogicalChannel.class,omero.model.LogicalChannelI.class);
        _omero2ome.put(omero.model.LogicalChannel.class,ome.model.core.LogicalChannel.class);
        _omero2ome.put(omero.model.LogicalChannelI.class,ome.model.core.LogicalChannel.class);

        _ome2omero.put(ome.model.annotations.LongAnnotation.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.LongAnnotation.class,omero.model.LongAnnotationI.class);
        _omero2ome.put(omero.model.LongAnnotation.class,ome.model.annotations.LongAnnotation.class);
        _omero2ome.put(omero.model.LongAnnotationI.class,ome.model.annotations.LongAnnotation.class);

        _ome2omero.put(ome.model.annotations.MapAnnotation.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.MapAnnotation.class,omero.model.MapAnnotationI.class);
        _omero2ome.put(omero.model.MapAnnotation.class,ome.model.annotations.MapAnnotation.class);
        _omero2ome.put(omero.model.MapAnnotationI.class,ome.model.annotations.MapAnnotation.class);

        _ome2omero.put(ome.model.roi.Mask.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.roi.Mask.class,omero.model.MaskI.class);
        _omero2ome.put(omero.model.Mask.class,ome.model.roi.Mask.class);
        _omero2ome.put(omero.model.MaskI.class,ome.model.roi.Mask.class);

        _ome2omero.put(ome.model.enums.Medium.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.Medium.class,omero.model.MediumI.class);
        _omero2ome.put(omero.model.Medium.class,ome.model.enums.Medium.class);
        _omero2ome.put(omero.model.MediumI.class,ome.model.enums.Medium.class);

        _ome2omero.put(ome.model.jobs.MetadataImportJob.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.jobs.MetadataImportJob.class,omero.model.MetadataImportJobI.class);
        _omero2ome.put(omero.model.MetadataImportJob.class,ome.model.jobs.MetadataImportJob.class);
        _omero2ome.put(omero.model.MetadataImportJobI.class,ome.model.jobs.MetadataImportJob.class);

        _ome2omero.put(ome.model.experiment.MicrobeamManipulation.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.experiment.MicrobeamManipulation.class,omero.model.MicrobeamManipulationI.class);
        _omero2ome.put(omero.model.MicrobeamManipulation.class,ome.model.experiment.MicrobeamManipulation.class);
        _omero2ome.put(omero.model.MicrobeamManipulationI.class,ome.model.experiment.MicrobeamManipulation.class);

        _ome2omero.put(ome.model.enums.MicrobeamManipulationType.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.MicrobeamManipulationType.class,omero.model.MicrobeamManipulationTypeI.class);
        _omero2ome.put(omero.model.MicrobeamManipulationType.class,ome.model.enums.MicrobeamManipulationType.class);
        _omero2ome.put(omero.model.MicrobeamManipulationTypeI.class,ome.model.enums.MicrobeamManipulationType.class);

        _ome2omero.put(ome.model.acquisition.Microscope.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.Microscope.class,omero.model.MicroscopeI.class);
        _omero2ome.put(omero.model.Microscope.class,ome.model.acquisition.Microscope.class);
        _omero2ome.put(omero.model.MicroscopeI.class,ome.model.acquisition.Microscope.class);

        _ome2omero.put(ome.model.enums.MicroscopeType.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.MicroscopeType.class,omero.model.MicroscopeTypeI.class);
        _omero2ome.put(omero.model.MicroscopeType.class,ome.model.enums.MicroscopeType.class);
        _omero2ome.put(omero.model.MicroscopeTypeI.class,ome.model.enums.MicroscopeType.class);

        _ome2omero.put(ome.model.meta.Namespace.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.meta.Namespace.class,omero.model.NamespaceI.class);
        _omero2ome.put(omero.model.Namespace.class,ome.model.meta.Namespace.class);
        _omero2ome.put(omero.model.NamespaceI.class,ome.model.meta.Namespace.class);

        _ome2omero.put(ome.model.annotations.NamespaceAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.NamespaceAnnotationLink.class,omero.model.NamespaceAnnotationLinkI.class);
        _omero2ome.put(omero.model.NamespaceAnnotationLink.class,ome.model.annotations.NamespaceAnnotationLink.class);
        _omero2ome.put(omero.model.NamespaceAnnotationLinkI.class,ome.model.annotations.NamespaceAnnotationLink.class);

        _ome2omero.put(ome.model.meta.Node.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.meta.Node.class,omero.model.NodeI.class);
        _omero2ome.put(omero.model.Node.class,ome.model.meta.Node.class);
        _omero2ome.put(omero.model.NodeI.class,ome.model.meta.Node.class);

        _ome2omero.put(ome.model.annotations.NodeAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.NodeAnnotationLink.class,omero.model.NodeAnnotationLinkI.class);
        _omero2ome.put(omero.model.NodeAnnotationLink.class,ome.model.annotations.NodeAnnotationLink.class);
        _omero2ome.put(omero.model.NodeAnnotationLinkI.class,ome.model.annotations.NodeAnnotationLink.class);

        _ome2omero.put(ome.model.acquisition.OTF.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.OTF.class,omero.model.OTFI.class);
        _omero2ome.put(omero.model.OTF.class,ome.model.acquisition.OTF.class);
        _omero2ome.put(omero.model.OTFI.class,ome.model.acquisition.OTF.class);

        _ome2omero.put(ome.model.acquisition.Objective.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.Objective.class,omero.model.ObjectiveI.class);
        _omero2ome.put(omero.model.Objective.class,ome.model.acquisition.Objective.class);
        _omero2ome.put(omero.model.ObjectiveI.class,ome.model.acquisition.Objective.class);

        _ome2omero.put(ome.model.annotations.ObjectiveAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.ObjectiveAnnotationLink.class,omero.model.ObjectiveAnnotationLinkI.class);
        _omero2ome.put(omero.model.ObjectiveAnnotationLink.class,ome.model.annotations.ObjectiveAnnotationLink.class);
        _omero2ome.put(omero.model.ObjectiveAnnotationLinkI.class,ome.model.annotations.ObjectiveAnnotationLink.class);

        _ome2omero.put(ome.model.acquisition.ObjectiveSettings.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.ObjectiveSettings.class,omero.model.ObjectiveSettingsI.class);
        _omero2ome.put(omero.model.ObjectiveSettings.class,ome.model.acquisition.ObjectiveSettings.class);
        _omero2ome.put(omero.model.ObjectiveSettingsI.class,ome.model.acquisition.ObjectiveSettings.class);

        _ome2omero.put(ome.model.core.OriginalFile.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.core.OriginalFile.class,omero.model.OriginalFileI.class);
        _omero2ome.put(omero.model.OriginalFile.class,ome.model.core.OriginalFile.class);
        _omero2ome.put(omero.model.OriginalFileI.class,ome.model.core.OriginalFile.class);

        _ome2omero.put(ome.model.annotations.OriginalFileAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.OriginalFileAnnotationLink.class,omero.model.OriginalFileAnnotationLinkI.class);
        _omero2ome.put(omero.model.OriginalFileAnnotationLink.class,ome.model.annotations.OriginalFileAnnotationLink.class);
        _omero2ome.put(omero.model.OriginalFileAnnotationLinkI.class,ome.model.annotations.OriginalFileAnnotationLink.class);

        _ome2omero.put(ome.model.jobs.ParseJob.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.jobs.ParseJob.class,omero.model.ParseJobI.class);
        _omero2ome.put(omero.model.ParseJob.class,ome.model.jobs.ParseJob.class);
        _omero2ome.put(omero.model.ParseJobI.class,ome.model.jobs.ParseJob.class);

        _ome2omero.put(ome.model.roi.Path.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.roi.Path.class,omero.model.PathI.class);
        _omero2ome.put(omero.model.Path.class,ome.model.roi.Path.class);
        _omero2ome.put(omero.model.PathI.class,ome.model.roi.Path.class);

        _ome2omero.put(ome.model.enums.PhotometricInterpretation.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.PhotometricInterpretation.class,omero.model.PhotometricInterpretationI.class);
        _omero2ome.put(omero.model.PhotometricInterpretation.class,ome.model.enums.PhotometricInterpretation.class);
        _omero2ome.put(omero.model.PhotometricInterpretationI.class,ome.model.enums.PhotometricInterpretation.class);

        _ome2omero.put(ome.model.jobs.PixelDataJob.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.jobs.PixelDataJob.class,omero.model.PixelDataJobI.class);
        _omero2ome.put(omero.model.PixelDataJob.class,ome.model.jobs.PixelDataJob.class);
        _omero2ome.put(omero.model.PixelDataJobI.class,ome.model.jobs.PixelDataJob.class);

        _ome2omero.put(ome.model.core.Pixels.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.core.Pixels.class,omero.model.PixelsI.class);
        _omero2ome.put(omero.model.Pixels.class,ome.model.core.Pixels.class);
        _omero2ome.put(omero.model.PixelsI.class,ome.model.core.Pixels.class);

        _ome2omero.put(ome.model.core.PixelsOriginalFileMap.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.core.PixelsOriginalFileMap.class,omero.model.PixelsOriginalFileMapI.class);
        _omero2ome.put(omero.model.PixelsOriginalFileMap.class,ome.model.core.PixelsOriginalFileMap.class);
        _omero2ome.put(omero.model.PixelsOriginalFileMapI.class,ome.model.core.PixelsOriginalFileMap.class);

        _ome2omero.put(ome.model.enums.PixelsType.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.PixelsType.class,omero.model.PixelsTypeI.class);
        _omero2ome.put(omero.model.PixelsType.class,ome.model.enums.PixelsType.class);
        _omero2ome.put(omero.model.PixelsTypeI.class,ome.model.enums.PixelsType.class);

        _ome2omero.put(ome.model.core.PlaneInfo.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.core.PlaneInfo.class,omero.model.PlaneInfoI.class);
        _omero2ome.put(omero.model.PlaneInfo.class,ome.model.core.PlaneInfo.class);
        _omero2ome.put(omero.model.PlaneInfoI.class,ome.model.core.PlaneInfo.class);

        _ome2omero.put(ome.model.annotations.PlaneInfoAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.PlaneInfoAnnotationLink.class,omero.model.PlaneInfoAnnotationLinkI.class);
        _omero2ome.put(omero.model.PlaneInfoAnnotationLink.class,ome.model.annotations.PlaneInfoAnnotationLink.class);
        _omero2ome.put(omero.model.PlaneInfoAnnotationLinkI.class,ome.model.annotations.PlaneInfoAnnotationLink.class);

        _ome2omero.put(ome.model.display.PlaneSlicingContext.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.display.PlaneSlicingContext.class,omero.model.PlaneSlicingContextI.class);
        _omero2ome.put(omero.model.PlaneSlicingContext.class,ome.model.display.PlaneSlicingContext.class);
        _omero2ome.put(omero.model.PlaneSlicingContextI.class,ome.model.display.PlaneSlicingContext.class);

        _ome2omero.put(ome.model.screen.Plate.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.screen.Plate.class,omero.model.PlateI.class);
        _omero2ome.put(omero.model.Plate.class,ome.model.screen.Plate.class);
        _omero2ome.put(omero.model.PlateI.class,ome.model.screen.Plate.class);

        _ome2omero.put(ome.model.screen.PlateAcquisition.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.screen.PlateAcquisition.class,omero.model.PlateAcquisitionI.class);
        _omero2ome.put(omero.model.PlateAcquisition.class,ome.model.screen.PlateAcquisition.class);
        _omero2ome.put(omero.model.PlateAcquisitionI.class,ome.model.screen.PlateAcquisition.class);

        _ome2omero.put(ome.model.annotations.PlateAcquisitionAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.PlateAcquisitionAnnotationLink.class,omero.model.PlateAcquisitionAnnotationLinkI.class);
        _omero2ome.put(omero.model.PlateAcquisitionAnnotationLink.class,ome.model.annotations.PlateAcquisitionAnnotationLink.class);
        _omero2ome.put(omero.model.PlateAcquisitionAnnotationLinkI.class,ome.model.annotations.PlateAcquisitionAnnotationLink.class);

        _ome2omero.put(ome.model.annotations.PlateAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.PlateAnnotationLink.class,omero.model.PlateAnnotationLinkI.class);
        _omero2ome.put(omero.model.PlateAnnotationLink.class,ome.model.annotations.PlateAnnotationLink.class);
        _omero2ome.put(omero.model.PlateAnnotationLinkI.class,ome.model.annotations.PlateAnnotationLink.class);

        _ome2omero.put(ome.model.roi.Point.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.roi.Point.class,omero.model.PointI.class);
        _omero2ome.put(omero.model.Point.class,ome.model.roi.Point.class);
        _omero2ome.put(omero.model.PointI.class,ome.model.roi.Point.class);

        _ome2omero.put(ome.model.roi.Polygon.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.roi.Polygon.class,omero.model.PolygonI.class);
        _omero2ome.put(omero.model.Polygon.class,ome.model.roi.Polygon.class);
        _omero2ome.put(omero.model.PolygonI.class,ome.model.roi.Polygon.class);

        _ome2omero.put(ome.model.roi.Polyline.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.roi.Polyline.class,omero.model.PolylineI.class);
        _omero2ome.put(omero.model.Polyline.class,ome.model.roi.Polyline.class);
        _omero2ome.put(omero.model.PolylineI.class,ome.model.roi.Polyline.class);

        _ome2omero.put(ome.model.containers.Project.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.containers.Project.class,omero.model.ProjectI.class);
        _omero2ome.put(omero.model.Project.class,ome.model.containers.Project.class);
        _omero2ome.put(omero.model.ProjectI.class,ome.model.containers.Project.class);

        _ome2omero.put(ome.model.annotations.ProjectAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.ProjectAnnotationLink.class,omero.model.ProjectAnnotationLinkI.class);
        _omero2ome.put(omero.model.ProjectAnnotationLink.class,ome.model.annotations.ProjectAnnotationLink.class);
        _omero2ome.put(omero.model.ProjectAnnotationLinkI.class,ome.model.annotations.ProjectAnnotationLink.class);

        _ome2omero.put(ome.model.containers.ProjectDatasetLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.containers.ProjectDatasetLink.class,omero.model.ProjectDatasetLinkI.class);
        _omero2ome.put(omero.model.ProjectDatasetLink.class,ome.model.containers.ProjectDatasetLink.class);
        _omero2ome.put(omero.model.ProjectDatasetLinkI.class,ome.model.containers.ProjectDatasetLink.class);

        _ome2omero.put(ome.model.enums.ProjectionAxis.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.ProjectionAxis.class,omero.model.ProjectionAxisI.class);
        _omero2ome.put(omero.model.ProjectionAxis.class,ome.model.enums.ProjectionAxis.class);
        _omero2ome.put(omero.model.ProjectionAxisI.class,ome.model.enums.ProjectionAxis.class);

        _ome2omero.put(ome.model.display.ProjectionDef.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.display.ProjectionDef.class,omero.model.ProjectionDefI.class);
        _omero2ome.put(omero.model.ProjectionDef.class,ome.model.display.ProjectionDef.class);
        _omero2ome.put(omero.model.ProjectionDefI.class,ome.model.display.ProjectionDef.class);

        _ome2omero.put(ome.model.enums.ProjectionType.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.ProjectionType.class,omero.model.ProjectionTypeI.class);
        _omero2ome.put(omero.model.ProjectionType.class,ome.model.enums.ProjectionType.class);
        _omero2ome.put(omero.model.ProjectionTypeI.class,ome.model.enums.ProjectionType.class);

        _ome2omero.put(ome.model.enums.Pulse.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.Pulse.class,omero.model.PulseI.class);
        _omero2ome.put(omero.model.Pulse.class,ome.model.enums.Pulse.class);
        _omero2ome.put(omero.model.PulseI.class,ome.model.enums.Pulse.class);

        _ome2omero.put(ome.model.display.QuantumDef.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.display.QuantumDef.class,omero.model.QuantumDefI.class);
        _omero2ome.put(omero.model.QuantumDef.class,ome.model.display.QuantumDef.class);
        _omero2ome.put(omero.model.QuantumDefI.class,ome.model.display.QuantumDef.class);

        _ome2omero.put(ome.model.screen.Reagent.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.screen.Reagent.class,omero.model.ReagentI.class);
        _omero2ome.put(omero.model.Reagent.class,ome.model.screen.Reagent.class);
        _omero2ome.put(omero.model.ReagentI.class,ome.model.screen.Reagent.class);

        _ome2omero.put(ome.model.annotations.ReagentAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.ReagentAnnotationLink.class,omero.model.ReagentAnnotationLinkI.class);
        _omero2ome.put(omero.model.ReagentAnnotationLink.class,ome.model.annotations.ReagentAnnotationLink.class);
        _omero2ome.put(omero.model.ReagentAnnotationLinkI.class,ome.model.annotations.ReagentAnnotationLink.class);

        _ome2omero.put(ome.model.roi.Rectangle.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.roi.Rectangle.class,omero.model.RectangleI.class);
        _omero2ome.put(omero.model.Rectangle.class,ome.model.roi.Rectangle.class);
        _omero2ome.put(omero.model.RectangleI.class,ome.model.roi.Rectangle.class);

        _ome2omero.put(ome.model.display.RenderingDef.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.display.RenderingDef.class,omero.model.RenderingDefI.class);
        _omero2ome.put(omero.model.RenderingDef.class,ome.model.display.RenderingDef.class);
        _omero2ome.put(omero.model.RenderingDefI.class,ome.model.display.RenderingDef.class);

        _ome2omero.put(ome.model.enums.RenderingModel.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.enums.RenderingModel.class,omero.model.RenderingModelI.class);
        _omero2ome.put(omero.model.RenderingModel.class,ome.model.enums.RenderingModel.class);
        _omero2ome.put(omero.model.RenderingModelI.class,ome.model.enums.RenderingModel.class);

        _ome2omero.put(ome.model.display.ReverseIntensityContext.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.display.ReverseIntensityContext.class,omero.model.ReverseIntensityContextI.class);
        _omero2ome.put(omero.model.ReverseIntensityContext.class,ome.model.display.ReverseIntensityContext.class);
        _omero2ome.put(omero.model.ReverseIntensityContextI.class,ome.model.display.ReverseIntensityContext.class);

        _ome2omero.put(ome.model.roi.Roi.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.roi.Roi.class,omero.model.RoiI.class);
        _omero2ome.put(omero.model.Roi.class,ome.model.roi.Roi.class);
        _omero2ome.put(omero.model.RoiI.class,ome.model.roi.Roi.class);

        _ome2omero.put(ome.model.annotations.RoiAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.RoiAnnotationLink.class,omero.model.RoiAnnotationLinkI.class);
        _omero2ome.put(omero.model.RoiAnnotationLink.class,ome.model.annotations.RoiAnnotationLink.class);
        _omero2ome.put(omero.model.RoiAnnotationLinkI.class,ome.model.annotations.RoiAnnotationLink.class);

        _ome2omero.put(ome.model.screen.Screen.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.screen.Screen.class,omero.model.ScreenI.class);
        _omero2ome.put(omero.model.Screen.class,ome.model.screen.Screen.class);
        _omero2ome.put(omero.model.ScreenI.class,ome.model.screen.Screen.class);

        _ome2omero.put(ome.model.annotations.ScreenAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.ScreenAnnotationLink.class,omero.model.ScreenAnnotationLinkI.class);
        _omero2ome.put(omero.model.ScreenAnnotationLink.class,ome.model.annotations.ScreenAnnotationLink.class);
        _omero2ome.put(omero.model.ScreenAnnotationLinkI.class,ome.model.annotations.ScreenAnnotationLink.class);

        _ome2omero.put(ome.model.screen.ScreenPlateLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.screen.ScreenPlateLink.class,omero.model.ScreenPlateLinkI.class);
        _omero2ome.put(omero.model.ScreenPlateLink.class,ome.model.screen.ScreenPlateLink.class);
        _omero2ome.put(omero.model.ScreenPlateLinkI.class,ome.model.screen.ScreenPlateLink.class);

        _ome2omero.put(ome.model.jobs.ScriptJob.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.jobs.ScriptJob.class,omero.model.ScriptJobI.class);
        _omero2ome.put(omero.model.ScriptJob.class,ome.model.jobs.ScriptJob.class);
        _omero2ome.put(omero.model.ScriptJobI.class,ome.model.jobs.ScriptJob.class);

        _ome2omero.put(ome.model.meta.Session.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.meta.Session.class,omero.model.SessionI.class);
        _omero2ome.put(omero.model.Session.class,ome.model.meta.Session.class);
        _omero2ome.put(omero.model.SessionI.class,ome.model.meta.Session.class);

        _ome2omero.put(ome.model.annotations.SessionAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.SessionAnnotationLink.class,omero.model.SessionAnnotationLinkI.class);
        _omero2ome.put(omero.model.SessionAnnotationLink.class,ome.model.annotations.SessionAnnotationLink.class);
        _omero2ome.put(omero.model.SessionAnnotationLinkI.class,ome.model.annotations.SessionAnnotationLink.class);

        _ome2omero.put(ome.model.annotations.ShapeAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.ShapeAnnotationLink.class,omero.model.ShapeAnnotationLinkI.class);
        _omero2ome.put(omero.model.ShapeAnnotationLink.class,ome.model.annotations.ShapeAnnotationLink.class);
        _omero2ome.put(omero.model.ShapeAnnotationLinkI.class,ome.model.annotations.ShapeAnnotationLink.class);

        _ome2omero.put(ome.model.meta.Share.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.meta.Share.class,omero.model.ShareI.class);
        _omero2ome.put(omero.model.Share.class,ome.model.meta.Share.class);
        _omero2ome.put(omero.model.ShareI.class,ome.model.meta.Share.class);

        _ome2omero.put(ome.model.meta.ShareMember.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.meta.ShareMember.class,omero.model.ShareMemberI.class);
        _omero2ome.put(omero.model.ShareMember.class,ome.model.meta.ShareMember.class);
        _omero2ome.put(omero.model.ShareMemberI.class,ome.model.meta.ShareMember.class);

        _ome2omero.put(ome.model.acquisition.StageLabel.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.StageLabel.class,omero.model.StageLabelI.class);
        _omero2ome.put(omero.model.StageLabel.class,ome.model.acquisition.StageLabel.class);
        _omero2ome.put(omero.model.StageLabelI.class,ome.model.acquisition.StageLabel.class);

        _ome2omero.put(ome.model.stats.StatsInfo.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.stats.StatsInfo.class,omero.model.StatsInfoI.class);
        _omero2ome.put(omero.model.StatsInfo.class,ome.model.stats.StatsInfo.class);
        _omero2ome.put(omero.model.StatsInfoI.class,ome.model.stats.StatsInfo.class);

        _ome2omero.put(ome.model.annotations.TagAnnotation.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.TagAnnotation.class,omero.model.TagAnnotationI.class);
        _omero2ome.put(omero.model.TagAnnotation.class,ome.model.annotations.TagAnnotation.class);
        _omero2ome.put(omero.model.TagAnnotationI.class,ome.model.annotations.TagAnnotation.class);

        _ome2omero.put(ome.model.annotations.TermAnnotation.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.TermAnnotation.class,omero.model.TermAnnotationI.class);
        _omero2ome.put(omero.model.TermAnnotation.class,ome.model.annotations.TermAnnotation.class);
        _omero2ome.put(omero.model.TermAnnotationI.class,ome.model.annotations.TermAnnotation.class);

        _ome2omero.put(ome.model.display.Thumbnail.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.display.Thumbnail.class,omero.model.ThumbnailI.class);
        _omero2ome.put(omero.model.Thumbnail.class,ome.model.display.Thumbnail.class);
        _omero2ome.put(omero.model.ThumbnailI.class,ome.model.display.Thumbnail.class);

        _ome2omero.put(ome.model.jobs.ThumbnailGenerationJob.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.jobs.ThumbnailGenerationJob.class,omero.model.ThumbnailGenerationJobI.class);
        _omero2ome.put(omero.model.ThumbnailGenerationJob.class,ome.model.jobs.ThumbnailGenerationJob.class);
        _omero2ome.put(omero.model.ThumbnailGenerationJobI.class,ome.model.jobs.ThumbnailGenerationJob.class);

        _ome2omero.put(ome.model.annotations.TimestampAnnotation.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.TimestampAnnotation.class,omero.model.TimestampAnnotationI.class);
        _omero2ome.put(omero.model.TimestampAnnotation.class,ome.model.annotations.TimestampAnnotation.class);
        _omero2ome.put(omero.model.TimestampAnnotationI.class,ome.model.annotations.TimestampAnnotation.class);

        _ome2omero.put(ome.model.acquisition.TransmittanceRange.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.acquisition.TransmittanceRange.class,omero.model.TransmittanceRangeI.class);
        _omero2ome.put(omero.model.TransmittanceRange.class,ome.model.acquisition.TransmittanceRange.class);
        _omero2ome.put(omero.model.TransmittanceRangeI.class,ome.model.acquisition.TransmittanceRange.class);

        _ome2omero.put(ome.model.jobs.UploadJob.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.jobs.UploadJob.class,omero.model.UploadJobI.class);
        _omero2ome.put(omero.model.UploadJob.class,ome.model.jobs.UploadJob.class);
        _omero2ome.put(omero.model.UploadJobI.class,ome.model.jobs.UploadJob.class);

        _ome2omero.put(ome.model.screen.Well.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.screen.Well.class,omero.model.WellI.class);
        _omero2ome.put(omero.model.Well.class,ome.model.screen.Well.class);
        _omero2ome.put(omero.model.WellI.class,ome.model.screen.Well.class);

        _ome2omero.put(ome.model.annotations.WellAnnotationLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.WellAnnotationLink.class,omero.model.WellAnnotationLinkI.class);
        _omero2ome.put(omero.model.WellAnnotationLink.class,ome.model.annotations.WellAnnotationLink.class);
        _omero2ome.put(omero.model.WellAnnotationLinkI.class,ome.model.annotations.WellAnnotationLink.class);

        _ome2omero.put(ome.model.screen.WellReagentLink.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.screen.WellReagentLink.class,omero.model.WellReagentLinkI.class);
        _omero2ome.put(omero.model.WellReagentLink.class,ome.model.screen.WellReagentLink.class);
        _omero2ome.put(omero.model.WellReagentLinkI.class,ome.model.screen.WellReagentLink.class);

        _ome2omero.put(ome.model.screen.WellSample.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.screen.WellSample.class,omero.model.WellSampleI.class);
        _omero2ome.put(omero.model.WellSample.class,ome.model.screen.WellSample.class);
        _omero2ome.put(omero.model.WellSampleI.class,ome.model.screen.WellSample.class);

        _ome2omero.put(ome.model.annotations.XmlAnnotation.Details.class,omero.model.DetailsI.class);
        _ome2omero.put(ome.model.annotations.XmlAnnotation.class,omero.model.XmlAnnotationI.class);
        _omero2ome.put(omero.model.XmlAnnotation.class,ome.model.annotations.XmlAnnotation.class);
        _omero2ome.put(omero.model.XmlAnnotationI.class,ome.model.annotations.XmlAnnotation.class);

        _ome2omero.put(ome.model.internal.Details.class,omero.model.DetailsI.class);
        _omero2ome.put(omero.model.Details.class,ome.model.internal.Details.class);
        _omero2ome.put(omero.model.DetailsI.class,ome.model.internal.Details.class);

        _ome2omero.put(ome.model.internal.Permissions.class,omero.model.PermissionsI.class);
        _omero2ome.put(omero.model.Permissions.class,ome.model.internal.Permissions.class);
        _omero2ome.put(omero.model.PermissionsI.class,ome.model.internal.Permissions.class);

        //
        // Overriding values. This is primarily a workaround and a more
        // convenient way for specifying server-side implementation
        // classes needs to be worked out.
        //
        _ome2omero.put(ome.model.roi.Ellipse.class, omero.model.SmartEllipseI.class);
        _ome2omero.put(ome.model.roi.Line.class, omero.model.SmartLineI.class);
        _ome2omero.put(ome.model.roi.Mask.class, omero.model.SmartMaskI.class);
        _ome2omero.put(ome.model.roi.Path.class, omero.model.SmartPathI.class);
        _ome2omero.put(ome.model.roi.Point.class, omero.model.SmartPointI.class);
        _ome2omero.put(ome.model.roi.Polygon.class, omero.model.SmartPolygonI.class);
        _ome2omero.put(ome.model.roi.Polyline.class, omero.model.SmartPolylineI.class);
        _ome2omero.put(ome.model.roi.Rectangle.class, omero.model.SmartRectI.class);
        _ome2omero.put(ome.model.roi.Label.class, omero.model.SmartTextI.class);

        // Units
        _ome2omero.put(ome.model.units.ElectricPotential.class, omero.model.ElectricPotentialI.class);
        _omero2ome.put(omero.model.ElectricPotential.class, ome.model.units.ElectricPotential.class);
        _omero2ome.put(omero.model.ElectricPotentialI.class, ome.model.units.ElectricPotential.class);
        _ome2omero.put(ome.model.units.Frequency.class, omero.model.FrequencyI.class);
        _omero2ome.put(omero.model.Frequency.class, ome.model.units.Frequency.class);
        _omero2ome.put(omero.model.FrequencyI.class, ome.model.units.Frequency.class);
        _ome2omero.put(ome.model.units.Length.class, omero.model.LengthI.class);
        _omero2ome.put(omero.model.Length.class, ome.model.units.Length.class);
        _omero2ome.put(omero.model.LengthI.class, ome.model.units.Length.class);
        _ome2omero.put(ome.model.units.Power.class, omero.model.PowerI.class);
        _omero2ome.put(omero.model.Power.class, ome.model.units.Power.class);
        _omero2ome.put(omero.model.PowerI.class, ome.model.units.Power.class);
        _ome2omero.put(ome.model.units.Pressure.class, omero.model.PressureI.class);
        _omero2ome.put(omero.model.Pressure.class, ome.model.units.Pressure.class);
        _omero2ome.put(omero.model.PressureI.class, ome.model.units.Pressure.class);
        _ome2omero.put(ome.model.units.Temperature.class, omero.model.TemperatureI.class);
        _omero2ome.put(omero.model.Temperature.class, ome.model.units.Temperature.class);
        _omero2ome.put(omero.model.TemperatureI.class, ome.model.units.Temperature.class);
        _ome2omero.put(ome.model.units.Time.class, omero.model.TimeI.class);
        _omero2ome.put(omero.model.Time.class, ome.model.units.Time.class);
        _omero2ome.put(omero.model.TimeI.class, ome.model.units.Time.class);

        // Other
        _ome2omero.put(ome.model.internal.NamedValue.class, omero.model.NamedValue.class);
        _omero2ome.put(omero.model.NamedValue.class, ome.model.internal.NamedValue.class);

        // Sealing
        OMEtoOMERO = Collections.unmodifiableMap(_ome2omero);
        OMEROtoOME = Collections.unmodifiableMap(_omero2ome);
    }

}

