
/*
 *   $$Id$$
 *
 *   Copyright 2006-2011 University of Dundee. All rights reserved.
 *   Use is subject to license terms supplied in LICENSE.txt
 *
 */

//
// ModelObjectFactoryRegistry generated by templates/java_objs_reg.vm
//

package omero.util;

import omero.util.ObjectFactoryRegistry;

import omero.model.DetailsI;
import omero.model.PermissionsI;
import omero.model.ElectricPotentialI;
import omero.model.FrequencyI;
import omero.model.LengthI;
import omero.model.PowerI;
import omero.model.PressureI;
import omero.model.TemperatureI;
import omero.model.TimeI;

import Ice.Communicator;
import Ice.Object;

import java.util.Map;
import java.util.HashMap;

public class ModelObjectFactoryRegistry extends ObjectFactoryRegistry {

    public void setIceCommunicator(Communicator ic, omero.client client) {

        // Non-conditional
        ic.addObjectFactory(DetailsI.makeFactory(client), DetailsI.ice_staticId());
        ic.addObjectFactory(PermissionsI.Factory, PermissionsI.ice_staticId());
        ic.addObjectFactory(ElectricPotentialI.makeFactory(client), ElectricPotentialI.ice_staticId());
        ic.addObjectFactory(FrequencyI.makeFactory(client), FrequencyI.ice_staticId());
        ic.addObjectFactory(LengthI.makeFactory(client), LengthI.ice_staticId());
        ic.addObjectFactory(PowerI.makeFactory(client), PowerI.ice_staticId());
        ic.addObjectFactory(PressureI.makeFactory(client), PressureI.ice_staticId());
        ic.addObjectFactory(TemperatureI.makeFactory(client), TemperatureI.ice_staticId());
        ic.addObjectFactory(TimeI.makeFactory(client), TimeI.ice_staticId());

        // Conditional
        super.setIceCommunicator(ic);
    }

    @Override
    public void setIceCommunicator(Communicator ic) {

        // Non-conditional
        ic.addObjectFactory(DetailsI.Factory, DetailsI.ice_staticId());
        ic.addObjectFactory(PermissionsI.Factory, PermissionsI.ice_staticId());
        ic.addObjectFactory(ElectricPotentialI.Factory, ElectricPotentialI.ice_staticId());
        ic.addObjectFactory(FrequencyI.Factory, FrequencyI.ice_staticId());
        ic.addObjectFactory(LengthI.Factory, LengthI.ice_staticId());
        ic.addObjectFactory(PowerI.Factory, PowerI.ice_staticId());
        ic.addObjectFactory(PressureI.Factory, PressureI.ice_staticId());
        ic.addObjectFactory(TemperatureI.Factory, TemperatureI.ice_staticId());
        ic.addObjectFactory(TimeI.Factory, TimeI.ice_staticId());

        // Conditional
        super.setIceCommunicator(ic);
    }

    @Override
    public Map<String, ObjectFactory> createFactories(Ice.Communicator ic) {
        Map<String, ObjectFactory> factories = new HashMap<String, ObjectFactory>();
        factories.put("::omero::model::AcquisitionMode",
                new ObjectFactory("::omero::model::AcquisitionMode") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.AcquisitionModeI();
                    }
                });
        factories.put("::omero::model::AdminPrivilege",
                new ObjectFactory("::omero::model::AdminPrivilege") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.AdminPrivilegeI();
                    }
                });
        factories.put("::omero::model::AffineTransform",
                new ObjectFactory("::omero::model::AffineTransform") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.AffineTransformI();
                    }
                });
        factories.put("::omero::model::AnnotationAnnotationLink",
                new ObjectFactory("::omero::model::AnnotationAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.AnnotationAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::Arc",
                new ObjectFactory("::omero::model::Arc") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ArcI();
                    }
                });
        factories.put("::omero::model::ArcType",
                new ObjectFactory("::omero::model::ArcType") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ArcTypeI();
                    }
                });
        factories.put("::omero::model::Binning",
                new ObjectFactory("::omero::model::Binning") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.BinningI();
                    }
                });
        factories.put("::omero::model::BooleanAnnotation",
                new ObjectFactory("::omero::model::BooleanAnnotation") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.BooleanAnnotationI();
                    }
                });
        factories.put("::omero::model::Channel",
                new ObjectFactory("::omero::model::Channel") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ChannelI();
                    }
                });
        factories.put("::omero::model::ChannelAnnotationLink",
                new ObjectFactory("::omero::model::ChannelAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ChannelAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::ChannelBinding",
                new ObjectFactory("::omero::model::ChannelBinding") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ChannelBindingI();
                    }
                });
        factories.put("::omero::model::ChecksumAlgorithm",
                new ObjectFactory("::omero::model::ChecksumAlgorithm") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ChecksumAlgorithmI();
                    }
                });
        factories.put("::omero::model::CommentAnnotation",
                new ObjectFactory("::omero::model::CommentAnnotation") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.CommentAnnotationI();
                    }
                });
        factories.put("::omero::model::ContrastMethod",
                new ObjectFactory("::omero::model::ContrastMethod") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ContrastMethodI();
                    }
                });
        factories.put("::omero::model::ContrastStretchingContext",
                new ObjectFactory("::omero::model::ContrastStretchingContext") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ContrastStretchingContextI();
                    }
                });
        factories.put("::omero::model::Correction",
                new ObjectFactory("::omero::model::Correction") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.CorrectionI();
                    }
                });
        factories.put("::omero::model::DBPatch",
                new ObjectFactory("::omero::model::DBPatch") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.DBPatchI();
                    }
                });
        factories.put("::omero::model::Dataset",
                new ObjectFactory("::omero::model::Dataset") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.DatasetI();
                    }
                });
        factories.put("::omero::model::DatasetAnnotationLink",
                new ObjectFactory("::omero::model::DatasetAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.DatasetAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::DatasetImageLink",
                new ObjectFactory("::omero::model::DatasetImageLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.DatasetImageLinkI();
                    }
                });
        factories.put("::omero::model::Detector",
                new ObjectFactory("::omero::model::Detector") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.DetectorI();
                    }
                });
        factories.put("::omero::model::DetectorAnnotationLink",
                new ObjectFactory("::omero::model::DetectorAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.DetectorAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::DetectorSettings",
                new ObjectFactory("::omero::model::DetectorSettings") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.DetectorSettingsI();
                    }
                });
        factories.put("::omero::model::DetectorType",
                new ObjectFactory("::omero::model::DetectorType") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.DetectorTypeI();
                    }
                });
        factories.put("::omero::model::Dichroic",
                new ObjectFactory("::omero::model::Dichroic") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.DichroicI();
                    }
                });
        factories.put("::omero::model::DichroicAnnotationLink",
                new ObjectFactory("::omero::model::DichroicAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.DichroicAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::DimensionOrder",
                new ObjectFactory("::omero::model::DimensionOrder") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.DimensionOrderI();
                    }
                });
        factories.put("::omero::model::DoubleAnnotation",
                new ObjectFactory("::omero::model::DoubleAnnotation") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.DoubleAnnotationI();
                    }
                });
        factories.put("::omero::model::Ellipse",
                new ObjectFactory("::omero::model::Ellipse") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.EllipseI();
                    }
                });
        factories.put("::omero::model::Event",
                new ObjectFactory("::omero::model::Event") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.EventI();
                    }
                });
        factories.put("::omero::model::EventLog",
                new ObjectFactory("::omero::model::EventLog") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.EventLogI();
                    }
                });
        factories.put("::omero::model::EventType",
                new ObjectFactory("::omero::model::EventType") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.EventTypeI();
                    }
                });
        factories.put("::omero::model::Experiment",
                new ObjectFactory("::omero::model::Experiment") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ExperimentI();
                    }
                });
        factories.put("::omero::model::ExperimentType",
                new ObjectFactory("::omero::model::ExperimentType") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ExperimentTypeI();
                    }
                });
        factories.put("::omero::model::Experimenter",
                new ObjectFactory("::omero::model::Experimenter") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ExperimenterI();
                    }
                });
        factories.put("::omero::model::ExperimenterAnnotationLink",
                new ObjectFactory("::omero::model::ExperimenterAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ExperimenterAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::ExperimenterGroup",
                new ObjectFactory("::omero::model::ExperimenterGroup") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ExperimenterGroupI();
                    }
                });
        factories.put("::omero::model::ExperimenterGroupAnnotationLink",
                new ObjectFactory("::omero::model::ExperimenterGroupAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ExperimenterGroupAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::ExternalInfo",
                new ObjectFactory("::omero::model::ExternalInfo") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ExternalInfoI();
                    }
                });
        factories.put("::omero::model::Family",
                new ObjectFactory("::omero::model::Family") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FamilyI();
                    }
                });
        factories.put("::omero::model::Filament",
                new ObjectFactory("::omero::model::Filament") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FilamentI();
                    }
                });
        factories.put("::omero::model::FilamentType",
                new ObjectFactory("::omero::model::FilamentType") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FilamentTypeI();
                    }
                });
        factories.put("::omero::model::FileAnnotation",
                new ObjectFactory("::omero::model::FileAnnotation") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FileAnnotationI();
                    }
                });
        factories.put("::omero::model::Fileset",
                new ObjectFactory("::omero::model::Fileset") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FilesetI();
                    }
                });
        factories.put("::omero::model::FilesetAnnotationLink",
                new ObjectFactory("::omero::model::FilesetAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FilesetAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::FilesetEntry",
                new ObjectFactory("::omero::model::FilesetEntry") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FilesetEntryI();
                    }
                });
        factories.put("::omero::model::FilesetJobLink",
                new ObjectFactory("::omero::model::FilesetJobLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FilesetJobLinkI();
                    }
                });
        factories.put("::omero::model::Filter",
                new ObjectFactory("::omero::model::Filter") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FilterI();
                    }
                });
        factories.put("::omero::model::FilterAnnotationLink",
                new ObjectFactory("::omero::model::FilterAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FilterAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::FilterSet",
                new ObjectFactory("::omero::model::FilterSet") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FilterSetI();
                    }
                });
        factories.put("::omero::model::FilterSetEmissionFilterLink",
                new ObjectFactory("::omero::model::FilterSetEmissionFilterLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FilterSetEmissionFilterLinkI();
                    }
                });
        factories.put("::omero::model::FilterSetExcitationFilterLink",
                new ObjectFactory("::omero::model::FilterSetExcitationFilterLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FilterSetExcitationFilterLinkI();
                    }
                });
        factories.put("::omero::model::FilterType",
                new ObjectFactory("::omero::model::FilterType") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FilterTypeI();
                    }
                });
        factories.put("::omero::model::Folder",
                new ObjectFactory("::omero::model::Folder") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FolderI();
                    }
                });
        factories.put("::omero::model::FolderAnnotationLink",
                new ObjectFactory("::omero::model::FolderAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FolderAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::FolderImageLink",
                new ObjectFactory("::omero::model::FolderImageLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FolderImageLinkI();
                    }
                });
        factories.put("::omero::model::FolderRoiLink",
                new ObjectFactory("::omero::model::FolderRoiLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FolderRoiLinkI();
                    }
                });
        factories.put("::omero::model::Format",
                new ObjectFactory("::omero::model::Format") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.FormatI();
                    }
                });
        factories.put("::omero::model::GenericExcitationSource",
                new ObjectFactory("::omero::model::GenericExcitationSource") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.GenericExcitationSourceI();
                    }
                });
        factories.put("::omero::model::GroupExperimenterMap",
                new ObjectFactory("::omero::model::GroupExperimenterMap") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.GroupExperimenterMapI();
                    }
                });
        factories.put("::omero::model::Illumination",
                new ObjectFactory("::omero::model::Illumination") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.IlluminationI();
                    }
                });
        factories.put("::omero::model::Image",
                new ObjectFactory("::omero::model::Image") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ImageI();
                    }
                });
        factories.put("::omero::model::ImageAnnotationLink",
                new ObjectFactory("::omero::model::ImageAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ImageAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::ImagingEnvironment",
                new ObjectFactory("::omero::model::ImagingEnvironment") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ImagingEnvironmentI();
                    }
                });
        factories.put("::omero::model::Immersion",
                new ObjectFactory("::omero::model::Immersion") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ImmersionI();
                    }
                });
        factories.put("::omero::model::ImportJob",
                new ObjectFactory("::omero::model::ImportJob") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ImportJobI();
                    }
                });
        factories.put("::omero::model::IndexingJob",
                new ObjectFactory("::omero::model::IndexingJob") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.IndexingJobI();
                    }
                });
        factories.put("::omero::model::Instrument",
                new ObjectFactory("::omero::model::Instrument") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.InstrumentI();
                    }
                });
        factories.put("::omero::model::InstrumentAnnotationLink",
                new ObjectFactory("::omero::model::InstrumentAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.InstrumentAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::IntegrityCheckJob",
                new ObjectFactory("::omero::model::IntegrityCheckJob") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.IntegrityCheckJobI();
                    }
                });
        factories.put("::omero::model::JobOriginalFileLink",
                new ObjectFactory("::omero::model::JobOriginalFileLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.JobOriginalFileLinkI();
                    }
                });
        factories.put("::omero::model::JobStatus",
                new ObjectFactory("::omero::model::JobStatus") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.JobStatusI();
                    }
                });
        factories.put("::omero::model::Label",
                new ObjectFactory("::omero::model::Label") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.LabelI();
                    }
                });
        factories.put("::omero::model::Laser",
                new ObjectFactory("::omero::model::Laser") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.LaserI();
                    }
                });
        factories.put("::omero::model::LaserMedium",
                new ObjectFactory("::omero::model::LaserMedium") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.LaserMediumI();
                    }
                });
        factories.put("::omero::model::LaserType",
                new ObjectFactory("::omero::model::LaserType") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.LaserTypeI();
                    }
                });
        factories.put("::omero::model::LightEmittingDiode",
                new ObjectFactory("::omero::model::LightEmittingDiode") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.LightEmittingDiodeI();
                    }
                });
        factories.put("::omero::model::LightPath",
                new ObjectFactory("::omero::model::LightPath") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.LightPathI();
                    }
                });
        factories.put("::omero::model::LightPathAnnotationLink",
                new ObjectFactory("::omero::model::LightPathAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.LightPathAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::LightPathEmissionFilterLink",
                new ObjectFactory("::omero::model::LightPathEmissionFilterLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.LightPathEmissionFilterLinkI();
                    }
                });
        factories.put("::omero::model::LightPathExcitationFilterLink",
                new ObjectFactory("::omero::model::LightPathExcitationFilterLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.LightPathExcitationFilterLinkI();
                    }
                });
        factories.put("::omero::model::LightSettings",
                new ObjectFactory("::omero::model::LightSettings") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.LightSettingsI();
                    }
                });
        factories.put("::omero::model::LightSourceAnnotationLink",
                new ObjectFactory("::omero::model::LightSourceAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.LightSourceAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::Line",
                new ObjectFactory("::omero::model::Line") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.LineI();
                    }
                });
        factories.put("::omero::model::Link",
                new ObjectFactory("::omero::model::Link") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.LinkI();
                    }
                });
        factories.put("::omero::model::ListAnnotation",
                new ObjectFactory("::omero::model::ListAnnotation") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ListAnnotationI();
                    }
                });
        factories.put("::omero::model::LogicalChannel",
                new ObjectFactory("::omero::model::LogicalChannel") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.LogicalChannelI();
                    }
                });
        factories.put("::omero::model::LongAnnotation",
                new ObjectFactory("::omero::model::LongAnnotation") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.LongAnnotationI();
                    }
                });
        factories.put("::omero::model::MapAnnotation",
                new ObjectFactory("::omero::model::MapAnnotation") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.MapAnnotationI();
                    }
                });
        factories.put("::omero::model::Mask",
                new ObjectFactory("::omero::model::Mask") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.MaskI();
                    }
                });
        factories.put("::omero::model::Medium",
                new ObjectFactory("::omero::model::Medium") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.MediumI();
                    }
                });
        factories.put("::omero::model::MetadataImportJob",
                new ObjectFactory("::omero::model::MetadataImportJob") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.MetadataImportJobI();
                    }
                });
        factories.put("::omero::model::MicrobeamManipulation",
                new ObjectFactory("::omero::model::MicrobeamManipulation") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.MicrobeamManipulationI();
                    }
                });
        factories.put("::omero::model::MicrobeamManipulationType",
                new ObjectFactory("::omero::model::MicrobeamManipulationType") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.MicrobeamManipulationTypeI();
                    }
                });
        factories.put("::omero::model::Microscope",
                new ObjectFactory("::omero::model::Microscope") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.MicroscopeI();
                    }
                });
        factories.put("::omero::model::MicroscopeType",
                new ObjectFactory("::omero::model::MicroscopeType") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.MicroscopeTypeI();
                    }
                });
        factories.put("::omero::model::Namespace",
                new ObjectFactory("::omero::model::Namespace") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.NamespaceI();
                    }
                });
        factories.put("::omero::model::NamespaceAnnotationLink",
                new ObjectFactory("::omero::model::NamespaceAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.NamespaceAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::Node",
                new ObjectFactory("::omero::model::Node") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.NodeI();
                    }
                });
        factories.put("::omero::model::NodeAnnotationLink",
                new ObjectFactory("::omero::model::NodeAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.NodeAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::OTF",
                new ObjectFactory("::omero::model::OTF") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.OTFI();
                    }
                });
        factories.put("::omero::model::Objective",
                new ObjectFactory("::omero::model::Objective") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ObjectiveI();
                    }
                });
        factories.put("::omero::model::ObjectiveAnnotationLink",
                new ObjectFactory("::omero::model::ObjectiveAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ObjectiveAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::ObjectiveSettings",
                new ObjectFactory("::omero::model::ObjectiveSettings") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ObjectiveSettingsI();
                    }
                });
        factories.put("::omero::model::OriginalFile",
                new ObjectFactory("::omero::model::OriginalFile") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.OriginalFileI();
                    }
                });
        factories.put("::omero::model::OriginalFileAnnotationLink",
                new ObjectFactory("::omero::model::OriginalFileAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.OriginalFileAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::ParseJob",
                new ObjectFactory("::omero::model::ParseJob") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ParseJobI();
                    }
                });
        factories.put("::omero::model::Path",
                new ObjectFactory("::omero::model::Path") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.PathI();
                    }
                });
        factories.put("::omero::model::PhotometricInterpretation",
                new ObjectFactory("::omero::model::PhotometricInterpretation") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.PhotometricInterpretationI();
                    }
                });
        factories.put("::omero::model::PixelDataJob",
                new ObjectFactory("::omero::model::PixelDataJob") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.PixelDataJobI();
                    }
                });
        factories.put("::omero::model::Pixels",
                new ObjectFactory("::omero::model::Pixels") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.PixelsI();
                    }
                });
        factories.put("::omero::model::PixelsOriginalFileMap",
                new ObjectFactory("::omero::model::PixelsOriginalFileMap") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.PixelsOriginalFileMapI();
                    }
                });
        factories.put("::omero::model::PixelsType",
                new ObjectFactory("::omero::model::PixelsType") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.PixelsTypeI();
                    }
                });
        factories.put("::omero::model::PlaneInfo",
                new ObjectFactory("::omero::model::PlaneInfo") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.PlaneInfoI();
                    }
                });
        factories.put("::omero::model::PlaneInfoAnnotationLink",
                new ObjectFactory("::omero::model::PlaneInfoAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.PlaneInfoAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::PlaneSlicingContext",
                new ObjectFactory("::omero::model::PlaneSlicingContext") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.PlaneSlicingContextI();
                    }
                });
        factories.put("::omero::model::Plate",
                new ObjectFactory("::omero::model::Plate") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.PlateI();
                    }
                });
        factories.put("::omero::model::PlateAcquisition",
                new ObjectFactory("::omero::model::PlateAcquisition") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.PlateAcquisitionI();
                    }
                });
        factories.put("::omero::model::PlateAcquisitionAnnotationLink",
                new ObjectFactory("::omero::model::PlateAcquisitionAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.PlateAcquisitionAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::PlateAnnotationLink",
                new ObjectFactory("::omero::model::PlateAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.PlateAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::Point",
                new ObjectFactory("::omero::model::Point") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.PointI();
                    }
                });
        factories.put("::omero::model::Polygon",
                new ObjectFactory("::omero::model::Polygon") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.PolygonI();
                    }
                });
        factories.put("::omero::model::Polyline",
                new ObjectFactory("::omero::model::Polyline") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.PolylineI();
                    }
                });
        factories.put("::omero::model::Project",
                new ObjectFactory("::omero::model::Project") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ProjectI();
                    }
                });
        factories.put("::omero::model::ProjectAnnotationLink",
                new ObjectFactory("::omero::model::ProjectAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ProjectAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::ProjectDatasetLink",
                new ObjectFactory("::omero::model::ProjectDatasetLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ProjectDatasetLinkI();
                    }
                });
        factories.put("::omero::model::ProjectionAxis",
                new ObjectFactory("::omero::model::ProjectionAxis") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ProjectionAxisI();
                    }
                });
        factories.put("::omero::model::ProjectionDef",
                new ObjectFactory("::omero::model::ProjectionDef") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ProjectionDefI();
                    }
                });
        factories.put("::omero::model::ProjectionType",
                new ObjectFactory("::omero::model::ProjectionType") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ProjectionTypeI();
                    }
                });
        factories.put("::omero::model::Pulse",
                new ObjectFactory("::omero::model::Pulse") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.PulseI();
                    }
                });
        factories.put("::omero::model::QuantumDef",
                new ObjectFactory("::omero::model::QuantumDef") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.QuantumDefI();
                    }
                });
        factories.put("::omero::model::Reagent",
                new ObjectFactory("::omero::model::Reagent") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ReagentI();
                    }
                });
        factories.put("::omero::model::ReagentAnnotationLink",
                new ObjectFactory("::omero::model::ReagentAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ReagentAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::Rectangle",
                new ObjectFactory("::omero::model::Rectangle") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.RectangleI();
                    }
                });
        factories.put("::omero::model::RenderingDef",
                new ObjectFactory("::omero::model::RenderingDef") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.RenderingDefI();
                    }
                });
        factories.put("::omero::model::RenderingModel",
                new ObjectFactory("::omero::model::RenderingModel") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.RenderingModelI();
                    }
                });
        factories.put("::omero::model::ReverseIntensityContext",
                new ObjectFactory("::omero::model::ReverseIntensityContext") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ReverseIntensityContextI();
                    }
                });
        factories.put("::omero::model::Roi",
                new ObjectFactory("::omero::model::Roi") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.RoiI();
                    }
                });
        factories.put("::omero::model::RoiAnnotationLink",
                new ObjectFactory("::omero::model::RoiAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.RoiAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::Screen",
                new ObjectFactory("::omero::model::Screen") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ScreenI();
                    }
                });
        factories.put("::omero::model::ScreenAnnotationLink",
                new ObjectFactory("::omero::model::ScreenAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ScreenAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::ScreenPlateLink",
                new ObjectFactory("::omero::model::ScreenPlateLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ScreenPlateLinkI();
                    }
                });
        factories.put("::omero::model::ScriptJob",
                new ObjectFactory("::omero::model::ScriptJob") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ScriptJobI();
                    }
                });
        factories.put("::omero::model::Session",
                new ObjectFactory("::omero::model::Session") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.SessionI();
                    }
                });
        factories.put("::omero::model::SessionAnnotationLink",
                new ObjectFactory("::omero::model::SessionAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.SessionAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::ShapeAnnotationLink",
                new ObjectFactory("::omero::model::ShapeAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ShapeAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::Share",
                new ObjectFactory("::omero::model::Share") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ShareI();
                    }
                });
        factories.put("::omero::model::ShareMember",
                new ObjectFactory("::omero::model::ShareMember") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ShareMemberI();
                    }
                });
        factories.put("::omero::model::StageLabel",
                new ObjectFactory("::omero::model::StageLabel") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.StageLabelI();
                    }
                });
        factories.put("::omero::model::StatsInfo",
                new ObjectFactory("::omero::model::StatsInfo") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.StatsInfoI();
                    }
                });
        factories.put("::omero::model::TagAnnotation",
                new ObjectFactory("::omero::model::TagAnnotation") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.TagAnnotationI();
                    }
                });
        factories.put("::omero::model::TermAnnotation",
                new ObjectFactory("::omero::model::TermAnnotation") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.TermAnnotationI();
                    }
                });
        factories.put("::omero::model::Thumbnail",
                new ObjectFactory("::omero::model::Thumbnail") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ThumbnailI();
                    }
                });
        factories.put("::omero::model::ThumbnailGenerationJob",
                new ObjectFactory("::omero::model::ThumbnailGenerationJob") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.ThumbnailGenerationJobI();
                    }
                });
        factories.put("::omero::model::TimestampAnnotation",
                new ObjectFactory("::omero::model::TimestampAnnotation") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.TimestampAnnotationI();
                    }
                });
        factories.put("::omero::model::TransmittanceRange",
                new ObjectFactory("::omero::model::TransmittanceRange") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.TransmittanceRangeI();
                    }
                });
        factories.put("::omero::model::UploadJob",
                new ObjectFactory("::omero::model::UploadJob") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.UploadJobI();
                    }
                });
        factories.put("::omero::model::Well",
                new ObjectFactory("::omero::model::Well") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.WellI();
                    }
                });
        factories.put("::omero::model::WellAnnotationLink",
                new ObjectFactory("::omero::model::WellAnnotationLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.WellAnnotationLinkI();
                    }
                });
        factories.put("::omero::model::WellReagentLink",
                new ObjectFactory("::omero::model::WellReagentLink") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.WellReagentLinkI();
                    }
                });
        factories.put("::omero::model::WellSample",
                new ObjectFactory("::omero::model::WellSample") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.WellSampleI();
                    }
                });
        factories.put("::omero::model::XmlAnnotation",
                new ObjectFactory("::omero::model::XmlAnnotation") {
                    @Override
                    public Object create(String name) {
                        return new omero.model.XmlAnnotationI();
                    }
                });
        return factories;
    }
}
