/*
 * org.openmicroscopy.shoola.util.roi.figures.ShapeTypeList 
 *
  *------------------------------------------------------------------------------
 *  Copyright (C) 2006-2007 University of Dundee. All rights reserved.
 *
 *
 * 	This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *------------------------------------------------------------------------------
 */
package org.openmicroscopy.shoola.util.roi.figures;



//Java imports
import java.util.ArrayList;
import java.util.List;


//Third-party libraries

//Application-internal dependencies

/** 
 * Supported shapes
 * 
 * @author  Jean-Marie Burel &nbsp;&nbsp;&nbsp;&nbsp;
 * 	<a href="mailto:j.burel@dundee.ac.uk">j.burel@dundee.ac.uk</a>
 * @author	Donald MacDonald &nbsp;&nbsp;&nbsp;&nbsp;
 * 	<a href="mailto:donald@lifesci.dundee.ac.uk">donald@lifesci.dundee.ac.uk</a>
 * @version 3.0
 * <small>
 * (<b>Internal version:</b> $Revision: $Date: $)
 * </small>
 * @since OME3.0
 */
public class ShapeTypes
{	
	
	/** The collection of supported shapes. */
	public static final List<String> SHAPE_LIST; 
	
	static 
	{
		SHAPE_LIST = new ArrayList<String>();
		SHAPE_LIST.add("Ellipse");
		SHAPE_LIST.add("Rectangle");
		SHAPE_LIST.add("Polygon");
		SHAPE_LIST.add("Line Connection");
		SHAPE_LIST.add("Line");
		SHAPE_LIST.add("Scribble");
		SHAPE_LIST.add("Point");
		SHAPE_LIST.add("Text");
		SHAPE_LIST.add("Mask");
		
	};
}