// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IAdmin.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Administration interface providing access to admin-only
 * functionality as well as JMX-based server access and selected user
 * functions. Most methods require membership in privileged
 * {@link omero.model.ExperimenterGroup groups}.
 * 
 * Methods which return {@link omero.model.Experimenter} or
 * {@link omero.model.ExperimenterGroup} instances fetch and load all
 * related instances of {@link omero.model.ExperimenterGroup} or
 * {@link omero.model.Experimenter}, respectively.
 * 
 **/
public interface IAdminPrx extends ServiceInterfacePrx
{
    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     **/
    public boolean canUpdate(omero.model.IObject obj)
        throws omero.ServerError;

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean canUpdate(omero.model.IObject obj, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_canUpdate(omero.model.IObject obj);

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_canUpdate(omero.model.IObject obj, java.util.Map<String, String> __ctx);

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_canUpdate(omero.model.IObject obj, Ice.Callback __cb);

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_canUpdate(omero.model.IObject obj, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_canUpdate(omero.model.IObject obj, Callback_IAdmin_canUpdate __cb);

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_canUpdate(omero.model.IObject obj, java.util.Map<String, String> __ctx, Callback_IAdmin_canUpdate __cb);

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __result The asynchronous result object.
     **/
    public boolean end_canUpdate(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __cb The callback object for the operation.
     **/
    public boolean canUpdate_async(AMI_IAdmin_canUpdate __cb, omero.model.IObject obj);

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean canUpdate_async(AMI_IAdmin_canUpdate __cb, omero.model.IObject obj, java.util.Map<String, String> __ctx);

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param id id of the Experimenter
     * @return an Experimenter. Never null.
     * @throws ApiUsageException if id does not exist.
     **/
    public omero.model.Experimenter getExperimenter(long id)
        throws omero.ServerError;

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param id id of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     * @return an Experimenter. Never null.
     * @throws ApiUsageException if id does not exist.
     **/
    public omero.model.Experimenter getExperimenter(long id, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param id id of the Experimenter
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getExperimenter(long id);

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param id id of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getExperimenter(long id, java.util.Map<String, String> __ctx);

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param id id of the Experimenter
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getExperimenter(long id, Ice.Callback __cb);

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param id id of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getExperimenter(long id, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param id id of the Experimenter
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getExperimenter(long id, Callback_IAdmin_getExperimenter __cb);

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param id id of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getExperimenter(long id, java.util.Map<String, String> __ctx, Callback_IAdmin_getExperimenter __cb);

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param __result The asynchronous result object.
     * @return an Experimenter. Never null.
     * @throws ApiUsageException if id does not exist.
     **/
    public omero.model.Experimenter end_getExperimenter(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the Experimenter
     **/
    public boolean getExperimenter_async(AMI_IAdmin_getExperimenter __cb, long id);

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getExperimenter_async(AMI_IAdmin_getExperimenter __cb, long id, java.util.Map<String, String> __ctx);

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param name Name of the Experimenter
     * @return an Experimenter. Never null.
     * @throws ApiUsageException if omeName does not exist.
     **/
    public omero.model.Experimenter lookupExperimenter(String name)
        throws omero.ServerError;

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param name Name of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     * @return an Experimenter. Never null.
     * @throws ApiUsageException if omeName does not exist.
     **/
    public omero.model.Experimenter lookupExperimenter(String name, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param name Name of the Experimenter
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupExperimenter(String name);

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param name Name of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupExperimenter(String name, java.util.Map<String, String> __ctx);

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param name Name of the Experimenter
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupExperimenter(String name, Ice.Callback __cb);

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param name Name of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupExperimenter(String name, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param name Name of the Experimenter
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupExperimenter(String name, Callback_IAdmin_lookupExperimenter __cb);

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param name Name of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupExperimenter(String name, java.util.Map<String, String> __ctx, Callback_IAdmin_lookupExperimenter __cb);

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param __result The asynchronous result object.
     * @return an Experimenter. Never null.
     * @throws ApiUsageException if omeName does not exist.
     **/
    public omero.model.Experimenter end_lookupExperimenter(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the Experimenter
     **/
    public boolean lookupExperimenter_async(AMI_IAdmin_lookupExperimenter __cb, String name);

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean lookupExperimenter_async(AMI_IAdmin_lookupExperimenter __cb, String name, java.util.Map<String, String> __ctx);

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @return all Experimenters. Never null.
     **/
    public java.util.List<omero.model.Experimenter> lookupExperimenters()
        throws omero.ServerError;

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return all Experimenters. Never null.
     **/
    public java.util.List<omero.model.Experimenter> lookupExperimenters(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupExperimenters();

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupExperimenters(java.util.Map<String, String> __ctx);

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupExperimenters(Ice.Callback __cb);

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupExperimenters(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupExperimenters(Callback_IAdmin_lookupExperimenters __cb);

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupExperimenters(java.util.Map<String, String> __ctx, Callback_IAdmin_lookupExperimenters __cb);

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __result The asynchronous result object.
     * @return all Experimenters. Never null.
     **/
    public java.util.List<omero.model.Experimenter> end_lookupExperimenters(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean lookupExperimenters_async(AMI_IAdmin_lookupExperimenters __cb);

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean lookupExperimenters_async(AMI_IAdmin_lookupExperimenters __cb, java.util.Map<String, String> __ctx);

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param id id of the ExperimenterGroup
     * @return an ExperimenterGroup. Never null.
     * @throws ApiUsageException if id does not exist.
     **/
    public omero.model.ExperimenterGroup getGroup(long id)
        throws omero.ServerError;

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param id id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     * @return an ExperimenterGroup. Never null.
     * @throws ApiUsageException if id does not exist.
     **/
    public omero.model.ExperimenterGroup getGroup(long id, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param id id of the ExperimenterGroup
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getGroup(long id);

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param id id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getGroup(long id, java.util.Map<String, String> __ctx);

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param id id of the ExperimenterGroup
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getGroup(long id, Ice.Callback __cb);

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param id id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getGroup(long id, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param id id of the ExperimenterGroup
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getGroup(long id, Callback_IAdmin_getGroup __cb);

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param id id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getGroup(long id, java.util.Map<String, String> __ctx, Callback_IAdmin_getGroup __cb);

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param __result The asynchronous result object.
     * @return an ExperimenterGroup. Never null.
     * @throws ApiUsageException if id does not exist.
     **/
    public omero.model.ExperimenterGroup end_getGroup(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the ExperimenterGroup
     **/
    public boolean getGroup_async(AMI_IAdmin_getGroup __cb, long id);

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getGroup_async(AMI_IAdmin_getGroup __cb, long id, java.util.Map<String, String> __ctx);

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param name Name of the ExperimenterGroup
     * @return an ExperimenterGroup. Never null.
     * @throws ApiUsageException if groupName does not exist.
     **/
    public omero.model.ExperimenterGroup lookupGroup(String name)
        throws omero.ServerError;

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param name Name of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     * @return an ExperimenterGroup. Never null.
     * @throws ApiUsageException if groupName does not exist.
     **/
    public omero.model.ExperimenterGroup lookupGroup(String name, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param name Name of the ExperimenterGroup
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupGroup(String name);

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param name Name of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupGroup(String name, java.util.Map<String, String> __ctx);

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param name Name of the ExperimenterGroup
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupGroup(String name, Ice.Callback __cb);

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param name Name of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupGroup(String name, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param name Name of the ExperimenterGroup
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupGroup(String name, Callback_IAdmin_lookupGroup __cb);

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param name Name of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupGroup(String name, java.util.Map<String, String> __ctx, Callback_IAdmin_lookupGroup __cb);

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param __result The asynchronous result object.
     * @return an ExperimenterGroup. Never null.
     * @throws ApiUsageException if groupName does not exist.
     **/
    public omero.model.ExperimenterGroup end_lookupGroup(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the ExperimenterGroup
     **/
    public boolean lookupGroup_async(AMI_IAdmin_lookupGroup __cb, String name);

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean lookupGroup_async(AMI_IAdmin_lookupGroup __cb, String name, java.util.Map<String, String> __ctx);

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @return all Groups. Never null.
     **/
    public java.util.List<omero.model.ExperimenterGroup> lookupGroups()
        throws omero.ServerError;

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return all Groups. Never null.
     **/
    public java.util.List<omero.model.ExperimenterGroup> lookupGroups(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupGroups();

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupGroups(java.util.Map<String, String> __ctx);

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupGroups(Ice.Callback __cb);

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupGroups(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupGroups(Callback_IAdmin_lookupGroups __cb);

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupGroups(java.util.Map<String, String> __ctx, Callback_IAdmin_lookupGroups __cb);

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __result The asynchronous result object.
     * @return all Groups. Never null.
     **/
    public java.util.List<omero.model.ExperimenterGroup> end_lookupGroups(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean lookupGroups_async(AMI_IAdmin_lookupGroups __cb);

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean lookupGroups_async(AMI_IAdmin_lookupGroups __cb, java.util.Map<String, String> __ctx);

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param groupId id of the ExperimenterGroup
     * @return non-null array of all
     * {@link omero.model.Experimenter} users in this group.
     **/
    public java.util.List<omero.model.Experimenter> containedExperimenters(long groupId)
        throws omero.ServerError;

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param groupId id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     * @return non-null array of all
     * {@link omero.model.Experimenter} users in this group.
     **/
    public java.util.List<omero.model.Experimenter> containedExperimenters(long groupId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param groupId id of the ExperimenterGroup
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_containedExperimenters(long groupId);

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param groupId id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_containedExperimenters(long groupId, java.util.Map<String, String> __ctx);

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param groupId id of the ExperimenterGroup
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_containedExperimenters(long groupId, Ice.Callback __cb);

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param groupId id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_containedExperimenters(long groupId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param groupId id of the ExperimenterGroup
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_containedExperimenters(long groupId, Callback_IAdmin_containedExperimenters __cb);

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param groupId id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_containedExperimenters(long groupId, java.util.Map<String, String> __ctx, Callback_IAdmin_containedExperimenters __cb);

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param __result The asynchronous result object.
     * @return non-null array of all
     * {@link omero.model.Experimenter} users in this group.
     **/
    public java.util.List<omero.model.Experimenter> end_containedExperimenters(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param groupId id of the ExperimenterGroup
     **/
    public boolean containedExperimenters_async(AMI_IAdmin_containedExperimenters __cb, long groupId);

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param groupId id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean containedExperimenters_async(AMI_IAdmin_containedExperimenters __cb, long groupId, java.util.Map<String, String> __ctx);

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param experimenterId id of the Experimenter. Not null.
     * @return non-null array of all
     * {@link omero.model.ExperimenterGroup} groups for this user.
     **/
    public java.util.List<omero.model.ExperimenterGroup> containedGroups(long experimenterId)
        throws omero.ServerError;

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param experimenterId id of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return non-null array of all
     * {@link omero.model.ExperimenterGroup} groups for this user.
     **/
    public java.util.List<omero.model.ExperimenterGroup> containedGroups(long experimenterId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param experimenterId id of the Experimenter. Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_containedGroups(long experimenterId);

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param experimenterId id of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_containedGroups(long experimenterId, java.util.Map<String, String> __ctx);

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param experimenterId id of the Experimenter. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_containedGroups(long experimenterId, Ice.Callback __cb);

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param experimenterId id of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_containedGroups(long experimenterId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param experimenterId id of the Experimenter. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_containedGroups(long experimenterId, Callback_IAdmin_containedGroups __cb);

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param experimenterId id of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_containedGroups(long experimenterId, java.util.Map<String, String> __ctx, Callback_IAdmin_containedGroups __cb);

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param __result The asynchronous result object.
     * @return non-null array of all
     * {@link omero.model.ExperimenterGroup} groups for this user.
     **/
    public java.util.List<omero.model.ExperimenterGroup> end_containedGroups(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId id of the Experimenter. Not null.
     **/
    public boolean containedGroups_async(AMI_IAdmin_containedGroups __cb, long experimenterId);

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId id of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean containedGroups_async(AMI_IAdmin_containedGroups __cb, long experimenterId, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param experimenterId of the Experimenter. Not null.
     * @return non-null {@link omero.model.ExperimenterGroup}. If
     * no default group is found, an exception will be
     * thrown.
     **/
    public omero.model.ExperimenterGroup getDefaultGroup(long experimenterId)
        throws omero.ServerError;

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param experimenterId of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return non-null {@link omero.model.ExperimenterGroup}. If
     * no default group is found, an exception will be
     * thrown.
     **/
    public omero.model.ExperimenterGroup getDefaultGroup(long experimenterId, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param experimenterId of the Experimenter. Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDefaultGroup(long experimenterId);

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param experimenterId of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDefaultGroup(long experimenterId, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param experimenterId of the Experimenter. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDefaultGroup(long experimenterId, Ice.Callback __cb);

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param experimenterId of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDefaultGroup(long experimenterId, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param experimenterId of the Experimenter. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDefaultGroup(long experimenterId, Callback_IAdmin_getDefaultGroup __cb);

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param experimenterId of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getDefaultGroup(long experimenterId, java.util.Map<String, String> __ctx, Callback_IAdmin_getDefaultGroup __cb);

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param __result The asynchronous result object.
     * @return non-null {@link omero.model.ExperimenterGroup}. If
     * no default group is found, an exception will be
     * thrown.
     **/
    public omero.model.ExperimenterGroup end_getDefaultGroup(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId of the Experimenter. Not null.
     **/
    public boolean getDefaultGroup_async(AMI_IAdmin_getDefaultGroup __cb, long experimenterId);

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getDefaultGroup_async(AMI_IAdmin_getDefaultGroup __cb, long experimenterId, java.util.Map<String, String> __ctx);

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @return Experimenter. Never null.
     **/
    public String lookupLdapAuthExperimenter(long id)
        throws omero.ServerError;

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return Experimenter. Never null.
     **/
    public String lookupLdapAuthExperimenter(long id, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenter(long id);

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenter(long id, java.util.Map<String, String> __ctx);

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenter(long id, Ice.Callback __cb);

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenter(long id, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenter(long id, Callback_IAdmin_lookupLdapAuthExperimenter __cb);

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenter(long id, java.util.Map<String, String> __ctx, Callback_IAdmin_lookupLdapAuthExperimenter __cb);

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __result The asynchronous result object.
     * @return Experimenter. Never null.
     **/
    public String end_lookupLdapAuthExperimenter(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean lookupLdapAuthExperimenter_async(AMI_IAdmin_lookupLdapAuthExperimenter __cb, long id);

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean lookupLdapAuthExperimenter_async(AMI_IAdmin_lookupLdapAuthExperimenter __cb, long id, java.util.Map<String, String> __ctx);

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @return list of experimenters. Never null.
     **/
    public omero.RList lookupLdapAuthExperimenters()
        throws omero.ServerError;

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return list of experimenters. Never null.
     **/
    public omero.RList lookupLdapAuthExperimenters(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenters();

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenters(java.util.Map<String, String> __ctx);

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenters(Ice.Callback __cb);

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenters(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenters(Callback_IAdmin_lookupLdapAuthExperimenters __cb);

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenters(java.util.Map<String, String> __ctx, Callback_IAdmin_lookupLdapAuthExperimenters __cb);

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __result The asynchronous result object.
     * @return list of experimenters. Never null.
     **/
    public omero.RList end_lookupLdapAuthExperimenters(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean lookupLdapAuthExperimenters_async(AMI_IAdmin_lookupLdapAuthExperimenters __cb);

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean lookupLdapAuthExperimenters_async(AMI_IAdmin_lookupLdapAuthExperimenters __cb, java.util.Map<String, String> __ctx);

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @see omero.model.Details#getOwner
     **/
    public java.util.List<Long> getMemberOfGroupIds(omero.model.Experimenter exp)
        throws omero.ServerError;

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @see omero.model.Details#getOwner
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<Long> getMemberOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberOfGroupIds(omero.model.Experimenter exp);

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx);

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberOfGroupIds(omero.model.Experimenter exp, Ice.Callback __cb);

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberOfGroupIds(omero.model.Experimenter exp, Callback_IAdmin_getMemberOfGroupIds __cb);

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMemberOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Callback_IAdmin_getMemberOfGroupIds __cb);

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __result The asynchronous result object.
     * @see omero.model.Details#getOwner
     **/
    public java.util.List<Long> end_getMemberOfGroupIds(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     **/
    public boolean getMemberOfGroupIds_async(AMI_IAdmin_getMemberOfGroupIds __cb, omero.model.Experimenter exp);

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getMemberOfGroupIds_async(AMI_IAdmin_getMemberOfGroupIds __cb, omero.model.Experimenter exp, java.util.Map<String, String> __ctx);

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @see omero.model.Details#getOwner
     **/
    public java.util.List<Long> getLeaderOfGroupIds(omero.model.Experimenter exp)
        throws omero.ServerError;

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @see omero.model.Details#getOwner
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<Long> getLeaderOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getLeaderOfGroupIds(omero.model.Experimenter exp);

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getLeaderOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx);

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getLeaderOfGroupIds(omero.model.Experimenter exp, Ice.Callback __cb);

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getLeaderOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getLeaderOfGroupIds(omero.model.Experimenter exp, Callback_IAdmin_getLeaderOfGroupIds __cb);

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getLeaderOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Callback_IAdmin_getLeaderOfGroupIds __cb);

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param __result The asynchronous result object.
     * @see omero.model.Details#getOwner
     **/
    public java.util.List<Long> end_getLeaderOfGroupIds(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     **/
    public boolean getLeaderOfGroupIds_async(AMI_IAdmin_getLeaderOfGroupIds __cb, omero.model.Experimenter exp);

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getLeaderOfGroupIds_async(AMI_IAdmin_getLeaderOfGroupIds __cb, omero.model.Experimenter exp, java.util.Map<String, String> __ctx);

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @see #setDefaultGroup
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     **/
    public void updateSelf(omero.model.Experimenter experimenter)
        throws omero.ServerError;

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @see #setDefaultGroup
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void updateSelf(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateSelf(omero.model.Experimenter experimenter);

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateSelf(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx);

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateSelf(omero.model.Experimenter experimenter, Ice.Callback __cb);

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateSelf(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateSelf(omero.model.Experimenter experimenter, Callback_IAdmin_updateSelf __cb);

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateSelf(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx, Callback_IAdmin_updateSelf __cb);

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param __result The asynchronous result object.
     * @see #setDefaultGroup
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     **/
    public void end_updateSelf(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     **/
    public boolean updateSelf_async(AMI_IAdmin_updateSelf __cb, omero.model.Experimenter experimenter);

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean updateSelf_async(AMI_IAdmin_updateSelf __cb, omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx);

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param filename Not null. String name which will be used.
     * @param format Not null. Format.value string. 'image/jpeg'
     * and 'image/png' are common values.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     * @return the id of the overwritten or newly created user
     * photo OriginalFile object.
     **/
    public long uploadMyUserPhoto(String filename, String format, byte[] data)
        throws omero.ServerError;

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param filename Not null. String name which will be used.
     * @param format Not null. Format.value string. 'image/jpeg'
     * and 'image/png' are common values.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     * @param __ctx The Context map to send with the invocation.
     * @return the id of the overwritten or newly created user
     * photo OriginalFile object.
     **/
    public long uploadMyUserPhoto(String filename, String format, byte[] data, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param filename Not null. String name which will be used.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_uploadMyUserPhoto(String filename, String format, byte[] data);

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param filename Not null. String name which will be used.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_uploadMyUserPhoto(String filename, String format, byte[] data, java.util.Map<String, String> __ctx);

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param filename Not null. String name which will be used.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_uploadMyUserPhoto(String filename, String format, byte[] data, Ice.Callback __cb);

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param filename Not null. String name which will be used.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_uploadMyUserPhoto(String filename, String format, byte[] data, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param filename Not null. String name which will be used.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_uploadMyUserPhoto(String filename, String format, byte[] data, Callback_IAdmin_uploadMyUserPhoto __cb);

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param filename Not null. String name which will be used.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_uploadMyUserPhoto(String filename, String format, byte[] data, java.util.Map<String, String> __ctx, Callback_IAdmin_uploadMyUserPhoto __cb);

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param __result The asynchronous result object.
     * @return the id of the overwritten or newly created user
     * photo OriginalFile object.
     **/
    public long end_uploadMyUserPhoto(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param __cb The callback object for the operation.
     * @param filename Not null. String name which will be used.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     **/
    public boolean uploadMyUserPhoto_async(AMI_IAdmin_uploadMyUserPhoto __cb, String filename, String format, byte[] data);

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param __cb The callback object for the operation.
     * @param filename Not null. String name which will be used.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean uploadMyUserPhoto_async(AMI_IAdmin_uploadMyUserPhoto __cb, String filename, String format, byte[] data, java.util.Map<String, String> __ctx);

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @return file objects. Possibly empty.
     **/
    public java.util.List<omero.model.OriginalFile> getMyUserPhotos()
        throws omero.ServerError;

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return file objects. Possibly empty.
     **/
    public java.util.List<omero.model.OriginalFile> getMyUserPhotos(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyUserPhotos();

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyUserPhotos(java.util.Map<String, String> __ctx);

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyUserPhotos(Ice.Callback __cb);

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyUserPhotos(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyUserPhotos(Callback_IAdmin_getMyUserPhotos __cb);

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getMyUserPhotos(java.util.Map<String, String> __ctx, Callback_IAdmin_getMyUserPhotos __cb);

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __result The asynchronous result object.
     * @return file objects. Possibly empty.
     **/
    public java.util.List<omero.model.OriginalFile> end_getMyUserPhotos(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getMyUserPhotos_async(AMI_IAdmin_getMyUserPhotos __cb);

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getMyUserPhotos_async(AMI_IAdmin_getMyUserPhotos __cb, java.util.Map<String, String> __ctx);

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param experimenter the Experimenter to update.
     **/
    public void updateExperimenter(omero.model.Experimenter experimenter)
        throws omero.ServerError;

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param experimenter the Experimenter to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void updateExperimenter(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param experimenter the Experimenter to update.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateExperimenter(omero.model.Experimenter experimenter);

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param experimenter the Experimenter to update.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateExperimenter(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx);

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param experimenter the Experimenter to update.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateExperimenter(omero.model.Experimenter experimenter, Ice.Callback __cb);

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param experimenter the Experimenter to update.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateExperimenter(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param experimenter the Experimenter to update.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateExperimenter(omero.model.Experimenter experimenter, Callback_IAdmin_updateExperimenter __cb);

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param experimenter the Experimenter to update.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateExperimenter(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx, Callback_IAdmin_updateExperimenter __cb);

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_updateExperimenter(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     **/
    public boolean updateExperimenter_async(AMI_IAdmin_updateExperimenter __cb, omero.model.Experimenter experimenter);

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean updateExperimenter_async(AMI_IAdmin_updateExperimenter __cb, omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx);

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param experimenter the Experimenter to update.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     **/
    public void updateExperimenterWithPassword(omero.model.Experimenter experimenter, omero.RString password)
        throws omero.ServerError;

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param experimenter the Experimenter to update.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void updateExperimenterWithPassword(omero.model.Experimenter experimenter, omero.RString password, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param experimenter the Experimenter to update.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateExperimenterWithPassword(omero.model.Experimenter experimenter, omero.RString password);

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param experimenter the Experimenter to update.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateExperimenterWithPassword(omero.model.Experimenter experimenter, omero.RString password, java.util.Map<String, String> __ctx);

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param experimenter the Experimenter to update.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateExperimenterWithPassword(omero.model.Experimenter experimenter, omero.RString password, Ice.Callback __cb);

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param experimenter the Experimenter to update.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateExperimenterWithPassword(omero.model.Experimenter experimenter, omero.RString password, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param experimenter the Experimenter to update.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateExperimenterWithPassword(omero.model.Experimenter experimenter, omero.RString password, Callback_IAdmin_updateExperimenterWithPassword __cb);

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param experimenter the Experimenter to update.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateExperimenterWithPassword(omero.model.Experimenter experimenter, omero.RString password, java.util.Map<String, String> __ctx, Callback_IAdmin_updateExperimenterWithPassword __cb);

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_updateExperimenterWithPassword(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     **/
    public boolean updateExperimenterWithPassword_async(AMI_IAdmin_updateExperimenterWithPassword __cb, omero.model.Experimenter experimenter, omero.RString password);

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean updateExperimenterWithPassword_async(AMI_IAdmin_updateExperimenterWithPassword __cb, omero.model.Experimenter experimenter, omero.RString password, java.util.Map<String, String> __ctx);

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param group the ExperimenterGroup to update.
     **/
    public void updateGroup(omero.model.ExperimenterGroup group)
        throws omero.ServerError;

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param group the ExperimenterGroup to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void updateGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param group the ExperimenterGroup to update.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateGroup(omero.model.ExperimenterGroup group);

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param group the ExperimenterGroup to update.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx);

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param group the ExperimenterGroup to update.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateGroup(omero.model.ExperimenterGroup group, Ice.Callback __cb);

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param group the ExperimenterGroup to update.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param group the ExperimenterGroup to update.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateGroup(omero.model.ExperimenterGroup group, Callback_IAdmin_updateGroup __cb);

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param group the ExperimenterGroup to update.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_updateGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, Callback_IAdmin_updateGroup __cb);

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_updateGroup(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param __cb The callback object for the operation.
     * @param group the ExperimenterGroup to update.
     **/
    public boolean updateGroup_async(AMI_IAdmin_updateGroup __cb, omero.model.ExperimenterGroup group);

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param __cb The callback object for the operation.
     * @param group the ExperimenterGroup to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean updateGroup_async(AMI_IAdmin_updateGroup __cb, omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx);

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     * @return id of the newly created
     * {@link omero.model.Experimenter}
     **/
    public long createUser(omero.model.Experimenter experimenter, String group)
        throws omero.ServerError;

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     * @param __ctx The Context map to send with the invocation.
     * @return id of the newly created
     * {@link omero.model.Experimenter}
     **/
    public long createUser(omero.model.Experimenter experimenter, String group, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createUser(omero.model.Experimenter experimenter, String group);

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createUser(omero.model.Experimenter experimenter, String group, java.util.Map<String, String> __ctx);

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createUser(omero.model.Experimenter experimenter, String group, Ice.Callback __cb);

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createUser(omero.model.Experimenter experimenter, String group, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createUser(omero.model.Experimenter experimenter, String group, Callback_IAdmin_createUser __cb);

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createUser(omero.model.Experimenter experimenter, String group, java.util.Map<String, String> __ctx, Callback_IAdmin_createUser __cb);

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param __result The asynchronous result object.
     * @return id of the newly created
     * {@link omero.model.Experimenter}
     **/
    public long end_createUser(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     **/
    public boolean createUser_async(AMI_IAdmin_createUser __cb, omero.model.Experimenter experimenter, String group);

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createUser_async(AMI_IAdmin_createUser __cb, omero.model.Experimenter experimenter, String group, java.util.Map<String, String> __ctx);

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @return id of the newly created
     * {@link omero.model.Experimenter}
     **/
    public long createSystemUser(omero.model.Experimenter experimenter)
        throws omero.ServerError;

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param __ctx The Context map to send with the invocation.
     * @return id of the newly created
     * {@link omero.model.Experimenter}
     **/
    public long createSystemUser(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSystemUser(omero.model.Experimenter experimenter);

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSystemUser(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx);

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSystemUser(omero.model.Experimenter experimenter, Ice.Callback __cb);

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSystemUser(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSystemUser(omero.model.Experimenter experimenter, Callback_IAdmin_createSystemUser __cb);

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createSystemUser(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx, Callback_IAdmin_createSystemUser __cb);

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param __result The asynchronous result object.
     * @return id of the newly created
     * {@link omero.model.Experimenter}
     **/
    public long end_createSystemUser(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     **/
    public boolean createSystemUser_async(AMI_IAdmin_createSystemUser __cb, omero.model.Experimenter experimenter);

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createSystemUser_async(AMI_IAdmin_createSystemUser __cb, omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx);

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @return id of the newly created
     * {@link omero.model.Experimenter} Not null.
     **/
    public long createExperimenter(omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups)
        throws omero.ServerError;

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     * @return id of the newly created
     * {@link omero.model.Experimenter} Not null.
     **/
    public long createExperimenter(omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createExperimenter(omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups);

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createExperimenter(omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx);

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createExperimenter(omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, Ice.Callback __cb);

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createExperimenter(omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createExperimenter(omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, Callback_IAdmin_createExperimenter __cb);

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createExperimenter(omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, Callback_IAdmin_createExperimenter __cb);

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param __result The asynchronous result object.
     * @return id of the newly created
     * {@link omero.model.Experimenter} Not null.
     **/
    public long end_createExperimenter(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     **/
    public boolean createExperimenter_async(AMI_IAdmin_createExperimenter __cb, omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups);

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createExperimenter_async(AMI_IAdmin_createExperimenter __cb, omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx);

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @return id of the newly created
     * {@link omero.model.Experimenter} Not null.
     * @throws SecurityViolation if the new password is too weak.
     **/
    public long createExperimenterWithPassword(omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups)
        throws omero.ServerError;

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     * @return id of the newly created
     * {@link omero.model.Experimenter} Not null.
     * @throws SecurityViolation if the new password is too weak.
     **/
    public long createExperimenterWithPassword(omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createExperimenterWithPassword(omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups);

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createExperimenterWithPassword(omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx);

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createExperimenterWithPassword(omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, Ice.Callback __cb);

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createExperimenterWithPassword(omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createExperimenterWithPassword(omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, Callback_IAdmin_createExperimenterWithPassword __cb);

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createExperimenterWithPassword(omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, Callback_IAdmin_createExperimenterWithPassword __cb);

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param __result The asynchronous result object.
     * @return id of the newly created
     * {@link omero.model.Experimenter} Not null.
     * @throws SecurityViolation if the new password is too weak.
     **/
    public long end_createExperimenterWithPassword(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     **/
    public boolean createExperimenterWithPassword_async(AMI_IAdmin_createExperimenterWithPassword __cb, omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups);

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createExperimenterWithPassword_async(AMI_IAdmin_createExperimenterWithPassword __cb, omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx);

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     * @return id of the newly created {@link ExperimenterGroup}
     **/
    public long createGroup(omero.model.ExperimenterGroup group)
        throws omero.ServerError;

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return id of the newly created {@link ExperimenterGroup}
     **/
    public long createGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createGroup(omero.model.ExperimenterGroup group);

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx);

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createGroup(omero.model.ExperimenterGroup group, Ice.Callback __cb);

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createGroup(omero.model.ExperimenterGroup group, Callback_IAdmin_createGroup __cb);

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_createGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, Callback_IAdmin_createGroup __cb);

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param __result The asynchronous result object.
     * @return id of the newly created {@link ExperimenterGroup}
     **/
    public long end_createGroup(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param __cb The callback object for the operation.
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     **/
    public boolean createGroup_async(AMI_IAdmin_createGroup __cb, omero.model.ExperimenterGroup group);

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param __cb The callback object for the operation.
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createGroup_async(AMI_IAdmin_createGroup __cb, omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx);

    /**
     * Adds a user to the given groups.
     * 
     * @param user A currently managed entity. Not null.
     * @param groups Groups to which the user will be added. Not
     * null.
     **/
    public void addGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups)
        throws omero.ServerError;

    /**
     * Adds a user to the given groups.
     * 
     * @param user A currently managed entity. Not null.
     * @param groups Groups to which the user will be added. Not
     * null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Adds a user to the given groups.
     * 
     * @param user A currently managed entity. Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups);

    /**
     * Adds a user to the given groups.
     * 
     * @param user A currently managed entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx);

    /**
     * Adds a user to the given groups.
     * 
     * @param user A currently managed entity. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, Ice.Callback __cb);

    /**
     * Adds a user to the given groups.
     * 
     * @param user A currently managed entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Adds a user to the given groups.
     * 
     * @param user A currently managed entity. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, Callback_IAdmin_addGroups __cb);

    /**
     * Adds a user to the given groups.
     * 
     * @param user A currently managed entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, Callback_IAdmin_addGroups __cb);

    /**
     * Adds a user to the given groups.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_addGroups(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Adds a user to the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     **/
    public boolean addGroups_async(AMI_IAdmin_addGroups __cb, omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups);

    /**
     * Adds a user to the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addGroups_async(AMI_IAdmin_addGroups __cb, omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx);

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param user A currently managed entity. Not null.
     * @param groups Groups from which the user will be removed.
     * Not null.
     **/
    public void removeGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups)
        throws omero.ServerError;

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param user A currently managed entity. Not null.
     * @param groups Groups from which the user will be removed.
     * Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param user A currently managed entity. Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups);

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param user A currently managed entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx);

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param user A currently managed entity. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, Ice.Callback __cb);

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param user A currently managed entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param user A currently managed entity. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, Callback_IAdmin_removeGroups __cb);

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param user A currently managed entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, Callback_IAdmin_removeGroups __cb);

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_removeGroups(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     **/
    public boolean removeGroups_async(AMI_IAdmin_removeGroups __cb, omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups);

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeGroups_async(AMI_IAdmin_removeGroups __cb, omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx);

    /**
     * Sets the default group for a given user.
     * 
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     **/
    public void setDefaultGroup(omero.model.Experimenter user, omero.model.ExperimenterGroup group)
        throws omero.ServerError;

    /**
     * Sets the default group for a given user.
     * 
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setDefaultGroup(omero.model.Experimenter user, omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Sets the default group for a given user.
     * 
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setDefaultGroup(omero.model.Experimenter user, omero.model.ExperimenterGroup group);

    /**
     * Sets the default group for a given user.
     * 
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setDefaultGroup(omero.model.Experimenter user, omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx);

    /**
     * Sets the default group for a given user.
     * 
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setDefaultGroup(omero.model.Experimenter user, omero.model.ExperimenterGroup group, Ice.Callback __cb);

    /**
     * Sets the default group for a given user.
     * 
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setDefaultGroup(omero.model.Experimenter user, omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Sets the default group for a given user.
     * 
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setDefaultGroup(omero.model.Experimenter user, omero.model.ExperimenterGroup group, Callback_IAdmin_setDefaultGroup __cb);

    /**
     * Sets the default group for a given user.
     * 
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setDefaultGroup(omero.model.Experimenter user, omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, Callback_IAdmin_setDefaultGroup __cb);

    /**
     * Sets the default group for a given user.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_setDefaultGroup(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Sets the default group for a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     **/
    public boolean setDefaultGroup_async(AMI_IAdmin_setDefaultGroup __cb, omero.model.Experimenter user, omero.model.ExperimenterGroup group);

    /**
     * Sets the default group for a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setDefaultGroup_async(AMI_IAdmin_setDefaultGroup __cb, omero.model.Experimenter user, omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx);

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     **/
    public void setGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner)
        throws omero.ServerError;

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner);

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx);

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, Ice.Callback __cb);

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, Callback_IAdmin_setGroupOwner __cb);

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx, Callback_IAdmin_setGroupOwner __cb);

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_setGroupOwner(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     **/
    public boolean setGroupOwner_async(AMI_IAdmin_setGroupOwner __cb, omero.model.ExperimenterGroup group, omero.model.Experimenter owner);

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setGroupOwner_async(AMI_IAdmin_setGroupOwner __cb, omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx);

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     **/
    public void unsetGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner)
        throws omero.ServerError;

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void unsetGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_unsetGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner);

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_unsetGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx);

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_unsetGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, Ice.Callback __cb);

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_unsetGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_unsetGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, Callback_IAdmin_unsetGroupOwner __cb);

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_unsetGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx, Callback_IAdmin_unsetGroupOwner __cb);

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_unsetGroupOwner(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     **/
    public boolean unsetGroupOwner_async(AMI_IAdmin_unsetGroupOwner __cb, omero.model.ExperimenterGroup group, omero.model.Experimenter owner);

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean unsetGroupOwner_async(AMI_IAdmin_unsetGroupOwner __cb, omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx);

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     **/
    public void addGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners)
        throws omero.ServerError;

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners);

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx);

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, Ice.Callback __cb);

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, Callback_IAdmin_addGroupOwners __cb);

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx, Callback_IAdmin_addGroupOwners __cb);

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_addGroupOwners(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     **/
    public boolean addGroupOwners_async(AMI_IAdmin_addGroupOwners __cb, omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners);

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addGroupOwners_async(AMI_IAdmin_addGroupOwners __cb, omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx);

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     **/
    public void removeGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners)
        throws omero.ServerError;

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners);

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx);

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, Ice.Callback __cb);

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, Callback_IAdmin_removeGroupOwners __cb);

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_removeGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx, Callback_IAdmin_removeGroupOwners __cb);

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_removeGroupOwners(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     **/
    public boolean removeGroupOwners_async(AMI_IAdmin_removeGroupOwners __cb, omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners);

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeGroupOwners_async(AMI_IAdmin_removeGroupOwners __cb, omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx);

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param user Experimenter to be deleted. Not null.
     **/
    public void deleteExperimenter(omero.model.Experimenter user)
        throws omero.ServerError;

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param user Experimenter to be deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void deleteExperimenter(omero.model.Experimenter user, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param user Experimenter to be deleted. Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deleteExperimenter(omero.model.Experimenter user);

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param user Experimenter to be deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deleteExperimenter(omero.model.Experimenter user, java.util.Map<String, String> __ctx);

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param user Experimenter to be deleted. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deleteExperimenter(omero.model.Experimenter user, Ice.Callback __cb);

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param user Experimenter to be deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deleteExperimenter(omero.model.Experimenter user, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param user Experimenter to be deleted. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deleteExperimenter(omero.model.Experimenter user, Callback_IAdmin_deleteExperimenter __cb);

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param user Experimenter to be deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deleteExperimenter(omero.model.Experimenter user, java.util.Map<String, String> __ctx, Callback_IAdmin_deleteExperimenter __cb);

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_deleteExperimenter(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param __cb The callback object for the operation.
     * @param user Experimenter to be deleted. Not null.
     **/
    public boolean deleteExperimenter_async(AMI_IAdmin_deleteExperimenter __cb, omero.model.Experimenter user);

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param __cb The callback object for the operation.
     * @param user Experimenter to be deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean deleteExperimenter_async(AMI_IAdmin_deleteExperimenter __cb, omero.model.Experimenter user, java.util.Map<String, String> __ctx);

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     **/
    public void deleteGroup(omero.model.ExperimenterGroup group)
        throws omero.ServerError;

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void deleteGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deleteGroup(omero.model.ExperimenterGroup group);

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deleteGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx);

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deleteGroup(omero.model.ExperimenterGroup group, Ice.Callback __cb);

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deleteGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deleteGroup(omero.model.ExperimenterGroup group, Callback_IAdmin_deleteGroup __cb);

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_deleteGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, Callback_IAdmin_deleteGroup __cb);

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_deleteGroup(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     **/
    public boolean deleteGroup_async(AMI_IAdmin_deleteGroup __cb, omero.model.ExperimenterGroup group);

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean deleteGroup_async(AMI_IAdmin_deleteGroup __cb, omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx);

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void changeOwner(omero.model.IObject obj, String omeName)
        throws omero.ServerError;

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void changeOwner(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeOwner(omero.model.IObject obj, String omeName);

    /**
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeOwner(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx);

    /**
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeOwner(omero.model.IObject obj, String omeName, Ice.Callback __cb);

    /**
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeOwner(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeOwner(omero.model.IObject obj, String omeName, Callback_IAdmin_changeOwner __cb);

    /**
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeOwner(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx, Callback_IAdmin_changeOwner __cb);

    /**
     * @param __result The asynchronous result object.
     **/
    public void end_changeOwner(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean changeOwner_async(AMI_IAdmin_changeOwner __cb, omero.model.IObject obj, String omeName);

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean changeOwner_async(AMI_IAdmin_changeOwner __cb, omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx);

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void changeGroup(omero.model.IObject obj, String omeName)
        throws omero.ServerError;

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void changeGroup(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeGroup(omero.model.IObject obj, String omeName);

    /**
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeGroup(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx);

    /**
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeGroup(omero.model.IObject obj, String omeName, Ice.Callback __cb);

    /**
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeGroup(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeGroup(omero.model.IObject obj, String omeName, Callback_IAdmin_changeGroup __cb);

    /**
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeGroup(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx, Callback_IAdmin_changeGroup __cb);

    /**
     * @param __result The asynchronous result object.
     **/
    public void end_changeGroup(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean changeGroup_async(AMI_IAdmin_changeGroup __cb, omero.model.IObject obj, String omeName);

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean changeGroup_async(AMI_IAdmin_changeGroup __cb, omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx);

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void changePermissions(omero.model.IObject obj, omero.model.Permissions perms)
        throws omero.ServerError;

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void changePermissions(omero.model.IObject obj, omero.model.Permissions perms, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changePermissions(omero.model.IObject obj, omero.model.Permissions perms);

    /**
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changePermissions(omero.model.IObject obj, omero.model.Permissions perms, java.util.Map<String, String> __ctx);

    /**
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changePermissions(omero.model.IObject obj, omero.model.Permissions perms, Ice.Callback __cb);

    /**
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changePermissions(omero.model.IObject obj, omero.model.Permissions perms, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changePermissions(omero.model.IObject obj, omero.model.Permissions perms, Callback_IAdmin_changePermissions __cb);

    /**
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changePermissions(omero.model.IObject obj, omero.model.Permissions perms, java.util.Map<String, String> __ctx, Callback_IAdmin_changePermissions __cb);

    /**
     * @param __result The asynchronous result object.
     **/
    public void end_changePermissions(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean changePermissions_async(AMI_IAdmin_changePermissions __cb, omero.model.IObject obj, omero.model.Permissions perms);

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean changePermissions_async(AMI_IAdmin_changePermissions __cb, omero.model.IObject obj, omero.model.Permissions perms, java.util.Map<String, String> __ctx);

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param objects
     **/
    public void moveToCommonSpace(java.util.List<omero.model.IObject> objects)
        throws omero.ServerError;

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param objects
     * @param __ctx The Context map to send with the invocation.
     **/
    public void moveToCommonSpace(java.util.List<omero.model.IObject> objects, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param objects
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_moveToCommonSpace(java.util.List<omero.model.IObject> objects);

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param objects
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_moveToCommonSpace(java.util.List<omero.model.IObject> objects, java.util.Map<String, String> __ctx);

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param objects
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_moveToCommonSpace(java.util.List<omero.model.IObject> objects, Ice.Callback __cb);

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param objects
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_moveToCommonSpace(java.util.List<omero.model.IObject> objects, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param objects
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_moveToCommonSpace(java.util.List<omero.model.IObject> objects, Callback_IAdmin_moveToCommonSpace __cb);

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param objects
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_moveToCommonSpace(java.util.List<omero.model.IObject> objects, java.util.Map<String, String> __ctx, Callback_IAdmin_moveToCommonSpace __cb);

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_moveToCommonSpace(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param __cb The callback object for the operation.
     * @param objects
     **/
    public boolean moveToCommonSpace_async(AMI_IAdmin_moveToCommonSpace __cb, java.util.List<omero.model.IObject> objects);

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param __cb The callback object for the operation.
     * @param objects
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean moveToCommonSpace_async(AMI_IAdmin_moveToCommonSpace __cb, java.util.List<omero.model.IObject> objects, java.util.Map<String, String> __ctx);

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @throws SecurityViolation if the user is not authenticated
     * with a password.
     **/
    public void changePassword(omero.RString newPassword)
        throws omero.ServerError;

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @throws SecurityViolation if the user is not authenticated
     * with a password.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void changePassword(omero.RString newPassword, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changePassword(omero.RString newPassword);

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changePassword(omero.RString newPassword, java.util.Map<String, String> __ctx);

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changePassword(omero.RString newPassword, Ice.Callback __cb);

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changePassword(omero.RString newPassword, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changePassword(omero.RString newPassword, Callback_IAdmin_changePassword __cb);

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changePassword(omero.RString newPassword, java.util.Map<String, String> __ctx, Callback_IAdmin_changePassword __cb);

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param __result The asynchronous result object.
     * @throws SecurityViolation if the user is not authenticated
     * with a password.
     **/
    public void end_changePassword(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     **/
    public boolean changePassword_async(AMI_IAdmin_changePassword __cb, omero.RString newPassword);

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean changePassword_async(AMI_IAdmin_changePassword __cb, omero.RString newPassword, java.util.Map<String, String> __ctx);

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @throws SecurityViolation if the oldPassword is incorrect.
     **/
    public void changePasswordWithOldPassword(omero.RString oldPassword, omero.RString newPassword)
        throws omero.ServerError;

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @throws SecurityViolation if the oldPassword is incorrect.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void changePasswordWithOldPassword(omero.RString oldPassword, omero.RString newPassword, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changePasswordWithOldPassword(omero.RString oldPassword, omero.RString newPassword);

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changePasswordWithOldPassword(omero.RString oldPassword, omero.RString newPassword, java.util.Map<String, String> __ctx);

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changePasswordWithOldPassword(omero.RString oldPassword, omero.RString newPassword, Ice.Callback __cb);

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changePasswordWithOldPassword(omero.RString oldPassword, omero.RString newPassword, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changePasswordWithOldPassword(omero.RString oldPassword, omero.RString newPassword, Callback_IAdmin_changePasswordWithOldPassword __cb);

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changePasswordWithOldPassword(omero.RString oldPassword, omero.RString newPassword, java.util.Map<String, String> __ctx, Callback_IAdmin_changePasswordWithOldPassword __cb);

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param __result The asynchronous result object.
     * @throws SecurityViolation if the oldPassword is incorrect.
     **/
    public void end_changePasswordWithOldPassword(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param __cb The callback object for the operation.
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     **/
    public boolean changePasswordWithOldPassword_async(AMI_IAdmin_changePasswordWithOldPassword __cb, omero.RString oldPassword, omero.RString newPassword);

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param __cb The callback object for the operation.
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean changePasswordWithOldPassword_async(AMI_IAdmin_changePasswordWithOldPassword __cb, omero.RString oldPassword, omero.RString newPassword, java.util.Map<String, String> __ctx);

    /**
     * Changes the password for the a given user.
     * 
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     * @throws SecurityViolation if the new password is too weak.
     **/
    public void changeUserPassword(String omeName, omero.RString newPassword)
        throws omero.ServerError;

    /**
     * Changes the password for the a given user.
     * 
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     * @throws SecurityViolation if the new password is too weak.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void changeUserPassword(String omeName, omero.RString newPassword, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Changes the password for the a given user.
     * 
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changeUserPassword(String omeName, omero.RString newPassword);

    /**
     * Changes the password for the a given user.
     * 
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changeUserPassword(String omeName, omero.RString newPassword, java.util.Map<String, String> __ctx);

    /**
     * Changes the password for the a given user.
     * 
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changeUserPassword(String omeName, omero.RString newPassword, Ice.Callback __cb);

    /**
     * Changes the password for the a given user.
     * 
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changeUserPassword(String omeName, omero.RString newPassword, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Changes the password for the a given user.
     * 
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changeUserPassword(String omeName, omero.RString newPassword, Callback_IAdmin_changeUserPassword __cb);

    /**
     * Changes the password for the a given user.
     * 
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changeUserPassword(String omeName, omero.RString newPassword, java.util.Map<String, String> __ctx, Callback_IAdmin_changeUserPassword __cb);

    /**
     * Changes the password for the a given user.
     * 
     * @param __result The asynchronous result object.
     * @throws SecurityViolation if the new password is too weak.
     **/
    public void end_changeUserPassword(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Changes the password for the a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     **/
    public boolean changeUserPassword_async(AMI_IAdmin_changeUserPassword __cb, String omeName, omero.RString newPassword);

    /**
     * Changes the password for the a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean changeUserPassword_async(AMI_IAdmin_changeUserPassword __cb, String omeName, omero.RString newPassword, java.util.Map<String, String> __ctx);

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     **/
    public void synchronizeLoginCache()
        throws omero.ServerError;

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void synchronizeLoginCache(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_synchronizeLoginCache();

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_synchronizeLoginCache(java.util.Map<String, String> __ctx);

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_synchronizeLoginCache(Ice.Callback __cb);

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_synchronizeLoginCache(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_synchronizeLoginCache(Callback_IAdmin_synchronizeLoginCache __cb);

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_synchronizeLoginCache(java.util.Map<String, String> __ctx, Callback_IAdmin_synchronizeLoginCache __cb);

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __result The asynchronous result object.
     **/
    public void end_synchronizeLoginCache(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __cb The callback object for the operation.
     **/
    public boolean synchronizeLoginCache_async(AMI_IAdmin_synchronizeLoginCache __cb);

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean synchronizeLoginCache_async(AMI_IAdmin_synchronizeLoginCache __cb, java.util.Map<String, String> __ctx);

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     **/
    public void changeExpiredCredentials(String name, String oldCred, String newCred)
        throws omero.ServerError;

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void changeExpiredCredentials(String name, String oldCred, String newCred, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changeExpiredCredentials(String name, String oldCred, String newCred);

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changeExpiredCredentials(String name, String oldCred, String newCred, java.util.Map<String, String> __ctx);

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changeExpiredCredentials(String name, String oldCred, String newCred, Ice.Callback __cb);

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changeExpiredCredentials(String name, String oldCred, String newCred, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changeExpiredCredentials(String name, String oldCred, String newCred, Callback_IAdmin_changeExpiredCredentials __cb);

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_changeExpiredCredentials(String name, String oldCred, String newCred, java.util.Map<String, String> __ctx, Callback_IAdmin_changeExpiredCredentials __cb);

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __result The asynchronous result object.
     **/
    public void end_changeExpiredCredentials(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __cb The callback object for the operation.
     **/
    public boolean changeExpiredCredentials_async(AMI_IAdmin_changeExpiredCredentials __cb, String name, String oldCred, String newCred);

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean changeExpiredCredentials_async(AMI_IAdmin_changeExpiredCredentials __cb, String name, String oldCred, String newCred, java.util.Map<String, String> __ctx);

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void reportForgottenPassword(String name, String email)
        throws omero.ServerError;

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void reportForgottenPassword(String name, String email, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_reportForgottenPassword(String name, String email);

    /**
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_reportForgottenPassword(String name, String email, java.util.Map<String, String> __ctx);

    /**
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_reportForgottenPassword(String name, String email, Ice.Callback __cb);

    /**
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_reportForgottenPassword(String name, String email, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_reportForgottenPassword(String name, String email, Callback_IAdmin_reportForgottenPassword __cb);

    /**
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_reportForgottenPassword(String name, String email, java.util.Map<String, String> __ctx, Callback_IAdmin_reportForgottenPassword __cb);

    /**
     * @param __result The asynchronous result object.
     **/
    public void end_reportForgottenPassword(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean reportForgottenPassword_async(AMI_IAdmin_reportForgottenPassword __cb, String name, String email);

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean reportForgottenPassword_async(AMI_IAdmin_reportForgottenPassword __cb, String name, String email, java.util.Map<String, String> __ctx);

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @return Non-null, immutable {@link omero.sys.Roles}
     * instance.
     **/
    public omero.sys.Roles getSecurityRoles()
        throws omero.ServerError;

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return Non-null, immutable {@link omero.sys.Roles}
     * instance.
     **/
    public omero.sys.Roles getSecurityRoles(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSecurityRoles();

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSecurityRoles(java.util.Map<String, String> __ctx);

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSecurityRoles(Ice.Callback __cb);

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSecurityRoles(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSecurityRoles(Callback_IAdmin_getSecurityRoles __cb);

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getSecurityRoles(java.util.Map<String, String> __ctx, Callback_IAdmin_getSecurityRoles __cb);

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __result The asynchronous result object.
     * @return Non-null, immutable {@link omero.sys.Roles}
     * instance.
     **/
    public omero.sys.Roles end_getSecurityRoles(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getSecurityRoles_async(AMI_IAdmin_getSecurityRoles __cb);

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getSecurityRoles_async(AMI_IAdmin_getSecurityRoles __cb, java.util.Map<String, String> __ctx);

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @return Non-null, immutable {@link omero.sys.EventContext}
     * instance
     **/
    public omero.sys.EventContext getEventContext()
        throws omero.ServerError;

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return Non-null, immutable {@link omero.sys.EventContext}
     * instance
     **/
    public omero.sys.EventContext getEventContext(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getEventContext();

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getEventContext(java.util.Map<String, String> __ctx);

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getEventContext(Ice.Callback __cb);

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getEventContext(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getEventContext(Callback_IAdmin_getEventContext __cb);

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getEventContext(java.util.Map<String, String> __ctx, Callback_IAdmin_getEventContext __cb);

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __result The asynchronous result object.
     * @return Non-null, immutable {@link omero.sys.EventContext}
     * instance
     **/
    public omero.sys.EventContext end_getEventContext(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getEventContext_async(AMI_IAdmin_getEventContext __cb);

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getEventContext_async(AMI_IAdmin_getEventContext __cb, java.util.Map<String, String> __ctx);
}
