// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IAdmin.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Administration interface providing access to admin-only
 * functionality as well as JMX-based server access and selected user
 * functions. Most methods require membership in privileged
 * {@link omero.model.ExperimenterGroup groups}.
 * 
 * Methods which return {@link omero.model.Experimenter} or
 * {@link omero.model.ExperimenterGroup} instances fetch and load all
 * related instances of {@link omero.model.ExperimenterGroup} or
 * {@link omero.model.Experimenter}, respectively.
 * 
 **/
public final class IAdminPrxHelper extends Ice.ObjectPrxHelperBase implements IAdminPrx
{
    private static final String __addGroupOwners_name = "addGroupOwners";

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     **/
    public void addGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners)
        throws omero.ServerError
    {
        addGroupOwners(group, owners, null, false);
    }

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        addGroupOwners(group, owners, __ctx, true);
    }

    private void addGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "addGroupOwners", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("addGroupOwners");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.addGroupOwners(group, owners, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     **/
    public Ice.AsyncResult begin_addGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners)
    {
        return begin_addGroupOwners(group, owners, null, false, null);
    }

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx)
    {
        return begin_addGroupOwners(group, owners, __ctx, true, null);
    }

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     **/
    public Ice.AsyncResult begin_addGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, Ice.Callback __cb)
    {
        return begin_addGroupOwners(group, owners, null, false, __cb);
    }

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_addGroupOwners(group, owners, __ctx, true, __cb);
    }

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     **/
    public Ice.AsyncResult begin_addGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, Callback_IAdmin_addGroupOwners __cb)
    {
        return begin_addGroupOwners(group, owners, null, false, __cb);
    }

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx, Callback_IAdmin_addGroupOwners __cb)
    {
        return begin_addGroupOwners(group, owners, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_addGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__addGroupOwners_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __addGroupOwners_name, __cb);
        try
        {
            __result.__prepare(__addGroupOwners_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(group);
            ExperimenterListHelper.write(__os, owners);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_addGroupOwners(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __addGroupOwners_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     **/
    public boolean addGroupOwners_async(AMI_IAdmin_addGroupOwners __cb, omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addGroupOwners_name);
            __r = begin_addGroupOwners(group, owners, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addGroupOwners_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Adds the given users to the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addGroupOwners_async(AMI_IAdmin_addGroupOwners __cb, omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addGroupOwners_name);
            __r = begin_addGroupOwners(group, owners, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addGroupOwners_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __addGroups_name = "addGroups";

    /**
     * Adds a user to the given groups.
     * 
     * @param user A currently managed entity. Not null.
     * @param groups Groups to which the user will be added. Not
     * null.
     **/
    public void addGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups)
        throws omero.ServerError
    {
        addGroups(user, groups, null, false);
    }

    /**
     * Adds a user to the given groups.
     * 
     * @param user A currently managed entity. Not null.
     * @param groups Groups to which the user will be added. Not
     * null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        addGroups(user, groups, __ctx, true);
    }

    private void addGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "addGroups", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("addGroups");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.addGroups(user, groups, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Adds a user to the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     **/
    public Ice.AsyncResult begin_addGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups)
    {
        return begin_addGroups(user, groups, null, false, null);
    }

    /**
     * Adds a user to the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx)
    {
        return begin_addGroups(user, groups, __ctx, true, null);
    }

    /**
     * Adds a user to the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     **/
    public Ice.AsyncResult begin_addGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, Ice.Callback __cb)
    {
        return begin_addGroups(user, groups, null, false, __cb);
    }

    /**
     * Adds a user to the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_addGroups(user, groups, __ctx, true, __cb);
    }

    /**
     * Adds a user to the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     **/
    public Ice.AsyncResult begin_addGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, Callback_IAdmin_addGroups __cb)
    {
        return begin_addGroups(user, groups, null, false, __cb);
    }

    /**
     * Adds a user to the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, Callback_IAdmin_addGroups __cb)
    {
        return begin_addGroups(user, groups, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_addGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__addGroups_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __addGroups_name, __cb);
        try
        {
            __result.__prepare(__addGroups_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(user);
            ExperimenterGroupListHelper.write(__os, groups);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_addGroups(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __addGroups_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Adds a user to the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     **/
    public boolean addGroups_async(AMI_IAdmin_addGroups __cb, omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addGroups_name);
            __r = begin_addGroups(user, groups, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addGroups_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Adds a user to the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addGroups_async(AMI_IAdmin_addGroups __cb, omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addGroups_name);
            __r = begin_addGroups(user, groups, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addGroups_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __canUpdate_name = "canUpdate";

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     **/
    public boolean canUpdate(omero.model.IObject obj)
        throws omero.ServerError
    {
        return canUpdate(obj, null, false);
    }

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean canUpdate(omero.model.IObject obj, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return canUpdate(obj, __ctx, true);
    }

    private boolean canUpdate(omero.model.IObject obj, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "canUpdate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("canUpdate");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.canUpdate(obj, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_canUpdate(omero.model.IObject obj)
    {
        return begin_canUpdate(obj, null, false, null);
    }

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_canUpdate(omero.model.IObject obj, java.util.Map<String, String> __ctx)
    {
        return begin_canUpdate(obj, __ctx, true, null);
    }

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_canUpdate(omero.model.IObject obj, Ice.Callback __cb)
    {
        return begin_canUpdate(obj, null, false, __cb);
    }

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_canUpdate(omero.model.IObject obj, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_canUpdate(obj, __ctx, true, __cb);
    }

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_canUpdate(omero.model.IObject obj, Callback_IAdmin_canUpdate __cb)
    {
        return begin_canUpdate(obj, null, false, __cb);
    }

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_canUpdate(omero.model.IObject obj, java.util.Map<String, String> __ctx, Callback_IAdmin_canUpdate __cb)
    {
        return begin_canUpdate(obj, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_canUpdate(omero.model.IObject obj, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__canUpdate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __canUpdate_name, __cb);
        try
        {
            __result.__prepare(__canUpdate_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(obj);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_canUpdate(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __canUpdate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __cb The callback object for the operation.
     **/
    public boolean canUpdate_async(AMI_IAdmin_canUpdate __cb, omero.model.IObject obj)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__canUpdate_name);
            __r = begin_canUpdate(obj, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __canUpdate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns true if the currently logged in user can modify the
     * given {@link omero.model.IObject}. This uses the same logic
     * that would be applied during a Hibernate flush to the
     * database.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean canUpdate_async(AMI_IAdmin_canUpdate __cb, omero.model.IObject obj, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__canUpdate_name);
            __r = begin_canUpdate(obj, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __canUpdate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __changeExpiredCredentials_name = "changeExpiredCredentials";

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     **/
    public void changeExpiredCredentials(String name, String oldCred, String newCred)
        throws omero.ServerError
    {
        changeExpiredCredentials(name, oldCred, newCred, null, false);
    }

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void changeExpiredCredentials(String name, String oldCred, String newCred, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        changeExpiredCredentials(name, oldCred, newCred, __ctx, true);
    }

    private void changeExpiredCredentials(String name, String oldCred, String newCred, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "changeExpiredCredentials", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("changeExpiredCredentials");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.changeExpiredCredentials(name, oldCred, newCred, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_changeExpiredCredentials(String name, String oldCred, String newCred)
    {
        return begin_changeExpiredCredentials(name, oldCred, newCred, null, false, null);
    }

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_changeExpiredCredentials(String name, String oldCred, String newCred, java.util.Map<String, String> __ctx)
    {
        return begin_changeExpiredCredentials(name, oldCred, newCred, __ctx, true, null);
    }

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_changeExpiredCredentials(String name, String oldCred, String newCred, Ice.Callback __cb)
    {
        return begin_changeExpiredCredentials(name, oldCred, newCred, null, false, __cb);
    }

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_changeExpiredCredentials(String name, String oldCred, String newCred, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_changeExpiredCredentials(name, oldCred, newCred, __ctx, true, __cb);
    }

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_changeExpiredCredentials(String name, String oldCred, String newCred, Callback_IAdmin_changeExpiredCredentials __cb)
    {
        return begin_changeExpiredCredentials(name, oldCred, newCred, null, false, __cb);
    }

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_changeExpiredCredentials(String name, String oldCred, String newCred, java.util.Map<String, String> __ctx, Callback_IAdmin_changeExpiredCredentials __cb)
    {
        return begin_changeExpiredCredentials(name, oldCred, newCred, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_changeExpiredCredentials(String name, String oldCred, String newCred, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__changeExpiredCredentials_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __changeExpiredCredentials_name, __cb);
        try
        {
            __result.__prepare(__changeExpiredCredentials_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(name);
            __os.writeString(oldCred);
            __os.writeString(newCred);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_changeExpiredCredentials(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __changeExpiredCredentials_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __cb The callback object for the operation.
     **/
    public boolean changeExpiredCredentials_async(AMI_IAdmin_changeExpiredCredentials __cb, String name, String oldCred, String newCred)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__changeExpiredCredentials_name);
            __r = begin_changeExpiredCredentials(name, oldCred, newCred, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __changeExpiredCredentials_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Used after an {@link omero.ExpiredCredentialException}
     * instance is thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean changeExpiredCredentials_async(AMI_IAdmin_changeExpiredCredentials __cb, String name, String oldCred, String newCred, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__changeExpiredCredentials_name);
            __r = begin_changeExpiredCredentials(name, oldCred, newCred, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __changeExpiredCredentials_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __changeGroup_name = "changeGroup";

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void changeGroup(omero.model.IObject obj, String omeName)
        throws omero.ServerError
    {
        changeGroup(obj, omeName, null, false);
    }

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void changeGroup(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        changeGroup(obj, omeName, __ctx, true);
    }

    private void changeGroup(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "changeGroup", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("changeGroup");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.changeGroup(obj, omeName, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeGroup(omero.model.IObject obj, String omeName)
    {
        return begin_changeGroup(obj, omeName, null, false, null);
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeGroup(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx)
    {
        return begin_changeGroup(obj, omeName, __ctx, true, null);
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeGroup(omero.model.IObject obj, String omeName, Ice.Callback __cb)
    {
        return begin_changeGroup(obj, omeName, null, false, __cb);
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeGroup(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_changeGroup(obj, omeName, __ctx, true, __cb);
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeGroup(omero.model.IObject obj, String omeName, Callback_IAdmin_changeGroup __cb)
    {
        return begin_changeGroup(obj, omeName, null, false, __cb);
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeGroup(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx, Callback_IAdmin_changeGroup __cb)
    {
        return begin_changeGroup(obj, omeName, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_changeGroup(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__changeGroup_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __changeGroup_name, __cb);
        try
        {
            __result.__prepare(__changeGroup_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(obj);
            __os.writeString(omeName);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_changeGroup(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __changeGroup_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean changeGroup_async(AMI_IAdmin_changeGroup __cb, omero.model.IObject obj, String omeName)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__changeGroup_name);
            __r = begin_changeGroup(obj, omeName, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __changeGroup_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean changeGroup_async(AMI_IAdmin_changeGroup __cb, omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__changeGroup_name);
            __r = begin_changeGroup(obj, omeName, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __changeGroup_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __changeOwner_name = "changeOwner";

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void changeOwner(omero.model.IObject obj, String omeName)
        throws omero.ServerError
    {
        changeOwner(obj, omeName, null, false);
    }

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void changeOwner(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        changeOwner(obj, omeName, __ctx, true);
    }

    private void changeOwner(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "changeOwner", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("changeOwner");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.changeOwner(obj, omeName, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeOwner(omero.model.IObject obj, String omeName)
    {
        return begin_changeOwner(obj, omeName, null, false, null);
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeOwner(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx)
    {
        return begin_changeOwner(obj, omeName, __ctx, true, null);
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeOwner(omero.model.IObject obj, String omeName, Ice.Callback __cb)
    {
        return begin_changeOwner(obj, omeName, null, false, __cb);
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeOwner(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_changeOwner(obj, omeName, __ctx, true, __cb);
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeOwner(omero.model.IObject obj, String omeName, Callback_IAdmin_changeOwner __cb)
    {
        return begin_changeOwner(obj, omeName, null, false, __cb);
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changeOwner(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx, Callback_IAdmin_changeOwner __cb)
    {
        return begin_changeOwner(obj, omeName, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_changeOwner(omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__changeOwner_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __changeOwner_name, __cb);
        try
        {
            __result.__prepare(__changeOwner_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(obj);
            __os.writeString(omeName);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_changeOwner(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __changeOwner_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean changeOwner_async(AMI_IAdmin_changeOwner __cb, omero.model.IObject obj, String omeName)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__changeOwner_name);
            __r = begin_changeOwner(obj, omeName, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __changeOwner_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean changeOwner_async(AMI_IAdmin_changeOwner __cb, omero.model.IObject obj, String omeName, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__changeOwner_name);
            __r = begin_changeOwner(obj, omeName, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __changeOwner_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __changePassword_name = "changePassword";

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @throws SecurityViolation if the user is not authenticated
     * with a password.
     **/
    public void changePassword(omero.RString newPassword)
        throws omero.ServerError
    {
        changePassword(newPassword, null, false);
    }

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @throws SecurityViolation if the user is not authenticated
     * with a password.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void changePassword(omero.RString newPassword, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        changePassword(newPassword, __ctx, true);
    }

    private void changePassword(omero.RString newPassword, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "changePassword", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("changePassword");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.changePassword(newPassword, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     **/
    public Ice.AsyncResult begin_changePassword(omero.RString newPassword)
    {
        return begin_changePassword(newPassword, null, false, null);
    }

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_changePassword(omero.RString newPassword, java.util.Map<String, String> __ctx)
    {
        return begin_changePassword(newPassword, __ctx, true, null);
    }

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     **/
    public Ice.AsyncResult begin_changePassword(omero.RString newPassword, Ice.Callback __cb)
    {
        return begin_changePassword(newPassword, null, false, __cb);
    }

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_changePassword(omero.RString newPassword, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_changePassword(newPassword, __ctx, true, __cb);
    }

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     **/
    public Ice.AsyncResult begin_changePassword(omero.RString newPassword, Callback_IAdmin_changePassword __cb)
    {
        return begin_changePassword(newPassword, null, false, __cb);
    }

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_changePassword(omero.RString newPassword, java.util.Map<String, String> __ctx, Callback_IAdmin_changePassword __cb)
    {
        return begin_changePassword(newPassword, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_changePassword(omero.RString newPassword, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__changePassword_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __changePassword_name, __cb);
        try
        {
            __result.__prepare(__changePassword_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(newPassword);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_changePassword(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __changePassword_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     **/
    public boolean changePassword_async(AMI_IAdmin_changePassword __cb, omero.RString newPassword)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__changePassword_name);
            __r = begin_changePassword(newPassword, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __changePassword_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Changes the password for the current user.
     * <p>
     * <em>Warning:</em>This method requires the user to be
     * authenticated with a password and not with a one-time
     * session id. To avoid this problem, use
     * {@link #changePasswordWithOldPassword}.
     * </p>
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/911">ticket 911</a>
     * and <a href="https://trac.openmicroscopy.org/ome/ticket/3201">ticket 3201</a>
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean changePassword_async(AMI_IAdmin_changePassword __cb, omero.RString newPassword, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__changePassword_name);
            __r = begin_changePassword(newPassword, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __changePassword_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __changePasswordWithOldPassword_name = "changePasswordWithOldPassword";

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @throws SecurityViolation if the oldPassword is incorrect.
     **/
    public void changePasswordWithOldPassword(omero.RString oldPassword, omero.RString newPassword)
        throws omero.ServerError
    {
        changePasswordWithOldPassword(oldPassword, newPassword, null, false);
    }

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @throws SecurityViolation if the oldPassword is incorrect.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void changePasswordWithOldPassword(omero.RString oldPassword, omero.RString newPassword, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        changePasswordWithOldPassword(oldPassword, newPassword, __ctx, true);
    }

    private void changePasswordWithOldPassword(omero.RString oldPassword, omero.RString newPassword, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "changePasswordWithOldPassword", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("changePasswordWithOldPassword");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.changePasswordWithOldPassword(oldPassword, newPassword, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param __cb The callback object for the operation.
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     **/
    public Ice.AsyncResult begin_changePasswordWithOldPassword(omero.RString oldPassword, omero.RString newPassword)
    {
        return begin_changePasswordWithOldPassword(oldPassword, newPassword, null, false, null);
    }

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param __cb The callback object for the operation.
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_changePasswordWithOldPassword(omero.RString oldPassword, omero.RString newPassword, java.util.Map<String, String> __ctx)
    {
        return begin_changePasswordWithOldPassword(oldPassword, newPassword, __ctx, true, null);
    }

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param __cb The callback object for the operation.
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     **/
    public Ice.AsyncResult begin_changePasswordWithOldPassword(omero.RString oldPassword, omero.RString newPassword, Ice.Callback __cb)
    {
        return begin_changePasswordWithOldPassword(oldPassword, newPassword, null, false, __cb);
    }

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param __cb The callback object for the operation.
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_changePasswordWithOldPassword(omero.RString oldPassword, omero.RString newPassword, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_changePasswordWithOldPassword(oldPassword, newPassword, __ctx, true, __cb);
    }

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param __cb The callback object for the operation.
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     **/
    public Ice.AsyncResult begin_changePasswordWithOldPassword(omero.RString oldPassword, omero.RString newPassword, Callback_IAdmin_changePasswordWithOldPassword __cb)
    {
        return begin_changePasswordWithOldPassword(oldPassword, newPassword, null, false, __cb);
    }

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param __cb The callback object for the operation.
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_changePasswordWithOldPassword(omero.RString oldPassword, omero.RString newPassword, java.util.Map<String, String> __ctx, Callback_IAdmin_changePasswordWithOldPassword __cb)
    {
        return begin_changePasswordWithOldPassword(oldPassword, newPassword, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_changePasswordWithOldPassword(omero.RString oldPassword, omero.RString newPassword, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__changePasswordWithOldPassword_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __changePasswordWithOldPassword_name, __cb);
        try
        {
            __result.__prepare(__changePasswordWithOldPassword_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(oldPassword);
            __os.writeObject(newPassword);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_changePasswordWithOldPassword(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __changePasswordWithOldPassword_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param __cb The callback object for the operation.
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     **/
    public boolean changePasswordWithOldPassword_async(AMI_IAdmin_changePasswordWithOldPassword __cb, omero.RString oldPassword, omero.RString newPassword)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__changePasswordWithOldPassword_name);
            __r = begin_changePasswordWithOldPassword(oldPassword, newPassword, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __changePasswordWithOldPassword_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Changes the password for the current user by passing the
     * old password.
     * 
     * @param __cb The callback object for the operation.
     * @param oldPassword Not-null. Must pass validation in the
     * security sub-system.
     * @param newPassword Possibly null to allow logging in with
     * no password.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean changePasswordWithOldPassword_async(AMI_IAdmin_changePasswordWithOldPassword __cb, omero.RString oldPassword, omero.RString newPassword, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__changePasswordWithOldPassword_name);
            __r = begin_changePasswordWithOldPassword(oldPassword, newPassword, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __changePasswordWithOldPassword_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __changePermissions_name = "changePermissions";

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void changePermissions(omero.model.IObject obj, omero.model.Permissions perms)
        throws omero.ServerError
    {
        changePermissions(obj, perms, null, false);
    }

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void changePermissions(omero.model.IObject obj, omero.model.Permissions perms, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        changePermissions(obj, perms, __ctx, true);
    }

    private void changePermissions(omero.model.IObject obj, omero.model.Permissions perms, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "changePermissions", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("changePermissions");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.changePermissions(obj, perms, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changePermissions(omero.model.IObject obj, omero.model.Permissions perms)
    {
        return begin_changePermissions(obj, perms, null, false, null);
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changePermissions(omero.model.IObject obj, omero.model.Permissions perms, java.util.Map<String, String> __ctx)
    {
        return begin_changePermissions(obj, perms, __ctx, true, null);
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changePermissions(omero.model.IObject obj, omero.model.Permissions perms, Ice.Callback __cb)
    {
        return begin_changePermissions(obj, perms, null, false, __cb);
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changePermissions(omero.model.IObject obj, omero.model.Permissions perms, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_changePermissions(obj, perms, __ctx, true, __cb);
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changePermissions(omero.model.IObject obj, omero.model.Permissions perms, Callback_IAdmin_changePermissions __cb)
    {
        return begin_changePermissions(obj, perms, null, false, __cb);
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_changePermissions(omero.model.IObject obj, omero.model.Permissions perms, java.util.Map<String, String> __ctx, Callback_IAdmin_changePermissions __cb)
    {
        return begin_changePermissions(obj, perms, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_changePermissions(omero.model.IObject obj, omero.model.Permissions perms, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__changePermissions_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __changePermissions_name, __cb);
        try
        {
            __result.__prepare(__changePermissions_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(obj);
            __os.writeObject(perms);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_changePermissions(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __changePermissions_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean changePermissions_async(AMI_IAdmin_changePermissions __cb, omero.model.IObject obj, omero.model.Permissions perms)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__changePermissions_name);
            __r = begin_changePermissions(obj, perms, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __changePermissions_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean changePermissions_async(AMI_IAdmin_changePermissions __cb, omero.model.IObject obj, omero.model.Permissions perms, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__changePermissions_name);
            __r = begin_changePermissions(obj, perms, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __changePermissions_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __changeUserPassword_name = "changeUserPassword";

    /**
     * Changes the password for the a given user.
     * 
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     * @throws SecurityViolation if the new password is too weak.
     **/
    public void changeUserPassword(String omeName, omero.RString newPassword)
        throws omero.ServerError
    {
        changeUserPassword(omeName, newPassword, null, false);
    }

    /**
     * Changes the password for the a given user.
     * 
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     * @throws SecurityViolation if the new password is too weak.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void changeUserPassword(String omeName, omero.RString newPassword, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        changeUserPassword(omeName, newPassword, __ctx, true);
    }

    private void changeUserPassword(String omeName, omero.RString newPassword, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "changeUserPassword", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("changeUserPassword");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.changeUserPassword(omeName, newPassword, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Changes the password for the a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     **/
    public Ice.AsyncResult begin_changeUserPassword(String omeName, omero.RString newPassword)
    {
        return begin_changeUserPassword(omeName, newPassword, null, false, null);
    }

    /**
     * Changes the password for the a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_changeUserPassword(String omeName, omero.RString newPassword, java.util.Map<String, String> __ctx)
    {
        return begin_changeUserPassword(omeName, newPassword, __ctx, true, null);
    }

    /**
     * Changes the password for the a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     **/
    public Ice.AsyncResult begin_changeUserPassword(String omeName, omero.RString newPassword, Ice.Callback __cb)
    {
        return begin_changeUserPassword(omeName, newPassword, null, false, __cb);
    }

    /**
     * Changes the password for the a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_changeUserPassword(String omeName, omero.RString newPassword, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_changeUserPassword(omeName, newPassword, __ctx, true, __cb);
    }

    /**
     * Changes the password for the a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     **/
    public Ice.AsyncResult begin_changeUserPassword(String omeName, omero.RString newPassword, Callback_IAdmin_changeUserPassword __cb)
    {
        return begin_changeUserPassword(omeName, newPassword, null, false, __cb);
    }

    /**
     * Changes the password for the a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_changeUserPassword(String omeName, omero.RString newPassword, java.util.Map<String, String> __ctx, Callback_IAdmin_changeUserPassword __cb)
    {
        return begin_changeUserPassword(omeName, newPassword, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_changeUserPassword(String omeName, omero.RString newPassword, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__changeUserPassword_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __changeUserPassword_name, __cb);
        try
        {
            __result.__prepare(__changeUserPassword_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(omeName);
            __os.writeObject(newPassword);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_changeUserPassword(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __changeUserPassword_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Changes the password for the a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     **/
    public boolean changeUserPassword_async(AMI_IAdmin_changeUserPassword __cb, String omeName, omero.RString newPassword)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__changeUserPassword_name);
            __r = begin_changeUserPassword(omeName, newPassword, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __changeUserPassword_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Changes the password for the a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param newPassword Not-null. Might must pass validation in
     * the security sub-system.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean changeUserPassword_async(AMI_IAdmin_changeUserPassword __cb, String omeName, omero.RString newPassword, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__changeUserPassword_name);
            __r = begin_changeUserPassword(omeName, newPassword, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __changeUserPassword_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __containedExperimenters_name = "containedExperimenters";

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param groupId id of the ExperimenterGroup
     * @return non-null array of all
     * {@link omero.model.Experimenter} users in this group.
     **/
    public java.util.List<omero.model.Experimenter> containedExperimenters(long groupId)
        throws omero.ServerError
    {
        return containedExperimenters(groupId, null, false);
    }

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param groupId id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     * @return non-null array of all
     * {@link omero.model.Experimenter} users in this group.
     **/
    public java.util.List<omero.model.Experimenter> containedExperimenters(long groupId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return containedExperimenters(groupId, __ctx, true);
    }

    private java.util.List<omero.model.Experimenter> containedExperimenters(long groupId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "containedExperimenters", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("containedExperimenters");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.containedExperimenters(groupId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param groupId id of the ExperimenterGroup
     **/
    public Ice.AsyncResult begin_containedExperimenters(long groupId)
    {
        return begin_containedExperimenters(groupId, null, false, null);
    }

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param groupId id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_containedExperimenters(long groupId, java.util.Map<String, String> __ctx)
    {
        return begin_containedExperimenters(groupId, __ctx, true, null);
    }

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param groupId id of the ExperimenterGroup
     **/
    public Ice.AsyncResult begin_containedExperimenters(long groupId, Ice.Callback __cb)
    {
        return begin_containedExperimenters(groupId, null, false, __cb);
    }

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param groupId id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_containedExperimenters(long groupId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_containedExperimenters(groupId, __ctx, true, __cb);
    }

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param groupId id of the ExperimenterGroup
     **/
    public Ice.AsyncResult begin_containedExperimenters(long groupId, Callback_IAdmin_containedExperimenters __cb)
    {
        return begin_containedExperimenters(groupId, null, false, __cb);
    }

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param groupId id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_containedExperimenters(long groupId, java.util.Map<String, String> __ctx, Callback_IAdmin_containedExperimenters __cb)
    {
        return begin_containedExperimenters(groupId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_containedExperimenters(long groupId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__containedExperimenters_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __containedExperimenters_name, __cb);
        try
        {
            __result.__prepare(__containedExperimenters_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(groupId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) non-null array of all
     * {@link omero.model.Experimenter} users in this group.
     **/
    public java.util.List<omero.model.Experimenter> end_containedExperimenters(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __containedExperimenters_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.Experimenter> __ret;
            __ret = ExperimenterListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param groupId id of the ExperimenterGroup
     **/
    public boolean containedExperimenters_async(AMI_IAdmin_containedExperimenters __cb, long groupId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__containedExperimenters_name);
            __r = begin_containedExperimenters(groupId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __containedExperimenters_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Fetches all {@link omero.model.Experimenter} users
     * contained in this group. The returned users will have all
     * fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param groupId id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean containedExperimenters_async(AMI_IAdmin_containedExperimenters __cb, long groupId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__containedExperimenters_name);
            __r = begin_containedExperimenters(groupId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __containedExperimenters_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __containedGroups_name = "containedGroups";

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param experimenterId id of the Experimenter. Not null.
     * @return non-null array of all
     * {@link omero.model.ExperimenterGroup} groups for this user.
     **/
    public java.util.List<omero.model.ExperimenterGroup> containedGroups(long experimenterId)
        throws omero.ServerError
    {
        return containedGroups(experimenterId, null, false);
    }

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param experimenterId id of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return non-null array of all
     * {@link omero.model.ExperimenterGroup} groups for this user.
     **/
    public java.util.List<omero.model.ExperimenterGroup> containedGroups(long experimenterId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return containedGroups(experimenterId, __ctx, true);
    }

    private java.util.List<omero.model.ExperimenterGroup> containedGroups(long experimenterId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "containedGroups", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("containedGroups");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.containedGroups(experimenterId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId id of the Experimenter. Not null.
     **/
    public Ice.AsyncResult begin_containedGroups(long experimenterId)
    {
        return begin_containedGroups(experimenterId, null, false, null);
    }

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId id of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_containedGroups(long experimenterId, java.util.Map<String, String> __ctx)
    {
        return begin_containedGroups(experimenterId, __ctx, true, null);
    }

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId id of the Experimenter. Not null.
     **/
    public Ice.AsyncResult begin_containedGroups(long experimenterId, Ice.Callback __cb)
    {
        return begin_containedGroups(experimenterId, null, false, __cb);
    }

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId id of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_containedGroups(long experimenterId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_containedGroups(experimenterId, __ctx, true, __cb);
    }

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId id of the Experimenter. Not null.
     **/
    public Ice.AsyncResult begin_containedGroups(long experimenterId, Callback_IAdmin_containedGroups __cb)
    {
        return begin_containedGroups(experimenterId, null, false, __cb);
    }

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId id of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_containedGroups(long experimenterId, java.util.Map<String, String> __ctx, Callback_IAdmin_containedGroups __cb)
    {
        return begin_containedGroups(experimenterId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_containedGroups(long experimenterId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__containedGroups_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __containedGroups_name, __cb);
        try
        {
            __result.__prepare(__containedGroups_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(experimenterId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) non-null array of all
     * {@link omero.model.ExperimenterGroup} groups for this user.
     **/
    public java.util.List<omero.model.ExperimenterGroup> end_containedGroups(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __containedGroups_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.ExperimenterGroup> __ret;
            __ret = ExperimenterGroupListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId id of the Experimenter. Not null.
     **/
    public boolean containedGroups_async(AMI_IAdmin_containedGroups __cb, long experimenterId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__containedGroups_name);
            __r = begin_containedGroups(experimenterId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __containedGroups_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Fetches all {@link omero.model.ExperimenterGroup} groups of
     * which the given user is a member. The returned groups will
     * have all fields filled in and all collections unloaded.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId id of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean containedGroups_async(AMI_IAdmin_containedGroups __cb, long experimenterId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__containedGroups_name);
            __r = begin_containedGroups(experimenterId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __containedGroups_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __createExperimenter_name = "createExperimenter";

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @return id of the newly created
     * {@link omero.model.Experimenter} Not null.
     **/
    public long createExperimenter(omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups)
        throws omero.ServerError
    {
        return createExperimenter(user, defaultGroup, groups, null, false);
    }

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     * @return id of the newly created
     * {@link omero.model.Experimenter} Not null.
     **/
    public long createExperimenter(omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return createExperimenter(user, defaultGroup, groups, __ctx, true);
    }

    private long createExperimenter(omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "createExperimenter", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("createExperimenter");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.createExperimenter(user, defaultGroup, groups, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     **/
    public Ice.AsyncResult begin_createExperimenter(omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups)
    {
        return begin_createExperimenter(user, defaultGroup, groups, null, false, null);
    }

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createExperimenter(omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx)
    {
        return begin_createExperimenter(user, defaultGroup, groups, __ctx, true, null);
    }

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     **/
    public Ice.AsyncResult begin_createExperimenter(omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, Ice.Callback __cb)
    {
        return begin_createExperimenter(user, defaultGroup, groups, null, false, __cb);
    }

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createExperimenter(omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_createExperimenter(user, defaultGroup, groups, __ctx, true, __cb);
    }

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     **/
    public Ice.AsyncResult begin_createExperimenter(omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, Callback_IAdmin_createExperimenter __cb)
    {
        return begin_createExperimenter(user, defaultGroup, groups, null, false, __cb);
    }

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createExperimenter(omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, Callback_IAdmin_createExperimenter __cb)
    {
        return begin_createExperimenter(user, defaultGroup, groups, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_createExperimenter(omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__createExperimenter_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __createExperimenter_name, __cb);
        try
        {
            __result.__prepare(__createExperimenter_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(user);
            __os.writeObject(defaultGroup);
            ExperimenterGroupListHelper.write(__os, groups);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) id of the newly created
     * {@link omero.model.Experimenter} Not null.
     **/
    public long end_createExperimenter(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __createExperimenter_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     **/
    public boolean createExperimenter_async(AMI_IAdmin_createExperimenter __cb, omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createExperimenter_name);
            __r = begin_createExperimenter(user, defaultGroup, groups, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createExperimenter_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Creates and returns a new user in the given groups.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createExperimenter_async(AMI_IAdmin_createExperimenter __cb, omero.model.Experimenter user, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createExperimenter_name);
            __r = begin_createExperimenter(user, defaultGroup, groups, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createExperimenter_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __createExperimenterWithPassword_name = "createExperimenterWithPassword";

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @return id of the newly created
     * {@link omero.model.Experimenter} Not null.
     * @throws SecurityViolation if the new password is too weak.
     **/
    public long createExperimenterWithPassword(omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups)
        throws omero.ServerError
    {
        return createExperimenterWithPassword(user, password, defaultGroup, groups, null, false);
    }

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     * @return id of the newly created
     * {@link omero.model.Experimenter} Not null.
     * @throws SecurityViolation if the new password is too weak.
     **/
    public long createExperimenterWithPassword(omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return createExperimenterWithPassword(user, password, defaultGroup, groups, __ctx, true);
    }

    private long createExperimenterWithPassword(omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "createExperimenterWithPassword", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("createExperimenterWithPassword");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.createExperimenterWithPassword(user, password, defaultGroup, groups, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     **/
    public Ice.AsyncResult begin_createExperimenterWithPassword(omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups)
    {
        return begin_createExperimenterWithPassword(user, password, defaultGroup, groups, null, false, null);
    }

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createExperimenterWithPassword(omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx)
    {
        return begin_createExperimenterWithPassword(user, password, defaultGroup, groups, __ctx, true, null);
    }

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     **/
    public Ice.AsyncResult begin_createExperimenterWithPassword(omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, Ice.Callback __cb)
    {
        return begin_createExperimenterWithPassword(user, password, defaultGroup, groups, null, false, __cb);
    }

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createExperimenterWithPassword(omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_createExperimenterWithPassword(user, password, defaultGroup, groups, __ctx, true, __cb);
    }

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     **/
    public Ice.AsyncResult begin_createExperimenterWithPassword(omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, Callback_IAdmin_createExperimenterWithPassword __cb)
    {
        return begin_createExperimenterWithPassword(user, password, defaultGroup, groups, null, false, __cb);
    }

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createExperimenterWithPassword(omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, Callback_IAdmin_createExperimenterWithPassword __cb)
    {
        return begin_createExperimenterWithPassword(user, password, defaultGroup, groups, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_createExperimenterWithPassword(omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__createExperimenterWithPassword_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __createExperimenterWithPassword_name, __cb);
        try
        {
            __result.__prepare(__createExperimenterWithPassword_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(user);
            __os.writeObject(password);
            __os.writeObject(defaultGroup);
            ExperimenterGroupListHelper.write(__os, groups);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) id of the newly created
     * {@link omero.model.Experimenter} Not null.
     **/
    public long end_createExperimenterWithPassword(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __createExperimenterWithPassword_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     **/
    public boolean createExperimenterWithPassword_async(AMI_IAdmin_createExperimenterWithPassword __cb, omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createExperimenterWithPassword_name);
            __r = begin_createExperimenterWithPassword(user, password, defaultGroup, groups, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createExperimenterWithPassword_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Creates and returns a new user in the given groups with
     * password.
     * 
     * @param __cb The callback object for the operation.
     * @param user A new {@link omero.model.Experimenter}
     * instance. Not null.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param defaultGroup Instance of
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param groups Array of
     * {@link omero.model.ExperimenterGroup} instances. Can
     * be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createExperimenterWithPassword_async(AMI_IAdmin_createExperimenterWithPassword __cb, omero.model.Experimenter user, omero.RString password, omero.model.ExperimenterGroup defaultGroup, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createExperimenterWithPassword_name);
            __r = begin_createExperimenterWithPassword(user, password, defaultGroup, groups, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createExperimenterWithPassword_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __createGroup_name = "createGroup";

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     * @return id of the newly created {@link ExperimenterGroup}
     **/
    public long createGroup(omero.model.ExperimenterGroup group)
        throws omero.ServerError
    {
        return createGroup(group, null, false);
    }

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return id of the newly created {@link ExperimenterGroup}
     **/
    public long createGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return createGroup(group, __ctx, true);
    }

    private long createGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "createGroup", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("createGroup");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.createGroup(group, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param __cb The callback object for the operation.
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     **/
    public Ice.AsyncResult begin_createGroup(omero.model.ExperimenterGroup group)
    {
        return begin_createGroup(group, null, false, null);
    }

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param __cb The callback object for the operation.
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx)
    {
        return begin_createGroup(group, __ctx, true, null);
    }

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param __cb The callback object for the operation.
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     **/
    public Ice.AsyncResult begin_createGroup(omero.model.ExperimenterGroup group, Ice.Callback __cb)
    {
        return begin_createGroup(group, null, false, __cb);
    }

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param __cb The callback object for the operation.
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_createGroup(group, __ctx, true, __cb);
    }

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param __cb The callback object for the operation.
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     **/
    public Ice.AsyncResult begin_createGroup(omero.model.ExperimenterGroup group, Callback_IAdmin_createGroup __cb)
    {
        return begin_createGroup(group, null, false, __cb);
    }

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param __cb The callback object for the operation.
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, Callback_IAdmin_createGroup __cb)
    {
        return begin_createGroup(group, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_createGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__createGroup_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __createGroup_name, __cb);
        try
        {
            __result.__prepare(__createGroup_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(group);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) id of the newly created {@link ExperimenterGroup}
     **/
    public long end_createGroup(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __createGroup_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param __cb The callback object for the operation.
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     **/
    public boolean createGroup_async(AMI_IAdmin_createGroup __cb, omero.model.ExperimenterGroup group)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createGroup_name);
            __r = begin_createGroup(group, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createGroup_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Creates and returns a new group. The
     * {@link omero.model.Details#setPermissions} method should be
     * called on the instance which is passed. The given
     * {@link omero.model.Permissions} will become the default for
     * all objects created while logged into this group, possibly
     * modified by the user's umask settings.
     * If no permissions is set, the default will be
     * {@link omero.model.Permissions#USER_PRIVATE},
     * i.e. a group in which no user can see the other group
     * member's data.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1434">ticket 1434</a>
     * 
     * @param __cb The callback object for the operation.
     * @param group  a new
     * {@link omero.model.ExperimenterGroup} instance. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createGroup_async(AMI_IAdmin_createGroup __cb, omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createGroup_name);
            __r = begin_createGroup(group, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createGroup_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __createSystemUser_name = "createSystemUser";

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @return id of the newly created
     * {@link omero.model.Experimenter}
     **/
    public long createSystemUser(omero.model.Experimenter experimenter)
        throws omero.ServerError
    {
        return createSystemUser(experimenter, null, false);
    }

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param __ctx The Context map to send with the invocation.
     * @return id of the newly created
     * {@link omero.model.Experimenter}
     **/
    public long createSystemUser(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return createSystemUser(experimenter, __ctx, true);
    }

    private long createSystemUser(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "createSystemUser", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("createSystemUser");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.createSystemUser(experimenter, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     **/
    public Ice.AsyncResult begin_createSystemUser(omero.model.Experimenter experimenter)
    {
        return begin_createSystemUser(experimenter, null, false, null);
    }

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createSystemUser(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx)
    {
        return begin_createSystemUser(experimenter, __ctx, true, null);
    }

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     **/
    public Ice.AsyncResult begin_createSystemUser(omero.model.Experimenter experimenter, Ice.Callback __cb)
    {
        return begin_createSystemUser(experimenter, null, false, __cb);
    }

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createSystemUser(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_createSystemUser(experimenter, __ctx, true, __cb);
    }

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     **/
    public Ice.AsyncResult begin_createSystemUser(omero.model.Experimenter experimenter, Callback_IAdmin_createSystemUser __cb)
    {
        return begin_createSystemUser(experimenter, null, false, __cb);
    }

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createSystemUser(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx, Callback_IAdmin_createSystemUser __cb)
    {
        return begin_createSystemUser(experimenter, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_createSystemUser(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__createSystemUser_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __createSystemUser_name, __cb);
        try
        {
            __result.__prepare(__createSystemUser_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(experimenter);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) id of the newly created
     * {@link omero.model.Experimenter}
     **/
    public long end_createSystemUser(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __createSystemUser_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     **/
    public boolean createSystemUser_async(AMI_IAdmin_createSystemUser __cb, omero.model.Experimenter experimenter)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createSystemUser_name);
            __r = begin_createSystemUser(experimenter, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createSystemUser_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Creates and returns a new system user. This user will be
     * created with the <i>System</i> (administration) group as
     * default and will also be in the <i>user</i> group.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createSystemUser_async(AMI_IAdmin_createSystemUser __cb, omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createSystemUser_name);
            __r = begin_createSystemUser(experimenter, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createSystemUser_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __createUser_name = "createUser";

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     * @return id of the newly created
     * {@link omero.model.Experimenter}
     **/
    public long createUser(omero.model.Experimenter experimenter, String group)
        throws omero.ServerError
    {
        return createUser(experimenter, group, null, false);
    }

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     * @param __ctx The Context map to send with the invocation.
     * @return id of the newly created
     * {@link omero.model.Experimenter}
     **/
    public long createUser(omero.model.Experimenter experimenter, String group, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return createUser(experimenter, group, __ctx, true);
    }

    private long createUser(omero.model.Experimenter experimenter, String group, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "createUser", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("createUser");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.createUser(experimenter, group, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     **/
    public Ice.AsyncResult begin_createUser(omero.model.Experimenter experimenter, String group)
    {
        return begin_createUser(experimenter, group, null, false, null);
    }

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createUser(omero.model.Experimenter experimenter, String group, java.util.Map<String, String> __ctx)
    {
        return begin_createUser(experimenter, group, __ctx, true, null);
    }

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     **/
    public Ice.AsyncResult begin_createUser(omero.model.Experimenter experimenter, String group, Ice.Callback __cb)
    {
        return begin_createUser(experimenter, group, null, false, __cb);
    }

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createUser(omero.model.Experimenter experimenter, String group, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_createUser(experimenter, group, __ctx, true, __cb);
    }

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     **/
    public Ice.AsyncResult begin_createUser(omero.model.Experimenter experimenter, String group, Callback_IAdmin_createUser __cb)
    {
        return begin_createUser(experimenter, group, null, false, __cb);
    }

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createUser(omero.model.Experimenter experimenter, String group, java.util.Map<String, String> __ctx, Callback_IAdmin_createUser __cb)
    {
        return begin_createUser(experimenter, group, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_createUser(omero.model.Experimenter experimenter, String group, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__createUser_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __createUser_name, __cb);
        try
        {
            __result.__prepare(__createUser_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(experimenter);
            __os.writeString(group);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) id of the newly created
     * {@link omero.model.Experimenter}
     **/
    public long end_createUser(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __createUser_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     **/
    public boolean createUser_async(AMI_IAdmin_createUser __cb, omero.model.Experimenter experimenter, String group)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createUser_name);
            __r = begin_createUser(experimenter, group, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createUser_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Creates and returns a new user. This user will be created
     * with the default group specified.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter a new {@link omero.model.Experimenter}
     * instance
     * @param group group name of the default group for this user
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createUser_async(AMI_IAdmin_createUser __cb, omero.model.Experimenter experimenter, String group, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createUser_name);
            __r = begin_createUser(experimenter, group, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createUser_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __deleteExperimenter_name = "deleteExperimenter";

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param user Experimenter to be deleted. Not null.
     **/
    public void deleteExperimenter(omero.model.Experimenter user)
        throws omero.ServerError
    {
        deleteExperimenter(user, null, false);
    }

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param user Experimenter to be deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void deleteExperimenter(omero.model.Experimenter user, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        deleteExperimenter(user, __ctx, true);
    }

    private void deleteExperimenter(omero.model.Experimenter user, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "deleteExperimenter", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("deleteExperimenter");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.deleteExperimenter(user, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param __cb The callback object for the operation.
     * @param user Experimenter to be deleted. Not null.
     **/
    public Ice.AsyncResult begin_deleteExperimenter(omero.model.Experimenter user)
    {
        return begin_deleteExperimenter(user, null, false, null);
    }

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param __cb The callback object for the operation.
     * @param user Experimenter to be deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_deleteExperimenter(omero.model.Experimenter user, java.util.Map<String, String> __ctx)
    {
        return begin_deleteExperimenter(user, __ctx, true, null);
    }

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param __cb The callback object for the operation.
     * @param user Experimenter to be deleted. Not null.
     **/
    public Ice.AsyncResult begin_deleteExperimenter(omero.model.Experimenter user, Ice.Callback __cb)
    {
        return begin_deleteExperimenter(user, null, false, __cb);
    }

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param __cb The callback object for the operation.
     * @param user Experimenter to be deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_deleteExperimenter(omero.model.Experimenter user, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_deleteExperimenter(user, __ctx, true, __cb);
    }

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param __cb The callback object for the operation.
     * @param user Experimenter to be deleted. Not null.
     **/
    public Ice.AsyncResult begin_deleteExperimenter(omero.model.Experimenter user, Callback_IAdmin_deleteExperimenter __cb)
    {
        return begin_deleteExperimenter(user, null, false, __cb);
    }

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param __cb The callback object for the operation.
     * @param user Experimenter to be deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_deleteExperimenter(omero.model.Experimenter user, java.util.Map<String, String> __ctx, Callback_IAdmin_deleteExperimenter __cb)
    {
        return begin_deleteExperimenter(user, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_deleteExperimenter(omero.model.Experimenter user, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__deleteExperimenter_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __deleteExperimenter_name, __cb);
        try
        {
            __result.__prepare(__deleteExperimenter_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(user);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_deleteExperimenter(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __deleteExperimenter_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param __cb The callback object for the operation.
     * @param user Experimenter to be deleted. Not null.
     **/
    public boolean deleteExperimenter_async(AMI_IAdmin_deleteExperimenter __cb, omero.model.Experimenter user)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__deleteExperimenter_name);
            __r = begin_deleteExperimenter(user, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __deleteExperimenter_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Removes a user by removing the password information for
     * that user as well as all
     * {@link omero.model.GroupExperimenterMap} instances.
     * 
     * @param __cb The callback object for the operation.
     * @param user Experimenter to be deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean deleteExperimenter_async(AMI_IAdmin_deleteExperimenter __cb, omero.model.Experimenter user, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__deleteExperimenter_name);
            __r = begin_deleteExperimenter(user, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __deleteExperimenter_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __deleteGroup_name = "deleteGroup";

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     **/
    public void deleteGroup(omero.model.ExperimenterGroup group)
        throws omero.ServerError
    {
        deleteGroup(group, null, false);
    }

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void deleteGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        deleteGroup(group, __ctx, true);
    }

    private void deleteGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "deleteGroup", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("deleteGroup");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.deleteGroup(group, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     **/
    public Ice.AsyncResult begin_deleteGroup(omero.model.ExperimenterGroup group)
    {
        return begin_deleteGroup(group, null, false, null);
    }

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_deleteGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx)
    {
        return begin_deleteGroup(group, __ctx, true, null);
    }

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     **/
    public Ice.AsyncResult begin_deleteGroup(omero.model.ExperimenterGroup group, Ice.Callback __cb)
    {
        return begin_deleteGroup(group, null, false, __cb);
    }

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_deleteGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_deleteGroup(group, __ctx, true, __cb);
    }

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     **/
    public Ice.AsyncResult begin_deleteGroup(omero.model.ExperimenterGroup group, Callback_IAdmin_deleteGroup __cb)
    {
        return begin_deleteGroup(group, null, false, __cb);
    }

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_deleteGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, Callback_IAdmin_deleteGroup __cb)
    {
        return begin_deleteGroup(group, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_deleteGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__deleteGroup_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __deleteGroup_name, __cb);
        try
        {
            __result.__prepare(__deleteGroup_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(group);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_deleteGroup(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __deleteGroup_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     **/
    public boolean deleteGroup_async(AMI_IAdmin_deleteGroup __cb, omero.model.ExperimenterGroup group)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__deleteGroup_name);
            __r = begin_deleteGroup(group, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __deleteGroup_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Removes a group by first removing all users in the group,
     * and then deleting the actual
     * {@link omero.model.ExperimenterGroup} instance.
     * 
     * @param __cb The callback object for the operation.
     * @param group {@link omero.model.ExperimenterGroup} to be
     * deleted. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean deleteGroup_async(AMI_IAdmin_deleteGroup __cb, omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__deleteGroup_name);
            __r = begin_deleteGroup(group, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __deleteGroup_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getDefaultGroup_name = "getDefaultGroup";

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param experimenterId of the Experimenter. Not null.
     * @return non-null {@link omero.model.ExperimenterGroup}. If
     * no default group is found, an exception will be
     * thrown.
     **/
    public omero.model.ExperimenterGroup getDefaultGroup(long experimenterId)
        throws omero.ServerError
    {
        return getDefaultGroup(experimenterId, null, false);
    }

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param experimenterId of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return non-null {@link omero.model.ExperimenterGroup}. If
     * no default group is found, an exception will be
     * thrown.
     **/
    public omero.model.ExperimenterGroup getDefaultGroup(long experimenterId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getDefaultGroup(experimenterId, __ctx, true);
    }

    private omero.model.ExperimenterGroup getDefaultGroup(long experimenterId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getDefaultGroup", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getDefaultGroup");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.getDefaultGroup(experimenterId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId of the Experimenter. Not null.
     **/
    public Ice.AsyncResult begin_getDefaultGroup(long experimenterId)
    {
        return begin_getDefaultGroup(experimenterId, null, false, null);
    }

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getDefaultGroup(long experimenterId, java.util.Map<String, String> __ctx)
    {
        return begin_getDefaultGroup(experimenterId, __ctx, true, null);
    }

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId of the Experimenter. Not null.
     **/
    public Ice.AsyncResult begin_getDefaultGroup(long experimenterId, Ice.Callback __cb)
    {
        return begin_getDefaultGroup(experimenterId, null, false, __cb);
    }

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getDefaultGroup(long experimenterId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getDefaultGroup(experimenterId, __ctx, true, __cb);
    }

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId of the Experimenter. Not null.
     **/
    public Ice.AsyncResult begin_getDefaultGroup(long experimenterId, Callback_IAdmin_getDefaultGroup __cb)
    {
        return begin_getDefaultGroup(experimenterId, null, false, __cb);
    }

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getDefaultGroup(long experimenterId, java.util.Map<String, String> __ctx, Callback_IAdmin_getDefaultGroup __cb)
    {
        return begin_getDefaultGroup(experimenterId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getDefaultGroup(long experimenterId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getDefaultGroup_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getDefaultGroup_name, __cb);
        try
        {
            __result.__prepare(__getDefaultGroup_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(experimenterId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) non-null {@link omero.model.ExperimenterGroup}. If
     * no default group is found, an exception will be
     * thrown.
     **/
    public omero.model.ExperimenterGroup end_getDefaultGroup(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getDefaultGroup_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.ExperimenterGroupHolder __ret = new omero.model.ExperimenterGroupHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId of the Experimenter. Not null.
     **/
    public boolean getDefaultGroup_async(AMI_IAdmin_getDefaultGroup __cb, long experimenterId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getDefaultGroup_name);
            __r = begin_getDefaultGroup(experimenterId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getDefaultGroup_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the default {@link omero.model.ExperimenterGroup}
     * group for the given user id.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenterId of the Experimenter. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getDefaultGroup_async(AMI_IAdmin_getDefaultGroup __cb, long experimenterId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getDefaultGroup_name);
            __r = begin_getDefaultGroup(experimenterId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getDefaultGroup_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getEventContext_name = "getEventContext";

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @return Non-null, immutable {@link omero.sys.EventContext}
     * instance
     **/
    public omero.sys.EventContext getEventContext()
        throws omero.ServerError
    {
        return getEventContext(null, false);
    }

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return Non-null, immutable {@link omero.sys.EventContext}
     * instance
     **/
    public omero.sys.EventContext getEventContext(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getEventContext(__ctx, true);
    }

    private omero.sys.EventContext getEventContext(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getEventContext", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getEventContext");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.getEventContext(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getEventContext()
    {
        return begin_getEventContext(null, false, null);
    }

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getEventContext(java.util.Map<String, String> __ctx)
    {
        return begin_getEventContext(__ctx, true, null);
    }

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getEventContext(Ice.Callback __cb)
    {
        return begin_getEventContext(null, false, __cb);
    }

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getEventContext(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getEventContext(__ctx, true, __cb);
    }

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getEventContext(Callback_IAdmin_getEventContext __cb)
    {
        return begin_getEventContext(null, false, __cb);
    }

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getEventContext(java.util.Map<String, String> __ctx, Callback_IAdmin_getEventContext __cb)
    {
        return begin_getEventContext(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getEventContext(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getEventContext_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getEventContext_name, __cb);
        try
        {
            __result.__prepare(__getEventContext_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Non-null, immutable {@link omero.sys.EventContext}
     * instance
     **/
    public omero.sys.EventContext end_getEventContext(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getEventContext_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.sys.EventContextHolder __ret = new omero.sys.EventContextHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getEventContext_async(AMI_IAdmin_getEventContext __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getEventContext_name);
            __r = begin_getEventContext(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getEventContext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns an implementation of {@link omero.sys.EventContext}
     * loaded with the security for the current user and thread.
     * If called remotely, not all values of
     * {@link omero.sys.EventContext} will be sensible.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getEventContext_async(AMI_IAdmin_getEventContext __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getEventContext_name);
            __r = begin_getEventContext(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getEventContext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getExperimenter_name = "getExperimenter";

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param id id of the Experimenter
     * @return an Experimenter. Never null.
     * @throws ApiUsageException if id does not exist.
     **/
    public omero.model.Experimenter getExperimenter(long id)
        throws omero.ServerError
    {
        return getExperimenter(id, null, false);
    }

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param id id of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     * @return an Experimenter. Never null.
     * @throws ApiUsageException if id does not exist.
     **/
    public omero.model.Experimenter getExperimenter(long id, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getExperimenter(id, __ctx, true);
    }

    private omero.model.Experimenter getExperimenter(long id, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getExperimenter", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getExperimenter");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.getExperimenter(id, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the Experimenter
     **/
    public Ice.AsyncResult begin_getExperimenter(long id)
    {
        return begin_getExperimenter(id, null, false, null);
    }

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getExperimenter(long id, java.util.Map<String, String> __ctx)
    {
        return begin_getExperimenter(id, __ctx, true, null);
    }

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the Experimenter
     **/
    public Ice.AsyncResult begin_getExperimenter(long id, Ice.Callback __cb)
    {
        return begin_getExperimenter(id, null, false, __cb);
    }

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getExperimenter(long id, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getExperimenter(id, __ctx, true, __cb);
    }

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the Experimenter
     **/
    public Ice.AsyncResult begin_getExperimenter(long id, Callback_IAdmin_getExperimenter __cb)
    {
        return begin_getExperimenter(id, null, false, __cb);
    }

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getExperimenter(long id, java.util.Map<String, String> __ctx, Callback_IAdmin_getExperimenter __cb)
    {
        return begin_getExperimenter(id, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getExperimenter(long id, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getExperimenter_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getExperimenter_name, __cb);
        try
        {
            __result.__prepare(__getExperimenter_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(id);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) an Experimenter. Never null.
     **/
    public omero.model.Experimenter end_getExperimenter(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getExperimenter_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.ExperimenterHolder __ret = new omero.model.ExperimenterHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the Experimenter
     **/
    public boolean getExperimenter_async(AMI_IAdmin_getExperimenter __cb, long id)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getExperimenter_name);
            __r = begin_getExperimenter(id, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getExperimenter_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Fetches an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup}.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getExperimenter_async(AMI_IAdmin_getExperimenter __cb, long id, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getExperimenter_name);
            __r = begin_getExperimenter(id, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getExperimenter_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getGroup_name = "getGroup";

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param id id of the ExperimenterGroup
     * @return an ExperimenterGroup. Never null.
     * @throws ApiUsageException if id does not exist.
     **/
    public omero.model.ExperimenterGroup getGroup(long id)
        throws omero.ServerError
    {
        return getGroup(id, null, false);
    }

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param id id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     * @return an ExperimenterGroup. Never null.
     * @throws ApiUsageException if id does not exist.
     **/
    public omero.model.ExperimenterGroup getGroup(long id, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getGroup(id, __ctx, true);
    }

    private omero.model.ExperimenterGroup getGroup(long id, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getGroup", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getGroup");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.getGroup(id, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the ExperimenterGroup
     **/
    public Ice.AsyncResult begin_getGroup(long id)
    {
        return begin_getGroup(id, null, false, null);
    }

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getGroup(long id, java.util.Map<String, String> __ctx)
    {
        return begin_getGroup(id, __ctx, true, null);
    }

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the ExperimenterGroup
     **/
    public Ice.AsyncResult begin_getGroup(long id, Ice.Callback __cb)
    {
        return begin_getGroup(id, null, false, __cb);
    }

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getGroup(long id, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getGroup(id, __ctx, true, __cb);
    }

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the ExperimenterGroup
     **/
    public Ice.AsyncResult begin_getGroup(long id, Callback_IAdmin_getGroup __cb)
    {
        return begin_getGroup(id, null, false, __cb);
    }

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getGroup(long id, java.util.Map<String, String> __ctx, Callback_IAdmin_getGroup __cb)
    {
        return begin_getGroup(id, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getGroup(long id, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getGroup_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getGroup_name, __cb);
        try
        {
            __result.__prepare(__getGroup_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(id);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) an ExperimenterGroup. Never null.
     **/
    public omero.model.ExperimenterGroup end_getGroup(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getGroup_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.ExperimenterGroupHolder __ret = new omero.model.ExperimenterGroupHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the ExperimenterGroup
     **/
    public boolean getGroup_async(AMI_IAdmin_getGroup __cb, long id)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getGroup_name);
            __r = begin_getGroup(id, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getGroup_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Fetches an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users.
     * 
     * @param __cb The callback object for the operation.
     * @param id id of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getGroup_async(AMI_IAdmin_getGroup __cb, long id, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getGroup_name);
            __r = begin_getGroup(id, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getGroup_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getLeaderOfGroupIds_name = "getLeaderOfGroupIds";

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @see omero.model.Details#getOwner
     **/
    public java.util.List<Long> getLeaderOfGroupIds(omero.model.Experimenter exp)
        throws omero.ServerError
    {
        return getLeaderOfGroupIds(exp, null, false);
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @see omero.model.Details#getOwner
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<Long> getLeaderOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getLeaderOfGroupIds(exp, __ctx, true);
    }

    private java.util.List<Long> getLeaderOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getLeaderOfGroupIds", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getLeaderOfGroupIds");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.getLeaderOfGroupIds(exp, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     **/
    public Ice.AsyncResult begin_getLeaderOfGroupIds(omero.model.Experimenter exp)
    {
        return begin_getLeaderOfGroupIds(exp, null, false, null);
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getLeaderOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
    {
        return begin_getLeaderOfGroupIds(exp, __ctx, true, null);
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     **/
    public Ice.AsyncResult begin_getLeaderOfGroupIds(omero.model.Experimenter exp, Ice.Callback __cb)
    {
        return begin_getLeaderOfGroupIds(exp, null, false, __cb);
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getLeaderOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getLeaderOfGroupIds(exp, __ctx, true, __cb);
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     **/
    public Ice.AsyncResult begin_getLeaderOfGroupIds(omero.model.Experimenter exp, Callback_IAdmin_getLeaderOfGroupIds __cb)
    {
        return begin_getLeaderOfGroupIds(exp, null, false, __cb);
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getLeaderOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Callback_IAdmin_getLeaderOfGroupIds __cb)
    {
        return begin_getLeaderOfGroupIds(exp, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getLeaderOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getLeaderOfGroupIds_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getLeaderOfGroupIds_name, __cb);
        try
        {
            __result.__prepare(__getLeaderOfGroupIds_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(exp);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.List<Long> end_getLeaderOfGroupIds(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getLeaderOfGroupIds_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<Long> __ret;
            __ret = LongListHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     **/
    public boolean getLeaderOfGroupIds_async(AMI_IAdmin_getLeaderOfGroupIds __cb, omero.model.Experimenter exp)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getLeaderOfGroupIds_name);
            __r = begin_getLeaderOfGroupIds(exp, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getLeaderOfGroupIds_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is owner/leader.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getLeaderOfGroupIds_async(AMI_IAdmin_getLeaderOfGroupIds __cb, omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getLeaderOfGroupIds_name);
            __r = begin_getLeaderOfGroupIds(exp, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getLeaderOfGroupIds_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getMemberOfGroupIds_name = "getMemberOfGroupIds";

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @see omero.model.Details#getOwner
     **/
    public java.util.List<Long> getMemberOfGroupIds(omero.model.Experimenter exp)
        throws omero.ServerError
    {
        return getMemberOfGroupIds(exp, null, false);
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param exp Non-null, managed (i.e. with id)
     * @see omero.model.Details#getOwner
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<Long> getMemberOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getMemberOfGroupIds(exp, __ctx, true);
    }

    private java.util.List<Long> getMemberOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getMemberOfGroupIds", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getMemberOfGroupIds");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.getMemberOfGroupIds(exp, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     **/
    public Ice.AsyncResult begin_getMemberOfGroupIds(omero.model.Experimenter exp)
    {
        return begin_getMemberOfGroupIds(exp, null, false, null);
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMemberOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
    {
        return begin_getMemberOfGroupIds(exp, __ctx, true, null);
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     **/
    public Ice.AsyncResult begin_getMemberOfGroupIds(omero.model.Experimenter exp, Ice.Callback __cb)
    {
        return begin_getMemberOfGroupIds(exp, null, false, __cb);
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMemberOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getMemberOfGroupIds(exp, __ctx, true, __cb);
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     **/
    public Ice.AsyncResult begin_getMemberOfGroupIds(omero.model.Experimenter exp, Callback_IAdmin_getMemberOfGroupIds __cb)
    {
        return begin_getMemberOfGroupIds(exp, null, false, __cb);
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMemberOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Callback_IAdmin_getMemberOfGroupIds __cb)
    {
        return begin_getMemberOfGroupIds(exp, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getMemberOfGroupIds(omero.model.Experimenter exp, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getMemberOfGroupIds_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getMemberOfGroupIds_name, __cb);
        try
        {
            __result.__prepare(__getMemberOfGroupIds_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(exp);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.List<Long> end_getMemberOfGroupIds(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getMemberOfGroupIds_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<Long> __ret;
            __ret = LongListHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     **/
    public boolean getMemberOfGroupIds_async(AMI_IAdmin_getMemberOfGroupIds __cb, omero.model.Experimenter exp)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getMemberOfGroupIds_name);
            __r = begin_getMemberOfGroupIds(exp, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getMemberOfGroupIds_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Finds the ids for all groups for which the given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param exp Non-null, managed (i.e. with id)
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getMemberOfGroupIds_async(AMI_IAdmin_getMemberOfGroupIds __cb, omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getMemberOfGroupIds_name);
            __r = begin_getMemberOfGroupIds(exp, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getMemberOfGroupIds_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getMyUserPhotos_name = "getMyUserPhotos";

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @return file objects. Possibly empty.
     **/
    public java.util.List<omero.model.OriginalFile> getMyUserPhotos()
        throws omero.ServerError
    {
        return getMyUserPhotos(null, false);
    }

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return file objects. Possibly empty.
     **/
    public java.util.List<omero.model.OriginalFile> getMyUserPhotos(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getMyUserPhotos(__ctx, true);
    }

    private java.util.List<omero.model.OriginalFile> getMyUserPhotos(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getMyUserPhotos", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getMyUserPhotos");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.getMyUserPhotos(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMyUserPhotos()
    {
        return begin_getMyUserPhotos(null, false, null);
    }

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMyUserPhotos(java.util.Map<String, String> __ctx)
    {
        return begin_getMyUserPhotos(__ctx, true, null);
    }

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMyUserPhotos(Ice.Callback __cb)
    {
        return begin_getMyUserPhotos(null, false, __cb);
    }

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMyUserPhotos(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getMyUserPhotos(__ctx, true, __cb);
    }

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMyUserPhotos(Callback_IAdmin_getMyUserPhotos __cb)
    {
        return begin_getMyUserPhotos(null, false, __cb);
    }

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMyUserPhotos(java.util.Map<String, String> __ctx, Callback_IAdmin_getMyUserPhotos __cb)
    {
        return begin_getMyUserPhotos(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getMyUserPhotos(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getMyUserPhotos_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getMyUserPhotos_name, __cb);
        try
        {
            __result.__prepare(__getMyUserPhotos_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) file objects. Possibly empty.
     **/
    public java.util.List<omero.model.OriginalFile> end_getMyUserPhotos(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getMyUserPhotos_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.OriginalFile> __ret;
            __ret = OriginalFileListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getMyUserPhotos_async(AMI_IAdmin_getMyUserPhotos __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getMyUserPhotos_name);
            __r = begin_getMyUserPhotos(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getMyUserPhotos_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the {@link omero.model.OriginalFile} object
     * attached to this user as specified by
     * {@link #uploadMyUserPhoto}.
     * The return value is order by the most recently modified
     * file first.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getMyUserPhotos_async(AMI_IAdmin_getMyUserPhotos __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getMyUserPhotos_name);
            __r = begin_getMyUserPhotos(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getMyUserPhotos_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getSecurityRoles_name = "getSecurityRoles";

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @return Non-null, immutable {@link omero.sys.Roles}
     * instance.
     **/
    public omero.sys.Roles getSecurityRoles()
        throws omero.ServerError
    {
        return getSecurityRoles(null, false);
    }

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return Non-null, immutable {@link omero.sys.Roles}
     * instance.
     **/
    public omero.sys.Roles getSecurityRoles(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getSecurityRoles(__ctx, true);
    }

    private omero.sys.Roles getSecurityRoles(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getSecurityRoles", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getSecurityRoles");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.getSecurityRoles(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getSecurityRoles()
    {
        return begin_getSecurityRoles(null, false, null);
    }

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getSecurityRoles(java.util.Map<String, String> __ctx)
    {
        return begin_getSecurityRoles(__ctx, true, null);
    }

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getSecurityRoles(Ice.Callback __cb)
    {
        return begin_getSecurityRoles(null, false, __cb);
    }

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getSecurityRoles(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getSecurityRoles(__ctx, true, __cb);
    }

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getSecurityRoles(Callback_IAdmin_getSecurityRoles __cb)
    {
        return begin_getSecurityRoles(null, false, __cb);
    }

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getSecurityRoles(java.util.Map<String, String> __ctx, Callback_IAdmin_getSecurityRoles __cb)
    {
        return begin_getSecurityRoles(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getSecurityRoles(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getSecurityRoles_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getSecurityRoles_name, __cb);
        try
        {
            __result.__prepare(__getSecurityRoles_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Non-null, immutable {@link omero.sys.Roles}
     * instance.
     **/
    public omero.sys.Roles end_getSecurityRoles(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getSecurityRoles_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.sys.RolesHolder __ret = new omero.sys.RolesHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getSecurityRoles_async(AMI_IAdmin_getSecurityRoles __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getSecurityRoles_name);
            __r = begin_getSecurityRoles(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getSecurityRoles_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the active {@link omero.sys.Roles} in use by the
     * server.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getSecurityRoles_async(AMI_IAdmin_getSecurityRoles __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getSecurityRoles_name);
            __r = begin_getSecurityRoles(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getSecurityRoles_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __lookupExperimenter_name = "lookupExperimenter";

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param name Name of the Experimenter
     * @return an Experimenter. Never null.
     * @throws ApiUsageException if omeName does not exist.
     **/
    public omero.model.Experimenter lookupExperimenter(String name)
        throws omero.ServerError
    {
        return lookupExperimenter(name, null, false);
    }

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param name Name of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     * @return an Experimenter. Never null.
     * @throws ApiUsageException if omeName does not exist.
     **/
    public omero.model.Experimenter lookupExperimenter(String name, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return lookupExperimenter(name, __ctx, true);
    }

    private omero.model.Experimenter lookupExperimenter(String name, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "lookupExperimenter", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("lookupExperimenter");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.lookupExperimenter(name, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the Experimenter
     **/
    public Ice.AsyncResult begin_lookupExperimenter(String name)
    {
        return begin_lookupExperimenter(name, null, false, null);
    }

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupExperimenter(String name, java.util.Map<String, String> __ctx)
    {
        return begin_lookupExperimenter(name, __ctx, true, null);
    }

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the Experimenter
     **/
    public Ice.AsyncResult begin_lookupExperimenter(String name, Ice.Callback __cb)
    {
        return begin_lookupExperimenter(name, null, false, __cb);
    }

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupExperimenter(String name, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_lookupExperimenter(name, __ctx, true, __cb);
    }

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the Experimenter
     **/
    public Ice.AsyncResult begin_lookupExperimenter(String name, Callback_IAdmin_lookupExperimenter __cb)
    {
        return begin_lookupExperimenter(name, null, false, __cb);
    }

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupExperimenter(String name, java.util.Map<String, String> __ctx, Callback_IAdmin_lookupExperimenter __cb)
    {
        return begin_lookupExperimenter(name, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_lookupExperimenter(String name, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__lookupExperimenter_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __lookupExperimenter_name, __cb);
        try
        {
            __result.__prepare(__lookupExperimenter_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(name);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) an Experimenter. Never null.
     **/
    public omero.model.Experimenter end_lookupExperimenter(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __lookupExperimenter_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.ExperimenterHolder __ret = new omero.model.ExperimenterHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the Experimenter
     **/
    public boolean lookupExperimenter_async(AMI_IAdmin_lookupExperimenter __cb, String name)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__lookupExperimenter_name);
            __r = begin_lookupExperimenter(name, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __lookupExperimenter_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Looks up an {@link omero.model.Experimenter} and all related
     * {@link omero.model.ExperimenterGroup} by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the Experimenter
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean lookupExperimenter_async(AMI_IAdmin_lookupExperimenter __cb, String name, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__lookupExperimenter_name);
            __r = begin_lookupExperimenter(name, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __lookupExperimenter_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __lookupExperimenters_name = "lookupExperimenters";

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @return all Experimenters. Never null.
     **/
    public java.util.List<omero.model.Experimenter> lookupExperimenters()
        throws omero.ServerError
    {
        return lookupExperimenters(null, false);
    }

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return all Experimenters. Never null.
     **/
    public java.util.List<omero.model.Experimenter> lookupExperimenters(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return lookupExperimenters(__ctx, true);
    }

    private java.util.List<omero.model.Experimenter> lookupExperimenters(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "lookupExperimenters", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("lookupExperimenters");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.lookupExperimenters(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_lookupExperimenters()
    {
        return begin_lookupExperimenters(null, false, null);
    }

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupExperimenters(java.util.Map<String, String> __ctx)
    {
        return begin_lookupExperimenters(__ctx, true, null);
    }

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_lookupExperimenters(Ice.Callback __cb)
    {
        return begin_lookupExperimenters(null, false, __cb);
    }

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupExperimenters(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_lookupExperimenters(__ctx, true, __cb);
    }

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_lookupExperimenters(Callback_IAdmin_lookupExperimenters __cb)
    {
        return begin_lookupExperimenters(null, false, __cb);
    }

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupExperimenters(java.util.Map<String, String> __ctx, Callback_IAdmin_lookupExperimenters __cb)
    {
        return begin_lookupExperimenters(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_lookupExperimenters(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__lookupExperimenters_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __lookupExperimenters_name, __cb);
        try
        {
            __result.__prepare(__lookupExperimenters_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) all Experimenters. Never null.
     **/
    public java.util.List<omero.model.Experimenter> end_lookupExperimenters(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __lookupExperimenters_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.Experimenter> __ret;
            __ret = ExperimenterListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean lookupExperimenters_async(AMI_IAdmin_lookupExperimenters __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__lookupExperimenters_name);
            __r = begin_lookupExperimenters(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __lookupExperimenters_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Looks up all {@link omero.model.Experimenter} experimenters
     * present and all related
     * {@link omero.model.ExperimenterGroup} groups.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean lookupExperimenters_async(AMI_IAdmin_lookupExperimenters __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__lookupExperimenters_name);
            __r = begin_lookupExperimenters(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __lookupExperimenters_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __lookupGroup_name = "lookupGroup";

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param name Name of the ExperimenterGroup
     * @return an ExperimenterGroup. Never null.
     * @throws ApiUsageException if groupName does not exist.
     **/
    public omero.model.ExperimenterGroup lookupGroup(String name)
        throws omero.ServerError
    {
        return lookupGroup(name, null, false);
    }

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param name Name of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     * @return an ExperimenterGroup. Never null.
     * @throws ApiUsageException if groupName does not exist.
     **/
    public omero.model.ExperimenterGroup lookupGroup(String name, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return lookupGroup(name, __ctx, true);
    }

    private omero.model.ExperimenterGroup lookupGroup(String name, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "lookupGroup", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("lookupGroup");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.lookupGroup(name, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the ExperimenterGroup
     **/
    public Ice.AsyncResult begin_lookupGroup(String name)
    {
        return begin_lookupGroup(name, null, false, null);
    }

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupGroup(String name, java.util.Map<String, String> __ctx)
    {
        return begin_lookupGroup(name, __ctx, true, null);
    }

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the ExperimenterGroup
     **/
    public Ice.AsyncResult begin_lookupGroup(String name, Ice.Callback __cb)
    {
        return begin_lookupGroup(name, null, false, __cb);
    }

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupGroup(String name, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_lookupGroup(name, __ctx, true, __cb);
    }

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the ExperimenterGroup
     **/
    public Ice.AsyncResult begin_lookupGroup(String name, Callback_IAdmin_lookupGroup __cb)
    {
        return begin_lookupGroup(name, null, false, __cb);
    }

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupGroup(String name, java.util.Map<String, String> __ctx, Callback_IAdmin_lookupGroup __cb)
    {
        return begin_lookupGroup(name, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_lookupGroup(String name, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__lookupGroup_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __lookupGroup_name, __cb);
        try
        {
            __result.__prepare(__lookupGroup_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(name);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) an ExperimenterGroup. Never null.
     **/
    public omero.model.ExperimenterGroup end_lookupGroup(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __lookupGroup_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.ExperimenterGroupHolder __ret = new omero.model.ExperimenterGroupHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the ExperimenterGroup
     **/
    public boolean lookupGroup_async(AMI_IAdmin_lookupGroup __cb, String name)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__lookupGroup_name);
            __r = begin_lookupGroup(name, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __lookupGroup_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Looks up an {@link omero.model.ExperimenterGroup} and all
     * contained {@link omero.model.Experimenter} users by name.
     * 
     * @param __cb The callback object for the operation.
     * @param name Name of the ExperimenterGroup
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean lookupGroup_async(AMI_IAdmin_lookupGroup __cb, String name, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__lookupGroup_name);
            __r = begin_lookupGroup(name, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __lookupGroup_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __lookupGroups_name = "lookupGroups";

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @return all Groups. Never null.
     **/
    public java.util.List<omero.model.ExperimenterGroup> lookupGroups()
        throws omero.ServerError
    {
        return lookupGroups(null, false);
    }

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return all Groups. Never null.
     **/
    public java.util.List<omero.model.ExperimenterGroup> lookupGroups(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return lookupGroups(__ctx, true);
    }

    private java.util.List<omero.model.ExperimenterGroup> lookupGroups(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "lookupGroups", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("lookupGroups");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.lookupGroups(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_lookupGroups()
    {
        return begin_lookupGroups(null, false, null);
    }

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupGroups(java.util.Map<String, String> __ctx)
    {
        return begin_lookupGroups(__ctx, true, null);
    }

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_lookupGroups(Ice.Callback __cb)
    {
        return begin_lookupGroups(null, false, __cb);
    }

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupGroups(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_lookupGroups(__ctx, true, __cb);
    }

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_lookupGroups(Callback_IAdmin_lookupGroups __cb)
    {
        return begin_lookupGroups(null, false, __cb);
    }

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupGroups(java.util.Map<String, String> __ctx, Callback_IAdmin_lookupGroups __cb)
    {
        return begin_lookupGroups(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_lookupGroups(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__lookupGroups_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __lookupGroups_name, __cb);
        try
        {
            __result.__prepare(__lookupGroups_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) all Groups. Never null.
     **/
    public java.util.List<omero.model.ExperimenterGroup> end_lookupGroups(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __lookupGroups_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.ExperimenterGroup> __ret;
            __ret = ExperimenterGroupListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean lookupGroups_async(AMI_IAdmin_lookupGroups __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__lookupGroups_name);
            __r = begin_lookupGroups(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __lookupGroups_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Looks up all {@link omero.model.ExperimenterGroup} groups
     * present and all related
     * {@link omero.model.Experimenter} experimenters. The
     * experimenter's groups are also loaded.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean lookupGroups_async(AMI_IAdmin_lookupGroups __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__lookupGroups_name);
            __r = begin_lookupGroups(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __lookupGroups_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __lookupLdapAuthExperimenter_name = "lookupLdapAuthExperimenter";

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @return Experimenter. Never null.
     **/
    public String lookupLdapAuthExperimenter(long id)
        throws omero.ServerError
    {
        return lookupLdapAuthExperimenter(id, null, false);
    }

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return Experimenter. Never null.
     **/
    public String lookupLdapAuthExperimenter(long id, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return lookupLdapAuthExperimenter(id, __ctx, true);
    }

    private String lookupLdapAuthExperimenter(long id, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "lookupLdapAuthExperimenter", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("lookupLdapAuthExperimenter");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.lookupLdapAuthExperimenter(id, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenter(long id)
    {
        return begin_lookupLdapAuthExperimenter(id, null, false, null);
    }

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenter(long id, java.util.Map<String, String> __ctx)
    {
        return begin_lookupLdapAuthExperimenter(id, __ctx, true, null);
    }

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenter(long id, Ice.Callback __cb)
    {
        return begin_lookupLdapAuthExperimenter(id, null, false, __cb);
    }

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenter(long id, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_lookupLdapAuthExperimenter(id, __ctx, true, __cb);
    }

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenter(long id, Callback_IAdmin_lookupLdapAuthExperimenter __cb)
    {
        return begin_lookupLdapAuthExperimenter(id, null, false, __cb);
    }

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenter(long id, java.util.Map<String, String> __ctx, Callback_IAdmin_lookupLdapAuthExperimenter __cb)
    {
        return begin_lookupLdapAuthExperimenter(id, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_lookupLdapAuthExperimenter(long id, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__lookupLdapAuthExperimenter_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __lookupLdapAuthExperimenter_name, __cb);
        try
        {
            __result.__prepare(__lookupLdapAuthExperimenter_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(id);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Experimenter. Never null.
     **/
    public String end_lookupLdapAuthExperimenter(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __lookupLdapAuthExperimenter_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            String __ret;
            __ret = __is.readString();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean lookupLdapAuthExperimenter_async(AMI_IAdmin_lookupLdapAuthExperimenter __cb, long id)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__lookupLdapAuthExperimenter_name);
            __r = begin_lookupLdapAuthExperimenter(id, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __lookupLdapAuthExperimenter_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Looks up {@link omero.model.Experimenter} experimenters who
     * use LDAP authentication  (has set dn on password table).
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean lookupLdapAuthExperimenter_async(AMI_IAdmin_lookupLdapAuthExperimenter __cb, long id, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__lookupLdapAuthExperimenter_name);
            __r = begin_lookupLdapAuthExperimenter(id, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __lookupLdapAuthExperimenter_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __lookupLdapAuthExperimenters_name = "lookupLdapAuthExperimenters";

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @return list of experimenters. Never null.
     **/
    public omero.RList lookupLdapAuthExperimenters()
        throws omero.ServerError
    {
        return lookupLdapAuthExperimenters(null, false);
    }

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return list of experimenters. Never null.
     **/
    public omero.RList lookupLdapAuthExperimenters(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return lookupLdapAuthExperimenters(__ctx, true);
    }

    private omero.RList lookupLdapAuthExperimenters(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "lookupLdapAuthExperimenters", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("lookupLdapAuthExperimenters");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.lookupLdapAuthExperimenters(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenters()
    {
        return begin_lookupLdapAuthExperimenters(null, false, null);
    }

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenters(java.util.Map<String, String> __ctx)
    {
        return begin_lookupLdapAuthExperimenters(__ctx, true, null);
    }

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenters(Ice.Callback __cb)
    {
        return begin_lookupLdapAuthExperimenters(null, false, __cb);
    }

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenters(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_lookupLdapAuthExperimenters(__ctx, true, __cb);
    }

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenters(Callback_IAdmin_lookupLdapAuthExperimenters __cb)
    {
        return begin_lookupLdapAuthExperimenters(null, false, __cb);
    }

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupLdapAuthExperimenters(java.util.Map<String, String> __ctx, Callback_IAdmin_lookupLdapAuthExperimenters __cb)
    {
        return begin_lookupLdapAuthExperimenters(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_lookupLdapAuthExperimenters(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__lookupLdapAuthExperimenters_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __lookupLdapAuthExperimenters_name, __cb);
        try
        {
            __result.__prepare(__lookupLdapAuthExperimenters_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) list of experimenters. Never null.
     **/
    public omero.RList end_lookupLdapAuthExperimenters(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __lookupLdapAuthExperimenters_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.RListHolder __ret = new omero.RListHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean lookupLdapAuthExperimenters_async(AMI_IAdmin_lookupLdapAuthExperimenters __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__lookupLdapAuthExperimenters_name);
            __r = begin_lookupLdapAuthExperimenters(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __lookupLdapAuthExperimenters_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Looks up all ids of {@link omero.model.Experimenter}
     * experimenters who use LDAP authentication (has set dn on
     * password table).
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean lookupLdapAuthExperimenters_async(AMI_IAdmin_lookupLdapAuthExperimenters __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__lookupLdapAuthExperimenters_name);
            __r = begin_lookupLdapAuthExperimenters(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __lookupLdapAuthExperimenters_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __moveToCommonSpace_name = "moveToCommonSpace";

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param objects
     **/
    public void moveToCommonSpace(java.util.List<omero.model.IObject> objects)
        throws omero.ServerError
    {
        moveToCommonSpace(objects, null, false);
    }

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param objects
     * @param __ctx The Context map to send with the invocation.
     **/
    public void moveToCommonSpace(java.util.List<omero.model.IObject> objects, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        moveToCommonSpace(objects, __ctx, true);
    }

    private void moveToCommonSpace(java.util.List<omero.model.IObject> objects, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "moveToCommonSpace", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("moveToCommonSpace");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.moveToCommonSpace(objects, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param __cb The callback object for the operation.
     * @param objects
     **/
    public Ice.AsyncResult begin_moveToCommonSpace(java.util.List<omero.model.IObject> objects)
    {
        return begin_moveToCommonSpace(objects, null, false, null);
    }

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param __cb The callback object for the operation.
     * @param objects
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_moveToCommonSpace(java.util.List<omero.model.IObject> objects, java.util.Map<String, String> __ctx)
    {
        return begin_moveToCommonSpace(objects, __ctx, true, null);
    }

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param __cb The callback object for the operation.
     * @param objects
     **/
    public Ice.AsyncResult begin_moveToCommonSpace(java.util.List<omero.model.IObject> objects, Ice.Callback __cb)
    {
        return begin_moveToCommonSpace(objects, null, false, __cb);
    }

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param __cb The callback object for the operation.
     * @param objects
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_moveToCommonSpace(java.util.List<omero.model.IObject> objects, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_moveToCommonSpace(objects, __ctx, true, __cb);
    }

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param __cb The callback object for the operation.
     * @param objects
     **/
    public Ice.AsyncResult begin_moveToCommonSpace(java.util.List<omero.model.IObject> objects, Callback_IAdmin_moveToCommonSpace __cb)
    {
        return begin_moveToCommonSpace(objects, null, false, __cb);
    }

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param __cb The callback object for the operation.
     * @param objects
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_moveToCommonSpace(java.util.List<omero.model.IObject> objects, java.util.Map<String, String> __ctx, Callback_IAdmin_moveToCommonSpace __cb)
    {
        return begin_moveToCommonSpace(objects, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_moveToCommonSpace(java.util.List<omero.model.IObject> objects, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__moveToCommonSpace_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __moveToCommonSpace_name, __cb);
        try
        {
            __result.__prepare(__moveToCommonSpace_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            IObjectListHelper.write(__os, objects);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_moveToCommonSpace(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __moveToCommonSpace_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param __cb The callback object for the operation.
     * @param objects
     **/
    public boolean moveToCommonSpace_async(AMI_IAdmin_moveToCommonSpace __cb, java.util.List<omero.model.IObject> objects)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__moveToCommonSpace_name);
            __r = begin_moveToCommonSpace(objects, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __moveToCommonSpace_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Moves the given objects into the <i>user</i> group to make
     * them visible and linkable from all security contexts.
     * 
     * See also <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * 
     * @param __cb The callback object for the operation.
     * @param objects
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean moveToCommonSpace_async(AMI_IAdmin_moveToCommonSpace __cb, java.util.List<omero.model.IObject> objects, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__moveToCommonSpace_name);
            __r = begin_moveToCommonSpace(objects, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __moveToCommonSpace_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __removeGroupOwners_name = "removeGroupOwners";

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     **/
    public void removeGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners)
        throws omero.ServerError
    {
        removeGroupOwners(group, owners, null, false);
    }

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        removeGroupOwners(group, owners, __ctx, true);
    }

    private void removeGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "removeGroupOwners", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("removeGroupOwners");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.removeGroupOwners(group, owners, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     **/
    public Ice.AsyncResult begin_removeGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners)
    {
        return begin_removeGroupOwners(group, owners, null, false, null);
    }

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx)
    {
        return begin_removeGroupOwners(group, owners, __ctx, true, null);
    }

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     **/
    public Ice.AsyncResult begin_removeGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, Ice.Callback __cb)
    {
        return begin_removeGroupOwners(group, owners, null, false, __cb);
    }

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_removeGroupOwners(group, owners, __ctx, true, __cb);
    }

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     **/
    public Ice.AsyncResult begin_removeGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, Callback_IAdmin_removeGroupOwners __cb)
    {
        return begin_removeGroupOwners(group, owners, null, false, __cb);
    }

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx, Callback_IAdmin_removeGroupOwners __cb)
    {
        return begin_removeGroupOwners(group, owners, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_removeGroupOwners(omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__removeGroupOwners_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __removeGroupOwners_name, __cb);
        try
        {
            __result.__prepare(__removeGroupOwners_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(group);
            ExperimenterListHelper.write(__os, owners);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_removeGroupOwners(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __removeGroupOwners_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     **/
    public boolean removeGroupOwners_async(AMI_IAdmin_removeGroupOwners __cb, omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeGroupOwners_name);
            __r = begin_removeGroupOwners(group, owners, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeGroupOwners_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * removes the given users from the owner list for this group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not
     * @param owners A set of currently managed
     * {@link omero.model.Experimenter}s. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeGroupOwners_async(AMI_IAdmin_removeGroupOwners __cb, omero.model.ExperimenterGroup group, java.util.List<omero.model.Experimenter> owners, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeGroupOwners_name);
            __r = begin_removeGroupOwners(group, owners, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeGroupOwners_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __removeGroups_name = "removeGroups";

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param user A currently managed entity. Not null.
     * @param groups Groups from which the user will be removed.
     * Not null.
     **/
    public void removeGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups)
        throws omero.ServerError
    {
        removeGroups(user, groups, null, false);
    }

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param user A currently managed entity. Not null.
     * @param groups Groups from which the user will be removed.
     * Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        removeGroups(user, groups, __ctx, true);
    }

    private void removeGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "removeGroups", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("removeGroups");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.removeGroups(user, groups, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     **/
    public Ice.AsyncResult begin_removeGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups)
    {
        return begin_removeGroups(user, groups, null, false, null);
    }

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx)
    {
        return begin_removeGroups(user, groups, __ctx, true, null);
    }

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     **/
    public Ice.AsyncResult begin_removeGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, Ice.Callback __cb)
    {
        return begin_removeGroups(user, groups, null, false, __cb);
    }

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_removeGroups(user, groups, __ctx, true, __cb);
    }

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     **/
    public Ice.AsyncResult begin_removeGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, Callback_IAdmin_removeGroups __cb)
    {
        return begin_removeGroups(user, groups, null, false, __cb);
    }

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, Callback_IAdmin_removeGroups __cb)
    {
        return begin_removeGroups(user, groups, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_removeGroups(omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__removeGroups_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __removeGroups_name, __cb);
        try
        {
            __result.__prepare(__removeGroups_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(user);
            ExperimenterGroupListHelper.write(__os, groups);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_removeGroups(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __removeGroups_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     **/
    public boolean removeGroups_async(AMI_IAdmin_removeGroups __cb, omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeGroups_name);
            __r = begin_removeGroups(user, groups, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeGroups_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Removes an experimenter from the given groups.
     * <ul>
     * <li>The root experimenter is required to be in both the
     * user and system groups.</li>
     * <li>An experimenter may not remove themself from the user
     * or system group.</li>
     * <li>An experimenter may not be a member of only the user
     * group, some other group is also required as the default
     * group.</li>
     * <li>An experimenter must remain a member of some group.</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed entity. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeGroups_async(AMI_IAdmin_removeGroups __cb, omero.model.Experimenter user, java.util.List<omero.model.ExperimenterGroup> groups, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeGroups_name);
            __r = begin_removeGroups(user, groups, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeGroups_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __reportForgottenPassword_name = "reportForgottenPassword";

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void reportForgottenPassword(String name, String email)
        throws omero.ServerError
    {
        reportForgottenPassword(name, email, null, false);
    }

    /**
     * @deprecated This operation has been deprecated.
     **/
    public void reportForgottenPassword(String name, String email, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        reportForgottenPassword(name, email, __ctx, true);
    }

    private void reportForgottenPassword(String name, String email, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "reportForgottenPassword", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("reportForgottenPassword");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.reportForgottenPassword(name, email, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_reportForgottenPassword(String name, String email)
    {
        return begin_reportForgottenPassword(name, email, null, false, null);
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_reportForgottenPassword(String name, String email, java.util.Map<String, String> __ctx)
    {
        return begin_reportForgottenPassword(name, email, __ctx, true, null);
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_reportForgottenPassword(String name, String email, Ice.Callback __cb)
    {
        return begin_reportForgottenPassword(name, email, null, false, __cb);
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_reportForgottenPassword(String name, String email, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_reportForgottenPassword(name, email, __ctx, true, __cb);
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_reportForgottenPassword(String name, String email, Callback_IAdmin_reportForgottenPassword __cb)
    {
        return begin_reportForgottenPassword(name, email, null, false, __cb);
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_reportForgottenPassword(String name, String email, java.util.Map<String, String> __ctx, Callback_IAdmin_reportForgottenPassword __cb)
    {
        return begin_reportForgottenPassword(name, email, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_reportForgottenPassword(String name, String email, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__reportForgottenPassword_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __reportForgottenPassword_name, __cb);
        try
        {
            __result.__prepare(__reportForgottenPassword_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(name);
            __os.writeString(email);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_reportForgottenPassword(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __reportForgottenPassword_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean reportForgottenPassword_async(AMI_IAdmin_reportForgottenPassword __cb, String name, String email)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__reportForgottenPassword_name);
            __r = begin_reportForgottenPassword(name, email, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __reportForgottenPassword_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean reportForgottenPassword_async(AMI_IAdmin_reportForgottenPassword __cb, String name, String email, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__reportForgottenPassword_name);
            __r = begin_reportForgottenPassword(name, email, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __reportForgottenPassword_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setDefaultGroup_name = "setDefaultGroup";

    /**
     * Sets the default group for a given user.
     * 
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     **/
    public void setDefaultGroup(omero.model.Experimenter user, omero.model.ExperimenterGroup group)
        throws omero.ServerError
    {
        setDefaultGroup(user, group, null, false);
    }

    /**
     * Sets the default group for a given user.
     * 
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setDefaultGroup(omero.model.Experimenter user, omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setDefaultGroup(user, group, __ctx, true);
    }

    private void setDefaultGroup(omero.model.Experimenter user, omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setDefaultGroup", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setDefaultGroup");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.setDefaultGroup(user, group, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets the default group for a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     **/
    public Ice.AsyncResult begin_setDefaultGroup(omero.model.Experimenter user, omero.model.ExperimenterGroup group)
    {
        return begin_setDefaultGroup(user, group, null, false, null);
    }

    /**
     * Sets the default group for a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setDefaultGroup(omero.model.Experimenter user, omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx)
    {
        return begin_setDefaultGroup(user, group, __ctx, true, null);
    }

    /**
     * Sets the default group for a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     **/
    public Ice.AsyncResult begin_setDefaultGroup(omero.model.Experimenter user, omero.model.ExperimenterGroup group, Ice.Callback __cb)
    {
        return begin_setDefaultGroup(user, group, null, false, __cb);
    }

    /**
     * Sets the default group for a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setDefaultGroup(omero.model.Experimenter user, omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setDefaultGroup(user, group, __ctx, true, __cb);
    }

    /**
     * Sets the default group for a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     **/
    public Ice.AsyncResult begin_setDefaultGroup(omero.model.Experimenter user, omero.model.ExperimenterGroup group, Callback_IAdmin_setDefaultGroup __cb)
    {
        return begin_setDefaultGroup(user, group, null, false, __cb);
    }

    /**
     * Sets the default group for a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setDefaultGroup(omero.model.Experimenter user, omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, Callback_IAdmin_setDefaultGroup __cb)
    {
        return begin_setDefaultGroup(user, group, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setDefaultGroup(omero.model.Experimenter user, omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setDefaultGroup_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setDefaultGroup_name, __cb);
        try
        {
            __result.__prepare(__setDefaultGroup_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(user);
            __os.writeObject(group);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setDefaultGroup(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setDefaultGroup_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets the default group for a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     **/
    public boolean setDefaultGroup_async(AMI_IAdmin_setDefaultGroup __cb, omero.model.Experimenter user, omero.model.ExperimenterGroup group)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setDefaultGroup_name);
            __r = begin_setDefaultGroup(user, group, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setDefaultGroup_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets the default group for a given user.
     * 
     * @param __cb The callback object for the operation.
     * @param user A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param group The group which should be set as default group
     * for this user. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setDefaultGroup_async(AMI_IAdmin_setDefaultGroup __cb, omero.model.Experimenter user, omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setDefaultGroup_name);
            __r = begin_setDefaultGroup(user, group, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setDefaultGroup_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setGroupOwner_name = "setGroupOwner";

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     **/
    public void setGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner)
        throws omero.ServerError
    {
        setGroupOwner(group, owner, null, false);
    }

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setGroupOwner(group, owner, __ctx, true);
    }

    private void setGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setGroupOwner", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setGroupOwner");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.setGroupOwner(group, owner, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     **/
    public Ice.AsyncResult begin_setGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner)
    {
        return begin_setGroupOwner(group, owner, null, false, null);
    }

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx)
    {
        return begin_setGroupOwner(group, owner, __ctx, true, null);
    }

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     **/
    public Ice.AsyncResult begin_setGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, Ice.Callback __cb)
    {
        return begin_setGroupOwner(group, owner, null, false, __cb);
    }

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setGroupOwner(group, owner, __ctx, true, __cb);
    }

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     **/
    public Ice.AsyncResult begin_setGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, Callback_IAdmin_setGroupOwner __cb)
    {
        return begin_setGroupOwner(group, owner, null, false, __cb);
    }

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx, Callback_IAdmin_setGroupOwner __cb)
    {
        return begin_setGroupOwner(group, owner, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setGroupOwner_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setGroupOwner_name, __cb);
        try
        {
            __result.__prepare(__setGroupOwner_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(group);
            __os.writeObject(owner);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setGroupOwner(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setGroupOwner_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     **/
    public boolean setGroupOwner_async(AMI_IAdmin_setGroupOwner __cb, omero.model.ExperimenterGroup group, omero.model.Experimenter owner)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setGroupOwner_name);
            __r = begin_setGroupOwner(group, owner, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setGroupOwner_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Adds the user to the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setGroupOwner_async(AMI_IAdmin_setGroupOwner __cb, omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setGroupOwner_name);
            __r = begin_setGroupOwner(group, owner, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setGroupOwner_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __synchronizeLoginCache_name = "synchronizeLoginCache";

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     **/
    public void synchronizeLoginCache()
        throws omero.ServerError
    {
        synchronizeLoginCache(null, false);
    }

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void synchronizeLoginCache(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        synchronizeLoginCache(__ctx, true);
    }

    private void synchronizeLoginCache(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "synchronizeLoginCache", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("synchronizeLoginCache");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.synchronizeLoginCache(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_synchronizeLoginCache()
    {
        return begin_synchronizeLoginCache(null, false, null);
    }

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_synchronizeLoginCache(java.util.Map<String, String> __ctx)
    {
        return begin_synchronizeLoginCache(__ctx, true, null);
    }

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_synchronizeLoginCache(Ice.Callback __cb)
    {
        return begin_synchronizeLoginCache(null, false, __cb);
    }

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_synchronizeLoginCache(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_synchronizeLoginCache(__ctx, true, __cb);
    }

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_synchronizeLoginCache(Callback_IAdmin_synchronizeLoginCache __cb)
    {
        return begin_synchronizeLoginCache(null, false, __cb);
    }

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_synchronizeLoginCache(java.util.Map<String, String> __ctx, Callback_IAdmin_synchronizeLoginCache __cb)
    {
        return begin_synchronizeLoginCache(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_synchronizeLoginCache(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__synchronizeLoginCache_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __synchronizeLoginCache_name, __cb);
        try
        {
            __result.__prepare(__synchronizeLoginCache_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_synchronizeLoginCache(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __synchronizeLoginCache_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __cb The callback object for the operation.
     **/
    public boolean synchronizeLoginCache_async(AMI_IAdmin_synchronizeLoginCache __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__synchronizeLoginCache_name);
            __r = begin_synchronizeLoginCache(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __synchronizeLoginCache_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Uses JMX to refresh the login cache <em>if supported</em>.
     * Some backends may not provide refreshing. This may be
     * called internally during some other administrative tasks.
     * The exact implementation of this depends on the application
     * server and the authentication/authorization backend.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean synchronizeLoginCache_async(AMI_IAdmin_synchronizeLoginCache __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__synchronizeLoginCache_name);
            __r = begin_synchronizeLoginCache(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __synchronizeLoginCache_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __unsetGroupOwner_name = "unsetGroupOwner";

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     **/
    public void unsetGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner)
        throws omero.ServerError
    {
        unsetGroupOwner(group, owner, null, false);
    }

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void unsetGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        unsetGroupOwner(group, owner, __ctx, true);
    }

    private void unsetGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "unsetGroupOwner", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("unsetGroupOwner");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.unsetGroupOwner(group, owner, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     **/
    public Ice.AsyncResult begin_unsetGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner)
    {
        return begin_unsetGroupOwner(group, owner, null, false, null);
    }

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_unsetGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx)
    {
        return begin_unsetGroupOwner(group, owner, __ctx, true, null);
    }

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     **/
    public Ice.AsyncResult begin_unsetGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, Ice.Callback __cb)
    {
        return begin_unsetGroupOwner(group, owner, null, false, __cb);
    }

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_unsetGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_unsetGroupOwner(group, owner, __ctx, true, __cb);
    }

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     **/
    public Ice.AsyncResult begin_unsetGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, Callback_IAdmin_unsetGroupOwner __cb)
    {
        return begin_unsetGroupOwner(group, owner, null, false, __cb);
    }

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_unsetGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx, Callback_IAdmin_unsetGroupOwner __cb)
    {
        return begin_unsetGroupOwner(group, owner, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_unsetGroupOwner(omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__unsetGroupOwner_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __unsetGroupOwner_name, __cb);
        try
        {
            __result.__prepare(__unsetGroupOwner_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(group);
            __os.writeObject(owner);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_unsetGroupOwner(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __unsetGroupOwner_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     **/
    public boolean unsetGroupOwner_async(AMI_IAdmin_unsetGroupOwner __cb, omero.model.ExperimenterGroup group, omero.model.Experimenter owner)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__unsetGroupOwner_name);
            __r = begin_unsetGroupOwner(group, owner, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __unsetGroupOwner_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Removes the user from the owner list for this group.
     * 
     * Since <a href="https://trac.openmicroscopy.org/ome/ticket/1434">Beta 4.2</a>
     * multiple users can be the <i>owner</i> of a group.
     * 
     * @param __cb The callback object for the operation.
     * @param group A currently managed
     * {@link omero.model.ExperimenterGroup}. Not null.
     * @param owner A currently managed
     * {@link omero.model.Experimenter}. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean unsetGroupOwner_async(AMI_IAdmin_unsetGroupOwner __cb, omero.model.ExperimenterGroup group, omero.model.Experimenter owner, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__unsetGroupOwner_name);
            __r = begin_unsetGroupOwner(group, owner, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __unsetGroupOwner_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __updateExperimenter_name = "updateExperimenter";

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param experimenter the Experimenter to update.
     **/
    public void updateExperimenter(omero.model.Experimenter experimenter)
        throws omero.ServerError
    {
        updateExperimenter(experimenter, null, false);
    }

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param experimenter the Experimenter to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void updateExperimenter(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        updateExperimenter(experimenter, __ctx, true);
    }

    private void updateExperimenter(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "updateExperimenter", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("updateExperimenter");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.updateExperimenter(experimenter, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     **/
    public Ice.AsyncResult begin_updateExperimenter(omero.model.Experimenter experimenter)
    {
        return begin_updateExperimenter(experimenter, null, false, null);
    }

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_updateExperimenter(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx)
    {
        return begin_updateExperimenter(experimenter, __ctx, true, null);
    }

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     **/
    public Ice.AsyncResult begin_updateExperimenter(omero.model.Experimenter experimenter, Ice.Callback __cb)
    {
        return begin_updateExperimenter(experimenter, null, false, __cb);
    }

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_updateExperimenter(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_updateExperimenter(experimenter, __ctx, true, __cb);
    }

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     **/
    public Ice.AsyncResult begin_updateExperimenter(omero.model.Experimenter experimenter, Callback_IAdmin_updateExperimenter __cb)
    {
        return begin_updateExperimenter(experimenter, null, false, __cb);
    }

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_updateExperimenter(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx, Callback_IAdmin_updateExperimenter __cb)
    {
        return begin_updateExperimenter(experimenter, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_updateExperimenter(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__updateExperimenter_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __updateExperimenter_name, __cb);
        try
        {
            __result.__prepare(__updateExperimenter_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(experimenter);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_updateExperimenter(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __updateExperimenter_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     **/
    public boolean updateExperimenter_async(AMI_IAdmin_updateExperimenter __cb, omero.model.Experimenter experimenter)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__updateExperimenter_name);
            __r = begin_updateExperimenter(experimenter, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __updateExperimenter_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Updates an experimenter if admin or owner of group. Only
     * string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * Before a SecurityViolation would be thrown, however, this
     * method will pass to {@link #updateSelf} <em>if</em> the
     * current user matches the given experimenter.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean updateExperimenter_async(AMI_IAdmin_updateExperimenter __cb, omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__updateExperimenter_name);
            __r = begin_updateExperimenter(experimenter, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __updateExperimenter_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __updateExperimenterWithPassword_name = "updateExperimenterWithPassword";

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param experimenter the Experimenter to update.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     **/
    public void updateExperimenterWithPassword(omero.model.Experimenter experimenter, omero.RString password)
        throws omero.ServerError
    {
        updateExperimenterWithPassword(experimenter, password, null, false);
    }

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param experimenter the Experimenter to update.
     * @param password Not-null. Must pass validation in the
     * security sub-system.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void updateExperimenterWithPassword(omero.model.Experimenter experimenter, omero.RString password, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        updateExperimenterWithPassword(experimenter, password, __ctx, true);
    }

    private void updateExperimenterWithPassword(omero.model.Experimenter experimenter, omero.RString password, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "updateExperimenterWithPassword", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("updateExperimenterWithPassword");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.updateExperimenterWithPassword(experimenter, password, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     **/
    public Ice.AsyncResult begin_updateExperimenterWithPassword(omero.model.Experimenter experimenter, omero.RString password)
    {
        return begin_updateExperimenterWithPassword(experimenter, password, null, false, null);
    }

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_updateExperimenterWithPassword(omero.model.Experimenter experimenter, omero.RString password, java.util.Map<String, String> __ctx)
    {
        return begin_updateExperimenterWithPassword(experimenter, password, __ctx, true, null);
    }

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     **/
    public Ice.AsyncResult begin_updateExperimenterWithPassword(omero.model.Experimenter experimenter, omero.RString password, Ice.Callback __cb)
    {
        return begin_updateExperimenterWithPassword(experimenter, password, null, false, __cb);
    }

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_updateExperimenterWithPassword(omero.model.Experimenter experimenter, omero.RString password, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_updateExperimenterWithPassword(experimenter, password, __ctx, true, __cb);
    }

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     **/
    public Ice.AsyncResult begin_updateExperimenterWithPassword(omero.model.Experimenter experimenter, omero.RString password, Callback_IAdmin_updateExperimenterWithPassword __cb)
    {
        return begin_updateExperimenterWithPassword(experimenter, password, null, false, __cb);
    }

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_updateExperimenterWithPassword(omero.model.Experimenter experimenter, omero.RString password, java.util.Map<String, String> __ctx, Callback_IAdmin_updateExperimenterWithPassword __cb)
    {
        return begin_updateExperimenterWithPassword(experimenter, password, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_updateExperimenterWithPassword(omero.model.Experimenter experimenter, omero.RString password, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__updateExperimenterWithPassword_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __updateExperimenterWithPassword_name, __cb);
        try
        {
            __result.__prepare(__updateExperimenterWithPassword_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(experimenter);
            __os.writeObject(password);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_updateExperimenterWithPassword(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __updateExperimenterWithPassword_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     **/
    public boolean updateExperimenterWithPassword_async(AMI_IAdmin_updateExperimenterWithPassword __cb, omero.model.Experimenter experimenter, omero.RString password)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__updateExperimenterWithPassword_name);
            __r = begin_updateExperimenterWithPassword(experimenter, password, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __updateExperimenterWithPassword_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Updates an experimenter if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root and guest experimenters may not be renamed.
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter the Experimenter to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean updateExperimenterWithPassword_async(AMI_IAdmin_updateExperimenterWithPassword __cb, omero.model.Experimenter experimenter, omero.RString password, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__updateExperimenterWithPassword_name);
            __r = begin_updateExperimenterWithPassword(experimenter, password, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __updateExperimenterWithPassword_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __updateGroup_name = "updateGroup";

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param group the ExperimenterGroup to update.
     **/
    public void updateGroup(omero.model.ExperimenterGroup group)
        throws omero.ServerError
    {
        updateGroup(group, null, false);
    }

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param group the ExperimenterGroup to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void updateGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        updateGroup(group, __ctx, true);
    }

    private void updateGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "updateGroup", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("updateGroup");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.updateGroup(group, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param __cb The callback object for the operation.
     * @param group the ExperimenterGroup to update.
     **/
    public Ice.AsyncResult begin_updateGroup(omero.model.ExperimenterGroup group)
    {
        return begin_updateGroup(group, null, false, null);
    }

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param __cb The callback object for the operation.
     * @param group the ExperimenterGroup to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_updateGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx)
    {
        return begin_updateGroup(group, __ctx, true, null);
    }

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param __cb The callback object for the operation.
     * @param group the ExperimenterGroup to update.
     **/
    public Ice.AsyncResult begin_updateGroup(omero.model.ExperimenterGroup group, Ice.Callback __cb)
    {
        return begin_updateGroup(group, null, false, __cb);
    }

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param __cb The callback object for the operation.
     * @param group the ExperimenterGroup to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_updateGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_updateGroup(group, __ctx, true, __cb);
    }

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param __cb The callback object for the operation.
     * @param group the ExperimenterGroup to update.
     **/
    public Ice.AsyncResult begin_updateGroup(omero.model.ExperimenterGroup group, Callback_IAdmin_updateGroup __cb)
    {
        return begin_updateGroup(group, null, false, __cb);
    }

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param __cb The callback object for the operation.
     * @param group the ExperimenterGroup to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_updateGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, Callback_IAdmin_updateGroup __cb)
    {
        return begin_updateGroup(group, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_updateGroup(omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__updateGroup_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __updateGroup_name, __cb);
        try
        {
            __result.__prepare(__updateGroup_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(group);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_updateGroup(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __updateGroup_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param __cb The callback object for the operation.
     * @param group the ExperimenterGroup to update.
     **/
    public boolean updateGroup_async(AMI_IAdmin_updateGroup __cb, omero.model.ExperimenterGroup group)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__updateGroup_name);
            __r = begin_updateGroup(group, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __updateGroup_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Updates an experimenter group if admin or owner of group.
     * Only string fields on the object are taken into account.
     * The root, system and guest groups may not be renamed,
     * nor may the user's current group.
     * 
     * @param __cb The callback object for the operation.
     * @param group the ExperimenterGroup to update.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean updateGroup_async(AMI_IAdmin_updateGroup __cb, omero.model.ExperimenterGroup group, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__updateGroup_name);
            __r = begin_updateGroup(group, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __updateGroup_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __updateSelf_name = "updateSelf";

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @see #setDefaultGroup
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     **/
    public void updateSelf(omero.model.Experimenter experimenter)
        throws omero.ServerError
    {
        updateSelf(experimenter, null, false);
    }

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @see #setDefaultGroup
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void updateSelf(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        updateSelf(experimenter, __ctx, true);
    }

    private void updateSelf(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "updateSelf", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("updateSelf");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    __del.updateSelf(experimenter, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     **/
    public Ice.AsyncResult begin_updateSelf(omero.model.Experimenter experimenter)
    {
        return begin_updateSelf(experimenter, null, false, null);
    }

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_updateSelf(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx)
    {
        return begin_updateSelf(experimenter, __ctx, true, null);
    }

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     **/
    public Ice.AsyncResult begin_updateSelf(omero.model.Experimenter experimenter, Ice.Callback __cb)
    {
        return begin_updateSelf(experimenter, null, false, __cb);
    }

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_updateSelf(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_updateSelf(experimenter, __ctx, true, __cb);
    }

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     **/
    public Ice.AsyncResult begin_updateSelf(omero.model.Experimenter experimenter, Callback_IAdmin_updateSelf __cb)
    {
        return begin_updateSelf(experimenter, null, false, __cb);
    }

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_updateSelf(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx, Callback_IAdmin_updateSelf __cb)
    {
        return begin_updateSelf(experimenter, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_updateSelf(omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__updateSelf_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __updateSelf_name, __cb);
        try
        {
            __result.__prepare(__updateSelf_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(experimenter);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_updateSelf(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __updateSelf_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     **/
    public boolean updateSelf_async(AMI_IAdmin_updateSelf __cb, omero.model.Experimenter experimenter)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__updateSelf_name);
            __r = begin_updateSelf(experimenter, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __updateSelf_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Allows a user to update his/her own information. This is
     * limited to the fields on Experimenter, all other fields
     * (groups, etc.) are ignored. The experimenter argument need
     * not have the proper id nor the proper omeName (which is
     * immutable). To change the users default group (which is the
     * only other customizable option), use
     * {@link #setDefaultGroup}
     * 
     * @param __cb The callback object for the operation.
     * @param experimenter A data transfer object. Only the fields:
     * firstName, middleName, lastName, email, and
     * institution are checked. Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean updateSelf_async(AMI_IAdmin_updateSelf __cb, omero.model.Experimenter experimenter, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__updateSelf_name);
            __r = begin_updateSelf(experimenter, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __updateSelf_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __uploadMyUserPhoto_name = "uploadMyUserPhoto";

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param filename Not null. String name which will be used.
     * @param format Not null. Format.value string. 'image/jpeg'
     * and 'image/png' are common values.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     * @return the id of the overwritten or newly created user
     * photo OriginalFile object.
     **/
    public long uploadMyUserPhoto(String filename, String format, byte[] data)
        throws omero.ServerError
    {
        return uploadMyUserPhoto(filename, format, data, null, false);
    }

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param filename Not null. String name which will be used.
     * @param format Not null. Format.value string. 'image/jpeg'
     * and 'image/png' are common values.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     * @param __ctx The Context map to send with the invocation.
     * @return the id of the overwritten or newly created user
     * photo OriginalFile object.
     **/
    public long uploadMyUserPhoto(String filename, String format, byte[] data, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return uploadMyUserPhoto(filename, format, data, __ctx, true);
    }

    private long uploadMyUserPhoto(String filename, String format, byte[] data, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "uploadMyUserPhoto", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("uploadMyUserPhoto");
                    __delBase = __getDelegate(false);
                    _IAdminDel __del = (_IAdminDel)__delBase;
                    return __del.uploadMyUserPhoto(filename, format, data, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param __cb The callback object for the operation.
     * @param filename Not null. String name which will be used.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     **/
    public Ice.AsyncResult begin_uploadMyUserPhoto(String filename, String format, byte[] data)
    {
        return begin_uploadMyUserPhoto(filename, format, data, null, false, null);
    }

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param __cb The callback object for the operation.
     * @param filename Not null. String name which will be used.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_uploadMyUserPhoto(String filename, String format, byte[] data, java.util.Map<String, String> __ctx)
    {
        return begin_uploadMyUserPhoto(filename, format, data, __ctx, true, null);
    }

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param __cb The callback object for the operation.
     * @param filename Not null. String name which will be used.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     **/
    public Ice.AsyncResult begin_uploadMyUserPhoto(String filename, String format, byte[] data, Ice.Callback __cb)
    {
        return begin_uploadMyUserPhoto(filename, format, data, null, false, __cb);
    }

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param __cb The callback object for the operation.
     * @param filename Not null. String name which will be used.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_uploadMyUserPhoto(String filename, String format, byte[] data, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_uploadMyUserPhoto(filename, format, data, __ctx, true, __cb);
    }

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param __cb The callback object for the operation.
     * @param filename Not null. String name which will be used.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     **/
    public Ice.AsyncResult begin_uploadMyUserPhoto(String filename, String format, byte[] data, Callback_IAdmin_uploadMyUserPhoto __cb)
    {
        return begin_uploadMyUserPhoto(filename, format, data, null, false, __cb);
    }

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param __cb The callback object for the operation.
     * @param filename Not null. String name which will be used.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_uploadMyUserPhoto(String filename, String format, byte[] data, java.util.Map<String, String> __ctx, Callback_IAdmin_uploadMyUserPhoto __cb)
    {
        return begin_uploadMyUserPhoto(filename, format, data, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_uploadMyUserPhoto(String filename, String format, byte[] data, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__uploadMyUserPhoto_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __uploadMyUserPhoto_name, __cb);
        try
        {
            __result.__prepare(__uploadMyUserPhoto_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(filename);
            __os.writeString(format);
            Ice.ByteSeqHelper.write(__os, data);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) the id of the overwritten or newly created user
     * photo OriginalFile object.
     **/
    public long end_uploadMyUserPhoto(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __uploadMyUserPhoto_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param __cb The callback object for the operation.
     * @param filename Not null. String name which will be used.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     **/
    public boolean uploadMyUserPhoto_async(AMI_IAdmin_uploadMyUserPhoto __cb, String filename, String format, byte[] data)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__uploadMyUserPhoto_name);
            __r = begin_uploadMyUserPhoto(filename, format, data, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __uploadMyUserPhoto_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Uploads a photo for the user which will be displayed on
     * his/her profile.
     * This photo will be saved as an
     * {@link omero.model.OriginalFile} object with the given
     * format, and attached to the user's
     * {@link omero.model.Experimenter} object via an
     * {@link omero.model.FileAnnotation} with
     * the namespace:
     * <i>openmicroscopy.org/omero/experimenter/photo</i>
     * (NSEXPERIMENTERPHOTO).
     * If such an {@link omero.model.OriginalFile} instance
     * already exists, it will be overwritten. If more than one
     * photo is present, the oldest version will be modified (i.e.
     * the highest updateEvent id).
     * 
     * Note: as outlined in <a href="https://trac.openmicroscopy.org/ome/ticket/1794">ticket 1794</a>
     * this photo will be placed in the <i>user</i> group and
     * therefore will be visible to everyone on the system.
     * 
     * @param __cb The callback object for the operation.
     * @param filename Not null. String name which will be used.
     * @param data Not null. Data from the image. This will be
     * written to disk.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean uploadMyUserPhoto_async(AMI_IAdmin_uploadMyUserPhoto __cb, String filename, String format, byte[] data, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__uploadMyUserPhoto_name);
            __r = begin_uploadMyUserPhoto(filename, format, data, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __uploadMyUserPhoto_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static IAdminPrx checkedCast(Ice.ObjectPrx __obj)
    {
        IAdminPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IAdminPrx)
            {
                __d = (IAdminPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    IAdminPrxHelper __h = new IAdminPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static IAdminPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        IAdminPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IAdminPrx)
            {
                __d = (IAdminPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    IAdminPrxHelper __h = new IAdminPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static IAdminPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        IAdminPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    IAdminPrxHelper __h = new IAdminPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static IAdminPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        IAdminPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    IAdminPrxHelper __h = new IAdminPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static IAdminPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        IAdminPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IAdminPrx)
            {
                __d = (IAdminPrx)__obj;
            }
            else
            {
                IAdminPrxHelper __h = new IAdminPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static IAdminPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        IAdminPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            IAdminPrxHelper __h = new IAdminPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IAdmin",
        "::omero::api::ServiceInterface"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _IAdminDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _IAdminDelD();
    }

    public static void __write(IceInternal.BasicStream __os, IAdminPrx v)
    {
        __os.writeProxy(v);
    }

    public static IAdminPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            IAdminPrxHelper result = new IAdminPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
