// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IRenderingSettings.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides method to apply rendering settings to a collection of
 * images.
 * All methods will receive the id of the pixels set to copy the
 * rendering settings from.
 **/
public final class IRenderingSettingsPrxHelper extends Ice.ObjectPrxHelperBase implements IRenderingSettingsPrx
{
    private static final String __applySettingsToDataset_name = "applySettingsToDataset";

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     * @return A map with two boolean keys. The value of the
     * <code>TRUE</code> is a collection of images ID, the
     * settings were successfully applied to.
     * The value of the <code>FALSE</code> is a collection
     * of images ID, the settings could not be applied to.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the dataset
     * <code>to</code> is unlocatable.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToDataset(long from, long to)
        throws omero.ServerError
    {
        return applySettingsToDataset(from, to, null, false);
    }

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @return A map with two boolean keys. The value of the
     * <code>TRUE</code> is a collection of images ID, the
     * settings were successfully applied to.
     * The value of the <code>FALSE</code> is a collection
     * of images ID, the settings could not be applied to.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the dataset
     * <code>to</code> is unlocatable.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToDataset(long from, long to, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return applySettingsToDataset(from, to, __ctx, true);
    }

    private java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToDataset(long from, long to, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "applySettingsToDataset", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("applySettingsToDataset");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    return __del.applySettingsToDataset(from, to, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     **/
    public Ice.AsyncResult begin_applySettingsToDataset(long from, long to)
    {
        return begin_applySettingsToDataset(from, to, null, false, null);
    }

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_applySettingsToDataset(long from, long to, java.util.Map<String, String> __ctx)
    {
        return begin_applySettingsToDataset(from, to, __ctx, true, null);
    }

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     **/
    public Ice.AsyncResult begin_applySettingsToDataset(long from, long to, Ice.Callback __cb)
    {
        return begin_applySettingsToDataset(from, to, null, false, __cb);
    }

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_applySettingsToDataset(long from, long to, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_applySettingsToDataset(from, to, __ctx, true, __cb);
    }

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     **/
    public Ice.AsyncResult begin_applySettingsToDataset(long from, long to, Callback_IRenderingSettings_applySettingsToDataset __cb)
    {
        return begin_applySettingsToDataset(from, to, null, false, __cb);
    }

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_applySettingsToDataset(long from, long to, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_applySettingsToDataset __cb)
    {
        return begin_applySettingsToDataset(from, to, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_applySettingsToDataset(long from, long to, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__applySettingsToDataset_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __applySettingsToDataset_name, __cb);
        try
        {
            __result.__prepare(__applySettingsToDataset_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(from);
            __os.writeLong(to);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) A map with two boolean keys. The value of the
     * <code>TRUE</code> is a collection of images ID, the
     * settings were successfully applied to.
     * The value of the <code>FALSE</code> is a collection
     * of images ID, the settings could not be applied to.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> end_applySettingsToDataset(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __applySettingsToDataset_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.Boolean, java.util.List<Long>> __ret;
            __ret = BooleanIdListMapHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     **/
    public boolean applySettingsToDataset_async(AMI_IRenderingSettings_applySettingsToDataset __cb, long from, long to)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__applySettingsToDataset_name);
            __r = begin_applySettingsToDataset(from, to, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __applySettingsToDataset_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Applies rendering settings to all images in a given Dataset.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the dataset container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean applySettingsToDataset_async(AMI_IRenderingSettings_applySettingsToDataset __cb, long from, long to, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__applySettingsToDataset_name);
            __r = begin_applySettingsToDataset(from, to, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __applySettingsToDataset_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __applySettingsToImage_name = "applySettingsToImage";

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @return <code>true</code> if the settings were successfully
     * applied, <code>false</code> otherwise.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the image
     * <code>to</code> is unlocatable.
     **/
    public boolean applySettingsToImage(long from, long to)
        throws omero.ServerError
    {
        return applySettingsToImage(from, to, null, false);
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @return <code>true</code> if the settings were successfully
     * applied, <code>false</code> otherwise.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the image
     * <code>to</code> is unlocatable.
     **/
    public boolean applySettingsToImage(long from, long to, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return applySettingsToImage(from, to, __ctx, true);
    }

    private boolean applySettingsToImage(long from, long to, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "applySettingsToImage", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("applySettingsToImage");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    return __del.applySettingsToImage(from, to, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     **/
    public Ice.AsyncResult begin_applySettingsToImage(long from, long to)
    {
        return begin_applySettingsToImage(from, to, null, false, null);
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_applySettingsToImage(long from, long to, java.util.Map<String, String> __ctx)
    {
        return begin_applySettingsToImage(from, to, __ctx, true, null);
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     **/
    public Ice.AsyncResult begin_applySettingsToImage(long from, long to, Ice.Callback __cb)
    {
        return begin_applySettingsToImage(from, to, null, false, __cb);
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_applySettingsToImage(long from, long to, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_applySettingsToImage(from, to, __ctx, true, __cb);
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     **/
    public Ice.AsyncResult begin_applySettingsToImage(long from, long to, Callback_IRenderingSettings_applySettingsToImage __cb)
    {
        return begin_applySettingsToImage(from, to, null, false, __cb);
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_applySettingsToImage(long from, long to, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_applySettingsToImage __cb)
    {
        return begin_applySettingsToImage(from, to, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_applySettingsToImage(long from, long to, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__applySettingsToImage_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __applySettingsToImage_name, __cb);
        try
        {
            __result.__prepare(__applySettingsToImage_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(from);
            __os.writeLong(to);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) <code>true</code> if the settings were successfully
     * applied, <code>false</code> otherwise.
     **/
    public boolean end_applySettingsToImage(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __applySettingsToImage_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     **/
    public boolean applySettingsToImage_async(AMI_IRenderingSettings_applySettingsToImage __cb, long from, long to)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__applySettingsToImage_name);
            __r = begin_applySettingsToImage(from, to, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __applySettingsToImage_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean applySettingsToImage_async(AMI_IRenderingSettings_applySettingsToImage __cb, long from, long to, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__applySettingsToImage_name);
            __r = begin_applySettingsToImage(from, to, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __applySettingsToImage_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __applySettingsToImages_name = "applySettingsToImages";

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @return <code>true</code> if the settings were successfully
     * applied, <code>false</code> otherwise.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the image
     * <code>to</code> is unlocatable.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToImages(long from, java.util.List<Long> to)
        throws omero.ServerError
    {
        return applySettingsToImages(from, to, null, false);
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @return <code>true</code> if the settings were successfully
     * applied, <code>false</code> otherwise.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the image
     * <code>to</code> is unlocatable.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToImages(long from, java.util.List<Long> to, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return applySettingsToImages(from, to, __ctx, true);
    }

    private java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToImages(long from, java.util.List<Long> to, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "applySettingsToImages", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("applySettingsToImages");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    return __del.applySettingsToImages(from, to, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     **/
    public Ice.AsyncResult begin_applySettingsToImages(long from, java.util.List<Long> to)
    {
        return begin_applySettingsToImages(from, to, null, false, null);
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_applySettingsToImages(long from, java.util.List<Long> to, java.util.Map<String, String> __ctx)
    {
        return begin_applySettingsToImages(from, to, __ctx, true, null);
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     **/
    public Ice.AsyncResult begin_applySettingsToImages(long from, java.util.List<Long> to, Ice.Callback __cb)
    {
        return begin_applySettingsToImages(from, to, null, false, __cb);
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_applySettingsToImages(long from, java.util.List<Long> to, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_applySettingsToImages(from, to, __ctx, true, __cb);
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     **/
    public Ice.AsyncResult begin_applySettingsToImages(long from, java.util.List<Long> to, Callback_IRenderingSettings_applySettingsToImages __cb)
    {
        return begin_applySettingsToImages(from, to, null, false, __cb);
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_applySettingsToImages(long from, java.util.List<Long> to, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_applySettingsToImages __cb)
    {
        return begin_applySettingsToImages(from, to, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_applySettingsToImages(long from, java.util.List<Long> to, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__applySettingsToImages_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __applySettingsToImages_name, __cb);
        try
        {
            __result.__prepare(__applySettingsToImages_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(from);
            omero.sys.LongListHelper.write(__os, to);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) <code>true</code> if the settings were successfully
     * applied, <code>false</code> otherwise.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> end_applySettingsToImages(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __applySettingsToImages_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.Boolean, java.util.List<Long>> __ret;
            __ret = BooleanIdListMapHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     **/
    public boolean applySettingsToImages_async(AMI_IRenderingSettings_applySettingsToImages __cb, long from, java.util.List<Long> to)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__applySettingsToImages_name);
            __r = begin_applySettingsToImages(from, to, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __applySettingsToImages_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Applies rendering settings to a given Image.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the image container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean applySettingsToImages_async(AMI_IRenderingSettings_applySettingsToImages __cb, long from, java.util.List<Long> to, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__applySettingsToImages_name);
            __r = begin_applySettingsToImages(from, to, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __applySettingsToImages_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __applySettingsToPixels_name = "applySettingsToPixels";

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     * @return See above.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the
     * pixels<code>to</code> is unlocatable.
     **/
    public boolean applySettingsToPixels(long from, long to)
        throws omero.ServerError
    {
        return applySettingsToPixels(from, to, null, false);
    }

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the
     * pixels<code>to</code> is unlocatable.
     **/
    public boolean applySettingsToPixels(long from, long to, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return applySettingsToPixels(from, to, __ctx, true);
    }

    private boolean applySettingsToPixels(long from, long to, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "applySettingsToPixels", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("applySettingsToPixels");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    return __del.applySettingsToPixels(from, to, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     **/
    public Ice.AsyncResult begin_applySettingsToPixels(long from, long to)
    {
        return begin_applySettingsToPixels(from, to, null, false, null);
    }

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_applySettingsToPixels(long from, long to, java.util.Map<String, String> __ctx)
    {
        return begin_applySettingsToPixels(from, to, __ctx, true, null);
    }

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     **/
    public Ice.AsyncResult begin_applySettingsToPixels(long from, long to, Ice.Callback __cb)
    {
        return begin_applySettingsToPixels(from, to, null, false, __cb);
    }

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_applySettingsToPixels(long from, long to, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_applySettingsToPixels(from, to, __ctx, true, __cb);
    }

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     **/
    public Ice.AsyncResult begin_applySettingsToPixels(long from, long to, Callback_IRenderingSettings_applySettingsToPixels __cb)
    {
        return begin_applySettingsToPixels(from, to, null, false, __cb);
    }

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_applySettingsToPixels(long from, long to, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_applySettingsToPixels __cb)
    {
        return begin_applySettingsToPixels(from, to, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_applySettingsToPixels(long from, long to, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__applySettingsToPixels_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __applySettingsToPixels_name, __cb);
        try
        {
            __result.__prepare(__applySettingsToPixels_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(from);
            __os.writeLong(to);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) See above.
     **/
    public boolean end_applySettingsToPixels(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __applySettingsToPixels_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     **/
    public boolean applySettingsToPixels_async(AMI_IRenderingSettings_applySettingsToPixels __cb, long from, long to)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__applySettingsToPixels_name);
            __r = begin_applySettingsToPixels(from, to, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __applySettingsToPixels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Applies rendering settings to a given Pixels.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the pixels container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean applySettingsToPixels_async(AMI_IRenderingSettings_applySettingsToPixels __cb, long from, long to, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__applySettingsToPixels_name);
            __r = begin_applySettingsToPixels(from, to, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __applySettingsToPixels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __applySettingsToProject_name = "applySettingsToProject";

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     * @return A map with two boolean keys. The value of the
     * <code>TRUE</code> is a collection of images ID, the
     * settings were successfully applied to.
     * The value of the <code>FALSE</code> is a collection
     * of images ID, the settings could not be applied to.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the project
     * <code>to</code> is unlocatable.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToProject(long from, long to)
        throws omero.ServerError
    {
        return applySettingsToProject(from, to, null, false);
    }

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     * @return A map with two boolean keys. The value of the
     * <code>TRUE</code> is a collection of images ID, the
     * settings were successfully applied to.
     * The value of the <code>FALSE</code> is a collection
     * of images ID, the settings could not be applied to.
     * @throws ValidationException if the rendering settings
     * <code>from</code> is unlocatable or the project
     * <code>to</code> is unlocatable.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToProject(long from, long to, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return applySettingsToProject(from, to, __ctx, true);
    }

    private java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToProject(long from, long to, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "applySettingsToProject", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("applySettingsToProject");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    return __del.applySettingsToProject(from, to, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     **/
    public Ice.AsyncResult begin_applySettingsToProject(long from, long to)
    {
        return begin_applySettingsToProject(from, to, null, false, null);
    }

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_applySettingsToProject(long from, long to, java.util.Map<String, String> __ctx)
    {
        return begin_applySettingsToProject(from, to, __ctx, true, null);
    }

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     **/
    public Ice.AsyncResult begin_applySettingsToProject(long from, long to, Ice.Callback __cb)
    {
        return begin_applySettingsToProject(from, to, null, false, __cb);
    }

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_applySettingsToProject(long from, long to, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_applySettingsToProject(from, to, __ctx, true, __cb);
    }

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     **/
    public Ice.AsyncResult begin_applySettingsToProject(long from, long to, Callback_IRenderingSettings_applySettingsToProject __cb)
    {
        return begin_applySettingsToProject(from, to, null, false, __cb);
    }

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_applySettingsToProject(long from, long to, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_applySettingsToProject __cb)
    {
        return begin_applySettingsToProject(from, to, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_applySettingsToProject(long from, long to, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__applySettingsToProject_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __applySettingsToProject_name, __cb);
        try
        {
            __result.__prepare(__applySettingsToProject_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(from);
            __os.writeLong(to);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) A map with two boolean keys. The value of the
     * <code>TRUE</code> is a collection of images ID, the
     * settings were successfully applied to.
     * The value of the <code>FALSE</code> is a collection
     * of images ID, the settings could not be applied to.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> end_applySettingsToProject(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __applySettingsToProject_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.Boolean, java.util.List<Long>> __ret;
            __ret = BooleanIdListMapHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     **/
    public boolean applySettingsToProject_async(AMI_IRenderingSettings_applySettingsToProject __cb, long from, long to)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__applySettingsToProject_name);
            __r = begin_applySettingsToProject(from, to, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __applySettingsToProject_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Applies rendering settings to all images in all Datasets of
     * a given Project.
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param to The Id of the project container to apply settings
     * to.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean applySettingsToProject_async(AMI_IRenderingSettings_applySettingsToProject __cb, long from, long to, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__applySettingsToProject_name);
            __r = begin_applySettingsToProject(from, to, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __applySettingsToProject_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __applySettingsToSet_name = "applySettingsToSet";

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @return A map with two boolean keys. The value of the
     * <code>TRUE</code> is a collection of images ID, the
     * settings were successfully applied to.
     * The value of the <code>FALSE</code> is a collection
     * of images ID, the settings could not be applied to.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToSet(long from, String toType, java.util.List<Long> nodeIds)
        throws omero.ServerError
    {
        return applySettingsToSet(from, toType, nodeIds, null, false);
    }

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @param __ctx The Context map to send with the invocation.
     * @return A map with two boolean keys. The value of the
     * <code>TRUE</code> is a collection of images ID, the
     * settings were successfully applied to.
     * The value of the <code>FALSE</code> is a collection
     * of images ID, the settings could not be applied to.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToSet(long from, String toType, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return applySettingsToSet(from, toType, nodeIds, __ctx, true);
    }

    private java.util.Map<java.lang.Boolean, java.util.List<Long>> applySettingsToSet(long from, String toType, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "applySettingsToSet", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("applySettingsToSet");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    return __del.applySettingsToSet(from, toType, nodeIds, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     **/
    public Ice.AsyncResult begin_applySettingsToSet(long from, String toType, java.util.List<Long> nodeIds)
    {
        return begin_applySettingsToSet(from, toType, nodeIds, null, false, null);
    }

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_applySettingsToSet(long from, String toType, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
    {
        return begin_applySettingsToSet(from, toType, nodeIds, __ctx, true, null);
    }

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     **/
    public Ice.AsyncResult begin_applySettingsToSet(long from, String toType, java.util.List<Long> nodeIds, Ice.Callback __cb)
    {
        return begin_applySettingsToSet(from, toType, nodeIds, null, false, __cb);
    }

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_applySettingsToSet(long from, String toType, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_applySettingsToSet(from, toType, nodeIds, __ctx, true, __cb);
    }

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     **/
    public Ice.AsyncResult begin_applySettingsToSet(long from, String toType, java.util.List<Long> nodeIds, Callback_IRenderingSettings_applySettingsToSet __cb)
    {
        return begin_applySettingsToSet(from, toType, nodeIds, null, false, __cb);
    }

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_applySettingsToSet(long from, String toType, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_applySettingsToSet __cb)
    {
        return begin_applySettingsToSet(from, toType, nodeIds, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_applySettingsToSet(long from, String toType, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__applySettingsToSet_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __applySettingsToSet_name, __cb);
        try
        {
            __result.__prepare(__applySettingsToSet_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(from);
            __os.writeString(toType);
            omero.sys.LongListHelper.write(__os, nodeIds);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) A map with two boolean keys. The value of the
     * <code>TRUE</code> is a collection of images ID, the
     * settings were successfully applied to.
     * The value of the <code>FALSE</code> is a collection
     * of images ID, the settings could not be applied to.
     **/
    public java.util.Map<java.lang.Boolean, java.util.List<Long>> end_applySettingsToSet(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __applySettingsToSet_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.Boolean, java.util.List<Long>> __ret;
            __ret = BooleanIdListMapHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     **/
    public boolean applySettingsToSet_async(AMI_IRenderingSettings_applySettingsToSet __cb, long from, String toType, java.util.List<Long> nodeIds)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__applySettingsToSet_name);
            __r = begin_applySettingsToSet(from, toType, nodeIds, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __applySettingsToSet_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Applies rendering settings to one or many containers. If a
     * container such as Dataset is to be copied to, all images
     * within that Dataset will have the rendering settings
     * applied. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Screen}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param from The Id of the pixels set to copy the rendering
     * settings from.
     * @param toType The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean applySettingsToSet_async(AMI_IRenderingSettings_applySettingsToSet __cb, long from, String toType, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__applySettingsToSet_name);
            __r = begin_applySettingsToSet(from, toType, nodeIds, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __applySettingsToSet_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __createNewRenderingDef_name = "createNewRenderingDef";

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param pixels The Pixels set to link to the rendering
     * definition.
     * @return A new, blank rendering definition and sub-objects.
     * <b>NOTE:</b> the linked Pixels has been unloaded.
     **/
    public omero.model.RenderingDef createNewRenderingDef(omero.model.Pixels pixels)
        throws omero.ServerError
    {
        return createNewRenderingDef(pixels, null, false);
    }

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param pixels The Pixels set to link to the rendering
     * definition.
     * @param __ctx The Context map to send with the invocation.
     * @return A new, blank rendering definition and sub-objects.
     * <b>NOTE:</b> the linked Pixels has been unloaded.
     **/
    public omero.model.RenderingDef createNewRenderingDef(omero.model.Pixels pixels, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return createNewRenderingDef(pixels, __ctx, true);
    }

    private omero.model.RenderingDef createNewRenderingDef(omero.model.Pixels pixels, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "createNewRenderingDef", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("createNewRenderingDef");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    return __del.createNewRenderingDef(pixels, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param __cb The callback object for the operation.
     * @param pixels The Pixels set to link to the rendering
     * definition.
     **/
    public Ice.AsyncResult begin_createNewRenderingDef(omero.model.Pixels pixels)
    {
        return begin_createNewRenderingDef(pixels, null, false, null);
    }

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param __cb The callback object for the operation.
     * @param pixels The Pixels set to link to the rendering
     * definition.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createNewRenderingDef(omero.model.Pixels pixels, java.util.Map<String, String> __ctx)
    {
        return begin_createNewRenderingDef(pixels, __ctx, true, null);
    }

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param __cb The callback object for the operation.
     * @param pixels The Pixels set to link to the rendering
     * definition.
     **/
    public Ice.AsyncResult begin_createNewRenderingDef(omero.model.Pixels pixels, Ice.Callback __cb)
    {
        return begin_createNewRenderingDef(pixels, null, false, __cb);
    }

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param __cb The callback object for the operation.
     * @param pixels The Pixels set to link to the rendering
     * definition.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createNewRenderingDef(omero.model.Pixels pixels, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_createNewRenderingDef(pixels, __ctx, true, __cb);
    }

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param __cb The callback object for the operation.
     * @param pixels The Pixels set to link to the rendering
     * definition.
     **/
    public Ice.AsyncResult begin_createNewRenderingDef(omero.model.Pixels pixels, Callback_IRenderingSettings_createNewRenderingDef __cb)
    {
        return begin_createNewRenderingDef(pixels, null, false, __cb);
    }

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param __cb The callback object for the operation.
     * @param pixels The Pixels set to link to the rendering
     * definition.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createNewRenderingDef(omero.model.Pixels pixels, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_createNewRenderingDef __cb)
    {
        return begin_createNewRenderingDef(pixels, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_createNewRenderingDef(omero.model.Pixels pixels, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__createNewRenderingDef_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __createNewRenderingDef_name, __cb);
        try
        {
            __result.__prepare(__createNewRenderingDef_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(pixels);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) A new, blank rendering definition and sub-objects.
     * <b>NOTE:</b> the linked Pixels has been unloaded.
     **/
    public omero.model.RenderingDef end_createNewRenderingDef(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __createNewRenderingDef_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.RenderingDefHolder __ret = new omero.model.RenderingDefHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param __cb The callback object for the operation.
     * @param pixels The Pixels set to link to the rendering
     * definition.
     **/
    public boolean createNewRenderingDef_async(AMI_IRenderingSettings_createNewRenderingDef __cb, omero.model.Pixels pixels)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createNewRenderingDef_name);
            __r = begin_createNewRenderingDef(pixels, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createNewRenderingDef_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Creates a new rendering definition object along with its
     * sub-objects.
     * 
     * @param __cb The callback object for the operation.
     * @param pixels The Pixels set to link to the rendering
     * definition.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createNewRenderingDef_async(AMI_IRenderingSettings_createNewRenderingDef __cb, omero.model.Pixels pixels, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createNewRenderingDef_name);
            __r = begin_createNewRenderingDef(pixels, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createNewRenderingDef_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getRenderingSettings_name = "getRenderingSettings";

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param pixelsId The Id of the Pixels
     * @return See above.
     * @throws ValidationException if the image qualified by
     * <code>imageId</code> is unlocatable.
     **/
    public omero.model.RenderingDef getRenderingSettings(long pixelsId)
        throws omero.ServerError
    {
        return getRenderingSettings(pixelsId, null, false);
    }

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param pixelsId The Id of the Pixels
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     * @throws ValidationException if the image qualified by
     * <code>imageId</code> is unlocatable.
     **/
    public omero.model.RenderingDef getRenderingSettings(long pixelsId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getRenderingSettings(pixelsId, __ctx, true);
    }

    private omero.model.RenderingDef getRenderingSettings(long pixelsId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getRenderingSettings", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getRenderingSettings");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    return __del.getRenderingSettings(pixelsId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels
     **/
    public Ice.AsyncResult begin_getRenderingSettings(long pixelsId)
    {
        return begin_getRenderingSettings(pixelsId, null, false, null);
    }

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRenderingSettings(long pixelsId, java.util.Map<String, String> __ctx)
    {
        return begin_getRenderingSettings(pixelsId, __ctx, true, null);
    }

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels
     **/
    public Ice.AsyncResult begin_getRenderingSettings(long pixelsId, Ice.Callback __cb)
    {
        return begin_getRenderingSettings(pixelsId, null, false, __cb);
    }

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRenderingSettings(long pixelsId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getRenderingSettings(pixelsId, __ctx, true, __cb);
    }

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels
     **/
    public Ice.AsyncResult begin_getRenderingSettings(long pixelsId, Callback_IRenderingSettings_getRenderingSettings __cb)
    {
        return begin_getRenderingSettings(pixelsId, null, false, __cb);
    }

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRenderingSettings(long pixelsId, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_getRenderingSettings __cb)
    {
        return begin_getRenderingSettings(pixelsId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getRenderingSettings(long pixelsId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getRenderingSettings_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getRenderingSettings_name, __cb);
        try
        {
            __result.__prepare(__getRenderingSettings_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(pixelsId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) See above.
     **/
    public omero.model.RenderingDef end_getRenderingSettings(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getRenderingSettings_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.RenderingDefHolder __ret = new omero.model.RenderingDefHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels
     **/
    public boolean getRenderingSettings_async(AMI_IRenderingSettings_getRenderingSettings __cb, long pixelsId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getRenderingSettings_name);
            __r = begin_getRenderingSettings(pixelsId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getRenderingSettings_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the default rendering settings for a given pixels
     * for the current user.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getRenderingSettings_async(AMI_IRenderingSettings_getRenderingSettings __cb, long pixelsId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getRenderingSettings_name);
            __r = begin_getRenderingSettings(pixelsId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getRenderingSettings_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __resetDefaults_name = "resetDefaults";

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     **/
    public void resetDefaults(omero.model.RenderingDef def, omero.model.Pixels pixels)
        throws omero.ServerError
    {
        resetDefaults(def, pixels, null, false);
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void resetDefaults(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        resetDefaults(def, pixels, __ctx, true);
    }

    private void resetDefaults(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "resetDefaults", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("resetDefaults");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    __del.resetDefaults(def, pixels, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     **/
    public Ice.AsyncResult begin_resetDefaults(omero.model.RenderingDef def, omero.model.Pixels pixels)
    {
        return begin_resetDefaults(def, pixels, null, false, null);
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaults(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx)
    {
        return begin_resetDefaults(def, pixels, __ctx, true, null);
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     **/
    public Ice.AsyncResult begin_resetDefaults(omero.model.RenderingDef def, omero.model.Pixels pixels, Ice.Callback __cb)
    {
        return begin_resetDefaults(def, pixels, null, false, __cb);
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaults(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_resetDefaults(def, pixels, __ctx, true, __cb);
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     **/
    public Ice.AsyncResult begin_resetDefaults(omero.model.RenderingDef def, omero.model.Pixels pixels, Callback_IRenderingSettings_resetDefaults __cb)
    {
        return begin_resetDefaults(def, pixels, null, false, __cb);
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaults(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_resetDefaults __cb)
    {
        return begin_resetDefaults(def, pixels, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_resetDefaults(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__resetDefaults_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __resetDefaults_name, __cb);
        try
        {
            __result.__prepare(__resetDefaults_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(def);
            __os.writeObject(pixels);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_resetDefaults(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __resetDefaults_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     **/
    public boolean resetDefaults_async(AMI_IRenderingSettings_resetDefaults __cb, omero.model.RenderingDef def, omero.model.Pixels pixels)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaults_name);
            __r = begin_resetDefaults(def, pixels, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaults_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings} as it
     * relies on certain objects being loaded. The rendering
     * settings are saved upon completion.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaults_async(AMI_IRenderingSettings_resetDefaults __cb, omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaults_name);
            __r = begin_resetDefaults(def, pixels, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaults_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __resetDefaultsByOwnerInSet_name = "resetDefaultsByOwnerInSet";

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> resetDefaultsByOwnerInSet(String type, java.util.List<Long> nodeIds)
        throws omero.ServerError
    {
        return resetDefaultsByOwnerInSet(type, nodeIds, null, false);
    }

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @param __ctx The Context map to send with the invocation.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> resetDefaultsByOwnerInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return resetDefaultsByOwnerInSet(type, nodeIds, __ctx, true);
    }

    private java.util.List<Long> resetDefaultsByOwnerInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "resetDefaultsByOwnerInSet", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("resetDefaultsByOwnerInSet");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    return __del.resetDefaultsByOwnerInSet(type, nodeIds, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public Ice.AsyncResult begin_resetDefaultsByOwnerInSet(String type, java.util.List<Long> nodeIds)
    {
        return begin_resetDefaultsByOwnerInSet(type, nodeIds, null, false, null);
    }

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultsByOwnerInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
    {
        return begin_resetDefaultsByOwnerInSet(type, nodeIds, __ctx, true, null);
    }

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public Ice.AsyncResult begin_resetDefaultsByOwnerInSet(String type, java.util.List<Long> nodeIds, Ice.Callback __cb)
    {
        return begin_resetDefaultsByOwnerInSet(type, nodeIds, null, false, __cb);
    }

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultsByOwnerInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_resetDefaultsByOwnerInSet(type, nodeIds, __ctx, true, __cb);
    }

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public Ice.AsyncResult begin_resetDefaultsByOwnerInSet(String type, java.util.List<Long> nodeIds, Callback_IRenderingSettings_resetDefaultsByOwnerInSet __cb)
    {
        return begin_resetDefaultsByOwnerInSet(type, nodeIds, null, false, __cb);
    }

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultsByOwnerInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_resetDefaultsByOwnerInSet __cb)
    {
        return begin_resetDefaultsByOwnerInSet(type, nodeIds, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_resetDefaultsByOwnerInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__resetDefaultsByOwnerInSet_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __resetDefaultsByOwnerInSet_name, __cb);
        try
        {
            __result.__prepare(__resetDefaultsByOwnerInSet_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(type);
            omero.sys.LongListHelper.write(__os, nodeIds);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     **/
    public java.util.List<Long> end_resetDefaultsByOwnerInSet(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __resetDefaultsByOwnerInSet_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<Long> __ret;
            __ret = omero.sys.LongListHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public boolean resetDefaultsByOwnerInSet_async(AMI_IRenderingSettings_resetDefaultsByOwnerInSet __cb, String type, java.util.List<Long> nodeIds)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaultsByOwnerInSet_name);
            __r = begin_resetDefaultsByOwnerInSet(type, nodeIds, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaultsByOwnerInSet_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Resets the rendering settings of a given group of
     * containers based on the owner's (essentially a copy).
     * Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaultsByOwnerInSet_async(AMI_IRenderingSettings_resetDefaultsByOwnerInSet __cb, String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaultsByOwnerInSet_name);
            __r = begin_resetDefaultsByOwnerInSet(type, nodeIds, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaultsByOwnerInSet_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __resetDefaultsForPixels_name = "resetDefaultsForPixels";

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param pixelsId The Id of the Pixels.
     * @throws ValidationException if the Pixels qualified by
     * <code>pixelsId</code> is unlocatable.
     **/
    public void resetDefaultsForPixels(long pixelsId)
        throws omero.ServerError
    {
        resetDefaultsForPixels(pixelsId, null, false);
    }

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param pixelsId The Id of the Pixels.
     * @throws ValidationException if the Pixels qualified by
     * <code>pixelsId</code> is unlocatable.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void resetDefaultsForPixels(long pixelsId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        resetDefaultsForPixels(pixelsId, __ctx, true);
    }

    private void resetDefaultsForPixels(long pixelsId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "resetDefaultsForPixels", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("resetDefaultsForPixels");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    __del.resetDefaultsForPixels(pixelsId, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels.
     **/
    public Ice.AsyncResult begin_resetDefaultsForPixels(long pixelsId)
    {
        return begin_resetDefaultsForPixels(pixelsId, null, false, null);
    }

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultsForPixels(long pixelsId, java.util.Map<String, String> __ctx)
    {
        return begin_resetDefaultsForPixels(pixelsId, __ctx, true, null);
    }

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels.
     **/
    public Ice.AsyncResult begin_resetDefaultsForPixels(long pixelsId, Ice.Callback __cb)
    {
        return begin_resetDefaultsForPixels(pixelsId, null, false, __cb);
    }

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultsForPixels(long pixelsId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_resetDefaultsForPixels(pixelsId, __ctx, true, __cb);
    }

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels.
     **/
    public Ice.AsyncResult begin_resetDefaultsForPixels(long pixelsId, Callback_IRenderingSettings_resetDefaultsForPixels __cb)
    {
        return begin_resetDefaultsForPixels(pixelsId, null, false, __cb);
    }

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultsForPixels(long pixelsId, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_resetDefaultsForPixels __cb)
    {
        return begin_resetDefaultsForPixels(pixelsId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_resetDefaultsForPixels(long pixelsId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__resetDefaultsForPixels_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __resetDefaultsForPixels_name, __cb);
        try
        {
            __result.__prepare(__resetDefaultsForPixels_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(pixelsId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_resetDefaultsForPixels(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __resetDefaultsForPixels_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels.
     **/
    public boolean resetDefaultsForPixels_async(AMI_IRenderingSettings_resetDefaultsForPixels __cb, long pixelsId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaultsForPixels_name);
            __r = begin_resetDefaultsForPixels(pixelsId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaultsForPixels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Resets a Pixels' default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaultsForPixels_async(AMI_IRenderingSettings_resetDefaultsForPixels __cb, long pixelsId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaultsForPixels_name);
            __r = begin_resetDefaultsForPixels(pixelsId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaultsForPixels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __resetDefaultsInDataset_name = "resetDefaultsInDataset";

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param dataSetId The Id of the Dataset.
     * @return A {@link java.util.Set} of image IDs that have had
     * their rendering settings reset.
     * @throws ValidationException if the image qualified by
     * <code>dataSetId</code> is unlocatable.
     **/
    public java.util.List<Long> resetDefaultsInDataset(long dataSetId)
        throws omero.ServerError
    {
        return resetDefaultsInDataset(dataSetId, null, false);
    }

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param dataSetId The Id of the Dataset.
     * @param __ctx The Context map to send with the invocation.
     * @return A {@link java.util.Set} of image IDs that have had
     * their rendering settings reset.
     * @throws ValidationException if the image qualified by
     * <code>dataSetId</code> is unlocatable.
     **/
    public java.util.List<Long> resetDefaultsInDataset(long dataSetId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return resetDefaultsInDataset(dataSetId, __ctx, true);
    }

    private java.util.List<Long> resetDefaultsInDataset(long dataSetId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "resetDefaultsInDataset", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("resetDefaultsInDataset");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    return __del.resetDefaultsInDataset(dataSetId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param dataSetId The Id of the Dataset.
     **/
    public Ice.AsyncResult begin_resetDefaultsInDataset(long dataSetId)
    {
        return begin_resetDefaultsInDataset(dataSetId, null, false, null);
    }

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param dataSetId The Id of the Dataset.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultsInDataset(long dataSetId, java.util.Map<String, String> __ctx)
    {
        return begin_resetDefaultsInDataset(dataSetId, __ctx, true, null);
    }

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param dataSetId The Id of the Dataset.
     **/
    public Ice.AsyncResult begin_resetDefaultsInDataset(long dataSetId, Ice.Callback __cb)
    {
        return begin_resetDefaultsInDataset(dataSetId, null, false, __cb);
    }

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param dataSetId The Id of the Dataset.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultsInDataset(long dataSetId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_resetDefaultsInDataset(dataSetId, __ctx, true, __cb);
    }

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param dataSetId The Id of the Dataset.
     **/
    public Ice.AsyncResult begin_resetDefaultsInDataset(long dataSetId, Callback_IRenderingSettings_resetDefaultsInDataset __cb)
    {
        return begin_resetDefaultsInDataset(dataSetId, null, false, __cb);
    }

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param dataSetId The Id of the Dataset.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultsInDataset(long dataSetId, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_resetDefaultsInDataset __cb)
    {
        return begin_resetDefaultsInDataset(dataSetId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_resetDefaultsInDataset(long dataSetId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__resetDefaultsInDataset_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __resetDefaultsInDataset_name, __cb);
        try
        {
            __result.__prepare(__resetDefaultsInDataset_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(dataSetId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) A {@link java.util.Set} of image IDs that have had
     * their rendering settings reset.
     **/
    public java.util.List<Long> end_resetDefaultsInDataset(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __resetDefaultsInDataset_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<Long> __ret;
            __ret = omero.sys.LongListHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param dataSetId The Id of the Dataset.
     **/
    public boolean resetDefaultsInDataset_async(AMI_IRenderingSettings_resetDefaultsInDataset __cb, long dataSetId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaultsInDataset_name);
            __r = begin_resetDefaultsInDataset(dataSetId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaultsInDataset_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Resets a dataset's rendering settings back to those that
     * are specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param dataSetId The Id of the Dataset.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaultsInDataset_async(AMI_IRenderingSettings_resetDefaultsInDataset __cb, long dataSetId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaultsInDataset_name);
            __r = begin_resetDefaultsInDataset(dataSetId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaultsInDataset_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __resetDefaultsInImage_name = "resetDefaultsInImage";

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param imageId The Id of the Image.
     * @throws ValidationException if the image qualified by
     * <code>imageId</code> is unlocatable.
     **/
    public void resetDefaultsInImage(long imageId)
        throws omero.ServerError
    {
        resetDefaultsInImage(imageId, null, false);
    }

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param imageId The Id of the Image.
     * @throws ValidationException if the image qualified by
     * <code>imageId</code> is unlocatable.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void resetDefaultsInImage(long imageId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        resetDefaultsInImage(imageId, __ctx, true);
    }

    private void resetDefaultsInImage(long imageId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "resetDefaultsInImage", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("resetDefaultsInImage");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    __del.resetDefaultsInImage(imageId, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     **/
    public Ice.AsyncResult begin_resetDefaultsInImage(long imageId)
    {
        return begin_resetDefaultsInImage(imageId, null, false, null);
    }

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultsInImage(long imageId, java.util.Map<String, String> __ctx)
    {
        return begin_resetDefaultsInImage(imageId, __ctx, true, null);
    }

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     **/
    public Ice.AsyncResult begin_resetDefaultsInImage(long imageId, Ice.Callback __cb)
    {
        return begin_resetDefaultsInImage(imageId, null, false, __cb);
    }

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultsInImage(long imageId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_resetDefaultsInImage(imageId, __ctx, true, __cb);
    }

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     **/
    public Ice.AsyncResult begin_resetDefaultsInImage(long imageId, Callback_IRenderingSettings_resetDefaultsInImage __cb)
    {
        return begin_resetDefaultsInImage(imageId, null, false, __cb);
    }

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultsInImage(long imageId, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_resetDefaultsInImage __cb)
    {
        return begin_resetDefaultsInImage(imageId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_resetDefaultsInImage(long imageId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__resetDefaultsInImage_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __resetDefaultsInImage_name, __cb);
        try
        {
            __result.__prepare(__resetDefaultsInImage_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(imageId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_resetDefaultsInImage(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __resetDefaultsInImage_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     **/
    public boolean resetDefaultsInImage_async(AMI_IRenderingSettings_resetDefaultsInImage __cb, long imageId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaultsInImage_name);
            __r = begin_resetDefaultsInImage(imageId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaultsInImage_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Resets an image's default rendering settings back to those
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaultsInImage_async(AMI_IRenderingSettings_resetDefaultsInImage __cb, long imageId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaultsInImage_name);
            __r = begin_resetDefaultsInImage(imageId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaultsInImage_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __resetDefaultsInSet_name = "resetDefaultsInSet";

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @return A {@link java.util.Set} of image IDs that have had
     * their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> resetDefaultsInSet(String type, java.util.List<Long> nodeIds)
        throws omero.ServerError
    {
        return resetDefaultsInSet(type, nodeIds, null, false);
    }

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @param __ctx The Context map to send with the invocation.
     * @return A {@link java.util.Set} of image IDs that have had
     * their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> resetDefaultsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return resetDefaultsInSet(type, nodeIds, __ctx, true);
    }

    private java.util.List<Long> resetDefaultsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "resetDefaultsInSet", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("resetDefaultsInSet");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    return __del.resetDefaultsInSet(type, nodeIds, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public Ice.AsyncResult begin_resetDefaultsInSet(String type, java.util.List<Long> nodeIds)
    {
        return begin_resetDefaultsInSet(type, nodeIds, null, false, null);
    }

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
    {
        return begin_resetDefaultsInSet(type, nodeIds, __ctx, true, null);
    }

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public Ice.AsyncResult begin_resetDefaultsInSet(String type, java.util.List<Long> nodeIds, Ice.Callback __cb)
    {
        return begin_resetDefaultsInSet(type, nodeIds, null, false, __cb);
    }

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_resetDefaultsInSet(type, nodeIds, __ctx, true, __cb);
    }

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public Ice.AsyncResult begin_resetDefaultsInSet(String type, java.util.List<Long> nodeIds, Callback_IRenderingSettings_resetDefaultsInSet __cb)
    {
        return begin_resetDefaultsInSet(type, nodeIds, null, false, __cb);
    }

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_resetDefaultsInSet __cb)
    {
        return begin_resetDefaultsInSet(type, nodeIds, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_resetDefaultsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__resetDefaultsInSet_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __resetDefaultsInSet_name, __cb);
        try
        {
            __result.__prepare(__resetDefaultsInSet_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(type);
            omero.sys.LongListHelper.write(__os, nodeIds);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) A {@link java.util.Set} of image IDs that have had
     * their rendering settings reset.
     **/
    public java.util.List<Long> end_resetDefaultsInSet(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __resetDefaultsInSet_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<Long> __ret;
            __ret = omero.sys.LongListHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public boolean resetDefaultsInSet_async(AMI_IRenderingSettings_resetDefaultsInSet __cb, String type, java.util.List<Long> nodeIds)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaultsInSet_name);
            __r = begin_resetDefaultsInSet(type, nodeIds, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaultsInSet_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Resets a rendering settings back to one or many containers
     * that are specified by the rendering engine intelligent
     * <i>pretty good image (PG)</i> logic. Supported container
     * types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaultsInSet_async(AMI_IRenderingSettings_resetDefaultsInSet __cb, String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaultsInSet_name);
            __r = begin_resetDefaultsInSet(type, nodeIds, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaultsInSet_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __resetDefaultsNoSave_name = "resetDefaultsNoSave";

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @return <code>def</code> with the rendering settings reset.
     **/
    public omero.model.RenderingDef resetDefaultsNoSave(omero.model.RenderingDef def, omero.model.Pixels pixels)
        throws omero.ServerError
    {
        return resetDefaultsNoSave(def, pixels, null, false);
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     * @return <code>def</code> with the rendering settings reset.
     **/
    public omero.model.RenderingDef resetDefaultsNoSave(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return resetDefaultsNoSave(def, pixels, __ctx, true);
    }

    private omero.model.RenderingDef resetDefaultsNoSave(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "resetDefaultsNoSave", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("resetDefaultsNoSave");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    return __del.resetDefaultsNoSave(def, pixels, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     **/
    public Ice.AsyncResult begin_resetDefaultsNoSave(omero.model.RenderingDef def, omero.model.Pixels pixels)
    {
        return begin_resetDefaultsNoSave(def, pixels, null, false, null);
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultsNoSave(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx)
    {
        return begin_resetDefaultsNoSave(def, pixels, __ctx, true, null);
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     **/
    public Ice.AsyncResult begin_resetDefaultsNoSave(omero.model.RenderingDef def, omero.model.Pixels pixels, Ice.Callback __cb)
    {
        return begin_resetDefaultsNoSave(def, pixels, null, false, __cb);
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultsNoSave(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_resetDefaultsNoSave(def, pixels, __ctx, true, __cb);
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     **/
    public Ice.AsyncResult begin_resetDefaultsNoSave(omero.model.RenderingDef def, omero.model.Pixels pixels, Callback_IRenderingSettings_resetDefaultsNoSave __cb)
    {
        return begin_resetDefaultsNoSave(def, pixels, null, false, __cb);
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultsNoSave(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_resetDefaultsNoSave __cb)
    {
        return begin_resetDefaultsNoSave(def, pixels, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_resetDefaultsNoSave(omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__resetDefaultsNoSave_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __resetDefaultsNoSave_name, __cb);
        try
        {
            __result.__prepare(__resetDefaultsNoSave_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(def);
            __os.writeObject(pixels);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) <code>def</code> with the rendering settings reset.
     **/
    public omero.model.RenderingDef end_resetDefaultsNoSave(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __resetDefaultsNoSave_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.RenderingDefHolder __ret = new omero.model.RenderingDefHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     **/
    public boolean resetDefaultsNoSave_async(AMI_IRenderingSettings_resetDefaultsNoSave __cb, omero.model.RenderingDef def, omero.model.Pixels pixels)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaultsNoSave_name);
            __r = begin_resetDefaultsNoSave(def, pixels, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaultsNoSave_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Resets the given rendering settings to those that are
     * specified by the rendering engine intelligent <i>pretty
     * good image (PG)</i> logic for the pixels set linked to that
     * set of rendering settings. <b>NOTE:</b> This method should
     * only be used to reset a rendering definition that has been
     * retrieved via {@link #getRenderingSettings(long)} as it
     * relies on certain objects being loaded. The rendering
     * settings are not saved.
     * 
     * @param __cb The callback object for the operation.
     * @param def A RenderingDef to reset. It is expected that
     * def.pixels will be <i>unloaded</i> and that the
     * actual linked Pixels set will be provided in the
     * <code>pixels</code> argument.
     * @param pixels The Pixels set for <code>def</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaultsNoSave_async(AMI_IRenderingSettings_resetDefaultsNoSave __cb, omero.model.RenderingDef def, omero.model.Pixels pixels, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaultsNoSave_name);
            __r = begin_resetDefaultsNoSave(def, pixels, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaultsNoSave_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __resetMinMaxInSet_name = "resetMinMaxInSet";

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> resetMinMaxInSet(String type, java.util.List<Long> nodeIds)
        throws omero.ServerError
    {
        return resetMinMaxInSet(type, nodeIds, null, false);
    }

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param type The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @param __ctx The Context map to send with the invocation.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> resetMinMaxInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return resetMinMaxInSet(type, nodeIds, __ctx, true);
    }

    private java.util.List<Long> resetMinMaxInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "resetMinMaxInSet", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("resetMinMaxInSet");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    return __del.resetMinMaxInSet(type, nodeIds, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public Ice.AsyncResult begin_resetMinMaxInSet(String type, java.util.List<Long> nodeIds)
    {
        return begin_resetMinMaxInSet(type, nodeIds, null, false, null);
    }

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetMinMaxInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
    {
        return begin_resetMinMaxInSet(type, nodeIds, __ctx, true, null);
    }

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public Ice.AsyncResult begin_resetMinMaxInSet(String type, java.util.List<Long> nodeIds, Ice.Callback __cb)
    {
        return begin_resetMinMaxInSet(type, nodeIds, null, false, __cb);
    }

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetMinMaxInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_resetMinMaxInSet(type, nodeIds, __ctx, true, __cb);
    }

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public Ice.AsyncResult begin_resetMinMaxInSet(String type, java.util.List<Long> nodeIds, Callback_IRenderingSettings_resetMinMaxInSet __cb)
    {
        return begin_resetMinMaxInSet(type, nodeIds, null, false, __cb);
    }

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetMinMaxInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_resetMinMaxInSet __cb)
    {
        return begin_resetMinMaxInSet(type, nodeIds, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_resetMinMaxInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__resetMinMaxInSet_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __resetMinMaxInSet_name, __cb);
        try
        {
            __result.__prepare(__resetMinMaxInSet_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(type);
            omero.sys.LongListHelper.write(__os, nodeIds);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     **/
    public java.util.List<Long> end_resetMinMaxInSet(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __resetMinMaxInSet_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<Long> __ret;
            __ret = omero.sys.LongListHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public boolean resetMinMaxInSet_async(AMI_IRenderingSettings_resetMinMaxInSet __cb, String type, java.util.List<Long> nodeIds)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetMinMaxInSet_name);
            __r = begin_resetMinMaxInSet(type, nodeIds, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetMinMaxInSet_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Resets a the channel windows for one or many containers
     * back to their global minimum and global maximum for the
     * channel. Supported container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetMinMaxInSet_async(AMI_IRenderingSettings_resetMinMaxInSet __cb, String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetMinMaxInSet_name);
            __r = begin_resetMinMaxInSet(type, nodeIds, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetMinMaxInSet_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __sanityCheckPixels_name = "sanityCheckPixels";

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param pFrom The pixels set to copy the settings from.
     * @param pTo The pixels set to copy the settings to.
     * @return See above.
     **/
    public boolean sanityCheckPixels(omero.model.Pixels pFrom, omero.model.Pixels pTo)
        throws omero.ServerError
    {
        return sanityCheckPixels(pFrom, pTo, null, false);
    }

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param pFrom The pixels set to copy the settings from.
     * @param pTo The pixels set to copy the settings to.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public boolean sanityCheckPixels(omero.model.Pixels pFrom, omero.model.Pixels pTo, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return sanityCheckPixels(pFrom, pTo, __ctx, true);
    }

    private boolean sanityCheckPixels(omero.model.Pixels pFrom, omero.model.Pixels pTo, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "sanityCheckPixels", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("sanityCheckPixels");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    return __del.sanityCheckPixels(pFrom, pTo, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param pFrom The pixels set to copy the settings from.
     **/
    public Ice.AsyncResult begin_sanityCheckPixels(omero.model.Pixels pFrom, omero.model.Pixels pTo)
    {
        return begin_sanityCheckPixels(pFrom, pTo, null, false, null);
    }

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param pFrom The pixels set to copy the settings from.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_sanityCheckPixels(omero.model.Pixels pFrom, omero.model.Pixels pTo, java.util.Map<String, String> __ctx)
    {
        return begin_sanityCheckPixels(pFrom, pTo, __ctx, true, null);
    }

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param pFrom The pixels set to copy the settings from.
     **/
    public Ice.AsyncResult begin_sanityCheckPixels(omero.model.Pixels pFrom, omero.model.Pixels pTo, Ice.Callback __cb)
    {
        return begin_sanityCheckPixels(pFrom, pTo, null, false, __cb);
    }

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param pFrom The pixels set to copy the settings from.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_sanityCheckPixels(omero.model.Pixels pFrom, omero.model.Pixels pTo, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_sanityCheckPixels(pFrom, pTo, __ctx, true, __cb);
    }

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param pFrom The pixels set to copy the settings from.
     **/
    public Ice.AsyncResult begin_sanityCheckPixels(omero.model.Pixels pFrom, omero.model.Pixels pTo, Callback_IRenderingSettings_sanityCheckPixels __cb)
    {
        return begin_sanityCheckPixels(pFrom, pTo, null, false, __cb);
    }

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param pFrom The pixels set to copy the settings from.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_sanityCheckPixels(omero.model.Pixels pFrom, omero.model.Pixels pTo, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_sanityCheckPixels __cb)
    {
        return begin_sanityCheckPixels(pFrom, pTo, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_sanityCheckPixels(omero.model.Pixels pFrom, omero.model.Pixels pTo, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__sanityCheckPixels_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __sanityCheckPixels_name, __cb);
        try
        {
            __result.__prepare(__sanityCheckPixels_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(pFrom);
            __os.writeObject(pTo);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) See above.
     **/
    public boolean end_sanityCheckPixels(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __sanityCheckPixels_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param pFrom The pixels set to copy the settings from.
     **/
    public boolean sanityCheckPixels_async(AMI_IRenderingSettings_sanityCheckPixels __cb, omero.model.Pixels pFrom, omero.model.Pixels pTo)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__sanityCheckPixels_name);
            __r = begin_sanityCheckPixels(pFrom, pTo, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __sanityCheckPixels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Checks if the specified sets of pixels are compatible.
     * Returns <code>true</code> if the pixels set is valid,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param pFrom The pixels set to copy the settings from.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean sanityCheckPixels_async(AMI_IRenderingSettings_sanityCheckPixels __cb, omero.model.Pixels pFrom, omero.model.Pixels pTo, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__sanityCheckPixels_name);
            __r = begin_sanityCheckPixels(pFrom, pTo, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __sanityCheckPixels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setOriginalSettingsForPixels_name = "setOriginalSettingsForPixels";

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param pixelsId The Id of the Pixels set.
     * @throws ValidationException if the image qualified by
     * <code>pixelsId</code> is unlocatable.
     **/
    public void setOriginalSettingsForPixels(long pixelsId)
        throws omero.ServerError
    {
        setOriginalSettingsForPixels(pixelsId, null, false);
    }

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param pixelsId The Id of the Pixels set.
     * @throws ValidationException if the image qualified by
     * <code>pixelsId</code> is unlocatable.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setOriginalSettingsForPixels(long pixelsId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setOriginalSettingsForPixels(pixelsId, __ctx, true);
    }

    private void setOriginalSettingsForPixels(long pixelsId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setOriginalSettingsForPixels", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setOriginalSettingsForPixels");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    __del.setOriginalSettingsForPixels(pixelsId, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels set.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsForPixels(long pixelsId)
    {
        return begin_setOriginalSettingsForPixels(pixelsId, null, false, null);
    }

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels set.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsForPixels(long pixelsId, java.util.Map<String, String> __ctx)
    {
        return begin_setOriginalSettingsForPixels(pixelsId, __ctx, true, null);
    }

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels set.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsForPixels(long pixelsId, Ice.Callback __cb)
    {
        return begin_setOriginalSettingsForPixels(pixelsId, null, false, __cb);
    }

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels set.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsForPixels(long pixelsId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setOriginalSettingsForPixels(pixelsId, __ctx, true, __cb);
    }

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels set.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsForPixels(long pixelsId, Callback_IRenderingSettings_setOriginalSettingsForPixels __cb)
    {
        return begin_setOriginalSettingsForPixels(pixelsId, null, false, __cb);
    }

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels set.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsForPixels(long pixelsId, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_setOriginalSettingsForPixels __cb)
    {
        return begin_setOriginalSettingsForPixels(pixelsId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setOriginalSettingsForPixels(long pixelsId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setOriginalSettingsForPixels_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setOriginalSettingsForPixels_name, __cb);
        try
        {
            __result.__prepare(__setOriginalSettingsForPixels_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(pixelsId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setOriginalSettingsForPixels(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setOriginalSettingsForPixels_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels set.
     **/
    public boolean setOriginalSettingsForPixels_async(AMI_IRenderingSettings_setOriginalSettingsForPixels __cb, long pixelsId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setOriginalSettingsForPixels_name);
            __r = begin_setOriginalSettingsForPixels(pixelsId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setOriginalSettingsForPixels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Resets an Pixels' default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The Id of the Pixels set.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setOriginalSettingsForPixels_async(AMI_IRenderingSettings_setOriginalSettingsForPixels __cb, long pixelsId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setOriginalSettingsForPixels_name);
            __r = begin_setOriginalSettingsForPixels(pixelsId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setOriginalSettingsForPixels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setOriginalSettingsInDataset_name = "setOriginalSettingsInDataset";

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param datasetId The id of the dataset to handle.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if the image qualified by
     * <code>datasetId</code> is unlocatable.
     **/
    public java.util.List<Long> setOriginalSettingsInDataset(long dataSetId)
        throws omero.ServerError
    {
        return setOriginalSettingsInDataset(dataSetId, null, false);
    }

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param datasetId The id of the dataset to handle.
     * @param __ctx The Context map to send with the invocation.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if the image qualified by
     * <code>datasetId</code> is unlocatable.
     **/
    public java.util.List<Long> setOriginalSettingsInDataset(long dataSetId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return setOriginalSettingsInDataset(dataSetId, __ctx, true);
    }

    private java.util.List<Long> setOriginalSettingsInDataset(long dataSetId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setOriginalSettingsInDataset", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setOriginalSettingsInDataset");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    return __del.setOriginalSettingsInDataset(dataSetId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInDataset(long dataSetId)
    {
        return begin_setOriginalSettingsInDataset(dataSetId, null, false, null);
    }

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInDataset(long dataSetId, java.util.Map<String, String> __ctx)
    {
        return begin_setOriginalSettingsInDataset(dataSetId, __ctx, true, null);
    }

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInDataset(long dataSetId, Ice.Callback __cb)
    {
        return begin_setOriginalSettingsInDataset(dataSetId, null, false, __cb);
    }

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInDataset(long dataSetId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setOriginalSettingsInDataset(dataSetId, __ctx, true, __cb);
    }

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInDataset(long dataSetId, Callback_IRenderingSettings_setOriginalSettingsInDataset __cb)
    {
        return begin_setOriginalSettingsInDataset(dataSetId, null, false, __cb);
    }

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInDataset(long dataSetId, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_setOriginalSettingsInDataset __cb)
    {
        return begin_setOriginalSettingsInDataset(dataSetId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setOriginalSettingsInDataset(long dataSetId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setOriginalSettingsInDataset_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setOriginalSettingsInDataset_name, __cb);
        try
        {
            __result.__prepare(__setOriginalSettingsInDataset_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(dataSetId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     **/
    public java.util.List<Long> end_setOriginalSettingsInDataset(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setOriginalSettingsInDataset_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<Long> __ret;
            __ret = omero.sys.LongListHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean setOriginalSettingsInDataset_async(AMI_IRenderingSettings_setOriginalSettingsInDataset __cb, long dataSetId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setOriginalSettingsInDataset_name);
            __r = begin_setOriginalSettingsInDataset(dataSetId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setOriginalSettingsInDataset_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Resets a dataset's rendering settings back to channel global
     * minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setOriginalSettingsInDataset_async(AMI_IRenderingSettings_setOriginalSettingsInDataset __cb, long dataSetId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setOriginalSettingsInDataset_name);
            __r = begin_setOriginalSettingsInDataset(dataSetId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setOriginalSettingsInDataset_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setOriginalSettingsInImage_name = "setOriginalSettingsInImage";

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param imageId The Id of the Image.
     * @throws ValidationException if the image qualified by
     * <code>imageId</code> is unlocatable.
     **/
    public void setOriginalSettingsInImage(long imageId)
        throws omero.ServerError
    {
        setOriginalSettingsInImage(imageId, null, false);
    }

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param imageId The Id of the Image.
     * @throws ValidationException if the image qualified by
     * <code>imageId</code> is unlocatable.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setOriginalSettingsInImage(long imageId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setOriginalSettingsInImage(imageId, __ctx, true);
    }

    private void setOriginalSettingsInImage(long imageId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setOriginalSettingsInImage", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setOriginalSettingsInImage");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    __del.setOriginalSettingsInImage(imageId, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInImage(long imageId)
    {
        return begin_setOriginalSettingsInImage(imageId, null, false, null);
    }

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInImage(long imageId, java.util.Map<String, String> __ctx)
    {
        return begin_setOriginalSettingsInImage(imageId, __ctx, true, null);
    }

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInImage(long imageId, Ice.Callback __cb)
    {
        return begin_setOriginalSettingsInImage(imageId, null, false, __cb);
    }

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInImage(long imageId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setOriginalSettingsInImage(imageId, __ctx, true, __cb);
    }

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInImage(long imageId, Callback_IRenderingSettings_setOriginalSettingsInImage __cb)
    {
        return begin_setOriginalSettingsInImage(imageId, null, false, __cb);
    }

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInImage(long imageId, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_setOriginalSettingsInImage __cb)
    {
        return begin_setOriginalSettingsInImage(imageId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setOriginalSettingsInImage(long imageId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setOriginalSettingsInImage_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setOriginalSettingsInImage_name, __cb);
        try
        {
            __result.__prepare(__setOriginalSettingsInImage_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(imageId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setOriginalSettingsInImage(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setOriginalSettingsInImage_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     **/
    public boolean setOriginalSettingsInImage_async(AMI_IRenderingSettings_setOriginalSettingsInImage __cb, long imageId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setOriginalSettingsInImage_name);
            __r = begin_setOriginalSettingsInImage(imageId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setOriginalSettingsInImage_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Resets an image's default rendering settings back to
     * channel global minimum and maximum.
     * 
     * @param __cb The callback object for the operation.
     * @param imageId The Id of the Image.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setOriginalSettingsInImage_async(AMI_IRenderingSettings_setOriginalSettingsInImage __cb, long imageId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setOriginalSettingsInImage_name);
            __r = begin_setOriginalSettingsInImage(imageId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setOriginalSettingsInImage_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setOriginalSettingsInSet_name = "setOriginalSettingsInSet";

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param type The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> setOriginalSettingsInSet(String type, java.util.List<Long> nodeIds)
        throws omero.ServerError
    {
        return setOriginalSettingsInSet(type, nodeIds, null, false);
    }

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param type The type of nodes to handle.
     * @param nodeIds Ids of the node type.
     * @param __ctx The Context map to send with the invocation.
     * @return A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     * @throws ValidationException if an illegal <code>type</code>
     * is used.
     **/
    public java.util.List<Long> setOriginalSettingsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return setOriginalSettingsInSet(type, nodeIds, __ctx, true);
    }

    private java.util.List<Long> setOriginalSettingsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setOriginalSettingsInSet", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setOriginalSettingsInSet");
                    __delBase = __getDelegate(false);
                    _IRenderingSettingsDel __del = (_IRenderingSettingsDel)__delBase;
                    return __del.setOriginalSettingsInSet(type, nodeIds, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInSet(String type, java.util.List<Long> nodeIds)
    {
        return begin_setOriginalSettingsInSet(type, nodeIds, null, false, null);
    }

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
    {
        return begin_setOriginalSettingsInSet(type, nodeIds, __ctx, true, null);
    }

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInSet(String type, java.util.List<Long> nodeIds, Ice.Callback __cb)
    {
        return begin_setOriginalSettingsInSet(type, nodeIds, null, false, __cb);
    }

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setOriginalSettingsInSet(type, nodeIds, __ctx, true, __cb);
    }

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInSet(String type, java.util.List<Long> nodeIds, Callback_IRenderingSettings_setOriginalSettingsInSet __cb)
    {
        return begin_setOriginalSettingsInSet(type, nodeIds, null, false, __cb);
    }

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setOriginalSettingsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, Callback_IRenderingSettings_setOriginalSettingsInSet __cb)
    {
        return begin_setOriginalSettingsInSet(type, nodeIds, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setOriginalSettingsInSet(String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setOriginalSettingsInSet_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setOriginalSettingsInSet_name, __cb);
        try
        {
            __result.__prepare(__setOriginalSettingsInSet_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(type);
            omero.sys.LongListHelper.write(__os, nodeIds);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) A {@link omero.sys.LongList} of image IDs that have
     * had their rendering settings reset.
     **/
    public java.util.List<Long> end_setOriginalSettingsInSet(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setOriginalSettingsInSet_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<Long> __ret;
            __ret = omero.sys.LongListHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     **/
    public boolean setOriginalSettingsInSet_async(AMI_IRenderingSettings_setOriginalSettingsInSet __cb, String type, java.util.List<Long> nodeIds)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setOriginalSettingsInSet_name);
            __r = begin_setOriginalSettingsInSet(type, nodeIds, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setOriginalSettingsInSet_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Resets a rendering settings back to channel global minimum
     * and maximum for the specified containers. Supported
     * container types are:
     * <ul>
     * <li>{@link omero.model.Project}</li>
     * <li>{@link omero.model.Dataset}</li>
     * <li>{@link omero.model.Image}</li>
     * <li>{@link omero.model.Plate}</li>
     * <li>{@link omero.model.Pixels}</li>
     * </ul>
     * 
     * @param __cb The callback object for the operation.
     * @param type The type of nodes to handle.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setOriginalSettingsInSet_async(AMI_IRenderingSettings_setOriginalSettingsInSet __cb, String type, java.util.List<Long> nodeIds, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setOriginalSettingsInSet_name);
            __r = begin_setOriginalSettingsInSet(type, nodeIds, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setOriginalSettingsInSet_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static IRenderingSettingsPrx checkedCast(Ice.ObjectPrx __obj)
    {
        IRenderingSettingsPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IRenderingSettingsPrx)
            {
                __d = (IRenderingSettingsPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    IRenderingSettingsPrxHelper __h = new IRenderingSettingsPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static IRenderingSettingsPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        IRenderingSettingsPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IRenderingSettingsPrx)
            {
                __d = (IRenderingSettingsPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    IRenderingSettingsPrxHelper __h = new IRenderingSettingsPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static IRenderingSettingsPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        IRenderingSettingsPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    IRenderingSettingsPrxHelper __h = new IRenderingSettingsPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static IRenderingSettingsPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        IRenderingSettingsPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    IRenderingSettingsPrxHelper __h = new IRenderingSettingsPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static IRenderingSettingsPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        IRenderingSettingsPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof IRenderingSettingsPrx)
            {
                __d = (IRenderingSettingsPrx)__obj;
            }
            else
            {
                IRenderingSettingsPrxHelper __h = new IRenderingSettingsPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static IRenderingSettingsPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        IRenderingSettingsPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            IRenderingSettingsPrxHelper __h = new IRenderingSettingsPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IRenderingSettings",
        "::omero::api::ServiceInterface"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _IRenderingSettingsDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _IRenderingSettingsDelD();
    }

    public static void __write(IceInternal.BasicStream __os, IRenderingSettingsPrx v)
    {
        __os.writeProxy(v);
    }

    public static IRenderingSettingsPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            IRenderingSettingsPrxHelper result = new IRenderingSettingsPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
