// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `IShare.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides method for sharing - collaboration process for images,
 * datasets, projects.
 **/
public final class ISharePrxHelper extends Ice.ObjectPrxHelperBase implements ISharePrx
{
    private static final String __activate_name = "activate";

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     **/
    public void activate(long shareId)
        throws omero.ServerError
    {
        activate(shareId, null, false);
    }

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void activate(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        activate(shareId, __ctx, true);
    }

    private void activate(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "activate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("activate");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.activate(shareId, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate(long shareId)
    {
        return begin_activate(shareId, null, false, null);
    }

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(long shareId, java.util.Map<String, String> __ctx)
    {
        return begin_activate(shareId, __ctx, true, null);
    }

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate(long shareId, Ice.Callback __cb)
    {
        return begin_activate(shareId, null, false, __cb);
    }

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_activate(shareId, __ctx, true, __cb);
    }

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate(long shareId, Callback_IShare_activate __cb)
    {
        return begin_activate(shareId, null, false, __cb);
    }

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_activate __cb)
    {
        return begin_activate(shareId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_activate(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__activate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
        try
        {
            __result.__prepare(__activate_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_activate(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __activate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __cb The callback object for the operation.
     **/
    public boolean activate_async(AMI_IShare_activate __cb, long shareId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__activate_name);
            __r = begin_activate(shareId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Turns on the access control lists attached to the given
     * share for the current session. Warning: this will slow down
     * the execution of the current session for all database
     * reads. Writing to the database will not be allowed. If
     * share does not exist or is not accessible (non-members) or
     * is disabled, then an {@link ValidationException} is thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean activate_async(AMI_IShare_activate __cb, long shareId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__activate_name);
            __r = begin_activate(shareId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __addComment_name = "addComment";

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     **/
    public omero.model.TextAnnotation addComment(long shareId, String comment)
        throws omero.ServerError
    {
        return addComment(shareId, comment, null, false);
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.TextAnnotation addComment(long shareId, String comment, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return addComment(shareId, comment, __ctx, true);
    }

    private omero.model.TextAnnotation addComment(long shareId, String comment, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "addComment", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("addComment");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.addComment(shareId, comment, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addComment(long shareId, String comment)
    {
        return begin_addComment(shareId, comment, null, false, null);
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addComment(long shareId, String comment, java.util.Map<String, String> __ctx)
    {
        return begin_addComment(shareId, comment, __ctx, true, null);
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addComment(long shareId, String comment, Ice.Callback __cb)
    {
        return begin_addComment(shareId, comment, null, false, __cb);
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addComment(long shareId, String comment, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_addComment(shareId, comment, __ctx, true, __cb);
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addComment(long shareId, String comment, Callback_IShare_addComment __cb)
    {
        return begin_addComment(shareId, comment, null, false, __cb);
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addComment(long shareId, String comment, java.util.Map<String, String> __ctx, Callback_IShare_addComment __cb)
    {
        return begin_addComment(shareId, comment, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_addComment(long shareId, String comment, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__addComment_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __addComment_name, __cb);
        try
        {
            __result.__prepare(__addComment_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __os.writeString(comment);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.model.TextAnnotation end_addComment(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __addComment_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.TextAnnotationHolder __ret = new omero.model.TextAnnotationHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public boolean addComment_async(AMI_IShare_addComment __cb, long shareId, String comment)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addComment_name);
            __r = begin_addComment(shareId, comment, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addComment_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment for
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addComment_async(AMI_IShare_addComment __cb, long shareId, String comment, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addComment_name);
            __r = begin_addComment(shareId, comment, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addComment_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __addGuest_name = "addGuest";

    /**
     * Adds guest email address to the share.
     **/
    public void addGuest(long shareId, String emailAddress)
        throws omero.ServerError
    {
        addGuest(shareId, emailAddress, null, false);
    }

    /**
     * Adds guest email address to the share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        addGuest(shareId, emailAddress, __ctx, true);
    }

    private void addGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "addGuest", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("addGuest");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.addGuest(shareId, emailAddress, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Adds guest email address to the share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addGuest(long shareId, String emailAddress)
    {
        return begin_addGuest(shareId, emailAddress, null, false, null);
    }

    /**
     * Adds guest email address to the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx)
    {
        return begin_addGuest(shareId, emailAddress, __ctx, true, null);
    }

    /**
     * Adds guest email address to the share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addGuest(long shareId, String emailAddress, Ice.Callback __cb)
    {
        return begin_addGuest(shareId, emailAddress, null, false, __cb);
    }

    /**
     * Adds guest email address to the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_addGuest(shareId, emailAddress, __ctx, true, __cb);
    }

    /**
     * Adds guest email address to the share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addGuest(long shareId, String emailAddress, Callback_IShare_addGuest __cb)
    {
        return begin_addGuest(shareId, emailAddress, null, false, __cb);
    }

    /**
     * Adds guest email address to the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx, Callback_IShare_addGuest __cb)
    {
        return begin_addGuest(shareId, emailAddress, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_addGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__addGuest_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __addGuest_name, __cb);
        try
        {
            __result.__prepare(__addGuest_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __os.writeString(emailAddress);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_addGuest(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __addGuest_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Adds guest email address to the share.
     * @param __cb The callback object for the operation.
     **/
    public boolean addGuest_async(AMI_IShare_addGuest __cb, long shareId, String emailAddress)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addGuest_name);
            __r = begin_addGuest(shareId, emailAddress, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addGuest_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Adds guest email address to the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addGuest_async(AMI_IShare_addGuest __cb, long shareId, String emailAddress, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addGuest_name);
            __r = begin_addGuest(shareId, emailAddress, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addGuest_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __addGuests_name = "addGuests";

    /**
     * Adds guest email addresses to the share.
     **/
    public void addGuests(long shareId, java.util.List<String> emailAddresses)
        throws omero.ServerError
    {
        addGuests(shareId, emailAddresses, null, false);
    }

    /**
     * Adds guest email addresses to the share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        addGuests(shareId, emailAddresses, __ctx, true);
    }

    private void addGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "addGuests", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("addGuests");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.addGuests(shareId, emailAddresses, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Adds guest email addresses to the share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addGuests(long shareId, java.util.List<String> emailAddresses)
    {
        return begin_addGuests(shareId, emailAddresses, null, false, null);
    }

    /**
     * Adds guest email addresses to the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx)
    {
        return begin_addGuests(shareId, emailAddresses, __ctx, true, null);
    }

    /**
     * Adds guest email addresses to the share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addGuests(long shareId, java.util.List<String> emailAddresses, Ice.Callback __cb)
    {
        return begin_addGuests(shareId, emailAddresses, null, false, __cb);
    }

    /**
     * Adds guest email addresses to the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_addGuests(shareId, emailAddresses, __ctx, true, __cb);
    }

    /**
     * Adds guest email addresses to the share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addGuests(long shareId, java.util.List<String> emailAddresses, Callback_IShare_addGuests __cb)
    {
        return begin_addGuests(shareId, emailAddresses, null, false, __cb);
    }

    /**
     * Adds guest email addresses to the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx, Callback_IShare_addGuests __cb)
    {
        return begin_addGuests(shareId, emailAddresses, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_addGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__addGuests_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __addGuests_name, __cb);
        try
        {
            __result.__prepare(__addGuests_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            StringSetHelper.write(__os, emailAddresses);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_addGuests(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __addGuests_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Adds guest email addresses to the share.
     * @param __cb The callback object for the operation.
     **/
    public boolean addGuests_async(AMI_IShare_addGuests __cb, long shareId, java.util.List<String> emailAddresses)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addGuests_name);
            __r = begin_addGuests(shareId, emailAddresses, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addGuests_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Adds guest email addresses to the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addGuests_async(AMI_IShare_addGuests __cb, long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addGuests_name);
            __r = begin_addGuests(shareId, emailAddresses, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addGuests_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __addObject_name = "addObject";

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     **/
    public void addObject(long shareId, omero.model.IObject iobject)
        throws omero.ServerError
    {
        addObject(shareId, iobject, null, false);
    }

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        addObject(shareId, iobject, __ctx, true);
    }

    private void addObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "addObject", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("addObject");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.addObject(shareId, iobject, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addObject(long shareId, omero.model.IObject iobject)
    {
        return begin_addObject(shareId, iobject, null, false, null);
    }

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx)
    {
        return begin_addObject(shareId, iobject, __ctx, true, null);
    }

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addObject(long shareId, omero.model.IObject iobject, Ice.Callback __cb)
    {
        return begin_addObject(shareId, iobject, null, false, __cb);
    }

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_addObject(shareId, iobject, __ctx, true, __cb);
    }

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addObject(long shareId, omero.model.IObject iobject, Callback_IShare_addObject __cb)
    {
        return begin_addObject(shareId, iobject, null, false, __cb);
    }

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx, Callback_IShare_addObject __cb)
    {
        return begin_addObject(shareId, iobject, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_addObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__addObject_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __addObject_name, __cb);
        try
        {
            __result.__prepare(__addObject_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __os.writeObject(iobject);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_addObject(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __addObject_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __cb The callback object for the operation.
     **/
    public boolean addObject_async(AMI_IShare_addObject __cb, long shareId, omero.model.IObject iobject)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addObject_name);
            __r = begin_addObject(shareId, iobject, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addObject_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Adds new {@link omero.model.IObject} item to
     * {@link omero.model.Session} share. The entire object graph
     * with the exception of all Details will be loaded into the
     * share. If you would like to load a single object, then pass
     * an unloaded reference.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addObject_async(AMI_IShare_addObject __cb, long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addObject_name);
            __r = begin_addObject(shareId, iobject, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addObject_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __addObjects_name = "addObjects";

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     **/
    public void addObjects(long shareId, java.util.List<omero.model.IObject> iobjects)
        throws omero.ServerError
    {
        addObjects(shareId, iobjects, null, false);
    }

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        addObjects(shareId, iobjects, __ctx, true);
    }

    private void addObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "addObjects", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("addObjects");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.addObjects(shareId, iobjects, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addObjects(long shareId, java.util.List<omero.model.IObject> iobjects)
    {
        return begin_addObjects(shareId, iobjects, null, false, null);
    }

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx)
    {
        return begin_addObjects(shareId, iobjects, __ctx, true, null);
    }

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addObjects(long shareId, java.util.List<omero.model.IObject> iobjects, Ice.Callback __cb)
    {
        return begin_addObjects(shareId, iobjects, null, false, __cb);
    }

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_addObjects(shareId, iobjects, __ctx, true, __cb);
    }

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addObjects(long shareId, java.util.List<omero.model.IObject> iobjects, Callback_IShare_addObjects __cb)
    {
        return begin_addObjects(shareId, iobjects, null, false, __cb);
    }

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx, Callback_IShare_addObjects __cb)
    {
        return begin_addObjects(shareId, iobjects, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_addObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__addObjects_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __addObjects_name, __cb);
        try
        {
            __result.__prepare(__addObjects_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            IObjectListHelper.write(__os, iobjects);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_addObjects(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __addObjects_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __cb The callback object for the operation.
     **/
    public boolean addObjects_async(AMI_IShare_addObjects __cb, long shareId, java.util.List<omero.model.IObject> iobjects)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addObjects_name);
            __r = begin_addObjects(shareId, iobjects, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addObjects_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Adds new {@link omero.model.IObject} items to
     * {@link omero.model.Session} share. Conceptually calls
     * {@link #addObjects} for every argument passed, but the
     * graphs will be merged.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addObjects_async(AMI_IShare_addObjects __cb, long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addObjects_name);
            __r = begin_addObjects(shareId, iobjects, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addObjects_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __addReply_name = "addReply";

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @return the new {@link omero.model.TextAnnotation}
     **/
    public omero.model.TextAnnotation addReply(long shareId, String comment, omero.model.TextAnnotation replyTo)
        throws omero.ServerError
    {
        return addReply(shareId, comment, replyTo, null, false);
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return the new {@link omero.model.TextAnnotation}
     **/
    public omero.model.TextAnnotation addReply(long shareId, String comment, omero.model.TextAnnotation replyTo, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return addReply(shareId, comment, replyTo, __ctx, true);
    }

    private omero.model.TextAnnotation addReply(long shareId, String comment, omero.model.TextAnnotation replyTo, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "addReply", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("addReply");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.addReply(shareId, comment, replyTo, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addReply(long shareId, String comment, omero.model.TextAnnotation replyTo)
    {
        return begin_addReply(shareId, comment, replyTo, null, false, null);
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addReply(long shareId, String comment, omero.model.TextAnnotation replyTo, java.util.Map<String, String> __ctx)
    {
        return begin_addReply(shareId, comment, replyTo, __ctx, true, null);
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addReply(long shareId, String comment, omero.model.TextAnnotation replyTo, Ice.Callback __cb)
    {
        return begin_addReply(shareId, comment, replyTo, null, false, __cb);
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addReply(long shareId, String comment, omero.model.TextAnnotation replyTo, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_addReply(shareId, comment, replyTo, __ctx, true, __cb);
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addReply(long shareId, String comment, omero.model.TextAnnotation replyTo, Callback_IShare_addReply __cb)
    {
        return begin_addReply(shareId, comment, replyTo, null, false, __cb);
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addReply(long shareId, String comment, omero.model.TextAnnotation replyTo, java.util.Map<String, String> __ctx, Callback_IShare_addReply __cb)
    {
        return begin_addReply(shareId, comment, replyTo, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_addReply(long shareId, String comment, omero.model.TextAnnotation replyTo, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__addReply_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __addReply_name, __cb);
        try
        {
            __result.__prepare(__addReply_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __os.writeString(comment);
            __os.writeObject(replyTo);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) the new {@link omero.model.TextAnnotation}
     **/
    public omero.model.TextAnnotation end_addReply(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __addReply_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.TextAnnotationHolder __ret = new omero.model.TextAnnotationHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean addReply_async(AMI_IShare_addReply __cb, long shareId, String comment, omero.model.TextAnnotation replyTo)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addReply_name);
            __r = begin_addReply(shareId, comment, replyTo, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addReply_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Creates {@link omero.model.TextAnnotation} comment which
     * replies to an existing comment.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addReply_async(AMI_IShare_addReply __cb, long shareId, String comment, omero.model.TextAnnotation replyTo, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addReply_name);
            __r = begin_addReply(shareId, comment, replyTo, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addReply_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __addUser_name = "addUser";

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     **/
    public void addUser(long shareId, omero.model.Experimenter exp)
        throws omero.ServerError
    {
        addUser(shareId, exp, null, false);
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        addUser(shareId, exp, __ctx, true);
    }

    private void addUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "addUser", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("addUser");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.addUser(shareId, exp, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addUser(long shareId, omero.model.Experimenter exp)
    {
        return begin_addUser(shareId, exp, null, false, null);
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
    {
        return begin_addUser(shareId, exp, __ctx, true, null);
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addUser(long shareId, omero.model.Experimenter exp, Ice.Callback __cb)
    {
        return begin_addUser(shareId, exp, null, false, __cb);
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_addUser(shareId, exp, __ctx, true, __cb);
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addUser(long shareId, omero.model.Experimenter exp, Callback_IShare_addUser __cb)
    {
        return begin_addUser(shareId, exp, null, false, __cb);
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Callback_IShare_addUser __cb)
    {
        return begin_addUser(shareId, exp, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_addUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__addUser_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __addUser_name, __cb);
        try
        {
            __result.__prepare(__addUser_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __os.writeObject(exp);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_addUser(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __addUser_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public boolean addUser_async(AMI_IShare_addUser __cb, long shareId, omero.model.Experimenter exp)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addUser_name);
            __r = begin_addUser(shareId, exp, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addUser_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenter to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addUser_async(AMI_IShare_addUser __cb, long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addUser_name);
            __r = begin_addUser(shareId, exp, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addUser_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __addUsers_name = "addUsers";

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     **/
    public void addUsers(long shareId, java.util.List<omero.model.Experimenter> exps)
        throws omero.ServerError
    {
        addUsers(shareId, exps, null, false);
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        addUsers(shareId, exps, __ctx, true);
    }

    private void addUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "addUsers", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("addUsers");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.addUsers(shareId, exps, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addUsers(long shareId, java.util.List<omero.model.Experimenter> exps)
    {
        return begin_addUsers(shareId, exps, null, false, null);
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx)
    {
        return begin_addUsers(shareId, exps, __ctx, true, null);
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addUsers(long shareId, java.util.List<omero.model.Experimenter> exps, Ice.Callback __cb)
    {
        return begin_addUsers(shareId, exps, null, false, __cb);
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_addUsers(shareId, exps, __ctx, true, __cb);
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_addUsers(long shareId, java.util.List<omero.model.Experimenter> exps, Callback_IShare_addUsers __cb)
    {
        return begin_addUsers(shareId, exps, null, false, __cb);
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx, Callback_IShare_addUsers __cb)
    {
        return begin_addUsers(shareId, exps, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_addUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__addUsers_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __addUsers_name, __cb);
        try
        {
            __result.__prepare(__addUsers_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            ExperimenterListHelper.write(__os, exps);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_addUsers(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __addUsers_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public boolean addUsers_async(AMI_IShare_addUsers __cb, long shareId, java.util.List<omero.model.Experimenter> exps)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addUsers_name);
            __r = begin_addUsers(shareId, exps, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addUsers_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Adds {@link omero.model.Experimenter} experimenters to
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addUsers_async(AMI_IShare_addUsers __cb, long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addUsers_name);
            __r = begin_addUsers(shareId, exps, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addUsers_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __closeShare_name = "closeShare";

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     **/
    public void closeShare(long shareId)
        throws omero.ServerError
    {
        closeShare(shareId, null, false);
    }

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void closeShare(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        closeShare(shareId, __ctx, true);
    }

    private void closeShare(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "closeShare", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("closeShare");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.closeShare(shareId, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_closeShare(long shareId)
    {
        return begin_closeShare(shareId, null, false, null);
    }

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_closeShare(long shareId, java.util.Map<String, String> __ctx)
    {
        return begin_closeShare(shareId, __ctx, true, null);
    }

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_closeShare(long shareId, Ice.Callback __cb)
    {
        return begin_closeShare(shareId, null, false, __cb);
    }

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_closeShare(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_closeShare(shareId, __ctx, true, __cb);
    }

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_closeShare(long shareId, Callback_IShare_closeShare __cb)
    {
        return begin_closeShare(shareId, null, false, __cb);
    }

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_closeShare(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_closeShare __cb)
    {
        return begin_closeShare(shareId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_closeShare(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__closeShare_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __closeShare_name, __cb);
        try
        {
            __result.__prepare(__closeShare_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_closeShare(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __closeShare_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __cb The callback object for the operation.
     **/
    public boolean closeShare_async(AMI_IShare_closeShare __cb, long shareId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__closeShare_name);
            __r = begin_closeShare(shareId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __closeShare_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Closes {@link omero.model.Session} share. No further logins
     * will be possible and all getters (e.g.
     * {@link #getMemberShares}, {@link #getOwnShares}, ...) will
     * filter these results if {@code onlyActive} is true.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean closeShare_async(AMI_IShare_closeShare __cb, long shareId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__closeShare_name);
            __r = begin_closeShare(shareId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __closeShare_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __createShare_name = "createShare";

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     **/
    public long createShare(String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled)
        throws omero.ServerError
    {
        return createShare(description, expiration, items, exps, guests, enabled, null, false);
    }

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     * @param __ctx The Context map to send with the invocation.
     **/
    public long createShare(String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return createShare(description, expiration, items, exps, guests, enabled, __ctx, true);
    }

    private long createShare(String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "createShare", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("createShare");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.createShare(description, expiration, items, exps, guests, enabled, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param __cb The callback object for the operation.
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     **/
    public Ice.AsyncResult begin_createShare(String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled)
    {
        return begin_createShare(description, expiration, items, exps, guests, enabled, null, false, null);
    }

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param __cb The callback object for the operation.
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createShare(String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled, java.util.Map<String, String> __ctx)
    {
        return begin_createShare(description, expiration, items, exps, guests, enabled, __ctx, true, null);
    }

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param __cb The callback object for the operation.
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     **/
    public Ice.AsyncResult begin_createShare(String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled, Ice.Callback __cb)
    {
        return begin_createShare(description, expiration, items, exps, guests, enabled, null, false, __cb);
    }

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param __cb The callback object for the operation.
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createShare(String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_createShare(description, expiration, items, exps, guests, enabled, __ctx, true, __cb);
    }

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param __cb The callback object for the operation.
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     **/
    public Ice.AsyncResult begin_createShare(String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled, Callback_IShare_createShare __cb)
    {
        return begin_createShare(description, expiration, items, exps, guests, enabled, null, false, __cb);
    }

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param __cb The callback object for the operation.
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createShare(String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled, java.util.Map<String, String> __ctx, Callback_IShare_createShare __cb)
    {
        return begin_createShare(description, expiration, items, exps, guests, enabled, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_createShare(String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__createShare_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __createShare_name, __cb);
        try
        {
            __result.__prepare(__createShare_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(description);
            __os.writeObject(expiration);
            IObjectListHelper.write(__os, items);
            ExperimenterListHelper.write(__os, exps);
            StringSetHelper.write(__os, guests);
            __os.writeBool(enabled);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public long end_createShare(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __createShare_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param __cb The callback object for the operation.
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     **/
    public boolean createShare_async(AMI_IShare_createShare __cb, String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createShare_name);
            __r = begin_createShare(description, expiration, items, exps, guests, enabled, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createShare_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Creates {@link omero.model.Session} share with all related:
     * {@link omero.model.IObject} itmes,
     * {@link omero.model.Experimenter} members, and guests.
     * 
     * @param __cb The callback object for the operation.
     * @param enabled
     * if true, then the share is immediately available
     * for use. If false, then the share is in draft
     * state. All methods on this interface will work
     * for shares <em>except</em> {@link #activate}.
     * Similarly, the share password cannot be used by
     * guests to login.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createShare_async(AMI_IShare_createShare __cb, String description, omero.RTime expiration, java.util.List<omero.model.IObject> items, java.util.List<omero.model.Experimenter> exps, java.util.List<String> guests, boolean enabled, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createShare_name);
            __r = begin_createShare(description, expiration, items, exps, guests, enabled, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createShare_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __deactivate_name = "deactivate";

    /**
     * Turns off the access control lists with the current share.
     **/
    public void deactivate()
        throws omero.ServerError
    {
        deactivate(null, false);
    }

    /**
     * Turns off the access control lists with the current share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void deactivate(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        deactivate(__ctx, true);
    }

    private void deactivate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "deactivate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("deactivate");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.deactivate(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Turns off the access control lists with the current share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_deactivate()
    {
        return begin_deactivate(null, false, null);
    }

    /**
     * Turns off the access control lists with the current share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_deactivate(java.util.Map<String, String> __ctx)
    {
        return begin_deactivate(__ctx, true, null);
    }

    /**
     * Turns off the access control lists with the current share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_deactivate(Ice.Callback __cb)
    {
        return begin_deactivate(null, false, __cb);
    }

    /**
     * Turns off the access control lists with the current share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_deactivate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_deactivate(__ctx, true, __cb);
    }

    /**
     * Turns off the access control lists with the current share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_deactivate(Callback_IShare_deactivate __cb)
    {
        return begin_deactivate(null, false, __cb);
    }

    /**
     * Turns off the access control lists with the current share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_deactivate(java.util.Map<String, String> __ctx, Callback_IShare_deactivate __cb)
    {
        return begin_deactivate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_deactivate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__deactivate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __deactivate_name, __cb);
        try
        {
            __result.__prepare(__deactivate_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_deactivate(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __deactivate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Turns off the access control lists with the current share.
     * @param __cb The callback object for the operation.
     **/
    public boolean deactivate_async(AMI_IShare_deactivate __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__deactivate_name);
            __r = begin_deactivate(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __deactivate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Turns off the access control lists with the current share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean deactivate_async(AMI_IShare_deactivate __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__deactivate_name);
            __r = begin_deactivate(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __deactivate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __deleteComment_name = "deleteComment";

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     **/
    public void deleteComment(omero.model.Annotation comment)
        throws omero.ServerError
    {
        deleteComment(comment, null, false);
    }

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void deleteComment(omero.model.Annotation comment, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        deleteComment(comment, __ctx, true);
    }

    private void deleteComment(omero.model.Annotation comment, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "deleteComment", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("deleteComment");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.deleteComment(comment, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_deleteComment(omero.model.Annotation comment)
    {
        return begin_deleteComment(comment, null, false, null);
    }

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_deleteComment(omero.model.Annotation comment, java.util.Map<String, String> __ctx)
    {
        return begin_deleteComment(comment, __ctx, true, null);
    }

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_deleteComment(omero.model.Annotation comment, Ice.Callback __cb)
    {
        return begin_deleteComment(comment, null, false, __cb);
    }

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_deleteComment(omero.model.Annotation comment, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_deleteComment(comment, __ctx, true, __cb);
    }

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_deleteComment(omero.model.Annotation comment, Callback_IShare_deleteComment __cb)
    {
        return begin_deleteComment(comment, null, false, __cb);
    }

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_deleteComment(omero.model.Annotation comment, java.util.Map<String, String> __ctx, Callback_IShare_deleteComment __cb)
    {
        return begin_deleteComment(comment, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_deleteComment(omero.model.Annotation comment, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__deleteComment_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __deleteComment_name, __cb);
        try
        {
            __result.__prepare(__deleteComment_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(comment);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_deleteComment(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __deleteComment_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __cb The callback object for the operation.
     **/
    public boolean deleteComment_async(AMI_IShare_deleteComment __cb, omero.model.Annotation comment)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__deleteComment_name);
            __r = begin_deleteComment(comment, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __deleteComment_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Deletes {@link omero.model.Annotation} comment from the
     * database.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean deleteComment_async(AMI_IShare_deleteComment __cb, omero.model.Annotation comment, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__deleteComment_name);
            __r = begin_deleteComment(comment, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __deleteComment_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getActiveConnections_name = "getActiveConnections";

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @return map of experimenter and IP address
     **/
    public java.util.Map<java.lang.String, omero.model.Experimenter> getActiveConnections(long shareId)
        throws omero.ServerError
    {
        return getActiveConnections(shareId, null, false);
    }

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return map of experimenter and IP address
     **/
    public java.util.Map<java.lang.String, omero.model.Experimenter> getActiveConnections(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getActiveConnections(shareId, __ctx, true);
    }

    private java.util.Map<java.lang.String, omero.model.Experimenter> getActiveConnections(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getActiveConnections", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getActiveConnections");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.getActiveConnections(shareId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getActiveConnections(long shareId)
    {
        return begin_getActiveConnections(shareId, null, false, null);
    }

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getActiveConnections(long shareId, java.util.Map<String, String> __ctx)
    {
        return begin_getActiveConnections(shareId, __ctx, true, null);
    }

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getActiveConnections(long shareId, Ice.Callback __cb)
    {
        return begin_getActiveConnections(shareId, null, false, __cb);
    }

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getActiveConnections(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getActiveConnections(shareId, __ctx, true, __cb);
    }

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getActiveConnections(long shareId, Callback_IShare_getActiveConnections __cb)
    {
        return begin_getActiveConnections(shareId, null, false, __cb);
    }

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getActiveConnections(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getActiveConnections __cb)
    {
        return begin_getActiveConnections(shareId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getActiveConnections(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getActiveConnections_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getActiveConnections_name, __cb);
        try
        {
            __result.__prepare(__getActiveConnections_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) map of experimenter and IP address
     **/
    public java.util.Map<java.lang.String, omero.model.Experimenter> end_getActiveConnections(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getActiveConnections_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.String, omero.model.Experimenter> __ret;
            __ret = UserMapHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getActiveConnections_async(AMI_IShare_getActiveConnections __cb, long shareId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getActiveConnections_name);
            __r = begin_getActiveConnections(shareId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getActiveConnections_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Gets actual active connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getActiveConnections_async(AMI_IShare_getActiveConnections __cb, long shareId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getActiveConnections_name);
            __r = begin_getActiveConnections(shareId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getActiveConnections_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getAllGuests_name = "getAllGuests";

    /**
     * Get the email addresses for all share guests.
     **/
    public java.util.List<String> getAllGuests(long shareId)
        throws omero.ServerError
    {
        return getAllGuests(shareId, null, false);
    }

    /**
     * Get the email addresses for all share guests.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<String> getAllGuests(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getAllGuests(shareId, __ctx, true);
    }

    private java.util.List<String> getAllGuests(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getAllGuests", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getAllGuests");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.getAllGuests(shareId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Get the email addresses for all share guests.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getAllGuests(long shareId)
    {
        return begin_getAllGuests(shareId, null, false, null);
    }

    /**
     * Get the email addresses for all share guests.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getAllGuests(long shareId, java.util.Map<String, String> __ctx)
    {
        return begin_getAllGuests(shareId, __ctx, true, null);
    }

    /**
     * Get the email addresses for all share guests.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getAllGuests(long shareId, Ice.Callback __cb)
    {
        return begin_getAllGuests(shareId, null, false, __cb);
    }

    /**
     * Get the email addresses for all share guests.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getAllGuests(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getAllGuests(shareId, __ctx, true, __cb);
    }

    /**
     * Get the email addresses for all share guests.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getAllGuests(long shareId, Callback_IShare_getAllGuests __cb)
    {
        return begin_getAllGuests(shareId, null, false, __cb);
    }

    /**
     * Get the email addresses for all share guests.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getAllGuests(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getAllGuests __cb)
    {
        return begin_getAllGuests(shareId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getAllGuests(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getAllGuests_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getAllGuests_name, __cb);
        try
        {
            __result.__prepare(__getAllGuests_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.List<String> end_getAllGuests(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getAllGuests_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<String> __ret;
            __ret = StringSetHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Get the email addresses for all share guests.
     * @param __cb The callback object for the operation.
     **/
    public boolean getAllGuests_async(AMI_IShare_getAllGuests __cb, long shareId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getAllGuests_name);
            __r = begin_getAllGuests(shareId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getAllGuests_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Get the email addresses for all share guests.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getAllGuests_async(AMI_IShare_getAllGuests __cb, long shareId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getAllGuests_name);
            __r = begin_getAllGuests(shareId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getAllGuests_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getAllMembers_name = "getAllMembers";

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     **/
    public java.util.List<omero.model.Experimenter> getAllMembers(long shareId)
        throws omero.ServerError
    {
        return getAllMembers(shareId, null, false);
    }

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.Experimenter> getAllMembers(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getAllMembers(shareId, __ctx, true);
    }

    private java.util.List<omero.model.Experimenter> getAllMembers(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getAllMembers", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getAllMembers");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.getAllMembers(shareId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getAllMembers(long shareId)
    {
        return begin_getAllMembers(shareId, null, false, null);
    }

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getAllMembers(long shareId, java.util.Map<String, String> __ctx)
    {
        return begin_getAllMembers(shareId, __ctx, true, null);
    }

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getAllMembers(long shareId, Ice.Callback __cb)
    {
        return begin_getAllMembers(shareId, null, false, __cb);
    }

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getAllMembers(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getAllMembers(shareId, __ctx, true, __cb);
    }

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getAllMembers(long shareId, Callback_IShare_getAllMembers __cb)
    {
        return begin_getAllMembers(shareId, null, false, __cb);
    }

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getAllMembers(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getAllMembers __cb)
    {
        return begin_getAllMembers(shareId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getAllMembers(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getAllMembers_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getAllMembers_name, __cb);
        try
        {
            __result.__prepare(__getAllMembers_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.List<omero.model.Experimenter> end_getAllMembers(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getAllMembers_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.Experimenter> __ret;
            __ret = ExperimenterListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __cb The callback object for the operation.
     **/
    public boolean getAllMembers_async(AMI_IShare_getAllMembers __cb, long shareId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getAllMembers_name);
            __r = begin_getAllMembers(shareId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getAllMembers_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Get all {@link omero.model.Experimenter} users who are a
     * member of the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getAllMembers_async(AMI_IShare_getAllMembers __cb, long shareId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getAllMembers_name);
            __r = begin_getAllMembers(shareId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getAllMembers_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getAllUsers_name = "getAllUsers";

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param shareId
     * @return a {@link StringSet} containing the login of all
     * users
     * @throws ValidationException
     * if there is a conflict between email addresses and
     * user names.
     **/
    public java.util.List<String> getAllUsers(long shareId)
        throws omero.ServerError,
               omero.ValidationException
    {
        return getAllUsers(shareId, null, false);
    }

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param shareId
     * @param __ctx The Context map to send with the invocation.
     * @return a {@link StringSet} containing the login of all
     * users
     * @throws ValidationException
     * if there is a conflict between email addresses and
     * user names.
     **/
    public java.util.List<String> getAllUsers(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError,
               omero.ValidationException
    {
        return getAllUsers(shareId, __ctx, true);
    }

    private java.util.List<String> getAllUsers(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError,
               omero.ValidationException
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getAllUsers", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getAllUsers");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.getAllUsers(shareId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param __cb The callback object for the operation.
     * @param shareId
     **/
    public Ice.AsyncResult begin_getAllUsers(long shareId)
    {
        return begin_getAllUsers(shareId, null, false, null);
    }

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param __cb The callback object for the operation.
     * @param shareId
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getAllUsers(long shareId, java.util.Map<String, String> __ctx)
    {
        return begin_getAllUsers(shareId, __ctx, true, null);
    }

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param __cb The callback object for the operation.
     * @param shareId
     **/
    public Ice.AsyncResult begin_getAllUsers(long shareId, Ice.Callback __cb)
    {
        return begin_getAllUsers(shareId, null, false, __cb);
    }

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param __cb The callback object for the operation.
     * @param shareId
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getAllUsers(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getAllUsers(shareId, __ctx, true, __cb);
    }

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param __cb The callback object for the operation.
     * @param shareId
     **/
    public Ice.AsyncResult begin_getAllUsers(long shareId, Callback_IShare_getAllUsers __cb)
    {
        return begin_getAllUsers(shareId, null, false, __cb);
    }

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param __cb The callback object for the operation.
     * @param shareId
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getAllUsers(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getAllUsers __cb)
    {
        return begin_getAllUsers(shareId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getAllUsers(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getAllUsers_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getAllUsers_name, __cb);
        try
        {
            __result.__prepare(__getAllUsers_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a {@link StringSet} containing the login of all
     * users
     **/
    public java.util.List<String> end_getAllUsers(Ice.AsyncResult __result)
        throws omero.ServerError,
               omero.ValidationException
    {
        Ice.AsyncResult.__check(__result, this, __getAllUsers_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ValidationException __ex)
                {
                    throw __ex;
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<String> __ret;
            __ret = StringSetHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param __cb The callback object for the operation.
     * @param shareId
     **/
    public boolean getAllUsers_async(AMI_IShare_getAllUsers __cb, long shareId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getAllUsers_name);
            __r = begin_getAllUsers(shareId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getAllUsers_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Get a single set containing the
     * {@link omero.model.Experimenter#getOmeName} login names
     * of the users as well email addresses for guests.
     * 
     * @param __cb The callback object for the operation.
     * @param shareId
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getAllUsers_async(AMI_IShare_getAllUsers __cb, long shareId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getAllUsers_name);
            __r = begin_getAllUsers(shareId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getAllUsers_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getCommentCount_name = "getCommentCount";

    /**
     * Returns a map from share id to comment count.
     * 
     * @param shareIds Not null.
     * @return Map with all ids present and 0 if no count exists.
     * @throws ValidationException if a given share does not exist
     **/
    public java.util.Map<Long,Long> getCommentCount(java.util.List<Long> shareIds)
        throws omero.ServerError
    {
        return getCommentCount(shareIds, null, false);
    }

    /**
     * Returns a map from share id to comment count.
     * 
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return Map with all ids present and 0 if no count exists.
     * @throws ValidationException if a given share does not exist
     **/
    public java.util.Map<Long,Long> getCommentCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getCommentCount(shareIds, __ctx, true);
    }

    private java.util.Map<Long,Long> getCommentCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getCommentCount", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getCommentCount");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.getCommentCount(shareIds, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns a map from share id to comment count.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     **/
    public Ice.AsyncResult begin_getCommentCount(java.util.List<Long> shareIds)
    {
        return begin_getCommentCount(shareIds, null, false, null);
    }

    /**
     * Returns a map from share id to comment count.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCommentCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx)
    {
        return begin_getCommentCount(shareIds, __ctx, true, null);
    }

    /**
     * Returns a map from share id to comment count.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     **/
    public Ice.AsyncResult begin_getCommentCount(java.util.List<Long> shareIds, Ice.Callback __cb)
    {
        return begin_getCommentCount(shareIds, null, false, __cb);
    }

    /**
     * Returns a map from share id to comment count.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCommentCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getCommentCount(shareIds, __ctx, true, __cb);
    }

    /**
     * Returns a map from share id to comment count.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     **/
    public Ice.AsyncResult begin_getCommentCount(java.util.List<Long> shareIds, Callback_IShare_getCommentCount __cb)
    {
        return begin_getCommentCount(shareIds, null, false, __cb);
    }

    /**
     * Returns a map from share id to comment count.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCommentCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx, Callback_IShare_getCommentCount __cb)
    {
        return begin_getCommentCount(shareIds, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getCommentCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getCommentCount_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getCommentCount_name, __cb);
        try
        {
            __result.__prepare(__getCommentCount_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.sys.LongListHelper.write(__os, shareIds);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Map with all ids present and 0 if no count exists.
     **/
    public java.util.Map<Long,Long> end_getCommentCount(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getCommentCount_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<Long,Long> __ret;
            __ret = omero.sys.CountMapHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns a map from share id to comment count.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     **/
    public boolean getCommentCount_async(AMI_IShare_getCommentCount __cb, java.util.List<Long> shareIds)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCommentCount_name);
            __r = begin_getCommentCount(shareIds, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCommentCount_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns a map from share id to comment count.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getCommentCount_async(AMI_IShare_getCommentCount __cb, java.util.List<Long> shareIds, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCommentCount_name);
            __r = begin_getCommentCount(shareIds, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCommentCount_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getComments_name = "getComments";

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @return list of Annotation
     **/
    public java.util.List<omero.model.Annotation> getComments(long shareId)
        throws omero.ServerError
    {
        return getComments(shareId, null, false);
    }

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return list of Annotation
     **/
    public java.util.List<omero.model.Annotation> getComments(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getComments(shareId, __ctx, true);
    }

    private java.util.List<omero.model.Annotation> getComments(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getComments", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getComments");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.getComments(shareId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getComments(long shareId)
    {
        return begin_getComments(shareId, null, false, null);
    }

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getComments(long shareId, java.util.Map<String, String> __ctx)
    {
        return begin_getComments(shareId, __ctx, true, null);
    }

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getComments(long shareId, Ice.Callback __cb)
    {
        return begin_getComments(shareId, null, false, __cb);
    }

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getComments(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getComments(shareId, __ctx, true, __cb);
    }

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getComments(long shareId, Callback_IShare_getComments __cb)
    {
        return begin_getComments(shareId, null, false, __cb);
    }

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getComments(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getComments __cb)
    {
        return begin_getComments(shareId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getComments(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getComments_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getComments_name, __cb);
        try
        {
            __result.__prepare(__getComments_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) list of Annotation
     **/
    public java.util.List<omero.model.Annotation> end_getComments(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getComments_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.Annotation> __ret;
            __ret = AnnotationListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getComments_async(AMI_IShare_getComments __cb, long shareId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getComments_name);
            __r = begin_getComments(shareId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getComments_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Looks up all {@link omero.model.Annotation} comments which
     * belong to the {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getComments_async(AMI_IShare_getComments __cb, long shareId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getComments_name);
            __r = begin_getComments(shareId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getComments_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getContentMap_name = "getContentMap";

    /**
     * Returns the contents of the share keyed by type.
     **/
    public java.util.Map<java.lang.String, long[]> getContentMap(long shareId)
        throws omero.ServerError
    {
        return getContentMap(shareId, null, false);
    }

    /**
     * Returns the contents of the share keyed by type.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.Map<java.lang.String, long[]> getContentMap(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getContentMap(shareId, __ctx, true);
    }

    private java.util.Map<java.lang.String, long[]> getContentMap(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getContentMap", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getContentMap");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.getContentMap(shareId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the contents of the share keyed by type.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getContentMap(long shareId)
    {
        return begin_getContentMap(shareId, null, false, null);
    }

    /**
     * Returns the contents of the share keyed by type.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getContentMap(long shareId, java.util.Map<String, String> __ctx)
    {
        return begin_getContentMap(shareId, __ctx, true, null);
    }

    /**
     * Returns the contents of the share keyed by type.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getContentMap(long shareId, Ice.Callback __cb)
    {
        return begin_getContentMap(shareId, null, false, __cb);
    }

    /**
     * Returns the contents of the share keyed by type.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getContentMap(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getContentMap(shareId, __ctx, true, __cb);
    }

    /**
     * Returns the contents of the share keyed by type.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getContentMap(long shareId, Callback_IShare_getContentMap __cb)
    {
        return begin_getContentMap(shareId, null, false, __cb);
    }

    /**
     * Returns the contents of the share keyed by type.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getContentMap(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getContentMap __cb)
    {
        return begin_getContentMap(shareId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getContentMap(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getContentMap_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getContentMap_name, __cb);
        try
        {
            __result.__prepare(__getContentMap_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.Map<java.lang.String, long[]> end_getContentMap(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getContentMap_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.String, long[]> __ret;
            __ret = IdListMapHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the contents of the share keyed by type.
     * @param __cb The callback object for the operation.
     **/
    public boolean getContentMap_async(AMI_IShare_getContentMap __cb, long shareId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getContentMap_name);
            __r = begin_getContentMap(shareId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getContentMap_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the contents of the share keyed by type.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getContentMap_async(AMI_IShare_getContentMap __cb, long shareId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getContentMap_name);
            __r = begin_getContentMap(shareId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getContentMap_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getContentSize_name = "getContentSize";

    /**
     * Returns the number of items in the share.
     **/
    public int getContentSize(long shareId)
        throws omero.ServerError
    {
        return getContentSize(shareId, null, false);
    }

    /**
     * Returns the number of items in the share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public int getContentSize(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getContentSize(shareId, __ctx, true);
    }

    private int getContentSize(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getContentSize", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getContentSize");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.getContentSize(shareId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the number of items in the share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getContentSize(long shareId)
    {
        return begin_getContentSize(shareId, null, false, null);
    }

    /**
     * Returns the number of items in the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getContentSize(long shareId, java.util.Map<String, String> __ctx)
    {
        return begin_getContentSize(shareId, __ctx, true, null);
    }

    /**
     * Returns the number of items in the share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getContentSize(long shareId, Ice.Callback __cb)
    {
        return begin_getContentSize(shareId, null, false, __cb);
    }

    /**
     * Returns the number of items in the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getContentSize(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getContentSize(shareId, __ctx, true, __cb);
    }

    /**
     * Returns the number of items in the share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getContentSize(long shareId, Callback_IShare_getContentSize __cb)
    {
        return begin_getContentSize(shareId, null, false, __cb);
    }

    /**
     * Returns the number of items in the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getContentSize(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getContentSize __cb)
    {
        return begin_getContentSize(shareId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getContentSize(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getContentSize_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getContentSize_name, __cb);
        try
        {
            __result.__prepare(__getContentSize_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public int end_getContentSize(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getContentSize_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int __ret;
            __ret = __is.readInt();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the number of items in the share.
     * @param __cb The callback object for the operation.
     **/
    public boolean getContentSize_async(AMI_IShare_getContentSize __cb, long shareId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getContentSize_name);
            __r = begin_getContentSize(shareId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getContentSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the number of items in the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getContentSize_async(AMI_IShare_getContentSize __cb, long shareId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getContentSize_name);
            __r = begin_getContentSize(shareId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getContentSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getContentSubList_name = "getContentSubList";

    /**
     * Returns a range of items from the share.
     * 
     * @see #getContents
     **/
    public java.util.List<omero.model.IObject> getContentSubList(long shareId, int start, int finish)
        throws omero.ServerError
    {
        return getContentSubList(shareId, start, finish, null, false);
    }

    /**
     * Returns a range of items from the share.
     * 
     * @see #getContents
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.IObject> getContentSubList(long shareId, int start, int finish, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getContentSubList(shareId, start, finish, __ctx, true);
    }

    private java.util.List<omero.model.IObject> getContentSubList(long shareId, int start, int finish, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getContentSubList", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getContentSubList");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.getContentSubList(shareId, start, finish, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns a range of items from the share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getContentSubList(long shareId, int start, int finish)
    {
        return begin_getContentSubList(shareId, start, finish, null, false, null);
    }

    /**
     * Returns a range of items from the share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getContentSubList(long shareId, int start, int finish, java.util.Map<String, String> __ctx)
    {
        return begin_getContentSubList(shareId, start, finish, __ctx, true, null);
    }

    /**
     * Returns a range of items from the share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getContentSubList(long shareId, int start, int finish, Ice.Callback __cb)
    {
        return begin_getContentSubList(shareId, start, finish, null, false, __cb);
    }

    /**
     * Returns a range of items from the share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getContentSubList(long shareId, int start, int finish, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getContentSubList(shareId, start, finish, __ctx, true, __cb);
    }

    /**
     * Returns a range of items from the share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getContentSubList(long shareId, int start, int finish, Callback_IShare_getContentSubList __cb)
    {
        return begin_getContentSubList(shareId, start, finish, null, false, __cb);
    }

    /**
     * Returns a range of items from the share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getContentSubList(long shareId, int start, int finish, java.util.Map<String, String> __ctx, Callback_IShare_getContentSubList __cb)
    {
        return begin_getContentSubList(shareId, start, finish, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getContentSubList(long shareId, int start, int finish, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getContentSubList_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getContentSubList_name, __cb);
        try
        {
            __result.__prepare(__getContentSubList_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __os.writeInt(start);
            __os.writeInt(finish);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.List<omero.model.IObject> end_getContentSubList(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getContentSubList_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.IObject> __ret;
            __ret = IObjectListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns a range of items from the share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getContentSubList_async(AMI_IShare_getContentSubList __cb, long shareId, int start, int finish)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getContentSubList_name);
            __r = begin_getContentSubList(shareId, start, finish, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getContentSubList_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns a range of items from the share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getContentSubList_async(AMI_IShare_getContentSubList __cb, long shareId, int start, int finish, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getContentSubList_name);
            __r = begin_getContentSubList(shareId, start, finish, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getContentSubList_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getContents_name = "getContents";

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @return list of objects. Not null. Probably not empty.
     **/
    public java.util.List<omero.model.IObject> getContents(long shareId)
        throws omero.ServerError
    {
        return getContents(shareId, null, false);
    }

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return list of objects. Not null. Probably not empty.
     **/
    public java.util.List<omero.model.IObject> getContents(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getContents(shareId, __ctx, true);
    }

    private java.util.List<omero.model.IObject> getContents(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getContents", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getContents");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.getContents(shareId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getContents(long shareId)
    {
        return begin_getContents(shareId, null, false, null);
    }

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getContents(long shareId, java.util.Map<String, String> __ctx)
    {
        return begin_getContents(shareId, __ctx, true, null);
    }

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getContents(long shareId, Ice.Callback __cb)
    {
        return begin_getContents(shareId, null, false, __cb);
    }

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getContents(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getContents(shareId, __ctx, true, __cb);
    }

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getContents(long shareId, Callback_IShare_getContents __cb)
    {
        return begin_getContents(shareId, null, false, __cb);
    }

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getContents(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getContents __cb)
    {
        return begin_getContents(shareId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getContents(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getContents_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getContents_name, __cb);
        try
        {
            __result.__prepare(__getContents_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) list of objects. Not null. Probably not empty.
     **/
    public java.util.List<omero.model.IObject> end_getContents(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getContents_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.IObject> __ret;
            __ret = IObjectListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getContents_async(AMI_IShare_getContents __cb, long shareId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getContents_name);
            __r = begin_getContents(shareId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getContents_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Looks up all {@link omero.model.IObject} items belong to the
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getContents_async(AMI_IShare_getContents __cb, long shareId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getContents_name);
            __r = begin_getContents(shareId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getContents_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getEvents_name = "getEvents";

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @return List of events
     **/
    public java.util.List<omero.model.IObject> getEvents(long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to)
        throws omero.ServerError
    {
        return getEvents(shareId, exp, from, to, null, false);
    }

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __ctx The Context map to send with the invocation.
     * @return List of events
     **/
    public java.util.List<omero.model.IObject> getEvents(long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getEvents(shareId, exp, from, to, __ctx, true);
    }

    private java.util.List<omero.model.IObject> getEvents(long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getEvents", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getEvents");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.getEvents(shareId, exp, from, to, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getEvents(long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to)
    {
        return begin_getEvents(shareId, exp, from, to, null, false, null);
    }

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getEvents(long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to, java.util.Map<String, String> __ctx)
    {
        return begin_getEvents(shareId, exp, from, to, __ctx, true, null);
    }

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getEvents(long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to, Ice.Callback __cb)
    {
        return begin_getEvents(shareId, exp, from, to, null, false, __cb);
    }

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getEvents(long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getEvents(shareId, exp, from, to, __ctx, true, __cb);
    }

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getEvents(long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to, Callback_IShare_getEvents __cb)
    {
        return begin_getEvents(shareId, exp, from, to, null, false, __cb);
    }

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getEvents(long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to, java.util.Map<String, String> __ctx, Callback_IShare_getEvents __cb)
    {
        return begin_getEvents(shareId, exp, from, to, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getEvents(long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getEvents_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getEvents_name, __cb);
        try
        {
            __result.__prepare(__getEvents_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __os.writeObject(exp);
            __os.writeObject(from);
            __os.writeObject(to);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) List of events
     **/
    public java.util.List<omero.model.IObject> end_getEvents(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getEvents_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.IObject> __ret;
            __ret = IObjectListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __cb The callback object for the operation.
     **/
    public boolean getEvents_async(AMI_IShare_getEvents __cb, long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getEvents_name);
            __r = begin_getEvents(shareId, exp, from, to, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getEvents_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Gets events for {@link omero.model.Session} share per
     * {@link omero.model.Experimenter} experimenter for period of
     * time.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getEvents_async(AMI_IShare_getEvents __cb, long shareId, omero.model.Experimenter exp, omero.RTime from, omero.RTime to, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getEvents_name);
            __r = begin_getEvents(shareId, exp, from, to, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getEvents_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getMemberCount_name = "getMemberCount";

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param shareIds Not null.
     * @return Map with all ids present.
     * @throws ValidationException if a given share does not exist
     **/
    public java.util.Map<Long,Long> getMemberCount(java.util.List<Long> shareIds)
        throws omero.ServerError
    {
        return getMemberCount(shareIds, null, false);
    }

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return Map with all ids present.
     * @throws ValidationException if a given share does not exist
     **/
    public java.util.Map<Long,Long> getMemberCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getMemberCount(shareIds, __ctx, true);
    }

    private java.util.Map<Long,Long> getMemberCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getMemberCount", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getMemberCount");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.getMemberCount(shareIds, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     **/
    public Ice.AsyncResult begin_getMemberCount(java.util.List<Long> shareIds)
    {
        return begin_getMemberCount(shareIds, null, false, null);
    }

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMemberCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx)
    {
        return begin_getMemberCount(shareIds, __ctx, true, null);
    }

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     **/
    public Ice.AsyncResult begin_getMemberCount(java.util.List<Long> shareIds, Ice.Callback __cb)
    {
        return begin_getMemberCount(shareIds, null, false, __cb);
    }

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMemberCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getMemberCount(shareIds, __ctx, true, __cb);
    }

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     **/
    public Ice.AsyncResult begin_getMemberCount(java.util.List<Long> shareIds, Callback_IShare_getMemberCount __cb)
    {
        return begin_getMemberCount(shareIds, null, false, __cb);
    }

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMemberCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx, Callback_IShare_getMemberCount __cb)
    {
        return begin_getMemberCount(shareIds, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getMemberCount(java.util.List<Long> shareIds, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getMemberCount_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getMemberCount_name, __cb);
        try
        {
            __result.__prepare(__getMemberCount_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.sys.LongListHelper.write(__os, shareIds);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) Map with all ids present.
     **/
    public java.util.Map<Long,Long> end_getMemberCount(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getMemberCount_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<Long,Long> __ret;
            __ret = omero.sys.CountMapHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     **/
    public boolean getMemberCount_async(AMI_IShare_getMemberCount __cb, java.util.List<Long> shareIds)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getMemberCount_name);
            __r = begin_getMemberCount(shareIds, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getMemberCount_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns a map from share id to the count of total members
     * (including the owner). This is represented by
     * {@link omero.model.ShareMember} links.
     * 
     * @param __cb The callback object for the operation.
     * @param shareIds Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getMemberCount_async(AMI_IShare_getMemberCount __cb, java.util.List<Long> shareIds, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getMemberCount_name);
            __r = begin_getMemberCount(shareIds, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getMemberCount_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getMemberShares_name = "getMemberShares";

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param onlyActive
     * if true, then only shares which can be used for
     * login will be returned. All <i>draft</i> shares
     * (see {@link #createShare}) and closed shares (see
     * {@link #closeShare}) will be filtered.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> getMemberShares(boolean active)
        throws omero.ServerError
    {
        return getMemberShares(active, null, false);
    }

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param onlyActive
     * if true, then only shares which can be used for
     * login will be returned. All <i>draft</i> shares
     * (see {@link #createShare}) and closed shares (see
     * {@link #closeShare}) will be filtered.
     * @param __ctx The Context map to send with the invocation.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> getMemberShares(boolean active, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getMemberShares(active, __ctx, true);
    }

    private java.util.List<omero.model.Session> getMemberShares(boolean active, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getMemberShares", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getMemberShares");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.getMemberShares(active, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMemberShares(boolean active)
    {
        return begin_getMemberShares(active, null, false, null);
    }

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMemberShares(boolean active, java.util.Map<String, String> __ctx)
    {
        return begin_getMemberShares(active, __ctx, true, null);
    }

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMemberShares(boolean active, Ice.Callback __cb)
    {
        return begin_getMemberShares(active, null, false, __cb);
    }

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMemberShares(boolean active, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getMemberShares(active, __ctx, true, __cb);
    }

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMemberShares(boolean active, Callback_IShare_getMemberShares __cb)
    {
        return begin_getMemberShares(active, null, false, __cb);
    }

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMemberShares(boolean active, java.util.Map<String, String> __ctx, Callback_IShare_getMemberShares __cb)
    {
        return begin_getMemberShares(active, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getMemberShares(boolean active, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getMemberShares_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getMemberShares_name, __cb);
        try
        {
            __result.__prepare(__getMemberShares_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(active);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> end_getMemberShares(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getMemberShares_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.Session> __ret;
            __ret = SessionListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getMemberShares_async(AMI_IShare_getMemberShares __cb, boolean active)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getMemberShares_name);
            __r = begin_getMemberShares(active, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getMemberShares_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Gets all shares where current
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getMemberShares_async(AMI_IShare_getMemberShares __cb, boolean active, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getMemberShares_name);
            __r = begin_getMemberShares(active, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getMemberShares_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getMemberSharesFor_name = "getMemberSharesFor";

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param onlyActive
     * if true, then only shares which can be used for
     * login will be returned. All <i>draft</i> shares
     * (see {@link #createShare}) and closed shares (see
     * {@link #closeShare}) will be filtered.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> getMemberSharesFor(omero.model.Experimenter user, boolean active)
        throws omero.ServerError
    {
        return getMemberSharesFor(user, active, null, false);
    }

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param onlyActive
     * if true, then only shares which can be used for
     * login will be returned. All <i>draft</i> shares
     * (see {@link #createShare}) and closed shares (see
     * {@link #closeShare}) will be filtered.
     * @param __ctx The Context map to send with the invocation.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> getMemberSharesFor(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getMemberSharesFor(user, active, __ctx, true);
    }

    private java.util.List<omero.model.Session> getMemberSharesFor(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getMemberSharesFor", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getMemberSharesFor");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.getMemberSharesFor(user, active, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMemberSharesFor(omero.model.Experimenter user, boolean active)
    {
        return begin_getMemberSharesFor(user, active, null, false, null);
    }

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMemberSharesFor(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx)
    {
        return begin_getMemberSharesFor(user, active, __ctx, true, null);
    }

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMemberSharesFor(omero.model.Experimenter user, boolean active, Ice.Callback __cb)
    {
        return begin_getMemberSharesFor(user, active, null, false, __cb);
    }

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMemberSharesFor(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getMemberSharesFor(user, active, __ctx, true, __cb);
    }

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getMemberSharesFor(omero.model.Experimenter user, boolean active, Callback_IShare_getMemberSharesFor __cb)
    {
        return begin_getMemberSharesFor(user, active, null, false, __cb);
    }

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getMemberSharesFor(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx, Callback_IShare_getMemberSharesFor __cb)
    {
        return begin_getMemberSharesFor(user, active, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getMemberSharesFor(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getMemberSharesFor_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getMemberSharesFor_name, __cb);
        try
        {
            __result.__prepare(__getMemberSharesFor_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(user);
            __os.writeBool(active);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> end_getMemberSharesFor(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getMemberSharesFor_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.Session> __ret;
            __ret = SessionListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getMemberSharesFor_async(AMI_IShare_getMemberSharesFor __cb, omero.model.Experimenter user, boolean active)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getMemberSharesFor_name);
            __r = begin_getMemberSharesFor(user, active, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getMemberSharesFor_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Gets all shares where given
     * {@link omero.model.Experimenter} is a member.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getMemberSharesFor_async(AMI_IShare_getMemberSharesFor __cb, omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getMemberSharesFor_name);
            __r = begin_getMemberSharesFor(user, active, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getMemberSharesFor_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getOwnShares_name = "getOwnShares";

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param onlyActive
     * if true, then only shares which can be used for
     * login will be returned. All <i>draft</i> shares
     * (see {@link #createShare}) and closed shares (see
     * {@link #closeShare}) will be filtered.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> getOwnShares(boolean active)
        throws omero.ServerError
    {
        return getOwnShares(active, null, false);
    }

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param onlyActive
     * if true, then only shares which can be used for
     * login will be returned. All <i>draft</i> shares
     * (see {@link #createShare}) and closed shares (see
     * {@link #closeShare}) will be filtered.
     * @param __ctx The Context map to send with the invocation.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> getOwnShares(boolean active, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getOwnShares(active, __ctx, true);
    }

    private java.util.List<omero.model.Session> getOwnShares(boolean active, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getOwnShares", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getOwnShares");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.getOwnShares(active, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getOwnShares(boolean active)
    {
        return begin_getOwnShares(active, null, false, null);
    }

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getOwnShares(boolean active, java.util.Map<String, String> __ctx)
    {
        return begin_getOwnShares(active, __ctx, true, null);
    }

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getOwnShares(boolean active, Ice.Callback __cb)
    {
        return begin_getOwnShares(active, null, false, __cb);
    }

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getOwnShares(boolean active, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getOwnShares(active, __ctx, true, __cb);
    }

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getOwnShares(boolean active, Callback_IShare_getOwnShares __cb)
    {
        return begin_getOwnShares(active, null, false, __cb);
    }

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getOwnShares(boolean active, java.util.Map<String, String> __ctx, Callback_IShare_getOwnShares __cb)
    {
        return begin_getOwnShares(active, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getOwnShares(boolean active, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getOwnShares_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getOwnShares_name, __cb);
        try
        {
            __result.__prepare(__getOwnShares_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(active);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> end_getOwnShares(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getOwnShares_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.Session> __ret;
            __ret = SessionListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getOwnShares_async(AMI_IShare_getOwnShares __cb, boolean active)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getOwnShares_name);
            __r = begin_getOwnShares(active, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getOwnShares_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Gets all owned shares for the current
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getOwnShares_async(AMI_IShare_getOwnShares __cb, boolean active, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getOwnShares_name);
            __r = begin_getOwnShares(active, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getOwnShares_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getPastConnections_name = "getPastConnections";

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @return map of experimenter and IP address
     **/
    public java.util.Map<java.lang.String, omero.model.Experimenter> getPastConnections(long shareId)
        throws omero.ServerError
    {
        return getPastConnections(shareId, null, false);
    }

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return map of experimenter and IP address
     **/
    public java.util.Map<java.lang.String, omero.model.Experimenter> getPastConnections(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getPastConnections(shareId, __ctx, true);
    }

    private java.util.Map<java.lang.String, omero.model.Experimenter> getPastConnections(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getPastConnections", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getPastConnections");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.getPastConnections(shareId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getPastConnections(long shareId)
    {
        return begin_getPastConnections(shareId, null, false, null);
    }

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPastConnections(long shareId, java.util.Map<String, String> __ctx)
    {
        return begin_getPastConnections(shareId, __ctx, true, null);
    }

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getPastConnections(long shareId, Ice.Callback __cb)
    {
        return begin_getPastConnections(shareId, null, false, __cb);
    }

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPastConnections(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getPastConnections(shareId, __ctx, true, __cb);
    }

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getPastConnections(long shareId, Callback_IShare_getPastConnections __cb)
    {
        return begin_getPastConnections(shareId, null, false, __cb);
    }

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPastConnections(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getPastConnections __cb)
    {
        return begin_getPastConnections(shareId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getPastConnections(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getPastConnections_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getPastConnections_name, __cb);
        try
        {
            __result.__prepare(__getPastConnections_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) map of experimenter and IP address
     **/
    public java.util.Map<java.lang.String, omero.model.Experimenter> end_getPastConnections(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getPastConnections_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.String, omero.model.Experimenter> __ret;
            __ret = UserMapHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getPastConnections_async(AMI_IShare_getPastConnections __cb, long shareId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPastConnections_name);
            __r = begin_getPastConnections(shareId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPastConnections_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Gets previous connections to
     * {@link omero.model.Session} share.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getPastConnections_async(AMI_IShare_getPastConnections __cb, long shareId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPastConnections_name);
            __r = begin_getPastConnections(shareId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPastConnections_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getShare_name = "getShare";

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @return a {@link omero.model.Session} with id and
     * {@link omero.model.Details} set or null.
     * The owner in the Details object is the true owner,
     * and the group in the Details has all member users
     * linked. {@link omero.model.Annotation} instances
     * of the share are linked to the
     * {@link omero.model.Session}. Missing is a list of
     * share guests.
     **/
    public omero.model.Share getShare(long shareId)
        throws omero.ServerError
    {
        return getShare(shareId, null, false);
    }

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return a {@link omero.model.Session} with id and
     * {@link omero.model.Details} set or null.
     * The owner in the Details object is the true owner,
     * and the group in the Details has all member users
     * linked. {@link omero.model.Annotation} instances
     * of the share are linked to the
     * {@link omero.model.Session}. Missing is a list of
     * share guests.
     **/
    public omero.model.Share getShare(long shareId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getShare(shareId, __ctx, true);
    }

    private omero.model.Share getShare(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getShare", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getShare");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.getShare(shareId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getShare(long shareId)
    {
        return begin_getShare(shareId, null, false, null);
    }

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getShare(long shareId, java.util.Map<String, String> __ctx)
    {
        return begin_getShare(shareId, __ctx, true, null);
    }

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getShare(long shareId, Ice.Callback __cb)
    {
        return begin_getShare(shareId, null, false, __cb);
    }

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getShare(long shareId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getShare(shareId, __ctx, true, __cb);
    }

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getShare(long shareId, Callback_IShare_getShare __cb)
    {
        return begin_getShare(shareId, null, false, __cb);
    }

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getShare(long shareId, java.util.Map<String, String> __ctx, Callback_IShare_getShare __cb)
    {
        return begin_getShare(shareId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getShare(long shareId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getShare_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getShare_name, __cb);
        try
        {
            __result.__prepare(__getShare_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a {@link omero.model.Session} with id and
     * {@link omero.model.Details} set or null.
     * The owner in the Details object is the true owner,
     * and the group in the Details has all member users
     * linked. {@link omero.model.Annotation} instances
     * of the share are linked to the
     * {@link omero.model.Session}. Missing is a list of
     * share guests.
     **/
    public omero.model.Share end_getShare(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getShare_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.ShareHolder __ret = new omero.model.ShareHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getShare_async(AMI_IShare_getShare __cb, long shareId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getShare_name);
            __r = begin_getShare(shareId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getShare_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Gets a share as a {@link omero.model.Session} with all
     * related: {@link omero.model.Annotation} comments,
     * {@link omero.model.Experimenter} members, fully loaded.
     * Unlike the other methods on this interface, if the
     * sessionId is unknown, does not throw a
     * {@link omero.ValidationException}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getShare_async(AMI_IShare_getShare __cb, long shareId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getShare_name);
            __r = begin_getShare(shareId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getShare_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getSharesOwnedBy_name = "getSharesOwnedBy";

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param onlyActive
     * if true, then only shares which can be used for
     * login will be returned. All <i>draft</i> shares
     * (see {@link #createShare}) and closed shares (see
     * {@link #closeShare}) will be filtered.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> getSharesOwnedBy(omero.model.Experimenter user, boolean active)
        throws omero.ServerError
    {
        return getSharesOwnedBy(user, active, null, false);
    }

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param onlyActive
     * if true, then only shares which can be used for
     * login will be returned. All <i>draft</i> shares
     * (see {@link #createShare}) and closed shares (see
     * {@link #closeShare}) will be filtered.
     * @param __ctx The Context map to send with the invocation.
     * @return set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> getSharesOwnedBy(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getSharesOwnedBy(user, active, __ctx, true);
    }

    private java.util.List<omero.model.Session> getSharesOwnedBy(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getSharesOwnedBy", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getSharesOwnedBy");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    return __del.getSharesOwnedBy(user, active, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getSharesOwnedBy(omero.model.Experimenter user, boolean active)
    {
        return begin_getSharesOwnedBy(user, active, null, false, null);
    }

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getSharesOwnedBy(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx)
    {
        return begin_getSharesOwnedBy(user, active, __ctx, true, null);
    }

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getSharesOwnedBy(omero.model.Experimenter user, boolean active, Ice.Callback __cb)
    {
        return begin_getSharesOwnedBy(user, active, null, false, __cb);
    }

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getSharesOwnedBy(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getSharesOwnedBy(user, active, __ctx, true, __cb);
    }

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getSharesOwnedBy(omero.model.Experimenter user, boolean active, Callback_IShare_getSharesOwnedBy __cb)
    {
        return begin_getSharesOwnedBy(user, active, null, false, __cb);
    }

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getSharesOwnedBy(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx, Callback_IShare_getSharesOwnedBy __cb)
    {
        return begin_getSharesOwnedBy(user, active, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getSharesOwnedBy(omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getSharesOwnedBy_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getSharesOwnedBy_name, __cb);
        try
        {
            __result.__prepare(__getSharesOwnedBy_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(user);
            __os.writeBool(active);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) set of shares. Never null. May be empty.
     **/
    public java.util.List<omero.model.Session> end_getSharesOwnedBy(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getSharesOwnedBy_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.Session> __ret;
            __ret = SessionListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getSharesOwnedBy_async(AMI_IShare_getSharesOwnedBy __cb, omero.model.Experimenter user, boolean active)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getSharesOwnedBy_name);
            __r = begin_getSharesOwnedBy(user, active, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getSharesOwnedBy_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Gets all shares owned by the given
     * {@link omero.model.Experimenter}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getSharesOwnedBy_async(AMI_IShare_getSharesOwnedBy __cb, omero.model.Experimenter user, boolean active, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getSharesOwnedBy_name);
            __r = begin_getSharesOwnedBy(user, active, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getSharesOwnedBy_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __invalidateConnection_name = "invalidateConnection";

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     **/
    public void invalidateConnection(long shareId, omero.model.Experimenter exp)
        throws omero.ServerError
    {
        invalidateConnection(shareId, exp, null, false);
    }

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void invalidateConnection(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        invalidateConnection(shareId, exp, __ctx, true);
    }

    private void invalidateConnection(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "invalidateConnection", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("invalidateConnection");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.invalidateConnection(shareId, exp, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_invalidateConnection(long shareId, omero.model.Experimenter exp)
    {
        return begin_invalidateConnection(shareId, exp, null, false, null);
    }

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_invalidateConnection(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
    {
        return begin_invalidateConnection(shareId, exp, __ctx, true, null);
    }

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_invalidateConnection(long shareId, omero.model.Experimenter exp, Ice.Callback __cb)
    {
        return begin_invalidateConnection(shareId, exp, null, false, __cb);
    }

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_invalidateConnection(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_invalidateConnection(shareId, exp, __ctx, true, __cb);
    }

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_invalidateConnection(long shareId, omero.model.Experimenter exp, Callback_IShare_invalidateConnection __cb)
    {
        return begin_invalidateConnection(shareId, exp, null, false, __cb);
    }

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_invalidateConnection(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Callback_IShare_invalidateConnection __cb)
    {
        return begin_invalidateConnection(shareId, exp, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_invalidateConnection(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__invalidateConnection_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __invalidateConnection_name, __cb);
        try
        {
            __result.__prepare(__invalidateConnection_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __os.writeObject(exp);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_invalidateConnection(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __invalidateConnection_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __cb The callback object for the operation.
     **/
    public boolean invalidateConnection_async(AMI_IShare_invalidateConnection __cb, long shareId, omero.model.Experimenter exp)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__invalidateConnection_name);
            __r = begin_invalidateConnection(shareId, exp, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __invalidateConnection_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Makes the connection invalid for
     * {@link omero.model.Session} share for specified user.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean invalidateConnection_async(AMI_IShare_invalidateConnection __cb, long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__invalidateConnection_name);
            __r = begin_invalidateConnection(shareId, exp, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __invalidateConnection_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __notifyMembersOfShare_name = "notifyMembersOfShare";

    /**
     * Notifies via email selected members of share.
     **/
    public void notifyMembersOfShare(long shareId, String subject, String message, boolean html)
        throws omero.ServerError
    {
        notifyMembersOfShare(shareId, subject, message, html, null, false);
    }

    /**
     * Notifies via email selected members of share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void notifyMembersOfShare(long shareId, String subject, String message, boolean html, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        notifyMembersOfShare(shareId, subject, message, html, __ctx, true);
    }

    private void notifyMembersOfShare(long shareId, String subject, String message, boolean html, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "notifyMembersOfShare", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("notifyMembersOfShare");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.notifyMembersOfShare(shareId, subject, message, html, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Notifies via email selected members of share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_notifyMembersOfShare(long shareId, String subject, String message, boolean html)
    {
        return begin_notifyMembersOfShare(shareId, subject, message, html, null, false, null);
    }

    /**
     * Notifies via email selected members of share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_notifyMembersOfShare(long shareId, String subject, String message, boolean html, java.util.Map<String, String> __ctx)
    {
        return begin_notifyMembersOfShare(shareId, subject, message, html, __ctx, true, null);
    }

    /**
     * Notifies via email selected members of share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_notifyMembersOfShare(long shareId, String subject, String message, boolean html, Ice.Callback __cb)
    {
        return begin_notifyMembersOfShare(shareId, subject, message, html, null, false, __cb);
    }

    /**
     * Notifies via email selected members of share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_notifyMembersOfShare(long shareId, String subject, String message, boolean html, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_notifyMembersOfShare(shareId, subject, message, html, __ctx, true, __cb);
    }

    /**
     * Notifies via email selected members of share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_notifyMembersOfShare(long shareId, String subject, String message, boolean html, Callback_IShare_notifyMembersOfShare __cb)
    {
        return begin_notifyMembersOfShare(shareId, subject, message, html, null, false, __cb);
    }

    /**
     * Notifies via email selected members of share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_notifyMembersOfShare(long shareId, String subject, String message, boolean html, java.util.Map<String, String> __ctx, Callback_IShare_notifyMembersOfShare __cb)
    {
        return begin_notifyMembersOfShare(shareId, subject, message, html, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_notifyMembersOfShare(long shareId, String subject, String message, boolean html, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__notifyMembersOfShare_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __notifyMembersOfShare_name, __cb);
        try
        {
            __result.__prepare(__notifyMembersOfShare_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __os.writeString(subject);
            __os.writeString(message);
            __os.writeBool(html);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_notifyMembersOfShare(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __notifyMembersOfShare_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Notifies via email selected members of share.
     * @param __cb The callback object for the operation.
     **/
    public boolean notifyMembersOfShare_async(AMI_IShare_notifyMembersOfShare __cb, long shareId, String subject, String message, boolean html)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__notifyMembersOfShare_name);
            __r = begin_notifyMembersOfShare(shareId, subject, message, html, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __notifyMembersOfShare_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Notifies via email selected members of share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean notifyMembersOfShare_async(AMI_IShare_notifyMembersOfShare __cb, long shareId, String subject, String message, boolean html, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__notifyMembersOfShare_name);
            __r = begin_notifyMembersOfShare(shareId, subject, message, html, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __notifyMembersOfShare_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __removeGuest_name = "removeGuest";

    /**
     * Removes guest email address from share.
     **/
    public void removeGuest(long shareId, String emailAddress)
        throws omero.ServerError
    {
        removeGuest(shareId, emailAddress, null, false);
    }

    /**
     * Removes guest email address from share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        removeGuest(shareId, emailAddress, __ctx, true);
    }

    private void removeGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "removeGuest", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("removeGuest");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.removeGuest(shareId, emailAddress, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Removes guest email address from share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeGuest(long shareId, String emailAddress)
    {
        return begin_removeGuest(shareId, emailAddress, null, false, null);
    }

    /**
     * Removes guest email address from share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx)
    {
        return begin_removeGuest(shareId, emailAddress, __ctx, true, null);
    }

    /**
     * Removes guest email address from share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeGuest(long shareId, String emailAddress, Ice.Callback __cb)
    {
        return begin_removeGuest(shareId, emailAddress, null, false, __cb);
    }

    /**
     * Removes guest email address from share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_removeGuest(shareId, emailAddress, __ctx, true, __cb);
    }

    /**
     * Removes guest email address from share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeGuest(long shareId, String emailAddress, Callback_IShare_removeGuest __cb)
    {
        return begin_removeGuest(shareId, emailAddress, null, false, __cb);
    }

    /**
     * Removes guest email address from share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx, Callback_IShare_removeGuest __cb)
    {
        return begin_removeGuest(shareId, emailAddress, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_removeGuest(long shareId, String emailAddress, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__removeGuest_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __removeGuest_name, __cb);
        try
        {
            __result.__prepare(__removeGuest_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __os.writeString(emailAddress);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_removeGuest(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __removeGuest_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Removes guest email address from share.
     * @param __cb The callback object for the operation.
     **/
    public boolean removeGuest_async(AMI_IShare_removeGuest __cb, long shareId, String emailAddress)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeGuest_name);
            __r = begin_removeGuest(shareId, emailAddress, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeGuest_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Removes guest email address from share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeGuest_async(AMI_IShare_removeGuest __cb, long shareId, String emailAddress, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeGuest_name);
            __r = begin_removeGuest(shareId, emailAddress, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeGuest_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __removeGuests_name = "removeGuests";

    /**
     * Removes guest email addresses from the share.
     **/
    public void removeGuests(long shareId, java.util.List<String> emailAddresses)
        throws omero.ServerError
    {
        removeGuests(shareId, emailAddresses, null, false);
    }

    /**
     * Removes guest email addresses from the share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        removeGuests(shareId, emailAddresses, __ctx, true);
    }

    private void removeGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "removeGuests", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("removeGuests");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.removeGuests(shareId, emailAddresses, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Removes guest email addresses from the share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeGuests(long shareId, java.util.List<String> emailAddresses)
    {
        return begin_removeGuests(shareId, emailAddresses, null, false, null);
    }

    /**
     * Removes guest email addresses from the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx)
    {
        return begin_removeGuests(shareId, emailAddresses, __ctx, true, null);
    }

    /**
     * Removes guest email addresses from the share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeGuests(long shareId, java.util.List<String> emailAddresses, Ice.Callback __cb)
    {
        return begin_removeGuests(shareId, emailAddresses, null, false, __cb);
    }

    /**
     * Removes guest email addresses from the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_removeGuests(shareId, emailAddresses, __ctx, true, __cb);
    }

    /**
     * Removes guest email addresses from the share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeGuests(long shareId, java.util.List<String> emailAddresses, Callback_IShare_removeGuests __cb)
    {
        return begin_removeGuests(shareId, emailAddresses, null, false, __cb);
    }

    /**
     * Removes guest email addresses from the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx, Callback_IShare_removeGuests __cb)
    {
        return begin_removeGuests(shareId, emailAddresses, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_removeGuests(long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__removeGuests_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __removeGuests_name, __cb);
        try
        {
            __result.__prepare(__removeGuests_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            StringSetHelper.write(__os, emailAddresses);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_removeGuests(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __removeGuests_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Removes guest email addresses from the share.
     * @param __cb The callback object for the operation.
     **/
    public boolean removeGuests_async(AMI_IShare_removeGuests __cb, long shareId, java.util.List<String> emailAddresses)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeGuests_name);
            __r = begin_removeGuests(shareId, emailAddresses, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeGuests_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Removes guest email addresses from the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeGuests_async(AMI_IShare_removeGuests __cb, long shareId, java.util.List<String> emailAddresses, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeGuests_name);
            __r = begin_removeGuests(shareId, emailAddresses, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeGuests_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __removeObject_name = "removeObject";

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     **/
    public void removeObject(long shareId, omero.model.IObject iobject)
        throws omero.ServerError
    {
        removeObject(shareId, iobject, null, false);
    }

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        removeObject(shareId, iobject, __ctx, true);
    }

    private void removeObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "removeObject", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("removeObject");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.removeObject(shareId, iobject, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeObject(long shareId, omero.model.IObject iobject)
    {
        return begin_removeObject(shareId, iobject, null, false, null);
    }

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx)
    {
        return begin_removeObject(shareId, iobject, __ctx, true, null);
    }

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeObject(long shareId, omero.model.IObject iobject, Ice.Callback __cb)
    {
        return begin_removeObject(shareId, iobject, null, false, __cb);
    }

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_removeObject(shareId, iobject, __ctx, true, __cb);
    }

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeObject(long shareId, omero.model.IObject iobject, Callback_IShare_removeObject __cb)
    {
        return begin_removeObject(shareId, iobject, null, false, __cb);
    }

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx, Callback_IShare_removeObject __cb)
    {
        return begin_removeObject(shareId, iobject, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_removeObject(long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__removeObject_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __removeObject_name, __cb);
        try
        {
            __result.__prepare(__removeObject_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __os.writeObject(iobject);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_removeObject(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __removeObject_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public boolean removeObject_async(AMI_IShare_removeObject __cb, long shareId, omero.model.IObject iobject)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeObject_name);
            __r = begin_removeObject(shareId, iobject, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeObject_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Removes existing {@link omero.model.IObject} object from the
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeObject_async(AMI_IShare_removeObject __cb, long shareId, omero.model.IObject iobject, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeObject_name);
            __r = begin_removeObject(shareId, iobject, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeObject_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __removeObjects_name = "removeObjects";

    /**
     * Remove existing items from the share.
     **/
    public void removeObjects(long shareId, java.util.List<omero.model.IObject> iobjects)
        throws omero.ServerError
    {
        removeObjects(shareId, iobjects, null, false);
    }

    /**
     * Remove existing items from the share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        removeObjects(shareId, iobjects, __ctx, true);
    }

    private void removeObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "removeObjects", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("removeObjects");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.removeObjects(shareId, iobjects, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Remove existing items from the share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeObjects(long shareId, java.util.List<omero.model.IObject> iobjects)
    {
        return begin_removeObjects(shareId, iobjects, null, false, null);
    }

    /**
     * Remove existing items from the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx)
    {
        return begin_removeObjects(shareId, iobjects, __ctx, true, null);
    }

    /**
     * Remove existing items from the share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeObjects(long shareId, java.util.List<omero.model.IObject> iobjects, Ice.Callback __cb)
    {
        return begin_removeObjects(shareId, iobjects, null, false, __cb);
    }

    /**
     * Remove existing items from the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_removeObjects(shareId, iobjects, __ctx, true, __cb);
    }

    /**
     * Remove existing items from the share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeObjects(long shareId, java.util.List<omero.model.IObject> iobjects, Callback_IShare_removeObjects __cb)
    {
        return begin_removeObjects(shareId, iobjects, null, false, __cb);
    }

    /**
     * Remove existing items from the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx, Callback_IShare_removeObjects __cb)
    {
        return begin_removeObjects(shareId, iobjects, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_removeObjects(long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__removeObjects_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __removeObjects_name, __cb);
        try
        {
            __result.__prepare(__removeObjects_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            IObjectListHelper.write(__os, iobjects);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_removeObjects(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __removeObjects_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Remove existing items from the share.
     * @param __cb The callback object for the operation.
     **/
    public boolean removeObjects_async(AMI_IShare_removeObjects __cb, long shareId, java.util.List<omero.model.IObject> iobjects)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeObjects_name);
            __r = begin_removeObjects(shareId, iobjects, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeObjects_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Remove existing items from the share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeObjects_async(AMI_IShare_removeObjects __cb, long shareId, java.util.List<omero.model.IObject> iobjects, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeObjects_name);
            __r = begin_removeObjects(shareId, iobjects, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeObjects_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __removeUser_name = "removeUser";

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     **/
    public void removeUser(long shareId, omero.model.Experimenter exp)
        throws omero.ServerError
    {
        removeUser(shareId, exp, null, false);
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        removeUser(shareId, exp, __ctx, true);
    }

    private void removeUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "removeUser", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("removeUser");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.removeUser(shareId, exp, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeUser(long shareId, omero.model.Experimenter exp)
    {
        return begin_removeUser(shareId, exp, null, false, null);
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
    {
        return begin_removeUser(shareId, exp, __ctx, true, null);
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeUser(long shareId, omero.model.Experimenter exp, Ice.Callback __cb)
    {
        return begin_removeUser(shareId, exp, null, false, __cb);
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_removeUser(shareId, exp, __ctx, true, __cb);
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeUser(long shareId, omero.model.Experimenter exp, Callback_IShare_removeUser __cb)
    {
        return begin_removeUser(shareId, exp, null, false, __cb);
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx, Callback_IShare_removeUser __cb)
    {
        return begin_removeUser(shareId, exp, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_removeUser(long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__removeUser_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __removeUser_name, __cb);
        try
        {
            __result.__prepare(__removeUser_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __os.writeObject(exp);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_removeUser(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __removeUser_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public boolean removeUser_async(AMI_IShare_removeUser __cb, long shareId, omero.model.Experimenter exp)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeUser_name);
            __r = begin_removeUser(shareId, exp, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeUser_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenter from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeUser_async(AMI_IShare_removeUser __cb, long shareId, omero.model.Experimenter exp, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeUser_name);
            __r = begin_removeUser(shareId, exp, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeUser_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __removeUsers_name = "removeUsers";

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     **/
    public void removeUsers(long shareId, java.util.List<omero.model.Experimenter> exps)
        throws omero.ServerError
    {
        removeUsers(shareId, exps, null, false);
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        removeUsers(shareId, exps, __ctx, true);
    }

    private void removeUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "removeUsers", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("removeUsers");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.removeUsers(shareId, exps, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeUsers(long shareId, java.util.List<omero.model.Experimenter> exps)
    {
        return begin_removeUsers(shareId, exps, null, false, null);
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx)
    {
        return begin_removeUsers(shareId, exps, __ctx, true, null);
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeUsers(long shareId, java.util.List<omero.model.Experimenter> exps, Ice.Callback __cb)
    {
        return begin_removeUsers(shareId, exps, null, false, __cb);
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_removeUsers(shareId, exps, __ctx, true, __cb);
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_removeUsers(long shareId, java.util.List<omero.model.Experimenter> exps, Callback_IShare_removeUsers __cb)
    {
        return begin_removeUsers(shareId, exps, null, false, __cb);
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx, Callback_IShare_removeUsers __cb)
    {
        return begin_removeUsers(shareId, exps, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_removeUsers(long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__removeUsers_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __removeUsers_name, __cb);
        try
        {
            __result.__prepare(__removeUsers_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            ExperimenterListHelper.write(__os, exps);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_removeUsers(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __removeUsers_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     **/
    public boolean removeUsers_async(AMI_IShare_removeUsers __cb, long shareId, java.util.List<omero.model.Experimenter> exps)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeUsers_name);
            __r = begin_removeUsers(shareId, exps, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeUsers_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Removes {@link omero.model.Experimenter} experimenters from
     * {@link omero.model.Session} share.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeUsers_async(AMI_IShare_removeUsers __cb, long shareId, java.util.List<omero.model.Experimenter> exps, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeUsers_name);
            __r = begin_removeUsers(shareId, exps, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeUsers_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setActive_name = "setActive";

    public void setActive(long shareId, boolean active)
        throws omero.ServerError
    {
        setActive(shareId, active, null, false);
    }

    public void setActive(long shareId, boolean active, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setActive(shareId, active, __ctx, true);
    }

    private void setActive(long shareId, boolean active, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setActive", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setActive");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.setActive(shareId, active, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_setActive(long shareId, boolean active)
    {
        return begin_setActive(shareId, active, null, false, null);
    }

    public Ice.AsyncResult begin_setActive(long shareId, boolean active, java.util.Map<String, String> __ctx)
    {
        return begin_setActive(shareId, active, __ctx, true, null);
    }

    public Ice.AsyncResult begin_setActive(long shareId, boolean active, Ice.Callback __cb)
    {
        return begin_setActive(shareId, active, null, false, __cb);
    }

    public Ice.AsyncResult begin_setActive(long shareId, boolean active, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setActive(shareId, active, __ctx, true, __cb);
    }

    public Ice.AsyncResult begin_setActive(long shareId, boolean active, Callback_IShare_setActive __cb)
    {
        return begin_setActive(shareId, active, null, false, __cb);
    }

    public Ice.AsyncResult begin_setActive(long shareId, boolean active, java.util.Map<String, String> __ctx, Callback_IShare_setActive __cb)
    {
        return begin_setActive(shareId, active, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setActive(long shareId, boolean active, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setActive_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setActive_name, __cb);
        try
        {
            __result.__prepare(__setActive_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __os.writeBool(active);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public void end_setActive(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setActive_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public boolean setActive_async(AMI_IShare_setActive __cb, long shareId, boolean active)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setActive_name);
            __r = begin_setActive(shareId, active, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setActive_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public boolean setActive_async(AMI_IShare_setActive __cb, long shareId, boolean active, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setActive_name);
            __r = begin_setActive(shareId, active, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setActive_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setDescription_name = "setDescription";

    public void setDescription(long shareId, String description)
        throws omero.ServerError
    {
        setDescription(shareId, description, null, false);
    }

    public void setDescription(long shareId, String description, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setDescription(shareId, description, __ctx, true);
    }

    private void setDescription(long shareId, String description, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setDescription", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setDescription");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.setDescription(shareId, description, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_setDescription(long shareId, String description)
    {
        return begin_setDescription(shareId, description, null, false, null);
    }

    public Ice.AsyncResult begin_setDescription(long shareId, String description, java.util.Map<String, String> __ctx)
    {
        return begin_setDescription(shareId, description, __ctx, true, null);
    }

    public Ice.AsyncResult begin_setDescription(long shareId, String description, Ice.Callback __cb)
    {
        return begin_setDescription(shareId, description, null, false, __cb);
    }

    public Ice.AsyncResult begin_setDescription(long shareId, String description, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setDescription(shareId, description, __ctx, true, __cb);
    }

    public Ice.AsyncResult begin_setDescription(long shareId, String description, Callback_IShare_setDescription __cb)
    {
        return begin_setDescription(shareId, description, null, false, __cb);
    }

    public Ice.AsyncResult begin_setDescription(long shareId, String description, java.util.Map<String, String> __ctx, Callback_IShare_setDescription __cb)
    {
        return begin_setDescription(shareId, description, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setDescription(long shareId, String description, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setDescription_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setDescription_name, __cb);
        try
        {
            __result.__prepare(__setDescription_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __os.writeString(description);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public void end_setDescription(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setDescription_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public boolean setDescription_async(AMI_IShare_setDescription __cb, long shareId, String description)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setDescription_name);
            __r = begin_setDescription(shareId, description, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setDescription_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public boolean setDescription_async(AMI_IShare_setDescription __cb, long shareId, String description, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setDescription_name);
            __r = begin_setDescription(shareId, description, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setDescription_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setExpiration_name = "setExpiration";

    public void setExpiration(long shareId, omero.RTime expiration)
        throws omero.ServerError
    {
        setExpiration(shareId, expiration, null, false);
    }

    public void setExpiration(long shareId, omero.RTime expiration, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setExpiration(shareId, expiration, __ctx, true);
    }

    private void setExpiration(long shareId, omero.RTime expiration, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setExpiration", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setExpiration");
                    __delBase = __getDelegate(false);
                    _IShareDel __del = (_IShareDel)__delBase;
                    __del.setExpiration(shareId, expiration, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_setExpiration(long shareId, omero.RTime expiration)
    {
        return begin_setExpiration(shareId, expiration, null, false, null);
    }

    public Ice.AsyncResult begin_setExpiration(long shareId, omero.RTime expiration, java.util.Map<String, String> __ctx)
    {
        return begin_setExpiration(shareId, expiration, __ctx, true, null);
    }

    public Ice.AsyncResult begin_setExpiration(long shareId, omero.RTime expiration, Ice.Callback __cb)
    {
        return begin_setExpiration(shareId, expiration, null, false, __cb);
    }

    public Ice.AsyncResult begin_setExpiration(long shareId, omero.RTime expiration, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setExpiration(shareId, expiration, __ctx, true, __cb);
    }

    public Ice.AsyncResult begin_setExpiration(long shareId, omero.RTime expiration, Callback_IShare_setExpiration __cb)
    {
        return begin_setExpiration(shareId, expiration, null, false, __cb);
    }

    public Ice.AsyncResult begin_setExpiration(long shareId, omero.RTime expiration, java.util.Map<String, String> __ctx, Callback_IShare_setExpiration __cb)
    {
        return begin_setExpiration(shareId, expiration, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setExpiration(long shareId, omero.RTime expiration, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setExpiration_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setExpiration_name, __cb);
        try
        {
            __result.__prepare(__setExpiration_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(shareId);
            __os.writeObject(expiration);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public void end_setExpiration(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setExpiration_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public boolean setExpiration_async(AMI_IShare_setExpiration __cb, long shareId, omero.RTime expiration)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setExpiration_name);
            __r = begin_setExpiration(shareId, expiration, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setExpiration_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public boolean setExpiration_async(AMI_IShare_setExpiration __cb, long shareId, omero.RTime expiration, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setExpiration_name);
            __r = begin_setExpiration(shareId, expiration, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setExpiration_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static ISharePrx checkedCast(Ice.ObjectPrx __obj)
    {
        ISharePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ISharePrx)
            {
                __d = (ISharePrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    ISharePrxHelper __h = new ISharePrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ISharePrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        ISharePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ISharePrx)
            {
                __d = (ISharePrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    ISharePrxHelper __h = new ISharePrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ISharePrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ISharePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    ISharePrxHelper __h = new ISharePrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ISharePrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        ISharePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    ISharePrxHelper __h = new ISharePrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ISharePrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        ISharePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ISharePrx)
            {
                __d = (ISharePrx)__obj;
            }
            else
            {
                ISharePrxHelper __h = new ISharePrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static ISharePrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ISharePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            ISharePrxHelper __h = new ISharePrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::IShare",
        "::omero::api::ServiceInterface"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _IShareDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _IShareDelD();
    }

    public static void __write(IceInternal.BasicStream __os, ISharePrx v)
    {
        __os.writeProxy(v);
    }

    public static ISharePrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            ISharePrxHelper result = new ISharePrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
