// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `RawPixelsStore.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Binary data provider. Initialized with the ID of a
 * {@link omero.model.Pixels} instance, this service can provide
 * various slices, stacks, regions of the 5-dimensional (X-Y planes with
 * multiple Z-sections and Channels over Time). The byte array returned
 * by the getter methods and passed to the setter methods can and will
 * be interpreted according to results of {@link #getByteWidth},
 * {@link #isFloat}, and {@link #isSigned}.
 * 
 * <p>
 * <b>Read-only caveat</b>:
 * 
 * Mutating methods (set*) are only available during the first access.
 * Once the Pixels data has been successfully saved (via the save or
 * close methods on this interface), then the data should be treated
 * read-only. If Pixels data writing fails and the service is
 * inadvertently closed, delete the Pixels object, and create a new
 * one. Any partially written data will be removed.
 **/
public final class RawPixelsStorePrxHelper extends Ice.ObjectPrxHelperBase implements RawPixelsStorePrx
{
    private static final String __getResolutionDescriptions_name = "getResolutionDescriptions";

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     **/
    public ResolutionDescription[] getResolutionDescriptions()
        throws omero.ServerError
    {
        return getResolutionDescriptions(null, false);
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public ResolutionDescription[] getResolutionDescriptions(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getResolutionDescriptions(__ctx, true);
    }

    private ResolutionDescription[] getResolutionDescriptions(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getResolutionDescriptions", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getResolutionDescriptions");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getResolutionDescriptions(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResolutionDescriptions()
    {
        return begin_getResolutionDescriptions(null, false, null);
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResolutionDescriptions(java.util.Map<String, String> __ctx)
    {
        return begin_getResolutionDescriptions(__ctx, true, null);
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResolutionDescriptions(Ice.Callback __cb)
    {
        return begin_getResolutionDescriptions(null, false, __cb);
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResolutionDescriptions(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getResolutionDescriptions(__ctx, true, __cb);
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResolutionDescriptions(Callback_PyramidService_getResolutionDescriptions __cb)
    {
        return begin_getResolutionDescriptions(null, false, __cb);
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResolutionDescriptions(java.util.Map<String, String> __ctx, Callback_PyramidService_getResolutionDescriptions __cb)
    {
        return begin_getResolutionDescriptions(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getResolutionDescriptions(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getResolutionDescriptions_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getResolutionDescriptions_name, __cb);
        try
        {
            __result.__prepare(__getResolutionDescriptions_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public ResolutionDescription[] end_getResolutionDescriptions(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getResolutionDescriptions_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            ResolutionDescription[] __ret;
            __ret = ResolutionDescriptionsHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     **/
    public boolean getResolutionDescriptions_async(AMI_PyramidService_getResolutionDescriptions __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getResolutionDescriptions_name);
            __r = begin_getResolutionDescriptions(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getResolutionDescriptions_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getResolutionDescriptions_async(AMI_PyramidService_getResolutionDescriptions __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getResolutionDescriptions_name);
            __r = begin_getResolutionDescriptions(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getResolutionDescriptions_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getResolutionLevel_name = "getResolutionLevel";

    /**
     * Retrieves the active resolution level.
     * @return The active resolution level.
     **/
    public int getResolutionLevel()
        throws omero.ServerError
    {
        return getResolutionLevel(null, false);
    }

    /**
     * Retrieves the active resolution level.
     * @param __ctx The Context map to send with the invocation.
     * @return The active resolution level.
     **/
    public int getResolutionLevel(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getResolutionLevel(__ctx, true);
    }

    private int getResolutionLevel(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getResolutionLevel", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getResolutionLevel");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getResolutionLevel(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResolutionLevel()
    {
        return begin_getResolutionLevel(null, false, null);
    }

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResolutionLevel(java.util.Map<String, String> __ctx)
    {
        return begin_getResolutionLevel(__ctx, true, null);
    }

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResolutionLevel(Ice.Callback __cb)
    {
        return begin_getResolutionLevel(null, false, __cb);
    }

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResolutionLevel(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getResolutionLevel(__ctx, true, __cb);
    }

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResolutionLevel(Callback_PyramidService_getResolutionLevel __cb)
    {
        return begin_getResolutionLevel(null, false, __cb);
    }

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResolutionLevel(java.util.Map<String, String> __ctx, Callback_PyramidService_getResolutionLevel __cb)
    {
        return begin_getResolutionLevel(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getResolutionLevel(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getResolutionLevel_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getResolutionLevel_name, __cb);
        try
        {
            __result.__prepare(__getResolutionLevel_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) The active resolution level.
     **/
    public int end_getResolutionLevel(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getResolutionLevel_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int __ret;
            __ret = __is.readInt();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     **/
    public boolean getResolutionLevel_async(AMI_PyramidService_getResolutionLevel __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getResolutionLevel_name);
            __r = begin_getResolutionLevel(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getResolutionLevel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getResolutionLevel_async(AMI_PyramidService_getResolutionLevel __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getResolutionLevel_name);
            __r = begin_getResolutionLevel(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getResolutionLevel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getResolutionLevels_name = "getResolutionLevels";

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @return The number of resolution levels. This value does not
     * necessarily indicate either the presence or absence of a
     * pixels pyramid.
     **/
    public int getResolutionLevels()
        throws omero.ServerError
    {
        return getResolutionLevels(null, false);
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __ctx The Context map to send with the invocation.
     * @return The number of resolution levels. This value does not
     * necessarily indicate either the presence or absence of a
     * pixels pyramid.
     **/
    public int getResolutionLevels(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getResolutionLevels(__ctx, true);
    }

    private int getResolutionLevels(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getResolutionLevels", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getResolutionLevels");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getResolutionLevels(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResolutionLevels()
    {
        return begin_getResolutionLevels(null, false, null);
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResolutionLevels(java.util.Map<String, String> __ctx)
    {
        return begin_getResolutionLevels(__ctx, true, null);
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResolutionLevels(Ice.Callback __cb)
    {
        return begin_getResolutionLevels(null, false, __cb);
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResolutionLevels(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getResolutionLevels(__ctx, true, __cb);
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResolutionLevels(Callback_PyramidService_getResolutionLevels __cb)
    {
        return begin_getResolutionLevels(null, false, __cb);
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResolutionLevels(java.util.Map<String, String> __ctx, Callback_PyramidService_getResolutionLevels __cb)
    {
        return begin_getResolutionLevels(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getResolutionLevels(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getResolutionLevels_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getResolutionLevels_name, __cb);
        try
        {
            __result.__prepare(__getResolutionLevels_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) The number of resolution levels. This value does not
     * necessarily indicate either the presence or absence of a
     * pixels pyramid.
     **/
    public int end_getResolutionLevels(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getResolutionLevels_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int __ret;
            __ret = __is.readInt();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     **/
    public boolean getResolutionLevels_async(AMI_PyramidService_getResolutionLevels __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getResolutionLevels_name);
            __r = begin_getResolutionLevels(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getResolutionLevels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getResolutionLevels_async(AMI_PyramidService_getResolutionLevels __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getResolutionLevels_name);
            __r = begin_getResolutionLevels(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getResolutionLevels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getTileSize_name = "getTileSize";

    /**
     * Retrieves the tile size for the pixel store.
     * @return An array of <code>length = 2</code> where the first
     * value of the array is the tile width and the second value is
     * the tile height.
     **/
    public int[] getTileSize()
        throws omero.ServerError
    {
        return getTileSize(null, false);
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return An array of <code>length = 2</code> where the first
     * value of the array is the tile width and the second value is
     * the tile height.
     **/
    public int[] getTileSize(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getTileSize(__ctx, true);
    }

    private int[] getTileSize(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getTileSize", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getTileSize");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getTileSize(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getTileSize()
    {
        return begin_getTileSize(null, false, null);
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTileSize(java.util.Map<String, String> __ctx)
    {
        return begin_getTileSize(__ctx, true, null);
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getTileSize(Ice.Callback __cb)
    {
        return begin_getTileSize(null, false, __cb);
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTileSize(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getTileSize(__ctx, true, __cb);
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getTileSize(Callback_PyramidService_getTileSize __cb)
    {
        return begin_getTileSize(null, false, __cb);
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTileSize(java.util.Map<String, String> __ctx, Callback_PyramidService_getTileSize __cb)
    {
        return begin_getTileSize(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getTileSize(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getTileSize_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getTileSize_name, __cb);
        try
        {
            __result.__prepare(__getTileSize_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) An array of <code>length = 2</code> where the first
     * value of the array is the tile width and the second value is
     * the tile height.
     **/
    public int[] end_getTileSize(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getTileSize_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int[] __ret;
            __ret = Ice.IntSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     **/
    public boolean getTileSize_async(AMI_PyramidService_getTileSize __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getTileSize_name);
            __r = begin_getTileSize(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getTileSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getTileSize_async(AMI_PyramidService_getTileSize __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getTileSize_name);
            __r = begin_getTileSize(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getTileSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __requiresPixelsPyramid_name = "requiresPixelsPyramid";

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @return <code>true</code> if the pixels store requires a
     * pixels pyramid and <code>false</code> otherwise.
     **/
    public boolean requiresPixelsPyramid()
        throws omero.ServerError
    {
        return requiresPixelsPyramid(null, false);
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __ctx The Context map to send with the invocation.
     * @return <code>true</code> if the pixels store requires a
     * pixels pyramid and <code>false</code> otherwise.
     **/
    public boolean requiresPixelsPyramid(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return requiresPixelsPyramid(__ctx, true);
    }

    private boolean requiresPixelsPyramid(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "requiresPixelsPyramid", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("requiresPixelsPyramid");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.requiresPixelsPyramid(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_requiresPixelsPyramid()
    {
        return begin_requiresPixelsPyramid(null, false, null);
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_requiresPixelsPyramid(java.util.Map<String, String> __ctx)
    {
        return begin_requiresPixelsPyramid(__ctx, true, null);
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_requiresPixelsPyramid(Ice.Callback __cb)
    {
        return begin_requiresPixelsPyramid(null, false, __cb);
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_requiresPixelsPyramid(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_requiresPixelsPyramid(__ctx, true, __cb);
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_requiresPixelsPyramid(Callback_PyramidService_requiresPixelsPyramid __cb)
    {
        return begin_requiresPixelsPyramid(null, false, __cb);
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_requiresPixelsPyramid(java.util.Map<String, String> __ctx, Callback_PyramidService_requiresPixelsPyramid __cb)
    {
        return begin_requiresPixelsPyramid(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_requiresPixelsPyramid(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__requiresPixelsPyramid_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __requiresPixelsPyramid_name, __cb);
        try
        {
            __result.__prepare(__requiresPixelsPyramid_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) <code>true</code> if the pixels store requires a
     * pixels pyramid and <code>false</code> otherwise.
     **/
    public boolean end_requiresPixelsPyramid(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __requiresPixelsPyramid_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     **/
    public boolean requiresPixelsPyramid_async(AMI_PyramidService_requiresPixelsPyramid __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__requiresPixelsPyramid_name);
            __r = begin_requiresPixelsPyramid(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __requiresPixelsPyramid_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean requiresPixelsPyramid_async(AMI_PyramidService_requiresPixelsPyramid __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__requiresPixelsPyramid_name);
            __r = begin_requiresPixelsPyramid(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __requiresPixelsPyramid_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setResolutionLevel_name = "setResolutionLevel";

    /**
     * Sets the active resolution level.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     **/
    public void setResolutionLevel(int resolutionLevel)
        throws omero.ServerError
    {
        setResolutionLevel(resolutionLevel, null, false);
    }

    /**
     * Sets the active resolution level.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setResolutionLevel(int resolutionLevel, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setResolutionLevel(resolutionLevel, __ctx, true);
    }

    private void setResolutionLevel(int resolutionLevel, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setResolutionLevel", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setResolutionLevel");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    __del.setResolutionLevel(resolutionLevel, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     **/
    public Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel)
    {
        return begin_setResolutionLevel(resolutionLevel, null, false, null);
    }

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel, java.util.Map<String, String> __ctx)
    {
        return begin_setResolutionLevel(resolutionLevel, __ctx, true, null);
    }

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     **/
    public Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel, Ice.Callback __cb)
    {
        return begin_setResolutionLevel(resolutionLevel, null, false, __cb);
    }

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setResolutionLevel(resolutionLevel, __ctx, true, __cb);
    }

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     **/
    public Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel, Callback_PyramidService_setResolutionLevel __cb)
    {
        return begin_setResolutionLevel(resolutionLevel, null, false, __cb);
    }

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel, java.util.Map<String, String> __ctx, Callback_PyramidService_setResolutionLevel __cb)
    {
        return begin_setResolutionLevel(resolutionLevel, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setResolutionLevel_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setResolutionLevel_name, __cb);
        try
        {
            __result.__prepare(__setResolutionLevel_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(resolutionLevel);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setResolutionLevel(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setResolutionLevel_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     **/
    public boolean setResolutionLevel_async(AMI_PyramidService_setResolutionLevel __cb, int resolutionLevel)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setResolutionLevel_name);
            __r = begin_setResolutionLevel(resolutionLevel, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setResolutionLevel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setResolutionLevel_async(AMI_PyramidService_setResolutionLevel __cb, int resolutionLevel, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setResolutionLevel_name);
            __r = begin_setResolutionLevel(resolutionLevel, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setResolutionLevel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __calculateMessageDigest_name = "calculateMessageDigest";

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @return byte array containing the message digest.
     **/
    public byte[] calculateMessageDigest()
        throws omero.ServerError
    {
        return calculateMessageDigest(null, false);
    }

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return byte array containing the message digest.
     **/
    public byte[] calculateMessageDigest(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return calculateMessageDigest(__ctx, true);
    }

    private byte[] calculateMessageDigest(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "calculateMessageDigest", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("calculateMessageDigest");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.calculateMessageDigest(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_calculateMessageDigest()
    {
        return begin_calculateMessageDigest(null, false, null);
    }

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_calculateMessageDigest(java.util.Map<String, String> __ctx)
    {
        return begin_calculateMessageDigest(__ctx, true, null);
    }

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_calculateMessageDigest(Ice.Callback __cb)
    {
        return begin_calculateMessageDigest(null, false, __cb);
    }

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_calculateMessageDigest(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_calculateMessageDigest(__ctx, true, __cb);
    }

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_calculateMessageDigest(Callback_RawPixelsStore_calculateMessageDigest __cb)
    {
        return begin_calculateMessageDigest(null, false, __cb);
    }

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_calculateMessageDigest(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_calculateMessageDigest __cb)
    {
        return begin_calculateMessageDigest(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_calculateMessageDigest(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__calculateMessageDigest_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __calculateMessageDigest_name, __cb);
        try
        {
            __result.__prepare(__calculateMessageDigest_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) byte array containing the message digest.
     **/
    public byte[] end_calculateMessageDigest(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __calculateMessageDigest_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __cb The callback object for the operation.
     **/
    public boolean calculateMessageDigest_async(AMI_RawPixelsStore_calculateMessageDigest __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__calculateMessageDigest_name);
            __r = begin_calculateMessageDigest(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __calculateMessageDigest_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Calculates a SHA-1 message digest for the entire pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean calculateMessageDigest_async(AMI_RawPixelsStore_calculateMessageDigest __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__calculateMessageDigest_name);
            __r = begin_calculateMessageDigest(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __calculateMessageDigest_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getByteWidth_name = "getByteWidth";

    /**
     * Returns the byte width for the pixel store.
     * @return See above.
     **/
    public int getByteWidth()
        throws omero.ServerError
    {
        return getByteWidth(null, false);
    }

    /**
     * Returns the byte width for the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public int getByteWidth(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getByteWidth(__ctx, true);
    }

    private int getByteWidth(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getByteWidth", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getByteWidth");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getByteWidth(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the byte width for the pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getByteWidth()
    {
        return begin_getByteWidth(null, false, null);
    }

    /**
     * Returns the byte width for the pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getByteWidth(java.util.Map<String, String> __ctx)
    {
        return begin_getByteWidth(__ctx, true, null);
    }

    /**
     * Returns the byte width for the pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getByteWidth(Ice.Callback __cb)
    {
        return begin_getByteWidth(null, false, __cb);
    }

    /**
     * Returns the byte width for the pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getByteWidth(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getByteWidth(__ctx, true, __cb);
    }

    /**
     * Returns the byte width for the pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getByteWidth(Callback_RawPixelsStore_getByteWidth __cb)
    {
        return begin_getByteWidth(null, false, __cb);
    }

    /**
     * Returns the byte width for the pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getByteWidth(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getByteWidth __cb)
    {
        return begin_getByteWidth(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getByteWidth(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getByteWidth_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getByteWidth_name, __cb);
        try
        {
            __result.__prepare(__getByteWidth_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) See above.
     **/
    public int end_getByteWidth(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getByteWidth_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int __ret;
            __ret = __is.readInt();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the byte width for the pixel store.
     * @param __cb The callback object for the operation.
     **/
    public boolean getByteWidth_async(AMI_RawPixelsStore_getByteWidth __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getByteWidth_name);
            __r = begin_getByteWidth(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getByteWidth_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the byte width for the pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getByteWidth_async(AMI_RawPixelsStore_getByteWidth __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getByteWidth_name);
            __r = begin_getByteWidth(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getByteWidth_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getCol_name = "getCol";

    /**
     * Retrieves a particular column from this pixel store.
     * @param x offset across the X-axis of the pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @return buffer containing the data which comprises this column.
     **/
    public byte[] getCol(int x, int z, int c, int t)
        throws omero.ServerError
    {
        return getCol(x, z, c, t, null, false);
    }

    /**
     * Retrieves a particular column from this pixel store.
     * @param x offset across the X-axis of the pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return buffer containing the data which comprises this column.
     **/
    public byte[] getCol(int x, int z, int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getCol(x, z, c, t, __ctx, true);
    }

    private byte[] getCol(int x, int z, int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getCol", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getCol");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getCol(x, z, c, t, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a particular column from this pixel store.
     * @param __cb The callback object for the operation.
     * @param x offset across the X-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     **/
    public Ice.AsyncResult begin_getCol(int x, int z, int c, int t)
    {
        return begin_getCol(x, z, c, t, null, false, null);
    }

    /**
     * Retrieves a particular column from this pixel store.
     * @param __cb The callback object for the operation.
     * @param x offset across the X-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCol(int x, int z, int c, int t, java.util.Map<String, String> __ctx)
    {
        return begin_getCol(x, z, c, t, __ctx, true, null);
    }

    /**
     * Retrieves a particular column from this pixel store.
     * @param __cb The callback object for the operation.
     * @param x offset across the X-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     **/
    public Ice.AsyncResult begin_getCol(int x, int z, int c, int t, Ice.Callback __cb)
    {
        return begin_getCol(x, z, c, t, null, false, __cb);
    }

    /**
     * Retrieves a particular column from this pixel store.
     * @param __cb The callback object for the operation.
     * @param x offset across the X-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCol(int x, int z, int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getCol(x, z, c, t, __ctx, true, __cb);
    }

    /**
     * Retrieves a particular column from this pixel store.
     * @param __cb The callback object for the operation.
     * @param x offset across the X-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     **/
    public Ice.AsyncResult begin_getCol(int x, int z, int c, int t, Callback_RawPixelsStore_getCol __cb)
    {
        return begin_getCol(x, z, c, t, null, false, __cb);
    }

    /**
     * Retrieves a particular column from this pixel store.
     * @param __cb The callback object for the operation.
     * @param x offset across the X-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCol(int x, int z, int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getCol __cb)
    {
        return begin_getCol(x, z, c, t, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getCol(int x, int z, int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getCol_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getCol_name, __cb);
        try
        {
            __result.__prepare(__getCol_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(x);
            __os.writeInt(z);
            __os.writeInt(c);
            __os.writeInt(t);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) buffer containing the data which comprises this column.
     **/
    public byte[] end_getCol(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getCol_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a particular column from this pixel store.
     * @param __cb The callback object for the operation.
     * @param x offset across the X-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     **/
    public boolean getCol_async(AMI_RawPixelsStore_getCol __cb, int x, int z, int c, int t)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCol_name);
            __r = begin_getCol(x, z, c, t, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCol_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a particular column from this pixel store.
     * @param __cb The callback object for the operation.
     * @param x offset across the X-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getCol_async(AMI_RawPixelsStore_getCol __cb, int x, int z, int c, int t, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCol_name);
            __r = begin_getCol(x, z, c, t, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCol_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getHistogram_name = "getHistogram";

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param channels the channels to generate the histogram data for
     * @param binCount the number of the histogram bins (optional, default: 256)
     * @param plane the plane (optional, default: whole region of first z/t plane)
     * @param globalRange use the global minimum/maximum to determine the histogram range, otherwise use plane minimum/maximum value
     * @return See above.
     **/
    public java.util.Map<java.lang.Integer, int[]> getHistogram(int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane)
        throws omero.ServerError
    {
        return getHistogram(channels, binCount, globalRange, plane, null, false);
    }

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param channels the channels to generate the histogram data for
     * @param binCount the number of the histogram bins (optional, default: 256)
     * @param plane the plane (optional, default: whole region of first z/t plane)
     * @param globalRange use the global minimum/maximum to determine the histogram range, otherwise use plane minimum/maximum value
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public java.util.Map<java.lang.Integer, int[]> getHistogram(int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getHistogram(channels, binCount, globalRange, plane, __ctx, true);
    }

    private java.util.Map<java.lang.Integer, int[]> getHistogram(int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getHistogram", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getHistogram");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getHistogram(channels, binCount, globalRange, plane, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param __cb The callback object for the operation.
     * @param channels the channels to generate the histogram data for
     * @param plane the plane (optional, default: whole region of first z/t plane)
     **/
    public Ice.AsyncResult begin_getHistogram(int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane)
    {
        return begin_getHistogram(channels, binCount, globalRange, plane, null, false, null);
    }

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param __cb The callback object for the operation.
     * @param channels the channels to generate the histogram data for
     * @param plane the plane (optional, default: whole region of first z/t plane)
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getHistogram(int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane, java.util.Map<String, String> __ctx)
    {
        return begin_getHistogram(channels, binCount, globalRange, plane, __ctx, true, null);
    }

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param __cb The callback object for the operation.
     * @param channels the channels to generate the histogram data for
     * @param plane the plane (optional, default: whole region of first z/t plane)
     **/
    public Ice.AsyncResult begin_getHistogram(int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane, Ice.Callback __cb)
    {
        return begin_getHistogram(channels, binCount, globalRange, plane, null, false, __cb);
    }

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param __cb The callback object for the operation.
     * @param channels the channels to generate the histogram data for
     * @param plane the plane (optional, default: whole region of first z/t plane)
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getHistogram(int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getHistogram(channels, binCount, globalRange, plane, __ctx, true, __cb);
    }

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param __cb The callback object for the operation.
     * @param channels the channels to generate the histogram data for
     * @param plane the plane (optional, default: whole region of first z/t plane)
     **/
    public Ice.AsyncResult begin_getHistogram(int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane, Callback_RawPixelsStore_getHistogram __cb)
    {
        return begin_getHistogram(channels, binCount, globalRange, plane, null, false, __cb);
    }

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param __cb The callback object for the operation.
     * @param channels the channels to generate the histogram data for
     * @param plane the plane (optional, default: whole region of first z/t plane)
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getHistogram(int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getHistogram __cb)
    {
        return begin_getHistogram(channels, binCount, globalRange, plane, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getHistogram(int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getHistogram_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getHistogram_name, __cb);
        try
        {
            __result.__prepare(__getHistogram_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            IntegerArrayHelper.write(__os, channels);
            __os.writeInt(binCount);
            __os.writeBool(globalRange);
            __os.writeObject(plane);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) See above.
     **/
    public java.util.Map<java.lang.Integer, int[]> end_getHistogram(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getHistogram_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.Integer, int[]> __ret;
            __ret = IntegerIntegerArrayMapHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param __cb The callback object for the operation.
     * @param channels the channels to generate the histogram data for
     * @param plane the plane (optional, default: whole region of first z/t plane)
     **/
    public boolean getHistogram_async(AMI_RawPixelsStore_getHistogram __cb, int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getHistogram_name);
            __r = begin_getHistogram(channels, binCount, globalRange, plane, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getHistogram_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the histogram data for the specified plane and channels. This method can currently only handle non-pyramid images.
     * @param __cb The callback object for the operation.
     * @param channels the channels to generate the histogram data for
     * @param plane the plane (optional, default: whole region of first z/t plane)
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getHistogram_async(AMI_RawPixelsStore_getHistogram __cb, int[] channels, int binCount, boolean globalRange, omero.romio.PlaneDef plane, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getHistogram_name);
            __r = begin_getHistogram(channels, binCount, globalRange, plane, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getHistogram_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getHypercube_name = "getHypercube";

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param start offset for each dimension within pixel store.
     * @param size of each dimension (dependent on dimension).
     * @param step needed of each dimension (dependent on
     * dimension).
     * @return buffer containing the data.
     **/
    public byte[] getHypercube(java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step)
        throws omero.ServerError
    {
        return getHypercube(offset, size, step, null, false);
    }

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param start offset for each dimension within pixel store.
     * @param size of each dimension (dependent on dimension).
     * @param step needed of each dimension (dependent on
     * dimension).
     * @param __ctx The Context map to send with the invocation.
     * @return buffer containing the data.
     **/
    public byte[] getHypercube(java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getHypercube(offset, size, step, __ctx, true);
    }

    private byte[] getHypercube(java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getHypercube", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getHypercube");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getHypercube(offset, size, step, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size of each dimension (dependent on dimension).
     **/
    public Ice.AsyncResult begin_getHypercube(java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step)
    {
        return begin_getHypercube(offset, size, step, null, false, null);
    }

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size of each dimension (dependent on dimension).
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getHypercube(java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step, java.util.Map<String, String> __ctx)
    {
        return begin_getHypercube(offset, size, step, __ctx, true, null);
    }

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size of each dimension (dependent on dimension).
     **/
    public Ice.AsyncResult begin_getHypercube(java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step, Ice.Callback __cb)
    {
        return begin_getHypercube(offset, size, step, null, false, __cb);
    }

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size of each dimension (dependent on dimension).
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getHypercube(java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getHypercube(offset, size, step, __ctx, true, __cb);
    }

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size of each dimension (dependent on dimension).
     **/
    public Ice.AsyncResult begin_getHypercube(java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step, Callback_RawPixelsStore_getHypercube __cb)
    {
        return begin_getHypercube(offset, size, step, null, false, __cb);
    }

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size of each dimension (dependent on dimension).
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getHypercube(java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getHypercube __cb)
    {
        return begin_getHypercube(offset, size, step, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getHypercube(java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getHypercube_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getHypercube_name, __cb);
        try
        {
            __result.__prepare(__getHypercube_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.sys.IntListHelper.write(__os, offset);
            omero.sys.IntListHelper.write(__os, size);
            omero.sys.IntListHelper.write(__os, step);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) buffer containing the data.
     **/
    public byte[] end_getHypercube(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getHypercube_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size of each dimension (dependent on dimension).
     **/
    public boolean getHypercube_async(AMI_RawPixelsStore_getHypercube __cb, java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getHypercube_name);
            __r = begin_getHypercube(offset, size, step, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getHypercube_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a n-dimensional block from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size of each dimension (dependent on dimension).
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getHypercube_async(AMI_RawPixelsStore_getHypercube __cb, java.util.List<Integer> offset, java.util.List<Integer> size, java.util.List<Integer> step, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getHypercube_name);
            __r = begin_getHypercube(offset, size, step, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getHypercube_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getPixelsId_name = "getPixelsId";

    /**
     * Returns the current Pixels set identifier.
     * @return See above.
     **/
    public long getPixelsId()
        throws omero.ServerError
    {
        return getPixelsId(null, false);
    }

    /**
     * Returns the current Pixels set identifier.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public long getPixelsId(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getPixelsId(__ctx, true);
    }

    private long getPixelsId(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getPixelsId", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getPixelsId");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getPixelsId(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the current Pixels set identifier.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getPixelsId()
    {
        return begin_getPixelsId(null, false, null);
    }

    /**
     * Returns the current Pixels set identifier.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPixelsId(java.util.Map<String, String> __ctx)
    {
        return begin_getPixelsId(__ctx, true, null);
    }

    /**
     * Returns the current Pixels set identifier.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getPixelsId(Ice.Callback __cb)
    {
        return begin_getPixelsId(null, false, __cb);
    }

    /**
     * Returns the current Pixels set identifier.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPixelsId(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getPixelsId(__ctx, true, __cb);
    }

    /**
     * Returns the current Pixels set identifier.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getPixelsId(Callback_RawPixelsStore_getPixelsId __cb)
    {
        return begin_getPixelsId(null, false, __cb);
    }

    /**
     * Returns the current Pixels set identifier.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPixelsId(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getPixelsId __cb)
    {
        return begin_getPixelsId(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getPixelsId(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getPixelsId_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getPixelsId_name, __cb);
        try
        {
            __result.__prepare(__getPixelsId_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) See above.
     **/
    public long end_getPixelsId(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getPixelsId_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the current Pixels set identifier.
     * @param __cb The callback object for the operation.
     **/
    public boolean getPixelsId_async(AMI_RawPixelsStore_getPixelsId __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPixelsId_name);
            __r = begin_getPixelsId(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPixelsId_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the current Pixels set identifier.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getPixelsId_async(AMI_RawPixelsStore_getPixelsId __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPixelsId_name);
            __r = begin_getPixelsId(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPixelsId_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getPixelsPath_name = "getPixelsPath";

    /**
     * Returns the current Pixels path.
     * @return See above.
     **/
    public String getPixelsPath()
        throws omero.ServerError
    {
        return getPixelsPath(null, false);
    }

    /**
     * Returns the current Pixels path.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public String getPixelsPath(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getPixelsPath(__ctx, true);
    }

    private String getPixelsPath(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getPixelsPath", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getPixelsPath");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getPixelsPath(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the current Pixels path.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getPixelsPath()
    {
        return begin_getPixelsPath(null, false, null);
    }

    /**
     * Returns the current Pixels path.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPixelsPath(java.util.Map<String, String> __ctx)
    {
        return begin_getPixelsPath(__ctx, true, null);
    }

    /**
     * Returns the current Pixels path.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getPixelsPath(Ice.Callback __cb)
    {
        return begin_getPixelsPath(null, false, __cb);
    }

    /**
     * Returns the current Pixels path.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPixelsPath(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getPixelsPath(__ctx, true, __cb);
    }

    /**
     * Returns the current Pixels path.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getPixelsPath(Callback_RawPixelsStore_getPixelsPath __cb)
    {
        return begin_getPixelsPath(null, false, __cb);
    }

    /**
     * Returns the current Pixels path.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPixelsPath(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getPixelsPath __cb)
    {
        return begin_getPixelsPath(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getPixelsPath(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getPixelsPath_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getPixelsPath_name, __cb);
        try
        {
            __result.__prepare(__getPixelsPath_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) See above.
     **/
    public String end_getPixelsPath(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getPixelsPath_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            String __ret;
            __ret = __is.readString();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the current Pixels path.
     * @param __cb The callback object for the operation.
     **/
    public boolean getPixelsPath_async(AMI_RawPixelsStore_getPixelsPath __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPixelsPath_name);
            __r = begin_getPixelsPath(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPixelsPath_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the current Pixels path.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getPixelsPath_async(AMI_RawPixelsStore_getPixelsPath __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPixelsPath_name);
            __r = begin_getPixelsPath(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPixelsPath_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getPlane_name = "getPlane";

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @return buffer containing the data which comprises this 2D image plane.
     **/
    public byte[] getPlane(int z, int c, int t)
        throws omero.ServerError
    {
        return getPlane(z, c, t, null, false);
    }

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return buffer containing the data which comprises this 2D image plane.
     **/
    public byte[] getPlane(int z, int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getPlane(z, c, t, __ctx, true);
    }

    private byte[] getPlane(int z, int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getPlane", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getPlane");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getPlane(z, c, t, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     **/
    public Ice.AsyncResult begin_getPlane(int z, int c, int t)
    {
        return begin_getPlane(z, c, t, null, false, null);
    }

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPlane(int z, int c, int t, java.util.Map<String, String> __ctx)
    {
        return begin_getPlane(z, c, t, __ctx, true, null);
    }

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     **/
    public Ice.AsyncResult begin_getPlane(int z, int c, int t, Ice.Callback __cb)
    {
        return begin_getPlane(z, c, t, null, false, __cb);
    }

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPlane(int z, int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getPlane(z, c, t, __ctx, true, __cb);
    }

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     **/
    public Ice.AsyncResult begin_getPlane(int z, int c, int t, Callback_RawPixelsStore_getPlane __cb)
    {
        return begin_getPlane(z, c, t, null, false, __cb);
    }

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPlane(int z, int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getPlane __cb)
    {
        return begin_getPlane(z, c, t, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getPlane(int z, int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getPlane_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getPlane_name, __cb);
        try
        {
            __result.__prepare(__getPlane_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(z);
            __os.writeInt(c);
            __os.writeInt(t);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) buffer containing the data which comprises this 2D image plane.
     **/
    public byte[] end_getPlane(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getPlane_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     **/
    public boolean getPlane_async(AMI_RawPixelsStore_getPlane __cb, int z, int c, int t)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPlane_name);
            __r = begin_getPlane(z, c, t, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPlane_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a particular 2D image plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getPlane_async(AMI_RawPixelsStore_getPlane __cb, int z, int c, int t, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPlane_name);
            __r = begin_getPlane(z, c, t, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPlane_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getPlaneOffset_name = "getPlaneOffset";

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @return offset of the 2D image plane.
     **/
    public long getPlaneOffset(int z, int c, int t)
        throws omero.ServerError
    {
        return getPlaneOffset(z, c, t, null, false);
    }

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @return offset of the 2D image plane.
     **/
    public long getPlaneOffset(int z, int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getPlaneOffset(z, c, t, __ctx, true);
    }

    private long getPlaneOffset(int z, int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getPlaneOffset", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getPlaneOffset");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getPlaneOffset(z, c, t, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     **/
    public Ice.AsyncResult begin_getPlaneOffset(int z, int c, int t)
    {
        return begin_getPlaneOffset(z, c, t, null, false, null);
    }

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPlaneOffset(int z, int c, int t, java.util.Map<String, String> __ctx)
    {
        return begin_getPlaneOffset(z, c, t, __ctx, true, null);
    }

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     **/
    public Ice.AsyncResult begin_getPlaneOffset(int z, int c, int t, Ice.Callback __cb)
    {
        return begin_getPlaneOffset(z, c, t, null, false, __cb);
    }

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPlaneOffset(int z, int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getPlaneOffset(z, c, t, __ctx, true, __cb);
    }

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     **/
    public Ice.AsyncResult begin_getPlaneOffset(int z, int c, int t, Callback_RawPixelsStore_getPlaneOffset __cb)
    {
        return begin_getPlaneOffset(z, c, t, null, false, __cb);
    }

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPlaneOffset(int z, int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getPlaneOffset __cb)
    {
        return begin_getPlaneOffset(z, c, t, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getPlaneOffset(int z, int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getPlaneOffset_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getPlaneOffset_name, __cb);
        try
        {
            __result.__prepare(__getPlaneOffset_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(z);
            __os.writeInt(c);
            __os.writeInt(t);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) offset of the 2D image plane.
     **/
    public long end_getPlaneOffset(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getPlaneOffset_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     **/
    public boolean getPlaneOffset_async(AMI_RawPixelsStore_getPlaneOffset __cb, int z, int c, int t)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPlaneOffset_name);
            __r = begin_getPlaneOffset(z, c, t, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPlaneOffset_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the offset for a particular 2D image plane in this pixel
     * store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getPlaneOffset_async(AMI_RawPixelsStore_getPlaneOffset __cb, int z, int c, int t, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPlaneOffset_name);
            __r = begin_getPlaneOffset(z, c, t, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPlaneOffset_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getPlaneRegion_name = "getPlaneRegion";

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param count the number of pixels to retrieve.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     * @return buffer containing the data which comprises the region of the
     * given 2D image plane. It is guaranteed that this buffer will have been
     * byte swapped.
     **/
    public byte[] getPlaneRegion(int z, int c, int t, int size, int offset)
        throws omero.ServerError
    {
        return getPlaneRegion(z, c, t, size, offset, null, false);
    }

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param count the number of pixels to retrieve.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     * @param __ctx The Context map to send with the invocation.
     * @return buffer containing the data which comprises the region of the
     * given 2D image plane. It is guaranteed that this buffer will have been
     * byte swapped.
     **/
    public byte[] getPlaneRegion(int z, int c, int t, int size, int offset, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getPlaneRegion(z, c, t, size, offset, __ctx, true);
    }

    private byte[] getPlaneRegion(int z, int c, int t, int size, int offset, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getPlaneRegion", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getPlaneRegion");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getPlaneRegion(z, c, t, size, offset, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     **/
    public Ice.AsyncResult begin_getPlaneRegion(int z, int c, int t, int size, int offset)
    {
        return begin_getPlaneRegion(z, c, t, size, offset, null, false, null);
    }

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPlaneRegion(int z, int c, int t, int size, int offset, java.util.Map<String, String> __ctx)
    {
        return begin_getPlaneRegion(z, c, t, size, offset, __ctx, true, null);
    }

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     **/
    public Ice.AsyncResult begin_getPlaneRegion(int z, int c, int t, int size, int offset, Ice.Callback __cb)
    {
        return begin_getPlaneRegion(z, c, t, size, offset, null, false, __cb);
    }

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPlaneRegion(int z, int c, int t, int size, int offset, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getPlaneRegion(z, c, t, size, offset, __ctx, true, __cb);
    }

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     **/
    public Ice.AsyncResult begin_getPlaneRegion(int z, int c, int t, int size, int offset, Callback_RawPixelsStore_getPlaneRegion __cb)
    {
        return begin_getPlaneRegion(z, c, t, size, offset, null, false, __cb);
    }

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPlaneRegion(int z, int c, int t, int size, int offset, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getPlaneRegion __cb)
    {
        return begin_getPlaneRegion(z, c, t, size, offset, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getPlaneRegion(int z, int c, int t, int size, int offset, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getPlaneRegion_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getPlaneRegion_name, __cb);
        try
        {
            __result.__prepare(__getPlaneRegion_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(z);
            __os.writeInt(c);
            __os.writeInt(t);
            __os.writeInt(size);
            __os.writeInt(offset);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) buffer containing the data which comprises the region of the
     * given 2D image plane. It is guaranteed that this buffer will have been
     * byte swapped.
     **/
    public byte[] end_getPlaneRegion(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getPlaneRegion_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     **/
    public boolean getPlaneRegion_async(AMI_RawPixelsStore_getPlaneRegion __cb, int z, int c, int t, int size, int offset)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPlaneRegion_name);
            __r = begin_getPlaneRegion(z, c, t, size, offset, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPlaneRegion_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a region from a given plane from this pixel store.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param offset the offset at which to retrieve <code>count</code> pixels.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getPlaneRegion_async(AMI_RawPixelsStore_getPlaneRegion __cb, int z, int c, int t, int size, int offset, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPlaneRegion_name);
            __r = begin_getPlaneRegion(z, c, t, size, offset, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPlaneRegion_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getPlaneSize_name = "getPlaneSize";

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @return 2D image plane size in bytes
     * <code>sizeX*sizeY*byteWidth</code>.
     **/
    public long getPlaneSize()
        throws omero.ServerError
    {
        return getPlaneSize(null, false);
    }

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return 2D image plane size in bytes
     * <code>sizeX*sizeY*byteWidth</code>.
     **/
    public long getPlaneSize(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getPlaneSize(__ctx, true);
    }

    private long getPlaneSize(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getPlaneSize", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getPlaneSize");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getPlaneSize(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getPlaneSize()
    {
        return begin_getPlaneSize(null, false, null);
    }

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPlaneSize(java.util.Map<String, String> __ctx)
    {
        return begin_getPlaneSize(__ctx, true, null);
    }

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getPlaneSize(Ice.Callback __cb)
    {
        return begin_getPlaneSize(null, false, __cb);
    }

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPlaneSize(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getPlaneSize(__ctx, true, __cb);
    }

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getPlaneSize(Callback_RawPixelsStore_getPlaneSize __cb)
    {
        return begin_getPlaneSize(null, false, __cb);
    }

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPlaneSize(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getPlaneSize __cb)
    {
        return begin_getPlaneSize(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getPlaneSize(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getPlaneSize_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getPlaneSize_name, __cb);
        try
        {
            __result.__prepare(__getPlaneSize_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) 2D image plane size in bytes
     * <code>sizeX*sizeY*byteWidth</code>.
     **/
    public long end_getPlaneSize(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getPlaneSize_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __cb The callback object for the operation.
     **/
    public boolean getPlaneSize_async(AMI_RawPixelsStore_getPlaneSize __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPlaneSize_name);
            __r = begin_getPlaneSize(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPlaneSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the in memory size of a 2D image plane in this
     * pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getPlaneSize_async(AMI_RawPixelsStore_getPlaneSize __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPlaneSize_name);
            __r = begin_getPlaneSize(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPlaneSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getRegion_name = "getRegion";

    /**
     * Retrieves a region from this pixel store.
     * @param size byte width of the region to retrieve.
     * @param offset offset within the pixel store.
     * @return buffer containing the data.
     **/
    public byte[] getRegion(int size, long offset)
        throws omero.ServerError
    {
        return getRegion(size, offset, null, false);
    }

    /**
     * Retrieves a region from this pixel store.
     * @param size byte width of the region to retrieve.
     * @param offset offset within the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return buffer containing the data.
     **/
    public byte[] getRegion(int size, long offset, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getRegion(size, offset, __ctx, true);
    }

    private byte[] getRegion(int size, long offset, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getRegion", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getRegion");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getRegion(size, offset, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a region from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to retrieve.
     **/
    public Ice.AsyncResult begin_getRegion(int size, long offset)
    {
        return begin_getRegion(size, offset, null, false, null);
    }

    /**
     * Retrieves a region from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to retrieve.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRegion(int size, long offset, java.util.Map<String, String> __ctx)
    {
        return begin_getRegion(size, offset, __ctx, true, null);
    }

    /**
     * Retrieves a region from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to retrieve.
     **/
    public Ice.AsyncResult begin_getRegion(int size, long offset, Ice.Callback __cb)
    {
        return begin_getRegion(size, offset, null, false, __cb);
    }

    /**
     * Retrieves a region from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to retrieve.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRegion(int size, long offset, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getRegion(size, offset, __ctx, true, __cb);
    }

    /**
     * Retrieves a region from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to retrieve.
     **/
    public Ice.AsyncResult begin_getRegion(int size, long offset, Callback_RawPixelsStore_getRegion __cb)
    {
        return begin_getRegion(size, offset, null, false, __cb);
    }

    /**
     * Retrieves a region from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to retrieve.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRegion(int size, long offset, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getRegion __cb)
    {
        return begin_getRegion(size, offset, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getRegion(int size, long offset, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getRegion_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getRegion_name, __cb);
        try
        {
            __result.__prepare(__getRegion_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(size);
            __os.writeLong(offset);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) buffer containing the data.
     **/
    public byte[] end_getRegion(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getRegion_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a region from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to retrieve.
     **/
    public boolean getRegion_async(AMI_RawPixelsStore_getRegion __cb, int size, long offset)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getRegion_name);
            __r = begin_getRegion(size, offset, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getRegion_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a region from this pixel store.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to retrieve.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getRegion_async(AMI_RawPixelsStore_getRegion __cb, int size, long offset, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getRegion_name);
            __r = begin_getRegion(size, offset, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getRegion_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getRow_name = "getRow";

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param y offset across the Y-axis of the pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @return buffer containing the data which comprises this row
     * or scanline.
     **/
    public byte[] getRow(int y, int z, int c, int t)
        throws omero.ServerError
    {
        return getRow(y, z, c, t, null, false);
    }

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param y offset across the Y-axis of the pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return buffer containing the data which comprises this row
     * or scanline.
     **/
    public byte[] getRow(int y, int z, int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getRow(y, z, c, t, __ctx, true);
    }

    private byte[] getRow(int y, int z, int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getRow", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getRow");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getRow(y, z, c, t, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     **/
    public Ice.AsyncResult begin_getRow(int y, int z, int c, int t)
    {
        return begin_getRow(y, z, c, t, null, false, null);
    }

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRow(int y, int z, int c, int t, java.util.Map<String, String> __ctx)
    {
        return begin_getRow(y, z, c, t, __ctx, true, null);
    }

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     **/
    public Ice.AsyncResult begin_getRow(int y, int z, int c, int t, Ice.Callback __cb)
    {
        return begin_getRow(y, z, c, t, null, false, __cb);
    }

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRow(int y, int z, int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getRow(y, z, c, t, __ctx, true, __cb);
    }

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     **/
    public Ice.AsyncResult begin_getRow(int y, int z, int c, int t, Callback_RawPixelsStore_getRow __cb)
    {
        return begin_getRow(y, z, c, t, null, false, __cb);
    }

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRow(int y, int z, int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getRow __cb)
    {
        return begin_getRow(y, z, c, t, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getRow(int y, int z, int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getRow_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getRow_name, __cb);
        try
        {
            __result.__prepare(__getRow_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(y);
            __os.writeInt(z);
            __os.writeInt(c);
            __os.writeInt(t);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) buffer containing the data which comprises this row
     * or scanline.
     **/
    public byte[] end_getRow(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getRow_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     **/
    public boolean getRow_async(AMI_RawPixelsStore_getRow __cb, int y, int z, int c, int t)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getRow_name);
            __r = begin_getRow(y, z, c, t, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getRow_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a particular row or scanline from this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getRow_async(AMI_RawPixelsStore_getRow __cb, int y, int z, int c, int t, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getRow_name);
            __r = begin_getRow(y, z, c, t, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getRow_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getRowOffset_name = "getRowOffset";

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @return offset of the row or scanline.
     **/
    public long getRowOffset(int y, int z, int c, int t)
        throws omero.ServerError
    {
        return getRowOffset(y, z, c, t, null, false);
    }

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @return offset of the row or scanline.
     **/
    public long getRowOffset(int y, int z, int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getRowOffset(y, z, c, t, __ctx, true);
    }

    private long getRowOffset(int y, int z, int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getRowOffset", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getRowOffset");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getRowOffset(y, z, c, t, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     **/
    public Ice.AsyncResult begin_getRowOffset(int y, int z, int c, int t)
    {
        return begin_getRowOffset(y, z, c, t, null, false, null);
    }

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRowOffset(int y, int z, int c, int t, java.util.Map<String, String> __ctx)
    {
        return begin_getRowOffset(y, z, c, t, __ctx, true, null);
    }

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     **/
    public Ice.AsyncResult begin_getRowOffset(int y, int z, int c, int t, Ice.Callback __cb)
    {
        return begin_getRowOffset(y, z, c, t, null, false, __cb);
    }

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRowOffset(int y, int z, int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getRowOffset(y, z, c, t, __ctx, true, __cb);
    }

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     **/
    public Ice.AsyncResult begin_getRowOffset(int y, int z, int c, int t, Callback_RawPixelsStore_getRowOffset __cb)
    {
        return begin_getRowOffset(y, z, c, t, null, false, __cb);
    }

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRowOffset(int y, int z, int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getRowOffset __cb)
    {
        return begin_getRowOffset(y, z, c, t, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getRowOffset(int y, int z, int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getRowOffset_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getRowOffset_name, __cb);
        try
        {
            __result.__prepare(__getRowOffset_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(y);
            __os.writeInt(z);
            __os.writeInt(c);
            __os.writeInt(t);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) offset of the row or scanline.
     **/
    public long end_getRowOffset(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getRowOffset_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     **/
    public boolean getRowOffset_async(AMI_RawPixelsStore_getRowOffset __cb, int y, int z, int c, int t)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getRowOffset_name);
            __r = begin_getRowOffset(y, z, c, t, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getRowOffset_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the offset for a particular row or scanline in
     * this pixel store.
     * @param __cb The callback object for the operation.
     * @param y offset across the Y-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getRowOffset_async(AMI_RawPixelsStore_getRowOffset __cb, int y, int z, int c, int t, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getRowOffset_name);
            __r = begin_getRowOffset(y, z, c, t, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getRowOffset_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getRowSize_name = "getRowSize";

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @return row or scanline size in bytes
     * <codesizeX*byteWidth</code>
     **/
    public int getRowSize()
        throws omero.ServerError
    {
        return getRowSize(null, false);
    }

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return row or scanline size in bytes
     * <codesizeX*byteWidth</code>
     **/
    public int getRowSize(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getRowSize(__ctx, true);
    }

    private int getRowSize(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getRowSize", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getRowSize");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getRowSize(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getRowSize()
    {
        return begin_getRowSize(null, false, null);
    }

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRowSize(java.util.Map<String, String> __ctx)
    {
        return begin_getRowSize(__ctx, true, null);
    }

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getRowSize(Ice.Callback __cb)
    {
        return begin_getRowSize(null, false, __cb);
    }

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRowSize(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getRowSize(__ctx, true, __cb);
    }

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getRowSize(Callback_RawPixelsStore_getRowSize __cb)
    {
        return begin_getRowSize(null, false, __cb);
    }

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRowSize(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getRowSize __cb)
    {
        return begin_getRowSize(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getRowSize(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getRowSize_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getRowSize_name, __cb);
        try
        {
            __result.__prepare(__getRowSize_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) row or scanline size in bytes
     * <codesizeX*byteWidth</code>
     **/
    public int end_getRowSize(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getRowSize_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int __ret;
            __ret = __is.readInt();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __cb The callback object for the operation.
     **/
    public boolean getRowSize_async(AMI_RawPixelsStore_getRowSize __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getRowSize_name);
            __r = begin_getRowSize(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getRowSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the in memory size of a row or scanline of pixels
     * in this pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getRowSize_async(AMI_RawPixelsStore_getRowSize __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getRowSize_name);
            __r = begin_getRowSize(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getRowSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getStack_name = "getStack";

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @return buffer containing the data which comprises this stack.
     **/
    public byte[] getStack(int c, int t)
        throws omero.ServerError
    {
        return getStack(c, t, null, false);
    }

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return buffer containing the data which comprises this stack.
     **/
    public byte[] getStack(int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getStack(c, t, __ctx, true);
    }

    private byte[] getStack(int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getStack", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getStack");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getStack(c, t, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel store.
     **/
    public Ice.AsyncResult begin_getStack(int c, int t)
    {
        return begin_getStack(c, t, null, false, null);
    }

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getStack(int c, int t, java.util.Map<String, String> __ctx)
    {
        return begin_getStack(c, t, __ctx, true, null);
    }

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel store.
     **/
    public Ice.AsyncResult begin_getStack(int c, int t, Ice.Callback __cb)
    {
        return begin_getStack(c, t, null, false, __cb);
    }

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getStack(int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getStack(c, t, __ctx, true, __cb);
    }

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel store.
     **/
    public Ice.AsyncResult begin_getStack(int c, int t, Callback_RawPixelsStore_getStack __cb)
    {
        return begin_getStack(c, t, null, false, __cb);
    }

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getStack(int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getStack __cb)
    {
        return begin_getStack(c, t, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getStack(int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getStack_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getStack_name, __cb);
        try
        {
            __result.__prepare(__getStack_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(c);
            __os.writeInt(t);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) buffer containing the data which comprises this stack.
     **/
    public byte[] end_getStack(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getStack_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel store.
     **/
    public boolean getStack_async(AMI_RawPixelsStore_getStack __cb, int c, int t)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getStack_name);
            __r = begin_getStack(c, t, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getStack_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getStack_async(AMI_RawPixelsStore_getStack __cb, int c, int t, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getStack_name);
            __r = begin_getStack(c, t, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getStack_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getStackOffset_name = "getStackOffset";

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @return offset of the stack.
     **/
    public long getStackOffset(int c, int t)
        throws omero.ServerError
    {
        return getStackOffset(c, t, null, false);
    }

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @return offset of the stack.
     **/
    public long getStackOffset(int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getStackOffset(c, t, __ctx, true);
    }

    private long getStackOffset(int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getStackOffset", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getStackOffset");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getStackOffset(c, t, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel buffer.
     **/
    public Ice.AsyncResult begin_getStackOffset(int c, int t)
    {
        return begin_getStackOffset(c, t, null, false, null);
    }

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getStackOffset(int c, int t, java.util.Map<String, String> __ctx)
    {
        return begin_getStackOffset(c, t, __ctx, true, null);
    }

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel buffer.
     **/
    public Ice.AsyncResult begin_getStackOffset(int c, int t, Ice.Callback __cb)
    {
        return begin_getStackOffset(c, t, null, false, __cb);
    }

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getStackOffset(int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getStackOffset(c, t, __ctx, true, __cb);
    }

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel buffer.
     **/
    public Ice.AsyncResult begin_getStackOffset(int c, int t, Callback_RawPixelsStore_getStackOffset __cb)
    {
        return begin_getStackOffset(c, t, null, false, __cb);
    }

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getStackOffset(int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getStackOffset __cb)
    {
        return begin_getStackOffset(c, t, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getStackOffset(int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getStackOffset_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getStackOffset_name, __cb);
        try
        {
            __result.__prepare(__getStackOffset_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(c);
            __os.writeInt(t);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) offset of the stack.
     **/
    public long end_getStackOffset(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getStackOffset_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel buffer.
     **/
    public boolean getStackOffset_async(AMI_RawPixelsStore_getStackOffset __cb, int c, int t)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getStackOffset_name);
            __r = begin_getStackOffset(c, t, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getStackOffset_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the offset for the entire number of optical
     * sections for a <b>single</b> wavelength or channel at a
     * particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param c offset across the C-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getStackOffset_async(AMI_RawPixelsStore_getStackOffset __cb, int c, int t, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getStackOffset_name);
            __r = begin_getStackOffset(c, t, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getStackOffset_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getStackSize_name = "getStackSize";

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @return stack size in bytes
     * <code>sizeX*sizeY*byteWidth</code>.
     **/
    public long getStackSize()
        throws omero.ServerError
    {
        return getStackSize(null, false);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return stack size in bytes
     * <code>sizeX*sizeY*byteWidth</code>.
     **/
    public long getStackSize(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getStackSize(__ctx, true);
    }

    private long getStackSize(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getStackSize", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getStackSize");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getStackSize(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getStackSize()
    {
        return begin_getStackSize(null, false, null);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getStackSize(java.util.Map<String, String> __ctx)
    {
        return begin_getStackSize(__ctx, true, null);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getStackSize(Ice.Callback __cb)
    {
        return begin_getStackSize(null, false, __cb);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getStackSize(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getStackSize(__ctx, true, __cb);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getStackSize(Callback_RawPixelsStore_getStackSize __cb)
    {
        return begin_getStackSize(null, false, __cb);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getStackSize(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getStackSize __cb)
    {
        return begin_getStackSize(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getStackSize(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getStackSize_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getStackSize_name, __cb);
        try
        {
            __result.__prepare(__getStackSize_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) stack size in bytes
     * <code>sizeX*sizeY*byteWidth</code>.
     **/
    public long end_getStackSize(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getStackSize_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getStackSize_async(AMI_RawPixelsStore_getStackSize __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getStackSize_name);
            __r = begin_getStackSize(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getStackSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for a <b>single</b> wavelength or channel
     * at a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getStackSize_async(AMI_RawPixelsStore_getStackSize __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getStackSize_name);
            __r = begin_getStackSize(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getStackSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getTile_name = "getTile";

    /**
     * Retrieves a tile from this pixel buffer.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param y Top left corner of the tile, Y offset.
     * @param w Width of the tile.
     * @param h Height of the tile.
     * @return buffer containing the data.
     **/
    public byte[] getTile(int z, int c, int t, int x, int y, int w, int h)
        throws omero.ServerError
    {
        return getTile(z, c, t, x, y, w, h, null, false);
    }

    /**
     * Retrieves a tile from this pixel buffer.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param y Top left corner of the tile, Y offset.
     * @param w Width of the tile.
     * @param h Height of the tile.
     * @param __ctx The Context map to send with the invocation.
     * @return buffer containing the data.
     **/
    public byte[] getTile(int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getTile(z, c, t, x, y, w, h, __ctx, true);
    }

    private byte[] getTile(int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getTile", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getTile");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getTile(z, c, t, x, y, w, h, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a tile from this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param y Top left corner of the tile, Y offset.
     * @param h Height of the tile.
     **/
    public Ice.AsyncResult begin_getTile(int z, int c, int t, int x, int y, int w, int h)
    {
        return begin_getTile(z, c, t, x, y, w, h, null, false, null);
    }

    /**
     * Retrieves a tile from this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param y Top left corner of the tile, Y offset.
     * @param h Height of the tile.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTile(int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx)
    {
        return begin_getTile(z, c, t, x, y, w, h, __ctx, true, null);
    }

    /**
     * Retrieves a tile from this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param y Top left corner of the tile, Y offset.
     * @param h Height of the tile.
     **/
    public Ice.AsyncResult begin_getTile(int z, int c, int t, int x, int y, int w, int h, Ice.Callback __cb)
    {
        return begin_getTile(z, c, t, x, y, w, h, null, false, __cb);
    }

    /**
     * Retrieves a tile from this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param y Top left corner of the tile, Y offset.
     * @param h Height of the tile.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTile(int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getTile(z, c, t, x, y, w, h, __ctx, true, __cb);
    }

    /**
     * Retrieves a tile from this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param y Top left corner of the tile, Y offset.
     * @param h Height of the tile.
     **/
    public Ice.AsyncResult begin_getTile(int z, int c, int t, int x, int y, int w, int h, Callback_RawPixelsStore_getTile __cb)
    {
        return begin_getTile(z, c, t, x, y, w, h, null, false, __cb);
    }

    /**
     * Retrieves a tile from this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param y Top left corner of the tile, Y offset.
     * @param h Height of the tile.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTile(int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getTile __cb)
    {
        return begin_getTile(z, c, t, x, y, w, h, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getTile(int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getTile_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getTile_name, __cb);
        try
        {
            __result.__prepare(__getTile_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(z);
            __os.writeInt(c);
            __os.writeInt(t);
            __os.writeInt(x);
            __os.writeInt(y);
            __os.writeInt(w);
            __os.writeInt(h);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) buffer containing the data.
     **/
    public byte[] end_getTile(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getTile_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a tile from this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param y Top left corner of the tile, Y offset.
     * @param h Height of the tile.
     **/
    public boolean getTile_async(AMI_RawPixelsStore_getTile __cb, int z, int c, int t, int x, int y, int w, int h)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getTile_name);
            __r = begin_getTile(z, c, t, x, y, w, h, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getTile_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a tile from this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param y Top left corner of the tile, Y offset.
     * @param h Height of the tile.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getTile_async(AMI_RawPixelsStore_getTile __cb, int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getTile_name);
            __r = begin_getTile(z, c, t, x, y, w, h, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getTile_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getTimepoint_name = "getTimepoint";

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param t offset across the T-axis of the pixel store.
     **/
    public byte[] getTimepoint(int t)
        throws omero.ServerError
    {
        return getTimepoint(t, null, false);
    }

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public byte[] getTimepoint(int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getTimepoint(t, __ctx, true);
    }

    private byte[] getTimepoint(int t, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getTimepoint", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getTimepoint");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getTimepoint(t, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel store.
     **/
    public Ice.AsyncResult begin_getTimepoint(int t)
    {
        return begin_getTimepoint(t, null, false, null);
    }

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTimepoint(int t, java.util.Map<String, String> __ctx)
    {
        return begin_getTimepoint(t, __ctx, true, null);
    }

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel store.
     **/
    public Ice.AsyncResult begin_getTimepoint(int t, Ice.Callback __cb)
    {
        return begin_getTimepoint(t, null, false, __cb);
    }

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTimepoint(int t, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getTimepoint(t, __ctx, true, __cb);
    }

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel store.
     **/
    public Ice.AsyncResult begin_getTimepoint(int t, Callback_RawPixelsStore_getTimepoint __cb)
    {
        return begin_getTimepoint(t, null, false, __cb);
    }

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTimepoint(int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getTimepoint __cb)
    {
        return begin_getTimepoint(t, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getTimepoint(int t, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getTimepoint_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getTimepoint_name, __cb);
        try
        {
            __result.__prepare(__getTimepoint_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(t);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public byte[] end_getTimepoint(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getTimepoint_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel store.
     **/
    public boolean getTimepoint_async(AMI_RawPixelsStore_getTimepoint __cb, int t)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getTimepoint_name);
            __r = begin_getTimepoint(t, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getTimepoint_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getTimepoint_async(AMI_RawPixelsStore_getTimepoint __cb, int t, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getTimepoint_name);
            __r = begin_getTimepoint(t, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getTimepoint_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getTimepointOffset_name = "getTimepointOffset";

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param t offset across the T-axis of the pixel buffer.
     * @return offset of the timepoint.
     **/
    public long getTimepointOffset(int t)
        throws omero.ServerError
    {
        return getTimepointOffset(t, null, false);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     * @return offset of the timepoint.
     **/
    public long getTimepointOffset(int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getTimepointOffset(t, __ctx, true);
    }

    private long getTimepointOffset(int t, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getTimepointOffset", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getTimepointOffset");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getTimepointOffset(t, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel buffer.
     **/
    public Ice.AsyncResult begin_getTimepointOffset(int t)
    {
        return begin_getTimepointOffset(t, null, false, null);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTimepointOffset(int t, java.util.Map<String, String> __ctx)
    {
        return begin_getTimepointOffset(t, __ctx, true, null);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel buffer.
     **/
    public Ice.AsyncResult begin_getTimepointOffset(int t, Ice.Callback __cb)
    {
        return begin_getTimepointOffset(t, null, false, __cb);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTimepointOffset(int t, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getTimepointOffset(t, __ctx, true, __cb);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel buffer.
     **/
    public Ice.AsyncResult begin_getTimepointOffset(int t, Callback_RawPixelsStore_getTimepointOffset __cb)
    {
        return begin_getTimepointOffset(t, null, false, __cb);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTimepointOffset(int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getTimepointOffset __cb)
    {
        return begin_getTimepointOffset(t, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getTimepointOffset(int t, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getTimepointOffset_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getTimepointOffset_name, __cb);
        try
        {
            __result.__prepare(__getTimepointOffset_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(t);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) offset of the timepoint.
     **/
    public long end_getTimepointOffset(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getTimepointOffset_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel buffer.
     **/
    public boolean getTimepointOffset_async(AMI_RawPixelsStore_getTimepointOffset __cb, int t)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getTimepointOffset_name);
            __r = begin_getTimepointOffset(t, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getTimepointOffset_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * 
     * @param __cb The callback object for the operation.
     * @param t offset across the T-axis of the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getTimepointOffset_async(AMI_RawPixelsStore_getTimepointOffset __cb, int t, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getTimepointOffset_name);
            __r = begin_getTimepointOffset(t, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getTimepointOffset_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getTimepointSize_name = "getTimepointSize";

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @return timepoint size in bytes
     * <code>sizeX*sizeY*sizeZ*sizeC*byteWidth</code>.
     **/
    public long getTimepointSize()
        throws omero.ServerError
    {
        return getTimepointSize(null, false);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return timepoint size in bytes
     * <code>sizeX*sizeY*sizeZ*sizeC*byteWidth</code>.
     **/
    public long getTimepointSize(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getTimepointSize(__ctx, true);
    }

    private long getTimepointSize(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getTimepointSize", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getTimepointSize");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getTimepointSize(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getTimepointSize()
    {
        return begin_getTimepointSize(null, false, null);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTimepointSize(java.util.Map<String, String> __ctx)
    {
        return begin_getTimepointSize(__ctx, true, null);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getTimepointSize(Ice.Callback __cb)
    {
        return begin_getTimepointSize(null, false, __cb);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTimepointSize(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getTimepointSize(__ctx, true, __cb);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getTimepointSize(Callback_RawPixelsStore_getTimepointSize __cb)
    {
        return begin_getTimepointSize(null, false, __cb);
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTimepointSize(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getTimepointSize __cb)
    {
        return begin_getTimepointSize(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getTimepointSize(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getTimepointSize_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getTimepointSize_name, __cb);
        try
        {
            __result.__prepare(__getTimepointSize_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) timepoint size in bytes
     * <code>sizeX*sizeY*sizeZ*sizeC*byteWidth</code>.
     **/
    public long end_getTimepointSize(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getTimepointSize_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     **/
    public boolean getTimepointSize_async(AMI_RawPixelsStore_getTimepointSize __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getTimepointSize_name);
            __r = begin_getTimepointSize(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getTimepointSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the in memory size of the entire number of
     * optical sections for <b>all</b> wavelengths or channels at
     * a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getTimepointSize_async(AMI_RawPixelsStore_getTimepointSize __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getTimepointSize_name);
            __r = begin_getTimepointSize(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getTimepointSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getTotalSize_name = "getTotalSize";

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @return total size of the pixel size in bytes
     * <code>sizeX*sizeY*sizeZ*sizeC*sizeT*byteWidth</code>.
     **/
    public long getTotalSize()
        throws omero.ServerError
    {
        return getTotalSize(null, false);
    }

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return total size of the pixel size in bytes
     * <code>sizeX*sizeY*sizeZ*sizeC*sizeT*byteWidth</code>.
     **/
    public long getTotalSize(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getTotalSize(__ctx, true);
    }

    private long getTotalSize(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getTotalSize", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getTotalSize");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getTotalSize(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getTotalSize()
    {
        return begin_getTotalSize(null, false, null);
    }

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTotalSize(java.util.Map<String, String> __ctx)
    {
        return begin_getTotalSize(__ctx, true, null);
    }

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getTotalSize(Ice.Callback __cb)
    {
        return begin_getTotalSize(null, false, __cb);
    }

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTotalSize(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getTotalSize(__ctx, true, __cb);
    }

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getTotalSize(Callback_RawPixelsStore_getTotalSize __cb)
    {
        return begin_getTotalSize(null, false, __cb);
    }

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTotalSize(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_getTotalSize __cb)
    {
        return begin_getTotalSize(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getTotalSize(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getTotalSize_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getTotalSize_name, __cb);
        try
        {
            __result.__prepare(__getTotalSize_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) total size of the pixel size in bytes
     * <code>sizeX*sizeY*sizeZ*sizeC*sizeT*byteWidth</code>.
     **/
    public long end_getTotalSize(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getTotalSize_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __cb The callback object for the operation.
     **/
    public boolean getTotalSize_async(AMI_RawPixelsStore_getTotalSize __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getTotalSize_name);
            __r = begin_getTotalSize(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getTotalSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the in memory size of the entire pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getTotalSize_async(AMI_RawPixelsStore_getTotalSize __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getTotalSize_name);
            __r = begin_getTotalSize(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getTotalSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __isFloat_name = "isFloat";

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @return
     **/
    public boolean isFloat()
        throws omero.ServerError
    {
        return isFloat(null, false);
    }

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __ctx The Context map to send with the invocation.
     * @return
     **/
    public boolean isFloat(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return isFloat(__ctx, true);
    }

    private boolean isFloat(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isFloat", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isFloat");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.isFloat(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isFloat()
    {
        return begin_isFloat(null, false, null);
    }

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isFloat(java.util.Map<String, String> __ctx)
    {
        return begin_isFloat(__ctx, true, null);
    }

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isFloat(Ice.Callback __cb)
    {
        return begin_isFloat(null, false, __cb);
    }

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isFloat(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isFloat(__ctx, true, __cb);
    }

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isFloat(Callback_RawPixelsStore_isFloat __cb)
    {
        return begin_isFloat(null, false, __cb);
    }

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isFloat(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_isFloat __cb)
    {
        return begin_isFloat(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isFloat(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isFloat_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isFloat_name, __cb);
        try
        {
            __result.__prepare(__isFloat_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value)
     **/
    public boolean end_isFloat(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __isFloat_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __cb The callback object for the operation.
     **/
    public boolean isFloat_async(AMI_RawPixelsStore_isFloat __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isFloat_name);
            __r = begin_isFloat(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isFloat_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns whether or not the pixel buffer has floating point pixels.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isFloat_async(AMI_RawPixelsStore_isFloat __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isFloat_name);
            __r = begin_isFloat(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isFloat_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __isSigned_name = "isSigned";

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @return See above.
     **/
    public boolean isSigned()
        throws omero.ServerError
    {
        return isSigned(null, false);
    }

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public boolean isSigned(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return isSigned(__ctx, true);
    }

    private boolean isSigned(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isSigned", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isSigned");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.isSigned(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isSigned()
    {
        return begin_isSigned(null, false, null);
    }

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isSigned(java.util.Map<String, String> __ctx)
    {
        return begin_isSigned(__ctx, true, null);
    }

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isSigned(Ice.Callback __cb)
    {
        return begin_isSigned(null, false, __cb);
    }

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isSigned(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isSigned(__ctx, true, __cb);
    }

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isSigned(Callback_RawPixelsStore_isSigned __cb)
    {
        return begin_isSigned(null, false, __cb);
    }

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isSigned(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_isSigned __cb)
    {
        return begin_isSigned(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isSigned(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isSigned_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isSigned_name, __cb);
        try
        {
            __result.__prepare(__isSigned_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) See above.
     **/
    public boolean end_isSigned(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __isSigned_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __cb The callback object for the operation.
     **/
    public boolean isSigned_async(AMI_RawPixelsStore_isSigned __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isSigned_name);
            __r = begin_isSigned(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isSigned_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns whether or not the pixel store has signed pixels.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isSigned_async(AMI_RawPixelsStore_isSigned __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isSigned_name);
            __r = begin_isSigned(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isSigned_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __prepare_name = "prepare";

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param pixelsIds Pixels IDs to cache.
     **/
    public void prepare(java.util.List<Long> pixelsIds)
        throws omero.ServerError
    {
        prepare(pixelsIds, null, false);
    }

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param pixelsIds Pixels IDs to cache.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void prepare(java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        prepare(pixelsIds, __ctx, true);
    }

    private void prepare(java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "prepare", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("prepare");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    __del.prepare(pixelsIds, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsIds Pixels IDs to cache.
     **/
    public Ice.AsyncResult begin_prepare(java.util.List<Long> pixelsIds)
    {
        return begin_prepare(pixelsIds, null, false, null);
    }

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsIds Pixels IDs to cache.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_prepare(java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx)
    {
        return begin_prepare(pixelsIds, __ctx, true, null);
    }

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsIds Pixels IDs to cache.
     **/
    public Ice.AsyncResult begin_prepare(java.util.List<Long> pixelsIds, Ice.Callback __cb)
    {
        return begin_prepare(pixelsIds, null, false, __cb);
    }

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsIds Pixels IDs to cache.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_prepare(java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_prepare(pixelsIds, __ctx, true, __cb);
    }

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsIds Pixels IDs to cache.
     **/
    public Ice.AsyncResult begin_prepare(java.util.List<Long> pixelsIds, Callback_RawPixelsStore_prepare __cb)
    {
        return begin_prepare(pixelsIds, null, false, __cb);
    }

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsIds Pixels IDs to cache.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_prepare(java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_prepare __cb)
    {
        return begin_prepare(pixelsIds, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_prepare(java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__prepare_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __prepare_name, __cb);
        try
        {
            __result.__prepare(__prepare_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.sys.LongListHelper.write(__os, pixelsIds);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_prepare(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __prepare_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsIds Pixels IDs to cache.
     **/
    public boolean prepare_async(AMI_RawPixelsStore_prepare __cb, java.util.List<Long> pixelsIds)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__prepare_name);
            __r = begin_prepare(pixelsIds, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __prepare_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Prepares the stateful service with a cache of loaded Pixels
     * objects.
     * This method is designed to combat query overhead, where
     * many sets of Pixels are to be read from or written to, by
     * loading all the Pixels sets at once. Multiple calls will
     * result in the existing cache being overwritten.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsIds Pixels IDs to cache.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean prepare_async(AMI_RawPixelsStore_prepare __cb, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__prepare_name);
            __r = begin_prepare(pixelsIds, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __prepare_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __save_name = "save";

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     **/
    public omero.model.Pixels save()
        throws omero.ServerError
    {
        return save(null, false);
    }

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.Pixels save(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return save(__ctx, true);
    }

    private omero.model.Pixels save(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "save", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("save");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.save(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_save()
    {
        return begin_save(null, false, null);
    }

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx)
    {
        return begin_save(__ctx, true, null);
    }

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_save(Ice.Callback __cb)
    {
        return begin_save(null, false, __cb);
    }

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_save(__ctx, true, __cb);
    }

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_save(Callback_RawPixelsStore_save __cb)
    {
        return begin_save(null, false, __cb);
    }

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx, Callback_RawPixelsStore_save __cb)
    {
        return begin_save(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_save(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__save_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __save_name, __cb);
        try
        {
            __result.__prepare(__save_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.model.Pixels end_save(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __save_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.PixelsHolder __ret = new omero.model.PixelsHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean save_async(AMI_RawPixelsStore_save __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__save_name);
            __r = begin_save(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __save_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Save the current state of the pixels, updating the SHA1. This should
     * only be called AFTER all data is successfully set. Future invocations
     * of set methods may be disallowed. This read-only status will allow
     * background processing (generation of thumbnails, compression, etc)
     * to begin. More information under {@link RawPixelsStore}.
     * 
     * A null instance will be returned if no save was performed.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean save_async(AMI_RawPixelsStore_save __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__save_name);
            __r = begin_save(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __save_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setPixelsId_name = "setPixelsId";

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param pixelsId Pixels set identifier.
     * @param bypassOriginalFile Whether or not to bypass checking
     * for an original file to back the pixel buffer used
     * by this service. If requests are predominantly
     * <code>write-only</code> or involve the population of
     * a brand new pixel buffer using <code>true</code>
     * here is a safe optimization otherwise
     * <code>false</code> is expected.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public void setPixelsId(long pixelsId, boolean bypassOriginalFile)
        throws omero.ServerError
    {
        setPixelsId(pixelsId, bypassOriginalFile, null, false);
    }

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param pixelsId Pixels set identifier.
     * @param bypassOriginalFile Whether or not to bypass checking
     * for an original file to back the pixel buffer used
     * by this service. If requests are predominantly
     * <code>write-only</code> or involve the population of
     * a brand new pixel buffer using <code>true</code>
     * here is a safe optimization otherwise
     * <code>false</code> is expected.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setPixelsId(long pixelsId, boolean bypassOriginalFile, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setPixelsId(pixelsId, bypassOriginalFile, __ctx, true);
    }

    private void setPixelsId(long pixelsId, boolean bypassOriginalFile, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setPixelsId", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setPixelsId");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    __del.setPixelsId(pixelsId, bypassOriginalFile, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId Pixels set identifier.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, boolean bypassOriginalFile)
    {
        return begin_setPixelsId(pixelsId, bypassOriginalFile, null, false, null);
    }

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId Pixels set identifier.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, boolean bypassOriginalFile, java.util.Map<String, String> __ctx)
    {
        return begin_setPixelsId(pixelsId, bypassOriginalFile, __ctx, true, null);
    }

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId Pixels set identifier.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, boolean bypassOriginalFile, Ice.Callback __cb)
    {
        return begin_setPixelsId(pixelsId, bypassOriginalFile, null, false, __cb);
    }

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId Pixels set identifier.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, boolean bypassOriginalFile, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setPixelsId(pixelsId, bypassOriginalFile, __ctx, true, __cb);
    }

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId Pixels set identifier.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, boolean bypassOriginalFile, Callback_RawPixelsStore_setPixelsId __cb)
    {
        return begin_setPixelsId(pixelsId, bypassOriginalFile, null, false, __cb);
    }

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId Pixels set identifier.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, boolean bypassOriginalFile, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_setPixelsId __cb)
    {
        return begin_setPixelsId(pixelsId, bypassOriginalFile, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setPixelsId(long pixelsId, boolean bypassOriginalFile, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setPixelsId_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setPixelsId_name, __cb);
        try
        {
            __result.__prepare(__setPixelsId_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(pixelsId);
            __os.writeBool(bypassOriginalFile);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setPixelsId(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setPixelsId_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId Pixels set identifier.
     **/
    public boolean setPixelsId_async(AMI_RawPixelsStore_setPixelsId __cb, long pixelsId, boolean bypassOriginalFile)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setPixelsId_name);
            __r = begin_setPixelsId(pixelsId, bypassOriginalFile, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setPixelsId_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Initializes the stateful service for a given Pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId Pixels set identifier.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setPixelsId_async(AMI_RawPixelsStore_setPixelsId __cb, long pixelsId, boolean bypassOriginalFile, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setPixelsId_name);
            __r = begin_setPixelsId(pixelsId, bypassOriginalFile, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setPixelsId_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setPlane_name = "setPlane";

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public void setPlane(byte[] buf, int z, int c, int t)
        throws omero.ServerError
    {
        setPlane(buf, z, c, t, null, false);
    }

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setPlane(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setPlane(buf, z, c, t, __ctx, true);
    }

    private void setPlane(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setPlane", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setPlane");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    __del.setPlane(buf, z, c, t, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param c offset across the C-axis of the pixel store.
     **/
    public Ice.AsyncResult begin_setPlane(byte[] buf, int z, int c, int t)
    {
        return begin_setPlane(buf, z, c, t, null, false, null);
    }

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setPlane(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx)
    {
        return begin_setPlane(buf, z, c, t, __ctx, true, null);
    }

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param c offset across the C-axis of the pixel store.
     **/
    public Ice.AsyncResult begin_setPlane(byte[] buf, int z, int c, int t, Ice.Callback __cb)
    {
        return begin_setPlane(buf, z, c, t, null, false, __cb);
    }

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setPlane(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setPlane(buf, z, c, t, __ctx, true, __cb);
    }

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param c offset across the C-axis of the pixel store.
     **/
    public Ice.AsyncResult begin_setPlane(byte[] buf, int z, int c, int t, Callback_RawPixelsStore_setPlane __cb)
    {
        return begin_setPlane(buf, z, c, t, null, false, __cb);
    }

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setPlane(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_setPlane __cb)
    {
        return begin_setPlane(buf, z, c, t, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setPlane(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setPlane_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setPlane_name, __cb);
        try
        {
            __result.__prepare(__setPlane_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            Ice.ByteSeqHelper.write(__os, buf);
            __os.writeInt(z);
            __os.writeInt(c);
            __os.writeInt(t);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setPlane(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setPlane_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param c offset across the C-axis of the pixel store.
     **/
    public boolean setPlane_async(AMI_RawPixelsStore_setPlane __cb, byte[] buf, int z, int c, int t)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setPlane_name);
            __r = begin_setPlane(buf, z, c, t, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setPlane_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets a particular 2D image plane in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this 2D image plane.
     * @param c offset across the C-axis of the pixel store.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setPlane_async(AMI_RawPixelsStore_setPlane __cb, byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setPlane_name);
            __r = begin_setPlane(buf, z, c, t, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setPlane_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setRegion_name = "setRegion";

    /**
     * Sets a region in this pixel buffer.
     * @param size byte width of the region to set.
     * @param offset offset within the pixel buffer.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public void setRegion(int size, long offset, byte[] buf)
        throws omero.ServerError
    {
        setRegion(size, offset, buf, null, false);
    }

    /**
     * Sets a region in this pixel buffer.
     * @param size byte width of the region to set.
     * @param offset offset within the pixel buffer.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setRegion(int size, long offset, byte[] buf, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setRegion(size, offset, buf, __ctx, true);
    }

    private void setRegion(int size, long offset, byte[] buf, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setRegion", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setRegion");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    __del.setRegion(size, offset, buf, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets a region in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to set.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public Ice.AsyncResult begin_setRegion(int size, long offset, byte[] buf)
    {
        return begin_setRegion(size, offset, buf, null, false, null);
    }

    /**
     * Sets a region in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to set.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setRegion(int size, long offset, byte[] buf, java.util.Map<String, String> __ctx)
    {
        return begin_setRegion(size, offset, buf, __ctx, true, null);
    }

    /**
     * Sets a region in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to set.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public Ice.AsyncResult begin_setRegion(int size, long offset, byte[] buf, Ice.Callback __cb)
    {
        return begin_setRegion(size, offset, buf, null, false, __cb);
    }

    /**
     * Sets a region in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to set.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setRegion(int size, long offset, byte[] buf, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setRegion(size, offset, buf, __ctx, true, __cb);
    }

    /**
     * Sets a region in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to set.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public Ice.AsyncResult begin_setRegion(int size, long offset, byte[] buf, Callback_RawPixelsStore_setRegion __cb)
    {
        return begin_setRegion(size, offset, buf, null, false, __cb);
    }

    /**
     * Sets a region in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to set.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setRegion(int size, long offset, byte[] buf, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_setRegion __cb)
    {
        return begin_setRegion(size, offset, buf, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setRegion(int size, long offset, byte[] buf, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setRegion_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setRegion_name, __cb);
        try
        {
            __result.__prepare(__setRegion_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(size);
            __os.writeLong(offset);
            Ice.ByteSeqHelper.write(__os, buf);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setRegion(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setRegion_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets a region in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to set.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public boolean setRegion_async(AMI_RawPixelsStore_setRegion __cb, int size, long offset, byte[] buf)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setRegion_name);
            __r = begin_setRegion(size, offset, buf, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setRegion_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets a region in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param size byte width of the region to set.
     * @param buf a byte array of the data.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setRegion_async(AMI_RawPixelsStore_setRegion __cb, int size, long offset, byte[] buf, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setRegion_name);
            __r = begin_setRegion(size, offset, buf, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setRegion_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setRow_name = "setRow";

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param y offset across the Y-axis of the pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public void setRow(byte[] buf, int y, int z, int c, int t)
        throws omero.ServerError
    {
        setRow(buf, y, z, c, t, null, false);
    }

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param y offset across the Y-axis of the pixel store.
     * @param z offset across the Z-axis of the pixel store.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setRow(byte[] buf, int y, int z, int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setRow(buf, y, z, c, t, __ctx, true);
    }

    private void setRow(byte[] buf, int y, int z, int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setRow", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setRow");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    __del.setRow(buf, y, z, c, t, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public Ice.AsyncResult begin_setRow(byte[] buf, int y, int z, int c, int t)
    {
        return begin_setRow(buf, y, z, c, t, null, false, null);
    }

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setRow(byte[] buf, int y, int z, int c, int t, java.util.Map<String, String> __ctx)
    {
        return begin_setRow(buf, y, z, c, t, __ctx, true, null);
    }

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public Ice.AsyncResult begin_setRow(byte[] buf, int y, int z, int c, int t, Ice.Callback __cb)
    {
        return begin_setRow(buf, y, z, c, t, null, false, __cb);
    }

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setRow(byte[] buf, int y, int z, int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setRow(buf, y, z, c, t, __ctx, true, __cb);
    }

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public Ice.AsyncResult begin_setRow(byte[] buf, int y, int z, int c, int t, Callback_RawPixelsStore_setRow __cb)
    {
        return begin_setRow(buf, y, z, c, t, null, false, __cb);
    }

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setRow(byte[] buf, int y, int z, int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_setRow __cb)
    {
        return begin_setRow(buf, y, z, c, t, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setRow(byte[] buf, int y, int z, int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setRow_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setRow_name, __cb);
        try
        {
            __result.__prepare(__setRow_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            Ice.ByteSeqHelper.write(__os, buf);
            __os.writeInt(y);
            __os.writeInt(z);
            __os.writeInt(c);
            __os.writeInt(t);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setRow(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setRow_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public boolean setRow_async(AMI_RawPixelsStore_setRow __cb, byte[] buf, int y, int z, int c, int t)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setRow_name);
            __r = begin_setRow(buf, y, z, c, t, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setRow_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets a particular row or scanline in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this row or scanline.
     * @param z offset across the Z-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setRow_async(AMI_RawPixelsStore_setRow __cb, byte[] buf, int y, int z, int c, int t, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setRow_name);
            __r = begin_setRow(buf, y, z, c, t, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setRow_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setStack_name = "setStack";

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this stack.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public void setStack(byte[] buf, int z, int c, int t)
        throws omero.ServerError
    {
        setStack(buf, z, c, t, null, false);
    }

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this stack.
     * @param c offset across the C-axis of the pixel store.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setStack(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setStack(buf, z, c, t, __ctx, true);
    }

    private void setStack(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setStack", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setStack");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    __del.setStack(buf, z, c, t, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this stack.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public Ice.AsyncResult begin_setStack(byte[] buf, int z, int c, int t)
    {
        return begin_setStack(buf, z, c, t, null, false, null);
    }

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this stack.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setStack(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx)
    {
        return begin_setStack(buf, z, c, t, __ctx, true, null);
    }

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this stack.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public Ice.AsyncResult begin_setStack(byte[] buf, int z, int c, int t, Ice.Callback __cb)
    {
        return begin_setStack(buf, z, c, t, null, false, __cb);
    }

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this stack.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setStack(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setStack(buf, z, c, t, __ctx, true, __cb);
    }

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this stack.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public Ice.AsyncResult begin_setStack(byte[] buf, int z, int c, int t, Callback_RawPixelsStore_setStack __cb)
    {
        return begin_setStack(buf, z, c, t, null, false, __cb);
    }

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this stack.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setStack(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_setStack __cb)
    {
        return begin_setStack(buf, z, c, t, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setStack(byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setStack_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setStack_name, __cb);
        try
        {
            __result.__prepare(__setStack_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            Ice.ByteSeqHelper.write(__os, buf);
            __os.writeInt(z);
            __os.writeInt(c);
            __os.writeInt(t);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setStack(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setStack_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this stack.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public boolean setStack_async(AMI_RawPixelsStore_setStack __cb, byte[] buf, int z, int c, int t)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setStack_name);
            __r = begin_setStack(buf, z, c, t, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setStack_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets the entire number of optical sections for a <b>single</b>
     * wavelength or channel at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this stack.
     * @param t offset across the T-axis of the pixel store.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setStack_async(AMI_RawPixelsStore_setStack __cb, byte[] buf, int z, int c, int t, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setStack_name);
            __r = begin_setStack(buf, z, c, t, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setStack_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setTile_name = "setTile";

    /**
     * Sets a tile in this pixel buffer.
     * @param buf A byte array of the data.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param y Top left corner of the tile, Y offset.
     * @param w Width of the tile.
     * @param h Height of the tile.
     * @throws IOException if there is a problem writing to the pixel buffer.
     * @throws BufferOverflowException if an attempt is made to write off the
     * end of the file.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public void setTile(byte[] buf, int z, int c, int t, int x, int y, int w, int h)
        throws omero.ServerError
    {
        setTile(buf, z, c, t, x, y, w, h, null, false);
    }

    /**
     * Sets a tile in this pixel buffer.
     * @param buf A byte array of the data.
     * @param z offset across the Z-axis of the pixel buffer.
     * @param c offset across the C-axis of the pixel buffer.
     * @param t offset across the T-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param y Top left corner of the tile, Y offset.
     * @param w Width of the tile.
     * @param h Height of the tile.
     * @throws IOException if there is a problem writing to the pixel buffer.
     * @throws BufferOverflowException if an attempt is made to write off the
     * end of the file.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setTile(byte[] buf, int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setTile(buf, z, c, t, x, y, w, h, __ctx, true);
    }

    private void setTile(byte[] buf, int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setTile", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setTile");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    __del.setTile(buf, z, c, t, x, y, w, h, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets a tile in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param buf A byte array of the data.
     * @param c offset across the C-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param w Width of the tile.
     **/
    public Ice.AsyncResult begin_setTile(byte[] buf, int z, int c, int t, int x, int y, int w, int h)
    {
        return begin_setTile(buf, z, c, t, x, y, w, h, null, false, null);
    }

    /**
     * Sets a tile in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param buf A byte array of the data.
     * @param c offset across the C-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param w Width of the tile.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setTile(byte[] buf, int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx)
    {
        return begin_setTile(buf, z, c, t, x, y, w, h, __ctx, true, null);
    }

    /**
     * Sets a tile in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param buf A byte array of the data.
     * @param c offset across the C-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param w Width of the tile.
     **/
    public Ice.AsyncResult begin_setTile(byte[] buf, int z, int c, int t, int x, int y, int w, int h, Ice.Callback __cb)
    {
        return begin_setTile(buf, z, c, t, x, y, w, h, null, false, __cb);
    }

    /**
     * Sets a tile in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param buf A byte array of the data.
     * @param c offset across the C-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param w Width of the tile.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setTile(byte[] buf, int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setTile(buf, z, c, t, x, y, w, h, __ctx, true, __cb);
    }

    /**
     * Sets a tile in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param buf A byte array of the data.
     * @param c offset across the C-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param w Width of the tile.
     **/
    public Ice.AsyncResult begin_setTile(byte[] buf, int z, int c, int t, int x, int y, int w, int h, Callback_RawPixelsStore_setTile __cb)
    {
        return begin_setTile(buf, z, c, t, x, y, w, h, null, false, __cb);
    }

    /**
     * Sets a tile in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param buf A byte array of the data.
     * @param c offset across the C-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param w Width of the tile.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setTile(byte[] buf, int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_setTile __cb)
    {
        return begin_setTile(buf, z, c, t, x, y, w, h, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setTile(byte[] buf, int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setTile_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setTile_name, __cb);
        try
        {
            __result.__prepare(__setTile_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            Ice.ByteSeqHelper.write(__os, buf);
            __os.writeInt(z);
            __os.writeInt(c);
            __os.writeInt(t);
            __os.writeInt(x);
            __os.writeInt(y);
            __os.writeInt(w);
            __os.writeInt(h);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setTile(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setTile_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets a tile in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param buf A byte array of the data.
     * @param c offset across the C-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param w Width of the tile.
     **/
    public boolean setTile_async(AMI_RawPixelsStore_setTile __cb, byte[] buf, int z, int c, int t, int x, int y, int w, int h)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setTile_name);
            __r = begin_setTile(buf, z, c, t, x, y, w, h, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setTile_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets a tile in this pixel buffer.
     * @param __cb The callback object for the operation.
     * @param buf A byte array of the data.
     * @param c offset across the C-axis of the pixel buffer.
     * @param x Top left corner of the tile, X offset.
     * @param w Width of the tile.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setTile_async(AMI_RawPixelsStore_setTile __cb, byte[] buf, int z, int c, int t, int x, int y, int w, int h, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setTile_name);
            __r = begin_setTile(buf, z, c, t, x, y, w, h, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setTile_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setTimepoint_name = "setTimepoint";

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this timepoint.
     * @param t offset across the T-axis of the pixel buffer.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     **/
    public void setTimepoint(byte[] buf, int t)
        throws omero.ServerError
    {
        setTimepoint(buf, t, null, false);
    }

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param buf a byte array of the data comprising this timepoint.
     * @param t offset across the T-axis of the pixel buffer.
     * 
     * See <b>Read-only caveat</b> under {@link RawPixelsStore}
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setTimepoint(byte[] buf, int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setTimepoint(buf, t, __ctx, true);
    }

    private void setTimepoint(byte[] buf, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setTimepoint", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setTimepoint");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    __del.setTimepoint(buf, t, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this timepoint.
     **/
    public Ice.AsyncResult begin_setTimepoint(byte[] buf, int t)
    {
        return begin_setTimepoint(buf, t, null, false, null);
    }

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this timepoint.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setTimepoint(byte[] buf, int t, java.util.Map<String, String> __ctx)
    {
        return begin_setTimepoint(buf, t, __ctx, true, null);
    }

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this timepoint.
     **/
    public Ice.AsyncResult begin_setTimepoint(byte[] buf, int t, Ice.Callback __cb)
    {
        return begin_setTimepoint(buf, t, null, false, __cb);
    }

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this timepoint.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setTimepoint(byte[] buf, int t, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setTimepoint(buf, t, __ctx, true, __cb);
    }

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this timepoint.
     **/
    public Ice.AsyncResult begin_setTimepoint(byte[] buf, int t, Callback_RawPixelsStore_setTimepoint __cb)
    {
        return begin_setTimepoint(buf, t, null, false, __cb);
    }

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this timepoint.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setTimepoint(byte[] buf, int t, java.util.Map<String, String> __ctx, Callback_RawPixelsStore_setTimepoint __cb)
    {
        return begin_setTimepoint(buf, t, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setTimepoint(byte[] buf, int t, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setTimepoint_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setTimepoint_name, __cb);
        try
        {
            __result.__prepare(__setTimepoint_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            Ice.ByteSeqHelper.write(__os, buf);
            __os.writeInt(t);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setTimepoint(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setTimepoint_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this timepoint.
     **/
    public boolean setTimepoint_async(AMI_RawPixelsStore_setTimepoint __cb, byte[] buf, int t)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setTimepoint_name);
            __r = begin_setTimepoint(buf, t, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setTimepoint_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets the entire number of optical sections for <b>all</b>
     * wavelengths or channels at a particular timepoint in this pixel store.
     * @param __cb The callback object for the operation.
     * @param buf a byte array of the data comprising this timepoint.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setTimepoint_async(AMI_RawPixelsStore_setTimepoint __cb, byte[] buf, int t, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setTimepoint_name);
            __r = begin_setTimepoint(buf, t, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setTimepoint_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __activate_name = "activate";

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     **/
    public void activate()
        throws omero.ServerError
    {
        activate(null, false);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void activate(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        activate(__ctx, true);
    }

    private void activate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "activate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("activate");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    __del.activate(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate()
    {
        return begin_activate(null, false, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx)
    {
        return begin_activate(__ctx, true, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate(Ice.Callback __cb)
    {
        return begin_activate(null, false, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_activate(__ctx, true, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate(Callback_StatefulServiceInterface_activate __cb)
    {
        return begin_activate(null, false, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_activate __cb)
    {
        return begin_activate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__activate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
        try
        {
            __result.__prepare(__activate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_activate(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __activate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public boolean activate_async(AMI_StatefulServiceInterface_activate __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__activate_name);
            __r = begin_activate(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean activate_async(AMI_StatefulServiceInterface_activate __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__activate_name);
            __r = begin_activate(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __close_name = "close";

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     **/
    public void close()
        throws omero.ServerError
    {
        close(null, false);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void close(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        close(__ctx, true);
    }

    private void close(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "close", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("close");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    __del.close(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close()
    {
        return begin_close(null, false, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx)
    {
        return begin_close(__ctx, true, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close(Ice.Callback __cb)
    {
        return begin_close(null, false, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_close(__ctx, true, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close(Callback_StatefulServiceInterface_close __cb)
    {
        return begin_close(null, false, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_close __cb)
    {
        return begin_close(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__close_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __close_name, __cb);
        try
        {
            __result.__prepare(__close_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_close(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __close_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public boolean close_async(AMI_StatefulServiceInterface_close __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__close_name);
            __r = begin_close(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __close_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean close_async(AMI_StatefulServiceInterface_close __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__close_name);
            __r = begin_close(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __close_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getCurrentEventContext_name = "getCurrentEventContext";

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     **/
    public omero.sys.EventContext getCurrentEventContext()
        throws omero.ServerError
    {
        return getCurrentEventContext(null, false);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.sys.EventContext getCurrentEventContext(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getCurrentEventContext(__ctx, true);
    }

    private omero.sys.EventContext getCurrentEventContext(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getCurrentEventContext", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getCurrentEventContext");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    return __del.getCurrentEventContext(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext()
    {
        return begin_getCurrentEventContext(null, false, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx)
    {
        return begin_getCurrentEventContext(__ctx, true, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(Ice.Callback __cb)
    {
        return begin_getCurrentEventContext(null, false, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getCurrentEventContext(__ctx, true, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(Callback_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        return begin_getCurrentEventContext(null, false, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        return begin_getCurrentEventContext(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getCurrentEventContext_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
        try
        {
            __result.__prepare(__getCurrentEventContext_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.sys.EventContext end_getCurrentEventContext(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getCurrentEventContext_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.sys.EventContextHolder __ret = new omero.sys.EventContextHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public boolean getCurrentEventContext_async(AMI_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCurrentEventContext_name);
            __r = begin_getCurrentEventContext(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getCurrentEventContext_async(AMI_StatefulServiceInterface_getCurrentEventContext __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCurrentEventContext_name);
            __r = begin_getCurrentEventContext(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __passivate_name = "passivate";

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     **/
    public void passivate()
        throws omero.ServerError
    {
        passivate(null, false);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void passivate(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        passivate(__ctx, true);
    }

    private void passivate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "passivate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("passivate");
                    __delBase = __getDelegate(false);
                    _RawPixelsStoreDel __del = (_RawPixelsStoreDel)__delBase;
                    __del.passivate(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate()
    {
        return begin_passivate(null, false, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx)
    {
        return begin_passivate(__ctx, true, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate(Ice.Callback __cb)
    {
        return begin_passivate(null, false, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_passivate(__ctx, true, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate(Callback_StatefulServiceInterface_passivate __cb)
    {
        return begin_passivate(null, false, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_passivate __cb)
    {
        return begin_passivate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__passivate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
        try
        {
            __result.__prepare(__passivate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_passivate(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __passivate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public boolean passivate_async(AMI_StatefulServiceInterface_passivate __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__passivate_name);
            __r = begin_passivate(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean passivate_async(AMI_StatefulServiceInterface_passivate __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__passivate_name);
            __r = begin_passivate(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static RawPixelsStorePrx checkedCast(Ice.ObjectPrx __obj)
    {
        RawPixelsStorePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof RawPixelsStorePrx)
            {
                __d = (RawPixelsStorePrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    RawPixelsStorePrxHelper __h = new RawPixelsStorePrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static RawPixelsStorePrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        RawPixelsStorePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof RawPixelsStorePrx)
            {
                __d = (RawPixelsStorePrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    RawPixelsStorePrxHelper __h = new RawPixelsStorePrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static RawPixelsStorePrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        RawPixelsStorePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    RawPixelsStorePrxHelper __h = new RawPixelsStorePrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static RawPixelsStorePrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        RawPixelsStorePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    RawPixelsStorePrxHelper __h = new RawPixelsStorePrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static RawPixelsStorePrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        RawPixelsStorePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof RawPixelsStorePrx)
            {
                __d = (RawPixelsStorePrx)__obj;
            }
            else
            {
                RawPixelsStorePrxHelper __h = new RawPixelsStorePrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static RawPixelsStorePrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        RawPixelsStorePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            RawPixelsStorePrxHelper __h = new RawPixelsStorePrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::PyramidService",
        "::omero::api::RawPixelsStore",
        "::omero::api::ServiceInterface",
        "::omero::api::StatefulServiceInterface"
    };

    public static String ice_staticId()
    {
        return __ids[2];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _RawPixelsStoreDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _RawPixelsStoreDelD();
    }

    public static void __write(IceInternal.BasicStream __os, RawPixelsStorePrx v)
    {
        __os.writeProxy(v);
    }

    public static RawPixelsStorePrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            RawPixelsStorePrxHelper result = new RawPixelsStorePrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
