// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `RenderingEngine.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Defines a service to render a given pixels set.
 * 
 * A pixels set is a <i>5D</i> array that stores the pixels data of an
 * image, that is the pixels intensity values. Every instance of this
 * service is paired up to a pixels set. Use this service to transform
 * planes within the pixels set onto an <i>RGB</i> image.
 * 
 * The RenderingEngine allows to fine-tune the settings that
 * define the transformation context &#151; that is, a specification
 * of how raw pixels data is to be transformed into an image that can
 * be displayed on screen. Those settings are referred to as rendering
 * settings or display options. After tuning those settings it is
 * possible to save them to the metadata repository so that they can
 * be used the next time the pixels set is accessed for rendering; for
 * example by another RenderingEngine instance. Note that the display
 * options are specific to the given pixels set and are experimenter
 * scoped &#151; that is, two different users can specify different
 * display options for the <i>same</i> pixels set. (A RenderingEngine
 * instance takes this into account automatically as it is always
 * bound to a given experimenter.)
 * 
 * This service is <b>thread-safe</b>.
 **/
public final class RenderingEnginePrxHelper extends Ice.ObjectPrxHelperBase implements RenderingEnginePrx
{
    private static final String __getResolutionDescriptions_name = "getResolutionDescriptions";

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     **/
    public ResolutionDescription[] getResolutionDescriptions()
        throws omero.ServerError
    {
        return getResolutionDescriptions(null, false);
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public ResolutionDescription[] getResolutionDescriptions(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getResolutionDescriptions(__ctx, true);
    }

    private ResolutionDescription[] getResolutionDescriptions(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getResolutionDescriptions", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getResolutionDescriptions");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getResolutionDescriptions(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResolutionDescriptions()
    {
        return begin_getResolutionDescriptions(null, false, null);
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResolutionDescriptions(java.util.Map<String, String> __ctx)
    {
        return begin_getResolutionDescriptions(__ctx, true, null);
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResolutionDescriptions(Ice.Callback __cb)
    {
        return begin_getResolutionDescriptions(null, false, __cb);
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResolutionDescriptions(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getResolutionDescriptions(__ctx, true, __cb);
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResolutionDescriptions(Callback_PyramidService_getResolutionDescriptions __cb)
    {
        return begin_getResolutionDescriptions(null, false, __cb);
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResolutionDescriptions(java.util.Map<String, String> __ctx, Callback_PyramidService_getResolutionDescriptions __cb)
    {
        return begin_getResolutionDescriptions(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getResolutionDescriptions(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getResolutionDescriptions_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getResolutionDescriptions_name, __cb);
        try
        {
            __result.__prepare(__getResolutionDescriptions_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public ResolutionDescription[] end_getResolutionDescriptions(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getResolutionDescriptions_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            ResolutionDescription[] __ret;
            __ret = ResolutionDescriptionsHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     **/
    public boolean getResolutionDescriptions_async(AMI_PyramidService_getResolutionDescriptions __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getResolutionDescriptions_name);
            __r = begin_getResolutionDescriptions(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getResolutionDescriptions_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a more complete definition of the resolution
     * level in question. The size of this array will be of
     * length {@link #getResolutionLevels}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getResolutionDescriptions_async(AMI_PyramidService_getResolutionDescriptions __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getResolutionDescriptions_name);
            __r = begin_getResolutionDescriptions(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getResolutionDescriptions_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getResolutionLevel_name = "getResolutionLevel";

    /**
     * Retrieves the active resolution level.
     * @return The active resolution level.
     **/
    public int getResolutionLevel()
        throws omero.ServerError
    {
        return getResolutionLevel(null, false);
    }

    /**
     * Retrieves the active resolution level.
     * @param __ctx The Context map to send with the invocation.
     * @return The active resolution level.
     **/
    public int getResolutionLevel(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getResolutionLevel(__ctx, true);
    }

    private int getResolutionLevel(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getResolutionLevel", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getResolutionLevel");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getResolutionLevel(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResolutionLevel()
    {
        return begin_getResolutionLevel(null, false, null);
    }

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResolutionLevel(java.util.Map<String, String> __ctx)
    {
        return begin_getResolutionLevel(__ctx, true, null);
    }

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResolutionLevel(Ice.Callback __cb)
    {
        return begin_getResolutionLevel(null, false, __cb);
    }

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResolutionLevel(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getResolutionLevel(__ctx, true, __cb);
    }

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResolutionLevel(Callback_PyramidService_getResolutionLevel __cb)
    {
        return begin_getResolutionLevel(null, false, __cb);
    }

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResolutionLevel(java.util.Map<String, String> __ctx, Callback_PyramidService_getResolutionLevel __cb)
    {
        return begin_getResolutionLevel(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getResolutionLevel(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getResolutionLevel_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getResolutionLevel_name, __cb);
        try
        {
            __result.__prepare(__getResolutionLevel_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) The active resolution level.
     **/
    public int end_getResolutionLevel(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getResolutionLevel_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int __ret;
            __ret = __is.readInt();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     **/
    public boolean getResolutionLevel_async(AMI_PyramidService_getResolutionLevel __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getResolutionLevel_name);
            __r = begin_getResolutionLevel(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getResolutionLevel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the active resolution level.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getResolutionLevel_async(AMI_PyramidService_getResolutionLevel __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getResolutionLevel_name);
            __r = begin_getResolutionLevel(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getResolutionLevel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getResolutionLevels_name = "getResolutionLevels";

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @return The number of resolution levels. This value does not
     * necessarily indicate either the presence or absence of a
     * pixels pyramid.
     **/
    public int getResolutionLevels()
        throws omero.ServerError
    {
        return getResolutionLevels(null, false);
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __ctx The Context map to send with the invocation.
     * @return The number of resolution levels. This value does not
     * necessarily indicate either the presence or absence of a
     * pixels pyramid.
     **/
    public int getResolutionLevels(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getResolutionLevels(__ctx, true);
    }

    private int getResolutionLevels(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getResolutionLevels", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getResolutionLevels");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getResolutionLevels(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResolutionLevels()
    {
        return begin_getResolutionLevels(null, false, null);
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResolutionLevels(java.util.Map<String, String> __ctx)
    {
        return begin_getResolutionLevels(__ctx, true, null);
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResolutionLevels(Ice.Callback __cb)
    {
        return begin_getResolutionLevels(null, false, __cb);
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResolutionLevels(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getResolutionLevels(__ctx, true, __cb);
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getResolutionLevels(Callback_PyramidService_getResolutionLevels __cb)
    {
        return begin_getResolutionLevels(null, false, __cb);
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getResolutionLevels(java.util.Map<String, String> __ctx, Callback_PyramidService_getResolutionLevels __cb)
    {
        return begin_getResolutionLevels(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getResolutionLevels(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getResolutionLevels_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getResolutionLevels_name, __cb);
        try
        {
            __result.__prepare(__getResolutionLevels_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) The number of resolution levels. This value does not
     * necessarily indicate either the presence or absence of a
     * pixels pyramid.
     **/
    public int end_getResolutionLevels(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getResolutionLevels_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int __ret;
            __ret = __is.readInt();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     **/
    public boolean getResolutionLevels_async(AMI_PyramidService_getResolutionLevels __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getResolutionLevels_name);
            __r = begin_getResolutionLevels(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getResolutionLevels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the number of resolution levels that the backing
     * pixels pyramid contains.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getResolutionLevels_async(AMI_PyramidService_getResolutionLevels __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getResolutionLevels_name);
            __r = begin_getResolutionLevels(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getResolutionLevels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getTileSize_name = "getTileSize";

    /**
     * Retrieves the tile size for the pixel store.
     * @return An array of <code>length = 2</code> where the first
     * value of the array is the tile width and the second value is
     * the tile height.
     **/
    public int[] getTileSize()
        throws omero.ServerError
    {
        return getTileSize(null, false);
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __ctx The Context map to send with the invocation.
     * @return An array of <code>length = 2</code> where the first
     * value of the array is the tile width and the second value is
     * the tile height.
     **/
    public int[] getTileSize(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getTileSize(__ctx, true);
    }

    private int[] getTileSize(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getTileSize", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getTileSize");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getTileSize(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getTileSize()
    {
        return begin_getTileSize(null, false, null);
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTileSize(java.util.Map<String, String> __ctx)
    {
        return begin_getTileSize(__ctx, true, null);
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getTileSize(Ice.Callback __cb)
    {
        return begin_getTileSize(null, false, __cb);
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTileSize(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getTileSize(__ctx, true, __cb);
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getTileSize(Callback_PyramidService_getTileSize __cb)
    {
        return begin_getTileSize(null, false, __cb);
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getTileSize(java.util.Map<String, String> __ctx, Callback_PyramidService_getTileSize __cb)
    {
        return begin_getTileSize(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getTileSize(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getTileSize_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getTileSize_name, __cb);
        try
        {
            __result.__prepare(__getTileSize_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) An array of <code>length = 2</code> where the first
     * value of the array is the tile width and the second value is
     * the tile height.
     **/
    public int[] end_getTileSize(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getTileSize_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int[] __ret;
            __ret = Ice.IntSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     **/
    public boolean getTileSize_async(AMI_PyramidService_getTileSize __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getTileSize_name);
            __r = begin_getTileSize(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getTileSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves the tile size for the pixel store.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getTileSize_async(AMI_PyramidService_getTileSize __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getTileSize_name);
            __r = begin_getTileSize(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getTileSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __requiresPixelsPyramid_name = "requiresPixelsPyramid";

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @return <code>true</code> if the pixels store requires a
     * pixels pyramid and <code>false</code> otherwise.
     **/
    public boolean requiresPixelsPyramid()
        throws omero.ServerError
    {
        return requiresPixelsPyramid(null, false);
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __ctx The Context map to send with the invocation.
     * @return <code>true</code> if the pixels store requires a
     * pixels pyramid and <code>false</code> otherwise.
     **/
    public boolean requiresPixelsPyramid(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return requiresPixelsPyramid(__ctx, true);
    }

    private boolean requiresPixelsPyramid(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "requiresPixelsPyramid", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("requiresPixelsPyramid");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.requiresPixelsPyramid(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_requiresPixelsPyramid()
    {
        return begin_requiresPixelsPyramid(null, false, null);
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_requiresPixelsPyramid(java.util.Map<String, String> __ctx)
    {
        return begin_requiresPixelsPyramid(__ctx, true, null);
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_requiresPixelsPyramid(Ice.Callback __cb)
    {
        return begin_requiresPixelsPyramid(null, false, __cb);
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_requiresPixelsPyramid(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_requiresPixelsPyramid(__ctx, true, __cb);
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_requiresPixelsPyramid(Callback_PyramidService_requiresPixelsPyramid __cb)
    {
        return begin_requiresPixelsPyramid(null, false, __cb);
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_requiresPixelsPyramid(java.util.Map<String, String> __ctx, Callback_PyramidService_requiresPixelsPyramid __cb)
    {
        return begin_requiresPixelsPyramid(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_requiresPixelsPyramid(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__requiresPixelsPyramid_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __requiresPixelsPyramid_name, __cb);
        try
        {
            __result.__prepare(__requiresPixelsPyramid_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) <code>true</code> if the pixels store requires a
     * pixels pyramid and <code>false</code> otherwise.
     **/
    public boolean end_requiresPixelsPyramid(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __requiresPixelsPyramid_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     **/
    public boolean requiresPixelsPyramid_async(AMI_PyramidService_requiresPixelsPyramid __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__requiresPixelsPyramid_name);
            __r = begin_requiresPixelsPyramid(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __requiresPixelsPyramid_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Whether or not this raw pixels store requires a backing
     * pixels pyramid to provide sub-resolutions of the data.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean requiresPixelsPyramid_async(AMI_PyramidService_requiresPixelsPyramid __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__requiresPixelsPyramid_name);
            __r = begin_requiresPixelsPyramid(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __requiresPixelsPyramid_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setResolutionLevel_name = "setResolutionLevel";

    /**
     * Sets the active resolution level.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     **/
    public void setResolutionLevel(int resolutionLevel)
        throws omero.ServerError
    {
        setResolutionLevel(resolutionLevel, null, false);
    }

    /**
     * Sets the active resolution level.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setResolutionLevel(int resolutionLevel, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setResolutionLevel(resolutionLevel, __ctx, true);
    }

    private void setResolutionLevel(int resolutionLevel, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setResolutionLevel", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setResolutionLevel");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.setResolutionLevel(resolutionLevel, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     **/
    public Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel)
    {
        return begin_setResolutionLevel(resolutionLevel, null, false, null);
    }

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel, java.util.Map<String, String> __ctx)
    {
        return begin_setResolutionLevel(resolutionLevel, __ctx, true, null);
    }

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     **/
    public Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel, Ice.Callback __cb)
    {
        return begin_setResolutionLevel(resolutionLevel, null, false, __cb);
    }

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setResolutionLevel(resolutionLevel, __ctx, true, __cb);
    }

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     **/
    public Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel, Callback_PyramidService_setResolutionLevel __cb)
    {
        return begin_setResolutionLevel(resolutionLevel, null, false, __cb);
    }

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel, java.util.Map<String, String> __ctx, Callback_PyramidService_setResolutionLevel __cb)
    {
        return begin_setResolutionLevel(resolutionLevel, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setResolutionLevel(int resolutionLevel, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setResolutionLevel_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setResolutionLevel_name, __cb);
        try
        {
            __result.__prepare(__setResolutionLevel_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(resolutionLevel);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setResolutionLevel(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setResolutionLevel_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     **/
    public boolean setResolutionLevel_async(AMI_PyramidService_setResolutionLevel __cb, int resolutionLevel)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setResolutionLevel_name);
            __r = begin_setResolutionLevel(resolutionLevel, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setResolutionLevel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets the active resolution level.
     * @param __cb The callback object for the operation.
     * @param resolutionLevel The resolution level to be used by
     * the pixel buffer.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setResolutionLevel_async(AMI_PyramidService_setResolutionLevel __cb, int resolutionLevel, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setResolutionLevel_name);
            __r = begin_setResolutionLevel(resolutionLevel, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setResolutionLevel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __addCodomainMap_name = "addCodomainMap";

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param mapCtx The context to add.
     * @see #updateCodomainMap
     * @see #removeCodomainMap
     * @deprecated This operation has been deprecated.
     **/
    public void addCodomainMap(omero.romio.CodomainMapContext mapCtx)
        throws omero.ServerError
    {
        addCodomainMap(mapCtx, null, false);
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param mapCtx The context to add.
     * @see #updateCodomainMap
     * @see #removeCodomainMap
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public void addCodomainMap(omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        addCodomainMap(mapCtx, __ctx, true);
    }

    private void addCodomainMap(omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "addCodomainMap", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("addCodomainMap");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.addCodomainMap(mapCtx, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to add.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_addCodomainMap(omero.romio.CodomainMapContext mapCtx)
    {
        return begin_addCodomainMap(mapCtx, null, false, null);
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to add.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_addCodomainMap(omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx)
    {
        return begin_addCodomainMap(mapCtx, __ctx, true, null);
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to add.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_addCodomainMap(omero.romio.CodomainMapContext mapCtx, Ice.Callback __cb)
    {
        return begin_addCodomainMap(mapCtx, null, false, __cb);
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to add.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_addCodomainMap(omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_addCodomainMap(mapCtx, __ctx, true, __cb);
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to add.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_addCodomainMap(omero.romio.CodomainMapContext mapCtx, Callback_RenderingEngine_addCodomainMap __cb)
    {
        return begin_addCodomainMap(mapCtx, null, false, __cb);
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to add.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_addCodomainMap(omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx, Callback_RenderingEngine_addCodomainMap __cb)
    {
        return begin_addCodomainMap(mapCtx, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_addCodomainMap(omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__addCodomainMap_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __addCodomainMap_name, __cb);
        try
        {
            __result.__prepare(__addCodomainMap_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(mapCtx);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_addCodomainMap(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __addCodomainMap_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to add.
     * @deprecated This operation has been deprecated.
     **/
    public boolean addCodomainMap_async(AMI_RenderingEngine_addCodomainMap __cb, omero.romio.CodomainMapContext mapCtx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addCodomainMap_name);
            __r = begin_addCodomainMap(mapCtx, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addCodomainMap_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to add.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean addCodomainMap_async(AMI_RenderingEngine_addCodomainMap __cb, omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addCodomainMap_name);
            __r = begin_addCodomainMap(mapCtx, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addCodomainMap_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __addCodomainMapToChannel_name = "addCodomainMapToChannel";

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param mapCtx The context to add.
     * @param w The channel to add the context to.
     * @see #removeCodomainMapFromChannel
     **/
    public void addCodomainMapToChannel(omero.romio.CodomainMapContext mapCtx, int w)
        throws omero.ServerError
    {
        addCodomainMapToChannel(mapCtx, w, null, false);
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param mapCtx The context to add.
     * @param w The channel to add the context to.
     * @see #removeCodomainMapFromChannel
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addCodomainMapToChannel(omero.romio.CodomainMapContext mapCtx, int w, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        addCodomainMapToChannel(mapCtx, w, __ctx, true);
    }

    private void addCodomainMapToChannel(omero.romio.CodomainMapContext mapCtx, int w, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "addCodomainMapToChannel", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("addCodomainMapToChannel");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.addCodomainMapToChannel(mapCtx, w, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to add.
     **/
    public Ice.AsyncResult begin_addCodomainMapToChannel(omero.romio.CodomainMapContext mapCtx, int w)
    {
        return begin_addCodomainMapToChannel(mapCtx, w, null, false, null);
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to add.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addCodomainMapToChannel(omero.romio.CodomainMapContext mapCtx, int w, java.util.Map<String, String> __ctx)
    {
        return begin_addCodomainMapToChannel(mapCtx, w, __ctx, true, null);
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to add.
     **/
    public Ice.AsyncResult begin_addCodomainMapToChannel(omero.romio.CodomainMapContext mapCtx, int w, Ice.Callback __cb)
    {
        return begin_addCodomainMapToChannel(mapCtx, w, null, false, __cb);
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to add.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addCodomainMapToChannel(omero.romio.CodomainMapContext mapCtx, int w, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_addCodomainMapToChannel(mapCtx, w, __ctx, true, __cb);
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to add.
     **/
    public Ice.AsyncResult begin_addCodomainMapToChannel(omero.romio.CodomainMapContext mapCtx, int w, Callback_RenderingEngine_addCodomainMapToChannel __cb)
    {
        return begin_addCodomainMapToChannel(mapCtx, w, null, false, __cb);
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to add.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addCodomainMapToChannel(omero.romio.CodomainMapContext mapCtx, int w, java.util.Map<String, String> __ctx, Callback_RenderingEngine_addCodomainMapToChannel __cb)
    {
        return begin_addCodomainMapToChannel(mapCtx, w, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_addCodomainMapToChannel(omero.romio.CodomainMapContext mapCtx, int w, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__addCodomainMapToChannel_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __addCodomainMapToChannel_name, __cb);
        try
        {
            __result.__prepare(__addCodomainMapToChannel_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(mapCtx);
            __os.writeInt(w);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_addCodomainMapToChannel(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __addCodomainMapToChannel_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to add.
     **/
    public boolean addCodomainMapToChannel_async(AMI_RenderingEngine_addCodomainMapToChannel __cb, omero.romio.CodomainMapContext mapCtx, int w)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addCodomainMapToChannel_name);
            __r = begin_addCodomainMapToChannel(mapCtx, w, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addCodomainMapToChannel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Adds the context to the mapping chain. Only one context of
     * the same type can be added to the chain. The codomain
     * transformations are functions from the device space to
     * device space. Each time a new context is added, the second
     * LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to add.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addCodomainMapToChannel_async(AMI_RenderingEngine_addCodomainMapToChannel __cb, omero.romio.CodomainMapContext mapCtx, int w, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addCodomainMapToChannel_name);
            __r = begin_addCodomainMapToChannel(mapCtx, w, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addCodomainMapToChannel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getAvailableFamilies_name = "getAvailableFamilies";

    /**
     * Returns the list of mapping families supported by the
     * Rendering engine.
     **/
    public java.util.List<omero.model.IObject> getAvailableFamilies()
        throws omero.ServerError
    {
        return getAvailableFamilies(null, false);
    }

    /**
     * Returns the list of mapping families supported by the
     * Rendering engine.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.IObject> getAvailableFamilies(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getAvailableFamilies(__ctx, true);
    }

    private java.util.List<omero.model.IObject> getAvailableFamilies(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getAvailableFamilies", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getAvailableFamilies");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getAvailableFamilies(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the list of mapping families supported by the
     * Rendering engine.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getAvailableFamilies()
    {
        return begin_getAvailableFamilies(null, false, null);
    }

    /**
     * Returns the list of mapping families supported by the
     * Rendering engine.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getAvailableFamilies(java.util.Map<String, String> __ctx)
    {
        return begin_getAvailableFamilies(__ctx, true, null);
    }

    /**
     * Returns the list of mapping families supported by the
     * Rendering engine.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getAvailableFamilies(Ice.Callback __cb)
    {
        return begin_getAvailableFamilies(null, false, __cb);
    }

    /**
     * Returns the list of mapping families supported by the
     * Rendering engine.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getAvailableFamilies(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getAvailableFamilies(__ctx, true, __cb);
    }

    /**
     * Returns the list of mapping families supported by the
     * Rendering engine.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getAvailableFamilies(Callback_RenderingEngine_getAvailableFamilies __cb)
    {
        return begin_getAvailableFamilies(null, false, __cb);
    }

    /**
     * Returns the list of mapping families supported by the
     * Rendering engine.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getAvailableFamilies(java.util.Map<String, String> __ctx, Callback_RenderingEngine_getAvailableFamilies __cb)
    {
        return begin_getAvailableFamilies(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getAvailableFamilies(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getAvailableFamilies_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getAvailableFamilies_name, __cb);
        try
        {
            __result.__prepare(__getAvailableFamilies_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.List<omero.model.IObject> end_getAvailableFamilies(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getAvailableFamilies_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.IObject> __ret;
            __ret = IObjectListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the list of mapping families supported by the
     * Rendering engine.
     * @param __cb The callback object for the operation.
     **/
    public boolean getAvailableFamilies_async(AMI_RenderingEngine_getAvailableFamilies __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getAvailableFamilies_name);
            __r = begin_getAvailableFamilies(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getAvailableFamilies_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the list of mapping families supported by the
     * Rendering engine.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getAvailableFamilies_async(AMI_RenderingEngine_getAvailableFamilies __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getAvailableFamilies_name);
            __r = begin_getAvailableFamilies(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getAvailableFamilies_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getAvailableModels_name = "getAvailableModels";

    /**
     * Returns the list of color models supported by the Rendering
     * engine.
     **/
    public java.util.List<omero.model.IObject> getAvailableModels()
        throws omero.ServerError
    {
        return getAvailableModels(null, false);
    }

    /**
     * Returns the list of color models supported by the Rendering
     * engine.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.IObject> getAvailableModels(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getAvailableModels(__ctx, true);
    }

    private java.util.List<omero.model.IObject> getAvailableModels(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getAvailableModels", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getAvailableModels");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getAvailableModels(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the list of color models supported by the Rendering
     * engine.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getAvailableModels()
    {
        return begin_getAvailableModels(null, false, null);
    }

    /**
     * Returns the list of color models supported by the Rendering
     * engine.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getAvailableModels(java.util.Map<String, String> __ctx)
    {
        return begin_getAvailableModels(__ctx, true, null);
    }

    /**
     * Returns the list of color models supported by the Rendering
     * engine.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getAvailableModels(Ice.Callback __cb)
    {
        return begin_getAvailableModels(null, false, __cb);
    }

    /**
     * Returns the list of color models supported by the Rendering
     * engine.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getAvailableModels(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getAvailableModels(__ctx, true, __cb);
    }

    /**
     * Returns the list of color models supported by the Rendering
     * engine.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getAvailableModels(Callback_RenderingEngine_getAvailableModels __cb)
    {
        return begin_getAvailableModels(null, false, __cb);
    }

    /**
     * Returns the list of color models supported by the Rendering
     * engine.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getAvailableModels(java.util.Map<String, String> __ctx, Callback_RenderingEngine_getAvailableModels __cb)
    {
        return begin_getAvailableModels(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getAvailableModels(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getAvailableModels_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getAvailableModels_name, __cb);
        try
        {
            __result.__prepare(__getAvailableModels_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.List<omero.model.IObject> end_getAvailableModels(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getAvailableModels_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.IObject> __ret;
            __ret = IObjectListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the list of color models supported by the Rendering
     * engine.
     * @param __cb The callback object for the operation.
     **/
    public boolean getAvailableModels_async(AMI_RenderingEngine_getAvailableModels __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getAvailableModels_name);
            __r = begin_getAvailableModels(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getAvailableModels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the list of color models supported by the Rendering
     * engine.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getAvailableModels_async(AMI_RenderingEngine_getAvailableModels __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getAvailableModels_name);
            __r = begin_getAvailableModels(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getAvailableModels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getChannelCurveCoefficient_name = "getChannelCurveCoefficient";

    /**
     * Returns the coefficient identifying a map in the family.
     * Each channel has a map associated to it.
     * 
     * @param w The channel index.
     * @return See above.
     * @see #getChannelFamily
     **/
    public double getChannelCurveCoefficient(int w)
        throws omero.ServerError
    {
        return getChannelCurveCoefficient(w, null, false);
    }

    /**
     * Returns the coefficient identifying a map in the family.
     * Each channel has a map associated to it.
     * 
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     * @see #getChannelFamily
     **/
    public double getChannelCurveCoefficient(int w, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getChannelCurveCoefficient(w, __ctx, true);
    }

    private double getChannelCurveCoefficient(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getChannelCurveCoefficient", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getChannelCurveCoefficient");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getChannelCurveCoefficient(w, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the coefficient identifying a map in the family.
     * Each channel has a map associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getChannelCurveCoefficient(int w)
    {
        return begin_getChannelCurveCoefficient(w, null, false, null);
    }

    /**
     * Returns the coefficient identifying a map in the family.
     * Each channel has a map associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getChannelCurveCoefficient(int w, java.util.Map<String, String> __ctx)
    {
        return begin_getChannelCurveCoefficient(w, __ctx, true, null);
    }

    /**
     * Returns the coefficient identifying a map in the family.
     * Each channel has a map associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getChannelCurveCoefficient(int w, Ice.Callback __cb)
    {
        return begin_getChannelCurveCoefficient(w, null, false, __cb);
    }

    /**
     * Returns the coefficient identifying a map in the family.
     * Each channel has a map associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getChannelCurveCoefficient(int w, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getChannelCurveCoefficient(w, __ctx, true, __cb);
    }

    /**
     * Returns the coefficient identifying a map in the family.
     * Each channel has a map associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getChannelCurveCoefficient(int w, Callback_RenderingEngine_getChannelCurveCoefficient __cb)
    {
        return begin_getChannelCurveCoefficient(w, null, false, __cb);
    }

    /**
     * Returns the coefficient identifying a map in the family.
     * Each channel has a map associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getChannelCurveCoefficient(int w, java.util.Map<String, String> __ctx, Callback_RenderingEngine_getChannelCurveCoefficient __cb)
    {
        return begin_getChannelCurveCoefficient(w, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getChannelCurveCoefficient(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getChannelCurveCoefficient_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getChannelCurveCoefficient_name, __cb);
        try
        {
            __result.__prepare(__getChannelCurveCoefficient_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(w);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) See above.
     **/
    public double end_getChannelCurveCoefficient(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getChannelCurveCoefficient_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            double __ret;
            __ret = __is.readDouble();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the coefficient identifying a map in the family.
     * Each channel has a map associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public boolean getChannelCurveCoefficient_async(AMI_RenderingEngine_getChannelCurveCoefficient __cb, int w)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getChannelCurveCoefficient_name);
            __r = begin_getChannelCurveCoefficient(w, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getChannelCurveCoefficient_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the coefficient identifying a map in the family.
     * Each channel has a map associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getChannelCurveCoefficient_async(AMI_RenderingEngine_getChannelCurveCoefficient __cb, int w, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getChannelCurveCoefficient_name);
            __r = begin_getChannelCurveCoefficient(w, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getChannelCurveCoefficient_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getChannelFamily_name = "getChannelFamily";

    /**
     * Returns the family associated to the specified channel.
     * 
     * @param w The channel index.
     * @return See above.
     * @see #getAvailableFamilies
     **/
    public omero.model.Family getChannelFamily(int w)
        throws omero.ServerError
    {
        return getChannelFamily(w, null, false);
    }

    /**
     * Returns the family associated to the specified channel.
     * 
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     * @see #getAvailableFamilies
     **/
    public omero.model.Family getChannelFamily(int w, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getChannelFamily(w, __ctx, true);
    }

    private omero.model.Family getChannelFamily(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getChannelFamily", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getChannelFamily");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getChannelFamily(w, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the family associated to the specified channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getChannelFamily(int w)
    {
        return begin_getChannelFamily(w, null, false, null);
    }

    /**
     * Returns the family associated to the specified channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getChannelFamily(int w, java.util.Map<String, String> __ctx)
    {
        return begin_getChannelFamily(w, __ctx, true, null);
    }

    /**
     * Returns the family associated to the specified channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getChannelFamily(int w, Ice.Callback __cb)
    {
        return begin_getChannelFamily(w, null, false, __cb);
    }

    /**
     * Returns the family associated to the specified channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getChannelFamily(int w, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getChannelFamily(w, __ctx, true, __cb);
    }

    /**
     * Returns the family associated to the specified channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getChannelFamily(int w, Callback_RenderingEngine_getChannelFamily __cb)
    {
        return begin_getChannelFamily(w, null, false, __cb);
    }

    /**
     * Returns the family associated to the specified channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getChannelFamily(int w, java.util.Map<String, String> __ctx, Callback_RenderingEngine_getChannelFamily __cb)
    {
        return begin_getChannelFamily(w, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getChannelFamily(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getChannelFamily_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getChannelFamily_name, __cb);
        try
        {
            __result.__prepare(__getChannelFamily_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(w);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) See above.
     **/
    public omero.model.Family end_getChannelFamily(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getChannelFamily_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.FamilyHolder __ret = new omero.model.FamilyHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the family associated to the specified channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public boolean getChannelFamily_async(AMI_RenderingEngine_getChannelFamily __cb, int w)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getChannelFamily_name);
            __r = begin_getChannelFamily(w, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getChannelFamily_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the family associated to the specified channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getChannelFamily_async(AMI_RenderingEngine_getChannelFamily __cb, int w, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getChannelFamily_name);
            __r = begin_getChannelFamily(w, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getChannelFamily_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getChannelLookupTable_name = "getChannelLookupTable";

    public String getChannelLookupTable(int w)
        throws omero.ServerError
    {
        return getChannelLookupTable(w, null, false);
    }

    public String getChannelLookupTable(int w, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getChannelLookupTable(w, __ctx, true);
    }

    private String getChannelLookupTable(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getChannelLookupTable", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getChannelLookupTable");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getChannelLookupTable(w, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_getChannelLookupTable(int w)
    {
        return begin_getChannelLookupTable(w, null, false, null);
    }

    public Ice.AsyncResult begin_getChannelLookupTable(int w, java.util.Map<String, String> __ctx)
    {
        return begin_getChannelLookupTable(w, __ctx, true, null);
    }

    public Ice.AsyncResult begin_getChannelLookupTable(int w, Ice.Callback __cb)
    {
        return begin_getChannelLookupTable(w, null, false, __cb);
    }

    public Ice.AsyncResult begin_getChannelLookupTable(int w, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getChannelLookupTable(w, __ctx, true, __cb);
    }

    public Ice.AsyncResult begin_getChannelLookupTable(int w, Callback_RenderingEngine_getChannelLookupTable __cb)
    {
        return begin_getChannelLookupTable(w, null, false, __cb);
    }

    public Ice.AsyncResult begin_getChannelLookupTable(int w, java.util.Map<String, String> __ctx, Callback_RenderingEngine_getChannelLookupTable __cb)
    {
        return begin_getChannelLookupTable(w, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getChannelLookupTable(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getChannelLookupTable_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getChannelLookupTable_name, __cb);
        try
        {
            __result.__prepare(__getChannelLookupTable_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(w);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public String end_getChannelLookupTable(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getChannelLookupTable_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            String __ret;
            __ret = __is.readString();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public boolean getChannelLookupTable_async(AMI_RenderingEngine_getChannelLookupTable __cb, int w)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getChannelLookupTable_name);
            __r = begin_getChannelLookupTable(w, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getChannelLookupTable_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public boolean getChannelLookupTable_async(AMI_RenderingEngine_getChannelLookupTable __cb, int w, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getChannelLookupTable_name);
            __r = begin_getChannelLookupTable(w, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getChannelLookupTable_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getChannelNoiseReduction_name = "getChannelNoiseReduction";

    /**
     * Returns <code>true</code> if the noise reduction algorithm
     * used to map the pixels intensity values is turned on,
     * <code>false</code> if the algorithm is turned off. Each
     * channel has an algorithm associated to it.
     * 
     * @param w The channel index.
     * @return See above.
     **/
    public boolean getChannelNoiseReduction(int w)
        throws omero.ServerError
    {
        return getChannelNoiseReduction(w, null, false);
    }

    /**
     * Returns <code>true</code> if the noise reduction algorithm
     * used to map the pixels intensity values is turned on,
     * <code>false</code> if the algorithm is turned off. Each
     * channel has an algorithm associated to it.
     * 
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     * @return See above.
     **/
    public boolean getChannelNoiseReduction(int w, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getChannelNoiseReduction(w, __ctx, true);
    }

    private boolean getChannelNoiseReduction(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getChannelNoiseReduction", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getChannelNoiseReduction");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getChannelNoiseReduction(w, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns <code>true</code> if the noise reduction algorithm
     * used to map the pixels intensity values is turned on,
     * <code>false</code> if the algorithm is turned off. Each
     * channel has an algorithm associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getChannelNoiseReduction(int w)
    {
        return begin_getChannelNoiseReduction(w, null, false, null);
    }

    /**
     * Returns <code>true</code> if the noise reduction algorithm
     * used to map the pixels intensity values is turned on,
     * <code>false</code> if the algorithm is turned off. Each
     * channel has an algorithm associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getChannelNoiseReduction(int w, java.util.Map<String, String> __ctx)
    {
        return begin_getChannelNoiseReduction(w, __ctx, true, null);
    }

    /**
     * Returns <code>true</code> if the noise reduction algorithm
     * used to map the pixels intensity values is turned on,
     * <code>false</code> if the algorithm is turned off. Each
     * channel has an algorithm associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getChannelNoiseReduction(int w, Ice.Callback __cb)
    {
        return begin_getChannelNoiseReduction(w, null, false, __cb);
    }

    /**
     * Returns <code>true</code> if the noise reduction algorithm
     * used to map the pixels intensity values is turned on,
     * <code>false</code> if the algorithm is turned off. Each
     * channel has an algorithm associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getChannelNoiseReduction(int w, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getChannelNoiseReduction(w, __ctx, true, __cb);
    }

    /**
     * Returns <code>true</code> if the noise reduction algorithm
     * used to map the pixels intensity values is turned on,
     * <code>false</code> if the algorithm is turned off. Each
     * channel has an algorithm associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getChannelNoiseReduction(int w, Callback_RenderingEngine_getChannelNoiseReduction __cb)
    {
        return begin_getChannelNoiseReduction(w, null, false, __cb);
    }

    /**
     * Returns <code>true</code> if the noise reduction algorithm
     * used to map the pixels intensity values is turned on,
     * <code>false</code> if the algorithm is turned off. Each
     * channel has an algorithm associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getChannelNoiseReduction(int w, java.util.Map<String, String> __ctx, Callback_RenderingEngine_getChannelNoiseReduction __cb)
    {
        return begin_getChannelNoiseReduction(w, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getChannelNoiseReduction(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getChannelNoiseReduction_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getChannelNoiseReduction_name, __cb);
        try
        {
            __result.__prepare(__getChannelNoiseReduction_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(w);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) See above.
     **/
    public boolean end_getChannelNoiseReduction(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getChannelNoiseReduction_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns <code>true</code> if the noise reduction algorithm
     * used to map the pixels intensity values is turned on,
     * <code>false</code> if the algorithm is turned off. Each
     * channel has an algorithm associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public boolean getChannelNoiseReduction_async(AMI_RenderingEngine_getChannelNoiseReduction __cb, int w)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getChannelNoiseReduction_name);
            __r = begin_getChannelNoiseReduction(w, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getChannelNoiseReduction_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns <code>true</code> if the noise reduction algorithm
     * used to map the pixels intensity values is turned on,
     * <code>false</code> if the algorithm is turned off. Each
     * channel has an algorithm associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getChannelNoiseReduction_async(AMI_RenderingEngine_getChannelNoiseReduction __cb, int w, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getChannelNoiseReduction_name);
            __r = begin_getChannelNoiseReduction(w, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getChannelNoiseReduction_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getChannelStats_name = "getChannelStats";

    public double[] getChannelStats(int w)
        throws omero.ServerError
    {
        return getChannelStats(w, null, false);
    }

    public double[] getChannelStats(int w, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getChannelStats(w, __ctx, true);
    }

    private double[] getChannelStats(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getChannelStats", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getChannelStats");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getChannelStats(w, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_getChannelStats(int w)
    {
        return begin_getChannelStats(w, null, false, null);
    }

    public Ice.AsyncResult begin_getChannelStats(int w, java.util.Map<String, String> __ctx)
    {
        return begin_getChannelStats(w, __ctx, true, null);
    }

    public Ice.AsyncResult begin_getChannelStats(int w, Ice.Callback __cb)
    {
        return begin_getChannelStats(w, null, false, __cb);
    }

    public Ice.AsyncResult begin_getChannelStats(int w, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getChannelStats(w, __ctx, true, __cb);
    }

    public Ice.AsyncResult begin_getChannelStats(int w, Callback_RenderingEngine_getChannelStats __cb)
    {
        return begin_getChannelStats(w, null, false, __cb);
    }

    public Ice.AsyncResult begin_getChannelStats(int w, java.util.Map<String, String> __ctx, Callback_RenderingEngine_getChannelStats __cb)
    {
        return begin_getChannelStats(w, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getChannelStats(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getChannelStats_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getChannelStats_name, __cb);
        try
        {
            __result.__prepare(__getChannelStats_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(w);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public double[] end_getChannelStats(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getChannelStats_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            double[] __ret;
            __ret = Ice.DoubleSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public boolean getChannelStats_async(AMI_RenderingEngine_getChannelStats __cb, int w)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getChannelStats_name);
            __r = begin_getChannelStats(w, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getChannelStats_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public boolean getChannelStats_async(AMI_RenderingEngine_getChannelStats __cb, int w, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getChannelStats_name);
            __r = begin_getChannelStats(w, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getChannelStats_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getChannelWindowEnd_name = "getChannelWindowEnd";

    /**
     * Returns the upper bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param w The channel index.
     **/
    public double getChannelWindowEnd(int w)
        throws omero.ServerError
    {
        return getChannelWindowEnd(w, null, false);
    }

    /**
     * Returns the upper bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public double getChannelWindowEnd(int w, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getChannelWindowEnd(w, __ctx, true);
    }

    private double getChannelWindowEnd(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getChannelWindowEnd", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getChannelWindowEnd");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getChannelWindowEnd(w, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the upper bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getChannelWindowEnd(int w)
    {
        return begin_getChannelWindowEnd(w, null, false, null);
    }

    /**
     * Returns the upper bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getChannelWindowEnd(int w, java.util.Map<String, String> __ctx)
    {
        return begin_getChannelWindowEnd(w, __ctx, true, null);
    }

    /**
     * Returns the upper bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getChannelWindowEnd(int w, Ice.Callback __cb)
    {
        return begin_getChannelWindowEnd(w, null, false, __cb);
    }

    /**
     * Returns the upper bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getChannelWindowEnd(int w, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getChannelWindowEnd(w, __ctx, true, __cb);
    }

    /**
     * Returns the upper bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getChannelWindowEnd(int w, Callback_RenderingEngine_getChannelWindowEnd __cb)
    {
        return begin_getChannelWindowEnd(w, null, false, __cb);
    }

    /**
     * Returns the upper bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getChannelWindowEnd(int w, java.util.Map<String, String> __ctx, Callback_RenderingEngine_getChannelWindowEnd __cb)
    {
        return begin_getChannelWindowEnd(w, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getChannelWindowEnd(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getChannelWindowEnd_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getChannelWindowEnd_name, __cb);
        try
        {
            __result.__prepare(__getChannelWindowEnd_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(w);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public double end_getChannelWindowEnd(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getChannelWindowEnd_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            double __ret;
            __ret = __is.readDouble();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the upper bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public boolean getChannelWindowEnd_async(AMI_RenderingEngine_getChannelWindowEnd __cb, int w)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getChannelWindowEnd_name);
            __r = begin_getChannelWindowEnd(w, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getChannelWindowEnd_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the upper bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getChannelWindowEnd_async(AMI_RenderingEngine_getChannelWindowEnd __cb, int w, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getChannelWindowEnd_name);
            __r = begin_getChannelWindowEnd(w, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getChannelWindowEnd_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getChannelWindowStart_name = "getChannelWindowStart";

    /**
     * Returns the lower bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param w The channel index.
     **/
    public double getChannelWindowStart(int w)
        throws omero.ServerError
    {
        return getChannelWindowStart(w, null, false);
    }

    /**
     * Returns the lower bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public double getChannelWindowStart(int w, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getChannelWindowStart(w, __ctx, true);
    }

    private double getChannelWindowStart(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getChannelWindowStart", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getChannelWindowStart");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getChannelWindowStart(w, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the lower bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getChannelWindowStart(int w)
    {
        return begin_getChannelWindowStart(w, null, false, null);
    }

    /**
     * Returns the lower bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getChannelWindowStart(int w, java.util.Map<String, String> __ctx)
    {
        return begin_getChannelWindowStart(w, __ctx, true, null);
    }

    /**
     * Returns the lower bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getChannelWindowStart(int w, Ice.Callback __cb)
    {
        return begin_getChannelWindowStart(w, null, false, __cb);
    }

    /**
     * Returns the lower bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getChannelWindowStart(int w, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getChannelWindowStart(w, __ctx, true, __cb);
    }

    /**
     * Returns the lower bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getChannelWindowStart(int w, Callback_RenderingEngine_getChannelWindowStart __cb)
    {
        return begin_getChannelWindowStart(w, null, false, __cb);
    }

    /**
     * Returns the lower bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getChannelWindowStart(int w, java.util.Map<String, String> __ctx, Callback_RenderingEngine_getChannelWindowStart __cb)
    {
        return begin_getChannelWindowStart(w, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getChannelWindowStart(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getChannelWindowStart_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getChannelWindowStart_name, __cb);
        try
        {
            __result.__prepare(__getChannelWindowStart_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(w);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public double end_getChannelWindowStart(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getChannelWindowStart_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            double __ret;
            __ret = __is.readDouble();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the lower bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public boolean getChannelWindowStart_async(AMI_RenderingEngine_getChannelWindowStart __cb, int w)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getChannelWindowStart_name);
            __r = begin_getChannelWindowStart(w, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getChannelWindowStart_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the lower bound of the pixels intensity interval.
     * Each channel has a pixels intensity interval associated to
     * it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getChannelWindowStart_async(AMI_RenderingEngine_getChannelWindowStart __cb, int w, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getChannelWindowStart_name);
            __r = begin_getChannelWindowStart(w, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getChannelWindowStart_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getCodomainMapContext_name = "getCodomainMapContext";

    /**
     * Returns the list of codomain contexts for the specified
     * channel.
     * 
     * @param w The channel index.
     **/
    public java.util.List<omero.model.IObject> getCodomainMapContext(int w)
        throws omero.ServerError
    {
        return getCodomainMapContext(w, null, false);
    }

    /**
     * Returns the list of codomain contexts for the specified
     * channel.
     * 
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.IObject> getCodomainMapContext(int w, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getCodomainMapContext(w, __ctx, true);
    }

    private java.util.List<omero.model.IObject> getCodomainMapContext(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getCodomainMapContext", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getCodomainMapContext");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getCodomainMapContext(w, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the list of codomain contexts for the specified
     * channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getCodomainMapContext(int w)
    {
        return begin_getCodomainMapContext(w, null, false, null);
    }

    /**
     * Returns the list of codomain contexts for the specified
     * channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCodomainMapContext(int w, java.util.Map<String, String> __ctx)
    {
        return begin_getCodomainMapContext(w, __ctx, true, null);
    }

    /**
     * Returns the list of codomain contexts for the specified
     * channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getCodomainMapContext(int w, Ice.Callback __cb)
    {
        return begin_getCodomainMapContext(w, null, false, __cb);
    }

    /**
     * Returns the list of codomain contexts for the specified
     * channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCodomainMapContext(int w, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getCodomainMapContext(w, __ctx, true, __cb);
    }

    /**
     * Returns the list of codomain contexts for the specified
     * channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getCodomainMapContext(int w, Callback_RenderingEngine_getCodomainMapContext __cb)
    {
        return begin_getCodomainMapContext(w, null, false, __cb);
    }

    /**
     * Returns the list of codomain contexts for the specified
     * channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCodomainMapContext(int w, java.util.Map<String, String> __ctx, Callback_RenderingEngine_getCodomainMapContext __cb)
    {
        return begin_getCodomainMapContext(w, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getCodomainMapContext(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getCodomainMapContext_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getCodomainMapContext_name, __cb);
        try
        {
            __result.__prepare(__getCodomainMapContext_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(w);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.List<omero.model.IObject> end_getCodomainMapContext(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getCodomainMapContext_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.IObject> __ret;
            __ret = IObjectListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the list of codomain contexts for the specified
     * channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public boolean getCodomainMapContext_async(AMI_RenderingEngine_getCodomainMapContext __cb, int w)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCodomainMapContext_name);
            __r = begin_getCodomainMapContext(w, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCodomainMapContext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the list of codomain contexts for the specified
     * channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getCodomainMapContext_async(AMI_RenderingEngine_getCodomainMapContext __cb, int w, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCodomainMapContext_name);
            __r = begin_getCodomainMapContext(w, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCodomainMapContext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getCompressionLevel_name = "getCompressionLevel";

    /**
     * Returns the current compression level for the service.
     **/
    public float getCompressionLevel()
        throws omero.ServerError
    {
        return getCompressionLevel(null, false);
    }

    /**
     * Returns the current compression level for the service.
     * @param __ctx The Context map to send with the invocation.
     **/
    public float getCompressionLevel(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getCompressionLevel(__ctx, true);
    }

    private float getCompressionLevel(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getCompressionLevel", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getCompressionLevel");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getCompressionLevel(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the current compression level for the service.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCompressionLevel()
    {
        return begin_getCompressionLevel(null, false, null);
    }

    /**
     * Returns the current compression level for the service.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCompressionLevel(java.util.Map<String, String> __ctx)
    {
        return begin_getCompressionLevel(__ctx, true, null);
    }

    /**
     * Returns the current compression level for the service.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCompressionLevel(Ice.Callback __cb)
    {
        return begin_getCompressionLevel(null, false, __cb);
    }

    /**
     * Returns the current compression level for the service.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCompressionLevel(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getCompressionLevel(__ctx, true, __cb);
    }

    /**
     * Returns the current compression level for the service.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCompressionLevel(Callback_RenderingEngine_getCompressionLevel __cb)
    {
        return begin_getCompressionLevel(null, false, __cb);
    }

    /**
     * Returns the current compression level for the service.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCompressionLevel(java.util.Map<String, String> __ctx, Callback_RenderingEngine_getCompressionLevel __cb)
    {
        return begin_getCompressionLevel(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getCompressionLevel(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getCompressionLevel_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getCompressionLevel_name, __cb);
        try
        {
            __result.__prepare(__getCompressionLevel_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public float end_getCompressionLevel(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getCompressionLevel_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            float __ret;
            __ret = __is.readFloat();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the current compression level for the service.
     * @param __cb The callback object for the operation.
     **/
    public boolean getCompressionLevel_async(AMI_RenderingEngine_getCompressionLevel __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCompressionLevel_name);
            __r = begin_getCompressionLevel(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCompressionLevel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the current compression level for the service.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getCompressionLevel_async(AMI_RenderingEngine_getCompressionLevel __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCompressionLevel_name);
            __r = begin_getCompressionLevel(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCompressionLevel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getDefaultT_name = "getDefaultT";

    /**
     * Returns the default timepoint index.
     **/
    public int getDefaultT()
        throws omero.ServerError
    {
        return getDefaultT(null, false);
    }

    /**
     * Returns the default timepoint index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public int getDefaultT(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getDefaultT(__ctx, true);
    }

    private int getDefaultT(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getDefaultT", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getDefaultT");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getDefaultT(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the default timepoint index.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getDefaultT()
    {
        return begin_getDefaultT(null, false, null);
    }

    /**
     * Returns the default timepoint index.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getDefaultT(java.util.Map<String, String> __ctx)
    {
        return begin_getDefaultT(__ctx, true, null);
    }

    /**
     * Returns the default timepoint index.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getDefaultT(Ice.Callback __cb)
    {
        return begin_getDefaultT(null, false, __cb);
    }

    /**
     * Returns the default timepoint index.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getDefaultT(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getDefaultT(__ctx, true, __cb);
    }

    /**
     * Returns the default timepoint index.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getDefaultT(Callback_RenderingEngine_getDefaultT __cb)
    {
        return begin_getDefaultT(null, false, __cb);
    }

    /**
     * Returns the default timepoint index.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getDefaultT(java.util.Map<String, String> __ctx, Callback_RenderingEngine_getDefaultT __cb)
    {
        return begin_getDefaultT(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getDefaultT(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getDefaultT_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getDefaultT_name, __cb);
        try
        {
            __result.__prepare(__getDefaultT_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public int end_getDefaultT(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getDefaultT_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int __ret;
            __ret = __is.readInt();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the default timepoint index.
     * @param __cb The callback object for the operation.
     **/
    public boolean getDefaultT_async(AMI_RenderingEngine_getDefaultT __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getDefaultT_name);
            __r = begin_getDefaultT(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getDefaultT_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the default timepoint index.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getDefaultT_async(AMI_RenderingEngine_getDefaultT __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getDefaultT_name);
            __r = begin_getDefaultT(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getDefaultT_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getDefaultZ_name = "getDefaultZ";

    /**
     * Returns the index of the default focal section.
     **/
    public int getDefaultZ()
        throws omero.ServerError
    {
        return getDefaultZ(null, false);
    }

    /**
     * Returns the index of the default focal section.
     * @param __ctx The Context map to send with the invocation.
     **/
    public int getDefaultZ(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getDefaultZ(__ctx, true);
    }

    private int getDefaultZ(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getDefaultZ", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getDefaultZ");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getDefaultZ(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the index of the default focal section.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getDefaultZ()
    {
        return begin_getDefaultZ(null, false, null);
    }

    /**
     * Returns the index of the default focal section.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getDefaultZ(java.util.Map<String, String> __ctx)
    {
        return begin_getDefaultZ(__ctx, true, null);
    }

    /**
     * Returns the index of the default focal section.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getDefaultZ(Ice.Callback __cb)
    {
        return begin_getDefaultZ(null, false, __cb);
    }

    /**
     * Returns the index of the default focal section.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getDefaultZ(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getDefaultZ(__ctx, true, __cb);
    }

    /**
     * Returns the index of the default focal section.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getDefaultZ(Callback_RenderingEngine_getDefaultZ __cb)
    {
        return begin_getDefaultZ(null, false, __cb);
    }

    /**
     * Returns the index of the default focal section.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getDefaultZ(java.util.Map<String, String> __ctx, Callback_RenderingEngine_getDefaultZ __cb)
    {
        return begin_getDefaultZ(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getDefaultZ(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getDefaultZ_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getDefaultZ_name, __cb);
        try
        {
            __result.__prepare(__getDefaultZ_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public int end_getDefaultZ(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getDefaultZ_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int __ret;
            __ret = __is.readInt();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the index of the default focal section.
     * @param __cb The callback object for the operation.
     **/
    public boolean getDefaultZ_async(AMI_RenderingEngine_getDefaultZ __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getDefaultZ_name);
            __r = begin_getDefaultZ(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getDefaultZ_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the index of the default focal section.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getDefaultZ_async(AMI_RenderingEngine_getDefaultZ __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getDefaultZ_name);
            __r = begin_getDefaultZ(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getDefaultZ_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getModel_name = "getModel";

    /**
     * Returns the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     **/
    public omero.model.RenderingModel getModel()
        throws omero.ServerError
    {
        return getModel(null, false);
    }

    /**
     * Returns the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.RenderingModel getModel(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getModel(__ctx, true);
    }

    private omero.model.RenderingModel getModel(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getModel", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getModel");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getModel(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getModel()
    {
        return begin_getModel(null, false, null);
    }

    /**
     * Returns the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getModel(java.util.Map<String, String> __ctx)
    {
        return begin_getModel(__ctx, true, null);
    }

    /**
     * Returns the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getModel(Ice.Callback __cb)
    {
        return begin_getModel(null, false, __cb);
    }

    /**
     * Returns the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getModel(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getModel(__ctx, true, __cb);
    }

    /**
     * Returns the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getModel(Callback_RenderingEngine_getModel __cb)
    {
        return begin_getModel(null, false, __cb);
    }

    /**
     * Returns the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getModel(java.util.Map<String, String> __ctx, Callback_RenderingEngine_getModel __cb)
    {
        return begin_getModel(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getModel(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getModel_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getModel_name, __cb);
        try
        {
            __result.__prepare(__getModel_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.model.RenderingModel end_getModel(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getModel_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.RenderingModelHolder __ret = new omero.model.RenderingModelHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * @param __cb The callback object for the operation.
     **/
    public boolean getModel_async(AMI_RenderingEngine_getModel __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getModel_name);
            __r = begin_getModel(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getModel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getModel_async(AMI_RenderingEngine_getModel __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getModel_name);
            __r = begin_getModel(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getModel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getPixels_name = "getPixels";

    /**
     * Returns the {@link omero.model.Pixels} set the Rendering
     * engine is for.
     **/
    public omero.model.Pixels getPixels()
        throws omero.ServerError
    {
        return getPixels(null, false);
    }

    /**
     * Returns the {@link omero.model.Pixels} set the Rendering
     * engine is for.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.Pixels getPixels(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getPixels(__ctx, true);
    }

    private omero.model.Pixels getPixels(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getPixels", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getPixels");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getPixels(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the {@link omero.model.Pixels} set the Rendering
     * engine is for.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getPixels()
    {
        return begin_getPixels(null, false, null);
    }

    /**
     * Returns the {@link omero.model.Pixels} set the Rendering
     * engine is for.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPixels(java.util.Map<String, String> __ctx)
    {
        return begin_getPixels(__ctx, true, null);
    }

    /**
     * Returns the {@link omero.model.Pixels} set the Rendering
     * engine is for.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getPixels(Ice.Callback __cb)
    {
        return begin_getPixels(null, false, __cb);
    }

    /**
     * Returns the {@link omero.model.Pixels} set the Rendering
     * engine is for.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPixels(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getPixels(__ctx, true, __cb);
    }

    /**
     * Returns the {@link omero.model.Pixels} set the Rendering
     * engine is for.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getPixels(Callback_RenderingEngine_getPixels __cb)
    {
        return begin_getPixels(null, false, __cb);
    }

    /**
     * Returns the {@link omero.model.Pixels} set the Rendering
     * engine is for.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPixels(java.util.Map<String, String> __ctx, Callback_RenderingEngine_getPixels __cb)
    {
        return begin_getPixels(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getPixels(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getPixels_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getPixels_name, __cb);
        try
        {
            __result.__prepare(__getPixels_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.model.Pixels end_getPixels(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getPixels_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.PixelsHolder __ret = new omero.model.PixelsHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the {@link omero.model.Pixels} set the Rendering
     * engine is for.
     * @param __cb The callback object for the operation.
     **/
    public boolean getPixels_async(AMI_RenderingEngine_getPixels __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPixels_name);
            __r = begin_getPixels(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPixels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the {@link omero.model.Pixels} set the Rendering
     * engine is for.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getPixels_async(AMI_RenderingEngine_getPixels __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPixels_name);
            __r = begin_getPixels(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPixels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getPixelsTypeLowerBound_name = "getPixelsTypeLowerBound";

    /**
     * Returns the maximum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param w The channel index.
     **/
    public double getPixelsTypeLowerBound(int w)
        throws omero.ServerError
    {
        return getPixelsTypeLowerBound(w, null, false);
    }

    /**
     * Returns the maximum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public double getPixelsTypeLowerBound(int w, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getPixelsTypeLowerBound(w, __ctx, true);
    }

    private double getPixelsTypeLowerBound(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getPixelsTypeLowerBound", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getPixelsTypeLowerBound");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getPixelsTypeLowerBound(w, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the maximum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getPixelsTypeLowerBound(int w)
    {
        return begin_getPixelsTypeLowerBound(w, null, false, null);
    }

    /**
     * Returns the maximum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPixelsTypeLowerBound(int w, java.util.Map<String, String> __ctx)
    {
        return begin_getPixelsTypeLowerBound(w, __ctx, true, null);
    }

    /**
     * Returns the maximum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getPixelsTypeLowerBound(int w, Ice.Callback __cb)
    {
        return begin_getPixelsTypeLowerBound(w, null, false, __cb);
    }

    /**
     * Returns the maximum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPixelsTypeLowerBound(int w, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getPixelsTypeLowerBound(w, __ctx, true, __cb);
    }

    /**
     * Returns the maximum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getPixelsTypeLowerBound(int w, Callback_RenderingEngine_getPixelsTypeLowerBound __cb)
    {
        return begin_getPixelsTypeLowerBound(w, null, false, __cb);
    }

    /**
     * Returns the maximum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPixelsTypeLowerBound(int w, java.util.Map<String, String> __ctx, Callback_RenderingEngine_getPixelsTypeLowerBound __cb)
    {
        return begin_getPixelsTypeLowerBound(w, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getPixelsTypeLowerBound(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getPixelsTypeLowerBound_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getPixelsTypeLowerBound_name, __cb);
        try
        {
            __result.__prepare(__getPixelsTypeLowerBound_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(w);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public double end_getPixelsTypeLowerBound(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getPixelsTypeLowerBound_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            double __ret;
            __ret = __is.readDouble();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the maximum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public boolean getPixelsTypeLowerBound_async(AMI_RenderingEngine_getPixelsTypeLowerBound __cb, int w)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPixelsTypeLowerBound_name);
            __r = begin_getPixelsTypeLowerBound(w, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPixelsTypeLowerBound_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the maximum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getPixelsTypeLowerBound_async(AMI_RenderingEngine_getPixelsTypeLowerBound __cb, int w, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPixelsTypeLowerBound_name);
            __r = begin_getPixelsTypeLowerBound(w, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPixelsTypeLowerBound_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getPixelsTypeUpperBound_name = "getPixelsTypeUpperBound";

    /**
     * Returns the minimum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param w The channel index.
     **/
    public double getPixelsTypeUpperBound(int w)
        throws omero.ServerError
    {
        return getPixelsTypeUpperBound(w, null, false);
    }

    /**
     * Returns the minimum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public double getPixelsTypeUpperBound(int w, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getPixelsTypeUpperBound(w, __ctx, true);
    }

    private double getPixelsTypeUpperBound(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getPixelsTypeUpperBound", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getPixelsTypeUpperBound");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getPixelsTypeUpperBound(w, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the minimum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getPixelsTypeUpperBound(int w)
    {
        return begin_getPixelsTypeUpperBound(w, null, false, null);
    }

    /**
     * Returns the minimum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPixelsTypeUpperBound(int w, java.util.Map<String, String> __ctx)
    {
        return begin_getPixelsTypeUpperBound(w, __ctx, true, null);
    }

    /**
     * Returns the minimum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getPixelsTypeUpperBound(int w, Ice.Callback __cb)
    {
        return begin_getPixelsTypeUpperBound(w, null, false, __cb);
    }

    /**
     * Returns the minimum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPixelsTypeUpperBound(int w, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getPixelsTypeUpperBound(w, __ctx, true, __cb);
    }

    /**
     * Returns the minimum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getPixelsTypeUpperBound(int w, Callback_RenderingEngine_getPixelsTypeUpperBound __cb)
    {
        return begin_getPixelsTypeUpperBound(w, null, false, __cb);
    }

    /**
     * Returns the minimum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getPixelsTypeUpperBound(int w, java.util.Map<String, String> __ctx, Callback_RenderingEngine_getPixelsTypeUpperBound __cb)
    {
        return begin_getPixelsTypeUpperBound(w, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getPixelsTypeUpperBound(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getPixelsTypeUpperBound_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getPixelsTypeUpperBound_name, __cb);
        try
        {
            __result.__prepare(__getPixelsTypeUpperBound_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(w);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public double end_getPixelsTypeUpperBound(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getPixelsTypeUpperBound_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            double __ret;
            __ret = __is.readDouble();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the minimum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public boolean getPixelsTypeUpperBound_async(AMI_RenderingEngine_getPixelsTypeUpperBound __cb, int w)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPixelsTypeUpperBound_name);
            __r = begin_getPixelsTypeUpperBound(w, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPixelsTypeUpperBound_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the minimum value for that channels depending on
     * the pixels type and the original range (globalmax,
     * globalmin)
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getPixelsTypeUpperBound_async(AMI_RenderingEngine_getPixelsTypeUpperBound __cb, int w, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getPixelsTypeUpperBound_name);
            __r = begin_getPixelsTypeUpperBound(w, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getPixelsTypeUpperBound_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getQuantumDef_name = "getQuantumDef";

    /**
     * Returns the quantization object.
     **/
    public omero.model.QuantumDef getQuantumDef()
        throws omero.ServerError
    {
        return getQuantumDef(null, false);
    }

    /**
     * Returns the quantization object.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.QuantumDef getQuantumDef(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getQuantumDef(__ctx, true);
    }

    private omero.model.QuantumDef getQuantumDef(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getQuantumDef", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getQuantumDef");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getQuantumDef(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the quantization object.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getQuantumDef()
    {
        return begin_getQuantumDef(null, false, null);
    }

    /**
     * Returns the quantization object.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getQuantumDef(java.util.Map<String, String> __ctx)
    {
        return begin_getQuantumDef(__ctx, true, null);
    }

    /**
     * Returns the quantization object.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getQuantumDef(Ice.Callback __cb)
    {
        return begin_getQuantumDef(null, false, __cb);
    }

    /**
     * Returns the quantization object.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getQuantumDef(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getQuantumDef(__ctx, true, __cb);
    }

    /**
     * Returns the quantization object.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getQuantumDef(Callback_RenderingEngine_getQuantumDef __cb)
    {
        return begin_getQuantumDef(null, false, __cb);
    }

    /**
     * Returns the quantization object.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getQuantumDef(java.util.Map<String, String> __ctx, Callback_RenderingEngine_getQuantumDef __cb)
    {
        return begin_getQuantumDef(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getQuantumDef(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getQuantumDef_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getQuantumDef_name, __cb);
        try
        {
            __result.__prepare(__getQuantumDef_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.model.QuantumDef end_getQuantumDef(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getQuantumDef_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.QuantumDefHolder __ret = new omero.model.QuantumDefHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the quantization object.
     * @param __cb The callback object for the operation.
     **/
    public boolean getQuantumDef_async(AMI_RenderingEngine_getQuantumDef __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getQuantumDef_name);
            __r = begin_getQuantumDef(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getQuantumDef_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the quantization object.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getQuantumDef_async(AMI_RenderingEngine_getQuantumDef __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getQuantumDef_name);
            __r = begin_getQuantumDef(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getQuantumDef_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getRGBA_name = "getRGBA";

    /**
     * Returns a 4D-array representing the color associated to the
     * specified channel. The first element corresponds to the red
     * component (value between 0 and 255). The second corresponds
     * to the green component (value between 0 and 255). The third
     * corresponds to the blue component (value between 0 and
     * 255). The fourth corresponds to the alpha component (value
     * between 0 and 255).
     * 
     * @param w The channel index.
     **/
    public int[] getRGBA(int w)
        throws omero.ServerError
    {
        return getRGBA(w, null, false);
    }

    /**
     * Returns a 4D-array representing the color associated to the
     * specified channel. The first element corresponds to the red
     * component (value between 0 and 255). The second corresponds
     * to the green component (value between 0 and 255). The third
     * corresponds to the blue component (value between 0 and
     * 255). The fourth corresponds to the alpha component (value
     * between 0 and 255).
     * 
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public int[] getRGBA(int w, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getRGBA(w, __ctx, true);
    }

    private int[] getRGBA(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getRGBA", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getRGBA");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getRGBA(w, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns a 4D-array representing the color associated to the
     * specified channel. The first element corresponds to the red
     * component (value between 0 and 255). The second corresponds
     * to the green component (value between 0 and 255). The third
     * corresponds to the blue component (value between 0 and
     * 255). The fourth corresponds to the alpha component (value
     * between 0 and 255).
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getRGBA(int w)
    {
        return begin_getRGBA(w, null, false, null);
    }

    /**
     * Returns a 4D-array representing the color associated to the
     * specified channel. The first element corresponds to the red
     * component (value between 0 and 255). The second corresponds
     * to the green component (value between 0 and 255). The third
     * corresponds to the blue component (value between 0 and
     * 255). The fourth corresponds to the alpha component (value
     * between 0 and 255).
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRGBA(int w, java.util.Map<String, String> __ctx)
    {
        return begin_getRGBA(w, __ctx, true, null);
    }

    /**
     * Returns a 4D-array representing the color associated to the
     * specified channel. The first element corresponds to the red
     * component (value between 0 and 255). The second corresponds
     * to the green component (value between 0 and 255). The third
     * corresponds to the blue component (value between 0 and
     * 255). The fourth corresponds to the alpha component (value
     * between 0 and 255).
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getRGBA(int w, Ice.Callback __cb)
    {
        return begin_getRGBA(w, null, false, __cb);
    }

    /**
     * Returns a 4D-array representing the color associated to the
     * specified channel. The first element corresponds to the red
     * component (value between 0 and 255). The second corresponds
     * to the green component (value between 0 and 255). The third
     * corresponds to the blue component (value between 0 and
     * 255). The fourth corresponds to the alpha component (value
     * between 0 and 255).
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRGBA(int w, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getRGBA(w, __ctx, true, __cb);
    }

    /**
     * Returns a 4D-array representing the color associated to the
     * specified channel. The first element corresponds to the red
     * component (value between 0 and 255). The second corresponds
     * to the green component (value between 0 and 255). The third
     * corresponds to the blue component (value between 0 and
     * 255). The fourth corresponds to the alpha component (value
     * between 0 and 255).
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_getRGBA(int w, Callback_RenderingEngine_getRGBA __cb)
    {
        return begin_getRGBA(w, null, false, __cb);
    }

    /**
     * Returns a 4D-array representing the color associated to the
     * specified channel. The first element corresponds to the red
     * component (value between 0 and 255). The second corresponds
     * to the green component (value between 0 and 255). The third
     * corresponds to the blue component (value between 0 and
     * 255). The fourth corresponds to the alpha component (value
     * between 0 and 255).
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRGBA(int w, java.util.Map<String, String> __ctx, Callback_RenderingEngine_getRGBA __cb)
    {
        return begin_getRGBA(w, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getRGBA(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getRGBA_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getRGBA_name, __cb);
        try
        {
            __result.__prepare(__getRGBA_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(w);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public int[] end_getRGBA(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getRGBA_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int[] __ret;
            __ret = Ice.IntSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns a 4D-array representing the color associated to the
     * specified channel. The first element corresponds to the red
     * component (value between 0 and 255). The second corresponds
     * to the green component (value between 0 and 255). The third
     * corresponds to the blue component (value between 0 and
     * 255). The fourth corresponds to the alpha component (value
     * between 0 and 255).
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public boolean getRGBA_async(AMI_RenderingEngine_getRGBA __cb, int w)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getRGBA_name);
            __r = begin_getRGBA(w, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getRGBA_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns a 4D-array representing the color associated to the
     * specified channel. The first element corresponds to the red
     * component (value between 0 and 255). The second corresponds
     * to the green component (value between 0 and 255). The third
     * corresponds to the blue component (value between 0 and
     * 255). The fourth corresponds to the alpha component (value
     * between 0 and 255).
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getRGBA_async(AMI_RenderingEngine_getRGBA __cb, int w, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getRGBA_name);
            __r = begin_getRGBA(w, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getRGBA_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getRenderingDefId_name = "getRenderingDefId";

    /**
     * Returns the id of the {@link omero.model.RenderingDef}
     * loaded by either {@link #lookupRenderingDef} or
     * {@link #loadRenderingDef}.
     **/
    public long getRenderingDefId()
        throws omero.ServerError
    {
        return getRenderingDefId(null, false);
    }

    /**
     * Returns the id of the {@link omero.model.RenderingDef}
     * loaded by either {@link #lookupRenderingDef} or
     * {@link #loadRenderingDef}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public long getRenderingDefId(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getRenderingDefId(__ctx, true);
    }

    private long getRenderingDefId(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getRenderingDefId", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getRenderingDefId");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getRenderingDefId(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the id of the {@link omero.model.RenderingDef}
     * loaded by either {@link #lookupRenderingDef} or
     * {@link #loadRenderingDef}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getRenderingDefId()
    {
        return begin_getRenderingDefId(null, false, null);
    }

    /**
     * Returns the id of the {@link omero.model.RenderingDef}
     * loaded by either {@link #lookupRenderingDef} or
     * {@link #loadRenderingDef}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRenderingDefId(java.util.Map<String, String> __ctx)
    {
        return begin_getRenderingDefId(__ctx, true, null);
    }

    /**
     * Returns the id of the {@link omero.model.RenderingDef}
     * loaded by either {@link #lookupRenderingDef} or
     * {@link #loadRenderingDef}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getRenderingDefId(Ice.Callback __cb)
    {
        return begin_getRenderingDefId(null, false, __cb);
    }

    /**
     * Returns the id of the {@link omero.model.RenderingDef}
     * loaded by either {@link #lookupRenderingDef} or
     * {@link #loadRenderingDef}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRenderingDefId(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getRenderingDefId(__ctx, true, __cb);
    }

    /**
     * Returns the id of the {@link omero.model.RenderingDef}
     * loaded by either {@link #lookupRenderingDef} or
     * {@link #loadRenderingDef}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getRenderingDefId(Callback_RenderingEngine_getRenderingDefId __cb)
    {
        return begin_getRenderingDefId(null, false, __cb);
    }

    /**
     * Returns the id of the {@link omero.model.RenderingDef}
     * loaded by either {@link #lookupRenderingDef} or
     * {@link #loadRenderingDef}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRenderingDefId(java.util.Map<String, String> __ctx, Callback_RenderingEngine_getRenderingDefId __cb)
    {
        return begin_getRenderingDefId(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getRenderingDefId(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getRenderingDefId_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getRenderingDefId_name, __cb);
        try
        {
            __result.__prepare(__getRenderingDefId_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public long end_getRenderingDefId(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getRenderingDefId_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the id of the {@link omero.model.RenderingDef}
     * loaded by either {@link #lookupRenderingDef} or
     * {@link #loadRenderingDef}.
     * @param __cb The callback object for the operation.
     **/
    public boolean getRenderingDefId_async(AMI_RenderingEngine_getRenderingDefId __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getRenderingDefId_name);
            __r = begin_getRenderingDefId(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getRenderingDefId_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the id of the {@link omero.model.RenderingDef}
     * loaded by either {@link #lookupRenderingDef} or
     * {@link #loadRenderingDef}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getRenderingDefId_async(AMI_RenderingEngine_getRenderingDefId __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getRenderingDefId_name);
            __r = begin_getRenderingDefId(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getRenderingDefId_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __isActive_name = "isActive";

    /**
     * Returns <code>true</code> if the channel is mapped,
     * <code>false</code> otherwise.
     * 
     * @param w The channel index.
     **/
    public boolean isActive(int w)
        throws omero.ServerError
    {
        return isActive(w, null, false);
    }

    /**
     * Returns <code>true</code> if the channel is mapped,
     * <code>false</code> otherwise.
     * 
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isActive(int w, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return isActive(w, __ctx, true);
    }

    private boolean isActive(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isActive", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isActive");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.isActive(w, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns <code>true</code> if the channel is mapped,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_isActive(int w)
    {
        return begin_isActive(w, null, false, null);
    }

    /**
     * Returns <code>true</code> if the channel is mapped,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isActive(int w, java.util.Map<String, String> __ctx)
    {
        return begin_isActive(w, __ctx, true, null);
    }

    /**
     * Returns <code>true</code> if the channel is mapped,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_isActive(int w, Ice.Callback __cb)
    {
        return begin_isActive(w, null, false, __cb);
    }

    /**
     * Returns <code>true</code> if the channel is mapped,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isActive(int w, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isActive(w, __ctx, true, __cb);
    }

    /**
     * Returns <code>true</code> if the channel is mapped,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_isActive(int w, Callback_RenderingEngine_isActive __cb)
    {
        return begin_isActive(w, null, false, __cb);
    }

    /**
     * Returns <code>true</code> if the channel is mapped,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isActive(int w, java.util.Map<String, String> __ctx, Callback_RenderingEngine_isActive __cb)
    {
        return begin_isActive(w, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isActive(int w, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isActive_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isActive_name, __cb);
        try
        {
            __result.__prepare(__isActive_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(w);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_isActive(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __isActive_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns <code>true</code> if the channel is mapped,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public boolean isActive_async(AMI_RenderingEngine_isActive __cb, int w)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isActive_name);
            __r = begin_isActive(w, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isActive_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns <code>true</code> if the channel is mapped,
     * <code>false</code> otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isActive_async(AMI_RenderingEngine_isActive __cb, int w, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isActive_name);
            __r = begin_isActive(w, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isActive_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __isPixelsTypeSigned_name = "isPixelsTypeSigned";

    /**
     * Returns <code>true</code> if the pixels type is signed,
     * <code>false</code> otherwise.
     **/
    public boolean isPixelsTypeSigned()
        throws omero.ServerError
    {
        return isPixelsTypeSigned(null, false);
    }

    /**
     * Returns <code>true</code> if the pixels type is signed,
     * <code>false</code> otherwise.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isPixelsTypeSigned(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return isPixelsTypeSigned(__ctx, true);
    }

    private boolean isPixelsTypeSigned(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isPixelsTypeSigned", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isPixelsTypeSigned");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.isPixelsTypeSigned(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns <code>true</code> if the pixels type is signed,
     * <code>false</code> otherwise.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isPixelsTypeSigned()
    {
        return begin_isPixelsTypeSigned(null, false, null);
    }

    /**
     * Returns <code>true</code> if the pixels type is signed,
     * <code>false</code> otherwise.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isPixelsTypeSigned(java.util.Map<String, String> __ctx)
    {
        return begin_isPixelsTypeSigned(__ctx, true, null);
    }

    /**
     * Returns <code>true</code> if the pixels type is signed,
     * <code>false</code> otherwise.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isPixelsTypeSigned(Ice.Callback __cb)
    {
        return begin_isPixelsTypeSigned(null, false, __cb);
    }

    /**
     * Returns <code>true</code> if the pixels type is signed,
     * <code>false</code> otherwise.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isPixelsTypeSigned(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isPixelsTypeSigned(__ctx, true, __cb);
    }

    /**
     * Returns <code>true</code> if the pixels type is signed,
     * <code>false</code> otherwise.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isPixelsTypeSigned(Callback_RenderingEngine_isPixelsTypeSigned __cb)
    {
        return begin_isPixelsTypeSigned(null, false, __cb);
    }

    /**
     * Returns <code>true</code> if the pixels type is signed,
     * <code>false</code> otherwise.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isPixelsTypeSigned(java.util.Map<String, String> __ctx, Callback_RenderingEngine_isPixelsTypeSigned __cb)
    {
        return begin_isPixelsTypeSigned(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isPixelsTypeSigned(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isPixelsTypeSigned_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isPixelsTypeSigned_name, __cb);
        try
        {
            __result.__prepare(__isPixelsTypeSigned_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_isPixelsTypeSigned(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __isPixelsTypeSigned_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns <code>true</code> if the pixels type is signed,
     * <code>false</code> otherwise.
     * @param __cb The callback object for the operation.
     **/
    public boolean isPixelsTypeSigned_async(AMI_RenderingEngine_isPixelsTypeSigned __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isPixelsTypeSigned_name);
            __r = begin_isPixelsTypeSigned(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isPixelsTypeSigned_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns <code>true</code> if the pixels type is signed,
     * <code>false</code> otherwise.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isPixelsTypeSigned_async(AMI_RenderingEngine_isPixelsTypeSigned __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isPixelsTypeSigned_name);
            __r = begin_isPixelsTypeSigned(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isPixelsTypeSigned_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __load_name = "load";

    /**
     * Creates an instance of the rendering engine.
     **/
    public void load()
        throws omero.ServerError
    {
        load(null, false);
    }

    /**
     * Creates an instance of the rendering engine.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void load(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        load(__ctx, true);
    }

    private void load(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "load", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("load");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.load(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Creates an instance of the rendering engine.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_load()
    {
        return begin_load(null, false, null);
    }

    /**
     * Creates an instance of the rendering engine.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_load(java.util.Map<String, String> __ctx)
    {
        return begin_load(__ctx, true, null);
    }

    /**
     * Creates an instance of the rendering engine.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_load(Ice.Callback __cb)
    {
        return begin_load(null, false, __cb);
    }

    /**
     * Creates an instance of the rendering engine.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_load(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_load(__ctx, true, __cb);
    }

    /**
     * Creates an instance of the rendering engine.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_load(Callback_RenderingEngine_load __cb)
    {
        return begin_load(null, false, __cb);
    }

    /**
     * Creates an instance of the rendering engine.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_load(java.util.Map<String, String> __ctx, Callback_RenderingEngine_load __cb)
    {
        return begin_load(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_load(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__load_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __load_name, __cb);
        try
        {
            __result.__prepare(__load_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_load(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __load_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Creates an instance of the rendering engine.
     * @param __cb The callback object for the operation.
     **/
    public boolean load_async(AMI_RenderingEngine_load __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__load_name);
            __r = begin_load(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __load_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Creates an instance of the rendering engine.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean load_async(AMI_RenderingEngine_load __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__load_name);
            __r = begin_load(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __load_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __loadRenderingDef_name = "loadRenderingDef";

    /**
     * Loads a specific set of rendering settings that does not
     * necessarily have to be linked to the given Pixels set.
     * However, the rendering settings <b>must</b> be linked to a
     * compatible Pixels set as defined by
     * {@link omero.api.IRenderingSettings#sanityCheckPixels}.
     * 
     * @param renderingDefId The rendering definition ID.
     * @throws ValidationException If a RenderingDef does not
     * exist with the ID <code>renderingDefId</code> or if
     * the RenderingDef is incompatible due to differing
     * pixels sets.
     **/
    public void loadRenderingDef(long renderingDefId)
        throws omero.ServerError
    {
        loadRenderingDef(renderingDefId, null, false);
    }

    /**
     * Loads a specific set of rendering settings that does not
     * necessarily have to be linked to the given Pixels set.
     * However, the rendering settings <b>must</b> be linked to a
     * compatible Pixels set as defined by
     * {@link omero.api.IRenderingSettings#sanityCheckPixels}.
     * 
     * @param renderingDefId The rendering definition ID.
     * @throws ValidationException If a RenderingDef does not
     * exist with the ID <code>renderingDefId</code> or if
     * the RenderingDef is incompatible due to differing
     * pixels sets.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void loadRenderingDef(long renderingDefId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        loadRenderingDef(renderingDefId, __ctx, true);
    }

    private void loadRenderingDef(long renderingDefId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "loadRenderingDef", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("loadRenderingDef");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.loadRenderingDef(renderingDefId, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Loads a specific set of rendering settings that does not
     * necessarily have to be linked to the given Pixels set.
     * However, the rendering settings <b>must</b> be linked to a
     * compatible Pixels set as defined by
     * {@link omero.api.IRenderingSettings#sanityCheckPixels}.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId The rendering definition ID.
     **/
    public Ice.AsyncResult begin_loadRenderingDef(long renderingDefId)
    {
        return begin_loadRenderingDef(renderingDefId, null, false, null);
    }

    /**
     * Loads a specific set of rendering settings that does not
     * necessarily have to be linked to the given Pixels set.
     * However, the rendering settings <b>must</b> be linked to a
     * compatible Pixels set as defined by
     * {@link omero.api.IRenderingSettings#sanityCheckPixels}.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId The rendering definition ID.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadRenderingDef(long renderingDefId, java.util.Map<String, String> __ctx)
    {
        return begin_loadRenderingDef(renderingDefId, __ctx, true, null);
    }

    /**
     * Loads a specific set of rendering settings that does not
     * necessarily have to be linked to the given Pixels set.
     * However, the rendering settings <b>must</b> be linked to a
     * compatible Pixels set as defined by
     * {@link omero.api.IRenderingSettings#sanityCheckPixels}.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId The rendering definition ID.
     **/
    public Ice.AsyncResult begin_loadRenderingDef(long renderingDefId, Ice.Callback __cb)
    {
        return begin_loadRenderingDef(renderingDefId, null, false, __cb);
    }

    /**
     * Loads a specific set of rendering settings that does not
     * necessarily have to be linked to the given Pixels set.
     * However, the rendering settings <b>must</b> be linked to a
     * compatible Pixels set as defined by
     * {@link omero.api.IRenderingSettings#sanityCheckPixels}.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId The rendering definition ID.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadRenderingDef(long renderingDefId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_loadRenderingDef(renderingDefId, __ctx, true, __cb);
    }

    /**
     * Loads a specific set of rendering settings that does not
     * necessarily have to be linked to the given Pixels set.
     * However, the rendering settings <b>must</b> be linked to a
     * compatible Pixels set as defined by
     * {@link omero.api.IRenderingSettings#sanityCheckPixels}.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId The rendering definition ID.
     **/
    public Ice.AsyncResult begin_loadRenderingDef(long renderingDefId, Callback_RenderingEngine_loadRenderingDef __cb)
    {
        return begin_loadRenderingDef(renderingDefId, null, false, __cb);
    }

    /**
     * Loads a specific set of rendering settings that does not
     * necessarily have to be linked to the given Pixels set.
     * However, the rendering settings <b>must</b> be linked to a
     * compatible Pixels set as defined by
     * {@link omero.api.IRenderingSettings#sanityCheckPixels}.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId The rendering definition ID.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_loadRenderingDef(long renderingDefId, java.util.Map<String, String> __ctx, Callback_RenderingEngine_loadRenderingDef __cb)
    {
        return begin_loadRenderingDef(renderingDefId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_loadRenderingDef(long renderingDefId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__loadRenderingDef_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __loadRenderingDef_name, __cb);
        try
        {
            __result.__prepare(__loadRenderingDef_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(renderingDefId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_loadRenderingDef(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __loadRenderingDef_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Loads a specific set of rendering settings that does not
     * necessarily have to be linked to the given Pixels set.
     * However, the rendering settings <b>must</b> be linked to a
     * compatible Pixels set as defined by
     * {@link omero.api.IRenderingSettings#sanityCheckPixels}.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId The rendering definition ID.
     **/
    public boolean loadRenderingDef_async(AMI_RenderingEngine_loadRenderingDef __cb, long renderingDefId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadRenderingDef_name);
            __r = begin_loadRenderingDef(renderingDefId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadRenderingDef_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Loads a specific set of rendering settings that does not
     * necessarily have to be linked to the given Pixels set.
     * However, the rendering settings <b>must</b> be linked to a
     * compatible Pixels set as defined by
     * {@link omero.api.IRenderingSettings#sanityCheckPixels}.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId The rendering definition ID.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean loadRenderingDef_async(AMI_RenderingEngine_loadRenderingDef __cb, long renderingDefId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__loadRenderingDef_name);
            __r = begin_loadRenderingDef(renderingDefId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __loadRenderingDef_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __lookupPixels_name = "lookupPixels";

    /**
     * Loads the Pixels set this Rendering Engine is for.
     * 
     * @param pixelsId The pixels set ID.
     **/
    public void lookupPixels(long pixelsId)
        throws omero.ServerError
    {
        lookupPixels(pixelsId, null, false);
    }

    /**
     * Loads the Pixels set this Rendering Engine is for.
     * 
     * @param pixelsId The pixels set ID.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void lookupPixels(long pixelsId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        lookupPixels(pixelsId, __ctx, true);
    }

    private void lookupPixels(long pixelsId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "lookupPixels", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("lookupPixels");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.lookupPixels(pixelsId, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Loads the Pixels set this Rendering Engine is for.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The pixels set ID.
     **/
    public Ice.AsyncResult begin_lookupPixels(long pixelsId)
    {
        return begin_lookupPixels(pixelsId, null, false, null);
    }

    /**
     * Loads the Pixels set this Rendering Engine is for.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The pixels set ID.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupPixels(long pixelsId, java.util.Map<String, String> __ctx)
    {
        return begin_lookupPixels(pixelsId, __ctx, true, null);
    }

    /**
     * Loads the Pixels set this Rendering Engine is for.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The pixels set ID.
     **/
    public Ice.AsyncResult begin_lookupPixels(long pixelsId, Ice.Callback __cb)
    {
        return begin_lookupPixels(pixelsId, null, false, __cb);
    }

    /**
     * Loads the Pixels set this Rendering Engine is for.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The pixels set ID.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupPixels(long pixelsId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_lookupPixels(pixelsId, __ctx, true, __cb);
    }

    /**
     * Loads the Pixels set this Rendering Engine is for.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The pixels set ID.
     **/
    public Ice.AsyncResult begin_lookupPixels(long pixelsId, Callback_RenderingEngine_lookupPixels __cb)
    {
        return begin_lookupPixels(pixelsId, null, false, __cb);
    }

    /**
     * Loads the Pixels set this Rendering Engine is for.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The pixels set ID.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupPixels(long pixelsId, java.util.Map<String, String> __ctx, Callback_RenderingEngine_lookupPixels __cb)
    {
        return begin_lookupPixels(pixelsId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_lookupPixels(long pixelsId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__lookupPixels_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __lookupPixels_name, __cb);
        try
        {
            __result.__prepare(__lookupPixels_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(pixelsId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_lookupPixels(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __lookupPixels_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Loads the Pixels set this Rendering Engine is for.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The pixels set ID.
     **/
    public boolean lookupPixels_async(AMI_RenderingEngine_lookupPixels __cb, long pixelsId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__lookupPixels_name);
            __r = begin_lookupPixels(pixelsId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __lookupPixels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Loads the Pixels set this Rendering Engine is for.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The pixels set ID.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean lookupPixels_async(AMI_RenderingEngine_lookupPixels __cb, long pixelsId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__lookupPixels_name);
            __r = begin_lookupPixels(pixelsId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __lookupPixels_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __lookupRenderingDef_name = "lookupRenderingDef";

    /**
     * Loads the rendering settings associated to the specified
     * pixels set.
     * 
     * @param pixelsId The pixels set ID.
     * @return <code>true</code> if a RenderingDef exists for the
     * Pixels set, otherwise <code>false</code>.
     **/
    public boolean lookupRenderingDef(long pixelsId)
        throws omero.ServerError
    {
        return lookupRenderingDef(pixelsId, null, false);
    }

    /**
     * Loads the rendering settings associated to the specified
     * pixels set.
     * 
     * @param pixelsId The pixels set ID.
     * @param __ctx The Context map to send with the invocation.
     * @return <code>true</code> if a RenderingDef exists for the
     * Pixels set, otherwise <code>false</code>.
     **/
    public boolean lookupRenderingDef(long pixelsId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return lookupRenderingDef(pixelsId, __ctx, true);
    }

    private boolean lookupRenderingDef(long pixelsId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "lookupRenderingDef", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("lookupRenderingDef");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.lookupRenderingDef(pixelsId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Loads the rendering settings associated to the specified
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The pixels set ID.
     **/
    public Ice.AsyncResult begin_lookupRenderingDef(long pixelsId)
    {
        return begin_lookupRenderingDef(pixelsId, null, false, null);
    }

    /**
     * Loads the rendering settings associated to the specified
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The pixels set ID.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupRenderingDef(long pixelsId, java.util.Map<String, String> __ctx)
    {
        return begin_lookupRenderingDef(pixelsId, __ctx, true, null);
    }

    /**
     * Loads the rendering settings associated to the specified
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The pixels set ID.
     **/
    public Ice.AsyncResult begin_lookupRenderingDef(long pixelsId, Ice.Callback __cb)
    {
        return begin_lookupRenderingDef(pixelsId, null, false, __cb);
    }

    /**
     * Loads the rendering settings associated to the specified
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The pixels set ID.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupRenderingDef(long pixelsId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_lookupRenderingDef(pixelsId, __ctx, true, __cb);
    }

    /**
     * Loads the rendering settings associated to the specified
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The pixels set ID.
     **/
    public Ice.AsyncResult begin_lookupRenderingDef(long pixelsId, Callback_RenderingEngine_lookupRenderingDef __cb)
    {
        return begin_lookupRenderingDef(pixelsId, null, false, __cb);
    }

    /**
     * Loads the rendering settings associated to the specified
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The pixels set ID.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_lookupRenderingDef(long pixelsId, java.util.Map<String, String> __ctx, Callback_RenderingEngine_lookupRenderingDef __cb)
    {
        return begin_lookupRenderingDef(pixelsId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_lookupRenderingDef(long pixelsId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__lookupRenderingDef_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __lookupRenderingDef_name, __cb);
        try
        {
            __result.__prepare(__lookupRenderingDef_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(pixelsId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) <code>true</code> if a RenderingDef exists for the
     * Pixels set, otherwise <code>false</code>.
     **/
    public boolean end_lookupRenderingDef(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __lookupRenderingDef_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Loads the rendering settings associated to the specified
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The pixels set ID.
     **/
    public boolean lookupRenderingDef_async(AMI_RenderingEngine_lookupRenderingDef __cb, long pixelsId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__lookupRenderingDef_name);
            __r = begin_lookupRenderingDef(pixelsId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __lookupRenderingDef_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Loads the rendering settings associated to the specified
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId The pixels set ID.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean lookupRenderingDef_async(AMI_RenderingEngine_lookupRenderingDef __cb, long pixelsId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__lookupRenderingDef_name);
            __r = begin_lookupRenderingDef(pixelsId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __lookupRenderingDef_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __removeCodomainMap_name = "removeCodomainMap";

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param mapCtx The context to remove.
     * @see #addCodomainMap
     * @see #updateCodomainMap
     * @deprecated This operation has been deprecated.
     **/
    public void removeCodomainMap(omero.romio.CodomainMapContext mapCtx)
        throws omero.ServerError
    {
        removeCodomainMap(mapCtx, null, false);
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param mapCtx The context to remove.
     * @see #addCodomainMap
     * @see #updateCodomainMap
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public void removeCodomainMap(omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        removeCodomainMap(mapCtx, __ctx, true);
    }

    private void removeCodomainMap(omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "removeCodomainMap", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("removeCodomainMap");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.removeCodomainMap(mapCtx, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to remove.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_removeCodomainMap(omero.romio.CodomainMapContext mapCtx)
    {
        return begin_removeCodomainMap(mapCtx, null, false, null);
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to remove.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_removeCodomainMap(omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx)
    {
        return begin_removeCodomainMap(mapCtx, __ctx, true, null);
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to remove.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_removeCodomainMap(omero.romio.CodomainMapContext mapCtx, Ice.Callback __cb)
    {
        return begin_removeCodomainMap(mapCtx, null, false, __cb);
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to remove.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_removeCodomainMap(omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_removeCodomainMap(mapCtx, __ctx, true, __cb);
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to remove.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_removeCodomainMap(omero.romio.CodomainMapContext mapCtx, Callback_RenderingEngine_removeCodomainMap __cb)
    {
        return begin_removeCodomainMap(mapCtx, null, false, __cb);
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to remove.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_removeCodomainMap(omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx, Callback_RenderingEngine_removeCodomainMap __cb)
    {
        return begin_removeCodomainMap(mapCtx, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_removeCodomainMap(omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__removeCodomainMap_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __removeCodomainMap_name, __cb);
        try
        {
            __result.__prepare(__removeCodomainMap_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(mapCtx);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_removeCodomainMap(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __removeCodomainMap_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to remove.
     * @deprecated This operation has been deprecated.
     **/
    public boolean removeCodomainMap_async(AMI_RenderingEngine_removeCodomainMap __cb, omero.romio.CodomainMapContext mapCtx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeCodomainMap_name);
            __r = begin_removeCodomainMap(mapCtx, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeCodomainMap_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to remove.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean removeCodomainMap_async(AMI_RenderingEngine_removeCodomainMap __cb, omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeCodomainMap_name);
            __r = begin_removeCodomainMap(mapCtx, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeCodomainMap_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __removeCodomainMapFromChannel_name = "removeCodomainMapFromChannel";

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param mapCtx The context to remove.
     * @param w The channel to remove the context from.
     * @see #addCodomainMapToChannel
     **/
    public void removeCodomainMapFromChannel(omero.romio.CodomainMapContext mapCtx, int w)
        throws omero.ServerError
    {
        removeCodomainMapFromChannel(mapCtx, w, null, false);
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param mapCtx The context to remove.
     * @param w The channel to remove the context from.
     * @see #addCodomainMapToChannel
     * @param __ctx The Context map to send with the invocation.
     **/
    public void removeCodomainMapFromChannel(omero.romio.CodomainMapContext mapCtx, int w, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        removeCodomainMapFromChannel(mapCtx, w, __ctx, true);
    }

    private void removeCodomainMapFromChannel(omero.romio.CodomainMapContext mapCtx, int w, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "removeCodomainMapFromChannel", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("removeCodomainMapFromChannel");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.removeCodomainMapFromChannel(mapCtx, w, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to remove.
     **/
    public Ice.AsyncResult begin_removeCodomainMapFromChannel(omero.romio.CodomainMapContext mapCtx, int w)
    {
        return begin_removeCodomainMapFromChannel(mapCtx, w, null, false, null);
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to remove.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeCodomainMapFromChannel(omero.romio.CodomainMapContext mapCtx, int w, java.util.Map<String, String> __ctx)
    {
        return begin_removeCodomainMapFromChannel(mapCtx, w, __ctx, true, null);
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to remove.
     **/
    public Ice.AsyncResult begin_removeCodomainMapFromChannel(omero.romio.CodomainMapContext mapCtx, int w, Ice.Callback __cb)
    {
        return begin_removeCodomainMapFromChannel(mapCtx, w, null, false, __cb);
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to remove.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeCodomainMapFromChannel(omero.romio.CodomainMapContext mapCtx, int w, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_removeCodomainMapFromChannel(mapCtx, w, __ctx, true, __cb);
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to remove.
     **/
    public Ice.AsyncResult begin_removeCodomainMapFromChannel(omero.romio.CodomainMapContext mapCtx, int w, Callback_RenderingEngine_removeCodomainMapFromChannel __cb)
    {
        return begin_removeCodomainMapFromChannel(mapCtx, w, null, false, __cb);
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to remove.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_removeCodomainMapFromChannel(omero.romio.CodomainMapContext mapCtx, int w, java.util.Map<String, String> __ctx, Callback_RenderingEngine_removeCodomainMapFromChannel __cb)
    {
        return begin_removeCodomainMapFromChannel(mapCtx, w, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_removeCodomainMapFromChannel(omero.romio.CodomainMapContext mapCtx, int w, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__removeCodomainMapFromChannel_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __removeCodomainMapFromChannel_name, __cb);
        try
        {
            __result.__prepare(__removeCodomainMapFromChannel_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(mapCtx);
            __os.writeInt(w);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_removeCodomainMapFromChannel(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __removeCodomainMapFromChannel_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to remove.
     **/
    public boolean removeCodomainMapFromChannel_async(AMI_RenderingEngine_removeCodomainMapFromChannel __cb, omero.romio.CodomainMapContext mapCtx, int w)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeCodomainMapFromChannel_name);
            __r = begin_removeCodomainMapFromChannel(mapCtx, w, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeCodomainMapFromChannel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Removes the specified context from the chain. Each time a
     * new context is removed, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to remove.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean removeCodomainMapFromChannel_async(AMI_RenderingEngine_removeCodomainMapFromChannel __cb, omero.romio.CodomainMapContext mapCtx, int w, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__removeCodomainMapFromChannel_name);
            __r = begin_removeCodomainMapFromChannel(mapCtx, w, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __removeCodomainMapFromChannel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __render_name = "render";

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     * @return An <i>RGB</i> image ready to be displayed on screen.
     * @throws ValidationException
     * If <code>def</code> is <code>null</code>.
     **/
    public omero.romio.RGBBuffer render(omero.romio.PlaneDef def)
        throws omero.ServerError
    {
        return render(def, null, false);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     * @param __ctx The Context map to send with the invocation.
     * @return An <i>RGB</i> image ready to be displayed on screen.
     * @throws ValidationException
     * If <code>def</code> is <code>null</code>.
     **/
    public omero.romio.RGBBuffer render(omero.romio.PlaneDef def, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return render(def, __ctx, true);
    }

    private omero.romio.RGBBuffer render(omero.romio.PlaneDef def, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "render", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("render");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.render(def, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     **/
    public Ice.AsyncResult begin_render(omero.romio.PlaneDef def)
    {
        return begin_render(def, null, false, null);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_render(omero.romio.PlaneDef def, java.util.Map<String, String> __ctx)
    {
        return begin_render(def, __ctx, true, null);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     **/
    public Ice.AsyncResult begin_render(omero.romio.PlaneDef def, Ice.Callback __cb)
    {
        return begin_render(def, null, false, __cb);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_render(omero.romio.PlaneDef def, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_render(def, __ctx, true, __cb);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     **/
    public Ice.AsyncResult begin_render(omero.romio.PlaneDef def, Callback_RenderingEngine_render __cb)
    {
        return begin_render(def, null, false, __cb);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_render(omero.romio.PlaneDef def, java.util.Map<String, String> __ctx, Callback_RenderingEngine_render __cb)
    {
        return begin_render(def, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_render(omero.romio.PlaneDef def, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__render_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __render_name, __cb);
        try
        {
            __result.__prepare(__render_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(def);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) An <i>RGB</i> image ready to be displayed on screen.
     **/
    public omero.romio.RGBBuffer end_render(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __render_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.romio.RGBBufferHolder __ret = new omero.romio.RGBBufferHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     **/
    public boolean render_async(AMI_RenderingEngine_render __cb, omero.romio.PlaneDef def)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__render_name);
            __r = begin_render(def, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __render_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean render_async(AMI_RenderingEngine_render __cb, omero.romio.PlaneDef def, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__render_name);
            __r = begin_render(def, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __render_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __renderAsPackedInt_name = "renderAsPackedInt";

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     * @return An <i>RGB</i> image ready to be displayed on screen.
     * @throws ValidationException
     * If <code>def</code> is <code>null</code>.
     * @see {@link #render}
     **/
    public int[] renderAsPackedInt(omero.romio.PlaneDef def)
        throws omero.ServerError
    {
        return renderAsPackedInt(def, null, false);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     * @param __ctx The Context map to send with the invocation.
     * @return An <i>RGB</i> image ready to be displayed on screen.
     * @throws ValidationException
     * If <code>def</code> is <code>null</code>.
     * @see {@link #render}
     **/
    public int[] renderAsPackedInt(omero.romio.PlaneDef def, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return renderAsPackedInt(def, __ctx, true);
    }

    private int[] renderAsPackedInt(omero.romio.PlaneDef def, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "renderAsPackedInt", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("renderAsPackedInt");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.renderAsPackedInt(def, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     **/
    public Ice.AsyncResult begin_renderAsPackedInt(omero.romio.PlaneDef def)
    {
        return begin_renderAsPackedInt(def, null, false, null);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_renderAsPackedInt(omero.romio.PlaneDef def, java.util.Map<String, String> __ctx)
    {
        return begin_renderAsPackedInt(def, __ctx, true, null);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     **/
    public Ice.AsyncResult begin_renderAsPackedInt(omero.romio.PlaneDef def, Ice.Callback __cb)
    {
        return begin_renderAsPackedInt(def, null, false, __cb);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_renderAsPackedInt(omero.romio.PlaneDef def, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_renderAsPackedInt(def, __ctx, true, __cb);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     **/
    public Ice.AsyncResult begin_renderAsPackedInt(omero.romio.PlaneDef def, Callback_RenderingEngine_renderAsPackedInt __cb)
    {
        return begin_renderAsPackedInt(def, null, false, __cb);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_renderAsPackedInt(omero.romio.PlaneDef def, java.util.Map<String, String> __ctx, Callback_RenderingEngine_renderAsPackedInt __cb)
    {
        return begin_renderAsPackedInt(def, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_renderAsPackedInt(omero.romio.PlaneDef def, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__renderAsPackedInt_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __renderAsPackedInt_name, __cb);
        try
        {
            __result.__prepare(__renderAsPackedInt_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(def);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) An <i>RGB</i> image ready to be displayed on screen.
     **/
    public int[] end_renderAsPackedInt(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __renderAsPackedInt_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int[] __ret;
            __ret = Ice.IntSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     **/
    public boolean renderAsPackedInt_async(AMI_RenderingEngine_renderAsPackedInt __cb, omero.romio.PlaneDef def)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__renderAsPackedInt_name);
            __r = begin_renderAsPackedInt(def, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __renderAsPackedInt_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings.
     * The passed argument selects a plane orthogonal to one
     * of the <i>X</i>, <i>Y</i>, or <i>Z</i> axes. How many
     * wavelengths are rendered and what color model is used
     * depends on the current rendering settings.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i>, or <i>Z</i> axes.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean renderAsPackedInt_async(AMI_RenderingEngine_renderAsPackedInt __cb, omero.romio.PlaneDef def, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__renderAsPackedInt_name);
            __r = begin_renderAsPackedInt(def, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __renderAsPackedInt_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __renderCompressed_name = "renderCompressed";

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings and compresses the resulting
     * RGBA composite image.
     * 
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i> or <i>Z</i> axes.
     * @return A compressed RGBA JPEG for display.
     * @throws ValidationException
     * If <code>def</code> is <code>null</code>.
     * @see #render
     * @see #renderAsPackedInt
     **/
    public byte[] renderCompressed(omero.romio.PlaneDef def)
        throws omero.ServerError
    {
        return renderCompressed(def, null, false);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings and compresses the resulting
     * RGBA composite image.
     * 
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i> or <i>Z</i> axes.
     * @param __ctx The Context map to send with the invocation.
     * @return A compressed RGBA JPEG for display.
     * @throws ValidationException
     * If <code>def</code> is <code>null</code>.
     * @see #render
     * @see #renderAsPackedInt
     **/
    public byte[] renderCompressed(omero.romio.PlaneDef def, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return renderCompressed(def, __ctx, true);
    }

    private byte[] renderCompressed(omero.romio.PlaneDef def, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "renderCompressed", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("renderCompressed");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.renderCompressed(def, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings and compresses the resulting
     * RGBA composite image.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i> or <i>Z</i> axes.
     **/
    public Ice.AsyncResult begin_renderCompressed(omero.romio.PlaneDef def)
    {
        return begin_renderCompressed(def, null, false, null);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings and compresses the resulting
     * RGBA composite image.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i> or <i>Z</i> axes.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_renderCompressed(omero.romio.PlaneDef def, java.util.Map<String, String> __ctx)
    {
        return begin_renderCompressed(def, __ctx, true, null);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings and compresses the resulting
     * RGBA composite image.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i> or <i>Z</i> axes.
     **/
    public Ice.AsyncResult begin_renderCompressed(omero.romio.PlaneDef def, Ice.Callback __cb)
    {
        return begin_renderCompressed(def, null, false, __cb);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings and compresses the resulting
     * RGBA composite image.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i> or <i>Z</i> axes.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_renderCompressed(omero.romio.PlaneDef def, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_renderCompressed(def, __ctx, true, __cb);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings and compresses the resulting
     * RGBA composite image.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i> or <i>Z</i> axes.
     **/
    public Ice.AsyncResult begin_renderCompressed(omero.romio.PlaneDef def, Callback_RenderingEngine_renderCompressed __cb)
    {
        return begin_renderCompressed(def, null, false, __cb);
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings and compresses the resulting
     * RGBA composite image.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i> or <i>Z</i> axes.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_renderCompressed(omero.romio.PlaneDef def, java.util.Map<String, String> __ctx, Callback_RenderingEngine_renderCompressed __cb)
    {
        return begin_renderCompressed(def, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_renderCompressed(omero.romio.PlaneDef def, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__renderCompressed_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __renderCompressed_name, __cb);
        try
        {
            __result.__prepare(__renderCompressed_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(def);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) A compressed RGBA JPEG for display.
     **/
    public byte[] end_renderCompressed(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __renderCompressed_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings and compresses the resulting
     * RGBA composite image.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i> or <i>Z</i> axes.
     **/
    public boolean renderCompressed_async(AMI_RenderingEngine_renderCompressed __cb, omero.romio.PlaneDef def)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__renderCompressed_name);
            __r = begin_renderCompressed(def, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __renderCompressed_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Renders the data selected by <code>def</code> according to
     * the current rendering settings and compresses the resulting
     * RGBA composite image.
     * 
     * @param __cb The callback object for the operation.
     * @param def Selects a plane orthogonal to one of the
     * <i>X</i>, <i>Y</i> or <i>Z</i> axes.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean renderCompressed_async(AMI_RenderingEngine_renderCompressed __cb, omero.romio.PlaneDef def, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__renderCompressed_name);
            __r = begin_renderCompressed(def, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __renderCompressed_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __renderProjectedAsPackedInt_name = "renderProjectedAsPackedInt";

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels
     * and renders the data for display.
     * 
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param end Optical section to finish projecting.
     * @return A packed-integer <i>RGBA</i> rendered image of the
     * projected pixels.
     * @throws ValidationException Where:
     * <ul>
     * <li><code>algorithm</code> is unknown</li>
     * <li><code>timepoint</code> is out of range</li>
     * <li><code>start</code> is out of range</li>
     * <li><code>end</code> is out of range</li>
     * <li><code>start > end</code></li>
     * </ul>
     * @see omero.api.IProjection#projectPixels
     **/
    public int[] renderProjectedAsPackedInt(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end)
        throws omero.ServerError
    {
        return renderProjectedAsPackedInt(algorithm, timepoint, stepping, start, end, null, false);
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels
     * and renders the data for display.
     * 
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param end Optical section to finish projecting.
     * @param __ctx The Context map to send with the invocation.
     * @return A packed-integer <i>RGBA</i> rendered image of the
     * projected pixels.
     * @throws ValidationException Where:
     * <ul>
     * <li><code>algorithm</code> is unknown</li>
     * <li><code>timepoint</code> is out of range</li>
     * <li><code>start</code> is out of range</li>
     * <li><code>end</code> is out of range</li>
     * <li><code>start > end</code></li>
     * </ul>
     * @see omero.api.IProjection#projectPixels
     **/
    public int[] renderProjectedAsPackedInt(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return renderProjectedAsPackedInt(algorithm, timepoint, stepping, start, end, __ctx, true);
    }

    private int[] renderProjectedAsPackedInt(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "renderProjectedAsPackedInt", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("renderProjectedAsPackedInt");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.renderProjectedAsPackedInt(algorithm, timepoint, stepping, start, end, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels
     * and renders the data for display.
     * 
     * @param __cb The callback object for the operation.
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     **/
    public Ice.AsyncResult begin_renderProjectedAsPackedInt(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end)
    {
        return begin_renderProjectedAsPackedInt(algorithm, timepoint, stepping, start, end, null, false, null);
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels
     * and renders the data for display.
     * 
     * @param __cb The callback object for the operation.
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_renderProjectedAsPackedInt(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end, java.util.Map<String, String> __ctx)
    {
        return begin_renderProjectedAsPackedInt(algorithm, timepoint, stepping, start, end, __ctx, true, null);
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels
     * and renders the data for display.
     * 
     * @param __cb The callback object for the operation.
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     **/
    public Ice.AsyncResult begin_renderProjectedAsPackedInt(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end, Ice.Callback __cb)
    {
        return begin_renderProjectedAsPackedInt(algorithm, timepoint, stepping, start, end, null, false, __cb);
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels
     * and renders the data for display.
     * 
     * @param __cb The callback object for the operation.
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_renderProjectedAsPackedInt(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_renderProjectedAsPackedInt(algorithm, timepoint, stepping, start, end, __ctx, true, __cb);
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels
     * and renders the data for display.
     * 
     * @param __cb The callback object for the operation.
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     **/
    public Ice.AsyncResult begin_renderProjectedAsPackedInt(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end, Callback_RenderingEngine_renderProjectedAsPackedInt __cb)
    {
        return begin_renderProjectedAsPackedInt(algorithm, timepoint, stepping, start, end, null, false, __cb);
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels
     * and renders the data for display.
     * 
     * @param __cb The callback object for the operation.
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_renderProjectedAsPackedInt(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end, java.util.Map<String, String> __ctx, Callback_RenderingEngine_renderProjectedAsPackedInt __cb)
    {
        return begin_renderProjectedAsPackedInt(algorithm, timepoint, stepping, start, end, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_renderProjectedAsPackedInt(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__renderProjectedAsPackedInt_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __renderProjectedAsPackedInt_name, __cb);
        try
        {
            __result.__prepare(__renderProjectedAsPackedInt_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            algorithm.__write(__os);
            __os.writeInt(timepoint);
            __os.writeInt(stepping);
            __os.writeInt(start);
            __os.writeInt(end);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) A packed-integer <i>RGBA</i> rendered image of the
     * projected pixels.
     **/
    public int[] end_renderProjectedAsPackedInt(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __renderProjectedAsPackedInt_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int[] __ret;
            __ret = Ice.IntSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels
     * and renders the data for display.
     * 
     * @param __cb The callback object for the operation.
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     **/
    public boolean renderProjectedAsPackedInt_async(AMI_RenderingEngine_renderProjectedAsPackedInt __cb, omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__renderProjectedAsPackedInt_name);
            __r = begin_renderProjectedAsPackedInt(algorithm, timepoint, stepping, start, end, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __renderProjectedAsPackedInt_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels
     * and renders the data for display.
     * 
     * @param __cb The callback object for the operation.
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean renderProjectedAsPackedInt_async(AMI_RenderingEngine_renderProjectedAsPackedInt __cb, omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__renderProjectedAsPackedInt_name);
            __r = begin_renderProjectedAsPackedInt(algorithm, timepoint, stepping, start, end, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __renderProjectedAsPackedInt_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __renderProjectedCompressed_name = "renderProjectedCompressed";

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels,
     * renders the data for display and compresses the resulting
     * RGBA composite image.
     * 
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param end Optical section to finish projecting.
     * @return A compressed <i>RGBA</i> rendered JPEG image of the
     * projected pixels.
     * @throws ValidationException Where:
     * <ul>
     * <li><code>algorithm</code> is unknown</li>
     * <li><code>timepoint</code> is out of range</li>
     * <li><code>start</code> is out of range</li>
     * <li><code>end</code> is out of range</li>
     * <li><code>start > end</code></li>
     * </ul>
     * @see omero.api.IProjection#projectPixels
     **/
    public byte[] renderProjectedCompressed(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end)
        throws omero.ServerError
    {
        return renderProjectedCompressed(algorithm, timepoint, stepping, start, end, null, false);
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels,
     * renders the data for display and compresses the resulting
     * RGBA composite image.
     * 
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param end Optical section to finish projecting.
     * @param __ctx The Context map to send with the invocation.
     * @return A compressed <i>RGBA</i> rendered JPEG image of the
     * projected pixels.
     * @throws ValidationException Where:
     * <ul>
     * <li><code>algorithm</code> is unknown</li>
     * <li><code>timepoint</code> is out of range</li>
     * <li><code>start</code> is out of range</li>
     * <li><code>end</code> is out of range</li>
     * <li><code>start > end</code></li>
     * </ul>
     * @see omero.api.IProjection#projectPixels
     **/
    public byte[] renderProjectedCompressed(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return renderProjectedCompressed(algorithm, timepoint, stepping, start, end, __ctx, true);
    }

    private byte[] renderProjectedCompressed(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "renderProjectedCompressed", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("renderProjectedCompressed");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.renderProjectedCompressed(algorithm, timepoint, stepping, start, end, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels,
     * renders the data for display and compresses the resulting
     * RGBA composite image.
     * 
     * @param __cb The callback object for the operation.
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     **/
    public Ice.AsyncResult begin_renderProjectedCompressed(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end)
    {
        return begin_renderProjectedCompressed(algorithm, timepoint, stepping, start, end, null, false, null);
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels,
     * renders the data for display and compresses the resulting
     * RGBA composite image.
     * 
     * @param __cb The callback object for the operation.
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_renderProjectedCompressed(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end, java.util.Map<String, String> __ctx)
    {
        return begin_renderProjectedCompressed(algorithm, timepoint, stepping, start, end, __ctx, true, null);
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels,
     * renders the data for display and compresses the resulting
     * RGBA composite image.
     * 
     * @param __cb The callback object for the operation.
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     **/
    public Ice.AsyncResult begin_renderProjectedCompressed(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end, Ice.Callback __cb)
    {
        return begin_renderProjectedCompressed(algorithm, timepoint, stepping, start, end, null, false, __cb);
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels,
     * renders the data for display and compresses the resulting
     * RGBA composite image.
     * 
     * @param __cb The callback object for the operation.
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_renderProjectedCompressed(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_renderProjectedCompressed(algorithm, timepoint, stepping, start, end, __ctx, true, __cb);
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels,
     * renders the data for display and compresses the resulting
     * RGBA composite image.
     * 
     * @param __cb The callback object for the operation.
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     **/
    public Ice.AsyncResult begin_renderProjectedCompressed(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end, Callback_RenderingEngine_renderProjectedCompressed __cb)
    {
        return begin_renderProjectedCompressed(algorithm, timepoint, stepping, start, end, null, false, __cb);
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels,
     * renders the data for display and compresses the resulting
     * RGBA composite image.
     * 
     * @param __cb The callback object for the operation.
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_renderProjectedCompressed(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end, java.util.Map<String, String> __ctx, Callback_RenderingEngine_renderProjectedCompressed __cb)
    {
        return begin_renderProjectedCompressed(algorithm, timepoint, stepping, start, end, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_renderProjectedCompressed(omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__renderProjectedCompressed_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __renderProjectedCompressed_name, __cb);
        try
        {
            __result.__prepare(__renderProjectedCompressed_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            algorithm.__write(__os);
            __os.writeInt(timepoint);
            __os.writeInt(stepping);
            __os.writeInt(start);
            __os.writeInt(end);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) A compressed <i>RGBA</i> rendered JPEG image of the
     * projected pixels.
     **/
    public byte[] end_renderProjectedCompressed(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __renderProjectedCompressed_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels,
     * renders the data for display and compresses the resulting
     * RGBA composite image.
     * 
     * @param __cb The callback object for the operation.
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     **/
    public boolean renderProjectedCompressed_async(AMI_RenderingEngine_renderProjectedCompressed __cb, omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__renderProjectedCompressed_name);
            __r = begin_renderProjectedCompressed(algorithm, timepoint, stepping, start, end, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __renderProjectedCompressed_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Performs a projection through selected optical sections of
     * a particular timepoint with the currently active channels,
     * renders the data for display and compresses the resulting
     * RGBA composite image.
     * 
     * @param __cb The callback object for the operation.
     * @param algorithm {@link ome.api.IProjection#MAXIMUM_INTENSITY},
     * {@link ome.api.IProjection#MEAN_INTENSITY} or
     * {@link ome.api.IProjection#SUM_INTENSITY}.
     * @param stepping Stepping value to use while calculating the
     * projection.
     * For example, <code>stepping=1</code> will
     * use every optical section from
     * <code>start</code> to <code>end</code>
     * where <code>stepping=2</code> will use every
     * other section from <code>start</code> to
     * <code>end</code> to perform the projection.
     * @param start Optical section to start projecting from.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean renderProjectedCompressed_async(AMI_RenderingEngine_renderProjectedCompressed __cb, omero.constants.projection.ProjectionType algorithm, int timepoint, int stepping, int start, int end, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__renderProjectedCompressed_name);
            __r = begin_renderProjectedCompressed(algorithm, timepoint, stepping, start, end, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __renderProjectedCompressed_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __resetDefaultSettings_name = "resetDefaultSettings";

    /**
     * Resets the default settings i.e. the default values
     * internal to the Rendering engine. The settings will be
     * saved.
     * 
     * @param save Pass <code>true</code> to save the settings,
     * <code>false</code> otherwise.
     **/
    public long resetDefaultSettings(boolean save)
        throws omero.ServerError
    {
        return resetDefaultSettings(save, null, false);
    }

    /**
     * Resets the default settings i.e. the default values
     * internal to the Rendering engine. The settings will be
     * saved.
     * 
     * @param save Pass <code>true</code> to save the settings,
     * <code>false</code> otherwise.
     * @param __ctx The Context map to send with the invocation.
     **/
    public long resetDefaultSettings(boolean save, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return resetDefaultSettings(save, __ctx, true);
    }

    private long resetDefaultSettings(boolean save, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "resetDefaultSettings", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("resetDefaultSettings");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.resetDefaultSettings(save, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Resets the default settings i.e. the default values
     * internal to the Rendering engine. The settings will be
     * saved.
     * 
     * @param __cb The callback object for the operation.
     * @param save Pass <code>true</code> to save the settings,
     * <code>false</code> otherwise.
     **/
    public Ice.AsyncResult begin_resetDefaultSettings(boolean save)
    {
        return begin_resetDefaultSettings(save, null, false, null);
    }

    /**
     * Resets the default settings i.e. the default values
     * internal to the Rendering engine. The settings will be
     * saved.
     * 
     * @param __cb The callback object for the operation.
     * @param save Pass <code>true</code> to save the settings,
     * <code>false</code> otherwise.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultSettings(boolean save, java.util.Map<String, String> __ctx)
    {
        return begin_resetDefaultSettings(save, __ctx, true, null);
    }

    /**
     * Resets the default settings i.e. the default values
     * internal to the Rendering engine. The settings will be
     * saved.
     * 
     * @param __cb The callback object for the operation.
     * @param save Pass <code>true</code> to save the settings,
     * <code>false</code> otherwise.
     **/
    public Ice.AsyncResult begin_resetDefaultSettings(boolean save, Ice.Callback __cb)
    {
        return begin_resetDefaultSettings(save, null, false, __cb);
    }

    /**
     * Resets the default settings i.e. the default values
     * internal to the Rendering engine. The settings will be
     * saved.
     * 
     * @param __cb The callback object for the operation.
     * @param save Pass <code>true</code> to save the settings,
     * <code>false</code> otherwise.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultSettings(boolean save, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_resetDefaultSettings(save, __ctx, true, __cb);
    }

    /**
     * Resets the default settings i.e. the default values
     * internal to the Rendering engine. The settings will be
     * saved.
     * 
     * @param __cb The callback object for the operation.
     * @param save Pass <code>true</code> to save the settings,
     * <code>false</code> otherwise.
     **/
    public Ice.AsyncResult begin_resetDefaultSettings(boolean save, Callback_RenderingEngine_resetDefaultSettings __cb)
    {
        return begin_resetDefaultSettings(save, null, false, __cb);
    }

    /**
     * Resets the default settings i.e. the default values
     * internal to the Rendering engine. The settings will be
     * saved.
     * 
     * @param __cb The callback object for the operation.
     * @param save Pass <code>true</code> to save the settings,
     * <code>false</code> otherwise.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaultSettings(boolean save, java.util.Map<String, String> __ctx, Callback_RenderingEngine_resetDefaultSettings __cb)
    {
        return begin_resetDefaultSettings(save, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_resetDefaultSettings(boolean save, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__resetDefaultSettings_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __resetDefaultSettings_name, __cb);
        try
        {
            __result.__prepare(__resetDefaultSettings_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(save);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public long end_resetDefaultSettings(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __resetDefaultSettings_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Resets the default settings i.e. the default values
     * internal to the Rendering engine. The settings will be
     * saved.
     * 
     * @param __cb The callback object for the operation.
     * @param save Pass <code>true</code> to save the settings,
     * <code>false</code> otherwise.
     **/
    public boolean resetDefaultSettings_async(AMI_RenderingEngine_resetDefaultSettings __cb, boolean save)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaultSettings_name);
            __r = begin_resetDefaultSettings(save, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaultSettings_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Resets the default settings i.e. the default values
     * internal to the Rendering engine. The settings will be
     * saved.
     * 
     * @param __cb The callback object for the operation.
     * @param save Pass <code>true</code> to save the settings,
     * <code>false</code> otherwise.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaultSettings_async(AMI_RenderingEngine_resetDefaultSettings __cb, boolean save, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaultSettings_name);
            __r = begin_resetDefaultSettings(save, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaultSettings_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __saveAsNewSettings_name = "saveAsNewSettings";

    /**
     * Saves the current rendering settings in the database
     * as a new {@link omero.model.RenderingDef} and loads the
     * object into the current {@link omero.api.RenderingEngine}.
     **/
    public long saveAsNewSettings()
        throws omero.ServerError
    {
        return saveAsNewSettings(null, false);
    }

    /**
     * Saves the current rendering settings in the database
     * as a new {@link omero.model.RenderingDef} and loads the
     * object into the current {@link omero.api.RenderingEngine}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public long saveAsNewSettings(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return saveAsNewSettings(__ctx, true);
    }

    private long saveAsNewSettings(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "saveAsNewSettings", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("saveAsNewSettings");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.saveAsNewSettings(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Saves the current rendering settings in the database
     * as a new {@link omero.model.RenderingDef} and loads the
     * object into the current {@link omero.api.RenderingEngine}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_saveAsNewSettings()
    {
        return begin_saveAsNewSettings(null, false, null);
    }

    /**
     * Saves the current rendering settings in the database
     * as a new {@link omero.model.RenderingDef} and loads the
     * object into the current {@link omero.api.RenderingEngine}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_saveAsNewSettings(java.util.Map<String, String> __ctx)
    {
        return begin_saveAsNewSettings(__ctx, true, null);
    }

    /**
     * Saves the current rendering settings in the database
     * as a new {@link omero.model.RenderingDef} and loads the
     * object into the current {@link omero.api.RenderingEngine}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_saveAsNewSettings(Ice.Callback __cb)
    {
        return begin_saveAsNewSettings(null, false, __cb);
    }

    /**
     * Saves the current rendering settings in the database
     * as a new {@link omero.model.RenderingDef} and loads the
     * object into the current {@link omero.api.RenderingEngine}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_saveAsNewSettings(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_saveAsNewSettings(__ctx, true, __cb);
    }

    /**
     * Saves the current rendering settings in the database
     * as a new {@link omero.model.RenderingDef} and loads the
     * object into the current {@link omero.api.RenderingEngine}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_saveAsNewSettings(Callback_RenderingEngine_saveAsNewSettings __cb)
    {
        return begin_saveAsNewSettings(null, false, __cb);
    }

    /**
     * Saves the current rendering settings in the database
     * as a new {@link omero.model.RenderingDef} and loads the
     * object into the current {@link omero.api.RenderingEngine}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_saveAsNewSettings(java.util.Map<String, String> __ctx, Callback_RenderingEngine_saveAsNewSettings __cb)
    {
        return begin_saveAsNewSettings(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_saveAsNewSettings(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__saveAsNewSettings_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __saveAsNewSettings_name, __cb);
        try
        {
            __result.__prepare(__saveAsNewSettings_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public long end_saveAsNewSettings(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __saveAsNewSettings_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Saves the current rendering settings in the database
     * as a new {@link omero.model.RenderingDef} and loads the
     * object into the current {@link omero.api.RenderingEngine}.
     * @param __cb The callback object for the operation.
     **/
    public boolean saveAsNewSettings_async(AMI_RenderingEngine_saveAsNewSettings __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__saveAsNewSettings_name);
            __r = begin_saveAsNewSettings(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __saveAsNewSettings_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Saves the current rendering settings in the database
     * as a new {@link omero.model.RenderingDef} and loads the
     * object into the current {@link omero.api.RenderingEngine}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean saveAsNewSettings_async(AMI_RenderingEngine_saveAsNewSettings __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__saveAsNewSettings_name);
            __r = begin_saveAsNewSettings(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __saveAsNewSettings_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __saveCurrentSettings_name = "saveCurrentSettings";

    /**
     * Saves the current rendering settings in the database.
     **/
    public void saveCurrentSettings()
        throws omero.ServerError
    {
        saveCurrentSettings(null, false);
    }

    /**
     * Saves the current rendering settings in the database.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void saveCurrentSettings(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        saveCurrentSettings(__ctx, true);
    }

    private void saveCurrentSettings(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "saveCurrentSettings", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("saveCurrentSettings");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.saveCurrentSettings(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Saves the current rendering settings in the database.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_saveCurrentSettings()
    {
        return begin_saveCurrentSettings(null, false, null);
    }

    /**
     * Saves the current rendering settings in the database.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_saveCurrentSettings(java.util.Map<String, String> __ctx)
    {
        return begin_saveCurrentSettings(__ctx, true, null);
    }

    /**
     * Saves the current rendering settings in the database.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_saveCurrentSettings(Ice.Callback __cb)
    {
        return begin_saveCurrentSettings(null, false, __cb);
    }

    /**
     * Saves the current rendering settings in the database.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_saveCurrentSettings(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_saveCurrentSettings(__ctx, true, __cb);
    }

    /**
     * Saves the current rendering settings in the database.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_saveCurrentSettings(Callback_RenderingEngine_saveCurrentSettings __cb)
    {
        return begin_saveCurrentSettings(null, false, __cb);
    }

    /**
     * Saves the current rendering settings in the database.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_saveCurrentSettings(java.util.Map<String, String> __ctx, Callback_RenderingEngine_saveCurrentSettings __cb)
    {
        return begin_saveCurrentSettings(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_saveCurrentSettings(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__saveCurrentSettings_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __saveCurrentSettings_name, __cb);
        try
        {
            __result.__prepare(__saveCurrentSettings_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_saveCurrentSettings(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __saveCurrentSettings_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Saves the current rendering settings in the database.
     * @param __cb The callback object for the operation.
     **/
    public boolean saveCurrentSettings_async(AMI_RenderingEngine_saveCurrentSettings __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__saveCurrentSettings_name);
            __r = begin_saveCurrentSettings(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __saveCurrentSettings_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Saves the current rendering settings in the database.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean saveCurrentSettings_async(AMI_RenderingEngine_saveCurrentSettings __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__saveCurrentSettings_name);
            __r = begin_saveCurrentSettings(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __saveCurrentSettings_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setActive_name = "setActive";

    /**
     * Maps the specified channel if <code>true</code>, unmaps the
     * channel otherwise.
     * 
     * @param w The channel index.
     * @param active Pass <code>true</code> to map the channel,
     * <code>false</code> otherwise.
     **/
    public void setActive(int w, boolean active)
        throws omero.ServerError
    {
        setActive(w, active, null, false);
    }

    /**
     * Maps the specified channel if <code>true</code>, unmaps the
     * channel otherwise.
     * 
     * @param w The channel index.
     * @param active Pass <code>true</code> to map the channel,
     * <code>false</code> otherwise.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setActive(int w, boolean active, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setActive(w, active, __ctx, true);
    }

    private void setActive(int w, boolean active, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setActive", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setActive");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.setActive(w, active, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Maps the specified channel if <code>true</code>, unmaps the
     * channel otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_setActive(int w, boolean active)
    {
        return begin_setActive(w, active, null, false, null);
    }

    /**
     * Maps the specified channel if <code>true</code>, unmaps the
     * channel otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setActive(int w, boolean active, java.util.Map<String, String> __ctx)
    {
        return begin_setActive(w, active, __ctx, true, null);
    }

    /**
     * Maps the specified channel if <code>true</code>, unmaps the
     * channel otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_setActive(int w, boolean active, Ice.Callback __cb)
    {
        return begin_setActive(w, active, null, false, __cb);
    }

    /**
     * Maps the specified channel if <code>true</code>, unmaps the
     * channel otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setActive(int w, boolean active, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setActive(w, active, __ctx, true, __cb);
    }

    /**
     * Maps the specified channel if <code>true</code>, unmaps the
     * channel otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public Ice.AsyncResult begin_setActive(int w, boolean active, Callback_RenderingEngine_setActive __cb)
    {
        return begin_setActive(w, active, null, false, __cb);
    }

    /**
     * Maps the specified channel if <code>true</code>, unmaps the
     * channel otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setActive(int w, boolean active, java.util.Map<String, String> __ctx, Callback_RenderingEngine_setActive __cb)
    {
        return begin_setActive(w, active, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setActive(int w, boolean active, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setActive_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setActive_name, __cb);
        try
        {
            __result.__prepare(__setActive_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(w);
            __os.writeBool(active);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setActive(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setActive_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Maps the specified channel if <code>true</code>, unmaps the
     * channel otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     **/
    public boolean setActive_async(AMI_RenderingEngine_setActive __cb, int w, boolean active)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setActive_name);
            __r = begin_setActive(w, active, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setActive_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Maps the specified channel if <code>true</code>, unmaps the
     * channel otherwise.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setActive_async(AMI_RenderingEngine_setActive __cb, int w, boolean active, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setActive_name);
            __r = begin_setActive(w, active, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setActive_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setChannelLookupTable_name = "setChannelLookupTable";

    public void setChannelLookupTable(int w, String lookup)
        throws omero.ServerError
    {
        setChannelLookupTable(w, lookup, null, false);
    }

    public void setChannelLookupTable(int w, String lookup, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setChannelLookupTable(w, lookup, __ctx, true);
    }

    private void setChannelLookupTable(int w, String lookup, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setChannelLookupTable", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setChannelLookupTable");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.setChannelLookupTable(w, lookup, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    public Ice.AsyncResult begin_setChannelLookupTable(int w, String lookup)
    {
        return begin_setChannelLookupTable(w, lookup, null, false, null);
    }

    public Ice.AsyncResult begin_setChannelLookupTable(int w, String lookup, java.util.Map<String, String> __ctx)
    {
        return begin_setChannelLookupTable(w, lookup, __ctx, true, null);
    }

    public Ice.AsyncResult begin_setChannelLookupTable(int w, String lookup, Ice.Callback __cb)
    {
        return begin_setChannelLookupTable(w, lookup, null, false, __cb);
    }

    public Ice.AsyncResult begin_setChannelLookupTable(int w, String lookup, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setChannelLookupTable(w, lookup, __ctx, true, __cb);
    }

    public Ice.AsyncResult begin_setChannelLookupTable(int w, String lookup, Callback_RenderingEngine_setChannelLookupTable __cb)
    {
        return begin_setChannelLookupTable(w, lookup, null, false, __cb);
    }

    public Ice.AsyncResult begin_setChannelLookupTable(int w, String lookup, java.util.Map<String, String> __ctx, Callback_RenderingEngine_setChannelLookupTable __cb)
    {
        return begin_setChannelLookupTable(w, lookup, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setChannelLookupTable(int w, String lookup, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setChannelLookupTable_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setChannelLookupTable_name, __cb);
        try
        {
            __result.__prepare(__setChannelLookupTable_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(w);
            __os.writeString(lookup);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    public void end_setChannelLookupTable(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setChannelLookupTable_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    public boolean setChannelLookupTable_async(AMI_RenderingEngine_setChannelLookupTable __cb, int w, String lookup)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setChannelLookupTable_name);
            __r = begin_setChannelLookupTable(w, lookup, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setChannelLookupTable_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public boolean setChannelLookupTable_async(AMI_RenderingEngine_setChannelLookupTable __cb, int w, String lookup, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setChannelLookupTable_name);
            __r = begin_setChannelLookupTable(w, lookup, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setChannelLookupTable_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setChannelWindow_name = "setChannelWindow";

    /**
     * Returns the pixels intensity interval. Each channel has a
     * pixels intensity interval associated to it.
     * 
     * @param w The channel index.
     * @param start The lower bound of the interval.
     * @param end The upper bound of the interval.
     **/
    public void setChannelWindow(int w, double start, double end)
        throws omero.ServerError
    {
        setChannelWindow(w, start, end, null, false);
    }

    /**
     * Returns the pixels intensity interval. Each channel has a
     * pixels intensity interval associated to it.
     * 
     * @param w The channel index.
     * @param start The lower bound of the interval.
     * @param end The upper bound of the interval.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setChannelWindow(int w, double start, double end, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setChannelWindow(w, start, end, __ctx, true);
    }

    private void setChannelWindow(int w, double start, double end, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setChannelWindow", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setChannelWindow");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.setChannelWindow(w, start, end, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the pixels intensity interval. Each channel has a
     * pixels intensity interval associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param end The upper bound of the interval.
     **/
    public Ice.AsyncResult begin_setChannelWindow(int w, double start, double end)
    {
        return begin_setChannelWindow(w, start, end, null, false, null);
    }

    /**
     * Returns the pixels intensity interval. Each channel has a
     * pixels intensity interval associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param end The upper bound of the interval.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setChannelWindow(int w, double start, double end, java.util.Map<String, String> __ctx)
    {
        return begin_setChannelWindow(w, start, end, __ctx, true, null);
    }

    /**
     * Returns the pixels intensity interval. Each channel has a
     * pixels intensity interval associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param end The upper bound of the interval.
     **/
    public Ice.AsyncResult begin_setChannelWindow(int w, double start, double end, Ice.Callback __cb)
    {
        return begin_setChannelWindow(w, start, end, null, false, __cb);
    }

    /**
     * Returns the pixels intensity interval. Each channel has a
     * pixels intensity interval associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param end The upper bound of the interval.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setChannelWindow(int w, double start, double end, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setChannelWindow(w, start, end, __ctx, true, __cb);
    }

    /**
     * Returns the pixels intensity interval. Each channel has a
     * pixels intensity interval associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param end The upper bound of the interval.
     **/
    public Ice.AsyncResult begin_setChannelWindow(int w, double start, double end, Callback_RenderingEngine_setChannelWindow __cb)
    {
        return begin_setChannelWindow(w, start, end, null, false, __cb);
    }

    /**
     * Returns the pixels intensity interval. Each channel has a
     * pixels intensity interval associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param end The upper bound of the interval.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setChannelWindow(int w, double start, double end, java.util.Map<String, String> __ctx, Callback_RenderingEngine_setChannelWindow __cb)
    {
        return begin_setChannelWindow(w, start, end, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setChannelWindow(int w, double start, double end, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setChannelWindow_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setChannelWindow_name, __cb);
        try
        {
            __result.__prepare(__setChannelWindow_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(w);
            __os.writeDouble(start);
            __os.writeDouble(end);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setChannelWindow(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setChannelWindow_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the pixels intensity interval. Each channel has a
     * pixels intensity interval associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param end The upper bound of the interval.
     **/
    public boolean setChannelWindow_async(AMI_RenderingEngine_setChannelWindow __cb, int w, double start, double end)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setChannelWindow_name);
            __r = begin_setChannelWindow(w, start, end, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setChannelWindow_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the pixels intensity interval. Each channel has a
     * pixels intensity interval associated to it.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param end The upper bound of the interval.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setChannelWindow_async(AMI_RenderingEngine_setChannelWindow __cb, int w, double start, double end, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setChannelWindow_name);
            __r = begin_setChannelWindow(w, start, end, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setChannelWindow_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setCodomainInterval_name = "setCodomainInterval";

    /**
     * Sets the sub-interval of the device space i.e. a discrete
     * sub-interval of \[0, 255].
     * 
     * @param start The lower bound of the interval.
     * @param end The upper bound of the interval.
     **/
    public void setCodomainInterval(int start, int end)
        throws omero.ServerError
    {
        setCodomainInterval(start, end, null, false);
    }

    /**
     * Sets the sub-interval of the device space i.e. a discrete
     * sub-interval of \[0, 255].
     * 
     * @param start The lower bound of the interval.
     * @param end The upper bound of the interval.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setCodomainInterval(int start, int end, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setCodomainInterval(start, end, __ctx, true);
    }

    private void setCodomainInterval(int start, int end, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setCodomainInterval", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setCodomainInterval");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.setCodomainInterval(start, end, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets the sub-interval of the device space i.e. a discrete
     * sub-interval of \[0, 255].
     * 
     * @param __cb The callback object for the operation.
     * @param start The lower bound of the interval.
     **/
    public Ice.AsyncResult begin_setCodomainInterval(int start, int end)
    {
        return begin_setCodomainInterval(start, end, null, false, null);
    }

    /**
     * Sets the sub-interval of the device space i.e. a discrete
     * sub-interval of \[0, 255].
     * 
     * @param __cb The callback object for the operation.
     * @param start The lower bound of the interval.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setCodomainInterval(int start, int end, java.util.Map<String, String> __ctx)
    {
        return begin_setCodomainInterval(start, end, __ctx, true, null);
    }

    /**
     * Sets the sub-interval of the device space i.e. a discrete
     * sub-interval of \[0, 255].
     * 
     * @param __cb The callback object for the operation.
     * @param start The lower bound of the interval.
     **/
    public Ice.AsyncResult begin_setCodomainInterval(int start, int end, Ice.Callback __cb)
    {
        return begin_setCodomainInterval(start, end, null, false, __cb);
    }

    /**
     * Sets the sub-interval of the device space i.e. a discrete
     * sub-interval of \[0, 255].
     * 
     * @param __cb The callback object for the operation.
     * @param start The lower bound of the interval.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setCodomainInterval(int start, int end, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setCodomainInterval(start, end, __ctx, true, __cb);
    }

    /**
     * Sets the sub-interval of the device space i.e. a discrete
     * sub-interval of \[0, 255].
     * 
     * @param __cb The callback object for the operation.
     * @param start The lower bound of the interval.
     **/
    public Ice.AsyncResult begin_setCodomainInterval(int start, int end, Callback_RenderingEngine_setCodomainInterval __cb)
    {
        return begin_setCodomainInterval(start, end, null, false, __cb);
    }

    /**
     * Sets the sub-interval of the device space i.e. a discrete
     * sub-interval of \[0, 255].
     * 
     * @param __cb The callback object for the operation.
     * @param start The lower bound of the interval.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setCodomainInterval(int start, int end, java.util.Map<String, String> __ctx, Callback_RenderingEngine_setCodomainInterval __cb)
    {
        return begin_setCodomainInterval(start, end, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setCodomainInterval(int start, int end, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setCodomainInterval_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setCodomainInterval_name, __cb);
        try
        {
            __result.__prepare(__setCodomainInterval_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(start);
            __os.writeInt(end);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setCodomainInterval(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setCodomainInterval_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets the sub-interval of the device space i.e. a discrete
     * sub-interval of \[0, 255].
     * 
     * @param __cb The callback object for the operation.
     * @param start The lower bound of the interval.
     **/
    public boolean setCodomainInterval_async(AMI_RenderingEngine_setCodomainInterval __cb, int start, int end)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setCodomainInterval_name);
            __r = begin_setCodomainInterval(start, end, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setCodomainInterval_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets the sub-interval of the device space i.e. a discrete
     * sub-interval of \[0, 255].
     * 
     * @param __cb The callback object for the operation.
     * @param start The lower bound of the interval.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setCodomainInterval_async(AMI_RenderingEngine_setCodomainInterval __cb, int start, int end, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setCodomainInterval_name);
            __r = begin_setCodomainInterval(start, end, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setCodomainInterval_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setCompressionLevel_name = "setCompressionLevel";

    /**
     * Sets the current compression level for the service. (The
     * default is 85%)
     * 
     * @param percentage A percentage compression level from 1.00
     * (100%) to 0.01 (1%).
     * @throws ValidationException if the <code>percentage</code
     * is out of range.
     **/
    public void setCompressionLevel(float percentage)
        throws omero.ServerError
    {
        setCompressionLevel(percentage, null, false);
    }

    /**
     * Sets the current compression level for the service. (The
     * default is 85%)
     * 
     * @param percentage A percentage compression level from 1.00
     * (100%) to 0.01 (1%).
     * @throws ValidationException if the <code>percentage</code
     * is out of range.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setCompressionLevel(float percentage, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setCompressionLevel(percentage, __ctx, true);
    }

    private void setCompressionLevel(float percentage, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setCompressionLevel", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setCompressionLevel");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.setCompressionLevel(percentage, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets the current compression level for the service. (The
     * default is 85%)
     * 
     * @param __cb The callback object for the operation.
     * @param percentage A percentage compression level from 1.00
     * (100%) to 0.01 (1%).
     **/
    public Ice.AsyncResult begin_setCompressionLevel(float percentage)
    {
        return begin_setCompressionLevel(percentage, null, false, null);
    }

    /**
     * Sets the current compression level for the service. (The
     * default is 85%)
     * 
     * @param __cb The callback object for the operation.
     * @param percentage A percentage compression level from 1.00
     * (100%) to 0.01 (1%).
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setCompressionLevel(float percentage, java.util.Map<String, String> __ctx)
    {
        return begin_setCompressionLevel(percentage, __ctx, true, null);
    }

    /**
     * Sets the current compression level for the service. (The
     * default is 85%)
     * 
     * @param __cb The callback object for the operation.
     * @param percentage A percentage compression level from 1.00
     * (100%) to 0.01 (1%).
     **/
    public Ice.AsyncResult begin_setCompressionLevel(float percentage, Ice.Callback __cb)
    {
        return begin_setCompressionLevel(percentage, null, false, __cb);
    }

    /**
     * Sets the current compression level for the service. (The
     * default is 85%)
     * 
     * @param __cb The callback object for the operation.
     * @param percentage A percentage compression level from 1.00
     * (100%) to 0.01 (1%).
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setCompressionLevel(float percentage, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setCompressionLevel(percentage, __ctx, true, __cb);
    }

    /**
     * Sets the current compression level for the service. (The
     * default is 85%)
     * 
     * @param __cb The callback object for the operation.
     * @param percentage A percentage compression level from 1.00
     * (100%) to 0.01 (1%).
     **/
    public Ice.AsyncResult begin_setCompressionLevel(float percentage, Callback_RenderingEngine_setCompressionLevel __cb)
    {
        return begin_setCompressionLevel(percentage, null, false, __cb);
    }

    /**
     * Sets the current compression level for the service. (The
     * default is 85%)
     * 
     * @param __cb The callback object for the operation.
     * @param percentage A percentage compression level from 1.00
     * (100%) to 0.01 (1%).
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setCompressionLevel(float percentage, java.util.Map<String, String> __ctx, Callback_RenderingEngine_setCompressionLevel __cb)
    {
        return begin_setCompressionLevel(percentage, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setCompressionLevel(float percentage, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setCompressionLevel_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setCompressionLevel_name, __cb);
        try
        {
            __result.__prepare(__setCompressionLevel_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeFloat(percentage);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setCompressionLevel(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setCompressionLevel_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets the current compression level for the service. (The
     * default is 85%)
     * 
     * @param __cb The callback object for the operation.
     * @param percentage A percentage compression level from 1.00
     * (100%) to 0.01 (1%).
     **/
    public boolean setCompressionLevel_async(AMI_RenderingEngine_setCompressionLevel __cb, float percentage)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setCompressionLevel_name);
            __r = begin_setCompressionLevel(percentage, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setCompressionLevel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets the current compression level for the service. (The
     * default is 85%)
     * 
     * @param __cb The callback object for the operation.
     * @param percentage A percentage compression level from 1.00
     * (100%) to 0.01 (1%).
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setCompressionLevel_async(AMI_RenderingEngine_setCompressionLevel __cb, float percentage, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setCompressionLevel_name);
            __r = begin_setCompressionLevel(percentage, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setCompressionLevel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setDefaultT_name = "setDefaultT";

    /**
     * Sets the default timepoint index. This index is used to
     * define a default plane.
     * 
     * @param t The value to set.
     **/
    public void setDefaultT(int t)
        throws omero.ServerError
    {
        setDefaultT(t, null, false);
    }

    /**
     * Sets the default timepoint index. This index is used to
     * define a default plane.
     * 
     * @param t The value to set.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setDefaultT(int t, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setDefaultT(t, __ctx, true);
    }

    private void setDefaultT(int t, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setDefaultT", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setDefaultT");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.setDefaultT(t, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets the default timepoint index. This index is used to
     * define a default plane.
     * 
     * @param __cb The callback object for the operation.
     * @param t The value to set.
     **/
    public Ice.AsyncResult begin_setDefaultT(int t)
    {
        return begin_setDefaultT(t, null, false, null);
    }

    /**
     * Sets the default timepoint index. This index is used to
     * define a default plane.
     * 
     * @param __cb The callback object for the operation.
     * @param t The value to set.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setDefaultT(int t, java.util.Map<String, String> __ctx)
    {
        return begin_setDefaultT(t, __ctx, true, null);
    }

    /**
     * Sets the default timepoint index. This index is used to
     * define a default plane.
     * 
     * @param __cb The callback object for the operation.
     * @param t The value to set.
     **/
    public Ice.AsyncResult begin_setDefaultT(int t, Ice.Callback __cb)
    {
        return begin_setDefaultT(t, null, false, __cb);
    }

    /**
     * Sets the default timepoint index. This index is used to
     * define a default plane.
     * 
     * @param __cb The callback object for the operation.
     * @param t The value to set.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setDefaultT(int t, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setDefaultT(t, __ctx, true, __cb);
    }

    /**
     * Sets the default timepoint index. This index is used to
     * define a default plane.
     * 
     * @param __cb The callback object for the operation.
     * @param t The value to set.
     **/
    public Ice.AsyncResult begin_setDefaultT(int t, Callback_RenderingEngine_setDefaultT __cb)
    {
        return begin_setDefaultT(t, null, false, __cb);
    }

    /**
     * Sets the default timepoint index. This index is used to
     * define a default plane.
     * 
     * @param __cb The callback object for the operation.
     * @param t The value to set.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setDefaultT(int t, java.util.Map<String, String> __ctx, Callback_RenderingEngine_setDefaultT __cb)
    {
        return begin_setDefaultT(t, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setDefaultT(int t, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setDefaultT_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setDefaultT_name, __cb);
        try
        {
            __result.__prepare(__setDefaultT_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(t);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setDefaultT(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setDefaultT_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets the default timepoint index. This index is used to
     * define a default plane.
     * 
     * @param __cb The callback object for the operation.
     * @param t The value to set.
     **/
    public boolean setDefaultT_async(AMI_RenderingEngine_setDefaultT __cb, int t)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setDefaultT_name);
            __r = begin_setDefaultT(t, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setDefaultT_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets the default timepoint index. This index is used to
     * define a default plane.
     * 
     * @param __cb The callback object for the operation.
     * @param t The value to set.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setDefaultT_async(AMI_RenderingEngine_setDefaultT __cb, int t, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setDefaultT_name);
            __r = begin_setDefaultT(t, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setDefaultT_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setDefaultZ_name = "setDefaultZ";

    /**
     * Sets the index of the default focal section. This index is
     * used to define a default plane.
     * 
     * @param z The value to set.
     **/
    public void setDefaultZ(int z)
        throws omero.ServerError
    {
        setDefaultZ(z, null, false);
    }

    /**
     * Sets the index of the default focal section. This index is
     * used to define a default plane.
     * 
     * @param z The value to set.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setDefaultZ(int z, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setDefaultZ(z, __ctx, true);
    }

    private void setDefaultZ(int z, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setDefaultZ", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setDefaultZ");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.setDefaultZ(z, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets the index of the default focal section. This index is
     * used to define a default plane.
     * 
     * @param __cb The callback object for the operation.
     * @param z The value to set.
     **/
    public Ice.AsyncResult begin_setDefaultZ(int z)
    {
        return begin_setDefaultZ(z, null, false, null);
    }

    /**
     * Sets the index of the default focal section. This index is
     * used to define a default plane.
     * 
     * @param __cb The callback object for the operation.
     * @param z The value to set.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setDefaultZ(int z, java.util.Map<String, String> __ctx)
    {
        return begin_setDefaultZ(z, __ctx, true, null);
    }

    /**
     * Sets the index of the default focal section. This index is
     * used to define a default plane.
     * 
     * @param __cb The callback object for the operation.
     * @param z The value to set.
     **/
    public Ice.AsyncResult begin_setDefaultZ(int z, Ice.Callback __cb)
    {
        return begin_setDefaultZ(z, null, false, __cb);
    }

    /**
     * Sets the index of the default focal section. This index is
     * used to define a default plane.
     * 
     * @param __cb The callback object for the operation.
     * @param z The value to set.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setDefaultZ(int z, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setDefaultZ(z, __ctx, true, __cb);
    }

    /**
     * Sets the index of the default focal section. This index is
     * used to define a default plane.
     * 
     * @param __cb The callback object for the operation.
     * @param z The value to set.
     **/
    public Ice.AsyncResult begin_setDefaultZ(int z, Callback_RenderingEngine_setDefaultZ __cb)
    {
        return begin_setDefaultZ(z, null, false, __cb);
    }

    /**
     * Sets the index of the default focal section. This index is
     * used to define a default plane.
     * 
     * @param __cb The callback object for the operation.
     * @param z The value to set.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setDefaultZ(int z, java.util.Map<String, String> __ctx, Callback_RenderingEngine_setDefaultZ __cb)
    {
        return begin_setDefaultZ(z, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setDefaultZ(int z, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setDefaultZ_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setDefaultZ_name, __cb);
        try
        {
            __result.__prepare(__setDefaultZ_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(z);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setDefaultZ(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setDefaultZ_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets the index of the default focal section. This index is
     * used to define a default plane.
     * 
     * @param __cb The callback object for the operation.
     * @param z The value to set.
     **/
    public boolean setDefaultZ_async(AMI_RenderingEngine_setDefaultZ __cb, int z)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setDefaultZ_name);
            __r = begin_setDefaultZ(z, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setDefaultZ_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets the index of the default focal section. This index is
     * used to define a default plane.
     * 
     * @param __cb The callback object for the operation.
     * @param z The value to set.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setDefaultZ_async(AMI_RenderingEngine_setDefaultZ __cb, int z, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setDefaultZ_name);
            __r = begin_setDefaultZ(z, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setDefaultZ_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setModel_name = "setModel";

    /**
     * Specifies the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * 
     * @param model Identifies the color space model.
     **/
    public void setModel(omero.model.RenderingModel model)
        throws omero.ServerError
    {
        setModel(model, null, false);
    }

    /**
     * Specifies the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * 
     * @param model Identifies the color space model.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setModel(omero.model.RenderingModel model, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setModel(model, __ctx, true);
    }

    private void setModel(omero.model.RenderingModel model, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setModel", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setModel");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.setModel(model, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Specifies the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * 
     * @param __cb The callback object for the operation.
     * @param model Identifies the color space model.
     **/
    public Ice.AsyncResult begin_setModel(omero.model.RenderingModel model)
    {
        return begin_setModel(model, null, false, null);
    }

    /**
     * Specifies the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * 
     * @param __cb The callback object for the operation.
     * @param model Identifies the color space model.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setModel(omero.model.RenderingModel model, java.util.Map<String, String> __ctx)
    {
        return begin_setModel(model, __ctx, true, null);
    }

    /**
     * Specifies the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * 
     * @param __cb The callback object for the operation.
     * @param model Identifies the color space model.
     **/
    public Ice.AsyncResult begin_setModel(omero.model.RenderingModel model, Ice.Callback __cb)
    {
        return begin_setModel(model, null, false, __cb);
    }

    /**
     * Specifies the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * 
     * @param __cb The callback object for the operation.
     * @param model Identifies the color space model.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setModel(omero.model.RenderingModel model, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setModel(model, __ctx, true, __cb);
    }

    /**
     * Specifies the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * 
     * @param __cb The callback object for the operation.
     * @param model Identifies the color space model.
     **/
    public Ice.AsyncResult begin_setModel(omero.model.RenderingModel model, Callback_RenderingEngine_setModel __cb)
    {
        return begin_setModel(model, null, false, __cb);
    }

    /**
     * Specifies the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * 
     * @param __cb The callback object for the operation.
     * @param model Identifies the color space model.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setModel(omero.model.RenderingModel model, java.util.Map<String, String> __ctx, Callback_RenderingEngine_setModel __cb)
    {
        return begin_setModel(model, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setModel(omero.model.RenderingModel model, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setModel_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setModel_name, __cb);
        try
        {
            __result.__prepare(__setModel_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(model);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setModel(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setModel_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Specifies the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * 
     * @param __cb The callback object for the operation.
     * @param model Identifies the color space model.
     **/
    public boolean setModel_async(AMI_RenderingEngine_setModel __cb, omero.model.RenderingModel model)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setModel_name);
            __r = begin_setModel(model, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setModel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Specifies the model that dictates how transformed raw data
     * has to be mapped onto a color space.
     * 
     * @param __cb The callback object for the operation.
     * @param model Identifies the color space model.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setModel_async(AMI_RenderingEngine_setModel __cb, omero.model.RenderingModel model, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setModel_name);
            __r = begin_setModel(model, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setModel_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setOverlays_name = "setOverlays";

    /**
     * Informs the rendering engine that it should render a set of
     * overlays on each rendered frame. These are expected to be
     * binary masks.
     * @param overlays Binary mask to color map.
     * @deprecated This operation has been deprecated.
     **/
    public void setOverlays(omero.RLong tablesId, omero.RLong imageId, java.util.Map<java.lang.Long, java.lang.Integer> rowColorMap)
        throws omero.ServerError
    {
        setOverlays(tablesId, imageId, rowColorMap, null, false);
    }

    /**
     * Informs the rendering engine that it should render a set of
     * overlays on each rendered frame. These are expected to be
     * binary masks.
     * @param overlays Binary mask to color map.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public void setOverlays(omero.RLong tablesId, omero.RLong imageId, java.util.Map<java.lang.Long, java.lang.Integer> rowColorMap, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setOverlays(tablesId, imageId, rowColorMap, __ctx, true);
    }

    private void setOverlays(omero.RLong tablesId, omero.RLong imageId, java.util.Map<java.lang.Long, java.lang.Integer> rowColorMap, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setOverlays", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setOverlays");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.setOverlays(tablesId, imageId, rowColorMap, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Informs the rendering engine that it should render a set of
     * overlays on each rendered frame. These are expected to be
     * binary masks.
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_setOverlays(omero.RLong tablesId, omero.RLong imageId, java.util.Map<java.lang.Long, java.lang.Integer> rowColorMap)
    {
        return begin_setOverlays(tablesId, imageId, rowColorMap, null, false, null);
    }

    /**
     * Informs the rendering engine that it should render a set of
     * overlays on each rendered frame. These are expected to be
     * binary masks.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_setOverlays(omero.RLong tablesId, omero.RLong imageId, java.util.Map<java.lang.Long, java.lang.Integer> rowColorMap, java.util.Map<String, String> __ctx)
    {
        return begin_setOverlays(tablesId, imageId, rowColorMap, __ctx, true, null);
    }

    /**
     * Informs the rendering engine that it should render a set of
     * overlays on each rendered frame. These are expected to be
     * binary masks.
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_setOverlays(omero.RLong tablesId, omero.RLong imageId, java.util.Map<java.lang.Long, java.lang.Integer> rowColorMap, Ice.Callback __cb)
    {
        return begin_setOverlays(tablesId, imageId, rowColorMap, null, false, __cb);
    }

    /**
     * Informs the rendering engine that it should render a set of
     * overlays on each rendered frame. These are expected to be
     * binary masks.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_setOverlays(omero.RLong tablesId, omero.RLong imageId, java.util.Map<java.lang.Long, java.lang.Integer> rowColorMap, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setOverlays(tablesId, imageId, rowColorMap, __ctx, true, __cb);
    }

    /**
     * Informs the rendering engine that it should render a set of
     * overlays on each rendered frame. These are expected to be
     * binary masks.
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_setOverlays(omero.RLong tablesId, omero.RLong imageId, java.util.Map<java.lang.Long, java.lang.Integer> rowColorMap, Callback_RenderingEngine_setOverlays __cb)
    {
        return begin_setOverlays(tablesId, imageId, rowColorMap, null, false, __cb);
    }

    /**
     * Informs the rendering engine that it should render a set of
     * overlays on each rendered frame. These are expected to be
     * binary masks.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_setOverlays(omero.RLong tablesId, omero.RLong imageId, java.util.Map<java.lang.Long, java.lang.Integer> rowColorMap, java.util.Map<String, String> __ctx, Callback_RenderingEngine_setOverlays __cb)
    {
        return begin_setOverlays(tablesId, imageId, rowColorMap, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setOverlays(omero.RLong tablesId, omero.RLong imageId, java.util.Map<java.lang.Long, java.lang.Integer> rowColorMap, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setOverlays_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setOverlays_name, __cb);
        try
        {
            __result.__prepare(__setOverlays_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(tablesId);
            __os.writeObject(imageId);
            LongIntMapHelper.write(__os, rowColorMap);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setOverlays(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setOverlays_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Informs the rendering engine that it should render a set of
     * overlays on each rendered frame. These are expected to be
     * binary masks.
     * @param __cb The callback object for the operation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean setOverlays_async(AMI_RenderingEngine_setOverlays __cb, omero.RLong tablesId, omero.RLong imageId, java.util.Map<java.lang.Long, java.lang.Integer> rowColorMap)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setOverlays_name);
            __r = begin_setOverlays(tablesId, imageId, rowColorMap, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setOverlays_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Informs the rendering engine that it should render a set of
     * overlays on each rendered frame. These are expected to be
     * binary masks.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean setOverlays_async(AMI_RenderingEngine_setOverlays __cb, omero.RLong tablesId, omero.RLong imageId, java.util.Map<java.lang.Long, java.lang.Integer> rowColorMap, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setOverlays_name);
            __r = begin_setOverlays(tablesId, imageId, rowColorMap, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setOverlays_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setQuantizationMap_name = "setQuantizationMap";

    /**
     * Sets the quantization map, one per channel.
     * 
     * @param w  The channel index.
     * @param family The mapping family.
     * @param coefficient The coefficient identifying a curve in
     * the family.
     * @param noiseReduction Pass <code>true</code> to turn the
     * noise reduction algorithm on,
     * <code>false</code> otherwise.
     * @see #getAvailableFamilies
     * @see #getChannelCurveCoefficient
     * @see #getChannelFamily
     * @see #getChannelNoiseReduction
     **/
    public void setQuantizationMap(int w, omero.model.Family fam, double coefficient, boolean noiseReduction)
        throws omero.ServerError
    {
        setQuantizationMap(w, fam, coefficient, noiseReduction, null, false);
    }

    /**
     * Sets the quantization map, one per channel.
     * 
     * @param w  The channel index.
     * @param family The mapping family.
     * @param coefficient The coefficient identifying a curve in
     * the family.
     * @param noiseReduction Pass <code>true</code> to turn the
     * noise reduction algorithm on,
     * <code>false</code> otherwise.
     * @see #getAvailableFamilies
     * @see #getChannelCurveCoefficient
     * @see #getChannelFamily
     * @see #getChannelNoiseReduction
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setQuantizationMap(int w, omero.model.Family fam, double coefficient, boolean noiseReduction, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setQuantizationMap(w, fam, coefficient, noiseReduction, __ctx, true);
    }

    private void setQuantizationMap(int w, omero.model.Family fam, double coefficient, boolean noiseReduction, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setQuantizationMap", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setQuantizationMap");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.setQuantizationMap(w, fam, coefficient, noiseReduction, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets the quantization map, one per channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w  The channel index.
     * @param coefficient The coefficient identifying a curve in
     * the family.
     * @param noiseReduction Pass <code>true</code> to turn the
     * noise reduction algorithm on,
     * <code>false</code> otherwise.
     **/
    public Ice.AsyncResult begin_setQuantizationMap(int w, omero.model.Family fam, double coefficient, boolean noiseReduction)
    {
        return begin_setQuantizationMap(w, fam, coefficient, noiseReduction, null, false, null);
    }

    /**
     * Sets the quantization map, one per channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w  The channel index.
     * @param coefficient The coefficient identifying a curve in
     * the family.
     * @param noiseReduction Pass <code>true</code> to turn the
     * noise reduction algorithm on,
     * <code>false</code> otherwise.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setQuantizationMap(int w, omero.model.Family fam, double coefficient, boolean noiseReduction, java.util.Map<String, String> __ctx)
    {
        return begin_setQuantizationMap(w, fam, coefficient, noiseReduction, __ctx, true, null);
    }

    /**
     * Sets the quantization map, one per channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w  The channel index.
     * @param coefficient The coefficient identifying a curve in
     * the family.
     * @param noiseReduction Pass <code>true</code> to turn the
     * noise reduction algorithm on,
     * <code>false</code> otherwise.
     **/
    public Ice.AsyncResult begin_setQuantizationMap(int w, omero.model.Family fam, double coefficient, boolean noiseReduction, Ice.Callback __cb)
    {
        return begin_setQuantizationMap(w, fam, coefficient, noiseReduction, null, false, __cb);
    }

    /**
     * Sets the quantization map, one per channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w  The channel index.
     * @param coefficient The coefficient identifying a curve in
     * the family.
     * @param noiseReduction Pass <code>true</code> to turn the
     * noise reduction algorithm on,
     * <code>false</code> otherwise.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setQuantizationMap(int w, omero.model.Family fam, double coefficient, boolean noiseReduction, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setQuantizationMap(w, fam, coefficient, noiseReduction, __ctx, true, __cb);
    }

    /**
     * Sets the quantization map, one per channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w  The channel index.
     * @param coefficient The coefficient identifying a curve in
     * the family.
     * @param noiseReduction Pass <code>true</code> to turn the
     * noise reduction algorithm on,
     * <code>false</code> otherwise.
     **/
    public Ice.AsyncResult begin_setQuantizationMap(int w, omero.model.Family fam, double coefficient, boolean noiseReduction, Callback_RenderingEngine_setQuantizationMap __cb)
    {
        return begin_setQuantizationMap(w, fam, coefficient, noiseReduction, null, false, __cb);
    }

    /**
     * Sets the quantization map, one per channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w  The channel index.
     * @param coefficient The coefficient identifying a curve in
     * the family.
     * @param noiseReduction Pass <code>true</code> to turn the
     * noise reduction algorithm on,
     * <code>false</code> otherwise.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setQuantizationMap(int w, omero.model.Family fam, double coefficient, boolean noiseReduction, java.util.Map<String, String> __ctx, Callback_RenderingEngine_setQuantizationMap __cb)
    {
        return begin_setQuantizationMap(w, fam, coefficient, noiseReduction, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setQuantizationMap(int w, omero.model.Family fam, double coefficient, boolean noiseReduction, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setQuantizationMap_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setQuantizationMap_name, __cb);
        try
        {
            __result.__prepare(__setQuantizationMap_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(w);
            __os.writeObject(fam);
            __os.writeDouble(coefficient);
            __os.writeBool(noiseReduction);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setQuantizationMap(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setQuantizationMap_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets the quantization map, one per channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w  The channel index.
     * @param coefficient The coefficient identifying a curve in
     * the family.
     * @param noiseReduction Pass <code>true</code> to turn the
     * noise reduction algorithm on,
     * <code>false</code> otherwise.
     **/
    public boolean setQuantizationMap_async(AMI_RenderingEngine_setQuantizationMap __cb, int w, omero.model.Family fam, double coefficient, boolean noiseReduction)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setQuantizationMap_name);
            __r = begin_setQuantizationMap(w, fam, coefficient, noiseReduction, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setQuantizationMap_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets the quantization map, one per channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w  The channel index.
     * @param coefficient The coefficient identifying a curve in
     * the family.
     * @param noiseReduction Pass <code>true</code> to turn the
     * noise reduction algorithm on,
     * <code>false</code> otherwise.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setQuantizationMap_async(AMI_RenderingEngine_setQuantizationMap __cb, int w, omero.model.Family fam, double coefficient, boolean noiseReduction, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setQuantizationMap_name);
            __r = begin_setQuantizationMap(w, fam, coefficient, noiseReduction, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setQuantizationMap_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setQuantumStrategy_name = "setQuantumStrategy";

    /**
     * Sets the quantization strategy. The strategy is common to
     * all channels.
     * 
     * @param bitResolution The bit resolution defining associated
     * to the strategy.
     **/
    public void setQuantumStrategy(int bitResolution)
        throws omero.ServerError
    {
        setQuantumStrategy(bitResolution, null, false);
    }

    /**
     * Sets the quantization strategy. The strategy is common to
     * all channels.
     * 
     * @param bitResolution The bit resolution defining associated
     * to the strategy.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setQuantumStrategy(int bitResolution, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setQuantumStrategy(bitResolution, __ctx, true);
    }

    private void setQuantumStrategy(int bitResolution, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setQuantumStrategy", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setQuantumStrategy");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.setQuantumStrategy(bitResolution, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets the quantization strategy. The strategy is common to
     * all channels.
     * 
     * @param __cb The callback object for the operation.
     * @param bitResolution The bit resolution defining associated
     * to the strategy.
     **/
    public Ice.AsyncResult begin_setQuantumStrategy(int bitResolution)
    {
        return begin_setQuantumStrategy(bitResolution, null, false, null);
    }

    /**
     * Sets the quantization strategy. The strategy is common to
     * all channels.
     * 
     * @param __cb The callback object for the operation.
     * @param bitResolution The bit resolution defining associated
     * to the strategy.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setQuantumStrategy(int bitResolution, java.util.Map<String, String> __ctx)
    {
        return begin_setQuantumStrategy(bitResolution, __ctx, true, null);
    }

    /**
     * Sets the quantization strategy. The strategy is common to
     * all channels.
     * 
     * @param __cb The callback object for the operation.
     * @param bitResolution The bit resolution defining associated
     * to the strategy.
     **/
    public Ice.AsyncResult begin_setQuantumStrategy(int bitResolution, Ice.Callback __cb)
    {
        return begin_setQuantumStrategy(bitResolution, null, false, __cb);
    }

    /**
     * Sets the quantization strategy. The strategy is common to
     * all channels.
     * 
     * @param __cb The callback object for the operation.
     * @param bitResolution The bit resolution defining associated
     * to the strategy.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setQuantumStrategy(int bitResolution, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setQuantumStrategy(bitResolution, __ctx, true, __cb);
    }

    /**
     * Sets the quantization strategy. The strategy is common to
     * all channels.
     * 
     * @param __cb The callback object for the operation.
     * @param bitResolution The bit resolution defining associated
     * to the strategy.
     **/
    public Ice.AsyncResult begin_setQuantumStrategy(int bitResolution, Callback_RenderingEngine_setQuantumStrategy __cb)
    {
        return begin_setQuantumStrategy(bitResolution, null, false, __cb);
    }

    /**
     * Sets the quantization strategy. The strategy is common to
     * all channels.
     * 
     * @param __cb The callback object for the operation.
     * @param bitResolution The bit resolution defining associated
     * to the strategy.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setQuantumStrategy(int bitResolution, java.util.Map<String, String> __ctx, Callback_RenderingEngine_setQuantumStrategy __cb)
    {
        return begin_setQuantumStrategy(bitResolution, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setQuantumStrategy(int bitResolution, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setQuantumStrategy_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setQuantumStrategy_name, __cb);
        try
        {
            __result.__prepare(__setQuantumStrategy_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(bitResolution);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setQuantumStrategy(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setQuantumStrategy_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets the quantization strategy. The strategy is common to
     * all channels.
     * 
     * @param __cb The callback object for the operation.
     * @param bitResolution The bit resolution defining associated
     * to the strategy.
     **/
    public boolean setQuantumStrategy_async(AMI_RenderingEngine_setQuantumStrategy __cb, int bitResolution)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setQuantumStrategy_name);
            __r = begin_setQuantumStrategy(bitResolution, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setQuantumStrategy_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets the quantization strategy. The strategy is common to
     * all channels.
     * 
     * @param __cb The callback object for the operation.
     * @param bitResolution The bit resolution defining associated
     * to the strategy.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setQuantumStrategy_async(AMI_RenderingEngine_setQuantumStrategy __cb, int bitResolution, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setQuantumStrategy_name);
            __r = begin_setQuantumStrategy(bitResolution, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setQuantumStrategy_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setRGBA_name = "setRGBA";

    /**
     * Sets the four components composing the color associated to
     * the specified channel.
     * 
     * @param w The channel index.
     * @param red The red component. A value between 0 and 255.
     * @param green The green component. A value between 0 and 255.
     * @param blue The blue component. A value between 0 and 255.
     * @param alpha The alpha component. A value between 0 and 255.
     **/
    public void setRGBA(int w, int red, int green, int blue, int alpha)
        throws omero.ServerError
    {
        setRGBA(w, red, green, blue, alpha, null, false);
    }

    /**
     * Sets the four components composing the color associated to
     * the specified channel.
     * 
     * @param w The channel index.
     * @param red The red component. A value between 0 and 255.
     * @param green The green component. A value between 0 and 255.
     * @param blue The blue component. A value between 0 and 255.
     * @param alpha The alpha component. A value between 0 and 255.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setRGBA(int w, int red, int green, int blue, int alpha, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setRGBA(w, red, green, blue, alpha, __ctx, true);
    }

    private void setRGBA(int w, int red, int green, int blue, int alpha, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setRGBA", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setRGBA");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.setRGBA(w, red, green, blue, alpha, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets the four components composing the color associated to
     * the specified channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param green The green component. A value between 0 and 255.
     * @param alpha The alpha component. A value between 0 and 255.
     **/
    public Ice.AsyncResult begin_setRGBA(int w, int red, int green, int blue, int alpha)
    {
        return begin_setRGBA(w, red, green, blue, alpha, null, false, null);
    }

    /**
     * Sets the four components composing the color associated to
     * the specified channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param green The green component. A value between 0 and 255.
     * @param alpha The alpha component. A value between 0 and 255.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setRGBA(int w, int red, int green, int blue, int alpha, java.util.Map<String, String> __ctx)
    {
        return begin_setRGBA(w, red, green, blue, alpha, __ctx, true, null);
    }

    /**
     * Sets the four components composing the color associated to
     * the specified channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param green The green component. A value between 0 and 255.
     * @param alpha The alpha component. A value between 0 and 255.
     **/
    public Ice.AsyncResult begin_setRGBA(int w, int red, int green, int blue, int alpha, Ice.Callback __cb)
    {
        return begin_setRGBA(w, red, green, blue, alpha, null, false, __cb);
    }

    /**
     * Sets the four components composing the color associated to
     * the specified channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param green The green component. A value between 0 and 255.
     * @param alpha The alpha component. A value between 0 and 255.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setRGBA(int w, int red, int green, int blue, int alpha, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setRGBA(w, red, green, blue, alpha, __ctx, true, __cb);
    }

    /**
     * Sets the four components composing the color associated to
     * the specified channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param green The green component. A value between 0 and 255.
     * @param alpha The alpha component. A value between 0 and 255.
     **/
    public Ice.AsyncResult begin_setRGBA(int w, int red, int green, int blue, int alpha, Callback_RenderingEngine_setRGBA __cb)
    {
        return begin_setRGBA(w, red, green, blue, alpha, null, false, __cb);
    }

    /**
     * Sets the four components composing the color associated to
     * the specified channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param green The green component. A value between 0 and 255.
     * @param alpha The alpha component. A value between 0 and 255.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setRGBA(int w, int red, int green, int blue, int alpha, java.util.Map<String, String> __ctx, Callback_RenderingEngine_setRGBA __cb)
    {
        return begin_setRGBA(w, red, green, blue, alpha, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setRGBA(int w, int red, int green, int blue, int alpha, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setRGBA_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setRGBA_name, __cb);
        try
        {
            __result.__prepare(__setRGBA_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(w);
            __os.writeInt(red);
            __os.writeInt(green);
            __os.writeInt(blue);
            __os.writeInt(alpha);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setRGBA(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setRGBA_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets the four components composing the color associated to
     * the specified channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param green The green component. A value between 0 and 255.
     * @param alpha The alpha component. A value between 0 and 255.
     **/
    public boolean setRGBA_async(AMI_RenderingEngine_setRGBA __cb, int w, int red, int green, int blue, int alpha)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setRGBA_name);
            __r = begin_setRGBA(w, red, green, blue, alpha, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setRGBA_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets the four components composing the color associated to
     * the specified channel.
     * 
     * @param __cb The callback object for the operation.
     * @param w The channel index.
     * @param green The green component. A value between 0 and 255.
     * @param alpha The alpha component. A value between 0 and 255.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setRGBA_async(AMI_RenderingEngine_setRGBA __cb, int w, int red, int green, int blue, int alpha, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setRGBA_name);
            __r = begin_setRGBA(w, red, green, blue, alpha, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setRGBA_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __updateCodomainMap_name = "updateCodomainMap";

    /**
     * Updates the specified context. The codomain chain already
     * contains the specified context. Each time a new context is
     * updated, the second LUT is rebuilt.
     * 
     * @param mapCtx The context to update.
     * @see #addCodomainMap
     * @see #removeCodomainMap
     * @deprecated This operation has been deprecated.
     **/
    public void updateCodomainMap(omero.romio.CodomainMapContext mapCtx)
        throws omero.ServerError
    {
        updateCodomainMap(mapCtx, null, false);
    }

    /**
     * Updates the specified context. The codomain chain already
     * contains the specified context. Each time a new context is
     * updated, the second LUT is rebuilt.
     * 
     * @param mapCtx The context to update.
     * @see #addCodomainMap
     * @see #removeCodomainMap
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public void updateCodomainMap(omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        updateCodomainMap(mapCtx, __ctx, true);
    }

    private void updateCodomainMap(omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "updateCodomainMap", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("updateCodomainMap");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.updateCodomainMap(mapCtx, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Updates the specified context. The codomain chain already
     * contains the specified context. Each time a new context is
     * updated, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to update.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_updateCodomainMap(omero.romio.CodomainMapContext mapCtx)
    {
        return begin_updateCodomainMap(mapCtx, null, false, null);
    }

    /**
     * Updates the specified context. The codomain chain already
     * contains the specified context. Each time a new context is
     * updated, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to update.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_updateCodomainMap(omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx)
    {
        return begin_updateCodomainMap(mapCtx, __ctx, true, null);
    }

    /**
     * Updates the specified context. The codomain chain already
     * contains the specified context. Each time a new context is
     * updated, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to update.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_updateCodomainMap(omero.romio.CodomainMapContext mapCtx, Ice.Callback __cb)
    {
        return begin_updateCodomainMap(mapCtx, null, false, __cb);
    }

    /**
     * Updates the specified context. The codomain chain already
     * contains the specified context. Each time a new context is
     * updated, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to update.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_updateCodomainMap(omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_updateCodomainMap(mapCtx, __ctx, true, __cb);
    }

    /**
     * Updates the specified context. The codomain chain already
     * contains the specified context. Each time a new context is
     * updated, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to update.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_updateCodomainMap(omero.romio.CodomainMapContext mapCtx, Callback_RenderingEngine_updateCodomainMap __cb)
    {
        return begin_updateCodomainMap(mapCtx, null, false, __cb);
    }

    /**
     * Updates the specified context. The codomain chain already
     * contains the specified context. Each time a new context is
     * updated, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to update.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public Ice.AsyncResult begin_updateCodomainMap(omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx, Callback_RenderingEngine_updateCodomainMap __cb)
    {
        return begin_updateCodomainMap(mapCtx, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_updateCodomainMap(omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__updateCodomainMap_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __updateCodomainMap_name, __cb);
        try
        {
            __result.__prepare(__updateCodomainMap_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(mapCtx);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_updateCodomainMap(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __updateCodomainMap_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Updates the specified context. The codomain chain already
     * contains the specified context. Each time a new context is
     * updated, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to update.
     * @deprecated This operation has been deprecated.
     **/
    public boolean updateCodomainMap_async(AMI_RenderingEngine_updateCodomainMap __cb, omero.romio.CodomainMapContext mapCtx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__updateCodomainMap_name);
            __r = begin_updateCodomainMap(mapCtx, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __updateCodomainMap_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Updates the specified context. The codomain chain already
     * contains the specified context. Each time a new context is
     * updated, the second LUT is rebuilt.
     * 
     * @param __cb The callback object for the operation.
     * @param mapCtx The context to update.
     * @param __ctx The Context map to send with the invocation.
     * @deprecated This operation has been deprecated.
     **/
    public boolean updateCodomainMap_async(AMI_RenderingEngine_updateCodomainMap __cb, omero.romio.CodomainMapContext mapCtx, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__updateCodomainMap_name);
            __r = begin_updateCodomainMap(mapCtx, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __updateCodomainMap_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __activate_name = "activate";

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     **/
    public void activate()
        throws omero.ServerError
    {
        activate(null, false);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void activate(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        activate(__ctx, true);
    }

    private void activate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "activate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("activate");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.activate(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate()
    {
        return begin_activate(null, false, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx)
    {
        return begin_activate(__ctx, true, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate(Ice.Callback __cb)
    {
        return begin_activate(null, false, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_activate(__ctx, true, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate(Callback_StatefulServiceInterface_activate __cb)
    {
        return begin_activate(null, false, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_activate __cb)
    {
        return begin_activate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__activate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
        try
        {
            __result.__prepare(__activate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_activate(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __activate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public boolean activate_async(AMI_StatefulServiceInterface_activate __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__activate_name);
            __r = begin_activate(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean activate_async(AMI_StatefulServiceInterface_activate __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__activate_name);
            __r = begin_activate(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __close_name = "close";

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     **/
    public void close()
        throws omero.ServerError
    {
        close(null, false);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void close(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        close(__ctx, true);
    }

    private void close(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "close", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("close");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.close(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close()
    {
        return begin_close(null, false, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx)
    {
        return begin_close(__ctx, true, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close(Ice.Callback __cb)
    {
        return begin_close(null, false, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_close(__ctx, true, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close(Callback_StatefulServiceInterface_close __cb)
    {
        return begin_close(null, false, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_close __cb)
    {
        return begin_close(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__close_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __close_name, __cb);
        try
        {
            __result.__prepare(__close_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_close(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __close_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public boolean close_async(AMI_StatefulServiceInterface_close __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__close_name);
            __r = begin_close(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __close_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean close_async(AMI_StatefulServiceInterface_close __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__close_name);
            __r = begin_close(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __close_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getCurrentEventContext_name = "getCurrentEventContext";

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     **/
    public omero.sys.EventContext getCurrentEventContext()
        throws omero.ServerError
    {
        return getCurrentEventContext(null, false);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.sys.EventContext getCurrentEventContext(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getCurrentEventContext(__ctx, true);
    }

    private omero.sys.EventContext getCurrentEventContext(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getCurrentEventContext", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getCurrentEventContext");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    return __del.getCurrentEventContext(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext()
    {
        return begin_getCurrentEventContext(null, false, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx)
    {
        return begin_getCurrentEventContext(__ctx, true, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(Ice.Callback __cb)
    {
        return begin_getCurrentEventContext(null, false, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getCurrentEventContext(__ctx, true, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(Callback_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        return begin_getCurrentEventContext(null, false, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        return begin_getCurrentEventContext(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getCurrentEventContext_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
        try
        {
            __result.__prepare(__getCurrentEventContext_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.sys.EventContext end_getCurrentEventContext(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getCurrentEventContext_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.sys.EventContextHolder __ret = new omero.sys.EventContextHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public boolean getCurrentEventContext_async(AMI_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCurrentEventContext_name);
            __r = begin_getCurrentEventContext(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getCurrentEventContext_async(AMI_StatefulServiceInterface_getCurrentEventContext __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCurrentEventContext_name);
            __r = begin_getCurrentEventContext(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __passivate_name = "passivate";

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     **/
    public void passivate()
        throws omero.ServerError
    {
        passivate(null, false);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void passivate(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        passivate(__ctx, true);
    }

    private void passivate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "passivate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("passivate");
                    __delBase = __getDelegate(false);
                    _RenderingEngineDel __del = (_RenderingEngineDel)__delBase;
                    __del.passivate(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate()
    {
        return begin_passivate(null, false, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx)
    {
        return begin_passivate(__ctx, true, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate(Ice.Callback __cb)
    {
        return begin_passivate(null, false, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_passivate(__ctx, true, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate(Callback_StatefulServiceInterface_passivate __cb)
    {
        return begin_passivate(null, false, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_passivate __cb)
    {
        return begin_passivate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__passivate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
        try
        {
            __result.__prepare(__passivate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_passivate(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __passivate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public boolean passivate_async(AMI_StatefulServiceInterface_passivate __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__passivate_name);
            __r = begin_passivate(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean passivate_async(AMI_StatefulServiceInterface_passivate __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__passivate_name);
            __r = begin_passivate(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static RenderingEnginePrx checkedCast(Ice.ObjectPrx __obj)
    {
        RenderingEnginePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof RenderingEnginePrx)
            {
                __d = (RenderingEnginePrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    RenderingEnginePrxHelper __h = new RenderingEnginePrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static RenderingEnginePrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        RenderingEnginePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof RenderingEnginePrx)
            {
                __d = (RenderingEnginePrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    RenderingEnginePrxHelper __h = new RenderingEnginePrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static RenderingEnginePrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        RenderingEnginePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    RenderingEnginePrxHelper __h = new RenderingEnginePrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static RenderingEnginePrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        RenderingEnginePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    RenderingEnginePrxHelper __h = new RenderingEnginePrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static RenderingEnginePrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        RenderingEnginePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof RenderingEnginePrx)
            {
                __d = (RenderingEnginePrx)__obj;
            }
            else
            {
                RenderingEnginePrxHelper __h = new RenderingEnginePrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static RenderingEnginePrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        RenderingEnginePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            RenderingEnginePrxHelper __h = new RenderingEnginePrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::PyramidService",
        "::omero::api::RenderingEngine",
        "::omero::api::ServiceInterface",
        "::omero::api::StatefulServiceInterface"
    };

    public static String ice_staticId()
    {
        return __ids[2];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _RenderingEngineDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _RenderingEngineDelD();
    }

    public static void __write(IceInternal.BasicStream __os, RenderingEnginePrx v)
    {
        __os.writeProxy(v);
    }

    public static RenderingEnginePrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            RenderingEnginePrxHelper result = new RenderingEnginePrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
