// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Search.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Central search interface, allowing Web2.0 style queries. Each
 * {@link omero.api.Search} instance keeps up with several queries and
 * lazily-loads the results as {@link #hasNext}, {@link #next} and
 * {@link #results} are called. These queries are created by the
 * <i>by*</i> methods.
 * 
 * Each instance also has a number of settings which can all be
 * changed from their defaults via accessors, e.g.
 * {@link #setBatchSize} or {@link #setCaseSentivice}.
 * 
 * The only methods which are required for the proper functioning of a
 * {@link Search} instance are:
 * <ul>
 * <li>{@link #onlyType}, {@link #onlyTypes} OR
 * {@link #allTypes}</li>
 * <li>Any <i>by*</i> method to create a query</li>
 * </ul>
 * Use of the {@link #allTypes} method is discouraged, since it is
 * possibly very resource intensive, which is why any attempt to
 * receive results without specifically setting types or allowing all
 * is prohibited.
 * 
 * @see omero.api.IQuery
 **/
public interface SearchPrx extends StatefulServiceInterfacePrx
{
    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @return number of active queries
     **/
    public int activeQueries()
        throws omero.ServerError;

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return number of active queries
     **/
    public int activeQueries(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_activeQueries();

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_activeQueries(java.util.Map<String, String> __ctx);

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_activeQueries(Ice.Callback __cb);

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_activeQueries(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_activeQueries(Callback_Search_activeQueries __cb);

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_activeQueries(java.util.Map<String, String> __ctx, Callback_Search_activeQueries __cb);

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __result The asynchronous result object.
     * @return number of active queries
     **/
    public int end_activeQueries(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean activeQueries_async(AMI_Search_activeQueries __cb);

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean activeQueries_async(AMI_Search_activeQueries __cb, java.util.Map<String, String> __ctx);

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param size maximum number of results per call to
     * {@link #results}
     **/
    public void setBatchSize(int size)
        throws omero.ServerError;

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param size maximum number of results per call to
     * {@link #results}
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setBatchSize(int size, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param size maximum number of results per call to
     * {@link #results}
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setBatchSize(int size);

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param size maximum number of results per call to
     * {@link #results}
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setBatchSize(int size, java.util.Map<String, String> __ctx);

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param size maximum number of results per call to
     * {@link #results}
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setBatchSize(int size, Ice.Callback __cb);

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param size maximum number of results per call to
     * {@link #results}
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setBatchSize(int size, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param size maximum number of results per call to
     * {@link #results}
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setBatchSize(int size, Callback_Search_setBatchSize __cb);

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param size maximum number of results per call to
     * {@link #results}
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setBatchSize(int size, java.util.Map<String, String> __ctx, Callback_Search_setBatchSize __cb);

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_setBatchSize(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param __cb The callback object for the operation.
     * @param size maximum number of results per call to
     * {@link #results}
     **/
    public boolean setBatchSize_async(AMI_Search_setBatchSize __cb, int size);

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param __cb The callback object for the operation.
     * @param size maximum number of results per call to
     * {@link #results}
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setBatchSize_async(AMI_Search_setBatchSize __cb, int size, java.util.Map<String, String> __ctx);

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @return maximum number of results per call to
     * {@link #results}
     **/
    public int getBatchSize()
        throws omero.ServerError;

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return maximum number of results per call to
     * {@link #results}
     **/
    public int getBatchSize(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBatchSize();

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBatchSize(java.util.Map<String, String> __ctx);

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBatchSize(Ice.Callback __cb);

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBatchSize(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBatchSize(Callback_Search_getBatchSize __cb);

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_getBatchSize(java.util.Map<String, String> __ctx, Callback_Search_getBatchSize __cb);

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __result The asynchronous result object.
     * @return maximum number of results per call to
     * {@link #results}
     **/
    public int end_getBatchSize(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getBatchSize_async(AMI_Search_getBatchSize __cb);

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getBatchSize_async(AMI_Search_getBatchSize __cb, java.util.Map<String, String> __ctx);

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     **/
    public void setMergedBatches(boolean merge)
        throws omero.ServerError;

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setMergedBatches(boolean merge, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMergedBatches(boolean merge);

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMergedBatches(boolean merge, java.util.Map<String, String> __ctx);

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMergedBatches(boolean merge, Ice.Callback __cb);

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMergedBatches(boolean merge, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMergedBatches(boolean merge, Callback_Search_setMergedBatches __cb);

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setMergedBatches(boolean merge, java.util.Map<String, String> __ctx, Callback_Search_setMergedBatches __cb);

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __result The asynchronous result object.
     **/
    public void end_setMergedBatches(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __cb The callback object for the operation.
     **/
    public boolean setMergedBatches_async(AMI_Search_setMergedBatches __cb, boolean merge);

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setMergedBatches_async(AMI_Search_setMergedBatches __cb, boolean merge, java.util.Map<String, String> __ctx);

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     **/
    public boolean isMergedBatches()
        throws omero.ServerError;

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isMergedBatches(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isMergedBatches();

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isMergedBatches(java.util.Map<String, String> __ctx);

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isMergedBatches(Ice.Callback __cb);

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isMergedBatches(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isMergedBatches(Callback_Search_isMergedBatches __cb);

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isMergedBatches(java.util.Map<String, String> __ctx, Callback_Search_isMergedBatches __cb);

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __result The asynchronous result object.
     **/
    public boolean end_isMergedBatches(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public boolean isMergedBatches_async(AMI_Search_isMergedBatches __cb);

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isMergedBatches_async(AMI_Search_isMergedBatches __cb, java.util.Map<String, String> __ctx);

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     **/
    public void setCaseSentivice(boolean caseSensitive)
        throws omero.ServerError;

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setCaseSentivice(boolean caseSensitive, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setCaseSentivice(boolean caseSensitive);

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setCaseSentivice(boolean caseSensitive, java.util.Map<String, String> __ctx);

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setCaseSentivice(boolean caseSensitive, Ice.Callback __cb);

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setCaseSentivice(boolean caseSensitive, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setCaseSentivice(boolean caseSensitive, Callback_Search_setCaseSentivice __cb);

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setCaseSentivice(boolean caseSensitive, java.util.Map<String, String> __ctx, Callback_Search_setCaseSentivice __cb);

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __result The asynchronous result object.
     **/
    public void end_setCaseSentivice(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __cb The callback object for the operation.
     **/
    public boolean setCaseSentivice_async(AMI_Search_setCaseSentivice __cb, boolean caseSensitive);

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setCaseSentivice_async(AMI_Search_setCaseSentivice __cb, boolean caseSensitive, java.util.Map<String, String> __ctx);

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     **/
    public boolean isCaseSensitive()
        throws omero.ServerError;

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isCaseSensitive(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isCaseSensitive();

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isCaseSensitive(java.util.Map<String, String> __ctx);

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isCaseSensitive(Ice.Callback __cb);

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isCaseSensitive(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isCaseSensitive(Callback_Search_isCaseSensitive __cb);

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isCaseSensitive(java.util.Map<String, String> __ctx, Callback_Search_isCaseSensitive __cb);

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __result The asynchronous result object.
     **/
    public boolean end_isCaseSensitive(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public boolean isCaseSensitive_async(AMI_Search_isCaseSensitive __cb);

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isCaseSensitive_async(AMI_Search_isCaseSensitive __cb, java.util.Map<String, String> __ctx);

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     **/
    public void setUseProjections(boolean useProjections)
        throws omero.ServerError;

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setUseProjections(boolean useProjections, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setUseProjections(boolean useProjections);

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setUseProjections(boolean useProjections, java.util.Map<String, String> __ctx);

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setUseProjections(boolean useProjections, Ice.Callback __cb);

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setUseProjections(boolean useProjections, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setUseProjections(boolean useProjections, Callback_Search_setUseProjections __cb);

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setUseProjections(boolean useProjections, java.util.Map<String, String> __ctx, Callback_Search_setUseProjections __cb);

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __result The asynchronous result object.
     **/
    public void end_setUseProjections(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __cb The callback object for the operation.
     **/
    public boolean setUseProjections_async(AMI_Search_setUseProjections __cb, boolean useProjections);

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setUseProjections_async(AMI_Search_setUseProjections __cb, boolean useProjections, java.util.Map<String, String> __ctx);

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     **/
    public boolean isUseProjections()
        throws omero.ServerError;

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isUseProjections(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isUseProjections();

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isUseProjections(java.util.Map<String, String> __ctx);

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isUseProjections(Ice.Callback __cb);

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isUseProjections(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isUseProjections(Callback_Search_isUseProjections __cb);

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isUseProjections(java.util.Map<String, String> __ctx, Callback_Search_isUseProjections __cb);

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __result The asynchronous result object.
     **/
    public boolean end_isUseProjections(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public boolean isUseProjections_async(AMI_Search_isUseProjections __cb);

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isUseProjections_async(AMI_Search_isUseProjections __cb, java.util.Map<String, String> __ctx);

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     **/
    public void setReturnUnloaded(boolean returnUnloaded)
        throws omero.ServerError;

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setReturnUnloaded(boolean returnUnloaded, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setReturnUnloaded(boolean returnUnloaded);

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setReturnUnloaded(boolean returnUnloaded, java.util.Map<String, String> __ctx);

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setReturnUnloaded(boolean returnUnloaded, Ice.Callback __cb);

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setReturnUnloaded(boolean returnUnloaded, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setReturnUnloaded(boolean returnUnloaded, Callback_Search_setReturnUnloaded __cb);

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setReturnUnloaded(boolean returnUnloaded, java.util.Map<String, String> __ctx, Callback_Search_setReturnUnloaded __cb);

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __result The asynchronous result object.
     **/
    public void end_setReturnUnloaded(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __cb The callback object for the operation.
     **/
    public boolean setReturnUnloaded_async(AMI_Search_setReturnUnloaded __cb, boolean returnUnloaded);

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setReturnUnloaded_async(AMI_Search_setReturnUnloaded __cb, boolean returnUnloaded, java.util.Map<String, String> __ctx);

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     **/
    public boolean isReturnUnloaded()
        throws omero.ServerError;

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isReturnUnloaded(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isReturnUnloaded();

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isReturnUnloaded(java.util.Map<String, String> __ctx);

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isReturnUnloaded(Ice.Callback __cb);

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isReturnUnloaded(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isReturnUnloaded(Callback_Search_isReturnUnloaded __cb);

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isReturnUnloaded(java.util.Map<String, String> __ctx, Callback_Search_isReturnUnloaded __cb);

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __result The asynchronous result object.
     **/
    public boolean end_isReturnUnloaded(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public boolean isReturnUnloaded_async(AMI_Search_isReturnUnloaded __cb);

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isReturnUnloaded_async(AMI_Search_isReturnUnloaded __cb, java.util.Map<String, String> __ctx);

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @see #isAllowLeadingWildcard
     * @see #byFullText
     * @see #bySomeMustNone
     **/
    public void setAllowLeadingWildcard(boolean allowLeadingWildcard)
        throws omero.ServerError;

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @see #isAllowLeadingWildcard
     * @see #byFullText
     * @see #bySomeMustNone
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setAllowLeadingWildcard(boolean allowLeadingWildcard, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setAllowLeadingWildcard(boolean allowLeadingWildcard);

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setAllowLeadingWildcard(boolean allowLeadingWildcard, java.util.Map<String, String> __ctx);

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setAllowLeadingWildcard(boolean allowLeadingWildcard, Ice.Callback __cb);

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setAllowLeadingWildcard(boolean allowLeadingWildcard, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setAllowLeadingWildcard(boolean allowLeadingWildcard, Callback_Search_setAllowLeadingWildcard __cb);

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_setAllowLeadingWildcard(boolean allowLeadingWildcard, java.util.Map<String, String> __ctx, Callback_Search_setAllowLeadingWildcard __cb);

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @param __result The asynchronous result object.
     * @see #isAllowLeadingWildcard
     * @see #byFullText
     * @see #bySomeMustNone
     **/
    public void end_setAllowLeadingWildcard(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean setAllowLeadingWildcard_async(AMI_Search_setAllowLeadingWildcard __cb, boolean allowLeadingWildcard);

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setAllowLeadingWildcard_async(AMI_Search_setAllowLeadingWildcard __cb, boolean allowLeadingWildcard, java.util.Map<String, String> __ctx);

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     **/
    public boolean isAllowLeadingWildcard()
        throws omero.ServerError;

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isAllowLeadingWildcard(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isAllowLeadingWildcard();

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isAllowLeadingWildcard(java.util.Map<String, String> __ctx);

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isAllowLeadingWildcard(Ice.Callback __cb);

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isAllowLeadingWildcard(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isAllowLeadingWildcard(Callback_Search_isAllowLeadingWildcard __cb);

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_isAllowLeadingWildcard(java.util.Map<String, String> __ctx, Callback_Search_isAllowLeadingWildcard __cb);

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __result The asynchronous result object.
     **/
    public boolean end_isAllowLeadingWildcard(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __cb The callback object for the operation.
     **/
    public boolean isAllowLeadingWildcard_async(AMI_Search_isAllowLeadingWildcard __cb);

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isAllowLeadingWildcard_async(AMI_Search_isAllowLeadingWildcard __cb, java.util.Map<String, String> __ctx);

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     **/
    public void onlyType(String klass)
        throws omero.ServerError;

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void onlyType(String klass, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyType(String klass);

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyType(String klass, java.util.Map<String, String> __ctx);

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyType(String klass, Ice.Callback __cb);

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyType(String klass, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyType(String klass, Callback_Search_onlyType __cb);

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyType(String klass, java.util.Map<String, String> __ctx, Callback_Search_onlyType __cb);

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __result The asynchronous result object.
     **/
    public void end_onlyType(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __cb The callback object for the operation.
     **/
    public boolean onlyType_async(AMI_Search_onlyType __cb, String klass);

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean onlyType_async(AMI_Search_onlyType __cb, String klass, java.util.Map<String, String> __ctx);

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     **/
    public void onlyTypes(java.util.List<String> classes)
        throws omero.ServerError;

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void onlyTypes(java.util.List<String> classes, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyTypes(java.util.List<String> classes);

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyTypes(java.util.List<String> classes, java.util.Map<String, String> __ctx);

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyTypes(java.util.List<String> classes, Ice.Callback __cb);

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyTypes(java.util.List<String> classes, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyTypes(java.util.List<String> classes, Callback_Search_onlyTypes __cb);

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyTypes(java.util.List<String> classes, java.util.Map<String, String> __ctx, Callback_Search_onlyTypes __cb);

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __result The asynchronous result object.
     **/
    public void end_onlyTypes(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __cb The callback object for the operation.
     **/
    public boolean onlyTypes_async(AMI_Search_onlyTypes __cb, java.util.List<String> classes);

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean onlyTypes_async(AMI_Search_onlyTypes __cb, java.util.List<String> classes, java.util.Map<String, String> __ctx);

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     **/
    public void allTypes()
        throws omero.ServerError;

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void allTypes(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_allTypes();

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_allTypes(java.util.Map<String, String> __ctx);

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_allTypes(Ice.Callback __cb);

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_allTypes(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_allTypes(Callback_Search_allTypes __cb);

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_allTypes(java.util.Map<String, String> __ctx, Callback_Search_allTypes __cb);

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __result The asynchronous result object.
     **/
    public void end_allTypes(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __cb The callback object for the operation.
     **/
    public boolean allTypes_async(AMI_Search_allTypes __cb);

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean allTypes_async(AMI_Search_allTypes __cb, java.util.Map<String, String> __ctx);

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     **/
    public void onlyIds(java.util.List<Long> ids)
        throws omero.ServerError;

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void onlyIds(java.util.List<Long> ids, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyIds(java.util.List<Long> ids);

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyIds(java.util.List<Long> ids, java.util.Map<String, String> __ctx);

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyIds(java.util.List<Long> ids, Ice.Callback __cb);

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyIds(java.util.List<Long> ids, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyIds(java.util.List<Long> ids, Callback_Search_onlyIds __cb);

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyIds(java.util.List<Long> ids, java.util.Map<String, String> __ctx, Callback_Search_onlyIds __cb);

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_onlyIds(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param __cb The callback object for the operation.
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     **/
    public boolean onlyIds_async(AMI_Search_onlyIds __cb, java.util.List<Long> ids);

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param __cb The callback object for the operation.
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean onlyIds_async(AMI_Search_onlyIds __cb, java.util.List<Long> ids, java.util.Map<String, String> __ctx);

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     **/
    public void onlyOwnedBy(omero.model.Details d)
        throws omero.ServerError;

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void onlyOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyOwnedBy(omero.model.Details d);

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx);

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyOwnedBy(omero.model.Details d, Ice.Callback __cb);

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyOwnedBy(omero.model.Details d, Callback_Search_onlyOwnedBy __cb);

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx, Callback_Search_onlyOwnedBy __cb);

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_onlyOwnedBy(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     **/
    public boolean onlyOwnedBy_async(AMI_Search_onlyOwnedBy __cb, omero.model.Details d);

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean onlyOwnedBy_async(AMI_Search_onlyOwnedBy __cb, omero.model.Details d, java.util.Map<String, String> __ctx);

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     **/
    public void notOwnedBy(omero.model.Details d)
        throws omero.ServerError;

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void notOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_notOwnedBy(omero.model.Details d);

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_notOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx);

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_notOwnedBy(omero.model.Details d, Ice.Callback __cb);

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_notOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_notOwnedBy(omero.model.Details d, Callback_Search_notOwnedBy __cb);

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_notOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx, Callback_Search_notOwnedBy __cb);

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_notOwnedBy(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     **/
    public boolean notOwnedBy_async(AMI_Search_notOwnedBy __cb, omero.model.Details d);

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean notOwnedBy_async(AMI_Search_notOwnedBy __cb, omero.model.Details d, java.util.Map<String, String> __ctx);

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     **/
    public void onlyCreatedBetween(omero.RTime start, omero.RTime stop)
        throws omero.ServerError;

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void onlyCreatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyCreatedBetween(omero.RTime start, omero.RTime stop);

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyCreatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx);

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyCreatedBetween(omero.RTime start, omero.RTime stop, Ice.Callback __cb);

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyCreatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyCreatedBetween(omero.RTime start, omero.RTime stop, Callback_Search_onlyCreatedBetween __cb);

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyCreatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx, Callback_Search_onlyCreatedBetween __cb);

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_onlyCreatedBetween(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     **/
    public boolean onlyCreatedBetween_async(AMI_Search_onlyCreatedBetween __cb, omero.RTime start, omero.RTime stop);

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean onlyCreatedBetween_async(AMI_Search_onlyCreatedBetween __cb, omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx);

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     **/
    public void onlyModifiedBetween(omero.RTime start, omero.RTime stop)
        throws omero.ServerError;

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void onlyModifiedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyModifiedBetween(omero.RTime start, omero.RTime stop);

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyModifiedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx);

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyModifiedBetween(omero.RTime start, omero.RTime stop, Ice.Callback __cb);

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyModifiedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyModifiedBetween(omero.RTime start, omero.RTime stop, Callback_Search_onlyModifiedBetween __cb);

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyModifiedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx, Callback_Search_onlyModifiedBetween __cb);

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_onlyModifiedBetween(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     **/
    public boolean onlyModifiedBetween_async(AMI_Search_onlyModifiedBetween __cb, omero.RTime start, omero.RTime stop);

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean onlyModifiedBetween_async(AMI_Search_onlyModifiedBetween __cb, omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx);

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     **/
    public void onlyAnnotatedBetween(omero.RTime start, omero.RTime stop)
        throws omero.ServerError;

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void onlyAnnotatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBetween(omero.RTime start, omero.RTime stop);

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx);

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBetween(omero.RTime start, omero.RTime stop, Ice.Callback __cb);

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBetween(omero.RTime start, omero.RTime stop, Callback_Search_onlyAnnotatedBetween __cb);

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx, Callback_Search_onlyAnnotatedBetween __cb);

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_onlyAnnotatedBetween(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     **/
    public boolean onlyAnnotatedBetween_async(AMI_Search_onlyAnnotatedBetween __cb, omero.RTime start, omero.RTime stop);

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean onlyAnnotatedBetween_async(AMI_Search_onlyAnnotatedBetween __cb, omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx);

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     **/
    public void onlyAnnotatedBy(omero.model.Details d)
        throws omero.ServerError;

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void onlyAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBy(omero.model.Details d);

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx);

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBy(omero.model.Details d, Ice.Callback __cb);

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBy(omero.model.Details d, Callback_Search_onlyAnnotatedBy __cb);

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx, Callback_Search_onlyAnnotatedBy __cb);

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_onlyAnnotatedBy(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     **/
    public boolean onlyAnnotatedBy_async(AMI_Search_onlyAnnotatedBy __cb, omero.model.Details d);

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean onlyAnnotatedBy_async(AMI_Search_onlyAnnotatedBy __cb, omero.model.Details d, java.util.Map<String, String> __ctx);

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     **/
    public void notAnnotatedBy(omero.model.Details d)
        throws omero.ServerError;

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void notAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_notAnnotatedBy(omero.model.Details d);

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_notAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx);

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_notAnnotatedBy(omero.model.Details d, Ice.Callback __cb);

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_notAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_notAnnotatedBy(omero.model.Details d, Callback_Search_notAnnotatedBy __cb);

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_notAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx, Callback_Search_notAnnotatedBy __cb);

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_notAnnotatedBy(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     **/
    public boolean notAnnotatedBy_async(AMI_Search_notAnnotatedBy __cb, omero.model.Details d);

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean notAnnotatedBy_async(AMI_Search_notAnnotatedBy __cb, omero.model.Details d, java.util.Map<String, String> __ctx);

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param classes Can be empty, in which case restriction is
     * removed.
     **/
    public void onlyAnnotatedWith(java.util.List<String> classes)
        throws omero.ServerError;

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param classes Can be empty, in which case restriction is
     * removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void onlyAnnotatedWith(java.util.List<String> classes, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param classes Can be empty, in which case restriction is
     * removed.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedWith(java.util.List<String> classes);

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param classes Can be empty, in which case restriction is
     * removed.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedWith(java.util.List<String> classes, java.util.Map<String, String> __ctx);

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param classes Can be empty, in which case restriction is
     * removed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedWith(java.util.List<String> classes, Ice.Callback __cb);

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param classes Can be empty, in which case restriction is
     * removed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedWith(java.util.List<String> classes, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param classes Can be empty, in which case restriction is
     * removed.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedWith(java.util.List<String> classes, Callback_Search_onlyAnnotatedWith __cb);

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param classes Can be empty, in which case restriction is
     * removed.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedWith(java.util.List<String> classes, java.util.Map<String, String> __ctx, Callback_Search_onlyAnnotatedWith __cb);

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_onlyAnnotatedWith(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, in which case restriction is
     * removed.
     **/
    public boolean onlyAnnotatedWith_async(AMI_Search_onlyAnnotatedWith __cb, java.util.List<String> classes);

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, in which case restriction is
     * removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean onlyAnnotatedWith_async(AMI_Search_onlyAnnotatedWith __cb, java.util.List<String> classes, java.util.Map<String, String> __ctx);

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @see #unordered
     **/
    public void addOrderByAsc(String path)
        throws omero.ServerError;

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @see #unordered
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addOrderByAsc(String path, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addOrderByAsc(String path);

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addOrderByAsc(String path, java.util.Map<String, String> __ctx);

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addOrderByAsc(String path, Ice.Callback __cb);

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addOrderByAsc(String path, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addOrderByAsc(String path, Callback_Search_addOrderByAsc __cb);

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addOrderByAsc(String path, java.util.Map<String, String> __ctx, Callback_Search_addOrderByAsc __cb);

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __result The asynchronous result object.
     * @see #unordered
     **/
    public void end_addOrderByAsc(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     **/
    public boolean addOrderByAsc_async(AMI_Search_addOrderByAsc __cb, String path);

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addOrderByAsc_async(AMI_Search_addOrderByAsc __cb, String path, java.util.Map<String, String> __ctx);

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @see #unordered
     **/
    public void addOrderByDesc(String path)
        throws omero.ServerError;

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @see #unordered
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addOrderByDesc(String path, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addOrderByDesc(String path);

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addOrderByDesc(String path, java.util.Map<String, String> __ctx);

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addOrderByDesc(String path, Ice.Callback __cb);

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addOrderByDesc(String path, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addOrderByDesc(String path, Callback_Search_addOrderByDesc __cb);

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_addOrderByDesc(String path, java.util.Map<String, String> __ctx, Callback_Search_addOrderByDesc __cb);

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __result The asynchronous result object.
     * @see #unordered
     **/
    public void end_addOrderByDesc(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     **/
    public boolean addOrderByDesc_async(AMI_Search_addOrderByDesc __cb, String path);

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addOrderByDesc_async(AMI_Search_addOrderByDesc __cb, String path, java.util.Map<String, String> __ctx);

    /**
     * Removes the current stack of order statements.
     * 
     * @see #addOrderByAsc
     * @see #addOrderByDesc
     **/
    public void unordered()
        throws omero.ServerError;

    /**
     * Removes the current stack of order statements.
     * 
     * @see #addOrderByAsc
     * @see #addOrderByDesc
     * @param __ctx The Context map to send with the invocation.
     **/
    public void unordered(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Removes the current stack of order statements.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_unordered();

    /**
     * Removes the current stack of order statements.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_unordered(java.util.Map<String, String> __ctx);

    /**
     * Removes the current stack of order statements.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_unordered(Ice.Callback __cb);

    /**
     * Removes the current stack of order statements.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_unordered(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Removes the current stack of order statements.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_unordered(Callback_Search_unordered __cb);

    /**
     * Removes the current stack of order statements.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_unordered(java.util.Map<String, String> __ctx, Callback_Search_unordered __cb);

    /**
     * Removes the current stack of order statements.
     * 
     * @param __result The asynchronous result object.
     * @see #addOrderByAsc
     * @see #addOrderByDesc
     **/
    public void end_unordered(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Removes the current stack of order statements.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean unordered_async(AMI_Search_unordered __cb);

    /**
     * Removes the current stack of order statements.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean unordered_async(AMI_Search_unordered __cb, java.util.Map<String, String> __ctx);

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param classes Can be empty, which removes previous fetch
     * setting.
     **/
    public void fetchAnnotations(java.util.List<String> classes)
        throws omero.ServerError;

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param classes Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void fetchAnnotations(java.util.List<String> classes, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param classes Can be empty, which removes previous fetch
     * setting.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fetchAnnotations(java.util.List<String> classes);

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param classes Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fetchAnnotations(java.util.List<String> classes, java.util.Map<String, String> __ctx);

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param classes Can be empty, which removes previous fetch
     * setting.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fetchAnnotations(java.util.List<String> classes, Ice.Callback __cb);

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param classes Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fetchAnnotations(java.util.List<String> classes, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param classes Can be empty, which removes previous fetch
     * setting.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fetchAnnotations(java.util.List<String> classes, Callback_Search_fetchAnnotations __cb);

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param classes Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fetchAnnotations(java.util.List<String> classes, java.util.Map<String, String> __ctx, Callback_Search_fetchAnnotations __cb);

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_fetchAnnotations(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, which removes previous fetch
     * setting.
     **/
    public boolean fetchAnnotations_async(AMI_Search_fetchAnnotations __cb, java.util.List<String> classes);

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean fetchAnnotations_async(AMI_Search_fetchAnnotations __cb, java.util.List<String> classes, java.util.Map<String, String> __ctx);

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     **/
    public void fetchAlso(java.util.List<String> fetches)
        throws omero.ServerError;

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void fetchAlso(java.util.List<String> fetches, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fetchAlso(java.util.List<String> fetches);

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fetchAlso(java.util.List<String> fetches, java.util.Map<String, String> __ctx);

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fetchAlso(java.util.List<String> fetches, Ice.Callback __cb);

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fetchAlso(java.util.List<String> fetches, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fetchAlso(java.util.List<String> fetches, Callback_Search_fetchAlso __cb);

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_fetchAlso(java.util.List<String> fetches, java.util.Map<String, String> __ctx, Callback_Search_fetchAlso __cb);

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_fetchAlso(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param __cb The callback object for the operation.
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     **/
    public boolean fetchAlso_async(AMI_Search_fetchAlso __cb, java.util.List<String> fetches);

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param __cb The callback object for the operation.
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean fetchAlso_async(AMI_Search_fetchAlso __cb, java.util.List<String> fetches, java.util.Map<String, String> __ctx);

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     **/
    public void resetDefaults()
        throws omero.ServerError;

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void resetDefaults(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaults();

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaults(java.util.Map<String, String> __ctx);

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaults(Ice.Callback __cb);

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaults(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaults(Callback_Search_resetDefaults __cb);

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_resetDefaults(java.util.Map<String, String> __ctx, Callback_Search_resetDefaults __cb);

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __result The asynchronous result object.
     **/
    public void end_resetDefaults(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __cb The callback object for the operation.
     **/
    public boolean resetDefaults_async(AMI_Search_resetDefaults __cb);

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaults_async(AMI_Search_resetDefaults __cb, java.util.Map<String, String> __ctx);

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param group Can be null or empty to return all tags.
     **/
    public void byGroupForTags(String group)
        throws omero.ServerError;

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param group Can be null or empty to return all tags.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void byGroupForTags(String group, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param group Can be null or empty to return all tags.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byGroupForTags(String group);

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param group Can be null or empty to return all tags.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byGroupForTags(String group, java.util.Map<String, String> __ctx);

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param group Can be null or empty to return all tags.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byGroupForTags(String group, Ice.Callback __cb);

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param group Can be null or empty to return all tags.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byGroupForTags(String group, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param group Can be null or empty to return all tags.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byGroupForTags(String group, Callback_Search_byGroupForTags __cb);

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param group Can be null or empty to return all tags.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byGroupForTags(String group, java.util.Map<String, String> __ctx, Callback_Search_byGroupForTags __cb);

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_byGroupForTags(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param group Can be null or empty to return all tags.
     **/
    public boolean byGroupForTags_async(AMI_Search_byGroupForTags __cb, String group);

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param group Can be null or empty to return all tags.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean byGroupForTags_async(AMI_Search_byGroupForTags __cb, String group, java.util.Map<String, String> __ctx);

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param tag Can be null or empty to return all groups.
     **/
    public void byTagForGroups(String tag)
        throws omero.ServerError;

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param tag Can be null or empty to return all groups.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void byTagForGroups(String tag, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param tag Can be null or empty to return all groups.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byTagForGroups(String tag);

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param tag Can be null or empty to return all groups.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byTagForGroups(String tag, java.util.Map<String, String> __ctx);

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param tag Can be null or empty to return all groups.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byTagForGroups(String tag, Ice.Callback __cb);

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param tag Can be null or empty to return all groups.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byTagForGroups(String tag, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param tag Can be null or empty to return all groups.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byTagForGroups(String tag, Callback_Search_byTagForGroups __cb);

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param tag Can be null or empty to return all groups.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byTagForGroups(String tag, java.util.Map<String, String> __ctx, Callback_Search_byTagForGroups __cb);

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_byTagForGroups(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param tag Can be null or empty to return all groups.
     **/
    public boolean byTagForGroups_async(AMI_Search_byTagForGroups __cb, String tag);

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param tag Can be null or empty to return all groups.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean byTagForGroups_async(AMI_Search_byTagForGroups __cb, String tag, java.util.Map<String, String> __ctx);

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param query May not be null or of zero length.
     **/
    public void byFullText(String query)
        throws omero.ServerError;

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void byFullText(String query, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param query May not be null or of zero length.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byFullText(String query);

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byFullText(String query, java.util.Map<String, String> __ctx);

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param query May not be null or of zero length.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byFullText(String query, Ice.Callback __cb);

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byFullText(String query, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param query May not be null or of zero length.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byFullText(String query, Callback_Search_byFullText __cb);

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byFullText(String query, java.util.Map<String, String> __ctx, Callback_Search_byFullText __cb);

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_byFullText(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param query May not be null or of zero length.
     **/
    public boolean byFullText_async(AMI_Search_byFullText __cb, String query);

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean byFullText_async(AMI_Search_byFullText __cb, String query, java.util.Map<String, String> __ctx);

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     **/
    public void byLuceneQueryBuilder(String fields, String from, String to, String dateType, String query)
        throws omero.ServerError;

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void byLuceneQueryBuilder(String fields, String from, String to, String dateType, String query, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byLuceneQueryBuilder(String fields, String from, String to, String dateType, String query);

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byLuceneQueryBuilder(String fields, String from, String to, String dateType, String query, java.util.Map<String, String> __ctx);

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byLuceneQueryBuilder(String fields, String from, String to, String dateType, String query, Ice.Callback __cb);

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byLuceneQueryBuilder(String fields, String from, String to, String dateType, String query, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byLuceneQueryBuilder(String fields, String from, String to, String dateType, String query, Callback_Search_byLuceneQueryBuilder __cb);

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byLuceneQueryBuilder(String fields, String from, String to, String dateType, String query, java.util.Map<String, String> __ctx, Callback_Search_byLuceneQueryBuilder __cb);

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_byLuceneQueryBuilder(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     **/
    public boolean byLuceneQueryBuilder_async(AMI_Search_byLuceneQueryBuilder __cb, String fields, String from, String to, String dateType, String query);

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean byLuceneQueryBuilder_async(AMI_Search_byLuceneQueryBuilder __cb, String fields, String from, String to, String dateType, String query, java.util.Map<String, String> __ctx);

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param terms Cannot be empty.
     **/
    public void bySimilarTerms(java.util.List<String> terms)
        throws omero.ServerError;

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param terms Cannot be empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void bySimilarTerms(java.util.List<String> terms, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param terms Cannot be empty.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_bySimilarTerms(java.util.List<String> terms);

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param terms Cannot be empty.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_bySimilarTerms(java.util.List<String> terms, java.util.Map<String, String> __ctx);

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param terms Cannot be empty.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_bySimilarTerms(java.util.List<String> terms, Ice.Callback __cb);

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param terms Cannot be empty.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_bySimilarTerms(java.util.List<String> terms, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param terms Cannot be empty.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_bySimilarTerms(java.util.List<String> terms, Callback_Search_bySimilarTerms __cb);

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param terms Cannot be empty.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_bySimilarTerms(java.util.List<String> terms, java.util.Map<String, String> __ctx, Callback_Search_bySimilarTerms __cb);

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_bySimilarTerms(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param __cb The callback object for the operation.
     * @param terms Cannot be empty.
     **/
    public boolean bySimilarTerms_async(AMI_Search_bySimilarTerms __cb, java.util.List<String> terms);

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param __cb The callback object for the operation.
     * @param terms Cannot be empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean bySimilarTerms_async(AMI_Search_bySimilarTerms __cb, java.util.List<String> terms, java.util.Map<String, String> __ctx);

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param query Not null.
     * @param p May be null. Defaults are then in effect.
     * @see omero.api.IQuery#findAllByQuery
     **/
    public void byHqlQuery(String query, omero.sys.Parameters params)
        throws omero.ServerError;

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param query Not null.
     * @param p May be null. Defaults are then in effect.
     * @see omero.api.IQuery#findAllByQuery
     * @param __ctx The Context map to send with the invocation.
     **/
    public void byHqlQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param query Not null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byHqlQuery(String query, omero.sys.Parameters params);

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param query Not null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byHqlQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx);

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param query Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byHqlQuery(String query, omero.sys.Parameters params, Ice.Callback __cb);

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param query Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byHqlQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param query Not null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byHqlQuery(String query, omero.sys.Parameters params, Callback_Search_byHqlQuery __cb);

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param query Not null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byHqlQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Callback_Search_byHqlQuery __cb);

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param __result The asynchronous result object.
     * @see omero.api.IQuery#findAllByQuery
     **/
    public void end_byHqlQuery(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param __cb The callback object for the operation.
     * @param query Not null.
     **/
    public boolean byHqlQuery_async(AMI_Search_byHqlQuery __cb, String query, omero.sys.Parameters params);

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param __cb The callback object for the operation.
     * @param query Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean byHqlQuery_async(AMI_Search_byHqlQuery __cb, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx);

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     **/
    public void bySomeMustNone(java.util.List<String> some, java.util.List<String> must, java.util.List<String> none)
        throws omero.ServerError;

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void bySomeMustNone(java.util.List<String> some, java.util.List<String> must, java.util.List<String> none, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_bySomeMustNone(java.util.List<String> some, java.util.List<String> must, java.util.List<String> none);

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_bySomeMustNone(java.util.List<String> some, java.util.List<String> must, java.util.List<String> none, java.util.Map<String, String> __ctx);

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_bySomeMustNone(java.util.List<String> some, java.util.List<String> must, java.util.List<String> none, Ice.Callback __cb);

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_bySomeMustNone(java.util.List<String> some, java.util.List<String> must, java.util.List<String> none, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_bySomeMustNone(java.util.List<String> some, java.util.List<String> must, java.util.List<String> none, Callback_Search_bySomeMustNone __cb);

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_bySomeMustNone(java.util.List<String> some, java.util.List<String> must, java.util.List<String> none, java.util.Map<String, String> __ctx, Callback_Search_bySomeMustNone __cb);

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_bySomeMustNone(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param __cb The callback object for the operation.
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     **/
    public boolean bySomeMustNone_async(AMI_Search_bySomeMustNone __cb, java.util.List<String> some, java.util.List<String> must, java.util.List<String> none);

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param __cb The callback object for the operation.
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean bySomeMustNone_async(AMI_Search_bySomeMustNone __cb, java.util.List<String> some, java.util.List<String> must, java.util.List<String> none, java.util.Map<String, String> __ctx);

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param examples Not empty.
     **/
    public void byAnnotatedWith(java.util.List<omero.model.Annotation> examples)
        throws omero.ServerError;

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param examples Not empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void byAnnotatedWith(java.util.List<omero.model.Annotation> examples, java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param examples Not empty.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byAnnotatedWith(java.util.List<omero.model.Annotation> examples);

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param examples Not empty.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byAnnotatedWith(java.util.List<omero.model.Annotation> examples, java.util.Map<String, String> __ctx);

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param examples Not empty.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byAnnotatedWith(java.util.List<omero.model.Annotation> examples, Ice.Callback __cb);

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param examples Not empty.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byAnnotatedWith(java.util.List<omero.model.Annotation> examples, java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param examples Not empty.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byAnnotatedWith(java.util.List<omero.model.Annotation> examples, Callback_Search_byAnnotatedWith __cb);

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param examples Not empty.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_byAnnotatedWith(java.util.List<omero.model.Annotation> examples, java.util.Map<String, String> __ctx, Callback_Search_byAnnotatedWith __cb);

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param __result The asynchronous result object.
     **/
    public void end_byAnnotatedWith(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param examples Not empty.
     **/
    public boolean byAnnotatedWith_async(AMI_Search_byAnnotatedWith __cb, java.util.List<omero.model.Annotation> examples);

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param examples Not empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean byAnnotatedWith_async(AMI_Search_byAnnotatedWith __cb, java.util.List<omero.model.Annotation> examples, java.util.Map<String, String> __ctx);

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     **/
    public void clearQueries()
        throws omero.ServerError;

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void clearQueries(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_clearQueries();

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_clearQueries(java.util.Map<String, String> __ctx);

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_clearQueries(Ice.Callback __cb);

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_clearQueries(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_clearQueries(Callback_Search_clearQueries __cb);

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_clearQueries(java.util.Map<String, String> __ctx, Callback_Search_clearQueries __cb);

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __result The asynchronous result object.
     **/
    public void end_clearQueries(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __cb The callback object for the operation.
     **/
    public boolean clearQueries_async(AMI_Search_clearQueries __cb);

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean clearQueries_async(AMI_Search_clearQueries __cb, java.util.Map<String, String> __ctx);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     **/
    public void and()
        throws omero.ServerError;

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __ctx The Context map to send with the invocation.
     **/
    public void and(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_and();

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_and(java.util.Map<String, String> __ctx);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_and(Ice.Callback __cb);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_and(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_and(Callback_Search_and __cb);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_and(java.util.Map<String, String> __ctx, Callback_Search_and __cb);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __result The asynchronous result object.
     **/
    public void end_and(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __cb The callback object for the operation.
     **/
    public boolean and_async(AMI_Search_and __cb);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean and_async(AMI_Search_and __cb, java.util.Map<String, String> __ctx);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     **/
    public void or()
        throws omero.ServerError;

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void or(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_or();

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_or(java.util.Map<String, String> __ctx);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_or(Ice.Callback __cb);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_or(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_or(Callback_Search_or __cb);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_or(java.util.Map<String, String> __ctx, Callback_Search_or __cb);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __result The asynchronous result object.
     **/
    public void end_or(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __cb The callback object for the operation.
     **/
    public boolean or_async(AMI_Search_or __cb);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean or_async(AMI_Search_or __cb, java.util.Map<String, String> __ctx);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     **/
    public void not()
        throws omero.ServerError;

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __ctx The Context map to send with the invocation.
     **/
    public void not(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_not();

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_not(java.util.Map<String, String> __ctx);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_not(Ice.Callback __cb);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_not(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_not(Callback_Search_not __cb);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_not(java.util.Map<String, String> __ctx, Callback_Search_not __cb);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __result The asynchronous result object.
     **/
    public void end_not(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __cb The callback object for the operation.
     **/
    public boolean not_async(AMI_Search_not __cb);

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean not_async(AMI_Search_not __cb, java.util.Map<String, String> __ctx);

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     **/
    public boolean hasNext()
        throws omero.ServerError;

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean hasNext(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_hasNext();

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_hasNext(java.util.Map<String, String> __ctx);

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_hasNext(Ice.Callback __cb);

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_hasNext(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_hasNext(Callback_Search_hasNext __cb);

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_hasNext(java.util.Map<String, String> __ctx, Callback_Search_hasNext __cb);

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __result The asynchronous result object.
     **/
    public boolean end_hasNext(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __cb The callback object for the operation.
     **/
    public boolean hasNext_async(AMI_Search_hasNext __cb);

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean hasNext_async(AMI_Search_hasNext __cb, java.util.Map<String, String> __ctx);

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @throws ApiUsageException if {@link #hasNext} returns false.
     **/
    public omero.model.IObject next()
        throws omero.ServerError;

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @throws ApiUsageException if {@link #hasNext} returns false.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.IObject next(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_next();

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_next(java.util.Map<String, String> __ctx);

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_next(Ice.Callback __cb);

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_next(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_next(Callback_Search_next __cb);

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_next(java.util.Map<String, String> __ctx, Callback_Search_next __cb);

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @param __result The asynchronous result object.
     * @throws ApiUsageException if {@link #hasNext} returns false.
     **/
    public omero.model.IObject end_next(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean next_async(AMI_Search_next __cb);

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean next_async(AMI_Search_next __cb, java.util.Map<String, String> __ctx);

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @throws ApiUsageException if {@link #hasNext} returns false.
     **/
    public java.util.List<omero.model.IObject> results()
        throws omero.ServerError;

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @throws ApiUsageException if {@link #hasNext} returns false.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.IObject> results(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_results();

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_results(java.util.Map<String, String> __ctx);

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_results(Ice.Callback __cb);

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_results(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_results(Callback_Search_results __cb);

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_results(java.util.Map<String, String> __ctx, Callback_Search_results __cb);

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @param __result The asynchronous result object.
     * @throws ApiUsageException if {@link #hasNext} returns false.
     **/
    public java.util.List<omero.model.IObject> end_results(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean results_async(AMI_Search_results __cb);

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean results_async(AMI_Search_results __cb, java.util.Map<String, String> __ctx);

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     **/
    public java.util.Map<java.lang.String, omero.model.Annotation> currentMetadata()
        throws omero.ServerError;

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.Map<java.lang.String, omero.model.Annotation> currentMetadata(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_currentMetadata();

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_currentMetadata(java.util.Map<String, String> __ctx);

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_currentMetadata(Ice.Callback __cb);

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_currentMetadata(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_currentMetadata(Callback_Search_currentMetadata __cb);

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_currentMetadata(java.util.Map<String, String> __ctx, Callback_Search_currentMetadata __cb);

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __result The asynchronous result object.
     **/
    public java.util.Map<java.lang.String, omero.model.Annotation> end_currentMetadata(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __cb The callback object for the operation.
     **/
    public boolean currentMetadata_async(AMI_Search_currentMetadata __cb);

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean currentMetadata_async(AMI_Search_currentMetadata __cb, java.util.Map<String, String> __ctx);

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     **/
    public java.util.List<java.util.Map<java.lang.String, omero.model.Annotation>> currentMetadataList()
        throws omero.ServerError;

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<java.util.Map<java.lang.String, omero.model.Annotation>> currentMetadataList(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_currentMetadataList();

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_currentMetadataList(java.util.Map<String, String> __ctx);

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_currentMetadataList(Ice.Callback __cb);

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_currentMetadataList(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_currentMetadataList(Callback_Search_currentMetadataList __cb);

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_currentMetadataList(java.util.Map<String, String> __ctx, Callback_Search_currentMetadataList __cb);

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __result The asynchronous result object.
     **/
    public java.util.List<java.util.Map<java.lang.String, omero.model.Annotation>> end_currentMetadataList(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __cb The callback object for the operation.
     **/
    public boolean currentMetadataList_async(AMI_Search_currentMetadataList __cb);

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean currentMetadataList_async(AMI_Search_currentMetadataList __cb, java.util.Map<String, String> __ctx);

    /**
     * Unsupported operation.
     **/
    public void remove()
        throws omero.ServerError;

    /**
     * Unsupported operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void remove(java.util.Map<String, String> __ctx)
        throws omero.ServerError;

    /**
     * Unsupported operation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove();

    /**
     * Unsupported operation.
     * @param __ctx The Context map to send with the invocation.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(java.util.Map<String, String> __ctx);

    /**
     * Unsupported operation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(Ice.Callback __cb);

    /**
     * Unsupported operation.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(java.util.Map<String, String> __ctx, Ice.Callback __cb);

    /**
     * Unsupported operation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(Callback_Search_remove __cb);

    /**
     * Unsupported operation.
     * @param __ctx The Context map to send with the invocation.
     * @param __cb The asynchronous callback object.
     * @return The asynchronous result object.
     **/
    public Ice.AsyncResult begin_remove(java.util.Map<String, String> __ctx, Callback_Search_remove __cb);

    /**
     * Unsupported operation.
     * @param __result The asynchronous result object.
     **/
    public void end_remove(Ice.AsyncResult __result)
        throws omero.ServerError;

    /**
     * Unsupported operation.
     * @param __cb The callback object for the operation.
     **/
    public boolean remove_async(AMI_Search_remove __cb);

    /**
     * Unsupported operation.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean remove_async(AMI_Search_remove __cb, java.util.Map<String, String> __ctx);
}
