// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Search.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Central search interface, allowing Web2.0 style queries. Each
 * {@link omero.api.Search} instance keeps up with several queries and
 * lazily-loads the results as {@link #hasNext}, {@link #next} and
 * {@link #results} are called. These queries are created by the
 * <i>by*</i> methods.
 * 
 * Each instance also has a number of settings which can all be
 * changed from their defaults via accessors, e.g.
 * {@link #setBatchSize} or {@link #setCaseSentivice}.
 * 
 * The only methods which are required for the proper functioning of a
 * {@link Search} instance are:
 * <ul>
 * <li>{@link #onlyType}, {@link #onlyTypes} OR
 * {@link #allTypes}</li>
 * <li>Any <i>by*</i> method to create a query</li>
 * </ul>
 * Use of the {@link #allTypes} method is discouraged, since it is
 * possibly very resource intensive, which is why any attempt to
 * receive results without specifically setting types or allowing all
 * is prohibited.
 * 
 * @see omero.api.IQuery
 **/
public final class SearchPrxHelper extends Ice.ObjectPrxHelperBase implements SearchPrx
{
    private static final String __activeQueries_name = "activeQueries";

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @return number of active queries
     **/
    public int activeQueries()
        throws omero.ServerError
    {
        return activeQueries(null, false);
    }

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return number of active queries
     **/
    public int activeQueries(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return activeQueries(__ctx, true);
    }

    private int activeQueries(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "activeQueries", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("activeQueries");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    return __del.activeQueries(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activeQueries()
    {
        return begin_activeQueries(null, false, null);
    }

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activeQueries(java.util.Map<String, String> __ctx)
    {
        return begin_activeQueries(__ctx, true, null);
    }

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activeQueries(Ice.Callback __cb)
    {
        return begin_activeQueries(null, false, __cb);
    }

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activeQueries(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_activeQueries(__ctx, true, __cb);
    }

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activeQueries(Callback_Search_activeQueries __cb)
    {
        return begin_activeQueries(null, false, __cb);
    }

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activeQueries(java.util.Map<String, String> __ctx, Callback_Search_activeQueries __cb)
    {
        return begin_activeQueries(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_activeQueries(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__activeQueries_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __activeQueries_name, __cb);
        try
        {
            __result.__prepare(__activeQueries_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) number of active queries
     **/
    public int end_activeQueries(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __activeQueries_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int __ret;
            __ret = __is.readInt();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean activeQueries_async(AMI_Search_activeQueries __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__activeQueries_name);
            __r = begin_activeQueries(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __activeQueries_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the number of active queries. This means that
     * {@link #activeQueries} gives the minimum number of
     * remaining calls to {@link #results} when batches are not
     * merged.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean activeQueries_async(AMI_Search_activeQueries __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__activeQueries_name);
            __r = begin_activeQueries(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __activeQueries_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __addOrderByAsc_name = "addOrderByAsc";

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @see #unordered
     **/
    public void addOrderByAsc(String path)
        throws omero.ServerError
    {
        addOrderByAsc(path, null, false);
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @see #unordered
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addOrderByAsc(String path, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        addOrderByAsc(path, __ctx, true);
    }

    private void addOrderByAsc(String path, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "addOrderByAsc", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("addOrderByAsc");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.addOrderByAsc(path, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     **/
    public Ice.AsyncResult begin_addOrderByAsc(String path)
    {
        return begin_addOrderByAsc(path, null, false, null);
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addOrderByAsc(String path, java.util.Map<String, String> __ctx)
    {
        return begin_addOrderByAsc(path, __ctx, true, null);
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     **/
    public Ice.AsyncResult begin_addOrderByAsc(String path, Ice.Callback __cb)
    {
        return begin_addOrderByAsc(path, null, false, __cb);
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addOrderByAsc(String path, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_addOrderByAsc(path, __ctx, true, __cb);
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     **/
    public Ice.AsyncResult begin_addOrderByAsc(String path, Callback_Search_addOrderByAsc __cb)
    {
        return begin_addOrderByAsc(path, null, false, __cb);
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addOrderByAsc(String path, java.util.Map<String, String> __ctx, Callback_Search_addOrderByAsc __cb)
    {
        return begin_addOrderByAsc(path, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_addOrderByAsc(String path, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__addOrderByAsc_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __addOrderByAsc_name, __cb);
        try
        {
            __result.__prepare(__addOrderByAsc_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(path);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_addOrderByAsc(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __addOrderByAsc_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     **/
    public boolean addOrderByAsc_async(AMI_Search_addOrderByAsc __cb, String path)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addOrderByAsc_name);
            __r = begin_addOrderByAsc(path, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addOrderByAsc_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addOrderByAsc_async(AMI_Search_addOrderByAsc __cb, String path, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addOrderByAsc_name);
            __r = begin_addOrderByAsc(path, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addOrderByAsc_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __addOrderByDesc_name = "addOrderByDesc";

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @see #unordered
     **/
    public void addOrderByDesc(String path)
        throws omero.ServerError
    {
        addOrderByDesc(path, null, false);
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param path Non-null.
     * @see #unordered
     * @param __ctx The Context map to send with the invocation.
     **/
    public void addOrderByDesc(String path, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        addOrderByDesc(path, __ctx, true);
    }

    private void addOrderByDesc(String path, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "addOrderByDesc", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("addOrderByDesc");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.addOrderByDesc(path, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     **/
    public Ice.AsyncResult begin_addOrderByDesc(String path)
    {
        return begin_addOrderByDesc(path, null, false, null);
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addOrderByDesc(String path, java.util.Map<String, String> __ctx)
    {
        return begin_addOrderByDesc(path, __ctx, true, null);
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     **/
    public Ice.AsyncResult begin_addOrderByDesc(String path, Ice.Callback __cb)
    {
        return begin_addOrderByDesc(path, null, false, __cb);
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addOrderByDesc(String path, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_addOrderByDesc(path, __ctx, true, __cb);
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     **/
    public Ice.AsyncResult begin_addOrderByDesc(String path, Callback_Search_addOrderByDesc __cb)
    {
        return begin_addOrderByDesc(path, null, false, __cb);
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_addOrderByDesc(String path, java.util.Map<String, String> __ctx, Callback_Search_addOrderByDesc __cb)
    {
        return begin_addOrderByDesc(path, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_addOrderByDesc(String path, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__addOrderByDesc_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __addOrderByDesc_name, __cb);
        try
        {
            __result.__prepare(__addOrderByDesc_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(path);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_addOrderByDesc(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __addOrderByDesc_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     **/
    public boolean addOrderByDesc_async(AMI_Search_addOrderByDesc __cb, String path)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addOrderByDesc_name);
            __r = begin_addOrderByDesc(path, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addOrderByDesc_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * A path from the target entity which will be added to the
     * current stack of order statements applied to the query.
     * 
     * @param __cb The callback object for the operation.
     * @param path Non-null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean addOrderByDesc_async(AMI_Search_addOrderByDesc __cb, String path, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__addOrderByDesc_name);
            __r = begin_addOrderByDesc(path, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __addOrderByDesc_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __allTypes_name = "allTypes";

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     **/
    public void allTypes()
        throws omero.ServerError
    {
        allTypes(null, false);
    }

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void allTypes(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        allTypes(__ctx, true);
    }

    private void allTypes(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "allTypes", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("allTypes");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.allTypes(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_allTypes()
    {
        return begin_allTypes(null, false, null);
    }

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_allTypes(java.util.Map<String, String> __ctx)
    {
        return begin_allTypes(__ctx, true, null);
    }

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_allTypes(Ice.Callback __cb)
    {
        return begin_allTypes(null, false, __cb);
    }

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_allTypes(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_allTypes(__ctx, true, __cb);
    }

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_allTypes(Callback_Search_allTypes __cb)
    {
        return begin_allTypes(null, false, __cb);
    }

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_allTypes(java.util.Map<String, String> __ctx, Callback_Search_allTypes __cb)
    {
        return begin_allTypes(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_allTypes(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__allTypes_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __allTypes_name, __cb);
        try
        {
            __result.__prepare(__allTypes_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_allTypes(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __allTypes_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __cb The callback object for the operation.
     **/
    public boolean allTypes_async(AMI_Search_allTypes __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__allTypes_name);
            __r = begin_allTypes(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __allTypes_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Permits all types to be returned. For some types of
     * queries, this carries a performance penalty as every
     * database table must be hit.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean allTypes_async(AMI_Search_allTypes __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__allTypes_name);
            __r = begin_allTypes(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __allTypes_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __and_name = "and";

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     **/
    public void and()
        throws omero.ServerError
    {
        and(null, false);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __ctx The Context map to send with the invocation.
     **/
    public void and(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        and(__ctx, true);
    }

    private void and(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "and", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("and");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.and(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_and()
    {
        return begin_and(null, false, null);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_and(java.util.Map<String, String> __ctx)
    {
        return begin_and(__ctx, true, null);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_and(Ice.Callback __cb)
    {
        return begin_and(null, false, __cb);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_and(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_and(__ctx, true, __cb);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_and(Callback_Search_and __cb)
    {
        return begin_and(null, false, __cb);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_and(java.util.Map<String, String> __ctx, Callback_Search_and __cb)
    {
        return begin_and(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_and(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__and_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __and_name, __cb);
        try
        {
            __result.__prepare(__and_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_and(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __and_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __cb The callback object for the operation.
     **/
    public boolean and_async(AMI_Search_and __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__and_name);
            __r = begin_and(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __and_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.intersection();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return only the Images with TagAnnotations.
     * 
     * <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.</p>
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean and_async(AMI_Search_and __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__and_name);
            __r = begin_and(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __and_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __byAnnotatedWith_name = "byAnnotatedWith";

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param examples Not empty.
     **/
    public void byAnnotatedWith(java.util.List<omero.model.Annotation> examples)
        throws omero.ServerError
    {
        byAnnotatedWith(examples, null, false);
    }

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param examples Not empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void byAnnotatedWith(java.util.List<omero.model.Annotation> examples, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        byAnnotatedWith(examples, __ctx, true);
    }

    private void byAnnotatedWith(java.util.List<omero.model.Annotation> examples, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "byAnnotatedWith", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("byAnnotatedWith");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.byAnnotatedWith(examples, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param examples Not empty.
     **/
    public Ice.AsyncResult begin_byAnnotatedWith(java.util.List<omero.model.Annotation> examples)
    {
        return begin_byAnnotatedWith(examples, null, false, null);
    }

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param examples Not empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_byAnnotatedWith(java.util.List<omero.model.Annotation> examples, java.util.Map<String, String> __ctx)
    {
        return begin_byAnnotatedWith(examples, __ctx, true, null);
    }

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param examples Not empty.
     **/
    public Ice.AsyncResult begin_byAnnotatedWith(java.util.List<omero.model.Annotation> examples, Ice.Callback __cb)
    {
        return begin_byAnnotatedWith(examples, null, false, __cb);
    }

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param examples Not empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_byAnnotatedWith(java.util.List<omero.model.Annotation> examples, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_byAnnotatedWith(examples, __ctx, true, __cb);
    }

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param examples Not empty.
     **/
    public Ice.AsyncResult begin_byAnnotatedWith(java.util.List<omero.model.Annotation> examples, Callback_Search_byAnnotatedWith __cb)
    {
        return begin_byAnnotatedWith(examples, null, false, __cb);
    }

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param examples Not empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_byAnnotatedWith(java.util.List<omero.model.Annotation> examples, java.util.Map<String, String> __ctx, Callback_Search_byAnnotatedWith __cb)
    {
        return begin_byAnnotatedWith(examples, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_byAnnotatedWith(java.util.List<omero.model.Annotation> examples, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__byAnnotatedWith_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __byAnnotatedWith_name, __cb);
        try
        {
            __result.__prepare(__byAnnotatedWith_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            AnnotationListHelper.write(__os, examples);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_byAnnotatedWith(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __byAnnotatedWith_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param examples Not empty.
     **/
    public boolean byAnnotatedWith_async(AMI_Search_byAnnotatedWith __cb, java.util.List<omero.model.Annotation> examples)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__byAnnotatedWith_name);
            __r = begin_byAnnotatedWith(examples, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __byAnnotatedWith_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Finds entities annotated with an
     * {@link omero.model.Annotation} similar to the example. This
     * does not use Hibernate's
     * {@link omero.api.IQuery#findByExample} Query-By-Example}
     * mechanism, since that cannot handle joins. The fields which
     * are used are:
     * <ul>
     * <li>the main content of the annotation : String,
     * {@link omero.model.OriginalFile#getId}, etc.</li>
     * </ul>
     * 
     * If the main content is <code>null</code> it is assumed to
     * be a wildcard searched, and only the type of the annotation
     * is searched. Currently, ListAnnotations are not supported.
     * 
     * 
     * @param __cb The callback object for the operation.
     * @param examples Not empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean byAnnotatedWith_async(AMI_Search_byAnnotatedWith __cb, java.util.List<omero.model.Annotation> examples, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__byAnnotatedWith_name);
            __r = begin_byAnnotatedWith(examples, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __byAnnotatedWith_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __byFullText_name = "byFullText";

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param query May not be null or of zero length.
     **/
    public void byFullText(String query)
        throws omero.ServerError
    {
        byFullText(query, null, false);
    }

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void byFullText(String query, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        byFullText(query, __ctx, true);
    }

    private void byFullText(String query, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "byFullText", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("byFullText");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.byFullText(query, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param query May not be null or of zero length.
     **/
    public Ice.AsyncResult begin_byFullText(String query)
    {
        return begin_byFullText(query, null, false, null);
    }

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_byFullText(String query, java.util.Map<String, String> __ctx)
    {
        return begin_byFullText(query, __ctx, true, null);
    }

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param query May not be null or of zero length.
     **/
    public Ice.AsyncResult begin_byFullText(String query, Ice.Callback __cb)
    {
        return begin_byFullText(query, null, false, __cb);
    }

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_byFullText(String query, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_byFullText(query, __ctx, true, __cb);
    }

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param query May not be null or of zero length.
     **/
    public Ice.AsyncResult begin_byFullText(String query, Callback_Search_byFullText __cb)
    {
        return begin_byFullText(query, null, false, __cb);
    }

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_byFullText(String query, java.util.Map<String, String> __ctx, Callback_Search_byFullText __cb)
    {
        return begin_byFullText(query, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_byFullText(String query, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__byFullText_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __byFullText_name, __cb);
        try
        {
            __result.__prepare(__byFullText_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(query);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_byFullText(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __byFullText_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param query May not be null or of zero length.
     **/
    public boolean byFullText_async(AMI_Search_byFullText __cb, String query)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__byFullText_name);
            __r = begin_byFullText(query, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __byFullText_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Passes the query as is to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean byFullText_async(AMI_Search_byFullText __cb, String query, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__byFullText_name);
            __r = begin_byFullText(query, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __byFullText_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __byGroupForTags_name = "byGroupForTags";

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param group Can be null or empty to return all tags.
     **/
    public void byGroupForTags(String group)
        throws omero.ServerError
    {
        byGroupForTags(group, null, false);
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param group Can be null or empty to return all tags.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void byGroupForTags(String group, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        byGroupForTags(group, __ctx, true);
    }

    private void byGroupForTags(String group, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "byGroupForTags", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("byGroupForTags");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.byGroupForTags(group, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param group Can be null or empty to return all tags.
     **/
    public Ice.AsyncResult begin_byGroupForTags(String group)
    {
        return begin_byGroupForTags(group, null, false, null);
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param group Can be null or empty to return all tags.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_byGroupForTags(String group, java.util.Map<String, String> __ctx)
    {
        return begin_byGroupForTags(group, __ctx, true, null);
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param group Can be null or empty to return all tags.
     **/
    public Ice.AsyncResult begin_byGroupForTags(String group, Ice.Callback __cb)
    {
        return begin_byGroupForTags(group, null, false, __cb);
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param group Can be null or empty to return all tags.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_byGroupForTags(String group, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_byGroupForTags(group, __ctx, true, __cb);
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param group Can be null or empty to return all tags.
     **/
    public Ice.AsyncResult begin_byGroupForTags(String group, Callback_Search_byGroupForTags __cb)
    {
        return begin_byGroupForTags(group, null, false, __cb);
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param group Can be null or empty to return all tags.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_byGroupForTags(String group, java.util.Map<String, String> __ctx, Callback_Search_byGroupForTags __cb)
    {
        return begin_byGroupForTags(group, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_byGroupForTags(String group, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__byGroupForTags_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __byGroupForTags_name, __cb);
        try
        {
            __result.__prepare(__byGroupForTags_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(group);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_byGroupForTags(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __byGroupForTags_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param group Can be null or empty to return all tags.
     **/
    public boolean byGroupForTags_async(AMI_Search_byGroupForTags __cb, String group)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__byGroupForTags_name);
            __r = begin_byGroupForTags(group, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __byGroupForTags_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TagAnnotation} instances which
     * represent all the
     * {@link omero.model.TagAnnotation} tags in the given group.
     * The entities are transient and without ownership since
     * multiple users can own the same tag. This method will
     * override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param group Can be null or empty to return all tags.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean byGroupForTags_async(AMI_Search_byGroupForTags __cb, String group, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__byGroupForTags_name);
            __r = begin_byGroupForTags(group, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __byGroupForTags_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __byHqlQuery_name = "byHqlQuery";

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param query Not null.
     * @param p May be null. Defaults are then in effect.
     * @see omero.api.IQuery#findAllByQuery
     **/
    public void byHqlQuery(String query, omero.sys.Parameters params)
        throws omero.ServerError
    {
        byHqlQuery(query, params, null, false);
    }

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param query Not null.
     * @param p May be null. Defaults are then in effect.
     * @see omero.api.IQuery#findAllByQuery
     * @param __ctx The Context map to send with the invocation.
     **/
    public void byHqlQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        byHqlQuery(query, params, __ctx, true);
    }

    private void byHqlQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "byHqlQuery", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("byHqlQuery");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.byHqlQuery(query, params, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param __cb The callback object for the operation.
     * @param query Not null.
     **/
    public Ice.AsyncResult begin_byHqlQuery(String query, omero.sys.Parameters params)
    {
        return begin_byHqlQuery(query, params, null, false, null);
    }

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param __cb The callback object for the operation.
     * @param query Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_byHqlQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
    {
        return begin_byHqlQuery(query, params, __ctx, true, null);
    }

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param __cb The callback object for the operation.
     * @param query Not null.
     **/
    public Ice.AsyncResult begin_byHqlQuery(String query, omero.sys.Parameters params, Ice.Callback __cb)
    {
        return begin_byHqlQuery(query, params, null, false, __cb);
    }

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param __cb The callback object for the operation.
     * @param query Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_byHqlQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_byHqlQuery(query, params, __ctx, true, __cb);
    }

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param __cb The callback object for the operation.
     * @param query Not null.
     **/
    public Ice.AsyncResult begin_byHqlQuery(String query, omero.sys.Parameters params, Callback_Search_byHqlQuery __cb)
    {
        return begin_byHqlQuery(query, params, null, false, __cb);
    }

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param __cb The callback object for the operation.
     * @param query Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_byHqlQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, Callback_Search_byHqlQuery __cb)
    {
        return begin_byHqlQuery(query, params, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_byHqlQuery(String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__byHqlQuery_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __byHqlQuery_name, __cb);
        try
        {
            __result.__prepare(__byHqlQuery_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(query);
            __os.writeObject(params);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_byHqlQuery(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __byHqlQuery_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param __cb The callback object for the operation.
     * @param query Not null.
     **/
    public boolean byHqlQuery_async(AMI_Search_byHqlQuery __cb, String query, omero.sys.Parameters params)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__byHqlQuery_name);
            __r = begin_byHqlQuery(query, params, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __byHqlQuery_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Delegates to {@link omero.api.IQuery#findAllByQuery} method
     * to take advantage of the {@link #and}, {@link #or}, and
     * {@link #not} methods, or queue-semantics.
     * 
     * @param __cb The callback object for the operation.
     * @param query Not null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean byHqlQuery_async(AMI_Search_byHqlQuery __cb, String query, omero.sys.Parameters params, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__byHqlQuery_name);
            __r = begin_byHqlQuery(query, params, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __byHqlQuery_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __byLuceneQueryBuilder_name = "byLuceneQueryBuilder";

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     **/
    public void byLuceneQueryBuilder(String fields, String from, String to, String dateType, String query)
        throws omero.ServerError
    {
        byLuceneQueryBuilder(fields, from, to, dateType, query, null, false);
    }

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void byLuceneQueryBuilder(String fields, String from, String to, String dateType, String query, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        byLuceneQueryBuilder(fields, from, to, dateType, query, __ctx, true);
    }

    private void byLuceneQueryBuilder(String fields, String from, String to, String dateType, String query, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "byLuceneQueryBuilder", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("byLuceneQueryBuilder");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.byLuceneQueryBuilder(fields, from, to, dateType, query, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     **/
    public Ice.AsyncResult begin_byLuceneQueryBuilder(String fields, String from, String to, String dateType, String query)
    {
        return begin_byLuceneQueryBuilder(fields, from, to, dateType, query, null, false, null);
    }

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_byLuceneQueryBuilder(String fields, String from, String to, String dateType, String query, java.util.Map<String, String> __ctx)
    {
        return begin_byLuceneQueryBuilder(fields, from, to, dateType, query, __ctx, true, null);
    }

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     **/
    public Ice.AsyncResult begin_byLuceneQueryBuilder(String fields, String from, String to, String dateType, String query, Ice.Callback __cb)
    {
        return begin_byLuceneQueryBuilder(fields, from, to, dateType, query, null, false, __cb);
    }

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_byLuceneQueryBuilder(String fields, String from, String to, String dateType, String query, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_byLuceneQueryBuilder(fields, from, to, dateType, query, __ctx, true, __cb);
    }

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     **/
    public Ice.AsyncResult begin_byLuceneQueryBuilder(String fields, String from, String to, String dateType, String query, Callback_Search_byLuceneQueryBuilder __cb)
    {
        return begin_byLuceneQueryBuilder(fields, from, to, dateType, query, null, false, __cb);
    }

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_byLuceneQueryBuilder(String fields, String from, String to, String dateType, String query, java.util.Map<String, String> __ctx, Callback_Search_byLuceneQueryBuilder __cb)
    {
        return begin_byLuceneQueryBuilder(fields, from, to, dateType, query, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_byLuceneQueryBuilder(String fields, String from, String to, String dateType, String query, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__byLuceneQueryBuilder_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __byLuceneQueryBuilder_name, __cb);
        try
        {
            __result.__prepare(__byLuceneQueryBuilder_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(fields);
            __os.writeString(from);
            __os.writeString(to);
            __os.writeString(dateType);
            __os.writeString(query);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_byLuceneQueryBuilder(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __byLuceneQueryBuilder_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     **/
    public boolean byLuceneQueryBuilder_async(AMI_Search_byLuceneQueryBuilder __cb, String fields, String from, String to, String dateType, String query)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__byLuceneQueryBuilder_name);
            __r = begin_byLuceneQueryBuilder(fields, from, to, dateType, query, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __byLuceneQueryBuilder_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Builds a Lucene query and passes it to the Lucene backend.
     * 
     * @param __cb The callback object for the operation.
     * @param fields   The fields (comma separated) to search in
     * (name, description, ...)
     * @param from     The date range from, in the form YYYYMMDD
     * (may be null)
     * @param to       The date range to (inclusive), in the form
     * YYYYMMDD (may be null)
     * @param dateType {@link #DATE_TYPE_ACQUISITION} or
     * {@link #DATE_TYPE_IMPORT}
     * @param query May not be null or of zero length.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean byLuceneQueryBuilder_async(AMI_Search_byLuceneQueryBuilder __cb, String fields, String from, String to, String dateType, String query, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__byLuceneQueryBuilder_name);
            __r = begin_byLuceneQueryBuilder(fields, from, to, dateType, query, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __byLuceneQueryBuilder_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __bySimilarTerms_name = "bySimilarTerms";

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param terms Cannot be empty.
     **/
    public void bySimilarTerms(java.util.List<String> terms)
        throws omero.ServerError
    {
        bySimilarTerms(terms, null, false);
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param terms Cannot be empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void bySimilarTerms(java.util.List<String> terms, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        bySimilarTerms(terms, __ctx, true);
    }

    private void bySimilarTerms(java.util.List<String> terms, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "bySimilarTerms", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("bySimilarTerms");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.bySimilarTerms(terms, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param __cb The callback object for the operation.
     * @param terms Cannot be empty.
     **/
    public Ice.AsyncResult begin_bySimilarTerms(java.util.List<String> terms)
    {
        return begin_bySimilarTerms(terms, null, false, null);
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param __cb The callback object for the operation.
     * @param terms Cannot be empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_bySimilarTerms(java.util.List<String> terms, java.util.Map<String, String> __ctx)
    {
        return begin_bySimilarTerms(terms, __ctx, true, null);
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param __cb The callback object for the operation.
     * @param terms Cannot be empty.
     **/
    public Ice.AsyncResult begin_bySimilarTerms(java.util.List<String> terms, Ice.Callback __cb)
    {
        return begin_bySimilarTerms(terms, null, false, __cb);
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param __cb The callback object for the operation.
     * @param terms Cannot be empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_bySimilarTerms(java.util.List<String> terms, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_bySimilarTerms(terms, __ctx, true, __cb);
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param __cb The callback object for the operation.
     * @param terms Cannot be empty.
     **/
    public Ice.AsyncResult begin_bySimilarTerms(java.util.List<String> terms, Callback_Search_bySimilarTerms __cb)
    {
        return begin_bySimilarTerms(terms, null, false, __cb);
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param __cb The callback object for the operation.
     * @param terms Cannot be empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_bySimilarTerms(java.util.List<String> terms, java.util.Map<String, String> __ctx, Callback_Search_bySimilarTerms __cb)
    {
        return begin_bySimilarTerms(terms, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_bySimilarTerms(java.util.List<String> terms, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__bySimilarTerms_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __bySimilarTerms_name, __cb);
        try
        {
            __result.__prepare(__bySimilarTerms_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            StringSetHelper.write(__os, terms);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_bySimilarTerms(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __bySimilarTerms_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param __cb The callback object for the operation.
     * @param terms Cannot be empty.
     **/
    public boolean bySimilarTerms_async(AMI_Search_bySimilarTerms __cb, java.util.List<String> terms)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__bySimilarTerms_name);
            __r = begin_bySimilarTerms(terms, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __bySimilarTerms_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns transient (without ID)
     * {@link omero.model.TextAnnotation} instances which represent
     * terms which are similar to the given terms. For example, if
     * the argument is <i>cell</i>, one return value might have as
     * its textValue: <i>cellular</i> while another has
     * <i>cellularize</i>.
     * 
     * No filtering or fetching is performed.
     * 
     * @param __cb The callback object for the operation.
     * @param terms Cannot be empty.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean bySimilarTerms_async(AMI_Search_bySimilarTerms __cb, java.util.List<String> terms, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__bySimilarTerms_name);
            __r = begin_bySimilarTerms(terms, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __bySimilarTerms_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __bySomeMustNone_name = "bySomeMustNone";

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     **/
    public void bySomeMustNone(java.util.List<String> some, java.util.List<String> must, java.util.List<String> none)
        throws omero.ServerError
    {
        bySomeMustNone(some, must, none, null, false);
    }

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void bySomeMustNone(java.util.List<String> some, java.util.List<String> must, java.util.List<String> none, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        bySomeMustNone(some, must, none, __ctx, true);
    }

    private void bySomeMustNone(java.util.List<String> some, java.util.List<String> must, java.util.List<String> none, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "bySomeMustNone", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("bySomeMustNone");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.bySomeMustNone(some, must, none, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param __cb The callback object for the operation.
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     **/
    public Ice.AsyncResult begin_bySomeMustNone(java.util.List<String> some, java.util.List<String> must, java.util.List<String> none)
    {
        return begin_bySomeMustNone(some, must, none, null, false, null);
    }

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param __cb The callback object for the operation.
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_bySomeMustNone(java.util.List<String> some, java.util.List<String> must, java.util.List<String> none, java.util.Map<String, String> __ctx)
    {
        return begin_bySomeMustNone(some, must, none, __ctx, true, null);
    }

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param __cb The callback object for the operation.
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     **/
    public Ice.AsyncResult begin_bySomeMustNone(java.util.List<String> some, java.util.List<String> must, java.util.List<String> none, Ice.Callback __cb)
    {
        return begin_bySomeMustNone(some, must, none, null, false, __cb);
    }

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param __cb The callback object for the operation.
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_bySomeMustNone(java.util.List<String> some, java.util.List<String> must, java.util.List<String> none, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_bySomeMustNone(some, must, none, __ctx, true, __cb);
    }

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param __cb The callback object for the operation.
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     **/
    public Ice.AsyncResult begin_bySomeMustNone(java.util.List<String> some, java.util.List<String> must, java.util.List<String> none, Callback_Search_bySomeMustNone __cb)
    {
        return begin_bySomeMustNone(some, must, none, null, false, __cb);
    }

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param __cb The callback object for the operation.
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_bySomeMustNone(java.util.List<String> some, java.util.List<String> must, java.util.List<String> none, java.util.Map<String, String> __ctx, Callback_Search_bySomeMustNone __cb)
    {
        return begin_bySomeMustNone(some, must, none, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_bySomeMustNone(java.util.List<String> some, java.util.List<String> must, java.util.List<String> none, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__bySomeMustNone_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __bySomeMustNone_name, __cb);
        try
        {
            __result.__prepare(__bySomeMustNone_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            StringSetHelper.write(__os, some);
            StringSetHelper.write(__os, must);
            StringSetHelper.write(__os, none);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_bySomeMustNone(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __bySomeMustNone_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param __cb The callback object for the operation.
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     **/
    public boolean bySomeMustNone_async(AMI_Search_bySomeMustNone __cb, java.util.List<String> some, java.util.List<String> must, java.util.List<String> none)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__bySomeMustNone_name);
            __r = begin_bySomeMustNone(some, must, none, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __bySomeMustNone_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Builds a Lucene query and passes it to {@link #byFullText}.
     * 
     * @param __cb The callback object for the operation.
     * @param some Some (at least one) of these terms must be
     * present in the document. May be null.
     * @param must All of these terms must be present in the
     * document. May be null.
     * @param none None of these terms may be present in the
     * document. May be null.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean bySomeMustNone_async(AMI_Search_bySomeMustNone __cb, java.util.List<String> some, java.util.List<String> must, java.util.List<String> none, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__bySomeMustNone_name);
            __r = begin_bySomeMustNone(some, must, none, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __bySomeMustNone_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __byTagForGroups_name = "byTagForGroups";

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param tag Can be null or empty to return all groups.
     **/
    public void byTagForGroups(String tag)
        throws omero.ServerError
    {
        byTagForGroups(tag, null, false);
    }

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param tag Can be null or empty to return all groups.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void byTagForGroups(String tag, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        byTagForGroups(tag, __ctx, true);
    }

    private void byTagForGroups(String tag, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "byTagForGroups", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("byTagForGroups");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.byTagForGroups(tag, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param tag Can be null or empty to return all groups.
     **/
    public Ice.AsyncResult begin_byTagForGroups(String tag)
    {
        return begin_byTagForGroups(tag, null, false, null);
    }

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param tag Can be null or empty to return all groups.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_byTagForGroups(String tag, java.util.Map<String, String> __ctx)
    {
        return begin_byTagForGroups(tag, __ctx, true, null);
    }

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param tag Can be null or empty to return all groups.
     **/
    public Ice.AsyncResult begin_byTagForGroups(String tag, Ice.Callback __cb)
    {
        return begin_byTagForGroups(tag, null, false, __cb);
    }

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param tag Can be null or empty to return all groups.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_byTagForGroups(String tag, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_byTagForGroups(tag, __ctx, true, __cb);
    }

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param tag Can be null or empty to return all groups.
     **/
    public Ice.AsyncResult begin_byTagForGroups(String tag, Callback_Search_byTagForGroups __cb)
    {
        return begin_byTagForGroups(tag, null, false, __cb);
    }

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param tag Can be null or empty to return all groups.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_byTagForGroups(String tag, java.util.Map<String, String> __ctx, Callback_Search_byTagForGroups __cb)
    {
        return begin_byTagForGroups(tag, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_byTagForGroups(String tag, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__byTagForGroups_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __byTagForGroups_name, __cb);
        try
        {
            __result.__prepare(__byTagForGroups_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(tag);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_byTagForGroups(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __byTagForGroups_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param tag Can be null or empty to return all groups.
     **/
    public boolean byTagForGroups_async(AMI_Search_byTagForGroups __cb, String tag)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__byTagForGroups_name);
            __r = begin_byTagForGroups(tag, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __byTagForGroups_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Creates a query which will return transient (without ID)
     * {@link omero.model.TagAnnotation} instances which represent
     * all the {@link omero.model.TagAnnotation} tag groups which
     * the given tag belongs to. The entities are transient and
     * without ownership since multiple users can own the same tag
     * group. This method will override settings for types.
     * 
     * @param __cb The callback object for the operation.
     * @param tag Can be null or empty to return all groups.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean byTagForGroups_async(AMI_Search_byTagForGroups __cb, String tag, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__byTagForGroups_name);
            __r = begin_byTagForGroups(tag, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __byTagForGroups_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __clearQueries_name = "clearQueries";

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     **/
    public void clearQueries()
        throws omero.ServerError
    {
        clearQueries(null, false);
    }

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void clearQueries(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        clearQueries(__ctx, true);
    }

    private void clearQueries(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "clearQueries", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("clearQueries");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.clearQueries(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_clearQueries()
    {
        return begin_clearQueries(null, false, null);
    }

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_clearQueries(java.util.Map<String, String> __ctx)
    {
        return begin_clearQueries(__ctx, true, null);
    }

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_clearQueries(Ice.Callback __cb)
    {
        return begin_clearQueries(null, false, __cb);
    }

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_clearQueries(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_clearQueries(__ctx, true, __cb);
    }

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_clearQueries(Callback_Search_clearQueries __cb)
    {
        return begin_clearQueries(null, false, __cb);
    }

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_clearQueries(java.util.Map<String, String> __ctx, Callback_Search_clearQueries __cb)
    {
        return begin_clearQueries(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_clearQueries(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__clearQueries_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __clearQueries_name, __cb);
        try
        {
            __result.__prepare(__clearQueries_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_clearQueries(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __clearQueries_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __cb The callback object for the operation.
     **/
    public boolean clearQueries_async(AMI_Search_clearQueries __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__clearQueries_name);
            __r = begin_clearQueries(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __clearQueries_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Removes all active queries (leaving {@link #resetDefaults}
     * settings alone), such that {@link #activeQueries} will
     * return 0.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean clearQueries_async(AMI_Search_clearQueries __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__clearQueries_name);
            __r = begin_clearQueries(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __clearQueries_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __currentMetadata_name = "currentMetadata";

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     **/
    public java.util.Map<java.lang.String, omero.model.Annotation> currentMetadata()
        throws omero.ServerError
    {
        return currentMetadata(null, false);
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.Map<java.lang.String, omero.model.Annotation> currentMetadata(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return currentMetadata(__ctx, true);
    }

    private java.util.Map<java.lang.String, omero.model.Annotation> currentMetadata(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "currentMetadata", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("currentMetadata");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    return __del.currentMetadata(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_currentMetadata()
    {
        return begin_currentMetadata(null, false, null);
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_currentMetadata(java.util.Map<String, String> __ctx)
    {
        return begin_currentMetadata(__ctx, true, null);
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_currentMetadata(Ice.Callback __cb)
    {
        return begin_currentMetadata(null, false, __cb);
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_currentMetadata(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_currentMetadata(__ctx, true, __cb);
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_currentMetadata(Callback_Search_currentMetadata __cb)
    {
        return begin_currentMetadata(null, false, __cb);
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_currentMetadata(java.util.Map<String, String> __ctx, Callback_Search_currentMetadata __cb)
    {
        return begin_currentMetadata(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_currentMetadata(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__currentMetadata_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __currentMetadata_name, __cb);
        try
        {
            __result.__prepare(__currentMetadata_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.Map<java.lang.String, omero.model.Annotation> end_currentMetadata(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __currentMetadata_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.String, omero.model.Annotation> __ret;
            __ret = SearchMetadataHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __cb The callback object for the operation.
     **/
    public boolean currentMetadata_async(AMI_Search_currentMetadata __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__currentMetadata_name);
            __r = begin_currentMetadata(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __currentMetadata_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #next}. This method may only be called once for any
     * given call to {@link #next}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean currentMetadata_async(AMI_Search_currentMetadata __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__currentMetadata_name);
            __r = begin_currentMetadata(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __currentMetadata_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __currentMetadataList_name = "currentMetadataList";

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     **/
    public java.util.List<java.util.Map<java.lang.String, omero.model.Annotation>> currentMetadataList()
        throws omero.ServerError
    {
        return currentMetadataList(null, false);
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<java.util.Map<java.lang.String, omero.model.Annotation>> currentMetadataList(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return currentMetadataList(__ctx, true);
    }

    private java.util.List<java.util.Map<java.lang.String, omero.model.Annotation>> currentMetadataList(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "currentMetadataList", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("currentMetadataList");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    return __del.currentMetadataList(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_currentMetadataList()
    {
        return begin_currentMetadataList(null, false, null);
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_currentMetadataList(java.util.Map<String, String> __ctx)
    {
        return begin_currentMetadataList(__ctx, true, null);
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_currentMetadataList(Ice.Callback __cb)
    {
        return begin_currentMetadataList(null, false, __cb);
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_currentMetadataList(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_currentMetadataList(__ctx, true, __cb);
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_currentMetadataList(Callback_Search_currentMetadataList __cb)
    {
        return begin_currentMetadataList(null, false, __cb);
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_currentMetadataList(java.util.Map<String, String> __ctx, Callback_Search_currentMetadataList __cb)
    {
        return begin_currentMetadataList(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_currentMetadataList(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__currentMetadataList_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __currentMetadataList_name, __cb);
        try
        {
            __result.__prepare(__currentMetadataList_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.List<java.util.Map<java.lang.String, omero.model.Annotation>> end_currentMetadataList(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __currentMetadataList_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<java.util.Map<java.lang.String, omero.model.Annotation>> __ret;
            __ret = SearchMetadataListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __cb The callback object for the operation.
     **/
    public boolean currentMetadataList_async(AMI_Search_currentMetadataList __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__currentMetadataList_name);
            __r = begin_currentMetadataList(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __currentMetadataList_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Provides access to the extra query information (for example
     * Lucene score and boost values) for a single call to
     * {@link #results}. This method may only be called once for
     * any given call to {@link #results}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean currentMetadataList_async(AMI_Search_currentMetadataList __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__currentMetadataList_name);
            __r = begin_currentMetadataList(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __currentMetadataList_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __fetchAlso_name = "fetchAlso";

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     **/
    public void fetchAlso(java.util.List<String> fetches)
        throws omero.ServerError
    {
        fetchAlso(fetches, null, false);
    }

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void fetchAlso(java.util.List<String> fetches, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        fetchAlso(fetches, __ctx, true);
    }

    private void fetchAlso(java.util.List<String> fetches, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "fetchAlso", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("fetchAlso");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.fetchAlso(fetches, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param __cb The callback object for the operation.
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     **/
    public Ice.AsyncResult begin_fetchAlso(java.util.List<String> fetches)
    {
        return begin_fetchAlso(fetches, null, false, null);
    }

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param __cb The callback object for the operation.
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_fetchAlso(java.util.List<String> fetches, java.util.Map<String, String> __ctx)
    {
        return begin_fetchAlso(fetches, __ctx, true, null);
    }

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param __cb The callback object for the operation.
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     **/
    public Ice.AsyncResult begin_fetchAlso(java.util.List<String> fetches, Ice.Callback __cb)
    {
        return begin_fetchAlso(fetches, null, false, __cb);
    }

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param __cb The callback object for the operation.
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_fetchAlso(java.util.List<String> fetches, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_fetchAlso(fetches, __ctx, true, __cb);
    }

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param __cb The callback object for the operation.
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     **/
    public Ice.AsyncResult begin_fetchAlso(java.util.List<String> fetches, Callback_Search_fetchAlso __cb)
    {
        return begin_fetchAlso(fetches, null, false, __cb);
    }

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param __cb The callback object for the operation.
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_fetchAlso(java.util.List<String> fetches, java.util.Map<String, String> __ctx, Callback_Search_fetchAlso __cb)
    {
        return begin_fetchAlso(fetches, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_fetchAlso(java.util.List<String> fetches, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__fetchAlso_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __fetchAlso_name, __cb);
        try
        {
            __result.__prepare(__fetchAlso_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            StringSetHelper.write(__os, fetches);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_fetchAlso(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __fetchAlso_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param __cb The callback object for the operation.
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     **/
    public boolean fetchAlso_async(AMI_Search_fetchAlso __cb, java.util.List<String> fetches)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__fetchAlso_name);
            __r = begin_fetchAlso(fetches, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __fetchAlso_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Adds a fetch clause for loading non-annotation fields of
     * returned entities. Each fetch is a hibernate clause in dot
     * notation.
     * 
     * @param __cb The callback object for the operation.
     * @param fetches Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean fetchAlso_async(AMI_Search_fetchAlso __cb, java.util.List<String> fetches, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__fetchAlso_name);
            __r = begin_fetchAlso(fetches, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __fetchAlso_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __fetchAnnotations_name = "fetchAnnotations";

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param classes Can be empty, which removes previous fetch
     * setting.
     **/
    public void fetchAnnotations(java.util.List<String> classes)
        throws omero.ServerError
    {
        fetchAnnotations(classes, null, false);
    }

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param classes Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void fetchAnnotations(java.util.List<String> classes, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        fetchAnnotations(classes, __ctx, true);
    }

    private void fetchAnnotations(java.util.List<String> classes, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "fetchAnnotations", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("fetchAnnotations");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.fetchAnnotations(classes, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, which removes previous fetch
     * setting.
     **/
    public Ice.AsyncResult begin_fetchAnnotations(java.util.List<String> classes)
    {
        return begin_fetchAnnotations(classes, null, false, null);
    }

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_fetchAnnotations(java.util.List<String> classes, java.util.Map<String, String> __ctx)
    {
        return begin_fetchAnnotations(classes, __ctx, true, null);
    }

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, which removes previous fetch
     * setting.
     **/
    public Ice.AsyncResult begin_fetchAnnotations(java.util.List<String> classes, Ice.Callback __cb)
    {
        return begin_fetchAnnotations(classes, null, false, __cb);
    }

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_fetchAnnotations(java.util.List<String> classes, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_fetchAnnotations(classes, __ctx, true, __cb);
    }

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, which removes previous fetch
     * setting.
     **/
    public Ice.AsyncResult begin_fetchAnnotations(java.util.List<String> classes, Callback_Search_fetchAnnotations __cb)
    {
        return begin_fetchAnnotations(classes, null, false, __cb);
    }

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_fetchAnnotations(java.util.List<String> classes, java.util.Map<String, String> __ctx, Callback_Search_fetchAnnotations __cb)
    {
        return begin_fetchAnnotations(classes, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_fetchAnnotations(java.util.List<String> classes, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__fetchAnnotations_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __fetchAnnotations_name, __cb);
        try
        {
            __result.__prepare(__fetchAnnotations_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            StringSetHelper.write(__os, classes);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_fetchAnnotations(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __fetchAnnotations_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, which removes previous fetch
     * setting.
     **/
    public boolean fetchAnnotations_async(AMI_Search_fetchAnnotations __cb, java.util.List<String> classes)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__fetchAnnotations_name);
            __r = begin_fetchAnnotations(classes, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __fetchAnnotations_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Queries the database for all {@link omero.model.Annotation}
     * annotations of the given types for all returned instances.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, which removes previous fetch
     * setting.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean fetchAnnotations_async(AMI_Search_fetchAnnotations __cb, java.util.List<String> classes, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__fetchAnnotations_name);
            __r = begin_fetchAnnotations(classes, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __fetchAnnotations_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getBatchSize_name = "getBatchSize";

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @return maximum number of results per call to
     * {@link #results}
     **/
    public int getBatchSize()
        throws omero.ServerError
    {
        return getBatchSize(null, false);
    }

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return maximum number of results per call to
     * {@link #results}
     **/
    public int getBatchSize(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getBatchSize(__ctx, true);
    }

    private int getBatchSize(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getBatchSize", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getBatchSize");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    return __del.getBatchSize(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getBatchSize()
    {
        return begin_getBatchSize(null, false, null);
    }

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getBatchSize(java.util.Map<String, String> __ctx)
    {
        return begin_getBatchSize(__ctx, true, null);
    }

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getBatchSize(Ice.Callback __cb)
    {
        return begin_getBatchSize(null, false, __cb);
    }

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getBatchSize(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getBatchSize(__ctx, true, __cb);
    }

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getBatchSize(Callback_Search_getBatchSize __cb)
    {
        return begin_getBatchSize(null, false, __cb);
    }

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getBatchSize(java.util.Map<String, String> __ctx, Callback_Search_getBatchSize __cb)
    {
        return begin_getBatchSize(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getBatchSize(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getBatchSize_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getBatchSize_name, __cb);
        try
        {
            __result.__prepare(__getBatchSize_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) maximum number of results per call to
     * {@link #results}
     **/
    public int end_getBatchSize(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getBatchSize_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            int __ret;
            __ret = __is.readInt();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean getBatchSize_async(AMI_Search_getBatchSize __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getBatchSize_name);
            __r = begin_getBatchSize(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getBatchSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the current batch size. If {@link #setBatchSize}
     * has not been called, the default value will be in effect.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getBatchSize_async(AMI_Search_getBatchSize __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getBatchSize_name);
            __r = begin_getBatchSize(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getBatchSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __hasNext_name = "hasNext";

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     **/
    public boolean hasNext()
        throws omero.ServerError
    {
        return hasNext(null, false);
    }

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean hasNext(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return hasNext(__ctx, true);
    }

    private boolean hasNext(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "hasNext", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("hasNext");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    return __del.hasNext(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_hasNext()
    {
        return begin_hasNext(null, false, null);
    }

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_hasNext(java.util.Map<String, String> __ctx)
    {
        return begin_hasNext(__ctx, true, null);
    }

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_hasNext(Ice.Callback __cb)
    {
        return begin_hasNext(null, false, __cb);
    }

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_hasNext(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_hasNext(__ctx, true, __cb);
    }

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_hasNext(Callback_Search_hasNext __cb)
    {
        return begin_hasNext(null, false, __cb);
    }

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_hasNext(java.util.Map<String, String> __ctx, Callback_Search_hasNext __cb)
    {
        return begin_hasNext(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_hasNext(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__hasNext_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __hasNext_name, __cb);
        try
        {
            __result.__prepare(__hasNext_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_hasNext(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __hasNext_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __cb The callback object for the operation.
     **/
    public boolean hasNext_async(AMI_Search_hasNext __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__hasNext_name);
            __r = begin_hasNext(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __hasNext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns <code>true</code> if another call to
     * {@link #next} is valid. A call to {@link #next} may throw
     * an exception for another reason, however.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean hasNext_async(AMI_Search_hasNext __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__hasNext_name);
            __r = begin_hasNext(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __hasNext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __isAllowLeadingWildcard_name = "isAllowLeadingWildcard";

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     **/
    public boolean isAllowLeadingWildcard()
        throws omero.ServerError
    {
        return isAllowLeadingWildcard(null, false);
    }

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isAllowLeadingWildcard(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return isAllowLeadingWildcard(__ctx, true);
    }

    private boolean isAllowLeadingWildcard(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isAllowLeadingWildcard", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isAllowLeadingWildcard");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    return __del.isAllowLeadingWildcard(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isAllowLeadingWildcard()
    {
        return begin_isAllowLeadingWildcard(null, false, null);
    }

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isAllowLeadingWildcard(java.util.Map<String, String> __ctx)
    {
        return begin_isAllowLeadingWildcard(__ctx, true, null);
    }

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isAllowLeadingWildcard(Ice.Callback __cb)
    {
        return begin_isAllowLeadingWildcard(null, false, __cb);
    }

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isAllowLeadingWildcard(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isAllowLeadingWildcard(__ctx, true, __cb);
    }

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isAllowLeadingWildcard(Callback_Search_isAllowLeadingWildcard __cb)
    {
        return begin_isAllowLeadingWildcard(null, false, __cb);
    }

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isAllowLeadingWildcard(java.util.Map<String, String> __ctx, Callback_Search_isAllowLeadingWildcard __cb)
    {
        return begin_isAllowLeadingWildcard(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isAllowLeadingWildcard(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isAllowLeadingWildcard_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isAllowLeadingWildcard_name, __cb);
        try
        {
            __result.__prepare(__isAllowLeadingWildcard_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_isAllowLeadingWildcard(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __isAllowLeadingWildcard_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __cb The callback object for the operation.
     **/
    public boolean isAllowLeadingWildcard_async(AMI_Search_isAllowLeadingWildcard __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isAllowLeadingWildcard_name);
            __r = begin_isAllowLeadingWildcard(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isAllowLeadingWildcard_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the current leading-wildcard setting. If false,
     * {@link #byFullText} and {@link #bySomeMustNone} will throw
     * an {@link omero.ApiUsageException}, since leading-wildcard
     * searches are quite slow. Use
     * {@link #setAllowLeadingWildcard} in order to permit this
     * usage.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isAllowLeadingWildcard_async(AMI_Search_isAllowLeadingWildcard __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isAllowLeadingWildcard_name);
            __r = begin_isAllowLeadingWildcard(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isAllowLeadingWildcard_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __isCaseSensitive_name = "isCaseSensitive";

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     **/
    public boolean isCaseSensitive()
        throws omero.ServerError
    {
        return isCaseSensitive(null, false);
    }

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isCaseSensitive(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return isCaseSensitive(__ctx, true);
    }

    private boolean isCaseSensitive(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isCaseSensitive", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isCaseSensitive");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    return __del.isCaseSensitive(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isCaseSensitive()
    {
        return begin_isCaseSensitive(null, false, null);
    }

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isCaseSensitive(java.util.Map<String, String> __ctx)
    {
        return begin_isCaseSensitive(__ctx, true, null);
    }

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isCaseSensitive(Ice.Callback __cb)
    {
        return begin_isCaseSensitive(null, false, __cb);
    }

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isCaseSensitive(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isCaseSensitive(__ctx, true, __cb);
    }

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isCaseSensitive(Callback_Search_isCaseSensitive __cb)
    {
        return begin_isCaseSensitive(null, false, __cb);
    }

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isCaseSensitive(java.util.Map<String, String> __ctx, Callback_Search_isCaseSensitive __cb)
    {
        return begin_isCaseSensitive(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isCaseSensitive(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isCaseSensitive_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isCaseSensitive_name, __cb);
        try
        {
            __result.__prepare(__isCaseSensitive_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_isCaseSensitive(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __isCaseSensitive_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public boolean isCaseSensitive_async(AMI_Search_isCaseSensitive __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isCaseSensitive_name);
            __r = begin_isCaseSensitive(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isCaseSensitive_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the current case sensitivity setting. If
     * {@link #setCaseSentivice} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isCaseSensitive_async(AMI_Search_isCaseSensitive __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isCaseSensitive_name);
            __r = begin_isCaseSensitive(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isCaseSensitive_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __isMergedBatches_name = "isMergedBatches";

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     **/
    public boolean isMergedBatches()
        throws omero.ServerError
    {
        return isMergedBatches(null, false);
    }

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isMergedBatches(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return isMergedBatches(__ctx, true);
    }

    private boolean isMergedBatches(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isMergedBatches", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isMergedBatches");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    return __del.isMergedBatches(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isMergedBatches()
    {
        return begin_isMergedBatches(null, false, null);
    }

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isMergedBatches(java.util.Map<String, String> __ctx)
    {
        return begin_isMergedBatches(__ctx, true, null);
    }

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isMergedBatches(Ice.Callback __cb)
    {
        return begin_isMergedBatches(null, false, __cb);
    }

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isMergedBatches(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isMergedBatches(__ctx, true, __cb);
    }

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isMergedBatches(Callback_Search_isMergedBatches __cb)
    {
        return begin_isMergedBatches(null, false, __cb);
    }

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isMergedBatches(java.util.Map<String, String> __ctx, Callback_Search_isMergedBatches __cb)
    {
        return begin_isMergedBatches(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isMergedBatches(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isMergedBatches_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isMergedBatches_name, __cb);
        try
        {
            __result.__prepare(__isMergedBatches_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_isMergedBatches(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __isMergedBatches_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public boolean isMergedBatches_async(AMI_Search_isMergedBatches __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isMergedBatches_name);
            __r = begin_isMergedBatches(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isMergedBatches_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the current merged-batches setting. If
     * {@link #setMergedBatches} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isMergedBatches_async(AMI_Search_isMergedBatches __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isMergedBatches_name);
            __r = begin_isMergedBatches(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isMergedBatches_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __isReturnUnloaded_name = "isReturnUnloaded";

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     **/
    public boolean isReturnUnloaded()
        throws omero.ServerError
    {
        return isReturnUnloaded(null, false);
    }

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isReturnUnloaded(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return isReturnUnloaded(__ctx, true);
    }

    private boolean isReturnUnloaded(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isReturnUnloaded", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isReturnUnloaded");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    return __del.isReturnUnloaded(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isReturnUnloaded()
    {
        return begin_isReturnUnloaded(null, false, null);
    }

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isReturnUnloaded(java.util.Map<String, String> __ctx)
    {
        return begin_isReturnUnloaded(__ctx, true, null);
    }

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isReturnUnloaded(Ice.Callback __cb)
    {
        return begin_isReturnUnloaded(null, false, __cb);
    }

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isReturnUnloaded(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isReturnUnloaded(__ctx, true, __cb);
    }

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isReturnUnloaded(Callback_Search_isReturnUnloaded __cb)
    {
        return begin_isReturnUnloaded(null, false, __cb);
    }

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isReturnUnloaded(java.util.Map<String, String> __ctx, Callback_Search_isReturnUnloaded __cb)
    {
        return begin_isReturnUnloaded(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isReturnUnloaded(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isReturnUnloaded_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isReturnUnloaded_name, __cb);
        try
        {
            __result.__prepare(__isReturnUnloaded_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_isReturnUnloaded(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __isReturnUnloaded_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public boolean isReturnUnloaded_async(AMI_Search_isReturnUnloaded __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isReturnUnloaded_name);
            __r = begin_isReturnUnloaded(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isReturnUnloaded_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the current return-unloaded setting. If true, all
     * returned entities will be unloaded. If
     * {@link #setReturnUnloaded} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isReturnUnloaded_async(AMI_Search_isReturnUnloaded __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isReturnUnloaded_name);
            __r = begin_isReturnUnloaded(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isReturnUnloaded_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __isUseProjections_name = "isUseProjections";

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     **/
    public boolean isUseProjections()
        throws omero.ServerError
    {
        return isUseProjections(null, false);
    }

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isUseProjections(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return isUseProjections(__ctx, true);
    }

    private boolean isUseProjections(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isUseProjections", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isUseProjections");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    return __del.isUseProjections(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isUseProjections()
    {
        return begin_isUseProjections(null, false, null);
    }

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isUseProjections(java.util.Map<String, String> __ctx)
    {
        return begin_isUseProjections(__ctx, true, null);
    }

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isUseProjections(Ice.Callback __cb)
    {
        return begin_isUseProjections(null, false, __cb);
    }

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isUseProjections(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isUseProjections(__ctx, true, __cb);
    }

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isUseProjections(Callback_Search_isUseProjections __cb)
    {
        return begin_isUseProjections(null, false, __cb);
    }

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isUseProjections(java.util.Map<String, String> __ctx, Callback_Search_isUseProjections __cb)
    {
        return begin_isUseProjections(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isUseProjections(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isUseProjections_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isUseProjections_name, __cb);
        try
        {
            __result.__prepare(__isUseProjections_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_isUseProjections(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __isUseProjections_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     **/
    public boolean isUseProjections_async(AMI_Search_isUseProjections __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isUseProjections_name);
            __r = begin_isUseProjections(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isUseProjections_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the current use-projection setting. If true, the
     * client must be careful with all results that are returned.
     * See {@link #setUseProjections} for more. If
     * {@link #setUseProjections} has not been called, the
     * default value will be in effect.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isUseProjections_async(AMI_Search_isUseProjections __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isUseProjections_name);
            __r = begin_isUseProjections(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isUseProjections_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __next_name = "next";

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @throws ApiUsageException if {@link #hasNext} returns false.
     **/
    public omero.model.IObject next()
        throws omero.ServerError
    {
        return next(null, false);
    }

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @throws ApiUsageException if {@link #hasNext} returns false.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.model.IObject next(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return next(__ctx, true);
    }

    private omero.model.IObject next(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "next", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("next");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    return __del.next(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_next()
    {
        return begin_next(null, false, null);
    }

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_next(java.util.Map<String, String> __ctx)
    {
        return begin_next(__ctx, true, null);
    }

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_next(Ice.Callback __cb)
    {
        return begin_next(null, false, __cb);
    }

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_next(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_next(__ctx, true, __cb);
    }

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_next(Callback_Search_next __cb)
    {
        return begin_next(null, false, __cb);
    }

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_next(java.util.Map<String, String> __ctx, Callback_Search_next __cb)
    {
        return begin_next(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_next(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__next_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __next_name, __cb);
        try
        {
            __result.__prepare(__next_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.model.IObject end_next(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __next_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.model.IObjectHolder __ret = new omero.model.IObjectHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean next_async(AMI_Search_next __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__next_name);
            __r = begin_next(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __next_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns the next entity from the current query. If the
     * previous call returned the last entity from a given query,
     * the first entity from the next query will be returned and
     * {@link #activeQueries} decremented.
     * Since this method only returns the entity itself, a single
     * call to {@link #currentMetadata} may follow this call to
     * gather the extra metadata which is returned in the map via
     * {@link #results}.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean next_async(AMI_Search_next __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__next_name);
            __r = begin_next(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __next_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __not_name = "not";

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     **/
    public void not()
        throws omero.ServerError
    {
        not(null, false);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __ctx The Context map to send with the invocation.
     **/
    public void not(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        not(__ctx, true);
    }

    private void not(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "not", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("not");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.not(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_not()
    {
        return begin_not(null, false, null);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_not(java.util.Map<String, String> __ctx)
    {
        return begin_not(__ctx, true, null);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_not(Ice.Callback __cb)
    {
        return begin_not(null, false, __cb);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_not(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_not(__ctx, true, __cb);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_not(Callback_Search_not __cb)
    {
        return begin_not(null, false, __cb);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_not(java.util.Map<String, String> __ctx, Callback_Search_not __cb)
    {
        return begin_not(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_not(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__not_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __not_name, __cb);
        try
        {
            __result.__prepare(__not_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_not(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __not_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __cb The callback object for the operation.
     **/
    public boolean not_async(AMI_Search_not __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__not_name);
            __r = begin_not(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __not_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next}, or
     * {@link #results} sees only the intersection of the two
     * calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.complement();
     * service.byAnnotatedWith(TagAnnotation.class);
     * </pre>
     * 
     * will return all the Images <em>not</em> annotated with
     * TagAnnotation. <p>
     * Calling this method overrides a previous setting of
     * {@link #or} or {@link #and}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link ApiUsageException} will be thrown.
     * </p>
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean not_async(AMI_Search_not __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__not_name);
            __r = begin_not(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __not_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __notAnnotatedBy_name = "notAnnotatedBy";

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     **/
    public void notAnnotatedBy(omero.model.Details d)
        throws omero.ServerError
    {
        notAnnotatedBy(d, null, false);
    }

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void notAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        notAnnotatedBy(d, __ctx, true);
    }

    private void notAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "notAnnotatedBy", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("notAnnotatedBy");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.notAnnotatedBy(d, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     **/
    public Ice.AsyncResult begin_notAnnotatedBy(omero.model.Details d)
    {
        return begin_notAnnotatedBy(d, null, false, null);
    }

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_notAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx)
    {
        return begin_notAnnotatedBy(d, __ctx, true, null);
    }

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     **/
    public Ice.AsyncResult begin_notAnnotatedBy(omero.model.Details d, Ice.Callback __cb)
    {
        return begin_notAnnotatedBy(d, null, false, __cb);
    }

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_notAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_notAnnotatedBy(d, __ctx, true, __cb);
    }

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     **/
    public Ice.AsyncResult begin_notAnnotatedBy(omero.model.Details d, Callback_Search_notAnnotatedBy __cb)
    {
        return begin_notAnnotatedBy(d, null, false, __cb);
    }

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_notAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx, Callback_Search_notAnnotatedBy __cb)
    {
        return begin_notAnnotatedBy(d, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_notAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__notAnnotatedBy_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __notAnnotatedBy_name, __cb);
        try
        {
            __result.__prepare(__notAnnotatedBy_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(d);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_notAnnotatedBy(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __notAnnotatedBy_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     **/
    public boolean notAnnotatedBy_async(AMI_Search_notAnnotatedBy __cb, omero.model.Details d)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__notAnnotatedBy_name);
            __r = begin_notAnnotatedBy(d, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __notAnnotatedBy_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Restricts entities by who has not annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #notOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean notAnnotatedBy_async(AMI_Search_notAnnotatedBy __cb, omero.model.Details d, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__notAnnotatedBy_name);
            __r = begin_notAnnotatedBy(d, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __notAnnotatedBy_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __notOwnedBy_name = "notOwnedBy";

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     **/
    public void notOwnedBy(omero.model.Details d)
        throws omero.ServerError
    {
        notOwnedBy(d, null, false);
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void notOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        notOwnedBy(d, __ctx, true);
    }

    private void notOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "notOwnedBy", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("notOwnedBy");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.notOwnedBy(d, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     **/
    public Ice.AsyncResult begin_notOwnedBy(omero.model.Details d)
    {
        return begin_notOwnedBy(d, null, false, null);
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_notOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx)
    {
        return begin_notOwnedBy(d, __ctx, true, null);
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     **/
    public Ice.AsyncResult begin_notOwnedBy(omero.model.Details d, Ice.Callback __cb)
    {
        return begin_notOwnedBy(d, null, false, __cb);
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_notOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_notOwnedBy(d, __ctx, true, __cb);
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     **/
    public Ice.AsyncResult begin_notOwnedBy(omero.model.Details d, Callback_Search_notOwnedBy __cb)
    {
        return begin_notOwnedBy(d, null, false, __cb);
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_notOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx, Callback_Search_notOwnedBy __cb)
    {
        return begin_notOwnedBy(d, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_notOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__notOwnedBy_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __notOwnedBy_name, __cb);
        try
        {
            __result.__prepare(__notOwnedBy_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(d);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_notOwnedBy(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __notOwnedBy_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     **/
    public boolean notOwnedBy_async(AMI_Search_notOwnedBy __cb, omero.model.Details d)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__notOwnedBy_name);
            __r = begin_notOwnedBy(d, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __notOwnedBy_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean notOwnedBy_async(AMI_Search_notOwnedBy __cb, omero.model.Details d, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__notOwnedBy_name);
            __r = begin_notOwnedBy(d, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __notOwnedBy_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __onlyAnnotatedBetween_name = "onlyAnnotatedBetween";

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     **/
    public void onlyAnnotatedBetween(omero.RTime start, omero.RTime stop)
        throws omero.ServerError
    {
        onlyAnnotatedBetween(start, stop, null, false);
    }

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void onlyAnnotatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        onlyAnnotatedBetween(start, stop, __ctx, true);
    }

    private void onlyAnnotatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "onlyAnnotatedBetween", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("onlyAnnotatedBetween");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.onlyAnnotatedBetween(start, stop, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBetween(omero.RTime start, omero.RTime stop)
    {
        return begin_onlyAnnotatedBetween(start, stop, null, false, null);
    }

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx)
    {
        return begin_onlyAnnotatedBetween(start, stop, __ctx, true, null);
    }

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBetween(omero.RTime start, omero.RTime stop, Ice.Callback __cb)
    {
        return begin_onlyAnnotatedBetween(start, stop, null, false, __cb);
    }

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_onlyAnnotatedBetween(start, stop, __ctx, true, __cb);
    }

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBetween(omero.RTime start, omero.RTime stop, Callback_Search_onlyAnnotatedBetween __cb)
    {
        return begin_onlyAnnotatedBetween(start, stop, null, false, __cb);
    }

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx, Callback_Search_onlyAnnotatedBetween __cb)
    {
        return begin_onlyAnnotatedBetween(start, stop, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_onlyAnnotatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__onlyAnnotatedBetween_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __onlyAnnotatedBetween_name, __cb);
        try
        {
            __result.__prepare(__onlyAnnotatedBetween_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(start);
            __os.writeObject(stop);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_onlyAnnotatedBetween(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __onlyAnnotatedBetween_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     **/
    public boolean onlyAnnotatedBetween_async(AMI_Search_onlyAnnotatedBetween __cb, omero.RTime start, omero.RTime stop)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__onlyAnnotatedBetween_name);
            __r = begin_onlyAnnotatedBetween(start, stop, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __onlyAnnotatedBetween_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Restricts entities by the time in which any annotation
     * (which matches the other filters) was added them. This
     * matches the {@link omero.model.Details#getCreationEvent}
     * creation event of the {@link omero..model.Annotation}.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean onlyAnnotatedBetween_async(AMI_Search_onlyAnnotatedBetween __cb, omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__onlyAnnotatedBetween_name);
            __r = begin_onlyAnnotatedBetween(start, stop, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __onlyAnnotatedBetween_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __onlyAnnotatedBy_name = "onlyAnnotatedBy";

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     **/
    public void onlyAnnotatedBy(omero.model.Details d)
        throws omero.ServerError
    {
        onlyAnnotatedBy(d, null, false);
    }

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void onlyAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        onlyAnnotatedBy(d, __ctx, true);
    }

    private void onlyAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "onlyAnnotatedBy", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("onlyAnnotatedBy");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.onlyAnnotatedBy(d, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBy(omero.model.Details d)
    {
        return begin_onlyAnnotatedBy(d, null, false, null);
    }

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx)
    {
        return begin_onlyAnnotatedBy(d, __ctx, true, null);
    }

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBy(omero.model.Details d, Ice.Callback __cb)
    {
        return begin_onlyAnnotatedBy(d, null, false, __cb);
    }

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_onlyAnnotatedBy(d, __ctx, true, __cb);
    }

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBy(omero.model.Details d, Callback_Search_onlyAnnotatedBy __cb)
    {
        return begin_onlyAnnotatedBy(d, null, false, __cb);
    }

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx, Callback_Search_onlyAnnotatedBy __cb)
    {
        return begin_onlyAnnotatedBy(d, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_onlyAnnotatedBy(omero.model.Details d, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__onlyAnnotatedBy_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __onlyAnnotatedBy_name, __cb);
        try
        {
            __result.__prepare(__onlyAnnotatedBy_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(d);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_onlyAnnotatedBy(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __onlyAnnotatedBy_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     **/
    public boolean onlyAnnotatedBy_async(AMI_Search_onlyAnnotatedBy __cb, omero.model.Details d)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__onlyAnnotatedBy_name);
            __r = begin_onlyAnnotatedBy(d, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __onlyAnnotatedBy_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Restricts entities by who has annotated them with an
     * {@link omero.model.Annotation} matching the other filters.
     * As {@link #onlyOwnedBy}, the
     * {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information is
     * combined with an AND condition.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case any previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean onlyAnnotatedBy_async(AMI_Search_onlyAnnotatedBy __cb, omero.model.Details d, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__onlyAnnotatedBy_name);
            __r = begin_onlyAnnotatedBy(d, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __onlyAnnotatedBy_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __onlyAnnotatedWith_name = "onlyAnnotatedWith";

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param classes Can be empty, in which case restriction is
     * removed.
     **/
    public void onlyAnnotatedWith(java.util.List<String> classes)
        throws omero.ServerError
    {
        onlyAnnotatedWith(classes, null, false);
    }

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param classes Can be empty, in which case restriction is
     * removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void onlyAnnotatedWith(java.util.List<String> classes, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        onlyAnnotatedWith(classes, __ctx, true);
    }

    private void onlyAnnotatedWith(java.util.List<String> classes, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "onlyAnnotatedWith", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("onlyAnnotatedWith");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.onlyAnnotatedWith(classes, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, in which case restriction is
     * removed.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedWith(java.util.List<String> classes)
    {
        return begin_onlyAnnotatedWith(classes, null, false, null);
    }

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, in which case restriction is
     * removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedWith(java.util.List<String> classes, java.util.Map<String, String> __ctx)
    {
        return begin_onlyAnnotatedWith(classes, __ctx, true, null);
    }

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, in which case restriction is
     * removed.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedWith(java.util.List<String> classes, Ice.Callback __cb)
    {
        return begin_onlyAnnotatedWith(classes, null, false, __cb);
    }

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, in which case restriction is
     * removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedWith(java.util.List<String> classes, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_onlyAnnotatedWith(classes, __ctx, true, __cb);
    }

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, in which case restriction is
     * removed.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedWith(java.util.List<String> classes, Callback_Search_onlyAnnotatedWith __cb)
    {
        return begin_onlyAnnotatedWith(classes, null, false, __cb);
    }

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, in which case restriction is
     * removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyAnnotatedWith(java.util.List<String> classes, java.util.Map<String, String> __ctx, Callback_Search_onlyAnnotatedWith __cb)
    {
        return begin_onlyAnnotatedWith(classes, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_onlyAnnotatedWith(java.util.List<String> classes, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__onlyAnnotatedWith_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __onlyAnnotatedWith_name, __cb);
        try
        {
            __result.__prepare(__onlyAnnotatedWith_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            StringSetHelper.write(__os, classes);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_onlyAnnotatedWith(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __onlyAnnotatedWith_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, in which case restriction is
     * removed.
     **/
    public boolean onlyAnnotatedWith_async(AMI_Search_onlyAnnotatedWith __cb, java.util.List<String> classes)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__onlyAnnotatedWith_name);
            __r = begin_onlyAnnotatedWith(classes, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __onlyAnnotatedWith_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Restricts entities to having an
     * {@link omero.model.Annotation} of all the given types. This
     * is useful in combination with the other onlyAnnotated*
     * methods to say, e.g., only annotated with a file by user X.
     * By default, this value is <code>null</code> and imposes no
     * restriction. Passing an empty array implies an object that
     * is not annotated at all.
     * 
     * 
     * Note: If the semantics were OR, then a client would have to
     * query each class individually, and compare all the various
     * values, checking which ids are where. However, since this
     * method defaults to AND, multiple calls (optionally with
     * {@link #isMergedBatches} and {@link #isReturnUnloaded})
     * and combine the results. Duplicate ids are still possible
     * so a set of some form should be used to collect the results.
     * 
     * @param __cb The callback object for the operation.
     * @param classes Can be empty, in which case restriction is
     * removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean onlyAnnotatedWith_async(AMI_Search_onlyAnnotatedWith __cb, java.util.List<String> classes, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__onlyAnnotatedWith_name);
            __r = begin_onlyAnnotatedWith(classes, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __onlyAnnotatedWith_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __onlyCreatedBetween_name = "onlyCreatedBetween";

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     **/
    public void onlyCreatedBetween(omero.RTime start, omero.RTime stop)
        throws omero.ServerError
    {
        onlyCreatedBetween(start, stop, null, false);
    }

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void onlyCreatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        onlyCreatedBetween(start, stop, __ctx, true);
    }

    private void onlyCreatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "onlyCreatedBetween", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("onlyCreatedBetween");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.onlyCreatedBetween(start, stop, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     **/
    public Ice.AsyncResult begin_onlyCreatedBetween(omero.RTime start, omero.RTime stop)
    {
        return begin_onlyCreatedBetween(start, stop, null, false, null);
    }

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyCreatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx)
    {
        return begin_onlyCreatedBetween(start, stop, __ctx, true, null);
    }

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     **/
    public Ice.AsyncResult begin_onlyCreatedBetween(omero.RTime start, omero.RTime stop, Ice.Callback __cb)
    {
        return begin_onlyCreatedBetween(start, stop, null, false, __cb);
    }

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyCreatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_onlyCreatedBetween(start, stop, __ctx, true, __cb);
    }

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     **/
    public Ice.AsyncResult begin_onlyCreatedBetween(omero.RTime start, omero.RTime stop, Callback_Search_onlyCreatedBetween __cb)
    {
        return begin_onlyCreatedBetween(start, stop, null, false, __cb);
    }

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyCreatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx, Callback_Search_onlyCreatedBetween __cb)
    {
        return begin_onlyCreatedBetween(start, stop, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_onlyCreatedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__onlyCreatedBetween_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __onlyCreatedBetween_name, __cb);
        try
        {
            __result.__prepare(__onlyCreatedBetween_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(start);
            __os.writeObject(stop);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_onlyCreatedBetween(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __onlyCreatedBetween_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     **/
    public boolean onlyCreatedBetween_async(AMI_Search_onlyCreatedBetween __cb, omero.RTime start, omero.RTime stop)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__onlyCreatedBetween_name);
            __r = begin_onlyCreatedBetween(start, stop, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __onlyCreatedBetween_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Restricts the time between which an entity may have been
     * created.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval opens to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean onlyCreatedBetween_async(AMI_Search_onlyCreatedBetween __cb, omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__onlyCreatedBetween_name);
            __r = begin_onlyCreatedBetween(start, stop, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __onlyCreatedBetween_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __onlyIds_name = "onlyIds";

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     **/
    public void onlyIds(java.util.List<Long> ids)
        throws omero.ServerError
    {
        onlyIds(ids, null, false);
    }

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void onlyIds(java.util.List<Long> ids, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        onlyIds(ids, __ctx, true);
    }

    private void onlyIds(java.util.List<Long> ids, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "onlyIds", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("onlyIds");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.onlyIds(ids, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param __cb The callback object for the operation.
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     **/
    public Ice.AsyncResult begin_onlyIds(java.util.List<Long> ids)
    {
        return begin_onlyIds(ids, null, false, null);
    }

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param __cb The callback object for the operation.
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyIds(java.util.List<Long> ids, java.util.Map<String, String> __ctx)
    {
        return begin_onlyIds(ids, __ctx, true, null);
    }

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param __cb The callback object for the operation.
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     **/
    public Ice.AsyncResult begin_onlyIds(java.util.List<Long> ids, Ice.Callback __cb)
    {
        return begin_onlyIds(ids, null, false, __cb);
    }

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param __cb The callback object for the operation.
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyIds(java.util.List<Long> ids, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_onlyIds(ids, __ctx, true, __cb);
    }

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param __cb The callback object for the operation.
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     **/
    public Ice.AsyncResult begin_onlyIds(java.util.List<Long> ids, Callback_Search_onlyIds __cb)
    {
        return begin_onlyIds(ids, null, false, __cb);
    }

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param __cb The callback object for the operation.
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyIds(java.util.List<Long> ids, java.util.Map<String, String> __ctx, Callback_Search_onlyIds __cb)
    {
        return begin_onlyIds(ids, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_onlyIds(java.util.List<Long> ids, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__onlyIds_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __onlyIds_name, __cb);
        try
        {
            __result.__prepare(__onlyIds_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            omero.sys.LongListHelper.write(__os, ids);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_onlyIds(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __onlyIds_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param __cb The callback object for the operation.
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     **/
    public boolean onlyIds_async(AMI_Search_onlyIds __cb, java.util.List<Long> ids)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__onlyIds_name);
            __r = begin_onlyIds(ids, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __onlyIds_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Restricts the set of ids which will be checked.
     * This is useful for testing one of the given restrictions on
     * a reduced set of objects.
     * 
     * @param __cb The callback object for the operation.
     * @param ids Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean onlyIds_async(AMI_Search_onlyIds __cb, java.util.List<Long> ids, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__onlyIds_name);
            __r = begin_onlyIds(ids, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __onlyIds_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __onlyModifiedBetween_name = "onlyModifiedBetween";

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     **/
    public void onlyModifiedBetween(omero.RTime start, omero.RTime stop)
        throws omero.ServerError
    {
        onlyModifiedBetween(start, stop, null, false);
    }

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void onlyModifiedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        onlyModifiedBetween(start, stop, __ctx, true);
    }

    private void onlyModifiedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "onlyModifiedBetween", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("onlyModifiedBetween");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.onlyModifiedBetween(start, stop, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     **/
    public Ice.AsyncResult begin_onlyModifiedBetween(omero.RTime start, omero.RTime stop)
    {
        return begin_onlyModifiedBetween(start, stop, null, false, null);
    }

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyModifiedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx)
    {
        return begin_onlyModifiedBetween(start, stop, __ctx, true, null);
    }

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     **/
    public Ice.AsyncResult begin_onlyModifiedBetween(omero.RTime start, omero.RTime stop, Ice.Callback __cb)
    {
        return begin_onlyModifiedBetween(start, stop, null, false, __cb);
    }

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyModifiedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_onlyModifiedBetween(start, stop, __ctx, true, __cb);
    }

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     **/
    public Ice.AsyncResult begin_onlyModifiedBetween(omero.RTime start, omero.RTime stop, Callback_Search_onlyModifiedBetween __cb)
    {
        return begin_onlyModifiedBetween(start, stop, null, false, __cb);
    }

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyModifiedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx, Callback_Search_onlyModifiedBetween __cb)
    {
        return begin_onlyModifiedBetween(start, stop, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_onlyModifiedBetween(omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__onlyModifiedBetween_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __onlyModifiedBetween_name, __cb);
        try
        {
            __result.__prepare(__onlyModifiedBetween_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(start);
            __os.writeObject(stop);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_onlyModifiedBetween(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __onlyModifiedBetween_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     **/
    public boolean onlyModifiedBetween_async(AMI_Search_onlyModifiedBetween __cb, omero.RTime start, omero.RTime stop)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__onlyModifiedBetween_name);
            __r = begin_onlyModifiedBetween(start, stop, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __onlyModifiedBetween_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Restricts the time between which an entity may have last
     * been modified.
     * 
     * @param __cb The callback object for the operation.
     * @param start Can be null, i.e. interval open to negative
     * infinity.
     * @param stop Can be null, i.e. interval open to positive
     * infinity.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean onlyModifiedBetween_async(AMI_Search_onlyModifiedBetween __cb, omero.RTime start, omero.RTime stop, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__onlyModifiedBetween_name);
            __r = begin_onlyModifiedBetween(start, stop, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __onlyModifiedBetween_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __onlyOwnedBy_name = "onlyOwnedBy";

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     **/
    public void onlyOwnedBy(omero.model.Details d)
        throws omero.ServerError
    {
        onlyOwnedBy(d, null, false);
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void onlyOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        onlyOwnedBy(d, __ctx, true);
    }

    private void onlyOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "onlyOwnedBy", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("onlyOwnedBy");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.onlyOwnedBy(d, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     **/
    public Ice.AsyncResult begin_onlyOwnedBy(omero.model.Details d)
    {
        return begin_onlyOwnedBy(d, null, false, null);
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx)
    {
        return begin_onlyOwnedBy(d, __ctx, true, null);
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     **/
    public Ice.AsyncResult begin_onlyOwnedBy(omero.model.Details d, Ice.Callback __cb)
    {
        return begin_onlyOwnedBy(d, null, false, __cb);
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_onlyOwnedBy(d, __ctx, true, __cb);
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     **/
    public Ice.AsyncResult begin_onlyOwnedBy(omero.model.Details d, Callback_Search_onlyOwnedBy __cb)
    {
        return begin_onlyOwnedBy(d, null, false, __cb);
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx, Callback_Search_onlyOwnedBy __cb)
    {
        return begin_onlyOwnedBy(d, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_onlyOwnedBy(omero.model.Details d, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__onlyOwnedBy_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __onlyOwnedBy_name, __cb);
        try
        {
            __result.__prepare(__onlyOwnedBy_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(d);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_onlyOwnedBy(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __onlyOwnedBy_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     **/
    public boolean onlyOwnedBy_async(AMI_Search_onlyOwnedBy __cb, omero.model.Details d)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__onlyOwnedBy_name);
            __r = begin_onlyOwnedBy(d, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __onlyOwnedBy_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Uses the {@link omero.model.Details#getOwner} and
     * {@link omero.model.Details#getGroup} information to
     * restrict the entities which will be returned. If both are
     * non-null, the two restrictions are joined by an AND.
     * 
     * @param __cb The callback object for the operation.
     * @param d Can be null, in which case the previous
     * restriction is removed.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean onlyOwnedBy_async(AMI_Search_onlyOwnedBy __cb, omero.model.Details d, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__onlyOwnedBy_name);
            __r = begin_onlyOwnedBy(d, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __onlyOwnedBy_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __onlyType_name = "onlyType";

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     **/
    public void onlyType(String klass)
        throws omero.ServerError
    {
        onlyType(klass, null, false);
    }

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void onlyType(String klass, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        onlyType(klass, __ctx, true);
    }

    private void onlyType(String klass, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "onlyType", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("onlyType");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.onlyType(klass, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_onlyType(String klass)
    {
        return begin_onlyType(klass, null, false, null);
    }

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyType(String klass, java.util.Map<String, String> __ctx)
    {
        return begin_onlyType(klass, __ctx, true, null);
    }

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_onlyType(String klass, Ice.Callback __cb)
    {
        return begin_onlyType(klass, null, false, __cb);
    }

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyType(String klass, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_onlyType(klass, __ctx, true, __cb);
    }

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_onlyType(String klass, Callback_Search_onlyType __cb)
    {
        return begin_onlyType(klass, null, false, __cb);
    }

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyType(String klass, java.util.Map<String, String> __ctx, Callback_Search_onlyType __cb)
    {
        return begin_onlyType(klass, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_onlyType(String klass, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__onlyType_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __onlyType_name, __cb);
        try
        {
            __result.__prepare(__onlyType_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeString(klass);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_onlyType(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __onlyType_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __cb The callback object for the operation.
     **/
    public boolean onlyType_async(AMI_Search_onlyType __cb, String klass)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__onlyType_name);
            __r = begin_onlyType(klass, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __onlyType_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Restricts the search to a single type. All return values
     * will match this type.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean onlyType_async(AMI_Search_onlyType __cb, String klass, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__onlyType_name);
            __r = begin_onlyType(klass, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __onlyType_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __onlyTypes_name = "onlyTypes";

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     **/
    public void onlyTypes(java.util.List<String> classes)
        throws omero.ServerError
    {
        onlyTypes(classes, null, false);
    }

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void onlyTypes(java.util.List<String> classes, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        onlyTypes(classes, __ctx, true);
    }

    private void onlyTypes(java.util.List<String> classes, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "onlyTypes", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("onlyTypes");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.onlyTypes(classes, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_onlyTypes(java.util.List<String> classes)
    {
        return begin_onlyTypes(classes, null, false, null);
    }

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyTypes(java.util.List<String> classes, java.util.Map<String, String> __ctx)
    {
        return begin_onlyTypes(classes, __ctx, true, null);
    }

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_onlyTypes(java.util.List<String> classes, Ice.Callback __cb)
    {
        return begin_onlyTypes(classes, null, false, __cb);
    }

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyTypes(java.util.List<String> classes, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_onlyTypes(classes, __ctx, true, __cb);
    }

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_onlyTypes(java.util.List<String> classes, Callback_Search_onlyTypes __cb)
    {
        return begin_onlyTypes(classes, null, false, __cb);
    }

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_onlyTypes(java.util.List<String> classes, java.util.Map<String, String> __ctx, Callback_Search_onlyTypes __cb)
    {
        return begin_onlyTypes(classes, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_onlyTypes(java.util.List<String> classes, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__onlyTypes_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __onlyTypes_name, __cb);
        try
        {
            __result.__prepare(__onlyTypes_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            StringSetHelper.write(__os, classes);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_onlyTypes(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __onlyTypes_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __cb The callback object for the operation.
     **/
    public boolean onlyTypes_async(AMI_Search_onlyTypes __cb, java.util.List<String> classes)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__onlyTypes_name);
            __r = begin_onlyTypes(classes, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __onlyTypes_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Restricts searches to a set of types. The entities returned
     * are guaranteed to be one of these types.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean onlyTypes_async(AMI_Search_onlyTypes __cb, java.util.List<String> classes, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__onlyTypes_name);
            __r = begin_onlyTypes(classes, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __onlyTypes_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __or_name = "or";

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     **/
    public void or()
        throws omero.ServerError
    {
        or(null, false);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void or(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        or(__ctx, true);
    }

    private void or(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "or", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("or");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.or(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_or()
    {
        return begin_or(null, false, null);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_or(java.util.Map<String, String> __ctx)
    {
        return begin_or(__ctx, true, null);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_or(Ice.Callback __cb)
    {
        return begin_or(null, false, __cb);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_or(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_or(__ctx, true, __cb);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_or(Callback_Search_or __cb)
    {
        return begin_or(null, false, __cb);
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_or(java.util.Map<String, String> __ctx, Callback_Search_or __cb)
    {
        return begin_or(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_or(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__or_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __or_name, __cb);
        try
        {
            __result.__prepare(__or_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_or(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __or_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __cb The callback object for the operation.
     **/
    public boolean or_async(AMI_Search_or __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__or_name);
            __r = begin_or(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __or_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Applies the next by* method to the previous by* method, so
     * that a call {@link #hasNext}, {@link #next} or
     * {@link #results} sees only the union of the two calls.
     * 
     * For example,
     * 
     * <pre>
     * service.onlyType(Image.class);
     * service.byFullText(&quot;foo&quot;);
     * service.or();
     * service.onlyType(Dataset.class);
     * service.byFullText(&quot;foo&quot;);
     * </pre>
     * 
     * will return both Images and Datasets together.
     * 
     * Calling this method overrides a previous setting of
     * {@link #and} or {@link #not}. If there is no active queries
     * (i.e. {@link #activeQueries} > 0), then an
     * {@link omero.ApiUsageException} will be thrown.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean or_async(AMI_Search_or __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__or_name);
            __r = begin_or(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __or_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __remove_name = "remove";

    /**
     * Unsupported operation.
     **/
    public void remove()
        throws omero.ServerError
    {
        remove(null, false);
    }

    /**
     * Unsupported operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void remove(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        remove(__ctx, true);
    }

    private void remove(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "remove", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("remove");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.remove(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Unsupported operation.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_remove()
    {
        return begin_remove(null, false, null);
    }

    /**
     * Unsupported operation.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_remove(java.util.Map<String, String> __ctx)
    {
        return begin_remove(__ctx, true, null);
    }

    /**
     * Unsupported operation.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_remove(Ice.Callback __cb)
    {
        return begin_remove(null, false, __cb);
    }

    /**
     * Unsupported operation.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_remove(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_remove(__ctx, true, __cb);
    }

    /**
     * Unsupported operation.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_remove(Callback_Search_remove __cb)
    {
        return begin_remove(null, false, __cb);
    }

    /**
     * Unsupported operation.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_remove(java.util.Map<String, String> __ctx, Callback_Search_remove __cb)
    {
        return begin_remove(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_remove(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__remove_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __remove_name, __cb);
        try
        {
            __result.__prepare(__remove_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_remove(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __remove_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Unsupported operation.
     * @param __cb The callback object for the operation.
     **/
    public boolean remove_async(AMI_Search_remove __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__remove_name);
            __r = begin_remove(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __remove_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Unsupported operation.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean remove_async(AMI_Search_remove __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__remove_name);
            __r = begin_remove(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __remove_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __resetDefaults_name = "resetDefaults";

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     **/
    public void resetDefaults()
        throws omero.ServerError
    {
        resetDefaults(null, false);
    }

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void resetDefaults(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        resetDefaults(__ctx, true);
    }

    private void resetDefaults(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "resetDefaults", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("resetDefaults");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.resetDefaults(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_resetDefaults()
    {
        return begin_resetDefaults(null, false, null);
    }

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaults(java.util.Map<String, String> __ctx)
    {
        return begin_resetDefaults(__ctx, true, null);
    }

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_resetDefaults(Ice.Callback __cb)
    {
        return begin_resetDefaults(null, false, __cb);
    }

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaults(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_resetDefaults(__ctx, true, __cb);
    }

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_resetDefaults(Callback_Search_resetDefaults __cb)
    {
        return begin_resetDefaults(null, false, __cb);
    }

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaults(java.util.Map<String, String> __ctx, Callback_Search_resetDefaults __cb)
    {
        return begin_resetDefaults(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_resetDefaults(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__resetDefaults_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __resetDefaults_name, __cb);
        try
        {
            __result.__prepare(__resetDefaults_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_resetDefaults(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __resetDefaults_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __cb The callback object for the operation.
     **/
    public boolean resetDefaults_async(AMI_Search_resetDefaults __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaults_name);
            __r = begin_resetDefaults(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaults_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Resets all settings (non-query state) to the original
     * default values, as if the instance had just be created.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaults_async(AMI_Search_resetDefaults __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaults_name);
            __r = begin_resetDefaults(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaults_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __results_name = "results";

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @throws ApiUsageException if {@link #hasNext} returns false.
     **/
    public java.util.List<omero.model.IObject> results()
        throws omero.ServerError
    {
        return results(null, false);
    }

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @throws ApiUsageException if {@link #hasNext} returns false.
     * @param __ctx The Context map to send with the invocation.
     **/
    public java.util.List<omero.model.IObject> results(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return results(__ctx, true);
    }

    private java.util.List<omero.model.IObject> results(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "results", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("results");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    return __del.results(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_results()
    {
        return begin_results(null, false, null);
    }

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_results(java.util.Map<String, String> __ctx)
    {
        return begin_results(__ctx, true, null);
    }

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_results(Ice.Callback __cb)
    {
        return begin_results(null, false, __cb);
    }

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_results(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_results(__ctx, true, __cb);
    }

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_results(Callback_Search_results __cb)
    {
        return begin_results(null, false, __cb);
    }

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_results(java.util.Map<String, String> __ctx, Callback_Search_results __cb)
    {
        return begin_results(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_results(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__results_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __results_name, __cb);
        try
        {
            __result.__prepare(__results_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public java.util.List<omero.model.IObject> end_results(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __results_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.List<omero.model.IObject> __ret;
            __ret = IObjectListHelper.read(__is);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean results_async(AMI_Search_results __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__results_name);
            __r = begin_results(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __results_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Returns up to {@link #getBatchSize} batch size number of
     * results along with the related query metadata. If
     * {@link #isMergedBatches} batches are merged then the
     * results from multiple queries may be returned together.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean results_async(AMI_Search_results __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__results_name);
            __r = begin_results(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __results_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setAllowLeadingWildcard_name = "setAllowLeadingWildcard";

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @see #isAllowLeadingWildcard
     * @see #byFullText
     * @see #bySomeMustNone
     **/
    public void setAllowLeadingWildcard(boolean allowLeadingWildcard)
        throws omero.ServerError
    {
        setAllowLeadingWildcard(allowLeadingWildcard, null, false);
    }

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @see #isAllowLeadingWildcard
     * @see #byFullText
     * @see #bySomeMustNone
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setAllowLeadingWildcard(boolean allowLeadingWildcard, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setAllowLeadingWildcard(allowLeadingWildcard, __ctx, true);
    }

    private void setAllowLeadingWildcard(boolean allowLeadingWildcard, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setAllowLeadingWildcard", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setAllowLeadingWildcard");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.setAllowLeadingWildcard(allowLeadingWildcard, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setAllowLeadingWildcard(boolean allowLeadingWildcard)
    {
        return begin_setAllowLeadingWildcard(allowLeadingWildcard, null, false, null);
    }

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setAllowLeadingWildcard(boolean allowLeadingWildcard, java.util.Map<String, String> __ctx)
    {
        return begin_setAllowLeadingWildcard(allowLeadingWildcard, __ctx, true, null);
    }

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setAllowLeadingWildcard(boolean allowLeadingWildcard, Ice.Callback __cb)
    {
        return begin_setAllowLeadingWildcard(allowLeadingWildcard, null, false, __cb);
    }

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setAllowLeadingWildcard(boolean allowLeadingWildcard, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setAllowLeadingWildcard(allowLeadingWildcard, __ctx, true, __cb);
    }

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setAllowLeadingWildcard(boolean allowLeadingWildcard, Callback_Search_setAllowLeadingWildcard __cb)
    {
        return begin_setAllowLeadingWildcard(allowLeadingWildcard, null, false, __cb);
    }

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setAllowLeadingWildcard(boolean allowLeadingWildcard, java.util.Map<String, String> __ctx, Callback_Search_setAllowLeadingWildcard __cb)
    {
        return begin_setAllowLeadingWildcard(allowLeadingWildcard, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setAllowLeadingWildcard(boolean allowLeadingWildcard, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setAllowLeadingWildcard_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setAllowLeadingWildcard_name, __cb);
        try
        {
            __result.__prepare(__setAllowLeadingWildcard_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(allowLeadingWildcard);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setAllowLeadingWildcard(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setAllowLeadingWildcard_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean setAllowLeadingWildcard_async(AMI_Search_setAllowLeadingWildcard __cb, boolean allowLeadingWildcard)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setAllowLeadingWildcard_name);
            __r = begin_setAllowLeadingWildcard(allowLeadingWildcard, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setAllowLeadingWildcard_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Permits full-text queries with a leading query if true.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setAllowLeadingWildcard_async(AMI_Search_setAllowLeadingWildcard __cb, boolean allowLeadingWildcard, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setAllowLeadingWildcard_name);
            __r = begin_setAllowLeadingWildcard(allowLeadingWildcard, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setAllowLeadingWildcard_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setBatchSize_name = "setBatchSize";

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param size maximum number of results per call to
     * {@link #results}
     **/
    public void setBatchSize(int size)
        throws omero.ServerError
    {
        setBatchSize(size, null, false);
    }

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param size maximum number of results per call to
     * {@link #results}
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setBatchSize(int size, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setBatchSize(size, __ctx, true);
    }

    private void setBatchSize(int size, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setBatchSize", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setBatchSize");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.setBatchSize(size, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param __cb The callback object for the operation.
     * @param size maximum number of results per call to
     * {@link #results}
     **/
    public Ice.AsyncResult begin_setBatchSize(int size)
    {
        return begin_setBatchSize(size, null, false, null);
    }

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param __cb The callback object for the operation.
     * @param size maximum number of results per call to
     * {@link #results}
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setBatchSize(int size, java.util.Map<String, String> __ctx)
    {
        return begin_setBatchSize(size, __ctx, true, null);
    }

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param __cb The callback object for the operation.
     * @param size maximum number of results per call to
     * {@link #results}
     **/
    public Ice.AsyncResult begin_setBatchSize(int size, Ice.Callback __cb)
    {
        return begin_setBatchSize(size, null, false, __cb);
    }

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param __cb The callback object for the operation.
     * @param size maximum number of results per call to
     * {@link #results}
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setBatchSize(int size, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setBatchSize(size, __ctx, true, __cb);
    }

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param __cb The callback object for the operation.
     * @param size maximum number of results per call to
     * {@link #results}
     **/
    public Ice.AsyncResult begin_setBatchSize(int size, Callback_Search_setBatchSize __cb)
    {
        return begin_setBatchSize(size, null, false, __cb);
    }

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param __cb The callback object for the operation.
     * @param size maximum number of results per call to
     * {@link #results}
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setBatchSize(int size, java.util.Map<String, String> __ctx, Callback_Search_setBatchSize __cb)
    {
        return begin_setBatchSize(size, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setBatchSize(int size, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setBatchSize_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setBatchSize_name, __cb);
        try
        {
            __result.__prepare(__setBatchSize_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(size);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setBatchSize(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setBatchSize_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param __cb The callback object for the operation.
     * @param size maximum number of results per call to
     * {@link #results}
     **/
    public boolean setBatchSize_async(AMI_Search_setBatchSize __cb, int size)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setBatchSize_name);
            __r = begin_setBatchSize(size, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setBatchSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets the maximum number of results that will be returned by
     * one call to {@link #results}. If batches are not merged,
     * then results may often be less than the batch size. If
     * batches are merged, then only the last call to
     * {@link #results} can be less than batch size.
     * 
     * Note: some query types may not support batching at the
     * query level, and all instances must then be loaded into
     * memory simultaneously.
     * 
     * @param __cb The callback object for the operation.
     * @param size maximum number of results per call to
     * {@link #results}
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setBatchSize_async(AMI_Search_setBatchSize __cb, int size, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setBatchSize_name);
            __r = begin_setBatchSize(size, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setBatchSize_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setCaseSentivice_name = "setCaseSentivice";

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     **/
    public void setCaseSentivice(boolean caseSensitive)
        throws omero.ServerError
    {
        setCaseSentivice(caseSensitive, null, false);
    }

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setCaseSentivice(boolean caseSensitive, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setCaseSentivice(caseSensitive, __ctx, true);
    }

    private void setCaseSentivice(boolean caseSensitive, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setCaseSentivice", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setCaseSentivice");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.setCaseSentivice(caseSensitive, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setCaseSentivice(boolean caseSensitive)
    {
        return begin_setCaseSentivice(caseSensitive, null, false, null);
    }

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setCaseSentivice(boolean caseSensitive, java.util.Map<String, String> __ctx)
    {
        return begin_setCaseSentivice(caseSensitive, __ctx, true, null);
    }

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setCaseSentivice(boolean caseSensitive, Ice.Callback __cb)
    {
        return begin_setCaseSentivice(caseSensitive, null, false, __cb);
    }

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setCaseSentivice(boolean caseSensitive, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setCaseSentivice(caseSensitive, __ctx, true, __cb);
    }

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setCaseSentivice(boolean caseSensitive, Callback_Search_setCaseSentivice __cb)
    {
        return begin_setCaseSentivice(caseSensitive, null, false, __cb);
    }

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setCaseSentivice(boolean caseSensitive, java.util.Map<String, String> __ctx, Callback_Search_setCaseSentivice __cb)
    {
        return begin_setCaseSentivice(caseSensitive, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setCaseSentivice(boolean caseSensitive, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setCaseSentivice_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setCaseSentivice_name, __cb);
        try
        {
            __result.__prepare(__setCaseSentivice_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(caseSensitive);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setCaseSentivice(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setCaseSentivice_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __cb The callback object for the operation.
     **/
    public boolean setCaseSentivice_async(AMI_Search_setCaseSentivice __cb, boolean caseSensitive)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setCaseSentivice_name);
            __r = begin_setCaseSentivice(caseSensitive, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setCaseSentivice_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Sets the case sensitivity on all queries where
     * case-sensitivity is supported.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setCaseSentivice_async(AMI_Search_setCaseSentivice __cb, boolean caseSensitive, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setCaseSentivice_name);
            __r = begin_setCaseSentivice(caseSensitive, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setCaseSentivice_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setMergedBatches_name = "setMergedBatches";

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     **/
    public void setMergedBatches(boolean merge)
        throws omero.ServerError
    {
        setMergedBatches(merge, null, false);
    }

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setMergedBatches(boolean merge, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setMergedBatches(merge, __ctx, true);
    }

    private void setMergedBatches(boolean merge, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setMergedBatches", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setMergedBatches");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.setMergedBatches(merge, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setMergedBatches(boolean merge)
    {
        return begin_setMergedBatches(merge, null, false, null);
    }

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setMergedBatches(boolean merge, java.util.Map<String, String> __ctx)
    {
        return begin_setMergedBatches(merge, __ctx, true, null);
    }

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setMergedBatches(boolean merge, Ice.Callback __cb)
    {
        return begin_setMergedBatches(merge, null, false, __cb);
    }

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setMergedBatches(boolean merge, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setMergedBatches(merge, __ctx, true, __cb);
    }

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setMergedBatches(boolean merge, Callback_Search_setMergedBatches __cb)
    {
        return begin_setMergedBatches(merge, null, false, __cb);
    }

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setMergedBatches(boolean merge, java.util.Map<String, String> __ctx, Callback_Search_setMergedBatches __cb)
    {
        return begin_setMergedBatches(merge, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setMergedBatches(boolean merge, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setMergedBatches_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setMergedBatches_name, __cb);
        try
        {
            __result.__prepare(__setMergedBatches_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(merge);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setMergedBatches(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setMergedBatches_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __cb The callback object for the operation.
     **/
    public boolean setMergedBatches_async(AMI_Search_setMergedBatches __cb, boolean merge)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setMergedBatches_name);
            __r = begin_setMergedBatches(merge, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setMergedBatches_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Set whether or not results from two separate queries can be
     * returned in the same call to {@link #results}.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setMergedBatches_async(AMI_Search_setMergedBatches __cb, boolean merge, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setMergedBatches_name);
            __r = begin_setMergedBatches(merge, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setMergedBatches_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setReturnUnloaded_name = "setReturnUnloaded";

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     **/
    public void setReturnUnloaded(boolean returnUnloaded)
        throws omero.ServerError
    {
        setReturnUnloaded(returnUnloaded, null, false);
    }

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setReturnUnloaded(boolean returnUnloaded, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setReturnUnloaded(returnUnloaded, __ctx, true);
    }

    private void setReturnUnloaded(boolean returnUnloaded, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setReturnUnloaded", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setReturnUnloaded");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.setReturnUnloaded(returnUnloaded, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setReturnUnloaded(boolean returnUnloaded)
    {
        return begin_setReturnUnloaded(returnUnloaded, null, false, null);
    }

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setReturnUnloaded(boolean returnUnloaded, java.util.Map<String, String> __ctx)
    {
        return begin_setReturnUnloaded(returnUnloaded, __ctx, true, null);
    }

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setReturnUnloaded(boolean returnUnloaded, Ice.Callback __cb)
    {
        return begin_setReturnUnloaded(returnUnloaded, null, false, __cb);
    }

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setReturnUnloaded(boolean returnUnloaded, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setReturnUnloaded(returnUnloaded, __ctx, true, __cb);
    }

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setReturnUnloaded(boolean returnUnloaded, Callback_Search_setReturnUnloaded __cb)
    {
        return begin_setReturnUnloaded(returnUnloaded, null, false, __cb);
    }

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setReturnUnloaded(boolean returnUnloaded, java.util.Map<String, String> __ctx, Callback_Search_setReturnUnloaded __cb)
    {
        return begin_setReturnUnloaded(returnUnloaded, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setReturnUnloaded(boolean returnUnloaded, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setReturnUnloaded_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setReturnUnloaded_name, __cb);
        try
        {
            __result.__prepare(__setReturnUnloaded_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(returnUnloaded);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setReturnUnloaded(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setReturnUnloaded_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __cb The callback object for the operation.
     **/
    public boolean setReturnUnloaded_async(AMI_Search_setReturnUnloaded __cb, boolean returnUnloaded)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setReturnUnloaded_name);
            __r = begin_setReturnUnloaded(returnUnloaded, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setReturnUnloaded_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Determines if all results should be returned as unloaded
     * objects. This is particularly useful for creating lists for
     * further querying via {@link omero.api.IQuery}. This value
     * overrides the {@link #setUseProjections} setting.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setReturnUnloaded_async(AMI_Search_setReturnUnloaded __cb, boolean returnUnloaded, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setReturnUnloaded_name);
            __r = begin_setReturnUnloaded(returnUnloaded, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setReturnUnloaded_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setUseProjections_name = "setUseProjections";

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     **/
    public void setUseProjections(boolean useProjections)
        throws omero.ServerError
    {
        setUseProjections(useProjections, null, false);
    }

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setUseProjections(boolean useProjections, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setUseProjections(useProjections, __ctx, true);
    }

    private void setUseProjections(boolean useProjections, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setUseProjections", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setUseProjections");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.setUseProjections(useProjections, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setUseProjections(boolean useProjections)
    {
        return begin_setUseProjections(useProjections, null, false, null);
    }

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setUseProjections(boolean useProjections, java.util.Map<String, String> __ctx)
    {
        return begin_setUseProjections(useProjections, __ctx, true, null);
    }

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setUseProjections(boolean useProjections, Ice.Callback __cb)
    {
        return begin_setUseProjections(useProjections, null, false, __cb);
    }

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setUseProjections(boolean useProjections, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setUseProjections(useProjections, __ctx, true, __cb);
    }

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_setUseProjections(boolean useProjections, Callback_Search_setUseProjections __cb)
    {
        return begin_setUseProjections(useProjections, null, false, __cb);
    }

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setUseProjections(boolean useProjections, java.util.Map<String, String> __ctx, Callback_Search_setUseProjections __cb)
    {
        return begin_setUseProjections(useProjections, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setUseProjections(boolean useProjections, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setUseProjections_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setUseProjections_name, __cb);
        try
        {
            __result.__prepare(__setUseProjections_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeBool(useProjections);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setUseProjections(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setUseProjections_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __cb The callback object for the operation.
     **/
    public boolean setUseProjections_async(AMI_Search_setUseProjections __cb, boolean useProjections)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setUseProjections_name);
            __r = begin_setUseProjections(useProjections, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setUseProjections_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Determines if Lucene queries should not hit the database.
     * Instead all values which are stored in the index will be
     * loaded into the object, which includes the id. However, the
     * entity will not be marked unloaded and therefore it is
     * especially important to not allow a projection-instance to
     * be saved back to the server. This can result in DATA LOSS.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setUseProjections_async(AMI_Search_setUseProjections __cb, boolean useProjections, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setUseProjections_name);
            __r = begin_setUseProjections(useProjections, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setUseProjections_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __unordered_name = "unordered";

    /**
     * Removes the current stack of order statements.
     * 
     * @see #addOrderByAsc
     * @see #addOrderByDesc
     **/
    public void unordered()
        throws omero.ServerError
    {
        unordered(null, false);
    }

    /**
     * Removes the current stack of order statements.
     * 
     * @see #addOrderByAsc
     * @see #addOrderByDesc
     * @param __ctx The Context map to send with the invocation.
     **/
    public void unordered(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        unordered(__ctx, true);
    }

    private void unordered(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "unordered", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("unordered");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.unordered(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Removes the current stack of order statements.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_unordered()
    {
        return begin_unordered(null, false, null);
    }

    /**
     * Removes the current stack of order statements.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_unordered(java.util.Map<String, String> __ctx)
    {
        return begin_unordered(__ctx, true, null);
    }

    /**
     * Removes the current stack of order statements.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_unordered(Ice.Callback __cb)
    {
        return begin_unordered(null, false, __cb);
    }

    /**
     * Removes the current stack of order statements.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_unordered(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_unordered(__ctx, true, __cb);
    }

    /**
     * Removes the current stack of order statements.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_unordered(Callback_Search_unordered __cb)
    {
        return begin_unordered(null, false, __cb);
    }

    /**
     * Removes the current stack of order statements.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_unordered(java.util.Map<String, String> __ctx, Callback_Search_unordered __cb)
    {
        return begin_unordered(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_unordered(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__unordered_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __unordered_name, __cb);
        try
        {
            __result.__prepare(__unordered_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_unordered(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __unordered_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Removes the current stack of order statements.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean unordered_async(AMI_Search_unordered __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__unordered_name);
            __r = begin_unordered(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __unordered_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Removes the current stack of order statements.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean unordered_async(AMI_Search_unordered __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__unordered_name);
            __r = begin_unordered(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __unordered_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __activate_name = "activate";

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     **/
    public void activate()
        throws omero.ServerError
    {
        activate(null, false);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void activate(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        activate(__ctx, true);
    }

    private void activate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "activate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("activate");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.activate(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate()
    {
        return begin_activate(null, false, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx)
    {
        return begin_activate(__ctx, true, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate(Ice.Callback __cb)
    {
        return begin_activate(null, false, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_activate(__ctx, true, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate(Callback_StatefulServiceInterface_activate __cb)
    {
        return begin_activate(null, false, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_activate __cb)
    {
        return begin_activate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__activate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
        try
        {
            __result.__prepare(__activate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_activate(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __activate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public boolean activate_async(AMI_StatefulServiceInterface_activate __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__activate_name);
            __r = begin_activate(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean activate_async(AMI_StatefulServiceInterface_activate __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__activate_name);
            __r = begin_activate(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __close_name = "close";

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     **/
    public void close()
        throws omero.ServerError
    {
        close(null, false);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void close(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        close(__ctx, true);
    }

    private void close(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "close", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("close");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.close(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close()
    {
        return begin_close(null, false, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx)
    {
        return begin_close(__ctx, true, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close(Ice.Callback __cb)
    {
        return begin_close(null, false, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_close(__ctx, true, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close(Callback_StatefulServiceInterface_close __cb)
    {
        return begin_close(null, false, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_close __cb)
    {
        return begin_close(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__close_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __close_name, __cb);
        try
        {
            __result.__prepare(__close_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_close(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __close_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public boolean close_async(AMI_StatefulServiceInterface_close __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__close_name);
            __r = begin_close(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __close_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean close_async(AMI_StatefulServiceInterface_close __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__close_name);
            __r = begin_close(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __close_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getCurrentEventContext_name = "getCurrentEventContext";

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     **/
    public omero.sys.EventContext getCurrentEventContext()
        throws omero.ServerError
    {
        return getCurrentEventContext(null, false);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.sys.EventContext getCurrentEventContext(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getCurrentEventContext(__ctx, true);
    }

    private omero.sys.EventContext getCurrentEventContext(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getCurrentEventContext", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getCurrentEventContext");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    return __del.getCurrentEventContext(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext()
    {
        return begin_getCurrentEventContext(null, false, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx)
    {
        return begin_getCurrentEventContext(__ctx, true, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(Ice.Callback __cb)
    {
        return begin_getCurrentEventContext(null, false, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getCurrentEventContext(__ctx, true, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(Callback_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        return begin_getCurrentEventContext(null, false, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        return begin_getCurrentEventContext(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getCurrentEventContext_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
        try
        {
            __result.__prepare(__getCurrentEventContext_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.sys.EventContext end_getCurrentEventContext(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getCurrentEventContext_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.sys.EventContextHolder __ret = new omero.sys.EventContextHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public boolean getCurrentEventContext_async(AMI_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCurrentEventContext_name);
            __r = begin_getCurrentEventContext(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getCurrentEventContext_async(AMI_StatefulServiceInterface_getCurrentEventContext __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCurrentEventContext_name);
            __r = begin_getCurrentEventContext(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __passivate_name = "passivate";

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     **/
    public void passivate()
        throws omero.ServerError
    {
        passivate(null, false);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void passivate(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        passivate(__ctx, true);
    }

    private void passivate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "passivate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("passivate");
                    __delBase = __getDelegate(false);
                    _SearchDel __del = (_SearchDel)__delBase;
                    __del.passivate(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate()
    {
        return begin_passivate(null, false, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx)
    {
        return begin_passivate(__ctx, true, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate(Ice.Callback __cb)
    {
        return begin_passivate(null, false, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_passivate(__ctx, true, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate(Callback_StatefulServiceInterface_passivate __cb)
    {
        return begin_passivate(null, false, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_passivate __cb)
    {
        return begin_passivate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__passivate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
        try
        {
            __result.__prepare(__passivate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_passivate(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __passivate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public boolean passivate_async(AMI_StatefulServiceInterface_passivate __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__passivate_name);
            __r = begin_passivate(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean passivate_async(AMI_StatefulServiceInterface_passivate __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__passivate_name);
            __r = begin_passivate(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static SearchPrx checkedCast(Ice.ObjectPrx __obj)
    {
        SearchPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof SearchPrx)
            {
                __d = (SearchPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    SearchPrxHelper __h = new SearchPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static SearchPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        SearchPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof SearchPrx)
            {
                __d = (SearchPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    SearchPrxHelper __h = new SearchPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static SearchPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        SearchPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    SearchPrxHelper __h = new SearchPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static SearchPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        SearchPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    SearchPrxHelper __h = new SearchPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static SearchPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        SearchPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof SearchPrx)
            {
                __d = (SearchPrx)__obj;
            }
            else
            {
                SearchPrxHelper __h = new SearchPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static SearchPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        SearchPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            SearchPrxHelper __h = new SearchPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::Search",
        "::omero::api::ServiceInterface",
        "::omero::api::StatefulServiceInterface"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _SearchDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _SearchDelD();
    }

    public static void __write(IceInternal.BasicStream __os, SearchPrx v)
    {
        __os.writeProxy(v);
    }

    public static SearchPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            SearchPrxHelper result = new SearchPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
