// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `ThumbnailStore.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package omero.api;

/**
 * Provides methods for dealing with thumbnails. Provision is provided
 * to retrieve thumbnails using the on-disk cache (provided by
 * <i>ROMIO</i>) or on the fly.
 * <p>
 * NOTE: The calling order for the service is as follows:
 * <ol>
 * <li>{@link #setPixelsId}</li>
 * <li>any of the thumbnail accessor methods or
 * {@link #resetDefaults}</li>
 * </ol>
 * </p>
 **/
public final class ThumbnailStorePrxHelper extends Ice.ObjectPrxHelperBase implements ThumbnailStorePrx
{
    private static final String __activate_name = "activate";

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     **/
    public void activate()
        throws omero.ServerError
    {
        activate(null, false);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void activate(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        activate(__ctx, true);
    }

    private void activate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "activate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("activate");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    __del.activate(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate()
    {
        return begin_activate(null, false, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx)
    {
        return begin_activate(__ctx, true, null);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate(Ice.Callback __cb)
    {
        return begin_activate(null, false, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_activate(__ctx, true, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_activate(Callback_StatefulServiceInterface_activate __cb)
    {
        return begin_activate(null, false, __cb);
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_activate __cb)
    {
        return begin_activate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_activate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__activate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
        try
        {
            __result.__prepare(__activate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_activate(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __activate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     **/
    public boolean activate_async(AMI_StatefulServiceInterface_activate __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__activate_name);
            __r = begin_activate(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Load a service implementation from disk if it was previously
     * passivated. It is unnecessary to call this method since activation
     * happens automatically, but calling this may prevent a short
     * lapse when the service is first accessed after passivation.
     * 
     * It is safe to call this method at any time, even when the service
     * is not passivated.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean activate_async(AMI_StatefulServiceInterface_activate __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__activate_name);
            __r = begin_activate(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __activate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __close_name = "close";

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     **/
    public void close()
        throws omero.ServerError
    {
        close(null, false);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void close(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        close(__ctx, true);
    }

    private void close(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "close", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("close");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    __del.close(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close()
    {
        return begin_close(null, false, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx)
    {
        return begin_close(__ctx, true, null);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close(Ice.Callback __cb)
    {
        return begin_close(null, false, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_close(__ctx, true, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_close(Callback_StatefulServiceInterface_close __cb)
    {
        return begin_close(null, false, __cb);
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_close __cb)
    {
        return begin_close(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_close(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__close_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __close_name, __cb);
        try
        {
            __result.__prepare(__close_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_close(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __close_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     **/
    public boolean close_async(AMI_StatefulServiceInterface_close __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__close_name);
            __r = begin_close(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __close_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Frees all resources -- passivated or active -- for the given
     * stateful service and removes its name from the object adapter.
     * Any further method calls will fail with a Ice::NoSuchObjectException.
     * 
     * Note: with JavaEE, the close method was called publically,
     * and internally this called destroy(). As of the OmeroBlitz
     * migration, this functionality has been combined.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean close_async(AMI_StatefulServiceInterface_close __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__close_name);
            __r = begin_close(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __close_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getCurrentEventContext_name = "getCurrentEventContext";

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     **/
    public omero.sys.EventContext getCurrentEventContext()
        throws omero.ServerError
    {
        return getCurrentEventContext(null, false);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __ctx The Context map to send with the invocation.
     **/
    public omero.sys.EventContext getCurrentEventContext(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getCurrentEventContext(__ctx, true);
    }

    private omero.sys.EventContext getCurrentEventContext(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getCurrentEventContext", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getCurrentEventContext");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    return __del.getCurrentEventContext(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext()
    {
        return begin_getCurrentEventContext(null, false, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx)
    {
        return begin_getCurrentEventContext(__ctx, true, null);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(Ice.Callback __cb)
    {
        return begin_getCurrentEventContext(null, false, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getCurrentEventContext(__ctx, true, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(Callback_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        return begin_getCurrentEventContext(null, false, __cb);
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        return begin_getCurrentEventContext(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getCurrentEventContext(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getCurrentEventContext_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
        try
        {
            __result.__prepare(__getCurrentEventContext_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public omero.sys.EventContext end_getCurrentEventContext(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getCurrentEventContext_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            omero.sys.EventContextHolder __ret = new omero.sys.EventContextHolder();
            __is.readObject(__ret);
            __is.readPendingObjects();
            __result.__endReadParams();
            return __ret.value;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     **/
    public boolean getCurrentEventContext_async(AMI_StatefulServiceInterface_getCurrentEventContext __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCurrentEventContext_name);
            __r = begin_getCurrentEventContext(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * To free clients from tracking the mapping from session to stateful
     * service, each stateful service can returns its own context information.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getCurrentEventContext_async(AMI_StatefulServiceInterface_getCurrentEventContext __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getCurrentEventContext_name);
            __r = begin_getCurrentEventContext(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getCurrentEventContext_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __passivate_name = "passivate";

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     **/
    public void passivate()
        throws omero.ServerError
    {
        passivate(null, false);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void passivate(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        passivate(__ctx, true);
    }

    private void passivate(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "passivate", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("passivate");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    __del.passivate(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate()
    {
        return begin_passivate(null, false, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx)
    {
        return begin_passivate(__ctx, true, null);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate(Ice.Callback __cb)
    {
        return begin_passivate(null, false, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_passivate(__ctx, true, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_passivate(Callback_StatefulServiceInterface_passivate __cb)
    {
        return begin_passivate(null, false, __cb);
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, Callback_StatefulServiceInterface_passivate __cb)
    {
        return begin_passivate(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_passivate(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__passivate_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
        try
        {
            __result.__prepare(__passivate_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_passivate(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __passivate_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     **/
    public boolean passivate_async(AMI_StatefulServiceInterface_passivate __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__passivate_name);
            __r = begin_passivate(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Causes the blitz server to store the service implementation to disk
     * to free memory. This is typically done automatically by the server
     * when a pre-defined memory limit is reached, but can be used by the
     * client if it clear that a stateful service will not be used for some
     * time.
     * 
     * Activation will happen automatically whether passivation was done
     * manually or automatically.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean passivate_async(AMI_StatefulServiceInterface_passivate __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__passivate_name);
            __r = begin_passivate(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __passivate_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __createThumbnail_name = "createThumbnail";

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @see #getThumbnail
     * @see #getThumbnailDirect
     **/
    public void createThumbnail(omero.RInt sizeX, omero.RInt sizeY)
        throws omero.ServerError
    {
        createThumbnail(sizeX, sizeY, null, false);
    }

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @see #getThumbnail
     * @see #getThumbnailDirect
     * @param __ctx The Context map to send with the invocation.
     **/
    public void createThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        createThumbnail(sizeX, sizeY, __ctx, true);
    }

    private void createThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "createThumbnail", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("createThumbnail");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    __del.createThumbnail(sizeX, sizeY, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public Ice.AsyncResult begin_createThumbnail(omero.RInt sizeX, omero.RInt sizeY)
    {
        return begin_createThumbnail(sizeX, sizeY, null, false, null);
    }

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
    {
        return begin_createThumbnail(sizeX, sizeY, __ctx, true, null);
    }

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public Ice.AsyncResult begin_createThumbnail(omero.RInt sizeX, omero.RInt sizeY, Ice.Callback __cb)
    {
        return begin_createThumbnail(sizeX, sizeY, null, false, __cb);
    }

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_createThumbnail(sizeX, sizeY, __ctx, true, __cb);
    }

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public Ice.AsyncResult begin_createThumbnail(omero.RInt sizeX, omero.RInt sizeY, Callback_ThumbnailStore_createThumbnail __cb)
    {
        return begin_createThumbnail(sizeX, sizeY, null, false, __cb);
    }

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_createThumbnail __cb)
    {
        return begin_createThumbnail(sizeX, sizeY, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_createThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__createThumbnail_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __createThumbnail_name, __cb);
        try
        {
            __result.__prepare(__createThumbnail_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(sizeX);
            __os.writeObject(sizeY);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_createThumbnail(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __createThumbnail_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public boolean createThumbnail_async(AMI_ThumbnailStore_createThumbnail __cb, omero.RInt sizeX, omero.RInt sizeY)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createThumbnail_name);
            __r = begin_createThumbnail(sizeX, sizeY, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createThumbnail_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Creates a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createThumbnail_async(AMI_ThumbnailStore_createThumbnail __cb, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createThumbnail_name);
            __r = begin_createThumbnail(sizeX, sizeY, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createThumbnail_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __createThumbnails_name = "createThumbnails";

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @see #getThumbnail
     * @see #getThumbnailDirect
     **/
    public void createThumbnails()
        throws omero.ServerError
    {
        createThumbnails(null, false);
    }

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @see #getThumbnail
     * @see #getThumbnailDirect
     * @param __ctx The Context map to send with the invocation.
     **/
    public void createThumbnails(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        createThumbnails(__ctx, true);
    }

    private void createThumbnails(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "createThumbnails", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("createThumbnails");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    __del.createThumbnails(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_createThumbnails()
    {
        return begin_createThumbnails(null, false, null);
    }

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createThumbnails(java.util.Map<String, String> __ctx)
    {
        return begin_createThumbnails(__ctx, true, null);
    }

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_createThumbnails(Ice.Callback __cb)
    {
        return begin_createThumbnails(null, false, __cb);
    }

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createThumbnails(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_createThumbnails(__ctx, true, __cb);
    }

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_createThumbnails(Callback_ThumbnailStore_createThumbnails __cb)
    {
        return begin_createThumbnails(null, false, __cb);
    }

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createThumbnails(java.util.Map<String, String> __ctx, Callback_ThumbnailStore_createThumbnails __cb)
    {
        return begin_createThumbnails(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_createThumbnails(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__createThumbnails_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __createThumbnails_name, __cb);
        try
        {
            __result.__prepare(__createThumbnails_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_createThumbnails(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __createThumbnails_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @param __cb The callback object for the operation.
     **/
    public boolean createThumbnails_async(AMI_ThumbnailStore_createThumbnails __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createThumbnails_name);
            __r = begin_createThumbnails(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createThumbnails_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Creates thumbnails for a pixels set using a given set of
     * rendering settings (RenderingDef) in the on-disk cache for
     * <b>every</b> sizeX/sizeY combination already cached.
     * 
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createThumbnails_async(AMI_ThumbnailStore_createThumbnails __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createThumbnails_name);
            __r = begin_createThumbnails(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createThumbnails_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __createThumbnailsByLongestSideSet_name = "createThumbnailsByLongestSideSet";

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li><code>size</code> is negative</li>
     * </ul>
     * @see #createThumbnail
     * @see #createThumbnails
     **/
    public void createThumbnailsByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds)
        throws omero.ServerError
    {
        createThumbnailsByLongestSideSet(size, pixelsIds, null, false);
    }

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li><code>size</code> is negative</li>
     * </ul>
     * @see #createThumbnail
     * @see #createThumbnails
     * @param __ctx The Context map to send with the invocation.
     **/
    public void createThumbnailsByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        createThumbnailsByLongestSideSet(size, pixelsIds, __ctx, true);
    }

    private void createThumbnailsByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "createThumbnailsByLongestSideSet", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("createThumbnailsByLongestSideSet");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    __del.createThumbnailsByLongestSideSet(size, pixelsIds, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     **/
    public Ice.AsyncResult begin_createThumbnailsByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds)
    {
        return begin_createThumbnailsByLongestSideSet(size, pixelsIds, null, false, null);
    }

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createThumbnailsByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx)
    {
        return begin_createThumbnailsByLongestSideSet(size, pixelsIds, __ctx, true, null);
    }

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     **/
    public Ice.AsyncResult begin_createThumbnailsByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, Ice.Callback __cb)
    {
        return begin_createThumbnailsByLongestSideSet(size, pixelsIds, null, false, __cb);
    }

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createThumbnailsByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_createThumbnailsByLongestSideSet(size, pixelsIds, __ctx, true, __cb);
    }

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     **/
    public Ice.AsyncResult begin_createThumbnailsByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, Callback_ThumbnailStore_createThumbnailsByLongestSideSet __cb)
    {
        return begin_createThumbnailsByLongestSideSet(size, pixelsIds, null, false, __cb);
    }

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_createThumbnailsByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_createThumbnailsByLongestSideSet __cb)
    {
        return begin_createThumbnailsByLongestSideSet(size, pixelsIds, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_createThumbnailsByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__createThumbnailsByLongestSideSet_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __createThumbnailsByLongestSideSet_name, __cb);
        try
        {
            __result.__prepare(__createThumbnailsByLongestSideSet_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(size);
            omero.sys.LongListHelper.write(__os, pixelsIds);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_createThumbnailsByLongestSideSet(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __createThumbnailsByLongestSideSet_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     **/
    public boolean createThumbnailsByLongestSideSet_async(AMI_ThumbnailStore_createThumbnailsByLongestSideSet __cb, omero.RInt size, java.util.List<Long> pixelsIds)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createThumbnailsByLongestSideSet_name);
            __r = begin_createThumbnailsByLongestSideSet(size, pixelsIds, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createThumbnailsByLongestSideSet_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Creates thumbnails for a number of pixels sets using a
     * given set of rendering settings (RenderingDef) in the
     * on-disk cache. Unlike the other thumbnail creation methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}. This method <b>will not</b> reset or
     * modify rendering settings in any way. If rendering settings
     * for a pixels set are not present, thumbnail creation for
     * that pixels set <b>will not</b> be performed.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean createThumbnailsByLongestSideSet_async(AMI_ThumbnailStore_createThumbnailsByLongestSideSet __cb, omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__createThumbnailsByLongestSideSet_name);
            __r = begin_createThumbnailsByLongestSideSet(size, pixelsIds, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __createThumbnailsByLongestSideSet_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getRenderingDefId_name = "getRenderingDefId";

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     **/
    public long getRenderingDefId()
        throws omero.ServerError
    {
        return getRenderingDefId(null, false);
    }

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __ctx The Context map to send with the invocation.
     **/
    public long getRenderingDefId(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getRenderingDefId(__ctx, true);
    }

    private long getRenderingDefId(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getRenderingDefId", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getRenderingDefId");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    return __del.getRenderingDefId(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getRenderingDefId()
    {
        return begin_getRenderingDefId(null, false, null);
    }

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRenderingDefId(java.util.Map<String, String> __ctx)
    {
        return begin_getRenderingDefId(__ctx, true, null);
    }

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getRenderingDefId(Ice.Callback __cb)
    {
        return begin_getRenderingDefId(null, false, __cb);
    }

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRenderingDefId(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getRenderingDefId(__ctx, true, __cb);
    }

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_getRenderingDefId(Callback_ThumbnailStore_getRenderingDefId __cb)
    {
        return begin_getRenderingDefId(null, false, __cb);
    }

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getRenderingDefId(java.util.Map<String, String> __ctx, Callback_ThumbnailStore_getRenderingDefId __cb)
    {
        return begin_getRenderingDefId(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getRenderingDefId(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getRenderingDefId_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getRenderingDefId_name, __cb);
        try
        {
            __result.__prepare(__getRenderingDefId_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public long end_getRenderingDefId(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getRenderingDefId_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            long __ret;
            __ret = __is.readLong();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __cb The callback object for the operation.
     **/
    public boolean getRenderingDefId_async(AMI_ThumbnailStore_getRenderingDefId __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getRenderingDefId_name);
            __r = begin_getRenderingDefId(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getRenderingDefId_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Return the id of the {@link omero.model.RenderingDef}
     * loaded in this instance.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getRenderingDefId_async(AMI_ThumbnailStore_getRenderingDefId __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getRenderingDefId_name);
            __r = begin_getRenderingDefId(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getRenderingDefId_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getThumbnail_name = "getThumbnail";

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnailDirect
     **/
    public byte[] getThumbnail(omero.RInt sizeX, omero.RInt sizeY)
        throws omero.ServerError
    {
        return getThumbnail(sizeX, sizeY, null, false);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @param __ctx The Context map to send with the invocation.
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnailDirect
     **/
    public byte[] getThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getThumbnail(sizeX, sizeY, __ctx, true);
    }

    private byte[] getThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getThumbnail", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getThumbnail");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    return __del.getThumbnail(sizeX, sizeY, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public Ice.AsyncResult begin_getThumbnail(omero.RInt sizeX, omero.RInt sizeY)
    {
        return begin_getThumbnail(sizeX, sizeY, null, false, null);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
    {
        return begin_getThumbnail(sizeX, sizeY, __ctx, true, null);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public Ice.AsyncResult begin_getThumbnail(omero.RInt sizeX, omero.RInt sizeY, Ice.Callback __cb)
    {
        return begin_getThumbnail(sizeX, sizeY, null, false, __cb);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getThumbnail(sizeX, sizeY, __ctx, true, __cb);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public Ice.AsyncResult begin_getThumbnail(omero.RInt sizeX, omero.RInt sizeY, Callback_ThumbnailStore_getThumbnail __cb)
    {
        return begin_getThumbnail(sizeX, sizeY, null, false, __cb);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_getThumbnail __cb)
    {
        return begin_getThumbnail(sizeX, sizeY, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getThumbnail(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getThumbnail_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getThumbnail_name, __cb);
        try
        {
            __result.__prepare(__getThumbnail_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(sizeX);
            __os.writeObject(sizeY);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a JPEG thumbnail byte buffer.
     **/
    public byte[] end_getThumbnail(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getThumbnail_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public boolean getThumbnail_async(AMI_ThumbnailStore_getThumbnail __cb, omero.RInt sizeX, omero.RInt sizeY)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getThumbnail_name);
            __r = begin_getThumbnail(sizeX, sizeY, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getThumbnail_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will be returned directly,
     * otherwise it will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk
     * cache and returned.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getThumbnail_async(AMI_ThumbnailStore_getThumbnail __cb, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getThumbnail_name);
            __r = begin_getThumbnail(sizeX, sizeY, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getThumbnail_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getThumbnailByLongestSide_name = "getThumbnailByLongestSide";

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @throws ApiUsageException if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnail
     **/
    public byte[] getThumbnailByLongestSide(omero.RInt size)
        throws omero.ServerError
    {
        return getThumbnailByLongestSide(size, null, false);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @throws ApiUsageException if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @param __ctx The Context map to send with the invocation.
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnail
     **/
    public byte[] getThumbnailByLongestSide(omero.RInt size, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getThumbnailByLongestSide(size, __ctx, true);
    }

    private byte[] getThumbnailByLongestSide(omero.RInt size, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getThumbnailByLongestSide", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getThumbnailByLongestSide");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    return __del.getThumbnailByLongestSide(size, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSide(omero.RInt size)
    {
        return begin_getThumbnailByLongestSide(size, null, false, null);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSide(omero.RInt size, java.util.Map<String, String> __ctx)
    {
        return begin_getThumbnailByLongestSide(size, __ctx, true, null);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSide(omero.RInt size, Ice.Callback __cb)
    {
        return begin_getThumbnailByLongestSide(size, null, false, __cb);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSide(omero.RInt size, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getThumbnailByLongestSide(size, __ctx, true, __cb);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSide(omero.RInt size, Callback_ThumbnailStore_getThumbnailByLongestSide __cb)
    {
        return begin_getThumbnailByLongestSide(size, null, false, __cb);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSide(omero.RInt size, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_getThumbnailByLongestSide __cb)
    {
        return begin_getThumbnailByLongestSide(size, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getThumbnailByLongestSide(omero.RInt size, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getThumbnailByLongestSide_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getThumbnailByLongestSide_name, __cb);
        try
        {
            __result.__prepare(__getThumbnailByLongestSide_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(size);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a JPEG thumbnail byte buffer.
     **/
    public byte[] end_getThumbnailByLongestSide(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getThumbnailByLongestSide_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     **/
    public boolean getThumbnailByLongestSide_async(AMI_ThumbnailStore_getThumbnailByLongestSide __cb, omero.RInt size)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getThumbnailByLongestSide_name);
            __r = begin_getThumbnailByLongestSide(size, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getThumbnailByLongestSide_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). If the thumbnail exists
     * in the on-disk cache it will bereturned directly, otherwise
     * it will be created as in {@link #getThumbnailDirect},
     * placed in the on-disk cache and returned. The longest side
     * of the image will be used to calculate the size for the
     * smaller side in order to keep the aspect ratio of the
     * original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getThumbnailByLongestSide_async(AMI_ThumbnailStore_getThumbnailByLongestSide __cb, omero.RInt size, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getThumbnailByLongestSide_name);
            __r = begin_getThumbnailByLongestSide(size, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getThumbnailByLongestSide_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getThumbnailByLongestSideDirect_name = "getThumbnailByLongestSideDirect";

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnailDirect
     **/
    public byte[] getThumbnailByLongestSideDirect(omero.RInt size)
        throws omero.ServerError
    {
        return getThumbnailByLongestSideDirect(size, null, false);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @param __ctx The Context map to send with the invocation.
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnailDirect
     **/
    public byte[] getThumbnailByLongestSideDirect(omero.RInt size, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getThumbnailByLongestSideDirect(size, __ctx, true);
    }

    private byte[] getThumbnailByLongestSideDirect(omero.RInt size, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getThumbnailByLongestSideDirect", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getThumbnailByLongestSideDirect");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    return __del.getThumbnailByLongestSideDirect(size, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideDirect(omero.RInt size)
    {
        return begin_getThumbnailByLongestSideDirect(size, null, false, null);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideDirect(omero.RInt size, java.util.Map<String, String> __ctx)
    {
        return begin_getThumbnailByLongestSideDirect(size, __ctx, true, null);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideDirect(omero.RInt size, Ice.Callback __cb)
    {
        return begin_getThumbnailByLongestSideDirect(size, null, false, __cb);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideDirect(omero.RInt size, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getThumbnailByLongestSideDirect(size, __ctx, true, __cb);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideDirect(omero.RInt size, Callback_ThumbnailStore_getThumbnailByLongestSideDirect __cb)
    {
        return begin_getThumbnailByLongestSideDirect(size, null, false, __cb);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideDirect(omero.RInt size, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_getThumbnailByLongestSideDirect __cb)
    {
        return begin_getThumbnailByLongestSideDirect(size, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getThumbnailByLongestSideDirect(omero.RInt size, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getThumbnailByLongestSideDirect_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getThumbnailByLongestSideDirect_name, __cb);
        try
        {
            __result.__prepare(__getThumbnailByLongestSideDirect_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(size);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a JPEG thumbnail byte buffer.
     **/
    public byte[] end_getThumbnailByLongestSideDirect(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getThumbnailByLongestSideDirect_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     **/
    public boolean getThumbnailByLongestSideDirect_async(AMI_ThumbnailStore_getThumbnailByLongestSideDirect __cb, omero.RInt size)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getThumbnailByLongestSideDirect_name);
            __r = begin_getThumbnailByLongestSideDirect(size, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getThumbnailByLongestSideDirect_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache. The
     * longest side of the image will be used to calculate the
     * size for the smaller side in order to keep the aspect ratio
     * of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getThumbnailByLongestSideDirect_async(AMI_ThumbnailStore_getThumbnailByLongestSideDirect __cb, omero.RInt size, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getThumbnailByLongestSideDirect_name);
            __r = begin_getThumbnailByLongestSideDirect(size, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getThumbnailByLongestSideDirect_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getThumbnailByLongestSideSet_name = "getThumbnailByLongestSideSet";

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @return a map whose keys are pixels ids and values are JPEG
     * thumbnail byte buffers or <code>null</code> if an
     * exception was thrown while attempting to retrieve
     * the thumbnail for that particular Pixels set.
     * @see #getThumbnailSet
     **/
    public java.util.Map<java.lang.Long, byte[]> getThumbnailByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds)
        throws omero.ServerError
    {
        return getThumbnailByLongestSideSet(size, pixelsIds, null, false);
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     * @return a map whose keys are pixels ids and values are JPEG
     * thumbnail byte buffers or <code>null</code> if an
     * exception was thrown while attempting to retrieve
     * the thumbnail for that particular Pixels set.
     * @see #getThumbnailSet
     **/
    public java.util.Map<java.lang.Long, byte[]> getThumbnailByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getThumbnailByLongestSideSet(size, pixelsIds, __ctx, true);
    }

    private java.util.Map<java.lang.Long, byte[]> getThumbnailByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getThumbnailByLongestSideSet", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getThumbnailByLongestSideSet");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    return __del.getThumbnailByLongestSideSet(size, pixelsIds, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds)
    {
        return begin_getThumbnailByLongestSideSet(size, pixelsIds, null, false, null);
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx)
    {
        return begin_getThumbnailByLongestSideSet(size, pixelsIds, __ctx, true, null);
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, Ice.Callback __cb)
    {
        return begin_getThumbnailByLongestSideSet(size, pixelsIds, null, false, __cb);
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getThumbnailByLongestSideSet(size, pixelsIds, __ctx, true, __cb);
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, Callback_ThumbnailStore_getThumbnailByLongestSideSet __cb)
    {
        return begin_getThumbnailByLongestSideSet(size, pixelsIds, null, false, __cb);
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_getThumbnailByLongestSideSet __cb)
    {
        return begin_getThumbnailByLongestSideSet(size, pixelsIds, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getThumbnailByLongestSideSet(omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getThumbnailByLongestSideSet_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getThumbnailByLongestSideSet_name, __cb);
        try
        {
            __result.__prepare(__getThumbnailByLongestSideSet_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(size);
            omero.sys.LongListHelper.write(__os, pixelsIds);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a map whose keys are pixels ids and values are JPEG
     * thumbnail byte buffers or <code>null</code> if an
     * exception was thrown while attempting to retrieve
     * the thumbnail for that particular Pixels set.
     **/
    public java.util.Map<java.lang.Long, byte[]> end_getThumbnailByLongestSideSet(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getThumbnailByLongestSideSet_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.Long, byte[]> __ret;
            __ret = omero.sys.IdByteMapHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     **/
    public boolean getThumbnailByLongestSideSet_async(AMI_ThumbnailStore_getThumbnailByLongestSideSet __cb, omero.RInt size, java.util.List<Long> pixelsIds)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getThumbnailByLongestSideSet_name);
            __r = begin_getThumbnailByLongestSideSet(size, pixelsIds, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getThumbnailByLongestSideSet_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * Thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailByLongestSideDirect}. The longest
     * side of the image will be used to calculate the size for
     * the smaller side in order to keep the aspect ratio of the
     * original image. Unlike the other thumbnail retrieval
     * methods, this method <b>may</b> be called without first
     * calling {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getThumbnailByLongestSideSet_async(AMI_ThumbnailStore_getThumbnailByLongestSideSet __cb, omero.RInt size, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getThumbnailByLongestSideSet_name);
            __r = begin_getThumbnailByLongestSideSet(size, pixelsIds, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getThumbnailByLongestSideSet_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getThumbnailDirect_name = "getThumbnailDirect";

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnail
     **/
    public byte[] getThumbnailDirect(omero.RInt sizeX, omero.RInt sizeY)
        throws omero.ServerError
    {
        return getThumbnailDirect(sizeX, sizeY, null, false);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @param __ctx The Context map to send with the invocation.
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnail
     **/
    public byte[] getThumbnailDirect(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getThumbnailDirect(sizeX, sizeY, __ctx, true);
    }

    private byte[] getThumbnailDirect(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getThumbnailDirect", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getThumbnailDirect");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    return __del.getThumbnailDirect(sizeX, sizeY, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public Ice.AsyncResult begin_getThumbnailDirect(omero.RInt sizeX, omero.RInt sizeY)
    {
        return begin_getThumbnailDirect(sizeX, sizeY, null, false, null);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailDirect(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
    {
        return begin_getThumbnailDirect(sizeX, sizeY, __ctx, true, null);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public Ice.AsyncResult begin_getThumbnailDirect(omero.RInt sizeX, omero.RInt sizeY, Ice.Callback __cb)
    {
        return begin_getThumbnailDirect(sizeX, sizeY, null, false, __cb);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailDirect(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getThumbnailDirect(sizeX, sizeY, __ctx, true, __cb);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public Ice.AsyncResult begin_getThumbnailDirect(omero.RInt sizeX, omero.RInt sizeY, Callback_ThumbnailStore_getThumbnailDirect __cb)
    {
        return begin_getThumbnailDirect(sizeX, sizeY, null, false, __cb);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailDirect(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_getThumbnailDirect __cb)
    {
        return begin_getThumbnailDirect(sizeX, sizeY, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getThumbnailDirect(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getThumbnailDirect_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getThumbnailDirect_name, __cb);
        try
        {
            __result.__prepare(__getThumbnailDirect_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(sizeX);
            __os.writeObject(sizeY);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a JPEG thumbnail byte buffer.
     **/
    public byte[] end_getThumbnailDirect(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getThumbnailDirect_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public boolean getThumbnailDirect_async(AMI_ThumbnailStore_getThumbnailDirect __cb, omero.RInt sizeX, omero.RInt sizeY)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getThumbnailDirect_name);
            __r = begin_getThumbnailDirect(sizeX, sizeY, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getThumbnailDirect_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef). The Thumbnail will
     * always be created directly, ignoring the on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getThumbnailDirect_async(AMI_ThumbnailStore_getThumbnailDirect __cb, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getThumbnailDirect_name);
            __r = begin_getThumbnailDirect(sizeX, sizeY, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getThumbnailDirect_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getThumbnailForSectionByLongestSideDirect_name = "getThumbnailForSectionByLongestSideDirect";

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnailDirect
     **/
    public byte[] getThumbnailForSectionByLongestSideDirect(int theZ, int theT, omero.RInt size)
        throws omero.ServerError
    {
        return getThumbnailForSectionByLongestSideDirect(theZ, theT, size, null, false);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param size the size of the longest side of the thumbnail
     * requested. <code>null</code> specifies the
     * default size of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>size</code> > pixels.sizeX and pixels.sizeY</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @param __ctx The Context map to send with the invocation.
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnailDirect
     **/
    public byte[] getThumbnailForSectionByLongestSideDirect(int theZ, int theT, omero.RInt size, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getThumbnailForSectionByLongestSideDirect(theZ, theT, size, __ctx, true);
    }

    private byte[] getThumbnailForSectionByLongestSideDirect(int theZ, int theT, omero.RInt size, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getThumbnailForSectionByLongestSideDirect", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getThumbnailForSectionByLongestSideDirect");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    return __del.getThumbnailForSectionByLongestSideDirect(theZ, theT, size, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionByLongestSideDirect(int theZ, int theT, omero.RInt size)
    {
        return begin_getThumbnailForSectionByLongestSideDirect(theZ, theT, size, null, false, null);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionByLongestSideDirect(int theZ, int theT, omero.RInt size, java.util.Map<String, String> __ctx)
    {
        return begin_getThumbnailForSectionByLongestSideDirect(theZ, theT, size, __ctx, true, null);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionByLongestSideDirect(int theZ, int theT, omero.RInt size, Ice.Callback __cb)
    {
        return begin_getThumbnailForSectionByLongestSideDirect(theZ, theT, size, null, false, __cb);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionByLongestSideDirect(int theZ, int theT, omero.RInt size, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getThumbnailForSectionByLongestSideDirect(theZ, theT, size, __ctx, true, __cb);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionByLongestSideDirect(int theZ, int theT, omero.RInt size, Callback_ThumbnailStore_getThumbnailForSectionByLongestSideDirect __cb)
    {
        return begin_getThumbnailForSectionByLongestSideDirect(theZ, theT, size, null, false, __cb);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionByLongestSideDirect(int theZ, int theT, omero.RInt size, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_getThumbnailForSectionByLongestSideDirect __cb)
    {
        return begin_getThumbnailForSectionByLongestSideDirect(theZ, theT, size, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getThumbnailForSectionByLongestSideDirect(int theZ, int theT, omero.RInt size, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getThumbnailForSectionByLongestSideDirect_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getThumbnailForSectionByLongestSideDirect_name, __cb);
        try
        {
            __result.__prepare(__getThumbnailForSectionByLongestSideDirect_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(theZ);
            __os.writeInt(theT);
            __os.writeObject(size);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a JPEG thumbnail byte buffer.
     **/
    public byte[] end_getThumbnailForSectionByLongestSideDirect(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getThumbnailForSectionByLongestSideDirect_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     **/
    public boolean getThumbnailForSectionByLongestSideDirect_async(AMI_ThumbnailStore_getThumbnailForSectionByLongestSideDirect __cb, int theZ, int theT, omero.RInt size)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getThumbnailForSectionByLongestSideDirect_name);
            __r = begin_getThumbnailForSectionByLongestSideDirect(theZ, theT, size, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getThumbnailForSectionByLongestSideDirect_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache. The longest side of the image will be used
     * to calculate the size for the smaller side in order to keep
     * the aspect ratio of the original image.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getThumbnailForSectionByLongestSideDirect_async(AMI_ThumbnailStore_getThumbnailForSectionByLongestSideDirect __cb, int theZ, int theT, omero.RInt size, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getThumbnailForSectionByLongestSideDirect_name);
            __r = begin_getThumbnailForSectionByLongestSideDirect(theZ, theT, size, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getThumbnailForSectionByLongestSideDirect_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getThumbnailForSectionDirect_name = "getThumbnailForSectionDirect";

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li><code>theZ</code> is out of range</li>
     * <li><code>theT</code> is out of range</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnail
     **/
    public byte[] getThumbnailForSectionDirect(int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY)
        throws omero.ServerError
    {
        return getThumbnailForSectionDirect(theZ, theT, sizeX, sizeY, null, false);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> > pixels.sizeX</li>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> > pixels.sizeY</li>
     * <li><code>sizeY</code> is negative</li>
     * <li><code>theZ</code> is out of range</li>
     * <li><code>theT</code> is out of range</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @param __ctx The Context map to send with the invocation.
     * @return a JPEG thumbnail byte buffer.
     * @see #getThumbnail
     **/
    public byte[] getThumbnailForSectionDirect(int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getThumbnailForSectionDirect(theZ, theT, sizeX, sizeY, __ctx, true);
    }

    private byte[] getThumbnailForSectionDirect(int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getThumbnailForSectionDirect", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getThumbnailForSectionDirect");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    return __del.getThumbnailForSectionDirect(theZ, theT, sizeX, sizeY, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionDirect(int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY)
    {
        return begin_getThumbnailForSectionDirect(theZ, theT, sizeX, sizeY, null, false, null);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionDirect(int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
    {
        return begin_getThumbnailForSectionDirect(theZ, theT, sizeX, sizeY, __ctx, true, null);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionDirect(int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY, Ice.Callback __cb)
    {
        return begin_getThumbnailForSectionDirect(theZ, theT, sizeX, sizeY, null, false, __cb);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionDirect(int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getThumbnailForSectionDirect(theZ, theT, sizeX, sizeY, __ctx, true, __cb);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionDirect(int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY, Callback_ThumbnailStore_getThumbnailForSectionDirect __cb)
    {
        return begin_getThumbnailForSectionDirect(theZ, theT, sizeX, sizeY, null, false, __cb);
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailForSectionDirect(int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_getThumbnailForSectionDirect __cb)
    {
        return begin_getThumbnailForSectionDirect(theZ, theT, sizeX, sizeY, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getThumbnailForSectionDirect(int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getThumbnailForSectionDirect_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getThumbnailForSectionDirect_name, __cb);
        try
        {
            __result.__prepare(__getThumbnailForSectionDirect_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeInt(theZ);
            __os.writeInt(theT);
            __os.writeObject(sizeX);
            __os.writeObject(sizeY);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a JPEG thumbnail byte buffer.
     **/
    public byte[] end_getThumbnailForSectionDirect(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getThumbnailForSectionDirect_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            byte[] __ret;
            __ret = Ice.ByteSeqHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public boolean getThumbnailForSectionDirect_async(AMI_ThumbnailStore_getThumbnailForSectionDirect __cb, int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getThumbnailForSectionDirect_name);
            __r = begin_getThumbnailForSectionDirect(theZ, theT, sizeX, sizeY, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getThumbnailForSectionDirect_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a thumbnail for a pixels set using a given set of
     * rendering settings (RenderingDef) for a particular section.
     * The Thumbnail will always be created directly, ignoring the
     * on-disk cache.
     * 
     * @param __cb The callback object for the operation.
     * @param theZ the optical section (offset across the Z-axis)
     * to use.
     * @param theT the timepoint (offset across the T-axis) to use.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getThumbnailForSectionDirect_async(AMI_ThumbnailStore_getThumbnailForSectionDirect __cb, int theZ, int theT, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getThumbnailForSectionDirect_name);
            __r = begin_getThumbnailForSectionDirect(theZ, theT, sizeX, sizeY, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getThumbnailForSectionDirect_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __getThumbnailSet_name = "getThumbnailSet";

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @return a map whose keys are pixels ids and values are JPEG
     * thumbnail byte buffers or <code>null</code> if an
     * exception was thrown while attempting to retrieve
     * the thumbnail for that particular Pixels set.
     * @see #getThumbnail
     **/
    public java.util.Map<java.lang.Long, byte[]> getThumbnailSet(omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds)
        throws omero.ServerError
    {
        return getThumbnailSet(sizeX, sizeY, pixelsIds, null, false);
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     * @return a map whose keys are pixels ids and values are JPEG
     * thumbnail byte buffers or <code>null</code> if an
     * exception was thrown while attempting to retrieve
     * the thumbnail for that particular Pixels set.
     * @see #getThumbnail
     **/
    public java.util.Map<java.lang.Long, byte[]> getThumbnailSet(omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return getThumbnailSet(sizeX, sizeY, pixelsIds, __ctx, true);
    }

    private java.util.Map<java.lang.Long, byte[]> getThumbnailSet(omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "getThumbnailSet", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("getThumbnailSet");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    return __del.getThumbnailSet(sizeX, sizeY, pixelsIds, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     **/
    public Ice.AsyncResult begin_getThumbnailSet(omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds)
    {
        return begin_getThumbnailSet(sizeX, sizeY, pixelsIds, null, false, null);
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailSet(omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx)
    {
        return begin_getThumbnailSet(sizeX, sizeY, pixelsIds, __ctx, true, null);
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     **/
    public Ice.AsyncResult begin_getThumbnailSet(omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds, Ice.Callback __cb)
    {
        return begin_getThumbnailSet(sizeX, sizeY, pixelsIds, null, false, __cb);
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailSet(omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_getThumbnailSet(sizeX, sizeY, pixelsIds, __ctx, true, __cb);
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     **/
    public Ice.AsyncResult begin_getThumbnailSet(omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds, Callback_ThumbnailStore_getThumbnailSet __cb)
    {
        return begin_getThumbnailSet(sizeX, sizeY, pixelsIds, null, false, __cb);
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_getThumbnailSet(omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_getThumbnailSet __cb)
    {
        return begin_getThumbnailSet(sizeX, sizeY, pixelsIds, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_getThumbnailSet(omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__getThumbnailSet_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __getThumbnailSet_name, __cb);
        try
        {
            __result.__prepare(__getThumbnailSet_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(sizeX);
            __os.writeObject(sizeY);
            omero.sys.LongListHelper.write(__os, pixelsIds);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) a map whose keys are pixels ids and values are JPEG
     * thumbnail byte buffers or <code>null</code> if an
     * exception was thrown while attempting to retrieve
     * the thumbnail for that particular Pixels set.
     **/
    public java.util.Map<java.lang.Long, byte[]> end_getThumbnailSet(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __getThumbnailSet_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            java.util.Map<java.lang.Long, byte[]> __ret;
            __ret = omero.sys.IdByteMapHelper.read(__is);
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     **/
    public boolean getThumbnailSet_async(AMI_ThumbnailStore_getThumbnailSet __cb, omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getThumbnailSet_name);
            __r = begin_getThumbnailSet(sizeX, sizeY, pixelsIds, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getThumbnailSet_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Retrieves a number of thumbnails for pixels sets using
     * given sets of rendering settings (RenderingDef). If the
     * thumbnails exist in the on-disk cache they will be returned
     * directly, otherwise they will be created as in
     * {@link #getThumbnailDirect}, placed in the on-disk cache
     * and returned. Unlike the other thumbnail retrieval methods,
     * this method <b>may</b> be called without first calling
     * {@link #setPixelsId}.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param pixelsIds the Pixels sets to retrieve thumbnails for.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean getThumbnailSet_async(AMI_ThumbnailStore_getThumbnailSet __cb, omero.RInt sizeX, omero.RInt sizeY, java.util.List<Long> pixelsIds, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__getThumbnailSet_name);
            __r = begin_getThumbnailSet(sizeX, sizeY, pixelsIds, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __getThumbnailSet_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __isInProgress_name = "isInProgress";

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @return <code>true</code> if the image is in the process of
     * being imported or a pyramid is being generated for
     * it.
     * 
     **/
    public boolean isInProgress()
        throws omero.ServerError
    {
        return isInProgress(null, false);
    }

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __ctx The Context map to send with the invocation.
     * @return <code>true</code> if the image is in the process of
     * being imported or a pyramid is being generated for
     * it.
     * 
     **/
    public boolean isInProgress(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return isInProgress(__ctx, true);
    }

    private boolean isInProgress(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "isInProgress", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("isInProgress");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    return __del.isInProgress(__ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isInProgress()
    {
        return begin_isInProgress(null, false, null);
    }

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isInProgress(java.util.Map<String, String> __ctx)
    {
        return begin_isInProgress(__ctx, true, null);
    }

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isInProgress(Ice.Callback __cb)
    {
        return begin_isInProgress(null, false, __cb);
    }

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isInProgress(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_isInProgress(__ctx, true, __cb);
    }

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_isInProgress(Callback_ThumbnailStore_isInProgress __cb)
    {
        return begin_isInProgress(null, false, __cb);
    }

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_isInProgress(java.util.Map<String, String> __ctx, Callback_ThumbnailStore_isInProgress __cb)
    {
        return begin_isInProgress(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_isInProgress(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__isInProgress_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __isInProgress_name, __cb);
        try
        {
            __result.__prepare(__isInProgress_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) <code>true</code> if the image is in the process of
     * being imported or a pyramid is being generated for
     * it.
     * 
     **/
    public boolean end_isInProgress(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __isInProgress_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __cb The callback object for the operation.
     **/
    public boolean isInProgress_async(AMI_ThumbnailStore_isInProgress __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isInProgress_name);
            __r = begin_isInProgress(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isInProgress_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * This returns the last available <i>in progress</i> state
     * for a thumbnail. Its return value is <b>only</b> expected
     * to be valid after the call to any of the individual
     * thumbnail retrieval methods.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean isInProgress_async(AMI_ThumbnailStore_isInProgress __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__isInProgress_name);
            __r = begin_isInProgress(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __isInProgress_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __resetDefaults_name = "resetDefaults";

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     **/
    public void resetDefaults()
        throws omero.ServerError
    {
        resetDefaults(null, false);
    }

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void resetDefaults(java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        resetDefaults(__ctx, true);
    }

    private void resetDefaults(java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "resetDefaults", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("resetDefaults");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    __del.resetDefaults(__ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_resetDefaults()
    {
        return begin_resetDefaults(null, false, null);
    }

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaults(java.util.Map<String, String> __ctx)
    {
        return begin_resetDefaults(__ctx, true, null);
    }

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_resetDefaults(Ice.Callback __cb)
    {
        return begin_resetDefaults(null, false, __cb);
    }

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaults(java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_resetDefaults(__ctx, true, __cb);
    }

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __cb The callback object for the operation.
     **/
    public Ice.AsyncResult begin_resetDefaults(Callback_ThumbnailStore_resetDefaults __cb)
    {
        return begin_resetDefaults(null, false, __cb);
    }

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_resetDefaults(java.util.Map<String, String> __ctx, Callback_ThumbnailStore_resetDefaults __cb)
    {
        return begin_resetDefaults(__ctx, true, __cb);
    }

    private Ice.AsyncResult begin_resetDefaults(java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__resetDefaults_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __resetDefaults_name, __cb);
        try
        {
            __result.__prepare(__resetDefaults_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            __result.__writeEmptyParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_resetDefaults(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __resetDefaults_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __cb The callback object for the operation.
     **/
    public boolean resetDefaults_async(AMI_ThumbnailStore_resetDefaults __cb)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaults_name);
            __r = begin_resetDefaults(null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaults_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Resets the rendering definition for the active pixels set
     * to its default settings.
     * @param __cb The callback object for the operation.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean resetDefaults_async(AMI_ThumbnailStore_resetDefaults __cb, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__resetDefaults_name);
            __r = begin_resetDefaults(__ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __resetDefaults_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setPixelsId_name = "setPixelsId";

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param pixelsId an {@link omero.model.Pixels} id.
     * @throws ApiUsageException if no pixels object exists with
     * the ID <code>pixelsId</code>.
     * @return <code>true</code> if a
     * {@link omero.model.RenderingDef} exists for the
     * {@link omero.model.Pixels} set, otherwise
     * <code>false</code>
     **/
    public boolean setPixelsId(long pixelsId)
        throws omero.ServerError
    {
        return setPixelsId(pixelsId, null, false);
    }

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param pixelsId an {@link omero.model.Pixels} id.
     * @throws ApiUsageException if no pixels object exists with
     * the ID <code>pixelsId</code>.
     * @param __ctx The Context map to send with the invocation.
     * @return <code>true</code> if a
     * {@link omero.model.RenderingDef} exists for the
     * {@link omero.model.Pixels} set, otherwise
     * <code>false</code>
     **/
    public boolean setPixelsId(long pixelsId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return setPixelsId(pixelsId, __ctx, true);
    }

    private boolean setPixelsId(long pixelsId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setPixelsId", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setPixelsId");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    return __del.setPixelsId(pixelsId, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId an {@link omero.model.Pixels} id.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId)
    {
        return begin_setPixelsId(pixelsId, null, false, null);
    }

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId an {@link omero.model.Pixels} id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, java.util.Map<String, String> __ctx)
    {
        return begin_setPixelsId(pixelsId, __ctx, true, null);
    }

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId an {@link omero.model.Pixels} id.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, Ice.Callback __cb)
    {
        return begin_setPixelsId(pixelsId, null, false, __cb);
    }

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId an {@link omero.model.Pixels} id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setPixelsId(pixelsId, __ctx, true, __cb);
    }

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId an {@link omero.model.Pixels} id.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, Callback_ThumbnailStore_setPixelsId __cb)
    {
        return begin_setPixelsId(pixelsId, null, false, __cb);
    }

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId an {@link omero.model.Pixels} id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setPixelsId(long pixelsId, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_setPixelsId __cb)
    {
        return begin_setPixelsId(pixelsId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setPixelsId(long pixelsId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setPixelsId_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setPixelsId_name, __cb);
        try
        {
            __result.__prepare(__setPixelsId_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(pixelsId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) <code>true</code> if a
     * {@link omero.model.RenderingDef} exists for the
     * {@link omero.model.Pixels} set, otherwise
     * <code>false</code>
     **/
    public boolean end_setPixelsId(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setPixelsId_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId an {@link omero.model.Pixels} id.
     **/
    public boolean setPixelsId_async(AMI_ThumbnailStore_setPixelsId __cb, long pixelsId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setPixelsId_name);
            __r = begin_setPixelsId(pixelsId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setPixelsId_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * This method manages the state of the service; it must be
     * invoked before using any other methods. As the
     * {@link omero.api.ThumbnailStore} relies on the
     * {@link omero.api.RenderingEngine}, a valid rendering
     * definition must be available for it to work.
     * 
     * @param __cb The callback object for the operation.
     * @param pixelsId an {@link omero.model.Pixels} id.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setPixelsId_async(AMI_ThumbnailStore_setPixelsId __cb, long pixelsId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setPixelsId_name);
            __r = begin_setPixelsId(pixelsId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setPixelsId_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __setRenderingDefId_name = "setRenderingDefId";

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     * @throws ValidationException
     * if no rendering definition exists with the ID
     * <code>renderingDefId</code>.
     **/
    public void setRenderingDefId(long renderingDefId)
        throws omero.ServerError
    {
        setRenderingDefId(renderingDefId, null, false);
    }

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     * @throws ValidationException
     * if no rendering definition exists with the ID
     * <code>renderingDefId</code>.
     * @param __ctx The Context map to send with the invocation.
     **/
    public void setRenderingDefId(long renderingDefId, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        setRenderingDefId(renderingDefId, __ctx, true);
    }

    private void setRenderingDefId(long renderingDefId, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "setRenderingDefId", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("setRenderingDefId");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    __del.setRenderingDefId(renderingDefId, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     **/
    public Ice.AsyncResult begin_setRenderingDefId(long renderingDefId)
    {
        return begin_setRenderingDefId(renderingDefId, null, false, null);
    }

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setRenderingDefId(long renderingDefId, java.util.Map<String, String> __ctx)
    {
        return begin_setRenderingDefId(renderingDefId, __ctx, true, null);
    }

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     **/
    public Ice.AsyncResult begin_setRenderingDefId(long renderingDefId, Ice.Callback __cb)
    {
        return begin_setRenderingDefId(renderingDefId, null, false, __cb);
    }

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setRenderingDefId(long renderingDefId, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_setRenderingDefId(renderingDefId, __ctx, true, __cb);
    }

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     **/
    public Ice.AsyncResult begin_setRenderingDefId(long renderingDefId, Callback_ThumbnailStore_setRenderingDefId __cb)
    {
        return begin_setRenderingDefId(renderingDefId, null, false, __cb);
    }

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_setRenderingDefId(long renderingDefId, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_setRenderingDefId __cb)
    {
        return begin_setRenderingDefId(renderingDefId, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_setRenderingDefId(long renderingDefId, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__setRenderingDefId_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __setRenderingDefId_name, __cb);
        try
        {
            __result.__prepare(__setRenderingDefId_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeLong(renderingDefId);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_setRenderingDefId(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __setRenderingDefId_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            __result.__readEmptyParams();
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     **/
    public boolean setRenderingDefId_async(AMI_ThumbnailStore_setRenderingDefId __cb, long renderingDefId)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setRenderingDefId_name);
            __r = begin_setRenderingDefId(renderingDefId, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setRenderingDefId_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * This method manages the state of the service; it should be
     * invoked directly after {@link #setPixelsId}. If it is not
     * invoked with a valid rendering definition ID before using
     * the thumbnail accessor methods execution continues as if
     * <code>renderingDefId</code> were set to <code>null</code>.
     * 
     * @param __cb The callback object for the operation.
     * @param renderingDefId
     * an {@link omero.model.RenderingDef} id.
     * <code>null</code> specifies the user's currently
     * active rendering settings to be used.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean setRenderingDefId_async(AMI_ThumbnailStore_setRenderingDefId __cb, long renderingDefId, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__setRenderingDefId_name);
            __r = begin_setRenderingDefId(renderingDefId, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __setRenderingDefId_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    private static final String __thumbnailExists_name = "thumbnailExists";

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @see #getThumbnail
     * @see #getThumbnailDirect
     **/
    public boolean thumbnailExists(omero.RInt sizeX, omero.RInt sizeY)
        throws omero.ServerError
    {
        return thumbnailExists(sizeX, sizeY, null, false);
    }

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @throws ApiUsageException
     * if:
     * <ul>
     * <li><code>sizeX</code> is negative</li>
     * <li><code>sizeY</code> is negative</li>
     * <li>{@link #setPixelsId} has not yet been called</li>
     * </ul>
     * @see #getThumbnail
     * @see #getThumbnailDirect
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean thumbnailExists(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
        throws omero.ServerError
    {
        return thumbnailExists(sizeX, sizeY, __ctx, true);
    }

    private boolean thumbnailExists(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, boolean __explicitCtx)
        throws omero.ServerError
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "thumbnailExists", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __checkTwowayOnly("thumbnailExists");
                    __delBase = __getDelegate(false);
                    _ThumbnailStoreDel __del = (_ThumbnailStoreDel)__delBase;
                    return __del.thumbnailExists(sizeX, sizeY, __ctx, __observer);
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public Ice.AsyncResult begin_thumbnailExists(omero.RInt sizeX, omero.RInt sizeY)
    {
        return begin_thumbnailExists(sizeX, sizeY, null, false, null);
    }

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_thumbnailExists(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
    {
        return begin_thumbnailExists(sizeX, sizeY, __ctx, true, null);
    }

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public Ice.AsyncResult begin_thumbnailExists(omero.RInt sizeX, omero.RInt sizeY, Ice.Callback __cb)
    {
        return begin_thumbnailExists(sizeX, sizeY, null, false, __cb);
    }

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_thumbnailExists(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_thumbnailExists(sizeX, sizeY, __ctx, true, __cb);
    }

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public Ice.AsyncResult begin_thumbnailExists(omero.RInt sizeX, omero.RInt sizeY, Callback_ThumbnailStore_thumbnailExists __cb)
    {
        return begin_thumbnailExists(sizeX, sizeY, null, false, __cb);
    }

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_thumbnailExists(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, Callback_ThumbnailStore_thumbnailExists __cb)
    {
        return begin_thumbnailExists(sizeX, sizeY, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_thumbnailExists(omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__thumbnailExists_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __thumbnailExists_name, __cb);
        try
        {
            __result.__prepare(__thumbnailExists_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            __os.writeObject(sizeX);
            __os.writeObject(sizeY);
            __os.writePendingObjects();
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public boolean end_thumbnailExists(Ice.AsyncResult __result)
        throws omero.ServerError
    {
        Ice.AsyncResult.__check(__result, this, __thumbnailExists_name);
        boolean __ok = __result.__wait();
        try
        {
            if(!__ok)
            {
                try
                {
                    __result.__throwUserException();
                }
                catch(omero.ServerError __ex)
                {
                    throw __ex;
                }
                catch(Ice.UserException __ex)
                {
                    throw new Ice.UnknownUserException(__ex.ice_name(), __ex);
                }
            }
            IceInternal.BasicStream __is = __result.__startReadParams();
            boolean __ret;
            __ret = __is.readBool();
            __result.__endReadParams();
            return __ret;
        }
        catch(Ice.LocalException ex)
        {
            Ice.Instrumentation.InvocationObserver __obsv = __result.__getObserver();
            if(__obsv != null)
            {
                __obsv.failed(ex.ice_name());
            }
            throw ex;
        }
    }

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     **/
    public boolean thumbnailExists_async(AMI_ThumbnailStore_thumbnailExists __cb, omero.RInt sizeX, omero.RInt sizeY)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__thumbnailExists_name);
            __r = begin_thumbnailExists(sizeX, sizeY, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __thumbnailExists_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Checks if a thumbnail of a particular size exists for a
     * pixels set.
     * 
     * @param __cb The callback object for the operation.
     * @param sizeX the X-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param sizeY the Y-axis width of the thumbnail.
     * <code>null</code> specifies the default size
     * of 48.
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean thumbnailExists_async(AMI_ThumbnailStore_thumbnailExists __cb, omero.RInt sizeX, omero.RInt sizeY, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__thumbnailExists_name);
            __r = begin_thumbnailExists(sizeX, sizeY, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __thumbnailExists_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static ThumbnailStorePrx checkedCast(Ice.ObjectPrx __obj)
    {
        ThumbnailStorePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ThumbnailStorePrx)
            {
                __d = (ThumbnailStorePrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    ThumbnailStorePrxHelper __h = new ThumbnailStorePrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ThumbnailStorePrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        ThumbnailStorePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ThumbnailStorePrx)
            {
                __d = (ThumbnailStorePrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    ThumbnailStorePrxHelper __h = new ThumbnailStorePrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ThumbnailStorePrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ThumbnailStorePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    ThumbnailStorePrxHelper __h = new ThumbnailStorePrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ThumbnailStorePrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        ThumbnailStorePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    ThumbnailStorePrxHelper __h = new ThumbnailStorePrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ThumbnailStorePrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        ThumbnailStorePrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ThumbnailStorePrx)
            {
                __d = (ThumbnailStorePrx)__obj;
            }
            else
            {
                ThumbnailStorePrxHelper __h = new ThumbnailStorePrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static ThumbnailStorePrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ThumbnailStorePrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            ThumbnailStorePrxHelper __h = new ThumbnailStorePrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::omero::api::ServiceInterface",
        "::omero::api::StatefulServiceInterface",
        "::omero::api::ThumbnailStore"
    };

    public static String ice_staticId()
    {
        return __ids[3];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _ThumbnailStoreDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _ThumbnailStoreDelD();
    }

    public static void __write(IceInternal.BasicStream __os, ThumbnailStorePrx v)
    {
        __os.writeProxy(v);
    }

    public static ThumbnailStorePrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            ThumbnailStorePrxHelper result = new ThumbnailStorePrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
